Package: rstudio.e2e.tests
Type: Package
Title: R Package Dependencies for RStudio Playwright E2E Tests
Version: 0.0.1
Description: Lists the R packages that RStudio Playwright tests rely on.
    Consumed by the workflows at .github/workflows/test-e2e-rstudio-*.yml
    via pak::local_install_dev_deps(). Not a real R package -- only the Imports
    field is meaningful here.
Imports:
    data.table,
    nycflights13,
    rmarkdown,
    rlang,
    roxygen2,
    shiny,
    testthat,
    tidyverse

RStudio
=============================================================================

RStudio is an integrated development environment (IDE) for the 
[R programming language](http://www.r-project.org). Some of its
features include:

- Customizable workbench with all of the tools required to work with R in one
  place (console, source, plots, workspace, help, history, etc.).
- Syntax highlighting editor with code completion.
- Execute code directly from the source editor (line, selection, or file).
- Full support for authoring Sweave and TeX documents.
- Runs on Windows, Mac, and Linux, and has a community-maintained 
  [FreeBSD port](https://www.freshports.org/devel/RStudio/).
- Can also be run as a server, enabling multiple users to access the RStudio
  IDE using a web browser.

For more information on RStudio please visit the 
[project website](http://www.posit.co/).

Getting the Code
-----------------------------------------------------------------------------

RStudio is licensed under the AGPLv3, the terms of which are included in
the file COPYING. You can find our source code repository on GitHub at [https://github.com/rstudio/rstudio](https://github.com/rstudio/rstudio).

Documentation
-----------------------------------------------------------------------------

For information on how to use RStudio check out our
[online documentation](http://www.rstudio.com/ide/docs/). 

For documentation on running your own RStudio Server see the 
[server getting started](http://www.rstudio.com/ide/docs/server/getting_started)
guide.

See also the following files included with the distribution:

- COPYING - RStudio license (AGPLv3)
- NOTICE  - Additional open source software included with RStudio
- SOURCE  - How to obtain the source code for RStudio
- INSTALL - How to build and install RStudio from source
- VSCODE.md - How to get started with development using Visual Studio Code

If you have problems or want to share feedback with us please visit our
[community forum](https://community.rstudio.com/c/rstudio-ide). For other
inquiries you can also email us at [info@posit.co](mailto:info@posit.co). 

RStudio
=============================================================================

RStudio is an integrated development environment (IDE) for the 
[R programming language](https://www.r-project.org). Some of its
features include:

- Customizable workbench with all of the tools required to work with R in one
  place (console, source, plots, workspace, help, history, etc.).
- Syntax highlighting editor with code completion.
- Execute code directly from the source editor (line, selection, or file).
- Full support for authoring Sweave and TeX documents.
- Runs on Windows, Mac, and Linux, and has a community-maintained 
  [FreeBSD port](https://www.freshports.org/devel/RStudio/).
- Can also be run as a server, enabling multiple users to access the RStudio
  IDE using a web browser.

For more information on RStudio please visit the 
[project website](https://posit.co/).

Getting the Code
-----------------------------------------------------------------------------

RStudio is licensed under the AGPLv3, the terms of which are included in
the file COPYING. You can find our source code repository on GitHub at [https://github.com/rstudio/rstudio](https://github.com/rstudio/rstudio).

Documentation
-----------------------------------------------------------------------------

For information on how to use RStudio check out our
[online documentation](https://docs.posit.co/ide/user/). 

See also the following files included with the distribution:

- COPYING - RStudio license (AGPLv3)
- NOTICE  - Additional open source software included with RStudio
- SOURCE  - How to obtain the source code for RStudio
- INSTALL - How to build and install RStudio from source

If you have problems or want to share feedback with us please visit our
[community forum](https://forum.posit.co/c/rstudio-ide). For other
inquiries you can also email us at [info@posit.co](mailto:info@posit.co). 

# git hooks

## Implemented Hooks
- [pre-commit](./hooks/pre-commit)
    - runs linting and formatting on staged JavaScript and TypeScript files
- [pre-push](./hooks/pre-push): prevents pushes to the main branch

## Install Hooks
The `set-up-git-hooks` script will copy the implemented hooks in [git_hooks/hooks](./hooks/) to [.git/hooks](/.git/hooks/) and make the hooks executable.

💡 Running on Windows? Run the commands from a `Git Bash` terminal.

From this directory (`git_hooks`), use the commands below to make the script executable and then run [set-up-git-hooks](./set-up-git-hooks).

> [!NOTE]
> If you have any existing hooks with the same name in your local project, they will be renamed with the current timestamp appended to the end of the file name.
> Run `./set-up-git-hooks --overwrite` to overwrite existing hooks.

```sh
chmod +x ./set-up-git-hooks
./set-up-git-hooks
```

### Install Specific Hooks
Currently, all implemented hooks are installed by default. To install specific hooks, ensure you've already run the `set-up-git-hooks` script, then navigate to [.git/hooks](/.git/hooks/) and manually update the `pre-commit` and `pre-push` scripts to only run the hooks you want.

In the future, we should add a way to specify which hooks to install when running the `set-up-git-hooks` script.

## Uninstall Hooks
Go to [.git/hooks](/.git/hooks/) and delete the file for the hook you want to uninstall.
- eg. If you want to uninstall the `pre-commit` hook, delete the `.git/hooks/pre-commit` file.

> If you are using VSCode and don't see the `.git` folder in your file explorer, go to VSCode settings and search for "exclude". You may need to remove `.git` from the exclude list for the file explorer.

## Skip Hooks
Hooks can be skipped by appending `--no-verify` to the git command you want to run without its corresponding hook.
- eg. To skip the pre-commit hook, you'd use `git commit --no-verify`.

# Utility Scripts

This folder contains scripts intended for use by engineers working on the RStudio IDE.

Use these with caution, and read the scripts before using them; they can definitely cause data loss.

The dataTables implementation in this directory has diverged from the original library.

Diff against commit hash https://github.com/rstudio/rstudio/commit/2feebac3997df8e21d5a7df3763bf29fc49a597
if looking to update dataTables to a newer version.

Warning: This implementation is considered archaic with undesirable monkey patches
Strongly consider alternate options if contemplating a library update.

# Configure Windows for RStudio Development

These instructions are intended for a clean Windows-11 x64 (not ARM) machine and may not produce
a successful build environment if different versions of any dependencies are already installed.

## Bootstrap

- Open an Administrator PowerShell and execute this command:
  - `Set-ExecutionPolicy Bypass -Scope Process -Force; iex ((New-Object System.Net.WebClient).DownloadString('https://raw.githubusercontent.com/rstudio/rstudio/main/dependencies/windows/Install-RStudio-Prereqs.ps1'))`
- Wait for the script to complete

## Clone the Repo and Run Batch File

- Open Command Prompt (non-administrator); do this **after** running the PowerShell bootstrapping 
  script above to pick up environment changes
- optional: if you will be making commits, configure git (your email address, name, ssh keys, etc.)
  make pull requests from that
- `cd` to the location you want the repo
- Clone the repro, e.g. `git clone https://github.com/rstudio/rstudio`
  - note: if you are not a Posit employee and want to submit changes you will
      need to fork the repo and work against that
- `cd rstudio\dependencies\windows`
- `install-dependencies.cmd`
- Wait for the script to complete

### Dependency install location

`install-dependencies.cmd` downloads and installs build dependencies into
`RSTUDIO_TOOLS_ROOT` (default: `%SYSTEMDRIVE%\rstudio-tools`, so normally
`C:\rstudio-tools`), outside the source tree. This mirrors how the other
platforms use `/opt/rstudio-tools`. Set the `RSTUDIO_TOOLS_ROOT` environment
variable before running the script to install elsewhere.

Older checkouts installed dependencies into the source tree itself (in
`dependencies\common` and `dependencies\windows`). The build still discovers
dependencies there as a fallback when `RSTUDIO_TOOLS_ROOT` has not been
populated, so existing setups keep working; when both locations are present,
the tools root wins. To avoid confusion after migrating, delete the
downloaded (gitignored) artifacts from the source tree.

## Build Java/Gwt

- `cd rstudio\src\gwt`
- `ant draft` or for iterative development of Java/Gwt code, `ant desktop`

## Build C++ From Command-Prompt

- `cd rstudio\src`
- `mkdir build`
- `cd build`
- `..\cpp\tools\windows-dev.cmd`
- `cmake ..\cpp -GNinja`
- `ninja`

## Build and run Electron

- Ensure that `node.js` is installed and available on the path. It is
  recommended to use the same version as set in globals.cmake (root of the repo), search for
  `RSTUDIO_NODE_VERSION` to find the current value
- `cd rstudio\src\node\desktop`
- `npm i`
- `npm start`

## Package Build

This is not necessary for regular development work, but can be used to fully
test your installation. This builds RStudio and bundles it up in a setup package.

In a non-administrator command prompt:

- `cd rstudio\package\win32`
- `make-package.bat`

When done, the setup is `rstudio\package\build\RStudio-99.9.9.exe`.

Component Version Requirements
=============================================================================

RStudio requires relatively recent versions of a number of components. It is
therefore likely to only correctly configure and build on more recent Linux
systems. Specific version requirements for various components include:

- R 3.6.0
- CMake 3.19.8 or newer
- Boost 1.90.0
- patchelf 0.9 [Required only for Desktop]

Installing Dependencies for Debian/Ubuntu, Fedora, RedHat/CentOS, or OpenSUSE
=============================================================================

1) R installation - building RStudio requires that a version of R be
previously installed within a location where the R executable can be run from
the system shell (e.g. /usr/bin or /usr/local/bin). Building R from source
and then executing 'make install' will conform to this requirement as will
installing it using the system standard package management tools (apt-get,
yum, etc).

2) Run the install-dependencies script appropriate to your platform's
package management system

   ./install-dependencies-debian
   ./install-dependencies-yum
   ./install-dependencies-zypper

Note that this script will install Boost in the /opt/rstudio-tools/boost
directory (the /opt/rstudio-tools directory is used to insure that this
installation of boost doesn't conflict with other versions of boost installed
on the system). This part of the installation will take a few minutes since
it requires that boost be built from source for your system.


Installing Dependencies for Other Systems
=============================================================================

If the system you are installing on is either older than the minimum required
versions listed above or another Linux distribution entirely, then you should
do the following to make sure you have fulfilled all dependencies:

1) The Dockerfiles in the docker/jenkins folder contain the definitive
dependency requirements for the platforms that RStudio is built on and can
serve as a guide in determining which referenced libraries must be available
on your system.

2) Run the install-common script from dependencies/common (which will
install Google Web Toolkit, Hunspell dictionaries, MathJax, Boost 1.78, and
other dependencies).

3) If your system doesn't meet the minimum version requirements for CMake
you can download a Linux binary of the latest version of CMake here:

  - https://cmake.org/download/

# RStudio Playwright Test Suite

End-to-end tests for [RStudio](https://github.com/rstudio/rstudio) using [Playwright](https://playwright.dev/). Tests are designed to run against **RStudio Desktop** (via Chrome DevTools Protocol) on Windows, macOS, and Linux, and **RStudio Server** (via a private in-tree `rserver-dev`, or against an external server) on Linux. Development and testing have primarily been done on Desktop so far. Server mode is supported but less exercised.

## Setup

From this directory (`e2e/rstudio`):

```bash
npm install
npx playwright install
```

### Ubuntu 26.04 LTS

Playwright doesn't yet ship a browser build or system-deps list for Ubuntu 26.04 (the release renamed SONAME-versioned libraries: `libicu74` -> `libicu78`, `libxml2` -> `libxml2-16`, etc.). Until Playwright catches up, point the installer at the Ubuntu 24.04 browser build and install the renamed system libraries by hand:

```bash
# Intel/AMD64
PLAYWRIGHT_HOST_PLATFORM_OVERRIDE=ubuntu24.04-x64 npx playwright install

# ARM64
PLAYWRIGHT_HOST_PLATFORM_OVERRIDE=ubuntu24.04-arm64 npx playwright install

sudo apt-get install libicu78 libxml2-16 libmanette-0.2-0
```

Remove the override once Playwright publishes an Ubuntu 26.04 build.

### Prerequisites

- **Desktop mode**: RStudio Desktop installed at the default path for your OS
- **Server mode**: By default, an in-tree `rserver-dev` built at `build/src/cpp/server/rserver` (run `cmake --build build` first). To target an external server instead, set `PW_RSTUDIO_SERVER_URL`; credentials are needed only if that server presents a login form.
- **Authentication**: The test suite does not currently automate sign-in to external services. Tests that require authentication (e.g., Posit Assistant, GitHub Copilot) assume the running RStudio instance is already signed in.

## Running Tests

### Pick a mode

The suite has two Playwright projects: `desktop` (default) and `server`. Each filters tests automatically by edition (via `PW_RSTUDIO_EDITION`, default `os`) and by OS -- `desktop` from the host's `os.platform()`, `server` always against Linux.

### Desktop Mode (Default)

No flag needed--`desktop` is the default project.

```bash
# All tests
npx playwright test

# Specific test file
npx playwright test tests/panes/misc/autocomplete.test.ts

# All tests in a folder (recursive)
npx playwright test tests/panes/posit-assistant-chat/

# Specific test by name
npx playwright test -g "test name here"
npx playwright test -g "base function: cat("

# With extra RStudio CLI args
PW_RSTUDIO_EXTRA_ARGS="--my-flag --other-option" npx playwright test

# Pro edition
PW_RSTUDIO_EDITION=pro npx playwright test
```

The desktop fixture automatically launches RStudio with CDP enabled on a random port (9231-9299), connects Playwright, and shuts down gracefully after tests complete. Override the port with `PW_CDP_PORT=9222`.

#### Against the in-tree dev build

Set `PW_RSTUDIO_DEV=1` to launch the dev build via `npm run start` in `src/node/desktop` instead of the installed RStudio binary. The fixture resolves `src/node/desktop` from this directory using the standard repo layout, so no path needs to be provided.

```bash
PW_RSTUDIO_DEV=1 npx playwright test
PW_RSTUDIO_DEV=1 npx playwright test tests/panes/misc/autocomplete.test.ts
```

Assumes the rest of the product (gwt, the C++ session, etc.) is already built such that `npm run start` in `src/node/desktop` would launch a working IDE. The CDP-wait deadline is extended to 3 minutes on this path to accommodate the first-run webpack compile; subsequent starts are faster. Tests that exercise the doRestart() flow (e.g. uninstall Posit Assistant) aren't fully supported in dev mode because the Electron relaunch spawns the same dev executable rather than a fresh CDP-enabled session.

### Server Mode

Pass `--project=server`. By default the fixture spawns a private in-tree `rserver-dev` per worker (using `build/src/cpp/server/rserver` and `build/src/cpp/conf/rserver-dev.conf`), launches a headed Chromium, and connects to it -- credentials aren't needed because the spawned server uses `--auth-none`. Build the server first with `cmake --build build`. Override the binary and conf paths with `PW_RSERVER_BIN` / `PW_RSERVER_CONF` if needed.

```bash
# Spawn in-tree rserver-dev (default)
npx playwright test --project=server

# All tests in a folder (recursive)
npx playwright test tests/panes/posit-assistant-chat/ --project=server
```

To skip the spawn and target an external server (e.g. CI, or a remote box), set `PW_RSTUDIO_SERVER_URL`. Credentials are required only when the external server presents a login form; `PW_RSTUDIO_SERVER_PORT` overrides the port in the URL when set.

**Prerequisite for external servers**: the rsession processes the target server spawns must run with `--automation-agent`, otherwise `window.rstudio` is never installed and the very first step of `launchServer()` (which calls `setPref()` through the bridge) will time out. The in-tree spawn handles this by passing `--automation-agent=1` to `rserver-dev`, which forwards the flag to every rsession it launches. External servers have to be configured explicitly -- either start `rserver` with `--automation-agent=1`, or add `automation-agent=1` to `rserver.conf`. Servers that aren't dedicated test instances will not have this set by default.

```bash
PW_RSTUDIO_SERVER_URL=http://10.0.0.1 \
  PW_RSTUDIO_SERVER_PORT=80 \
  PW_RSTUDIO_SERVER_USER=myuser \
  PW_RSTUDIO_SERVER_PASSWORD=mypass \
  npx playwright test --project=server

# Pro edition
PW_RSTUDIO_EDITION=pro \
  PW_RSTUDIO_SERVER_URL=http://10.0.0.2 \
  PW_RSTUDIO_SERVER_PORT=80 \
  PW_RSTUDIO_SERVER_USER=myuser \
  PW_RSTUDIO_SERVER_PASSWORD=mypass \
  npx playwright test --project=server
```

`PW_RSTUDIO_MODE=desktop|server` is a fallback when `--project` isn't passed; if both are set, `--project` wins.

### Viewing the Report

After a test run, open the HTML report with:

```bash
npx playwright show-report
```

### Profiling a slow test

When a test passes but is slower than expected, find out *which step* is slow
rather than guessing. A full trace records every action (clicks, `waitFor`,
`expect`, `evaluate`) with begin/end timestamps.

Traces are retained automatically on failure (see `use.trace` in
`playwright.config.ts`), so a failing test already has one. For a passing test,
force one with `--trace on`:

```bash
npm run test:desktop-dev -- tests/path/to/test.test.ts -g "test name" --trace on
```

The fastest way to read per-action timing headlessly (no GUI) is to unzip the
trace and pair the `before`/`after` events in `test.trace` by `callId`:

```bash
TRACE=$(find test-results -name trace.zip | tail -1)
mkdir -p /tmp/tx && unzip -o "$TRACE" -d /tmp/tx >/dev/null
node -e '
const fs = require("fs");
const ev = fs.readFileSync("/tmp/tx/test.trace", "utf8")
  .split("\n").filter(Boolean).map(JSON.parse);
const open = {}, dur = [];
for (const e of ev) {
  if (e.type === "before") open[e.callId] = { t: e.startTime, title: e.title || e.method };
  else if (e.type === "after" && open[e.callId])
    dur.push({ ms: (e.endTime - open[e.callId].t) | 0, title: open[e.callId].title });
}
dur.sort((a, b) => b.ms - a.ms);
for (const r of dur.slice(0, 15)) console.log(String(r.ms).padStart(6), r.title);
'
```

`startTime`/`endTime` are milliseconds. The one-time app launch shows up as
multi-second `Before Hooks` / `beforeAll hook` / `Fixture "rstudioPage"`
entries -- ignore those and look at the actions inside the test body. A common
gotcha this surfaces: calling `locator.inputValue()` (or other
value-reading actions) on an element that isn't in the DOM yet blocks on the
action timeout; probe with `locator.count()` (instant) instead, and open the
editor/popup before reading from it.

For an interactive view (DOM snapshots, network, console per step), use the
GUI trace viewer instead:

```bash
npx playwright show-trace "$TRACE"
```

### Configuration

The Playwright config (`playwright.config.ts`) runs tests **sequentially** (1 worker, no parallel) with a 5-minute timeout per test. Retries default to 0 locally and to 1 under CI (controlled by the standard `CI` env var) -- one retry absorbs a transient launch flake on a fresh runner without rerunning the suite by hand. Override on the CLI with `--retries N`.

## Project Structure

```
e2e/rstudio/
├── fixtures/               # Test fixtures (session lifecycle, sandbox setup/teardown)
├── pages/                  # Page objects (locators and low-level helpers)
├── actions/                # Higher-level actions (multi-step operations)
├── utils/                  # Shared utilities (timeouts, constants, helpers)
├── tests/                  # Test specs, organized by feature area
├── scripts/                # Dev wrappers for the in-tree dev build (test:desktop-dev, test:server-dev)
├── docs/                   # Supplementary documentation
├── DESCRIPTION             # R-style package metadata (lets RStudio treat this dir as a project)
├── playwright.config.ts
├── tsconfig.json
└── package.json
```

The `package.json` exposes a few convenience npm scripts on top of `npx playwright test`:

- `npm test` / `npm run test:desktop` -- runs `--project=desktop`
- `npm run test:server` -- runs `--project=server` pointing `PW_RSERVER_BIN` / `PW_RSERVER_CONF` at an installed Server build
- `npm run test:desktop-dev` / `npm run test:server-dev` -- runs an incremental `cmake --build` so the in-tree C++ session is current, then checks that a usable GWT build is available (devmode process running, or a precompiled bootstrap from `ant draft`) and launches against the in-tree dev build. The GWT check is a probe only -- if neither is present, the wrapper prints a warning telling you to run `ant devmode` or `ant draft` and continues; bring up GWT yourself before invoking these. See `scripts/`.
- `npm run test:report` -- opens the HTML report
- `npm run typecheck` -- `tsc --noEmit`

### Path Aliases

The `tsconfig.json` defines path aliases so imports stay clean:

| Alias | Directory |
|-------|-----------|
| `@fixtures/*` | `fixtures/*` |
| `@pages/*` | `pages/*` |
| `@actions/*` | `actions/*` |
| `@utils/*` | `utils/*` |

## Architecture

### Fixtures

The unified fixture (`rstudio.fixture.ts`) reads the per-project `mode` option (set in `playwright.config.ts`) and delegates to the appropriate launcher. It provides a shared `rstudioPage` (a Playwright `Page`) scoped to the worker, so all tests in a file share one RStudio session.

- **Desktop**: Kills any process on the CDP port, spawns RStudio with `--remote-debugging-port` and `--automation-agent`, connects via `chromium.connectOverCDP()`, waits for the console to be ready.
- **Server**: When `PW_RSTUDIO_SERVER_URL` is unset, spawns a private in-tree `rserver-dev` per worker with sandboxed env (`--auth-none`, `--automation-agent`, isolated `HOME` / config / data dirs). Otherwise connects to the configured external URL. Either way, launches a headed Chromium, navigates to the server, and -- only if a login form is presented -- fills in `PW_RSTUDIO_SERVER_USER` / `_PASSWORD` before waiting for the IDE to load.

Both fixtures dismiss leftover save dialogs from previous runs.

`--automation-agent` is the flag that makes the IDE testable: rsession's `ApplicationAutomation` only installs `window.rstudio` (the command, preference, and document bridge driven from `@utils/commands`) when this is set. The Desktop fixture polls for `window.rstudio.ready === true` rather than a fixed sleep, which transparently rides out the splash screen and (in GWT super dev mode) the transient "Compiling RStudio" page.

In CI mode, `globalSetup` does a warmup launch+shutdown of Desktop RStudio before any worker starts, so the first real test doesn't pay the cold-cache GWT-ready cost. This adds one extra launch to a CI run; set `PW_WARMUP_LAUNCH=0` to opt out, or `PW_WARMUP_LAUNCH=1` to force-enable it locally. Skipped for Server mode regardless.

Before any worker spawns, a Playwright `globalSetup` hook (`fixtures/sandbox-setup.ts`) creates a per-invocation **sandbox** directory under `os.tmpdir()` (or under `PW_SANDBOX_ROOT` if set) and exports its absolute path as the internal `PW_SANDBOX` env var. Every test-side artifact lives inside it. A matching `globalTeardown` (`fixtures/sandbox-teardown.ts`) removes the entire subtree at end of run -- unless a test failed or `PW_SANDBOX_SKIP_CLEANUP` is set, in which case the path is logged and the contents are left in place for triage. The auto-created `pw_sandbox_<rand>` subtree is the only thing that ever gets removed; if you set `PW_SANDBOX_ROOT` yourself, that parent directory is never touched.

The Desktop fixture launches RStudio against per-spec subdirs under the sandbox, set via env vars and the Electron `--user-data-dir` switch. With `<sandbox>` = `$PW_SANDBOX` and `<rand>` = a random suffix:

| Setting | Value |
|----------|-------|
| `RSTUDIO_CONFIG_ROOT` | `<sandbox>/config_<rand>` |
| `RSTUDIO_CONFIG_HOME` | `<sandbox>/config_<rand>/config-home` |
| `RSTUDIO_CONFIG_DIR` | `<sandbox>/config_<rand>/config-dir` |
| `--user-data-dir` (Electron) | `<sandbox>/config_<rand>/electron-userdata` |
| `RSTUDIO_DATA_HOME` | `<sandbox>/data-home` (shared across specs in the invocation) |
| `HOME` / `USERPROFILE` | `<sandbox>/user-home` (shared across specs in the invocation) |

The `rstudio-prefs.json` (under `RSTUDIO_CONFIG_HOME`) is generated by merging defaults from `fixtures/base-prefs.jsonc` with an optional override from `PW_RSTUDIO_PREFS_OVERRIDE`; override values win per-key. The user's real RStudio profile and home dotfiles are untouched.

Because each Desktop launch has its own `--user-data-dir`, RStudio's single-instance attaching no longer applies between worker launches -- each spawn is a fresh, independent IDE process.

The shared `data-home/`, `user-home/`, `HOME`, and `USERPROFILE` are safe under the suite's `workers: 1` setting (see `playwright.config.ts`). If parallel workers are ever enabled, those would need to move back to per-spec subtrees or be partitioned per worker -- they aren't safe for concurrent writers as-is.

`PW_SANDBOX` resolves to a runner-side path. When the rsession runs on the same host as the test runner (Desktop, or Server pointed at `localhost`), the R workdir is created inside `PW_SANDBOX`, so `globalTeardown` removes it as part of the umbrella cleanup. When the rsession runs on a remote host (Server pointed at a non-`localhost` URL), `PW_SANDBOX` doesn't exist on the rsession filesystem, so the R workdir is created under R's own `dirname(tempdir())` instead. That keeps Server tests working against remote rsession, with one caveat: remote R-side workdirs aren't covered by `globalTeardown` and will accumulate on the rsession host across runs.

`HOME` / `USERPROFILE` point at a sandboxed `user-home/`. By default nothing is seeded there, so user dotfiles (`~/.Rprofile`, `~/.Renviron`, `~/.R/`, `~/.gitconfig`, `~/.ssh/`, etc.) are absent for tests. AI provider credentials are the exception: if the Posit Assistant state dir (`~/.posit/assistant`, or legacy `~/.positai/`) and/or the GitHub Copilot config directory exist on the host they're copied into the sandbox automatically so the `@ai` tests can drive the providers. Tests that need credentials check the matching `PW_AI_SEEDED_POSITAI` / `PW_AI_SEEDED_COPILOT` flag (set by `globalSetup` after a successful copy) via `requireAiCredentials()` and skip with a clean reason when unseeded -- so a missing credential surfaces as "skipped: no credentials seeded" rather than a 5-minute timeout. Set `PW_SANDBOX_NO_SEED_CREDENTIALS=1` to opt out of the auto-copy entirely (useful when the host isn't a dedicated test account); the `@ai` tests then skip across the board.

The Posit Assistant `@ai` tests normally download the official assistant package into the sandbox `data-home`. To run them against a locally built assistant instead, set `PW_SEED_PAI` to an install directory and `globalSetup` seeds it into `data-home/pai` (see Environment Variables).

On Windows, `globalSetup` pre-creates `user-home/AppData/Roaming/` and `user-home/AppData/Local/` because Electron's `app.getPath('appData')` fails at startup if those subdirs don't exist under the redirected `USERPROFILE` (the "Failed to get 'appData' path" popup). The same kind of scaffolding will likely be needed for macOS Desktop (`~/Library/Application Support`) and Linux Desktop (`~/.config`) when those platforms get tested.

### Page Objects

Page objects define **locators and low-level helpers** — where elements are and how to interact with them at the DOM level. Example: `typeInConsole(page, command)`.

### Actions

Actions define **higher-level operations** that compose multiple page-object calls. Example: `consoleActions.ensurePackages(['dplyr'])` checks for a package, installs it if missing, and verifies success.

## Writing Tests

### Basic Structure

```typescript
import { test, expect } from '@fixtures/rstudio.fixture';

test.describe('Feature name', () => {
  test('does something', async ({ rstudioPage: page }) => {
    // test code
  });
});
```

### Conventions

- **Parallel safety**: Default to `test.describe()`. Use `test.describe.serial()` only when tests share state (e.g., multi-turn chat conversations).
- **Failing tests**: Use `test.fixme()` — never comment tests out.
- **Cleanup**: prefer a `beforeAll` calling `consoleActions.resetSourcePane()` over per-test cleanup. That helper leaves the source pane in a single-Untitled-tab state -- it avoids the no-tabs/has-tabs HIDE animation race (#17738) that `closeAllBuffersWithoutSaving` triggers, and gives every test a known starting state. Use `saveAllSourceDocs` → `closeAllSourceDocs` only when the test must flush in-editor edits to disk.
- **File naming**: Test files use snake_case: `feature_name.test.ts`.
- **Temporary files**: Use timestamps (`test_${Date.now()}.R`) to avoid collisions.

### Selector Hierarchy

Prefer selectors in this order:

1. **Stable RStudio IDs** — e.g., `#rstudio_console_input`
2. **ARIA / role-based** — `getByRole()`, `aria-label`
3. **CSS attribute selectors** — `[class*=...]`, `[id^=...]`
4. **XPath** — only when CSS can't express it
5. **Never** `gwt-uid-XXXX` — these change on every restart

### Ace Editor Interactions

The console and source editor use Ace, which has a hidden textarea behind an overlay:

- **Always** `click({ force: true })` on `.ace_text-input` — the overlay intercepts normal clicks
- **Use `pressSequentially()`** for typing in the console/editor — ensures character-by-character detection
- **Never** use `ace.edit(element)` — it reinitializes the editor and breaks Copilot/NES

### Cross-Platform

Tests run on Windows, macOS, and Linux. Key rules:

- Use `ControlOrMeta` for shortcuts that are Cmd on macOS and Ctrl elsewhere (e.g., `ControlOrMeta+s` for Save).
- Use plain `Control` for shortcuts that are literally Ctrl on every platform, including macOS (e.g., `Control+Enter` for Run Line, `Control+l` for Clear Console). Using `ControlOrMeta` for these fires Cmd on macOS, which does something else entirely.
- Use `process.platform` guards for platform-branched keys like `Control+End` (Windows/Linux) vs `Meta+ArrowDown` (macOS).

### Sandbox (R-side scratch directory)

Specs that create files or directories on disk must route those writes into a **workdir** -- a unique per-spec subdirectory under the per-invocation sandbox at `$PW_SANDBOX` -- so tests don't pollute `~/`, the repo tree, or wherever R's cwd happens to be.

```typescript
import { useSuiteSandbox } from '@utils/sandbox';

const sandbox = useSuiteSandbox();

test('writes land in sandbox', async ({ rstudioPage: page }) => {
  await typeInConsole(page, `writeLines("hi", "${sandbox.dir}/foo.txt")`);
});
```

`useSuiteSandbox()` registers a `beforeAll` hook that creates the workdir under `$PW_SANDBOX` and `setwd()`s into it. `sandbox.dir` is populated before any test runs; use it when you need an absolute path. If you only need relative paths to land in the workdir, calling `useSuiteSandbox();` and discarding the return value is enough -- cwd is already redirected. There is no `afterAll` cleanup: the `globalTeardown` removes the entire `$PW_SANDBOX` subtree at end of run.

**Wizard-driven tests:** the New Project Wizard's parent-directory field is read-only. `setwd()` doesn't redirect it -- override the `default_project_location` preference via `.rs.api.writeRStudioPreference()` and restore it in `afterAll`. See `create_projects.test.ts` for the pattern.

**Tests that exercise a user-home-relative product path** (e.g. `chat-user-skills.test.ts` exercises `~/.positai/skills/`) should resolve `~` against the sandbox's redirected user-home, not against the runner's `os.homedir()`. The rstudio child process and its descendants (Databot, etc.) inherit `HOME` / `USERPROFILE` = `$PW_SANDBOX/user-home`, so the absolute path to use is computed from `process.env.PW_SANDBOX`. Guard against the env var being unset so a setup-ordering regression fails loud rather than producing `undefined/user-home`:

```ts
const PW_SANDBOX = process.env.PW_SANDBOX;
if (!PW_SANDBOX) throw new Error('PW_SANDBOX is not set');
const USER_HOME = path.join(PW_SANDBOX, 'user-home');
// ... then path.join(USER_HOME, '.positai', 'skills', ...)
```

Don't compute paths from Node's `os.homedir()` -- that returns the host home, which the rstudio child can't see.

**Low-level helper:** `createSandbox` is also exported from `@utils/sandbox` if you need to create an extra workdir under `$PW_SANDBOX` without going through `useSuiteSandbox()`.

### Overriding RStudio prefs

Suite-wide RStudio prefs come from `fixtures/base-prefs.jsonc`. To override one for a test run without editing that file, point `PW_RSTUDIO_PREFS_OVERRIDE` at a JSON or JSONC file containing the keys to override. The override merges per-key on top of the base, with override values winning.

```bash
PW_RSTUDIO_PREFS_OVERRIDE=/path/to/my-prefs.json npx playwright test ...
```

### Package Dependencies

`globalSetup` pre-installs a baseline manifest of CRAN packages into the shared `R_LIBS_USER` cache (see *R package pre-population* under Environment Variables). For tests using a package that's already in `REQUIRED_PACKAGES`, no extra setup is required.

For tests using a package outside the manifest, add it via `ensurePackages` in `beforeAll`. The helper installs into the same cache, so subsequent runs are no-ops:

```typescript
test.describe('Tests needing packages', () => {
  let missingPackages: string[] = [];
  test.beforeAll(async ({ rstudioPage: page }) => {
    missingPackages = await consoleActions.ensurePackages(['dplyr']);
  });
  test('my test', async ({ rstudioPage: page }) => {
    test.skip(missingPackages.length > 0, `Missing: ${missingPackages.join(', ')}`);
    // ...
  });
});
```

If you find yourself adding the same package to many tests, promote it into `REQUIRED_PACKAGES` so it gets pre-installed once at setup time.

## Tags

Tests use [Playwright tags](https://playwright.dev/docs/test-annotations#tag-tests) to indicate platform, edition, and product tier constraints. Apply tags via the `tag` option on `test()` or `test.describe()`:

```typescript
test.describe('Feature', { tag: ['@desktop_only'] }, () => { ... });
test('specific test', { tag: ['@macos_only'] }, async ({ rstudioPage: page }) => { ... });
```

### Available Tags

| Tag | Meaning |
|-----|---------|
| `@parallel_safe` | Test can run in parallel without interfering with other tests |
| `@serial` | Test must run sequentially (modifies shared state, restarts sessions, etc.) |
| `@macos_only` | Test only applies on macOS |
| `@windows_only` | Test only applies on Windows |
| `@linux_only` | Test only applies on Linux |
| `@desktop_only` | Test only applies to RStudio Desktop |
| `@server_only` | Test only applies to RStudio Server |
| `@pro_only` | Test requires RStudio Pro |
| `@os_only` | Test only applies to open-source RStudio |
| `@ai` | Test exercises an AI feature (Copilot ghost text / NES, Posit Assistant chat). Useful for skipping AI-dependent suites in offline or no-credential runs. |

### Filtering by Tag

The config defines two **projects** -- `desktop` and `server` -- each with a `grepInvert` computed at config load:

- **OS**: `desktop` excludes OS-only tags that don't match the host (`os.platform()`); `server` always excludes `@windows_only|@macos_only` (server targets Linux).
- **Edition**: `PW_RSTUDIO_EDITION=os` (default) excludes `@pro_only`; `PW_RSTUDIO_EDITION=pro` excludes `@os_only`.
- **Mode**: each project also excludes the opposite mode's tag (`@server_only` from `desktop`, `@desktop_only` from `server`).

Select a project with `--project`:

```bash
npx playwright test --project=desktop
npx playwright test --project=server
```

`PW_RSTUDIO_MODE=desktop|server` is a fallback for shell aliases when `--project` isn't passed. **`--project` wins** when both are set.

You can also filter manually with `--grep` and `--grep-invert`:

```bash
# Run only tests with a specific tag
npx playwright test --grep @desktop_only

# Exclude a single tag
npx playwright test --grep-invert @pro_only

# Exclude multiple tags
npx playwright test --grep-invert "@pro_only|@server_only"

# Skip AI-dependent tests (Copilot/NES + Posit Assistant chat)
npx playwright test --grep-invert @ai
```

You can also exclude tests by file path with `PW_TEST_IGNORE` (whitespace-separated globs):

```bash
# Exclude a single file
PW_TEST_IGNORE="**/code_suggestions.test.ts" npx playwright test

# Exclude an entire directory
PW_TEST_IGNORE="**/posit-assistant-chat/**" npx playwright test

# Combine both
PW_TEST_IGNORE="**/code_suggestions.test.ts **/posit-assistant-chat/**" npx playwright test
```

#### Summary: four ways to filter

|               | Include                                              | Exclude                                                    |
|---------------|------------------------------------------------------|------------------------------------------------------------|
| By file path  | `npx playwright test foo.test.ts` (positional arg)   | `PW_TEST_IGNORE="**/foo.test.ts" npx playwright test`      |
| By test title | `npx playwright test --grep "pattern"`               | `npx playwright test --grep-invert "pattern"`              |

Include sets the candidate pool; exclude trims it. When both apply, exclude wins.

## Environment Variables

| Variable | Mode | Required | Description |
|----------|------|----------|-------------|
| `PW_RSTUDIO_MODE` | Both | No | Fallback for `--project` (`desktop` or `server`); `--project` wins if both set. Default: `desktop`. |
| `PW_RSTUDIO_EDITION` | Both | No | `os` (default) or `pro`. Filters out `@pro_only` or `@os_only` tagged tests. |
| `PW_CDP_PORT` | Desktop | No | Override the CDP port (default: random 9231-9299) |
| `PW_RSTUDIO_DEV` | Desktop | No | Set to `1`/`true` to launch the in-tree dev build via `npm run start` in `src/node/desktop` instead of the installed RStudio binary. Assumes the rest of the product is already built. |
| `PW_RSTUDIO_SERVER_URL` | Server | No | Full URL, e.g., `http://10.0.0.1:8787`. If unset, a private in-tree `rserver-dev` is spawned per worker. |
| `PW_RSTUDIO_SERVER_PORT` | Server | No | Override the port in the URL |
| `PW_RSTUDIO_SERVER_USER` | Server | Conditional | Login username. Required only when the external server presents a login form; ignored for the in-tree spawn (`--auth-none`). |
| `PW_RSTUDIO_SERVER_PASSWORD` | Server | Conditional | Login password. Same conditional rule as `PW_RSTUDIO_SERVER_USER`. |
| `PW_RSTUDIO_SERVER_LOGIN_TIMEOUT` | Server | No | Post-login wait for the IDE console, in ms (default: 60000) |
| `PW_RSERVER_BIN` | Server | No | Path to the `rserver` binary used by the in-tree spawn (default: `build/src/cpp/server/rserver` in the repo). |
| `PW_RSERVER_CONF` | Server | No | Path to the `rserver-dev.conf` used by the in-tree spawn (default: `build/src/cpp/conf/rserver-dev.conf` in the repo). |
| `PW_RSTUDIO_EXTRA_ARGS` | Desktop | No | Space-separated extra CLI args passed to RStudio (e.g., `--my-flag --other-option`) |
| `PW_RSTUDIO_PREFS_OVERRIDE` | Desktop | No | Path to a JSON/JSONC file whose keys override `fixtures/base-prefs.jsonc` per-key. |
| `PW_TEST_IGNORE` | Both | No | Space-separated globs of test paths to exclude (e.g., `**/foo.test.ts **/posit-assistant-chat/**`). Fills the gap that Playwright has no CLI option for path-based exclusion -- file inclusion uses positional CLI arguments, and title filtering uses `--grep`/`--grep-invert`. |
| `PW_SANDBOX_ROOT` | Both | No | Parent directory under which the per-invocation sandbox is created. Defaults to `os.tmpdir()`. |
| `PW_SANDBOX_ROOT_CREATE` | Both | No | Set to `true`/`1` to auto-create `PW_SANDBOX_ROOT` if missing. Default `false` -- fails loud on typos. |
| `PW_SANDBOX_SKIP_CLEANUP` | Both | No | Set to `true`/`1` to preserve the sandbox at end of run regardless of pass/fail. |
| `PW_SEED_PAI` | Both | No | Path to a locally built Posit Assistant install directory (e.g. `~/.local/share/rstudio/pai`, as produced by the assistant repo's `npm run deploy:rstudio`). `globalSetup` copies it into the sandbox `data-home/pai`, so tests exercise that local build instead of downloading the official package. Fails loud if the path doesn't contain `bin/package.json`. The seeded build's `package.json` version and `protocol.json` must satisfy the IDE under test, or it will be treated as needing an update. |
| `PW_SANDBOX_NO_SEED_CREDENTIALS` | Both | No | Set to `true`/`1` to opt out of copying real AI credentials into the sandbox. By default, if the Posit Assistant state dir (`~/.posit/assistant`, or legacy `~/.positai/`) or the GitHub Copilot config directory (`%LOCALAPPDATA%\github-copilot\` on Windows, `~/.config/github-copilot/` on macOS/Linux) exists on the host, it's copied into the sandbox so `@ai` tests start authenticated. When this is set (or the source directory is absent), `@ai` tests skip with a clear "no credentials seeded" reason. Privacy: tokens land inside the sandbox and persist on failed runs until you delete it -- set this opt-out on machines that aren't dedicated test accounts. |
| `PW_RSTUDIO_R_LIBS_USER` | Both | No | Override the R user-library template path (passed to rsession as `R_LIBS_USER`). Defaults to `~/.cache/rstudio-playwright/r-libs/%p/%v` on macOS/Linux and `%LOCALAPPDATA%\rstudio-playwright\r-libs\%p\%v` on Windows. R expands `%p` (platform) and `%v` (R x.y) at startup. The library lives outside the per-run sandbox so packages persist between runs. |
| `PW_RSTUDIO_R_LIBS_SKIP_PREP` | Both | No | Set to `true`/`1` to skip globalSetup's pre-population of the user library. Useful when running against an R install that already has everything, or to reproduce the empty-library popup behavior on purpose. |
| `PW_WARMUP_LAUNCH` | Desktop | No | `1`/`true` to force a warmup launch in globalSetup; `0`/`false` to skip it. Default: on under CI, off locally. Skipped entirely in Server mode. |
| `PW_LAUNCH_ATTEMPTS` | Desktop | No | Number of attempts the in-fixture launch retry will make before giving up (default: `2`, i.e. one retry). |
| `PW_GWT_READY_TIMEOUT_MS` | Desktop | No | Override how long the fixture waits for `window.rstudio.ready === true` after CDP connects. Default: `60000` on CI, `30000` locally. |
| `PW_DEBUG_LAUNCH` | Desktop | No | Set to `1`/`true` to emit `[debug-launch]` / `[launch-timing]` traces (page lifecycle, console errors, post-CDP wait steps) during startup. Diagnostic only. |
| `PW_ENV_FILE` | Both | No | Path (relative to `e2e/rstudio/`) to a dotenv file loaded by `playwright.config.ts` before any env reads. Default: `.env.local`. Setting this to a missing file is a hard error (so typos surface immediately). See *`.env.local` (dotenv)* below. |

`PW_SANDBOX` itself is internal: it's set by `globalSetup` to the absolute path of the auto-created sandbox subtree and is read by workers, the R workdir helper, and `globalTeardown`. Don't set it manually. `PW_AI_SEEDED_POSITAI` / `PW_AI_SEEDED_COPILOT` are also internal: `globalSetup` sets them to `1` for each provider whose credentials were successfully copied; `requireAiCredentials()` reads them to decide whether to skip an `@ai` test. Don't set those manually either.

### R package pre-population

Because the Desktop and Server fixtures redirect `HOME` / `USERPROFILE` into the per-run sandbox, R computes an empty default user library and won't see the host user's installed packages. `globalSetup` works around this by pointing `R_LIBS_USER` at a stable per-host cache (see `PW_RSTUDIO_R_LIBS_USER` above) and pre-installing a manifest of packages that tests use -- the list lives in `REQUIRED_PACKAGES` inside `fixtures/r-libs-setup.ts`. The check is idempotent (`installed.packages()` then `setdiff`), so a warm cache adds almost no startup time; the first run installs ~23 packages from CRAN (or PPM on Linux) and may take a few minutes.

## Variable Helpers

The examples above use shell-prefix syntax (`KEY=val cmd ...`) which works in bash/zsh but not in `cmd.exe` or PowerShell. Two helpers are wired in for cases where you want a per-run setup without permanently changing your shell or Windows user environment.

### `cross-env` (inline, cross-shell)

`cross-env` parses leading `KEY=VAL` tokens on any shell, so the bash-style examples above work verbatim from PowerShell or `cmd.exe`. Combine it with `--project` to pick the project in the same line:

```powershell
npx cross-env PW_RSTUDIO_EDITION=pro npx playwright test --project=desktop
```

On bash/zsh it passes through unchanged; the native `PW_RSTUDIO_EDITION=pro npx playwright test --project=desktop` already works. Its reason for existing is `cmd.exe`/PowerShell, where the prefix syntax otherwise fails.

### `.env.local` (dotenv)

For a saved per-target setup instead of a long command line, `playwright.config.ts` loads `dotenv` before reading any env vars. Create `e2e/rstudio/.env.local` (gitignored) with whatever you want available to the run:

```
PW_RSTUDIO_MODE=server
PW_RSTUDIO_EDITION=pro
PW_RSTUDIO_SERVER_URL=http://10.0.0.5
PW_RSTUDIO_SERVER_USER=myuser
PW_RSTUDIO_SERVER_PASSWORD=mypass
```

Then just run:

```bash
npx playwright test
```

Notes:
- The file is loaded only when Playwright reads its config, so vars never leak into your shell.
- Vars already set in the shell (including via `cross-env`) win over values in the file; the file provides defaults, not overrides.
- Point at a different file with `PW_ENV_FILE=.env.staging npx playwright test`. Useful for keeping per-target files (`.env.10-0-0-5`, `.env.pro-staging`).
- A committed `.env.example` template documents the available keys.

## Claude Skills

Claude skills are available for use when working with this test suite:

- `.claude/skills/rstudio-create-playwright-tests/SKILL.md` — guide for writing tests
- `.claude/skills/rstudio-run-playwright-tests/SKILL.md` — test execution protocol

---

[*Fear not till Birnam Wood do come to Dunsinane*](https://www.folger.edu/explore/shakespeares-works/macbeth/read/5/5/#:~:text=Fear%C2%A0not%C2%A0till%C2%A0Birnam%C2%A0Wood%0A%C2%A0Do%C2%A0come%C2%A0to%C2%A0Dunsinane)

System Requirements
=============================================================================

These instructions *should* work on both an Intel Mac or an Apple Silicon Mac,
running a recent macOS release, but we recommend using an Apple Silicon Mac,
as it is required to create a Universal build.

Caveat: We are not actively testing building RStudio on Intel machines, so it is
possible it will stop working at some point.

Install Required Applications for MacOS
=============================================================================

Building RStudio requires installation of several components. The following
must be installed manually:

- R:         https://www.r-project.org/
- XCode:     https://developer.apple.com/xcode/

Note that after installing XCode you should also be sure to install the XCode
Command Line Tools, which can be done by running the following:

```bash
xcode-select --install
```

Installing Homebrew
=============================================================================
Before running the dependency scripts in the next section, you must install
the Homebrew package manager.

First, install Homebrew using the command given on the website at
https://brew.sh/, currently:

```bash
/bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/HEAD/install.sh)"
```

Next, if you are on an Apple Silicon Mac (as opposed to an older Intel-based Mac), re-run
that command, preceding it with `arch -x86_64`, for example:

```bash
arch -x86_64 /bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/HEAD/install.sh)"
```

Satisfy Additional Dependencies
=============================================================================

Additional dependencies can be satisfied by running the following script:

```bash
./install-dependencies-osx
```

Note that this script includes download, extraction, and compilation of
boost so can take some time to complete.

To skip specific Homebrew formulae -- for example, when R is already
installed from the CRAN `.pkg` -- set `RSTUDIO_SKIP_FORMULAS` to a
space-separated list of formula names before running the script:

```bash
RSTUDIO_SKIP_FORMULAS="r" ./install-dependencies-osx
```

Building the RStudio Distribution
=============================================================================

With dependencies satisfied, you should be able to produce a full packaged
build of RStudio as follows (assuming the repo is cloned to `~/rstudio`):

```bash
cd ~/rstudio/package/osx
./make-package
```

When completed, the resulting `.dmg` and standalone `.zip` can be found in
`~/rstudio/package/osx/build`.

Run `./make-package --help` for more information.

# README - `docs/reference`

Reference material for use by developers and agents working on the RStudio code.

Caution: we will try to keep it current and accurate, but always check the actual
code.

## ansi.md

[ansi.md](./ansi.md) - documentation on ANSI control code support in RStudio Console

# RStudio "Electron"

## Version Number Update:

To update the version number, just run `./scripts/update-json-version.sh "1.2.3"`

## Error Dialogs

To show error dialogs please use the `createStandaloneErrorDialog` function by importing it with

`import { createStandaloneErrorDialog } from './utils';`

Instead of using the `showErrorBox` function from the `electron` module.

## Linting and Formatting

Refer to the [Coding Standards (js, ts) Wiki page](https://github.com/rstudio/rstudio/wiki/Coding-Standards-(js,-ts)) for guidelines on code format and naming conventions.

Follow the steps in the [hooks README](/git_hooks/README.md) to set up the pre-commit hook, which will run the linter and formatter each time you `git commit` some code.

To format the entire project run `npm run format`. You are encouraged to run this before every commit to avoid unnecessary merge conflicts in the future, otherwise please install the pre-commit hook to automatically run the linter and formatter.

Code errors may arise due to running the linting and formatting. You can install the `Prettier` VS Code extension so you can run the formatter from a shortcut, or run it from the terminal.

## Command-line

- `--log-level=LEVEL`: control logging verbosity; from least verbose to
  most: `OFF`, `ERR`, `WARN`, `INFO`, `DEBUG` (the default is ERR)
- `--version-json`: output version information on RStudio desktop components, in JSON format, and exit

# lockfiles

This directory houses a variety of [renv](https://rstudio.github.io/renv)
lockfiles, which lock the R package versions used with the different Docker
images we build + test RStudio with.

If necessary, package versions can be tweaked (upgraded; downgraded) as
necessary depending on whether or not issues arise when building packages in
the associated Docker image.

See [this commit](https://github.com/rstudio/rstudio/pull/13820/commits/358ae40104453c691344a9e191a91eef5c16dc1d) for an example of how to add a new lockfile.

## How to generate a lockfile

1. On your development machine, use [docker-compile.sh](/docker/docker-compile.sh) to build an image for the platform you'd like to generate a lockfile for.

    ```bash
    # example
    ./docker-compile.sh opensuse15 server
    ```

2. Run a Docker container based on the image that was built.
    - You can use `docker image ls` to determine the Image Name or ID for the image you just built.
    - The below command will run an interactive `bash` shell for your container, based on the image.
    - To more easily retrieve the generated `renv.lock`, you may want to leverage Docker [bind mounts](https://docs.docker.com/storage/bind-mounts/) or [volumes](https://docs.docker.com/storage/volumes/)...but you can also just copy-paste the file contents if you don't want to set that up.
    - You can add `--rm` to remove the container upon exit automatically.

    ```bash
    docker run -ti <IMAGE_NAME_OR_IMAGE_ID> /bin/bash
    ```

3. In the container, navigate to the R library location.

    ```bash
    # example
    cd /root/R/aarch64-suse-linux-gnu-library/3.5
    ```

4. Open the R console in this location.

    ```bash
    R
    ```

5. You may need to install `renv` if it isn't already available.

    ```R
    install.packages("renv")
    ```

6. Before continuing in the R console, determine the versions you want to lock and verify the package repository date where the versions are available.

    The versions to lock are largely based on what's listed under [PACKAGES](/dependencies/common/install-packages), but you may need to pin to a specific version instead of using the unversioned package name.

    For example, we may want to pin `digest@0.6.31` and `testthat@3.1.10`, but use the latest (unversioned package names) for the rest of our dependencies.

    Generally, the most recent Posit Package Manager (PPM) package listing will be sufficient. You can find that date by looking at the most recent date (scroll to the bottom of the page) at [packagemanager.posit.co/cran](https://packagemanager.posit.co/cran).
    
    If you're not using the most recent date, you'll need to verify if the PPM repository listing at the date you're choosing is aware of all the dependency versions you need. To verify this:

    1. Look up each package you want to pin to a specific version at [Posit Package Manager](https://packagemanager.posit.co/client/#/repos/cran/packages/overview)
    2. On each package listing page, scroll to the "ARCHIVED VERSIONS" section and note the date of the version you want was made available.
        - digest
            > ARCHIVED VERSIONS
            > 
            > 0.6.31
            >
            > Dec 11, 2022 7:40 AM UTC
        - testthat   
            > ARCHIVED VERSIONS
            > 
            > 3.1.10
            >
            > Jul 6, 2023 10:00 PM UTC
    3. Ensure that the PPM listing date you choose is the same date or more recent than the availability date for the pinned versions you need.

    In this example, `https://packagemanager.posit.co/cran/2023-10-19` has the versions we need. `digest@0.6.31` was available on `2022-12-11` and `testthat@3.1.10` was available on `2023-07-06`, so the PPM listing for `2023-10-19` will know about these versions.

7. Back in the R console, using `renv::install`, install the default packages listed under [PACKAGES](/dependencies/common/install-packages). This is the time to pin specific versions of these packages! Pin by appending `@<VERSION>` to the package name.
    - `digest` and `testthat` are pinned to specific versions below.
    - see the [`renv::install` docs](https://rstudio.github.io/renv/reference/install.html) for more details and configuration.

    ```R
    # example
    renv::install(c(
        "digest@0.6.31",
        "purrr",
        "rmarkdown",
        "testthat@3.1.10",
        "xml2",
        "yaml"
    ))
    ```

8. Using `renv::snapshot`, snapshot the dependencies at the desired date.
    - the `repos` argument allows us to specify the repo and date of the snapshot (use the PPM url with the date you determined in step 6 above)
    - since we started `R` in the R library location, the current working directory already contains the relevant R packages to be snapshotted.
    - recursive dependencies will be included, unless otherwise configured.
    - see the [`renv::snapshot` docs](https://rstudio.github.io/renv/reference/snapshot.html) for more details and configuration.
    https://packagemanager.posit.co/cran/

    ```R
    # example
    renv::snapshot(repos = "https://packagemanager.posit.co/cran/2023-10-19")
    ```

    - When prompted `A large number of files (<NUMBER> in total) have been discovered.Do you want to proceed?`, respond "yes" (`y`).
    - When prompted `Packages must first be installed before renv can snapshot them. What do you want to do?`, respond "1: Snapshot, just using the currently installed packages." (`1`).
    - Your lockfile should have been written to your current working directory.

    ```R
    # example
    Lockfile written to "~/R/aarch64-suse-linux-gnu-library/3.5/renv.lock"
    ```

9. Exit R using `quit()` and copy the `renv.lock` to your development machine. If you didn't mount your filesystem in some way, you can `cat renv.lock` and copy-paste the contents to you development machine.

10. Update `renv.lock` if the platform already exists under [lockfiles](/dependencies/common/lockfiles/), or add the generated `renv.lock` in new platform directory (and copy in the `_deps.R` and `.dockerignore`).

11. Remove the lockfile entry for `renv` from `renv.lock` as it isn't needed.

12. Run [docker-compile.sh](/docker/docker-compile.sh) again to confirm that building the image still works and that the dependency versions match the `renv.lock` versions.

    ```bash
    # example
    ./docker-compile.sh opensuse15 server
    ```

## Purpose

This library exists to be shared with external projects from the IDE. Files should be added to this library only when they are directly needed by the IDE and an external project which uses this library. If the file/class will only be used by the IDE, it should be added to the `core` library, or another applicable library. If the file/class will be used only by an external project, it should be placed in the relevant location within that project. 

This library should be kept as small as possible to avoid adding unnecessary dependencies to external projects. Be careful when moving files or functionality from `core` to `shared_core` to avoid moving more than is absolutely necessary. If possible, try refactoring to reduce dependencies on the other classes in `core`. At the same time, the goal is to eliminate or greatly reduce duplicate code (and therefore duplicate maintenance), so if you feel like you're writing the same thing over again, it may be a good idea to put it here.

## Coding Standards

Currently this library is shared with the [Launcher Plugin SDK](https://github.com/rstudio/rstudio-launcher-plugin-sdk). Because the Launcher Plugin SDK has a stricter coding standard (because it is an SDK), files in this library must follow the coding standards that can be found on the [Launcher Plugin SDK Wiki](https://github.com/rstudio/rstudio-launcher-plugin-sdk/wiki/Coding-Standards)

## Licensing

Because the Launcher Plugin SDK uses an MIT license and the source will be distributed, files added to this library must also use an MIT license.

As an exception to this, Windows only files will not be shared with the Launcher Plugin SDK and may be licensed as usual (e.g. Win32StringUtils.cpp/hpp).

# RStudio User Guide

-   Source code: <https://github.com/rstudio/rstudio/tree/main/docs/user/rstudio>
-   Public URL: <https://docs.posit.co/ide/user/>

> If you’re interested in getting involved with open source, contributing to documentation is a good—and helpful—place to start. - [James Turnbill](https://increment.com/documentation/documentation-as-a-gateway-to-open-source/)

If you have found issues with the RStudio User Guide, please check for existing duplicate issues/pull requests. 
If a matching Issue/Pull Request doesn't exist, please then open an [Issue](https://github.com/rstudio/rstudio/issues/new/choose) or Pull Request. 
Each page in the RStudio User Guide docs have an option to view the source which is useful for specifying a line of code in an Issue. 
Alternatively, selecting "Edit this Page" will prepare you to open a quick Pull Request from your browser.

## Development

To locally test changes to the User Guide, you will need to do the following:

1.  [Install Quarto](https://quarto.org/docs/getting-started/installation.html) or RStudio 2022.07.2 or later, which bundles Quarto.

-   Quarto is bundled with RStudio. Download RStudio from [posit.co/downloads/](https://posit.co/downloads/)
-   If not using RStudio, download the CLI directly from [github.com/quarto-dev](https://github.com/quarto-dev/quarto-cli/releases/latest) for your operating system
-   Optionally install the Quarto R Package with `install.packages("quarto")`

2.  Clone the [rstudio](https://github.com/rstudio/rstudio) repo
3.  Open up the `docs/user/rstudio/` directory in your favorite IDE (RStudio!).
4.  Serve the project in one of the following ways.

This will serve the site to the RStudio Viewer or your web browser. Quarto will detect when you make changes to any of the `qmd` files and rerender that page. 

-   From an open `.qmd` file, click the **Render** button

-   From the command line, `quarto preview` from within the `docs/user/rstudio` directory:

```bash
cd docs/user/rstudio
quarto preview
```

-   From the R console, enter `quarto::quarto_preview()` on the file you've changed like below:

```r
quarto::quarto_preview(file = "docs/user/rstudio/index.qmd")
```

Regardless of the method - you are likely to see the below error, because you don't have the environment variables set that we use in the build process. You can safely ignore these as they are resolved during our render/publish of the guide to docs.posit.co.

```
WARNING: Unknown var buildType specified in a var shortcode.
WARNING: Unknown var version specified in a var shortcode.
```

5. Once you have confirmed that the changes are technically accurate and that the rendered output is visually correct, you can either open a Pull Request with your changes or an Issue with the suggested fix.

Thank you for your contribution to open source - it will definitely help future users (and probably you)!

# Summary

This README describes the internationalization (i18n) development workflow and helper tools available.

After making any change (even whitespace-only) to Commands.cmd.xml, you must run one of
`ant`, `ant draft`, or `ant generate-i18n` and commit all modified files along with Commands.cmd.xml.
Failure to do this will break the RStudio build.

This workflow requires Python3 to be active, and the requirements in commands.cmd.xml/requirements.txt
to have been installed (i.e. with `pip install -r requirements.txt`).

# i18n in RStudio

## Implementation Details

i18n is implemented using GWT's [i18n](http://www.gwtproject.org/doc/latest/DevGuideI18n.html) features, typically through static string internationalization.  Until i18n has been enabled across RStudio, non-English locales are enabled only when running `ant` in `SuperDevMode`.  

To localize part of the codebase, define interfaces that extend `com.google.gwt.i18n.client.Constants` and `.Messages`.  Include `String`s with `@DefaultStringValue`s in the interfaces for all localized text, and cite these `String` objects in your code to get their text values.  To add locales to your application, add properties files called `INTERFACENAME_LOCALE.properties`.  An example of this implemented is available in `src/org/rstudio/studio/client/application/ui/AboutDialog.java`, which cites:
* `AboutDialogConstants.java` (interface for constants)
* `AboutDialogConstants_en.properties` (English locale for constants)
* `AboutDialogConstants.java` (interface for messages)
* `AboutDialogMessages_en.properties` (English locale for messages)

When debugging, access non-English locales from `SuperDevMode` by adding `?locale=yourLocale` to the RStudio URL (for example, `http://localhost:8787/?locale=yourLocale`).

When serving localized content, GWT will serve it in the following order:
* Locale matching the locale selected, if available (if `?locale=en`, serve `*_en.properties` if it is available)
* Default locale (defined in `RStudio.gwt.xml` or other XML files), if available
* The `@DefaultStringValue` text

GWT suggests you always include both a `@DefaultStringValue` and at least one `.properties` file.

## Development Workflow 

When implementing i18n and going from hard-coded English text to text from an English properties file, it can be hard to know what is/is not translated and whether your translations are actually working because you are "translating" without changing the visible content.  One workflow to help with this problem is to use a "dev" locale which applies easily visible changes to the text for development purposes.  The "dev" locale is:
* a copy of the current English locale's `.properties` files, with "@" prepended to all constants and messages to make them clearly visible in the UI
* enabled when in SuperDevMode (server or desktop) and accessible at `http://localhost:8787/?locale=dev`, but not accessible during production use (see `RStudioSuperDevMode.gwt.xml`/`RStudioDesktopSuperDevMode.gwt.xml`)
* intended to be generated when needed during development and to be committed with the codebase (files are ignored in `.gitignore`)

For example, below shows a "dev" locale where menus and commands have i18n support but other text does not:

![Example of partly-translated dev locale](./rstudio-dev-locale-example.png)

# Tools

The following tools are included to help with i18n development:

## create_dev_locale.sh

Useful for debugging i18n and visually confirming what is/is not i18n-enabled by creating `*_dev.properties` files from
existing `*_en.properties` files.  The script copies the English properties files and prefixes their texts with `@`.

Run this script from `/src/gwt/src` with syntax `./create_dev_locale.sh`

## commands_xml_to_i18n.py

### Summary

Auto-generates java interfaces and properties files for all commands and menus defined with `Commands.cmd.xml` using 
the English text in that file.  This script must be run whenever `Commands.cmd.xml` is edited, and is automatically
executed whenever changes to this file are detected and the `build`, `desktop`, or `devmode` ant targets are triggered.

Usage below shows how to trigger the scripts manually (instead of via ant buildfile targets) for the creation of English
and "dev" locales, as discussed above for `create_dev_locale.sh`

TODO: Shortcuts in Commands.cmd.xml are not currently localizable.

### Usage

See `commands_xml_to_i18n.py -h` for more details on options.

Typical usage (from the `commands.cmd.xml` subfolder) is:

```shell
CMD_DIR="../../../src/org/rstudio/studio/client/workbench/commands/"

# Commands
# Interface (no prefix added to texts)
python commands_xml_to_i18n.py "${CMD_DIR}/Commands.cmd.xml" cmd constant "${CMD_DIR}/CmdConstants.java" --package "package org.rstudio.studio.client.workbench.commands;"
# English (en) properties file (no prefix added to texts)
python commands_xml_to_i18n.py "${CMD_DIR}/Commands.cmd.xml" cmd properties "${CMD_DIR}/CmdConstants_en.properties"
# (optional) Development (dev) properties file (prefix "@" added to all texts for development - see Summary)
python commands_xml_to_i18n.py "${CMD_DIR}/Commands.cmd.xml" cmd properties "${CMD_DIR}/CmdConstants_dev.properties" --prefix "@"

# Menus
# Interface (no prefix added to texts)
python commands_xml_to_i18n.py "${CMD_DIR}/Commands.cmd.xml" menu constant "${CMD_DIR}/MenuConstants.java" --package "package org.rstudio.studio.client.workbench.commands;"
# English (en) properties file (no prefix added to texts)
python commands_xml_to_i18n.py "${CMD_DIR}/Commands.cmd.xml" menu properties "${CMD_DIR}/MenuConstants_en.properties"
# (optional) Development (dev) properties file (prefix "@" added to all texts for development - see Summary)
python commands_xml_to_i18n.py "${CMD_DIR}/Commands.cmd.xml" menu properties "${CMD_DIR}/MenuConstants_dev.properties" --prefix "@"
```

### Tests

A minimal test suite for the tool is available using `python -m pytest ./test_command.py`

These are themes mostly copied from <https://github.com/mbadolato/iTerm2-Color-Schemes> with names to match the Ace theme names

They are used to generate the css mappings needed for the first 16 colors and
are parsed by `generate_xterm_16color_map()` included in `../compile-themes.R`

`download_theme_xrdb.R` is used to download the xrdb files, the URLs are listed in `theme_urls.tsv`

RStudio Server Global Fonts
===========================

RStudio's code editor and R console use a fixed-width font. By default users
must choose a fixed-width font supported by their browser for their R code. If
you wish to make additional fixed-width fonts available to your users, you can
place them in this directory (/etc/rstudio/fonts).

Fonts placed here will be automatically made available for selection in
RStudio's Appearances settings (Tools -> Global Options -> Appearance). 

Supported Formats
-----------------

The following font formats are supported:

- Web Open Font Format (.woff, .woff2)
- OpenType (.otf)
- Embedded OpenType (.eot)
- TrueType (.ttf)

Only fixed-width fonts are supported. Proportional fonts will cause cursor
positioning problems.

Naming and Directory Structure
------------------------------

The name of the file is presumed to be the name of the font. If you wish to
give the font a custom name, you can place it in a directory with your name of
choice. For example:

    + fonts/
    |
    +-- Coding-Font.ttf
    |
    +-- Coding Font Two/
        |
        +-- CodingFont2-Regular.woff

This directory structure would make two fonts available, *Coding-Font* and
*Coding Font Two*.

Some fonts come in many different weights and styles. If you want these weights
and styles to be treated as single font, you can place them underneath a single
folder. This is useful when a theme uses bold or italic variants of a font to
decorate code (e.g., to set comments in italics).

To do this, create subfolders with the font's weight or style. For example,
this creates a single font, "Coding Font 3", which has two weights (400 and 700
for regular and bold, respectively) and an italic style for each weight.

    + fonts/
    |
    +-- Coding Font Three/
        |
        +-- 400/
        |   |
        |   +-- CodingFont3-Regular.woff
        |   |
        |   +-- italic/
        |       |
        |       +-- CodingFont3-Italic.woff
        |
        +-- 700/
            |
            +-- CodingFont3-Bold.woff
            |
            +-- italic/
                |
                +-- CodingFont3-BoldItalic.woff

Defaults and User Configuration
-------------------------------

Fonts can also be installed for individual users rather than for the entire
server. The folder `~/.config/rstudio/fonts` works exactly as
`/etc/rstudio/fonts` does. In the case where a font exists in both folders, the
user font overrides the system font.

It is also possible to set a default font for all RStudio Server users using
the `server_editor_font_enabled` and `server_editor_font` options in
`rstudio-prefs.json`.. See the *Session User Settings* chapter of the RStudio
Workbench Administration Guide for more information.

Browser Fonts
-------------

RStudio Server attempts to automatically detect available fixed-width fonts
that are installed on a user's browser. For security reasons, it is not
possible for RStudio Server to enumerate all the fonts on the user's machine,
so a known list of popular programming fixed-width fonts are checked for
compatibility. This list is stored in the option `browser_fixed_width_fonts` in
`rstudio-prefs.json`.

## Server Database Schemas

This folder contains the database schemas for the RStudio Server database. These schemas are copied to the build output directory, and are applied to the database every time `rserver` is started.

Schema files rely on a file format convention containing the following:
* The date time at which the script was generated in the format YYYYMMDDHHmmssnnnnnnnnn (where nnnnnnnnn is nanoseconds)
* An underscore separating the date time from the friendly name
* A friendly name for what the script does
* A file extension, which can be `.sql`, `.sqlite`, or `.postgresql`. `.sql` files will be run for any database type, but the other two extensions are reserved for only running if the database in use corresponds to that file extension.

### Generating New Schemas

It can be cumbersome to generate the correct schema file names as they include a precise timestamp. For this purpose, simply run the `make-schema.sh` script from this folder, like so:

```
./make-schema AddNewTable sql
```

This will generate a file like `20200226141952248123456_AddNewTable.sql`. To generate schemas files that are database specific, leave off the `sql` part of the command, which will generate a schema file for each supported database type.

You should not generate both a `.sql` and specific database extension types for the same migration. In this case, both migrations would be run, but this is nonsensical. You should either generate one `.sql` migration for the generic case, or one migration for each specific targeted database, not both.

### Dev Schema Updates

In order to run any new schemas, you simply need to restart `rstudio-server` to ensure that any unapplied schemas are applied. Note that there is currently no way to rollback successful schema updates, so you are responsible for backing up your existing data if that is important to you.

### SQL Naming

Within your schema files, make sure to use `snake_case` naming for all table and column names. There are several reasons for preferring this. For more information, see https://github.com/rstudio/rstudio/issues/6589.

### Make Compatible Schema Changes

Ensure old code will work with the new schema for when users upgrade and downgrade. Use default values that makes sense for new columns. Always use column names in the schema (no wildcards), no destructive changes, no name changes. It's ok to abandon columns, that could eventually get cleaned up once affected versions are out of support.

## Documentation

When you change the database schema, ensure you also update the data dictionary in the documentation, found in `docs/server/data_dictionary`.

RStudio Global Custom Themes
=============================================================================

Add .rstheme files to this directory in order to install themes for all users.

Creating Custom Themes from a tmTheme File
-----------------------------------------------------------------------------
Custom themes can be created and installed globally by calling rstudioapi::convertTheme(<path to tmTheme file>, add = TRUE, globally = TRUE). This function will generate a name for the theme from the input when the theme is created. The theme name can be edited by changing the value of 	`rs-theme-name` inside the generated "rstheme" file.

Adding an Existing rstheme File
-----------------------------------------------------------------------------
"rstheme" files can be installed globally directly by calling rstudioapi::addTheme(<path to rstheme file>, globally = TRUE).

Setting a Custom Theme
-----------------------------------------------------------------------------
Once a custom theme has been installed locally or globally, users connecting to that server can see the custom theme in the list of themes in the Appearance Preferences pane. Alternately, the theme can be set by calling rstudioapi::applyTheme(<unique theme name>).

More Information
-----------------------------------------------------------------------------
For more information about working with the theme management API, see TODO.

# GWT Localized Strings

Under the path `src/gwt/src/org` are files matching `*_en.properties` containing English strings
for the user interface and files matching `*_fr.properties` containing French translations of
those strings.

## Properties File Categories

The `.properties` files are in three categories.

### (1) Generated Files

The following Java classes and their associated `*_en.properties` files are generated and must
not be edited directly. The matching `*_fr.properties` files are not generated and must be
manually updated.

- `src/gwt/src/org/rstudio/studio/client/workbench/prefs/model/UserPrefsAccessorConstants.java`
- `src/org/rstudio/studio/client/workbench/prefs/model/UserStateAccessorConstants.java`
- `src/gwt/src/org/rstudio/studio/client/workbench/commands/MenuConstants.java`
- `src/gwt/src/org/rstudio/studio/client/workbench/commands/CmdConstants.java`

### (2) Declarative UI

Files containing strings referenced in the declarative UI (`*.ui.xml` files).

These have names matching `*BinderImplGenMessages_en.properties` where the wildcard is the name
of the associated `.ui.xml` file.

One example (there are many others) is:

- `src/org/rstudio/studio/client/panmirror/dialogs/PanmirrorEditRawDialogBinderImplGenMessages_en.properties`

which is associated with

- `src/org/rstudio/studio/client/panmirror/dialogs/PanmirrorEditRawDialog.ui.xml`

### (3) All Others

Strings not generated by the build process or associated with a declarative UI file.

One example (there are many others) is

- `src/org/rstudio/studio/client/workbench/views/source/editors/text/EditorsTextConstants_en.properties`

which is associated with the Java class

- `src/org/rstudio/studio/client/workbench/views/source/editors/text/EditorsTextConstants.java`

All files in this category will following this naming convention where the part before `_en.properties`
is the name of the associated Java class.

In addition to matching the `*Constants.java` filename, only those files containing an 
`interface` that extends either `Messages` or `Constants`.

The Java class file contains entries of the form:

```java
    String chunkHtmlPageOutputFrame();
```

These have entries in the properties file where the key matches the method name.

```properties
chunkHtmlPageOutputFrame=Chunk HTML Page Output Frame
```

There is a special case when handling plural forms. This is currently only used once in the
`RSConnectConstants` class, as follows:

```java
@DefaultMessage("{0,number} environment variables will be published with this {1}.")
@AlternateMessage({"one", "1 environment variable will be published with this {1}."})
String envVarsPublishMessage(@PluralCount int itemCount, String contentType);
```

The matching properties are:

```properties
envVarsPublishMessage={0,number} environment variables will be published with this {1}.
envVarsPublishMessage[one]=1 environment variable will be published with this {1}.
```

## Other Considerations

- the key is case-sensitive
- the rules for escaping single-quotes in `.properties` files:
    - if the associatated Java class derives from `Constants` then only strings using placeholders
      such as {0}, {1}, etc. need to use `''` to represent a single `'`; strings not using 
      placeholders should use `'`
    - if the associated Java class derives from `Messages` then all strings must use `''` to 
      represent `'` whether or not they have placeholders

## Documentation on GWT i18n support

- https://www.gwtproject.org/doc/latest/DevGuideI18n.html

# RStudio Theme Maintenance

Most of the themes the RStudio IDE bundles are maintained by pulling the CSS versions of the themes from ACE and regenerating them using the `compile-themes.R` script in the `src/gwt/tools` folder. In general, changes should not be made to `.rstheme` files manually, as they will be overwritten each time that the themes are regenerated. To (re)generate themes:

1. Navigate to `src/gwt/tools`
2. Run `./sync-ace-commits`
3. Run `Rscript compile-themes.R`

## Manually Maintained Themes

Some themes were contributed to the RStudio IDE as already created `.rstheme` files, and do not have an associated source `.css` file. The following is the current list of themes which need to be updated manually if any changes are required:

* material.rstheme

## Test Cases

The tests cases validate that `tmTheme` files can be converted into Ace CSS  and that the same Ace CSS can then be converted into `rstheme` files . The Ace CSS files are the expected output for the `tmTheme -> Ace CSS` conversion, and the input for the `Ace CSS -> rstheme` conversion.

In addition, the test cases also:
  * validate that invalid `tmTheme`s will produce an error and not an Ace CSS file.
  * validate that files are installed to the global and local theme directories correctly.
  * validate that themes will not be installed to folders which have restrictive permissions.
  * validate that themes will be installed (or not installed) over existing `rsthemes` with the same name based on the options specified.
  * validate that the IDE bundled themes exist and the API returns the correct information about them.

The folder structure of the tests cases is described below:
 * `src/cpp/tests/testthat`
    * `regenerate-css.R` - script which regenerates expected results
    * `test-themes.R` - the themes test cases
    * `themes` - root folder for expected input and output
        * `acecss` - expected output for `tmTheme -> Ace CSS` and input for `Ace CSS -> rsthemes`
        * `errorthemes` - invalid `tmTheme` files that should generate an error
        * `globalInstall` - folder that will be used as the "global" install location. Should be empty after tests complete.
        * `localInstall` - folder that will be used as the "local" install location. Should be empty after tests complete.
        * `nopermission` - folder with restrictive permissions. Should always be empty.
        * `rsthemes` - expected output for `Ace CSS -> rstheme` conversion
        * `thmThemes` - input for `tmTheme -> Ace CSS` conversion

### Fixing the Test Cases

The most common cause of failing test cases is that new fields were added to (or extra fields were removed from) the generated `rstheme` files. The expected results can be updated using the `regenerate-css.R` script by loading the `themes` list from `test-themes.R` into the local R environment and then sourcing `regenerate-css.R`. Note that `xml2` is required, as it would be to install a custom theme to the IDE. After regenerating the expected results, it is a good idea to manually check that the changes in the expected results are only include the changes you expected.

Another easy-to-fix scenario is when a new bundled theme is added to the IDE. To resolve this, add a new line to the `defaultThemes` list in `test-themes.R` (in alphabetical order) for the new theme and set the `fileName` and `isDark` fields as appropriate.

Other problems in the test cases may require debugging. The easiest way to debug the test cases is to add a `browser` call to the failing test case  and then run `testthat::test_file("test-themes.R")` from the R console. Note that this requires the working directory of the R console to be `src/cpp/tests/testthat`. Alternately, a full or relative path to the `test-themes.R` file may be provided.

NOTE: Changes to `src/cpp/session/modules/resources/compile-themes.R` and `src/cpp/session/modules/SessionThemes.R` require the CMake project to be reloaded before they will be observed in the test results.

# RStudio Electron UI

This README documents the structure of custom widgets used in RStudio.

For example, consider a widget called 'clock'. The following files should be created:

```
widgets/clock.ts            <required>
widgets/clock/ui.html       <required>
widgets/clock/preload.ts    <required>
widgets/clock/load.ts       <optional>
widgets/clock/styles.css    <optional>
```

## widgets/clock.ts

This module should export a class defining the widget itself. It should inherit
either from Electron's `BrowserWindow` class, or from one of our utility classes
derived from `BrowserWindow`. This is the main module that should be imported by
others that want to use the 'clock' widget.

## widgets/clock/ui.html

The actual HTML used for the window.

## widgets/clock/preload.ts

The preload script. This should primarily be used to expose callbacks used so
that the window can communicate with the main process, which should typically
communicate via messages sent on the `ipcRenderer` object. See
https://www.electronjs.org/docs/api/context-bridge for more details.

## widgets/clock/load.ts

An optional load script. This should be used to initialize widget-specific
behaviours in the widget.

## widgets/clock/styles.css

An optional CSS stylesheet. To be applied to the HTML content after the page
has been loaded. Note that the CSS stylesheet contents are transferred via
Electron IPC, so if your widget has a custom stylesheet you should ensure
`preload.ts` receives that CSS and applies the style in an appropriate channel.

## Modal Widgets

Modal widgets which need to return a value should inherit from the `ModalWindow`
class, and provide a `showModal()` method. For example:

```
export class ModalClock extends ModalWindow<Time> {

    async onShowModal(): Promise<Time> {
        // perform other page initialization
        // return a promise that is resolved on some appropriate user gesture;
        // e.g. signaled via a message received via IPC from the page
    }

}
```

Users of these widgets can then do something of the form:

```
const widget = new ModalClock();
[result, error] = await widget.showModal();
if (error) {
    // handle error
}
```

# Visual C++ Runtime Files

The DLLs in this folder will be installed as part of RStudio, and should be updated to match the
ones included with most recent major version of the Microsoft Visual C++ toolset (currently 2022).

## How To Update These Files

Microsoft doesn't make it easy to get the files from vc_redist.exe. There is an /extract argument
that is documented as doing so, but this hasn't worked in many, many years, and never will.

The best way is to install the latest version of Microsoft Visual C++ build tools, and copy the
files from its redist folders.

Download `vs_buildtools.exe` from: https://visualstudio.microsoft.com/visual-cpp-build-tools/.

```powershell
vs_buildtools.exe --passive --add Microsoft.VisualStudio.Workload.VCTools --add Microsoft.VisualStudio.Component.VC.Tools.x86.x64
```

Copy all the files from the following to the x64 and x86 folders.

- x64: `C:\Program Files (x86)\Microsoft Visual Studio\2022\BuildTools\VC\Redist\MSVC\14.42.34433\x64\Microsoft.VC143.CRT\*.*`
- x86: `C:\Program Files (x86)\Microsoft Visual Studio\2022\BuildTools\VC\Redist\MSVC\14.42.34433\x64\Microsoft.VC143.CRT\*.*`
- ARM: future

Note that "2022", "14.29.30133", and "VC143" will need to be updated to match what has actually
been installed.

## TLDR; More Background

Up to and including version 2024.12.1, RStudio desktop on Windows installed the vc_redist and
ucrt files via CMake's `CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_SKIP` and `CMAKE_INSTALL_UCRT_LIBRARIES`.

CMake uses the versions of the redist files that came with the Visual C++ build tools installed
on the build machine, installing into RStudio folder, not globally.

Unless we keep the compiler up-to-date, we may end up installing runtimes that
are not compatible with those installed system-wide (C:\Windows\system32, etc.), which can
lead to crashes such as https://github.com/rstudio/rstudio/issues/15674.

This is because "...the version of the Microsoft Visual C++ Redistributable installed on the machine
must be the same or higher than the version of the Visual C++ toolset used to create your application."

# What's New Content

This directory contains the per-release content shown in the "What's New" window
on first launch of each RStudio Desktop release.

## Directory Structure

```
whats-new/
├── whats-new-base.css              # Shared base stylesheet
├── globemaster-allium/             # Content for "Globemaster Allium" release
│   ├── index.html
│   └── images/                     # Optional images
│       └── feature-screenshot.png
└── <next-release-slug>/
    └── index.html
```

## Adding Content for a New Release

1. **Create a folder** named after the release's flower name, converted to a slug:
   - Lowercase the name
   - Remove apostrophes
   - Replace spaces and non-alphanumeric characters with hyphens

   Examples: "Globemaster Allium" → `globemaster-allium`, "King's Crown" → `kings-crown`

2. **Create `index.html`** in that folder using the template below.

3. **Add images** (optional) in the same folder or an `images/` subfolder.
   Use relative paths in the HTML (e.g., `<img src="images/screenshot.png">`).

4. **Run tests** to verify the required tags are present:
   ```
   cd src/node/desktop && npm test
   ```

## Template

Copy this into your new `index.html` and edit the content. Replace
`YYYY.MM.PATCH` in the release notes URL with the actual version
(e.g., `2026.04.0`):

```html
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="Content-Security-Policy" content="default-src 'self' 'unsafe-inline' file:;">
  <link rel="stylesheet" href="../whats-new-base.css">
  <title>What's New in RStudio</title>
</head>
<body>
  <div class="feature-section">
    <h2>New Features</h2>
    <ul>
      <li>Feature description here</li>
    </ul>
  </div>

  <div class="feature-section">
    <h2>Fixes</h2>
    <p>
      For a full list of bug fixes in this release, see the
      <a href="https://www.rstudio.org/links/release_notes#rstudio-YYYY.MM.PATCH">release notes</a>.
    </p>
  </div>
</body>
</html>
```

## Requirements

Each `index.html` **must** include:

- The `Content-Security-Policy` meta tag (as shown in the template)
- The `whats-new-base.css` stylesheet link

These are enforced by automated tests.

## Styling

The base stylesheet (`whats-new-base.css`) provides:

- System font stack, light background, base typography
- Heading styles (`h2`, `h3`)
- List and paragraph spacing
- Image styling (max-width, rounded corners, border)
- Link colors
- `.feature-section` class for spacing between sections

You can add a `<style>` block in your `index.html` to extend or override the
base styles.

## How It Works

The What's New window is a wrapper page with a fixed header (release name and
version), a scrollable iframe that loads your `index.html`, and a footer with a
Close button. Each release page must be a complete HTML document including the
required `<head>` tags (CSP and stylesheet). The wrapper provides the outer
window chrome (header, footer, close/escape behavior) around the iframe.

External links (`https://`, `http://`) open in the user's default browser.

## Environment Variables

| Variable | Effect |
|----------|--------|
| `RSTUDIO_SHOW_WHATS_NEW` | Force the What's New window at startup (any value). Bypasses build type and seen-state checks. Content must still exist. |
| `RSTUDIO_DISABLE_WHATS_NEW` | Suppress the What's New window at startup (any value). The **Help** > **What's New** command still works. |

These must be set in your shell environment before launching RStudio.
Setting them in `.Renviron` will not work because the What's New check
runs in the Electron process before R starts.

## Testing Locally

Set `RSTUDIO_SHOW_WHATS_NEW=1` when launching RStudio Desktop to force the
What's New window to appear at startup, regardless of build type or seen state.

Use **Help** > **What's New** to open it on demand.

# Adding data source icons

### File name matching

Data source icons are displayed in the connection dialog when the icon file name matches one or more of the references below. Name matching is done with case insensitive exact matching (minus the file extension). For example, references to `SQLServer` will match `sqlserver.png`. However, references to `microsoftsqlserver` will *not* match `sqlserver.png`.

There are five ways to match data source icons. For more info, see [Troubleshooting Connections](https://support.posit.co/hc/en-us/articles/115011264307).

1.  The driver name in `odbcinst.ini`

2.  The DSN name in `odbc.ini`

3.  The DSN name in `.odbc.ini`

4.  The snippet name on the system under `/etc/rstudio/connections/<snippet name>.R`

5.  The snippet name in an R package under `inst/rstudio/connections/<snippet name>.R` provided the R package has a valid [connections contract](https://rstudio.github.io/rstudio-extensions/rstudio-connections.html)

### Icon size and resolution

Each data source should have a large and small `png` icon.

#### Small ![](sqlite.png)

-   Name: `<data source>.png`
-   Size: 32px x 32px
-   Resolution: 72 px/in

#### Large ![](sqlitelarge.png)

-   Name: `<data source>large.png`
-   Size: 64px x 64px
-   Resolution: 72 px/in

gwt-websockets
==============

[<img src="https://img.shields.io/maven-central/v/com.sksamuel.gwt/gwt-websockets*.svg?label=latest%20release"/>](http://search.maven.org/#search%7Cga%7C1%7Ca%3A%22gwt-websockets%22)

A simple GWT wrapper for javascript websockets which enable you to avoid writing native javascript code. This is not a fully featured client/server framework for websockets. Instead it is a simple wrapper for client side code when you need to connect to an existing websocket server. For example, this library was built because I needed to connect a mobile GWT webapp to a Java websocket system that used Apache Camel.

This library has no dependency outside of the standard GWT distribution.

To use add this dependency to your project (hosted on maven central):

    <dependency>
        <groupId>com.sksamuel.gwt</groupId>
        <artifactId>gwt-websockets</artifactId>
        <version>1.0.4</version>
    </dependency>

Then update your .gwt.xml files to include this:

    <inherits name="com.sksamuel.gwt.GwtWebsockets" />

Getting Started
===============

To create a websocket in your code, use 

`Websocket socket = new Websocket("ws://hostname:port/path");`

Then attach one or more listeners which are used for the callbacks:

    socket.addListener(new WebsocketListener() {

        @Override
        public void onClose(CloseEvent event) {
    	    // do something on close
        }

        @Override
        public void onMessage(String msg) {
	        // a message is received
        }

        @Override
        public void onOpen() {
	        // do something on open
        }
    });
    
When the socket is successfully connected, the onOpen() callback will be invoked on each of your listeners. Similarly, for onClose() and onMessage(String). Note: You can add as many listeners as you want, and you can remove/add while the socket is open.

To open a websocket use `socket.open();`

To close a websocket `socket.close();`

To send a message to the websocket server `socket.send("My message");`

Sometimes you might want to check if websockets are available on your target system. For this you can use the static method `Websocket.isSupported()` which returns true if websockets are available.

You can create as many websockets as you want on a single page. The library takes care of assigning each one to a different javascript global.

Finally, you can get the status of the socket using the method `socket.getState()` which returns an integer for the
current state of the socket, where `CONNECTING = 0, OPEN = 1, CLOSING = 2, CLOSED = 3`.

Have fun.

Binary support
===============

Version 1.0.1 adds support for byte methods for sending and receiving. To send, simply use send(byte[]) method on Websocket. To receive, you must implement BinaryWebsocketListener instead of WebsocketListener and then you have a new callback method onMessage(byte[]).

Because binary support on websockets isn't yet supported on all browsers, this modules sends binary data using base64.

## License
```
This software is licensed under the Apache 2 license, quoted below.

Copyright 2013 Stephen Samuel

Licensed under the Apache License, Version 2.0 (the "License"); you may not
use this file except in compliance with the License. You may obtain a copy of
the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
License for the specific language governing permissions and limitations under
the License.
```

#
# SessionDataPreview.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("preview_sql", function(code)
{
   # helper function for reporting errors
   onError <- function(reason) {
      .rs.scalar(.rs.truncate(reason))
   }
   
   # parse the user-provided code
   parsed <- .rs.tryCatch(parse(text = code)[[1]])
   if (inherits(parsed, "error"))
      return(onError("Failed to parse SQL preview comment."))
   
   # substitute missing arguments for NULL, so that match.call
   # does what we expect
   for (i in seq_along(parsed))
      if (identical(parsed[[i]], quote(expr = )))
         parsed[i] <- list(NULL)

   # attempt to match the call
   matched <- .rs.tryCatch(match.call(.rs.previewSql, parsed))
   if (inherits(matched, "error"))
      return(onError("Unexpected SQL preview comment."))
   
   # validate that the user provided a connection
   if (is.null(matched$conn))
      return(onError("No connection was specified in SQL preview comment."))
   
   # okay, try to evaluate it
   status <- .rs.tryCatch(eval(parsed, envir = globalenv()))
   if (inherits(status, "error"))
      return(onError(conditionMessage(status)))
   
   invisible(status)
})

.rs.addFunction("previewDataFrame", function(data, script)
{
   preparedData <- .rs.prepareViewerData(
      data,
      maxFactors = 100,
      maxCols = 100,
      maxRows = 1000
   )

   preview <- list(
      data = preparedData$data,
      columns = preparedData$columns,
      title = if (is.character(script)) .rs.scalar(script) else NULL
   )

   .rs.enqueClientEvent("data_output_completed", preview)
   
   invisible(NULL)

})

.rs.addFunction("previewSql", function(conn, statement, ...)
{
   script <- NULL
   if (file.exists(statement)) {
      script <- statement
      statement <- paste(readLines(script), collapse = "\n")
   }

   # remove comments since some drivers might not support them
   statement <- gsub("--[^\n]*\n+", "", statement)

   # force the connection to let DBI and others initialize S3
   conn <- .rs.tryCatch(force(conn))
   if (inherits(conn, "error")) {
      msg <- paste("Failed to retrieve connection:", conditionMessage(conn))
      return(.rs.scalar(msg))
   }

   # fetch at most 100 records as a preview
   status <- .rs.tryCatch({
      rs <- DBI::dbSendQuery(conn, statement = statement, ...)
      data <- DBI::dbFetch(rs, n = 1000)
      DBI::dbClearResult(rs)
   })
   
   if (inherits(status, "error")) {
      msg <- paste("Failed to query database:", conditionMessage(status))
      return(.rs.scalar(msg))
   }

   .rs.previewDataFrame(data, script)
})

#
# SessionStan.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("stan_get_completions", function(line)
{
   .rs.stan.getCompletions(line)
})

.rs.addJsonRpcHandler("stan_get_arguments", function(f)
{
   .rs.stan.getArguments(f)
})

.rs.addJsonRpcHandler("stan_run_diagnostics", function(file, useSourceDatabase)
{
   .rs.stan.runDiagnostics(file, useSourceDatabase)
})

.rs.addFunction("stan.getCompletions", function(line)
{
   Encoding(line) <- "UTF-8"
   completions <- .rs.emptyCompletions()
   
   # extract token from line
   parts <- .rs.strsplit(line, "\\W+")
   token <- tail(parts, n = 1)
   
   # TODO: what kind of completions to supply when we have no token?
   if (!nzchar(token))
      return(.rs.emptyCompletions(language = "Stan"))
   
   # construct keyword completions
   keywords <- c(
      .rs.stan.keywords(),
      .rs.stan.types(),
      .rs.stan.blocks()
   )
   
   completions <- .rs.appendCompletions(
      completions,
      .rs.makeCompletions(
         token   = token,
         results = .rs.selectFuzzyMatches(keywords, token),
         type = .rs.acCompletionTypes$KEYWORD
      )
   )
   
   # construct function completions
   rosetta <- .rs.stan.rosetta()
   matches <- .rs.fuzzyMatches(rosetta$StanFunction, token)
   
   completions <- .rs.appendCompletions(
      completions,
      .rs.makeCompletions(
         token    = token,
         results  = rosetta$StanFunction[matches],
         packages = "function",
         type     = .rs.acCompletionTypes$FUNCTION,
         meta     = rosetta$Arguments[matches]
      )
   )
   
   completions
   
})

.rs.addFunction("stan.getArguments", function(f)
{
   none <- .rs.scalar("")
   
   rosetta <- .rs.stan.rosetta()
   if (is.null(rosetta))
      return(none)
   
   idx <- match(f, rosetta$StanFunction)
   if (is.na(idx))
      return(none)
   
   arguments <- rosetta$Arguments[idx]
   
   # if this is a distribution function, borrow arguments from the
   # corresponding '_lpdf' or '_lpmf' function
   if (identical(arguments, "~"))
   {
      for (suffix in c("lpdf", "lpmf"))
      {
         method <- paste(f, suffix, sep = "_")
         idx <- match(method, rosetta$StanFunction)
         if (!is.na(idx))
            break
      }
      
      if (is.na(idx))
         return(none)
      
      arguments <- rosetta$Arguments[idx]
   }
   
   .rs.scalar(arguments)
})

.rs.addFunction("stan.runDiagnostics", function(file, useSourceDatabase)
{
   if (!requireNamespace("rstan", quietly = TRUE))
      return(list())
   
   # update the file path if we're using the source database
   if (useSourceDatabase)
   {
      candidate <- .rs.stan.copySourceDatabaseToTempfile(file)
      if (!is.null(candidate))
      {
         file <- candidate
         on.exit(unlink(dirname(candidate), recursive = TRUE), add = TRUE)
      }
   }
   
   # invoke stan compiler and capture messages; note that the Stan
   # compiler will write some things to stderr and so we need to be careful
   # to capture that as well
   so <- textConnection(NULL, open = "w")
   on.exit(close(so), add = TRUE)
   
   se <- textConnection(NULL, open = "w")
   on.exit(close(se), add = TRUE)
   
   sink(so, type = "output")
   sink(se, type = "message")
   
   messages <- c()
   result <- tryCatch(
      withCallingHandlers(
         rstan::stanc_builder(file),
         message = function(m) {
            messages <<- c(messages, conditionMessage(m))
            invokeRestart("muffleMessage")
         },
         warning = function(w) invokeRestart("muffleWarning")
      ),
      error = identity
   )
   
   # close our sinks
   sink(NULL, type = "output")
   sink(NULL, type = "message")
   
   # bail if we failed to invoke the compiler
   if (!inherits(result, "error"))
      return(list())
   
   # search for relevant information
   pattern <- "^\\s*error in '([^']+)' at line (\\d+), column (\\d+)"
   line <- grep(pattern, messages, value = TRUE)
   if (length(line) != 1)
      return(list())
   
   m <- regexec(pattern, line)
   matches <- regmatches(line, m)[[1]]
   if (length(matches) != 4)
      return(list())
   
   # keep all lines without indent for messages
   lines <- grep("^\\s+", messages, value = TRUE, invert = TRUE)
   message <- paste(tail(lines, n = -1), collapse = "")
   
   # TODO: although we only ever get one error now, return a vector of
   # error objects in anticipation of that changing in the future.
   # (unfortunately diagnostics emitted on stderr don't provide line information)
   errors <- list(
      list(
         row    = as.numeric(matches[[3]]) - 1,
         column = as.numeric(matches[[4]]) - 1,
         type   = "error",
         text   = message
      )
   )
   
   # make all entries scalar
   rapply(errors, .rs.scalar, how = "replace")
   
})

.rs.addFunction("stan.extractFromNamespace", function(key)
{
   if (!requireNamespace("rstan", quietly = TRUE))
      return(NULL)
   
   rstan <- asNamespace("rstan")
   rstan[[key]]
})

.rs.addFunction("stan.keywords", function()
{
   keywords <- .rs.stan.extractFromNamespace("stan_kw1")
   if (is.character(keywords))
      return(keywords)
   
   c("for", "in", "while", "repeat", "until",
     "if", "then", "else",  "true", "false")
})

.rs.addFunction("stan.types", function()
{
   types <- .rs.stan.extractFromNamespace("stan_kw2")
   if (is.character(types))
      return(types)
   
   c("int", "real", "vector", "simplex", "ordered",
     "positive_ordered", "row_vector", "matrix",
     "corr_matrix", "cov_matrix", "lower",  "upper")
})

.rs.addFunction("stan.blocks", function()
{
   blocks <- .rs.stan.extractFromNamespace("stan_kw3")
   if (is.character(blocks))
      return(blocks)
   
   c("model", "data", "parameters",
     "quantities", "transformed", "generated")
})

.rs.addFunction("stan.rosetta", function()
{
   rosetta <- .rs.stan.extractFromNamespace("rosetta")
   if (!is.data.frame(rosetta))
      return(data.frame())
   
   # remove operator functions
   rosetta <- rosetta[grep("^operator", rosetta$StanFunction, invert = TRUE), ]
   
   # remove duplicates
   rosetta <- rosetta[!duplicated(rosetta$StanFunction), ]
   
   rosetta
})

.rs.addFunction("stan.copySourceDatabaseToTempfile", function(file)
{
   properties <- .rs.getSourceDocumentProperties(file, includeContents = TRUE)
   if (is.null(properties) || is.null(properties$contents))
      return(NULL)
   
   dir <- tempfile("rstudio-stan-diagnostics-")
   if (!dir.create(dir, showWarnings = FALSE))
      return(NULL)
   
   newPath <- file.path(dir, basename(file))
   status <- tryCatch(
      writeLines(properties$contents, con = newPath, useBytes = TRUE),
      error = identity
   )
   
   if (inherits(status, "error") || !file.exists(newPath))
      return(NULL)
   
   newPath
})

#
# This is the user-interface definition of a Shiny web application. You can
# run the application by clicking 'Run App' above.
#
# Find out more about building applications with Shiny here:
#
#    http://shiny.rstudio.com/
#

library(shiny)

# Define UI for application that draws a histogram
shinyUI(fluidPage(

    # Application title
    titlePanel("Old Faithful Geyser Data"),

    # Sidebar with a slider input for number of bins
    sidebarLayout(
        sidebarPanel(
            sliderInput("bins",
                        "Number of bins:",
                        min = 1,
                        max = 50,
                        value = 30)
        ),

        # Show a plot of the generated distribution
        mainPanel(
            plotOutput("distPlot")
        )
    )
))

#
# SessionRMarkdown.R
#
# Copyright (C) 2009-12 by RStudio, Inc.
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("scalarListFromList", function(l)
{
   # hint that every non-list element of the hierarchical list l
   # is a scalar value if it is of length 1
   l <- lapply(l, function(ele) {
      if (is.null(ele))
         NULL
      else if (is.list(ele)) 
         .rs.scalarListFromList(ele)
      else if (length(ele) == 1) {
         # mark strings with encoding unless already marked (see comment
         # below in convert_to_yaml)
         if (is.character(ele) && Encoding(ele) == "unknown")
            Encoding(ele) <- "UTF-8"
         .rs.scalar(ele)
      }
      else
         ele
   })
})

.rs.addFunction("isREADME", function(file) {
  identical(tools::file_path_sans_ext(basename(file)), "README")
})

.rs.addFunction("updateRMarkdownPackage", function(archive) 
{
  pkgDir <- find.package("rmarkdown")
  .rs.forceUnloadPackage("rmarkdown")
  .Call("rs_installPackage",  archive, dirname(pkgDir))
})

.rs.addFunction("getRmdRuntime", function(file) {
   lines <- readLines(file, warn = FALSE)

   yamlFrontMatter <- tryCatch(
     rmarkdown:::parse_yaml_front_matter(lines),
     error=function(e) {
        list()
     })

   if (!is.null(yamlFrontMatter$runtime))
      yamlFrontMatter$runtime
    else
      ""
})

.rs.addFunction("getCustomRenderFunction", function(file) {
  # read the contents of the file
  lines <- readLines(file, warn = FALSE)
  
  # mark the encoding if it's available
  properties <- .rs.getSourceDocumentProperties(file)
  if (identical(properties$encoding, "UTF-8"))
    Encoding(lines) <- "UTF-8"
  
  yamlFrontMatter <- tryCatch(
    rmarkdown:::parse_yaml_front_matter(lines),
    error = function(e) {
      list()
    }
  )

  if (is.character(yamlFrontMatter[["knit"]]))
    yamlFrontMatter[["knit"]][[1]]
  else if (!is.null(yamlFrontMatter$runtime) &&
           grepl('^shiny', yamlFrontMatter$runtime)) {
    # use run as a wrapper for render when the doc requires the Shiny runtime,
    # and outputs HTML. 
    tryCatch({
       outputFormat <- rmarkdown:::output_format_from_yaml_front_matter(lines)
       formatFunction <- eval(parse(text = outputFormat$name), 
                              envir = asNamespace("rmarkdown"))
       if (identical(tolower(tools::file_ext(
            rmarkdown:::pandoc_output_file("shiny", formatFunction()$pandoc))), 
            "html"))
          "rmarkdown::run"
       else 
          # this situation is nonsensical (runtime: shiny only makse sense for
          # HTML-based output formats)
          ""
     }, error = function(e) {
        ""
     })
  }
  else {
    # return render_site if we are in a website and this isn't a README
    if (!.rs.isREADME(file)) {
       siteGenerator <- tryCatch(rmarkdown::site_generator(file),
                                 error = function(e) NULL)
       if (!is.null(siteGenerator))
         "rmarkdown::render_site"
       else
         ""
    }
    else {
       ""
    }
  }
})

# given an input file, return the associated output file, and attempt to deduce
# whether it's up to date (e.g. for input.Rmd producing input.html, see whether
# input.html exists and has been written since input.Rmd)
.rs.addFunction("getRmdOutputInfo", function(target) {
  
   # read the contents of the file
   lines <- readLines(target, warn = FALSE)
   
   # mark the encoding if it's available
   properties <- .rs.getSourceDocumentProperties(target)
   if (identical(properties$encoding, "UTF-8"))
      Encoding(lines) <- "UTF-8"
   
   # compute the name of the output file
   outputFormat <- rmarkdown:::output_format_from_yaml_front_matter(lines)
   outputFormat <- rmarkdown:::create_output_format(outputFormat$name, outputFormat$options)
   outputFile <- rmarkdown:::pandoc_output_file(target, outputFormat$pandoc)
   outputPath <- file.path(dirname(target), outputFile) 
   
   # ensure output file exists
   current <- file.exists(outputPath) && 
      file.info(outputPath)$mtime >= file.info(target)$mtime
   
   list(
      output_file = .rs.scalar(outputPath),
      is_current  = .rs.scalar(current)
   )
})

# given a path to a folder on disk, return information about the R Markdown
# template in that folder.
.rs.addFunction("getTemplateDetails", function(path) {
   # check for required files
   templateYaml <- file.path(path, "template.yaml")
   skeletonPath <- file.path(path, "skeleton")
   if (!file.exists(templateYaml)) {
      templateYaml <- file.path(path, "template.yml")
      if (!file.exists(templateYaml))
         return(NULL)
   }

   if (!file.exists(file.path(skeletonPath, "skeleton.Rmd")))
      return(NULL)

   # load template details from YAML
   templateDetails <- yaml::yaml.load_file(templateYaml)

   # enforce create_dir if there are multiple files in /skeleton/
   if (length(list.files(skeletonPath)) > 1) 
      templateDetails$create_dir <- TRUE

   templateDetails
})


.rs.addFunction("evaluateRmdParams", function(contents) {

   # extract the params using knitr::knit_params
   knitParams <- knitr::knit_params(contents)

   if (length(knitParams) > 0)
   {
      # turn them into a named list
      params <- list()
      for (param in knitParams)
         params[[param$name]] <- param$value
      
      # mark as knit_params_list (so other routines know we generated it)
      class(params) <- "knit_param_list"

      # inject into global environment
      assign("params", params, envir = globalenv())
   }
})

.rs.addJsonRpcHandler("convert_to_yaml", function(input)
{
   # the yaml package doesn't treat string values kindly if they're surrounded
   # by backticks, so we will need to replace those with UUIDs we can sub out
   # later
   exprs <- list()
   tick_sub <- function(x) 
   {
      lapply(x, function(val) 
      {
         if (is.list(val)) 
         {
            # if it's a list, recurse
            tick_sub(val)
         }
         else if (is.character(val) && length(val) == 1) 
         {
            needsPlaceholder <- (function() {
               
               # if it's a character value, check to see if it's a backtick
               # expression
               if (identical(substr(val, 1, 1), "`") &&
                   identical(substr(val, nchar(val), nchar(val)), "`"))
               {
                  return(TRUE)
               }
               
               # if it's a tagged value, placeholder
               if (grepl("^[!]", val))
                  return(TRUE)
               
               FALSE
            })()
            
            if (needsPlaceholder)
            {
               # replace the backtick expression with an identifier
               key <- .Call("rs_generateShortUuid")
               exprs[[key]] <<- val
               key
            }
            else 
            {
               # leave other character expressions as-is
               val
            }
         } 
         else 
         {
            # leave non-character values alone
            val
         }
      })
   }
   
   # substitute ticks and convert to yaml
   yaml <- yaml::as.yaml(tick_sub(input))

   # the yaml package produces UTF-8 output strings, but doesn't mark them
   # as such, which leads to trouble (in particular: on Windows the string
   # may be later interpreted in system default encoding, which is not UTF-8.)
   # see: https://github.com/viking/r-yaml/issues/6
   if (Encoding(yaml) == "unknown")
      Encoding(yaml) <- "UTF-8"

   # put the backticked expressions back
   for (key in names(exprs)) 
      yaml <- sub(key, exprs[[key]], yaml, fixed = TRUE)

   list(yaml = .rs.scalar(yaml))
})

.rs.addJsonRpcHandler("convert_from_yaml", function(yaml)
{
   data <- list()
   parseError <- ""
   parseSucceeded <- FALSE
   
   tryCatch(
   {
      handlers <- list(r = function(x) paste("!r", x))
      data <- .rs.scalarListFromList(yaml::yaml.load(yaml, handlers = handlers))
      parseSucceeded <- TRUE
   },
   error = function(e)
   {
      parseError <<- as.character(e)
   })
   list(data = data, 
        parse_succeeded = .rs.scalar(parseSucceeded),
        parse_error = .rs.scalar(parseError))
})


.rs.addJsonRpcHandler("rmd_output_format", function(input, encoding) {
  if (Encoding(input) == "unknown")
    Encoding(input) <- "UTF-8"
  formats <- rmarkdown:::enumerate_output_formats(input, encoding = encoding)
  if (is.character(formats))
    .rs.scalar(formats[[1]])
  else
    NULL
})

.rs.addGlobalFunction("knit_with_parameters", 
                      function(file, encoding = getOption("encoding")) {
   
   # result to return via event
   result <- NULL
   
   # check for parameters 
   if (length(knitr::knit_params(readLines(file, 
                                           warn = FALSE, 
                                           encoding = encoding),
                                 evaluate = FALSE)) > 0) {
      
      # allocate temp file to hold parameter values
      paramsFile <- .Call("rs_paramsFileForRmd", file)
     
      # read any existing parameters contained therin
      params <- list()
      if (file.exists(paramsFile))
         params <- readRDS(paramsFile)
      
      # ask for parameters
      params <- rmarkdown::knit_params_ask(
         file, 
         params = params,
         shiny_args = list(
            launch.browser = function(url, ...) {
               .Call("rs_showShinyGadgetDialog",
                     "Knit with Parameters",
                     url,
                     600,
                     600)
            },
            quiet = TRUE),
         save_caption = "Knit",
         encoding = encoding
      )
      
      if (!is.null(params)) {
         saveRDS(params, file = paramsFile)
         result <- paramsFile
      }
      
   } else {
      # return special "none" value if there are no params
      result <- "none"
   }
   
   .rs.enqueClientEvent("rmd_params_ready", result)

   invisible(NULL)
})

.rs.addJsonRpcHandler("get_rmd_output_info", function(target) {
  return(.rs.getRmdOutputInfo(target))
})

.rs.addFunction("inputDirToIndexFile", function(input_dir) {
   index <- file.path(input_dir, "index.Rmd")
   if (file.exists(index))
      index
   else {
      index <- file.path(input_dir, "index.md")
      if (file.exists(index))
         index
      else
         NULL
   }
})

.rs.addFunction("getAllOutputFormats", function(input_dir, encoding) {
   index <- .rs.inputDirToIndexFile(input_dir)
   if (!is.null(index))
      rmarkdown:::enumerate_output_formats(input = index,
                                           envir = parent.frame(),
                                           encoding = encoding)
   else
      character()
})

.rs.addFunction("isBookdownWebsite", function(input_dir, encoding) {
   index <- .rs.inputDirToIndexFile(input_dir)
   if (!is.null(index)) {
      
      formats <- rmarkdown:::enumerate_output_formats(input = index,
                                                      envir = parent.frame(),
                                                      encoding = encoding)
      any(grepl("^bookdown", formats))
   }
   else
      FALSE
})

#
# NotebookErrors.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("handleNotebookError", function() {
  .rs.recordTraceback(FALSE, 2, function(err) {
    .Call("rs_recordNotebookError", err)
  })
},
attrs = list(hideFromDebugger = TRUE,
             errorHandlerType = 4L))

.rs.addFunction("registerNotebookErrHandler", function() {
  options(error = .rs.handleNotebookError)
})

#
# SessionTutorial.R
#
# Copyright (C) 2009-20 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# State ----

.rs.setVar("tutorial.registry", new.env(parent = emptyenv()))



# JSON RPC ----
.rs.addJsonRpcHandler("tutorial_started", function(name, package, url)
{
   # tag the associated tutorial with the browser url
   tutorial <- .rs.tutorial.registryGet(name, package)
   tutorial[["browser_url"]] <- url
})

.rs.addJsonRpcHandler("tutorial_stop", function(url)
{
   tutorial <- .rs.tutorial.registryFind(url)
   if (is.null(tutorial))
      return(FALSE)
   
   .rs.tutorial.stopTutorial(
      name    = tutorial[["name"]],
      package = tutorial[["package"]]
   )
   
   TRUE
   
})

.rs.addJsonRpcHandler("tutorial_metadata", function(url)
{
   tutorial <- .rs.tutorial.registryFind(url)
   if (is.null(tutorial))
      return(list())
   
   .rs.scalarListFromList(as.list(tutorial))
})

# Methods ----

.rs.addFunction("tutorial.registryKey", function(name, package)
{
   paste(package, name, sep = "::")
})

.rs.addFunction("tutorial.registryCreate", function(name, package)
{
   # NOTE: we use an R environment here just so we can get reference semantics
   # (makes mutation of existing tutorial objects more straight-forward, which
   # is necessary as we'll need to tag tutorial objects with extra meta-data
   # after creation)
   tutorial <- as.environment(list(name = name, package = package))
   
   # store in registry
   key <- .rs.tutorial.registryKey(name, package)
   .rs.tutorial.registry[[key]] <- tutorial
   
   # return tutorial object
   tutorial
})

.rs.addFunction("tutorial.registryGet", function(name, package)
{
   key <- .rs.tutorial.registryKey(name, package)
   .rs.tutorial.registry[[key]]
})

.rs.addFunction("tutorial.registryFind", function(url)
{
   keys <- ls(envir = .rs.tutorial.registry)
   for (key in keys)
   {
      tutorial <- .rs.tutorial.registry[[key]]
      
      match <-
         identical(url, tutorial[["shiny_url"]]) ||
         identical(url, tutorial[["browser_url"]])
      
      if (match)
         return(tutorial)
   }
   
   NULL
   
})

# TODO: local jobs are stopped when the session is suspended, and so running
# tutorials are stopped as well. do we want to take the extra step to allow
# sessions to suspend with running tutorials active?
.rs.addFunction("tutorial.onSuspend", function(path)
{
})

.rs.addFunction("tutorial.onResume", function(path)
{
})

.rs.addFunction("tutorial.launchBrowser", function(url)
{
   # get the pending tutorial
   tutorial <- .rs.getVar("tutorial.pendingTutorial")
   .rs.clearVar("tutorial.pendingTutorial")
   
   # tag that tutorial with the shiny url
   tutorial[["shiny_url"]] <- url
   
   # open tutorial in pane
   meta <- .rs.scalarListFromList(tutorial)
   .rs.invokeShinyTutorialViewer(url, meta)
})

.rs.addFunction("tutorial.openExistingTutorial", function(name, package)
{
   # find tutorial in registry
   tutorial <- .rs.tutorial.registryGet(name, package)
   if (is.null(tutorial))
      return(FALSE)

   # get underlying shiny url
   url <- tutorial[["shiny_url"]]
   if (is.null(url))
      return(FALSE)   
   
   # check for an associated active job
   job <- tutorial[["job"]]
   running <- .rs.tryCatch(.Call("rs_isJobRunning", job, PACKAGE = "(embedding)"))
   if (!identical(running, TRUE))
      return(FALSE)
   
   # open tutorial in pane
   meta <- .rs.scalarListFromList(tutorial)
   .rs.invokeShinyTutorialViewer(url, meta)
   
   TRUE
})

.rs.addFunction("tutorial.runTutorial", function(name, package, shiny_args = NULL)
{
   # if we already have a running tutorial, just open the associated URL
   if (.rs.tutorial.openExistingTutorial(name, package))
      return()
   
   # install any required package dependencies before running tutorial
   .rs.tutorial.installPackageDependencies(name, package)
   
   # prepare the call to learnr to run the tutorial
   shiny_args$launch.browser <- quote(rstudioapi:::tutorialLaunchBrowser)
   
   call <- substitute(
      
      learnr::run_tutorial(
         name = name,
         package = package,
         shiny_args = shiny_args
      ),
      
      list(
         name = name,
         package = package,
         shiny_args = shiny_args
      )
      
   )
   
   # write to file
   deparsed <- deparse(call)
   path <- tempfile("rstudio-tutorial-", fileext = ".R")
   writeLines(deparsed, con = path)
   
   # run as job
   job <- .rs.api.runScriptJob(
      path = path,
      name = paste("Tutorial:", name),
      encoding = "UTF-8"
   )
   
   # register a tutorial object
   tutorial <- .rs.tutorial.registryCreate(name, package)
   
   # add job id
   tutorial[["job"]] <- job
   
   # set as pending
   .rs.setVar("tutorial.pendingTutorial", tutorial)
   
   invisible(job)
   
})

.rs.addFunction("tutorial.stopTutorial", function(name, package)
{
   # find tutorial in registry
   tutorial <- .rs.tutorial.registryGet(name, package)
   
   # stop its associated job
   .rs.api.stopJob(tutorial[["job"]])
   
   # remove from registry
   key <- .rs.tutorial.registryKey(name, package)
   .rs.tutorial.registry[[key]] <- NULL
})

.rs.addFunction("tutorial.enqueueClientEvent", function(type, data = list())
{
   eventData <- list(type = .rs.scalar(type), data = data)
   .rs.enqueClientEvent("tutorial_command", eventData)
})

.rs.addFunction("tutorial.findTutorials", function(pkgRoot)
{
   tutorialsRoot <- file.path(pkgRoot, "tutorials")
   if (!file.exists(tutorialsRoot))
      return(list())
   
   tutorialDirs <- sort(list.files(tutorialsRoot, full.names = TRUE))
   tutorials <- lapply(tutorialDirs, .rs.tutorial.findTutorialsImpl)
   Filter(Negate(is.null), tutorials)
   
})

.rs.addFunction("tutorial.findTutorialsImpl", function(tutorialDir)
{
   tutorialFiles <- list.files(
      tutorialDir,
      pattern = "[.]Rmd$",
      full.names = TRUE,
      ignore.case = TRUE
   )
   
   if (length(tutorialFiles) == 0)
      return(NULL)
   
   tutorialFile <- tutorialFiles[[1]]
   contents <- readLines(tutorialFile, encoding = "UTF-8", warn = FALSE)
   yaml <- rmarkdown:::parse_yaml_front_matter(contents)
   
   title <- .rs.nullCoalesce(yaml$title, "")
   desc  <- .rs.nullCoalesce(yaml$description, "")
   
   list(
      name        = .rs.scalar(basename(tutorialDir)),
      file        = .rs.scalar(tutorialFile),
      title       = .rs.scalar(title),
      description = .rs.scalar(desc)
   )
})

.rs.addFunction("tutorial.installPackageDependencies", function(name, package)
{
   pkgs <- character()

   # form path to tutorial folder   
   path <- system.file("tutorials", name, package = package)
   if (!file.exists(path))
      return(character())
   
   # find dependencies
   deps <- renv::dependencies(path, quiet = TRUE)
   
   # ensure rstudioapi is included (required for communication between
   # the child R process hosting the tutorial + the main IDE session)
   pkgs <- sort(unique(c(deps$Package, c("learnr", "rstudioapi"))))
   
   # screen out some potentially invalid package names
   pkgs <- grep("^[a-zA-Z0-9._]+$", pkgs, value = TRUE)
   
   # find packages which are not installed
   installed <- vapply(pkgs, function(pkg) {
      location <- find.package(pkg, quiet = TRUE)
      length(location) > 0
   }, FUN.VALUE = logical(1))
   
   missing <- pkgs[!installed]
   if (length(missing) == 0)
      return(character())
   
   # ask user to install these packages
   title <- "Install Required Packages"
   message <- paste(
      "The following tutorial package dependencies are missing and will be installed:\n",
      paste("-", .rs.formatListForDialog(missing)),
      "\nWould you like to proceed?",
      sep = "\n"
   )
   
   ok <- .rs.api.showQuestion(title, message)
   if (!ok) {
      fmt <- "cannot run tutorial '%s'; required dependencies not installed"
      msg <- sprintf(fmt, name)
      stop(msg, call. = FALSE)
   }
 
   # write out call to console for user
   call <- substitute(
      install.packages(missing),
      list(missing = missing)
   )
   
   writeLines(paste(getOption("prompt"), format(call), sep = ""))
   install.packages(missing)
   
})

#
# SessionTests.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("has_shinytest_dependencies", function() {

   if (.rs.isPackageInstalled("shinytest")) {
      if (!exists("dependenciesInstalled", envir = asNamespace("shinytest"))) {
         # assume dependencies installed if shinytest does not provide dependencies state
         .rs.scalar(TRUE)
      } else {
         shinytestDepsInstalled <- get("dependenciesInstalled", envir = asNamespace("shinytest"))()
         .rs.scalar(shinytestDepsInstalled)
      }
   } else {
      .rs.scalar(FALSE)
   }

})

.rs.addJsonRpcHandler("has_shinytest_results", function(testFile) {

   # The test result is stored in a directory alongside the test file
   dirExists <- dir.exists(file.path(
      dirname(testFile), 
      paste(tools::file_path_sans_ext(basename(testFile)), "current", sep = "-")))

   # Find the Shiny app directory
   shinyDir <- dirname(testFile)
   if (identical(basename(shinyDir), "shinytests") ||
       identical(basename(shinyDir), "shinytest")) {
      # Newer versions of shinytest store tests in a "shinytest" or "shinytests" folder (depending
      # on version)
      shinyDir <- dirname(shinyDir)
   } 
   if (identical(basename(shinyDir), "tests")) {
      # Move up from the tests folder to the app folder
      shinyDir <- dirname(shinyDir)
   } else {
      stop("Could not find Shiny app for test file ", testFile)
   }

   # Return the discovered application directory, and whether the test exists 
   list(
      appDir = .rs.scalar(shinyDir),
      testDirExists = .rs.scalar(dirExists))
})

#
# Diagnostics.R
#
# Copyright (C) 2009-20 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# Init ----

library(utils)
diagnosticsDefault <- path.expand("~/rstudio-diagnostics/diagnostics-report.txt")
diagnosticsFile <- Sys.getenv("RSTUDIO_DIAGNOSTICS_REPORT", unset = diagnosticsDefault)
dir.create(dirname(diagnosticsFile), recursive = TRUE, showWarnings = FALSE)

# Utility functions ----

redact_regex <- function() {
  
  words <- c(
    "API", "AUTH", "GITHUB", "HOST", "HOST", "KEY", "LOGNAME",
    "PASSWORD", "PAT", "SECRET", "TOKEN", "USERNAME"
  )
  
  fmt <- "\\b%s\\b"
  sprintf("(?:%s)", paste(sprintf(fmt, words), collapse = "|"))
  
}

header <- function(fmt, ...) {
  label <- sprintf(fmt, ...)
  separator <- paste(rep.int("-", 50L), collapse = "")
  writeLines(c(label, separator))
}

newlines <- function(n = 2L) {
  writeLines(character(n))
}

dump <- function(object) {
  formatted <- if (!is.null(names(object))) {
    paste(format(names(object)), format(object), sep = " : ")
  } else {
    format(object)
  }
  writeLines(formatted)
}

dumpfile <- function(path) {
  
  if (!file.exists(path)) {
    writeLines("(File does not exist)")
    return(invisible())
  }
  
  contents <- readLines(path, warn = FALSE)
  if (length(contents) == 0L) {
    writeLines("(File exists but is empty)")
    return(invisible())
  }
  
  if (all(grepl("^\\s*$", contents, perl = TRUE))) {
    writeLines("(File exists but is empty / blank)")
    return(invisible())
  }
  
  regex <- sprintf("%s\\s*=", redact_regex())
  matches <- grep(regex, gsub("_", " ", contents))
  for (i in matches) {
    line <- contents[[i]]
    redacted <- paste(substring(line, 1, regexpr("=", line, fixed = TRUE)), "*** redacted ***")
    contents[[i]] <- redacted
  }
  
  writeLines(contents)
  
}

envvars <- function() {
  
  # log environment variables, redacting any banned words (e.g. those that might
  # expose API tokens or other secrets). match it on the list of environment
  # variable names with _ converted to a space (so that e.g. GITHUB_PAT becomes
  # GITHUB PAT and matches the banned word PAT)
  vars <- Sys.getenv()
  keys <- gsub("_", " ", names(vars), fixed = TRUE)
  matches <- grepl(redact_regex(), keys, ignore.case = TRUE)
  vars[matches] <- "*** redacted ***"
  as.list(vars)
}

# Main script ----

capture.output(file = diagnosticsFile, {

  report <- "
RStudio Diagnostics Report
==========================

WARNING: This report may contain sensitive security information and / or
personally identifiable information. Please audit the below and redact any
sensitive information before submitting your diagnostics report.
"

  writeLines(report)
  writeLines(paste("Generated:", date()))
  writeLines("")
  
  # version
  versionFile <- "../VERSION"
  if (file.exists(versionFile)) {
    header("RStudio Version")
    dumpfile(versionFile)
    newlines()
  }
  
  header("Session Information")
  print(sessionInfo())
  newlines()
  
  header("System Information")
  dump(Sys.info())
  newlines()
  
  header("Platform Information")
  dump(.Platform)
  newlines()
  
  header("Environment Variables")
  dump(envvars())
  newlines()
  
  header("R Version")
  dump(R.Version())
  newlines()
  
  header("R Home")
  dump(R.home())
  newlines()
  
  header("R Search Path")
  dump(search())
  newlines()
  
  header("R Library Paths")
  dump(.libPaths())
  newlines()
  
  header("Loaded Packages")
  packages <- loadedNamespaces()
  paths <- find.package(packages)
  names(paths) <- packages
  dump(sort(paths))
  newlines()
  
  local({
    
    op <- options()
    on.exit(options(op), add = TRUE)
    options(width = 1000, max.print = 50000)
    
    header("Installed Packages")
    ip <- as.data.frame(installed.packages(noCache = TRUE), stringsAsFactors = FALSE)
    rownames(ip) <- NULL
    print(ip[c("Package", "LibPath", "Version")])
    newlines()
  
  })
  
  # dump .Rprofiles
  r_base_profile <- file.path(R.home(), "library/base/R/Rprofile")
  header("R System Profile: %s", r_base_profile)
  dumpfile(r_base_profile)
  newlines()
  
  r_site_profile <- Sys.getenv("R_PROFILE", unset = file.path(R.home("etc"), "Rprofile.site"))
  header("R Site Profile: %s", r_site_profile)
  dumpfile(r_site_profile)
  newlines()
  
  r_user_profile <- Sys.getenv("R_PROFILE_USER", unset = path.expand("~/.Rprofile"))
  header("R User Profile: %s", r_user_profile)
  dumpfile(r_user_profile)
  newlines()
  
  # dump .Renvirons
  r_site_environ <- Sys.getenv("R_ENVIRON", unset = file.path(R.home("etc"), "Renviron.site"))
  header("R Site Environ: %s", r_site_environ)
  dumpfile(r_site_environ)
  newlines()
  
  r_user_environ <- Sys.getenv("R_ENVIRON_USER", unset = path.expand("~/.Renviron"))
  header("R User Environ: %s", r_user_environ)
  dumpfile(r_user_environ)
  newlines()
  
  header("R Temporary Directory")
  dump(tempdir())
  newlines()
  
  header("Files in R Temporary Directory")
  dump(list.files(tempdir()))
  newlines()
  
  # locate diagnostics binary and run it
  binaryPath <- local({
    
    # detect dev configurations
    postback <- Sys.getenv("RS_RPOSTBACK_PATH", unset = NA)
    if (!is.na(postback)) {
      devpath <- file.path(dirname(postback), "../../diagnostics/diagnostics")
      if (file.exists(devpath))
        return(devpath)
    }
    
    # detect release configurations
    sysname <- Sys.info()[["sysname"]]
    if (identical(sysname, "Darwin"))
      "../../MacOS/diagnostics"
    else if (identical(sysname, "Windows"))
      "../bin/diagnostics.exe"
    else
      "../bin/diagnostics"
    
  })
    
  if (file.exists(binaryPath)) {
    binaryPath <- normalizePath(binaryPath)
    diagnostics <- system2(binaryPath, stdout = TRUE, stderr = TRUE)
    writeLines(diagnostics)
  }
  
})

footer <- c(
  paste("Diagnostics report written to:", diagnosticsFile),
  "Please audit the report and remove any sensitive information before sharing this report with RStudio."
)

writeLines(footer)

#
# SessionOverlay.R
#
# Copyright (C) 2009-12 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

#
# NotebookConditions.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("notebookConditions.onWarning", function(condition)
{
   prefix <- gettext("Warning:", domain = "R")
   message <- paste(condition$message, collapse = "\n")
   full <- paste(prefix, message)
   .Call("rs_signalNotebookCondition", 1L, full, PACKAGE = "(embedding)")
   invokeRestart("muffleWarning")
})

.rs.addFunction("notebookConditions.onMessage", function(condition)
{
   full <- paste(condition$message, collapse = "\n")
   .Call("rs_signalNotebookCondition", 0L, full, PACKAGE = "(embedding)")
   invokeRestart("muffleMessage")
})

# NOTE: we need to add condition handlers to the top level, but cannot
# actually do so if there is an R function context on the stack.
#
# To circumvent this, we define R functions with the code we need to run,
# but explicitly extract the body of that function, and then execute that
# at the top level.
.rs.addFunction("notebookConditions.connectCall", function()
{
   body(.rs.notebookConditions.connectImpl)
})

.rs.addFunction("notebookConditions.connectImpl", function()
{
  
   # NOTE: because the body of this function will be evaluated in the
   # global environment, we need to avoid defining variables here.
   #
   # https://github.com/rstudio/rstudio/issues/8834
  .rs.notebookConditions.handlerStack <-
   .Internal(.addCondHands(
         c("warning", "message"),
         list(
            warning = .rs.notebookConditions.onWarning,
            message = .rs.notebookConditions.onMessage
         ),
         base::globalenv(),
         NULL,
         TRUE
      ))
  base::assign(x = ".rs.notebookConditions.handlerStack", 
               value = .rs.notebookConditions.handlerStack,
               envir = .rs.toolsEnv())
  base::rm(.rs.notebookConditions.handlerStack)
})

.rs.addFunction("notebookConditions.disconnectCall", function()
{
   body(.rs.notebookConditions.disconnectImpl)
})

.rs.addFunction("notebookConditions.disconnectImpl", function()
{
   # NOTE: because the body of this function will be evaluated in the
   # global environment, we need to avoid defining variables here.
   #
   # https://github.com/rstudio/rstudio/issues/8834
   .Internal(.resetCondHands(
     base::get(
       x = ".rs.notebookConditions.handlerStack",
       envir = .rs.toolsEnv()
     )
     
   ))
  base::rm(.rs.notebookConditions.handlerStack, envir = .rs.toolsEnv())
})

#
# SessionObjectExplorer.R
#
# Copyright (C) 2009-17 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# NOTE: these should be synchronized with the enum defined in ObjectExplorerEvent.java
.rs.setVar("explorer.types", list(
   NEW        = "new",
   OPEN_NODE  = "open_node",
   CLOSE_NODE = "close_node"
))

.rs.setVar("explorer.tags", list(
   ATTRIBUTES = "attributes",
   VIRTUAL    = "virtual"
))

# NOTE: this should be synchronized with DEFAULT_ROW_LIMIT
# in ObjectExplorerDataGrid.java
.rs.setVar("explorer.defaultRowLimit", 1000)

# this environment holds data objects currently open within
# a viewer tab; this environment will be persisted across
# RStudio sessions
.rs.setVar("explorer.cache", new.env(parent = emptyenv()))

# this environment holds custom inspectors that might be
# registered by client packages
.rs.setVar("explorer.inspectorRegistry", new.env(parent = emptyenv()))

.rs.addJsonRpcHandler("explorer_inspect_object", function(id,
                                                          extractingCode,
                                                          name,
                                                          access,
                                                          tags,
                                                          start)
{
   # retrieve object from cache
   object <- .rs.explorer.getCachedObject(
      id = id,
      extractingCode = extractingCode,
      refresh = FALSE
   )
   
   # construct context
   context <- .rs.explorer.createContext(
      name      = name,
      access    = access,
      tags      = tags,
      recursive = 1,
      start     = start + 1,   # 0 -> 1-based indexing,
      end       = start + .rs.explorer.defaultRowLimit
   )
   
   # generate inspection result
   result <- .rs.explorer.inspectObject(object, context)
   result
})

.rs.addJsonRpcHandler("explorer_begin_inspect", function(id, name)
{
   # retrieve object from cache
   object <- .rs.explorer.getCachedObject(
      id = id,
      extractingCode = NULL,
      refresh = TRUE
   )
   
   # construct context
   context <- .rs.explorer.createContext(
      name      = name,
      access    = NULL,
      tags      = character(),
      recursive = 1,
      start     = 1,
      end       = .rs.explorer.defaultRowLimit
   )
   
   # generate inspection result
   result <- .rs.explorer.inspectObject(object, context)
   result
})

.rs.addJsonRpcHandler("explorer_end_inspect", function(id)
{
   .rs.explorer.removeCachedObject(id)
})

.rs.addFunction("objectAddress", function(object)
{
   .Call("rs_objectAddress", object, PACKAGE = "(embedding)")
})

.rs.addFunction("objectClass", function(object)
{
   .Call("rs_objectClass", object, PACKAGE = "(embedding)")
})

.rs.addFunction("objectType", function(object)
{
   type <- typeof(object)
   
   if (type %in% "closure")
      type <- "function"
   else if (type %in% c("builtin", "special"))
      type <- "function (primitive)"
   
   dimensions <- dim(object)
   if (!is.null(dimensions))
   {
      dimtext <- paste(dimensions, collapse = " x ")
      type <- paste(type, sprintf("[%s]", dimtext))
   }
   else if (is.character(object) || is.numeric(object) ||
            is.raw(object) || is.complex(object) ||
            is.list(object) || is.environment(object) ||
            is.factor(object) || is.logical(object))
   {
      type <- paste(type, sprintf("[%s]", length(object)))
   }
   
   type
})

.rs.addFunction("objectAttributes", function(object)
{
   .Call("rs_objectAttributes", object, PACKAGE = "(embedding)")
})

.rs.addFunction("explorer.hasRelevantAttributes", function(object)
{
   attrib <- attributes(object)
   
   boring <-
      is.null(attrib) ||
      identical(object, attrib) ||
      identical(names(attrib), "names")
   
   if (boring)
      return(FALSE)
   
   TRUE
})

.rs.addFunction("explorer.saveCache", function(cacheDir)
{
   cache <- .rs.explorer.getCache()
   ids <- ls(envir = cache)
   lapply(ids, function(id) {
      file <- file.path(cacheDir, id)
      tryCatch(
         saveRDS(cache[[id]], file = file),
         error = warning
      )
   })
})

.rs.addFunction("explorer.restoreCache", function(cacheDir)
{
   cache <- .rs.explorer.getCache()
   ids <- list.files(cacheDir)
   for (id in ids) {
      tryCatch(
         {
            path <- file.path(cacheDir, id)
            object <- readRDS(path)
            cache[[id]] <- object
         },
         
         error = warning
      )
   }
})

.rs.addFunction("explorer.getCache", function()
{
   .rs.explorer.cache
})

.rs.addFunction("explorer.getCachedObject", function(id,
                                                     extractingCode = NULL,
                                                     refresh = FALSE)
{
   # retrieve cached entry
   cache <- .rs.explorer.getCache()
   entry <- cache[[id]]
   
   # handle NULL entries (e.g. the cache somehow became out-of-sync)
   if (is.null(entry))
      return(NULL)
   
   # get object (refreshing if requested). note that refreshes following a
   # restart may lose reference to the original object if e.g. the object lived
   # in the global environment but the global environment was not restored
   if (refresh && is.character(entry$title)) {
      tryCatch(
         expr = {
            object <- eval(parse(text = entry$title), envir = entry$envir)
            entry$object <- object
            cache[[id]] <- entry
         },
         error = identity
      )
   }
   object <- entry$object
   
   # return if no sub-extraction needed
   if (is.null(extractingCode))
      return(object)
   
   # otherwise, evaluate expression to retrieve sub-object
   envir <- new.env(parent = globalenv())
   envir[["__OBJECT__"]] <- object
   
   tryCatch(
      eval(parse(text = extractingCode), envir = envir),
      error = warning
   )
})

.rs.addFunction("explorer.setCachedObject", function(object,
                                                     id = .rs.createUUID())
{
   cache <- .rs.explorer.getCache()
   cache[[id]] <- object
   id
})

.rs.addFunction("explorer.removeCachedObject", function(id)
{
   cache <- .rs.explorer.getCache()
   if (exists(id, envir = cache))
      rm(list = id, envir = cache)
})

#' @param name The display name, as should be used in UI.
#' @param access A string of R code, indicating how this object
#'   should be accessed from a parent object. The '#' character
#'   is used as a placeholder for the name of the parent object.
#' @param tags An optional character vector of tags, used to identify
#'   special nodes (e.g. R attributes).
#' @param recursive Whether children of this object should be
#'   inspected recursively (if applicable). Can either be a boolean
#'   argument, or a numeric argument indicating the maximum depth
#'   of the recursion.
#' @param start The index at which inspection should begin, for children.
#' @param end The index at which inspection should end, for children.
.rs.addFunction("explorer.createContext", function(name = NULL,
                                                   access = NULL,
                                                   tags = character(),
                                                   recursive = FALSE,
                                                   start = 1,
                                                   end = .rs.explorer.defaultRowLimit)
{
   list(
      name      = name,
      access    = access,
      tags      = tags,
      recursive = recursive,
      start     = start,
      end       = end
   )
})

.rs.addFunction("explorer.createChildContext", function(context,
                                                        name,
                                                        access,
                                                        tags)
{
   # decrement a numeric recursion count
   recursive <- context$recursive
   if (is.numeric(recursive))
      recursive <- recursive - 1
   
   # establish a new context
   .rs.explorer.createContext(
      name      = name,
      access    = access,
      tags      = tags,
      recursive = recursive,
      start     = 1,
      end       = .rs.explorer.defaultRowLimit
   )
})

.rs.addFunction("explorer.fireEvent", function(type, data = list())
{
   .rs.enqueClientEvent("object_explorer_event", list(
      type = .rs.scalar(type),
      data = data
   ))
})


.rs.addFunction("explorer.viewObject", function(object,
                                                title = NULL,
                                                envir = .GlobalEnv)
{
   # attempt to divine title from call when not supplied
   if (is.null(title))
   {
      call <- match.call()
      title <- paste(deparse(call$object, width.cutoff = 500), collapse = " ")
   }
   
   # provide an appropriate name for the root node
   name <- .rs.explorer.objectName(object, title)
   
   # generate a handle for this object
   handle <- .rs.explorer.createHandle(object, name, title, envir)
   
   # fire event to client
   .rs.explorer.fireEvent(.rs.explorer.types$NEW, handle)
})

.rs.addFunction("explorer.createHandle", function(object,
                                                  name,
                                                  title,
                                                  envir)
{
   # save in cached data environment
   entry <- list(object = object, name = name, title = title, envir = envir)
   id <- .rs.explorer.setCachedObject(entry)
   
   # return a handle object
   list(
      id    = .rs.scalar(id),
      name  = .rs.scalar(name),
      title = .rs.scalar(title)
   )
})

# NOTE: synchronize the structure of this object with
# the JSO defined in 'ObjectExplorerInspectionResult.java'
.rs.addFunction("explorer.createInspectionResult", function(object,
                                                            context = NULL,
                                                            children = NULL)
{
   # because 'object' can be missing, and attempts to directly
   # evaluate missing objects will fail, we use a silly bit of indirection
   # whenever introspecting that object
   . <- environment()
   
   # extract pertinent values from context
   name      <- context$name
   access    <- context$access
   tags      <- context$tags
   recursive <- context$recursive
   more      <- isTRUE(context$more)
   
   # if we did a recursive lookup, but children is still NULL,
   # set it as an empty list
   if (recursive && is.null(children))
      children <- list()
   
   # determine whether this is an S4 object
   s4 <- isS4(.$object)
   
   # figure out whether this object is expandable
   # (note that the client will still need to refine behavior
   # depending on whether attributes are being shown)
   n <- length(.$object)
   expandable <-
      
      
      # is this an R list / environment with children?
      (is.recursive(.$object) && !is.primitive(.$object) && n > 0) ||
      
      # is this an S4 object with one or more slots?
      (s4 && length(.rs.slotNames(.$object)) > 0) ||
      
      # is this a named atomic vector?
      (is.atomic(.$object) && !is.null(names(.$object)) && n > 0) ||

      # do we have relevant attributes?
      (.rs.explorer.hasRelevantAttributes(.$object) && n > 0)
   
   # extract attributes when relevant
   attributes <- NULL
   if (context$recursive && .rs.explorer.hasRelevantAttributes(.$object))
   {
      childName <- "(attributes)"
      childAccess <- "attributes(#)"
      childTags <- c(.rs.explorer.tags$ATTRIBUTES, .rs.explorer.tags$VIRTUAL)
      childContext <- .rs.explorer.createChildContext(context,
                                                      childName,
                                                      childAccess,
                                                      childTags)
      childResult <- .rs.explorer.inspectObject(attributes(.$object), childContext)
      attributes <- childResult
   }
   
   # elements dictating how this should be displayed in UI
   display <- list(
      name = .rs.scalar(name),
      type = .rs.scalar(.rs.explorer.objectType(.$object)),
      desc = .rs.scalar(.rs.explorer.objectDesc(.$object))
   )
   
   # create inspection result
   list(
      address    = .rs.scalar(.rs.objectAddress(.$object)),
      type       = .rs.scalar(typeof(.$object)),
      class      = class(.$object),
      length     = .rs.scalar(length(.$object)),
      access     = .rs.scalar(access),
      recursive  = .rs.scalar(is.recursive(.$object)),
      expandable = .rs.scalar(expandable),
      atomic     = .rs.scalar(is.atomic(.$object)),
      named      = .rs.scalar(!is.null(names(.$object))),
      s4         = .rs.scalar(s4),
      tags       = as.character(tags),
      display    = display,
      attributes = attributes,
      children   = if (is.list(children)) unname(children),
      more       = .rs.scalar(more)
   )
})

.rs.addFunction("explorer.isValidInspectionResult", function(result)
{
   if (!is.list(result))
      return(FALSE)
   
   expected <- .rs.explorer.createInspectionResult(NULL)
   keys <- names(expected)
   missing <- setdiff(keys, names(result))
   if (length(missing))
      return(FALSE)
   
   TRUE
})

.rs.addFunction("explorer.callCustomInspector", function(object, context)
{
   classes <- class(object)
   
   # find a custom inspector method in the registry
   method <- NULL
   for (class in classes) {
      candidate <- .rs.explorer.inspectorRegistry[[class]]
      if (is.function(candidate)) {
         method <- candidate
         break
      }
   }
   
   # bail if we failed to find anything relevant
   if (is.null(method))
      return(NULL)
   
   # give the user's inspection routine 1 second to produce
   # an inspection result (returns NULL if we were forced
   # to halt execution)
   result <- .rs.withTimeLimit(1, method(object, context))
   if (is.null(result))
      return(NULL)
   
   # ensure we copy relevant context fields
   special <- c("name", "access", "tags")
   for (field in special)
      if (is.null(result[[field]]))
         result[[field]] <- context[[field]]
   
   # ensure that this is a valid inspection result
   if (!.rs.explorer.isValidInspectionResult(result))
      return(NULL)
   
   result
})

.rs.addFunction("explorer.inspectObject", function(object,
                                                   context = .rs.explorer.createContext())
{
   # check for missingness (can occur when inspecting an object
   # recursively that contain keys which map to missing objects)
   if (missing(object) || identical(object, quote(expr = )))
      return(.rs.explorer.createInspectionResult(quote(expr = ), context))
   
   # check for a custom registered inspector for this object's class
   result <- .rs.explorer.callCustomInspector(object, context)
   if (!is.null(result))
      return(result)
   
   # default to internal inspectors
   if (inherits(object, "xml_node") && "xml2" %in% loadedNamespaces())
      .rs.explorer.inspectXmlNode(object, context)
   else if (is.list(object) || is.call(object) || is.expression(object))
      .rs.explorer.inspectList(object, context)
   else if (is.environment(object))
      .rs.explorer.inspectEnvironment(object, context)
   else if (isS4(object))
      .rs.explorer.inspectS4(object, context)
   else if (is.function(object))
      .rs.explorer.inspectFunction(object, context)
   else
      .rs.explorer.inspectDefault(object, context)
})

.rs.addFunction("explorer.inspectXmlNode", function(object,
                                                    context = .rs.explorer.createContext())
{
   children <- NULL
   if (context$recursive)
   {
      # examine xml children
      xmlChildren <- xml2::xml_children(object)
      xmlNames <- xml2::xml_name(xmlChildren)
      indices <- seq_along(xmlChildren)
      children <- lapply(indices, function(i)
      {
         name <- sprintf("<%s>", xmlNames[[i]])
         access <- sprintf("xml_child(#, %i)", i)
         tags <- character()
         childContext <- .rs.explorer.createChildContext(context, name, access, tags)
         .rs.explorer.inspectObject(xmlChildren[[i]], childContext)
      })
      
      # examine xml attributes
      xmlAttributes <- xml2::xml_attrs(object)
      name <- "(xml attributes)"
      access <- "xml_attrs(#)"
      tags <- .rs.explorer.tags$VIRTUAL
      childContext <- .rs.explorer.createChildContext(context, name, access, tags)
      children[[length(children) + 1]] <-
         .rs.explorer.inspectObject(xmlAttributes, childContext)
   }
   
   .rs.explorer.createInspectionResult(object, context, children)
})

.rs.addFunction("explorer.inspectList", function(object,
                                                 context = .rs.explorer.createContext())
{
   # list children if requested
   children <- NULL
   if (context$recursive)
   {
      names <- names(object)
      indices <- .rs.slice(seq_along(object), context$start, context$end)
      context$more <- length(object) > context$end
      
      # iterate over children and inspect
      children <- lapply(indices, function(i)
      {
         if (is.null(names) || !nzchar(names[[i]]))
         {
            name <- sprintf("[[%i]]", i)
            access <- sprintf("#[[%i]]", i)
            tags <- .rs.explorer.tags$VIRTUAL
         }
         else
         {
            name <- names[[i]]
            access <- sprintf("#[[\"%s\"]]", name)
            tags <- character()
         }
         
         childContext <- .rs.explorer.createChildContext(context, name, access, tags)
         .rs.explorer.inspectObject(object[[i]], childContext)
      })
   }
   
   .rs.explorer.createInspectionResult(object, context, children)
})

.rs.addFunction("explorer.inspectEnvironment", function(object,
                                                        context = .rs.explorer.createContext())
{
   # list children if requested
   children <- NULL
   if (context$recursive)
   {
      # retrieve keys
      allKeys <- ls(envir = object, all.names = TRUE)
      keys <- .rs.slice(allKeys, context$start, context$end)
      context$more <- length(allKeys) > context$end
      
      children <- lapply(keys, function(key)
      {
         # we need special handling for '...'
         if (inherits(object[[key]], "..."))
         {
            value <- eval(quote(pairlist(...)), envir = object)
            access <- sprintf("eval(quote(pairlist(...)), envir = #)")
         }
         else
         {
            value <- object[[key]]
            access <- sprintf("#[[\"%s\"]]", key)
         }
         
         name <- key
         tags <- character()
         childContext <- .rs.explorer.createChildContext(context, name, access, tags)
         result <- .rs.explorer.inspectObject(value, childContext)
         result[order(names(result))]
      })
   }
   
   .rs.explorer.createInspectionResult(object, context, children)
})

.rs.addFunction("explorer.inspectS4", function(object,
                                               context = .rs.explorer.createContext())
{
   # get child slots if applicable
   children <- NULL
   if (context$recursive)
   {
      slots <- .rs.slotNames(object)
      children <- lapply(slots, function(slot) {
         name <- slot
         access <- sprintf("#@%s", name)
         tags <- character()
         
         childContext <- .rs.explorer.createChildContext(context, name, access, tags)
         value <- eval(call("@", object, slot))
         .rs.explorer.inspectObject(value, childContext)
      })
   }
   
   .rs.explorer.createInspectionResult(object, context, children)
})

.rs.addFunction("explorer.inspectFunction", function(object,
                                                     context = .rs.explorer.createContext())
{
   # construct interesting pieces of function
   children <- NULL
   if (is.primitive(object))
   {
      children <- list()
   }
   else if (context$recursive)
   {
      parts <- list(
         formals = formals(object),
         body = body(object),
         environment = environment(object)
      )
      
      children <- .rs.enumerate(parts, function(key, value) {
         
         # construct child context
         name <- key
         access <- sprintf("%s(#)", name)
         tags <- .rs.explorer.tags$VIRTUAL
         childContext <- .rs.explorer.createChildContext(context, name, access, tags)
         
         # inspect with context
         .rs.explorer.inspectObject(value, childContext)
      })
   }
   
   .rs.explorer.createInspectionResult(object, context, children)
})

.rs.addFunction("explorer.inspectDefault", function(object,
                                                    context = .rs.explorer.createContext())
{
   # allow children when object is named
   children <- NULL
   if (context$recursive && !is.null(names(object)))
   {
      names <- names(object)
      indices <- .rs.slice(seq_along(object), context$start, context$end)
      context$more <- length(object) > context$end
      
      # iterate over children and inspect
      children <- lapply(indices, function(i)
      {
         if (is.null(names) || !nzchar(names[[i]]))
         {
            name <- sprintf("[[%i]]", i)
            access <- sprintf("#[[%i]]", i)
            tags <- .rs.explorer.tags$VIRTUAL
         }
         else
         {
            name <- names[[i]]
            access <- sprintf("#[[\"%s\"]]", name)
            tags <- character()
         }
         
         childContext <- .rs.explorer.createChildContext(context, name, access, tags)
         .rs.explorer.inspectObject(object[[i]], childContext)
      })
   }
   
   .rs.explorer.createInspectionResult(object, context, children)
})

.rs.addFunction("explorer.objectName", function(object, default)
{
   if (inherits(object, "xml_node"))
      return(sprintf("<%s>", xml2::xml_name(object)))
   
   default
})

.rs.addFunction("explorer.objectType", function(object)
{
   # some specialized behavior for certain objects
   if (inherits(object, "factor"))
   {
      type <- "factor"
      classes <- setdiff(class(object), "factor")
      if (length(classes))
         type <- paste(type, sprintf("(%s)", paste(classes, collapse = ", ")))
      return(type)
   }
   else if (inherits(object, "formula"))
   {
      return("formula")
   }
   
   # ascertain the object type
   type <- .rs.objectType(object)
   
   # append class information when relevant
   class <- .rs.objectClass(object)
   if (is.null(class) || identical(type, class))
      return(type)
   
   # generate short description from classes
   desc <- NULL
   if (isS4(object))
   {
      package <- attr(class, "package")
      is_pkg_relevant <-
         !is.null(package) &&
         !identical(package, ".GlobalEnv")
      desc <- if (is_pkg_relevant)
         paste(package, class, sep = "::")
      else
         class
   }
   else if (inherits(object, "R6"))
   {
      class <- setdiff(class, "R6")
      desc <- paste("R6:", paste(class, collapse = ", "))
   }
   else
   {
      desc <- paste("S3:", paste(class, collapse = ", "))
   }
   
   # append description on to type
   if (!is.null(desc))
   {
      type <- sprintf("%s (%s)", type, desc)
   }
   
   type
})

.rs.addFunction("explorer.objectDesc", function(object)
{
   output <- ""
   more <- FALSE
   trailing <- " ..."
   n <- 6L
   
   if (is.primitive(object))
   {
      output <- paste(capture.output(print(object)), collapse = " ")
      output <- sub("function ", "function", output)
      more <- FALSE
   }
   else if (is.function(object))
   {
      # construct argument list
      fmls <- formals(object)
      
      pieces <- .rs.enumerate(fmls, function(key, value) {
         
         if (identical(value, quote(expr = )))
            return(key)
         
         value <- if (is.call(value))
            format(value)
         else if (is.symbol(value))
            as.character(value)
         else
            value
         
         paste(key, value, sep = " = ")
      })
      
      output <- sprintf(
         "function(%s) { ... }",
         paste(pieces, collapse = ", ")
      )
      more <- FALSE
   }
   else if (is.factor(object))
   {
      fmt <- "%s with %i %s: %s"
      header <- head(levels(object), n)
      collapse <- if (is.ordered(object)) " < " else ", "
      output <- sprintf(
         fmt,
         if (is.ordered(object)) "Ordered factor" else "Factor",
         length(levels(object)),
         if (length(levels(object)) == 1) "level" else "levels",
         paste(.rs.surround(header, with = "\""), collapse = collapse)
      )
      more <- length(levels(object)) > n
      trailing <- if (is.ordered(object)) " < ..." else ", ..."
   }
   else if (is.character(object))
   {
      header <- head(object, n)
      output <- paste(encodeString(header, quote = "'"), collapse = " ")
      more <- length(object) > n
   }
   else if (is.call(object))
   {
      output <- paste(format(object), collapse = " ")
      more <- FALSE
   }
   else if (is.symbol(object))
   {
      output <- if (identical(object, quote(expr = )))
         "<missing>"
      else
         .rs.surround(object, with = "`")
      more <- FALSE
   }
   else if (is.data.frame(object))
   {
      fmt <- "A %s with %s %s and %s %s"
      
      name <- if (inherits(object, "tbl"))
         "tibble"
      else if (inherits(object, "data.table"))
         "data.table"
      else
         "data.frame"
      
      output <- sprintf(
         fmt,
         name,
         nrow(object),
         if (nrow(object) == 1) "row" else "rows",
         ncol(object),
         if (ncol(object) == 1) "column" else "columns"
      )
      
      more <- FALSE
   }
   else if (is.pairlist(object))
   {
      output <- sprintf("Pairlist of length %i", length(object))
      more <- FALSE
   }
   else if (is.list(object))
   {
      output <- sprintf("List of length %i", length(object))
      more <- FALSE
   }
   else if (is.environment(object))
   {
      if (inherits(object, "R6"))
      {
         fmt <- "R6 object of %s %s"
         class <- setdiff(class(object), "R6")
         output <- sprintf(
            fmt,
            if (length(class) > 1) "classes" else "class",
            paste(class, collapse = ", ")
         )
         more <- FALSE
      }
      else
      {
         # NOTE: R prevents us from calling 'unclass' on environment
         # objects, so we need to do something a bit different here.
         # We also want to avoid 'print' dispatching to custom methods
         # to avoid evaluating arbitrary user code here
         oldClass <- class(object)
         tryCatch({
            class(object) <- "environment"
            output <- capture.output(base::print(object))[[1]]
            more <- FALSE
         }, error = identity)
         class(object) <- oldClass
      }
   }
   else if (is.double(object))
   {
      if (length(object) > 1)
      {
         header <- head(object, n)
         formatted <- format(header, digits = 3)
         output <- paste(formatted, collapse = " ")
         more <- length(object) > n
      }
      else
      {
         output <- format(object)
         more <- FALSE
      }
   }
   else if (is.atomic(object))
   {
      output <- paste(head(object, n), collapse = " ")
      more <- length(object) > n
   }
   else if (isS4(object))
   {
      output <- sprintf("S4 object of class %s", class(object))
      more <- FALSE
   }
   else if (.rs.isExternalPointer(object))
   {
      output <- capture.output(base::print.default(object))
      more <- FALSE
   }
   
   # guard against unexpected inputs
   if (length(output) == 0)
   {
      output <- ""
   }
   else if (is.na(output) || !is.character(output))
   {
      output <- "<NA>"
   }
   else if (more || nchar(output) > 80)
   {
      truncated <- substring(output, 1, 80)
      output <- paste(truncated, trailing, sep = "")
   }
   
   output
})

.rs.addFunction("explorer.objectSize", function(object)
{
   format(object.size(object), units = "auto")
})

# Utility Functions ----

.rs.addFunction("getRefCount", function(object)
{
   .Call("rs_getRefCount",
         as.name("object"),
         environment(),
         PACKAGE = "(embedding)")
})

.rs.addFunction("setRefCount", function(object, count)
{
   .Call("rs_setRefCount",
         as.name("object"),
         environment(),
         as.integer(count),
         PACKAGE = "(embedding)")
})

#
# SessionRHooks.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("invokeHook", function(hookName, ...) {
  # ensure that the list of hooks can be iterated over as a list
  hooks <- getHook(hookName)
  if (!is.list(hooks))
    hooks <- list(hooks)

  # execute each attached hook with the given parameters
  for (fun in hooks) {
    if (is.character(fun))
      fun <- get(fun)
    tryCatch(fun(...),
             error = function(e) { 
                # ignore errors occurring during hook execution
             })
  }
})

#
#  compile-themes.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

.rs.addFunction("parseCss", function(lines)
{
   css <- list()
   
   # Split any lines with "\n" for proper parsing.
   cssLines <- unlist(strsplit(gsub("\\}", "\\}\n", lines), c("\n"), perl = TRUE))
   
   currKeys <-list()
   isLastDescForKey <- FALSE
   inCommentBlock <- FALSE
   candidateKey <- NULL
   for (currLine in cssLines)
   {
      orgLine <- currLine
      
      # We use this to still parse the code before the start of the comment, if any.
      startCommentBlock <- FALSE
      
      # Remove all in-line comments.
      currLine <- gsub("/\\*.*?\\*/", "", currLine)
      
      # If we're not in a comment block and the current line has a comment opener, start the comment
      # block and update the line by removing the commented section. This allows for CSS before the
      # start of a comment. Note that this comment can't be contained wholly on a single line
      # because of the gsub above this.
      if (!inCommentBlock && grepl("/\\*", currLine))
      {
         startCommentBlock <- TRUE
         currLine <- sub("/\\*.*$", "", currLine)
      }
      
      # If we're in a comment block and the current line has a comment closer, end the comment block
      # and update the line by removing the commented section. This allows for CSS after the end of
      # a comment.
      if (inCommentBlock && grepl("\\*/", currLine))
      {
         inCommentBlock <- FALSE
         currLine <- sub("^.*?\\*/", "", currLine)
      }
      
      if (!inCommentBlock)
      {
         # Check for a change of key. A "key" in this context is the name of a CSS rule block. For example, in
         # .ace_editor {
         #     font-weight: bold;
         #     color: #AAAAAA
         # }
         # ".ace_editor" is the key and "font-weight: bold" and "color: #AAAAAA" are descriptions for that key.
         if (grepl("^\\s*\\.[^\\{]+\\{", currLine))
         {
            candidateKey <- paste(
               candidateKey, 
               regmatches(
                  currLine,
                  regexec("^\\s*([^\\{]*?)\\s*\\{", currLine))[[1]][2],
               sep = " ")
            candidateKey <- gsub("^\\s*|\\s*$", "", candidateKey, perl = TRUE)
            
            if (!grepl("^\\s*$", candidateKey))
            {
               if (length(currKeys) > 0)
               {
                  warning("Malformed CSS: ", orgLine, ". No closing bracket for last block.")
               }
               currKeys <- unlist(strsplit(candidateKey, "\\s*,\\s*", perl = TRUE))
               candidateKey <- NULL
               
               for (currKey in currKeys)
               {
                  css[[currKey]] <- list()
               }
               currLine <- sub("^\\s*[^\\{]*?\\s*\\{", "", currLine)
            }
         }
         
         # If there is currently a key, look for it's descriptions.
         if (length(currKeys) > 0)
         {
            # Determine if we're at the end of the block and remove the closing bracket to be able
            # to parse anything that comes before it on the same line.
            if (grepl("\\}", currLine))
            {
               isLastDescForKey <- TRUE
               currLine <- sub("^([^\\}]*)\\}\\s*$", "\\1", currLine)
               if (grepl("\\}", currLine))
               {
                  warning("Maformed CSS: ", orgLine, ". Extra closing brackets.")
               }
            }
            
            # Handle any URL fields, because they're too complex to be parsed as below.
            urlPattern <-"\\s*(background(?:-image)?)\\s*:\\s*(url\\((?:\"[^\"]*\"|[^)]*)\\)[^();]*?)\\s*(?:;|$)"
            
            while (grepl(urlPattern, currLine, ignore.case = TRUE, perl = TRUE))
            {
               ruleName = sub(urlPattern, "\\1", currLine, ignore.case = TRUE, perl = TRUE)
               ruleValue = sub(urlPattern, "\\2", currLine, ignore.case = TRUE, perl = TRUE)
               currLine <- sub(urlPattern, "", currLine, ignore.case = TRUE, perl = TRUE)
               
               for (currKey in currKeys) css[[currKey]][[ruleName]] <- ruleValue
            }
            
            # Look for a : on the line. CSS rules always have the format "name: style", so this
            # indicates there is a description on this line..
            if (grepl(":", currLine))
            {
               # Split on the rule separator. There may be multiple descriptions on one line.
               descValues <- strsplit(currLine, "\\s*;\\s*")[[1]]
               for (value in descValues)
               {
                  # If there is a non-empty value, parse the description.
                  if (value != "")
                  {
                     # Strip whitespace and ;, if any, and then split on :.
                     desc <- strsplit(sub("^\\s*([^;]+);?\\s*$", "\\1", value), "\\s*:\\s*")[[1]]
                     if (length(desc) != 2)
                     {
                        warning("Malformed CSS: ", orgLine, ". Invalid element within block.")
                     }
                     else
                     {
                        for (currKey in currKeys) css[[currKey]][[ desc[1] ]] <- tolower(desc[2])
                     }
                  }
               }
            }
            # If the line doesn't contain a description and is non-empty, it is malformed.
            else if (!grepl("^\\s*$", currLine))
            {
               warning("Malformd CSS: ", orgLine, ". Unexpected non-css line.")
            }
         }
         else if (!grepl("^\\s*$", currLine))
         {
            if (is.null(candidateKey))
            {
               candidateKey <- currLine
            }
            else
            {
               # selectors for CSS rule blocks may be split over multiple lines.
               candidateKey <- paste(candidateKey, currLine)
            }
         }
         
         # If we've finished a block, reset the key and the block-end indicator.
         if (isLastDescForKey)
         {
            currKeys <- list()
            isLastDescForKey <- FALSE
         }
         
         # If we started a comment block this line, update the inCommentBlock status so we ignore
         # all lines until the end of the comment block is found.
         if (startCommentBlock)
         {
            inCommentBlock <- TRUE
         }
      }
   }
   
   css
})

.rs.addFunction("add_operator_color", function(content, name, isDark = FALSE, overrideMap = list()) {
   color <- overrideMap[[name]]
   
   if (is.null(color))
      color <- if (isDark) "#AAAAAA" else "#888888"
   
   .rs.add_content(
      content,
      ".ace_keyword.ace_operator {",
      "  color: %s !important;",
      "}",
      replace = color
   )
})

.rs.addFunction("add_keyword_color", function(content, name, overrideMap) {
   .rs.add_content(
      content,
      ".ace_keyword {",
      "  color: %s !important;",
      "}",
      replace = overrideMap[[name]]
   )
})

# Converts a color to an array of the RGB values of the color.
#
# @param color    The color to convert.
#
# Returns the RGB color.
.rs.addFunction("getRgbColor", function(color) {

   # Named CSS colors we can decode. Source:
   # https://developer.mozilla.org/en-US/docs/Web/CSS/color_value
   namedCssColors <- list(
      black                  = c(0L, 0L, 0L),
      silver                 = c(192L, 192L, 192L),
      gray                   = c(128L, 128L, 128L),
      white                  = c(255L, 255L, 255L),
      maroon                 = c(128L, 0L, 0L),
      red                    = c(255L, 0L, 0L),
      purple                 = c(128L, 0L, 128L),
      fuchsia                = c(255L, 0L, 255L),
      green                  = c(0L, 128L, 0L),
      lime                   = c(0L, 255L, 0L),
      olive                  = c(128L, 128L, 0L),
      yellow                 = c(255L, 255L, 0L),
      navy                   = c(0L, 0L, 128L),
      blue                   = c(0L, 0L, 255L),
      teal                   = c(0L, 128L, 128L),
      aqua                   = c(0L, 255L, 255L),
      orange                 = c(255L, 165L, 0L),
      aliceblue              = c(240L, 248L, 255L),
      antiquewhite           = c(250L, 235L, 215L),
      aquamarine             = c(127L, 255L, 212L),
      azure                  = c(240L, 255L, 255L),
      beige                  = c(245L, 245L, 220L),
      bisque                 = c(255L, 228L, 196L),
      blanchedalmond         = c(255L, 235L, 205L),
      blueviolet             = c(138L, 43L, 226L),
      brown                  = c(165L, 42L, 42L),
      burlywood              = c(222L, 184L, 135L),
      cadetblue              = c(95L, 158L, 160L),
      chartreuse             = c(127L, 255L, 0L),
      chocolate              = c(210L, 105L, 30L),
      coral                  = c(255L, 127L, 80L),
      cornflowerblue         = c(100L, 149L, 237L),
      cornsilk               = c(255L, 248L, 220L),
      crimson                = c(220L, 20L, 60L),
      cyan                   = c(0L, 255L, 255L),
      darkblue               = c(0L, 0L, 139L),
      darkcyan               = c(0L, 139L, 139L),
      darkgoldenrod          = c(184L, 134L, 11L),
      darkgray               = c(169L, 169L, 169L),
      darkgreen              = c(0L, 100L, 0L),
      darkgrey               = c(169L, 169L, 169L),
      darkkhaki              = c(189L, 183L, 107L),
      darkmagenta            = c(139L, 0L, 139L),
      darkolivegreen         = c(85L, 107L, 47L),
      darkorange             = c(255L, 140L, 0L),
      darkorchid             = c(153L, 50L, 204L),
      darkred                = c(139L, 0L, 0L),
      darksalmon             = c(233L, 150L, 122L),
      darkseagreen           = c(143L, 188L, 143L),
      darkslateblue          = c(72L, 61L, 139L),
      darkslategray          = c(47L, 79L, 79L),
      darkslategrey          = c(47L, 79L, 79L),
      darkturquoise          = c(0L, 206L, 209L),
      darkviolet             = c(148L, 0L, 211L),
      deeppink               = c(255L, 20L, 147L),
      deepskyblue            = c(0L, 191L, 255L),
      dimgray                = c(105L, 105L, 105L),
      dimgrey                = c(105L, 105L, 105L),
      dodgerblue             = c(30L, 144L, 255L),
      firebrick              = c(178L, 34L, 34L),
      floralwhite            = c(255L, 250L, 240L),
      forestgreen            = c(34L, 139L, 34L),
      gainsboro              = c(220L, 220L, 220L),
      ghostwhite             = c(248L, 248L, 255L),
      gold                   = c(255L, 215L, 0L),
      goldenrod              = c(218L, 165L, 32L),
      greenyellow            = c(173L, 255L, 47L),
      grey                   = c(128L, 128L, 128L),
      honeydew               = c(240L, 255L, 240L),
      hotpink                = c(255L, 105L, 180L),
      indianred              = c(205L, 92L, 92L),
      indigo                 = c(75L, 0L, 130L),
      ivory                  = c(255L, 255L, 240L),
      khaki                  = c(240L, 230L, 140L),
      lavender               = c(230L, 230L, 250L),
      lavenderblush          = c(255L, 240L, 245L),
      lawngreen              = c(124L, 252L, 0L),
      lemonchiffon           = c(255L, 250L, 205L),
      lightblue              = c(173L, 216L, 230L),
      lightcoral             = c(240L, 128L, 128L),
      lightcyan              = c(224L, 255L, 255L),
      lightgoldenrodyellow   = c(250L, 250L, 210L),
      lightgray              = c(211L, 211L, 211L),
      lightgreen             = c(144L, 238L, 144L),
      lightgrey              = c(211L, 211L, 211L),
      lightpink              = c(255L, 182L, 193L),
      lightsalmon            = c(255L, 160L, 122L),
      lightseagreen          = c(32L, 178L, 170L),
      lightskyblue           = c(135L, 206L, 250L),
      lightslategray         = c(119L, 136L, 153L),
      lightslategrey         = c(119L, 136L, 153L),
      lightsteelblue         = c(176L, 196L, 222L),
      lightyellow            = c(255L, 255L, 224L),
      limegreen              = c(50L, 205L, 50L),
      linen                  = c(250L, 240L, 230L),
      magenta                = c(255L, 0L, 255L),
      mediumaquamarine       = c(102L, 205L, 170L),
      mediumblue             = c(0L, 0L, 205L),
      mediumorchid           = c(186L, 85L, 211L),
      mediumpurple           = c(147L, 112L, 219L),
      mediumseagreen         = c(60L, 179L, 113L),
      mediumslateblue        = c(123L, 104L, 238L),
      mediumspringgreen      = c(0L, 250L, 154L),
      mediumturquoise        = c(72L, 209L, 204L),
      mediumvioletred        = c(199L, 21L, 133L),
      midnightblue           = c(25L, 25L, 112L),
      mintcream              = c(245L, 255L, 250L),
      mistyrose              = c(255L, 228L, 225L),
      moccasin               = c(255L, 228L, 181L),
      navajowhite            = c(255L, 222L, 173L),
      oldlace                = c(253L, 245L, 230L),
      olivedrab              = c(107L, 142L, 35L),
      orangered              = c(255L, 69L, 0L),
      orchid                 = c(218L, 112L, 214L),
      palegoldenrod          = c(238L, 232L, 170L),
      palegreen              = c(152L, 251L, 152L),
      paleturquoise          = c(175L, 238L, 238L),
      palevioletred          = c(219L, 112L, 147L),
      papayawhip             = c(255L, 239L, 213L),
      peachpuff              = c(255L, 218L, 185L),
      peru                   = c(205L, 133L, 63L),
      pink                   = c(255L, 192L, 203L),
      plum                   = c(221L, 160L, 221L),
      powderblue             = c(176L, 224L, 230L),
      rosybrown              = c(188L, 143L, 143L),
      royalblue              = c(65L, 105L, 225L),
      saddlebrown            = c(139L, 69L, 19L),
      salmon                 = c(250L, 128L, 114L),
      sandybrown             = c(244L, 164L, 96L),
      seagreen               = c(46L, 139L, 87L),
      seashell               = c(255L, 245L, 238L),
      sienna                 = c(160L, 82L, 45L),
      skyblue                = c(135L, 206L, 235L),
      slateblue              = c(106L, 90L, 205L),
      slategray              = c(112L, 128L, 144L),
      slategrey              = c(112L, 128L, 144L),
      snow                   = c(255L, 250L, 250L),
      springgreen            = c(0L, 255L, 127L),
      steelblue              = c(70L, 130L, 180L),
      tan                    = c(210L, 180L, 140L),
      thistle                = c(216L, 191L, 216L),
      tomato                 = c(255L, 99L, 71L),
      turquoise              = c(64L, 224L, 208L),
      violet                 = c(238L, 130L, 238L),
      wheat                  = c(245L, 222L, 179L),
      whitesmoke             = c(245L, 245L, 245L),
      yellowgreen            = c(154L, 205L, 50L),
      rebeccapurple          = c(102L, 51L, 153L)
   )

   if (is.vector(color) && any(is.integer(color)))
   {
      if (length(color) != 3)
      {
         stop(
            "expected 3 values for RGB color, not ",
            length(color),
            call. = FALSE)
      }
      colorVec <- color
   }
   else if (substr(color, 0, 1) == "#") 
   {
      if (nchar(color) != 7)
      {
         stop(
            "hex representation of RGB values should have the format \"#RRGGBB\", where `RR`, `GG` and `BB` are in [0x00, 0xFF]. Found: ",
            color,
            call. = FALSE)
      }
      else
      {
         colorVec <- sapply(
            c(substr(color, 2, 3), substr(color, 4, 5), substr(color, 6, 7)),
            function(str) { strtoi(str, 16L) },
            USE.NAMES = FALSE)
      }
   }
   else if (grepl("^rgba?", color))
   {
      matches = regmatches(color, regexec("\\(([^,\\)]+),([^,\\)]+),([^,\\)]+)", color))[[1]]
      if (length(matches) != 4)
      {
         stop(
            "non-hex representation of RGB values should have the format \"rgb(R, G, B)\" or \"rgba(R, G, B, A)\" where `R`, `G`, and `B` are integer values in [0, 255] and `A` is decimal value in [0, 1.0]. Found: ",
            color,
            call. = FALSE)
      }
      colorVec <- strtoi(matches[2:4])
   }
   else if (color %in% names(namedCssColors))
   {
      colorVec <- namedCssColors[[color]]
   }
   else
   {
      stop(
         "supplied color has an invalid format: ",
         color,
         ". Expected \"#RRGGBB\", \"rgb(R, G, B) or \"rgba(R, G, B, A)\", where `RR`, `GG` and `BB` are in [0x00, 0xFF], `R`, `G`, and `B` are integer values in [0, 255], and `A` is decimal value in [0, 1.0]",
         call. = FALSE)
   }
   
   # Check for inconsistencies.
   invalidMsg <- paste0("invalid color supplied: ", color, ". ")
   if (any(is.na(colorVec)) || any(!is.integer(colorVec)))
   {
      stop(
         invalidMsg,
         "One or more RGB values could not be converted to an integer",
         call. = FALSE)
   }
   if (any(colorVec < 0))
   {
      stop(invalidMsg, "RGB value cannot be negative", call. = FALSE)
   }
   if (any(colorVec > 255))
   {
      stop(invalidMsg, "RGB value cannot be greater than 255", call. = FALSE)
   }
   
   colorVec
})

.rs.addFunction("format_css_color", function(color) {
   sprintf("rgb(%s, %s, %s)",
           color[1],
           color[2],
           color[3])
})

.rs.addFunction("color_as_hex", function(color) {
   paste("#", paste(format(as.hexmode(as.integer(color[1:3])), upper.case = TRUE, width = 2), collapse = ""), sep = "")
})

# Strip color from field
.rs.addFunction("strip_color_from_field", function(css) {
   if (grepl("rgb", css)) {
      gsub(".*rgb", "rgb", css)
   } else {
      gsub(".*#", "#", css)
   }
})

# Mixes two colors together.
#
# @param color1   The first color.
# @param color2   The second color.
# @param alpha1   The alpha of the first color.
# @param alpha2   The alpha of the second color.
# 
# Returns the mixed color in string format.
.rs.addFunction("mixColors", function(color1, color2, alpha1, alpha2 = NULL) {
   c1rgb <- .rs.getRgbColor(color1)
   c2rgb <- .rs.getRgbColor(color2)
   
   if (is.null(alpha2))
   {
      alpha2 = 1 - alpha1
   }
   
   .rs.color_as_hex(
      c(
         ceiling(alpha1 * c1rgb[[1]] + alpha2 * c2rgb[[1]]),
         ceiling(alpha1 * c1rgb[[2]] + alpha2 * c2rgb[[2]]),
         ceiling(alpha1 * c1rgb[[3]] + alpha2 * c2rgb[[3]]),
         sep = ","))
})

.rs.addFunction("add_content", function(content, ..., replace)
   c(
      content,
      do.call(sprintf, list(paste(..., sep = "\n"), replace))
   ))

.rs.addFunction("create_line_marker_rule", function(markerName, markerColor) {
   sprintf(paste(sep = "\n",
                 ".ace_marker-layer %s {",
                 "  position: absolute;",
                 "  z-index: -1;",
                 "  background-color: %s;",
                 "}"),
           markerName,
           markerColor)
})

.rs.addFunction("createNodeSelectorRule", function(themeName, isDark, overrides = list()) {
   nodeSelectorColor <- overrides[[themeName]]
   if (is.null(nodeSelectorColor))
      nodeSelectorColor <- if (isDark) "#fb6f1c" else "rgb(102, 155, 243)"
   
   sprintf(paste(sep = "\n",
                 ".ace_node-selector {",
                 "  background-color: %s",
                 "}"),
           nodeSelectorColor)
})

.rs.addFunction("createCommentBgRule", function(themeName, isDark, overrides = list()) {
   commentFgColor <- if (isDark) "#4D4333" else "#3C4C72"
   commentBgColor <- if (isDark) "#D1B78A" else "#FFECCB"
   
   override <- overrides[[themeName]]
   if (!is.null(override) && !is.null(override$fg))
      commentFgColor <- override$fg
   
   if (!is.null(override) && !is.null(override$bg))
      commentBgColor <- override$bg
   
   sprintf(paste(sep = "\n",
                 ".ace_comment-highlight {",
                 "  color: %s;",
                 "  background-color: %s;",
                 "}"),
           commentFgColor,
           commentBgColor)
})

.rs.addFunction("get_chunk_bg_color", function(themeName, isDark, overrides = list()) {
   p <- overrides[[themeName]]
   if (is.null(p))
      if (isDark) 0.9 else 0.95
   else
      p
})

.rs.addFunction("findNext", function(regex, content, start = 1, end = length(content)) {
   matches <- grep(regex, content, perl = TRUE)
   matches[(matches > start) & (matches < end)][1]
})

.rs.addFunction("updateSetting", function(content, newValue, cssClass, settingName) {
   classPat <- paste0("\\.", cssClass, "( *){")
   if (any(grepl(classPat, content, perl = TRUE)))
   {
      settingName <- paste0(settingName, ":")
      blockLoc <- grep(classPat, content, perl = TRUE)
      
      newLine <-  paste0("  ", settingName, " ", newValue, ";")
      settingPat <- paste0("(^| )",settingName)
      if (!any(grepl(settingPat, content, perl = TRUE)))
      {
         settingLoc <- grep("}",  content, perl = TRUE)
         
         loc <- settingLoc[settingLoc > blockLoc][1]
         content <- c(content[1:loc-1], newLine, content[loc:length(content)])
      }
      else
      {
         settingLoc <- grep(settingPat,  content, perl = TRUE)
      
         loc <- settingLoc[settingLoc > blockLoc][1]
         content[loc] <- newLine
      }
   }
   content
})

.rs.addFunction("setPrintMarginColor", function(content, color) {
   .rs.updateSetting(content, color, "ace_print-margin", "background")
})

.rs.addFunction("setActiveDebugLineColor", function(content, color) {
   .rs.updateSetting(content, color, "ace_active_debug_line", "background-color")
})

.rs.addFunction("setSelectionStartBorderRadius", function(content) {
   .rs.updateSetting(content, "2px", "ace_selection.ace_start", "border-radius")
})

.rs.addFunction("create_terminal_cursor_rules", function(isDark) {
   termCursorBgColorFirst <-  "#333"
   termCursorBgColorSecond <- "#CCC"
   if (isDark) {
      termCursorBgColorFirst <-  "#CCC"
      termCursorBgColorSecond <- "#1e1e1e"
   }
   
   sprintf(paste(sep = "\n",
                 ".terminal.xterm-cursor-style-block.focus:not(.xterm-cursor-blink-on) .terminal-cursor {",
                 "  background-color: %s;",
                 "  color: %s;",
                 "}",
                 ".terminal.focus.xterm-cursor-style-bar:not(.xterm-cursor-blink-on) .terminal-cursor::before,",
                 ".terminal.focus.xterm-cursor-style-underline:not(.xterm-cursor-blink-on) .terminal-cursor::before {",
                 "  content: \'\';",
                 "  position: absolute;",
                 "  background-color: %s;",
                 "}",
                 ".terminal:not(.focus) .terminal-cursor {",
                 "  outline: 1px solid %s;",
                 "  outline-offset: -1px;",
                 "}",
                 ".terminal .xterm-selection div {",
                 "   position: absolute;",
                 "   background-color: %s;",
                 "}"),
           
           # .terminal.xterm-cursor-style-block.focus:not(.xterm-cursor-blink-on) .terminal-cursor
           termCursorBgColorFirst,
           termCursorBgColorSecond,
           
           # .terminal.focus.xterm-cursor-style-bar:not(.xterm-cursor-blink-on) .terminal-cursor::before,
           # .terminal.focus.xterm-cursor-style-underline:not(.xterm-cursor-blink-on) .terminal-cursor::before
           termCursorBgColorFirst,
           
           # .terminal:not(.focus) .terminal-cursor
           termCursorBgColorFirst,
           
           # .terminal .xterm-selection div
           termCursorBgColorFirst)
})

.rs.addFunction("create_terminal_rule", function(background, foreground) {
   sprintf(paste(sep = "\n",
                 ".terminal {",
                 "  background-color: %s;",
                 "  color: %s;",
                 "  font-feature-settings: \"liga\" 0;",
                 "  position: relative;",
                 "  user-select: none;",
                 "  -ms-user-select: none;",
                 "  -webkit-user-select: none;",
                 "}"),
           background, foreground)
})

.rs.addFunction("create_terminal_viewport_rule", function(background) {
   sprintf(paste(sep = "\n",
                 ".terminal .xterm-viewport {",
                 "  background-color: %s;",
                 "  overflow-y: scroll;",
                 "}"),
           background)
})

.rs.addFunction("show_xterm16", function() {
  names <- sprintf("%-8s ", c("black", "red", "green", "yellow", "blue", "magenta", "cyan", "white"))
  colors <- glue::glue(
    "{names}  ", 
    "\033[{40 + 0:7}m     \033[49m \033[{30 + 0:7}mxtermColor{0:7}\033[39m", "    ",
    "\033[{100 + 0:7}m     \033[49m \033[{90 + 0:7}mxtermColor{8 + 0:7}\033[39m", 
  )
  cat("name       standard             bright\n\n")
  writeLines(colors)
  cat("\n")
})

.rs.addFunction("create_xterm_color_rules", function(background, foreground, isDark, xterm16ColorMap = NULL) {

   default_16_colors_light <- c(
      "0"  = "#2e3436", 
      "1"  = "#cc0000", 
      "2"  = "#4e9a06", 
      "3"  = "#c4a000", 
      "4"  = "#3465a4", 
      "5"  = "#75507b", 
      "6"  = "#06989a", 
      "7"  = "#d3d7cf", 
      "8"  = "#555753", 
      "9"  = "#ef2929", 
      "10" = "#8ae234", 
      "11" = "#fce94f", 
      "12" = "#729fcf", 
      "13" = "#ad7fa8", 
      "14" = "#34e2e2", 
      "15" = "#eeeeec"
   )

   # borrowed from "pastel on dark" theme
   default_16_colors_dark <- c(
      "0"  = "#4f4f4f", 
      "1"  = "#ff6c60", 
      "2"  = "#a8ff60", 
      "3"  = "#ffffb6", 
      "4"  = "#96cbfe", 
      "5"  = "#ff73fd", 
      "6"  = "#c6c5fe", 
      "7"  = "#eeeeee", 
      "8"  = "#7c7c7c", 
      "9"  = "#ffb6b0", 
      "10" = "#ceffac", 
      "11" = "#ffffcc", 
      "12" = "#b5dcff", 
      "13" = "#ff9cfe", 
      "14" = "#dfdffe", 
      "15" = "#ffffff"
   )

   generate_16_colors <- function(xterm16ColorMap) {
     if (is.null(xterm16ColorMap)) {
       colors <- if (isDark) default_16_colors_dark else default_16_colors_light
     } else {
       colors <- xterm16ColorMap[order(as.numeric(names(xterm16ColorMap)))]
     }

     paste0(collapse = "\n",
       sprintf(names(colors), colors, names(colors), colors,
         fmt =
".xtermColor%s { color: %s !important; }
.xtermBgColor%s { background-color: %s; }")
     )
   }

   paste(sep = "\n",
         sprintf(".xtermInvertColor { color: %s; }", background),
         sprintf(".xtermInvertBgColor { background-color: %s; }", foreground),
         ".xtermBold { font-weight: bold; }",
         ".xtermBlur { filter: blur(1px); }", 
         ".xtermUnderline { text-decoration: underline; }",
         ".xtermBlink { text-decoration: blink; }",
         ".xtermHidden { visibility: hidden; }",
         ".xtermItalic { font-style: italic; }",
         ".xtermStrike { text-decoration: line-through; }",
         generate_16_colors(xterm16ColorMap),
         ".xtermColor16 { color: #000000 !important; }",
         ".xtermBgColor16 { background-color: #000000; }",
         ".xtermColor17 { color: #00005f !important; }",
         ".xtermBgColor17 { background-color: #00005f; }",
         ".xtermColor18 { color: #000087 !important; }",
         ".xtermBgColor18 { background-color: #000087; }",
         ".xtermColor19 { color: #0000af !important; }",
         ".xtermBgColor19 { background-color: #0000af; }",
         ".xtermColor20 { color: #0000d7 !important; }",
         ".xtermBgColor20 { background-color: #0000d7; }",
         ".xtermColor21 { color: #0000ff !important; }",
         ".xtermBgColor21 { background-color: #0000ff; }",
         ".xtermColor22 { color: #005f00 !important; }",
         ".xtermBgColor22 { background-color: #005f00; }",
         ".xtermColor23 { color: #005f5f !important; }",
         ".xtermBgColor23 { background-color: #005f5f; }",
         ".xtermColor24 { color: #005f87 !important; }",
         ".xtermBgColor24 { background-color: #005f87; }",
         ".xtermColor25 { color: #005faf !important; }",
         ".xtermBgColor25 { background-color: #005faf; }",
         ".xtermColor26 { color: #005fd7 !important; }",
         ".xtermBgColor26 { background-color: #005fd7; }",
         ".xtermColor27 { color: #005fff !important; }",
         ".xtermBgColor27 { background-color: #005fff; }",
         ".xtermColor28 { color: #008700 !important; }",
         ".xtermBgColor28 { background-color: #008700; }",
         ".xtermColor29 { color: #00875f !important; }",
         ".xtermBgColor29 { background-color: #00875f; }",
         ".xtermColor30 { color: #008787 !important; }",
         ".xtermBgColor30 { background-color: #008787; }",
         ".xtermColor31 { color: #0087af !important; }",
         ".xtermBgColor31 { background-color: #0087af; }",
         ".xtermColor32 { color: #0087d7 !important; }",
         ".xtermBgColor32 { background-color: #0087d7; }",
         ".xtermColor33 { color: #0087ff !important; }",
         ".xtermBgColor33 { background-color: #0087ff; }",
         ".xtermColor34 { color: #00af00 !important; }",
         ".xtermBgColor34 { background-color: #00af00; }",
         ".xtermColor35 { color: #00af5f !important; }",
         ".xtermBgColor35 { background-color: #00af5f; }",
         ".xtermColor36 { color: #00af87 !important; }",
         ".xtermBgColor36 { background-color: #00af87; }",
         ".xtermColor37 { color: #00afaf !important; }",
         ".xtermBgColor37 { background-color: #00afaf; }",
         ".xtermColor38 { color: #00afd7 !important; }",
         ".xtermBgColor38 { background-color: #00afd7; }",
         ".xtermColor39 { color: #00afff !important; }",
         ".xtermBgColor39 { background-color: #00afff; }",
         ".xtermColor40 { color: #00d700 !important; }",
         ".xtermBgColor40 { background-color: #00d700; }",
         ".xtermColor41 { color: #00d75f !important; }",
         ".xtermBgColor41 { background-color: #00d75f; }",
         ".xtermColor42 { color: #00d787 !important; }",
         ".xtermBgColor42 { background-color: #00d787; }",
         ".xtermColor43 { color: #00d7af !important; }",
         ".xtermBgColor43 { background-color: #00d7af; }",
         ".xtermColor44 { color: #00d7d7 !important; }",
         ".xtermBgColor44 { background-color: #00d7d7; }",
         ".xtermColor45 { color: #00d7ff !important; }",
         ".xtermBgColor45 { background-color: #00d7ff; }",
         ".xtermColor46 { color: #00ff00 !important; }",
         ".xtermBgColor46 { background-color: #00ff00; }",
         ".xtermColor47 { color: #00ff5f !important; }",
         ".xtermBgColor47 { background-color: #00ff5f; }",
         ".xtermColor48 { color: #00ff87 !important; }",
         ".xtermBgColor48 { background-color: #00ff87; }",
         ".xtermColor49 { color: #00ffaf !important; }",
         ".xtermBgColor49 { background-color: #00ffaf; }",
         ".xtermColor50 { color: #00ffd7 !important; }",
         ".xtermBgColor50 { background-color: #00ffd7; }",
         ".xtermColor51 { color: #00ffff !important; }",
         ".xtermBgColor51 { background-color: #00ffff; }",
         ".xtermColor52 { color: #5f0000 !important; }",
         ".xtermBgColor52 { background-color: #5f0000; }",
         ".xtermColor53 { color: #5f005f !important; }",
         ".xtermBgColor53 { background-color: #5f005f; }",
         ".xtermColor54 { color: #5f0087 !important; }",
         ".xtermBgColor54 { background-color: #5f0087; }",
         ".xtermColor55 { color: #5f00af !important; }",
         ".xtermBgColor55 { background-color: #5f00af; }",
         ".xtermColor56 { color: #5f00d7 !important; }",
         ".xtermBgColor56 { background-color: #5f00d7; }",
         ".xtermColor57 { color: #5f00ff !important; }",
         ".xtermBgColor57 { background-color: #5f00ff; }",
         ".xtermColor58 { color: #5f5f00 !important; }",
         ".xtermBgColor58 { background-color: #5f5f00; }",
         ".xtermColor59 { color: #5f5f5f !important; }",
         ".xtermBgColor59 { background-color: #5f5f5f; }",
         ".xtermColor60 { color: #5f5f87 !important; }",
         ".xtermBgColor60 { background-color: #5f5f87; }",
         ".xtermColor61 { color: #5f5faf !important; }",
         ".xtermBgColor61 { background-color: #5f5faf; }",
         ".xtermColor62 { color: #5f5fd7 !important; }",
         ".xtermBgColor62 { background-color: #5f5fd7; }",
         ".xtermColor63 { color: #5f5fff !important; }",
         ".xtermBgColor63 { background-color: #5f5fff; }",
         ".xtermColor64 { color: #5f8700 !important; }",
         ".xtermBgColor64 { background-color: #5f8700; }",
         ".xtermColor65 { color: #5f875f !important; }",
         ".xtermBgColor65 { background-color: #5f875f; }",
         ".xtermColor66 { color: #5f8787 !important; }",
         ".xtermBgColor66 { background-color: #5f8787; }",
         ".xtermColor67 { color: #5f87af !important; }",
         ".xtermBgColor67 { background-color: #5f87af; }",
         ".xtermColor68 { color: #5f87d7 !important; }",
         ".xtermBgColor68 { background-color: #5f87d7; }",
         ".xtermColor69 { color: #5f87ff !important; }",
         ".xtermBgColor69 { background-color: #5f87ff; }",
         ".xtermColor70 { color: #5faf00 !important; }",
         ".xtermBgColor70 { background-color: #5faf00; }",
         ".xtermColor71 { color: #5faf5f !important; }",
         ".xtermBgColor71 { background-color: #5faf5f; }",
         ".xtermColor72 { color: #5faf87 !important; }",
         ".xtermBgColor72 { background-color: #5faf87; }",
         ".xtermColor73 { color: #5fafaf !important; }",
         ".xtermBgColor73 { background-color: #5fafaf; }",
         ".xtermColor74 { color: #5fafd7 !important; }",
         ".xtermBgColor74 { background-color: #5fafd7; }",
         ".xtermColor75 { color: #5fafff !important; }",
         ".xtermBgColor75 { background-color: #5fafff; }",
         ".xtermColor76 { color: #5fd700 !important; }",
         ".xtermBgColor76 { background-color: #5fd700; }",
         ".xtermColor77 { color: #5fd75f !important; }",
         ".xtermBgColor77 { background-color: #5fd75f; }",
         ".xtermColor78 { color: #5fd787 !important; }",
         ".xtermBgColor78 { background-color: #5fd787; }",
         ".xtermColor79 { color: #5fd7af !important; }",
         ".xtermBgColor79 { background-color: #5fd7af; }",
         ".xtermColor80 { color: #5fd7d7 !important; }",
         ".xtermBgColor80 { background-color: #5fd7d7; }",
         ".xtermColor81 { color: #5fd7ff !important; }",
         ".xtermBgColor81 { background-color: #5fd7ff; }",
         ".xtermColor82 { color: #5fff00 !important; }",
         ".xtermBgColor82 { background-color: #5fff00; }",
         ".xtermColor83 { color: #5fff5f !important; }",
         ".xtermBgColor83 { background-color: #5fff5f; }",
         ".xtermColor84 { color: #5fff87 !important; }",
         ".xtermBgColor84 { background-color: #5fff87; }",
         ".xtermColor85 { color: #5fffaf !important; }",
         ".xtermBgColor85 { background-color: #5fffaf; }",
         ".xtermColor86 { color: #5fffd7 !important; }",
         ".xtermBgColor86 { background-color: #5fffd7; }",
         ".xtermColor87 { color: #5fffff !important; }",
         ".xtermBgColor87 { background-color: #5fffff; }",
         ".xtermColor88 { color: #870000 !important; }",
         ".xtermBgColor88 { background-color: #870000; }",
         ".xtermColor89 { color: #87005f !important; }",
         ".xtermBgColor89 { background-color: #87005f; }",
         ".xtermColor90 { color: #870087 !important; }",
         ".xtermBgColor90 { background-color: #870087; }",
         ".xtermColor91 { color: #8700af !important; }",
         ".xtermBgColor91 { background-color: #8700af; }",
         ".xtermColor92 { color: #8700d7 !important; }",
         ".xtermBgColor92 { background-color: #8700d7; }",
         ".xtermColor93 { color: #8700ff !important; }",
         ".xtermBgColor93 { background-color: #8700ff; }",
         ".xtermColor94 { color: #875f00 !important; }",
         ".xtermBgColor94 { background-color: #875f00; }",
         ".xtermColor95 { color: #875f5f !important; }",
         ".xtermBgColor95 { background-color: #875f5f; }",
         ".xtermColor96 { color: #875f87 !important; }",
         ".xtermBgColor96 { background-color: #875f87; }",
         ".xtermColor97 { color: #875faf !important; }",
         ".xtermBgColor97 { background-color: #875faf; }",
         ".xtermColor98 { color: #875fd7 !important; }",
         ".xtermBgColor98 { background-color: #875fd7; }",
         ".xtermColor99 { color: #875fff !important; }",
         ".xtermBgColor99 { background-color: #875fff; }",
         ".xtermColor100 { color: #878700 !important; }",
         ".xtermBgColor100 { background-color: #878700; }",
         ".xtermColor101 { color: #87875f !important; }",
         ".xtermBgColor101 { background-color: #87875f; }",
         ".xtermColor102 { color: #878787 !important; }",
         ".xtermBgColor102 { background-color: #878787; }",
         ".xtermColor103 { color: #8787af !important; }",
         ".xtermBgColor103 { background-color: #8787af; }",
         ".xtermColor104 { color: #8787d7 !important; }",
         ".xtermBgColor104 { background-color: #8787d7; }",
         ".xtermColor105 { color: #8787ff !important; }",
         ".xtermBgColor105 { background-color: #8787ff; }",
         ".xtermColor106 { color: #87af00 !important; }",
         ".xtermBgColor106 { background-color: #87af00; }",
         ".xtermColor107 { color: #87af5f !important; }",
         ".xtermBgColor107 { background-color: #87af5f; }",
         ".xtermColor108 { color: #87af87 !important; }",
         ".xtermBgColor108 { background-color: #87af87; }",
         ".xtermColor109 { color: #87afaf !important; }",
         ".xtermBgColor109 { background-color: #87afaf; }",
         ".xtermColor110 { color: #87afd7 !important; }",
         ".xtermBgColor110 { background-color: #87afd7; }",
         ".xtermColor111 { color: #87afff !important; }",
         ".xtermBgColor111 { background-color: #87afff; }",
         ".xtermColor112 { color: #87d700 !important; }",
         ".xtermBgColor112 { background-color: #87d700; }",
         ".xtermColor113 { color: #87d75f !important; }",
         ".xtermBgColor113 { background-color: #87d75f; }",
         ".xtermColor114 { color: #87d787 !important; }",
         ".xtermBgColor114 { background-color: #87d787; }",
         ".xtermColor115 { color: #87d7af !important; }",
         ".xtermBgColor115 { background-color: #87d7af; }",
         ".xtermColor116 { color: #87d7d7 !important; }",
         ".xtermBgColor116 { background-color: #87d7d7; }",
         ".xtermColor117 { color: #87d7ff !important; }",
         ".xtermBgColor117 { background-color: #87d7ff; }",
         ".xtermColor118 { color: #87ff00 !important; }",
         ".xtermBgColor118 { background-color: #87ff00; }",
         ".xtermColor119 { color: #87ff5f !important; }",
         ".xtermBgColor119 { background-color: #87ff5f; }",
         ".xtermColor120 { color: #87ff87 !important; }",
         ".xtermBgColor120 { background-color: #87ff87; }",
         ".xtermColor121 { color: #87ffaf !important; }",
         ".xtermBgColor121 { background-color: #87ffaf; }",
         ".xtermColor122 { color: #87ffd7 !important; }",
         ".xtermBgColor122 { background-color: #87ffd7; }",
         ".xtermColor123 { color: #87ffff !important; }",
         ".xtermBgColor123 { background-color: #87ffff; }",
         ".xtermColor124 { color: #af0000 !important; }",
         ".xtermBgColor124 { background-color: #af0000; }",
         ".xtermColor125 { color: #af005f !important; }",
         ".xtermBgColor125 { background-color: #af005f; }",
         ".xtermColor126 { color: #af0087 !important; }",
         ".xtermBgColor126 { background-color: #af0087; }",
         ".xtermColor127 { color: #af00af !important; }",
         ".xtermBgColor127 { background-color: #af00af; }",
         ".xtermColor128 { color: #af00d7 !important; }",
         ".xtermBgColor128 { background-color: #af00d7; }",
         ".xtermColor129 { color: #af00ff !important; }",
         ".xtermBgColor129 { background-color: #af00ff; }",
         ".xtermColor130 { color: #af5f00 !important; }",
         ".xtermBgColor130 { background-color: #af5f00; }",
         ".xtermColor131 { color: #af5f5f !important; }",
         ".xtermBgColor131 { background-color: #af5f5f; }",
         ".xtermColor132 { color: #af5f87 !important; }",
         ".xtermBgColor132 { background-color: #af5f87; }",
         ".xtermColor133 { color: #af5faf !important; }",
         ".xtermBgColor133 { background-color: #af5faf; }",
         ".xtermColor134 { color: #af5fd7 !important; }",
         ".xtermBgColor134 { background-color: #af5fd7; }",
         ".xtermColor135 { color: #af5fff !important; }",
         ".xtermBgColor135 { background-color: #af5fff; }",
         ".xtermColor136 { color: #af8700 !important; }",
         ".xtermBgColor136 { background-color: #af8700; }",
         ".xtermColor137 { color: #af875f !important; }",
         ".xtermBgColor137 { background-color: #af875f; }",
         ".xtermColor138 { color: #af8787 !important; }",
         ".xtermBgColor138 { background-color: #af8787; }",
         ".xtermColor139 { color: #af87af !important; }",
         ".xtermBgColor139 { background-color: #af87af; }",
         ".xtermColor140 { color: #af87d7 !important; }",
         ".xtermBgColor140 { background-color: #af87d7; }",
         ".xtermColor141 { color: #af87ff !important; }",
         ".xtermBgColor141 { background-color: #af87ff; }",
         ".xtermColor142 { color: #afaf00 !important; }",
         ".xtermBgColor142 { background-color: #afaf00; }",
         ".xtermColor143 { color: #afaf5f !important; }",
         ".xtermBgColor143 { background-color: #afaf5f; }",
         ".xtermColor144 { color: #afaf87 !important; }",
         ".xtermBgColor144 { background-color: #afaf87; }",
         ".xtermColor145 { color: #afafaf !important; }",
         ".xtermBgColor145 { background-color: #afafaf; }",
         ".xtermColor146 { color: #afafd7 !important; }",
         ".xtermBgColor146 { background-color: #afafd7; }",
         ".xtermColor147 { color: #afafff !important; }",
         ".xtermBgColor147 { background-color: #afafff; }",
         ".xtermColor148 { color: #afd700 !important; }",
         ".xtermBgColor148 { background-color: #afd700; }",
         ".xtermColor149 { color: #afd75f !important; }",
         ".xtermBgColor149 { background-color: #afd75f; }",
         ".xtermColor150 { color: #afd787 !important; }",
         ".xtermBgColor150 { background-color: #afd787; }",
         ".xtermColor151 { color: #afd7af !important; }",
         ".xtermBgColor151 { background-color: #afd7af; }",
         ".xtermColor152 { color: #afd7d7 !important; }",
         ".xtermBgColor152 { background-color: #afd7d7; }",
         ".xtermColor153 { color: #afd7ff !important; }",
         ".xtermBgColor153 { background-color: #afd7ff; }",
         ".xtermColor154 { color: #afff00 !important; }",
         ".xtermBgColor154 { background-color: #afff00; }",
         ".xtermColor155 { color: #afff5f !important; }",
         ".xtermBgColor155 { background-color: #afff5f; }",
         ".xtermColor156 { color: #afff87 !important; }",
         ".xtermBgColor156 { background-color: #afff87; }",
         ".xtermColor157 { color: #afffaf !important; }",
         ".xtermBgColor157 { background-color: #afffaf; }",
         ".xtermColor158 { color: #afffd7 !important; }",
         ".xtermBgColor158 { background-color: #afffd7; }",
         ".xtermColor159 { color: #afffff !important; }",
         ".xtermBgColor159 { background-color: #afffff; }",
         ".xtermColor160 { color: #d70000 !important; }",
         ".xtermBgColor160 { background-color: #d70000; }",
         ".xtermColor161 { color: #d7005f !important; }",
         ".xtermBgColor161 { background-color: #d7005f; }",
         ".xtermColor162 { color: #d70087 !important; }",
         ".xtermBgColor162 { background-color: #d70087; }",
         ".xtermColor163 { color: #d700af !important; }",
         ".xtermBgColor163 { background-color: #d700af; }",
         ".xtermColor164 { color: #d700d7 !important; }",
         ".xtermBgColor164 { background-color: #d700d7; }",
         ".xtermColor165 { color: #d700ff !important; }",
         ".xtermBgColor165 { background-color: #d700ff; }",
         ".xtermColor166 { color: #d75f00 !important; }",
         ".xtermBgColor166 { background-color: #d75f00; }",
         ".xtermColor167 { color: #d75f5f !important; }",
         ".xtermBgColor167 { background-color: #d75f5f; }",
         ".xtermColor168 { color: #d75f87 !important; }",
         ".xtermBgColor168 { background-color: #d75f87; }",
         ".xtermColor169 { color: #d75faf !important; }",
         ".xtermBgColor169 { background-color: #d75faf; }",
         ".xtermColor170 { color: #d75fd7 !important; }",
         ".xtermBgColor170 { background-color: #d75fd7; }",
         ".xtermColor171 { color: #d75fff !important; }",
         ".xtermBgColor171 { background-color: #d75fff; }",
         ".xtermColor172 { color: #d78700 !important; }",
         ".xtermBgColor172 { background-color: #d78700; }",
         ".xtermColor173 { color: #d7875f !important; }",
         ".xtermBgColor173 { background-color: #d7875f; }",
         ".xtermColor174 { color: #d78787 !important; }",
         ".xtermBgColor174 { background-color: #d78787; }",
         ".xtermColor175 { color: #d787af !important; }",
         ".xtermBgColor175 { background-color: #d787af; }",
         ".xtermColor176 { color: #d787d7 !important; }",
         ".xtermBgColor176 { background-color: #d787d7; }",
         ".xtermColor177 { color: #d787ff !important; }",
         ".xtermBgColor177 { background-color: #d787ff; }",
         ".xtermColor178 { color: #d7af00 !important; }",
         ".xtermBgColor178 { background-color: #d7af00; }",
         ".xtermColor179 { color: #d7af5f !important; }",
         ".xtermBgColor179 { background-color: #d7af5f; }",
         ".xtermColor180 { color: #d7af87 !important; }",
         ".xtermBgColor180 { background-color: #d7af87; }",
         ".xtermColor181 { color: #d7afaf !important; }",
         ".xtermBgColor181 { background-color: #d7afaf; }",
         ".xtermColor182 { color: #d7afd7 !important; }",
         ".xtermBgColor182 { background-color: #d7afd7; }",
         ".xtermColor183 { color: #d7afff !important; }",
         ".xtermBgColor183 { background-color: #d7afff; }",
         ".xtermColor184 { color: #d7d700 !important; }",
         ".xtermBgColor184 { background-color: #d7d700; }",
         ".xtermColor185 { color: #d7d75f !important; }",
         ".xtermBgColor185 { background-color: #d7d75f; }",
         ".xtermColor186 { color: #d7d787 !important; }",
         ".xtermBgColor186 { background-color: #d7d787; }",
         ".xtermColor187 { color: #d7d7af !important; }",
         ".xtermBgColor187 { background-color: #d7d7af; }",
         ".xtermColor188 { color: #d7d7d7 !important; }",
         ".xtermBgColor188 { background-color: #d7d7d7; }",
         ".xtermColor189 { color: #d7d7ff !important; }",
         ".xtermBgColor189 { background-color: #d7d7ff; }",
         ".xtermColor190 { color: #d7ff00 !important; }",
         ".xtermBgColor190 { background-color: #d7ff00; }",
         ".xtermColor191 { color: #d7ff5f !important; }",
         ".xtermBgColor191 { background-color: #d7ff5f; }",
         ".xtermColor192 { color: #d7ff87 !important; }",
         ".xtermBgColor192 { background-color: #d7ff87; }",
         ".xtermColor193 { color: #d7ffaf !important; }",
         ".xtermBgColor193 { background-color: #d7ffaf; }",
         ".xtermColor194 { color: #d7ffd7 !important; }",
         ".xtermBgColor194 { background-color: #d7ffd7; }",
         ".xtermColor195 { color: #d7ffff !important; }",
         ".xtermBgColor195 { background-color: #d7ffff; }",
         ".xtermColor196 { color: #ff0000 !important; }",
         ".xtermBgColor196 { background-color: #ff0000; }",
         ".xtermColor197 { color: #ff005f !important; }",
         ".xtermBgColor197 { background-color: #ff005f; }",
         ".xtermColor198 { color: #ff0087 !important; }",
         ".xtermBgColor198 { background-color: #ff0087; }",
         ".xtermColor199 { color: #ff00af !important; }",
         ".xtermBgColor199 { background-color: #ff00af; }",
         ".xtermColor200 { color: #ff00d7 !important; }",
         ".xtermBgColor200 { background-color: #ff00d7; }",
         ".xtermColor201 { color: #ff00ff !important; }",
         ".xtermBgColor201 { background-color: #ff00ff; }",
         ".xtermColor202 { color: #ff5f00 !important; }",
         ".xtermBgColor202 { background-color: #ff5f00; }",
         ".xtermColor203 { color: #ff5f5f !important; }",
         ".xtermBgColor203 { background-color: #ff5f5f; }",
         ".xtermColor204 { color: #ff5f87 !important; }",
         ".xtermBgColor204 { background-color: #ff5f87; }",
         ".xtermColor205 { color: #ff5faf !important; }",
         ".xtermBgColor205 { background-color: #ff5faf; }",
         ".xtermColor206 { color: #ff5fd7 !important; }",
         ".xtermBgColor206 { background-color: #ff5fd7; }",
         ".xtermColor207 { color: #ff5fff !important; }",
         ".xtermBgColor207 { background-color: #ff5fff; }",
         ".xtermColor208 { color: #ff8700 !important; }",
         ".xtermBgColor208 { background-color: #ff8700; }",
         ".xtermColor209 { color: #ff875f !important; }",
         ".xtermBgColor209 { background-color: #ff875f; }",
         ".xtermColor210 { color: #ff8787 !important; }",
         ".xtermBgColor210 { background-color: #ff8787; }",
         ".xtermColor211 { color: #ff87af !important; }",
         ".xtermBgColor211 { background-color: #ff87af; }",
         ".xtermColor212 { color: #ff87d7 !important; }",
         ".xtermBgColor212 { background-color: #ff87d7; }",
         ".xtermColor213 { color: #ff87ff !important; }",
         ".xtermBgColor213 { background-color: #ff87ff; }",
         ".xtermColor214 { color: #ffaf00 !important; }",
         ".xtermBgColor214 { background-color: #ffaf00; }",
         ".xtermColor215 { color: #ffaf5f !important; }",
         ".xtermBgColor215 { background-color: #ffaf5f; }",
         ".xtermColor216 { color: #ffaf87 !important; }",
         ".xtermBgColor216 { background-color: #ffaf87; }",
         ".xtermColor217 { color: #ffafaf !important; }",
         ".xtermBgColor217 { background-color: #ffafaf; }",
         ".xtermColor218 { color: #ffafd7 !important; }",
         ".xtermBgColor218 { background-color: #ffafd7; }",
         ".xtermColor219 { color: #ffafff !important; }",
         ".xtermBgColor219 { background-color: #ffafff; }",
         ".xtermColor220 { color: #ffd700 !important; }",
         ".xtermBgColor220 { background-color: #ffd700; }",
         ".xtermColor221 { color: #ffd75f !important; }",
         ".xtermBgColor221 { background-color: #ffd75f; }",
         ".xtermColor222 { color: #ffd787 !important; }",
         ".xtermBgColor222 { background-color: #ffd787; }",
         ".xtermColor223 { color: #ffd7af !important; }",
         ".xtermBgColor223 { background-color: #ffd7af; }",
         ".xtermColor224 { color: #ffd7d7 !important; }",
         ".xtermBgColor224 { background-color: #ffd7d7; }",
         ".xtermColor225 { color: #ffd7ff !important; }",
         ".xtermBgColor225 { background-color: #ffd7ff; }",
         ".xtermColor226 { color: #ffff00 !important; }",
         ".xtermBgColor226 { background-color: #ffff00; }",
         ".xtermColor227 { color: #ffff5f !important; }",
         ".xtermBgColor227 { background-color: #ffff5f; }",
         ".xtermColor228 { color: #ffff87 !important; }",
         ".xtermBgColor228 { background-color: #ffff87; }",
         ".xtermColor229 { color: #ffffaf !important; }",
         ".xtermBgColor229 { background-color: #ffffaf; }",
         ".xtermColor230 { color: #ffffd7 !important; }",
         ".xtermBgColor230 { background-color: #ffffd7; }",
         ".xtermColor231 { color: #ffffff !important; }",
         ".xtermBgColor231 { background-color: #ffffff; }",
         ".xtermColor232 { color: #080808 !important; }",
         ".xtermBgColor232 { background-color: #080808; }",
         ".xtermColor233 { color: #121212 !important; }",
         ".xtermBgColor233 { background-color: #121212; }",
         ".xtermColor234 { color: #1c1c1c !important; }",
         ".xtermBgColor234 { background-color: #1c1c1c; }",
         ".xtermColor235 { color: #262626 !important; }",
         ".xtermBgColor235 { background-color: #262626; }",
         ".xtermColor236 { color: #303030 !important; }",
         ".xtermBgColor236 { background-color: #303030; }",
         ".xtermColor237 { color: #3a3a3a !important; }",
         ".xtermBgColor237 { background-color: #3a3a3a; }",
         ".xtermColor238 { color: #444444 !important; }",
         ".xtermBgColor238 { background-color: #444444; }",
         ".xtermColor239 { color: #4e4e4e !important; }",
         ".xtermBgColor239 { background-color: #4e4e4e; }",
         ".xtermColor240 { color: #585858 !important; }",
         ".xtermBgColor240 { background-color: #585858; }",
         ".xtermColor241 { color: #626262 !important; }",
         ".xtermBgColor241 { background-color: #626262; }",
         ".xtermColor242 { color: #6c6c6c !important; }",
         ".xtermBgColor242 { background-color: #6c6c6c; }",
         ".xtermColor243 { color: #767676 !important; }",
         ".xtermBgColor243 { background-color: #767676; }",
         ".xtermColor244 { color: #808080 !important; }",
         ".xtermBgColor244 { background-color: #808080; }",
         ".xtermColor245 { color: #8a8a8a !important; }",
         ".xtermBgColor245 { background-color: #8a8a8a; }",
         ".xtermColor246 { color: #949494 !important; }",
         ".xtermBgColor246 { background-color: #949494; }",
         ".xtermColor247 { color: #9e9e9e !important; }",
         ".xtermBgColor247 { background-color: #9e9e9e; }",
         ".xtermColor248 { color: #a8a8a8 !important; }",
         ".xtermBgColor248 { background-color: #a8a8a8; }",
         ".xtermColor249 { color: #b2b2b2 !important; }",
         ".xtermBgColor249 { background-color: #b2b2b2; }",
         ".xtermColor250 { color: #bcbcbc !important; }",
         ".xtermBgColor250 { background-color: #bcbcbc; }",
         ".xtermColor251 { color: #c6c6c6 !important; }",
         ".xtermBgColor251 { background-color: #c6c6c6; }",
         ".xtermColor252 { color: #d0d0d0 !important; }",
         ".xtermBgColor252 { background-color: #d0d0d0; }",
         ".xtermColor253 { color: #dadada !important; }",
         ".xtermBgColor253 { background-color: #dadada; }",
         ".xtermColor254 { color: #e4e4e4 !important; }",
         ".xtermBgColor254 { background-color: #e4e4e4; }",
         ".xtermColor255 { color: #eeeeee !important; }",
         ".xtermBgColor255 { background-color: #eeeeee; }")
})

.rs.addFunction("themes_static_rules", function(isDark) {
   content <- paste(".editor_dark.ace_editor_theme a {",
                    "   color: #FFF !important;",
                    "}",
                    "",
                    ".ace_layer {",
                    "   z-index: 3;",
                    "}",
                    "",
                    # support for showing margin line over nodebook code chunks 
                    ".ace_layer.ace_print-margin-layer {",
                    "   z-index: 2;",
                    "}",
                    "",
                    ".ace_layer.ace_marker-layer {",
                    "   z-index: 1;",
                    "}",
                    sep = "\n")
   
   if (isDark) {
      content <- c(
         content,
         paste(
            ".rstudio-themes-dark-menus .ace_editor.ace_autocomplete {",
            "   background: #2f3941;",                    # darkGreyMenuBackground
            "   border: solid 1px #4e5c68 !important;",   # darkGreyMenuBorder
            "   color: #f0f0f0;",
            "}",
            "",
            ".rstudio-themes-dark-menus .ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line,",
            ".rstudio-themes-dark-menus .ace_editor.ace_autocomplete .ace_marker-layer .ace_line-hover {",
            "   background: rgba(255, 255, 255, 0.15);",  # darkGreyMenuSelected 
            "   border: none",
            "}",
            sep = "\n"
         )
      )
   }
   
   content
})

.rs.addFunction("compile_theme", function(
   lines,
   isDark,
   name = "",
   chunkBgPropOverrideMap = list(),
   operatorOverrideMap = list(),
   keywordOverrideMap = list(),
   nodeSelectorOverrideMap = list(),
   commentBgOverrideMap = list(), 
   xterm16ColorMap = NULL)
{
   ## Guess the theme name -- all rules should start with it.
   stripped <- sub(" .*", "", lines)
   stripped <- grep("^\\.", stripped, value = TRUE)
   
   ## Get the most common value; this is the theme name.
   ## We do this because some rules will have e.g.
   ## '.ace-<theme>.normal-mode', or other things we don't use.
   themeNameCssClass <- names(sort(c(table(stripped)), decreasing = TRUE))[[1]]
   
   ## There may (should) be a rule for just '.ace-<theme> { ... }'; we need
   ## to preserve this theme, but apply it to the '.ace_editor' directly.
   regex <- paste("^\\s*", themeNameCssClass, "\\s*\\{\\s*$", sep = "")
   content <- gsub(regex, paste(
      ".ace_editor",
      ".ace_editor_theme .profvis-flamegraph",
      ".ace_editor_theme {",
      sep = ", "), lines)
   
   ## Strip the theme name rule from the CSS.
   regex <- paste("^\\", themeNameCssClass, "\\S*\\s+", sep = "")
   content <- gsub(regex, "", content)
   
   ## Add border radius
   content <- .rs.setSelectionStartBorderRadius(content)
   
   ## Parse the css
   parsed <- .rs.parseCss(lines = content)
   
   names(parsed)[grep("^\\.ace_editor(,.*|)$", names(parsed), perl = TRUE)] <- "ace_editor"
   
   if (!any(grepl("^\\.ace_keyword", names(parsed)))) {
      warning("No field 'ace_keyword' in file '", paste0(name,".css"), "'; skipping", call. = FALSE)
      return(c())
   }
   
   key <- grep("^\\.ace_keyword\\s*$", names(parsed), value = TRUE)
   keywordColor <- NULL
   if (length(key) > 0) {
      keywordColor <- parsed[[key[[1]]]]$color
   }
   if (is.null(keywordColor)) {
      warning("No field 'color' for rule 'ace_keyword' in file '", paste0(name,".css"), "'", call. = FALSE)
      return(c())
   }
   
   content <- .rs.add_content(
      content,
      ".nocolor.ace_editor .ace_line span {",
      "  color: %s !important;",
      "}",
      replace = keywordColor
   )
   
   ## Coloring for brackets, discarding the ace bounding box shown
   ## on highlight.
   layerName <- ".ace_marker-layer .ace_bracket"
   if (!(layerName %in% names(parsed))) {
      warning("Expected rule for '", layerName, "' in file '", paste0(name,".css"), "'; skipping", call. = FALSE)
      return(c())
   }
   
   borderField <- parsed[[layerName]]$border
   if (is.null(borderField)) {
      warning("No field 'border' for rule '", layerName, "' in file '", paste0(name,".css"), "'; skipping", call. = FALSE)
      return(c())
   }
   
   operatorBgColor <- if (isDark)
      "rgba(128, 128, 128, 0.5)"
   else
      "rgba(192, 192, 192, 0.5)"
   
   content <- .rs.add_content(
      content,
      ".ace_bracket {",
      "  margin: 0 !important;",
      "  border: 0 !important;",
      "  background-color: %s;",
      "}",
      replace = operatorBgColor
   )
   
   ## Get the default background, foreground color for the theme.
   background <- parsed$ace_editor$`background-color`
   if (is.null(background))
      background <- if (isDark) "#000000" else "#FFFFFF"
   
   foreground <- parsed$ace_editor$color
   if (is.null(foreground))
      foreground <- if (isDark) "#FFFFFF" else "#000000"
   
   
   ## Generate a color used for chunks, e.g. in .Rmd documents.
   ## Determine an appropriate mixing proportion, and override for certain
   ## themes.
   mix <- .rs.get_chunk_bg_color(name, isDark, chunkBgPropOverrideMap)
   
   mergedColor <- .rs.mixColors(
      background,
      foreground,
      mix
   )
   
   content <- c(
      content,
      .rs.create_line_marker_rule(".ace_foreign_line", mergedColor),
      .rs.createNodeSelectorRule(name, isDark, nodeSelectorOverrideMap),
      .rs.createCommentBgRule(name, isDark, commentBgOverrideMap)
   )
   
   ## Generate a color used for 'debugging' backgrounds.
   if (!any(grepl(".ace_active_debug_line", content, fixed = TRUE)))
   {
      debugPrimary <- "#FFDE38"
      debugBg <- .rs.mixColors(background, debugPrimary, 0.5)
   
      content <- c(
         content,
         .rs.create_line_marker_rule(".ace_active_debug_line", debugBg)
      )
   }
   
   ## Generate a background color used for console errors, as well as
   ## 'find_line' (used for highlighting e.g. 'sourceCpp' errors).
   
   ## Dark backgrounds need a bit more contrast than light ones for
   ## a nice visual display.
   mixingProportion <- if (isDark) 0.8 else 0.9
   errorBgColor <- .rs.mixColors(background, foreground, mixingProportion)
   
   content <- c(
      content,
      .rs.create_line_marker_rule(".ace_find_line", errorBgColor)
   )
   
   content <- .rs.add_content(
      content,
      ".ace_console_error {",
      "  background-color: %s;",
      "}",
      replace = errorBgColor
   )
   
   ## Add operator colors if necessary.
   if (name %in% names(operatorOverrideMap))
      content <- .rs.add_operator_color(content, name, isDark, operatorOverrideMap)
   
   ## Add keyword colors if necessary.
   if (name %in% names(keywordOverrideMap))
      content <- .rs.add_keyword_color(content, name, keywordOverrideMap)
   
   # Apply terminal-specifics
   content <- c(content,
                .rs.create_terminal_rule(background, foreground)) 
   content <- c(content,
                .rs.create_terminal_cursor_rules(isDark))
   content <- c(content,
                .rs.create_terminal_viewport_rule(background))
   
   # Add xterm-256 colors for colorized console output
   content <- c(content,
                .rs.create_xterm_color_rules(background, foreground, isDark, xterm16ColorMap = xterm16ColorMap))
   
   # Theme rules
   content <- c(content,
                .rs.themes_static_rules(isDark)) 
   
   # All done, return the lines.
   content
})

#
# SessionDataViewer.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# host environment for cached data; this allows us to continue to view data 
# even if the original object is deleted
.rs.setVar("CachedDataEnv", new.env(parent = emptyenv()))

# host environment for working data; this allows us to sort/filter/page the
# data without recomputing on the original object every time
.rs.setVar("WorkingDataEnv", new.env(parent = emptyenv()))

.rs.addFunction("formatDataColumn", function(x, start, len, ...)
{
   # extract the visible part of the column
   col <- x[start:min(NROW(x), start + len)]
   
   # if this object has a format method, use it. catch errors
   # and validate that the format method has given us something 'sane'
   formatted <- .rs.tryCatch(.rs.formatDataColumnDispatch(col, ...))
   if (is.character(formatted) && length(formatted) == length(col))
      return(formatted)
   
   # otherwise, delegate to internal methods
   if (is.numeric(col))
      .rs.formatDataColumnNumeric(col, ...)
   else if (is.list(col) && !is.data.frame(col))
      .rs.formatDataColumnList(col, ...)
   else
      .rs.formatDataColumnDefault(col, ...)
})

.rs.addFunction("formatDataColumnDispatch", function(col, ...)
{
   formatter <- NULL
   for (class in class(col))
   {
      formatter <- utils::getS3method(
         "format",
         class = class,
         optional = TRUE
      )
      if (!is.null(formatter))
         break
   }
   
   if (is.null(formatter))
      return(NULL)
   
   formatted <- formatter(col, trim = TRUE, justify = "none", ...)
   
   if (is.character(formatted) && length(formatted) == length(col))
      formatted[is.na(col)] <- NA
   
   formatted
   
})

.rs.addFunction("formatDataColumnNumeric", function(col, ...)
{
   # show numbers as doubles
   storage.mode(col) <- "double"
   
   # remember which values are NA 
   naVals <- is.na(col) 
   
   # format all the numeric values; this drops NAs (the na.encode option only
   # preserves NA for character cols)
   vals <- format(col, trim = TRUE, justify = "none", ...)
   
   # restore NA values if there were any
   if (any(naVals))
      vals[naVals] <- col[naVals]
   
   # return formatted values
   vals
})

.rs.addFunction("formatDataColumnList", function(col, ...)
{
   limit <- .rs.readUserPref("data_viewer_max_cell_size")
   if (is.null(limit)) {
      limit <- 50L
   }

   formatted <- as.character(col)
   large <- nchar(formatted) > limit
   formatted <- substr(formatted, 1, limit)
   formatted <- paste0(formatted, ifelse(large, " [...]", ""))
   formatted
})

.rs.addFunction("formatDataColumnDefault", function(col, ...)
{
   # show everything else as characters
   as.character(col)
})

.rs.addFunction("describeCols", function(x, maxFactors) 
{
   colNames <- names(x)
   
   # get the variable labels, if any--labels may be provided either by this 
   # global attribute or by a 'label' attribute on an individual column (as in
   # e.g. Hmisc), which takes precedence if both are present
   colLabels <- attr(x, "variable.labels", exact = TRUE)
   if (!is.character(colLabels)) 
   {
      colLabels <- character()
   }
   
   # the first column is always the row names
   rowNameCol <- list(
      col_name        = .rs.scalar(""),
      col_type        = .rs.scalar("rownames"),
      col_min         = .rs.scalar(0),
      col_max         = .rs.scalar(0),
      col_search_type = .rs.scalar("none"),
      col_label       = .rs.scalar(""),
      col_vals        = "",
      col_type_r      = .rs.scalar(""))
   
   # if there are no columns, bail out
   if (length(colNames) == 0) {
      return(rowNameCol)
   }
   
   # get the attributes for each column
   colAttrs <- lapply(seq_along(colNames), function(idx) {
      col_name <- if (idx <= length(colNames)) 
         colNames[idx] 
      else 
         as.character(idx)
      col_type <- "unknown"
      col_type_r <- "unknown"
      col_breaks <- c()
      col_counts <- c()
      col_vals <- ""
      col_search_type <- ""
      
      # extract label, if any, or use global label, if any
      label <- attr(x[[idx]], "label", exact = TRUE)
      col_label <- if (is.character(label))
      {
         label
      }
      else if (idx <= length(colLabels))
      {
         if (col_name %in% names(colLabels))
            colLabels[[col_name]]
         else
            colLabels[[idx]]
      }
      else
      {
         ""
      }
      
      # ensure that the column contains some scalar values we can examine 
      if (length(x[[idx]]) > 0)
      {
         val <- x[[idx]][[1]]
         col_type_r <- typeof(val)
         if (is.factor(val))
         {
            col_type <- "factor"
            if (length(levels(val)) > maxFactors)
            {
               # if the number of factors exceeds the max, search the column as 
               # though it were a character column
               col_search_type <- "character"
            }
            else 
            {
               col_search_type <- "factor"
               col_vals <- levels(val)
            }
         }
         # for histograms, we support only the base R numeric class and its derivatives;
         # is.numeric can return true for values that can only be manipulated using
         # packages that are currently loaded (e.g. bit64's integer64)
         else if (is.numeric(x[[idx]]) && !is.object(x[[idx]]))
         {
            # ignore missing and infinite values (i.e. let any filter applied
            # implicitly remove those values); if that leaves us with nothing,
            # treat this column as untyped since we can do no meaningful filtering
            # on it
            hist_vals <- x[[idx]][is.finite(x[[idx]])]
            if (length(hist_vals) > 1)
            {
               # create histogram for brushing -- suppress warnings as in rare cases
               # an otherwise benign integer overflow can occurs; see
               # https://github.com/rstudio/rstudio/issues/3232
               h <- suppressWarnings(graphics::hist(hist_vals, plot = FALSE))
               col_breaks <- h$breaks
               col_counts <- h$counts
               
               # record column type
               col_type <- "numeric"
               col_search_type <- "numeric"
            }
         }
         else if (inherits(x[[idx]], "integer64"))
         {
            col_type <- "numeric"
            col_search_type <- "character"
         }
         else if (is.character(val))
         {
            col_type <- "character"
            col_search_type <- "character"
         }
         else if (is.logical(val))
         {
            col_type <- "boolean"
            col_search_type <- "boolean"
         }
         else if (is.data.frame(val))
         {
            col_type <- "data.frame"
         }
         else if (is.list(val))
         {
            col_type <- "list"
         }
      }
      list(
         col_name        = .rs.scalar(col_name),
         col_type        = .rs.scalar(col_type),
         col_breaks      = as.character(col_breaks),
         col_counts      = col_counts,
         col_search_type = .rs.scalar(col_search_type),
         col_label       = .rs.scalar(col_label),
         col_vals        = col_vals,
         col_type_r      = .rs.scalar(col_type_r)
      )
   })
   c(list(rowNameCol), colAttrs)
})

.rs.addFunction("formatRowNames", function(x, start, len) 
{
   # detect whether this is a data.frame that contains
   # row names, or if the row names are stored compactly
   if (is.data.frame(x))
   {
      info <- .row_names_info(x, type = 0L)
      if (is.integer(info) && length(info) > 0 && is.na(info[[1]]))
      {
         # the second element indicates the number of rows, and is negative if they're 
         # automatic
         n <- abs(info[[2]])
         range <- seq(from = start, to = min(n, start + len))
         return(as.character(range))
      }
   }
   
   # otherwise, extract row names and subset as usual
   rownames <- row.names(x)
   rownames[start:min(length(rownames), start + len)]
})

# wrappers for nrow/ncol which will report the class of object for which we
# fail to get dimensions along with the original error
.rs.addFunction("nrow", function(x)
{
   rows <- 0
   tryCatch({
      rows <- NROW(x)
   }, error = function(e) {
      stop("Failed to determine rows for object of class '", class(x), "': ", 
           e$message)
   })
   if (is.null(rows))
      0
   else
      rows
})

.rs.addFunction("ncol", function(x)
{
   cols <- 0
   tryCatch({
      cols <- NCOL(x)
   }, error = function(e) {
      stop("Failed to determine columns for object of class '", class(x), "': ", 
           e$message)
   })
   if (is.null(cols))
      0
   else
      cols
})

.rs.addFunction("toDataFrame", function(x, name, flatten) {
   
   # if we have a data.table, convert it to a data.frame explicitly
   if (inherits(x, "data.table"))
      x <- as.data.frame(x)
   
   # if it's not already a frame, coerce it to a frame
   if (!is.data.frame(x)) {
      frame <- NULL
      # attempt to coerce to a data frame--this can throw errors in the case
      # where we're watching a named object in an environment and the user
      # replaces an object that can be coerced to a data frame with one that
      # cannot
      tryCatch(
         {
            # create a temporary frame to hold the value; this is necessary because
            # "x" is a function argument and therefore a promise whose value won't
            # be bound via substitute() below. we use a random-looking name so we 
            # can spot it later when relabeling columns.
            `__RSTUDIO_VIEWER_COLUMN__` <- x
            
            # perform the actual coercion in the global environment; this is 
            # necessary because we want to honor as.data.frame overrides of packages
            # which are loaded after tools:rstudio in the search path
            frame <- eval(substitute(as.data.frame(`__RSTUDIO_VIEWER_COLUMN__`, 
                                                   optional = TRUE)), 
                          envir = globalenv())
         },
         error = function(e)
         {
         })
      
      # as.data.frame uses the name of its argument to label unlabeled columns,
      # so label these back to the original name
      if (!is.null(frame) && !is.null(names(frame)))
         names(frame)[names(frame) == "__RSTUDIO_VIEWER_COLUMN__"] <- name
      x <- frame 
   }
   
   # if coercion was successful (or we started with a frame), flatten the frame
   # if necessary and requested
   if (is.data.frame(x)) {
      
      # generate column names if we didn't have any to start
      if (is.null(names(x)))
         names(x) <- paste("V", seq_along(x), sep = "")
      
      if (flatten) {
         x <- .rs.flattenFrame(x)
      } 
      return(x)
   }
})

.rs.addFunction("multiCols", function(x) {
   fun <- function(col) is.data.frame(col) || is.matrix(col)
   which(vapply(x, fun, TRUE))
})

.rs.addFunction("flattenFrame", function(x) {
  multicols <- .rs.multiCols(x)
  while (length(multicols) > 0) {
    multicol <- multicols[1]
    newcols <- ncol(x[[multicol]])
    if (identical(newcols, 0)) 
    {
      # remove columns consisting of empty frames
      x[[multicol]] <- NULL
    }
    else
    {
      cols <- x[[multicol]]

      # recurse because x[[multicol]] might also need flattening
      if (length(.rs.multiCols(cols)) > 0L) {
        cols <- x[[multicol]] <- .rs.flattenFrame(cols)
        
        # readjust indices
        newcols <- ncol(cols)
      }
      
      # apply column names
      prefix <- names(multicol)[[1]]
      if (is.matrix(cols)) {
        colnames <- colnames(cols)
        if (is.null(colnames)) {
          colnames(cols) <- paste0(prefix, '[,', 1:ncol(cols), ']')
        } else {
          colnames(cols) <- paste0(prefix, '[,"', colnames, '"]')
        }

      } else if (is.data.frame(cols)) {
        names(cols) <- paste(prefix, names(cols), sep = "$")
      }
      
      # replace other columns in place
      if (multicol >= ncol(x))  {
        x <- cbind(x[0:(multicol-1)], cols)
      } else {
        x <- cbind(x[0:(multicol-1)], cols, x[(multicol+1):ncol(x)])
      }
    }
    
    # pop this frame off the list and adjust the other indices to account for
    # the columns we just added, if any
    multicols <- multicols[-1] + (max(newcols, 1) - 1) 
  }
  x
})

.rs.addFunction("applyTransform", function(x, filtered, search, cols, dirs)
{
   # mark encoding on character inputs if not already marked
   filtered <- vapply(filtered, function(colfilter) {
      if (Encoding(colfilter) == "unknown") 
         Encoding(colfilter) <- "UTF-8"
      colfilter
   }, "")
   if (Encoding(search) == "unknown")
      Encoding(search) <- "UTF-8"
   
   # coerce argument to data frame--data.table objects (for example) report that
   # they're data frames, but don't actually support the subsetting operations
   # needed for search/sort/filter without an explicit cast
   x <- .rs.toDataFrame(x, "transformed", TRUE)
   
   # apply columnwise filters
   for (i in seq_along(filtered)) {
      if (nchar(filtered[i]) > 0 && length(x[[i]]) > 0) {
         # split filter--string format is "type|value" (e.g. "numeric|12-25") 
         filter <- strsplit(filtered[i], split="|", fixed = TRUE)[[1]]
         if (length(filter) < 2) 
         {
            # no filter type information
            next
         }
         filtertype <- filter[1]
         filterval <- filter[2]
         
         # apply filter appropriate to type
         if (identical(filtertype, "factor")) 
         {
            # apply factor filter: convert to numeric values and discard missing
            filterval <- as.numeric(filterval)
            matches <- as.numeric(x[[i]]) == filterval
            matches[is.na(matches)] <- FALSE
            x <- x[matches, , drop = FALSE]
         }
         else if (identical(filtertype, "character"))
         {
            # apply character filter: non-case-sensitive prefix
            # use PCRE and the special \Q and \E escapes to ensure no characters in
            # the search expression are interpreted as regexes 
            x <- x[grepl(paste("\\Q", filterval, "\\E", sep = ""), x[[i]], 
                         perl = TRUE, ignore.case = TRUE), , 
                   drop = FALSE]
         } 
         else if (identical(filtertype, "numeric"))
         {
            # apply numeric filter, range ("2-32") or equality ("15")
            filterval <- as.numeric(strsplit(filterval, "_")[[1]])
            if (length(filterval) > 1)
               # range filter
               x <- x[is.finite(x[[i]]) & x[[i]] >= filterval[1] & x[[i]] <= filterval[2], , drop = FALSE]
            else
               # equality filter
               x <- x[is.finite(x[[i]]) & x[[i]] == filterval, , drop = FALSE]
         }
         else if (identical(filtertype, "boolean")) 
         {
            filterval <- isTRUE(filterval == "TRUE")
            matches <- x[[i]] == filterval
            matches[is.na(matches)] <- FALSE
            x <- x[matches, , drop = FALSE]
         }
      }
   }
   
   # apply global search
   if (!is.null(search) && nchar(search) > 0)
   {
      x <- x[Reduce("|", lapply(x, function(column) { 
         grepl(paste("\\Q", search, "\\E", sep = ""), column, perl = TRUE,
               ignore.case = TRUE)
      })), , drop = FALSE]
   }
   
   # apply sort
   if (length(cols) > 0)
   {
      vals <- list()
      for (i in length(cols))
      {
         idx <- cols[[i]]
         if (length(x[[idx]]) > 0)
         {
            if (identical(dirs[[i]], "asc"))
            {
               vals <- append(vals, list(x[[idx]]))
            }
            else
            {
               vals <- append(vals, list(-xtfrm(x[[idx]])))
            }
         }
      }
      
      if (length(vals) > 0)
      {
         x <- x[do.call(order, vals), , drop = FALSE]
      }
   }
   
   return(x)
})

# returns envName as an environment, or NULL if the conversion failed
.rs.addFunction("safeAsEnvironment", function(envName)
{
   env <- NULL
   tryCatch(
      {
         env <- as.environment(envName)
      }, 
      error = function(e) { })
   env
})

.rs.addFunction("findDataFrame", function(envName, objName, cacheKey, cacheDir) 
{
   env <- NULL
   
   # mark encoding on cache directory 
   if (Encoding(cacheDir) == "unknown")
      Encoding(cacheDir) <- "UTF-8"
   
   # do we have an object name? if so, check in a named environment
   if (!is.null(objName) && nchar(objName) > 0) 
   {
      if (is.null(envName) || identical(envName, "R_GlobalEnv") || 
          nchar(envName) == 0)
      {
         # global environment
         env <- globalenv()
      }
      else 
      {
         env <- .rs.safeAsEnvironment(envName)
         if (is.null(env))
            env <- emptyenv()
      }
      
      # if the object exists in this environment, return it (avoid creating a
      # temporary here)
      if (exists(objName, where = env, inherits = FALSE))
      {
         # attempt to coerce the object to a data frame--note that a null return
         # value here may indicate that the object exists in the environment but
         # is no longer a data frame (we want to fall back on the cache in this
         # case)
         dataFrame <- .rs.toDataFrame(get(objName, envir = env, inherits = FALSE), 
                                      objName, TRUE)
         if (!is.null(dataFrame)) 
            return(dataFrame)
      }
   }
   
   # if the object exists in the cache environment, return it. Objects
   # in the cache environment have already been coerced to data frames.
   if (exists(cacheKey, where = .rs.CachedDataEnv, inherits = FALSE))
      return(get(cacheKey, envir = .rs.CachedDataEnv, inherits = FALSE))
   
   # perhaps the object has been saved? attempt to load it into the
   # cached environment
   cacheFile <- file.path(cacheDir, paste(cacheKey, "Rdata", sep = "."))
   if (file.exists(cacheFile))
   {
      status <- try(load(cacheFile, envir = .rs.CachedDataEnv), silent = TRUE)
      if (inherits(status, "try-error"))
         return(NULL)
      
      if (exists(cacheKey, where = .rs.CachedDataEnv, inherits = FALSE))
         return(get(cacheKey, envir = .rs.CachedDataEnv, inherits = FALSE))
   }
   
   # failure
   return(NULL)
})

# given a name, return the first environment on the search list that contains
# an object bearing that name. 
.rs.addFunction("findViewingEnv", function(name)
{
   # default to searching from the global environment
   env <- globalenv()
   
   # attempt to find a callframe from which View was invoked; this will allow
   # us to locate viewing environments further in the callstack (e.g. in the
   # debugger)
   for (i in seq_along(sys.calls()))
   {
      if (identical(deparse(sys.call(i)[[1]]), "View"))
      {
         env <- sys.frame(i - 1)
         break
      }
   }
   
   while (environmentName(env) != "R_EmptyEnv" && 
          !exists(name, where = env, inherits = FALSE)) 
   {
      env <- parent.env(env)
   }
   env
})

# attempts to determine whether the View(...) function the user has an 
# override (i.e. it's not the handler RStudio uses)
.rs.addFunction("isViewOverride", function() {
   # check to see if View has been overridden: find the View() call in the 
   # stack and examine the function being evaluated there
   for (i in seq_along(sys.calls()))
   {
      if (identical(deparse(sys.call(i)[[1]]), "View"))
      {
         # the first statement in the override function should be a call to 
         # .rs.callAs
         return(!identical(deparse(body(sys.function(i))[[1]]), ".rs.callAs"))
      }
   }
   # if we can't find View on the callstack, presume the common case (no
   # override)
   FALSE
})

.rs.addFunction("viewHook", function(original, x, title) {
   
   # remember the expression from which the data was generated
   expr <- deparse(substitute(x), backtick = TRUE)
   
   # generate title if necessary (from deparsed expr)
   if (missing(title))
      title <- paste(expr[1])
   
   # collapse expr for serialization
   expr <- paste(expr, collapse = " ")
   
   name <- ""
   env <- emptyenv()
   
   
   if (.rs.isViewOverride()) 
   {
      # if the View() invoked wasn't our own, we have no way of knowing what's
      # been done to the data since the user invoked View() on it, so just view
      # a snapshot of the data
      name <- title
   }
   else if (is.name(substitute(x)))
   {
      # if the argument is the name of a variable, we can monitor it in its
      # environment, and don't need to make a copy for viewing
      name <- paste(deparse(substitute(x)))
      env <- .rs.findViewingEnv(name)
   }
   
   # is this a function? if it is, view as a function instead
   if (is.function(x)) 
   {
      # check the source refs to see if we can open the file itself instead of
      # opening a read-only source viewer
      srcref <- .rs.getSrcref(x)
      if (!is.null(srcref))
      {
         srcfile <- attr(srcref, "srcfile", exact = TRUE)
         filename <- .rs.nullCoalesce(srcfile$filename, "")
         if (!identical(filename, "~/.active-rstudio-document") &&
             file.exists(filename))
         {
            # the srcref points to a valid file--go there 
            .Call("rs_jumpToFunction",
                  normalizePath(filename, winslash = "/"),
                  srcref[[1]],
                  srcref[[5]],
                  TRUE,
                  PACKAGE = "(embedding)")
            
            return(invisible(NULL))
         }
      }
      
      # either this function doesn't have a source reference or its source
      # reference points to a file we can't locate on disk--show a deparsed
      # version of the function
      
      # remove package qualifiers from function name
      title <- sub("^[^:]+:::?", "", title)
      
      # infer environment location
      namespace <- .rs.environmentName(environment(x))
      if (identical(namespace, "R_EmptyEnv") || identical(namespace, ""))
         namespace <- "viewing"
      else if (identical(namespace, "R_GlobalEnv"))
         namespace <- ".GlobalEnv"
      invisible(.Call("rs_viewFunction", x, title, namespace, PACKAGE = "(embedding)"))
      return(invisible(NULL))
   }
   else if (inherits(x, "vignette"))
   {
      file.edit(file.path(x$Dir, "doc", x$File))
      return(invisible(NULL))
   }
   
   # delegate to object explorer if this is an 'explorable' object
   if (.rs.dataViewer.shouldUseObjectExplorer(x))
   {
      view <- .rs.explorer.viewObject(x, title = title, envir = env)
      return(invisible(view))
   }
   
   # convert Pandas DataFrames to R data.frames
   if (inherits(x, "pandas.core.frame.DataFrame"))
      x <- reticulate::py_to_r(x)
   
   # test for coercion to data frame--the goal of this expression is just to
   # raise an error early if the object can't be made into a frame; don't
   # require that we can generate row/col names
   coerced <- x
   eval(
      expr = substitute(as.data.frame(coerced, optional = TRUE)),
      envir = globalenv()
   )
   
   # save a copy into the cached environment
   cacheKey <- .rs.addCachedData(force(x), name)
   
   # call viewData 
   invisible(.Call("rs_viewData", x, expr, title, name, env, cacheKey, FALSE))
})

.rs.registerReplaceHook("View", "utils", .rs.viewHook)

.rs.addFunction("dataViewer.shouldUseObjectExplorer", function(object)
{
   # prefer data viewer for pandas DataFrames
   if (inherits(object, "pandas.core.frame.DataFrame"))
      return(FALSE)
   
   # don't explore regular data.frames
   isTabular <-
      is.data.frame(object) ||
      is.matrix(object) ||
      is.table(object)
   
   if (isTabular)
      return(FALSE)
   
   # other objects are worth using object explorer for
   TRUE
})

.rs.addFunction("viewDataFrame", function(x, title, preview) {
   cacheKey <- .rs.addCachedData(force(x), "")
   invisible(.Call("rs_viewData", x, "", title, "", emptyenv(), cacheKey, preview))
})

.rs.addFunction("initializeDataViewer", function(server) {
   if (server) {
      .rs.registerReplaceHook("edit", "utils", function(original, name, ...) {
         if (is.data.frame(name) || is.matrix(name))
            stop("Editing of data frames and matrixes is not supported in RStudio.", call. = FALSE)
         else
            original(name, ...)
      })
   }
})

.rs.addFunction("addCachedData", function(obj, objName) 
{
   cacheKey <- .Call("rs_generateShortUuid")
   .rs.assignCachedData(cacheKey, obj, objName)
   cacheKey
})

.rs.addFunction("assignCachedData", function(cacheKey, obj, objName) 
{
   # coerce to data frame before assigning, and don't assign if we can't coerce
   frame <- .rs.toDataFrame(obj, objName, TRUE)
   if (!is.null(frame))
      assign(cacheKey, frame, .rs.CachedDataEnv)
})

.rs.addFunction("removeCachedData", function(cacheKey, cacheDir)
{
   # mark encoding on cache directory 
   if (Encoding(cacheDir) == "unknown")
      Encoding(cacheDir) <- "UTF-8"
   
   # remove data from the cache environment
   if (exists(".rs.CachedDataEnv") &&
       exists(cacheKey, where = .rs.CachedDataEnv, inherits = FALSE))
      rm(list = cacheKey, envir = .rs.CachedDataEnv, inherits = FALSE)
   
   # remove data from the cache directory
   cacheFile <- file.path(cacheDir, paste(cacheKey, "Rdata", sep = "."))
   if (file.exists(cacheFile))
      file.remove(cacheFile)
   
   # remove any working data
   .rs.removeWorkingData(cacheKey)
   
   invisible(NULL)
})

.rs.addFunction("saveCachedData", function(cacheDir)
{
   # mark encoding on cache directory 
   if (Encoding(cacheDir) == "unknown")
      Encoding(cacheDir) <- "UTF-8"
   
   # no work to do if we have no cache
   if (!exists(".rs.CachedDataEnv")) 
      return(invisible(NULL))
   
   # save each active cache file from the cache environment
   lapply(ls(.rs.CachedDataEnv), function(cacheKey) {
      save(list = cacheKey, 
           file = file.path(cacheDir, paste(cacheKey, "Rdata", sep = ".")),
           envir = .rs.CachedDataEnv)
   })
   
   # clean the cache environment
   # can generate warnings if .rs.CachedDataEnv disappears (we call this on
   # shutdown); suppress these
   suppressWarnings(rm(list = ls(.rs.CachedDataEnv), where = .rs.CachedDataEnv))
   
   invisible(NULL)
})

.rs.addFunction("findWorkingData", function(cacheKey)
{
   if (exists(".rs.WorkingDataEnv") &&
       exists(cacheKey, where = .rs.WorkingDataEnv, inherits = FALSE))
      get(cacheKey, envir = .rs.WorkingDataEnv, inherits = FALSE)
   else
      NULL
})

.rs.addFunction("removeWorkingData", function(cacheKey)
{
   if (exists(".rs.WorkingDataEnv") &&
       exists(cacheKey, where = .rs.WorkingDataEnv, inherits = FALSE))
      rm(list = cacheKey, envir = .rs.WorkingDataEnv, inherits = FALSE)
   invisible(NULL)
})

.rs.addFunction("assignWorkingData", function(cacheKey, obj)
{
   assign(cacheKey, obj, .rs.WorkingDataEnv)
})

.rs.addFunction("findGlobalData", function(name)
{
   if (exists(name, envir = globalenv()))
   {
      if (inherits(get(name, envir = globalenv()), "data.frame"))
         return(name)
   }
   invisible("")
})

#
# test-auto-completion.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

library(testthat)

context("auto-completion")

test_that(".rs.matchCall() respects numCommas=", {
    fun <- function(aaa, bbb, ccc){}

    expect_identical(
        .rs.matchCall(fun, quote(fun(a, b, c))), 
        quote(fun(aaa = a, bbb = b, ccc = c))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, b, c)), numCommas = 0), 
        quote(fun())
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, b, c)), numCommas = 1), 
        quote(fun(aaa = a))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, b, c)), numCommas = 2), 
        quote(fun(aaa = a, bbb = b))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, b, c)), numCommas = 3), 
        quote(fun(aaa = a, bbb = b, ccc = c))
    )

    expect_identical(
        .rs.matchCall(fun, quote(fun(a, b, aaa = c)), numCommas = 0), 
        quote(fun(aaa = c))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, b, aaa = c)), numCommas = 1), 
        quote(fun(aaa = c, bbb = a))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, b, aaa = c)), numCommas = 2), 
        quote(fun(aaa = c, bbb = a, ccc = b))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, b, aaa = c)), numCommas = 3), 
        quote(fun(aaa = c, bbb = a, ccc = b))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, b, aaa = c))), 
        quote(fun(aaa = c, bbb = a, ccc = b))
    )
    
    expect_identical(
        .rs.matchCall(fun, quote(fun(aaa = a, b, c)), numCommas = 0), 
        quote(fun(aaa = a))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(aaa = a, b, c)), numCommas = 1), 
        quote(fun(aaa = a))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(aaa = a, b, c)), numCommas = 2), 
        quote(fun(aaa = a, bbb = b))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(aaa = a, b, c)), numCommas = 3), 
        quote(fun(aaa = a, bbb = b, ccc = c))
    )

    expect_identical(
        .rs.matchCall(fun, quote(fun(a, bbb = d, c)), numCommas = 0), 
        quote(fun(bbb = d))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, bbb = d, c)), numCommas = 1), 
        quote(fun(aaa = a, bbb = d))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, bbb = d, c)), numCommas = 2), 
        quote(fun(aaa = a, bbb = d))
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(a, bbb = d, c)), numCommas = 3), 
        quote(fun(aaa = a, bbb = d, ccc = c))
    )
})

test_that(".rs.matchCall() removes named arguments not in the formals", {
    fun <- function(aaa, bbb, ccc){}

    expect_identical(
        .rs.matchCall(fun, quote(fun(ddd = a))), 
        quote(fun())
    )
    expect_identical(
        .rs.matchCall(fun, quote(fun(ddd = a, a))), 
        quote(fun(aaa = a))
    )
})

test_that(".rs.makeCompletions() handle optional $suggestOnAccept", {
    expect_null(
        .rs.makeCompletions("", c("a", "b"))$suggestOnAccept
    )
    expect_equal(
        .rs.makeCompletions("", c("a", "b"), suggestOnAccept = logical())$suggestOnAccept, 
        c(FALSE, FALSE)
    )
    expect_equal(
        .rs.makeCompletions("", c("a", "b"), suggestOnAccept = TRUE)$suggestOnAccept, 
        c(TRUE, TRUE)
    )
    expect_equal(
        .rs.makeCompletions("", c("a", "b"), suggestOnAccept = c(TRUE, FALSE))$suggestOnAccept, 
        c(TRUE, FALSE)
    )
})

test_that(".rs.appendCompletions() handle optional $suggestOnAccept", {
    expect_null(
        .rs.appendCompletions(
            .rs.makeCompletions("", c("a", "b")), 
            .rs.makeCompletions("", c("c", "d", "e"))
        )$suggestOnAccept
    )

    expect_equal(
        .rs.appendCompletions(
            .rs.makeCompletions("", c("a", "b"), suggestOnAccept = c(TRUE, FALSE)), 
            .rs.makeCompletions("", c("c", "d", "e"))
        )$suggestOnAccept, 
        c(TRUE, FALSE, FALSE, FALSE, FALSE)
    )

    expect_equal(
        .rs.appendCompletions(
            .rs.makeCompletions("", c("a", "b")), 
            .rs.makeCompletions("", c("c", "d", "e"), suggestOnAccept = c(TRUE, FALSE, TRUE))
        )$suggestOnAccept, 
        c(FALSE, FALSE, TRUE, FALSE, TRUE)
    )

    expect_equal(
        .rs.appendCompletions(
            .rs.makeCompletions("", c("a", "b")     , suggestOnAccept = c(FALSE, TRUE)), 
            .rs.makeCompletions("", c("c", "d", "e"), suggestOnAccept = c(TRUE, FALSE, TRUE))
        )$suggestOnAccept, 
        c(FALSE, TRUE, TRUE, FALSE, TRUE)
    )
})

test_that(".rs.subsetCompletions() handle optional $suggestOnAccept", {
    expect_equal(
        .rs.subsetCompletions(
            .rs.makeCompletions("", c("c", "d", "e"), suggestOnAccept = c(TRUE, FALSE, TRUE)),
            1
        )$suggestOnAccept,
        TRUE
    )

    expect_equal(
        .rs.subsetCompletions(
            .rs.makeCompletions("", c("c", "d", "e"), suggestOnAccept = c(TRUE, FALSE, TRUE)),
            c(TRUE, TRUE, FALSE)
        )$suggestOnAccept,
        c(TRUE, FALSE)
    )

    expect_null(
        .rs.subsetCompletions(
            .rs.makeCompletions("", c("c", "d", "e")),
            1
        )$suggestOnAccept
    )
})

test_that(".rs.getCompletionsSingleBracket() uses dimnames() for matrix-like S4 objects", {
    skip_if_not_installed("Matrix")

    e <- new.env()
    e$m <- Matrix::sparseMatrix(
        i = c(1L, 2L),
        j = c(1L, 2L),
        x = c(1, 2),
        dims = c(3L, 4L)
    )
    colnames(e$m) <- c("c1", "c2", "c3", "c4")

    # m[, |  -- numCommas = 1 -> column names from dimnames()
    result <- .rs.getCompletionsSingleBracket(
        token = "",
        string = "m",
        functionCall = quote(m[]),
        numCommas = 1,
        index = 1L,
        envir = e
    )
    expect_equal(result$results, c("c1", "c2", "c3", "c4"))
})

test_that(".rs.getCompletionsSingleBracket() handles sparse matrices with no dimnames", {
    skip_if_not_installed("Matrix")

    e <- new.env()
    e$m <- Matrix::sparseMatrix(
        i = c(1L, 2L),
        j = c(1L, 2L),
        x = c(1, 2),
        dims = c(3L, 4L)
    )

    # Should return cleanly (not hang or error) with no completions when
    # no dimnames are set.
    result <- .rs.getCompletionsSingleBracket(
        token = "",
        string = "m",
        functionCall = quote(m[]),
        numCommas = 1,
        index = 1L,
        envir = e
    )
    expect_equal(length(result$results), 0L)
})

test_that(".rs.getCompletionsSingleBracket() does not offer auto-rownames for data.frames", {
    e <- new.env()
    e$df <- data.frame(x = 1:3, y = 4:6)

    # df[|  -- numCommas = 0; auto-generated rownames "1", "2", "3" must
    # NOT be offered as completions.
    result <- .rs.getCompletionsSingleBracket(
        token = "",
        string = "df",
        functionCall = quote(df[]),
        numCommas = 0,
        index = 1L,
        envir = e
    )
    expect_false(any(c("1", "2", "3") %in% result$results))
})

test_that(".rs.getCompletionsSingleBracket() offers explicit rownames for data.frames", {
    e <- new.env()
    e$mt <- mtcars

    result <- .rs.getCompletionsSingleBracket(
        token = "Mazda",
        string = "mt",
        functionCall = quote(mt[]),
        numCommas = 0,
        index = 1L,
        envir = e
    )
    expect_true("Mazda RX4" %in% result$results)
})

test_that(".rs.getCompletionsSingleBracket() offers colnames for data.frames after a comma", {
    e <- new.env()
    e$df <- data.frame(apple = 1:3, banana = 4:6)

    # df[, |
    result <- .rs.getCompletionsSingleBracket(
        token = "",
        string = "df",
        functionCall = quote(df[]),
        numCommas = 1,
        index = 1L,
        envir = e
    )
    expect_setequal(result$results, c("apple", "banana"))
})

#
# SessionRHooks.R
#
# Copyright (C) 2009-14 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("invokeHook", function(hookName, ...) {
  # ensure that the list of hooks can be iterated over as a list
  hooks <- getHook(hookName)
  if (!is.list(hooks))
    hooks <- list(hooks)

  # execute each attached hook with the given parameters
  for (fun in hooks) {
    if (is.character(fun))
      fun <- get(fun)
    tryCatch(fun(...),
             error = function(e) { 
                # ignore errors occurring during hook execution
             })
  }
})

#
# SessionDataImport.R
#
# Copyright (C) 2009-12 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("parseDataFile", function(path, encoding, header, sep, dec, 
                                          quote, comment, nrows) {
   data <- tryCatch(
      # try to use read.csv directly if possible (since this is a common case
      # and since LibreOffice spreadsheet exports produce files unparsable
      # by read.table). check Workspace.makeCommand if we want to deduce
      # other more concrete read calls.
      if (identical(sep,",") && identical(dec,".") && identical(quote,"\""))
         read.csv(path, encoding=encoding, header=header, nrows=nrows,
                  comment.char=comment)
      else
         read.table(path, encoding=encoding, header=header, sep=sep, dec=dec, 
                    quote=quote, comment.char=comment, nrows=nrows),
      error=function(e) {
         data.frame(Error=e$message)
      })

   oldWidth <- options('width')$width
   options(width=1000)
   output <- format(data)
   options(width=oldWidth)
   return(output)
})

.rs.addJsonRpcHandler("download_data_file", function(url)
{
   # download the file
   downloadPath <- tempfile("data")
   download.file(url, downloadPath)

   # return the path
   downloadInfo <- list()
   downloadInfo$path = downloadPath

   # also return a suggested variable name
   downloadInfo$varname <- "dataset"
   urlBasename <- basename(url)
   if (length(urlBasename) > 0)
   {
      fileComponents <- unlist(strsplit(urlBasename, ".", fixed = TRUE))
      components <- length(fileComponents)
      if (components >= 1)
         downloadInfo$varname <- paste(fileComponents[1:components-1],
                                       collapse=".")
   }

   return (downloadInfo)
})

.rs.addJsonRpcHandler("get_data_preview", function(path)
{
   nrows <- 20

   lines <- readLines(path, n=nrows, warn=F)

   # Drop comment lines, leaving the significant ones
   siglines <- grep("^[^#].*", lines, value=TRUE)

   # If any comment lines were found, presume # to be the comment character
   comment <- ""
   if (length(siglines) < length(lines)) {
     comment <- "#"
   } 

   firstline <- siglines[1]

   dataline <- siglines[2]
   if (is.na(dataline) || length(grep("[^\\s]+", dataline)) == 0)
      dataline <- firstline

   sep <- ''
   if (length(grep("\\t", firstline)) > 0) {
      sep <- "\t"
   } else if (length(grep(";", firstline)) > 0) {
      sep <- ";"
   } else if (length(grep(",", firstline)) > 0) {
      sep <- ","
   }

   dec <- '.'
   if (length(grep("\\.", dataline)) == 0
         && length(grep(",", dataline)) > 0
         && sep != ",")
   {
      dec <- ','
   }

   header <- length(grep("[0-9]", firstline)) == 0

   quote <- "\""

   output <- .rs.parseDataFile(path,
                               encoding="unknown",
                               header=header,
                               sep=sep,
                               dec=dec,
                               quote=quote,
                               comment=comment,
                               nrows=nrows)

   list(inputLines=paste(lines, collapse="\n"),
        output=output,
        outputNames=names(output),
        encoding="unknown",
        header=header,
        separator=sep,
        decimal=dec,
        quote=quote,
        comment=comment,
        defaultStringsAsFactors=default.stringsAsFactors())
})

.rs.addJsonRpcHandler("get_output_preview", function(path, encoding, header,
                                                     sep, decimal, quote, 
                                                     comment)
{
   nrows <- 20
   output <- .rs.parseDataFile(path, encoding=encoding, header=header, sep=sep, 
                               dec=decimal, quote=quote, comment=comment, 
                               nrows=nrows)

   list(output=output,
        outputNames=names(output),
        header=header,
        encoding=encoding,
        separator=sep,
        quote=quote,
        comment=comment,
        defaultStringsAsFactors=default.stringsAsFactors())
})

#
# SessionRAddins.R
#
# Copyright (C) 2014-18 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

assign(".rs.rAddinsEnv", new.env(parent = emptyenv()), envir = .rs.toolsEnv())

.rs.addJsonRpcHandler("prepare_for_addin", function()
{
   .rs.addins.addShinyResponseFilter()
})

.rs.addFunction("addins.addShinyResponseFilter", function()
{
   # save the old filter (if any)
   assign(
      ".rs.addins.savedShinyResponseFilter",
      getOption("shiny.http.response.filter"),
      envir = .rs.toolsEnv())
   
   # register console prompt handler (clean up the filter on next prompt event)
   .Call("rs_registerAddinConsolePromptHandler", PACKAGE = "(embedding)")
   
   # activate our filter
   options(shiny.http.response.filter = .rs.addins.shinyResponseFilter)
})

.rs.addFunction("addins.removeShinyResponseFilter", function()
{
   # restore the saved filter
   options(shiny.http.response.filter = .rs.addins.savedShinyResponseFilter)
   
   # remove the saved filter from tools env
   rm(".rs.addins.savedShinyResponseFilter", envir = .rs.toolsEnv())
})

.rs.addFunction("addins.shinyResponseFilter", function(request, response)
{
   # bail if this isn't the root response
   if (!identical(request$PATH_INFO, "/"))
      return(response)
   
   # ensure text is character rather than raw (not sure if this can happen
   # but other shiny.http.response.filters do this so best to be safe)
   if (is.raw(response$content))
      response$content <- rawToChar(response$content)
   
   # inject our CSS into the response
   inject <- '<head><style type="text/css">select, input { zoom: 1.000001; }</style>'
   response$content <- sub('<head>', inject, response$content, ignore.case = TRUE)
   
   # return the response
   response
})

.rs.addApiFunction("restartSession", function(command = NULL) {
   command <- as.character(command)
   invisible(.rs.restartR(command))
})

.rs.addApiFunction("initializeProject", function(path = getwd())
{
   path <- .rs.ensureScalarCharacter(path)
   
   # if this is an existing file ...
   if (file.exists(path))
   {
      # ... and it's an .Rproj file, then just return that (don't 
      # re-initialize the project)
      if (grepl("[.]Rproj$", path))
         return(.rs.normalizePath(path, winslash = "/"))
      
      # ... and it's not a directory, bail
      if (!utils::file_test("-d", path))
      {
         fmt <- "file '%s' exists and is not a directory"
         stop(sprintf(fmt, .rs.createAliasedPath(path)))
      }
   }
   
   # otherwise, assume we've received the path to a directory, and
   # attempt to initialize a project within that directory
   .rs.ensureDirectory(path)
   
   # check to see if a .Rproj file already exists in that directory;
   # if so, then we don't need to re-initialize
   rProjFiles <- list.files(path, 
                            pattern = "[.]Rproj$",
                            full.names = TRUE)
   
   # if we already have a .Rproj file, just return that
   if (length(rProjFiles))
      return(.rs.normalizePath(rProjFiles[[1]], winslash = "/"))
   
   # otherwise, attempt to create a new .Rproj file, and return
   # the path to the generated file
   rProjFile <- file.path(
      normalizePath(path, mustWork = TRUE, winslash = "/"),
      paste(basename(path), "Rproj", sep = ".")
   )
   
   success <- .Call(
      "rs_writeProjectFile",
      rProjFile,
      PACKAGE = "(embedding)"
   )
   
   if (!success)
   {
      fmt <- "failed to initialize RStudio project in directory '%s'"
      stop(sprintf(fmt, .rs.createAliasedPath(path)))
   }
   
   return(rProjFile)
   
})

.rs.addApiFunction("openProject", function(path = NULL,
                                           newSession = FALSE)
{
   # default to current project directory (note that this can be
   # NULL if the user is not within an RStudio project)
   if (is.null(path))
     path <- .rs.getProjectDirectory()
   
   path <- .rs.ensureScalarCharacter(path)
   
   # attempt to initialize project if necessary
   rProjFile <- .rs.api.initializeProject(path)
   
   # request that we open this project
   invisible(
      .Call("rs_requestOpenProject",
            rProjFile,
            newSession,
            PACKAGE = "(embedding)")
   )
})

.rs.addApiFunction("versionInfo", function() {
  info <- list()
  info$citation <- .Call("rs_rstudioCitation", PACKAGE = "(embedding)")
  info$mode <- .Call("rs_rstudioProgramMode", PACKAGE = "(embedding)")
  info$edition <- .Call("rs_rstudioEdition", PACKAGE = "(embedding)")
  info$version <- .Call("rs_rstudioVersion", PACKAGE = "(embedding)")
  info$version <- package_version(info$version)
  info$release_name <- .Call("rs_rstudioReleaseName", PACKAGE = "(embedding)")
  info
})

.rs.addApiFunction("diagnosticsReport", function() {
  invisible(.Call(getNativeSymbolInfo("rs_sourceDiagnostics", PACKAGE="")))
})


.rs.addApiFunction("previewRd", function(rdFile) {

  if (!is.character(rdFile) || (length(rdFile) != 1))
    stop("rdFile must be a single element character vector.")
  if (!file.exists(rdFile))
    stop("The specified rdFile ' ", rdFile, "' does not exist.")

  invisible(.Call(getNativeSymbolInfo("rs_previewRd", PACKAGE=""), rdFile))
})

.rs.addApiFunction("viewer", function(url, height = NULL) {

  if (!is.character(url) || (length(url) != 1))
    stop("url must be a single element character vector.")

  if (identical(height, "maximize"))
     height <- -1

  if (!is.null(height) && (!is.numeric(height) || (length(height) != 1)))
     stop("height must be a single element numeric vector or 'maximize'.")

  invisible(.Call(getNativeSymbolInfo("rs_viewer", PACKAGE=""), url, height))
})


.rs.addApiFunction("savePlotAsImage", function(
                   file,
                   format = c("png", "jpeg", "bmp", "tiff", "emf", "svg", "eps"),
                   width,
                   height) {

   file <- path.expand(file)
   format <- match.arg(format)
   if (!is.numeric(width))
      stop("width argument mut be numeric", call. = FALSE)
   if (!is.numeric(height))
      stop("height argument mut be numeric", call. = FALSE)
   invisible(.Call("rs_savePlotAsImage", file, format, width, height))
})

.rs.addApiFunction("sourceMarkers", function(name,
                                             markers,
                                             basePath = NULL,
                                             autoSelect = c("none", "first", "error")) {

   # validate name
   if (!is.character(name))
      stop("name parameter is specified or invalid: ", name, call. = FALSE)

   # validate autoSelect
   autoSelect = match.arg(autoSelect)

   # normalize basePath
   if (!is.null(basePath))
      basePath <- .rs.normalizePath(basePath,  mustWork = TRUE)

   if (is.data.frame(markers)) {

      cols <- colnames(markers)

      if (!"type" %in% cols || !is.character(markers$type))
         stop("markers type field is unspecified or invalid", call. = FALSE)
      if (!"file" %in% cols || !is.character(markers$file))
         stop("markers file field is unspecified or invalid", call. = FALSE)
      if (!"line" %in% cols || !is.numeric(markers$line))
         stop("markers line field is unspecified or invalid", call. = FALSE)
      if (!"column" %in% cols || !is.numeric(markers$column))
         stop("markers column field is unspecified or invalid", call. = FALSE)
      if (!"message" %in% cols || !is.character(markers$message))
         stop("markers message field is unspecified or invalid", call. = FALSE)

      # normalize paths
      markers$file <- .rs.normalizePath(markers$file, mustWork = TRUE)

      # check for html
      markers$messageHTML <- inherits(markers$message, "html")

   } else if (is.list(markers)) {
      markers <- lapply(markers, function(marker) {
         markerTypes <- c("error", "warning", "box", "info", "style", "usage")
         if (is.null(marker$type) || (!marker$type %in% markerTypes))
            stop("Invalid marker type (", marker$type, ")", call. = FALSE)
         if (!is.character(marker$file))
            stop("Marker file is unspecified or invalid: ", marker$file, call. = FALSE)
         if (!is.numeric(marker$line))
            stop("Marker line is unspecified or invalid", marker$line, call. = FALSE)
         if (!is.numeric(marker$column))
            stop("Marker column is unspecified or invalid", marker$line, call. = FALSE)
         if (!is.character(marker$message))
            stop("Marker message is unspecified or invalid: ", marker$message, call. = FALSE)

         marker$type <- .rs.scalar(marker$type)
         marker$file <- .rs.scalar(.rs.normalizePath(marker$file, mustWork = TRUE))
         marker$line <- .rs.scalar(as.numeric(marker$line))
         marker$column <- .rs.scalar(as.numeric(marker$column))
         marker$message <- .rs.scalar(marker$message)
         marker$messageHTML <- .rs.scalar(inherits(marker$message, "html"))

         marker
      })
   } else {
      stop("markers was not a data.frame or a list", call. = FALSE)
   }

   # validate basePath
   if (is.null(basePath))
      basePath <- ""
   else if (!is.character(basePath))
      stop("basePath parameter is not of type character", call. = FALSE)

   invisible(.Call("rs_sourceMarkers", name, markers, basePath, autoSelect))
})

.rs.addApiFunction("navigateToFile", function(filePath, line = 1L, col = 1L) {
   # validate file argument
   if (!is.character(filePath)) {
      stop("filePath must be a character")
   }
   if (!file.exists(filePath)) {
      stop(filePath, " does not exist.")
   }
   
   # transform numeric line, column values to integer
   if (is.numeric(line))
      line <- as.integer(line)
   
   if (is.numeric(col))
      col <- as.integer(col)

   # validate line/col arguments
   if (!is.integer(line) || length(line) != 1 ||
       !is.integer(col)  || length(col) != 1) {
      stop("line and column must be numeric values.")
   }

   # expand and alias for client
   filePath <- .rs.normalizePath(filePath, winslash="/", mustWork = TRUE)
   homeDir <- path.expand("~")
   if (identical(substr(filePath, 1, nchar(homeDir)), homeDir)) {
      filePath <- file.path("~", substring(filePath, nchar(homeDir) + 2))
   }

   # send event to client
   .rs.enqueClientEvent("jump_to_function", list(
      file_name     = .rs.scalar(filePath),
      line_number   = .rs.scalar(line),
      column_number = .rs.scalar(col)))

   invisible(NULL)
})

.rs.addFunction("validateAndTransformLocation", function(location)
{
   invalidRangeMsg <- "'ranges' should be a list of 4-element integer vectors"

   # allow a single range (then validate that it's a true range after)
   if (!is.list(location) || inherits(location, "document_range"))
      location <- list(location)

   ranges <- lapply(location, function(el) {

      # detect proxy Inf object
      if (identical(el, Inf))
         el <- c(Inf, 0, Inf, 0)

      # detect positions (2-element vectors) and transform them to ranges
      n <- length(el)
      if (n == 2 && is.numeric(el))
         el <- c(el, el)

      # detect document_ranges and transform
      if (is.list(el) && all(c("start", "end") %in% names(el)))
         el <- c(el$start, el$end)

      # validate we have a range-like object
      if (length(el) != 4 || !is.numeric(el) || any(is.na(el)))
         stop(invalidRangeMsg, call. = FALSE)

      # transform out-of-bounds values appropriately
      el[el < 1] <- 1
      el[is.infinite(el)] <- NA

      # transform from 1-based to 0-based indexing for server
      result <- as.integer(el) - 1L

      # treat NAs as end of row / column
      result[is.na(result)] <- as.integer(2 ^ 31 - 1)

      result
   })

   ranges
})

.rs.addFunction("enqueEditorClientEvent", function(type, data)
{
   eventData = list(type = .rs.scalar(type), data = data)
   .rs.enqueClientEvent("editor_command", eventData)
})

.rs.addApiFunction("insertText", function(location, text, id = "") {

   invalidTextMsg <- "'text' should be a character vector"
   invalidLengthMsg <- "'text' should either be length 1, or same length as 'ranges'"

   if (is.null(id))
      id <- ""

   if (!is.character(id))
      stop("'id' must be NULL or a character vector of length one")

   # allow calls of the form:
   #
   #    insertText("foo")
   #    insertText(text = "foo")
   #
   # in such cases, we replace the current selection. we pass an empty range
   # and let upstream interpret this as a request to replace the current
   # selection.

   if (missing(text) && is.character(location)) {
      text <- location
      location <- list()
   } else if (missing(location) && is.character(text)) {
      text <- text
      location <- list()
   } else if (length(location) == 0) {
      return()
   }

   ranges <- .rs.validateAndTransformLocation(location)
   if (!is.character(text))
      stop(invalidTextMsg, call. = FALSE)

   if (length(text) != 1 && length(ranges) != length(text))
      stop(invalidLengthMsg, call. = FALSE)

   # sort the ranges in decreasing order -- this way, we can
   # ensure the replacements occur correctly (except in the
   # case of overlaps)
   if (length(ranges)) {
      idx <- order(unlist(lapply(ranges, `[[`, 1)))

      ranges <- ranges[idx]
      if (length(text) != 1)
         text <- text[idx]
   }

   data <- list(ranges = ranges, text = text, id = .rs.scalar(id))
   .rs.enqueEditorClientEvent("replace_ranges", data)
   invisible(data)
})

.rs.addApiFunction("setSelectionRanges", function(ranges, id = "")
{
   ranges <- .rs.validateAndTransformLocation(ranges)
   data <- list(ranges = ranges, id = .rs.scalar(id))
   .rs.enqueEditorClientEvent("set_selection_ranges", data)
   invisible(data)
})

# NOTE: Kept for backwards compatibility with older versions
# of the 'rstudioapi' package -- it is superceded by
# '.rs.getLastActiveEditorContext()'.
.rs.addApiFunction("getActiveDocumentContext", function() {
   .Call("rs_getEditorContext", 0L)
})

.rs.addApiFunction("getLastActiveEditorContext", function() {
   .Call("rs_getEditorContext", 0L)
})

.rs.addApiFunction("getConsoleEditorContext", function() {
   .Call("rs_getEditorContext", 1L)
})

.rs.addApiFunction("getSourceEditorContext", function() {
   .Call("rs_getEditorContext", 2L)
})

.rs.addApiFunction("getActiveProject", function() {
   .rs.getProjectDirectory()
})

.rs.addApiFunction("sendToConsole", function(code,
                                             echo = TRUE,
                                             execute = TRUE,
                                             focus = TRUE)
{
   if (!is.character(code))
      stop("'code' should be a character vector", call. = FALSE)

   code <- paste(code, collapse = "\n")
   data <- list(
      code = .rs.scalar(code),
      echo = .rs.scalar(as.logical(echo)),
      execute = .rs.scalar(as.logical(execute)),
      focus = .rs.scalar(as.logical(focus)),
      language = "R"
   )

   .rs.enqueClientEvent("send_to_console", data)
   invisible(data)
})

.rs.addApiFunction("askForPassword", function(prompt) {
   .rs.askForPassword(prompt)
})

.rs.addFunction("dialogIcon", function(name) {
  list(
    info = 1,
    warning = 2,
    error = 3,
    question = 4
  )
})

.rs.addApiFunction("showDialog", function(title, message, url = "") {
   
   # ensure URL is a string
   if (is.null(url) || is.na(url))
      url <- ""
   
   .Call("rs_showDialog",
      title = title,
      message = message,
      dialogIcon = .rs.dialogIcon()$info,
      prompt = FALSE,
      promptDefault = "",
      ok = "OK",
      cancel = "Cancel",
      url = url)
})

.rs.addApiFunction("updateDialog", function(...)
{
   scalarValues <- lapply(list(...), .rs.scalar)
   .rs.enqueClientEvent("update_new_connection_dialog", scalarValues)

   invisible(NULL)
})

.rs.addApiFunction("showPrompt", function(title, message, default = "") {
   
   # ensure default is a string
   if (is.null(default) || is.na(default))
      default <- ""
   
   .Call("rs_showDialog",
      title = title,
      message = message,
      dialogIcon = .rs.dialogIcon()$info,
      prompt = TRUE,
      promptDefault = default,
      ok = "OK",
      cancel = "Cancel",
      url = "")
})

.rs.addApiFunction("showQuestion", function(title, message, ok = "OK", cancel = "Cancel") {
   
   # fix up ok, cancel
   if (is.null(ok) || is.na(ok))
      ok <- "OK"
   
   if (is.null(cancel) || is.na(cancel))
      cancel <- "Cancel"
   
   .Call("rs_showDialog",
      title = title,
      message = message,
      dialogIcon = .rs.dialogIcon()$question,
      prompt = FALSE,
      promptDefault = NULL,
      ok = ok,
      cancel = cancel,
      url = NULL)
})

.rs.addApiFunction("writePreference", function(name, value) {
  .rs.writeApiPref(name, value)
})

.rs.addApiFunction("readPreference", function(name, default = NULL) {
  value <- .rs.readApiPref(name)
  if (is.null(value)) default else value
})

.rs.addApiFunction("writeRStudioPreference", function(name, value) {
  .rs.writeUiPref(name, value)
})

.rs.addApiFunction("readRStudioPreference", function(name, default = NULL) {
  value <- .rs.readUiPref(name)
  if (is.null(value)) default else value
})

.rs.addApiFunction("setPersistentValue", function(name, value) {
   invisible(.Call("rs_setPersistentValue", name, value))
})

.rs.addApiFunction("getPersistentValue", function(name) {
   .Call("rs_getPersistentValue", name)
})

.rs.addApiFunction("documentSave", function(id = NULL) {
   # If no ID is specified, try to save the active editor.
   if (is.null(id)) {
      context <- .rs.api.getSourceEditorContext()
      if (!is.null(context)) {
         id <- context$id
      }
   }
   if (is.null(id)) {
      # No ID specified and no document open; succeed without meaning
      return(TRUE)
   }
   .Call("rs_requestDocumentSave", id, PACKAGE = "(embedding)")
})

.rs.addApiFunction("documentSaveAll", function() {
   .Call("rs_requestDocumentSave", NULL, PACKAGE = "(embedding)")
})

.rs.addApiFunction("documentNew", function(type, code, row = 0, column= 0, execute = FALSE) {
   type <- switch(
      type,
      rmarkdown = "r_markdown",
      sql = "sql",
      "r_script"
   )

   .rs.enqueClientEvent("new_document_with_code", list(
      type = .rs.scalar(type),
      code = .rs.scalar(code),
      row = .rs.scalar(row),
      column = .rs.scalar(column),
      execute = .rs.scalar(execute)
   ))

   invisible(NULL)
})

.rs.addApiFunction("documentClose", function(id = NULL, save = TRUE) {
   # If no ID is specified, try to close the active editor.
   if (is.null(id)) {
      context <- .rs.api.getSourceEditorContext()
      if (!is.null(context)) {
         id <- context$id
      }
   }
   if (is.null(id)) {
      # No ID specified and no document open; succeed without meaning
      return(TRUE)
   }
   .Call("rs_requestDocumentClose", id, save, PACKAGE = "(embedding)")
})

.rs.addApiFunction("getConsoleHasColor", function(name) {
   value <- .rs.readUiPref("ansi_console_mode")
   if (is.null(value) || value != 1) FALSE else TRUE
})

.rs.addApiFunction("terminalSend", function(id, text) {
   if (!is.character(text))
      stop("'text' should be a character vector", call. = FALSE)

   if (is.null(id) || !is.character(id) || length(id) != 1)
      stop("'id' must be a character vector of length one")

  .Call("rs_terminalSend", id, text)
   invisible(NULL)
})

.rs.addApiFunction("terminalClear", function(id) {
   if (is.null(id) || !is.character(id) || length(id) != 1)
      stop("'id' must be a character vector of length one")

  .Call("rs_terminalClear", id)
  invisible(NULL)
})

.rs.addApiFunction("terminalCreate", function(caption = NULL, show = TRUE, shellType = NULL) {
   if (!is.null(caption) && (!is.character(caption) || (length(caption) != 1)))
      stop("'caption' must be NULL or a character vector of length one")

   if (is.null(show) || !is.logical(show))
      stop("'show' must be a logical vector")

   if (!is.null(shellType) && (!is.character(shellType) || (length(shellType) != 1)))
      stop("'shellType' must be NULL or a character vector of length one")

   validShellType = TRUE
   if (!is.null(shellType)) {
      validShellType <- tolower(shellType) %in% c("default", "win-cmd", 
            "win-ps", "win-git-bash", "win-wsl-bash", "ps-core", "custom")
   }      
   if (!validShellType)
      stop("'shellType' must be NULL, or one of 'default', 'win-cmd', 'win-ps', 'win-git-bash', 'win-wsl-bash', 'ps-core', 'bash', 'zsh', or 'custom'.") 

   .Call("rs_terminalCreate", caption, show, shellType)
})

.rs.addApiFunction("terminalBusy", function(id) {
   if (is.null(id) || !is.character(id))
      stop("'id' must be a character vector")

   .Call("rs_terminalBusy", id)
})

.rs.addApiFunction("terminalRunning", function(id) {
   if (is.null(id) || !is.character(id))
      stop("'id' must be a character vector")

   .Call("rs_terminalRunning", id)
})

.rs.addApiFunction("terminalList", function() {
   .Call("rs_terminalList")
})

.rs.addApiFunction("terminalContext", function(id) {
   if (is.null(id) || !is.character(id) || (length(id) != 1))
      stop("'id' must be a single element character vector")

   .Call("rs_terminalContext", id)
})

.rs.addApiFunction("terminalActivate", function(id = NULL, show = TRUE) {
   if (!is.null(id) && (!is.character(id) || (length(id) != 1)))
      stop("'id' must be NULL or a character vector of length one")

   if (!is.logical(show))
     stop("'show' must be TRUE or FALSE")

   .Call("rs_terminalActivate", id, show)
   invisible(NULL)
})

.rs.addApiFunction("terminalBuffer", function(id, stripAnsi = TRUE) {
   if (is.null(id) || !is.character(id) || (length(id) != 1))
      stop("'id' must be a single element character vector")

   if (is.null(stripAnsi) || !is.logical(stripAnsi))
      stop("'stripAnsi' must be a logical vector")

   .Call("rs_terminalBuffer", id, stripAnsi)
})

.rs.addApiFunction("terminalKill", function(id) {
   if (is.null(id) || !is.character(id))
      stop("'id' must be a character vector")

   .Call("rs_terminalKill", id)
   invisible(NULL)
})

.rs.addApiFunction("terminalVisible", function() {
   .Call("rs_terminalVisible")
})

.rs.addApiFunction("terminalExecute", function(command,
                                               workingDir = NULL,
                                               env = character(),
                                               show = TRUE) {
   if (is.null(command) || !is.character(command) || (length(command) != 1))
      stop("'command' must be a single element character vector")
   if (!is.null(workingDir) && (!is.character(workingDir) || (length(workingDir) != 1)))
      stop("'workingDir' must be a single element character vector")
   if (!is.null(env) && !is.character(env))
      stop("'env' must be a character vector")
   if (is.null(show) || !is.logical(show))
      stop("'show' must be a logical vector")

   .Call("rs_terminalExecute", command, workingDir, env, show)
})

.rs.addApiFunction("terminalExitCode", function(id) {
   if (is.null(id) || !is.character(id) || (length(id) != 1))
      stop("'id' must be a single element character vector")

   .Call("rs_terminalExitCode", id)
})

options(terminal.manager = list(terminalActivate = .rs.api.terminalActivate,
                                terminalCreate = .rs.api.terminalCreate,
                                terminalClear = .rs.api.terminalClear,
                                terminalList = .rs.api.terminalList,
                                terminalContext = .rs.api.terminalContext,
                                terminalBuffer = .rs.api.terminalBuffer,
                                terminalVisible = .rs.api.terminalVisible,
                                terminalBusy = .rs.api.terminalBusy,
                                terminalRunning = .rs.api.terminalRunning,
                                terminalKill = .rs.api.terminalKill,
                                terminalSend = .rs.api.terminalSend,
                                terminalExecute = .rs.api.terminalExecute,
                                terminalExitCode = .rs.api.terminalExitCode))

.rs.addApiFunction("selectFile", function(
   caption = "Select File",
   label = "Select",
   path = .rs.getProjectDirectory(),
   filter = NULL,
   existing = TRUE)
{
   .Call("rs_openFileDialog",
         1L,
         caption,
         label,
         path,
         filter,
         existing,
         PACKAGE = "(embedding)")
})

.rs.addApiFunction("selectDirectory", function(
   caption = "Select Directory",
   label = "Select",
   path = .rs.getProjectDirectory())
{
   .Call("rs_openFileDialog",
         2L,
         caption,
         label,
         path,
         NULL,
         TRUE,
         PACKAGE = "(embedding)")
})

.rs.addApiFunction("getThemeInfo", function() {
   
   # read theme preferences
   global <- .rs.readUiPref("global_theme")

   theme <- .rs.readUserState("theme")
   if (is.null(theme))
      theme <- list("name" = "Textmate (default)", "isDark" = FALSE)

   global <- switch(
      if (is.null(global)) "" else global,
      alternate = "Sky",
      default = "Modern",
      "Classic"
   )

   # default/fallback theme colors 
   foreground <- "#000000";
   background <- "#FFFFFF";

   # attempt to read colors from browser
   colors <- .Call("rs_getThemeColors", PACKAGE = "(embedding)")
   if (!is.null(colors)) {
      foreground <- colors$foreground
      background <- colors$background
   }

   list(
      editor = theme$name,
      global = global,
      dark = theme$isDark,
      foreground = foreground,
      background = background
   )
})

.rs.addApiFunction("askForSecret", function(name, title, prompt) {
   .rs.askForSecret(name, title, prompt)
})

.rs.addApiFunction("previewSql", function(conn, statement, ...) {
   .rs.previewSql(conn, statement, ...)
})

.rs.addApiFunction("buildToolsCheck", function() {
   .Call("rs_canBuildCpp", PACKAGE = "(embedding)")
})

.rs.addApiFunction("buildToolsInstall", function(action) {
   
   # skip prompt if requested explicitly
   if (is.null(action) || !nzchar(action))
      return(.Call("rs_installBuildTools", PACKAGE = "(embedding)"))
   
   # otherwise, call prompting version
   .rs.installBuildTools(action)
})

.rs.addApiFunction("buildToolsExec", function(expr) {
   .rs.withBuildTools(expr)
})

.rs.addApiFunction("dictionariesPath", function() {
   .Call("rs_dictionariesPath", PACKAGE = "(embedding)")
})

.rs.addApiFunction("userDictionariesPath", function() {
   .Call("rs_userDictionariesPath", PACKAGE = "(embedding)")
})

# translate a local URL into an externally accessible URL on RStudio Server
.rs.addApiFunction("translateLocalUrl", function(url, absolute = FALSE) {
  .Call("rs_translateLocalUrl", url, absolute, PACKAGE = "(embedding)")
})

# execute an arbitrary RStudio application command (AppCommand)
.rs.addApiFunction("executeCommand", function(commandId, quiet = FALSE) {
  .Call("rs_executeAppCommand", commandId, quiet, PACKAGE = "(embedding)")
})

# return a list of all the R packages RStudio depends on in in some way
.rs.addApiFunction("getPackageDependencies", function() {
  .Call("rs_packageDependencies", PACKAGE = "(embedding)")
})

# highlight UI elements within the IDE
.rs.addApiFunction("highlightUi", function(data = list()) {
   .Call("rs_highlightUi", data, PACKAGE = "(embedding)")
})

# return display username (user identity)
.rs.addApiFunction("userIdentity", function() {
   .Call("rs_userIdentity", PACKAGE = "(embedding)")
})

# return system username 
.rs.addApiFunction("systemUsername", function() {
   .Call("rs_systemUsername", PACKAGE = "(embedding)")
})

# Tutorial ----

# invoked by rstudioapi to instruct RStudio to open a particular
# URL in the Tutorial pane. should be considered an internal contract
# between the RStudio + rstudioapi packages rather than an official
# user-facing API
.rs.addApiFunction("tutorialLaunchBrowser", function(url) {
   .rs.tutorial.launchBrowser(url)
})

# given a tutorial 'name' from package 'package', run that tutorial
# and show the application in the Tutorial pane
.rs.addApiFunction("tutorialRun", function(name, package, shiny_args = NULL) {
   .rs.tutorial.runTutorial(name, package, shiny_args)
})

# stop a running tutorial
.rs.addApiFunction("tutorialStop", function(name, package) {
   .rs.tutorial.stopTutorial(name, package)
})

#
# SessionRmdNotebook.R
#
# Copyright (C) 2009-17 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#
assign(".rs.notebookVersion", envir = .rs.toolsEnv(), "1.0")

.rs.addFunction("extractRmdFromNotebook", function(notebook) {
   # parse the notebook to get the text of the contained R markdown doc
   parsed <- try(rmarkdown::parse_html_notebook(notebook), silent = TRUE)
   if (inherits(parsed, "try-error") || is.null(parsed$rmd)) {
    return("")
   }

   # as this string will be eventually written to (and compared with) files
   # on disk, use native line endings
   return(paste(parsed$rmd,
                collapse = ifelse(identical(.Platform$OS.type, "windows"),
                                  "\r\n", "\n")))
})

.rs.addFunction("reRmdChunkBegin", function()
{
   "^[\t >]*```+\\s*\\{[.]?([a-zA-Z]+.*)\\}\\s*$"
})

.rs.addFunction("reRmdChunkEnd", function()
{
   "^[\t >]*```+\\s*$"
})

.rs.addFunction("rnb.cachePathFromRmdPath", function(rmdPath)
{
   .Call("rs_chunkCacheFolder", rmdPath)
})

.rs.addFunction("coalesceCsvOutput", function(chunkData) {
  # nothing to coalesce if < 2 outputs
  if (length(chunkData) < 2)
    return(chunkData)
    
  # keep all output by default
  keep <- rep(TRUE, length(chunkData))

  # coalesce contents for consecutive csv entries
  csvs <- .rs.endsWith(names(chunkData), ".csv")
  for (i in seq.int(1, length(csvs) - 1)) {
    if (keep[[i]] && csvs[[i]] && csvs[[i + 1]]) {
      chunkData[[i]] <- paste(chunkData[[i]], chunkData[[i + 1]], sep = "")
      keep[[i + 1]] <- FALSE
    }
  }
  chunkData[keep]
})

.rs.addFunction("readRnbCache", function(rmdPath, cachePath)
{
   if (!file.exists(rmdPath))
      stop("No file at path '", rmdPath, "'")
   
   # tolerate missing cache (implies there's no chunk outputs)
   rmdPath <- path.expand(rmdPath)
   rmdContents <- .rs.readLines(rmdPath)
   
   # Begin collecting the units that form the Rnb data structure
   rnbData <- list()
   
   # store reference to source path
   rnbData[["source_path"]] <- rmdPath
   rnbData[["cache_path"]]  <- cachePath
   
   # Keep the original source data
   rnbData[["contents"]] <- rmdContents
   
   # Set up rnbData structure (if we have a cache, these entries will be filled)
   rnbData[["chunk_info"]] <- list()
   rnbData[["chunk_data"]] <- list()
   rnbData[["lib"]] <- list()
   
   # early return if we have no cache
   if (!file.exists(cachePath))
      return(rnbData)
   
   # Read the chunk information
   chunkInfoPath <- file.path(cachePath, "chunks.json")
   chunkInfo <- .rs.fromJSON(.rs.readFile(chunkInfoPath, encoding = "UTF-8"))
   names(chunkInfo$chunk_definitions) <-
      unlist(lapply(chunkInfo$chunk_definitions, `[[`, "chunk_id"))
   rnbData[["chunk_info"]] <- chunkInfo

   # Read external chunks (code chunks defined in other files)
   rnbData[["external_chunks"]] <- chunkInfo$external_chunks
   
   # Read the chunk data
   chunkDirs <- file.path(cachePath, names(chunkInfo$chunk_definitions))
   chunkData <- lapply(chunkDirs, function(dir) {
      files <- list.files(dir, full.names = TRUE)

      # exclude directories
      fileInfo <- file.info(files)
      files <- files[!fileInfo$isdir]

      # extract the contents from each regular file
      contents <- lapply(files, function(file) {
         .rs.readFile(
            file,
            encoding = "UTF-8",
            binary = .rs.endsWith(file, "png")  ||
                     .rs.endsWith(file, "jpg")  ||
                     .rs.endsWith(file, "jpeg") ||
                     .rs.endsWith(file, "rdf")
         )
      })
      names(contents) <- basename(files)
      contents
   })
   names(chunkData) <- basename(chunkDirs)
   rnbData[["chunk_data"]] <- chunkData
   
   # Read in the 'libs' directory.
   rnbData[["lib"]] <- list()
   
   libDir <- file.path(cachePath, "lib")
   if (file.exists(libDir)) {
      owd <- setwd(libDir)
      libFiles <- list.files(libDir, recursive = TRUE)
      libData <- lapply(libFiles, .rs.readFile, encoding = "UTF-8")
      names(libData) <- libFiles
      rnbData[["lib"]] <- libData
      setwd(owd)
   }
   
   rnbData
})

.rs.addFunction("extractHTMLBodyElement", function(html)
{
   begin <- regexpr('<body[^>]*>', html, perl = TRUE)
   end   <- regexpr('</body>', html, perl = TRUE)
   
   contents <- substring(html, begin + attr(begin, "match.length"), end - 1)
   .rs.trimWhitespace(contents)
})

.rs.addFunction("rnb.resolveActiveChunkId", function(rnbData, label)
{
   chunkDefns <- rnbData$chunk_info$chunk_definitions
   for (defn in chunkDefns) {
      if (identical(defn$chunk_label, label))
         return(defn$chunk_id)
   }
   return(NULL)
})

.rs.addFunction("rnb.engineToCodeClass", function(engine)
{
   engine <- tolower(engine)
   switch(engine,
      rcpp = "cpp",
      sh = "bash",
      engine)
})

.rs.addFunction("rnb.outputSourcePng", function(fileName,
                                                fileContents,
                                                metadata,
                                                ...)
{
   rmarkdown:::html_notebook_output_png(bytes = fileContents,
                                        meta = metadata)
})

.rs.addFunction("rnb.outputSourceJpeg", function(fileName,
                                                 fileContents,
                                                 metadata,
                                                 ...)
{
   rmarkdown:::html_notebook_output_img(bytes = fileContents,
                                        meta = metadata,
                                        format = "jpeg")
})

.rs.addFunction("rnb.outputSourceConsole", function(fileName,
                                                    fileContents,
                                                    context,
                                                    includeSource,
                                                    ...)
{
   Encoding(fileContents) <- "UTF-8"
   parsed <- .rs.rnb.readConsoleData(fileContents)
   
   # exclude source code if requested
   if (!includeSource)
      parsed <- parsed[parsed$type != 0, ]
   
   # exclude console output if requested
   if (identical(context$results, "hide"))
      parsed <- parsed[parsed$type != 1, ]
   
   attributes <- list(class = .rs.rnb.engineToCodeClass(context$engine))
   rendered <- .rs.rnb.renderConsoleData(parsed,
                                         attributes = attributes,
                                         context)
   return(rendered)
})

.rs.addFunction("rnb.outputSourceHtml", function(fileName,
                                                 fileContents,
                                                 rnbData,
                                                 chunkId,
                                                 metadata,
                                                 ...)
{
   # if we have a '.json' sidecar file, this is an HTML widget
   jsonName <- .rs.withChangedExtension(fileName, ".json")
   jsonPath <- file.path(rnbData$cache_path, chunkId, jsonName)
   if (file.exists(jsonPath)) {
      
      # read and restore 'html_dependency' class (this may not be
      # preserved in the serialized JSON file)
      jsonContents <- .rs.fromJSON(.rs.readFile(jsonPath, encoding = "UTF-8"))
      for (i in seq_along(jsonContents))
         class(jsonContents[[i]]) <- "html_dependency"
      
      # extract body element (this is effectively what the
      # widget emitted on print in addition to aforementioned
      # dependency information)
      bodyEl <- .rs.extractHTMLBodyElement(fileContents)
      
      # annotate widget manually and return asis output
      annotated <- rmarkdown:::html_notebook_annotated_output(
         bodyEl,
         "htmlwidget",
         list(dependencies = jsonContents,
              metadata     = metadata)
      )
      preserved <- htmltools::htmlPreserve(annotated)
      widget <- knitr::asis_output(preserved)
      attr(widget, "knit_meta") <- jsonContents
      return(widget)
   }
   
   # no .json file; just return HTML as-is
   annotated <- rmarkdown:::html_notebook_annotated_output(
      fileContents,
      "html",
      list(metadata = metadata)
   )
   preserved <- htmltools::htmlPreserve(annotated)
   knitr::asis_output(preserved)
})

.rs.addFunction("rnb.pagedTableHtml", function(rdfPath)
{
   data <- .rs.readDataCapture(rdfPath)
   
   paste(
      "<div data-pagedtable=\"false\">",
      "  <script data-pagedtable-source type=\"application/json\">",
      jsonlite::toJSON(data),
      "  </script>",
      "</div>",
      sep = "\n"
   )
})

.rs.addFunction("rnb.outputSourceRdf", function(fileName,
                                                fileContents,
                                                metadata,
                                                rnbData,
                                                chunkId,
                                                ...)
{
   rdfName <- .rs.withChangedExtension(fileName, ".rdf")
   rdfPath <- file.path(rnbData$cache_path, chunkId, rdfName)
   
   annotated <- rmarkdown:::html_notebook_annotated_output(
      .rs.rnb.pagedTableHtml(rdfPath),
      "frame",
      list(metadata = metadata, rdf = .rs.base64encode(fileContents))
   )
   
   knitr::asis_output(annotated)
})

.rs.addFunction("rnb.outputSource", function(rnbData) {
   force(rnbData)
   
   # define output source
   result <- function(code, context, ...) {
      
      # resolve chunk id (attempt to match labels)
      chunkId <- .rs.rnb.resolveActiveChunkId(rnbData, context$label)
      
      # determine whether we include source code (respect chunk options)
      includeSource <- isTRUE(context$echo) && isTRUE(context$include)
      
      if (identical(context$engine, "js") || identical(context$engine, "css")) {
         # these engines never show code; ensure they're marked for evaluation
         # and then emit contents literally wrapped in the appropriate tags
         htmlOutput <- ""
         if (isTRUE(context$eval)) {
            if (identical(context$engine, "js")) {
               htmlOutput <- paste(
                  c('<script type="text/javascript">', code, '</script>'),
                    collapse = '\n')
            } else if (identical(context$engine, "css")) {
               htmlOutput <- paste(
                  c('<style type="text/css">', code, '</style>'),
                    collapse = '\n')
            }
         }
         return(knitr::asis_output(htmlOutput))
      } else if (is.null(chunkId)) {
         # if we have no chunk outputs, just show source code (respecting
         # chunk options as appropriate)
         if (includeSource) {
            attributes <- list(class = .rs.rnb.engineToCodeClass(context$engine))
            
            # tidy code if necessary
            if (isTRUE(context$tidy)) {
               args <- c(list(text = code, output = FALSE), context$tidy.opts)
               formatted <- do.call(formatR::tidy_source, args)
               code <- formatted$text.tidy
            }
            
            if (!is.null(context$indent)) {
               return(.rs.rnb.renderVerbatimConsoleInput(code, tolower(context$engine), ""))
            } else {
               return(rmarkdown::html_notebook_output_code(code, attributes = attributes))
            }
         }
         return(knitr::asis_output(""))
      }
      
      chunkData <- .rs.coalesceCsvOutput(rnbData$chunk_data[[chunkId]])
      
      # map file extensions to handlers
      outputHandlers <- list(
         "png"  = .rs.rnb.outputSourcePng,
         "jpg"  = .rs.rnb.outputSourceJpeg,
         "jpeg" = .rs.rnb.outputSourceJpeg,
         "csv"  = .rs.rnb.outputSourceConsole,
         "html" = .rs.rnb.outputSourceHtml,
         "rdf"  = .rs.rnb.outputSourceRdf
      )

      outputList <- .rs.enumerate(chunkData, function(fileName, fileContents) {
         
         # read metadata sidecar if present
         metadata <- NULL
         metadataName <- .rs.withChangedExtension(fileName, ".metadata")
         metadataPath <- file.path(rnbData$cache_path, chunkId, metadataName)
         if (file.exists(metadataPath))
            metadata <- .rs.fromJSON(.rs.readFile(metadataPath, encoding = "UTF-8"))
         
         # find and execute handler for extension (return NULL if no handler defined)
         ext <- tools::file_ext(fileName)
         handler <- outputHandlers[[ext]]
         if (!is.function(handler))
            return(NULL)
         
         handler(code = code,
                 context = context,
                 fileName = fileName,
                 fileContents = fileContents,
                 metadata = metadata,
                 rnbData = rnbData,
                 chunkId = chunkId,
                 includeSource = includeSource)
      })
      
      # remove nulls
      filtered <- Filter(Negate(is.null), outputList)
      lapply(filtered, function(x) {
         if (!is.list(x)) list(x) else x
      })
   }
   
   # attach a pre_knit handler that injects setup chunk options
   attr(result, "pre_knit") <- function() {
      
      # extract setup chunk options
      options <- rnbData$chunk_info$default_chunk_options
      if (is.null(options))
         return()
      
      # fix up case where 'fig.dim' is a list
      options[["fig.dim"]] <- as.numeric(options[["fig.dim"]])
      
      # set those options
      knitr::opts_chunk$set(options)
      
      # return invisibly
      invisible(NULL)
   }
   
   # return output source
   result
})

.rs.addFunction("createNotebookFromCacheData", function(rnbData,
                                                        inputFile,
                                                        outputFile = NULL,
                                                        envir = .GlobalEnv)
{
   if (is.null(outputFile))
      outputFile <- .rs.withChangedExtension(inputFile, ext = ".nb.html")

   # specify default encoding (we'll try to infer + convert to UTF-8
   # if necessary)
   encoding <- getOption("encoding")
   
   # attempt to get encoding from source database (note: this will only
   # succeed for files already open in the IDE, but since this operation
   # is normally called when attempting to preview / create a notebook on
   # save we generally expect the document to be available)
   properties <- .rs.getSourceDocumentProperties(inputFile, FALSE)
   if (!is.null(properties$encoding))
      encoding <- properties$encoding
   
   # reset the knitr chunk counter (it can be modified as a side effect of
   # parse_params, which is called during notebook execution)
   knitr:::chunk_counter(reset = TRUE)

   # restore external chunks into the knit environment
   if (!is.null(rnbData$external_chunks)) 
      knitr:::knit_code$restore(rnbData$external_chunks)

   # set up output_source
   outputOptions <- list(output_source = .rs.rnb.outputSource(rnbData))
   
   # override knitr's 'eval_lang' and suppress evaluation of language /
   # symbol chunk options (necessary since we don't actually execute any
   # R code while evaluating chunks and so evaluation of such chunk options
   # could fail)
   if (exists("eval_lang", envir = asNamespace("knitr")))
   {
      override <- function(x, envir = knit_global()) {
         
         # white-list for the commonly-used 'T' and 'F' options
         if (identical(x, as.name("T")))
            return(TRUE)
         else if (identical(x, as.name("F")))
            return(FALSE)
         else if (is.language(x))
            return(NULL)
         else
            return(x)
         
      }
      
      original <- .rs.replaceBinding("eval_lang", "knitr", override)
      on.exit(.rs.replaceBinding("eval_lang", "knitr", original), add = TRUE)
   }

   # knitr outputs relevant information in the form of messages that we attach to the error
   renderMessages <- list()
   tryCatch({
      withCallingHandlers({
         # call render with special format hooks
         rmarkdown::render(input = inputFile,
                           output_format = "html_notebook",
                           output_options = outputOptions,
                           output_file = outputFile,
                           quiet = TRUE,
                           envir = envir,
                           encoding = encoding)
      }, message = function(...) {
         args <- list(...)
         renderMessages <<- c(renderMessages, args[[1]])
      })
   }, error = function(e) {
      messages <- list(e$message)

      lapply(renderMessages, function(m) {
        if (typeof(m) != "character") return();

        result <- regexec("Quitting from lines ([0-9]+)-([0-9]+) ", text = m)
        if (result[[1]][[1]] < 0) return();

        groups <- regmatches(m, result)[[1]]
        messages <<- c(messages, paste("See line ", (strtoi(groups[[2]]) - 1), sep = ""))
      })

      stop(paste(messages, collpase = ". ", sep = ""))
   })
})

.rs.addFunction("createNotebookFromCache", function(rmdPath, outputPath = NULL)
{
   # presume success unless we fail below
   result <- list(succeeded = .rs.scalar(TRUE))

   tryCatch({
      cachePath <- .rs.rnb.cachePathFromRmdPath(rmdPath)
      rnbData <- .rs.readRnbCache(rmdPath, cachePath)
      .rs.createNotebookFromCacheData(rnbData, rmdPath, outputPath)
   }, 
   
   error = function(e) {
      # convert exception to error message for client
      result <<- list(
         succeeded = .rs.scalar(FALSE),
         error_message = .rs.scalar(e$message)
      )
   })
   
   result
})

.rs.addFunction("rnb.readConsoleData", function(encodedData)
{
   # read from CSV
   csvData <- read.csv(
      text = encodedData,
      encoding = "UTF-8",
      header = FALSE,
      stringsAsFactors = FALSE
   )
   
   names(csvData) <- c("type", "text")
   
   csvData
})

.rs.addFunction("rnb.renderVerbatimConsoleInput", function(code, engine, indent)
{
   Encoding(code) <- "UTF-8"
   
   if (length(code) == 1)
      code <- strsplit(code, "\n", fixed = TRUE)[[1]]
   
   # remove indentation from code
   code <- substring(code, nchar(indent) + 1)
   
   # print as block code (as knitr might normally do)
   fmt <- "```%s\n%s\n```"
   out <- sprintf(fmt, tolower(engine), paste(code, collapse = "\n"))
   knitr::asis_output(out)
})

.rs.addFunction("rnb.renderConsoleData", function(csvData,
                                                  attributes = list(class = "r"),
                                                  context = list())
{
   # bail early for empty data
   if (length(csvData) == 0 || nrow(csvData) == 0)
      return(list())
   
   # remove ANSI escapes used for color from text
   csvData$text <- gsub("\033\\[\\d*(?:;\\d*)*m", "", csvData$text)
   
   # split on type
   cutpoints <- .rs.cutpoints(csvData$type)
   
   ranges <- Map(
      function(start, end) list(start = start, end = end),
      c(1, cutpoints),
      c(cutpoints - 1, nrow(csvData))
   )
   
   splat <- lapply(ranges, function(range) {
      type <- csvData$type[[range$start]]
      text <- csvData$text[range$start:range$end]
      collapse <- if (type == 0) "\n" else ""
      code <- paste(text, collapse = collapse)
      
      if (type == 0) {
         
         # tidy code if necessary
         if (isTRUE(context$tidy)) {
            args <- c(list(text = code, output = FALSE), context$tidy.opts)
            formatted <- do.call(formatR::tidy_source, args)
            code <- paste(formatted$text.tidy, collapse = "\n")
         }
         
         if (is.null(context$indent)) {
            return(rmarkdown::html_notebook_output_code(code, attributes = attributes))
         } else {
            return(.rs.rnb.renderVerbatimConsoleInput(code, tolower(context$engine), context$indent))
         }
      } else {
         return(code)
      }
   })
   
   splat
})

.rs.addFunction("scrapeHtmlAttributes", function(line)
{
   reData <- '([[:alnum:]_-]+)[[:space:]]*=[[:space:]]*"(\\\\.|[^"])+"'
   reMatches <- gregexpr(reData, line)[[1]]
   starts <- c(reMatches)
   ends   <- starts + attr(reMatches, "match.length") - 1
   stripped <- substring(line, starts, ends)
   equalsIndex <- regexpr("=", stripped, fixed = TRUE)
   lhs <- substring(stripped, 1, equalsIndex - 1)
   rhs <- substring(stripped, equalsIndex + 2, nchar(stripped) - 1)
   names(rhs) <- lhs
   as.list(rhs)
})

.rs.addFunction("rnb.encode", function(data)
{
   .rs.base64encode(.rs.toJSON(data, unbox = TRUE))
})

.rs.addFunction("rnb.decode", function(encoded)
{
   .rs.fromJSON(.rs.base64decode(encoded))
})

.rs.addFunction("evaluateChunkOptions", function(code)
{
  opts <- list()

  Encoding(code) <- "UTF-8"
  # if several lines of code are passed, operate only on the first 
  code <- unlist(strsplit(code, "\n", fixed = TRUE))[[1]]

  # strip chunk indicators if present
  matches <- unlist(regmatches(code, regexec(.rs.reRmdChunkBegin(), code)))
  if (length(matches) > 1)
    code <- matches[[2]]

  tryCatch({
    # if this is the setup chunk, it's not included by default
    setupIndicator <- "r setup"
    if (identical(substring(code, 1, nchar(setupIndicator)), 
                  setupIndicator)) {
      opts$include <- FALSE
    }

    # extract and remove engine name (can be overridden below with engine=)
    opts$engine <- unlist(strsplit(code, split = "(\\s|,)+"))[[1]]
    code <- substring(code, nchar(opts$engine) + 1)

    # parse them, then merge with the defaults (evaluate in global environment)
    opts <- .rs.mergeLists(opts,
                           eval(substitute(knitr:::parse_params(code)),
                                envir = .GlobalEnv))
    
    # convert T, F to TRUE, FALSE as appropriate
    opts <- lapply(opts, function(opt) {
      if (identical(opt, as.name("T")))
        TRUE
      else if (identical(opt, as.name("F")))
        FALSE
      else
        opt
    })

    # convert language name objects to plain characters (these can occur in
    # malformed expressions, and cause scalar conversion below to fail)
    names <- vapply(opts, is.name, TRUE)
    opts[names] <- as.character(opts[names])
    
    # ensure that fields we expect to be logical are actually logical
    # (sanitize invalid inputs here since they can break notebook execution)
    fields <- list(
      warning = TRUE,
      message = TRUE,
      error   = FALSE
    )
    
    .rs.enumerate(fields, function(key, default) {
       
      if (is.null(opts[[key]]))
        next
       
      opts[[key]] <<- tryCatch(
        as.logical(opts[[key]]),
        error = function(e) default
      )
       
    })
    
  },
  error = function(e) {})

  .rs.scalarListFromList(opts, expressions = TRUE)
})

.rs.addFunction("extractChunkInnerCode", function(code)
{
  # split into lines
  Encoding(code) <- "UTF-8"   
  code <- unlist(strsplit(code, "\n", fixed = TRUE))
  
  # find chunk indicators (safe fallbacks if absent)
  start <- max(1, grep(.rs.reRmdChunkBegin(), code, perl = TRUE))
  end   <- min(length(code), grep(.rs.reRmdChunkEnd(), code, perl = TRUE))

  paste(code[(start + 1):(end - 1)], collapse = "\n")
});

.rs.addFunction("extractRmdChunkInformation", function(rmd)
{
   starts <- grep(.rs.reRmdChunkBegin(), rmd, perl = TRUE)
   ends   <- grep(.rs.reRmdChunkEnd(), rmd, perl = TRUE)
   
   # TODO: how to handle invalid document?
   n <- min(length(starts), length(ends))
   if (length(starts) != n) starts <- starts[seq_len(n)]
   if (length(ends) != n)   ends <- ends[seq_len(n)]
   
   # collect chunk information
   lapply(seq_len(n), function(i) {
      begin    <- starts[[i]]
      end      <- ends[[i]]
      contents <- rmd[begin:end]
      list(
         begin    = starts[[i]],
         end      = ends[[i]],
         contents = contents
      )
   })
})

.rs.addFunction("rnb.generateRandomChunkId", function()
{
   candidates <- c(letters, 0:9)
   .rs.randomString("c", candidates = candidates, n = 12L)
})

.rs.addFunction("hydrateCacheFromNotebook", function(nbPath, cachePath = NULL)
{
   if (is.null(cachePath)) {
      rmdPath <- .rs.withChangedExtension(nbPath, ".Rmd")
      cachePath <- .rs.rnb.cachePathFromRmdPath(rmdPath)
   }

   # ensure cache directory
   if (!.rs.dirExists(cachePath))
      dir.create(cachePath, recursive = TRUE)
   
   # parse the notebook file
   nbData <- rmarkdown::parse_html_notebook(nbPath)
   
   # clear out old cache
   unlink(list.files(cachePath, full.names = TRUE), recursive = TRUE)
   
   # State, etc. ----
   lastActiveAnnotation   <- list()
   activeChunkId          <- "unknown"
   activeChunkIndex       <- 0
   activeIndex            <- 2
   
   headerContent <- nbData$source[`:`(
      grep("^\\s*<head>\\s*$", nbData$source, perl = TRUE)[[1]] + 1,
      grep("^\\s*</head>\\s*$", nbData$source, perl = TRUE)[[1]] - 1
   )]
   
   chunkInfo <- .rs.extractRmdChunkInformation(nbData$rmd)
   
   outputPath <- function(cachePath, chunkId, index, ext) {
      file.path(cachePath, chunkId, sprintf("%06i.%s", as.integer(index), ext))
   }
   
   # Text ----
   onText <- function(annotation) {
      # HACK: the 'chunk' hook is not fired for chunks that
      # produce no output on execution, and so such chunks
      # are not annotated within the generated .nb.html file.
      # fortunately, we can detect two sequential 'text'
      # blocks as an indicator that there was an 'invisible'
      # chunk within.
      if (identical(annotation$state, "begin") &&
          identical(lastActiveAnnotation$label, "text") &&
          identical(lastActiveAnnotation$state, "end"))
      {
         activeChunkId    <<- .rs.rnb.generateRandomChunkId()
         activeChunkIndex <<- activeChunkIndex + 1
         activeIndex      <<- 2
      }
   }
   
   # Console I/O ----
   consoleDataBuilder <- .rs.listBuilder()
   writeConsoleData <- function(builder) {
      if (builder$empty()) return()
      
      # convert to .csv file
      df <- .rs.rbindList(builder$data())
      
      # reorder and rename type column
      df <- df[c("type", "data")]
      df$type[df$type == "input"]  <- "0"
      df$type[df$type == "output"] <- "1"
      
      path <- outputPath(cachePath, activeChunkId, activeIndex, "csv")
      .rs.ensureDirectory(dirname(path))
      write.table(df,
                  file = path,
                  quote = TRUE,
                  sep = ",",
                  row.names = FALSE,
                  col.names = FALSE,
                  fileEncoding = "UTF-8")
      
      # update state
      builder$clear()
      activeIndex <<- activeIndex + 1
   }
   
   onSource <- function(annotation) {
      if (annotation$state == "begin") {
         consoleDataBuilder$append(list(
            data = paste(annotation$meta$data, collapse = "\n"),
            type = "input"
         ))
      } else {
         # nothing to do?
      }
   }
   
   onOutput <- function(annotation) {
      if (annotation$state == "begin") {
         consoleDataBuilder$append(list(
            data = paste(annotation$meta$data, collapse = "\n"),
            type = "output"
         ))
      } else {
         # nothing to do?
      }
   }
   
   # Chunk Handling ----
   chunkDefnsBuilder <- .rs.listBuilder()
   onChunk <- function(annotation) {
      if (annotation$state == "begin") {
         
         # update state re: active chunk + number of processed outputs
         activeChunkIndex <<- activeChunkIndex + 1
         activeIndex      <<- 2
         
         # create chunk defn for this chunk
         info <- chunkInfo[[activeChunkIndex]]
         
         # get active chunk id (special handling for setup chunk)
         candidates <- c(letters, 0:9)
         if (.rs.isSetupChunk(info$contents))
            activeChunkId <<- "csetup_chunk"
         else
            activeChunkId <<- .rs.rnb.generateRandomChunkId()
         
         # add our chunk defn
         chunkDefnsBuilder$append(list(
            chunk_id = activeChunkId,
            expansion_state = 0,
            options = list(),         # TODO: parse from chunk header?
            row = info$end - 1,
            row_count = 1,            # TODO: ever not 1?
            visible = TRUE
         ))
         
      } else {
         # flush console data
         writeConsoleData(consoleDataBuilder)
         
         # leaving active chunk
         activeChunkId <<- "unknown"
      }
   }
   
   # Plot Handling ----
   plotRange <- list(start = NULL, end = NULL)
   plotMeta <- NULL
   writePlot <- function(source, range, meta) {
      
      # get html plot output
      html <- paste(source[`:`(
         range$start + 1,
         range$end - 1
      )], collapse = " ")
      
      # extract base64 encoded content
      scraped <- .rs.scrapeHtmlAttributes(html)
      ext <- if (.rs.startsWith(scraped$src, "data:image/jpeg;"))
                 "jpeg" else "png"
      imgDataEncoded <- substring(scraped$src, 
         nchar(paste("data:image/", ext, ";base64,", sep = "")) + 1)
      imgData <- .rs.base64decode(imgDataEncoded, binary = TRUE)
      
      # write to file
      path <- outputPath(cachePath, activeChunkId, activeIndex, ext)
      .rs.ensureDirectory(dirname(path))
      writeBin(imgData, path, useBytes = TRUE)
      
      # write metadata if present
      if (!is.null(meta) && !is.null(meta$metadata)) {
        metaPath <- outputPath(cachePath, activeChunkId, activeIndex, "metadata")
        cat(.rs.toJSON(meta, unbox = TRUE), file = metaPath, sep = "\n")
      }

      # update state
      activeIndex <<- activeIndex + 1
   }
   onPlot <- function(annotation) {
      if (annotation$state == "begin") {
         writeConsoleData(consoleDataBuilder)
         plotRange$start <<- annotation$row
         plotMeta        <<- annotation$meta
      } else {
         plotRange$end <<- annotation$row
         writePlot(nbData$source, plotRange, plotMeta)
         plotRange <<- list(start = NULL, end = NULL)
         plotMeta  <<- NULL
      }
   }

   # Data frame handling ----
   frameRange <- list(start = NULL, end = NULL)
   frameMeta <- NULL
   writeFrame <- function(source, range, meta) {
      if (is.null(meta))
        return(NULL);

      # write out frame metadata
      if (!is.null(meta$metadata)) {
        metaPath <- outputPath(cachePath, activeChunkId, activeIndex, "metadata")
        cat(.rs.toJSON(meta$metadata, unbox = TRUE), file = metaPath, sep = "\n")
      }

      # write out raw frame data
      if (!is.null(meta$rdf)) {
        rdfPath <- outputPath(cachePath, activeChunkId, activeIndex, "rdf")
        writeBin(object = .rs.base64decode(meta$rdf, binary = TRUE), 
                 con = rdfPath)
      }
   }
   onFrame <- function(annotation) {
      if (annotation$state == "begin") {
         writeConsoleData(consoleDataBuilder)
         frameRange$start <<- annotation$row
         frameMeta        <<- annotation$meta
      } else {
         frameRange$end <<- annotation$row
         writeFrame(nbData$source, frameRange, frameMeta)
         frameRange <<- list(start = NULL, end = NULL)
         frameMeta  <<- NULL
      }
   }
   
   # HTML Handling ----
   htmlRange <- list(start = NULL, end = NULL)
   htmlMeta <- NULL
   writeHtml <- function(source, range, meta) {
      
      # extract html from source document
      htmlOutput <- source[`:`(
         range$start + 1,
         range$end - 1
      )]
      
      htmlPath <- outputPath(cachePath, activeChunkId, activeIndex, "html")
      cat(htmlOutput, file = htmlPath, sep = "\n")

      # write metadata if present
      if (!is.null(meta) && !is.null(meta$metadata)) {
        metaPath <- outputPath(cachePath, activeChunkId, activeIndex, "metadata")
        cat(.rs.toJSON(meta, unbox = TRUE), file = metaPath, sep = "\n")
      }

      # update state
      activeIndex <<- activeIndex + 1
   }
   onHtml <- function(annotation) {
      if (annotation$state == "begin") {
         writeConsoleData(consoleDataBuilder)
         htmlRange$start <<- annotation$row
         htmlMeta        <<- annotation$meta
      } else {
         htmlRange$end   <<- annotation$row
         writeHtml(nbData$source, htmlRange, htmlMeta)
         htmlRange <<- list(start = NULL, end = NULL)
         htmlMeta  <<- NULL
      }
   }
   
   # HTML Widget Handling ----
   widgetRange <- list(start = NULL, end = NULL)
   widgetMeta  <- NULL
   writeHtmlWidget <- function(source, range, meta) {
      
      # get inner (body) HTML
      htmlBody <- source[`:`(
         range$start + 1,
         range$end - 1
      )]
      
      # TODO: background color should be passed as
      # metadata attribute and used here
      fmt <- paste(
         '<!DOCTYPE html>',
         '<html>',
         '<head>',
         '%s',
         '</head>',
         '<body style="background-color:white;">',
         '%s',
         '</body>',
         '</html>',
         sep = "\n"
      )
      
      htmlOutput <- sprintf(fmt,
                            paste(headerContent, collapse = "\n"),
                            paste(htmlBody, collapse = "\n"))
      
      htmlPath <- outputPath(cachePath, activeChunkId, activeIndex, "html")
      cat(htmlOutput, file = htmlPath, sep = "\n")
      
      jsonPath <- outputPath(cachePath, activeChunkId, activeIndex, "json")
      cat(.rs.toJSON(meta, unbox = TRUE), file = jsonPath, sep = "\n")
      
      # update state
      activeIndex <<- activeIndex + 1
   }
   onHtmlWidget <- function(annotation) {
      if (annotation$state == "begin") {
         writeConsoleData(consoleDataBuilder)
         widgetRange$start <<- annotation$row
         widgetMeta        <<- annotation$meta
      } else {
         widgetRange$end <- annotation$row
         writeHtmlWidget(nbData$source, widgetRange, widgetMeta)
         widgetRange <<- list(start = NULL, end = NULL)
         widgetMeta  <<- NULL
      }
   }
   
   # begin looping through annotations and building cache
   annotations <- nbData$annotations
   for (i in seq_along(annotations)) {
      
      annotation <- annotations[[i]]
      label <- annotation$label
      
      switch(label,
             "text"       = onText(annotation),
             "chunk"      = onChunk(annotation),
             "source"     = onSource(annotation),
             "output"     = onOutput(annotation),
             "plot"       = onPlot(annotation),
             "html"       = onHtml(annotation),
             "frame"      = onFrame(annotation),
             "htmlwidget" = onHtmlWidget(annotation))
      
      lastActiveAnnotation <- annotation
   }
   
   # write 'chunks.json' based on gathered chunk info
   mtime <- file.info(nbPath)$mtime
   chunks <- list(
      chunk_definitions = chunkDefnsBuilder$data(),
      doc_write_time    = as.numeric(mtime)
   )
   chunksJson <- .rs.toJSON(chunks, unbox = TRUE)
   chunksJsonPath <- file.path(cachePath, "chunks.json")
   cat(chunksJson, file = chunksJsonPath, sep = "\n")
   
   # NOTE: we don't bother writing a libs folder as we'll just dump
   # the base64 encoded headers into all HTML widget elements
   
})

.rs.addFunction("isSetupChunk", function(lines)
{
   if (!is.character(lines) || !length(lines))
      return(FALSE)
   
   grepl("^\\s*```{[Rr]\\s+setup[\\s,}]", lines[[1]], perl = TRUE)
})

.rs.addFunction("setDefaultChunkOptions", function()
{
   # get the current set of chunk options
   chunkOptions <- knitr::opts_chunk$get()

   # make sure global connection lists exists
   if (!exists(".rs.knitr.chunkReferences", envir = .rs.toolsEnv()))
      assign(".rs.knitr.chunkReferences", list(), envir = .rs.toolsEnv())
   
   # assign connection
   chunkReferences <- get(".rs.knitr.chunkReferences", envir = .rs.toolsEnv())
   if (!is.null(chunkOptions$connection) && !is.character(chunkOptions$connection)) {
      idReference <- length(chunkReferences) + 1
      chunkReferences[[idReference]] <- chunkOptions$connection
      chunkOptions$connection <- idReference
   }

   # cache the current set of chunk options
   assign(".rs.knitr.chunkOptions", chunkOptions, envir = .rs.toolsEnv())

   # cache the set of external code
   knitrCode <- knitr:::knit_code$get()
   assign(".rs.knitr.code", knitrCode, envir = .rs.toolsEnv())

   # cache default working dir
   knitrDir <- knitr::opts_knit$get("root.dir")
   assign(".rs.knitr.root.dir", knitrDir, envir = .rs.toolsEnv())
   
   # unset the chunk options and code (so we know what options/code
   # were actually specified in setup chunk later)
   # (we tag the 'FALSE' value so we can detect if the user has explicitly
   # set or unset it in the setup chunk as well)
   defaults <- list(error = .rs.scalar(FALSE))
   knitr::opts_chunk$restore(defaults)
   knitr:::knit_code$restore(list())
   knitr::opts_knit$set(root.dir = NULL)
})

.rs.addFunction("defaultChunkOptions", function()
{
   # get current set of options
   defaultOptions <- knitr::opts_chunk$get()
   
   # remove the rstudio-injected 'error' option if needed
   if (identical(defaultOptions$error, .rs.scalar(FALSE)))
      defaultOptions$error <- NULL
   
   # restore the previously cached knitr options and code
   chunkOptions <- get(".rs.knitr.chunkOptions", envir = .rs.toolsEnv())
   knitr::opts_chunk$restore(chunkOptions)
   knitrCode <- get(".rs.knitr.code", envir = .rs.toolsEnv())
   knitr:::knit_code$restore(knitrCode)
   knitrDir <- get(".rs.knitr.root.dir", envir = .rs.toolsEnv())
   knitr::opts_knit$set(root.dir = knitrDir)
   
   # overlay any newly-set chunk options set by the user in this chunk.
   # this is necessary so that settings from e.g.
   #
   #    knitr::opts_chunk$set(connection = conn)
   #
   # are appropriately preserved after running the setup chunk
   knitr::opts_chunk$set(defaultOptions)
   
   # return current set
   .rs.scalarListFromList(defaultOptions)
})

#
# SourceWithProgress.R
#
# Copyright (C) 2009-18 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

emitProgress <- function(kind, arg, con) {
   if (!is.null(con)) {
      cat(paste0("__rs_progress_0__ ", kind, " __ ", arg, 
                 " __rs_progress_1__\n"), file = con)
   }
}

sourceWithProgress <- function(script,               # path to R script
                               encoding = "unknown", # character encoding of script
                               con = NULL,           # connection to write progress
                               importRdata = NULL,   # RData file to import on start 
                               exportRdata = NULL    # RData file to export when done
                               ) {
   # create a new enviroment to host any values created; make its parent the global env so any
   # variables inside this function's environment aren't visible to the script
   sourceEnv <- new.env(parent = globalenv())

   # parse the script
   statements <- parse(file = script, keep.source = TRUE, encoding = encoding)
   units <- length(statements)
   unit <- 0

   # add extra steps for importing/exporting
   if (!is.null(importRdata))
      units <- units + 1
   if (!is.null(exportRdata))
      units <- units + 1

   # notify host process of 
   emitProgress("count", units, con)

   if (!is.null(importRdata)) {
      # indicate that we're importing the requested env
      emitProgress("section", "Importing environment", con)
      load(importRdata, envir = globalenv())

      # clear progress text and advance marker
      unit <- unit + 1
      emitProgress("section", "", con)
      emitProgress("statement", unit, con)
   }

   # find the sections
   lines <- readLines(con = script, encoding = encoding, warn = FALSE)
   sections <- regmatches(lines, regexec("^\\s*#+ (.+) -----*$", lines))
   sectLines <- which(sapply(sections, length) > 0)

   # evaluate each statement
   for (idx in seq_along(statements)) {
      # check to see if this is the first statement in a section
      ref <- attr(statements[idx], "srcref", exact = TRUE)
      if (!is.null(ref)) {
         line <- ref[[1]][[1]]

         # look for sections that begin above this line
         candidates <- which(sectLines <= line)

         if (length(candidates) > 0) {
            # find line on which section starts
            line <- sectLines[[length(candidates)]]

            # emit indicator that we've started this section
            emitProgress("section", sections[[line]][[2]], con)

            # remove this from the set of sections so we don't emit again
            sectLines <- sectLines[sectLines != line]
         }
      }
      
      # evaluate the statement
      eval(statements[[idx]], envir = sourceEnv)

      # update progress; statement is complete
      unit <- unit + 1
      emitProgress("statement", unit, con)
   }

   if (!is.null(exportRdata))
   {
      # export any created values
      emitProgress("section", "Exporting environment", con)
      save(list = ls(envir = sourceEnv, all.names = TRUE), 
           file = exportRdata, 
           envir = sourceEnv)

      # update progress
      unit <- unit + 1
      emitProgress("statement", unit, con)
   }

   emitProgress("completed", 1, con)
}

#
# SessionOverlay.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("invokeServerRpc", function(method, ...)
{
   # callback to session to invoke server RPC
   args <- list(...)
   .Call("rs_invokeServerRpc", method, .rs.scalarListFromList(args), PACKAGE="(embedding)")
})

#
# SessionEnvironment.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("is_function_masked", function(functionName,
                                                     packageName)
{
   result <- tryCatch(
      .rs.isFunctionMasked(functionName, packageName),
      error = function(e) FALSE
   )
   
   .rs.scalar(result)
})

.rs.addFunction("isFunctionMasked", function(functionName,
                                             packageName)
{
   globalValue  <- get(
      x = functionName,
      envir = globalenv(),
      mode = "function"
   )
   
   packageValue <- get(
      x = functionName,
      envir = asNamespace(packageName),
      mode = "function"
   )
   
   !identical(globalValue, packageValue)
})

.rs.addFunction("valueFromStr", function(val)
{
   .rs.withTimeLimit(1, fail = "<truncated>", {
      capture.output(try(str(val), silent = TRUE))
   })
   
})

.rs.addFunction("valueAsString", function(val)
{
   tryCatch(
      .rs.valueAsStringImpl(val),
      error = function(e) "NO_VALUE"
   )
})

.rs.addFunction("valueAsStringImpl", function(val)
{
   if (missing(val))
   {
      "<missing>"
   }
   else if (is.null(val))
   {
      "NULL"
   }
   else if (is.character(val) && !is.object(val))
   {
      # for plain character variables, we 'mock' the behavior of str()
      # while avoiding the potential for re-encoding (as this could mangle
      # UTF-8 characters on Windows)
      n <- length(val)
      if (n == 0)
      {
         "character (empty)"
      }
      else if (n == 1)
      {
         encodeString(val, quote = "\"", na.encode = FALSE)
      }
      else
      {
         encoded <- encodeString(
            head(val, n = 128L),
            quote = "\"",
            na.encode = FALSE
         )
         
         fmt <- "chr [1:%i] %s"
         txt <- sprintf(fmt, n, paste(encoded, collapse = " "))
         .rs.truncate(txt)
      }
   }
   else if (is.raw(val))
   {
      if (length(val) == 0)
      {
         "raw (empty)"
      }
      else
      {
         .rs.valueFromStr(val)
      }
   }
   else if (is.atomic(val) && is.null(attributes(val)))
   {
      n <- length(val)
      if (n == 0)
      {
         paste(.rs.getSingleClass(val), " (empty)")
      }
      else if (n == 1)
      {
         .rs.truncate(.rs.deparse(val), 1024L)
      }
      else
      {
         .rs.valueFromStr(val)
      }
   }
   else if (inherits(val, "python.builtin.object"))
   {
      .rs.valueFromStr(val)
   }
   else if (.rs.isFunction(val))
   {
      .rs.getSignature(val)
   }
   else if (inherits(val, c("Date", "POSIXct", "POSIXlt")))
   {
      if (length(val) == 1)
      {
         format(val, usetz = TRUE)
      }
      else
      {
         .rs.valueFromStr(val)
      }
   }
   else
   {
      "NO_VALUE"
   }
})

.rs.addFunction("valueContents", function(val)
{
   tryCatch(
      .rs.valueContentsImpl(val),
      error = function(e) "NO_VALUE"
   )
})

.rs.addFunction("valueContentsImpl", function(val)
{
   if (inherits(val, "ore.frame"))
   {
      # for Oracle R frames, show the query if it exists
      query <- attr(val, "dataQry", exact = TRUE)
      
      # no query, show empty
      if (is.null(query))
         return("NO_VALUE") 
      
      # query, display it
      attributes(query) <- NULL
      paste("   Query:", query)
   }
   else if (inherits(val, "pandas.core.frame.DataFrame"))
   {
      output <- reticulate::py_to_r(val$to_string(max_rows = 150L))
      strsplit(output, "\n", fixed = TRUE)[[1]]
   }
   else
   {
      output <- .rs.valueFromStr(val)
      
      n <- length(output)
      
      # only return the first 150 lines of detail (generally columns)--any more
      # won't be very presentable in the environment pane. the first line
      # generally contains descriptive text, so don't return that.
      if (n > 150)
      {
         fmt <- "  [... %i lines omitted]"
         tail <- sprintf(fmt, n - 150)
         output <- c(output[2:150], tail)
      }
      else if (n > 1)
      {
        output <- output[-1]
      }
      
      output
   }
})

.rs.addFunction("isFunction", function(val)
{
   is.function(val) || identical(.rs.getSingleClass(val), "C++Function")
})

# used to create description for promises
.rs.addFunction("promiseDescription", function(obj)
{
   # NOTE: substitute() returns the expression associated with a promise,
   # without forcing it to be evaluated
   expr <- substitute(obj)
   
   # if this appears to be a call to 'lazyLoadDBfetch()', that implies
   # this is lazy-loaded data (typically associated with an R package).
   # handle those up front
   isLazyLoad <-
      is.call(expr) &&
      is.name(expr[[1L]]) &&
      identical(expr[[1L]], as.name("lazyLoadDBfetch"))
   
   if (isLazyLoad)
      return("<Promise>")
   
   # for some calls, e.g. those formed manually or those evaluated via
   # do.call(), the 'expression' here might just be an already-evaluated
   # R object. in such a case, we want to avoid deparsing the object as
   # it could be expensive (especially for large objects).
   if (!is.call(expr))
      return(.rs.valueDescription(expr))
   
   # we have a call; try to deparse it
   .rs.describeCall(expr)
})

# used to create descriptions for language objects and symbols
.rs.addFunction("languageDescription", function(env, objectName)
{
   desc <- "Missing object"
   tryCatch(
   {
      desc <- capture.output(print(get(objectName, env)))
   },
   error = function(e)
   {
      # silently ignore; if the object can't be retrieved from the
      # environment, treat it as missing
   },
   finally =
   {
      return(desc)
   })
})

.rs.addFunction("sourceFileFromRef", function(srcref)
{
   if (!is.null(srcref))
   {
      fileattr <- attr(srcref, "srcfile")
      enc2utf8(fileattr$filename)
   }
   else
      ""
})

# Given a function and some content inside that function, returns a vector
# in the standard R source reference format that represents the location of
# the content in the deparsed representation of the function.
.rs.addFunction("simulateSourceRefs", function(var)
{
  # Read arguments from attached attributes to the input (these can't be passed
  # naked from RStudio)
  fun <-  attr(var, "_rs_callfun")
  call <- attr(var, "_rs_callobj")
  calltext <- attr(var, "_rs_calltext")
  linepref <- attr(var, "_rs_lastline")

  # To proceed, we need the function to look in, and either the raw call
  # object (which we will deparse later) or the text to look for.
  if (is.null(fun) || 
      (is.null(call) && is.null(calltext)) )
     return(c(0L, 0L, 0L, 0L, 0L, 0L))

  lines <- .rs.deparseFunction(fun, FALSE, FALSE)

  # Remember the indentation level on each line (added by deparse), and remove
  # it along with any other leading or trailing whitespace. 
  indents <- nchar(sub("\\S.*", "", lines))
  slines <- sub("\\s+$", "", sub("^\\s+", "", lines))

  # Compute the character position of the start of each line, and collapse the
  # lines to a character vector of length 1. 
  nchars <- 0
  offsets <- integer(length(slines))
  for (i in 1:length(slines)) {
    nchars <- nchars + nchar(slines[i]) + 1
    offsets[i] <- nchars
  }
  
  singleline <- paste(slines, collapse = " ")
  
  if (is.null(calltext))
  {
     # No call text specified; deparse into a list of lines
     # limit length of deparsed output to avoid issues with very large calls
     # 
     # this implies that we might be unable to highlight calls larger than
     # the below number of lines, but in practice such a large highlight
     # would be unlikely to be useful
     # https://github.com/rstudio/rstudio/issues/5158
     calltext <- .rs.deparse(call, nlines = 200L)
  }
  else
  {
     # Call text specified as a single character vector; split into a list
     # of lines
     calltext <- unlist(strsplit(calltext, "\n", fixed = TRUE))
  }

  # Remove leading/trailing whitespace on each line, and collapse the lines
  calltext <- sub("\\s+$", "", sub("^\\s+", "", calltext))
  calltext <- paste(calltext, collapse = " ")

  # Any call text supplied is presumed UTF-8 unless we know otherwise
  if (Encoding(calltext) == "unknown")
     Encoding(calltext) <- "UTF-8"

  # NULL is output by R when it doesn't have an expression to output; don't
  # try to match it to code
  if (identical(calltext, "NULL")) 
     return(c(0L, 0L, 0L, 0L, 0L, 0L))

  pos <- gregexpr(calltext, singleline, fixed = TRUE)[[1]]
  if (length(pos) > 1)
  {
     # There is more than one instance of the call text in the function; try 
     # to pick the first match past the preferred line.
     best <- which(pos > offsets[linepref])
     if (length(best) == 0)
     {
        # No match past the preferred line, just pick the match closest
        best <- which.min(abs(linepref - pos))
     }
     else
        best <- best[1]
     endpos <- pos[best] + attr(pos, "match.length")[best]
     pos <- pos[best]
  }
  else
  {
     endpos <- pos + attr(pos, "match.length")
  }

  # Return an empty source ref if we couldn't find a match
  if (length(pos) == 0 || pos < 0)
     return(c(0L, 0L, 0L, 0L, 0L, 0L))

  # Compute the starting and ending lines
  firstline <- which(offsets >= pos, arr.ind = TRUE)[1]
  lastline <- which(offsets >= endpos, arr.ind = TRUE)[1]
  if (is.na(lastline))
     lastline <- length(offsets)

  # Compute the starting and ending character positions within the line, 
  # taking into account the indents we removed earlier. 
  firstchar <- pos - (if (firstline == 1) 0 else offsets[firstline - 1])
  firstchar <- firstchar + indents[firstline]

  # If the match is a block ({ ... }) and contains more than a few lines, 
  # match the first line instead of the whole block; having the entire contents
  # of the code browser highlighted is not useful. 
  if (substr(calltext, 1, 1) == "{" &&
      substr(calltext, nchar(calltext), nchar(calltext)) == "}" &&
      lastline - firstline > 5)
  {
     lastline <- firstline
     lastchar <- offsets[firstline] - pos
  }
  else
  {
     lastchar <- endpos - (if (lastline == 1) 0 else offsets[lastline - 1])
     lastchar <- lastchar + indents[lastline]
  }

  result <- as.integer(c(firstline, firstchar,
                         lastline,  lastchar,
                         firstchar, lastchar))
  return(result)
})

.rs.addFunction("functionNameFromCall", function(val)
{
   call <- .rs.nullCoalesce(
      attr(val, "_rs_call", exact = TRUE),
      val
   )
   
   if (is.function(call[[1]]))
      return("[Anonymous function]")
   
   if (is.name(call[[1L]]))
      return(as.character(call[[1L]]))
   
   .rs.deparse(call[[1L]])
})

.rs.addFunction("sanitizeCall", function(object)
{
   if (missing(object))
   {
      return(object)
   }
   else if (is.call(object))
   {
      # if this is the concatenation of a large number of objects,
      # then just use a shorter representation of the call
      callee <- object[[1L]]
      long <-
         is.name(callee) &&
         length(object) > 20
      
      if (long)
         return(as.call(list(callee, quote(...))))
      
      # sanitize each call entry separately
      for (i in seq_along(object))
      {
         # assigning NULL to object will remove that entry
         # https://github.com/rstudio/rstudio/issues/9299
         sanitized <- .rs.sanitizeCall(object[[i]])
         if (!missing(sanitized) && !is.null(sanitized))
            object[[i]] <- sanitized
      }
      
      # return object
      object
   }
   else if (is.pairlist(object))
   {
      # handle pairlists specially, primarily because they're
      # used directly within function calls
      object
   }
   else if (!is.language(object))
   {
      # if the object would be very expensive to deparse,
      # just use a placeholder instead
      #
      # note that we still want to accept literals here,
      # e.g. 42, "abc"
      if (!is.object(object) && length(object) == 1)
      {
         object
      }
      else
      {
         type <- .rs.explorer.objectType(object)
         as.name(sprintf("<%s>", type))
      }
   }
   else
   {
      object
   }
})

.rs.addFunction("callSummary", function(val)
{
   call <- .rs.nullCoalesce(
      attr(val, "_rs_call", exact = TRUE),
      val
   )
   
   # some calls might be very large when deparsed, especially when
   # they include R objects which have already been evaluated. this
   # happens most often with calls like:
   #
   #   do.call("fn", list(object))
   #
   # where 'object' is something very large when deparsed. we avoid
   # issues by replacing such objects with a short identifier of their
   # type / class
   call <- .rs.sanitizeCall(call)
   
   # deparse call
   .rs.deparse(call)
   
})

.rs.addFunction("valueDescription", function(obj)
{
   tryCatch(
      .rs.valueDescriptionImpl(obj),
      error = function(e) ""
   )
})

.rs.addFunction("valueDescriptionImpl", function(obj)
{
   if (missing(obj))
   {
      return("Missing argument")
   }
   else if (is.null(obj))
   {
      return("NULL")
   }
   else if (is(obj, "ore.frame"))
   {
      sqlTable <- attr(obj, "sqlTable", exact = TRUE)
      if (is.null(sqlTable))
         return("Oracle R frame") 
      else
         return(paste("Oracle R frame:", sqlTable))
   }
   else if (.rs.isExternalPointer(obj))
   {
      class <- class(obj)
      if (length(class) && !identical(class, "externalptr"))
      {
         fmt <- "External pointer of class '%s'"
         return(sprintf(fmt, class[[1]]))
      }
      else
      {
         return("External pointer")
      }
   }
   else if (is.data.frame(obj))
   {
      return(paste(dim(obj)[1],
                   "obs. of",
                   dim(obj)[2],
                   ifelse(dim(obj)[2] == 1, "variable", "variables"),
                   sep=" "))
   }
   else if (is.environment(obj))
   {
      return("Environment")
   }
   else if (isS4(obj))
   {
      return(paste("Formal class ", is(obj)))
   }
   else if (is.list(obj))
   {
      return(paste("List of ", length(obj)))
   }
   else if (is.matrix(obj)
            || is.numeric(obj)
            || is.factor(obj)
            || is.raw(obj) 
            || is.character(obj)
            || is.logical(obj))
   {
      return(.rs.valueFromStr(obj))
   }
   else
   {
      return("")
   }
})

.rs.addFunction("editor", function(name, file = "", title = file, ...)
{
   # if 'name' is missing, we're likely being invoked by
   # 'utils::file.edit()', so just edit the requested file
   if (missing(name) || is.null(name))
      return(.Call("rs_editFile", file, PACKAGE = "(embedding)"))
   
   # otherwise, we're more likely being invoked by 'edit()', which
   # requires the parsed file to be valid R code -- so handle that
   
   # if no file has been supplied, generate one for the user
   if (is.null(file) || !nzchar(file)) {
      file <- tempfile("rstudio-scratch-", fileext = ".R")
      on.exit(unlink(file), add = TRUE)
   }
   
   # write deparsed R object to file
   deparsed <- if (is.function(name))
      .rs.deparseFunction(name, useSource = TRUE, asString = FALSE)
   else
      deparse(name)
   writeLines(deparsed, con = file)
   
   # invoke edit
   .Call("rs_editFile", file, PACKAGE = "(embedding)")
   
   # attempt to parse-eval the generated content
   eval(parse(file), envir = globalenv())
   
})

.rs.addFunction("registerFunctionEditor", function()
{
   options(editor = .rs.editor)
})


.rs.addFunction("getSingleClass", function(obj)
{
   class(obj)[[1L]]
})

.rs.addFunction("describeCall", function(call)
{
   # defend against very large calls; e.g. those with R objects inlined
   # as part of the call (can happen in do.call contexts)
   #
   # this is primarily used for the Environment pane, where we try to display
   # a single-line summary of an R object -- so we can enforce that when
   # deparsing calls here as well
   #
   # https://github.com/rstudio/rstudio/issues/5158
   sanitized <- .rs.sanitizeCall(call)
   val1 <- .rs.deparse(sanitized, nlines = 1L)
   val2 <- .rs.deparse(sanitized, nlines = 2L)
   
   # indicate if there is more output
   val <- if (!identical(val1, val2))
      paste(val1, "<...>")
   else
      val1
})

.rs.addFunction("hasExternalPointer", function(object, nullPtr = FALSE)
{
   .Call("rs_hasExternalPointer", object, nullPtr, PACKAGE = "(embedding)")
})

.rs.addFunction("describeObject", function(env, objName, computeSize = TRUE)
{
   obj <- get(objName, env)
   
   # https://github.com/rstudio/rstudio/issues/9328
   if (missing(obj))
      obj <- as.name("Missing argument")
   
   if (inherits(obj, "python.builtin.object"))
      return(.rs.reticulate.describeObject(objName, env))
   
   # NOTE (kevin): we previously screened R objects for null pointers here,
   # as we had seen in the distant past that attempting to introspect such
   # objects would cause an R session crash. that no longer appears to be
   # the case so we now no longer perform this check here.
   #
   # https://github.com/rstudio/rstudio/issues/4741
   # https://github.com/rstudio/rstudio/issues/5546
   #
   # however, just in case some users are still effected, we allow users to
   # opt-in to checking for null pointers if required.
   checkNullPtr <- .rs.readUiPref("check_null_external_pointers")
   hasNullPtr <- if (identical(checkNullPtr, TRUE))
      .rs.hasExternalPointer(obj, TRUE)
   else
      FALSE
   
   if (hasNullPtr) 
   {
      val <- "<Object with null pointer>"
      desc <- "An R object containing a null external pointer"
      size <- 0
      len <- 0
   }
   else 
   {
      val <- "(unknown)"
      desc <- ""

      # some objects (e.g. ALTREP) have compact representations that are forced to materialize if
      # an attempt is made to compute their metrics exactly; avoid computing the size for these
      size <- if (computeSize) object.size(obj) else 0
      len <- length(obj)
   }
   
   class <- .rs.getSingleClass(obj)
   contents <- list()
   contents_deferred <- FALSE
   
   # for language objects, don't evaluate, just show the expression
   if (is.symbol(obj))
   {
      val <- as.character(obj)
   }
   else if (is.language(obj))
   {
      .rs.describeCall(obj)  
   }
   else if (!hasNullPtr)
   {
      # for large objects (> half MB), don't try to get the value, just show
      # the size. Some functions (e.g. str()) can cause the object to be
      # copied, which is slow for large objects.
      if (size > 524288)
      {
         len_desc <- if (len > 1)
         {
            paste(len, " elements, ", sep = "")
         }
         else
         {
            ""
         }
         
         # data frames are likely to be large, but a summary is still helpful
         if (is.data.frame(obj))
         {
            val <- "NO_VALUE"
            desc <- .rs.valueDescription(obj)
         }
         else
         {
            fmt <- "Large %s (%s %s)"
            val <- sprintf(fmt, class, len_desc, format(size, units = "auto", standard = "SI"))
         }
         contents_deferred <- TRUE
      }
      else
      {
         val <- .rs.valueAsString(obj)
         desc <- .rs.valueDescription(obj)

         # expandable object--supply contents 
         if (is.list(obj) ||  is.data.frame(obj) || isS4(obj) ||
             inherits(obj, c("data.table", "ore.frame", "cast_df", "xts", "DataFrame")))
         {
            if (computeSize)
            {
               # normal object
               contents <- .rs.valueContents(obj)
            }
            else
            {
               # don't prefetch content for altreps
               val <- "NO_VALUE"
               contents_deferred <- TRUE
            }
         }
      }
   }
   
   list(
      name              = .rs.scalar(objName),
      type              = .rs.scalar(class),
      clazz             = c(class(obj), typeof(obj)),
      is_data           = .rs.scalar(is.data.frame(obj)),
      value             = .rs.scalar(val),
      description       = .rs.scalar(desc),
      size              = .rs.scalar(size),
      length            = .rs.scalar(len),
      contents          = contents,
      contents_deferred = .rs.scalar(contents_deferred)
   )
   
})

# returns the name and frame number of an environment from a call frame
.rs.addFunction("environmentCallFrameName", function(env)
{
   numCalls <- length(sys.calls())
   result <- list()
   for (i in 1:numCalls)
   {
      if (identical(sys.frame(i), env))
      {
         calldesc <- paste(deparse(sys.call(i)[[1]]), "()", sep="")
         result <- list(name = .rs.scalar(calldesc), 
                        frame = .rs.scalar(i),
                        local = .rs.scalar(TRUE))
         break
      }
   }
   if (identical(result, list()))
      list(name = .rs.scalar("unknown"), frame = .rs.scalar(0L))
   else
      result
})

# indicate whether the given environment is local (i.e. it comes before the
# global environment in the search path)
.rs.addFunction("environmentIsLocal", function(env)
{
   while (!identical(env, emptyenv())) 
   {
      # if one of this environment's parents is the global environment, it's
      # local
      env = parent.env(env)
      if (identical(env, globalenv())) 
         return(TRUE)
   }
   return(FALSE)
})

.rs.addFunction("environmentName", function(env)
{
   # global environment 
   if (identical(env, globalenv()))
     return(".GlobalEnv")

   # base environment
   if (identical(env, baseenv()))
     return("package:base")

   # look for the environment's given name; if it doesn't have a name, check
   # the callstack to see if it matches the environment in one of the call 
   # frames.
   result <- environmentName(env)
   
   if (nchar(result) == 0)
      .rs.environmentCallFrameName(env)$name
   else
   {
      # resolve namespaces
      if ((result %in% loadedNamespaces()) && 
          identical(asNamespace(result), env))
         paste("namespace:", result, sep = "")
      else
         result
   }
})

.rs.addFunction("environmentList", function(startEnv)
{
   env <- startEnv
   envs <- list()
   local <- TRUE
   # if starting above the global environment, the environments will be
   # unnamed. to provide sensible names for them, look for a matching frame in
   # the callstack.
   if (!identical(env, globalenv()))
   {
      while (!identical(env, globalenv()) &&
             !identical(env, emptyenv()))
      {
         frame <- .rs.environmentCallFrameName(env)
         # if this frame is from the callstack, store it and proceed
         if (frame$frame > 0)
         {
            envs[[length(envs) + 1]] <- frame
            env <- parent.env(env)
         }
         # otherwise, stop here and get names normally
         else
         {
            break
         }
      }
   }
   # we're now past the call-frame portion of the stack; proceed normally
   # through the rest of the search path.
   while (!identical(env, emptyenv()))
   {
      # mark all environments as local until we reach the global 
      # environment
      if (identical(env, globalenv())) 
         local <- FALSE

      envName <- environmentName(env)

      # hide the RStudio internal tools environment and the autoloads
      # environment, and any environment that doesn't have a name
      if (nzchar(envName) && !envName %in% c("tools:rstudio", "Autoloads"))
      {
         envs[[length(envs) + 1]] <- list(
            name = .rs.scalar(envName),
            frame = .rs.scalar(0L),
            local = .rs.scalar(local)
         )
      }
      env <- parent.env(env)
   }
   envs
})

.rs.addFunction("removeObjects", function(objNames, env)
{
   objects <- unlist(objNames)
   rm(list = objects, envir = env)
})

.rs.addFunction("removeAllObjects", function(includeHidden, env)
{
   objects <- ls(envir = env, all.names = includeHidden)
   rm(list = objects, envir = env)
})

.rs.addFunction("getObjectContents", function(objName, env)
{
   object <- get(objName, envir = env)
   .rs.valueContents(object)
})

.rs.addFunction("isAltrep", function(var)
{
   .Call("rs_isAltrep", var, PACKAGE = "(embedding)")
})

.rs.addFunction("hasAltrep", function(var)
{
   .Call("rs_hasAltrep", var, PACKAGE = "(embedding)")
})

.rs.addFunction("resolveContextSourceRefs", function(callfun)
{
   calls <- sys.calls()
   
   for (i in seq_along(calls))
   {
      fn <- sys.function(i)
      if (identical(fn, callfun))
      {
         srcref <- attr(calls[[i]], "srcref", exact = TRUE)
         return(srcref)
      }
   }
   
   NULL
   
})

#
# SessionRMarkdown.R
#
# Copyright (C) 2009-12 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar("markdown.acCompletionTypes", list(
   COMPLETION_HREF = 1
))

.rs.addJsonRpcHandler("markdown_get_completions", function(type, data)
{
   if (type == .rs.markdown.acCompletionTypes$COMPLETION_HREF)
      return(.rs.markdown.getCompletionsHref(data))
})

.rs.addFunction("markdown.getCompletionsHref", function(data)
{
   # extract parameters
   token <- data$token
   path <- data$path
   
   # if we don't have a path, bail
   if (is.null(path))
      return(.rs.emptyCompletions())
   
   # figure out working directory
   props <- .rs.getSourceDocumentProperties(path)
   workingDirProp <- props$properties$working_dir
   workingDir <- if (identical(workingDirProp, "project"))
      props$project_path
   else if (identical(workingDirProp, "current"))
      getwd()
   
   # check for NULL working dir (don't include as part of if-else check above
   # since some documents may not have an associated project and yet could
   # be configured to use a project directory)
   if (is.null(workingDir))
      workingDir <- dirname(path)
   
   # determine dirname, basename (need to handle trailing slashes properly
   # so can't just use dirname / basename)
   slashes <- gregexpr("[/\\]", token)[[1]]
   idx <- tail(slashes, n = 1)
   lhs <- substring(token, 1, idx - 1)
   rhs <- substring(token, idx + 1)
   
   # check to see if user is providing absolute path, and construct
   # completion directory appropriately
   isAbsolute <- grepl("^(?:[A-Z]:|/|\\\\|~)", token, perl = TRUE)
   if (!isAbsolute)
      lhs <- file.path(workingDir, lhs)
   
   # retrieve completions
   completions <- .rs.getCompletionsFile(
      token = rhs,
      path = lhs,
      quote = FALSE,
      directoriesOnly = FALSE
   )
   
   return(completions)
   
})

.rs.addFunction("scalarListFromList", function(l, expressions = FALSE)
{
   # hint that every non-list element of the hierarchical list l
   # is a scalar value if it is of length 1
   l <- lapply(l, function(ele) {
      if (is.null(ele))
         NULL
      else if (is.list(ele)) 
         .rs.scalarListFromList(ele)
      else if (length(ele) == 1) {
         # mark strings with encoding unless already marked (see comment
         # below in convert_to_yaml)
         if (is.character(ele) && Encoding(ele) == "unknown")
            Encoding(ele) <- "UTF-8"
         .rs.scalar(ele)
      }
      else if (identical(expressions, TRUE) && (is.expression(ele) || is.call(ele)))
         .rs.scalarListFromList(list(expr = eval(ele)))$expr
      else
         ele
   })
})

.rs.addFunction("isREADME", function(file) {
  identical(tools::file_path_sans_ext(basename(file)), "README")
})

.rs.addFunction("updateRMarkdownPackage", function(archive) 
{
  pkgDir <- find.package("rmarkdown")
  .rs.forceUnloadPackage("rmarkdown")
  .Call("rs_installPackage",  archive, dirname(pkgDir))
})

.rs.addFunction("getRmdRuntime", function(file) {
   lines <- readLines(file, warn = FALSE)

   yamlFrontMatter <- tryCatch(
     rmarkdown:::parse_yaml_front_matter(lines),
     error=function(e) {
        list()
     })

   if (!is.null(yamlFrontMatter$runtime))
      yamlFrontMatter$runtime
    else
      ""
})

.rs.addFunction("getCustomRenderFunction", function(file) {
  # read the contents of the file
  lines <- readLines(file, warn = FALSE)
  
  # mark the encoding if it's available
  properties <- .rs.getSourceDocumentProperties(file)
  if (identical(properties$encoding, "UTF-8"))
    Encoding(lines) <- "UTF-8"
  
  yamlFrontMatter <- tryCatch(
    rmarkdown:::parse_yaml_front_matter(lines),
    error = function(e) {
      list()
    }
  )

  if (is.character(yamlFrontMatter[["knit"]]))
    yamlFrontMatter[["knit"]][[1]]
  else if (!is.null(yamlFrontMatter$runtime) &&
           grepl('^shiny', yamlFrontMatter$runtime)) {
    # use run as a wrapper for render when the doc requires the Shiny runtime,
    # and outputs HTML. 
    tryCatch({
       outputFormat <- rmarkdown:::output_format_from_yaml_front_matter(lines)
       formatFunction <- eval(parse(text = outputFormat$name), 
                              envir = asNamespace("rmarkdown"))
       if (identical(tolower(tools::file_ext(
            rmarkdown:::pandoc_output_file("shiny", formatFunction()$pandoc))), 
            "html"))
          "rmarkdown::run"
       else 
          # this situation is nonsensical (runtime: shiny only makse sense for
          # HTML-based output formats)
          ""
     }, error = function(e) {
        ""
     })
  }
  else {
    # return render_site if we are in a website and this isn't a README
    if (!.rs.isREADME(file)) {
       siteGenerator <- tryCatch(rmarkdown::site_generator(file),
                                 error = function(e) NULL)
       if (!is.null(siteGenerator))
         "rmarkdown::render_site"
       else
         ""
    }
    else {
       ""
    }
  }
})

# given an input file, return the associated output file, and attempt to deduce
# whether it's up to date (e.g. for input.Rmd producing input.html, see whether
# input.html exists and has been written since input.Rmd)
.rs.addFunction("getRmdOutputInfo", function(target) {
  
   # read the contents of the file
   lines <- readLines(target, warn = FALSE)
   
   # mark the encoding if it's available
   properties <- .rs.getSourceDocumentProperties(target)
   if (identical(properties$encoding, "UTF-8"))
      Encoding(lines) <- "UTF-8"
   
   # compute the name of the output file
   outputFormat <- rmarkdown:::output_format_from_yaml_front_matter(lines)
   outputFormat <- rmarkdown:::create_output_format(outputFormat$name, outputFormat$options)
   outputFile <- rmarkdown:::pandoc_output_file(target, outputFormat$pandoc)

   # determine location of output file, accounting for possibility of a website project which
   # puts the output in a different location than the source file
   outputDir <- .Call("rs_getWebsiteOutputDir")
   if (is.null(outputDir))
      outputDir <- dirname(target)
   outputPath <- file.path(outputDir, outputFile)
   
   # ensure output file exists
   fileExists <- file.exists(outputPath)
   current <- fileExists && 
      file.info(outputPath)$mtime >= file.info(target)$mtime
   
   list(
      output_file = .rs.scalar(outputPath),
      is_current  = .rs.scalar(current),
      output_file_exists = .rs.scalar(fileExists)
   )
})

.rs.addFunction("getTemplateDetails", function(templateYaml) {
   yaml::yaml.load_file(templateYaml)
})

# given a path to a folder on disk, return information about the R Markdown
# template in that folder.
.rs.addFunction("getTemplateYamlFile", function(path) {
   # check for required files
   templateYaml <- file.path(path, "template.yaml")
   skeletonPath <- file.path(path, "skeleton")
   if (!file.exists(templateYaml)) {
      templateYaml <- file.path(path, "template.yml")
      if (!file.exists(templateYaml))
         return(NULL)
   }

   if (!file.exists(file.path(skeletonPath, "skeleton.Rmd")))
      return(NULL)

   # will need to enforce create_dir if there are multiple files in /skeleton/
   multiFile = length(list.files(skeletonPath)) > 1 

   # return metadata; we won't parse until the client requests template files
   list(
      template_yaml = .rs.scalar(templateYaml),
      multi_file    = .rs.scalar(multiFile)
   )
})


.rs.addFunction("evaluateRmdParams", function(contents) {

   Encoding(contents) <- "UTF-8"

   # extract the params using knitr::knit_params
   knitParams <- knitr::knit_params(contents)

   if (length(knitParams) > 0)
   {
      # turn them into a named list
      params <- list()
      for (param in knitParams)
         params[[param$name]] <- param$value
      
      # mark as knit_params_list (so other routines know we generated it)
      class(params) <- "knit_param_list"

      # inject into global environment
      assign("params", params, envir = globalenv())
   }
})

.rs.addJsonRpcHandler("convert_to_yaml", function(input)
{
   # the yaml package doesn't treat string values kindly if they're surrounded
   # by backticks, so we will need to replace those with UUIDs we can sub out
   # later
   exprs <- list()
   tick_sub <- function(x) 
   {
      lapply(x, function(val) 
      {
         if (is.list(val)) 
         {
            # if it's a list, recurse
            tick_sub(val)
         }
         else if (is.character(val) && length(val) == 1) 
         {
            needsPlaceholder <- (function() {
               
               # if it's a character value, check to see if it's a backtick
               # expression
               if (identical(substr(val, 1, 1), "`") &&
                   identical(substr(val, nchar(val), nchar(val)), "`"))
               {
                  return(TRUE)
               }
               
               # if it's a tagged value, placeholder
               if (grepl("^[!]", val))
                  return(TRUE)
               
               FALSE
            })()
            
            if (needsPlaceholder)
            {
               # replace the backtick expression with an identifier
               key <- .Call("rs_generateShortUuid")
               exprs[[key]] <<- val
               key
            }
            else 
            {
               # leave other character expressions as-is
               val
            }
         } 
         else 
         {
            # leave non-character values alone
            val
         }
      })
   }
   
   # substitute ticks and convert to yaml
   yaml <- yaml::as.yaml(tick_sub(input))

   # the yaml package produces UTF-8 output strings, but doesn't mark them
   # as such, which leads to trouble (in particular: on Windows the string
   # may be later interpreted in system default encoding, which is not UTF-8.)
   # see: https://github.com/viking/r-yaml/issues/6
   if (Encoding(yaml) == "unknown")
      Encoding(yaml) <- "UTF-8"

   # put the backticked expressions back
   for (key in names(exprs)) 
      yaml <- sub(key, exprs[[key]], yaml, fixed = TRUE)

   list(yaml = .rs.scalar(yaml))
})

.rs.addJsonRpcHandler("convert_from_yaml", function(yaml)
{
   Encoding(yaml) <- "UTF-8"

   data <- list()
   parseError <- ""
   parseSucceeded <- FALSE
   
   tryCatch(
   {
      handlers <- list(r = function(x) paste("!r", x))
      data <- .rs.scalarListFromList(yaml::yaml.load(yaml, handlers = handlers))
      parseSucceeded <- TRUE
   },
   error = function(e)
   {
      parseError <<- as.character(e)
   })
   list(data = data, 
        parse_succeeded = .rs.scalar(parseSucceeded),
        parse_error = .rs.scalar(parseError))
})


.rs.addJsonRpcHandler("rmd_output_format", function(input, encoding) {
  if (Encoding(input) == "unknown")
    Encoding(input) <- "UTF-8"
  formats <- rmarkdown:::enumerate_output_formats(input, encoding = encoding)
  if (is.character(formats))
    .rs.scalar(formats[[1]])
  else
    NULL
})

.rs.addGlobalFunction("knit_with_parameters", 
                      function(file, encoding = getOption("encoding")) {
   
   # result to return via event
   result <- NULL
   
   # check for parameters 
   if (length(knitr::knit_params(readLines(file, 
                                           warn = FALSE, 
                                           encoding = encoding),
                                 evaluate = FALSE)) > 0) {
      
      # allocate temp file to hold parameter values
      paramsFile <- .Call("rs_paramsFileForRmd", file)
     
      # read any existing parameters contained therin
      params <- list()
      if (file.exists(paramsFile))
         params <- readRDS(paramsFile)
      
      # ask for parameters
      params <- rmarkdown::knit_params_ask(
         file, 
         params = params,
         shiny_args = list(
            launch.browser = function(url, ...) {
               .Call("rs_showShinyGadgetDialog",
                     "Knit with Parameters",
                     url,
                     600,
                     600)
            },
            quiet = TRUE),
         save_caption = "Knit",
         encoding = encoding
      )
      
      if (!is.null(params)) {
         saveRDS(params, file = paramsFile)
         result <- paramsFile
      }
      
   } else {
      # return special "none" value if there are no params
      result <- "none"
   }
   
   .rs.enqueClientEvent("rmd_params_ready", result)

   invisible(NULL)
})

.rs.addJsonRpcHandler("get_rmd_output_info", function(target) {
  return(.rs.getRmdOutputInfo(target))
})

.rs.addFunction("inputDirToIndexFile", function(input_dir) {
   index <- file.path(input_dir, "index.Rmd")
   if (file.exists(index))
      index
   else {
      index <- file.path(input_dir, "index.md")
      if (file.exists(index))
         index
      else
         NULL
   }
})

.rs.addFunction("getAllOutputFormats", function(input_dir, encoding) {
   index <- .rs.inputDirToIndexFile(input_dir)
   if (!is.null(index))
      rmarkdown:::enumerate_output_formats(input = index,
                                           envir = parent.frame(),
                                           encoding = encoding)
   else
      character()
})

.rs.addFunction("isBookdownWebsite", function(input_dir, encoding) {
   index <- .rs.inputDirToIndexFile(input_dir)
   if (!is.null(index)) {
      
      formats <- rmarkdown:::enumerate_output_formats(input = index,
                                                      envir = parent.frame(),
                                                      encoding = encoding)
      any(grepl("^bookdown", formats))
   }
   else
      FALSE
})

.rs.addFunction("tinytexRoot", function()
{
   sysname <- Sys.info()[["sysname"]]
   if (sysname == "Windows")
      file.path(Sys.getenv("APPDATA"), "TinyTeX")
   else if (sysname == "Darwin")
      "~/Library/TinyTeX"
   else
      "~/.TinyTeX"
})

.rs.addFunction("tinytexBin", function()
{
   root <- tryCatch(
      tinytex:::tinytex_root(),
      error = function(e) .rs.tinytexRoot()
   )
   
   if (!file.exists(root))
      return(NULL)
   
   # NOTE: binary directory has a single arch-specific subdir;
   # rather than trying to hard-code the architecture we just
   # infer it directly
   bin <- file.path(root, "bin")
   subbin <- list.files(bin, full.names = TRUE)
   normalizePath(subbin[[1]], mustWork = TRUE)
})

.rs.addFunction("bookdown.renderedOutputPath", function(outputPath)
{
   # if this is a PDF, use it directly
   if (tools::file_ext(outputPath) == "pdf")
      return(outputPath)
   
   # if we have an index, prefer using that
   index <- file.path(dirname(outputPath), "index.html")
   if (file.exists(index))
      return(index)
   
   # otherwise, return the rendered path directly
   # (typically necessary for self-contained books)
   outputPath
})

#
# SessionUserPrefValues.R
#
# Copyright (C) 2025 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

#
# This file was automatically generated -- please do not modify it by hand.
#

.rs.setVar("uiPrefs", new.env(parent = emptyenv()))

# Run .Rprofile on resume
#
# Whether to run .Rprofile again after resuming a suspended R session.
.rs.uiPrefs$runRprofileOnResume <- list(
   get = function() { .rs.getUserPref("run_rprofile_on_resume") },
   set = function(value) { .rs.setUserPref("run_rprofile_on_resume", value) },
   clear = function() { .rs.clearUserPref("run_rprofile_on_resume") }
)

# Save workspace on quit
#
# Whether to save the workspace to an .Rdata file after the R session ends.
.rs.uiPrefs$saveWorkspace <- list(
   get = function() { .rs.getUserPref("save_workspace") },
   set = function(value) { .rs.setUserPref("save_workspace", value) },
   clear = function() { .rs.clearUserPref("save_workspace") }
)

# Load workspace on start
#
# Whether to load the workspace when the R session begins.
.rs.uiPrefs$loadWorkspace <- list(
   get = function() { .rs.getUserPref("load_workspace") },
   set = function(value) { .rs.setUserPref("load_workspace", value) },
   clear = function() { .rs.clearUserPref("load_workspace") }
)

# Initial working directory
#
# The initial working directory for new R sessions.
.rs.uiPrefs$initialWorkingDirectory <- list(
   get = function() { .rs.getUserPref("initial_working_directory") },
   set = function(value) { .rs.setUserPref("initial_working_directory", value) },
   clear = function() { .rs.clearUserPref("initial_working_directory") }
)

# 
#
# The CRAN mirror to use.
.rs.uiPrefs$cranMirror <- list(
   get = function() { .rs.getUserPref("cran_mirror") },
   set = function(value) { .rs.setUserPref("cran_mirror", value) },
   clear = function() { .rs.clearUserPref("cran_mirror") }
)

# 
#
# The name of the default Bioconductor mirror.
.rs.uiPrefs$bioconductorMirrorName <- list(
   get = function() { .rs.getUserPref("bioconductor_mirror_name") },
   set = function(value) { .rs.setUserPref("bioconductor_mirror_name", value) },
   clear = function() { .rs.clearUserPref("bioconductor_mirror_name") }
)

# 
#
# The URL of the default Bioconductor mirror.
.rs.uiPrefs$bioconductorMirrorUrl <- list(
   get = function() { .rs.getUserPref("bioconductor_mirror_url") },
   set = function(value) { .rs.setUserPref("bioconductor_mirror_url", value) },
   clear = function() { .rs.clearUserPref("bioconductor_mirror_url") }
)

# Save R console history
#
# Whether to always save the R console history.
.rs.uiPrefs$alwaysSaveHistory <- list(
   get = function() { .rs.getUserPref("always_save_history") },
   set = function(value) { .rs.setUserPref("always_save_history", value) },
   clear = function() { .rs.clearUserPref("always_save_history") }
)

# Remove duplicates from console history
#
# Whether to remove duplicate entries from the R console history.
.rs.uiPrefs$removeHistoryDuplicates <- list(
   get = function() { .rs.getUserPref("remove_history_duplicates") },
   set = function(value) { .rs.setUserPref("remove_history_duplicates", value) },
   clear = function() { .rs.clearUserPref("remove_history_duplicates") }
)

# Show .Last.value in Environment pane
#
# Show the result of the last expression (.Last.value) in the Environment pane.
.rs.uiPrefs$showLastDotValue <- list(
   get = function() { .rs.getUserPref("show_last_dot_value") },
   set = function(value) { .rs.setUserPref("show_last_dot_value", value) },
   clear = function() { .rs.clearUserPref("show_last_dot_value") }
)

# Line ending format
#
# The line ending format to use when saving files.
.rs.uiPrefs$lineEndingConversion <- list(
   get = function() { .rs.getUserPref("line_ending_conversion") },
   set = function(value) { .rs.setUserPref("line_ending_conversion", value) },
   clear = function() { .rs.clearUserPref("line_ending_conversion") }
)

# Use newlines in Makefiles
#
# Whether to use newlines when saving Makefiles.
.rs.uiPrefs$useNewlinesInMakefiles <- list(
   get = function() { .rs.getUserPref("use_newlines_in_makefiles") },
   set = function(value) { .rs.setUserPref("use_newlines_in_makefiles", value) },
   clear = function() { .rs.clearUserPref("use_newlines_in_makefiles") }
)

# 
#
# The terminal shell to use on Windows.
.rs.uiPrefs$windowsTerminalShell <- list(
   get = function() { .rs.getUserPref("windows_terminal_shell") },
   set = function(value) { .rs.setUserPref("windows_terminal_shell", value) },
   clear = function() { .rs.clearUserPref("windows_terminal_shell") }
)

# 
#
# The terminal shell to use on POSIX operating systems (MacOS and Linux).
.rs.uiPrefs$posixTerminalShell <- list(
   get = function() { .rs.getUserPref("posix_terminal_shell") },
   set = function(value) { .rs.setUserPref("posix_terminal_shell", value) },
   clear = function() { .rs.clearUserPref("posix_terminal_shell") }
)

# 
#
# The fully qualified path to the custom shell command to use in the Terminal
# tab.
.rs.uiPrefs$customShellCommand <- list(
   get = function() { .rs.getUserPref("custom_shell_command") },
   set = function(value) { .rs.setUserPref("custom_shell_command", value) },
   clear = function() { .rs.clearUserPref("custom_shell_command") }
)

# 
#
# The command-line options to pass to the custom shell command.
.rs.uiPrefs$customShellOptions <- list(
   get = function() { .rs.getUserPref("custom_shell_options") },
   set = function(value) { .rs.setUserPref("custom_shell_options", value) },
   clear = function() { .rs.clearUserPref("custom_shell_options") }
)

# Show line numbers in editor
#
# Show line numbers in RStudio's code editor.
.rs.uiPrefs$showLineNumbers <- list(
   get = function() { .rs.getUserPref("show_line_numbers") },
   set = function(value) { .rs.setUserPref("show_line_numbers", value) },
   clear = function() { .rs.clearUserPref("show_line_numbers") }
)

# Use relative line numbers in editor
#
# Show relative, rather than absolute, line numbers in RStudio's code editor.
.rs.uiPrefs$relativeLineNumbers <- list(
   get = function() { .rs.getUserPref("relative_line_numbers") },
   set = function(value) { .rs.setUserPref("relative_line_numbers", value) },
   clear = function() { .rs.clearUserPref("relative_line_numbers") }
)

# Highlight selected word in editor
#
# Highlight the selected word in RStudio's code editor.
.rs.uiPrefs$highlightSelectedWord <- list(
   get = function() { .rs.getUserPref("highlight_selected_word") },
   set = function(value) { .rs.setUserPref("highlight_selected_word", value) },
   clear = function() { .rs.clearUserPref("highlight_selected_word") }
)

# Highlight selected line in editor
#
# Highlight the selected line in RStudio's code editor.
.rs.uiPrefs$highlightSelectedLine <- list(
   get = function() { .rs.getUserPref("highlight_selected_line") },
   set = function(value) { .rs.setUserPref("highlight_selected_line", value) },
   clear = function() { .rs.clearUserPref("highlight_selected_line") }
)

# 
#
# Layout of panes in the RStudio workbench.
.rs.uiPrefs$panes <- list(
   get = function() { .rs.getUserPref("panes") },
   set = function(value) { .rs.setUserPref("panes", value) },
   clear = function() { .rs.clearUserPref("panes") }
)

# Allow source columns
#
# Whether to enable the ability to add source columns to display.
.rs.uiPrefs$allowSourceColumns <- list(
   get = function() { .rs.getUserPref("allow_source_columns") },
   set = function(value) { .rs.setUserPref("allow_source_columns", value) },
   clear = function() { .rs.clearUserPref("allow_source_columns") }
)

# Insert spaces for Tab
#
# Whether to insert spaces when pressing the Tab key.
.rs.uiPrefs$useSpacesForTab <- list(
   get = function() { .rs.getUserPref("use_spaces_for_tab") },
   set = function(value) { .rs.setUserPref("use_spaces_for_tab", value) },
   clear = function() { .rs.clearUserPref("use_spaces_for_tab") }
)

# Number of spaces for Tab
#
# The number of spaces to insert when pressing the Tab key.
.rs.uiPrefs$numSpacesForTab <- list(
   get = function() { .rs.getUserPref("num_spaces_for_tab") },
   set = function(value) { .rs.setUserPref("num_spaces_for_tab", value) },
   clear = function() { .rs.clearUserPref("num_spaces_for_tab") }
)

# Auto-detect indentation in files
#
# Whether to automatically detect indentation settings from file contents.
.rs.uiPrefs$autoDetectIndentation <- list(
   get = function() { .rs.getUserPref("auto_detect_indentation") },
   set = function(value) { .rs.setUserPref("auto_detect_indentation", value) },
   clear = function() { .rs.clearUserPref("auto_detect_indentation") }
)

# Show margin in editor
#
# Whether to show the margin guide in the RStudio code editor.
.rs.uiPrefs$showMargin <- list(
   get = function() { .rs.getUserPref("show_margin") },
   set = function(value) { .rs.setUserPref("show_margin", value) },
   clear = function() { .rs.clearUserPref("show_margin") }
)

# Use a blinking cursor
#
# Whether to flash the cursor off and on.
.rs.uiPrefs$blinkingCursor <- list(
   get = function() { .rs.getUserPref("blinking_cursor") },
   set = function(value) { .rs.setUserPref("blinking_cursor", value) },
   clear = function() { .rs.clearUserPref("blinking_cursor") }
)

# Margin column
#
# The number of columns of text after which the margin is shown.
.rs.uiPrefs$marginColumn <- list(
   get = function() { .rs.getUserPref("margin_column") },
   set = function(value) { .rs.setUserPref("margin_column", value) },
   clear = function() { .rs.clearUserPref("margin_column") }
)

# Soft-wrap at margin column
#
# When set and soft-wrapping is enabled, soft-wrap at the margin column instead
# of editor width.
.rs.uiPrefs$marginColumnSoftWrap <- list(
   get = function() { .rs.getUserPref("margin_column_soft_wrap") },
   set = function(value) { .rs.setUserPref("margin_column_soft_wrap", value) },
   clear = function() { .rs.clearUserPref("margin_column_soft_wrap") }
)

# Clamp editor width to margin column
#
# When set, the editor width will be clamped to the size of the margin column.
.rs.uiPrefs$marginColumnEditorWidth <- list(
   get = function() { .rs.getUserPref("margin_column_editor_width") },
   set = function(value) { .rs.setUserPref("margin_column_editor_width", value) },
   clear = function() { .rs.clearUserPref("margin_column_editor_width") }
)

# Show invisible characters in editor
#
# Whether to show invisible characters, such as spaces and tabs, in the RStudio
# code editor.
.rs.uiPrefs$showInvisibles <- list(
   get = function() { .rs.getUserPref("show_invisibles") },
   set = function(value) { .rs.setUserPref("show_invisibles", value) },
   clear = function() { .rs.clearUserPref("show_invisibles") }
)

# Indentation guides
#
# Style for indentation guides in the RStudio code editor.
.rs.uiPrefs$indentGuides <- list(
   get = function() { .rs.getUserPref("indent_guides") },
   set = function(value) { .rs.setUserPref("indent_guides", value) },
   clear = function() { .rs.clearUserPref("indent_guides") }
)

# Continue comments after adding new line
#
# Whether to continue comments (by inserting the comment character) after adding
# a new line.
.rs.uiPrefs$continueCommentsOnNewline <- list(
   get = function() { .rs.getUserPref("continue_comments_on_newline") },
   set = function(value) { .rs.setUserPref("continue_comments_on_newline", value) },
   clear = function() { .rs.clearUserPref("continue_comments_on_newline") }
)

# Whether web links in comments are clickable
#
# Whether web links in comments are clickable.
.rs.uiPrefs$highlightWebLink <- list(
   get = function() { .rs.getUserPref("highlight_web_link") },
   set = function(value) { .rs.setUserPref("highlight_web_link", value) },
   clear = function() { .rs.clearUserPref("highlight_web_link") }
)

# Keybinding set for editor
#
# The keybindings to use in the RStudio code editor.
.rs.uiPrefs$editorKeybindings <- list(
   get = function() { .rs.getUserPref("editor_keybindings") },
   set = function(value) { .rs.setUserPref("editor_keybindings", value) },
   clear = function() { .rs.clearUserPref("editor_keybindings") }
)

# Auto-insert matching parentheses and brackets
#
# Whether to insert matching pairs, such as () and [], when the first is typed.
.rs.uiPrefs$insertMatching <- list(
   get = function() { .rs.getUserPref("insert_matching") },
   set = function(value) { .rs.setUserPref("insert_matching", value) },
   clear = function() { .rs.clearUserPref("insert_matching") }
)

# Insert spaces around = in R code
#
# Whether to insert spaces around the equals sign in R code.
.rs.uiPrefs$insertSpacesAroundEquals <- list(
   get = function() { .rs.getUserPref("insert_spaces_around_equals") },
   set = function(value) { .rs.setUserPref("insert_spaces_around_equals", value) },
   clear = function() { .rs.clearUserPref("insert_spaces_around_equals") }
)

# Insert parentheses after functions
#
# Whether to insert parentheses after function completions.
.rs.uiPrefs$insertParensAfterFunctionCompletion <- list(
   get = function() { .rs.getUserPref("insert_parens_after_function_completion") },
   set = function(value) { .rs.setUserPref("insert_parens_after_function_completion", value) },
   clear = function() { .rs.clearUserPref("insert_parens_after_function_completion") }
)

# Complete multi-line statements with Tab
#
# Whether to attempt completion of multiple-line statements when pressing Tab.
.rs.uiPrefs$tabMultilineCompletion <- list(
   get = function() { .rs.getUserPref("tab_multiline_completion") },
   set = function(value) { .rs.setUserPref("tab_multiline_completion", value) },
   clear = function() { .rs.clearUserPref("tab_multiline_completion") }
)

# Use Tab to trigger autocompletion
#
# Whether to attempt completion of statements when pressing Tab.
.rs.uiPrefs$tabCompletion <- list(
   get = function() { .rs.getUserPref("tab_completion") },
   set = function(value) { .rs.setUserPref("tab_completion", value) },
   clear = function() { .rs.clearUserPref("tab_completion") }
)

# Show function help tooltips on idle
#
# Whether to show help tooltips for functions when the cursor has not been
# recently moved.
.rs.uiPrefs$showHelpTooltipOnIdle <- list(
   get = function() { .rs.getUserPref("show_help_tooltip_on_idle") },
   set = function(value) { .rs.setUserPref("show_help_tooltip_on_idle", value) },
   clear = function() { .rs.clearUserPref("show_help_tooltip_on_idle") }
)

# Surround selections with
#
# Which kinds of delimiters can be used to surround the current selection.
.rs.uiPrefs$surroundSelection <- list(
   get = function() { .rs.getUserPref("surround_selection") },
   set = function(value) { .rs.setUserPref("surround_selection", value) },
   clear = function() { .rs.clearUserPref("surround_selection") }
)

# Enable code snippets
#
# Whether to enable code snippets in the RStudio code editor.
.rs.uiPrefs$enableSnippets <- list(
   get = function() { .rs.getUserPref("enable_snippets") },
   set = function(value) { .rs.setUserPref("enable_snippets", value) },
   clear = function() { .rs.clearUserPref("enable_snippets") }
)

# Use code completion for R
#
# When to use auto-completion for R code in the RStudio code editor.
.rs.uiPrefs$codeCompletion <- list(
   get = function() { .rs.getUserPref("code_completion") },
   set = function(value) { .rs.setUserPref("code_completion", value) },
   clear = function() { .rs.clearUserPref("code_completion") }
)

# Use code completion for other languages
#
# When to use auto-completion for other languages (such as JavaScript and SQL) in
# the RStudio code editor.
.rs.uiPrefs$codeCompletionOther <- list(
   get = function() { .rs.getUserPref("code_completion_other") },
   set = function(value) { .rs.setUserPref("code_completion_other", value) },
   clear = function() { .rs.clearUserPref("code_completion_other") }
)

# Use code completion in the R console
#
# Whether to always use code completion in the R console.
.rs.uiPrefs$consoleCodeCompletion <- list(
   get = function() { .rs.getUserPref("console_code_completion") },
   set = function(value) { .rs.setUserPref("console_code_completion", value) },
   clear = function() { .rs.clearUserPref("console_code_completion") }
)

# Delay before completing code (ms)
#
# The number of milliseconds to wait before offering code suggestions.
.rs.uiPrefs$codeCompletionDelay <- list(
   get = function() { .rs.getUserPref("code_completion_delay") },
   set = function(value) { .rs.setUserPref("code_completion_delay", value) },
   clear = function() { .rs.clearUserPref("code_completion_delay") }
)

# Number of characters for code completion
#
# The number of characters in a symbol that can be entered before completions are
# offered.
.rs.uiPrefs$codeCompletionCharacters <- list(
   get = function() { .rs.getUserPref("code_completion_characters") },
   set = function(value) { .rs.setUserPref("code_completion_characters", value) },
   clear = function() { .rs.clearUserPref("code_completion_characters") }
)

# Include all function arguments in completion list
#
# When set, RStudio will include all function arguments in the completion list,
# even if those arguments have already appeared to be used in the current
# function invocation.
.rs.uiPrefs$codeCompletionIncludeAlreadyUsed <- list(
   get = function() { .rs.getUserPref("code_completion_include_already_used") },
   set = function(value) { .rs.setUserPref("code_completion_include_already_used", value) },
   clear = function() { .rs.clearUserPref("code_completion_include_already_used") }
)

# Show function signature tooltips
#
# Whether to show function signature tooltips during autocompletion.
.rs.uiPrefs$showFunctionSignatureTooltips <- list(
   get = function() { .rs.getUserPref("show_function_signature_tooltips") },
   set = function(value) { .rs.setUserPref("show_function_signature_tooltips", value) },
   clear = function() { .rs.clearUserPref("show_function_signature_tooltips") }
)

# Show data preview in autocompletion help popup
#
# Whether a data preview is shown in the autocompletion help popup for datasets
# and values.
.rs.uiPrefs$showDataPreview <- list(
   get = function() { .rs.getUserPref("show_data_preview") },
   set = function(value) { .rs.setUserPref("show_data_preview", value) },
   clear = function() { .rs.clearUserPref("show_data_preview") }
)

# Show diagnostics in R code
#
# Whether to show diagnostic messages (such as syntax and usage errors) for R
# code as you type.
.rs.uiPrefs$showDiagnosticsR <- list(
   get = function() { .rs.getUserPref("show_diagnostics_r") },
   set = function(value) { .rs.setUserPref("show_diagnostics_r", value) },
   clear = function() { .rs.clearUserPref("show_diagnostics_r") }
)

# Show diagnostics in C++ code
#
# Whether to show diagnostic messages for C++ code as you type.
.rs.uiPrefs$showDiagnosticsCpp <- list(
   get = function() { .rs.getUserPref("show_diagnostics_cpp") },
   set = function(value) { .rs.setUserPref("show_diagnostics_cpp", value) },
   clear = function() { .rs.clearUserPref("show_diagnostics_cpp") }
)

# Show diagnostics in YAML code
#
# Whether to show diagnostic messages for YAML code as you type.
.rs.uiPrefs$showDiagnosticsYaml <- list(
   get = function() { .rs.getUserPref("show_diagnostics_yaml") },
   set = function(value) { .rs.setUserPref("show_diagnostics_yaml", value) },
   clear = function() { .rs.clearUserPref("show_diagnostics_yaml") }
)

# Show diagnostics in other languages
#
# Whether to show diagnostic messages for other types of code (not R, C++, or
# YAML).
.rs.uiPrefs$showDiagnosticsOther <- list(
   get = function() { .rs.getUserPref("show_diagnostics_other") },
   set = function(value) { .rs.setUserPref("show_diagnostics_other", value) },
   clear = function() { .rs.clearUserPref("show_diagnostics_other") }
)

# Show style diagnostics for R code
#
# Whether to show style diagnostics (suggestions for improving R code style)
.rs.uiPrefs$styleDiagnostics <- list(
   get = function() { .rs.getUserPref("style_diagnostics") },
   set = function(value) { .rs.setUserPref("style_diagnostics", value) },
   clear = function() { .rs.clearUserPref("style_diagnostics") }
)

# Check code for problems when saving
#
# Whether to check code for problems after saving it.
.rs.uiPrefs$diagnosticsOnSave <- list(
   get = function() { .rs.getUserPref("diagnostics_on_save") },
   set = function(value) { .rs.setUserPref("diagnostics_on_save", value) },
   clear = function() { .rs.clearUserPref("diagnostics_on_save") }
)

# Run R code diagnostics in the background
#
# Whether to run code diagnostics in the background, as you type.
.rs.uiPrefs$backgroundDiagnostics <- list(
   get = function() { .rs.getUserPref("background_diagnostics") },
   set = function(value) { .rs.setUserPref("background_diagnostics", value) },
   clear = function() { .rs.clearUserPref("background_diagnostics") }
)

# Run R code diagnostics after (ms)
#
# The number of milliseconds to delay before running code diagnostics in the
# background.
.rs.uiPrefs$backgroundDiagnosticsDelayMs <- list(
   get = function() { .rs.getUserPref("background_diagnostics_delay_ms") },
   set = function(value) { .rs.setUserPref("background_diagnostics_delay_ms", value) },
   clear = function() { .rs.clearUserPref("background_diagnostics_delay_ms") }
)

# Run diagnostics on R function calls
#
# Whether to run diagnostics in R function calls.
.rs.uiPrefs$diagnosticsInRFunctionCalls <- list(
   get = function() { .rs.getUserPref("diagnostics_in_r_function_calls") },
   set = function(value) { .rs.setUserPref("diagnostics_in_r_function_calls", value) },
   clear = function() { .rs.clearUserPref("diagnostics_in_r_function_calls") }
)

# Check arguments to R function calls
#
# Whether to check arguments to R function calls.
.rs.uiPrefs$checkArgumentsToRFunctionCalls <- list(
   get = function() { .rs.getUserPref("check_arguments_to_r_function_calls") },
   set = function(value) { .rs.setUserPref("check_arguments_to_r_function_calls", value) },
   clear = function() { .rs.clearUserPref("check_arguments_to_r_function_calls") }
)

# Check for unexpected assignments
#
# Whether to check for unexpected variable assignments inside R function calls.
.rs.uiPrefs$checkUnexpectedAssignmentInFunctionCall <- list(
   get = function() { .rs.getUserPref("check_unexpected_assignment_in_function_call") },
   set = function(value) { .rs.setUserPref("check_unexpected_assignment_in_function_call", value) },
   clear = function() { .rs.clearUserPref("check_unexpected_assignment_in_function_call") }
)

# Warn when R variable used but not defined
#
# Whether to generate a warning if a variable is used without being defined in
# the current scope.
.rs.uiPrefs$warnIfNoSuchVariableInScope <- list(
   get = function() { .rs.getUserPref("warn_if_no_such_variable_in_scope") },
   set = function(value) { .rs.setUserPref("warn_if_no_such_variable_in_scope", value) },
   clear = function() { .rs.clearUserPref("warn_if_no_such_variable_in_scope") }
)

# Warn when R variable defined but not used
#
# Whether to generate a warning if a variable is defined without being used in
# the current scope
.rs.uiPrefs$warnVariableDefinedButNotUsed <- list(
   get = function() { .rs.getUserPref("warn_variable_defined_but_not_used") },
   set = function(value) { .rs.setUserPref("warn_variable_defined_but_not_used", value) },
   clear = function() { .rs.clearUserPref("warn_variable_defined_but_not_used") }
)

# Detect missing R packages in the editor
#
# Whether to automatically discover and offer to install missing R package
# dependencies.
.rs.uiPrefs$autoDiscoverPackageDependencies <- list(
   get = function() { .rs.getUserPref("auto_discover_package_dependencies") },
   set = function(value) { .rs.setUserPref("auto_discover_package_dependencies", value) },
   clear = function() { .rs.clearUserPref("auto_discover_package_dependencies") }
)

# Ensure files end with a newline when saving
#
# Whether to ensure that source files end with a newline character.
.rs.uiPrefs$autoAppendNewline <- list(
   get = function() { .rs.getUserPref("auto_append_newline") },
   set = function(value) { .rs.setUserPref("auto_append_newline", value) },
   clear = function() { .rs.clearUserPref("auto_append_newline") }
)

# Strip trailing whitespace when saving
#
# Whether to strip trailing whitespace from each line when saving.
.rs.uiPrefs$stripTrailingWhitespace <- list(
   get = function() { .rs.getUserPref("strip_trailing_whitespace") },
   set = function(value) { .rs.setUserPref("strip_trailing_whitespace", value) },
   clear = function() { .rs.clearUserPref("strip_trailing_whitespace") }
)

# Restore cursor position when reopening files
#
# Whether to save the position of the cursor when a file is closed, restore it
# when the file is opened.
.rs.uiPrefs$restoreSourceDocumentCursorPosition <- list(
   get = function() { .rs.getUserPref("restore_source_document_cursor_position") },
   set = function(value) { .rs.setUserPref("restore_source_document_cursor_position", value) },
   clear = function() { .rs.clearUserPref("restore_source_document_cursor_position") }
)

# Re-indent code when pasting
#
# Whether to automatically re-indent code when it's pasted into RStudio.
.rs.uiPrefs$reindentOnPaste <- list(
   get = function() { .rs.getUserPref("reindent_on_paste") },
   set = function(value) { .rs.setUserPref("reindent_on_paste", value) },
   clear = function() { .rs.clearUserPref("reindent_on_paste") }
)

# Vertically align function arguments
#
# Whether to vertically align arguments to R function calls during automatic
# indentation.
.rs.uiPrefs$verticallyAlignArgumentsIndent <- list(
   get = function() { .rs.getUserPref("vertically_align_arguments_indent") },
   set = function(value) { .rs.setUserPref("vertically_align_arguments_indent", value) },
   clear = function() { .rs.clearUserPref("vertically_align_arguments_indent") }
)

# Soft-wrap source files
#
# Whether to soft-wrap source files, wrapping the text for display without
# inserting newline characters.
.rs.uiPrefs$softWrapRFiles <- list(
   get = function() { .rs.getUserPref("soft_wrap_r_files") },
   set = function(value) { .rs.setUserPref("soft_wrap_r_files", value) },
   clear = function() { .rs.clearUserPref("soft_wrap_r_files") }
)

# Soft-wrap R Markdown files
#
# Whether to soft-wrap R Markdown files (and similar types such as R HTML and R
# Notebooks)
.rs.uiPrefs$softWrapRmdFiles <- list(
   get = function() { .rs.getUserPref("soft_wrap_rmd_files") },
   set = function(value) { .rs.setUserPref("soft_wrap_rmd_files", value) },
   clear = function() { .rs.clearUserPref("soft_wrap_rmd_files") }
)

# Focus console after executing R code
#
# Whether to focus the R console after executing an R command from a script.
.rs.uiPrefs$focusConsoleAfterExec <- list(
   get = function() { .rs.getUserPref("focus_console_after_exec") },
   set = function(value) { .rs.setUserPref("focus_console_after_exec", value) },
   clear = function() { .rs.clearUserPref("focus_console_after_exec") }
)

# Fold style in editor
#
# The style of folding to use.
.rs.uiPrefs$foldStyle <- list(
   get = function() { .rs.getUserPref("fold_style") },
   set = function(value) { .rs.setUserPref("fold_style", value) },
   clear = function() { .rs.clearUserPref("fold_style") }
)

# Hierarchical section folding
#
# Whether section headers create nested folds based on their heading level (e.g.
# ## folds inside # sections).
.rs.uiPrefs$hierarchicalSectionFolding <- list(
   get = function() { .rs.getUserPref("hierarchical_section_folding") },
   set = function(value) { .rs.setUserPref("hierarchical_section_folding", value) },
   clear = function() { .rs.clearUserPref("hierarchical_section_folding") }
)

# Save R scripts before sourcing
#
# Whether to automatically save scripts before executing them.
.rs.uiPrefs$saveBeforeSourcing <- list(
   get = function() { .rs.getUserPref("save_before_sourcing") },
   set = function(value) { .rs.setUserPref("save_before_sourcing", value) },
   clear = function() { .rs.clearUserPref("save_before_sourcing") }
)

# Enable soft-wrapping of console output
#
# When enabled, console output will be wrapped at the console width.
.rs.uiPrefs$consoleSoftWrap <- list(
   get = function() { .rs.getUserPref("console_soft_wrap") },
   set = function(value) { .rs.setUserPref("console_soft_wrap", value) },
   clear = function() { .rs.clearUserPref("console_soft_wrap") }
)

# Syntax highlighting in R console
#
# Whether to use syntax highlighting in the R console.
.rs.uiPrefs$syntaxColorConsole <- list(
   get = function() { .rs.getUserPref("syntax_color_console") },
   set = function(value) { .rs.setUserPref("syntax_color_console", value) },
   clear = function() { .rs.clearUserPref("syntax_color_console") }
)

# Different color for error output in R console
#
# Whether to display error, warning, and message output in a different color.
.rs.uiPrefs$highlightConsoleErrors <- list(
   get = function() { .rs.getUserPref("highlight_console_errors") },
   set = function(value) { .rs.setUserPref("highlight_console_errors", value) },
   clear = function() { .rs.clearUserPref("highlight_console_errors") }
)

# Scroll past end of file
#
# Whether to allow scrolling past the end of a file.
.rs.uiPrefs$scrollPastEndOfDocument <- list(
   get = function() { .rs.getUserPref("scroll_past_end_of_document") },
   set = function(value) { .rs.setUserPref("scroll_past_end_of_document", value) },
   clear = function() { .rs.clearUserPref("scroll_past_end_of_document") }
)

# Highlight R function calls
#
# Whether to highlight R function calls in the code editor.
.rs.uiPrefs$highlightRFunctionCalls <- list(
   get = function() { .rs.getUserPref("highlight_r_function_calls") },
   set = function(value) { .rs.setUserPref("highlight_r_function_calls", value) },
   clear = function() { .rs.clearUserPref("highlight_r_function_calls") }
)

# Enable preview of named and hexadecimal colors
#
# Whether to show preview for named and hexadecimal colors.
.rs.uiPrefs$colorPreview <- list(
   get = function() { .rs.getUserPref("color_preview") },
   set = function(value) { .rs.setUserPref("color_preview", value) },
   clear = function() { .rs.clearUserPref("color_preview") }
)

# Use rainbow parentheses
#
# Whether to highlight parentheses in a variety of colors.
.rs.uiPrefs$rainbowParentheses <- list(
   get = function() { .rs.getUserPref("rainbow_parentheses") },
   set = function(value) { .rs.setUserPref("rainbow_parentheses", value) },
   clear = function() { .rs.clearUserPref("rainbow_parentheses") }
)

# Use rainbow fenced divs
#
# Whether to highlight fenced divs in a variety of colors.
.rs.uiPrefs$rainbowFencedDivs <- list(
   get = function() { .rs.getUserPref("rainbow_fenced_divs") },
   set = function(value) { .rs.setUserPref("rainbow_fenced_divs", value) },
   clear = function() { .rs.clearUserPref("rainbow_fenced_divs") }
)

# Maximum characters per line in R console
#
# The maximum number of characters to display in a single line in the R console.
.rs.uiPrefs$consoleLineLengthLimit <- list(
   get = function() { .rs.getUserPref("console_line_length_limit") },
   set = function(value) { .rs.setUserPref("console_line_length_limit", value) },
   clear = function() { .rs.clearUserPref("console_line_length_limit") }
)

# Maximum lines in R console
#
# The maximum number of console actions to store and display in the console
# scrollback buffer.
.rs.uiPrefs$consoleMaxLines <- list(
   get = function() { .rs.getUserPref("console_max_lines") },
   set = function(value) { .rs.setUserPref("console_max_lines", value) },
   clear = function() { .rs.clearUserPref("console_max_lines") }
)

# ANSI escape codes in R console
#
# How to treat ANSI escape codes in the console.
.rs.uiPrefs$ansiConsoleMode <- list(
   get = function() { .rs.getUserPref("ansi_console_mode") },
   set = function(value) { .rs.setUserPref("ansi_console_mode", value) },
   clear = function() { .rs.clearUserPref("ansi_console_mode") }
)

# Show toolbar on R Markdown chunks
#
# Whether to show a toolbar on code chunks in R Markdown documents.
.rs.uiPrefs$showInlineToolbarForRCodeChunks <- list(
   get = function() { .rs.getUserPref("show_inline_toolbar_for_r_code_chunks") },
   set = function(value) { .rs.setUserPref("show_inline_toolbar_for_r_code_chunks", value) },
   clear = function() { .rs.clearUserPref("show_inline_toolbar_for_r_code_chunks") }
)

# Highlight code chunks in R Markdown files
#
# Whether to highlight code chunks in R Markdown documents with a different
# background color.
.rs.uiPrefs$highlightCodeChunks <- list(
   get = function() { .rs.getUserPref("highlight_code_chunks") },
   set = function(value) { .rs.setUserPref("highlight_code_chunks", value) },
   clear = function() { .rs.clearUserPref("highlight_code_chunks") }
)

# Save files before building
#
# Whether to save all open, unsaved files before building the project.
.rs.uiPrefs$saveFilesBeforeBuild <- list(
   get = function() { .rs.getUserPref("save_files_before_build") },
   set = function(value) { .rs.setUserPref("save_files_before_build", value) },
   clear = function() { .rs.clearUserPref("save_files_before_build") }
)

# Save and reload R workspace on build
#
# Whether RStudio should save and reload the R workspace when building the
# project.
.rs.uiPrefs$saveAndReloadWorkspaceOnBuild <- list(
   get = function() { .rs.getUserPref("save_and_reload_workspace_on_build") },
   set = function(value) { .rs.setUserPref("save_and_reload_workspace_on_build", value) },
   clear = function() { .rs.clearUserPref("save_and_reload_workspace_on_build") }
)

# Editor font size (points)
#
# The default editor font size, in points.
.rs.uiPrefs$fontSizePoints <- list(
   get = function() { .rs.getUserPref("font_size_points") },
   set = function(value) { .rs.setUserPref("font_size_points", value) },
   clear = function() { .rs.clearUserPref("font_size_points") }
)

# Editor line height
#
# The editor line height, as a percentage of the font size.
.rs.uiPrefs$editorLineHeight <- list(
   get = function() { .rs.getUserPref("editor_line_height") },
   set = function(value) { .rs.setUserPref("editor_line_height", value) },
   clear = function() { .rs.clearUserPref("editor_line_height") }
)

# Help panel font size (points)
#
# The help panel font size, in points.
.rs.uiPrefs$helpFontSizePoints <- list(
   get = function() { .rs.getUserPref("help_font_size_points") },
   set = function(value) { .rs.setUserPref("help_font_size_points", value) },
   clear = function() { .rs.clearUserPref("help_font_size_points") }
)

# Zoom with mouse wheel when holding Ctrl (Cmd on macOS)
#
# Use Ctrl+Mouse Wheel (Cmd+Mouse Wheel on macOS) to zoom the interface in and
# out.
.rs.uiPrefs$enableMousewheelZoom <- list(
   get = function() { .rs.getUserPref("enable_mousewheel_zoom") },
   set = function(value) { .rs.setUserPref("enable_mousewheel_zoom", value) },
   clear = function() { .rs.clearUserPref("enable_mousewheel_zoom") }
)

# Mouse wheel zoom debounce delay (ms)
#
# A delay in milliseconds to wait before applying the zoom level after a mouse
# wheel event.
.rs.uiPrefs$mousewheelZoomDebounceMs <- list(
   get = function() { .rs.getUserPref("mousewheel_zoom_debounce_ms") },
   set = function(value) { .rs.setUserPref("mousewheel_zoom_debounce_ms", value) },
   clear = function() { .rs.clearUserPref("mousewheel_zoom_debounce_ms") }
)

# Theme
#
# The name of the color theme to apply to the text editor in RStudio.
.rs.uiPrefs$editorTheme <- list(
   get = function() { .rs.getUserPref("editor_theme") },
   set = function(value) { .rs.setUserPref("editor_theme", value) },
   clear = function() { .rs.clearUserPref("editor_theme") }
)

# Ignore project-specific appearance settings
#
# Whether to ignore appearance settings (such as the editor theme) configured at
# the project level, always using the global settings instead.
.rs.uiPrefs$ignoreProjectAppearance <- list(
   get = function() { .rs.getUserPref("ignore_project_appearance") },
   set = function(value) { .rs.setUserPref("ignore_project_appearance", value) },
   clear = function() { .rs.clearUserPref("ignore_project_appearance") }
)

# Enable editor fonts on RStudio Server
#
# Whether to use a custom editor font in RStudio Server.
.rs.uiPrefs$serverEditorFontEnabled <- list(
   get = function() { .rs.getUserPref("server_editor_font_enabled") },
   set = function(value) { .rs.setUserPref("server_editor_font_enabled", value) },
   clear = function() { .rs.clearUserPref("server_editor_font_enabled") }
)

# Editor font
#
# The name of the fixed-width editor font to use with RStudio Server.
.rs.uiPrefs$serverEditorFont <- list(
   get = function() { .rs.getUserPref("server_editor_font") },
   set = function(value) { .rs.setUserPref("server_editor_font", value) },
   clear = function() { .rs.clearUserPref("server_editor_font") }
)

# Default character encoding
#
# The default character encoding to use when saving files.
.rs.uiPrefs$defaultEncoding <- list(
   get = function() { .rs.getUserPref("default_encoding") },
   set = function(value) { .rs.setUserPref("default_encoding", value) },
   clear = function() { .rs.clearUserPref("default_encoding") }
)

# Show top toolbar
#
# Whether to show the toolbar at the top of the RStudio workbench.
.rs.uiPrefs$toolbarVisible <- list(
   get = function() { .rs.getUserPref("toolbar_visible") },
   set = function(value) { .rs.setUserPref("toolbar_visible", value) },
   clear = function() { .rs.clearUserPref("toolbar_visible") }
)

# Default new project location
#
# The directory path under which to place new projects by default.
.rs.uiPrefs$defaultProjectLocation <- list(
   get = function() { .rs.getUserPref("default_project_location") },
   set = function(value) { .rs.setUserPref("default_project_location", value) },
   clear = function() { .rs.clearUserPref("default_project_location") }
)

# Default open project location
#
# The default directory to use in file dialogs when opening a project.
.rs.uiPrefs$defaultOpenProjectLocation <- list(
   get = function() { .rs.getUserPref("default_open_project_location") },
   set = function(value) { .rs.setUserPref("default_open_project_location", value) },
   clear = function() { .rs.clearUserPref("default_open_project_location") }
)

# Source with echo by default
#
# Whether to echo R code when sourcing it.
.rs.uiPrefs$sourceWithEcho <- list(
   get = function() { .rs.getUserPref("source_with_echo") },
   set = function(value) { .rs.setUserPref("source_with_echo", value) },
   clear = function() { .rs.clearUserPref("source_with_echo") }
)

# Default Sweave engine
#
# The default engine to use when processing Sweave documents.
.rs.uiPrefs$defaultSweaveEngine <- list(
   get = function() { .rs.getUserPref("default_sweave_engine") },
   set = function(value) { .rs.setUserPref("default_sweave_engine", value) },
   clear = function() { .rs.clearUserPref("default_sweave_engine") }
)

# Default LaTeX program
#
# The default program to use when processing LaTeX documents.
.rs.uiPrefs$defaultLatexProgram <- list(
   get = function() { .rs.getUserPref("default_latex_program") },
   set = function(value) { .rs.setUserPref("default_latex_program", value) },
   clear = function() { .rs.clearUserPref("default_latex_program") }
)

# Use Roxygen for documentation
#
# Whether to use Roxygen for documentation.
.rs.uiPrefs$useRoxygen <- list(
   get = function() { .rs.getUserPref("use_roxygen") },
   set = function(value) { .rs.setUserPref("use_roxygen", value) },
   clear = function() { .rs.clearUserPref("use_roxygen") }
)

# Enable data import
#
# Whether to use RStudio's data import feature.
.rs.uiPrefs$useDataimport <- list(
   get = function() { .rs.getUserPref("use_dataimport") },
   set = function(value) { .rs.setUserPref("use_dataimport", value) },
   clear = function() { .rs.clearUserPref("use_dataimport") }
)

# PDF previewer
#
# The program to use to preview PDF files after generation.
.rs.uiPrefs$pdfPreviewer <- list(
   get = function() { .rs.getUserPref("pdf_previewer") },
   set = function(value) { .rs.setUserPref("pdf_previewer", value) },
   clear = function() { .rs.clearUserPref("pdf_previewer") }
)

# Enable Rnw concordance
#
# Whether to always enable the concordance for RNW files.
.rs.uiPrefs$alwaysEnableRnwConcordance <- list(
   get = function() { .rs.getUserPref("always_enable_rnw_concordance") },
   set = function(value) { .rs.setUserPref("always_enable_rnw_concordance", value) },
   clear = function() { .rs.clearUserPref("always_enable_rnw_concordance") }
)

# Insert numbered LaTeX sections
#
# Whether to insert numbered sections in LaTeX.
.rs.uiPrefs$insertNumberedLatexSections <- list(
   get = function() { .rs.getUserPref("insert_numbered_latex_sections") },
   set = function(value) { .rs.setUserPref("insert_numbered_latex_sections", value) },
   clear = function() { .rs.clearUserPref("insert_numbered_latex_sections") }
)

# Spelling dictionary language
#
# The language of the spelling dictionary to use for spell checking.
.rs.uiPrefs$spellingDictionaryLanguage <- list(
   get = function() { .rs.getUserPref("spelling_dictionary_language") },
   set = function(value) { .rs.setUserPref("spelling_dictionary_language", value) },
   clear = function() { .rs.clearUserPref("spelling_dictionary_language") }
)

# Custom spelling dictionaries
#
# The list of custom dictionaries to use when spell checking.
.rs.uiPrefs$spellingCustomDictionaries <- list(
   get = function() { .rs.getUserPref("spelling_custom_dictionaries") },
   set = function(value) { .rs.setUserPref("spelling_custom_dictionaries", value) },
   clear = function() { .rs.clearUserPref("spelling_custom_dictionaries") }
)

# Lint document after load (ms)
#
# The number of milliseconds to wait before linting a document after it is
# loaded.
.rs.uiPrefs$documentLoadLintDelay <- list(
   get = function() { .rs.getUserPref("document_load_lint_delay") },
   set = function(value) { .rs.setUserPref("document_load_lint_delay", value) },
   clear = function() { .rs.clearUserPref("document_load_lint_delay") }
)

# Ignore uppercase words in spell check
#
# Whether to ignore words in uppercase when spell checking.
.rs.uiPrefs$ignoreUppercaseWords <- list(
   get = function() { .rs.getUserPref("ignore_uppercase_words") },
   set = function(value) { .rs.setUserPref("ignore_uppercase_words", value) },
   clear = function() { .rs.clearUserPref("ignore_uppercase_words") }
)

# Ignore words with numbers in spell check
#
# Whether to ignore words with numbers in them when spell checking.
.rs.uiPrefs$ignoreWordsWithNumbers <- list(
   get = function() { .rs.getUserPref("ignore_words_with_numbers") },
   set = function(value) { .rs.setUserPref("ignore_words_with_numbers", value) },
   clear = function() { .rs.clearUserPref("ignore_words_with_numbers") }
)

# Use real-time spellchecking
#
# Whether to enable real-time spellchecking by default.
.rs.uiPrefs$realTimeSpellchecking <- list(
   get = function() { .rs.getUserPref("real_time_spellchecking") },
   set = function(value) { .rs.setUserPref("real_time_spellchecking", value) },
   clear = function() { .rs.clearUserPref("real_time_spellchecking") }
)

# Navigate to build errors
#
# Whether to navigate to build errors.
.rs.uiPrefs$navigateToBuildError <- list(
   get = function() { .rs.getUserPref("navigate_to_build_error") },
   set = function(value) { .rs.setUserPref("navigate_to_build_error", value) },
   clear = function() { .rs.clearUserPref("navigate_to_build_error") }
)

# Enable the Packages pane
#
# Whether to enable RStudio's Packages pane.
.rs.uiPrefs$packagesPaneEnabled <- list(
   get = function() { .rs.getUserPref("packages_pane_enabled") },
   set = function(value) { .rs.setUserPref("packages_pane_enabled", value) },
   clear = function() { .rs.clearUserPref("packages_pane_enabled") }
)

# Display the Source column in the Packages pane
#
# Whether to display the Source column in the Package's pane.
.rs.uiPrefs$packagesSourceColumnEnabled <- list(
   get = function() { .rs.getUserPref("packages_source_column_enabled") },
   set = function(value) { .rs.setUserPref("packages_source_column_enabled", value) },
   clear = function() { .rs.clearUserPref("packages_source_column_enabled") }
)

# C++ template
#
# C++ template.
.rs.uiPrefs$cppTemplate <- list(
   get = function() { .rs.getUserPref("cpp_template") },
   set = function(value) { .rs.setUserPref("cpp_template", value) },
   clear = function() { .rs.clearUserPref("cpp_template") }
)

# Restore last opened documents on startup
#
# Whether to restore the last opened source documents when RStudio starts up.
.rs.uiPrefs$restoreSourceDocuments <- list(
   get = function() { .rs.getUserPref("restore_source_documents") },
   set = function(value) { .rs.setUserPref("restore_source_documents", value) },
   clear = function() { .rs.clearUserPref("restore_source_documents") }
)

# Handle errors only when user code present
#
# Whether to handle errors only when user code is on the stack.
.rs.uiPrefs$handleErrorsInUserCodeOnly <- list(
   get = function() { .rs.getUserPref("handle_errors_in_user_code_only") },
   set = function(value) { .rs.setUserPref("handle_errors_in_user_code_only", value) },
   clear = function() { .rs.clearUserPref("handle_errors_in_user_code_only") }
)

# Auto-expand error tracebacks
#
# Whether to automatically expand tracebacks when an error occurs.
.rs.uiPrefs$autoExpandErrorTracebacks <- list(
   get = function() { .rs.getUserPref("auto_expand_error_tracebacks") },
   set = function(value) { .rs.setUserPref("auto_expand_error_tracebacks", value) },
   clear = function() { .rs.clearUserPref("auto_expand_error_tracebacks") }
)

# Check for new version at startup
#
# Whether to check for new versions of RStudio when RStudio starts.
.rs.uiPrefs$checkForUpdates <- list(
   get = function() { .rs.getUserPref("check_for_updates") },
   set = function(value) { .rs.setUserPref("check_for_updates", value) },
   clear = function() { .rs.clearUserPref("check_for_updates") }
)

# Show internal functions when debugging
#
# Whether to show functions without source references in the Traceback pane while
# debugging.
.rs.uiPrefs$showInternalFunctions <- list(
   get = function() { .rs.getUserPref("show_internal_functions") },
   set = function(value) { .rs.setUserPref("show_internal_functions", value) },
   clear = function() { .rs.clearUserPref("show_internal_functions") }
)

# Run Shiny applications in
#
# Where to display Shiny applications when they are run.
.rs.uiPrefs$shinyViewerType <- list(
   get = function() { .rs.getUserPref("shiny_viewer_type") },
   set = function(value) { .rs.setUserPref("shiny_viewer_type", value) },
   clear = function() { .rs.clearUserPref("shiny_viewer_type") }
)

# Run Shiny applications in the background
#
# Whether to run Shiny applications as background jobs.
.rs.uiPrefs$shinyBackgroundJobs <- list(
   get = function() { .rs.getUserPref("shiny_background_jobs") },
   set = function(value) { .rs.setUserPref("shiny_background_jobs", value) },
   clear = function() { .rs.clearUserPref("shiny_background_jobs") }
)

# Run Plumber APIs in
#
# Where to display Shiny applications when they are run.
.rs.uiPrefs$plumberViewerType <- list(
   get = function() { .rs.getUserPref("plumber_viewer_type") },
   set = function(value) { .rs.setUserPref("plumber_viewer_type", value) },
   clear = function() { .rs.clearUserPref("plumber_viewer_type") }
)

# Document author
#
# The default name to use as the document author when creating new documents.
.rs.uiPrefs$documentAuthor <- list(
   get = function() { .rs.getUserPref("document_author") },
   set = function(value) { .rs.setUserPref("document_author", value) },
   clear = function() { .rs.clearUserPref("document_author") }
)

# Use current date when rendering document
#
# Use current date when rendering document
.rs.uiPrefs$rmdAutoDate <- list(
   get = function() { .rs.getUserPref("rmd_auto_date") },
   set = function(value) { .rs.setUserPref("rmd_auto_date", value) },
   clear = function() { .rs.clearUserPref("rmd_auto_date") }
)

# Path to preferred R Markdown template
#
# The path to the preferred R Markdown template.
.rs.uiPrefs$rmdPreferredTemplatePath <- list(
   get = function() { .rs.getUserPref("rmd_preferred_template_path") },
   set = function(value) { .rs.setUserPref("rmd_preferred_template_path", value) },
   clear = function() { .rs.clearUserPref("rmd_preferred_template_path") }
)

# Display R Markdown documents in
#
# Where to display R Markdown documents when they have completed rendering.
.rs.uiPrefs$rmdViewerType <- list(
   get = function() { .rs.getUserPref("rmd_viewer_type") },
   set = function(value) { .rs.setUserPref("rmd_viewer_type", value) },
   clear = function() { .rs.clearUserPref("rmd_viewer_type") }
)

# Show diagnostic info when publishing
#
# Whether to show verbose diagnostic information when publishing content.
.rs.uiPrefs$showPublishDiagnostics <- list(
   get = function() { .rs.getUserPref("show_publish_diagnostics") },
   set = function(value) { .rs.setUserPref("show_publish_diagnostics", value) },
   clear = function() { .rs.clearUserPref("show_publish_diagnostics") }
)

# Check SSL certificates when publishing
#
# Whether to check remote server SSL certificates when publishing content.
.rs.uiPrefs$publishCheckCertificates <- list(
   get = function() { .rs.getUserPref("publish_check_certificates") },
   set = function(value) { .rs.setUserPref("publish_check_certificates", value) },
   clear = function() { .rs.clearUserPref("publish_check_certificates") }
)

# Use custom CA bundle when publishing
#
# Whether to use a custom certificate authority (CA) bundle when publishing
# content.
.rs.uiPrefs$usePublishCaBundle <- list(
   get = function() { .rs.getUserPref("use_publish_ca_bundle") },
   set = function(value) { .rs.setUserPref("use_publish_ca_bundle", value) },
   clear = function() { .rs.clearUserPref("use_publish_ca_bundle") }
)

# Path to custom CA bundle for publishing
#
# The path to the custom certificate authority (CA) bundle to use when publishing
# content.
.rs.uiPrefs$publishCaBundle <- list(
   get = function() { .rs.getUserPref("publish_ca_bundle") },
   set = function(value) { .rs.setUserPref("publish_ca_bundle", value) },
   clear = function() { .rs.clearUserPref("publish_ca_bundle") }
)

# Show chunk output inline in all documents
#
# Whether to show chunk output inline for ordinary R Markdown documents.
.rs.uiPrefs$rmdChunkOutputInline <- list(
   get = function() { .rs.getUserPref("rmd_chunk_output_inline") },
   set = function(value) { .rs.setUserPref("rmd_chunk_output_inline", value) },
   clear = function() { .rs.clearUserPref("rmd_chunk_output_inline") }
)

# Open document outline by default
#
# Whether to show the document outline by default when opening R Markdown
# documents.
.rs.uiPrefs$showDocOutlineRmd <- list(
   get = function() { .rs.getUserPref("show_doc_outline_rmd") },
   set = function(value) { .rs.setUserPref("show_doc_outline_rmd", value) },
   clear = function() { .rs.clearUserPref("show_doc_outline_rmd") }
)

# Document outline font size
#
# The font size to use for items in the document outline.
.rs.uiPrefs$documentOutlineFontSize <- list(
   get = function() { .rs.getUserPref("document_outline_font_size") },
   set = function(value) { .rs.setUserPref("document_outline_font_size", value) },
   clear = function() { .rs.clearUserPref("document_outline_font_size") }
)

# Automatically run Setup chunk when needed
#
# Whether to automatically run an R Markdown document's Setup chunk before
# running other chunks.
.rs.uiPrefs$autoRunSetupChunk <- list(
   get = function() { .rs.getUserPref("auto_run_setup_chunk") },
   set = function(value) { .rs.setUserPref("auto_run_setup_chunk", value) },
   clear = function() { .rs.clearUserPref("auto_run_setup_chunk") }
)

# Execute inline R code when previewing notebooks
#
# Whether to evaluate a notebook's inline R code in the current R session when
# creating a notebook preview, so that inline code can use objects in the global
# environment. When disabled, inline code is evaluated in the background
# rendering process instead.
.rs.uiPrefs$notebookExecuteInlineChunks <- list(
   get = function() { .rs.getUserPref("notebook_execute_inline_chunks") },
   set = function(value) { .rs.setUserPref("notebook_execute_inline_chunks", value) },
   clear = function() { .rs.clearUserPref("notebook_execute_inline_chunks") }
)

# Hide console when running R Markdown chunks
#
# Whether to hide the R console when executing inline R Markdown chunks.
.rs.uiPrefs$hideConsoleOnChunkExecute <- list(
   get = function() { .rs.getUserPref("hide_console_on_chunk_execute") },
   set = function(value) { .rs.setUserPref("hide_console_on_chunk_execute", value) },
   clear = function() { .rs.clearUserPref("hide_console_on_chunk_execute") }
)

# Unit of R code execution
#
# The unit of R code to execute when the Execute command is invoked.
.rs.uiPrefs$executionBehavior <- list(
   get = function() { .rs.getUserPref("execution_behavior") },
   set = function(value) { .rs.setUserPref("execution_behavior", value) },
   clear = function() { .rs.clearUserPref("execution_behavior") }
)

# Show the Terminal tab
#
# Whether to show the Terminal tab.
.rs.uiPrefs$showTerminalTab <- list(
   get = function() { .rs.getUserPref("show_terminal_tab") },
   set = function(value) { .rs.setUserPref("show_terminal_tab", value) },
   clear = function() { .rs.clearUserPref("show_terminal_tab") }
)

# Use local echo in the Terminal
#
# Whether to use local echo in the Terminal.
.rs.uiPrefs$terminalLocalEcho <- list(
   get = function() { .rs.getUserPref("terminal_local_echo") },
   set = function(value) { .rs.setUserPref("terminal_local_echo", value) },
   clear = function() { .rs.clearUserPref("terminal_local_echo") }
)

# Use websockets in the Terminal
#
# Whether to use websockets to communicate with the shell in the Terminal tab.
.rs.uiPrefs$terminalWebsockets <- list(
   get = function() { .rs.getUserPref("terminal_websockets") },
   set = function(value) { .rs.setUserPref("terminal_websockets", value) },
   clear = function() { .rs.clearUserPref("terminal_websockets") }
)

# Close Terminal pane after shell exit
#
# Whether to close the terminal pane after the shell exits.
.rs.uiPrefs$terminalCloseBehavior <- list(
   get = function() { .rs.getUserPref("terminal_close_behavior") },
   set = function(value) { .rs.setUserPref("terminal_close_behavior", value) },
   clear = function() { .rs.clearUserPref("terminal_close_behavior") }
)

# Save and restore system environment in Terminal tab
#
# Whether to track and save changes to system environment variables in the
# Terminal.
.rs.uiPrefs$terminalTrackEnvironment <- list(
   get = function() { .rs.getUserPref("terminal_track_environment") },
   set = function(value) { .rs.setUserPref("terminal_track_environment", value) },
   clear = function() { .rs.clearUserPref("terminal_track_environment") }
)

# Ignored environment variables
#
# Environment variables which should be ignored when tracking changed to
# environment variables within a Terminal. Environment variables in this list
# will not be saved when a Terminal instance is saved and restored.
.rs.uiPrefs$terminalIgnoredEnvironmentVariables <- list(
   get = function() { .rs.getUserPref("terminal_ignored_environment_variables") },
   set = function(value) { .rs.setUserPref("terminal_ignored_environment_variables", value) },
   clear = function() { .rs.clearUserPref("terminal_ignored_environment_variables") }
)

# Enable Terminal hooks
#
# Enabled Terminal hooks? Required for Python terminal integration, which places
# the active version of Python on the PATH in new Terminal sessions.
.rs.uiPrefs$terminalHooks <- list(
   get = function() { .rs.getUserPref("terminal_hooks") },
   set = function(value) { .rs.setUserPref("terminal_hooks", value) },
   clear = function() { .rs.clearUserPref("terminal_hooks") }
)

# Terminal bell style
#
# Terminal bell style
.rs.uiPrefs$terminalBellStyle <- list(
   get = function() { .rs.getUserPref("terminal_bell_style") },
   set = function(value) { .rs.setUserPref("terminal_bell_style", value) },
   clear = function() { .rs.clearUserPref("terminal_bell_style") }
)

# Terminal tab rendering engine
#
# Terminal rendering engine: canvas is faster, dom may be needed for some
# browsers or graphics cards
.rs.uiPrefs$terminalRenderer <- list(
   get = function() { .rs.getUserPref("terminal_renderer") },
   set = function(value) { .rs.setUserPref("terminal_renderer", value) },
   clear = function() { .rs.clearUserPref("terminal_renderer") }
)

# Make links in Terminal clickable
#
# Whether web links displayed in the Terminal tab are made clickable.
.rs.uiPrefs$terminalWeblinks <- list(
   get = function() { .rs.getUserPref("terminal_weblinks") },
   set = function(value) { .rs.setUserPref("terminal_weblinks", value) },
   clear = function() { .rs.clearUserPref("terminal_weblinks") }
)

# Show R Markdown render command
#
# Whether to print the render command use to knit R Markdown documents in the R
# Markdown tab.
.rs.uiPrefs$showRmdRenderCommand <- list(
   get = function() { .rs.getUserPref("show_rmd_render_command") },
   set = function(value) { .rs.setUserPref("show_rmd_render_command", value) },
   clear = function() { .rs.clearUserPref("show_rmd_render_command") }
)

# Rename in scope operates on:
#
# Controls whether the Rename in Scope command acts only upon the current chunk,
# or upon all chunks in the document. Multiple executions of the command will
# toggle between the two selection types.
.rs.uiPrefs$rmdRenameInScopeBehavior <- list(
   get = function() { .rs.getUserPref("rmd_rename_in_scope_behavior") },
   set = function(value) { .rs.setUserPref("rmd_rename_in_scope_behavior", value) },
   clear = function() { .rs.clearUserPref("rmd_rename_in_scope_behavior") }
)

# Enable dragging text in code editor
#
# Whether to enable moving text on the editing surface by clicking and dragging
# it.
.rs.uiPrefs$enableTextDrag <- list(
   get = function() { .rs.getUserPref("enable_text_drag") },
   set = function(value) { .rs.setUserPref("enable_text_drag", value) },
   clear = function() { .rs.clearUserPref("enable_text_drag") }
)

# Show hidden files in Files pane
#
# Whether to show hidden files in the Files pane.
.rs.uiPrefs$showHiddenFiles <- list(
   get = function() { .rs.getUserPref("show_hidden_files") },
   set = function(value) { .rs.setUserPref("show_hidden_files", value) },
   clear = function() { .rs.clearUserPref("show_hidden_files") }
)

# Delete files to Trash/Recycle Bin
#
# Whether to move deleted files to the system Trash/Recycle Bin instead of
# permanently deleting them.
.rs.uiPrefs$deleteToTrash <- list(
   get = function() { .rs.getUserPref("delete_to_trash") },
   set = function(value) { .rs.setUserPref("delete_to_trash", value) },
   clear = function() { .rs.clearUserPref("delete_to_trash") }
)

# Files always shown in the Files Pane
#
# List of file names (case sensitive) that are always shown in the Files Pane,
# regardless of whether hidden files are shown
.rs.uiPrefs$alwaysShownFiles <- list(
   get = function() { .rs.getUserPref("always_shown_files") },
   set = function(value) { .rs.setUserPref("always_shown_files", value) },
   clear = function() { .rs.clearUserPref("always_shown_files") }
)

# Extensions always shown in the Files Pane
#
# List of file extensions (beginning with ., not case sensitive) that are always
# shown in the Files Pane, regardless of whether hidden files are shown
.rs.uiPrefs$alwaysShownExtensions <- list(
   get = function() { .rs.getUserPref("always_shown_extensions") },
   set = function(value) { .rs.setUserPref("always_shown_extensions", value) },
   clear = function() { .rs.clearUserPref("always_shown_extensions") }
)

# Sort file names naturally in Files pane
#
# Whether to sort file names naturally, so that e.g., file10.R comes after
# file9.R
.rs.uiPrefs$sortFileNamesNaturally <- list(
   get = function() { .rs.getUserPref("sort_file_names_naturally") },
   set = function(value) { .rs.setUserPref("sort_file_names_naturally", value) },
   clear = function() { .rs.clearUserPref("sort_file_names_naturally") }
)

# Use ISO-8601 date-time formatting
#
# Whether to display dates and times using the ISO-8601 format (e.g. 2026-03-09
# 14:30) instead of the format inferred from the system region.
.rs.uiPrefs$dateTimeUseIso8601 <- list(
   get = function() { .rs.getUserPref("date_time_use_iso8601") },
   set = function(value) { .rs.setUserPref("date_time_use_iso8601", value) },
   clear = function() { .rs.clearUserPref("date_time_use_iso8601") }
)

# Use UTC time zone
#
# Whether to display dates and times in the UTC time zone instead of the local
# time zone.
.rs.uiPrefs$dateTimeUseUtc <- list(
   get = function() { .rs.getUserPref("date_time_use_utc") },
   set = function(value) { .rs.setUserPref("date_time_use_utc", value) },
   clear = function() { .rs.clearUserPref("date_time_use_utc") }
)

# Synchronize the Files pane with the current working directory
#
# Whether to change the directory in the Files pane automatically when the
# working directory in R changes.
.rs.uiPrefs$syncFilesPaneWorkingDir <- list(
   get = function() { .rs.getUserPref("sync_files_pane_working_dir") },
   set = function(value) { .rs.setUserPref("sync_files_pane_working_dir", value) },
   clear = function() { .rs.clearUserPref("sync_files_pane_working_dir") }
)

# Jobs tab visibility
#
# The visibility of the Jobs tab.
.rs.uiPrefs$jobsTabVisibility <- list(
   get = function() { .rs.getUserPref("jobs_tab_visibility") },
   set = function(value) { .rs.setUserPref("jobs_tab_visibility", value) },
   clear = function() { .rs.clearUserPref("jobs_tab_visibility") }
)

# 
#
# Whether to show the Workbench Jobs tab in RStudio Pro and RStudio Workbench.
.rs.uiPrefs$showLauncherJobsTab <- list(
   get = function() { .rs.getUserPref("show_launcher_jobs_tab") },
   set = function(value) { .rs.setUserPref("show_launcher_jobs_tab", value) },
   clear = function() { .rs.clearUserPref("show_launcher_jobs_tab") }
)

# 
#
# How to sort jobs in the Workbench Jobs tab in RStudio Pro and RStudio
# Workbench.
.rs.uiPrefs$launcherJobsSort <- list(
   get = function() { .rs.getUserPref("launcher_jobs_sort") },
   set = function(value) { .rs.setUserPref("launcher_jobs_sort", value) },
   clear = function() { .rs.clearUserPref("launcher_jobs_sort") }
)

# 
#
# How to detect busy status in the Terminal.
.rs.uiPrefs$busyDetection <- list(
   get = function() { .rs.getUserPref("busy_detection") },
   set = function(value) { .rs.setUserPref("busy_detection", value) },
   clear = function() { .rs.clearUserPref("busy_detection") }
)

# 
#
# A list of apps that should not be considered busy in the Terminal.
.rs.uiPrefs$busyExclusionList <- list(
   get = function() { .rs.getUserPref("busy_exclusion_list") },
   set = function(value) { .rs.setUserPref("busy_exclusion_list", value) },
   clear = function() { .rs.clearUserPref("busy_exclusion_list") }
)

# Working directory for knitting
#
# The working directory to use when knitting R Markdown documents.
.rs.uiPrefs$knitWorkingDir <- list(
   get = function() { .rs.getUserPref("knit_working_dir") },
   set = function(value) { .rs.setUserPref("knit_working_dir", value) },
   clear = function() { .rs.clearUserPref("knit_working_dir") }
)

# Show in Document Outline
#
# Which objects to show in the document outline pane.
.rs.uiPrefs$docOutlineShow <- list(
   get = function() { .rs.getUserPref("doc_outline_show") },
   set = function(value) { .rs.setUserPref("doc_outline_show", value) },
   clear = function() { .rs.clearUserPref("doc_outline_show") }
)

# Preview LaTeX equations on idle
#
# When to preview LaTeX mathematical equations when cursor has not moved
# recently.
.rs.uiPrefs$latexPreviewOnCursorIdle <- list(
   get = function() { .rs.getUserPref("latex_preview_on_cursor_idle") },
   set = function(value) { .rs.setUserPref("latex_preview_on_cursor_idle", value) },
   clear = function() { .rs.clearUserPref("latex_preview_on_cursor_idle") }
)

# Wrap around when going to previous/next tab
#
# Whether to wrap around when going to the previous or next editor tab.
.rs.uiPrefs$wrapTabNavigation <- list(
   get = function() { .rs.getUserPref("wrap_tab_navigation") },
   set = function(value) { .rs.setUserPref("wrap_tab_navigation", value) },
   clear = function() { .rs.clearUserPref("wrap_tab_navigation") }
)

# Change active editor tab with mouse wheel
#
# Whether scrolling the mouse wheel over the editor tab bar changes the active
# editor tab.
.rs.uiPrefs$mousewheelChangesEditorTab <- list(
   get = function() { .rs.getUserPref("mousewheel_changes_editor_tab") },
   set = function(value) { .rs.setUserPref("mousewheel_changes_editor_tab", value) },
   clear = function() { .rs.clearUserPref("mousewheel_changes_editor_tab") }
)

# Global theme
#
# The theme to use for the main RStudio user interface.
.rs.uiPrefs$globalTheme <- list(
   get = function() { .rs.getUserPref("global_theme") },
   set = function(value) { .rs.setUserPref("global_theme", value) },
   clear = function() { .rs.clearUserPref("global_theme") }
)

# Use dark theme modal dialogs
#
# Whether modal dialogs should use dark styling when a dark editor theme is
# active.
.rs.uiPrefs$useDarkThemeModalDialogs <- list(
   get = function() { .rs.getUserPref("use_dark_theme_modal_dialogs") },
   set = function(value) { .rs.setUserPref("use_dark_theme_modal_dialogs", value) },
   clear = function() { .rs.clearUserPref("use_dark_theme_modal_dialogs") }
)

# Ignore whitespace in VCS diffs
#
# Whether to ignore whitespace when generating diffs of version controlled files.
.rs.uiPrefs$gitDiffIgnoreWhitespace <- list(
   get = function() { .rs.getUserPref("git_diff_ignore_whitespace") },
   set = function(value) { .rs.setUserPref("git_diff_ignore_whitespace", value) },
   clear = function() { .rs.clearUserPref("git_diff_ignore_whitespace") }
)

# Sign git commits
#
# Whether to sign git commits.
.rs.uiPrefs$gitSignedCommits <- list(
   get = function() { .rs.getUserPref("git_signed_commits") },
   set = function(value) { .rs.setUserPref("git_signed_commits", value) },
   clear = function() { .rs.clearUserPref("git_signed_commits") }
)

# Double click to select in the Console
#
# Whether double-clicking should select a word in the Console pane.
.rs.uiPrefs$consoleDoubleClickSelect <- list(
   get = function() { .rs.getUserPref("console_double_click_select") },
   set = function(value) { .rs.setUserPref("console_double_click_select", value) },
   clear = function() { .rs.clearUserPref("console_double_click_select") }
)

# Warn when automatic session suspension is paused
#
# Whether the 'Auto Suspension Blocked' icon should appear in the R Console
# toolbar.
.rs.uiPrefs$consoleSuspendBlockedNotice <- list(
   get = function() { .rs.getUserPref("console_suspend_blocked_notice") },
   set = function(value) { .rs.setUserPref("console_suspend_blocked_notice", value) },
   clear = function() { .rs.clearUserPref("console_suspend_blocked_notice") }
)

# Number of seconds to delay warning
#
# How long to wait before warning that automatic session suspension has been
# paused. Higher values for less frequent notices.
.rs.uiPrefs$consoleSuspendBlockedNoticeDelay <- list(
   get = function() { .rs.getUserPref("console_suspend_blocked_notice_delay") },
   set = function(value) { .rs.setUserPref("console_suspend_blocked_notice_delay", value) },
   clear = function() { .rs.clearUserPref("console_suspend_blocked_notice_delay") }
)

# Create a Git repo in new projects
#
# Whether a git repo should be initialized inside new projects by default.
.rs.uiPrefs$newProjGitInit <- list(
   get = function() { .rs.getUserPref("new_proj_git_init") },
   set = function(value) { .rs.setUserPref("new_proj_git_init", value) },
   clear = function() { .rs.clearUserPref("new_proj_git_init") }
)

# Create an renv environment in new projects
#
# Whether an renv environment should be created inside new projects by default.
.rs.uiPrefs$newProjUseRenv <- list(
   get = function() { .rs.getUserPref("new_proj_use_renv") },
   set = function(value) { .rs.setUserPref("new_proj_use_renv", value) },
   clear = function() { .rs.clearUserPref("new_proj_use_renv") }
)

# Root document for PDF compilation
#
# The root document to use when compiling PDF documents.
.rs.uiPrefs$rootDocument <- list(
   get = function() { .rs.getUserPref("root_document") },
   set = function(value) { .rs.setUserPref("root_document", value) },
   clear = function() { .rs.clearUserPref("root_document") }
)

# Show user home page in RStudio Workbench
#
# When to show the server home page in RStudio Workbench.
.rs.uiPrefs$showUserHomePage <- list(
   get = function() { .rs.getUserPref("show_user_home_page") },
   set = function(value) { .rs.setUserPref("show_user_home_page", value) },
   clear = function() { .rs.clearUserPref("show_user_home_page") }
)

# 
#
# Whether to reuse sessions when opening projects in RStudio Workbench.
.rs.uiPrefs$reuseSessionsForProjectLinks <- list(
   get = function() { .rs.getUserPref("reuse_sessions_for_project_links") },
   set = function(value) { .rs.setUserPref("reuse_sessions_for_project_links", value) },
   clear = function() { .rs.clearUserPref("reuse_sessions_for_project_links") }
)

# Enable version control if available
#
# Whether to enable RStudio's version control system interface.
.rs.uiPrefs$vcsEnabled <- list(
   get = function() { .rs.getUserPref("vcs_enabled") },
   set = function(value) { .rs.setUserPref("vcs_enabled", value) },
   clear = function() { .rs.clearUserPref("vcs_enabled") }
)

# Auto-refresh state from version control
#
# Automatically refresh VCS status?
.rs.uiPrefs$vcsAutorefresh <- list(
   get = function() { .rs.getUserPref("vcs_autorefresh") },
   set = function(value) { .rs.setUserPref("vcs_autorefresh", value) },
   clear = function() { .rs.clearUserPref("vcs_autorefresh") }
)

# Path to Git executable
#
# The path to the Git executable to use.
.rs.uiPrefs$gitExePath <- list(
   get = function() { .rs.getUserPref("git_exe_path") },
   set = function(value) { .rs.setUserPref("git_exe_path", value) },
   clear = function() { .rs.clearUserPref("git_exe_path") }
)

# Path to Subversion executable
#
# The path to the Subversion executable to use.
.rs.uiPrefs$svnExePath <- list(
   get = function() { .rs.getUserPref("svn_exe_path") },
   set = function(value) { .rs.setUserPref("svn_exe_path", value) },
   clear = function() { .rs.clearUserPref("svn_exe_path") }
)

# 
#
# The path to the terminal executable to use.
.rs.uiPrefs$terminalPath <- list(
   get = function() { .rs.getUserPref("terminal_path") },
   set = function(value) { .rs.setUserPref("terminal_path", value) },
   clear = function() { .rs.clearUserPref("terminal_path") }
)

# 
#
# The path to the SSH key file to use.
.rs.uiPrefs$rsaKeyPath <- list(
   get = function() { .rs.getUserPref("rsa_key_path") },
   set = function(value) { .rs.setUserPref("rsa_key_path", value) },
   clear = function() { .rs.clearUserPref("rsa_key_path") }
)

# 
#
# The encryption type to use for the SSH key file.
.rs.uiPrefs$sshKeyType <- list(
   get = function() { .rs.getUserPref("ssh_key_type") },
   set = function(value) { .rs.setUserPref("ssh_key_type", value) },
   clear = function() { .rs.clearUserPref("ssh_key_type") }
)

# Use the devtools R package if available
#
# Whether to use the devtools R package.
.rs.uiPrefs$useDevtools <- list(
   get = function() { .rs.getUserPref("use_devtools") },
   set = function(value) { .rs.setUserPref("use_devtools", value) },
   clear = function() { .rs.clearUserPref("use_devtools") }
)

# Always use --preclean when installing package
#
# Always use --preclean when installing package.
.rs.uiPrefs$cleanBeforeInstall <- list(
   get = function() { .rs.getUserPref("clean_before_install") },
   set = function(value) { .rs.setUserPref("clean_before_install", value) },
   clear = function() { .rs.clearUserPref("clean_before_install") }
)

# Use alternate library path when building package
#
# When set, RStudio will build your package in a '_build' sub-directory of your
# current library paths.
.rs.uiPrefs$useBuildSubdirectory <- list(
   get = function() { .rs.getUserPref("use_build_subdirectory") },
   set = function(value) { .rs.setUserPref("use_build_subdirectory", value) },
   clear = function() { .rs.clearUserPref("use_build_subdirectory") }
)

# Download R packages securely
#
# Whether to use secure downloads when fetching R packages.
.rs.uiPrefs$useSecureDownload <- list(
   get = function() { .rs.getUserPref("use_secure_download") },
   set = function(value) { .rs.setUserPref("use_secure_download", value) },
   clear = function() { .rs.clearUserPref("use_secure_download") }
)

# Clean up temporary files after R CMD CHECK
#
# Whether to clean up temporary files after running R CMD CHECK.
.rs.uiPrefs$cleanupAfterRCmdCheck <- list(
   get = function() { .rs.getUserPref("cleanup_after_r_cmd_check") },
   set = function(value) { .rs.setUserPref("cleanup_after_r_cmd_check", value) },
   clear = function() { .rs.clearUserPref("cleanup_after_r_cmd_check") }
)

# View directory after R CMD CHECK
#
# Whether to view the directory after running R CMD CHECK.
.rs.uiPrefs$viewDirAfterRCmdCheck <- list(
   get = function() { .rs.getUserPref("view_dir_after_r_cmd_check") },
   set = function(value) { .rs.setUserPref("view_dir_after_r_cmd_check", value) },
   clear = function() { .rs.clearUserPref("view_dir_after_r_cmd_check") }
)

# Hide object files in the Files pane
#
# Whether to hide object files in the Files pane.
.rs.uiPrefs$hideObjectFiles <- list(
   get = function() { .rs.getUserPref("hide_object_files") },
   set = function(value) { .rs.setUserPref("hide_object_files", value) },
   clear = function() { .rs.clearUserPref("hide_object_files") }
)

# Restore last project when starting RStudio
#
# Whether to restore the last project when starting RStudio.
.rs.uiPrefs$restoreLastProject <- list(
   get = function() { .rs.getUserPref("restore_last_project") },
   set = function(value) { .rs.setUserPref("restore_last_project", value) },
   clear = function() { .rs.clearUserPref("restore_last_project") }
)

# Number of seconds for safe project startup
#
# The number of seconds after which a project is deemed to have successfully
# started.
.rs.uiPrefs$projectSafeStartupSeconds <- list(
   get = function() { .rs.getUserPref("project_safe_startup_seconds") },
   set = function(value) { .rs.setUserPref("project_safe_startup_seconds", value) },
   clear = function() { .rs.clearUserPref("project_safe_startup_seconds") }
)

# Use tinytex to compile .tex files
#
# Use tinytex to compile .tex files.
.rs.uiPrefs$useTinytex <- list(
   get = function() { .rs.getUserPref("use_tinytex") },
   set = function(value) { .rs.setUserPref("use_tinytex", value) },
   clear = function() { .rs.clearUserPref("use_tinytex") }
)

# Clean output after running Texi2Dvi
#
# Whether to clean output after running Texi2Dvi.
.rs.uiPrefs$cleanTexi2dviOutput <- list(
   get = function() { .rs.getUserPref("clean_texi2dvi_output") },
   set = function(value) { .rs.setUserPref("clean_texi2dvi_output", value) },
   clear = function() { .rs.clearUserPref("clean_texi2dvi_output") }
)

# Shell escape LaTeX documents
#
# Whether to enable shell escaping with LaTeX documents.
.rs.uiPrefs$latexShellEscape <- list(
   get = function() { .rs.getUserPref("latex_shell_escape") },
   set = function(value) { .rs.setUserPref("latex_shell_escape", value) },
   clear = function() { .rs.clearUserPref("latex_shell_escape") }
)

# Restore project R version in RStudio Pro and RStudio Workbench
#
# Whether to restore the last version of R used by the project in RStudio Pro and
# RStudio Workbench.
.rs.uiPrefs$restoreProjectRVersion <- list(
   get = function() { .rs.getUserPref("restore_project_r_version") },
   set = function(value) { .rs.setUserPref("restore_project_r_version", value) },
   clear = function() { .rs.clearUserPref("restore_project_r_version") }
)

# Clang verbosity level (0 - 2)
#
# The verbosity level to use with Clang (0 - 2)
.rs.uiPrefs$clangVerbose <- list(
   get = function() { .rs.getUserPref("clang_verbose") },
   set = function(value) { .rs.setUserPref("clang_verbose", value) },
   clear = function() { .rs.clearUserPref("clang_verbose") }
)

# Show splash screen when RStudio is starting
#
# Whether to show the splash screen when RStudio is starting.
.rs.uiPrefs$enableSplashScreen <- list(
   get = function() { .rs.getUserPref("enable_splash_screen") },
   set = function(value) { .rs.setUserPref("enable_splash_screen", value) },
   clear = function() { .rs.clearUserPref("enable_splash_screen") }
)

# 
#
# The R version to use by default.
.rs.uiPrefs$defaultRVersion <- list(
   get = function() { .rs.getUserPref("default_r_version") },
   set = function(value) { .rs.setUserPref("default_r_version", value) },
   clear = function() { .rs.clearUserPref("default_r_version") }
)

# Maximum number of columns in data viewer
#
# The maximum number of columns to show at once in the data viewer.
.rs.uiPrefs$dataViewerMaxColumns <- list(
   get = function() { .rs.getUserPref("data_viewer_max_columns") },
   set = function(value) { .rs.setUserPref("data_viewer_max_columns", value) },
   clear = function() { .rs.clearUserPref("data_viewer_max_columns") }
)

# Maximum number of character in data viewer cells
#
# The maximum number of characters to show in a data viewer cell.
.rs.uiPrefs$dataViewerMaxCellSize <- list(
   get = function() { .rs.getUserPref("data_viewer_max_cell_size") },
   set = function(value) { .rs.setUserPref("data_viewer_max_cell_size", value) },
   clear = function() { .rs.clearUserPref("data_viewer_max_cell_size") }
)

# Show data viewer summary panel by default
#
# Whether the Summary side panel is shown by default when opening the data
# viewer.
.rs.uiPrefs$dataViewerShowSummary <- list(
   get = function() { .rs.getUserPref("data_viewer_show_summary") },
   set = function(value) { .rs.setUserPref("data_viewer_show_summary", value) },
   clear = function() { .rs.clearUserPref("data_viewer_show_summary") }
)

# Show data viewer filter UI by default
#
# Whether the data viewer filter UI is shown by default when opening the data
# viewer.
.rs.uiPrefs$dataViewerShowFilters <- list(
   get = function() { .rs.getUserPref("data_viewer_show_filters") },
   set = function(value) { .rs.setUserPref("data_viewer_show_filters", value) },
   clear = function() { .rs.clearUserPref("data_viewer_show_filters") }
)

# Use overlay scrollbars in the data viewer
#
# Whether the data viewer draws its own overlay scrollbars; when disabled, native
# scrollbars are used instead.
.rs.uiPrefs$dataViewerUseOverlayScrollbars <- list(
   get = function() { .rs.getUserPref("data_viewer_use_overlay_scrollbars") },
   set = function(value) { .rs.setUserPref("data_viewer_use_overlay_scrollbars", value) },
   clear = function() { .rs.clearUserPref("data_viewer_use_overlay_scrollbars") }
)

# Enable support for screen readers
#
# Support accessibility aids such as screen readers.
.rs.uiPrefs$enableScreenReader <- list(
   get = function() { .rs.getUserPref("enable_screen_reader") },
   set = function(value) { .rs.setUserPref("enable_screen_reader", value) },
   clear = function() { .rs.clearUserPref("enable_screen_reader") }
)

# Seconds to wait before updating ARIA live region
#
# Number of milliseconds to wait after last keystroke before updating live
# region.
.rs.uiPrefs$typingStatusDelayMs <- list(
   get = function() { .rs.getUserPref("typing_status_delay_ms") },
   set = function(value) { .rs.setUserPref("typing_status_delay_ms", value) },
   clear = function() { .rs.clearUserPref("typing_status_delay_ms") }
)

# Reduced animation/motion mode
#
# Reduce use of animations in the user interface.
.rs.uiPrefs$reducedMotion <- list(
   get = function() { .rs.getUserPref("reduced_motion") },
   set = function(value) { .rs.setUserPref("reduced_motion", value) },
   clear = function() { .rs.clearUserPref("reduced_motion") }
)

# Tab key always moves focus
#
# Tab key moves focus out of text editing controls instead of inserting tabs.
.rs.uiPrefs$tabKeyMoveFocus <- list(
   get = function() { .rs.getUserPref("tab_key_move_focus") },
   set = function(value) { .rs.setUserPref("tab_key_move_focus", value) },
   clear = function() { .rs.clearUserPref("tab_key_move_focus") }
)

# Tab key moves focus directly from find text to replace text in find panel
#
# In source editor find panel, tab key moves focus directly from find text to
# replace text.
.rs.uiPrefs$findPanelLegacyTabSequence <- list(
   get = function() { .rs.getUserPref("find_panel_legacy_tab_sequence") },
   set = function(value) { .rs.setUserPref("find_panel_legacy_tab_sequence", value) },
   clear = function() { .rs.clearUserPref("find_panel_legacy_tab_sequence") }
)

# Show focus outline around focused panel
#
# Show which panel contains keyboard focus.
.rs.uiPrefs$showPanelFocusRectangle <- list(
   get = function() { .rs.getUserPref("show_panel_focus_rectangle") },
   set = function(value) { .rs.setUserPref("show_panel_focus_rectangle", value) },
   clear = function() { .rs.clearUserPref("show_panel_focus_rectangle") }
)

# Autosave mode on idle
#
# How to deal with changes to documents on idle.
.rs.uiPrefs$autoSaveOnIdle <- list(
   get = function() { .rs.getUserPref("auto_save_on_idle") },
   set = function(value) { .rs.setUserPref("auto_save_on_idle", value) },
   clear = function() { .rs.clearUserPref("auto_save_on_idle") }
)

# Idle period for document autosave (ms)
#
# The idle period, in milliseconds, after which documents should be auto-saved.
.rs.uiPrefs$autoSaveIdleMs <- list(
   get = function() { .rs.getUserPref("auto_save_idle_ms") },
   set = function(value) { .rs.setUserPref("auto_save_idle_ms", value) },
   clear = function() { .rs.clearUserPref("auto_save_idle_ms") }
)

# Save documents when editor loses input focus
#
# Whether to automatically save when the editor loses focus.
.rs.uiPrefs$autoSaveOnBlur <- list(
   get = function() { .rs.getUserPref("auto_save_on_blur") },
   set = function(value) { .rs.setUserPref("auto_save_on_blur", value) },
   clear = function() { .rs.clearUserPref("auto_save_on_blur") }
)

# Reduce background file operations on network and remote drives
#
# When enabled, RStudio reduces background file monitoring, code indexing, and
# external-edit checks for projects detected to be on a network or remote
# filesystem. This improves responsiveness on slow drives, at the cost of less
# frequent automatic refreshing of file listings and version-control status.
.rs.uiPrefs$reduceRemoteFilesystemOperations <- list(
   get = function() { .rs.getUserPref("reduce_remote_filesystem_operations") },
   set = function(value) { .rs.setUserPref("reduce_remote_filesystem_operations", value) },
   clear = function() { .rs.clearUserPref("reduce_remote_filesystem_operations") }
)

# Initial working directory for new terminals
#
# Initial directory for new terminals.
.rs.uiPrefs$terminalInitialDirectory <- list(
   get = function() { .rs.getUserPref("terminal_initial_directory") },
   set = function(value) { .rs.setUserPref("terminal_initial_directory", value) },
   clear = function() { .rs.clearUserPref("terminal_initial_directory") }
)

# Show full path to project in RStudio Desktop windows
#
# Whether to show the full path to project in desktop window title.
.rs.uiPrefs$fullProjectPathInWindowTitle <- list(
   get = function() { .rs.getUserPref("full_project_path_in_window_title") },
   set = function(value) { .rs.setUserPref("full_project_path_in_window_title", value) },
   clear = function() { .rs.clearUserPref("full_project_path_in_window_title") }
)

# Use visual editing by default for new markdown documents
#
# Whether to enable visual editing by default for new markdown documents
.rs.uiPrefs$visualMarkdownEditingIsDefault <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_is_default") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_is_default", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_is_default") }
)

# Default list spacing in visual markdown editing mode
#
# Default spacing for lists created in the visual editor
.rs.uiPrefs$visualMarkdownEditingListSpacing <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_list_spacing") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_list_spacing", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_list_spacing") }
)

# Wrap text in visual markdown editing mode
#
# Whether to automatically wrap text when writing markdown
.rs.uiPrefs$visualMarkdownEditingWrap <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_wrap") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_wrap", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_wrap") }
)

# Wrap column for visual markdown editing mode
#
# The column to wrap text at when writing markdown
.rs.uiPrefs$visualMarkdownEditingWrapAtColumn <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_wrap_at_column") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_wrap_at_column", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_wrap_at_column") }
)

# Place visual markdown footnotes in
#
# Placement of footnotes within markdown output.
.rs.uiPrefs$visualMarkdownEditingReferencesLocation <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_references_location") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_references_location", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_references_location") }
)

# Write canonical visual mode markdown in source mode
#
# Whether to write canonical visual mode markdown when saving from source mode.
.rs.uiPrefs$visualMarkdownEditingCanonical <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_canonical") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_canonical", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_canonical") }
)

# Max content width for visual markdown editor (px)
#
# Maximum content width for visual editing mode, in pixels
.rs.uiPrefs$visualMarkdownEditingMaxContentWidth <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_max_content_width") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_max_content_width", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_max_content_width") }
)

# Show document outline in visual markdown editing mode
#
# Whether to show the document outline by default when opening R Markdown
# documents in visual mode.
.rs.uiPrefs$visualMarkdownEditingShowDocOutline <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_show_doc_outline") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_show_doc_outline", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_show_doc_outline") }
)

# Show margin in visual mode code blocks
#
# Whether to show the margin guide in the visual mode code blocks.
.rs.uiPrefs$visualMarkdownEditingShowMargin <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_show_margin") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_show_margin", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_show_margin") }
)

# Show line numbers in visual mode code blocks
#
# Whether to show line numbers in the code editors used in visual mode
.rs.uiPrefs$visualMarkdownCodeEditorLineNumbers <- list(
   get = function() { .rs.getUserPref("visual_markdown_code_editor_line_numbers") },
   set = function(value) { .rs.setUserPref("visual_markdown_code_editor_line_numbers", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_code_editor_line_numbers") }
)

# Font size for visual editing mode
#
# The default visual editing mode font size, in points
.rs.uiPrefs$visualMarkdownEditingFontSizePoints <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_font_size_points") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_font_size_points", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_font_size_points") }
)

# Editor for code chunks in visual editing mode
#
# The name of the editor to use to provide code editing in visual mode
.rs.uiPrefs$visualMarkdownCodeEditor <- list(
   get = function() { .rs.getUserPref("visual_markdown_code_editor") },
   set = function(value) { .rs.setUserPref("visual_markdown_code_editor", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_code_editor") }
)

# Zotero libraries
#
# Zotero libraries to insert citations from.
.rs.uiPrefs$zoteroLibraries <- list(
   get = function() { .rs.getUserPref("zotero_libraries") },
   set = function(value) { .rs.setUserPref("zotero_libraries", value) },
   clear = function() { .rs.clearUserPref("zotero_libraries") }
)

# 
#
# Preferred emoji skintone
.rs.uiPrefs$emojiSkintone <- list(
   get = function() { .rs.getUserPref("emoji_skintone") },
   set = function(value) { .rs.setUserPref("emoji_skintone", value) },
   clear = function() { .rs.clearUserPref("emoji_skintone") }
)

# Disabled aria-live announcements
#
# List of aria-live announcements to disable.
.rs.uiPrefs$disabledAriaLiveAnnouncements <- list(
   get = function() { .rs.getUserPref("disabled_aria_live_announcements") },
   set = function(value) { .rs.setUserPref("disabled_aria_live_announcements", value) },
   clear = function() { .rs.clearUserPref("disabled_aria_live_announcements") }
)

# Maximum number of console lines to announce
#
# Maximum number of lines of console output announced after a command.
.rs.uiPrefs$screenreaderConsoleAnnounceLimit <- list(
   get = function() { .rs.getUserPref("screenreader_console_announce_limit") },
   set = function(value) { .rs.setUserPref("screenreader_console_announce_limit", value) },
   clear = function() { .rs.clearUserPref("screenreader_console_announce_limit") }
)

# List of path components ignored by file monitor
#
# List of path components; file monitor will ignore paths containing one or more
# of these components.
.rs.uiPrefs$fileMonitorIgnoredComponents <- list(
   get = function() { .rs.getUserPref("file_monitor_ignored_components") },
   set = function(value) { .rs.setUserPref("file_monitor_ignored_components", value) },
   clear = function() { .rs.clearUserPref("file_monitor_ignored_components") }
)

# Use .gitignore for file monitoring
#
# When enabled, directories ignored by Git (.gitignore rules) and their contents
# will be excluded from project file monitoring and code indexing.
.rs.uiPrefs$fileMonitorUseGitignore <- list(
   get = function() { .rs.getUserPref("file_monitor_use_gitignore") },
   set = function(value) { .rs.setUserPref("file_monitor_use_gitignore", value) },
   clear = function() { .rs.clearUserPref("file_monitor_use_gitignore") }
)

# Install R package dependencies one at a time
#
# Whether to install R package dependencies one at a time.
.rs.uiPrefs$installPkgDepsIndividually <- list(
   get = function() { .rs.getUserPref("install_pkg_deps_individually") },
   set = function(value) { .rs.setUserPref("install_pkg_deps_individually", value) },
   clear = function() { .rs.clearUserPref("install_pkg_deps_individually") }
)

# R graphics backend
#
# R graphics backend.
.rs.uiPrefs$graphicsBackend <- list(
   get = function() { .rs.getUserPref("graphics_backend") },
   set = function(value) { .rs.setUserPref("graphics_backend", value) },
   clear = function() { .rs.clearUserPref("graphics_backend") }
)

# R graphics antialiasing method
#
# Type of anti-aliasing to be used for generated R plots.
.rs.uiPrefs$graphicsAntialiasing <- list(
   get = function() { .rs.getUserPref("graphics_antialiasing") },
   set = function(value) { .rs.setUserPref("graphics_antialiasing", value) },
   clear = function() { .rs.clearUserPref("graphics_antialiasing") }
)

# Fixed-width font list for RStudio Server
#
# List of fixed-width fonts to check for browser support.
.rs.uiPrefs$browserFixedWidthFonts <- list(
   get = function() { .rs.getUserPref("browser_fixed_width_fonts") },
   set = function(value) { .rs.setUserPref("browser_fixed_width_fonts", value) },
   clear = function() { .rs.clearUserPref("browser_fixed_width_fonts") }
)

# 
#
# The Python type.
.rs.uiPrefs$pythonType <- list(
   get = function() { .rs.getUserPref("python_type") },
   set = function(value) { .rs.setUserPref("python_type", value) },
   clear = function() { .rs.clearUserPref("python_type") }
)

# 
#
# The Python version.
.rs.uiPrefs$pythonVersion <- list(
   get = function() { .rs.getUserPref("python_version") },
   set = function(value) { .rs.setUserPref("python_version", value) },
   clear = function() { .rs.clearUserPref("python_version") }
)

# 
#
# The path to the default Python interpreter.
.rs.uiPrefs$pythonPath <- list(
   get = function() { .rs.getUserPref("python_path") },
   set = function(value) { .rs.setUserPref("python_path", value) },
   clear = function() { .rs.clearUserPref("python_path") }
)

# Save Retry Timeout
#
# The maximum amount of seconds of retry for save operations.
.rs.uiPrefs$saveRetryTimeout <- list(
   get = function() { .rs.getUserPref("save_retry_timeout") },
   set = function(value) { .rs.setUserPref("save_retry_timeout", value) },
   clear = function() { .rs.clearUserPref("save_retry_timeout") }
)

# Use durable writes when saving files
#
# Whether to flush saved files all the way to physical storage so that write
# failures (such as a full disk or an exceeded quota) are reported rather than
# silently lost. Disabling this can improve save performance on slow or networked
# filesystems, at the risk of not detecting some failed writes.
.rs.uiPrefs$saveFilesDurably <- list(
   get = function() { .rs.getUserPref("save_files_durably") },
   set = function(value) { .rs.setUserPref("save_files_durably", value) },
   clear = function() { .rs.clearUserPref("save_files_durably") }
)

# Use R's native pipe operator, |>
#
# Whether the Insert Pipe Operator command should use the native R pipe operator,
# |>
.rs.uiPrefs$insertNativePipeOperator <- list(
   get = function() { .rs.getUserPref("insert_native_pipe_operator") },
   set = function(value) { .rs.setUserPref("insert_native_pipe_operator", value) },
   clear = function() { .rs.clearUserPref("insert_native_pipe_operator") }
)

# Remember recently used items in Command Palette
#
# Whether to keep track of recently used commands in the Command Palette
.rs.uiPrefs$commandPaletteMru <- list(
   get = function() { .rs.getUserPref("command_palette_mru") },
   set = function(value) { .rs.setUserPref("command_palette_mru", value) },
   clear = function() { .rs.clearUserPref("command_palette_mru") }
)

# Show memory usage in Environment Pane
#
# Whether to compute and show memory usage in the Environment Pane
.rs.uiPrefs$showMemoryUsage <- list(
   get = function() { .rs.getUserPref("show_memory_usage") },
   set = function(value) { .rs.setUserPref("show_memory_usage", value) },
   clear = function() { .rs.clearUserPref("show_memory_usage") }
)

# Interval for requerying memory stats (seconds)
#
# How many seconds to wait between automatic requeries of memory statistics (0 to
# disable)
.rs.uiPrefs$memoryQueryIntervalSeconds <- list(
   get = function() { .rs.getUserPref("memory_query_interval_seconds") },
   set = function(value) { .rs.setUserPref("memory_query_interval_seconds", value) },
   clear = function() { .rs.clearUserPref("memory_query_interval_seconds") }
)

# Enable terminal Python integration
#
# Enable Python terminal hooks. When enabled, the RStudio-configured version of
# Python will be placed on the PATH.
.rs.uiPrefs$terminalPythonIntegration <- list(
   get = function() { .rs.getUserPref("terminal_python_integration") },
   set = function(value) { .rs.setUserPref("terminal_python_integration", value) },
   clear = function() { .rs.clearUserPref("terminal_python_integration") }
)

# Session protocol debug logging
#
# Enable session protocol debug logging showing all session requests and events
.rs.uiPrefs$sessionProtocolDebug <- list(
   get = function() { .rs.getUserPref("session_protocol_debug") },
   set = function(value) { .rs.setUserPref("session_protocol_debug", value) },
   clear = function() { .rs.clearUserPref("session_protocol_debug") }
)

# Automatically activate project Python environments
#
# When enabled, if the active project contains a Python virtual environment, then
# RStudio will automatically activate this environment on startup.
.rs.uiPrefs$pythonProjectEnvironmentAutomaticActivate <- list(
   get = function() { .rs.getUserPref("python_project_environment_automatic_activate") },
   set = function(value) { .rs.setUserPref("python_project_environment_automatic_activate", value) },
   clear = function() { .rs.clearUserPref("python_project_environment_automatic_activate") }
)

# Check values in the Environment pane for null external pointers
#
# (Deprecated) When enabled, RStudio will detect R objects containing null
# external pointers when building the Environment pane, and avoid introspecting
# their contents further. This preference is no longer used.
.rs.uiPrefs$checkNullExternalPointers <- list(
   get = function() { .rs.getUserPref("check_null_external_pointers") },
   set = function(value) { .rs.setUserPref("check_null_external_pointers", value) },
   clear = function() { .rs.clearUserPref("check_null_external_pointers") }
)

# User Interface Language:
#
# The IDE's user-interface language.
.rs.uiPrefs$uiLanguage <- list(
   get = function() { .rs.getUserPref("ui_language") },
   set = function(value) { .rs.setUserPref("ui_language", value) },
   clear = function() { .rs.clearUserPref("ui_language") }
)

# Auto hide menu bar
#
# Hide desktop menu bar until Alt key is pressed.
.rs.uiPrefs$autohideMenubar <- list(
   get = function() { .rs.getUserPref("autohide_menubar") },
   set = function(value) { .rs.setUserPref("autohide_menubar", value) },
   clear = function() { .rs.clearUserPref("autohide_menubar") }
)

# Use native file and message dialog boxes
#
# Whether RStudio Desktop will use the operating system's native File and Message
# dialog boxes.
.rs.uiPrefs$nativeFileDialogs <- list(
   get = function() { .rs.getUserPref("native_file_dialogs") },
   set = function(value) { .rs.setUserPref("native_file_dialogs", value) },
   clear = function() { .rs.clearUserPref("native_file_dialogs") }
)

# Discard pending console input on error
#
# When enabled, any pending console input will be discarded when an (uncaught) R
# error occurs.
.rs.uiPrefs$discardPendingConsoleInputOnError <- list(
   get = function() { .rs.getUserPref("discard_pending_console_input_on_error") },
   set = function(value) { .rs.setUserPref("discard_pending_console_input_on_error", value) },
   clear = function() { .rs.clearUserPref("discard_pending_console_input_on_error") }
)

# Editor scroll speed sensitivity
#
# An integer value, 1-200, to set the editor scroll multiplier. The higher the
# value, the faster the scrolling.
.rs.uiPrefs$editorScrollMultiplier <- list(
   get = function() { .rs.getUserPref("editor_scroll_multiplier") },
   set = function(value) { .rs.setUserPref("editor_scroll_multiplier", value) },
   clear = function() { .rs.clearUserPref("editor_scroll_multiplier") }
)

# Text rendering
#
# Control how text is rendered within the IDE surface.
.rs.uiPrefs$textRendering <- list(
   get = function() { .rs.getUserPref("text_rendering") },
   set = function(value) { .rs.setUserPref("text_rendering", value) },
   clear = function() { .rs.clearUserPref("text_rendering") }
)

# Disable Electron accessibility support
#
# Disable Electron accessibility support.
.rs.uiPrefs$disableRendererAccessibility <- list(
   get = function() { .rs.getUserPref("disable_renderer_accessibility") },
   set = function(value) { .rs.setUserPref("disable_renderer_accessibility", value) },
   clear = function() { .rs.clearUserPref("disable_renderer_accessibility") }
)

# AI Assistant
#
# Select which AI assistant to use for code suggestions and assistance.
.rs.uiPrefs$assistant <- list(
   get = function() { .rs.getUserPref("assistant") },
   set = function(value) { .rs.setUserPref("assistant", value) },
   clear = function() { .rs.clearUserPref("assistant") }
)

# Chat Provider
#
# Select which AI assistant to use for chat functionality.
.rs.uiPrefs$chatProvider <- list(
   get = function() { .rs.getUserPref("chat_provider") },
   set = function(value) { .rs.setUserPref("chat_provider", value) },
   clear = function() { .rs.clearUserPref("chat_provider") }
)

# Show code suggestions:
#
# Control when code suggestions are displayed in the editor.
.rs.uiPrefs$assistantCompletionsTrigger <- list(
   get = function() { .rs.getUserPref("assistant_completions_trigger") },
   set = function(value) { .rs.setUserPref("assistant_completions_trigger", value) },
   clear = function() { .rs.clearUserPref("assistant_completions_trigger") }
)

# AI completions delay
#
# The delay (in milliseconds) before AI completions are requested after the
# cursor position has changed.
.rs.uiPrefs$assistantCompletionsDelay <- list(
   get = function() { .rs.getUserPref("assistant_completions_delay") },
   set = function(value) { .rs.setUserPref("assistant_completions_delay", value) },
   clear = function() { .rs.clearUserPref("assistant_completions_delay") }
)

# Pressing Tab key will prefer inserting:
#
# Control the behavior of the Tab key when both AI code suggestions and RStudio
# code completions are visible.
.rs.uiPrefs$assistantTabKeyBehavior <- list(
   get = function() { .rs.getUserPref("assistant_tab_key_behavior") },
   set = function(value) { .rs.setUserPref("assistant_tab_key_behavior", value) },
   clear = function() { .rs.clearUserPref("assistant_tab_key_behavior") }
)

# Index project files with AI assistant
#
# When enabled, RStudio will index project files with the AI assistant.
.rs.uiPrefs$assistantIndexingEnabled <- list(
   get = function() { .rs.getUserPref("assistant_indexing_enabled") },
   set = function(value) { .rs.setUserPref("assistant_indexing_enabled", value) },
   clear = function() { .rs.clearUserPref("assistant_indexing_enabled") }
)

# Enable next edit suggestions
#
# When enabled, RStudio will display next edit suggestions as provided by the
# active AI assistant when available.
.rs.uiPrefs$assistantNesEnabled <- list(
   get = function() { .rs.getUserPref("assistant_nes_enabled") },
   set = function(value) { .rs.setUserPref("assistant_nes_enabled", value) },
   clear = function() { .rs.clearUserPref("assistant_nes_enabled") }
)

# Automatically display next edit suggestions in editor
#
# When enabled, next edit suggestions will be automatically displayed. When
# disabled, suggestions will only be shown when hovering over the gutter icon.
.rs.uiPrefs$assistantNesAutoshow <- list(
   get = function() { .rs.getUserPref("assistant_nes_autoshow") },
   set = function(value) { .rs.setUserPref("assistant_nes_autoshow", value) },
   clear = function() { .rs.clearUserPref("assistant_nes_autoshow") }
)

# Display account and billing messages from Posit Assistant
#
# When enabled, RStudio will show messages from the Posit Assistant in a message
# box.
.rs.uiPrefs$assistantShowMessages <- list(
   get = function() { .rs.getUserPref("assistant_show_messages") },
   set = function(value) { .rs.setUserPref("assistant_show_messages", value) },
   clear = function() { .rs.clearUserPref("assistant_show_messages") }
)

# Show Posit Assistant button in toolbar
#
# When enabled, the Posit Assistant button is displayed in the main toolbar.
.rs.uiPrefs$assistantToolbarButtonVisible <- list(
   get = function() { .rs.getUserPref("assistant_toolbar_button_visible") },
   set = function(value) { .rs.setUserPref("assistant_toolbar_button_visible", value) },
   clear = function() { .rs.clearUserPref("assistant_toolbar_button_visible") }
)

# Use the system certificate store (restart required)
#
# When enabled, the AI assistant agents trust the operating system certificate
# store (e.g. the Windows Certificate Store or macOS Keychain) in addition to
# Node.js's built-in certificate authorities. Useful behind a TLS-inspecting
# proxy. Restart the R session for the change to take effect.
.rs.uiPrefs$assistantUseSystemCa <- list(
   get = function() { .rs.getUserPref("assistant_use_system_ca") },
   set = function(value) { .rs.setUserPref("assistant_use_system_ca", value) },
   clear = function() { .rs.clearUserPref("assistant_use_system_ca") }
)

# Use pre-release version of Posit Assistant (restart required)
#
# Use a pre-release version of the Posit Assistant for testing purposes. Do not
# use for production work.
.rs.uiPrefs$positAssistantTestManifest <- list(
   get = function() { .rs.getUserPref("posit_assistant_test_manifest") },
   set = function(value) { .rs.setUserPref("posit_assistant_test_manifest", value) },
   clear = function() { .rs.clearUserPref("posit_assistant_test_manifest") }
)

# Posit Assistant update check interval (hours)
#
# The minimum number of hours between checks for a new version of the Posit
# Assistant. Set to 0 to check every time.
.rs.uiPrefs$positAssistantUpdateCheckIntervalHours <- list(
   get = function() { .rs.getUserPref("posit_assistant_update_check_interval_hours") },
   set = function(value) { .rs.setUserPref("posit_assistant_update_check_interval_hours", value) },
   clear = function() { .rs.clearUserPref("posit_assistant_update_check_interval_hours") }
)

# Enable GitHub Copilot
#
# When enabled, RStudio will use GitHub Copilot to provide code suggestions.
.rs.uiPrefs$copilotEnabled <- list(
   get = function() { .rs.getUserPref("copilot_enabled") },
   set = function(value) { .rs.setUserPref("copilot_enabled", value) },
   clear = function() { .rs.clearUserPref("copilot_enabled") }
)

# Show code suggestions:
#
# Control when code suggestions are displayed in the editor.
.rs.uiPrefs$copilotCompletionsTrigger <- list(
   get = function() { .rs.getUserPref("copilot_completions_trigger") },
   set = function(value) { .rs.setUserPref("copilot_completions_trigger", value) },
   clear = function() { .rs.clearUserPref("copilot_completions_trigger") }
)

# GitHub Copilot completions delay
#
# The delay (in milliseconds) before GitHub Copilot completions are requested
# after the cursor position has changed.
.rs.uiPrefs$copilotCompletionsDelay <- list(
   get = function() { .rs.getUserPref("copilot_completions_delay") },
   set = function(value) { .rs.setUserPref("copilot_completions_delay", value) },
   clear = function() { .rs.clearUserPref("copilot_completions_delay") }
)

# Pressing Tab key will prefer inserting:
#
# Control the behavior of the Tab key when both Copilot code suggestions and
# RStudio code completions are visible.
.rs.uiPrefs$copilotTabKeyBehavior <- list(
   get = function() { .rs.getUserPref("copilot_tab_key_behavior") },
   set = function(value) { .rs.setUserPref("copilot_tab_key_behavior", value) },
   clear = function() { .rs.clearUserPref("copilot_tab_key_behavior") }
)

# Index project files with GitHub Copilot
#
# When enabled, RStudio will index project files with GitHub Copilot.
.rs.uiPrefs$copilotIndexingEnabled <- list(
   get = function() { .rs.getUserPref("copilot_indexing_enabled") },
   set = function(value) { .rs.setUserPref("copilot_indexing_enabled", value) },
   clear = function() { .rs.clearUserPref("copilot_indexing_enabled") }
)

# Enable next edit suggestions
#
# When enabled, RStudio will display next edit suggestions as provided by Copilot
# when available.
.rs.uiPrefs$copilotNesEnabled <- list(
   get = function() { .rs.getUserPref("copilot_nes_enabled") },
   set = function(value) { .rs.setUserPref("copilot_nes_enabled", value) },
   clear = function() { .rs.clearUserPref("copilot_nes_enabled") }
)

# Automatically show next edit suggestions
#
# When enabled, next edit suggestions will be automatically displayed. When
# disabled, suggestions will only be shown when hovering over the gutter icon.
.rs.uiPrefs$copilotNesAutoshow <- list(
   get = function() { .rs.getUserPref("copilot_nes_autoshow") },
   set = function(value) { .rs.setUserPref("copilot_nes_autoshow", value) },
   clear = function() { .rs.clearUserPref("copilot_nes_autoshow") }
)

# Display account and billing messages from GitHub Copilot
#
# When enabled, RStudio will show account and billing messages from GitHub
# Copilot in a message box.
.rs.uiPrefs$copilotShowMessages <- list(
   get = function() { .rs.getUserPref("copilot_show_messages") },
   set = function(value) { .rs.setUserPref("copilot_show_messages", value) },
   clear = function() { .rs.clearUserPref("copilot_show_messages") }
)

# Use project directory as a Copilot workspace
#
# When enabled, RStudio will tell Copilot to use the current project's directory
# as a workspace.
.rs.uiPrefs$copilotProjectWorkspace <- list(
   get = function() { .rs.getUserPref("copilot_project_workspace") },
   set = function(value) { .rs.setUserPref("copilot_project_workspace", value) },
   clear = function() { .rs.clearUserPref("copilot_project_workspace") }
)

# 
#
# User-provided name for the currently opened R project.
.rs.uiPrefs$projectName <- list(
   get = function() { .rs.getUserPref("project_name") },
   set = function(value) { .rs.setUserPref("project_name", value) },
   clear = function() { .rs.clearUserPref("project_name") }
)

# Default working directory for background jobs
#
# Default working directory in background job dialog.
.rs.uiPrefs$runBackgroundJobDefaultWorkingDir <- list(
   get = function() { .rs.getUserPref("run_background_job_default_working_dir") },
   set = function(value) { .rs.setUserPref("run_background_job_default_working_dir", value) },
   clear = function() { .rs.clearUserPref("run_background_job_default_working_dir") }
)

# Code formatter
#
# The formatter to use when reformatting code.
.rs.uiPrefs$codeFormatter <- list(
   get = function() { .rs.getUserPref("code_formatter") },
   set = function(value) { .rs.setUserPref("code_formatter", value) },
   clear = function() { .rs.clearUserPref("code_formatter") }
)

# Use strict transformers when formatting code
#
# When set, strict transformers will be used when formatting code. See the
# `styler` package documentation for more details.
.rs.uiPrefs$codeFormatterStylerStrict <- list(
   get = function() { .rs.getUserPref("code_formatter_styler_strict") },
   set = function(value) { .rs.setUserPref("code_formatter_styler_strict", value) },
   clear = function() { .rs.clearUserPref("code_formatter_styler_strict") }
)

# 
#
# The external command to be used when reformatting code.
.rs.uiPrefs$codeFormatterExternalCommand <- list(
   get = function() { .rs.getUserPref("code_formatter_external_command") },
   set = function(value) { .rs.setUserPref("code_formatter_external_command", value) },
   clear = function() { .rs.clearUserPref("code_formatter_external_command") }
)

# Use Air for code formatting
#
# When set, RStudio will automatically select and use an appropriate version of
# Air when formatting R code.
.rs.uiPrefs$useAirFormatter <- list(
   get = function() { .rs.getUserPref("use_air_formatter") },
   set = function(value) { .rs.setUserPref("use_air_formatter", value) },
   clear = function() { .rs.clearUserPref("use_air_formatter") }
)

# Only use Air when an air.toml file is found
#
# When set, Air will only be used to format R documents located within a project
# or directory containing an air.toml file.
.rs.uiPrefs$airFormatterRequireToml <- list(
   get = function() { .rs.getUserPref("air_formatter_require_toml") },
   set = function(value) { .rs.setUserPref("air_formatter_require_toml", value) },
   clear = function() { .rs.clearUserPref("air_formatter_require_toml") }
)

# Reformat documents on save
#
# When set, the selected formatter will be used to reformat documents on save.
.rs.uiPrefs$reformatOnSave <- list(
   get = function() { .rs.getUserPref("reformat_on_save") },
   set = function(value) { .rs.setUserPref("reformat_on_save", value) },
   clear = function() { .rs.clearUserPref("reformat_on_save") }
)

# Default project user data directory
#
# The folder in which RStudio should store project .Rproj.user data.
.rs.uiPrefs$projectUserDataDirectory <- list(
   get = function() { .rs.getUserPref("project_user_data_directory") },
   set = function(value) { .rs.setUserPref("project_user_data_directory", value) },
   clear = function() { .rs.clearUserPref("project_user_data_directory") }
)

# Use extended display for
#
# When enabled, R errors, warnings, and messages will receive an extended display
# with custom styles applied.
.rs.uiPrefs$consoleHighlightConditions <- list(
   get = function() { .rs.getUserPref("console_highlight_conditions") },
   set = function(value) { .rs.setUserPref("console_highlight_conditions", value) },
   clear = function() { .rs.clearUserPref("console_highlight_conditions") }
)

#
# test-log-message.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("log message helpers")

# Captures arguments passed to .rs.logMessageEmit during 'expr'. The full
# .rs.log*Message -> .rs.logMessageImpl -> .rs.logMessageEmit chain runs
# normally, but the final .Call is intercepted so we can assert on what
# would have been logged.
withCapturedLogs <- function(expr) {
   captured <- list()
   rsEnv <- as.environment("tools:rstudio")
   original <- get(".rs.logMessageEmit", envir = rsEnv)
   on.exit(assign(".rs.logMessageEmit", original, envir = rsEnv), add = TRUE)
   assign(".rs.logMessageEmit", function(method, message) {
      captured[[length(captured) + 1L]] <<- list(method = method, message = message)
   }, envir = rsEnv)
   force(expr)
   captured
}

clearLogCache <- function() {
   rm(list = ls(envir = .rs.loggedMessageCache, all.names = TRUE),
      envir = .rs.loggedMessageCache)
}

test_that(".rs.log*Message passes literal text verbatim when ... is empty", {
   logs <- withCapturedLogs({
      .rs.logInfoMessage("progress: 100% complete")
   })
   expect_length(logs, 1L)
   expect_equal(logs[[1]]$method, "rs_logInfoMessage")
   expect_equal(logs[[1]]$message, "progress: 100% complete")
})

test_that(".rs.log*Message applies sprintf when ... is non-empty", {
   logs <- withCapturedLogs({
      .rs.logWarningMessage("hello %s, count = %d", "world", 42L)
   })
   expect_length(logs, 1L)
   expect_equal(logs[[1]]$method, "rs_logWarningMessage")
   expect_equal(logs[[1]]$message, "hello world, count = 42")
})

test_that(".rs.log*Message with once = TRUE suppresses repeats but lets others through", {
   clearLogCache()
   on.exit(clearLogCache(), add = TRUE)

   logs <- withCapturedLogs({
      .rs.logErrorMessage("duplicate message", once = TRUE)
      .rs.logErrorMessage("duplicate message", once = TRUE)   # suppressed
      .rs.logErrorMessage("duplicate message")                # once = FALSE, still logs
      .rs.logErrorMessage("different message", once = TRUE)   # distinct, logs
   })

   messages <- vapply(logs, `[[`, character(1L), "message")
   expect_equal(messages, c("duplicate message", "duplicate message", "different message"))
})

#
# test-object-explorer.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("object explorer")

# Evaluate a child's access string the way explorer_inspect_object does when
# the client expands that child: '#' is replaced with the parent object and
# the resulting code is evaluated.
inspectionAccessEval <- function(object, access)
{
   extractingCode <- sub("#", "`__OBJECT__`", access, fixed = TRUE)
   envir <- new.env(parent = globalenv())
   envir[["__OBJECT__"]] <- object
   eval(parse(text = extractingCode), envir = envir)
}

test_that("list elements with duplicated names are accessed by index (#17937)", {
   object <- list(
      list(Id = 1, Age = 12),
      list(Id = 2, Age = 22),
      list(Id = 3, Age = 33)
   )
   names(object) <- rep("Passenger", 3)

   context <- .rs.explorer.createContext(recursive = 1)
   result <- .rs.explorer.inspectObject(object, context)
   children <- result$children
   expect_length(children, 3)

   # the duplicated name is still displayed
   names <- vapply(children, function(child) child$display$name, "")
   expect_equal(names, rep("Passenger", 3))

   # but access goes by index, as access-by-name would always
   # retrieve the first matching element
   access <- vapply(children, function(child) child$access, "")
   expect_equal(access, c("#[[1]]", "#[[2]]", "#[[3]]"))

   # expanding each child retrieves its own value
   for (i in seq_along(children))
      expect_equal(inspectionAccessEval(object, access[[i]]), object[[i]])
})

test_that("uniquely named list elements are still accessed by name", {
   object <- list(a = 1, b = 2)

   context <- .rs.explorer.createContext(recursive = 1)
   result <- .rs.explorer.inspectObject(object, context)
   children <- result$children

   access <- vapply(children, function(child) child$access, "")
   expect_equal(access, c("#[[\"a\"]]", "#[[\"b\"]]"))
})

test_that("unnamed and empty-named list elements are accessed by index", {
   object <- list(1, b = 2, 3)
   names(object)[[3]] <- ""

   context <- .rs.explorer.createContext(recursive = 1)
   result <- .rs.explorer.inspectObject(object, context)
   children <- result$children

   access <- vapply(children, function(child) child$access, "")
   expect_equal(access, c("#[[1]]", "#[[\"b\"]]", "#[[3]]"))
})

test_that("environment-like S4 objects are described without warnings", {
   setClass("TestS4Env", contains = "environment", where = environment())
   object <- new("TestS4Env")
   expect_no_warning(desc <- .rs.explorer.objectDesc(object))
   expect_equal(desc, "S4 object of class TestS4Env")

   generator <- setRefClass("TestRC", fields = list(x = "numeric"), where = environment())
   object <- generator$new(x = 1)
   expect_no_warning(desc <- .rs.explorer.objectDesc(object))
   expect_equal(desc, "Reference class object of class TestRC")

   # describing the object should not strip its S4 bit
   expect_true(isS4(object))
})

test_that("environments are described without mutating their class", {
   object <- new.env()
   class(object) <- c("foo", "bar")
   desc <- .rs.explorer.objectDesc(object)
   expect_match(desc, "^<environment: 0x")
   expect_equal(class(object), c("foo", "bar"))
})

test_that("named environments are described like R's default print", {
   expect_equal(.rs.explorer.objectDesc(globalenv()), "<environment: R_GlobalEnv>")
   expect_equal(.rs.explorer.objectDesc(baseenv()), "<environment: base>")
   expect_equal(.rs.explorer.objectDesc(emptyenv()), "<environment: R_EmptyEnv>")
   expect_equal(.rs.explorer.objectDesc(asNamespace("stats")), "<environment: namespace:stats>")
   expect_equal(.rs.explorer.objectDesc(as.environment("package:stats")), "<environment: package:stats>")
})

test_that("atomic vectors with duplicated names are accessed by index (#17937)", {
   object <- c(a = 1, a = 2, b = 3)

   context <- .rs.explorer.createContext(recursive = 1)
   result <- .rs.explorer.inspectObject(object, context)
   children <- result$children
   expect_length(children, 3)

   access <- vapply(children, function(child) child$access, "")
   expect_equal(access, c("#[[1]]", "#[[2]]", "#[[\"b\"]]"))

   for (i in seq_along(children))
      expect_equal(inspectionAccessEval(object, access[[i]]), object[[i]])
})

test_that("objects with non-scalar length() methods can be inspected (#18138)", {
   # mimic Formula::length.Formula, which returns a length-2 integer
   # (one count each for the left-hand and right-hand sides); register
   # the method the same way a package NAMESPACE would
   registerS3method("length", "rs_test_formula", function(x) c(1L, 1L))
   on.exit({
      table <- get(".__S3MethodsTable__.", envir = asNamespace("base"))
      rm(list = "length.rs_test_formula", envir = table)
   }, add = TRUE)

   formula <- structure(y ~ x, class = c("rs_test_formula", "formula"))
   expect_identical(length(formula), c(1L, 1L))

   # inspecting the object directly succeeds, and reports the
   # internal length rather than the dispatched one
   context <- .rs.explorer.createContext(recursive = 1)
   result <- .rs.explorer.inspectObject(formula, context)
   expect_equal(as.integer(result$length), 3L)
   expect_true(as.logical(result$expandable))
   expect_length(result$children, 3)

   # inspecting a model-like object containing it succeeds as well;
   # this is the path exercised by View() on an mlogit model
   model <- list(coefficients = c(a = 1, b = 2), formula = formula)
   result <- .rs.explorer.inspectObject(model, context)
   expect_length(result$children, 2)
})

#
# test-completions-inherit-dot-params.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

library(testthat)

context("inheritDotParams completions")

# ---------------------------------------------------------------------------
# Helpers
# ---------------------------------------------------------------------------

make_wrapper_fn <- function(own_args = c("x", "...")) {
   args_list <- setNames(vector("list", length(own_args)), own_args)
   as.function(c(args_list, list(NULL)))
}

make_matched_call <- function(named_args = character()) {
   as.call(c(
      list(as.symbol("f")),
      setNames(replicate(length(named_args), quote(x)), named_args)
   ))
}

has_system_rd_macros <- file.exists(
   file.path(R.home("share"), "Rd", "macros", "system.Rd")
)

test_that <- function(desc, code) {
   if (!has_system_rd_macros) {
      testthat::test_that(desc, testthat::skip("system.Rd macros file not available"))
      return(invisible(NULL))
   }
   call <- sys.call()
   call[[1L]] <- quote(testthat::test_that)
   eval(call, envir = parent.frame())
}

fixture_rd <- if (has_system_rd_macros) tools::parse_Rd(
   testthat::test_path("fixtures/wrapper-inheritDotParams.Rd")
)

fixture_rd_partial <- if (has_system_rd_macros) tools::parse_Rd(
   testthat::test_path("fixtures/wrapper-inheritDotParams-partial.Rd")
)

# testthat::with_mocked_bindings / local_mocked_bindings cannot mock functions
# in the locked "tools:rstudio" environment, so we use a shared helper that
# saves, replaces, and restores bindings via assign() + on.exit().
with_rs_mock <- function(targetName, newValue, expr) {
   rsEnv <- as.environment("tools:rstudio")
   original <- get(targetName, envir = rsEnv)
   on.exit(assign(targetName, original, envir = rsEnv), add = TRUE)
   assign(targetName, newValue, envir = rsEnv)
   force(expr)
}

# Builds a minimal synthetic Rd object with the structure that roxygen2 generates
# for @inheritDotParams. Individual fields can be overridden to exercise specific
# guards in parseInheritDotParamsFromRd without needing to construct valid Rd text.
make_inherit_rd <- function(
   arg_name   = "...",
   sentinel   = "Arguments passed on to ",
   code_tag   = "\\code",
   link_text  = "target",
   link_tag   = "\\link",
   with_link  = TRUE,
   with_describe = TRUE,
   describe_items = list()
) {
   mk <- function(tag, ...) {
      node <- list(...)
      attr(node, "Rd_tag") <- tag
      node
   }

   linkNode   <- mk(link_tag, link_text)
   codeNode   <- if (with_link) mk(code_tag, linkNode) else mk(code_tag, link_text)
   textNode   <- mk("TEXT", sentinel)
   descItems  <- lapply(describe_items, function(nm) {
      mk("\\item", mk("\\code", nm), mk("TEXT", "desc"))
   })
   descNode   <- if (with_describe) do.call(mk, c(list("\\describe"), descItems)) else NULL
   dotsDesc   <- if (!is.null(descNode)) mk("RCODE", textNode, codeNode, descNode)
                 else                    mk("RCODE", textNode, codeNode)
   nameNode   <- mk("TEXT", arg_name)
   dotsItem   <- mk("\\item", nameNode, dotsDesc)
   argsNode   <- mk("\\arguments", dotsItem)
   mk("Rd", argsNode)
}


# ---------------------------------------------------------------------------
# .rs.parseInheritDotParamsFromRd  (pure Rd logic, no help-db lookup)
# ---------------------------------------------------------------------------

test_that("parseInheritDotParamsFromRd extracts targetName from fixture Rd", {
   result <- .rs.parseInheritDotParamsFromRd(fixture_rd)
   expect_equal(result$targetName, "target")
   expect_null(result$targetPkg)
})

test_that("parseInheritDotParamsFromRd returns NULL targetPkg for same-package [=fn] link form", {
   # Form 1: same-package -- \link[=fn]{fn}, no package prefix
   rd_text <- paste0(
      "\\name{f}\\title{F}\\description{D}\\usage{f(...)}\n",
      "\\arguments{\\item{...}{Arguments passed on to \\code{\\link[=target]{target}}",
      "\\describe{\\item{\\code{x}}{desc}}}}"
   )
   rd <- tools::parse_Rd(textConnection(rd_text))
   result <- .rs.parseInheritDotParamsFromRd(rd)
   expect_null(result$targetPkg)
   expect_equal(result$targetName, "target")
})

test_that("parseInheritDotParamsFromRd extracts targetPkg from cross-package [pkg:topic] link form", {
   # Form 2: cross-package -- \link[pkg:topic]{pkg::fn}
   # roxygen2 generates: dest <- gsub("::", ":", src) when src contains "::"
   rd_text <- paste0(
      "\\name{f}\\title{F}\\description{D}\\usage{f(...)}\n",
      "\\arguments{\\item{...}{Arguments passed on to \\code{\\link[dplyr:slice_min]{dplyr::slice_min}}",
      "\\describe{\\item{\\code{x}}{desc}}}}"
   )
   rd <- tools::parse_Rd(textConnection(rd_text))
   result <- .rs.parseInheritDotParamsFromRd(rd)
   expect_equal(result$targetPkg,  "dplyr")
   expect_equal(result$targetName, "slice_min")
})

test_that("parseInheritDotParamsFromRd extracts argNames from fixture Rd", {
   result <- .rs.parseInheritDotParamsFromRd(fixture_rd)
   # Standard args
   expect_in("alpha", result$argNames)
   expect_in("beta",  result$argNames)
   expect_in("gamma", result$argNames)
   # Reserved word -- requires backtick-quoting when deparsed
   expect_in("if",    result$argNames)
   # Comma-separated args from a single \item{\code{n,prop}}{} entry
   expect_in("n",     result$argNames)
   expect_in("prop",  result$argNames)
})

test_that("parseInheritDotParamsFromRd respects partial @inheritDotParams", {
   result <- .rs.parseInheritDotParamsFromRd(fixture_rd_partial)
   expect_in("alpha",       result$argNames)
   expect_in("beta",        result$argNames)
   expect_disjoint("gamma", result$argNames)
})

test_that("parseInheritDotParamsFromRd returns NULL for Rd with no @inheritDotParams", {
   # base::mean Rd has ... but documented manually -- parse it directly
   mean_rd <- tryCatch(
      get(".getHelpFile", envir = asNamespace("utils"), mode = "function")(
         eval(.rs.makeHelpCall("mean", "base"))
      ),
      error = function(e) NULL
   )
   skip_if(is.null(mean_rd), "Could not load mean Rd")
   expect_null(.rs.parseInheritDotParamsFromRd(mean_rd))
})

test_that("parseInheritDotParamsFromRd uses first block when multiple @inheritDotParams exist", {
   # Two @inheritDotParams blocks: first targets 'target1' with arg 'alpha',
   # second targets 'target2' with arg 'beta'. Only the first block is used.
   rd_text <- paste0(
      "\\name{f}\\title{F}\\description{D}\\usage{f(...)}\n",
      "\\arguments{",
      "\\item{...}{Arguments passed on to \\code{\\link[=target1]{target1}}\\describe{\\item{\\code{alpha}}{desc}}}",
      "\\item{...}{Arguments passed on to \\code{\\link[=target2]{target2}}\\describe{\\item{\\code{beta}}{desc}}}",
      "}"
   )
   rd <- tools::parse_Rd(textConnection(rd_text))
   result <- .rs.parseInheritDotParamsFromRd(rd)
   expect_false(is.null(result))
   expect_equal(result$targetName, "target1")
   expect_in("alpha", result$argNames)
   expect_false("beta" %in% result$argNames)
})

# ---------------------------------------------------------------------------
# .rs.parseInheritDotParamsFromRd -- Rd not matching @inheritDotParams structure
#
# Steps through the expected structure in guard order. Valid Rd that deviates
# from the roxygen2-generated format returns NULL at the relevant guard.
# ---------------------------------------------------------------------------

# Guard 1: Find \arguments
test_that("parseInheritDotParamsFromRd returns NULL when \\arguments section is absent", {
   rd_no_args <- list(); attr(rd_no_args, "Rd_tag") <- "Rd"
   expect_null(.rs.parseInheritDotParamsFromRd(rd_no_args))
})

# Guard 2: Find \item with ... name
test_that("parseInheritDotParamsFromRd returns NULL when no ... item is found", {
   rd <- make_inherit_rd(arg_name = "x")
   expect_null(.rs.parseInheritDotParamsFromRd(rd))
})

# Guard 3: sentinel TEXT must be present and start with "Arguments passed on to"
test_that("parseInheritDotParamsFromRd returns NULL when sentinel text is absent", {
   rd <- make_inherit_rd(sentinel = "Something else entirely")
   expect_null(.rs.parseInheritDotParamsFromRd(rd))
})

test_that("parseInheritDotParamsFromRd returns NULL when sentinel text does not start the TEXT node", {
   rd <- make_inherit_rd(sentinel = "Note: Arguments passed on to ")
   expect_null(.rs.parseInheritDotParamsFromRd(rd))
})

# Guard 4: \code node must follow the sentinel
test_that("parseInheritDotParamsFromRd returns NULL when \\code node is absent", {
   # e.g. \code{target} replaced with a different tag
   rd <- make_inherit_rd(code_tag = "\\text")
   expect_null(.rs.parseInheritDotParamsFromRd(rd))
})

# Guard 5: Find \link inside \code
test_that("parseInheritDotParamsFromRd returns NULL when \\link node is absent", {
   # e.g. \code{target} without a \link node
   rd <- make_inherit_rd(with_link = FALSE)
   expect_null(.rs.parseInheritDotParamsFromRd(rd))
})

# Guard 6: \link node text must be non-empty and of the form "pkg::fn" or "fn"
test_that("parseInheritDotParamsFromRd returns NULL when \\link node text is empty", {
   rd <- make_inherit_rd(link_text = "")
   expect_null(.rs.parseInheritDotParamsFromRd(rd))
})

test_that("parseInheritDotParamsFromRd returns NULL when \\link pkg prefix is empty", {
   # "::fn" is not a valid R namespace expression -- return NULL rather than
   # silently treating it as a same-package reference.
   rd <- make_inherit_rd(link_text = "::fn")
   expect_null(.rs.parseInheritDotParamsFromRd(rd))
})

test_that("parseInheritDotParamsFromRd returns NULL when \\link text has too many separators", {
   # "a::b::c" splits into 3 parts -- not a valid namespace expression
   rd <- make_inherit_rd(link_text = "a::b::c")
   expect_null(.rs.parseInheritDotParamsFromRd(rd))
})

test_that("parseInheritDotParamsFromRd extracts targetPkg from triple-colon link text", {
   # :{2,3} split handles pkg:::fn defensively, even though roxygen2 currently
   # produces a parse error for @inheritDotParams pkg:::fn
   rd <- make_inherit_rd(link_text = "pkg:::fn")
   result <- .rs.parseInheritDotParamsFromRd(rd)
   expect_equal(result$targetPkg,  "pkg")
   expect_equal(result$targetName, "fn")
})

# Guard 7: Find \describe
test_that("parseInheritDotParamsFromRd returns NULL when \\describe node is absent", {
   rd <- make_inherit_rd(with_describe = FALSE)
   expect_null(.rs.parseInheritDotParamsFromRd(rd))
})

# Guard 8: Filter \item nodes with length >= 1. An empty \describe is a valid
# (if degenerate) @inheritDotParams -- the pattern matched, but no args were
# forwarded -- so the function returns a list with empty argNames, not NULL.
test_that("parseInheritDotParamsFromRd returns empty argNames for empty \\describe block", {
   rd <- make_inherit_rd(describe_items = list())
   result <- .rs.parseInheritDotParamsFromRd(rd)
   expect_length(result$argNames, 0L)
})

# ---------------------------------------------------------------------------
# .rs.parseInheritDotParamsFromHelp  (help-db lookup layer)
# ---------------------------------------------------------------------------

test_that("parseInheritDotParamsFromHelp returns NULL for unknown function", {
   expect_null(.rs.parseInheritDotParamsFromHelp("____no_such_fn____", NULL))
})


# ---------------------------------------------------------------------------
# .rs.getCompletionsInheritDotParams
# ---------------------------------------------------------------------------

test_that("getCompletionsInheritDotParams returns empty when fn has no ...", {
   result <- .rs.getCompletionsInheritDotParams(
      token       = "",
      string      = "wrapper",
      object      = function(x, y) NULL,
      matchedCall = make_matched_call(),
      ownFormals  = c("x", "y")
   )
   expect_length(result$results, 0L)
})

test_that("getCompletionsInheritDotParams returns empty for malformed string with multiple ::", {
   result <- .rs.getCompletionsInheritDotParams(
      token       = "",
      string      = "a::b::c",
      object      = make_wrapper_fn(c("x", "...")),
      ownFormals  = c("x = ", "... = "),
      matchedCall = make_matched_call()
   )
   expect_length(result$results, 0L)
})

test_that("getCompletionsInheritDotParams returns empty for unknown function", {
   result <- .rs.getCompletionsInheritDotParams(
      token       = "",
      string      = "____no_such_fn____",
      object      = make_wrapper_fn(),
      matchedCall = make_matched_call(),
      ownFormals  = c("x", "...")
   )
   expect_length(result$results, 0L)
})

with_fixture_completions <- function(expr) {
   with_rs_mock(
      ".rs.parseInheritDotParamsFromHelp",
      function(fnName, pkgName) .rs.parseInheritDotParamsFromRd(fixture_rd),
      expr
   )
}

test_that("getCompletionsInheritDotParams returns ARGUMENT completions from fixture", {
   with_fixture_completions({
      result <- .rs.getCompletionsInheritDotParams(
         token       = "",
         string      = "pkg::wrapper",
         object      = make_wrapper_fn(c("x", "...")),
         ownFormals  = c("x = ", "... = "),
         matchedCall = make_matched_call()
      )
      expect_length(result$results, 6L)
      expect_all_equal(result$type, .rs.acCompletionTypes$ARGUMENT)
      # Verify comma-separated args are split correctly
      expect_in("n = ",    result$results)
      expect_in("prop = ", result$results)
   })
})

test_that("getCompletionsInheritDotParams uses target package from \\link for completionSource", {
   with_fixture_completions({
      result <- .rs.getCompletionsInheritDotParams(
         token       = "",
         string      = "pkg::wrapper",
         object      = make_wrapper_fn(c("x", "...")),
         ownFormals  = c("x = ", "... = "),
         matchedCall = make_matched_call()
      )
      # Fixture uses [=target]{target} (same-package), so completionSource
      # falls back to pkgName.
      expect_all_equal(result$packages, "pkg::target")
   })
})

test_that("getCompletionsInheritDotParams uses targetPkg over pkgName for cross-package \\link", {
   # Cross-package [pkg:topic]{pkg::fn} link -- targetPkg should be preferred
   # over pkgName (the wrapper's package), fixing the masking / cross-package case.
   rd_text <- paste0(
      "\\name{wrapper}\\title{W}\\description{D}\\usage{wrapper(...)}\n",
      "\\arguments{\\item{...}{Arguments passed on to \\code{\\link[otherpkg:target]{otherpkg::target}}",
      "\\describe{\\item{\\code{x}}{desc}}}}"
   )
   rd <- tools::parse_Rd(textConnection(rd_text))
   with_rs_mock(
      ".rs.parseInheritDotParamsFromHelp",
      function(fnName, pkgName) .rs.parseInheritDotParamsFromRd(rd),
      {
         result <- .rs.getCompletionsInheritDotParams(
            token       = "",
            string      = "otherpkg::wrapper",
            object      = make_wrapper_fn(c("...")),
            ownFormals  = c("... = "),
            matchedCall = make_matched_call()
         )
         expect_all_equal(result$packages, "otherpkg::target")
      }
   )
})

test_that("getCompletionsInheritDotParams excludes wrapper's own formals", {
   with_fixture_completions({
      result <- .rs.getCompletionsInheritDotParams(
         token       = "",
         string      = "pkg::wrapper",
         object      = make_wrapper_fn(c("x", "...")),
         ownFormals  = c("x = ", "... = "),
         matchedCall = make_matched_call()
      )
      returned_names <- sub(" = $", "", result$results)
      expect_disjoint("x",     returned_names)
      expect_in("alpha", returned_names)
      expect_in("beta",  returned_names)
      expect_in("gamma", returned_names)
   })
})

test_that("getCompletionsInheritDotParams excludes already-used args", {
   with_fixture_completions({
      result <- .rs.getCompletionsInheritDotParams(
         token       = "",
         string      = "pkg::wrapper",
         object      = make_wrapper_fn(c("x", "...")),
         ownFormals  = c("x = ", "... = "),
         matchedCall = make_matched_call(named_args = "alpha")
      )
      returned_names <- sub(" = $", "", result$results)
      expect_disjoint("alpha", returned_names)
      expect_in("beta",   returned_names)
      expect_in("gamma",  returned_names)
   })
})

test_that("getCompletionsInheritDotParams backtick-quotes reserved word arg names", {
   with_fixture_completions({
      result <- .rs.getCompletionsInheritDotParams(
         token       = "",
         string      = "pkg::wrapper",
         object      = make_wrapper_fn(c("x", "...")),
         ownFormals  = c("x = ", "... = "),
         matchedCall = make_matched_call()
      )
      # Reserved words like `if` require backtick-quoting when deparsed
      expect_in("`if` = ", result$results)
   })
})

test_that("getCompletionsInheritDotParams filters by token prefix", {
   with_fixture_completions({
      result <- .rs.getCompletionsInheritDotParams(
         token       = "al",
         string      = "pkg::wrapper",
         object      = make_wrapper_fn(c("x", "...")),
         ownFormals  = c("x = ", "... = "),
         matchedCall = make_matched_call()
      )
      returned_names <- sub(" = $", "", result$results)
      expect_in("alpha",  returned_names)
      expect_disjoint("beta",  returned_names)
      expect_disjoint("gamma", returned_names)
   })
})

test_that("getCompletionsInheritDotParams returns empty for function defined in global env", {
   # A locally-defined function lives in R_GlobalEnv, not a package namespace.
   # The early exit should fire and return empty completions.
   local_fn <- local(function(x, ...) x, envir = globalenv())
   result <- .rs.getCompletionsInheritDotParams(
      token       = "",
      string      = "local_fn",   # no :: prefix, so package resolved from env
      object      = local_fn,
      ownFormals  = c("x = ", "... = "),
      matchedCall = make_matched_call()
   )
   expect_length(result$results, 0L)
})

test_that("getCompletionsInheritDotParams handles triple-colon pkg:::fn syntax", {
   with_fixture_completions({
      result <- .rs.getCompletionsInheritDotParams(
         token       = "",
         string      = "pkg:::wrapper",
         object      = make_wrapper_fn(c("x", "...")),
         ownFormals  = c("x = ", "... = "),
         matchedCall = make_matched_call()
      )
      expect_gt(length(result$results), 0L)
   })
})

test_that("getCompletionsInheritDotParams returns cached result on second call", {
   with_fixture_completions({
      # Call twice with the same pkg::fn -- second call hits the cache.
      result1 <- .rs.getCompletionsInheritDotParams(
         token       = "",
         string      = "pkg::wrapper",
         object      = make_wrapper_fn(c("x", "...")),
         ownFormals  = c("x = ", "... = "),
         matchedCall = make_matched_call()
      )
      result2 <- .rs.getCompletionsInheritDotParams(
         token       = "",
         string      = "pkg::wrapper",
         object      = make_wrapper_fn(c("x", "...")),
         ownFormals  = c("x = ", "... = "),
         matchedCall = make_matched_call()
      )
      expect_equal(result1$results, result2$results)
   })
})


# ---------------------------------------------------------------------------
# .rs.getCompletionsFunction  (end-to-end, no external packages)
# ---------------------------------------------------------------------------

with_mock_inherit_dot_params <- function(newValue, expr) {
   with_rs_mock(".rs.getCompletionsInheritDotParams", newValue, expr)
}

test_that("getCompletionsFunction does not call getCompletionsInheritDotParams for primitives", {
   # Primitives like list() have ... but cannot have @inheritDotParams docs.
   # Verify the is.primitive() guard fires before getCompletionsInheritDotParams is reached.
   expect_no_error(
      with_mock_inherit_dot_params(
         function(...) stop("should not be called for primitives"),
         .rs.getCompletionsFunction(
            token        = "",
            string       = "list",
            functionCall = quote(list()),
            numCommas    = 0L,
            envir        = globalenv()
         )
      )
   )
})

test_that("getCompletionsFunction returns only own formals for non-primitive base fns without @inheritDotParams", {
   # base::mean has ... but no @inheritDotParams -- getCompletionsInheritDotParams
   # is called but returns empty, so only mean's own formals are offered.
   result <- .rs.getCompletionsFunction(
      token        = "",
      string       = "mean",
      functionCall = quote(mean()),
      numCommas    = 0L,
      envir        = globalenv()
   )
   returned_names <- sub(" = $", "", result$results)
   expect_setequal(returned_names, c("x", "..."))
})


# ---------------------------------------------------------------------------
# .rs.getCompletionsFunction  (end-to-end, requires ggplot2)
# ---------------------------------------------------------------------------

test_that("getCompletionsFunction returns inherited dot args with empty token", {
   skip_if_not_installed("ggplot2")
   result <- .rs.getCompletionsFunction(
      token        = "",
      string       = "ggplot2::scale_color_grey",
      functionCall = quote(ggplot2::scale_color_grey()),
      numCommas    = 0L,
      envir        = globalenv()
   )
   returned_names <- sub(" = $", "", result$results)
   expect_in("breaks", returned_names)
})

test_that("getCompletionsFunction returns inherited dot args with partial token", {
   skip_if_not_installed("ggplot2")
   result <- .rs.getCompletionsFunction(
      token        = "br",
      string       = "ggplot2::scale_color_grey",
      functionCall = quote(ggplot2::scale_color_grey(br)),
      numCommas    = 0L,
      envir        = globalenv()
   )
   returned_names <- sub(" = $", "", result$results)
   expect_in("breaks",  returned_names)
   expect_disjoint("labels", returned_names)
})

test_that("getCompletionsFunction resolves package via environment when no :: used", {
   skip_if_not_installed("ggplot2")
   # Use the function object from ggplot2 but pass a bare name as string --
   # exercises the environmentName(environment(object)) fallback path.
   withr::with_package("ggplot2", {
      result <- .rs.getCompletionsFunction(
         token        = "",
         string       = "scale_color_grey",
         functionCall = quote(scale_color_grey()),
         numCommas    = 0L,
         envir        = globalenv()
      )
   })
   returned_names <- sub(" = $", "", result$results)
   expect_in("breaks", returned_names)
})

test_that("getCompletionsFunction handles triple-colon pkg:::fn syntax", {
   skip_if_not_installed("ggplot2")
   result <- .rs.getCompletionsFunction(
      token        = "",
      string       = "ggplot2:::scale_color_grey",
      functionCall = quote(ggplot2:::scale_color_grey()),
      numCommas    = 0L,
      envir        = globalenv()
   )
   returned_names <- sub(" = $", "", result$results)
   expect_in("breaks", returned_names)
})

test_that("getCompletionsFunction returns completions when token filters out ...", {
   skip_if_not_installed("ggplot2")
   # When token = "br", resolveFormals filters out "... = " from formals$formals,
   # so the hasDots fallback via formals(object) must be exercised.
   result <- .rs.getCompletionsFunction(
      token        = "br",
      string       = "ggplot2::scale_color_grey",
      functionCall = quote(ggplot2::scale_color_grey(br)),
      numCommas    = 0L,
      envir        = globalenv()
   )
   returned_names <- sub(" = $", "", result$results)
   expect_in("breaks", returned_names)
})

#
# test-environment.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("environment")

test_that("environment object listings are correct", {
   # temporarily disable showing the .Last.value so we don't have to account for it in test results
   lastValue <- .rs.api.readRStudioPreference("show_last_dot_value")
   on.exit(.rs.api.writeRStudioPreference("show_last_dot_value", lastValue))
   .rs.api.writeRStudioPreference("show_last_dot_value", FALSE)

   # our test-runner sets runAllTests function in the global environment, so initial
   # length is one
   .rs.invokeRpc("set_environment", "R_GlobalEnv")
   expect_equal(length(.rs.invokeRpc("list_environment")), 1)

   # add some items to the global environment
   assign("obj1", 1, envir = globalenv())
   assign("obj2", "two", envir = globalenv())
   assign("obj3", list(1, 2, 3), envir = globalenv())

   # active binding
   makeActiveBinding("obj4", env = globalenv(), local({
      count <- 0
      function(){
         count <<- count + 1
         count
      }
   }))

   # promise
   delayedAssign("obj5", local({
      assign("obj6", 6, globalenv())
      5
   }), globalenv(), globalenv())

   # list the global environment
   .rs.invokeRpc("set_environment", "R_GlobalEnv")
   contents <- .rs.invokeRpc("list_environment")

   # verify contents (newly added plus the initial runAllTests function)
   expect_equal(length(contents), 6)
   obj1 <- contents[[1]]
   expect_equal(obj1[["name"]], "obj1")
   expect_equal(obj1[["value"]], "1")
   obj2 <- contents[[2]]
   expect_equal(obj2[["name"]], "obj2")
   expect_equal(obj2[["value"]], "\"two\"")
   obj3 <- contents[[3]]
   expect_equal(obj3[["name"]], "obj3")
   expect_equal(obj3[["length"]], 3)
   obj4 <- contents[[4]]
   expect_equal(obj4[["name"]], "obj4")
   expect_equal(obj4[["type"]], "active binding")
   expect_equal(obj4[["value"]], "<Active binding>")
   obj5 <- contents[[5]]
   expect_equal(obj5[["name"]], "obj5")
   expect_equal(obj5[["type"]], "promise")
   expect_equal(obj5[["value"]], "local({ <...>")

   # check that active binding wasn't forced yet
   expect_equal(get("obj4", globalenv()), 1)

   # check that the promise wasn't evaluated yet
   expect_true(!exists("obj6", globalenv()))
})

test_that(".Last.value appears in environment listing when enabled", {
   # https://github.com/rstudio/rstudio/issues/17737
   # Regression test: ensure the "Show .Last.value" preference works.
   # .Last.value is stored on R_LastvalueSymbol via SET_SYMVALUE (it lives
   # in baseenv, not in globalenv's frame), so a frame-only lookup misses it.
   lastValue <- .rs.api.readRStudioPreference("show_last_dot_value")
   on.exit(.rs.api.writeRStudioPreference("show_last_dot_value", lastValue), add = TRUE)
   .rs.api.writeRStudioPreference("show_last_dot_value", TRUE)

   # .Last.value's binding in baseenv is locked; unlock to set a known value
   # then relock (and restore) so we don't leak state to other tests.
   prev <- .Last.value
   unlockBinding(".Last.value", baseenv())
   on.exit({
      assign(".Last.value", prev, envir = baseenv())
      lockBinding(".Last.value", baseenv())
   }, add = TRUE)
   assign(".Last.value", 42L, envir = baseenv())

   .rs.invokeRpc("set_environment", "R_GlobalEnv")
   contents <- .rs.invokeRpc("list_environment")

   names <- vapply(contents, function(x) x[["name"]], character(1))
   expect_true(".Last.value" %in% names)

   lastVal <- contents[[which(names == ".Last.value")]]
   # binding-type classification must resolve via baseenv (not "unknown")
   expect_false(identical(lastVal[["type"]], "unknown"))
   expect_equal(lastVal[["value"]], "42L")
})

test_that("ancestor-shadowed .Last.value is classified at the shadowing env", {
   # https://github.com/rstudio/rstudio/issues/17737
   # When a parent env in the search path shadows .Last.value (e.g. with an
   # active binding), the binding-type cascade must classify it against the
   # shadowing env, not against R_BaseEnv. This also exercises the
   # non-evaluating chain walk in findBindingFrame: the active binding's
   # getter must fire only once (during the existence check in listEnvironment),
   # not again while we locate the binding's frame for type classification.
   lastValue <- .rs.api.readRStudioPreference("show_last_dot_value")
   on.exit(.rs.api.writeRStudioPreference("show_last_dot_value", lastValue), add = TRUE)
   .rs.api.writeRStudioPreference("show_last_dot_value", TRUE)

   # Attach an empty env first, then add the active binding directly to the
   # env on the search path. attach(env) on R < 4.6 copies contents via get(),
   # which would fire the active binding during the copy and demote it to a
   # regular value -- defeating the test.
   attach(NULL, name = "rstudio-17737-shadow", warn.conflicts = FALSE)
   on.exit(detach("rstudio-17737-shadow"), add = TRUE)
   shadow <- as.environment("rstudio-17737-shadow")

   counter <- 0L
   makeActiveBinding(".Last.value", function() {
      counter <<- counter + 1L
      42L
   }, env = shadow)

   .rs.invokeRpc("set_environment", "R_GlobalEnv")
   contents <- .rs.invokeRpc("list_environment")

   names <- vapply(contents, function(x) x[["name"]], character(1))
   expect_true(".Last.value" %in% names)

   lastVal <- contents[[which(names == ".Last.value")]]
   expect_equal(lastVal[["type"]], "active binding")
   # Getter ran only for the existence-check value lookup; the chain walk
   # used to identify the shadowing env must not have re-fired it.
   expect_equal(counter, 1L)
})

test_that(".Last.value is hidden when preference is disabled", {
   # https://github.com/rstudio/rstudio/issues/17737
   lastValue <- .rs.api.readRStudioPreference("show_last_dot_value")
   on.exit(.rs.api.writeRStudioPreference("show_last_dot_value", lastValue), add = TRUE)
   .rs.api.writeRStudioPreference("show_last_dot_value", FALSE)

   .rs.invokeRpc("set_environment", "R_GlobalEnv")
   contents <- .rs.invokeRpc("list_environment")

   names <- vapply(contents, function(x) x[["name"]], character(1))
   expect_false(".Last.value" %in% names)
})

test_that("flag must be specified when removing objects", {
   expect_error(.rs.invokeRpc("remove_all_objects"))
})

test_that("all objects are removed when requested", {

   # temporarily disable showing the .Last.value so we don't have to account for it in test results
   lastValue <- .rs.api.readRStudioPreference("show_last_dot_value")
   on.exit(.rs.api.writeRStudioPreference("show_last_dot_value", lastValue))
   .rs.api.writeRStudioPreference("show_last_dot_value", FALSE)

   contents <- .rs.invokeRpc("list_environment")
   expect_true(length(contents) > 0)

   .rs.invokeRpc("remove_all_objects", TRUE)

   contents <- .rs.invokeRpc("list_environment")
   expect_equal(length(contents), 0)
})

test_that("functions with backslashes deparse correctly", {
   # make diagnostics happy
   f <- NULL
   
   # character vector with code for a simple function
   code <- "f <- function() { \"first line\\nsecond line\" }"

   # parse and evaluate the expression (yielding a function f)
   eval(parse(text = code))

   # immediately deparse f back into a string
   output <- .rs.deparseFunction(f, TRUE, TRUE)

   expect_equal(output, code)
})

test_that("memory usage stats are reasonable", {
   report <- .rs.invokeRpc("get_memory_usage_report")

   # ensure that we get values from R
   expect_true(report$r$cons > 0)
   expect_true(report$r$vector > 0)

   # ensure that the memory used by R is less than the memory used by the process
   r_total <- report$r$cons + report$r$vector
   expect_true(report$system$process$kb > r_total)
})

test_that("missing arguments can be described", {

   # simulate a missing value argument
   delayedAssign("x", quote(expr = ))
   desc <- .rs.describeObject("x", environment())
   expect_identical(desc$name, .rs.scalar("x"))

})

test_that("date/time scalars are formatted in the environment pane", {
   # https://github.com/rstudio/rstudio/issues/17556
   # difftime objects previously fell through to NO_VALUE because they
   # carry attributes (so the atomic-no-attributes branch is skipped) and
   # weren't included in the date/time class list.
   env <- new.env(parent = emptyenv())
   env$dt <- as.difftime(90, units = "secs")
   env$ts <- .POSIXct(1234567890, tz = "UTC")

   dt_desc <- .rs.describeObject("dt", env)
   expect_identical(dt_desc$value, .rs.scalar(format(env$dt, usetz = TRUE)))

   ts_desc <- .rs.describeObject("ts", env)
   expect_identical(ts_desc$value, .rs.scalar(format(env$ts, usetz = TRUE)))
})

test_that(".rs.isSerializable() works as expected", {
   
   # some 'obvious' examples
   expect_true(.rs.isSerializable(1))
   expect_true(.rs.isSerializable(letters))
   expect_true(.rs.isSerializable(mtcars))
   expect_true(.rs.isSerializable(pairlist(1, 2)))
   expect_true(.rs.isSerializable(matrix(1:4, nrow = 2)))
   
   # slightly less obvious
   envir <- new.env(parent = emptyenv())
   expect_true(.rs.isSerializable(envir))

   # test that we avoid infinite recursion
   envir$self <- envir
   expect_true(.rs.isSerializable(envir))
   
   # external pointers can't be serialized
   expect_false(.rs.isSerializable(.Call("rs_newTestExternalPointer", FALSE)))
   expect_false(.rs.isSerializable(.Call("rs_newTestExternalPointer", TRUE)))

   # put the extptr into an environment; no longer serializable
   envir$extptr <- .Call("rs_newTestExternalPointer", FALSE)
   expect_false(.rs.isSerializable(envir))
   
   # test that promises are not evaluated
   value <- FALSE
   delayedAssign("value", { value <- TRUE }, assign.env = envir)
   expect_false(.rs.isSerializable(envir))
   expect_false(value)
   
   # force the promise, just to confirm it does what we expect it to
   force(envir$value)
   expect_true(value)
   
   # test that active bindings are not evaluated
   value <- FALSE
   makeActiveBinding("active", function() value <<- TRUE, env = envir)
   expect_false(.rs.isSerializable(envir))
   expect_false(value)
   
   # trigger the active binding, just to confirm it does what we expected
   force(envir$active)
   expect_true(value)
   
   # for loops create immediate bindings; check that we don't barf when
   # attempting to scan the environment in such cases
   for (binding in 1)
      .rs.isSerializable(environment())
   
})

test_that("object size computations are correct", {

   expect_equal_size <- function(object) {
      testthat::expect_equal(object.size(object), .rs.objectSize(object))
   }
   
   expect_equal_size(NULL)
   expect_equal_size(as.symbol("symbol"))
   expect_equal_size(pairlist(42))
   expect_equal_size(function() {})
   expect_equal_size(globalenv())
   expect_equal_size(quote(2 + 2))
   expect_equal_size(c)
   expect_equal_size(logical(42))
   expect_equal_size(integer(42))
   expect_equal_size(double(42))
   expect_equal_size(complex(42))
   expect_equal_size(raw(42))
   expect_equal_size(letters)
   expect_equal_size(vector("list", 42))
   expect_equal_size(list(1, 2, 3))
   expect_equal_size(parse(text = "{ 1 + 2 }"))
   expect_equal_size(parse(text = "{ 1 + 2 }")[[1]])
   
   
   expect_equal_size(NULL)
   expect_equal_size(TRUE)
   expect_equal_size(NA)
   expect_equal_size(123L)
   expect_equal_size(123)
   expect_equal_size(letters)
   
   expect_equal_size(list())
   expect_equal_size(letters)
   expect_equal_size(mtcars)
   
   expect_equal_size(quote(expr = ))
   expect_equal_size(as.symbol("hello"))
   
   expect_equal_size(pairlist(1, 2, 3))
   
   expect_equal_size(baseenv())
   expect_equal_size(globalenv())
   
   foo <- function(a = 1) {}
   expect_equal_size(formals(foo))
   expect_equal_size(body(foo))
   expect_equal_size(foo)
   
   if (requireNamespace("compiler", quietly = TRUE))
   {
      foo <- compiler::cmpfun(foo)
      expect_equal_size(formals(foo))
      expect_equal_size(body(foo))
      expect_equal_size(foo)
      
      bytecode <- .Call("rs_functionBody", foo)
      expect_equal_size(bytecode)
   }
   
   expect_equal_size(globalenv())
   expect_equal_size(emptyenv())
   expect_equal_size(baseenv())
   expect_equal_size(new.env())
   
   setClass("Person", representation(name = "character", age = "numeric"))
   kevin <- new("Person", name = "Kevin", age = NA_real_)
   expect_equal_size(kevin)
   
   expect_equal_size(c("a", "a", "a"))
   expect_equal_size(c("a", "b", "c"))
   expect_equal_size(list("a", "a", "a"))
   expect_equal_size(list("a", "b", "c"))
   
   # https://github.com/rstudio/rstudio/issues/16202
   x <- as.character(42)
   expect_true(.rs.objectSize(x) > 0)
   
})

#
# test-ppm.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("ppm")

# Helper: produce expected structures pre-marked with .rs.scalar so they
# compare equal to the parser's output (which runs everything through
# .rs.markScalars before returning).
expected <- function(...) .rs.markScalars(list(...))

# Helper: build a cache environment populated with the given keyed entries,
# matching the per-repo layout produced by .rs.ppm.repoVulnCache and consumed
# by .rs.ppm.aggregateVulnsByName.
cacheEnv <- function(...)
{
   entries <- list(...)
   env <- new.env(parent = emptyenv())
   for (key in names(entries))
      assign(key, entries[[key]], envir = env)
   env
}

test_that("parseVulnerabilityResponse treats a missing body as nothing-to-record", {
   # character(0) is the crash-guard case: strsplit(character(0), ...) has no
   # [[1L]] element. We return the empty marker (not NULL) so the response is
   # recorded as "checked, no vulns" rather than retried forever.
   result <- .rs.ppm.parseVulnerabilityResponse(character(0))
   expect_equal(result, structure(list(), names = character()))
})

test_that("parseVulnerabilityResponse returns NULL for an empty server body", {
   # a 2xx with an empty body tells us nothing about the requested packages, so
   # we signal failure (NULL) and let a later refresh retry rather than caching
   # every package as "no vulns" and clearing badges
   expect_null(.rs.ppm.parseVulnerabilityResponse(""))
})

test_that("parseVulnerabilityResponse returns NULL for a whitespace-only body", {
   expect_null(.rs.ppm.parseVulnerabilityResponse("   "))
   expect_null(.rs.ppm.parseVulnerabilityResponse("\n"))
   expect_null(.rs.ppm.parseVulnerabilityResponse("\r\n"))
})

test_that("parseVulnerabilityResponse parses a single record into a name==version key", {
   contents <- '{"name":"pkgA","version":"1.0.0","vulns":[{"id":"V1","summary":"hi"}]}'
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgA==1.0.0` = list(list(id = "V1", summary = "hi"))
   ))
})

test_that("parseVulnerabilityResponse keeps each (name, version) pair in its own key", {
   contents <- paste(
      '{"name":"pkgA","version":"1.0.0","vulns":[{"id":"V1","summary":"hi"}]}',
      '{"name":"pkgA","version":"1.1.0","vulns":[{"id":"V1","summary":"hi"}]}',
      sep = "\n"
   )
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgA==1.0.0` = list(list(id = "V1", summary = "hi")),
      `pkgA==1.1.0` = list(list(id = "V1", summary = "hi"))
   ))
})

test_that("parseVulnerabilityResponse groups records across distinct packages", {
   contents <- paste(
      '{"name":"pkgA","version":"1.0.0","vulns":[{"id":"V1"}]}',
      '{"name":"pkgB","version":"0.2.0","vulns":[{"id":"V2"}]}',
      sep = "\n"
   )
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgA==1.0.0` = list(list(id = "V1")),
      `pkgB==0.2.0` = list(list(id = "V2"))
   ))
})

test_that("parseVulnerabilityResponse returns NULL and warns when any record is an error", {
   contents <- paste(
      '{"name":"pkgA","version":"1.0.0","vulns":[{"id":"V1"}]}',
      '{"error":"not allowed","code":"403"}',
      sep = "\n"
   )
   expect_warning(
      result <- .rs.ppm.parseVulnerabilityResponse(contents),
      "error requesting package vulnerabilities.*not allowed.*403"
   )
   expect_null(result)
})

test_that("parseVulnerabilityResponse skips records with no vulns field", {
   contents <- paste(
      '{"name":"pkgA","version":"1.0.0"}',
      '{"name":"pkgB","version":"0.1.0","vulns":[{"id":"V2"}]}',
      sep = "\n"
   )
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgB==0.1.0` = list(list(id = "V2"))
   ))
})

test_that("parseVulnerabilityResponse skips records with empty vulns arrays", {
   contents <- paste(
      '{"name":"pkgA","version":"1.0.0","vulns":[]}',
      '{"name":"pkgB","version":"0.1.0","vulns":[{"id":"V2"}]}',
      sep = "\n"
   )
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgB==0.1.0` = list(list(id = "V2"))
   ))
})

test_that("parseVulnerabilityResponse skips records missing the name field", {
   contents <- paste(
      '{"version":"1.0.0","vulns":[{"id":"V1"}]}',
      '{"name":"pkgB","version":"0.1.0","vulns":[{"id":"V2"}]}',
      sep = "\n"
   )
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgB==0.1.0` = list(list(id = "V2"))
   ))
})

test_that("parseVulnerabilityResponse skips records missing the version field", {
   contents <- paste(
      '{"name":"pkgA","vulns":[{"id":"V1"}]}',
      '{"name":"pkgB","version":"0.1.0","vulns":[{"id":"V2"}]}',
      sep = "\n"
   )
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgB==0.1.0` = list(list(id = "V2"))
   ))
})

test_that("parseVulnerabilityResponse tolerates blank lines between records", {
   contents <- paste(
      '{"name":"pkgA","version":"1.0.0","vulns":[{"id":"V1"}]}',
      "",
      '{"name":"pkgB","version":"0.2.0","vulns":[{"id":"V2"}]}',
      "",
      sep = "\n"
   )
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgA==1.0.0` = list(list(id = "V1")),
      `pkgB==0.2.0` = list(list(id = "V2"))
   ))
})

test_that("parseVulnerabilityResponse preserves nested vuln fields", {
   contents <- paste0(
      '{"name":"pkgA","version":"1.0.0","vulns":[',
      '{"id":"V1","summary":"s","details":"d","modified":"m","published":"p",',
      '"ranges":[{"type":"SEMVER","events":[{"introduced":"0","fixed":"2"}]}],',
      '"versions":{"1.0.0":true}}',
      ']}'
   )
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgA==1.0.0` = list(list(
         id = "V1",
         summary = "s",
         details = "d",
         modified = "m",
         published = "p",
         ranges = list(list(
            type = "SEMVER",
            events = list(list(introduced = "0", fixed = "2"))
         )),
         versions = list(`1.0.0` = TRUE)
      ))
   ))
})

test_that("parseVulnerabilityResponse skips malformed JSON lines", {
   # .rs.fromJSON returns NULL on parse failure; the parser silently
   # skips those records. Pin the contract so a future change makes a
   # deliberate decision rather than an accidental one.
   contents <- paste(
      '{"name":"pkgA","version":"1.0.0","vulns":[{"id":"V1"}]}',
      '{this is not json',
      '{"name":"pkgB","version":"0.1.0","vulns":[{"id":"V2"}]}',
      sep = "\n"
   )
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgA==1.0.0` = list(list(id = "V1")),
      `pkgB==0.1.0` = list(list(id = "V2"))
   ))
})

test_that("parseVulnerabilityResponse tolerates CRLF line endings", {
   contents <- paste(
      '{"name":"pkgA","version":"1.0.0","vulns":[{"id":"V1"}]}',
      '{"name":"pkgB","version":"0.2.0","vulns":[{"id":"V2"}]}',
      sep = "\r\n"
   )
   result <- .rs.ppm.parseVulnerabilityResponse(contents)
   expect_equal(result, expected(
      `pkgA==1.0.0` = list(list(id = "V1")),
      `pkgB==0.2.0` = list(list(id = "V2"))
   ))
})

test_that("aggregateVulnsByName collects a single (name, version) into the by-name shape", {
   cache <- cacheEnv(
      `pkgA==1.0.0` = list(list(id = "V1", summary = "hi"))
   )
   result <- .rs.ppm.aggregateVulnsByName(cache, "pkgA==1.0.0")
   expect_equal(result, expected(
      pkgA = list(list(id = "V1", summary = "hi"))
   ))
})

test_that("aggregateVulnsByName groups vulns across multiple installed versions", {
   # PPM returns the same vuln list for every queried version of a given
   # package, but a user with the same package in two libraries will see
   # both versions cached. We concatenate without deduping; the rare
   # duplicate is cosmetic only -- the frontend's per-row check uses each
   # vuln's versions map, not list position.
   cache <- cacheEnv(
      `pkgA==1.0.0` = list(list(id = "V1", summary = "hi")),
      `pkgA==1.1.0` = list(list(id = "V1", summary = "hi"))
   )
   result <- .rs.ppm.aggregateVulnsByName(cache, c("pkgA==1.0.0", "pkgA==1.1.0"))
   expect_equal(result, expected(
      pkgA = list(
         list(id = "V1", summary = "hi"),
         list(id = "V1", summary = "hi")
      )
   ))
})

test_that("aggregateVulnsByName groups vulns across distinct packages", {
   cache <- cacheEnv(
      `pkgA==1.0.0` = list(list(id = "V1", summary = "first")),
      `pkgB==2.0.0` = list(list(id = "V2", summary = "second"))
   )
   result <- .rs.ppm.aggregateVulnsByName(cache, c("pkgA==1.0.0", "pkgB==2.0.0"))
   expect_equal(result, expected(
      pkgA = list(list(id = "V1", summary = "first")),
      pkgB = list(list(id = "V2", summary = "second"))
   ))
})

test_that("aggregateVulnsByName skips cache entries that aren't currently installed", {
   # A package upgrade leaves the old (name, version) key behind in the
   # cache. Filtering by pkgKeys means the orphan doesn't leak back to the UI.
   cache <- cacheEnv(
      `pkgA==1.0.0` = list(list(id = "V1", summary = "stale")),
      `pkgA==2.0.0` = list()
   )
   result <- .rs.ppm.aggregateVulnsByName(cache, "pkgA==2.0.0")
   expect_equal(result, structure(list(), names = character()))
})

test_that("aggregateVulnsByName skips cached entries with empty vuln lists", {
   # PPM may have nothing to say about a package, in which case the cache
   # holds an empty list as a "queried, no vulns" marker.
   cache <- cacheEnv(
      `pkgA==1.0.0` = list(),
      `pkgB==0.1.0` = list(list(id = "V2"))
   )
   result <- .rs.ppm.aggregateVulnsByName(cache, c("pkgA==1.0.0", "pkgB==0.1.0"))
   expect_equal(result, expected(
      pkgB = list(list(id = "V2"))
   ))
})

# Tests for the asynchronous request-plan / response-recording flow. The
# network request itself happens in C++ (off the main thread); these tests
# exercise the R helpers that decide what to request and that fold a response
# back into the per-repo cache.
.rs.testPpm <- list(
   repoUrl = "https://example.test/repo/latest"
)

# Swap a tools-env function for the duration of the current test_that() frame.
# Schedules restoration via withr::defer so the swap only lasts for that frame.
withMockFunction <- function(name, fn)
{
   toolsEnv <- .rs.toolsEnv()
   original <- get(name, envir = toolsEnv)
   assign(name, fn, envir = toolsEnv)
   withr::defer(
      assign(name, original, envir = toolsEnv),
      envir = parent.frame()
   )
}

# Reset the per-repo cache and pending-key state between tests so nothing
# leaks between them.
clearVulnsState <- function()
{
   rm(list = ls(envir = .rs.ppm.vulns, all.names = TRUE), envir = .rs.ppm.vulns)
   rm(list = ls(envir = .rs.ppm.pending, all.names = TRUE), envir = .rs.ppm.pending)
}

test_that("getVulnerabilityRequestPlan asks PPM only about uncached keys", {
   clearVulnsState()
   cache <- new.env(parent = emptyenv())
   assign("pkgA==1.0.0", list(list(id = "V1")), envir = cache)
   assign(.rs.testPpm$repoUrl, cache, envir = .rs.ppm.vulns)

   withMockFunction(".rs.ppm.installedPackageKeys", function() c("pkgA==1.0.0", "pkgB==2.0.0"))
   withMockFunction(".rs.computeAuthorizationHeader", function(url) "")

   plan <- .rs.ppm.getVulnerabilityRequestPlan(repos = c(CRAN = .rs.testPpm$repoUrl))

   expect_length(plan, 1L)
   # only the uncached key should appear in the request body
   expect_true(grepl("pkgB==2.0.0", plan[[1L]]$body, fixed = TRUE))
   expect_false(grepl("pkgA==1.0.0", plan[[1L]]$body, fixed = TRUE))
   # the requested keys are recorded so the response handler can mark them
   expect_equal(.rs.ppm.pending[[.rs.testPpm$repoUrl]], "pkgB==2.0.0")
})

test_that("getVulnerabilityRequestPlan skips repos with no uncached keys", {
   clearVulnsState()
   cache <- new.env(parent = emptyenv())
   assign("pkgA==1.0.0", list(list(id = "V1")), envir = cache)
   assign(.rs.testPpm$repoUrl, cache, envir = .rs.ppm.vulns)

   withMockFunction(".rs.ppm.installedPackageKeys", function() "pkgA==1.0.0")

   plan <- .rs.ppm.getVulnerabilityRequestPlan(repos = c(CRAN = .rs.testPpm$repoUrl))

   expect_length(plan, 0L)
   expect_false(exists(.rs.testPpm$repoUrl, envir = .rs.ppm.pending, inherits = FALSE))
})

test_that("getVulnerabilityRequestPlan ignores the integration-enabled flag", {
   # Regression guard: vulnerability display is intentionally NOT opt-in. It is
   # driven by whether a PPM repository is configured (see the PPM-URL check
   # below), NOT by the PWB_PPM_* env vars (.rs.ppm.isIntegrationEnabled, which
   # gates only the Workbench metadata column). A plan must still be built for a
   # PPM repo even when integration reports "disabled". See 88778df845 "always
   # try to provide vuln info if available"; an async rewrite once re-applied the
   # env-var gate here and suppressed vulns for sessions that set repos by hand.
   clearVulnsState()
   withMockFunction(".rs.ppm.isIntegrationEnabled", function() FALSE)
   withMockFunction(".rs.ppm.installedPackageKeys", function() "pkgA==1.0.0")
   withMockFunction(".rs.computeAuthorizationHeader", function(url) "")

   plan <- .rs.ppm.getVulnerabilityRequestPlan(repos = c(CRAN = .rs.testPpm$repoUrl))
   expect_length(plan, 1L)
})

test_that("getVulnerabilityRequestPlan skips non-PPM repositories", {
   clearVulnsState()
   withMockFunction(".rs.ppm.installedPackageKeys", function() "pkgA==1.0.0")

   plan <- .rs.ppm.getVulnerabilityRequestPlan(repos = c(CRAN = "https://cran.rstudio.com"))
   expect_length(plan, 0L)
})

test_that("getVulnerabilityRequestPlan keeps the PPM repo when a non-PPM repo is mixed in", {
   # the cheap any() pre-filter only decides whether to bail; the per-repo loop
   # does the real filtering, so a non-PPM repo alongside a PPM one must not
   # suppress the PPM plan entry
   clearVulnsState()
   withMockFunction(".rs.ppm.installedPackageKeys", function() "pkgA==1.0.0")
   withMockFunction(".rs.computeAuthorizationHeader", function(url) "")

   plan <- .rs.ppm.getVulnerabilityRequestPlan(
      repos = c(CRAN = "https://cran.rstudio.com", PPM = .rs.testPpm$repoUrl)
   )
   expect_length(plan, 1L)
   expect_equal(as.character(plan[[1L]]$repoUrl), .rs.testPpm$repoUrl)
})

test_that("getVulnerabilityRequestPlan skips installed.packages() for non-PPM sessions", {
   # the PPM-URL pre-filter exists to avoid the expensive installed.packages()
   # call when no repo qualifies; this locks in that ordering
   clearVulnsState()
   withMockFunction(".rs.ppm.installedPackageKeys", function() stop("should not be called"))

   plan <- .rs.ppm.getVulnerabilityRequestPlan(repos = c(CRAN = "https://cran.rstudio.com"))
   expect_length(plan, 0L)
})

test_that("getVulnerabilityRequestPlan tolerates an NA repo entry", {
   # getOption("repos") can carry an NA entry (e.g. an unset named repo); the
   # plan must not abort on it (.rs.regexMatches would otherwise throw)
   clearVulnsState()
   withMockFunction(".rs.ppm.installedPackageKeys", function() "pkgA==1.0.0")
   withMockFunction(".rs.computeAuthorizationHeader", function(url) "")

   plan <- .rs.ppm.getVulnerabilityRequestPlan(
      repos = c(BIOC = NA_character_, PPM = .rs.testPpm$repoUrl)
   )
   expect_length(plan, 1L)
   expect_equal(as.character(plan[[1L]]$repoUrl), .rs.testPpm$repoUrl)
})

test_that("getVulnerabilityRequestPlan returns nothing when no packages are installed", {
   clearVulnsState()
   withMockFunction(".rs.ppm.installedPackageKeys", function() character())

   plan <- .rs.ppm.getVulnerabilityRequestPlan(repos = c(CRAN = .rs.testPpm$repoUrl))
   expect_length(plan, 0L)
})

test_that("getVulnerabilityRequestPlan includes the computed auth header and endpoint", {
   clearVulnsState()
   withMockFunction(".rs.ppm.installedPackageKeys", function() "pkgA==1.0.0")
   # mock the header explicitly so the assertion doesn't depend on the test
   # runner's real ~/.netrc
   withMockFunction(".rs.computeAuthorizationHeader", function(url) "Basic dXNlcjpwYXNz")

   plan <- .rs.ppm.getVulnerabilityRequestPlan(repos = c(CRAN = .rs.testPpm$repoUrl))
   expect_length(plan, 1L)
   expect_equal(as.character(plan[[1L]]$authHeader), "Basic dXNlcjpwYXNz")
   expect_match(as.character(plan[[1L]]$endpoint), "/__api__/filter/packages$")
})

test_that("getVulnerabilityRequestPlan emits one entry per PPM repo with uncached keys", {
   clearVulnsState()

   repoA <- "https://a.example.test/repo/latest"
   repoB <- "https://b.example.test/repo/latest"

   # repoA already has pkgA cached; repoB has nothing cached yet
   cacheA <- new.env(parent = emptyenv())
   assign("pkgA==1.0.0", list(), envir = cacheA)
   assign(repoA, cacheA, envir = .rs.ppm.vulns)

   withMockFunction(".rs.ppm.installedPackageKeys", function() c("pkgA==1.0.0", "pkgB==2.0.0"))
   withMockFunction(".rs.computeAuthorizationHeader", function(url) "")

   plan <- .rs.ppm.getVulnerabilityRequestPlan(repos = c(A = repoA, B = repoB))
   expect_length(plan, 2L)

   repoUrls <- vapply(plan, function(e) as.character(e$repoUrl), character(1))
   planA <- plan[[which(repoUrls == repoA)]]
   planB <- plan[[which(repoUrls == repoB)]]

   # repoA only needs pkgB (pkgA is cached); repoB needs both
   expect_true(grepl("pkgB==2.0.0", planA$body, fixed = TRUE))
   expect_false(grepl("pkgA==1.0.0", planA$body, fixed = TRUE))
   expect_true(grepl("pkgA==1.0.0", planB$body, fixed = TRUE))
   expect_true(grepl("pkgB==2.0.0", planB$body, fixed = TRUE))
})

test_that("buildVulnerabilityRequestBody sets the repo and omit flags", {
   parsed <- .rs.fromJSON(
      .rs.ppm.buildVulnerabilityRequestBody("cran", c("pkgA==1.0.0", "pkgB==2.0.0"))
   )
   expect_equal(as.character(parsed$repo), "cran")
   expect_true(as.logical(parsed$omit_dependencies))
   expect_true(as.logical(parsed$omit_downloads))
   expect_true(as.logical(parsed$omit_package_details))
   expect_equal(as.character(parsed$names), c("pkgA==1.0.0", "pkgB==2.0.0"))
})

test_that("buildVulnerabilityRequestBody omits has_vulns so all packages are returned", {
   # has_vulns is a server-side filter; sending it would drop every non-vulnerable
   # package from the response, taking its metadata down with it. The single
   # request must return a record for every requested package so we can feed both
   # the vulnerability badges and the metadata column from one response.
   body <- .rs.ppm.buildVulnerabilityRequestBody("cran", "pkgA==1.0.0")
   parsed <- .rs.fromJSON(body)
   expect_null(parsed$has_vulns)
   expect_false(grepl("has_vulns", body, fixed = TRUE))
})

test_that("buildVulnerabilityRequestBody keeps a single package name as a JSON array", {
   # as.list() prevents unbox = TRUE from collapsing a one-element vector into a
   # bare string; PPM's filter/packages endpoint requires names to be an array.
   # fromJSON can't distinguish array-of-one from a scalar, so assert on the
   # serialized form directly.
   body <- .rs.ppm.buildVulnerabilityRequestBody("cran", "pkgA==1.0.0")
   expect_match(body, '"names"[[:space:]]*:[[:space:]]*\\[')
   expect_true(grepl("pkgA==1.0.0", body, fixed = TRUE))
})

test_that("fromRepositoryUrl classifies a plain PPM repo URL", {
   parts <- .rs.ppm.fromRepositoryUrl("https://packagemanager.posit.co/cran/latest")
   expect_equal(parts[["root"]], "https://packagemanager.posit.co")
   expect_equal(parts[["repos"]], "cran")
   expect_equal(parts[["snapshot"]], "latest")
   expect_false(nzchar(parts[["binary"]]))
})

test_that("fromRepositoryUrl tolerates a trailing slash", {
   # RStudio's own CRAN-mirror UI normalizes the repo URL with a trailing slash,
   # so a UI-configured PPM repo lands in options(repos) as ".../latest/". Both
   # forms must be detected as the same repo, or such users silently get no
   # vulnerability badges. (Trailing-slash defect found while investigating
   # rstudio#18018.)
   bare <- .rs.ppm.fromRepositoryUrl("https://packagemanager.posit.co/cran/latest")
   slash <- .rs.ppm.fromRepositoryUrl("https://packagemanager.posit.co/cran/latest/")
   expect_false(is.null(slash))
   expect_equal(slash[["root"]], "https://packagemanager.posit.co")
   expect_equal(slash[["repos"]], "cran")
   expect_equal(slash[["snapshot"]], "latest")
   # the snapshot must not absorb the trailing slash
   expect_equal(slash[["snapshot"]], bare[["snapshot"]])
})

test_that("fromRepositoryUrl extracts the optional binary / platform parts", {
   parts <- .rs.ppm.fromRepositoryUrl(
      "https://packagemanager.posit.co/cran/__linux__/jammy/2024-01-01"
   )
   expect_equal(parts[["repos"]], "cran")
   expect_equal(parts[["binary"]], "__linux__")
   expect_equal(parts[["platform"]], "jammy")
   expect_equal(parts[["snapshot"]], "2024-01-01")
})

test_that("fromRepositoryUrl tolerates a trailing slash on a binary URL", {
   # the optional trailing slash must apply to the binary / platform shape too,
   # and must not bleed into the snapshot.
   parts <- .rs.ppm.fromRepositoryUrl(
      "https://packagemanager.posit.co/cran/__linux__/jammy/2024-01-01/"
   )
   expect_equal(parts[["repos"]], "cran")
   expect_equal(parts[["binary"]], "__linux__")
   expect_equal(parts[["platform"]], "jammy")
   expect_equal(parts[["snapshot"]], "2024-01-01")
})

test_that("fromRepositoryUrl returns NULL for non-PPM and non-string inputs", {
   # the common desktop entries -- "@CRAN@" and "" -- are not PPM URLs, and an
   # NA entry must be tolerated rather than throwing from .rs.regexMatches
   expect_null(.rs.ppm.fromRepositoryUrl("@CRAN@"))
   expect_null(.rs.ppm.fromRepositoryUrl(""))
   expect_null(.rs.ppm.fromRepositoryUrl(NA_character_))
   expect_null(.rs.ppm.fromRepositoryUrl(NULL))
   expect_null(.rs.ppm.fromRepositoryUrl(character()))
})

test_that("recordVulnerabilityResponse caches vulns and empty markers for requested keys", {
   clearVulnsState()
   assign(.rs.testPpm$repoUrl, c("pkgA==1.0.0", "pkgB==2.0.0"), envir = .rs.ppm.pending)

   body <- '{"name":"pkgA","version":"1.0.0","vulns":[{"id":"V1"}]}'
   .rs.ppm.recordVulnerabilityResponse(.rs.testPpm$repoUrl, body)

   cache <- .rs.ppm.vulns[[.rs.testPpm$repoUrl]]
   # the parser marks leaf values as scalars, so compare against the marked form
   expect_equal(get("pkgA==1.0.0", envir = cache), expected(list(id = "V1")))
   # pkgB had no vulns reported -- cache an empty marker so we don't re-ask
   expect_equal(get("pkgB==2.0.0", envir = cache), list())
   # the pending entry is cleared once recorded
   expect_false(exists(.rs.testPpm$repoUrl, envir = .rs.ppm.pending, inherits = FALSE))
})

test_that("recordVulnerabilityResponse caches metadata from the same response", {
   # a single filter/packages response carries both vulns and custom metadata;
   # recording it must populate the metadata cache too (the metadata column reads
   # this cache directly, with no network access of its own)
   clearVulnsState()
   rm(
      list = ls(envir = .rs.ppm.metadataCache, all.names = TRUE),
      envir = .rs.ppm.metadataCache
   )
   assign(.rs.testPpm$repoUrl, c("pkgA==1.0.0", "pkgB==2.0.0"), envir = .rs.ppm.pending)

   body <- paste(
      '{"name":"pkgA","version":"1.0.0","vulns":[{"id":"V1"}],"metadata":[{"key":"risk-level","value":"low"}]}',
      '{"name":"pkgB","version":"2.0.0"}',
      sep = "\n"
   )
   .rs.ppm.recordVulnerabilityResponse(.rs.testPpm$repoUrl, body)

   metaCache <- .rs.ppm.metadataCache[[.rs.testPpm$repoUrl]]
   # pkgA's metadata is cached in the raw [{key,value}] form getMetadata expects
   expect_equal(
      get("pkgA==1.0.0", envir = metaCache),
      list(list(key = "risk-level", value = "low"))
   )
   # pkgB reported no metadata -- cache an NA marker so we don't keep re-asking
   expect_true(is.na(get("pkgB==2.0.0", envir = metaCache)))
})

test_that("metadataByKey keys metadata by name==version and marks misses with NA", {
   records <- list(
      list(name = "pkgA", version = "1.0.0",
           metadata = list(list(key = "risk-level", value = "high"))),
      list(name = "pkgB", version = "2.0.0"),
      list(version = "9.9.9")   # missing name -- skipped entirely
   )
   result <- .rs.ppm.metadataByKey(records)
   expect_equal(result[["pkgA==1.0.0"]], list(list(key = "risk-level", value = "high")))
   expect_true(is.na(result[["pkgB==2.0.0"]]))
   expect_false("9.9.9" %in% names(result))
})

test_that("recordVulnerabilityResponse leaves cache and pending intact on a server error", {
   clearVulnsState()
   assign(.rs.testPpm$repoUrl, "pkgB==2.0.0", envir = .rs.ppm.pending)

   body <- '{"error":"not allowed","code":"403"}'
   expect_warning(
      .rs.ppm.recordVulnerabilityResponse(.rs.testPpm$repoUrl, body),
      "error requesting package vulnerabilities.*not allowed.*403"
   )

   # nothing cached, and the key stays pending so a later refresh retries it
   expect_null(.rs.ppm.vulns[[.rs.testPpm$repoUrl]])
   expect_equal(.rs.ppm.pending[[.rs.testPpm$repoUrl]], "pkgB==2.0.0")
})

test_that("recordVulnerabilityResponse leaves cache and pending intact on an empty body", {
   # an empty 2xx body parses to NULL (request-failed signal), so nothing should
   # be cached and the key stays pending for a later retry
   clearVulnsState()
   assign(.rs.testPpm$repoUrl, "pkgB==2.0.0", envir = .rs.ppm.pending)

   .rs.ppm.recordVulnerabilityResponse(.rs.testPpm$repoUrl, "")

   expect_null(.rs.ppm.vulns[[.rs.testPpm$repoUrl]])
   expect_equal(.rs.ppm.pending[[.rs.testPpm$repoUrl]], "pkgB==2.0.0")
})

test_that("getMetadata reads the cache for the active repo without any network access", {
   clearVulnsState()
   rm(
      list = ls(envir = .rs.ppm.metadataCache, all.names = TRUE),
      envir = .rs.ppm.metadataCache
   )

   # seed the metadata cache as the async refresh would have
   metaCache <- .rs.ppm.repoMetadataCache(.rs.testPpm$repoUrl)
   assign("pkgA==1.0.0", list(list(key = "risk-level", value = "low")), envir = metaCache)
   assign("pkgB==2.0.0", NA_character_, envir = metaCache)

   withMockFunction(".rs.ppm.getActiveRepository", function() list(url = .rs.testPpm$repoUrl))
   withMockFunction(".rs.ppm.getMetadataKey", function() "risk-level")

   result <- .rs.ppm.getMetadata()
   # the requested key resolves to its value; the NA-marked package yields ""
   expect_equal(as.character(result[["pkgA==1.0.0"]]), "low")
   expect_equal(as.character(result[["pkgB==2.0.0"]]), "")
})

test_that("getMetadata returns an empty list when the active repo has no cache", {
   rm(
      list = ls(envir = .rs.ppm.metadataCache, all.names = TRUE),
      envir = .rs.ppm.metadataCache
   )
   withMockFunction(".rs.ppm.getActiveRepository", function() list(url = .rs.testPpm$repoUrl))
   withMockFunction(".rs.ppm.getMetadataKey", function() "risk-level")

   expect_equal(.rs.ppm.getMetadata(), list())
})

test_that("getCachedVulnerabilities aggregates per repo without any network access", {
   clearVulnsState()
   cache <- new.env(parent = emptyenv())
   assign("pkgA==1.0.0", list(list(id = "V1")), envir = cache)
   assign(.rs.testPpm$repoUrl, cache, envir = .rs.ppm.vulns)

   withMockFunction(".rs.ppm.installedPackageKeys", function() "pkgA==1.0.0")

   result <- .rs.ppm.getCachedVulnerabilities(repos = c(CRAN = .rs.testPpm$repoUrl))
   expect_equal(result, list(CRAN = expected(
      pkgA = list(list(id = "V1"))
   )))
})

test_that("getCachedVulnerabilities isolates a failing repo from the others", {
   # one repo's aggregation error must not take down the client update for the
   # rest -- the failing repo yields an empty map while the others succeed
   clearVulnsState()

   repoA <- "https://a.example.test/repo/latest"   # will fail to aggregate
   repoB <- "https://b.example.test/repo/latest"   # will aggregate cleanly

   cacheA <- new.env(parent = emptyenv())
   assign("__boom__", TRUE, envir = cacheA)
   assign(repoA, cacheA, envir = .rs.ppm.vulns)

   cacheB <- new.env(parent = emptyenv())
   assign("pkgB==2.0.0", list(list(id = "V2")), envir = cacheB)
   assign(repoB, cacheB, envir = .rs.ppm.vulns)

   warned <- FALSE
   withMockFunction(".rs.logWarningMessage", function(message) warned <<- TRUE)
   withMockFunction(".rs.ppm.installedPackageKeys", function() "pkgB==2.0.0")
   withMockFunction(".rs.ppm.aggregateVulnsByName", function(cache, pkgKeys)
   {
      if (exists("__boom__", envir = cache, inherits = FALSE))
         stop("boom")
      .rs.markScalars(list(pkgB = list(list(id = "V2"))))
   })

   result <- .rs.ppm.getCachedVulnerabilities(repos = c(A = repoA, B = repoB))
   expect_true(warned)
   expect_equal(result$A, structure(list(), names = character()))
   expect_equal(result$B, expected(pkgB = list(list(id = "V2"))))
})

#
# SessionRenv.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar("renvCache", new.env(parent = emptyenv()))

.rs.addJsonRpcHandler("renv_init", function(project)
{
   # run script in child process (done so that `renv::init()` doesn't
   # change the state of the running session)
   .rs.executeFunctionInChildProcess(
      callback   = .rs.renv.initCallback,
      data       = list(repos = getOption("repos")),
      workingDir = project
   )
   
})

.rs.addJsonRpcHandler("renv_actions", function(action)
{
   project <- .rs.getProjectDirectory()
   actions <- renv:::actions(tolower(action), project = project)
   if (length(actions) == 0)
      return(list())
   
   remap <- c(
      "Package"          = "packageName",
      "Library Version"  = "libraryVersion",
      "Library Source"   = "librarySource",
      "Lockfile Version" = "lockfileVersion",
      "Lockfile Source"  = "lockfileSource",
      "Action"           = "action"
   )
   
   matches <- match(names(actions), names(remap), nomatch = 0L)
   names(actions)[matches] <- remap[matches]
   
   data <- lapply(seq_len(nrow(actions)), function(i) {
      as.list(actions[i, ])
   })
   
   .rs.scalarListFromList(data)
})

.rs.addFunction("renv.context", function()
{
   context <- list()
   
   # validate that renv is installed
   location <- find.package("renv", quiet = TRUE)
   context[["installed"]] <- length(location) != 0
   
   # check and see if renv is active
   project <- Sys.getenv("RENV_PROJECT", unset = NA)
   context[["active"]] <- !is.na(project)
   
   # return context
   lapply(context, .rs.scalar)
   
})

.rs.addFunction("renv.options", function()
{
   context <- .rs.renv.context()
   
   options <- list()
   
   options[["useRenv"]] <- context[["active"]]
   # TODO: surface options associated with
   # the current project
   
   options
   
})

.rs.addFunction("renv.refresh", function()
{
   # get file info on installed packages, lockfile
   project <- renv::project()
   libdir <- renv:::renv_paths_library(project = project)
   
   files <- c(
      file.path(project, "renv.lock"),
      list.files(libdir, full.names = TRUE)
   )
   
   info <- file.info(files, extra_cols = FALSE)
   
   # drop unneeded fields
   new <- info[c("size", "mtime")]
   
   # check for changes
   old <- .rs.renvCache[["modifiedTimes"]]
   
   # have things changed?
   if (identical(old, new))
      return()
   
   # update cache
   .rs.renvCache[["modifiedTimes"]] <- new
   
   # fire events
   .rs.updatePackageEvents()
   .Call("rs_packageLibraryMutated", PACKAGE = "(embedding)")
})

.rs.addFunction("renv.readLockfilePackages", function(project)
{
   renv <- asNamespace("renv")
   
   # read lockfile
   lockpath <- file.path(project, "renv.lock")
   lockfile <- renv$renv_lockfile_read(lockpath)
   
   # grab lockfile records
   # renv internal APIs changed in a recent update, so look for the right
   # accessor method here
   method <- .rs.nullCoalesce(renv$renv_lockfile_records, renv$renv_records)
   packages <- method(lockfile)
   
   # keep only the pieces we need
   filtered <- lapply(packages, `[`, c("Package", "Version", "Source"))
   df <- .rs.rbindList(filtered)
   rownames(df) <- NULL
   df
})

.rs.addFunction("renv.activeProjectPath", function()
{
   tryCatch(renv:::project(), error = function(e) NULL)
})

.rs.addFunction("renv.listPackages", function(project)
{
   # get list of packages
   installedPackagesList <- .rs.listInstalledPackages()
   installedPackages <- .rs.rbindList(installedPackagesList)
   
   # try to read the lockfile (return plain library list if this fails)
   lockfilePackages <- .rs.tryCatch(.rs.renv.readLockfilePackages(project))
   if (inherits(lockfilePackages, "error"))
      return(installedPackages)
   
   # rename columns for conformity of Packrat stuff
   names(lockfilePackages) <- c("name", "packrat.version", "packrat.source")

   # note which packages are in project library
   projectLibrary <- renv:::renv_paths_library(project = project)
   installedPackages[["in.project.library"]] <-
      installedPackages[["library_absolute"]] == projectLibrary

   # merge together
   merge.data.frame(
      x = installedPackages,
      y = lockfilePackages,
      by = "name",
      all.x = TRUE,
      all.y = TRUE
   )
   
})

.rs.addFunction("renv.initCallback", function(repos)
{
   # set active repos
   options(repos = repos)
   
   # avoid timeouts when querying unresponsive R package repositories
   options(renv.config.connect.timeout = 0L)
   options(renv.config.connect.retry = 0L)

   # tell renv that we know what we're doing
   options(renv.consent = TRUE)
   
   # if we're running tests, be quiet during init
   if (!is.na(Sys.getenv("TESTTHAT", unset = NA)))
     return(renv:::quietly(renv::init()))
     
   # otherwise, do a regular init
   renv::init()
})

#
# SessionPatches.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.registerPackageLoadHook("rstudioapi", function(...)
{
   # bail if we're not version 0.7
   if (packageVersion("rstudioapi") != "0.7")
      return()
   
   # re-assign the 'selectDirectory()' function
   rstudioapi <- asNamespace("rstudioapi")
   override <- function(caption = "Select Directory",
                        label = "Select",
                        path = rstudioapi::getActiveProject())
   {
      callFun("selectDirectory", caption, label, path)
   }
   environment(override) <- rstudioapi
   
   .rs.replaceBinding("selectDirectory", "rstudioapi", override)
})

.rs.registerPackageLoadHook("parallel", function(...)
{
   # enforce sequential setup of cluster
   # https://github.com/rstudio/rstudio/issues/6692
   parallel:::setDefaultClusterOptions(setup_strategy = "sequential")
})

# On Windows, because we now set the active code page to UTF-8,
# we need to be careful to ensure the outputs from list.files(), list.dirs()
# and dir() have their encoding properly marked. We do this here.
if (.rs.platform.isWindows)
{
   setHook("rstudio.sessionInit", function(...)
   {
      enabled <- getOption("rstudio.enableFileHooks", default = getRversion() < "4.2.0")
      if (identical(enabled, TRUE))
         .rs.files.replaceBindings()
   })
}

#
# SessionRUtil.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("suspendSession", function(force = FALSE, exitStatus = 0L)
{
   .Call("rs_suspendSession",
         as.logical(force),
         as.integer(exitStatus),
         PACKAGE = "(embedding)")
})

.rs.addFunction("enc2native", function(text)
{
   # try converting to native encoding
   native <- iconv(text, from = "UTF-8", to = "")

   # iconv will return NA for any strings that we couldn't
   # re-encode into the native encoding -- replace those
   # back with their UTF-8 originals
   failed <- is.na(native)
   native[failed] <- text[failed]

   # return the converted string
   native
})

.rs.addFunction("isNullExternalPointer", function(object)
{
   .Call("rs_isNullExternalPointer", object, PACKAGE = "(embedding)")
})

.rs.addFunction("readIniFile", function(filePath)
{
   as.list(.Call("rs_readIniFile", filePath, PACKAGE = "(embedding)"))
})

.rs.addFunction("runAsyncRProcess", function(
   code,
   workingDir  = getwd(),
   onStarted   = function() {},
   onContinue  = function() {},
   onStdout    = function(output) {},
   onStderr    = function(output) {},
   onCompleted = function(exitStatus) {})
{
   callbacks <- list(
      started   = onStarted,
      continue  = onContinue,
      stdout    = onStdout,
      stderr    = onStderr,
      completed = onCompleted
   )
   
   .Call(
      "rs_runAsyncRProcess",
      as.character(code),
      normalizePath(workingDir, mustWork = TRUE),
      as.list(callbacks),
      PACKAGE = "(embedding)"
   )
})

#' Run an R script in a separate R process, via `system2()`.
#' 
#' Run `code` in a child \R process, launched via `system2()`.
#' 
#' @param callback An \R function, to be executed within the child process.
#'   It should take a single parameter, which represents the `data` to
#'   be supplied to the callback.
#' 
#' @param data An optional list of side-car data, to be referenced from
#'   `code` via the `data` argument. These arguments will be applied to
#'   the callback via `do.call(callback, data)`, and so should normally
#'   be a named list mapping argument names to their appropriate values.
#'   
#' @param workingDir An optional working directory in which `code`
#'   should be run.
#' 
#' @param libPaths The library paths to be set and used by the child process.
#'   By default, the parent's library paths are used.
#'
#' @param ... Optional arguments passed to `system2()`.
#' 
.rs.addFunction("executeFunctionInChildProcess", function(callback, 
                                                          data = list(),
                                                          workingDir = NULL,
                                                          libPaths = .libPaths(),
                                                          ...)
{
   # create and move to directory we'll use to stage our scripts
   scriptDir <- tempfile("rstudio-script-")
   dir.create(scriptDir, recursive = TRUE, showWarnings = FALSE)
   owd <- setwd(scriptDir)
   
   # clean up when we're done
   on.exit({
      setwd(owd)
      unlink(scriptDir, recursive = TRUE)
   }, add = TRUE)
   
   # set R_LIBS so that library paths are propagated to child process
   rlibs <- Sys.getenv("R_LIBS", unset = NA)
   Sys.setenv(R_LIBS = paste(libPaths, collapse = .Platform$path.sep))
   on.exit({
      if (is.na(rlibs))
         Sys.unsetenv("R_LIBS")
      else
         Sys.setenv(R_LIBS = rlibs)
   }, add = TRUE)
   
   # create data bundle powering script
   bundle <- list(
      callback   = callback,
      data       = data,
      workingDir = workingDir
   )
   
   # define runner script (will load data and execute user-defined callback)
   script <- quote({
      
      # read side-car data file
      bundle <- readRDS("bundle.rds")
      
      # move to requested working directory
      workingDir <- bundle[["workingDir"]]
      if (!is.null(workingDir)) {
         dir.create(workingDir, recursive = TRUE, showWarnings = FALSE)
         owd <- setwd(workingDir)
         on.exit(setwd(owd), add = TRUE)
      }
      
      # retrieve callback data
      callback <- bundle[["callback"]]
      data     <- bundle[["data"]]
      
      # execute callback
      do.call(callback, data)
      
   })
   
   # write bundle to file
   # (suppress 'may not be available when loading' warnings)
   suppressWarnings(saveRDS(bundle, file = "bundle.rds"))
   
   # write script to file
   writeLines(deparse(script), con = "script.R")
   
   # form path to R
   exe <- if (Sys.info()[["sysname"]] == "Windows") "R.exe" else "R"
   r <- file.path(R.home("bin"), exe)
   
   # form command line arguments
   args <- c("--vanilla", "-s", "-f", shQuote("script.R"))
   
   # run the script
   system2(r, args, ...)
   
})

# NOTE: this uses a bundled YAML library in the IDE as opposed to the R
# yaml package; primarily to avoid issues that can arise when attempting
# to load R packages in a session (users will then struggle to update or
# reinstall such packages)
.rs.addFunction("fromYAML", function(yamlCode)
{
   yamlCode <- paste(yamlCode, collapse = "\n")
   .Call("rs_fromYAML", yamlCode, PACKAGE = "(embedding)")
})

#
# SessionEnvironment.R
#
# Copyright (C) 2009-16 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("valueFromStr", function(val)
{
   .rs.withTimeLimit(1, fail = "<truncated>", {
      capture.output(try(str(val), silent = TRUE))
   })
   
})

.rs.addFunction("valueAsString", function(val)
{
   tryCatch(
   {
      is.scalarOrVector <- function (x) {
         if (is.null(attributes(x)))
         {
            !is.na(c(NULL=TRUE,
                     logical=TRUE,
                     double=TRUE,
                     integer=TRUE,
                     complex=TRUE,
                     character=TRUE)[typeof(x)])
         }
         else
         {
            FALSE
         }
      }

      if (is.scalarOrVector(val))
      {
         if (length(val) == 0)
            return (paste(.rs.getSingleClass(val), " (empty)"))
         if (length(val) == 1)
         {
            quotedVal <- deparse(val)
            if (nchar(quotedVal) < 1024)
                return (quotedVal)
            else
                return (paste(substr(quotedVal, 1, 1024), " ..."))
         }
         else if (length(val) > 1)
            return (.rs.valueFromStr(val))
         else
            return ("NO_VALUE")
      }
      else if (is(val, "python.builtin.object")) {
         return (.rs.valueFromStr(val))
      }
      else if (.rs.isFunction(val))
         return (.rs.getSignature(val))
      else if (is(val, "Date") || is(val, "POSIXct") || is(val, "POSIXlt")) {
         if (length(val) == 1)
           return (format(val))
         else
           return (.rs.valueFromStr(val))
      }
      else
         return ("NO_VALUE")
   },
   error = function(e) 
   { 
      # Don't print errors--they'll appear in the R console. Instead, let the
      # client deal with errors by handling the special value NO_VALUE.
   })

   return ("NO_VALUE")
})

.rs.addFunction("valueContents", function(val)
{
   tryCatch(
   {
      # for Oracle R frames, show the query if it exists
      if (is(val, "ore.frame")) 
      {
        query <- attr(val, "dataQry", exact = TRUE) 

        # no query, show empty
        if (is.null(query))
          return("NO_VALUE") 

        # query, display it
        attributes(query) <- NULL
        return(paste("   Query:", query))
      }

      # only return the first 150 lines of detail (generally columns)--any more
      # won't be very presentable in the environment pane. the first line
      # generally contains descriptive text, so don't return that.
      output <- .rs.valueFromStr(val)
      lines <- length(output)
      if (lines > 150) {
        output <- c(output[2:150], 
                    paste("  [... ", lines - 150, " lines omitted]", 
                          sep = ""))
      } 
      else if (lines > 1) {
        output <- output[-1]
      }
      return(output)
   },
   error = function(e) { })

   return ("NO_VALUE")
})

.rs.addFunction("isFunction", function(val)
{
   is.function(val) || identical(.rs.getSingleClass(val), "C++Function")
})

# used to create description for promises
.rs.addFunction("promiseDescription", function(obj)
{
   # by default, the description should be the expression associated with the
   # object
   description <- paste(deparse(substitute(obj)), collapse="")

   # create a more friendly description for delay-loaded data
   if (substr(description, 1, 16) == "lazyLoadDBfetch(")
   {
      description <- "<Promise>"
   }
   return (description)
})

# used to create descriptions for language objects and symbols
.rs.addFunction("languageDescription", function(env, objectName)
{
   desc <- "Missing object"
   tryCatch(
   {
      desc <- capture.output(print(get(objectName, env)))
   },
   error = function(e)
   {
      # silently ignore; if the object can't be retrieved from the
      # environment, treat it as missing
   },
   finally =
   {
      return(desc)
   })
})

.rs.addFunction("sourceFileFromRef", function(srcref)
{
   if (!is.null(srcref))
   {
      fileattr <- attr(srcref, "srcfile")
      enc2utf8(fileattr$filename)
   }
   else
      ""
})

# Given a function and some content inside that function, returns a vector
# in the standard R source reference format that represents the location of
# the content in the deparsed representation of the function.
.rs.addFunction("simulateSourceRefs", function(var)
{
  # Read arguments from attached attributes to the input (these can't be passed
  # naked from RStudio)
  fun <-  attr(var, "_rs_callfun")
  call <- attr(var, "_rs_callobj")
  calltext <- attr(var, "_rs_calltext")
  linepref <- attr(var, "_rs_lastline")

  # To proceed, we need the function to look in, and either the raw call
  # object (which we will deparse later) or the text to look for.
  if (is.null(fun) || 
      (is.null(call) && is.null(calltext)) )
     return(c(0L, 0L, 0L, 0L, 0L, 0L))

  lines <- .rs.deparseFunction(fun, FALSE, FALSE)

  # Remember the indentation level on each line (added by deparse), and remove
  # it along with any other leading or trailing whitespace. 
  indents <- nchar(sub("\\S.*", "", lines))
  slines <- sub("\\s+$", "", sub("^\\s+", "", lines))

  # Compute the character position of the start of each line, and collapse the
  # lines to a character vector of length 1. 
  nchars <- 0
  offsets <- integer(length(slines))
  for (i in 1:length(slines)) {
    nchars <- nchars + nchar(slines[i]) + 1
    offsets[i] <- nchars
  }
  singleline <- paste(slines, collapse=" ")
  
  if (is.null(calltext))
  {
     # No call text specified; deparse into a list of lines
     calltext <- deparse(call)
  }
  else
  {
     # Call text specified as a single character vector; split into a list
     # of lines
     calltext <- unlist(strsplit(calltext, "\n", fixed = TRUE))
  }

  # Remove leading/trailing whitespace on each line, and collapse the lines
  calltext <- sub("\\s+$", "", sub("^\\s+", "", calltext))
  calltext <- paste(calltext, collapse=" ")

  # Any call text supplied is presumed UTF-8 unless we know otherwise
  if (Encoding(calltext) == "unknown")
     Encoding(calltext) <- "UTF-8"

  # NULL is output by R when it doesn't have an expression to output; don't
  # try to match it to code
  if (identical(calltext, "NULL")) 
     return(c(0L, 0L, 0L, 0L, 0L, 0L))

  pos <- gregexpr(calltext, singleline, fixed = TRUE)[[1]]
  if (length(pos) > 1)
  {
     # There is more than one instance of the call text in the function; try 
     # to pick the first match past the preferred line.
     best <- which(pos > offsets[linepref])
     if (length(best) == 0)
     {
        # No match past the preferred line, just pick the match closest
        best <- which.min(abs(linepref - pos))
     }
     else
        best <- best[1]
     endpos <- pos[best] + attr(pos, "match.length")[best]
     pos <- pos[best]
  }
  else
  {
     endpos <- pos + attr(pos, "match.length")
  }

  # Return an empty source ref if we couldn't find a match
  if (length(pos) == 0 || pos < 0)
     return(c(0L, 0L, 0L, 0L, 0L, 0L))

  # Compute the starting and ending lines
  firstline <- which(offsets >= pos, arr.ind = TRUE)[1] 
  lastline <- which(offsets >= endpos, arr.ind = TRUE)[1]  
  if (is.na(lastline))
     lastline <- length(offsets)

  # Compute the starting and ending character positions within the line, 
  # taking into account the indents we removed earlier. 
  firstchar <- pos - (if (firstline == 1) 0 else offsets[firstline - 1])
  firstchar <- firstchar + indents[firstline]

  # If the match is a block ({ ... }) and contains more than a few lines, 
  # match the first line instead of the whole block; having the entire contents
  # of the code browser highlighted is not useful. 
  if (substr(calltext, 1, 1) == "{" &&
      substr(calltext, nchar(calltext), nchar(calltext)) == "}" &&
      lastline - firstline > 5)
  {
     lastline <- firstline
     lastchar <- offsets[firstline] - pos
  }
  else
  {
     lastchar <- endpos - (if (lastline == 1) 0 else offsets[lastline - 1])
     lastchar <- lastchar + indents[lastline]
  }

  result <- as.integer(c(firstline, firstchar, lastline, 
                         lastchar, firstchar, lastchar))
  return(result)
})

.rs.addFunction("functionNameFromCall", function(val)
{
   call <- attr(val, "_rs_call")
   if (is.function(call[[1]]))
      "[Anonymous function]"
   else
      as.character(substitute(call))
})

.rs.addFunction("callSummary", function(val)
{
   deparse(attr(val, "_rs_call"))
})

.rs.addFunction("valueDescription", function(obj)
{
   tryCatch(
   {
      if (missing(obj))
      {
        return("Missing argument")
      }
      else if (is(obj, "ore.frame"))
      {
        sqlTable <- attr(obj, "sqlTable", exact = TRUE)
        if (is.null(sqlTable))
          return("Oracle R frame") 
        else
          return(paste("Oracle R frame:", sqlTable))
      }
      else if (.rs.isExternalPointer(obj))
      {
         class <- class(obj)
         if (length(class) && !identical(class, "externalptr"))
         {
            fmt <- "External pointer of class '%s'"
            return(sprintf(fmt, class[[1]]))
         }
         else
         {
            return("External pointer")
         }
      }
      else if (is.data.frame(obj))
      {
         return(paste(dim(obj)[1],
                      "obs. of",
                      dim(obj)[2],
                      ifelse(dim(obj)[2] == 1, "variable", "variables"),
                      sep=" "))
      }
      else if (is.environment(obj))
      {
         return("Environment")
      }
      else if (isS4(obj))
      {
         return(paste("Formal class ", is(obj)))
      }
      else if (is.list(obj))
      {
         return(paste("List of ", length(obj)))
      }
      else if (is.matrix(obj)
              || is.numeric(obj)
              || is.factor(obj)
              || is.raw(obj) 
              || is.character(obj)
              || is.logical(obj))
      {
         return(.rs.valueFromStr(obj))
      }
      else
         return("")
   },
   error = function(e) print(e))

   return ("")
})

.rs.addFunction("editor", function(name, file = "", title = file, ...)
{
   # if 'name' is missing, we're likely being invoked by
   # 'utils::file.edit()', so just edit the requested file
   if (missing(name))
      return(.Call("rs_editFile", file, PACKAGE = "(embedding)"))
   
   # otherwise, we're more likely being invoked by 'edit()', which
   # requires the parsed file to be valid R code -- so handle that
   
   # if no file has been supplied, generate one for the user
   if (is.null(file) || !nzchar(file)) {
      file <- tempfile("rstudio-scratch-", fileext = ".R")
      on.exit(unlink(file), add = TRUE)
   }
   
   # write deparsed R object to file
   deparsed <- if (is.function(name))
      .rs.deparseFunction(name, useSource = TRUE, asString = FALSE)
   else
      deparse(name)
   writeLines(deparsed, con = file)
   
   # invoke edit
   .Call("rs_editFile", file, PACKAGE = "(embedding)")
   
   # attempt to parse-eval the generated content
   eval(parse(file), envir = globalenv())
   
})

.rs.addFunction("registerFunctionEditor", function()
{
   options(editor = .rs.editor)
})


.rs.addFunction("getSingleClass", function(obj)
{
   className <- "(unknown)"
   tryCatch(className <- class(obj)[1],
            error = function(e) print(e))
   return (className)
})

.rs.addFunction("describeObject", function(env, objName, computeSize = TRUE)
{
   obj <- get(objName, env)
   # objects containing null external pointers can crash when
   # evaluated--display generically (see case 4092)
   hasNullPtr <- .Call("rs_hasExternalPointer", obj, TRUE, PACKAGE = "(embedding)")
   if (hasNullPtr) 
   {
      val <- "<Object with null pointer>"
      desc <- "An R object containing a null external pointer"
      size <- 0
      len <- 0
   }
   else 
   {
      val <- "(unknown)"
      desc <- ""

      # some objects (e.g. ALTREP) have compact representations that are forced to materialize if
      # an attempt is made to compute their metrics exactly; avoid computing the size for these
      size <- if (computeSize) object.size(obj) else 0
      len <- length(obj)
   }
   class <- .rs.getSingleClass(obj)
   contents <- list()
   contents_deferred <- FALSE
   # for language objects, don't evaluate, just show the expression
   if (is.language(obj) || is.symbol(obj))
   {
      val <- deparse(obj)
   }
   else if (!hasNullPtr)
   {
      # for large objects (> half MB), don't try to get the value, just show
      # the size. Some functions (e.g. str()) can cause the object to be
      # copied, which is slow for large objects.
      if (size > 524288)
      {
         len_desc <- if (len > 1) 
                   paste(len, " elements, ", sep="")
                else 
                   ""
         # data frames are likely to be large, but a summary is still helpful
         if (is.data.frame(obj))
         {
            val <- "NO_VALUE"
            desc <- .rs.valueDescription(obj)
         }
         else
         {
            val <- paste("Large ", class, " (", len_desc, 
                         format(size, units="auto", standard="SI"), ")", sep="")
         }
         contents_deferred <- TRUE
      }
      else
      {
         val <- .rs.valueAsString(obj)
         desc <- .rs.valueDescription(obj)

         # expandable object--supply contents 
         if (class == "data.table" ||
             class == "ore.frame" ||
             class == "cast_df" ||
             class == "xts" ||
             class == "DataFrame" ||
             is.list(obj) || 
             is.data.frame(obj) ||
             isS4(obj))
         {
            if (computeSize)
            {
               # normal object
               contents <- .rs.valueContents(obj)
            }
            else
            {
               # don't prefetch content for altreps
               val <- "NO_VALUE"
               contents_deferred <- TRUE
            }
         }
      }
   }
   list(
      name = .rs.scalar(objName),
      type = .rs.scalar(class),
      clazz = c(class(obj), typeof(obj)),
      is_data = .rs.scalar(is.data.frame(obj)),
      value = .rs.scalar(val),
      description = .rs.scalar(desc),
      size = .rs.scalar(size),
      length = .rs.scalar(len),
      contents = contents,
      contents_deferred = .rs.scalar(contents_deferred))
})

# returns the name and frame number of an environment from a call frame
.rs.addFunction("environmentCallFrameName", function(env)
{
   numCalls <- length(sys.calls())
   result <- list()
   for (i in 1:numCalls)
   {
      if (identical(sys.frame(i), env))
      {
         calldesc <- paste(deparse(sys.call(i)[[1]]), "()", sep="")
         result <- list(name = .rs.scalar(calldesc), 
                        frame = .rs.scalar(i),
                        local = .rs.scalar(TRUE))
         break
      }
   }
   if (identical(result, list()))
      list(name = .rs.scalar("unknown"), frame = .rs.scalar(0L))
   else
      result
})

# indicate whether the given environment is local (i.e. it comes before the
# global environment in the search path)
.rs.addFunction("environmentIsLocal", function(env)
{
   while (!identical(env, emptyenv())) 
   {
      # if one of this environment's parents is the global environment, it's
      # local
      env = parent.env(env)
      if (identical(env, globalenv())) 
         return(TRUE)
   }
   return(FALSE)
})

.rs.addFunction("environmentName", function(env)
{
   # global environment 
   if (identical(env, globalenv()))
     return(".GlobalEnv")

   # base environment
   if (identical(env, baseenv()))
     return("package:base")

   # look for the environment's given name; if it doesn't have a name, check
   # the callstack to see if it matches the environment in one of the call 
   # frames.
   result <- environmentName(env)
   
   if (nchar(result) == 0)
      .rs.environmentCallFrameName(env)$name
   else
   {
      # resolve namespaces
      if ((result %in% loadedNamespaces()) && 
          identical(asNamespace(result), env))
         paste("namespace:", result, sep="")
      else
         result
   }
})

.rs.addFunction("environmentList", function(startEnv)
{
   env <- startEnv
   envs <- list()
   local <- TRUE
   # if starting above the global environment, the environments will be
   # unnamed. to provide sensible names for them, look for a matching frame in
   # the callstack.
   if (!identical(env, globalenv()))
   {
      while (!identical(env, globalenv()) &&
             !identical(env, emptyenv()))
      {
         frame <- .rs.environmentCallFrameName(env)
         # if this frame is from the callstack, store it and proceed
         if (frame$frame > 0)
         {
            envs[[length(envs)+1]] <- frame 
            env <- parent.env(env)
         }
         # otherwise, stop here and get names normally
         else
            break
      }
   }
   # we're now past the call-frame portion of the stack; proceed normally
   # through the rest of the search path.
   while (!identical(env, emptyenv()))
   {
      # mark all environments as local until we reach the global 
      # environment
      if (identical(env, globalenv())) 
         local <- FALSE

      envName <- environmentName(env)

      # hide the RStudio internal tools environment and the autoloads
      # environment, and any environment that doesn't have a name
      if (nchar(envName) > 0 &&
          envName != "tools:rstudio" &&
          envName != "Autoloads")
      {
         envs[[length(envs)+1]] <-
                        list (name = .rs.scalar(envName),
                              frame = .rs.scalar(0L),
                              local = .rs.scalar(local))
      }
      env <- parent.env(env)
   }
   envs
})

.rs.addFunction("removeObjects", function(objNames, env)
{
   remove(list=unlist(objNames), envir=env)
})

.rs.addFunction("removeAllObjects", function(includeHidden, env)
{
   rm(list=ls(envir=env, all.names=includeHidden), envir=env)
})

.rs.addFunction("getObjectContents", function(objName, env)
{
   .rs.valueContents(get(objName, env));
})

.rs.addFunction("isAltrep", function(var)
{
   .Call("rs_isAltrep", var, PACKAGE="(embedding)")
})

.rs.addFunction("hasAltrep", function(var)
{
   .Call("rs_hasAltrep", var, PACKAGE="(embedding)")
})

#
# SessionProjectTemplate.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("getProjectTemplateRegistry", function()
{
   .Call("rs_getProjectTemplateRegistry", PACKAGE = "(embedding)")
})

.rs.addFunction("initializeProjectFromTemplate", function(projectFilePath,
                                                          projectPath,
                                                          description,
                                                          inputs)
{
   # move to parent path for project directory
   parentPath <- dirname(projectPath)
   .rs.ensureDirectory(parentPath)
   owd <- setwd(parentPath)
   on.exit(setwd(owd), add = TRUE)
   
   # detect whether this is a 'local' template; in such a case
   # we'll just attempt to discover the function name in the
   # global environment
   fn <- if (identical(description$package, "(local)"))
      as.name(description$binding)
   else
      call(":::", as.name(description$package), as.name(description$binding))
   
   # construct skeleton call
   skeleton <- c(
      fn,
      basename(projectPath),
      inputs
   )
   
   # evaluate skeleton function in global environment
   eval(as.call(skeleton), envir = .GlobalEnv)
   
   TRUE
})

.rs.addFunction("addFirstRunDocumentsForTemplate", function(projectFilePath,
                                                            projectPath,
                                                            openFiles)
{
   # list all files in project directory
   projectFiles <- list.files(projectPath, recursive = TRUE)
   
   # convert from glob to regular expression
   reOpenFiles <- glob2rx(openFiles)
   
   # keep all files that match one of the regular expressions
   files <- Reduce(union, lapply(reOpenFiles, function(regex) {
      grep(regex, projectFiles, value = TRUE)
   }))
   
   # compute scratch path
   scratchPaths <- .Call("rs_computeScratchPaths", projectFilePath, PACKAGE = "(embedding)")
   scratchPath <- scratchPaths$scratch_path
   
   # add these as first-run documents
   .Call("rs_addFirstRunDoc", scratchPath, files, PACKAGE = "(embedding)")
})

#
# SessionDiagnostics.R
#
# Copyright (C) 2015 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar(
   "r.keywords",
   c(
      "TRUE",
      "FALSE",
      "NA",
      "NA_real_",
      "NA_complex_",
      "NA_integer_",
      "NA_character_",
      "NULL",
      "Inf",
      "else",
      "in"
   )
)

.rs.addFunction("setLintEngine", function(engine)
{
   if (identical(engine, "internal"))
      .rs.setVar("r.lint.engine", .rs.internalLintEngine)
   else if (!is.function(engine))
      stop("'engine' must be a function taking a single argument (file path)")
   else
      .rs.setVar("r.lint.engine", engine)
})

.rs.addFunction("getLintEngine", function()
{
   engine <- .rs.getVar("r.lint.engine")
   if (is.null(engine))
      .rs.internalLintEngine
   else
      engine
})

.rs.addFunction("lint", function(filePath)
{
   engine <- .rs.getLintEngine()
   invisible(engine(filePath))
})

.rs.addFunction("availableRSymbols", function()
{
   unlist(c(
      .rs.objectsOnSearchPath(excludeGlobalEnv = TRUE),
      .rs.getVar("r.keywords")
   ))
})

.rs.addFunction("internalLintEngine", function(filePath)
{
   if (!file.exists(filePath))
      return(list())
      
   filePath <- .rs.normalizePath(filePath, mustWork = TRUE)
   lint <- .rs.lintRFile(filePath)
   invisible(.rs.showLintMarkers(lint, filePath))
})

.rs.addFunction("lintRFile", function(filePath)
{
   .Call("rs_lintRFile", filePath)
})

.rs.addFunction("showLintMarkers", function(lint, filePath)
{
   markers <- .rs.createMarkersFromLint(lint, filePath)
   .rs.api.sourceMarkers(
      name = "Diagnostics",
      markers = markers,
      basePath = .rs.getProjectDirectory()
   )
})

.rs.addFunction("createMarkersFromLint", function(lint, file) {
   lapply(lint, function(x) {
      list(
         type = x$type,
         file = file,
         line = x$start.row,
         column = x$start.column,
         message = x$message,
         messageHTML = FALSE
      )
   })
})

.rs.addFunction("extractRCode", function(content,
                                         reStart,
                                         reEnd)
{
   # This function should be called with content that is already known
   # to be UTF-8 encoded; however, that encoding can be lost when forming
   # this call so bring the encoding back.
   Encoding(content) <- "UTF-8"
   
   splat <- strsplit(content, "\n", fixed = TRUE)[[1]]
   starts <- grep(reStart, splat, perl = TRUE)
   ends <- grep(reEnd, splat, perl = TRUE)
   
   # Get start/end pairs
   pairs <- lapply(starts, function(i) {
      following <- ends[ends > i]
      if (!length(following)) return(NULL)
      c(i, following[[1]])
   })
   
   # Drop NULL
   pairs[unlist(lapply(pairs, is.null))] <- NULL
   
   new <- character(length(splat))
   for (pair in pairs)
   {
      start <- pair[[1]]
      end <- pair[[2]]
      
      # Ignore pairs that include 'eval = FALSE'.
      if (grepl("eval\\s*=\\s*F", splat[[start]], perl = TRUE))
         next
      
      # Ignore pairs that include 'engine=', assuming they're non-R chunks.
      #
      # 'Rscript' chunks would work standalone and hence the linter would not
      # properly understand that it should discard the parse tree generated
      # from prior chunks, so we just don't lint it.
      if (grepl("engine\\s*=", splat[[start]], perl = TRUE))
         next
      
      # If the chunk end lies immediately after the chunk start, bail
      if (start + 1 == end)
         next
      
      new[(start + 1):(end - 1)] <- splat[(start + 1):(end - 1)]
   }
   
   .rs.scalar(paste(new, collapse = "\n"))
})

.rs.addFunction("lintDirectory", function(directory = .rs.getProjectDirectory())
{
   .Call("rs_lintDirectory", directory)
})

.rs.addJsonRpcHandler("analyze_project", function(directory = .rs.getProjectDirectory())
{
   .rs.lintDirectory(directory)
})

#
# SessionHelp.R
#
# Copyright (C) 2009-12 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# use html help 
options(help_type = "html")

.rs.addFunction( "httpdPortIsFunction", function() {
   is.function(tools:::httpdPort)
})

.rs.addFunction( "httpdPort", function()
{
   if (.rs.httpdPortIsFunction())
      as.character(tools:::httpdPort())
   else
      as.character(tools:::httpdPort)
})

.rs.addFunction("initHelp", function(port, isDesktop)
{ 
   # function to set the help port
   setHelpPort <- function() {
      if (.rs.httpdPortIsFunction()) {
         tools:::httpdPort(port)
      } else {
         env <- environment(tools::startDynamicHelp)
         unlockBinding("httpdPort", env)
         assign("httpdPort", port, envir = env)
         lockBinding("httpdPort", env)   
      }
   }
   
   # for desktop mode see if R can successfully initialize the httpd
   # server -- if it can't then perhaps localhost ports are blocked,
   # in this case we take over help entirely
   if (isDesktop) 
   {
      # start the help server if it hasn't previously been started
      # (suppress warnings and messages because if there is a problem
      # binding to a local port we are going to patch this up by 
      # redirecting all traffic to our local peer)
      if (.rs.httpdPort() <= 0L)
         suppressWarnings(suppressMessages(tools::startDynamicHelp()))
      
      # if couldn't start it then set the help port directly so that
      # help requests still flow through our local peer connection
      if (.rs.httpdPort() <= 0L)
      {
         setHelpPort()
         return (TRUE)
      }
      else
      {
         return (FALSE)
      }
   }
   # always take over help in server mode
   else 
   { 
      # stop the help server if it was previously started e.g. by .Rprofile
      if (.rs.httpdPort() > 0L)
         suppressMessages(tools::startDynamicHelp(start=FALSE))
      
      # set the help port
      setHelpPort()
      
      # indicate we should handle custom internally
      return (TRUE)
   }
})

.rs.addFunction( "handlerLookupError", function(path, query=NULL, ...)
{
   payload = paste(
      "<h3>R Custom HTTP Handler Not Found</h3>",
      "<p>Unable to locate custom HTTP handler for",
      "<i>", path, "</i>",
      "<p>Is the package which implements this HTTP handler loaded?</p>")
   
   list(payload, "text/html", character(), 404)
});

.rs.setVar("topicsEnv", new.env(parent = emptyenv()))

.rs.addJsonRpcHandler("suggest_topics", function(query)
{
   pkgpaths <- path.package(quiet = TRUE)
   
   # read topics from
   topics <- lapply(pkgpaths, function(pkgpath) tryCatch({
      
      if (exists(pkgpath, envir = .rs.topicsEnv))
         return(get(pkgpath, envir = .rs.topicsEnv))
      
      aliases <- file.path(pkgpath, "help/aliases.rds")
      index <- file.path(pkgpath, "help/AnIndex")
      
      value <- if (file.exists(aliases)) {
         names(readRDS(aliases))
      } else if (file.exists(index)) {
         data <- read.table(index, sep = "\t")
         data[, 1]
      }
      
      assign(pkgpath, value, envir = .rs.topicsEnv)
      
   }, error = function(e) NULL))
   
   flat <- unlist(topics, use.names = FALSE)
   
   # order matches by subsequence match score
   scores <- .rs.scoreMatches(tolower(flat), tolower(query))
   ordered <- flat[order(scores)]
   matches <- unique(ordered[.rs.isSubsequence(tolower(ordered), tolower(query))])
   
   # force first character to match, but allow typos after.
   # also keep matches with one or more leading '.', so that e.g.
   # the prefix 'libpaths' can match '.libPaths'
   if (nzchar(query)) {
      first <- substring(query, 1, 1)
      pattern <- sprintf("^[.]*[%s]", first)
      matches <- grep(pattern, matches, value = TRUE, perl = TRUE)
   }
   
   matches
   
})

.rs.addFunction("getHelpFromObject", function(object, envir, name = NULL)
{
   # Try to find the associated namespace of the object
   namespace <- NULL
   if (is.primitive(object))
      namespace <- "base"
   else if (is.function(object))
   {
      envString <- capture.output(environment(object))[1]
      
      # Strip out the irrelevant bits of the package name. We'd like
      # to just use 'regexpr' but its output is funky with older versions
      # of R.
      if (!grepl("namespace:", envString))
         return()
      
      namespace <- sub(".*namespace:", "", envString)
      namespace <- sub(">.*", "", namespace)
   }
   else if (isS4(object))
      namespace <- attr(class(object), "package")
   
   if (is.null(namespace))
      return()
   
   # Get objects from that namespace
   ns <- try(asNamespace(namespace), silent = TRUE)
   if (inherits(ns, "try-error"))
      return()
   
   # Datasets don't live in the namespace -- ennumerate them separately
   # We have to avoid the 'base' package, though.
   datasets <- tryCatch(
      suppressWarnings(data(package = namespace)),
      error = function(e) NULL
   )
   
   objectNames <- objects(ns, all.names = TRUE)
   datasetNames <- unname(grep(" ", datasets$results[, "Item"], fixed = TRUE, value = TRUE, invert = TRUE))
   
   objects <- tryCatch(
      mget(objectNames, envir = ns, inherits = TRUE),
      error = function(e) NULL
   )
   
   # Try to get the datasets from the namespace. These will only exist if they have
   # been explicitly loaded, so be careful to tryCatch here.
   data <- lapply(datasetNames, function(x) {
      tryCatch(
         get(x, envir = ns),
         error = function(e) NULL
      )
   })
   
   # Combine them together
   if (length(data))
   {
      objects <- c(objects, data)
      objectNames <- c(objectNames, datasetNames)
   }
   
   # Find which object is actually identical to the one we have
   success <- FALSE
   for (i in seq_along(objects))
   {
      if (!identical(class(object), class(objects[[i]])))
         next
      
      # Once again, 'ignore.environment' is not available in older R's
      # identical, so construct and eval a call to 'base::identical'.
      formals <- as.list(formals(base::identical))
      formals$x <- object
      formals$y <- objects[[i]]
      if ("ignore.environment" %in% names(formals))
         formals[["ignore.environment"]] <- TRUE
      
      result <- tryCatch(
         do.call(base::identical, formals),
         error = function(e) FALSE
      )
      
      if (result)
      {
         success <- TRUE
         break
      }
   }
   
   if (success)
   {
      # Use that name for the help lookup
      object <- objects[[i]]
      objectName <- objectNames[[i]]
      
      # use the function name seen in the
      # source document if provided
      sigName <- if (is.null(name))
         objectName
      else
         name
      
      # Get the associated signature for functions
      signature <- NULL
      if (is.function(object))
         signature <- sub("function ", sigName, .rs.getSignature(object))
      
      result <- .rs.getHelp(topic = objectName, package = namespace, sig = signature)
      if (length(result))
         return(result)
      
      # If the previous lookup failed, perhaps it was an S3 method for which no
      # documentation was available. Fall back to generic documentation.
      dotPos <- gregexpr(".", objectName, fixed = TRUE)[[1]]
      for (i in seq_along(dotPos))
      {
         maybeGeneric <- substring(objectName, 1, dotPos[[i]] - 1)
         methods <- suppressWarnings(
            tryCatch(
               eval(substitute(methods(x), list(x = maybeGeneric)), envir = envir),
               error = function(e) NULL
            )
         )
         
         if (objectName %in% methods)
         {
            result <- .rs.getHelp(maybeGeneric)
            if (length(result))
               return(result)
         }
      }
   }
   
   # Fail -- return NULL
   NULL
})

.rs.addJsonRpcHandler("get_help", function(what, from, type)
{
   # Protect against missing type
   if (!length(type))
      return()
   
   # If we've encoded the package and function in 'what', pull it out
   if (grepl("|||", what, fixed = TRUE))
   {
      splat <- strsplit(what, "|||", fixed = TRUE)[[1]]
      from <- splat[[1]]
      what <- splat[[2]]
   }
   
   # Avoid install.packages hook
   if (what == "install.packages" &&
       type == .rs.acCompletionTypes$ARGUMENT &&
       is.null(from))
      return(.rs.getHelp("install.packages", "utils"))
   
   # Help for options
   if (type == .rs.acCompletionTypes$OPTION)
      return(.rs.getHelp("options", "base", subset = FALSE))
   
   if (type %in% c(.rs.acCompletionTypes$S4_GENERIC,
                   .rs.acCompletionTypes$S4_METHOD))
   {
      # Try getting methods for the method from the associated package
      if (!is.null(help <- .rs.getHelp(paste(what, "methods", sep = "-"), from)))
         return(help)
      
      # Try getting help from anywhere
      if (!is.null(help <- .rs.getHelp(what, from)))
         return(help)
      
      # Give up
      return()
   }
   
   if (type %in% c(.rs.acCompletionTypes$FUNCTION,
                   .rs.acCompletionTypes$S4_GENERIC,
                   .rs.acCompletionTypes$S4_METHOD,
                   .rs.acCompletionTypes$R5_METHOD))
      return(.rs.getHelpFunction(what, from))
   else if (type == .rs.acCompletionTypes$ARGUMENT)
      return(.rs.getHelpArgument(what, from, parent.frame()))
   else if (type == .rs.acCompletionTypes$PACKAGE)
      return(.rs.getHelpPackage(what))
   else if (length(from) && length(what))
      return(.rs.getHelp(what, from))
   else
      return()
})

.rs.addJsonRpcHandler("get_custom_help", function(helpHandler,
                                                  topic,
                                                  source,
                                                  language)
{
   # use own handler for Python language help
   if (identical(language, "Python"))
      return(.rs.python.getHelp(topic, source))
   
   helpHandlerFunc <- tryCatch(eval(parse(text = helpHandler)), 
                               error = function(e) NULL)
   if (!is.function(helpHandlerFunc))
      return()
   
   results <- helpHandlerFunc("completion", topic, source)
   if (!is.null(results))
      results$description <- .rs.markdownToHTML(results$description)
     
   results 
})

.rs.addJsonRpcHandler("get_custom_parameter_help", function(helpHandler,
                                                            source,
                                                            language)
{
   # use own handler for Python language help
   if (identical(language, "Python"))
      return(.rs.python.getParameterHelp(source))
   
   helpHandlerFunc <- tryCatch(eval(parse(text = helpHandler)), 
                               error = function(e) NULL)
   if (!is.function(helpHandlerFunc))
      return()
   
   results <- helpHandlerFunc("parameter", NULL, source)
   if (!is.null(results)) {
      results$arg_descriptions <- sapply(results$arg_descriptions, 
                                         .rs.markdownToHTML)
   }
   
   results
})

.rs.addJsonRpcHandler("show_custom_help_topic", function(helpHandler, topic, source) {
   
   helpHandlerFunc <- tryCatch(eval(parse(text = helpHandler)), 
                               error = function(e) NULL)
   if (!is.function(helpHandlerFunc))
      return()
   
   url <- helpHandlerFunc("url", topic, source)
   if (!is.null(url) && nzchar(url)) # handlers return "" for no help topic
      utils::browseURL(url)
})


.rs.addFunction("getHelpFunction", function(name, src, envir = parent.frame())
{
   # If 'src' is the name of something on the searchpath, get that object
   # from the seach path, then attempt to get help based on that object
   pos <- match(src, search(), nomatch = -1L)
   if (pos >= 0)
   {
      object <- tryCatch(get(name, pos = pos), error = function(e) NULL)
      if (!is.null(object))
         return(.rs.getHelpFromObject(object, envir, name))
   }
   
   # Otherwise, check to see if there is an object 'src' in the global env
   # from which we can pull the object
   container <- tryCatch(eval(parse(text = src), envir = .GlobalEnv), error = function(e) NULL)
   if (!is.null(container))
   {
      object <- tryCatch(eval(call("$", container, name)), error = function(e) NULL)
      if (!is.null(object))
         return(.rs.getHelpFromObject(object, envir, name))
   }
   
   # Otherwise, try to get help in the vanilla way
   .rs.getHelp(name, src, getSignature = TRUE)
})

.rs.addFunction("getHelpPackage", function(pkgName)
{
   # We might be getting the completion with colons appended, so strip those out.
   pkgName <- sub(":*$", "", pkgName, perl = TRUE)
   topic <- paste(pkgName, "-package", sep = "")
   .rs.getHelp(topic, pkgName)
})

.rs.addFunction("getHelpArgument", function(functionName, src, envir)
{
   if (is.null(src))
   {
      object <- .rs.getAnywhere(functionName, envir)
      if (!is.null(object))
         return(.rs.getHelpFromObject(object, envir, functionName))
   }
   else
   {
      pos <- match(src, search(), nomatch = -1L)
      
      if (pos >= 0)
      {
         object <- tryCatch(get(functionName, pos = pos), error = function(e) NULL)
         if (!is.null(object))
            return(.rs.getHelpFromObject(object, envir, functionName))
      }
   }
   
   .rs.getHelp(functionName, src)
})

.rs.addFunction("makeHelpCall", function(topic,
                                         package = NULL,
                                         help_type = "html")
{
   substitute(utils::help(TOPIC, package = PACKAGE, help_type = "html"),
              list(TOPIC = topic,
                   PACKAGE = package))
})

.rs.addFunction("getHelp", function(topic,
                                    package = "",
                                    sig = NULL,
                                    subset = TRUE,
                                    getSignature = FALSE)
{
   # Completions from the search path might have the 'package:' prefix, so
   # lets strip that out.
   package <- sub("package:", "", package, fixed = TRUE)
   
   # Ensure topic is not zero-length
   if (!length(topic))
      topic <- ""
   
   # If the topic is not provided, but we're getting help on e.g.
   # 'stats::rnorm', then split up the topic into the appropriate pieces.
   if (!length(package) && any(grepl(":{2,3}", topic, perl = TRUE)))
   {
      splat <- strsplit(topic, ":{2,3}", perl = TRUE)[[1]]
      topic <- splat[[2]]
      package <- splat[[1]]
   }
   
   # If 'package' is the name of something on the search path, then we
   # attempt to resolve the object and get its help.
   if (length(package))
   {
      pos <- match(package, search(), nomatch = -1L)
      if (pos >= 0)
      {
         object <- tryCatch(get(topic, pos = pos), error = function(e) NULL)
         if (is.null(object))
            return(NULL)
         return(.rs.getHelpFromObject(object, envir, topic))
      }
   }
   
   helpfiles <- NULL
   if (!length(package) || package == "") {
      helpfiles <- utils::help(topic, help_type = "html")
   } else {
      helpfiles <- tryCatch(
         
         expr = {
            call <- .rs.makeHelpCall(topic, package)
            eval(call)
         },
         
         error = function(e) {
            return(NULL)
         }
      )
   }
   
   if (length(helpfiles) <= 0)
      return ()
   
   file = helpfiles[[1]]
   path <- dirname(file)
   dirpath <- dirname(path)
   pkgname <- basename(dirpath)
   
   query <- paste("/library/", pkgname, "/html/", basename(file), ".html", sep = "")
   html <- suppressWarnings(tools:::httpd(query, NULL, NULL))$payload
   
   match = suppressWarnings(regexpr('<body>.*</body>', html))
   if (match < 0)
   {
      html = NULL
   }
   else
   {
      html = substring(html, match + 6, match + attr(match, 'match.length') - 1 - 7)
      
      if (subset)
      {   
         slotsMatch <- suppressWarnings(regexpr('<h3>Slots</h3>', html))
         detailsMatch <- suppressWarnings(regexpr('<h3>Details</h3>', html))
         
         match <- if (slotsMatch > detailsMatch) slotsMatch else detailsMatch
         if (match >= 0)
            html = substring(html, 1, match - 1)
      }
   }
   
   # Try to resolve function signatures for help
   if (is.null(sig) && getSignature)
   {
      object <- NULL
      if (length(package) &&
             package != "" &&
             package %in% loadedNamespaces())
      {
         object <- tryCatch(
            get(topic, envir = asNamespace(package)),
            error = function(e) NULL
         )
      }
      
      if (!length(object))
      {
         object <- tryCatch(
            get(topic, pos = globalenv()),
            error = function(e) NULL
         )
      }
      
      sig <- .rs.getSignature(object)
      sig <- gsub('^function ', topic, sig)
   }
   
   list('html' = html, 'signature' = sig, 'pkgname' = pkgname)
})

.rs.addJsonRpcHandler("show_help_topic", function(what, from, type)
{
   # strip off a 'package:' prefix if necessary
   if (is.character(from) && nzchar(from))
      from <- sub("^package:", "", from)
   
   if (type == .rs.acCompletionTypes$FUNCTION)
      .rs.showHelpTopicFunction(what, from)
   else if (type == .rs.acCompletionTypes$ARGUMENT)
      .rs.showHelpTopicArgument(from)
   else if (type == .rs.acCompletionTypes$PACKAGE)
      .rs.showHelpTopicPackage(what)
   else
      .rs.showHelpTopic(what, from)
})

.rs.addFunction("showHelpTopicFunction", function(topic, package)
{
   if (is.null(package) && grepl(":{2,3}", topic, perl = TRUE))
   {
      splat <- strsplit(topic, ":{2,3}", perl = TRUE)[[1]]
      topic <- splat[[2]]
      package <- splat[[1]]
   }
   
   if (!is.null(package))
      requireNamespace(package, quietly = TRUE)
   
   call <- .rs.makeHelpCall(topic, package)
   print(eval(call, envir = parent.frame()))
})

.rs.addFunction("showHelpTopicArgument", function(functionName)
{
   topic <- functionName
   pkgName <- NULL
   
   if (grepl(":{2,3}", functionName, perl = TRUE))
   {
      splat <- strsplit(functionName, ":{2,3}", perl = TRUE)[[1]]
      topic <- splat[[2]]
      pkgName <- splat[[1]]
   }
   
   call <- .rs.makeHelpCall(topic, pkgName)
   print(eval(call, envir = parent.frame()))
})

.rs.addFunction("showHelpTopicPackage", function(pkgName)
{
   pkgName <- sub(":*$", "", pkgName)
   topic <- paste(pkgName, "-package", sep = "")
   call <- .rs.makeHelpCall(topic, pkgName)
   print(eval(call, envir = parent.frame()))
})

.rs.addFunction("showHelpTopic", function(topic, package)
{
   call <- .rs.makeHelpCall(topic, package)
   print(eval(call, envir = parent.frame()))
})

.rs.addJsonRpcHandler("search", function(query)
{
   exactMatch = help(query, help_type = "html")
   if (length(exactMatch) == 1)
   {
      print(exactMatch)
      return()
   }
   else
   {
      paste("help/doc/html/Search?pattern=",
            utils::URLencode(query, reserved = TRUE),
            "&title=1&keyword=1&alias=1",
            sep = "")
   }
})

#
# SessionBuild.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

setHook("sourceCpp.onBuild", function(file, fromCode, showOutput)
{
   .Call("rs_sourceCppOnBuild", file, fromCode, showOutput, PACKAGE = "(embedding)")
})

setHook("sourceCpp.onBuildComplete", function(succeeded, output)
{
   .Call("rs_sourceCppOnBuildComplete", succeeded, output, PACKAGE = "(embedding)")
})

.rs.addFunction("installBuildTools", function(action)
{
   fmt <- .rs.trimWhitespace("
%s requires installation of additional build tools.

Do you want to install the additional tools now?
")
   
   response <- .rs.userPrompt(
      "question",
      "Install Build Tools",
      sprintf(fmt, action)
   )
   
   if (!identical(response, "yes"))
      return(FALSE)
   
   .Call("rs_installBuildTools", PACKAGE = "(embedding)")
   return(TRUE)
   
})

.rs.addFunction("checkBuildTools", function(action)
{
   # TODO: should this check for other flavors of mac.binary?
   if (identical(.Platform$pkgType, "mac.binary.mavericks"))
      return(.Call("rs_canBuildCpp", PACKAGE = "(embedding)"))
   
   ok <- .Call("rs_canBuildCpp", PACKAGE = "(embedding)")
   if (ok)
      return(TRUE)
   
   .rs.installBuildTools(action)
   FALSE
})

.rs.addFunction("withBuildTools", function(code)
{
    .rs.addRToolsToPath()
    on.exit(.rs.restorePreviousPath(), add = TRUE)
    force(code)
})

options(buildtools.check = function(action)
{
   .rs.checkBuildTools(action)
})

options(buildtools.with = function(code)
{
   .rs.withBuildTools(code)
})

.rs.addFunction("websiteOutputDir", function(siteDir)
{
   siteGenerator <- rmarkdown::site_generator(siteDir)
   if (!is.null(siteGenerator))
      if (siteGenerator$output_dir != ".")
         file.path(siteDir, siteGenerator$output_dir)
      else
         siteDir
   else
      siteDir
})

.rs.addFunction("builtWithRtoolsGcc493", function()
{
   identical(.Platform$OS.type, "windows") &&
      getRversion() >= "3.3" && 
      .rs.haveRequiredRSvnRev(70462)
})

.rs.addFunction("readShinytestResultRds", function(rdsPath)
{
   failures <- Filter(function(e) !identical(e$pass, TRUE), readRDS(rdsPath)$results)
   sapply(failures, function(e) e$name)
})

.rs.addFunction("findShinyTestsDir", function(appDir)
{
   tryCatch(
      
      expr = shinytest:::findTestsDir(
         appDir = appDir,
         mustExit = FALSE,
         quiet = TRUE
      ),
      
      error = function(e) {
         file.path(appDir, "tests")
      }
      
   )
   
})

#
# SessionPlots.R
#
# Copyright (C) 2009-16 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# register hook to be invoked before creating a new plot
setHook(
  hookName = "before.plot.new", 
  value = function() { 
    .Call("rs_emitBeforeNewPlot")
  },
  action = "append")

setHook(
  hookName = "before.grid.newpage", 
  value = function() { 
    .Call("rs_emitBeforeNewGridPage")
  },
  action = "append")

# register hook to be invoked when a new plot has been created
setHook(
  hookName = "plot.new", 
  value = function() { 
    .Call("rs_emitNewPlot")
  },
  action = "append")

#
# SessionAssistant.R
#
# Copyright (C) 2023 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# Constants for variable description limits
.rs.setVar("assistant.kMaxVariables", 100L)
.rs.setVar("assistant.kMaxChildren", 50L)

.rs.addFunction("assistant.setLogLevel", function(level = 0L)
{
   .Call("rs_assistantSetLogLevel", as.integer(level), PACKAGE = "(embedding)")
})

# Extract variable names referenced in R code that also exist in the global environment.
# Returns a character vector of variable names.
.rs.addFunction("assistant.extractVariablesInScope", function(code, envir = globalenv())
{
   # Try to parse the code; return empty if parsing fails
   expr <- tryCatch(
      parse(text = code, keep.source = FALSE),
      error = function(e) NULL
   )

   if (is.null(expr))
      return(character())

   # Get all names referenced in the code
   referencedNames <- all.names(expr, unique = TRUE)

   # Filter to only include names that exist in the environment
   existingNames <- ls(envir = envir)
   intersect(referencedNames, existingNames)
})

.rs.addFunction("assistant.variableType", function(object)
{
   if (is.data.frame(object))
   {
      "data.frame"
   }
   else
   {
      mode(object)
   }
})

#' Build child descriptions for a recursive object.
#' @param value A recursive object (list, data.frame, etc.)
#' @param maxChildren Maximum number of children to include
#' @return A list of child descriptions with name and type
.rs.addFunction("assistant.describeChildren", function(value, maxChildren = .rs.assistant.kMaxChildren)
{
   n <- min(length(value), maxChildren)
   idxs <- seq_len(n)
   nms <- names(value)
   keys <- if (is.null(nms)) character(n) else nms[idxs]
   vals <- value[idxs]

   .mapply(function(idx, key, val) {
      list(
         name = .rs.scalar(if (nzchar(key)) key else paste0("[[", idx, "]]")),
         type = .rs.scalar(.rs.assistant.variableType(val))
      )
   }, list(idxs, keys, vals), NULL)
})

#' Describe a single variable for assistant context.
#' Returns a list with name, type, optionally action, and optionally children.
#'
#' @param name The variable name
#' @param value The variable value (can be NULL for delete action)
#' @param children Controls child element inclusion:
#'   - FALSE or 0: don't include children
#'   - TRUE: include up to 50 children (default max)
#'   - integer > 0: include up to that many children
#' @param action Optional action field ("create", "modify", or "delete")
.rs.addFunction("assistant.describeVariable", function(name, value, children = FALSE, action = NULL)
{
   # For delete actions, return minimal info
   if (identical(action, "delete"))
   {
      return(list(
         name = .rs.scalar(name),
         type = .rs.scalar(""),
         action = .rs.scalar(action)
      ))
   }

   type <- .rs.assistant.variableType(value)
   result <- list(name = .rs.scalar(name), type = .rs.scalar(type))

   # Add action field if provided
   if (!is.null(action))
      result$action <- .rs.scalar(action)

   # Determine maxChildren from the children parameter
   # Handle both integer and numeric 0
   if (identical(children, FALSE) || (is.numeric(children) && children == 0))
      return(result)

   # Skip if this object is not recursive
   if (is.null(value) || !is.recursive(value))
      return(result)

   # Determine the maximum number of children to include
   maxChildren <- if (isTRUE(children)) .rs.assistant.kMaxChildren else as.integer(children)

   # Build child descriptions
   result$children <- .rs.assistant.describeChildren(value, maxChildren)

   result
})

# Describe a single variable from an environment.
# Returns NULL if the variable doesn't exist or can't be accessed.
.rs.addFunction("assistant.describeVariableFromEnv", function(varName,
                                                              envir,
                                                              examineChildren,
                                                              maxChildren,
                                                              action)
{
   if (!exists(varName, envir = envir, inherits = FALSE))
      return(NULL)

   value <- get(varName, envir = envir, inherits = FALSE)
   children <- if (examineChildren) maxChildren else FALSE
   .rs.assistant.describeVariable(varName, value, children, action)
})

# Check if a variable should have its children examined.
# @param varName The variable name to check
# @param names The names parameter from variableDescriptions (NULL or character vector)
# @param variablesInScope TRUE, FALSE, or character vector of variable names
.rs.addFunction("assistant.shouldExamineChildren", function(varName, names, variablesInScope)
{
   !is.null(names) ||
      isTRUE(variablesInScope) ||
      (is.character(variablesInScope) && varName %in% variablesInScope)
})

# Generate variable descriptions for the current R session.
# Returns a list suitable for JSON serialization in the format:
# list(
#    list(name = "x", type = "numeric"),
#    list(name = "df", type = "data.frame", children = list(...))
# )
#
# @param envir The environment to examine
# @param names Optional character vector of specific variable names to describe.
#   If NULL (default), describes all variables in the environment.
# @param variablesInScope Controls which variables get children examined (only used when names=NULL):
#   - TRUE: examine children on all recursive objects
#   - character vector: examine children only for named variables
#   - FALSE: don't examine children
# @param maxVariables Maximum number of variables to include (only used when names=NULL)
# @param maxChildren Maximum number of children to include for recursive objects
# @param action Optional action field ("create", "modify", or "delete")
.rs.addFunction("assistant.variableDescriptions", function(envir = globalenv(),
                                                           names = NULL,
                                                           variablesInScope = TRUE,
                                                           maxVariables = .rs.assistant.kMaxVariables,
                                                           maxChildren = .rs.assistant.kMaxChildren,
                                                           action = NULL)
{
   # Get variable names - either specified or all from environment
   if (is.null(names))
   {
      varNames <- ls(envir = envir)
      length(varNames) <- min(length(varNames), maxVariables)
   }
   else
   {
      varNames <- names
   }

   # Build descriptions for all variables
   descriptions <- lapply(varNames, function(varName) {
      examineChildren <- .rs.assistant.shouldExamineChildren(varName, names, variablesInScope)

      tryCatch(
         .rs.assistant.describeVariableFromEnv(varName, envir, examineChildren, maxChildren, action),
         error = function(e) NULL
      )
   })

   # Remove NULL entries (failed accesses)
   Filter(Negate(is.null), descriptions)
})

attach(list(
  ojs_define = function(...) {
    # validate that we aren't in a cached chunk
    cache <- knitr:::opts_current$get('cache')
    if (is.numeric(cache) && cache > 0) {
      stop("ojs_define() cannot be cached\n",
           "Add cache: false to this cell's options to disable caching",
           call. = FALSE)
    }
    quos <- rlang::enquos(...)
    vars <- rlang::list2(...)
    nm <- names(vars)
    if (is.null(nm)) {
      nm <- rep_len("", length(vars))
    }
    contents <- jsonlite::toJSON(list(contents = I(mapply(
      function(q, nm, val) {
        # Infer name, if possible
        if (nm == "") {
          tryCatch({
            nm <- rlang::as_name(q)
          }, error = function(e) {
            code <- paste(collapse = "\n", deparse(rlang::f_rhs(q)))
            stop("ojs_define() could not create a name for the argument: ", code)
          })
        }
        list(name=nm, value=val)
      }, quos, nm, vars, SIMPLIFY = FALSE, USE.NAMES=FALSE))),
      dataframe = "columns", null = "null", na = "null", auto_unbox = TRUE)
    script_string <- c(
        "<script type=\"ojs-define\">",
        contents,
        "</script>");

    invisible(knitr:::knit_meta_add(list(structure(class="ojs-define", script_string))))
  }
), name = "tools:quarto")

#
# Options.R
#
# Copyright (C) 2009-11 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# get version
.rs.addGlobalFunction("RStudio.Version", function() {
   .rs.api.versionInfo()
})

# custom browseURL implementation
options(browser = function(url)
{
   .Call("rs_browseURL", url) ;
})

# default viewer option if not already set
if (is.null(getOption("viewer"))) {
   options(viewer = function(url, height = NULL)
   {
      if (!is.character(url) || (length(url) != 1))
         stop("url must be a single element character vector.", call. = FALSE)
      
      if (identical(height, "maximize"))
         height <- -1

      if (!is.null(height) && (!is.numeric(height) || (length(height) != 1)))
         stop("height must be a single element numeric vector or 'maximize'.", call. = FALSE)
      
      invisible(.Call("rs_viewer", url, height))  
   })
}

# default page_viewer option if not already set
if (is.null(getOption("page_viewer"))) {
   options(page_viewer = function(url, title = "RStudio Viewer", self_contained = FALSE)
   {
      if (!is.character(url) || (length(url) != 1))
         stop("url must be a single element character vector.", call. = FALSE)
      
      if (!is.character(title) || (length(title) != 1))
         stop("title must be a single element character vector.", call. = FALSE)
      
      if (!is.logical(self_contained) || (length(self_contained) != 1))
         stop("self_contained must be a single element logical vector.", call. = FALSE)
      
      invisible(.Call("rs_showPageViewer", url, title, self_contained))
   })
}

# default shinygadgets.showdialog if not already set
if (is.null(getOption("shinygadgets.showdialog"))) {
   options(shinygadgets.showdialog = function(caption,
                                              url,
                                              width = NULL,
                                              height = NULL)
   {
      if (!is.character(caption) || (length(caption) != 1))
         stop("caption must be a single element character vector.", call. = FALSE)

      if (!is.character(url) || (length(url) != 1))
         stop("url must be a single element character vector.", call. = FALSE)

      # default width and height
      if (is.null(width))
         width <- 600
      if (is.null(height))
         height <- 600

      # validate width and height
      if (!is.numeric(width) || (length(width) != 1))
         stop("width must be a single element numeric vector.", call. = FALSE)
      if (!is.numeric(height) || (length(height) != 1))
         stop("height must be a single element numeric vector.", call. = FALSE)

      invisible(.Call("rs_showShinyGadgetDialog", caption, url, width, height))
   })
}

# provide askpass function
options(askpass = .rs.askForPassword)

# provide asksecret function
options(asksecret = .rs.askForSecret)

# provide restart function
options(restart = .rs.restartR)

# custom pager implementation
options(pager = .rs.pager)

# never allow graphical menus
options(menu.graphics = FALSE)

# set max print to 1000 if not already set
if (is.null(getOption("max.print")) || (getOption("max.print") == 99999)) {
   options(max.print = 1000)
}

# set max print so that the DOM won't go haywire showing large datasets
if (getOption("max.print", 10000) > 10000) {
   options(max.print = 10000)
}

# set RStudio as the GUI
local({
   platform = .Platform
   if (platform$GUI != "RStudio") {
      platform$GUI = "RStudio"
      unlockBinding(".Platform", asNamespace("base"))
      assign(".Platform", platform, inherits=TRUE)
      lockBinding(".Platform", asNamespace("base"))
   }
})

# set default x display (see below for comment on why we need to do this)
if (is.na(Sys.getenv("DISPLAY", NA)))
   Sys.setenv(DISPLAY = ":0")

# the above two display oriented command affect the behavior of edit.data.frame
# and edit.matrix as follows: these methods will use .Internal(edit, ...) rather
# than .Internal(dataentry, ...) if DISPLAY == "" or if the .Platform$GUI is
# "unknown". since we plan on running on a server without X available we need
# to manually make sure that the DISPLAY environment variable exists and that
# the .Platform$GUI is not "unknown"

# configure profvis to use custom path to store profiles
options(profvis.output_path = NULL)

# configure profvis to not delete generated profiles
options(profvis.keep_output = TRUE)

# indicate that we're not in a notebook by default
options(rstudio.notebook.executing = FALSE)

# provide a custom HTTP user agent
.rs.initHttpUserAgent()

#
# SessionThemes.R
#
# Copyright (C) 2018 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

# ACE/tools/tmThemes.js Functions ==================================================================

# Determines the luma of a color. This refers to the perceived luminance of the color. More 
# information can be found at https://en.wikipedia.org/wiki/Relative_luminance.
# 
# @param color    The color for which to determine the luma.
#
# Returns the luma of the specified color.
.rs.addFunction("getLuma", function(color) {
   rgb <- .rs.getRgbColor(color)
   (0.21 * rgb[[1]] + 0.72 * rgb[[2]] + 0.07 * rgb[[3]]) / 255
})

# Parses a color.
# 
# @param color    The color to parse.
#
# Returns the parsed color.
.rs.addFunction("parseColor", function(color) {
   colorLen <- nchar(color)
   if (colorLen < 1)
   {
      return(NULL)
   }
   
   if (colorLen == 4)
   {
      color <- gsub("([a-fA-F0-9])", "\\1\\1", color)
   }
   if (!grepl("^#[a-fA-F0-9]{6}$", color))
   {
      if (!grepl("^#[a-fA-F0-9]{8}$", color))
      {
         stop(
            "Unable to parse color: ",
            color, 
            "it must have format \"#RGB\", \"#RRGGBB\" or \"#RRGGBBAA\" where `R`, `G`, `B`, and `A` are in [0x00, 0xFF].",
            call. = FALSE)
      }
      
      aVal <- format(
         round(strtoi(substr(color, 8, 9), base = 16L) / 255, digits = 2),
         nsmall = 2)
      color <- paste0(
         "rgba(",
         paste(
            c(.rs.getRgbColor(substr(color, 1, 7)), aVal),
            collapse = ", "),
         ")")
   }
   
   color
})

# Parses a font style and converts it to CSS.
#
# @param styles      The style(s) to convert.
#
# Returns the converted font style.
.rs.addFunction("parseStyles", function(styles) {
   css <- list()
   fontStyle <- if (is.null(styles$fontStyle)) "" else styles$fontStyle
   
   if (grepl("underline", fontStyle))
   {
      # Not the most efficient, but this shouldn't be an overly common operation.
      css[["text-decoration"]] = "underline"
   }
   if (grepl("italic", fontStyle))
   {
      css[["font-style"]] <- "italic"
   }
   if (grepl("bold", fontStyle))
   {
      css[["font-weight"]] <- "bold"
   }
   
   if (!is.null(styles$foreground))
   {
      css[["color"]] <- .rs.parseColor(styles$foreground)
   }
   if (!is.null(styles$background))
   {
      css[["background-color"]] <- .rs.parseColor(styles$background)
   }
   
   css
})

# Extracts the style information from a parsed tmTheme object.
#
# @param theme             The parsed tmTheme object.
# @param supportScopes     tmTheme scopes that are supported by ace and a mapping to their ace
#                          value.
# 
# Returns a list which contains the styles and unsupportedScopes in named elements.
.rs.addFunction("extractStyles", function(theme, supportedScopes) {
   # Fallback Scopes
   fallbackScopes <- list(
      "keyword" = "meta",
      "keyword.operator" = "keyword",
      "support.type" = "storage.type",
      "variable" = "entity.name.function")
   
   # Default Global Values
   defaultGlobals <- list(
      "printMargin" = "#e8e8e8",
      "background" = "#ffffff",
      "foreground" = "#000000",
      "gutter" = "#f0f0f0",
      "selection" = "rgb(181, 213, 255)",
      "step" = "rgb(198, 219, 174)",
      "bracket" = "rgb(192, 192, 192)",
      "active_line" = "rgba(0, 0, 0, 0.07)",
      "cursor" = "#000000",
      "invisible" = "rgb(191, 191, 191)",
      "fold" = "#6b72e6")
   
   globalSettings <- theme$settings[[1]]$settings
   
   # Get the global colors
   invisColor <- .rs.parseColor(globalSettings$invisibles)
   if (is.null(invisColor)) invisColor <- defaultGlobals$invisibles
   
   styles <- list(
      "printMargin" = defaultGlobals$printMargin,
      "background" = .rs.parseColor(globalSettings$background),
      "foreground" = .rs.parseColor(globalSettings$foreground),
      "gutter" = defaultGlobals$gutter,
      "selection" = .rs.parseColor(globalSettings$selection),
      "step" = defaultGlobals$step,
      "bracket" =  invisColor,
      "active_line" = .rs.parseColor(globalSettings$lineHighlight),
      "cursor" = .rs.parseColor(globalSettings$caret),
      "invisible" = invisColor)
   
   if (!("background" %in% names(styles))) styles$background <- defaultGlobals$background
   if (!("foreground" %in% names(styles))) styles$foreground <- defaultGlobals$foreground
   if (!("selection" %in% names(styles))) styles$selection <- defaultGlobals$selection
   if (!("active_line" %in% names(styles))) styles$active_line <- defaultGlobals$active_line
   if (!("cursor" %in% names(styles))) styles$cursor <- defaultGlobals$cursor
   
   # Get the specified scopes
   unsupportedScopes <- list()
   supportedScopeNames <- names(supportedScopes)
   for (element in theme$settings)
   {
      if (!is.null(element$scope) && !is.null(element$settings))
      {
         # Split on commas and strip whitespace.
         scopes <- strsplit(gsub("^\\s*|\\s*$", "", element$scope), "\\s*(,|\\|\\s)\\s*")[[1]]
         for (scope in scopes)
         {
            style <- .rs.parseStyles(element$settings)
            haveStyle <- !is.null(style) && !is.na(style) && (length(style) > 0)
            if ((scope %in% supportedScopeNames) && haveStyle)
            {
               styles[[ supportedScopes[[scope]] ]] <- style
            }
            else if (haveStyle)
            {
               if (!(scope %in% names(unsupportedScopes)))
               {
                  unsupportedScopes[[scope]] <- 0
               }
               else 
               {
                  unsupportedScopes[[scope]] <- unsupportedScopes[[scope]] + 1
               }
            }
         }
      }
   }
   
   if (!("fold" %in% names(styles)))
   {
      if (("entity.name.function" %in% names(styles)) 
          && ("color" %in% names(styles[["entity.name.function"]]))
          && (styles[["entity.name.function"]][["color"]] != ""))
      {
         styles[["fold"]] <- styles[["entity.name.function"]][["color"]]
      }
      else if (("keyword" %in% names(styles))
               && ("color" %in% names(styles[["keyword"]]))
               && (styles[["keyword"]][["color"]] != ""))
      {
         styles[["fold"]] <- styles[["keyword"]][["color"]]
      }
      else
      {
         styles[["fold"]] <- defaultGlobals$fold
      }
   }
   
   styles[["gutterBg"]] <- styles$background
   styles[["gutterFg"]] <- .rs.mixColors(styles$foreground, styles$background, 0.5)
   styles[["selected_word_highlight"]] <- paste0("border: 1px solid ", styles$selection)
   
   styles$isDark = tolower(as.character(.rs.getLuma(styles$background) <  0.5))
   
   fScopeNames <- names(fallbackScopes)
   for (i in 1:length(fallbackScopes))
   {
      name <- fScopeNames[i]
      scope <- fallbackScopes[[i]]
      if (!(name %in% names(styles)) || !("color" %in% names(styles[[name]])))
      {
         if (!(scope %in% names(styles)) || !("color" %in% names(styles[[scope]])))
         {
            # All fallback elements are foreground for now.
            if (!(name %in% names(styles))) styles[[name]] <- list()
            styles[[name]][["color"]] <- styles$foreground
         }
         else if (name %in% names(styles))
         {
            styles[[name]][["color"]] <- styles[[scope]][["color"]]
         }
         else
         {
            styles[[name]] <- styles[[scope]]
         }
      }
   }
   
   list("styles" = styles, "unsupportedScopes" = unsupportedScopes)
})

# Converts a theme from a tmTheme to an Ace css theme.
#
# @param tmTheme     The parsed tmTheme object.
# 
# Returns Ace css theme as a string.
.rs.addFunction("convertTmTheme", function(tmTheme) {
   # Helper functions 
   
   # Fills a template value with the given replacements.
   #
   # @param template          The template to fill.
   # @param replacements      The replacements to fill the template with.
   #
   # Returns a string of the filled template.
   fillTemplate <- function(template, replacements) {
      repeat
      {
         matches <- regmatches(template, regexec("%(.+?)%", template))[[1]]
         if (length(matches) != 2)
         {
            break
         }
         
         replacement <- replacements[[matches[2]]]
         if (is.null(replacement)) replacement <- ""
         template <- sub(matches[1], replacement, template)
      }
      
      template
   }
   
   # Hyphenates a title or camel case string, separating words and replacing "_" with "-".
   # 
   # @param string      The string to convert to lower case with hyphens.
   #
   # Returns the converted string.
   hyphenate <- function(string) {
      tolower(
         gsub("-+", "-", # Get rid of duplicate hyphens
              sub(
                 "^-", "", # Get rid of leading hyphen
                 gsub(
                    "_",
                    "-", # Replace _ with hyphen
                    gsub(
                       "([^0-9A-Z])([A-Z])", # Insert hyphen before capital letters which are not immediately preceded by a digit or another capital letter
                       "\\1-\\2",
                       gsub("(?:'|\"|\\(([^\\)]*)\\))", "\\1", # Remove special characters and antyhing encased in parantheses
                            gsub("&","-and-", # Replace & with And
                                 gsub("\\s", "-", string)))))))) # Replace whitespace with hyphen
   }
   
   # Quotes a string and adds extra escapes to escape characters.
   #
   # @param string      The string to quoted.
   #
   # Returns the processed string
   quoteStr <- function(string) {
      paste0(
         "\"",
         gsub("\n", "\\n", gsub("\"", "\\\"", gsub("\\", "\\\\", string))),
         "\"")
   }
   
   # Syntax highlighting scopes
   supportedScopes <- list()
   
   # Keywords
   supportedScopes[["keyword"]] <- "keyword"
   supportedScopes[["keyword.operator"]] <- "keyword.operator"
   supportedScopes[["keyword.other.unit"]] <- "keyword.other.unit"
   
   # Constants
   supportedScopes[["constant"]] <- "constant"
   supportedScopes[["constant.language"]] <- "constant.language"
   supportedScopes[["constant.library"]] <- "constant.library"
   supportedScopes[["constant.numeric"]] <- "constant.numeric"
   supportedScopes[["constant.character"]] <- "constant.character"
   supportedScopes[["constant.character.escape"]] <- "constant.character.escape"
   supportedScopes[["constant.character.entity"]] <- "constant.character.entity"
   supportedScopes[["constant.other"]] <- "constant.other"
   
   # Supports
   supportedScopes[["support"]] <- "support"
   supportedScopes[["support.function"]] <- "support.function"
   supportedScopes[["support.function.dom"]] <- "support.function.dom"
   supportedScopes[["support.function.firebug"]] <- "support.firebug"
   supportedScopes[["support.function.constant"]] <- "support.function.constant"
   supportedScopes[["support.constant"]] <- "support.constant"
   supportedScopes[["support.constant.property-value"]] <- "support.constant.property-value"
   supportedScopes[["support.class"]] <- "support.class"
   supportedScopes[["support.type"]] <- "support.type"
   supportedScopes[["support.other"]] <- "support.other"
   
   # Functions
   supportedScopes[["function"]] <- "function"
   supportedScopes[["function.buildin"]] <- "function.buildin"
   
   # Storages
   supportedScopes[["storage"]] <- "storage"
   supportedScopes[["storage.type"]] <- "storage.type"
   
   # Invalids
   supportedScopes[["invalid"]] <- "invalid"
   supportedScopes[["invalid.illegal"]] <- "invalid.illegal"
   supportedScopes[["invalid.deprecated"]] <- "invalid.deprecated"
   
   # Strings
   supportedScopes[["string"]] <- "string"
   supportedScopes[["string.regexp"]] <- "string.regexp"
   
   # Comments
   supportedScopes[["comment"]] <- "comment"
   supportedScopes[["comment.documentation"]] <- "comment.doc"
   supportedScopes[["comment.documentation.tag"]] <- "comment.doc.tag"
   
   # Variables
   supportedScopes[["variable"]] <- "variable"
   supportedScopes[["variable.language"]] <- "variable.language"
   supportedScopes[["variable.parameter"]] <- "variable.parameter"
   
   # Meta
   supportedScopes[["meta"]] <- "meta"
   supportedScopes[["meta.tag.sgml.doctype"]] <- "xml-pe"
   supportedScopes[["meta.tag"]] <- "meta.tag"
   supportedScopes[["meta.selector"]] <- "meta.selector"
   
   # Entities
   supportedScopes[["entity.other.attribute-name"]] <- "entity.other.attribute-name"
   supportedScopes[["entity.name.function"]] <- "entity.name.function"
   supportedScopes[["entity.name"]] <- "entity.name"
   supportedScopes[["entity.name.tag"]] <- "entity.name.tag"
   
   # Markup
   supportedScopes[["markup.heading"]] <- "markup.heading"
   supportedScopes[["markup.heading.1"]] <- "markup.heading.1"
   supportedScopes[["markup.heading.2"]] <- "markup.heading.2"
   supportedScopes[["markup.heading.3"]] <- "markup.heading.3"
   supportedScopes[["markup.heading.4"]] <- "markup.heading.4"
   supportedScopes[["markup.heading.5"]] <- "markup.heading.5"
   supportedScopes[["markup.heading.6"]] <- "markup.heading.6"
   supportedScopes[["markup.list"]] <- "markup.list"
   
   # Collaborators
   supportedScopes[["collab.user1"]] <- "collab.user1"
   
   # RStudio Supported Scopes
   supportedScopes[["marker-layer.active_debug_line"]] <- "marker-layer .active_debug_line"
   # Read the template files
   conn <- file(
      description = file.path(.Call("rs_rResourcesPath", PACKAGE = "(embedding)"), "templates", "ace_theme_template.css"),
      open = "rt")
   on.exit(close(conn), add = TRUE)
   cssTemplate <- paste0(readLines(conn, encoding = "UTF-8"), collapse ="\n")
   
   # Extract styles
   name <- tmTheme$name
   if (is.null(name)) name <- ""
   styleRes <- .rs.extractStyles(tmTheme, supportedScopes)
   styles <- styleRes$styles
   unsupportedScopes <- styleRes$unsupportedScopes
   
   # Fill template
   styles$cssClass = paste0("ace-", hyphenate(name))
   styles$uuid <- tmTheme$uuid
   css <- fillTemplate(cssTemplate, styles)
   
   for (scope in supportedScopes)
   {
      if (scope %in% names(styles))
      {
         if (grepl("active_debug_line", scope, fixed = TRUE))
         {
            css = paste0(
               css,
               "\n\n.",
               styles$cssClass,
               " ",
               gsub("^|\\.", ".ace_", scope),
               " {\n")
            for (rule in names(styles[[scope]]))
            {
               if (!grepl("^\\s*$", styles[[scope]][[rule]], perl = TRUE))
               {
                  css = paste0(css, "  ", rule, ": ", styles[[scope]][[rule]], ";\n")
               }
            }
            
            css = paste0(
               css,
               "\n  position: absolute;",
               "\n  z-index: -1;",
               "\n}")
         }
         else if (length(styles[[scope]]) > 0)
         {
            css = paste0(
               css,
               "\n\n.",
               styles$cssClass,
               " ",
               gsub("^|\\.", ".ace_", scope),
               " {\n")
            for (rule in names(styles[[scope]]))
            {
               if (!grepl("^\\s*$", styles[[scope]][[rule]], perl = TRUE))
               {
                  css = paste0(css, "  ", rule, ": ", styles[[scope]][[rule]], ";\n")
               }
            }
            
            css = paste0(css, "\n}")
         }
      }
   }
   
   list(
      "theme" = strsplit(gsub("[^\\{\\}]+\\{\\s*\\}", "", css, perl = TRUE), "\n")[[1]],
      "isDark" = as.logical(styles$isDark))
})

# TmTheme XML Parsing functions ====================================================================

# Parses a "key" element from a tmtheme document and raises appropriate error.
#
# @param element     The element to parse.
#
# Returns the text value of the element.
.rs.addFunction("parseKeyElement", function(element) {
   key <- xml2::xml_text(element)
   if (key == "")
   {
      stop("The value of a \"key\" element may not be empty.", call. = FALSE)
   }
   
   key
})

# Parses a "string" element from a tmtheme document and raises appropriate errors.
#
# @param element     The element to parse.
# @param keyName     The name of the key for this value.
#
# Returns the text value of the element.
.rs.addFunction("parseStringElement", function(element, keyName) {
   value <- xml2::xml_text(element)
   
   # The key can only be null if there was no <key> element immediately preceding the <string>
   # element in the provided xml. If any <key> element was found (even a <key/>), the key name
   # will at least be "".
   if (is.null(keyName))
   {
      stop(
         "Unable to find a key for the \"string\" element with value \"",
         value,
         "\".",
         call. = FALSE)
   }
   
   value
})

# Recursivley parses a dictionary element from a tmtheme document and raises the correct errors.
#
# @param dictElement    The element to parse.
# @param keyName        The name of the dictionary.
#
# Returns a list with named values.
.rs.addFunction("parseDictElement", function(dictElement, keyName) {
   if (is.null(keyName))
   {
      stop("Unable to find a key for the current \"dict\" element.", call. = FALSE)
   }
   
   values <- list()
   if (xml2::xml_length(dictElement) >= 1)
   {
      key <- NULL
      for (element in xml2::xml_children(dictElement))
      {
         elName <- xml2::xml_name(element)
         if (elName != "comment")
         {
            if (elName == "key")
            {
               if (!is.null(key))
               {
                  stop(
                     "Unable to find a value for the key \"",
                     key,
                     "\".",
                     call. = FALSE)
               }
               key <- .rs.parseKeyElement(element)
            }
            else if (elName == "string")
            {
               # Add the key-value pair to the theme object and reset the key to NULL to avoid erroneously
               # using the same key twice.
               values[[key]] <- .rs.parseStringElement(element, key)
               key <- NULL
            }
            else if (elName == "dict")
            {
               values[[key]] <- .rs.parseDictElement(element, key)
               key <- NULL
            }
            else if (elName == "array")
            {
               values[[key]] <- .rs.parseArrayElement(element, key)
               key <- NULL
            }
            else
            {
               stop(
                  "Encountered unexpected element as a child of the current \"dict\" element: \"",
                  elName,
                  "\". Expected \"key\", \"string\", \"array\", or \"dict\".",
                  call. = FALSE)
            }
         }
      }
      
      if (!is.null(key))
      {
         stop(
            "Unable to find a value for the key \"",
            key,
            "\".",
            call. = FALSE)
      }
   }
   
   values
})

# Recursively parses the list of settings from a tmtheme document.
#
# @param arrayElement      The <array> element to parse.
# @param keyName           The name of the key for this array element.
#
# Returns a list() of named settings.
.rs.addFunction("parseArrayElement", function(arrayElement, keyName) {
   if (xml2::xml_length(arrayElement) < 1)
   {
      stop("\"array\" element cannot be empty.", call. = FALSE)
   }
   
   if (is.null(keyName))
   {
      stop("Unable to find a key for array value.", call. = FALSE)
   }
   if (keyName != "settings")
   {
      stop(
         "Incorrect key for array element. Expected: \"settings\"; Actual: \"",
         keyName,
         "\".",
         call. = FALSE)
   }
   
   values <- list()
   index <- 1
   for (element in xml2::xml_children(arrayElement))
   {
      elName <- xml2::xml_name(element)
      if (elName != "comment")
      {
         if (elName != "dict")
         {
            stop(
               "Expecting \"dict\" element; found \"",
               elName,
               "\".",
               call. = FALSE)
         }
         
         # Intentionally empty key here
         values[[index]] <- .rs.parseDictElement(element, "")
         index <- index + 1
      }
   }
   
   values
})

# Parses a tmtheme document and stores the relevant values in a list with named values.
#
# @param filePath     The path of the file to parse.
# 
# Returns a list with named values.
.rs.addFunction("parseTmTheme", function(filePath) {
   if (!file.exists(filePath))
   {
      stop(
         "The specified file, \"",
         filePath,
         "\", does not exist.",
         call. = FALSE)
   }
   xmlStr <- paste(readLines(filePath, encoding = "UTF-8", warn = FALSE), collapse = "\n")
   
   tmThemeDoc <- xml2::xml_root(xml2::read_xml(
      xmlStr, 
      error = function(msg, code, domain, line, col, level, filename) {
         stop(
            "An error occurred while parsing ",
            filename,
            " at line ",
            line,
            ": ",
            msg,
            call. = FALSE)
      },
      encoding = "UTF-8"))
   
   # Check for the right number of children
   childrenCount <- xml2::xml_length(tmThemeDoc)
   if (childrenCount != 1)
   {
      stop("Expected 1 non-text child of the root, found: ",
           childrenCount,
           call. = FALSE)
   }
   
   # Check the structure at the root is correct before continuing.
   if (xml2::xml_name(xml2::xml_child(tmThemeDoc, 1)) != "dict")
   {
      stop("Expecting \"dict\" element; found \"",
           xml2::xml_name(xml2::xml_child(tmThemeDoc, 1)),
           "\".",
           call. = FALSE)
   }
   if (xml2::xml_length(xml2::xml_child(tmThemeDoc, 1)) < 1)
   {
      stop(
         "\"dict\" element cannot be empty.",
         call. = FALSE)
   }
   
   # Skip the plist (root), first child is a <dict>.
   # Intentionally empty key here
   .rs.parseDictElement(xml2::xml_child(tmThemeDoc, 1), "")
})

# compile-themes Functions =========================================================================

# Converts an ace theme to an RStudio theme.
# 
# @param aceCss      The ace CSS to convert.
# @param name        The name 
.rs.addFunction("convertAceTheme", function(name, aceCss, isDark) {
   rsTheme <- .rs.compile_theme(aceCss, isDark, name = name)
   if (length(rsTheme) == 0)
   {
      stop("Please see above for warnings.",
           .call = FALSE)
   }
   
   c(
      paste0("/* rs-theme-name: ", name, " */"),
      paste0("/* rs-theme-is-dark: ", isDark, " */"),
      rsTheme,
      "\n")
})

# Worker Functions =================================================================================
.rs.addFunction("isGlobalTheme", function(themeUrl)
{
   grepl("^theme/custom/global/.*?\\.rstheme$", themeUrl, ignore.case = TRUE)
})

.rs.addFunction("isLocalTheme", function(themeUrl)
{
   grepl("^theme/custom/local/.*\\.rstheme$", themeUrl, ignore.case = TRUE)
})

.rs.addFunction("isDefaultTheme", function(themeUrl)
{
   grepl("^theme/default/.*\\.rstheme$", themeUrl, ignore.case = TRUE)
})

.rs.addFunction("getThemeName", function(themeLines, fileName)
{
   tmThemeNameRegex <- "<key>name</key>\\s*<string>([^>]*)</string>"
   rsthemeNameRegex <- "rs-theme-name\\s*:\\s*([^\\*]+?)\\s*(?:\\*|$)"
   nameRegex <- tmThemeNameRegex
   nameLine <- themeLines[grep(tmThemeNameRegex, themeLines, perl = TRUE, ignore.case = TRUE)]
   if (length(nameLine) == 0)
   {
      nameRegex <- rsthemeNameRegex
      nameLine <- themeLines[grep(rsthemeNameRegex, themeLines, perl = TRUE, ignore.case = TRUE)]
   }
   if (length(nameLine) == 0)
   {
      regmatches(
         basename(fileName),
         regexec(
            "^([^\\.]*)(?:\\.[^\\.]*)?",
            basename(fileName),
            perl = TRUE))[[1]][2]
   }
   else
   {
      sub(
         "^\\s*(.+?)\\s*$",
         "\\1",
         regmatches(
            nameLine,
            regexec(
               nameRegex,
               nameLine,
               perl = TRUE))[[1]][2],
         perl = TRUE)
   }
})

# Gets the install location.
#
# @param global    Whether to get the global or local install dir.
#
# Returns the install location.
.rs.addFunction("getThemeInstallDir", function(global) 
{
   if (global)
      .Call("rs_getGlobalThemeDir", PACKAGE = "(embedding)")
   else
      .Call("rs_getLocalThemeDir", PACKAGE = "(embedding)")
})

.rs.addFunction("getThemeDirFromUrl", function(url) 
{
   decodedUrl <- URLdecode(url)
   if (.rs.isGlobalTheme(decodedUrl))
   {
      file.path(.rs.getThemeInstallDir(TRUE), basename(decodedUrl))
   }
   else if (.rs.isLocalTheme(decodedUrl))
   {
      .Call("rs_getLocalThemePath", basename(decodedUrl), PACKAGE="(embedding)")
   }
   else
   {
      NULL
   }
})

# Converts a tmtheme file into an rstheme file.
# 
# @param themePath         The tmtheme file to convert.
# @param add               Whether to add the converted custom theme to RStudio.
# @param outputLocation    Where to place a local copy of the converted theme.
# @param apply             Whether to immediately apply the new custom theme.
# @param force             Whether to force the operation when it may involve an overwrite.
# @param globally          Whether to add the theme for all users (true) or just this user (false).
#
# Returns the name of the theme on success.
.rs.addFunction("convertTheme", function(themePath, add, outputLocation, apply, force, globally) {
   tmTheme <- .rs.parseTmTheme(themePath)
   name <- tmTheme$name
   fileName <- paste0(tools::file_path_sans_ext(basename(themePath)), ".rstheme")
   
   
   aceTheme <- .rs.convertTmTheme(tmTheme)
   rsTheme <- .rs.convertAceTheme(name, aceTheme$theme, aceTheme$isDark)
   
   
   isTemp <- is.null(outputLocation)
   location <- if (is.null(outputLocation)) file.path(tempdir(), fileName)
   else file.path(outputLocation, fileName)
   
   if (!file.create(location))
   {
      stop(
         "Unable to create the theme file in the requested location: ",
         location,
         ". Please see above for relevant warnings.",
         call. = FALSE)
   }
   
   cat(paste(rsTheme, collapse="\n"), file = location)
   
   if (add)
   {
      .rs.addTheme(location, apply, force, globally)
   }
   else if (apply)
   {
      stop("Invalid input: unable to apply a theme which has not been added.", call. = FALSE)
   }
   
   name
})

# Adds a custom rstheme to RStudio.
#
# @param themePath   The full or relative path of the rstheme file to add.
# @param apply       Whether to immediately apply the newly added theme.
# @param force       Whether to force the operation when it may involve an overwrite.
# @param globally    Whether to add the theme for all users (true) or for the current user (false).
#
# Returns the name of the theme on success.
.rs.addFunction("addTheme", function(themePath, apply, force, globally) {
   # Get the name of the file without extension.
   fileName <- basename(themePath)
   
   # Get the name of the theme either from the first occurence of "rs-theme-name:" in the css or 
   # the name of the file.
   themeLines <- readLines(themePath, encoding = "UTF-8", warn = FALSE)
   name <- .rs.getThemeName(paste0(themeLines, collapse = "\n"), fileName)
   
   if (is.na(name) || (name == "") || is.null(name))
   {
      stop(
         "Unable to find a name for the new theme. Please check that the file \"",
         themePath,
         "\" is valid.",
         call. = FALSE)
   }
   
   if (length(themeLines) == 0)
   {
      stop("The theme file is empty.", call. = FALSE);
   }
      
   # Check if a theme with the same name already exists in the current location.
   dupTheme <- .rs.getThemes()[[tolower(name)]]
   if (!is.null(dupTheme) && 
       ((globally && .rs.isGlobalTheme(dupTheme$url)) ||
        (!globally && .rs.isLocalTheme(dupTheme$url))) &&
       !force)
   {
      stop(
         "The specified theme, \"",
         name,
         "\", already exists in the target location. Please delete the existing theme and try again.",
         call. = FALSE)
   }
   else if (!is.null(dupTheme))
   {
      willBeOverridden <- if (!globally || .rs.isDefaultTheme(dupTheme$url)) "The existing theme will be overridden by the new theme."
      else "The newly added theme will be overridden by the existing theme."
      warning("There is another theme with the same name, \"",
              name,
              "\". ",
              willBeOverridden,
              call. = FALSE)
   }
   
   outputDir <- .rs.getThemeInstallDir(globally)
   if (!dir.exists(outputDir))
   {
      if (globally)
      {
         stop(
            "The global installation directory does not exist: \"",
            outputDir,
            "\".",
            call. = FALSE)
      }
      if (!dir.create(outputDir, recursive = TRUE))
      {
         stop(
            "Please check file system permissions.",
            call. = FALSE)
      }
   }
   
   addedTheme <- file.path(outputDir, fileName)
   if (file.exists(addedTheme) && !force)
   {
      stop(
         "A file with the same name, \"",
         fileName,
         "\", already exists in the target location. To add the theme anyway, try again with `force = TRUE`.",
         call. = FALSE)
   }
   
   if (!file.copy(
      themePath,
      addedTheme,
      overwrite = force))
   {
      msg <- "Please check file system permissions"
      if (!force)
      {
         msg <- paste0(msg, " or try again with `force = TRUE`.")
      }
      
      stop(msg, ".", call. = FALSE)
   }
   
   if (apply)
   {
      .rs.applyTheme(name, .rs.getThemes())
   }
   
   name
})

# Applies a theme to RStudio.
#
# @param name     The name of the theme to apply.
.rs.addFunction("applyTheme", function(name, themeList) {
   theme <- themeList[[tolower(name)]]
   if (is.null(theme))
   {
      stop("The specified theme \"", name, "\" does not exist.", call. = FALSE)
   }
   
   themeValue <- list(
      "name"= .rs.scalar(theme$name),
      "isDark" = .rs.scalar(theme$isDark),
      "url" = .rs.scalar(theme$url))

   # Save theme details to user state
   .rs.writeUserState("theme", themeValue)

   # Save theme itself as a user pref
   .rs.writeUserPref("editor_theme", name)
})

# Removes a theme from RStudio. If the removed theme is the current theme, the current theme will be
# set to the default theme.
#
# @param The name of the theme to remove.
.rs.addFunction("removeTheme", function(name, themeList) {
   currentTheme <- .rs.api.getThemeInfo()$editor
   lowerCaseName <- tolower(name)
   
   if (is.null(themeList[[lowerCaseName]]))
   {
      stop("The specified theme \"", name, "\" does not exist.")
   }
   
   if (identical(lowerCaseName, tolower(currentTheme)))
   {
      nextTheme <- if (themeList[[lowerCaseName]]$isDark) "Tomorrow Night" else "TextMate (default)"
      warning("Removing the active theme - setting the current theme to ", nextTheme)
      .rs.applyTheme(nextTheme, themeList)
   }

   filePath <- .rs.getThemeDirFromUrl(themeList[[lowerCaseName]]$url)
   if (is.null(filePath))
   {
      stop("Please verify that the theme is installed as a custom theme.")
   }
   if (!file.remove(filePath))
   {
      if (file.exists(filePath))
      {
         justFileName <- basename(filePath)
         actualPath <- normalizePath(filePath, mustWork = FALSE, winslash = "/")
         globalPath <- normalizePath(.rs.getThemeInstallDir(TRUE), mustWork = FALSE, winslash = "/")
         if (identical(file.path(globalPath, justFileName), actualPath))
         {
            stop("The specified theme is installed for all users. Please contact your system administrator to remove the theme.")
         }
         else
         {
            stop("Please check your file system permissions.")
         }
      }
   }
})

.rs.addFunction("getThemes", function() {
   themeList <- .Call("rs_getThemes", PACKAGE = "(embedding)")
   for (i in seq_along(themeList))
   {
      Encoding(themeList[[i]]$name) <- "UTF-8"
      Encoding(themeList[[i]]$url) <- "UTF-8"
   }
   themeList
})

# C++ Wrappers =====================================================================================
.rs.addFunction("internal.convertTheme", function(themePath) {
   Encoding(themePath) <- "UTF-8"
   
   warnings <- c()
   tryCatch(
      withCallingHandlers(
         .rs.convertTheme(
            themePath,
            add = TRUE,
            outputLocation = NULL,
            apply = FALSE,
            force = TRUE,
            globally = FALSE),
         warning = function(w) 
         { 
            warnings <<- conditionMessage(w)
            invokeRestart("muffleWarning")
         }),
      error = function(e) 
      { 
         if (length(warnings) > 0)
            e$message <- paste(
               e$message,
               paste0(warnings, collapse = "\n    "),
               sep = "\nAlso, warnings:\n    ")
         e 
      })
})

.rs.addFunction("internal.addTheme", function(themePath) {
   Encoding(themePath) <- "UTF-8"
   
   warnings <- c()
   tryCatch(
      withCallingHandlers(
         .rs.addTheme(themePath, apply = FALSE, force = FALSE, globally = FALSE),
         warning = function(w) 
         { 
            warnings <<- conditionMessage(w)
            invokeRestart("muffleWarning")
         }),
      error = function(e) 
      {
         if (length(warnings) > 0)
            e$message <- paste(
               e$message,
               paste0(warnings, collapse = "\n    "),
               sep = "\nAlso, warnings:\n    ")
         e 
      })
})

.rs.addFunction("internal.removeTheme", function(name, themeList) {
   Encoding(name) <- "UTF-8"
   
   warnings <- c()
   tryCatch(
      withCallingHandlers(
         .rs.removeTheme(name, themeList),
         warning = function(w) 
         { 
            warnings <<- c(warnings, conditionMessage(w))
            invokeRestart("muffleWarning")
         }),
      error = function(e) 
      { 
         if (length(warnings) > 0)
            e$message <- paste(
               e$message,
               paste0(warnings, collapse = "\n    "),
               sep = "\nAlso, warnings:\n    ")
         e 
      })
})

# API Functions ====================================================================================

# Convert a tmtheme to rstheme and optionally add it to RStudio.
.rs.addApiFunction("convertTheme", function(themePath, add = TRUE, outputLocation = NULL, apply = FALSE, force = FALSE, globally = FALSE) {
   # Require XML package for parsing the tmtheme files.
   missingLibraryMsg <- "Taking this action requires the %pkg% library. Please run 'install.packages(\"%pkg%\")' before continuing."
   if (!suppressWarnings(require("xml2", quietly = TRUE)))
   {
      stop(gsub("%pkg%", "xml2", missingLibraryMsg, fixed = TRUE))
   }
   
   tryCatch(
      .rs.convertTheme(themePath, add, outputLocation, apply, force, globally),
      error = function(e) { stop("Unable to convert the tmTheme to an rstheme. ", e$message) })
})

# Add a theme to RStudio.
.rs.addApiFunction("addTheme", function(themePath, apply = FALSE, force = FALSE, globally = FALSE) {
   tryCatch(
      .rs.addTheme(themePath, apply, force, globally),
      error = function(e) 
      {
         stop("Unable to add the theme file \"", themePath, "\". ", e$message)
      })
})

# Apply a theme to RStudio.
.rs.addApiFunction("applyTheme", function(name) {
   tryCatch(
      .rs.applyTheme(name, .rs.getThemes()),
      error = function(e) { stop("Unable to apply the theme \"", name, "\". ", e$message) })
})

# Remove a theme from RStudio.
.rs.addApiFunction("removeTheme", function(name) {
   tryCatch(
      .rs.removeTheme(name, .rs.getThemes()),
      error = function(e) { stop("Unable to remove the theme \"", name, "\". ", e$message) })
})

# Get the list of installed themes.
.rs.addApiFunction("getThemes", function() {
   lapply(.rs.getThemes(), function(theme) {
      theme[names(theme) != "url"]
   })
})

# RPC Functions ====================================================================================
.rs.addJsonRpcHandler("get_theme_name", function(themeFile) {
   Encoding(themeFile) <- "UTF-8"
   lines <- readLines(themeFile, encoding = "UTF-8")
   .rs.scalar(.rs.getThemeName(paste0(lines, collapse = "\n"), themeFile))
})

#
# SessionSpelling.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("downloadAllDictionaries", function(targetDir, secure)
{
   # form url to dictionaries
   fmt <- "%s://s3.amazonaws.com/rstudio-buildtools/dictionaries/%s"
   protocol <- if (secure) "https" else "http"
   archive <- "all-dictionaries.zip"
   url <- sprintf(fmt, protocol, archive)
   
   # form path to downloaded dictionaries in tempdir
   archivePath <- file.path(tempdir(), archive)
   if (file.exists(archivePath))
      file.remove(archivePath)
   
   # download the dictionary
   download.file(
      url = url,
      destfile = archivePath,
      cacheOK = FALSE,
      quiet = TRUE
   )
   
   # remove existing dictionaries if they exist
   unlink(targetDir, recursive = TRUE)
   dir.create(targetDir, showWarnings = FALSE, recursive = TRUE)
   
   # unzip downloaded dictionaries into target -- if this fails for any
   # reason then remove any files that were unpacked (because we don't 
   # know if the partially unzipped archive is valid)
   tryCatch(
      unzip(archivePath, exdir = targetDir),
      error = function(e) {
         unlink(targetDir, recursive = TRUE)
         stop(e)
      }
   )
   
   # remove the downloaded archive
   unlink(archivePath)
   
   invisible(targetDir)
})

#
# SessionShinyViewer.R
#
# Copyright (C) 2009-19 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("invokeShinyTutorialViewer", function(url, meta) {
   invisible(.Call("rs_shinyviewer", url, getwd(), "tutorial", meta, PACKAGE = "(embedding)"))
}, attrs = list(shinyViewerType = "tutorial"))

.rs.addFunction("invokeShinyPaneViewer", function(url) {
   invisible(.Call("rs_shinyviewer", url, getwd(), "pane", NULL, PACKAGE = "(embedding)"))
}, attrs = list(shinyViewerType = "pane"))

.rs.addFunction("invokeShinyWindowViewer", function(url) {
   invisible(.Call("rs_shinyviewer", url, getwd(), "window", NULL, PACKAGE = "(embedding)"))
}, attrs = list(shinyViewerType = "window"))

.rs.addFunction("invokeShinyWindowExternal", function(url) {
   invisible(.Call("rs_shinyviewer", url, getwd(), "browser", NULL, PACKAGE = "(embedding)"))
}, attrs = list(shinyViewerType = "browser"))

.rs.addFunction("setShinyViewerType", function(type) {
   if (identical(type, "none"))
      options(shiny.launch.browser = FALSE)
   else if (identical(type, "tutorial"))
      options(shiny.launch.browser = .rs.invokeShinyTutorialViewer)
   else if (identical(type, "pane"))
      options(shiny.launch.browser = .rs.invokeShinyPaneViewer)
   else if (identical(type, "window"))
      options(shiny.launch.browser = .rs.invokeShinyWindowViewer)
   else if (identical(type, "browser"))
      options(shiny.launch.browser = .rs.invokeShinyWindowExternal)
})

.rs.addFunction("getShinyViewerType", function() {
   viewer <- getOption("shiny.launch.browser")
   if (identical(viewer, FALSE))
      return("none")
   else if (identical(viewer, TRUE))
      return("browser")
   else if (is.function(viewer) && is.character(attr(viewer, "shinyViewerType")))
      return(attr(viewer, "shinyViewerType"))
   return("user")
})

.rs.addFunction("refreshShinyLaunchBrowserOption", function()
{
   # read viewer option
   viewer <- getOption("shiny.launch.browser")
   if (!is.function(viewer))
      return(FALSE)
   
   type <- attr(viewer, "shinyViewerType", exact = TRUE)
   if (is.null(type))
      return(FALSE)
   
   # NOTE: in RStudio v1.2, Shiny viewer types were stored as numeric values;
   # now, they're stored as explicit names. we handle both cases here; the
   # indices of the following 'types' vector matches the types used for v1.2
   if (is.numeric(type) && length(type) == 1L)
   {
      types <- c("none", "pane", "window", "browser")
      type <- types[[type]]
   }
   
   # validate that we now have a character type
   if (!is.character(type) || length(type) != 1L)
      return(FALSE)
   
   # set the viewer type
   .rs.setShinyViewerType(type)
   TRUE
})

.rs.addJsonRpcHandler("get_shiny_viewer_type", function() {
   .rs.scalar(.rs.getShinyViewerType())
})

.rs.addJsonRpcHandler("stop_shiny_app", function(id)
{
   if (identical(id, "foreground")) {
      # if the app is running in the foreground, tell Shiny to stop it directly
      shiny::stopApp()
   } else {
      # it's running in the background; stop the associated job
      .rs.api.stopJob(id)
   }
})

#
# SessionEnvironment.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("is_function_masked", function(functionName,
                                                     packageName)
{
   result <- tryCatch(
      .rs.isFunctionMasked(functionName, packageName),
      error = function(e) FALSE
   )

   .rs.scalar(result)
})

.rs.addFunction("isFunctionMasked", function(functionName,
                                             packageName)
{
   globalValue  <- get(
      x = functionName,
      envir = globalenv(),
      mode = "function"
   )

   packageValue <- get(
      x = functionName,
      envir = asNamespace(packageName),
      mode = "function"
   )

   !identical(globalValue, packageValue)
})

.rs.addFunction("valueFromStr", function(val)
{
   .rs.withS3OverridesDisabled({
      .rs.withTimeLimit(1, fail = "<truncated>", {
         capture.output(try(str(val), silent = TRUE))
      })
   })
})

.rs.addFunction("valueAsString", function(val)
{
   tryCatch(
      .rs.valueAsStringImpl(val),
      error = function(e) "NO_VALUE"
   )
})

.rs.addFunction("valueAsStringImpl", function(val)
{
   if (missing(val))
   {
      "<missing>"
   }
   else if (is.null(val))
   {
      "NULL"
   }
   else if (is.character(val) && !is.object(val) && !is.array(val))
   {
      # for plain character variables, we 'mock' the behavior of str()
      # while avoiding the potential for re-encoding (as this could mangle
      # UTF-8 characters on Windows)
      n <- length(val)
      if (n == 0)
      {
         "character (empty)"
      }
      else if (n == 1)
      {
         encodeString(val, quote = "\"", na.encode = FALSE)
      }
      else
      {
         encoded <- encodeString(
            head(val, n = 128L),
            quote = "\"",
            na.encode = FALSE
         )

         fmt <- "chr [1:%i] %s"
         txt <- sprintf(fmt, n, paste(encoded, collapse = " "))
         .rs.truncate(txt)
      }
   }
   else if (is.raw(val))
   {
      if (length(val) == 0)
      {
         "raw (empty)"
      }
      else
      {
         .rs.valueFromStr(val)
      }
   }
   else if (is.atomic(val) && is.null(attributes(val)))
   {
      n <- length(val)
      if (n == 0)
      {
         paste(.rs.getSingleClass(val), " (empty)")
      }
      else if (n == 1)
      {
         .rs.truncate(.rs.deparse(val), 1024L)
      }
      else
      {
         .rs.valueFromStr(val)
      }
   }
   else if (inherits(val, "python.builtin.object"))
   {
      .rs.valueFromStr(val)
   }
   else if (.rs.isFunction(val))
   {
      .rs.getSignature(val)
   }
   else if (inherits(val, c("Date", "POSIXct", "POSIXlt", "difftime")))
   {
      if (length(val) == 1)
      {
         format(val, usetz = TRUE)
      }
      else
      {
         .rs.valueFromStr(val)
      }
   }
   else
   {
      "NO_VALUE"
   }
})

.rs.addFunction("valueContents", function(val)
{
   tryCatch(
      .rs.valueContentsImpl(val),
      error = function(e) "NO_VALUE"
   )
})

.rs.addFunction("valueContentsImpl", function(val)
{
   if (inherits(val, "ore.frame"))
   {
      # for Oracle R frames, show the query if it exists
      query <- attr(val, "dataQry", exact = TRUE)

      # no query, show empty
      if (is.null(query))
         return("NO_VALUE")

      # query, display it
      attributes(query) <- NULL
      paste("   Query:", query)
   }
   else if (inherits(val, "pandas.core.frame.DataFrame"))
   {
      output <- reticulate::py_to_r(val$to_string(max_rows = 150L))
      strsplit(output, "\n", fixed = TRUE)[[1]]
   }
   else
   {
      output <- .rs.valueFromStr(val)

      n <- length(output)

      # only return the first 150 lines of detail (generally columns)--any more
      # won't be very presentable in the environment pane. the first line
      # generally contains descriptive text, so don't return that.
      #
      # however, str.default() may incorrectly omit the description header
      # for classed lists when a user-defined str method exists in the global
      # environment (even if that method wasn't dispatched to). detect this
      # by checking if the first line is indented (a data line) vs unindented
      # (a header line). see https://github.com/rstudio/rstudio/issues/16985
      hasHeader <- n > 0 && !.rs.startsWith(output[[1L]], " ")

      if (n > 150)
      {
         fmt <- "  [... %i lines omitted]"
         tail <- sprintf(fmt, n - 150)
         if (hasHeader)
            output <- c(output[2:150], tail)
         else
            output <- c(output[1:150], tail)
      }
      else if (n > 1 && hasHeader)
      {
        output <- output[-1]
      }

      output
   }
})

.rs.addFunction("isFunction", function(val)
{
   is.function(val) || identical(.rs.getSingleClass(val), "C++Function")
})

# used to create description for promises (legacy path for R < 4.6.0)
.rs.addFunction("promiseDescription", function(obj)
{
   # NOTE: substitute() returns the expression associated with a promise,
   # without forcing it to be evaluated
   expr <- substitute(obj)
   .rs.promiseExprDescription(expr)
})

# describe a promise from its pre-extracted expression
.rs.addFunction("promiseExprDescription", function(expr)
{
   # if this appears to be a call to 'lazyLoadDBfetch()', that implies
   # this is lazy-loaded data (typically associated with an R package).
   # handle those up front
   isLazyLoad <-
      is.call(expr) &&
      is.name(expr[[1L]]) &&
      identical(expr[[1L]], as.name("lazyLoadDBfetch"))

   if (isLazyLoad)
      return("<Promise>")

   # for some calls, e.g. those formed manually or those evaluated via
   # do.call(), the 'expression' here might just be an already-evaluated
   # R object. in such a case, we want to avoid deparsing the object as
   # it could be expensive (especially for large objects).
   if (!is.call(expr))
      return(.rs.valueDescription(expr))

   # we have a call; try to deparse it
   .rs.describeCall(expr)
})

# used to create descriptions for language objects and symbols
.rs.addFunction("languageDescription", function(env, objectName)
{
   desc <- "Missing object"
   tryCatch(
   {
      desc <- capture.output(print(get(objectName, env)))
   },
   error = function(e)
   {
      # silently ignore; if the object can't be retrieved from the
      # environment, treat it as missing
   },
   finally =
   {
      return(desc)
   })
})

.rs.addFunction("sourceFileFromRef", function(srcref)
{
   if (is.null(srcref))
      return("")

   # resolve file path for this srcref
   srcfile <- attr(srcref, "srcfile")
   if (is.null(srcfile) || is.null(srcfile$filename))
      return("")

   # check for absolute path in srcref
   filename <- enc2utf8(srcfile$filename)
   if (.rs.isAbsolutePath(filename))
      return(filename)

   # if the path was not absolute, we need to resolve it relative
   # to the working directory associated with the srcref
   if (!is.null(srcfile$wd)) {
      wd <- enc2utf8(srcfile$wd)
      filename <- paste(c(wd, filename), collapse = "/")
   }

   normalizePath(filename, winslash = "/", mustWork = FALSE)
})

# Given a function and some content inside that function, returns a vector
# in the standard R source reference format that represents the location of
# the content in the deparsed representation of the function.
.rs.addFunction("simulateSourceRefs", function(var)
{
  # Read arguments from attached attributes to the input (these can't be passed
  # naked from RStudio)
  fun <-  attr(var, "_rs_callfun")
  call <- attr(var, "_rs_callobj")
  calltext <- attr(var, "_rs_calltext")
  linepref <- attr(var, "_rs_lastline")

  # To proceed, we need the function to look in, and either the raw call
  # object (which we will deparse later) or the text to look for.
  if (is.null(fun) ||
      (is.null(call) && is.null(calltext)) )
     return(c(0L, 0L, 0L, 0L, 0L, 0L))

  lines <- .rs.deparseFunction(fun, TRUE, FALSE)

  # Remember the indentation level on each line (added by deparse), and remove
  # it along with any other leading or trailing whitespace.
  indents <- nchar(sub("\\S.*", "", lines))
  slines <- sub("\\s+$", "", sub("^\\s+", "", lines))

  # Compute the character position of the start of each line, and collapse the
  # lines to a character vector of length 1.
  nchars <- 0
  offsets <- integer(length(slines))
  for (i in 1:length(slines)) {
    nchars <- nchars + nchar(slines[i]) + 1
    offsets[i] <- nchars
  }

  singleline <- paste(slines, collapse = " ")

  if (is.null(calltext))
  {
     # No call text specified; deparse into a list of lines
     # limit length of deparsed output to avoid issues with very large calls
     #
     # this implies that we might be unable to highlight calls larger than
     # the below number of lines, but in practice such a large highlight
     # would be unlikely to be useful
     # https://github.com/rstudio/rstudio/issues/5158
     calltext <- .rs.deparse(call, nlines = 200L)
  }
  else
  {
     # Call text specified as a single character vector; split into a list
     # of lines
     calltext <- unlist(strsplit(calltext, "\n", fixed = TRUE))
  }

  # Remove leading/trailing whitespace on each line, and collapse the lines
  calltext <- sub("\\s+$", "", sub("^\\s+", "", calltext))
  calltext <- paste(calltext, collapse = " ")

  # Any call text supplied is presumed UTF-8 unless we know otherwise
  if (Encoding(calltext) == "unknown")
     Encoding(calltext) <- "UTF-8"

  # NULL is output by R when it doesn't have an expression to output; don't
  # try to match it to code
  if (identical(calltext, "NULL"))
     return(c(0L, 0L, 0L, 0L, 0L, 0L))

  pos <- gregexpr(calltext, singleline, fixed = TRUE)[[1]]
  if (length(linepref) == 0L || linepref <= 0L)
  {
     endpos <- pos[[1L]] + attr(pos, "match.length")[[1L]]
     pos <- pos[[1L]]
  }
  else if (length(pos) > 1)
  {
     # There is more than one instance of the call text in the function; try
     # to pick the first match past the preferred line.
     best <- which(pos > offsets[linepref])
     if (length(best) == 0)
     {
        # No match past the preferred line, just pick the match closest
        best <- which.min(abs(linepref - pos))
     }
     else
     {
        best <- best[1]
     }
     
     endpos <- pos[best] + attr(pos, "match.length")[best]
     pos <- pos[best]
  }
  else
  {
     endpos <- pos[[1L]] + attr(pos, "match.length")[[1L]]
     pos <- pos[[1L]]
  }

  # Return an empty source ref if we couldn't find a match
  if (length(pos) == 0 || pos < 0)
     return(c(0L, 0L, 0L, 0L, 0L, 0L))

  # Compute the starting and ending lines
  firstline <- which(offsets >= pos, arr.ind = TRUE)[1]
  lastline <- which(offsets >= endpos, arr.ind = TRUE)[1]
  if (is.na(lastline))
     lastline <- length(offsets)

  # Compute the starting and ending character positions within the line,
  # taking into account the indents we removed earlier.
  firstchar <- pos - (if (firstline == 1) 0 else offsets[firstline - 1])
  firstchar <- firstchar + indents[firstline]

  # If the match is a block ({ ... }) and contains more than a few lines,
  # match the first line instead of the whole block; having the entire contents
  # of the code browser highlighted is not useful.
  if (substr(calltext, 1, 1) == "{" &&
      substr(calltext, nchar(calltext), nchar(calltext)) == "}" &&
      lastline - firstline > 5)
  {
     lastline <- firstline
     lastchar <- offsets[firstline] - pos
  }
  else
  {
     lastchar <- endpos - (if (lastline == 1) 0 else offsets[lastline - 1])
     lastchar <- lastchar + indents[lastline] - 1
  }

  result <- c(
     firstline, firstchar,
     lastline,  lastchar,
     firstchar, lastchar
  )

  as.integer(result)
  
})

.rs.addFunction("functionNameFromCall", function(val)
{
   call <- .rs.nullCoalesce(
      attr(val, "_rs_call", exact = TRUE),
      val
   )

   if (is.function(call[[1]]))
      return("[Anonymous function]")

   if (is.name(call[[1L]]))
      return(as.character(call[[1L]]))

   .rs.deparse(call[[1L]])
})

.rs.addFunction("sanitizeCall", function(object)
{
   if (missing(object))
   {
      return(object)
   }
   else if (is.call(object))
   {
      # if this is the concatenation of a large number of objects,
      # then just use a shorter representation of the call
      callee <- object[[1L]]
      long <-
         is.name(callee) &&
         length(object) > 20

      if (long)
         return(as.call(list(callee, quote(...))))

      # sanitize each call entry separately
      for (i in seq_along(object))
      {
         # assigning NULL to object will remove that entry
         # https://github.com/rstudio/rstudio/issues/9299
         sanitized <- .rs.sanitizeCall(object[[i]])
         if (!missing(sanitized) && !is.null(sanitized))
            object[[i]] <- sanitized
      }

      # return object
      object
   }
   else if (is.pairlist(object))
   {
      # handle pairlists specially, primarily because they're
      # used directly within function calls
      object
   }
   else if (!is.language(object))
   {
      # if the object would be very expensive to deparse,
      # just use a placeholder instead
      #
      # note that we still want to accept literals here,
      # e.g. 42, "abc"
      if (!is.object(object) && length(object) == 1)
      {
         object
      }
      else
      {
         type <- .rs.explorer.objectType(object)
         as.name(sprintf("<%s>", type))
      }
   }
   else
   {
      object
   }
})

.rs.addFunction("callSummary", function(val)
{
   call <- .rs.nullCoalesce(
      attr(val, "_rs_call", exact = TRUE),
      val
   )

   # some calls might be very large when deparsed, especially when
   # they include R objects which have already been evaluated. this
   # happens most often with calls like:
   #
   #   do.call("fn", list(object))
   #
   # where 'object' is something very large when deparsed. we avoid
   # issues by replacing such objects with a short identifier of their
   # type / class
   call <- .rs.sanitizeCall(call)

   # deparse call
   .rs.deparse(call)

})

.rs.addFunction("valueDescription", function(obj)
{
   tryCatch(
      .rs.valueDescriptionImpl(obj),
      error = function(e) ""
   )
})

.rs.addFunction("valueDescriptionImpl", function(obj)
{
   if (missing(obj))
   {
      return("Missing argument")
   }
   else if (is.null(obj))
   {
      return("NULL")
   }
   else if (is(obj, "ore.frame"))
   {
      sqlTable <- attr(obj, "sqlTable", exact = TRUE)
      if (is.null(sqlTable))
         return("Oracle R frame")
      else
         return(paste("Oracle R frame:", sqlTable))
   }
   else if (.rs.isExternalPointer(obj))
   {
      class <- class(obj)
      if (length(class) && !identical(class, "externalptr"))
      {
         fmt <- "External pointer of class '%s'"
         return(sprintf(fmt, class[[1]]))
      }
      else
      {
         return("External pointer")
      }
   }
   else if (is.data.frame(obj))
   {
      # use .row_names_info() to avoid materializing altrep vectors
      # https://github.com/rstudio/rstudio/issues/13540
      dims <- .Call("rs_dim", obj, PACKAGE = "(embedding)")
      if (is.null(dims))
         dims <- c(-1L, -1L)

      # extract rows, columns
      nr <- dims[[1L]]
      nc <- dims[[2L]]

      # build message
      msg <- sprintf(
         "%s obs. of %s %s",
         if (is.na(nr) || nr < 0L) "??" else as.character(nr),
         if (is.na(nc) || nc < 0L) "??" else as.character(nc),
         if (!is.na(nc) && nc != 1L) "variables" else "variable"
      )

      return(msg)
   }
   else if (is.environment(obj))
   {
      return("Environment")
   }
   else if (isS4(obj))
   {
      return(paste("Formal class ", is(obj)))
   }
   else if (is.list(obj))
   {
      return(paste("List of ", length(obj)))
   }
   else if (is.matrix(obj)
            || is.numeric(obj)
            || is.factor(obj)
            || is.raw(obj)
            || is.character(obj)
            || is.logical(obj))
   {
      return(.rs.valueFromStr(obj))
   }
   else
   {
      return("")
   }
})

.rs.addFunction("editor", function(name, file = "", title = file, ...)
{
   # if 'name' is missing, we're likely being invoked by
   # 'utils::file.edit()', so just edit the requested file
   if (missing(name) || is.null(name))
      return(.Call("rs_editFile", file, PACKAGE = "(embedding)"))

   # otherwise, we're more likely being invoked by 'edit()', which
   # requires the parsed file to be valid R code -- so handle that

   # if no file has been supplied, generate one for the user
   if (is.null(file) || !nzchar(file)) {
      file <- tempfile("rstudio-scratch-", fileext = ".R")
      on.exit(unlink(file), add = TRUE)
   }

   # write deparsed R object to file
   deparsed <- if (is.function(name))
      .rs.deparseFunction(name, useSource = TRUE, asString = FALSE)
   else
      deparse(name)
   writeLines(deparsed, con = file)

   # invoke edit
   .Call("rs_editFile", file, PACKAGE = "(embedding)")

   # attempt to parse-eval the generated content
   eval(parse(file), envir = globalenv())

})

.rs.addFunction("registerFunctionEditor", function()
{
   options(editor = .rs.editor)
})


.rs.addFunction("getSingleClass", function(obj)
{
   class(obj)[[1L]]
})

.rs.addFunction("describeCall", function(call)
{
   # defend against very large calls; e.g. those with R objects inlined
   # as part of the call (can happen in do.call contexts)
   #
   # this is primarily used for the Environment pane, where we try to display
   # a single-line summary of an R object -- so we can enforce that when
   # deparsing calls here as well
   #
   # https://github.com/rstudio/rstudio/issues/5158
   sanitized <- .rs.sanitizeCall(call)
   val1 <- .rs.deparse(sanitized, nlines = 1L)
   val2 <- .rs.deparse(sanitized, nlines = 2L)

   # indicate if there is more output
   val <- if (!identical(val1, val2))
      paste(val1, "<...>")
   else
      val1
})

.rs.addFunction("describeObject", function(objName, env)
{
   obj <- get(objName, env)

   # https://github.com/rstudio/rstudio/issues/9328
   if (missing(obj))
      obj <- as.name("Missing argument")

   # For S4 objects whose defining package isn't loaded, operations like
   # inherits(), length(), is(), and str() can trigger S4 method dispatch,
   # which calls .requirePackage() to load the package namespace and its
   # native DLL. If the DLL is broken or missing, this can crash the R
   # session at the OS level (e.g. STATUS_ENTRYPOINT_NOT_FOUND on Windows)
   # in a way that R's error handling cannot intercept. Return a safe
   # minimal description that avoids any S4-dispatching operations.
   # NOTE: This must come before any call that could dispatch on the object
   # (including inherits()).
   # https://github.com/rstudio/rstudio/issues/17353
   if (.rs.isUnloadedS4(obj))
   {
      cls <- class(obj)
      pkg <- attr(cls, "package")
      desc <- sprintf("Formal class '%s' [package \"%s\" not loaded]", cls[[1L]], pkg)
      return(list(
         name              = .rs.scalar(objName),
         type              = .rs.scalar(cls[[1L]]),
         clazz             = c(cls, typeof(obj)),
         is_data           = .rs.scalar(FALSE),
         value             = .rs.scalar(desc),
         description       = .rs.scalar(desc),
         size              = .rs.scalar(0L),
         is_size_estimated = .rs.scalar(FALSE),
         length            = .rs.scalar(0L),
         contents          = list(),
         contents_deferred = .rs.scalar(FALSE)
      ))
   }

   if (inherits(obj, "python.builtin.object"))
      return(.rs.reticulate.describeObject(objName, env))

   val <- "(unknown)"
   desc <- ""

   # some objects (e.g. ALTREP) have compact representations that are forced to materialize if
   # an attempt is made to compute their metrics exactly; avoid computing the size for these
   size <- .rs.estimatedObjectSize(obj)
   len <- length(obj)

   class <- .rs.getSingleClass(obj)
   contents <- list()
   contents_deferred <- FALSE
   is_size_estimated <- FALSE

   # for language objects, don't evaluate, just show the expression
   if (is.symbol(obj))
   {
      val <- as.character(obj)
   }
   else if (is.language(obj))
   {
      val <- .rs.describeCall(obj)
   }
   else
   {
      # for large objects (> half MB), don't try to get the value, just show
      # the size. Some functions (e.g. str()) can cause the object to be
      # copied, which is slow for large objects.
      if (size > 524288)
      {
         len_desc <- if (len > 1)
         {
            paste(len, "elements, ")
         }
         else
         {
            ""
         }

         # data frames are likely to be large, but a summary is still helpful
         if (is.data.frame(obj))
         {
            val <- "NO_VALUE"
            desc <- .rs.valueDescription(obj)
         }
         else
         {
            is_size_estimated <- identical(attr(size, "estimate"), TRUE)
            size_formatted <- format(size, units = "auto", standard = "SI")
            if (is_size_estimated)
               size_formatted <- paste(">", size_formatted)

            fmt <- "Large %s (%s%s)"
            val <- sprintf(fmt, class, len_desc, size_formatted)
         }
         contents_deferred <- TRUE
      }
      else
      {
         val <- .rs.valueAsString(obj)
         desc <- .rs.valueDescription(obj)

         # expandable object--supply contents
         if (is.list(obj) || is.data.frame(obj) || isS4(obj) ||
             inherits(obj, c("data.table", "ore.frame", "cast_df", "xts", "DataFrame")))
         {
            if (.rs.hasAltrep(obj))
            {
               # don't prefetch content for altreps
               val <- "NO_VALUE"
               contents_deferred <- TRUE
            }
            else
            {
               # normal object -- disable the debugger to prevent recursive
               # debugger invocations when str() dispatches to user S3 methods
               # https://github.com/rstudio/rstudio/issues/16987
               contents <- .rs.withDebuggerDisabled(.rs.valueContents(obj))
            }
         }
      }
   }

   list(
      name              = .rs.scalar(objName),
      type              = .rs.scalar(class),
      clazz             = c(class(obj), typeof(obj)),
      is_data           = .rs.scalar(is.data.frame(obj)),
      value             = .rs.scalar(val),
      description       = .rs.scalar(desc),
      size              = .rs.scalar(size),
      is_size_estimated = .rs.scalar(is_size_estimated),
      length            = .rs.scalar(len),
      contents          = contents,
      contents_deferred = .rs.scalar(contents_deferred)
   )

})

# returns the name and frame number of an environment from a call frame
.rs.addFunction("environmentCallFrameName", function(env)
{
   numCalls <- length(sys.calls())
   result <- list()
   for (i in 1:numCalls)
   {
      if (identical(sys.frame(i), env))
      {
         calldesc <- paste(deparse(sys.call(i)[[1]]), "()", sep="")
         result <- list(name = .rs.scalar(calldesc),
                        frame = .rs.scalar(i),
                        local = .rs.scalar(TRUE))
         break
      }
   }
   if (identical(result, list()))
      list(name = .rs.scalar("unknown"), frame = .rs.scalar(0L))
   else
      result
})

# indicate whether the given environment is local (i.e. it comes before the
# global environment in the search path)
.rs.addFunction("environmentIsLocal", function(env)
{
   while (!identical(env, emptyenv()))
   {
      # if one of this environment's parents is the global environment, it's
      # local
      env = parent.env(env)
      if (identical(env, globalenv()))
         return(TRUE)
   }
   return(FALSE)
})

.rs.addFunction("environmentName", function(env)
{
   # global environment
   if (identical(env, globalenv()))
     return(".GlobalEnv")

   # base environment
   if (identical(env, baseenv()))
     return("package:base")

   # look for the environment's given name; if it doesn't have a name, check
   # the callstack to see if it matches the environment in one of the call
   # frames.
   result <- environmentName(env)

   if (nchar(result) == 0)
      .rs.environmentCallFrameName(env)$name
   else
   {
      # resolve namespaces
      if ((result %in% loadedNamespaces()) &&
          identical(asNamespace(result), env))
         paste("namespace:", result, sep = "")
      else
         result
   }
})

.rs.addFunction("environmentList", function(startEnv)
{
   env <- startEnv
   envs <- list()
   local <- TRUE
   # if starting above the global environment, the environments will be
   # unnamed. to provide sensible names for them, look for a matching frame in
   # the callstack.
   if (!identical(env, globalenv()))
   {
      while (!identical(env, globalenv()) &&
             !identical(env, emptyenv()))
      {
         frame <- .rs.environmentCallFrameName(env)
         # if this frame is from the callstack, store it and proceed
         if (frame$frame > 0)
         {
            envs[[length(envs) + 1]] <- frame
            env <- parent.env(env)
         }
         # otherwise, stop here and get names normally
         else
         {
            break
         }
      }
   }
   # we're now past the call-frame portion of the stack; proceed normally
   # through the rest of the search path.
   while (!identical(env, emptyenv()))
   {
      # mark all environments as local until we reach the global
      # environment
      if (identical(env, globalenv()))
         local <- FALSE

      envName <- environmentName(env)

      # hide the RStudio internal tools environment and the autoloads
      # environment, and any environment that doesn't have a name
      if (nzchar(envName) && !envName %in% c("tools:rstudio", "Autoloads"))
      {
         envs[[length(envs) + 1]] <- list(
            name = .rs.scalar(envName),
            frame = .rs.scalar(0L),
            local = .rs.scalar(local)
         )
      }
      env <- parent.env(env)
   }
   envs
})

.rs.addFunction("removeObjects", function(objNames, env)
{
   objects <- unlist(objNames)
   rm(list = objects, envir = env)
})

.rs.addFunction("removeAllObjects", function(includeHidden, env)
{
   objects <- ls(envir = env, all.names = includeHidden)
   rm(list = objects, envir = env)
})

.rs.addFunction("getObjectContents", function(objName, env)
{
   object <- get(objName, envir = env)

   # Guard against S4 objects whose defining package isn't loaded.
   # See the parallel guard in .rs.describeObject() for details.
   # https://github.com/rstudio/rstudio/issues/17353
   if (.rs.isUnloadedS4(object))
      return(list())

   .rs.withDebuggerDisabled(.rs.valueContents(object))
})

# Check if an object is an S4 instance whose defining package namespace
# is not currently loaded. Operations on such objects (length(), str(), etc.)
# can trigger namespace loading and crash the session if the package's native
# DLL is broken or missing. https://github.com/rstudio/rstudio/issues/17353
.rs.addFunction("isUnloadedS4", function(obj)
{
   if (!isS4(obj))
      return(FALSE)

   cls <- class(obj)
   pkg <- attr(cls, "package")

   is.character(pkg) &&
      length(pkg) == 1L &&
      !is.na(pkg) &&
      nzchar(pkg) &&
      !identical(pkg, ".GlobalEnv") &&
      !isNamespaceLoaded(pkg)
})

.rs.addFunction("isAltrep", function(var)
{
   .Call("rs_isAltrep", var, PACKAGE = "(embedding)")
})

.rs.addFunction("hasAltrep", function(var)
{
   .Call("rs_hasAltrep", var, PACKAGE = "(embedding)")
})

.rs.addFunction("resolveContextSourceRefs", function(callfun)
{
   calls <- sys.calls()

   for (i in seq_along(calls))
   {
      fn <- sys.function(i)
      if (identical(fn, callfun))
      {
         srcref <- attr(calls[[i]], "srcref", exact = TRUE)
         return(srcref)
      }
   }

   NULL

})

.rs.addFunction("environment.isSerializable", function()
{
   tryCatch(
      .rs.environment.isSerializableImpl(globalenv(), 1L),
      error = function(e) TRUE
   )
})

.rs.addFunction("environment.isSerializableImpl", function(value, depth)
{
   # Avoid overly-deep recursions.
   if (depth >= 8L)
      return(TRUE)

   # Skip overly-large objects.
   n <- length(value)
   if (isTRUE(n >= 10000L))
      return(TRUE)

   # Objects containing external pointers cannot be serialized.
   if (typeof(value) %in% c("externalptr", "weakref"))
      return(FALSE)

   # Check for 'known-safe' object classes.
   if (inherits(value, c("data.frame", "igraph")))
      return(TRUE)

   # Check for 'known-unsafe' object classes.
   if (inherits(value, c("ArrowObject", "DBIConnection", "python.builtin.object")))
       return(FALSE)

   # Iterate through other recursive objects.
   if (is.environment(value)) {
      keys <- ls(envir = value, all.names = TRUE)
      for (key in keys) {
         if (!.rs.environment.isSerializableImpl(value[[key]], depth + 1L)) {
            return(FALSE)
         }
      }
   } else if (is.recursive(value)) {
      for (i in seq_along(value)) {
         if (!.rs.environment.isSerializableImpl(value[[i]], depth + 1L)) {
            return(FALSE)
         }
      }
   }

   # Assume that other kinds of objects can be restored.
   TRUE
})

.rs.addFunction("objectSize", function(object)
{
   envir <- parent.frame()
   result <- .Call("rs_objectSize", object, envir, PACKAGE = "(embedding)")
   class(result) <- "object_size"
   result
})

.rs.addFunction("computeNodeSize", function()
{
   as.integer(utils::object.size(quote(expr = )))
})

.rs.addFunction("computeVectorSize", function()
{
   as.integer(utils::object.size(logical()))
})

.rs.addFunction("estimatedObjectSize", function(x)
{
   # avoid invoking object.size() on large character vectors,
   # as this can be slow
   n <- 1E5
   if (is.character(x) && length(unclass(x)) >= n)
   {
      result <- n * .Machine$sizeof.pointer
      class(result) <- "object_size"
      attr(result, "estimate") <- TRUE
      return(result)
   }

   .rs.objectSize(x)
})

# Find the function context for the browser, or at a given depth.
#
# When depth == 0 (BROWSER_FUNCTION), finds the outermost function whose
# execution environment matches the browser's environment (from C++).
# When depth > 0, finds the function at the given depth (inner->outer numbering).
#
# Returns list(depth, env) where depth is the inner->outer depth and
# env is the function's closure environment, or list(0, globalenv()) if
# no matching context was found.
# Capture the current environment at the browser prompt. This function
# is injected into the browser REPL by RReadConsole so that it is
# evaluated by R in the browser's evaluation environment (rho).
# parent.frame() then returns that environment, which is the function
# being debugged. The result is stored via .Call for C++ to read.
.rs.addFunction("captureCurrentEnvironment", function()
{
   invisible(.Call("rs_setCapturedBrowserEnv", parent.frame(), PACKAGE = "(embedding)"))
})

#
# @param depth When 0, find the function context associated with the
#   active browser. When > 0, find the function context at the given
#   inner-to-outer depth.
# @param browserEnv The browser context's closure environment, captured
#   by .rs.captureCurrentEnvironment() which runs in the browser REPL.
#   NULL when not browsing.
.rs.addFunction("getFunctionContext", function(depth = 0L, browserEnv = NULL)
{
   nframe <- sys.nframe() - 1L  # skip our own frame
   if (nframe < 1L)
      return(list(depth = 0L, env = globalenv()))

   foundDepth <- 0L
   foundEnv <- globalenv()

   # Iterate inner-to-outer (matching C++ RCNTXT convention)
   contextDepth <- 0L
   for (i in rev(seq_len(nframe)))
   {
      contextDepth <- contextDepth + 1L
      cloenv <- sys.frame(i)

      if (depth == 0L)
      {
         # BROWSER_FUNCTION mode: find the outermost function whose
         # environment matches the browser's environment
         if (!is.null(browserEnv) && identical(cloenv, browserEnv))
         {
            foundDepth <- contextDepth
            foundEnv <- cloenv
            # keep going -- we want the outermost match
         }
      }
      else if (contextDepth >= depth)
      {
         foundDepth <- contextDepth
         foundEnv <- cloenv
         break
      }
   }

   list(depth = foundDepth, env = foundEnv)
})

# Check if the topmost function on the call stack has the hideFromDebugger
# attribute, indicating it's a debugger-internal function.
.rs.addFunction("inDebugHiddenContext", function()
{
   nframe <- sys.nframe() - 1L  # skip our own frame
   if (nframe < 1L)
      return(FALSE)

   # Walk inner-to-outer looking for the first function context
   for (i in rev(seq_len(nframe)))
   {
      fn <- sys.function(i)

      # If we find a debugger internal function before any user function,
      # hide it from the user callstack.
      if (isTRUE(attr(fn, "hideFromDebugger", exact = TRUE)))
         return(TRUE)

      # If we find a function with source refs (user code), don't hide
      origFn <- .rs.originalFunction(fn)
      if (!is.null(attr(origFn, "srcref", exact = TRUE)))
         return(FALSE)
   }

   FALSE
})

# Helper: get the "original" function, unwrapping S4 trace wrappers
.rs.addFunction("originalFunction", function(fn)
{
   if (isS4(fn))
   {
      orig <- attr(fn, "original")
      if (!is.null(orig)) return(orig)
   }
   fn
})

# Helper: check if a srcref is valid (not NULL, not a symbol like <in-bc-interp>)
.rs.addFunction("isValidSrcref", function(srcref)
{
   !is.null(srcref) && is.integer(srcref)
})

# Helper: resolve source references, handling byte-code compiled contexts.
# For byte-compiled code, the srcref on the call may be the symbol
# <in-bc-interp> rather than a real srcref. In that case, we try to find
# the real srcref by matching the function against the call stack.
.rs.addFunction("resolveCallSrcref", function(callSrcref, callfun)
{
   if (.rs.isValidSrcref(callSrcref))
      return(callSrcref)

   # check for byte-code srcref (a symbol rather than integer vector)
   if (!is.symbol(callSrcref))
      return(NULL)

   # try to resolve via .rs.resolveContextSourceRefs
   tryCatch(
      .rs.resolveContextSourceRefs(callfun),
      error = function(e) NULL
   )
})

# Helper: extract source reference fields as a named list
.rs.addFunction("srcrefData", function(srcref)
{
   if (.rs.isValidSrcref(srcref))
   {
      list(
         line_number          = srcref[1L],
         end_line_number      = srcref[3L],
         character_number     = srcref[5L],
         end_character_number = srcref[6L]
      )
   }
   else
   {
      list(
         line_number          = 0L,
         end_line_number      = 0L,
         character_number     = 0L,
         end_character_number = 0L
      )
   }
})

# Build call frame information for the debugger using sys.*() functions.
#
# This replaces the C++ callFramesAsJson() which walked the RCNTXT linked list.
#
# @param targetDepth The function-context depth of interest (1-based).
#   The function/source context at this depth are returned separately for
#   further introspection by the caller.
# @param lineDebugState A list with 'lastDebugText' and 'lastDebugLine',
#   or NULL if not available.
#
# @return A list with components:
#   - frames: a list of frame descriptor lists (one per function context)
#   - context_callfun: the callfun at targetDepth (or NULL)
#   - context_cloenv: the cloenv at targetDepth (or NULL)
#   - src_context_callfun: the source context's callfun at targetDepth (or NULL)
#   - src_context_call: the source context's call at targetDepth (or NULL)
.rs.addFunction("callFrames", function(targetDepth = 0L,
                                       lineDebugState = NULL,
                                       currentSrcref = NULL)
{
   # Exclude our own frame(s) from the stack. When called from C++ via
   # r::exec::RFunction, our frame is at sys.nframe(). We want only the
   # frames that existed before this call.
   ownFrame <- sys.nframe()
   nframe <- ownFrame - 1L

   if (nframe < 1L)
   {
      return(list(frames = list(), context = NULL, src_context = NULL))
   }

   # sys.parents() and sys.calls() include our own frame; we subset below.
   parents <- sys.parents()[seq_len(nframe)]
   calls   <- sys.calls()[seq_len(nframe)]

   # -- Phase 1: collect srcref-to-environment mapping --
   # For each frame i with a valid srcref, map it to the parent frame's
   # environment. This tells us "where in the parent's code was frame i called?"
   # We iterate inner-to-outer so the first-match-wins policy selects the
   # innermost (most current/specific) srcref, matching the old C++ behavior.
   envSrcrefMap <- new.env(parent = emptyenv())

   for (i in rev(seq_len(nframe)))
   {
      callSrcref <- attr(calls[[i]], "srcref", exact = TRUE)
      callfun <- sys.function(i)
      srcref <- .rs.resolveCallSrcref(callSrcref, callfun)
      if (is.null(srcref))
         next

      p <- parents[i]
      if (p == 0L)
         next

      parentEnv <- sys.frame(p)
      key <- format(parentEnv)
      if (is.null(envSrcrefMap[[key]]))
      {
         envSrcrefMap[[key]] <- list(srcref = srcref, callfun = callfun, call = calls[[i]])
      }
   }

   # -- Phase 2: detect browser context --
   # The browser environment is tracked by C++ (set from onConsolePrompt
   # via getFunctionContext). We read it via .Call because during promise
   # forcing, the browser's environment may not correspond to any
   # sys.frame() visible from R.
   browserCloenv <- .Call("rs_getBrowserEnv", PACKAGE = "(embedding)")
   browserUsed <- FALSE

   # -- Phase 3: build frame descriptors --
   # Iterate from innermost to outermost frame to match the C++ convention
   # where the RCNTXT walk starts at R_GlobalContext (innermost) and goes
   # outward. This means depth 1 = innermost function context.
   frames <- vector("list", nframe)
   contextDepth <- 0L

   resultContext <- NULL
   resultSrcContext <- NULL
   updatedLastDebugLine <- NULL

   for (i in rev(seq_len(nframe)))
   {
      callfun <- sys.function(i)
      cloenv  <- sys.frame(i)
      call    <- calls[[i]]

      contextDepth <- contextDepth + 1L
      origFun <- .rs.originalFunction(callfun)

      # Function name
      functionName <- tryCatch(
         .rs.functionNameFromCall(call),
         error = function(e) ""
      )

      # Error handler / debug hidden checks (attribute-based)
      isErrorHandler <- !is.null(attr(origFun, "errorHandlerType", exact = TRUE))
      isHidden <- isTRUE(attr(origFun, "hideFromDebugger", exact = TRUE))

      # Shiny function label
      shinyLabel <- attr(origFun, "_rs_shinyDebugLabel", exact = TRUE)
      if (is.null(shinyLabel)) shinyLabel <- ""

      # Source reference resolution:
      # For the innermost frame (contextDepth == 1), use the runtime srcref
      # passed from C++ (R_GetCurrentSrcref), which reflects the evaluator's
      # current position inside the function. For outer frames, use the
      # envSrcrefMap which maps each frame's env to the srcref of the call
      # made from that frame (set by the next-inner frame's call srcref).
      if (contextDepth == 1L && .rs.isValidSrcref(currentSrcref))
      {
         srcContext <- list(srcref = currentSrcref, callfun = callfun, call = call)
      }
      else
      {
         envKey <- format(cloenv)
         mapped <- envSrcrefMap[[envKey]]
         if (!is.null(mapped))
         {
            srcContext <- mapped
         }
         else
         {
            # Fall back to the srcref on this context's own call
            callSrcref <- attr(call, "srcref", exact = TRUE)
            resolved <- .rs.resolveCallSrcref(callSrcref, callfun)
            srcContext <- list(srcref = resolved, callfun = callfun, call = call)
         }
      }

      srcref <- srcContext$srcref
      isRealSrcref <- .rs.isValidSrcref(srcref)
      isSourceEquiv <- identical(cloenv, globalenv()) && isRealSrcref

      # File name from srcref
      fileName <- ""
      if (isRealSrcref)
      {
         fileName <- tryCatch(
            .rs.sourceFileFromRef(srcref),
            error = function(e) ""
         )
      }

      aliasedFileName <- .rs.createAliasedPath(fileName)

      # Source ref data (line/character numbers)
      srcrefInfo <- .rs.srcrefData(srcref)

      # Lines from source (for real srcrefs)
      linesText <- ""
      if (isRealSrcref)
      {
         linesText <- tryCatch(
            .rs.readSrcrefLines(srcref, TRUE),
            error = function(e) ""
         )
      }

      # Simulated source refs (for code without real srcrefs)
      if (!isRealSrcref)
      {
         info <- "_rs_sourceinfo"
         attr(info, "_rs_callfun") <- origFun

         isBrowserFrame <- !is.null(browserCloenv) && !browserUsed &&
             identical(cloenv, browserCloenv)
         if (isBrowserFrame)
         {
            browserUsed <- TRUE
            if (!is.null(lineDebugState))
            {
               attr(info, "_rs_calltext") <- lineDebugState$lastDebugText
               attr(info, "_rs_lastline") <- lineDebugState$lastDebugLine
            }
         }
         else
         {
            # Use the call from the next innermost frame (if any) to locate
            # our position within this function's deparsed body. This matches
            # the old C++ code which iterated inner-to-outer and used
            # prevContext.call() -- the inner frame's call tells us where
            # in the outer function's code execution currently is.
            innerIdx <- i + 1L
            if (innerIdx <= nframe)
            {
               attr(info, "_rs_callobj") <- calls[[innerIdx]]
            }
         }

         simSrcref <- tryCatch(
            .rs.simulateSourceRefs(info),
            error = function(e) c(0L, 0L, 0L, 0L, 0L, 0L)
         )

         # Update lastDebugLine for the browser frame (propagated back to C++)
         if (isBrowserFrame && .rs.isValidSrcref(simSrcref))
         {
            updatedLastDebugLine <- simSrcref[1L] - 1L
         }

         srcrefInfo <- .rs.srcrefData(simSrcref)
      }

      # Call summary
      callSummary <- tryCatch(
         .rs.callSummary(call),
         error = function(e) ""
      )

      frame <- c(
         list(
            context_depth          = contextDepth,
            function_name          = functionName,
            is_error_handler       = isErrorHandler,
            is_hidden              = isHidden,
            is_source_equiv        = isSourceEquiv,
            file_name              = fileName,
            aliased_file_name      = aliasedFileName,
            real_sourceref         = isRealSrcref
         ),
         srcrefInfo,
         list(
            lines                  = linesText,
            function_line_number   = 1L,
            call_summary           = callSummary,
            shiny_function_label   = shinyLabel
         )
      )

      frames[[contextDepth]] <- .rs.scalarListFromList(frame)

      # Track the context at the target depth
      if (contextDepth == targetDepth)
      {
         resultContext <- list(
            callfun        = callfun,
            cloenv         = cloenv,
            call           = call,
            functionName   = functionName,
            originalCallfun = origFun,
            hasSourceRefs  = !is.null(attr(origFun, "srcref", exact = TRUE)),
            callFunSourceRefs = attr(origFun, "srcref", exact = TRUE)
         )
         resultSrcContext <- srcContext
      }

   }

   # Trim to actual depth (in case nframe included our own frames)
   frames <- frames[seq_len(contextDepth)]

   list(
      frames             = frames,
      context            = resultContext,
      src_context        = resultSrcContext,
      lastDebugLine      = updatedLastDebugLine
   )
})

#
# SessionClang.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#



.rs.addFunction("clangPCHPath", function(pkg, clangVersion)
{
   paste(
      packageVersion(pkg),
      R.version$platform,
      R.version$`svn rev`,
      clangVersion,
      sep = "-"
   )
})

.rs.addFunction("isClangAvailable", function() {
   cat("Attempting to load libclang for", R.version$platform, "\n")
   .Call("rs_isLibClangAvailable", PACKAGE = "(embedding)")
})

.rs.addFunction("setClangDiagnostics", function(level)
{
   if (!is.numeric(level) || (level < 0) || (level > 3))
      stop("level must be within the range [0, 3]")
   
   if (level > 0)
      .rs.isClangAvailable()
   
   .Call("rs_setClangDiagnostics", level, PACKAGE = "(embedding)")
   
   .rs.restartR()
   invisible(NULL)
})

.rs.addFunction("packagePCH", function(linkingTo)
{
   linkingTo <- .rs.parseLinkingTo(linkingTo)
   packages <- c("RcppArmadillo", "RcppEigen", "Rcpp11", "Rcpp", "cpp11")
   for (package in packages)
      if (package %in% linkingTo)
         return(package)
   ""
})

.rs.addFunction("includesForLinkingTo", function(linkingTo)
{
   includes <- character()
   
   linkingTo <- .rs.parseLinkingTo(linkingTo)
   for (pkg in linkingTo) {
      
      includeDir <- if (identical(pkg, "R"))
         R.home("include")
      else
         system.file("include", package = pkg)
      
      if (file.exists(includeDir)) {
         includes <- c(
            includes,
            paste("-I", .rs.asBuildPath(includeDir), sep = "")
         )
      }
      
   }
   
   includes
})

.rs.addFunction("includesForPackage", function(package)
{
   # find the package path
   pkgPath <- find.package(package, quiet = TRUE)
   if (!file.exists(pkgPath))
      return(.rs.includesForLinkingTo(package))
   
   # read the description file
   desc <- .rs.readPackageDescription(pkgPath)
   if (is.null(desc$LinkingTo))
      return(.rs.includesForLinkingTo(package))
   
   linkingTo <- paste(package, desc$LinkingTo, "R", sep = ", ")
   .rs.includesForLinkingTo(linkingTo)
})

.rs.addFunction("asBuildPath", function(path)
{
   if (.Platform$OS.type == "windows") {
      path <- normalizePath(path)
      if (grepl(' ', path, fixed = TRUE))
         path <- utils::shortPathName(path)
      path <- gsub("\\\\", "/", path)
   }
   
   return(path)
})

# this function can be useful when updating an Rtools definition,
# when you need to determine the default compiler include paths
.rs.addFunction("libclang.defaultCompilerIncludeDirectories", function(compiler = NULL,
                                                                       isCpp = TRUE)
{
   # put rtools on PATH for windows
   if (.rs.platform.isWindows)
   {
      path <- Sys.getenv("PATH")
      on.exit(Sys.setenv(PATH = path), add = TRUE)
      .rs.addRToolsToPath()
   }
   
   if (is.null(compiler))
   {
      # if compiler is not set, then use the default C++ compiler
      exe <- if (.rs.platform.isWindows) "R.exe" else "R"
      R <- file.path(R.home("bin"), exe)
      compiler <- if (isCpp) "CXX" else "CC"
      cxx <- system2(R, c("CMD", "config", compiler), stdout = TRUE, stderr = TRUE)
      
      # take only last line, in case R or the compiler spat out other output
      compiler <- tail(cxx, n = 1L)
   }
   
   # create a dummy c++ file
   file <- tempfile(fileext = if (isCpp) ".cpp" else ".c")
   writeLines("void test() {}", con = file)
   
   # build a command for printing compiler include paths
   command <- paste(compiler, "-E -v", basename(file))
   
   # run it
   output <- local({
      owd <- setwd(tempdir())
      on.exit(setwd(owd), add = TRUE)
      suppressWarnings(system(command, intern = TRUE))
   })
   
   # find the lines of interest
   start <- grep("#include <...> search starts here:", output)
   end <- grep("End of search list.", output)
   if (length(start) == 0L || length(end) == 0L)
   {
      .rs.logWarningMessage("couldn't determine compiler search list")
      return(character())
   }
   
   lines <- output[(start + 1L):(end - 1L)]
   
   # trim and normalize paths
   paths <- .rs.trimWhitespace(lines)
   normalizePath(paths, winslash = "/", mustWork = FALSE)
})

.rs.addFunction("libclang.generateCompilerDefinitions", function(path, isCpp = TRUE)
{
   # put rtools on PATH for windows
   if (.rs.platform.isWindows)
   {
      envpath <- Sys.getenv("PATH")
      on.exit(Sys.setenv(PATH = envpath), add = TRUE)
      .rs.addRToolsToPath()
   }

   # use the default compiler configured by R   
   exe <- if (.rs.platform.isWindows) "R.exe" else "R"
   R <- file.path(R.home("bin"), exe)
   args <- c("CMD", "config", if (isCpp) "CXX" else "CC")
   output <- system2(R, args, stdout = TRUE, stderr = TRUE)
   
   # take only last line, in case R or the compiler spat out other output
   compiler <- tail(output, n = 1L)
   
   # on Windows, with Rtools40, the path to the compiler is only valid
   # within an MinGW shell; we work around this by just replacing the compiler
   # path with the "real" path
   if (.rs.platform.isWindows &&
       getRversion() >= "4.0.0" &&
       getRversion() < "4.2.0" &&
       (.rs.startsWith(compiler, "/mingw32/bin") ||
        .rs.startsWith(compiler, "/mingw64/bin")))
   {
      for (root in c("C:/rtools40", "C:/RBuildTools/4.0"))
      {
         if (file.exists(root))
         {
            compiler <- paste0(root, compiler)
            break
         }
      }
   }
   
   # create a dummy c++ file
   file <- tempfile(fileext = if (isCpp) ".cpp" else ".c")
   writeLines("void test() {}", con = file)
   
   # build a command for printing compiler definitions
   command <- paste(compiler, "-dM -E", basename(file))
   
   # run it
   output <- .rs.tryCatch({
      owd <- setwd(tempdir())
      on.exit(setwd(owd), add = TRUE)
      suppressWarnings(system(command, intern = TRUE))
   })
   
   # if an error occurs, then nothing to do
   if (inherits(output, "error"))
      return()
   
   # for each line, only define if it's not already defined
   formatted <- unlist(lapply(output, function(line) {
      parts <- strsplit(line, "\\s+", perl = TRUE)[[1L]]
      fmt <- "#ifndef %s\n%s\n#endif\n"
      msg <- sprintf(fmt, gsub("\\(.*", "", parts[[2L]]), line)
      gsub("#define", "# define", msg)
   }))
   
   # libclang doesn't seem to support __float128 with a Windows target,
   # even though gcc does -- either way, remove this define so that we
   # don't get (hopefully spurious) libclang warnings
   if (.rs.platform.isWindows && isCpp)
   {
      formatted <- c(
         "#include <bits/c++config.h>",
         "",
         formatted,
         "",
         "#undef _GLIBCXX_USE_FLOAT128"
      )
   }
   
   # dump it to file
   dir.create(dirname(path), showWarnings = FALSE, recursive = TRUE)
   writeLines(formatted, con = path)
   
   # return path
   normalizePath(path)
   
})

#
# NotebookData.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("dataCaptureOverrides", function(outputFolder, libraryFolder)
{
  defaultOverride <- function(x, options) list(x = x, options = options, className = class(x), nRow = .rs.scalar(nrow(x)), nCol = .rs.scalar(ncol(x)))
  c(
    "print.data.frame" = defaultOverride,
    "print.tbl_df"     = defaultOverride,
    "print.paged_df"   = defaultOverride,
    "print.grouped_df" = defaultOverride,
    "print.rowwise_df" = defaultOverride,
    "print.tbl_sql"    = defaultOverride,
    "print.data.table" = function(x, options) {
      shouldPrintTable <- TRUE

      if ("data.table" %in% loadedNamespaces() &&
          exists("shouldPrint", envir = asNamespace("data.table")))
      {
        shouldPrint <- get("shouldPrint", envir = asNamespace("data.table"))
        shouldPrintTable <- tryCatch(
          shouldPrint(x) || !inherits(x, "data.table"),
          error = function(e) TRUE
        )
      }

      if (!shouldPrintTable) {
        return(NULL)
      }

      list(x = x, options = options, className = class(x), nRow = .rs.scalar(nrow(x)), nCol = .rs.scalar(ncol(x)))
    },
    "print.tbl_lazy" = function(x, options) {
      tblLazyData <- lapply(dplyr::tbl_vars(x), function(e) character(0))
      names(tblLazyData) <- dplyr::tbl_vars(x)
      lazyFrame <- do.call("data.frame", tblLazyData)

      list(
        x = lazyFrame,
        options = options,
        className = class(x),
        nRow = "?",
        nCol = "?"
      )
    }

  )
})

.rs.addFunction("initDataCapture", function(outputFolder, options)
{
  pagedOption <- if (!is.null(options[["paged.print"]])) options[["paged.print"]] else getOption("paged.print")
  if (identical(pagedOption, FALSE)) {
    return()
  }

  overridePrint <- function(x, options, className, nRow, nCol) {
    original <- x
    options <- if (is.null(options)) list() else options
    
    optionRowNames <- options[["rownames.print"]]
    options[["rownames.print"]] <- if (is.null(optionRowNames)) (.row_names_info(x, type = 1) > 0) else optionRowNames
    options[["rows.total"]] <- nrow(x)
    options[["cols.total"]] <- ncol(x)

    output <- tempfile(pattern = "_rs_rdf_", tmpdir = outputFolder, 
                       fileext = ".rdf")

    max.print <- if (is.null(options$max.print)) getOption("max.print", 1000) else options$max.print

    cols.max.print <- if (is.null(options$cols.max.print)) getOption("cols.max.print", 1000) else options$cols.max.print
    if (NCOL(x) > cols.max.print) {
      x <- x[,c(1:cols.max.print)]
    }

    x <- as.data.frame(head(x, max.print))

    save(
      x,
      options,
      file = output)

    # standard metadata
    metadata <- list(classes = className, nrow = nRow, ncol = nCol, summary = list())

    # if tibble is loaded, use it to create a summary of the object
    if ("tibble" %in% loadedNamespaces())
    {
       metadata$summary <- as.list(tibble::tbl_sum(original))
    }

    .Call("rs_recordData", output, metadata, PACKAGE = "(embedding)")
    invisible(original)
  }

  overrides <- .rs.dataCaptureOverrides()
  lapply(names(overrides), function(overrideName) {
    overrideMap <- overrides[[overrideName]]
    overrideFun <- function(x, ...) {
        o <- overrideMap(x, options)
        if (!is.null(o)) {
          overridePrint(o$x, o$options, o$className, o$nRow, o$nCol)
        }
      }
     .rs.addS3Override(overrideName, overrideFun)
  })

  assign(
    "dplyr_tibble_print_original",
    getOption("dplyr.tibble.print"),
    envir = as.environment("tools:rstudio")
  )

  options("dplyr.tibble.print" = function(x, n, width, ...) {
    isSQL <- "tbl_sql" %in% class(x)
    n <- if (isSQL) getOption("sql.max.print", 1000) else getOption("max.print", 1000)

    print(as.data.frame(head(x, n)))
  })

  .rs.addS3Override("print.knitr_kable", function(x, ...) {
    print(
      knitr::asis_output(x)
    )
    invisible(x)
  })
})

.rs.addFunction("releaseDataCapture", function()
{
  if (!is.null(getOption("dplyr_tibble_print_original"))) {
    options(
      "dplyr.tibble.print" = get(
        "dplyr_tibble_print_original",
        envir = as.environment("tools:rstudio")
      )
    )
  }

  overrides <- .rs.dataCaptureOverrides()
  lapply(names(overrides), function(override) {
    .rs.removeS3Override(override)
  })
  .rs.removeS3Override("print.knitr_kable")
})

.rs.addFunction("readDataCapture", function(path)
{
  type_sum <- function(x) {
    format_sum <- switch (class(x)[[1]],
                          ordered = "ord",
                          factor = "fctr",
                          POSIXt = "dttm",
                          difftime = "time",
                          Date = "date",
                          data.frame = class(x)[[1]],
                          tbl_df = "tibble",
                          NULL
    )
    if (!is.null(format_sum)) {
      format_sum
    } else if (!is.object(x)) {
      switch(typeof(x),
             logical = "lgl",
             integer = "int",
             double = "dbl",
             character = "chr",
             complex = "cplx",
             closure = "fun",
             environment = "env",
             typeof(x)
      )
    } else if (!isS4(x)) {
      paste0("S3: ", class(x)[[1]])
    } else {
      paste0("S4: ", methods::is(x)[[1]])
    }
  }

  "%||%" <- function(x, y) {
    if(is.null(x)) y else x
  }

  big_mark <- function(x, ...) {
    mark <- if (identical(getOption("OutDec"), ",")) "." else ","
    formatC(x, big.mark = mark, ...)
  }

  dim_desc <- function(x) {
    dim <- dim(x) %||% length(x)
    format_dim <- vapply(dim, big_mark, character(1))
    format_dim[is.na(dim)] <- "??"
    paste0(format_dim, collapse = " \u00d7 ")
  }

  is_atomic <- function(x) {
    is.atomic(x) && !is.null(x)
  }

  is_vector <- function(x) {
    is_atomic(x) || is.list(x)
  }

  paged_table_is_vector_s3 <- function(x) {
    switch(class(x)[[1]],
      ordered = TRUE,
      factor = TRUE,
      Date = TRUE,
      POSIXct = TRUE,
      difftime = TRUE,
      data.frame = TRUE,
      !is.object(x) && is_vector(x))
  }

  size_sum <- function(x) {
    if (!paged_table_is_vector_s3(x)) return("")

    paste0(" [", dim_desc(x), "]" )
  }

  obj_sum.default <- function(x) {
    paste0(type_sum(x), size_sum(x))
  }

  obj_sum <- function(x) {
    switch(class(x)[[1]],
      POSIXlt = rep("POSIXlt", length(x)),
      list = vapply(x, obj_sum.default, character(1L)),
      paste0(type_sum(x), size_sum(x))
    )
  }

  e <- new.env(parent = emptyenv())
  load(file = path, envir = e)
  
  # this works around a strange bug in R 3.5.1 on Windows
  # where output can be mis-encoded after a save / load
  cat(NULL, sep = "")

  data <- head(e$x, getOption("max.print", 1000))
  data <- if (is.null(data)) as.data.frame(list()) else data
  options <- e$options

  columnNames <- names(data)
  columnSequence <- seq_len(ncol(data))
  
  columns <- lapply(
    columnSequence,
    function(columnIdx) {
      column <- data[[columnIdx]]
      baseType <- class(column)[[1]]
      tibbleType <- type_sum(column)

      list(
        label = if (!is.null(columnNames)) columnNames[[columnIdx]] else "",
        name = columnIdx,
        type = tibbleType,
        align = if (baseType == "character" || baseType == "factor") "left" else "right"
      )
    }
  )

  names(data) <- as.character(columnSequence)

  addRowNames = isTRUE(options[["rownames.print"]])
  if (addRowNames) {
    columns <- c(
      list(
        list(
          label = "",
          name = "_rn_",
          type = "",
          align = "left"
        )
      ),
      columns
    )

    data$`_rn_` <- rownames(data)
  }

  columns <- unname(columns)

  is_list <- vapply(data, is.list, logical(1))
  data[is_list] <- lapply(data[is_list], function(x) {
        summary <- obj_sum(x)
        paste0("<", summary, ">")
      })

  # R 3.6.0 on Windows has an issue where RGui escapes can 'leak'
  # into encoded strings; detect and remove those post-hoc.
  # (should be fixed in R 3.6.1)
  #
  # https://bugs.r-project.org/bugzilla/show_bug.cgi?id=17567
  needsEncodeFix <-
    .Platform$OS.type == "windows" &&
    getRversion() == "3.6.0"
  
  data <- as.data.frame(
    lapply(
      data,
      function (y) {
        
        # escape NAs from character columns
        if (typeof(y) == "character") {
          y[y == "NA"] <- "__NA__"
        }

        # encode string (ensure control characters are escaped)
        y <- encodeString(format(y))
        if (needsEncodeFix) {
          y <- gsub("^\002\377\376", "", y)
          y <- gsub("\003\377\376$", "", y)
        }

        # trim spaces
        gsub("^\\s+|\\s+$", "", y)
      }
    ),
    stringsAsFactors = FALSE,
    optional = TRUE)
  
  pagedTableOptions <- list(
    columns = list(
      min = options[["cols.min.print"]],
      max = if (is.null(options[["cols.print"]])) 10 else options[["cols.print"]],
      total = options[["cols.total"]]
    ),
    rows = list(
      min = if (is.null(options[["rows.print"]])) 10 else options[["rows.print"]],
      max = if (is.null(options[["rows.print"]])) 10 else options[["rows.print"]],
      total = options[["rows.total"]]
    ),
    pages = options[["pages.print"]]
  )

  list(
    columns = columns,
    data = if (length(data) == 0) list() else data,
    options = pagedTableOptions
  )
})

.rs.addFunction("runSqlForDataCapture", function(sql, outputFile, options)
{
  is_sql_update_query <- function(query) {
    # remove line comments
    query <- gsub("^\\s*--.*\n", "", query)

    # remove multi-line comments
    if (grepl("^\\s*\\/\\*.*", query)) {
      query <- gsub(".*\\*\\/", "", query)
    }

    grepl("^\\s*(INSERT|UPDATE|DELETE|CREATE|DROP).*", query, ignore.case = TRUE)
  }

  # precreate directories if needed
  dir.create(dirname(outputFile), recursive = TRUE, showWarnings = FALSE)

  max.print <- if (is.null(options$max.print)) getOption("max.print", 1000) else as.numeric(options$max.print)
  max.print <- if (is.null(options$sql.max.print)) max.print else as.numeric(options$sql.max.print)

  conn <- options$connection
  
  if (is.numeric(options$connection)) {
    chunkReferences <- get(".rs.knitr.chunkReferences", envir = .rs.toolsEnv())
    conn <- chunkReferences[[chunkOptions$connection]]
  }

  if (is.null(conn)) {
    stop("The 'connection' option (DBI connection) is required for sql chunks.")
  }

  if (is.character(options$connection)) {
    conn <- get(options$connection, envir = globalenv())
    if (is.null(conn)) stop(
      "The 'connection' option must be a valid DBI connection."
    )
  }

  # Return char vector of sql interpolation param names
  varnames_from_sql <- function(conn, sql) {
    varPos <- DBI::sqlParseVariables(conn, sql)
    if (length(varPos$start) > 0) {
      varNames <- substring(sql, varPos$start, varPos$end)
      sub("^\\?", "", varNames)
    }
  }

  # Vectorized version of exists
  mexists <- function(x, env = globalenv(), inherits = TRUE) {
    vapply(x, exists, logical(1), where = env, inherits = inherits)
  }

  # Interpolate a sql query based on the variables in an environment
  interpolate_from_env <- function(conn, sql, env = globalenv(), inherits = TRUE) {
    names <- unique(varnames_from_sql(conn, sql))
    names_missing <- names[!mexists(names, env, inherits)]
    if (length(names_missing) > 0) {
      stop("Object(s) not found: ", paste('"', names_missing, '"', collapse = ", "))
    }

    args <- if (length(names) > 0) setNames(
      mget(names, envir = env, inherits = inherits), names
    )

    do.call(DBI::sqlInterpolate, c(list(conn, sql), args))
  }

  # extract options
  varname <- options$output.var

  # execute query -- when we are printing with an enforced max.print we
  # use dbFetch so as to only pull down the required number of records
  query <- interpolate_from_env(conn, sql)
  if (is_sql_update_query(query)) {
    DBI::dbExecute(conn, query)
    data <- NULL
  } else if (is.null(varname) && max.print > 0) {
    res <- DBI::dbSendQuery(conn, query)
    data <- DBI::dbFetch(res, n = max.print)
    DBI::dbClearResult(res)
  } else {
    data <- DBI::dbGetQuery(conn, query)
  }

  # assign varname if requested, otherwise print
  if (!is.null(varname)) {
    assign(varname, data, envir = globalenv())
  }
  else if(!is.null(data)) {
    x <- data
    save(
      x, 
      file = outputFile
    )
  }
})

.rs.addJsonRpcHandler("default_sql_connection_name", function()
{
  dbiClassNames <- lapply(methods::.S4methods("dbGetQuery"), function(methodInfo) {
    methodInfoSplit <- strsplit(methodInfo, split = ",")[[1]]
    methodInfoSplit[[2]]
  })

  dbiObjectNames <- Filter(function(objName) {
    any(class(get(objName, envir = globalenv())) %in% dbiClassNames)
  }, ls(envir = globalenv()))

  if (length(dbiObjectNames) > 0) .rs.scalar(dbiObjectNames[[1]]) else NULL
})

#
# SessionPatches.R
#
# Copyright (C) 2009-17 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

setHook(
   packageEvent("rstudioapi", "onLoad"),
   function(...) {

      # bail if we're not version 0.7
      if (packageVersion("rstudioapi") != "0.7")
         return()

      # re-assign the 'selectDirectory()' function
      rstudioapi <- asNamespace("rstudioapi")
      override <- function(caption = "Select Directory",
                           label = "Select",
                           path = rstudioapi::getActiveProject())
      {
         callFun("selectDirectory", caption, label, path)
      }
      environment(override) <- rstudioapi

      .rs.replaceBinding("selectDirectory", "rstudioapi", override)
   }
)

#
# SessionUserCommands.R
#
# Copyright (C) 2009-19 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

assign(".rs.userCommands", new.env(parent = emptyenv()), envir = .rs.toolsEnv())

.rs.addFunction("isValidShortcut", function(shortcut)
{
   if (!is.character(shortcut))
      return(FALSE)
   
   # TODO
   TRUE
})

.rs.addFunction("normalizeKeyboardShortcut", function(shortcut)
{
   # A shortcut may be a vector of 'strings', each to be pressed
   # in sequence to trigger the shortcut. Normalize each set and
   # then paste together.
   normalized <- lapply(shortcut, function(shortcut) {
      
      # Ensure lower case
      shortcut <- tolower(shortcut)
      
      # Normalize aliases
      aliases <- list(
         "ctrl" = "control",
         "cmd" = c("meta", "command", "win", "super")
      )
      
      for (i in seq_along(aliases))
      {
         destination <- names(aliases)[[i]]
         potentials <- aliases[[i]]
         for (item in potentials)
         {
            bounded <- paste("\\b", item, "\\b", sep = "")
            shortcut <- gsub(bounded, destination, shortcut, perl = TRUE)
         }
      }
      
      # Normalize modifier key names
      for (modifier in c("ctrl", "alt", "cmd", "shift"))
      {
         reFrom <- paste(modifier, "\\s*[-+]\\s*", sep = "")
         reTo <- paste(modifier, "-", sep = "")
         shortcut <- gsub(reFrom, reTo, shortcut, perl = TRUE)
      }
      
      shortcut
      
   })
   
   paste(normalized, collapse = " ")
   
})

.rs.addFunction("registerUserCommand", function(name, shortcuts, fn, overwrite = TRUE)
{
   if (length(name) != 1 || !is.character(name))
      stop("'name' should be a length-one character vector")
   
   if (!overwrite && exists(name, envir = .rs.userCommands)) {
      stop("'", name, "' is already bound to a command; use 'overwrite = TRUE'",
           "to overwrite with the new command definition.")
   }
   
   shortcuts <- unlist(lapply(shortcuts, .rs.normalizeKeyboardShortcut))
   .rs.userCommands[[name]] <- fn
   .Call("rs_registerUserCommand", .rs.scalar(name), shortcuts)
   
   TRUE
})

.rs.addFunction("loadUserCommands", function(keybindingPath)
{
   env <- new.env(parent = globalenv())
   env$registerUserCommand <- .rs.registerUserCommand
   
   # load user commands from pre-1.3 RStudio folder if present, then from the configured user
   # command folder
   paths <- c("~/.R/keybindings", keybindingPath)
   for (path in paths)
   {
      files <- list.files(file.path(path, "R"), full.names = TRUE)
      lapply(files, function(file)
      {
         source(file, local = env)
      })
   }
})

#
# SessionDependencies.R
#
# Copyright (C) 2020 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# Topographically sorts a list of packages (nodes) by their dependencies (edges). Note that this is
# not meant to be a general-purpose topo sort algorithm, and that it returns packages in the correct
# installation order, which is the exact reverse of traditional topological order. For example,
# given packages with dependencies a -> b -> c, we would want to install packages in the order "c",
# "b", and then "a".
.rs.addFunction("topoSortPackages", function(nodes, edges) {
   # List of sorted packages
   sorted <- c()

   # All nodes are unvisited to begin with
   visited <- c()

   # Define recursive descent function for dependencies
   visit <- function(node, stack) {
      if (node %in% visited) {
         return()
      }
      if (node %in% stack) {
         # We visited this node while visiting itself; this is a dependency loop.
         stop("Package dependency graph is not a directed acyclic graph.")
      }

      # Visit all the edges of this node
      stack <- c(stack, node)
      for (edge in edges) {
         if (identical(edge$from, node)) {
            visit(edge$to, stack)
         }
      }

      visited <<- c(visited, node)
      sorted <<- c(sorted, node)
   }

   # Keep visiting unvisited nodes until we have visited all of them
   while (length(visited) < length(nodes)) {
      for (node in nodes) {
         if (!(node %in% visited)) {
            visit(node, c())
            break
         }
      }
   }

   # Return topologically sorted list
   sorted
})

.rs.addFunction("expandPkgDependencies", function(dependencies) {
   available <- if (identical(R.version$os, "linux-gnu")) {
      # Get the default set of available packages on Linux (usually source) 
      available.packages()
   } else {
      # On other platforms (Mac and Windows), explicitly list both binary and source packages
      available.packages(type = "both")
   }
   .rs.expandDependencies(available, installed.packages(), dependencies)
})

.rs.addFunction("expandDependencies", function(available, installed, dependencies) {
   # A list of nodes (package names) to be installed
   nodes <- c()

   # A list of details for packages to be installed
   packages <- dependencies

   # A vector of lists, with "from" and "to" named elements giving the dependencies
   edges <- list()

   # Get the dependencies of each package
   for (dep in dependencies) {
      # Add the package itself to the list of nodes
      nodes <- c(nodes, dep$name)
   }

   # Look for dependencies of each package
   for (dep in dependencies) {
      # Dependencies are discovered from these three fields
      fields <- c("Depends", "Imports", "LinkingTo")
      for (field in fields) {
         # Read contents for field (ignore if no contents)
         contents <- available[dep$name, field]
         if (is.na(contents) || !is.character(contents))
            next

         # Split into a list of individual package names, using comma/whitespace as a delimiter
         prereqs <- strsplit(contents, "\\s*,\\s*")[[1]]

         # Parse the package names into groups:
         # 1. The package name
         # 2. The package's requirements
         # 3. The package's version
         parsed <- regexec("([a-zA-Z0-9._]+)(?:\\s*\\(([><=]+)\\s*([0-9.-]+)\\))?", prereqs)
         matches <- regmatches(prereqs, parsed)

         # Decompose matches into additional nodes
         for (match in matches) {
            if (length(match) < 2)
               next

            # Extract package name from regex result
            pkgName <- match[[2]]

            # Ignore packages that don't have an entry in the availability list
            if (!(pkgName %in% rownames(available)))
                next

            # Append to node list if we don't know about it already
            if (!pkgName %in% nodes) {
               nodes <- c(nodes, pkgName)


               # Figure out whether there is a version of the package installed which meets the
               # given constraints.
               satisfied <- if (pkgName %in% rownames(installed))
               {
                  if (length(match >= 4) && nchar(match[[4]]) > 0)
                  {
                     # We found a requirement for a specific version. See if that requirement is
                     # met.
                     installedVer <- as.package_version(installed[pkgName, "Version"])
                     requiredVer <- as.package_version(match[[4]])
                     if (identical(match[[3]], ">"))
                     {
                        # Satisfied if the installed version is strictly greater than the actual
                        # version.
                        installedVer > requiredVer
                     }
                     else
                     {
                        # If we aren't sure, treat it as a simple minimum version (this is by far
                        # the most common pattern, represented by `>=` in the Depends field and
                        # others)
                        installedVer >= requiredVer
                     }
                  }
                  else
                  {
                     # No version information was given, so the installed version is okay.
                     TRUE
                  }
               }
               else
               {
                  # The package is not installed, and therefore not satisfied.
                  FALSE
               }
               
               # The dependency is not satisfied; we will need to install it
               if (!satisfied)
               {
                  packages <- append(packages, list(list(
                        name = pkgName,
                        location = "cran",
                        version = available[pkgName, "Version"],
                        source = FALSE)))
               }
            }

            # Add a dependency edge
            edges <- append(edges, list(list(from = dep$name, to = pkgName)))
         }
      }
   }

   # We now have a complete list of packages that we need to install. Sort it topologically so that
   # we install dependencies before the packages they depend on. This returns a character vector of
   # sorted package names.
   sorted <- .rs.topoSortPackages(nodes, edges)

   # Rebuild the list of actual package records from the sorted names.
   result <- list()
   for (package in sorted) {
      for (record in packages) {
         if (record$name == package) {
            result <- append(result, list(record))
            break
         }
      }
   }

   # Return the expanded and sorted result
   result
})

#
# SessionSystemResources.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("getRMemoryUsed", function()
{
   # Perform a garbage collection to collect memory statistics
   mem_used <- gc()

   # A cons cell is 28 bytes on a 32 bit R and 56 on 64 bit (see ?gc)
   cons_size <- .Machine$sizeof.pointer * 7
   cons_kb <- (mem_used["Ncells", "used"] * cons_size) / 1024

   # Vector cells are always 8 bytes (see ?gc)
   vector_kb <- mem_used["Vcells", "used"] / 128

   # Return stats
   list(
      cons = .rs.scalar(round(cons_kb)),
      vector = .rs.scalar(round(vector_kb))
   )
})

#
# SessionCpp.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("cppSourceFile", function(file)
{
   lines <- .rs.tryCatch(readLines(file, warn = FALSE))
   call <- call("fun", file)
   
   if (is.character(lines) && any(grepl("cpp11::register", lines)))
      call[[1L]] <- quote(cpp11::cpp_source)
   else 
      call[[1L]] <- quote(Rcpp::sourceCpp)

    deparse(call)
})

.rs.addJsonRpcHandler("cpp_source_file", function(file)
{
   .rs.api.sendToConsole(.rs.cppSourceFile(file))
})

#
# This is the server logic of a Shiny web application. You can run the
# application by clicking 'Run App' above.
#
# Find out more about building applications with Shiny here:
#
#    http://shiny.rstudio.com/
#

library(shiny)

# Define server logic required to draw a histogram
shinyServer(function(input, output) {

    output$distPlot <- renderPlot({

        # generate bins based on input$bins from ui.R
        x    <- faithful[, 2]
        bins <- seq(min(x), max(x), length.out = input$bins + 1)

        # draw the histogram with the specified number of bins
        hist(x, breaks = bins, col = 'darkgray', border = 'white')

    })

})

#
# SessionPythonEnvironments.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("python_active_interpreter", function()
{
   pythonPath <- Sys.getenv("RETICULATE_PYTHON", unset = NA)

   if (is.na(pythonPath))
      pythonPath <- Sys.getenv("RETICULATE_PYTHON_FALLBACK", unset = NA)

   info <- if (is.na(pythonPath))
   {
      .rs.python.invalidInterpreter(
         path = pythonPath,
         type = NULL,
         reason = "RETICULATE_PYTHON and RETICULATE_PYTHON_FALLBACK are unset."
      )
   }
   else
   {
      .rs.python.getPythonInfo(pythonPath, strict = TRUE)
   }

   .rs.scalarListFromList(info)
})

.rs.addJsonRpcHandler("python_find_interpreters", function()
{
   .rs.python.findPythonInterpreters()
})

.rs.addJsonRpcHandler("python_interpreter_info", function(pythonPath)
{
   .rs.python.describeInterpreter(pythonPath)
})

.rs.addFunction("python.findCondaForEnvironment", function(envPath)
{
   # locate history file
   historyFile <- file.path(envPath, "conda-meta/history")
   if (!file.exists(historyFile))
      return("")

   # read first few lines
   contents <- readLines(historyFile, n = 2L, warn = FALSE)
   if (length(contents) < 2L)
    return("")

   # parse conda path
   line <- substring(contents[2L], 8L)
   index <- regexpr(" ", line, fixed = TRUE)
   if (index == -1L)
      return("")

   conda <- substring(line, 1L, index - 1L)
   if (.rs.platform.isWindows)
      conda <- file.path(dirname(conda), "conda.exe")

   # prefer condabin if it exists
   condabin <- file.path(dirname(conda), "../condabin", basename(conda))
   if (file.exists(condabin))
      conda <- condabin

   # bail if conda wasn't found
   if (!file.exists(conda))
      return("")

   .rs.canonicalizePath(conda)

})

.rs.addFunction("python.findWindowsPython", function()
{
   # if `py` and `python` are not available, nothing we can do
   pythonCommands <- c("py", "python3", "python")
   available <- nzchar(Sys.which(pythonCommands))

   if (!any(available))
      return("")
   else
      pythonCommand <- pythonCommands[available][1]

   # NOTE: ideally, we would just parse the output of 'py --list-paths',
   # but for whatever reason the '*' indicating the default version of
   # Python is omitted when run from RStudio, so we try to explicitly
   # run Python here and then ask where the executable lives.
   #
   # We pass '-E' here just to avoid things like PYTHONPATH potentially
   # influencing how the python session is launched
   pythonPath <- .rs.tryCatch(
      system2(
         command = pythonCommand,
         args    = c("-E", "-Xutf8"),
         input   = "import sys; print(sys.executable)",
         stdout  = TRUE,
         stderr  = TRUE
      )
   )

   if (inherits(pythonPath, "error"))
      return("")

   Encoding(pythonPath) <- "UTF-8"
   pythonPath
})

.rs.addFunction("python.configuredInterpreterPath", function(projectDir)
{
   # on Windows, check if PY_PYTHON is defined; if it is, we should use 'py'
   # to determine the version of python to be used
   if (.rs.platform.isWindows)
   {
      pyPython <- Sys.getenv("PY_PYTHON", unset = NA)
      if (!is.na(pyPython))
      {
         python <- .rs.python.findWindowsPython()
         if (file.exists(python))
            return(python)
      }
   }

   # check some pre-defined environment variables
   vars <- c("RENV_PYTHON", "RETICULATE_PYTHON", "RETICULATE_PYTHON_FALLBACK")
   for (var in vars)
   {
      value <- Sys.getenv(var, unset = NA)
      if (!is.na(value))
         return(value)
   }

   # if this project has a local interpreter, use it
   if (!is.null(projectDir))
   {
      projectPython <- .rs.python.projectInterpreterPath(projectDir)
      if (file.exists(projectPython))
         return(projectPython)
   }

   # check version of Python configured by user
   prefsPython <- .rs.readUiPref("python_path")
   if (file.exists(prefsPython))
      return(path.expand(prefsPython))

   # on Windows, help users find a default version of Python if possible
   if (.rs.platform.isWindows)
   {
     pythonPath <- .rs.python.findWindowsPython()
     if (file.exists(pythonPath))
        return(pythonPath)
   }

   # look for python + python3 on the PATH
   if (!.rs.platform.isWindows)
   {
     python3 <- Sys.which("python3")
     if (nzchar(python3) && python3 != "/usr/bin/python3")
        return(python3)

     python <- Sys.which("python")
     if (nzchar(python) && python != "/usr/bin/python")
     {
       info <- .rs.python.interpreterInfo(python, NULL)
       version <- numeric_version(info$version, strict = FALSE)
       if (!is.na(version) && version >= "3.2")
          return(python)
     }
   }

   # if the user has Anaconda installed, then try auto-activating
   # the base environment of that Anaconda installation
   conda <- .rs.python.findCondaBinary()
   if (file.exists(conda))
   {
     pythonPath <- if (.rs.platform.isWindows) "../python.exe" else "../bin/python"
     python <- file.path(dirname(conda), pythonPath)
     if (file.exists(python))
        return(python)
   }

   # fall back to versions of python in /usr/bin if available
   if (!.rs.platform.isWindows)
   {
     python3 <- Sys.which("python3")
     if (nzchar(python3) && python3 == "/usr/bin/python3")
        return(python3)

     python <- Sys.which("python")
     if (nzchar(python) && python == "/usr/bin/python")
     {
       info <- .rs.python.interpreterInfo(python, NULL)
       version <- numeric_version(info$version, strict = FALSE)
       if (!is.na(version) && version >= "3.2")
          return(python)
     }
   }

   # no python found; return empty string placeholder
   ""

})

.rs.addFunction("python.projectInterpreterPath", function(projectDir)
{
   # check for virtual environments / conda environments
   pythonSuffixes <- if (.rs.platform.isWindows)
      c("Scripts/python.exe", "python.exe")
   else
      c("bin/python3", "bin/python")

   # look within all top-level directories for an environment
   envPaths <- list.dirs(
      path = projectDir,
      full.names = TRUE,
      recursive = FALSE
   )

   for (envPath in envPaths)
   {
      for (pythonSuffix in pythonSuffixes)
      {
         pythonPath <- file.path(envPath, pythonSuffix)
         if (file.exists(pythonPath))
            return(pythonPath)
      }
   }

   ""
})

.rs.addFunction("python.initialize", function(projectDir)
{
   # do nothing if the user hasn't opted in
   activate <- .rs.readUiPref("python_project_environment_automatic_activate")
   if (!identical(activate, TRUE))
      return()

   # find path to python interpreter for this project
   pythonPath <- .rs.python.configuredInterpreterPath(projectDir)
   if (!file.exists(pythonPath))
      return()

   # normalize path (avoid following symlinks)
   pythonPath <- file.path(
      normalizePath(dirname(pythonPath), winslash = "/", mustWork = FALSE),
      basename(pythonPath)
   )

   # add the Python directory to the PATH
   pythonBin <- dirname(pythonPath)
   .rs.prependToPath(pythonBin)

   # if we have a Scripts directory, place that on the PATH as well
   # (primarily for Windows + conda environments)
   scriptsPath <- file.path(pythonBin, "Scripts")
   if (file.exists(scriptsPath))
      .rs.prependToPath(scriptsPath)

   pythonInfo <- .rs.python.getPythonInfo(pythonPath, strict = TRUE)

   # if this is a virtual environment, set VIRTUAL_ENV
   if (identical(pythonInfo$type, "virtualenv"))
   {
      envPath <- dirname(dirname(pythonPath))
      Sys.setenv(VIRTUAL_ENV = envPath)
   }

   # if this is a conda environment, set CONDA_PREFIX
   if (identical(pythonInfo$type, "conda"))
   {
      condaPrefix <- pythonBin
      if (!.rs.platform.isWindows)
         condaPrefix <- dirname(condaPrefix)

      Sys.setenv(CONDA_PREFIX = condaPrefix)

      # also ensure that conda is placed on the PATH
      condaPath <- .rs.python.findCondaForEnvironment(condaPrefix)
      if (file.exists(condaPath))
         .rs.prependToPath(dirname(condaPath))
   }

   # also set RETICULATE_PYTHON_FALLBACK so this python is used by default
   Sys.setenv(RETICULATE_PYTHON_FALLBACK = pythonPath)

   # return path to python
   invisible(pythonPath)
})

.rs.addFunction("python.execute", function(python, code)
{
   python <- normalizePath(python, winslash = "/", mustWork = TRUE)

   args <- c("-E", "-c", shQuote(code))
   result <- suppressWarnings(
      system2(python, args, stdout = TRUE, stderr = TRUE)
   )

   # propagate failure as error
   status <- .rs.nullCoalesce(attr(result, "status", exact = TRUE), 0L)
   if (!identical(status, 0L))
      .rs.stopf("error retrieving Python version [error code %i]", status)

   paste(result, collapse = "\n")
})

.rs.addFunction("python.getPythonVersion", function(pythonPath)
{
   .rs.python.execute(pythonPath, "import platform; print(platform.python_version())")
})

.rs.addFunction("python.getPythonDescription", function(pythonPath)
{
   .rs.python.execute(pythonPath, "import sys; print(sys.version)")
})

.rs.addFunction("python.getPythonInfo", function(path, strict)
{
   # default to concluding python binary path == requested path
   pythonPath <- path

   # if this is the path to an existing file, use the directory path
   info <- file.info(path, extra_cols = FALSE)
   if (identical(info$isdir, FALSE))
      path <- dirname(path)

   # if this is the path to the 'root' of an environment,
   # start from the associated bin / scripts directory
   binExt <- if (.rs.platform.isWindows) "Scripts" else "bin"
   binPath <- file.path(path, binExt)
   if (file.exists(binPath))
      path <- binPath

   # now form the python path
   if (!strict)
   {
      exe <- if (.rs.platform.isWindows) "python.exe" else "python"
      pythonPath <- file.path(path, exe)
   }

   # if this python doesn't exist, bail
   if (!file.exists(pythonPath))
   {
      info <- .rs.python.invalidInterpreter(
         path = pythonPath,
         type = NULL,
         reason = "There is no Python interpreter available at this location."
      )

      return(info)
   }

   # check for conda environment
   # (look for folders normally seen in conda installations)
   condaFiles <- c("../conda-meta", "../condabin")
   condaPaths <- file.path(path, condaFiles)
   if (any(file.exists(condaPaths)))
      return(.rs.python.interpreterInfo(pythonPath, "conda"))

   # check for virtual environment
   # (look for files normally seen in virtual envs)
   venvFiles <- c("activate", "pyvenv.cfg", "../pyvenv.cfg")
   venvPaths <- file.path(path, venvFiles)
   if (any(file.exists(venvPaths)))
      return(.rs.python.interpreterInfo(pythonPath, "virtualenv"))

   # default to assuming a system interpreter
   .rs.python.interpreterInfo(pythonPath, "system")

})

.rs.addFunction("python.interpreterInfo", function(path, type)
{
   # prefer UTF-8 path when possible
   path <- enc2utf8(path)

   # prefer unix-style slashes
   path <- chartr("\\", "/", path)

   # defaults for version, description
   valid <- TRUE
   version <- "[unknown]"
   description <- "[unknown]"

   # determine interpreter version
   version <- tryCatch(
      .rs.python.getPythonVersion(path),
      error = function(e) {
         valid <<- FALSE
         conditionMessage(e)
      }
   )

   # determine interpreter description
   description <- tryCatch(
      .rs.python.getPythonDescription(path),
      error = function(e) {
         valid <<- FALSE
         conditionMessage(e)
      }
   )

   list(
      path        = .rs.createAliasedPath(path),
      type        = type,
      version     = version,
      description = description,
      valid       = valid,
      reason      = NULL
   )
})

.rs.addFunction("python.invalidInterpreter", function(path, type, reason)
{
   list(
      path        = .rs.createAliasedPath(path),
      type        = type,
      version     = NULL,
      description = NULL,
      valid       = FALSE,
      reason      = reason
   )
})

.rs.addFunction("python.findPythonInterpreters", function()
{
   # get interpreters from all known sources
   interpreters <- unname(c(
      .rs.python.findPythonProjectInterpreters(),
      .rs.python.findPythonSystemInterpreters(),
      .rs.python.findPythonInterpretersInKnownLocations(),
      .rs.python.findPythonPyenvInterpreters(),
      .rs.python.findPythonVirtualEnvironments(),
      .rs.python.findPythonCondaEnvironments()
   ))

   default <- Sys.getenv("RETICULATE_PYTHON", unset = "")

   list(
      python_interpreters = .rs.scalarListFromList(interpreters),
      default_interpreter = .rs.scalar(default)
   )

})

.rs.addFunction("python.findPythonProjectInterpreters", function()
{
   projectDir <- .rs.getProjectDirectory()
   if (is.null(projectDir))
      return(list())

   candidateDirs <- list.files(
      path = projectDir,
      all.files = TRUE,
      full.names = TRUE
   )

   pythonSuffix <- if (.rs.platform.isWindows) "Scripts/python.exe" else "bin/python"
   candidatePaths <- file.path(candidateDirs, pythonSuffix)
   pythonPaths <- Filter(file.exists, candidatePaths)
   lapply(pythonPaths, .rs.python.getPythonInfo, strict = TRUE)
})

.rs.addFunction("python.findPythonSystemInterpreters", function()
{
   interpreters <- list()

   # look for interpreters on the PATH
   paths <- strsplit(Sys.getenv("PATH"), split = .Platform$path.sep, fixed = TRUE)[[1]]
   paths <- unique(normalizePath(paths, winslash = "/", mustWork = FALSE))

   for (path in paths)
   {

      # skip fake broken Windows Python interpreters
      skip <-
         .rs.platform.isWindows &&
         grepl("AppData\\Local\\Microsoft\\WindowsApps", path, fixed = TRUE)

      if (skip)
         next

      # create pattern matching interpreter paths
      pattern <- if (.rs.platform.isWindows)
         "^python[[:digit:].]*exe$"
      else
         "^python[[:digit:].]*$"

      # look for python installations
      pythons <- list.files(
         path       = path,
         pattern    = pattern,
         full.names = TRUE
      )

      # loop over interpreters and add them
      for (python in pythons)
      {
         # skip simple symlinks. the intention here is to avoid adding
         # all of python, python3, and python3.9 if they all ultimately
         # resolve to the same python executable
         if (!.rs.platform.isWindows)
         {
            link <- Sys.readlink(python)
            if (grepl(pattern, link))
               next
         }

         # add the interpreter
         info <- .rs.python.getPythonInfo(python, strict = TRUE)
         interpreters[[length(interpreters) + 1]] <- info
      }

   }

   interpreters

})

.rs.addFunction("python.findPythonInterpretersInKnownLocations", function()
{
   # set of discovered paths
   pythonPaths <- character()

   # Python root paths we'll search in
   roots <- if (.rs.platform.isWindows) {

      # find path to Windows local app data folder
      localAppData <- local({

         path <- Sys.getenv("LOCALAPPDATA", unset = NA)
         if (!is.na(path))
            return(path)

         profile <- Sys.getenv("USERPROFILE", unset = NA)
         if (!is.na(profile))
            return(file.path(profile, "AppData\\Local"))

         ""

      })

      # system-installs of Python might be in one of these folders
      drive <- Sys.getenv("SYSTEMDRIVE", unset = "C:")
      suffixes <- c("/", "/Program Files", "/Program Files (x86)")

      c(
         paste0(drive, suffixes),
         file.path(localAppData, "Programs/Python")
      )

   } else {

      c(
         "/opt/python",
         "/opt/local/python",
         "/usr/local/opt/python"
      )

   }

   # also include those defined via option
   roots <- c(roots, getOption("rstudio.python.installationPath"))

   # check and see if any of these roots point directly
   # to a particular version of Python.
   #
   # on Windows, Python is typically installed in 'Scripts/python.exe'
   # for virtual environments, and 'python.exe' for Anaconda + standalone
   suffixes <- if (.rs.platform.isWindows) {
      c("Scripts/python.exe", "python.exe")
   } else {
      c("bin/python3", "bin/python")
   }

   paths <- vapply(roots, function(root) {
      paths <- file.path(root, suffixes)
      paths[file.exists(paths)][1]
   }, FUN.VALUE = character(1))

   # collect the discovered python paths, if any
   exists <- !is.na(paths)
   pythonPaths <- c(pythonPaths, paths[exists])
   roots <- roots[!exists]

   # treat any remaining root directories as versioned roots
   roots <- list.files(roots, full.names = TRUE)

   # check and see if any of these roots point directly
   # to a particular version of Python
   paths <- vapply(roots, function(root) {
      paths <- file.path(root, suffixes)
      paths[file.exists(paths)][1]
   }, FUN.VALUE = character(1))

   # collect the discovered python paths, if any
   exists <- !is.na(paths)
   pythonPaths <- c(pythonPaths, paths[exists])

   # return the discovered paths
   lapply(pythonPaths, .rs.python.getPythonInfo, strict = TRUE)

})

.rs.addFunction("python.findPythonPyenvInterpreters", function()
{
   root <- Sys.getenv("PYENV_ROOT", unset = "~/.pyenv")

   # on Windows, Python interpreters are normally part of pyenv-windows
   if (.rs.platform.isWindows)
      root <- file.path(root, "pyenv-win")

   # get path to roots of Python installations
   versionsPath <- file.path(root, "versions")
   pythonRoots <- list.files(versionsPath, full.names = TRUE)

   # form path to Python binaries
   stem <- if (.rs.platform.isWindows) "python.exe" else "bin/python"
   pythonPaths <- file.path(pythonRoots, stem)

   # exclude anything that doesn't exist for some reason
   pythonPaths <- pythonPaths[file.exists(pythonPaths)]

   # get interpreter info for each found
   lapply(pythonPaths, .rs.python.getPythonInfo, strict = TRUE)

})

.rs.addFunction("python.findCondaBinary", function()
{
   # read from option (primarily for internal use / testing)
   conda <- getOption("rstudio.conda.binary")
   if (!is.null(conda))
   {
      conda <- Sys.which(conda)
      if (nzchar(conda))
         return(conda)
   }

   # look on PATH
   conda <- Sys.which("conda")
   if (nzchar(conda))
      return(conda)

   # look in some default locations
   if (.rs.platform.isWindows)
   {
      condaRoots <- c(
         file.path(Sys.getenv("USERPROFILE"), "anaconda3"),
         file.path(Sys.getenv("SYSTEMDRIVE"), "ProgramData/anaconda3")
      )
   }
   else
   {
      condaRoots <- c(
         "~/opt/anaconda3",
         "~/anaconda3",
         "~/opt/miniconda3",
         "~/miniconda3",
         "/anaconda3",
         "/miniconda3"
      )
   }

   condaSuffix <- if (.rs.platform.isWindows)
      "condabin/conda.bat"
   else
      "condabin/conda"

   condaPaths <- file.path(condaRoots, condaSuffix)
   for (condaPath in condaPaths)
      if (file.exists(condaPath))
         return(path.expand(condaPath))

   ""

})

.rs.addFunction("python.findPythonCondaEnvironments", function()
{
   # look for conda
   conda <- .rs.python.findCondaBinary()
   if (!file.exists(conda))
      return(NULL)

   # ask it for environments
   args <- c("env", "list", "--json", "--quiet")
   tmp <- tempfile()
   output <- system2(conda, args, stdout = TRUE, stderr = tmp)

   status <- .rs.nullCoalesce(attr(output, "status", exact = TRUE), 0L)
   if (!identical(status, 0L)) {
     errors <- paste(readLines(tmp), collapse = "\n")
     .rs.stopf("Error executing %s %s:\n%s", conda, paste(args, collapse = " "), errors)
   }
   json <- .rs.fromJSON(paste(output, collapse = "\n"))
   envList <- unlist(json$envs)

   # prefer unix separators
   if (.rs.platform.isWindows)
      envList <- chartr("\\", "/", envList)

   # ignore certain special environments
   ignorePatterns <- c("/revdep/", "/basilisk/", "/renv/python/condaenvs/")
   pattern <- sprintf("(?:%s)", paste(ignorePatterns, collapse = "|"))
   envList <- grep(pattern, envList, value = TRUE, invert = TRUE)

   # get paths to Python in each environment
   pythonSuffix <- if (.rs.platform.isWindows) "python.exe" else "bin/python"
   pythonPaths <- file.path(envList, pythonSuffix)

   # only keep existing
   pythonPaths <- Filter(file.exists, pythonPaths)

   # drop duplicates, just in case
   pythonPaths <- unique(normalizePath(pythonPaths, winslash = "/"))

   # get information for each environment
   lapply(pythonPaths, .rs.python.getCondaEnvironmentInfo)
})

.rs.addFunction("python.getCondaEnvironmentInfo", function(pythonPath)
{
   .rs.python.interpreterInfo(
      path = pythonPath,
      type = "conda"
   )
})

.rs.addFunction("python.findPythonVirtualEnvironments", function()
{
   home <- Sys.getenv("WORKON_HOME", unset = "~/.virtualenvs")
   roots <- list.files(home, full.names = TRUE)
   lapply(roots, .rs.python.getVirtualEnvironmentInfo)
})

.rs.addFunction("python.getVirtualEnvironmentInfo", function(envPath)
{
   # form path to Python executable from root
   exeSuffix <- if (.rs.platform.isWindows)
      "Scripts/python.exe"
   else
      "bin/python"

   # form executable path (ensure it exists)
   exePath <- file.path(envPath, exeSuffix)
   if (!file.exists(exePath))
   {
      fmt <- "Python executable '%s' does not exist."
      reason <- sprintf(fmt, exePath)
      return(.rs.python.invalidInterpreter(
         path   = exePath,
         type   = "virtualenv",
         reason = reason
      ))
   }

   .rs.python.interpreterInfo(
      path = exePath,
      type = "virtualenv"
   )

})

.rs.addFunction("python.describeInterpreter", function(pythonPath)
{
   info <- .rs.python.getPythonInfo(pythonPath, strict = TRUE)
   .rs.scalarListFromList(info)
})

#
# SessionDependencies.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# Topographically sorts a list of packages (nodes) by their dependencies (edges). Note that this is
# not meant to be a general-purpose topo sort algorithm, and that it returns packages in the correct
# installation order, which is the exact reverse of traditional topological order. For example,
# given packages with dependencies a -> b -> c, we would want to install packages in the order "c",
# "b", and then "a".
.rs.addFunction("topoSortPackages", function(nodes, edges) {
   # List of sorted packages
   sorted <- c()

   # All nodes are unvisited to begin with
   visited <- c()

   # Define recursive descent function for dependencies
   visit <- function(node, stack) {
      if (node %in% visited) {
         return()
      }
      if (node %in% stack) {
         # We visited this node while visiting itself; this is a dependency loop.
         stop("Package dependency graph is not a directed acyclic graph.")
      }

      # Visit all the edges of this node
      stack <- c(stack, node)
      for (edge in edges) {
         if (identical(edge$from, node)) {
            visit(edge$to, stack)
         }
      }

      visited <<- c(visited, node)
      sorted <<- c(sorted, node)
   }

   # Keep visiting unvisited nodes until we have visited all of them
   while (length(visited) < length(nodes)) {
      for (node in nodes) {
         if (!(node %in% visited)) {
            visit(node, c())
            break
         }
      }
   }

   # Return topologically sorted list
   sorted
})

.rs.addFunction("expandPkgDependencies", function(dependencies) {
   available <- if (identical(R.version$os, "linux-gnu")) {
      # Get the default set of available packages on Linux (usually source) 
      available.packages()
   } else {
      # On other platforms (Mac and Windows), explicitly list both binary and source packages
      available.packages(type = "both")
   }
   .rs.expandDependencies(available, installed.packages(), dependencies)
})

.rs.addFunction("expandDependencies", function(available, installed, dependencies) {
   # A list of nodes (package names) to be installed
   nodes <- c()

   # A list of details for packages to be installed
   packages <- dependencies

   # A vector of lists, with "from" and "to" named elements giving the dependencies
   edges <- list()

   # Get the dependencies of each package
   for (dep in dependencies) {
      # Add the package itself to the list of nodes
      nodes <- c(nodes, dep$name)
   }

   # Look for dependencies of each package
   for (dep in dependencies) {
      # Dependencies are discovered from these three fields
      fields <- c("Depends", "Imports", "LinkingTo")
      for (field in fields) {
         # Read contents for field (ignore if no contents)
         contents <- available[dep$name, field]
         if (is.na(contents) || !is.character(contents))
            next

         # Split into a list of individual package names, using comma/whitespace as a delimiter
         prereqs <- strsplit(contents, "\\s*,\\s*")[[1]]

         # Parse the package names into groups:
         # 1. The package name
         # 2. The package's requirements
         # 3. The package's version
         parsed <- regexec("([a-zA-Z0-9._]+)(?:\\s*\\(([><=]+)\\s*([0-9.-]+)\\))?", prereqs)
         matches <- regmatches(prereqs, parsed)

         # Decompose matches into additional nodes
         for (match in matches) {
            if (length(match) < 2)
               next

            # Extract package name from regex result
            pkgName <- match[[2]]

            # Ignore packages that don't have an entry in the availability list
            if (!(pkgName %in% rownames(available)))
                next

            # Append to node list if we don't know about it already
            if (!pkgName %in% nodes) {
               nodes <- c(nodes, pkgName)


               # Figure out whether there is a version of the package installed which meets the
               # given constraints.
               satisfied <- if (pkgName %in% rownames(installed))
               {
                  if (length(match >= 4) && nchar(match[[4]]) > 0)
                  {
                     # We found a requirement for a specific version. See if that requirement is
                     # met.
                     installedVer <- as.package_version(installed[pkgName, "Version"])
                     requiredVer <- as.package_version(match[[4]])
                     if (identical(match[[3]], ">"))
                     {
                        # Satisfied if the installed version is strictly greater than the actual
                        # version.
                        installedVer > requiredVer
                     }
                     else
                     {
                        # If we aren't sure, treat it as a simple minimum version (this is by far
                        # the most common pattern, represented by `>=` in the Depends field and
                        # others)
                        installedVer >= requiredVer
                     }
                  }
                  else
                  {
                     # No version information was given, so the installed version is okay.
                     TRUE
                  }
               }
               else
               {
                  # The package is not installed, and therefore not satisfied.
                  FALSE
               }
               
               # The dependency is not satisfied; we will need to install it
               if (!satisfied)
               {
                  packages <- append(packages, list(list(
                        name = pkgName,
                        location = "cran",
                        version = available[pkgName, "Version"],
                        source = FALSE)))
               }
            }

            # Add a dependency edge
            edges <- append(edges, list(list(from = dep$name, to = pkgName)))
         }
      }
   }

   # We now have a complete list of packages that we need to install. Sort it topologically so that
   # we install dependencies before the packages they depend on. This returns a character vector of
   # sorted package names.
   sorted <- .rs.topoSortPackages(nodes, edges)

   # Rebuild the list of actual package records from the sorted names.
   result <- list()
   for (package in sorted) {
      for (record in packages) {
         if (record$name == package) {
            result <- append(result, list(record))
            break
         }
      }
   }

   # Return the expanded and sorted result
   result
})

#
# SessionInstallRTools.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("findRtools42Installer", function(url, fallbackUrl)
{
   tryCatch({
       tmp <- tempfile()
       utils::download.file(url, tmp, mode = "w", quiet = TRUE)
       homePageHtml <- paste(readLines(tmp), collapse = " ")
       unlink(tmp)
     },
     error = function(e) {
       return(fallbackUrl)
     })
     reLinkPattern <- ".*<a\\shref=\"(.*rtools.*\\.exe)\">\\s*.+<\\/a>.*"
     if (grepl(reLinkPattern, homePageHtml)) {
       urlRoot <- dirname(url)
       # extract the relative url to the installer exe file
       installerUrl <- gsub(reLinkPattern, "\\1", homePageHtml)
       file.path(urlRoot, installerUrl)
     }
     else
       fallbackUrl
})

#
# SessionAuthoring.R
#
# Copyright (C) 2009-12 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#


.rs.addFunction( "knitrChunkOptions", function()
{
   # starting with v0.4.2 this is avavilable directly from knitr
   if (.rs.getPackageVersion("knitr") >= "0.4.2")
      return(knitr:::opts_chunk_attr)

   # still try to return correct results for previous versions
   knitrOptions <- knitr:::opts_chunk$get()
   knitrOptions <- as.list(sapply(knitrOptions, class))
   knitrOptions[knitrOptions == "NULL"] <- "character"
   knitrOptions$results <- list("markup", "asis", "hide")
   knitrOptions$fig.show <- list("asis", "hold", "animate")
   knitrOptions$fig.keep <- list("high", "none", "all", "first", "last")
   knitrOptions$fig.align <- list("left", "right", "center")
   if (.rs.getPackageVersion("knitr") >= "0.4")
      knitrOptions$dev <- as.list(names(knitr:::auto_exts))
   
   return (knitrOptions)
})

.rs.addFunction( "sweaveChunkOptions", function()
{
   sweaveOptions <- list()
   
   sweaveOptions$label <- "character"
   sweaveOptions$engine <- list("R", "S")
   sweaveOptions$echo <- "logical"
   sweaveOptions$keep.source <- "logical"
   sweaveOptions$eval <- "logical"
   sweaveOptions$results <- list("verbatim", "tex", "hide")
   sweaveOptions$print <- "logical"
   sweaveOptions$term <- "logical"
   sweaveOptions$split <- "logical"
   sweaveOptions$strip.white <- list("true", "all", "false")
   sweaveOptions$prefix <- "logical"
   sweaveOptions$prefix.string <- "character"
   sweaveOptions$include <- "logical"
   sweaveOptions$fig <- "logical"
   sweaveOptions$eps <- "logical"
   sweaveOptions$pdf <- "logical"
   sweaveOptions$pdf.version <- "character"
   sweaveOptions$pdf.encoding <- "character"
   sweaveOptions$pdf.compress <-"logical"
   if (getRversion() >= "2.13.0") {
      sweaveOptions$png <- "logical"
      sweaveOptions$jpeg <- "logical"
      sweaveOptions$grdevice <- "character"
   }
   sweaveOptions$width <- "numeric"
   sweaveOptions$height <- "numeric"
   sweaveOptions$resolution <- "numeric"
   sweaveOptions$figs.only <- "logical"
   
   return (sweaveOptions)
})

#
# SessionRSConnect.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("forget_rsconnect_deployments", function(sourcePath, outputPath)
{
  # for R files, assume that the containing directory is treated as the
  # application path as opposed to the file itself
  ext <- tolower(tools::file_ext(sourcePath))
  if (identical(ext, "r"))
    sourcePath <- dirname(sourcePath)
  
  rsconnect::forgetDeployment(appPath = sourcePath, force = TRUE)
})

# this is a clone of 'applicationConfigDir' in the rsconnect package; we use it
# to detect the condition in which rsconnect has state but the package itself
# isn't installed. 
.rs.addFunction("connectConfigDir", function(appName, subDir = NULL) {

  # get the home directory from the operating system (in case
  # the user has redefined the meaning of ~) but fault back
  # to ~ if there is no HOME variable defined
  homeDir <- Sys.getenv("HOME", unset="~")

  # determine application config dir (platform specific)
  sysName <- Sys.info()[['sysname']]
  if (identical(sysName, "Windows"))
    configDir <- Sys.getenv("APPDATA")
  else if (identical(sysName, "Darwin"))
    configDir <- file.path(homeDir, "Library/Application Support")
  else
    configDir <- Sys.getenv("XDG_CONFIG_HOME", file.path(homeDir, ".config"))

  # append the application name and optional subdir
  configDir <- file.path(configDir, "R", appName)
  if (!is.null(subDir))
    configDir <- file.path(configDir, subDir)

  # normalize path
  configDir <- normalizePath(configDir, mustWork=FALSE)

  # ensure that it exists
  if (!file.exists(configDir))
    dir.create(configDir, recursive=TRUE)

  # return it
  configDir
})

.rs.addFunction("scalarListFromFrame", function(frame)
{
   ret <- list()

   # return an empty list when no entries exist
   if (is.null(frame))
     return(ret)

   cols <- names(frame)

   # take apart the frame and compose a list of scalars from each row
   for (i in seq_len(nrow(frame))) {
      row <- lapply(cols, 
                    function(col) { if (is.null(frame[i,col])) NULL 
                                    else .rs.scalar(unlist(frame[i,col])) })
      names(row) <- cols
      ret[[i]] <- row
   }
   return(ret)
})

.rs.addFunction("getRSConnectDeployments", function(path, rpubsUploadId) {
   # start with an empty list
   deploymentsFrame <- data.frame(
     name = character(0),
     account = character(0),
     server = character(0),
     bundleId = character(0),
     appId = character(0),
     asStatic = logical(0),
     hostUrl = character(0),
     username = character(0),
     when = numeric(0))
   deployments <- list()
   servers <- data.frame(
     name = character(0),
     url = character(0))
   accounts <- data.frame(
     name = character(0),
     server = character(0))
     
   # attempt to populate the list from rsconnect; this can throw if e.g. the
   # package is not installed. in the case of any error we'll safely return 
   # an empty list, or a stored RPubs upload ID if one was given (below)
   tryCatch({
     # included "orphaned" deployments; we will filter later
     deploymentsFrame <- rsconnect::deployments(appPath = path, excludeOrphaned = FALSE)
     deployments <- .rs.scalarListFromFrame(deploymentsFrame)

     # create the list of servers and accounts (for later filtering)
     servers <- rsconnect::servers()
     accounts <- rsconnect::accounts()
   }, error = function(e) { })

   # cross-reference registered servers against the list of deployments, so the
   # client knows without issuing a separate RPC which deployments don't have
   # registered servers
   if (nrow(deploymentsFrame) > 0) {
     # filter the list of servers by those that actually have accounts
     # registered 
     servers <- servers[
         as.character(servers$name) %in% as.character(accounts$server),]

     # extract names and URLs from the remaining servers (include the virtual server rpubs.com)
     urls <- as.character(servers[["url"]])
     names <- c(as.character(servers[["name"]]), "rpubs.com")

     # compute whether the deployment is orphaned; note that this differs from
     # the definition of "orphaned" used by the rsconnect package in that it
     # considers only the server (not the account)
     deploymentsFrame <- cbind(deploymentsFrame, list(
       serverRegistered = as.character(deploymentsFrame[["server"]]) %in% names |
                          as.character(deploymentsFrame[["hostUrl"]]) %in% urls))

     # rebuild list with additional metadata
     deployments <- .rs.scalarListFromFrame(deploymentsFrame)
   }
   
   # no RPubs upload IDs to consider
   if (!is.character(rpubsUploadId) || nchar(rpubsUploadId) == 0) {
     return(deployments)
   }

   # if there's already a deployment to rpubs.com, ignore legacy deployment
   if ("rpubs.com" %in% deployments$server) {
     return(deployments)
   }

   # create a new list with the same names as the one we're about to return,
   # and populate the fields we know from RPubs. leave all others, including
   # user-defined fields, blank; this allows us to tolerate changes to the
   # deployment frame format.
   rpubsDeployment <- list()
   for (col in colnames(deploymentsFrame)) {
     if (col == "name")
       rpubsDeployment[col] = ""
     else if (col == "account")
       rpubsDeployment[col] = "rpubs"
     else if (col == "server")
       rpubsDeployment[col] = "rpubs.com"
     else if (col == "appId")
       rpubsDeployment[col] = rpubsUploadId
     else if (col == "bundleId") 
       rpubsDeployment[col] = rpubsUploadId
     else if (col == "asStatic")
       rpubsDeployment[col] = TRUE
     else if (col == "when") 
       rpubsDeployment[col] = 0
     else if (col == "hostUrl")
       rpubsDeployment[col] = "rpubs.com"
     else if (col == "username")
       rpubsDeployment[col] = "rpubs"
     else 
       rpubsDeployment[col] = NA
   }

   # combine the deployments rsconnect knows about with the deployments we know
   # about
   c(deployments, list(.rs.scalarListFromList(rpubsDeployment)))
})

.rs.addJsonRpcHandler("get_rsconnect_account_list", function() {
   accounts <- list()
   # safely return an empty list--we want to consider there to be 0 connected
   # accounts when the rsconnect package is not installed or broken 
   # (vs. raising an error)
   tryCatch({
     accountFrame <- rsconnect::accounts()
     # if raw characters (older rsconnect), presume shinyapps.io
     if (is.character(accountFrame))
       accountFrame <- data.frame(name = accountFrame, server = "shinyapps.io")
     accounts <- .rs.scalarListFromFrame(accountFrame)
   }, error = function(e) { })
   accounts
})

.rs.addJsonRpcHandler("remove_rsconnect_account", function(account, server) {
   rsconnect::removeAccount(name = account, server = server)
})

.rs.addJsonRpcHandler("get_rsconnect_app_list", function(account, server) {
   .rs.scalarListFromFrame(rsconnect::applications(account = account, server = server))
})

.rs.addJsonRpcHandler("get_rsconnect_app", function(id, account, server, hostUrl) { 
   # init with empty list
   appList <- list()
   appError <- ""

   # attempt to get app ID from server
   tryCatch({
     appList <- rsconnect:::getAppById(id = id, account = account, server = server, 
                                       hostUrl = hostUrl)
   }, error = function(e) {
      # record the error message when a failure occurs (will be passed to the client for display)
      appError <<- conditionMessage(e)
   })
   
   list(error = .rs.scalar(appError), 
        app   = if(length(appList) > 0) .rs.scalarListFromList(appList) else NULL)
})

.rs.addJsonRpcHandler("validate_server_url", function(url) {
   # suppress output when validating server URL (timeouts otherwise emitted to
   # console)
   capture.output(serverInfo <- rsconnect:::validateServerUrl(url = url))
   .rs.scalarListFromList(serverInfo)
})

.rs.addJsonRpcHandler("get_auth_token", function(name) {
   .rs.scalarListFromList(rsconnect:::getAuthToken(server = name))
})

.rs.addJsonRpcHandler("get_user_from_token", function(url, token, privateKey) {
   user <- rsconnect:::getUserFromRawToken(serverUrl = url, token = token, privateKey = privateKey)
   .rs.scalarListFromList(user)
})

.rs.addJsonRpcHandler("register_user_token", function(serverName, accountName,
   userId, token, privateKey) {
  rsconnect:::registerUserToken(serverName = serverName, accountName = accountName, userId = userId,
                                token = token, privateKey = privateKey)
})

.rs.addJsonRpcHandler("get_rsconnect_lint_results", function(target) {
   err <- ""
   results <- NULL
   basePath <- ""

   # validate and lint the requested target
   if (!file.exists(target)) {
     err <- paste("The file or directory ", target, " does not exist.")
   } else {
     tryCatch({
       info <- file.info(target)
       if (info$isdir) {
         # a directory was specified--lint the whole thing
         basePath <- target
         results <- rsconnect::lint(project = basePath)
       } else if (tolower(tools::file_ext(target)) == "r") {
         # a single-file Shiny app--lint the directory (with file hint)
         basePath <- dirname(target)
         results <- rsconnect::lint(project = basePath, appPrimaryDoc = basename(target))
       } else {
         # a single file was specified--lint just that file
         basePath <- dirname(target)
         results <- rsconnect::lint(project = basePath, files = basename(target))
       }
    }, error = function(e) {
      err <<- e$message
    })
  }

  # empty or missing results; no need to do further work
  if (identical(length(results), 0) || !rsconnect:::hasLint(results)) {
    return(list(
      has_lint = .rs.scalar(FALSE),
      error_message = .rs.scalar(err)))
  }

  # we have a list of lint results; convert them to markers and emit them to
  # the Markers pane
  rsconnect:::showRstudioSourceMarkers(basePath = basePath, results)
  
  # return the result to the client
  list(
    has_lint = .rs.scalar(TRUE), 
    error_message = .rs.scalar(err)) 
})

.rs.addFunction("docDeployList", function(target, asMultipleDoc, quartoSrcFile) {
  file_list <- c()

  # if deploying multiple documents, find all the files in the with a matching
  # extension; otherwise, just use the single document we were given
  if (asMultipleDoc) {
    targets <- list.files(path = dirname(target), 
      pattern = glob2rx(paste("*", tools::file_ext(target), sep = ".")), 
      ignore.case = TRUE, full.names = TRUE)
  } else {
    targets <- target
  }

  yaml <- NULL
  
  # check for a known encoding
  encoding <- getOption("encoding")
  properties <- .rs.getSourceDocumentProperties(target)
  if (!is.null(properties$encoding))
     encoding <- properties$encoding
  
  # attempt to parse yaml front matter
  yaml <- tryCatch(
     rmarkdown::yaml_front_matter(target, encoding = encoding),
     error = function(e) NULL
  )
  
  # if this failed, try again as UTF-8
  if (is.null(yaml) && !identical(encoding, "UTF-8"))
  {
     yaml <- tryCatch(
        rmarkdown::yaml_front_matter(target, encoding = "UTF-8"),
        error = function(e) NULL
     )
  }
  
  # check to see if the target has "runtime: shiny/prerendred", if so then
  # return a full directory deploy list
  if (is.list(yaml) && (identical(yaml$runtime, "shiny_prerendered") ||
                        identical(yaml$runtime, "shinyrmd") ||
                        identical(yaml$server, "shiny") ||
                        (is.list(yaml$server) && identical(yaml$server$type, "shiny"))
                       )
     )
  {
    return(rsconnect::listBundleFiles(appDir = dirname(target)))
  }

  # find the resources used by each document
  for (t in targets) {
    deploy_frame <- NULL
    tryCatch({
      # this operation can be expensive and could also throw if e.g. the 
      # document fails to parse or render
      deploy_frame <- rmarkdown::find_external_resources(t) 
    },
    error = function(e) {
      # errors are not fatal here; we just might miss some resources, which
      # the user will have to add manually
    })
    if (!is.null(deploy_frame)) {
      file_list <- c(file_list, deploy_frame$path)
    } 
    file_list <- c(file_list, basename(t))
  }

  if (nzchar(quartoSrcFile)) {
    # query quarto for project and resources
    project <- .rs.quartoFileProject(quartoSrcFile)
    resources <- project$resources
    project <- project$project
    
    # query quarto for resources
    file_list <- c(file_list, resources)

    # per-directory option may be given in _metadata.yml
    if (file.exists(file.path(dirname(quartoSrcFile), "_metadata.yml"))) {
      file_list <- c(file_list, "_metadata.yml")
    }
    
    if (length(project)) {
      if (identical(project, "")) {
        file_list <- c(file_list, "_quarto.yml")
      } else {
        file_list <- c(file_list, file.path(project, "_quarto.yml"))
      }
    }
  }

  # discard any duplicates (the same resource may be depended upon by multiple
  # R Markdown documents)
  file_list <- unique(file_list)

  # compose the result
  list(
    contents = file_list,
    totalSize = sum(
       file.info(file.path(dirname(target), file_list))$size))
})

.rs.addFunction("makeDeploymentList", function(target, asMultipleDoc, 
                                               quartoSrcFile, max_size) {
   ext <- tolower(tools::file_ext(target))
   if (ext %in% c("qmd", "rmd", "html", "htm", "md"))
     .rs.docDeployList(target, asMultipleDoc, quartoSrcFile)
   else
     rsconnect::listBundleFiles(appDir = target)
})

.rs.addFunction("quartoFileResources", function(target) {
   .Call("rs_quartoFileResources", target)
})

.rs.addFunction("quartoFileProject", function(target) {
   .Call("rs_quartoFileProject", basename(target), dirname(target), PACKAGE = "(embedding)")
})

# Given a list of files of the form:
# 
# file2.ext
# dir/file1.ext
# dir/file2.ext
# dir/file3.ext
# dir/subdir/file4.ext
# dir2/file2.ext
# 
# and a threshold, collapses all directories that contain more than the threshold
# number of files. For instance, if threshold = 2, the result from the above
# would be:
# 
# file2.ext
# dir2/file2.ext
# dir/

.rs.addFunction("summarizeDir", function(files, threshold) {
  # extract the subdir using a regex
  prefixes <- regexec("^([^/])+/", files)

  # extract the matching text to form a list of top-level subdirs; skip files
  # with no prefix
  prefixes <- lapply(regmatches(x = files, m = prefixes), `[`, 1)
  prefixes[is.na(prefixes)] <- ""

  # get a list of top-level directories
  toplevel <- sort(unlist(prefixes))

  # get a count of the number of files in each top-level dir
  counts <- rle(toplevel)

  # for those dirs which have more than the threshold, hide all of the contents
  rollups <- which(counts$lengths > threshold)
  include <- rep_len(TRUE, length(files))
  for (rollup in rollups) {
    if (nzchar(counts$values[rollup]))
       include <- include & prefixes != counts$values[rollup]
  }

  # combine the files to be included with the top-level directories that were
  # rolled up
  toplevel <- counts$values[rollups]
  c(files[include], toplevel[nzchar(toplevel)])
})

.rs.addFunction("rsconnectDeployList", function(target, asMultipleDoc, quartoSrcFile) {
  max_size <- getOption("rsconnect.max.bundle.size", 1048576000)
  dirlist <- .rs.makeDeploymentList(target, asMultipleDoc, quartoSrcFile, max_size)

  list (
    # if the directory is too large, no need to bother sending a potentially
    # large blob of data to the client
    dir_list = if (dirlist$totalSize >= max_size)
                  NULL 
               else
                  .rs.summarizeDir(dirlist$contents, 5),
    max_size = .rs.scalar(max_size), 
    dir_size = .rs.scalar(dirlist$totalSize))
})

.rs.addFunction("enableRStudioConnectUI", function(enable) {
  .rs.enqueClientEvent("enable_rstudio_connect", enable);
  message("Posit Connect UI ", if (enable) "enabled" else "disabled", ".")
  invisible(enable)
})

.rs.addFunction("hasConnectAccount", function() {
   tryCatch({
      # check for any non-shinyapps.io accounts
      accounts <- rsconnect::accounts()
      subset(accounts, !(server %in% c("shinyapps.io", "rstudio.cloud", "posit.cloud")))
      .rs.scalar(nrow(accounts) > 0)
   }, error = function(e) { FALSE })
})


.rs.addJsonRpcHandler("get_deployment_files", function(target, asMultipleDoc, quartoSrcFile) {
  .rs.rsconnectDeployList(target, asMultipleDoc, quartoSrcFile)
})

# The parameter to this function is a string containing the R command from
# the rsconnect service; we just need to parse and execute it directly.
# The client is responsible for verifying that the statement corresponds to
# a valid ::setAccountInfo command.
.rs.addJsonRpcHandler("connect_rsconnect_account", function(accountCmd) {
   cmd <- parse(text=accountCmd)
   eval(cmd, envir = globalenv())
})


.rs.addFunction("getRmdPublishDetails", function(target, encoding) {

  # read yaml
  lines <- readLines(target, encoding = encoding, warn = FALSE)
  frontMatter <- rmarkdown:::parse_yaml_front_matter(lines)

  # if this is runtime: shiny_prerendered then is_multi_rmd is FALSE
  if (is.list(frontMatter) &&
      (identical(frontMatter$runtime, "shiny_prerendered") ||
       identical(frontMatter$runtime, "shinyrmd") ||
       identical(frontMatter$server, "shiny") ||
       (is.list(frontMatter$server) && identical(frontMatter$server$type, "shiny")))) {
    is_multi_rmd <- FALSE
  } else {
    # check for multiple R Markdown documents in the directory
    rmds <- list.files(path = dirname(target), pattern = glob2rx("*.Rmd"),
                       all.files = FALSE, recursive = FALSE, ignore.case = TRUE,
                       include.dirs = FALSE)
    is_multi_rmd <- length(rmds) > 1
  }

  # see if this format is self-contained (defaults to true for HTML-based 
  # formats)
  selfContained <- TRUE
  outputFormat <- rmarkdown:::output_format_from_yaml_front_matter(lines)
  if (is.list(outputFormat$options) &&
      identical(outputFormat$options$self_contained, FALSE)) {
    selfContained <- FALSE
  }

  # extract the document's title
  title <- ""
  if (is.list(frontMatter) && is.character(frontMatter$title)) {
    title <- frontMatter$title
  }

  # check to see if this is an interactive doc (i.e. needs to be run rather
  # rather than rendered)
  renderFunction <- .rs.getCustomRenderFunction(target)

  list(
    is_multi_rmd        = .rs.scalar(is_multi_rmd),
    is_shiny_rmd        = .rs.scalar(renderFunction == "rmarkdown::run"),
    is_self_contained   = .rs.scalar(selfContained),
    title               = .rs.scalar(title),
    has_connect_account = .rs.scalar(.rs.hasConnectAccount()))
})

# indicates whether there appear to be accounts registered on the system that
# cannot be used because the rsconnect package isn't installed
.rs.addJsonRpcHandler("has_orphaned_accounts", function() {
  # get the folder in which we expect account data to exist
  accountDir <- .rs.connectConfigDir("rsconnect", "accounts")

  # if this folder doesn't exist, check the old location
  if (!file.exists(accountDir))
    accountDir <- .rs.connectConfigDir("connect", "accounts")

  # if we found a config folder, list all regular files (not directories) inside
  # it
  if (file.exists(accountDir)) {
    files <- list.files(accountDir, recursive = TRUE, include.dirs = FALSE)

    # if there are files and the rsconnect package isn't installed at all, 
    # consider those files to correspond to orphaned accounts
    if (length(files) > 0 && !.rs.isPackageInstalled("rsconnect")) {
      return(.rs.scalar(length(files)))
    }
  }

  return(.rs.scalar(0))
})

.rs.addJsonRpcHandler("get_server_urls", function() {
  servers <- rsconnect::servers()

  # convert from factors if necessary
  for (col in c("name", "url")) {
    if (col %in% colnames(servers)) {
      servers[[col]] <- as.character(servers[[col]])
    }
  }
  .rs.scalarListFromFrame(servers)
})

.rs.addJsonRpcHandler("generate_app_name", function(appTitle, appPath, account) {
  name  <- ""
  valid <- TRUE
  error <- ""

  # attempt to generate a name from the title
  tryCatch({
    name <- rsconnect::generateAppName(appTitle = appTitle, 
                                       appPath  = appPath, 
                                       account  = account)
  }, error = function(e) {
    valid <<- FALSE
    error <<- e$message
  })
  
  # report result
  list(name  = .rs.scalar(name),
       valid = .rs.scalar(valid),
       error = .rs.scalar(error))
})

#
# SessionRUtil.R
#
# Copyright (C) 2009-17 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("isNullExternalPointer", function(object)
{
   .Call("rs_isNullExternalPointer", object, PACKAGE = "(embedding)")
})

.rs.addFunction("readIniFile", function(filePath)
{
   as.list(.Call("rs_readIniFile", filePath))
})

.rs.addFunction("runAsyncRProcess", function(
   code,
   workingDir  = getwd(),
   onStarted   = function() {},
   onContinue  = function() {},
   onStdout    = function(output) {},
   onStderr    = function(output) {},
   onCompleted = function(exitStatus) {})
{
   callbacks <- list(
      started   = onStarted,
      continue  = onContinue,
      stdout    = onStdout,
      stderr    = onStderr,
      completed = onCompleted
   )
   
   .Call(
      "rs_runAsyncRProcess",
      as.character(code),
      normalizePath(workingDir, mustWork = TRUE),
      as.list(callbacks),
      PACKAGE = "(embedding)"
   )
})

#
# SessionConnectionsInstaller.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("odbcBundleOsName", function() {
   osMapping <- list (
      linux = "linux",
      windows = "windows",
      darwin = "osx"
   )
   
   if (!tolower(Sys.info()["sysname"]) %in% names(osMapping))
      stop("Operating system \"", Sys.info()["sysname"], "\" is unsupported.")
   
   osMapping[[tolower(Sys.info()[["sysname"]])]]
})

.rs.addFunction("odbcOsBitness", function() {
   if (grepl("64", Sys.info()["machine"])) {
      "64"
   }
   else {
      "32"
   }
})

.rs.addFunction("odbcIsWow", function() {
   identical(tolower(Sys.info()["sysname"])[[1]], "windows") &&
      identical(.rs.odbcOsBitness(), "32") &&
      nchar(Sys.getenv("ProgramW6432")) > 0
})

.rs.addFunction("odbcBundleName", function(placeholder) {
   osName <- .rs.odbcBundleOsName()
   bitness <- .rs.odbcOsBitness()
   
   bundleName <- gsub("\\(os\\)", osName, placeholder)
   bundleName <- gsub("\\(bitness\\)", bitness, bundleName)
   
   bundleName
})

.rs.addFunction("odbcBundleDownload", function(url, placeholder, bundleTemp) {
   bundleName <- .rs.odbcBundleName(placeholder)
   bundleUrl <- file.path(url, bundleName)
   
   if (exists(bundleTemp)) unlink(bundleTemp, recursive = TRUE)
   dir.create(bundleTemp, recursive = TRUE)
   
   bundleFileTemp <- file.path(bundleTemp, bundleName)
   download.file(bundleUrl, bundleFileTemp)
   
   bundleFileTemp
})

.rs.addFunction("odbcBundleExtract", function(bundleFileTemp, installPath) {
   untar(bundleFileTemp, exdir = installPath)
})

.rs.addFunction("odbcBundleCheckPrereqsUnixodbc", function() {
   identical(
      suppressWarnings(
         system2(
            "odbcinst",
            stdout = getOption("odbc.installer.verbose", FALSE),
            stderr = getOption("odbc.installer.verbose", FALSE)
         )
      ),
      1L
   )
})

.rs.addFunction("odbcBundleCheckPrereqsBrew", function() {
   identical(
      suppressWarnings(
         system2(
            "brew",
            stdout = getOption("odbc.installer.verbose", FALSE),
            stderr = getOption("odbc.installer.verbose", FALSE)
         )
      ),
      1L
   )
})

.rs.addFunction("odbcBundleCheckPrereqsOsx", function() {
   if (!.rs.odbcBundleCheckPrereqsUnixodbc()) {
      if (!.rs.odbcBundleCheckPrereqsBrew()) {
         stop(
            "unixODBC is required but missing, you can install from http://www.unixodbc.org/. ",
            "Alternatively, install Brew and RStudio will install unixODBC automatically, ",
            "you can install Brew by running: ",
            "/usr/bin/ruby -e \"$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/install)\""
         )
      }
      
      message("Installing unixODBC...")
      system2(
         "brew",
         args = list("install", "unixodbc")
      )
   }
   
   if (!.rs.odbcBundleCheckPrereqsUnixodbc())
      stop("Failed to install unixODBC, please install from www.unixodbc.org")
})

.rs.addFunction("odbcBundleCheckPrereqsLinux", function() {
   if (!.rs.odbcBundleCheckPrereqsUnixodbc())
      stop("unixODBC is not installed, please install from www.unixodbc.org")
})

.rs.addFunction("odbcBundleRegistryAdd", function(entries) {
   validateEntry <- function(entry) {
      tryCatch({
         verify <- readRegistry(entry$path, "HLM", view = .rs.odbcOsBitness())
         identical(verify[[entry$key]], entry$value)
      }, error = function(e) {
         FALSE
      })
   }

   odbcFileEscape <- function(value) {
    gsub("\\\\", "\\\\\\\\", value)
   }

   if (all(sapply(entries, function(e) validateEntry(e))))
      return()

   bitness <- .rs.odbcOsBitness()

   allAdded <- TRUE
   for (entry in entries) {
     fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")
     system2(
        "REG",
        args = list(
           "ADD",
           shQuote(fullPath),
           "/v",
           shQuote(entry$key),
           "/t",
           "REG_SZ",
           "/d",
           shQuote(entry$value),
           "/f",
           paste("/reg:", bitness, sep = "")
        ),
        stdout = getOption("odbc.installer.verbose", FALSE),
        stderr = getOption("odbc.installer.verbose", FALSE)
     )

     if (!validateEntry(entry)) {
      allAdded <- FALSE
      break
     }
   }

   if (!allAdded) {
      if (.rs.odbcIsWow()) {
         stop("Failed to install x86 driver in x64 machine, retry running as administrator.")
      }

      message("Could not add registry keys from R, retrying using registry prompt.")
      addReg <- tempfile(fileext = ".reg")

      lineEntries <- sapply(entries, function(entry) {
         fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")
         c(
            paste("[", fullPath, "]", sep = ""),
            paste(
               "\"",
               entry$key,
               "\"=\"",
               odbcFileEscape(entry$value),
               "\"",
               sep = ""
            ),
            ""
         )
      })

      lines <- c(
         "REGEDIT4",
         "",
         lineEntries
      )

      writeLines(lines, addReg)

      message("Waiting for ", addReg, " to be registered.")
      system2(
         "explorer",
         addReg
      )

      allEntriesValid <- function() {
        all(sapply(entries, function(e) validateEntry(e)))
      }

      registryStart <- Sys.time()
      registryWait <- 30
      while (!allEntriesValid() && Sys.time() < registryStart + registryWait) {
         Sys.sleep(1)
         cat(".")
      }

      if (!allEntriesValid()) {
         stop("Failed to add all registry keys using registry file.")
      }
   }
})

.rs.addFunction("odbcBundleRegistryRemove", function(entries) {
   validateEntry <- function(entry) {
      tryCatch({
         regEntry <- readRegistry(entry$path, "HLM", view = .rs.odbcOsBitness())
         if (!is.null(entry$key))
            is.null(regEntry[[entry$key]])
         else
            FALSE
      }, error = function(e) {
         TRUE
      })
   }

   if (all(sapply(entries, function(e) validateEntry(e))))
      return()

   bitness <- .rs.odbcOsBitness()

   for (entry in entries) {
      fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")

      if (!is.null(entry$key)) {
         regArgs <- list(
            "DELETE",
            shQuote(fullPath),
            "/v",
            shQuote(entry$key),
            "/f",
            paste("/reg:", bitness, sep = "")
         )
      }
      else {
         regArgs <- list(
            "DELETE",
            shQuote(fullPath),
            "/f",
            paste("/reg:", bitness, sep = "")
         )
      }

      system2(
         "REG",
         args = regArgs
      )
   }

   if (all(sapply(entries, function(e) validateEntry(e))))
      return()

   addReg <- tempfile(fileext = ".reg")

   lineEntries <- sapply(entries, function(entry) {
      fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")

      if (is.null(entry$key)) {
         paste("[-", fullPath, "]", sep = "")
      }
      else {
         c(
            paste("[", fullPath, "]", sep = ""),
            paste(
               "\"",
               entry$key,
               "\"=-",
               sep = ""
            ),
            ""
         )
      }
   })

   lines <- c(
      "REGEDIT4",
      "",
      unlist(lineEntries)
   )

   writeLines(lines, addReg)
   system2(
      "explorer",
      addReg
   )
})

.rs.addFunction("odbcBundleRegistryDelete", function(path) {
   system2(
      "REG",
      args = list(
         "DELETE",
         shQuote(path),
         "/f"
      )
   )
   
   identical(ret, 0L)
})

.rs.addFunction("odbcBundleCheckPrereqsWindows", function() {
})

.rs.addFunction("odbcBundleCheckPrereqs", function() {
   osPrereqs <- list(
      osx = .rs.odbcBundleCheckPrereqsOsx,
      windows = .rs.odbcBundleCheckPrereqsWindows,
      linux = .rs.odbcBundleCheckPrereqsLinux
   )
   
   prereqs <- osPrereqs[[.rs.odbcBundleOsName()]]
   prereqs()
})

.rs.addFunction("odbcBundleOdbcinstPathWithOdbcinst", function() {
   config <- system2("odbcinst", "-j", stdout = TRUE)
   odbciniEntry <- config[grepl("odbcinst.ini", config)]
   gsub("^[^/\\\\]*", "", odbciniEntry)
})

.rs.addFunction("odbcBundleOdbcinstPathUseHome", function() {
   normalizePath("~/.odbcinst.ini", mustWork = FALSE)
})

.rs.addFunction("odbcBundleOdbcinstPath", function() {
   osOdbcinstPath <- list(
      osx = .rs.odbcBundleOdbcinstPathWithOdbcinst,
      windows = .rs.odbcBundleOdbcinstPathWithOdbcinst,
      linux = .rs.odbcBundleOdbcinstPathUseHome
   )

   osOdbcinstPath[[.rs.odbcBundleOsName()]]()
})

.rs.addFunction("odbcBundleReadIni", function(odbcinstPath) {

   # return nothing if file doesn't exist
   if (!file.exists(odbcinstPath))
      return(list())

   lines <- readLines(odbcinstPath)
   data <- list()
   
   currentDriver <- "__header__"
   
   for (line in lines) {
      # Is header?
      if (grepl("^ *\\[[^]]+\\] *", line)) {
         currentDriver <- gsub("^ *\\[|\\] *", "", line)
         data[[currentDriver]] <- ""
      }
      else if (!grepl("^ *$", line)) {
         if (identical(data[[currentDriver]], ""))
            data[[currentDriver]] <- line
         else
            data[[currentDriver]] <- c(
               data[[currentDriver]],
               line
            )
      }
   }
   
   data
})

.rs.addFunction("odbcBundleWriteIni", function(odbcinstPath, data) {
   lines <- c()
   for (name in names(data)) {
      lines <- c(
         lines, 
         if (identical(name, "__header__")) 
            ""
         else
            paste("[", name, "]", sep = "")
      )
      
      lines <- c(
         lines,
         unlist(data[[name]]),
         ""
      )
   }
   
   if (is.null(lines)) lines <- c("")

   writeLines(lines, odbcinstPath)
})

.rs.addFunction("odbcOdbcInstLibPath", function() {
   odbcinstLib <- NULL

   odbcinstBin <- Sys.which("odbcinst")
   if (nchar(odbcinstBin) == 0) {
      warning("Could not find path to odbcinst.")
   }
   else {
      odbcinstLink <- Sys.readlink(odbcinstBin)
      if (!is.na(odbcinstLink)) {
         odbcinstBinPath <- normalizePath(file.path(dirname(odbcinstBin), dirname(odbcinstLink)))
         odbcinstLibPath <- normalizePath(file.path(odbcinstBinPath, "..", "lib"))
         odbcinstLib <- dir(odbcinstLibPath, pattern = "libodbcinst.*\\.dylib", full.names = TRUE)[[1]]
      }
   }

   odbcinstLib
})

.rs.addFunction("odbcBundleRegisterLinux", function(name, driverPath, version, installPath) {
   # Find odbcinst.ini file
   odbcinstPath <- .rs.odbcBundleOdbcinstPath()
   
   # Read odbcinst.ini
   odbcinst <- .rs.odbcBundleReadIni(odbcinstPath)
   
   # Set odbcinst.ini entries
   odbcinst[[name]] <- list(
      paste("Driver", "=", driverPath),
      paste("Version", "=", version),
      paste("Installer", "=", "RStudio")
   )
   
   # Write odbcinst.ini
   .rs.odbcBundleWriteIni(odbcinstPath, odbcinst)
})

.rs.addFunction("odbcBundleDriverIniPath", function(name, driverPath) {
   dir(driverPath, pattern = paste(tolower(name), ".*\\.ini", sep = ""), recursive = TRUE, full.names = T)
})

.rs.addFunction("odbcBundleRegisterOSX", function(name, driverPath, version, installPath) {
   # Update odbcinst.ini
   .rs.odbcBundleRegisterLinux(name, driverPath, version, installPath)

   # Find driver.ini file
   driverIniFile <- .rs.odbcBundleDriverIniPath(name, installPath)
   
   if (length(driverIniFile) == 0) {
      warning("Could not find '", name, "' driver INI file under: ", installPath)
   }
   else {
      # Read driver.ini
      driverIni <- .rs.odbcBundleReadIni(driverIniFile)

      # In OSX register to use unixODBC
      odbcinstLib <- .rs.odbcOdbcInstLibPath()
      if (!is.null(odbcinstLib)) {
         driverIni[["Driver"]] <- c(
            driverIni[["Driver"]],
            paste("ODBCInstLib", "=", odbcinstLib)
         )
      }
      
      # Write odbcinst.ini
      .rs.odbcBundleWriteIni(driverIniFile, driverIni)
   }
})

.rs.addFunction("odbcBundleRegisterWindows", function(name, driverPath, version, installPath) {
   .rs.odbcBundleRegistryAdd(
      list(
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", "ODBC Drivers", fsep = "\\"),
            key = name,
            value = "installed"
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Driver",
            value = driverPath
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Setup",
            value = driverPath
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Version",
            value = version
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Installer",
            value = "RStudio"
         )
      )
   )
})

.rs.addFunction("odbcBundleFindDriver", function(name, installPath, libraryPattern) { 
   osExtensions <- list(
      osx = "dylib$",
      windows = "dll$",
      linux = "so$"
   )
   
   osExtension <- osExtensions[[.rs.odbcBundleOsName()]]
   driverName <- gsub(paste(" |", trimws(.rs.connectionOdbcRStudioDriver()), sep = ""), "", name)
   
   if (is.null(libraryPattern) || nchar(libraryPattern) == 0) {
      libraryPattern <- paste(
         driverName,
         "[^/\\\\]+\\.",
         osExtension,
         sep = ""
      )
   }

   # apply dynamic patterns
   osName <- .rs.odbcBundleOsName()
   bitness <- .rs.odbcOsBitness()
   libraryPattern <- gsub("\\(os\\)", osName, libraryPattern)
   libraryPattern <- gsub("\\(bitness\\)", bitness, libraryPattern)
   
   allFiles <- dir(installPath, recursive = TRUE, full.names = TRUE)
   driverPath <- allFiles[grepl(libraryPattern, allFiles, ignore.case = TRUE)]

   if (!identical(length(driverPath), 1L))
      stop("Failed to find ", library, " inside driver bundle.")
   
   normalizePath(driverPath)
})

.rs.addFunction("odbcBundleRegister", function(name, driverPath, version, installPath) {
   osRegistrations <- list(
      osx = .rs.odbcBundleRegisterOSX,
      windows = .rs.odbcBundleRegisterWindows,
      linux = .rs.odbcBundleRegisterLinux
   )
   
   osRegistration <- osRegistrations[[.rs.odbcBundleOsName()]]
   
   osRegistration(name, driverPath, version, installPath) 
})

.rs.addFunction("odbcBundleValidate", function(bundleFile, md5) {
   if (!is.null(md5) && nchar(md5) > 0) {
      validMd5s <- strsplit(as.character(md5), "[ \n,]+")[[1]]
      bundleMd5 <- tools::md5sum(bundleFile)
      if (!bundleMd5 %in% validMd5s) {
         stop("Failed to validate bundle with signature ", md5, " but got ", bundleMd5, " instead.")
      }
   }
})

.rs.addFunction("odbcBundleInstall", function(
   name,
   url,
   placeholder,
   installPath,
   libraryPattern = NULL,
   md5 = NULL,
   version = "") {

   installPath <- file.path(
      normalizePath(installPath, mustWork = FALSE),
      tolower(name)
   )
   
   bundleTemp <- tempfile()
   on.exit(unlink(bundleTemp, recursive = TRUE), add = TRUE)

   message("Installing")
   message("  Driver: ", name)
   message("  Version: ", version)
   message("  Path: ", installPath)

   message("Checking prerequisites")
   .rs.odbcBundleCheckPrereqs()
   
   message("Downloading bundle")
   bundleFileTemp <- .rs.odbcBundleDownload(url, placeholder, bundleTemp)

   message("Validating bundle")
   .rs.odbcBundleValidate(bundleFileTemp, md5)
   
   message("Extracting bundle")
   .rs.odbcBundleExtract(bundleFileTemp, installPath)
   
   message("Inspecting driver")
   driverPath <- .rs.odbcBundleFindDriver(name, installPath, libraryPattern)
   
   message("Registering driver")
   .rs.odbcBundleRegister(name, driverPath, version, installPath)

   message("")
   message("Installation complete")

   invisible(NULL)
})

.rs.addFunction("connectionOdbcRStudioDriver", function() {
   " with RStudio Driver"
})

#
# This is a Shiny web application. You can run the application by clicking
# the 'Run App' button above.
#
# Find out more about building applications with Shiny here:
#
#    http://shiny.rstudio.com/
#

library(shiny)

# Define UI for application that draws a histogram
ui <- fluidPage(

    # Application title
    titlePanel("Old Faithful Geyser Data"),

    # Sidebar with a slider input for number of bins 
    sidebarLayout(
        sidebarPanel(
            sliderInput("bins",
                        "Number of bins:",
                        min = 1,
                        max = 50,
                        value = 30)
        ),

        # Show a plot of the generated distribution
        mainPanel(
           plotOutput("distPlot")
        )
    )
)

# Define server logic required to draw a histogram
server <- function(input, output) {

    output$distPlot <- renderPlot({
        # generate bins based on input$bins from ui.R
        x    <- faithful[, 2]
        bins <- seq(min(x), max(x), length.out = input$bins + 1)

        # draw the histogram with the specified number of bins
        hist(x, breaks = bins, col = 'darkgray', border = 'white')
    })
}

# Run the application 
shinyApp(ui = ui, server = server)

#
# SessionDataImport.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("parseDataFile", function(path, encoding, header, sep, dec, 
                                          quote, comment, nrows) {
   data <- tryCatch(
      # try to use read.csv directly if possible (since this is a common case
      # and since LibreOffice spreadsheet exports produce files unparsable
      # by read.table). check Workspace.makeCommand if we want to deduce
      # other more concrete read calls.
      if (identical(sep,",") && identical(dec,".") && identical(quote,"\""))
         read.csv(path, encoding=encoding, header=header, nrows=nrows,
                  comment.char=comment)
      else
         read.table(path, encoding=encoding, header=header, sep=sep, dec=dec, 
                    quote=quote, comment.char=comment, nrows=nrows),
      error=function(e) {
         data.frame(Error=e$message)
      })

   oldWidth <- options('width')$width
   options(width=1000)
   output <- format(data)
   options(width=oldWidth)
   return(output)
})

.rs.addJsonRpcHandler("download_data_file", function(url)
{
   # download the file
   downloadPath <- tempfile("data")
   download.file(url, downloadPath)

   # return the path
   downloadInfo <- list()
   downloadInfo$path = downloadPath

   # also return a suggested variable name
   downloadInfo$varname <- "dataset"
   urlBasename <- basename(url)
   if (length(urlBasename) > 0)
   {
      fileComponents <- unlist(strsplit(urlBasename, ".", fixed = TRUE))
      components <- length(fileComponents)
      if (components >= 1)
         downloadInfo$varname <- paste(fileComponents[1:components-1],
                                       collapse=".")
   }

   return (downloadInfo)
})

.rs.addJsonRpcHandler("get_data_preview", function(path)
{
   nrows <- 20

   lines <- readLines(path, n=nrows, warn=F)

   # Drop comment lines, leaving the significant ones
   siglines <- grep("^[^#].*", lines, value=TRUE)

   # If any comment lines were found, presume # to be the comment character
   comment <- ""
   if (length(siglines) < length(lines)) {
     comment <- "#"
   } 

   firstline <- siglines[1]

   dataline <- siglines[2]
   if (is.na(dataline) || length(grep("[^\\s]+", dataline)) == 0)
      dataline <- firstline

   sep <- ''
   if (length(grep("\\t", firstline)) > 0) {
      sep <- "\t"
   } else if (length(grep(";", firstline)) > 0) {
      sep <- ";"
   } else if (length(grep(",", firstline)) > 0) {
      sep <- ","
   }

   dec <- '.'
   if (length(grep("\\.", dataline)) == 0
         && length(grep(",", dataline)) > 0
         && sep != ",")
   {
      dec <- ','
   }

   header <- length(grep("[0-9]", firstline)) == 0

   quote <- "\""

   output <- .rs.parseDataFile(path,
                               encoding="unknown",
                               header=header,
                               sep=sep,
                               dec=dec,
                               quote=quote,
                               comment=comment,
                               nrows=nrows)

   list(inputLines=paste(lines, collapse="\n"),
        output=output,
        outputNames=names(output),
        encoding="unknown",
        header=header,
        separator=sep,
        decimal=dec,
        quote=quote,
        comment=comment,
        defaultStringsAsFactors=default.stringsAsFactors())
})

.rs.addJsonRpcHandler("get_output_preview", function(path, encoding, header,
                                                     sep, decimal, quote, 
                                                     comment)
{
   nrows <- 20
   output <- .rs.parseDataFile(path, encoding=encoding, header=header, sep=sep, 
                               dec=decimal, quote=quote, comment=comment, 
                               nrows=nrows)

   list(output=output,
        outputNames=names(output),
        header=header,
        encoding=encoding,
        separator=sep,
        quote=quote,
        comment=comment,
        defaultStringsAsFactors=default.stringsAsFactors())
})

`%||%` <- function(x, y) {
   if (is.null(x)) y else x
}

sprintf <- function(fmt, ...) {
   if (nargs() == 1L) fmt else base::sprintf(fmt, ...)
}

printf <- function(fmt, ...) {
   msg <- sprintf(fmt, ...)
   cat(msg, sep = "")
}

section <- function(fmt, ...) {
   msg <- sprintf(fmt, ...)
   printf("\n== %s\n", msg)
}

progress <- function(fmt, ...) {
   msg <- sprintf(fmt, ...)
   printf("-- %s\n", msg)
}

fatal <- function(fmt, ...) {

   msg <- sprintf(fmt, ...)
   if (interactive())
      stop(msg, call. = FALSE)

   printf("!!\n!! ERROR: %s\n!!\n", msg)
   quit(save = "no", status = 1, runLast = TRUE)

}

path_program <- function(name) {

   prog <- Sys.which(name)
   if (!nzchar(prog))
      fatal("failed to find %s on PATH", shQuote(name))

   prog

}

execBatch <- function(batchfile) {

   if (!file.exists(batchfile))
      fatal("batch file %s does not exist", shQuote(batchfile))

   # Execute the batch file and wait for completion
   output <- system2(
      command = "cmd",
      args    = c("/c", shQuote(batchfile)),
      stdout  = TRUE,
      stderr  = TRUE
   )

   # Check return status
   status <- attr(output, "status") %||% 0L
   if (status != 0L) {
      fmt <- "error executing %s [error code %i]\n%s\n"
      fatal(fmt, shQuote(batchfile), as.integer(status), output)
   }

   invisible(TRUE)
}

exec <- function(command, ..., output = NULL, dir = NULL) {

   # construct path to logfile
   if (is.null(output)) {
      dir <- dir %||% getOption("log.dir", default = getwd())
      prefix <- paste0(basename(command), "-output-")
      output <- paste(tempfile(prefix, dir), "txt", sep = ".")
   }

   # construct command line arguments
   dots <- list(...)
   splat <- unlist(rapply(dots, function(dot) {
      unlist(strsplit(dot, "[[:space:]]+"))
   }))

   # print command to console
   cmd <- paste(command, paste(splat, collapse = " "))
   printf("> %s\n", cmd)

   # run command
   output <- suppressWarnings(
      system2(
         command = command,
         args    = splat,
         stdout  = output,
         stderr  = output
      )
   )

   # retrieve status, accommodating fact that form of output depends on
   # what we passed to 'stdout' and 'stderr'
   status <- if (is.integer(output)) {
      output
   } else {
      attr(output, "status") %||% 0L
   }

   # report status
   if (status) {

      msg <- paste0("Command exited with status ", as.integer(status), ".")

      # 'output' is a log file path by default, but is the captured output
      # itself (a character vector of lines) when the caller passed
      # 'output = TRUE'
      if (is.character(output)) {
         if (length(output) == 1L && file.exists(output)) {
            logmsg <- paste0("Logs written to ", output, ":\n")
            logmsg <- paste0(logmsg, paste(readLines(output), collapse = "\n"), "\n")
            msg <- paste(msg, logmsg, sep = "\n")
         } else {
            msg <- paste(msg, paste(output, collapse = "\n"), "", sep = "\n")
         }
      }

      fatal("%s\n", msg)

   }

   invisible(TRUE)
}

run <- function(...) {

   command <- paste(c(..., "2>&1"), collapse = " ")
   writeLines(paste(">", command))

   conn <- pipe(command, open = "rb")
   if (!isOpen(conn))
      fatal("execution of %s failed", command)

   while (TRUE) {
      output <- readLines(conn, n = 1L, skipNul = TRUE, warn = FALSE)
      writeLines(output)
      if (length(output) == 0)
         break
   }

   result <- close(conn)
   if (is.integer(result) && result != 0L)
      fatal("execution of %s failed [status %i]", command, result)

   invisible(result)

}

download <- function(url, destfile, ...) {
   fmt <- "Downloading file:\n- %s => %s"
   progress(fmt, shQuote(url), shQuote(destfile))
   exec("wget.exe", "--no-check-certificate", "-c", shQuote(url), "-O", shQuote(destfile))
}

PATH <- (function() {

   read <- function() {
      unlist(strsplit(Sys.getenv("PATH"), .Platform$path.sep, fixed = TRUE))
   }

   write <- function(path) {
      pasted <- paste(path, collapse = .Platform$path.sep)
      Sys.setenv(PATH = pasted)
      invisible(pasted)
   }

   prepend <- function(dir) {
      dir <- normalizePath(dir, mustWork = TRUE)
      path <- unique(c(dir, read()))
      write(path)
   }

   append <- function(dir) {
      dir <- normalizePath(dir, mustWork = TRUE)
      path <- unique(c(read(), dir))
      write(path)
   }

   remove <- function(dir) {
      dir <- normalizePath(dir, mustWork = TRUE)
      path <- setdiff(read(), dir)
      write(path)
   }

   list(
      read = read,
      prepend = prepend,
      append = append,
      remove = remove
   )

})()

enter <- function(dir) {
   progress("Entering directory %s", shQuote(dir))
   dir.create(dir, recursive = TRUE, showWarnings = FALSE)
   setwd(dir)
}

replace_one_line <- function(filepath, orig_line, new_line) {
   contents <- readLines(filepath)
   replaced <- gsub(orig_line, new_line, contents, fixed = TRUE)
   if (!identical(contents, replaced))
      writeLines(replaced, filepath)
}

interpolate <- function(string) {

   result <- string

   # get variable names used within the string
   starts <- gregexpr("{", string, perl = TRUE)[[1L]]
   ends <- gregexpr("}", string, perl = TRUE)[[1L]]
   exprs <- substring(string, starts + 1L, ends - 1L)

   # replace with their formatted values
   for (expr in exprs) {
      value <- eval(parse(text = expr), envir = parent.frame())
      pattern <- sprintf("{%s}", expr)
      replace <- paste(as.character(value), collapse = " ")
      result <- gsub(pattern, replace, result, fixed = TRUE)
   }

   result

}

initialize <- function() {

   # Make sure MSVC tools are available
   msvcCandidates <- c(
      "C:/Program Files/Microsoft Visual Studio/2022/BuildTools/VC/Auxiliary/Build",
      "C:/Program Files/Microsoft Visual Studio/2022/Community/VC/Auxiliary/Build",
      "C:/Program Files (x86)/Microsoft Visual Studio/2022/BuildTools/VC/Auxiliary/Build",
      "C:/Program Files (x86)/Microsoft Visual Studio/2022/Community/VC/Auxiliary/Build"
   )

   msvc <- Filter(file.exists, msvcCandidates)
   if (length(msvc) == 0L) {
      message <- paste(
         "No MSVC 2022 installation detected.",
         "Install build tools using 'Install-RStudio-Prereqs.ps1'."
      )
      fatal(message)
   }
   PATH$prepend(msvc[[1L]])

   # Make sure perl is available
   # try to find a perl installation directory
   perlCandidates <- c(
      "C:/Strawberry/perl/bin",
      "C:/Perl64/bin",
      "C:/Perl/bin"
   )

   perl <- Filter(file.exists, perlCandidates)
   if (length(perl) == 0L) {
      message <- paste(
         "No perl installation detected.",
         "Please install Strawberry Perl via 'choco install strawberryperl'."
      )
      fatal(message)
   }
   PATH$prepend(perl[[1L]])

}

initialize()

#
# test-packages.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

test_that(".rs.isPackageManagementCall detects namespace-qualified mutators", {
   # qualified calls use the literal namespace, so these hold whether or not the
   # packages are installed
   expect_true(.rs.isPackageManagementCall("renv::install(\"dplyr\")"))
   expect_true(.rs.isPackageManagementCall("renv::update()"))
   expect_true(.rs.isPackageManagementCall("renv::remove(\"dplyr\")"))
   expect_true(.rs.isPackageManagementCall("renv::restore()"))
   expect_true(.rs.isPackageManagementCall("renv::rebuild(\"dplyr\")"))
   expect_true(.rs.isPackageManagementCall("renv:::update()"))
   expect_true(.rs.isPackageManagementCall("utils::install.packages(\"dplyr\")"))
   expect_true(.rs.isPackageManagementCall("utils::remove.packages(\"dplyr\")"))
   expect_true(.rs.isPackageManagementCall("devtools::install_github(\"r-lib/cli\")"))
   expect_true(.rs.isPackageManagementCall("devtools::load_all(\".\")"))
   expect_true(.rs.isPackageManagementCall("remotes::install_version(\"dplyr\")"))
   expect_true(.rs.isPackageManagementCall("pak::pkg_install(\"dplyr\")"))
   expect_true(.rs.isPackageManagementCall("pacman::p_load(dplyr)"))
   expect_true(.rs.isPackageManagementCall("BiocManager::install(\"limma\")"))
})

test_that(".rs.isPackageManagementCall detects unqualified mutators from utils", {
   # utils is attached in a default session, so these bare calls resolve to it
   expect_true(.rs.isPackageManagementCall("install.packages(\"dplyr\")"))
   expect_true(.rs.isPackageManagementCall("update.packages()"))
   expect_true(.rs.isPackageManagementCall("remove.packages(\"dplyr\")"))
})

test_that(".rs.isPackageManagementCall ignores base R remove()/update()", {
   # base::remove removes objects and stats::update refits models; neither
   # mutates the package library, even though renv exports same-named functions
   expect_false(.rs.isPackageManagementCall("remove(x)"))
   expect_false(.rs.isPackageManagementCall("remove(x, y, z)"))
   expect_false(.rs.isPackageManagementCall("update(model)"))
   expect_false(.rs.isPackageManagementCall("update(fit, . ~ . + x)"))
   expect_false(.rs.isPackageManagementCall("base::remove(x)"))
   expect_false(.rs.isPackageManagementCall("stats::update(model)"))
})

test_that(".rs.isPackageManagementCall ignores non-mutating calls", {
   expect_false(.rs.isPackageManagementCall("str_remove_all(x)"))
   expect_false(.rs.isPackageManagementCall("stringr::str_remove_all(x)"))
   expect_false(.rs.isPackageManagementCall("installed.packages()"))
   expect_false(.rs.isPackageManagementCall("old.packages()"))
   expect_false(.rs.isPackageManagementCall("library(dplyr)"))
   expect_false(.rs.isPackageManagementCall("updates <- c(1, 2)"))
   # functions that are not in the registry for their namespace
   expect_false(.rs.isPackageManagementCall("pak::pkg_update(\"dplyr\")"))
   expect_false(.rs.isPackageManagementCall("renv::snapshot()"))
})

test_that(".rs.isPackageManagementCall ignores comments and strings", {
   expect_false(.rs.isPackageManagementCall("# remove this later"))
   expect_false(.rs.isPackageManagementCall("(t0 <- Sys.time()) # remove"))
   expect_false(.rs.isPackageManagementCall("x <- \"remove\""))
   expect_false(.rs.isPackageManagementCall("y <- \"renv::update()\""))
})

test_that(".rs.isPackageManagementCall handles multi-statement and nested calls", {
   expect_true(.rs.isPackageManagementCall("x <- 1; renv::update(); y <- 2"))
   expect_true(.rs.isPackageManagementCall("lapply(pkgs, function(p) install.packages(p))"))
   expect_false(.rs.isPackageManagementCall("x <- 1; print(remove(y)); z <- 3"))
})

test_that(".rs.isPackageManagementCall tolerates unparseable input", {
   expect_false(.rs.isPackageManagementCall(""))
   expect_false(.rs.isPackageManagementCall("install.packages("))
   expect_false(.rs.isPackageManagementCall("if (x"))
})

test_that(".rs.isPackageManagementCall does not force active bindings", {
   # resolving a bare call must not (re-)invoke an active binding, which could
   # run arbitrary user code as a side effect
   invoked <- 0L
   makeActiveBinding(
      "remove",
      function() { invoked <<- invoked + 1L; function(...) NULL },
      globalenv()
   )
   on.exit(rm("remove", envir = globalenv()), add = TRUE)

   expect_false(.rs.isPackageManagementCall("remove(x)"))
   expect_identical(invoked, 0L)
})

test_that(".rs.isPackageManagementCall does not force promises", {
   # a delayedAssign promise shadowing utils::install.packages must not be forced
   forced <- 0L
   delayedAssign(
      "install.packages",
      { forced <<- forced + 1L; function(...) NULL },
      assign.env = globalenv()
   )
   on.exit(rm("install.packages", envir = globalenv()), add = TRUE)

   expect_false(.rs.isPackageManagementCall("install.packages(x)"))
   expect_identical(forced, 0L)
})

#
# test-sql-preview.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("sql preview")

# parse a single expression the same way the connection classifier does
.rs.test.parseConn <- function(text)
{
   parse(text = text, keep.source = FALSE)[[1L]]
}

test_that(".rs.preview.isSafeExpr accepts benign connection expressions", {

   safe <- c(
      "con",                                       # plain symbol lookup
      "\"con\"",                                   # string literal
      "42",                                        # numeric literal
      "DBI::dbConnect(RSQLite::SQLite())",         # allow-listed constructors
      "dbConnect(odbc::odbc())",                   # bare allow-listed call
      "dbConnect(odbc::odbc(), pwd = Sys.getenv(\"PW\"))",
      "(DBI::dbConnect(RSQLite::SQLite()))",       # parenthesized
      "DBI::dbConnect"                             # namespace access, no call
   )

   for (expr in safe)
      expect_true(
         .rs.preview.isSafeExpr(.rs.test.parseConn(expr)),
         info = expr
      )

})

test_that(".rs.preview.isSafeExpr rejects arbitrary code", {

   unsafe <- c(
      "system(\"echo pwned\")",                    # the reported payload
      "base::system(\"echo pwned\")",              # qualification is not trust
      "getNamespace(\"base\")$system(\"x\")",
      "DBI::dbConnect(RSQLite::SQLite(), x = system(\"x\"))", # unsafe argument
      "list(system(\"x\"))",                       # nested in a pure helper
      "{ system(\"x\") }",                         # braces
      "eval(parse(text = \"system('x')\"))"
   )

   for (expr in unsafe)
      expect_false(
         .rs.preview.isSafeExpr(.rs.test.parseConn(expr)),
         info = expr
      )

})

test_that("active bindings are not treated as safe symbols", {

   name <- ".rs.test.activeConn"
   on.exit(if (exists(name, envir = globalenv())) rm(list = name, envir = globalenv()))

   makeActiveBinding(name, function() stop("active binding evaluated"), globalenv())
   expect_false(.rs.preview.isSafeExpr(as.symbol(name)))

   # a normal (inactive) binding of the same name is safe
   rm(list = name, envir = globalenv())
   assign(name, 1L, envir = globalenv())
   expect_true(.rs.preview.isSafeExpr(as.symbol(name)))

})

test_that("sites can extend the allowlist via the session option", {

   call <- .rs.test.parseConn("acmedb::connect(\"prod\")")

   # not allow-listed by default
   expect_identical(.rs.preview.exprStatus(call), "unsafe")

   # the 'preview-allowed-functions' session option is surfaced into this
   # cache var; populate it directly to mirror an administrator setting it
   .rs.setVar("preview.allowedFunctions", "acmedb::connect")
   on.exit(.rs.setVar("preview.allowedFunctions", NULL), add = TRUE)

   # an allow-listed callee makes the call safe, but its arguments are still
   # validated recursively
   expect_identical(.rs.preview.exprStatus(call), "safe")
   expect_identical(
      .rs.preview.exprStatus(.rs.test.parseConn("acmedb::connect(system(\"x\"))")),
      "unsafe"
   )

})

test_that("active bindings anywhere on the search path are unsafe", {

   # eval() resolves a symbol starting in the evaluation environment and
   # walking its enclosing environments, so an active binding in an enclosing
   # environment (not just the evaluation environment itself) must also be
   # rejected. Construct that chain directly rather than relying on attach(),
   # whose environment-copying semantics for active bindings vary by R version.
   name <- "rs_test_active"

   # active binding directly in the evaluation environment
   here <- new.env(parent = emptyenv())
   makeActiveBinding(name, function() stop("active binding evaluated"), here)
   expect_false(.rs.preview.isSafeExpr(as.symbol(name), envir = here))

   # active binding in an enclosing environment, reached by the search walk
   parent <- new.env(parent = emptyenv())
   makeActiveBinding(name, function() stop("active binding evaluated"), parent)
   child <- new.env(parent = parent)
   expect_false(.rs.preview.isSafeExpr(as.symbol(name), envir = child))

   # a plain (non-active) binding in an enclosing environment is a safe lookup
   parent2 <- new.env(parent = emptyenv())
   assign(name, 42, envir = parent2)
   child2 <- new.env(parent = parent2)
   expect_true(.rs.preview.isSafeExpr(as.symbol(name), envir = child2))

})

test_that("the per-session permitted set is honored and matches by structure", {

   expr <- .rs.test.parseConn("connectViaCustomHelper(profile = \"prod\")")
   expect_identical(.rs.preview.exprStatus(expr), "unsafe")

   .rs.preview.permitExpr(expr)
   on.exit(.rs.preview.permittedExprs$items <- NULL)

   # the same expression, parsed independently, must now be permitted
   reparsed <- .rs.test.parseConn("connectViaCustomHelper(profile = \"prod\")")
   expect_identical(.rs.preview.exprStatus(reparsed), "permitted")

   # a different expression remains unsafe
   other <- .rs.test.parseConn("connectViaCustomHelper(profile = \"dev\")")
   expect_identical(.rs.preview.exprStatus(other), "unsafe")

})

test_that("asDBIConnection refuses to evaluate unsafe connection strings", {

   skip_if_not_installed("DBI")

   marker <- "RS_SQL_PREVIEW_PWNED"
   Sys.unsetenv(marker)
   on.exit(Sys.unsetenv(marker))

   payload <- sprintf("Sys.setenv(%s = \"1\")", marker)
   expect_null(.rs.sql.asDBIConnection(payload))
   expect_identical(Sys.getenv(marker), "")

})

test_that("preview_sql blocks function-name injection in the header", {

   handler <- .rs.rpc.preview_sql

   # '-- !preview system(...)' builds a call whose function position is the
   # payload, bypassing any check that only inspects the 'conn' argument
   result <- handler("system(\"echo pwned\")")
   expect_identical(unclass(result$action), "error")
   expect_match(unclass(result$message), "Unsupported")

})

test_that("preview_sql prompts for unsafe connection expressions", {

   handler <- .rs.rpc.preview_sql

   code <- ".rs.previewSql(\"query.sql\", conn = system(\"echo pwned\"))"

   # without consent, the unsafe expression is not evaluated; the caller is
   # asked to confirm instead
   result <- handler(code, allow = FALSE)
   expect_identical(unclass(result$action), "confirm")

})

test_that("preview_sql rejects injection smuggled through extra arguments", {

   handler <- .rs.rpc.preview_sql

   code <- ".rs.previewSql(\"query.sql\", conn = con, params = system(\"echo pwned\"))"
   result <- handler(code, allow = FALSE)
   expect_identical(unclass(result$action), "error")
   expect_match(unclass(result$message), "Unsupported")

})

test_that("preview_sql does not prompt for safe connection expressions", {

   handler <- .rs.rpc.preview_sql

   # a bare symbol is a safe lookup; it should pass the consent gate and reach
   # evaluation (which here fails harmlessly, but is never a 'confirm')
   code <- ".rs.previewSql(\"query.sql\", conn = .rs.test.missingConnection)"
   result <- handler(code, allow = FALSE)
   expect_false(identical(unclass(result$action), "confirm"))

})

test_that("preview_r2d3 only consents to the r2d3::r2d3 call", {

   handler <- .rs.rpc.preview_r2d3

   # the function position must be r2d3::r2d3; anything else is rejected so the
   # callee cannot itself be used to inject code
   result <- handler("system(\"echo pwned\")")
   expect_identical(unclass(result$action), "error")
   expect_match(unclass(result$message), "Unsupported")

})

test_that("preview_r2d3 prompts for unsafe argument expressions", {

   handler <- .rs.rpc.preview_r2d3

   code <- "r2d3::r2d3(\"viz.js\", data = system(\"echo pwned\"))"
   result <- handler(code, allow = FALSE)
   expect_identical(unclass(result$action), "confirm")

})

test_that("preview_r2d3 allows statically-safe commands without prompting", {

   handler <- .rs.rpc.preview_r2d3

   code <- "r2d3::r2d3(\"viz.js\", data = c(0.3, 0.6, 0.8))"
   result <- handler(code, allow = FALSE)
   expect_identical(unclass(result$action), "ok")

})

test_that("preview_r2d3 rejects multi-statement input", {

   handler <- .rs.rpc.preview_r2d3

   # the front-end runs the command verbatim in the console, so a header that
   # closes the r2d3 call early and appends another statement must not classify
   # as safe: otherwise the classifier inspects only the first expression while
   # the console runs both. This is the reported bypass.
   code <- "r2d3::r2d3(\"viz.js\", height = 300); system(\"echo pwned\")"
   result <- handler(code, allow = FALSE)
   expect_false(identical(unclass(result$action), "ok"))
   expect_identical(unclass(result$action), "error")
   expect_match(unclass(result$message), "Unsupported")

   # even explicit consent must not turn multi-statement input into "ok"
   result <- handler(code, allow = TRUE)
   expect_identical(unclass(result$action), "error")

})

test_that("preview_r2d3 rejects a top-level brace block", {

   handler <- .rs.rpc.preview_r2d3

   # a single '{ ... }' statement parses to length 1, so the multi-statement
   # guard does not fire; the callee check rejects it instead (the function
   # position must be r2d3::r2d3, not '{')
   code <- "{ r2d3::r2d3(\"viz.js\"); system(\"echo pwned\") }"
   result <- handler(code, allow = FALSE)
   expect_identical(unclass(result$action), "error")
   expect_match(unclass(result$message), "Unsupported")

})

test_that("preview_r2d3 prompts for a brace block smuggled through an argument", {

   handler <- .rs.rpc.preview_r2d3

   # a brace block nested as an argument is a single statement with the right
   # callee, but '{' is not allow-listed, so the argument is unsafe and consent
   # is required before it can run
   code <- "r2d3::r2d3(\"viz.js\", data = { system(\"echo pwned\") })"
   result <- handler(code, allow = FALSE)
   expect_identical(unclass(result$action), "confirm")

})

test_that("preview_r2d3 permits an unsafe argument once the user consents", {

   handler <- .rs.rpc.preview_r2d3
   on.exit(.rs.preview.permittedExprs$items <- NULL)

   code <- "r2d3::r2d3(\"viz.js\", data = system(\"echo pwned\"))"

   # without consent the unsafe argument prompts
   expect_identical(unclass(handler(code, allow = FALSE)$action), "confirm")

   # with consent the handler permits the expression and reports it is safe to
   # run. The r2d3 handler only classifies; it never evaluates the command, so
   # 'system(...)' does not actually run here.
   expect_identical(unclass(handler(code, allow = TRUE)$action), "ok")

   # the consented argument is now permitted for the session, so a later
   # preview of the same command no longer prompts
   expect_identical(unclass(handler(code, allow = FALSE)$action), "ok")

})

test_that("preview_sql rejects multi-statement input", {

   handler <- .rs.rpc.preview_sql

   # symmetric with the r2d3 handler: a preview comment is a single call, so
   # reject trailing statements rather than silently dropping them
   code <- ".rs.previewSql(\"query.sql\", conn = con); system(\"echo pwned\")"
   result <- handler(code, allow = FALSE)
   expect_identical(unclass(result$action), "error")
   expect_match(unclass(result$message), "Unsupported")

})

test_that("preview_sql permits an unsafe connection once the user consents", {

   handler <- .rs.rpc.preview_sql
   on.exit(.rs.preview.permittedExprs$items <- NULL)

   # 'identity' is not allow-listed, so the connection expression is unsafe.
   # Evaluating it is harmless (it yields NULL, which previewSql reports as a
   # failed connection) but exercises the allow = TRUE permit-and-evaluate path.
   code <- ".rs.previewSql(\"query.sql\", conn = identity(NULL))"

   expect_identical(unclass(handler(code, allow = FALSE)$action), "confirm")

   # with consent the expression is permitted and evaluation proceeds (no
   # second prompt); it never returns "confirm" again
   expect_false(identical(unclass(handler(code, allow = TRUE)$action), "confirm"))
   expect_false(identical(unclass(handler(code, allow = FALSE)$action), "confirm"))

})

#
# SessionTutorial.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# State ----

.rs.setVar("tutorial.registry", new.env(parent = emptyenv()))



# JSON RPC ----
.rs.addJsonRpcHandler("tutorial_started", function(name, package, url)
{
   # tag the associated tutorial with the browser url
   tutorial <- .rs.tutorial.registryGet(name, package)
   tutorial[["browser_url"]] <- url
})

.rs.addJsonRpcHandler("tutorial_stop", function(url)
{
   tutorial <- .rs.tutorial.registryFind(url)
   if (is.null(tutorial))
      return(FALSE)
   
   .rs.tutorial.stopTutorial(
      name    = tutorial[["name"]],
      package = tutorial[["package"]]
   )
   
   TRUE
   
})

.rs.addJsonRpcHandler("tutorial_metadata", function(url)
{
   tutorial <- .rs.tutorial.registryFind(url)
   if (is.null(tutorial))
      return(list())
   
   .rs.scalarListFromList(as.list(tutorial))
})

# Methods ----

.rs.addFunction("tutorial.registryKey", function(name, package)
{
   paste(package, name, sep = "::")
})

.rs.addFunction("tutorial.registryCreate", function(name, package)
{
   # NOTE: we use an R environment here just so we can get reference semantics
   # (makes mutation of existing tutorial objects more straight-forward, which
   # is necessary as we'll need to tag tutorial objects with extra meta-data
   # after creation)
   tutorial <- as.environment(list(name = name, package = package))
   
   # store in registry
   key <- .rs.tutorial.registryKey(name, package)
   .rs.tutorial.registry[[key]] <- tutorial
   
   # return tutorial object
   tutorial
})

.rs.addFunction("tutorial.registryGet", function(name, package)
{
   key <- .rs.tutorial.registryKey(name, package)
   .rs.tutorial.registry[[key]]
})

.rs.addFunction("tutorial.registryFind", function(url)
{
   keys <- ls(envir = .rs.tutorial.registry)
   for (key in keys)
   {
      tutorial <- .rs.tutorial.registry[[key]]
      
      match <-
         identical(url, tutorial[["shiny_url"]]) ||
         identical(url, tutorial[["browser_url"]])
      
      if (match)
         return(tutorial)
   }
   
   NULL
   
})

# TODO: local jobs are stopped when the session is suspended, and so running
# tutorials are stopped as well. do we want to take the extra step to allow
# sessions to suspend with running tutorials active?
.rs.addFunction("tutorial.onSuspend", function(path)
{
})

.rs.addFunction("tutorial.onResume", function(path)
{
})

.rs.addFunction("tutorial.launchBrowser", function(url)
{
   # get the pending tutorial
   tutorial <- .rs.getVar("tutorial.pendingTutorial")
   .rs.clearVar("tutorial.pendingTutorial")
   
   # tag that tutorial with the shiny url
   tutorial[["shiny_url"]] <- url
   
   # open tutorial in pane
   meta <- .rs.scalarListFromList(tutorial)
   .rs.invokeShinyTutorialViewer(url, meta)
})

.rs.addFunction("tutorial.openExistingTutorial", function(name, package)
{
   # find tutorial in registry
   tutorial <- .rs.tutorial.registryGet(name, package)
   if (is.null(tutorial))
      return(FALSE)

   # get underlying shiny url
   url <- tutorial[["shiny_url"]]
   if (is.null(url))
      return(FALSE)   
   
   # check for an associated active job
   job <- tutorial[["job"]]
   running <- .rs.tryCatch(.Call("rs_isJobRunning", job, PACKAGE = "(embedding)"))
   if (!identical(running, TRUE))
      return(FALSE)
   
   # open tutorial in pane
   meta <- .rs.scalarListFromList(tutorial)
   .rs.invokeShinyTutorialViewer(url, meta)
   
   TRUE
})

.rs.addFunction("tutorial.runTutorial", function(name, package, shiny_args = NULL)
{
   # if we already have a running tutorial, just open the associated URL
   if (.rs.tutorial.openExistingTutorial(name, package))
      return()
   
   # install any required package dependencies before running tutorial
   .rs.tutorial.installPackageDependencies(name, package)
   
   # prepare the call to learnr to run the tutorial
   shiny_args$launch.browser <- quote(rstudioapi:::tutorialLaunchBrowser)
   
   call <- substitute(
      
      learnr::run_tutorial(
         name = name,
         package = package,
         shiny_args = shiny_args
      ),
      
      list(
         name = name,
         package = package,
         shiny_args = shiny_args
      )
      
   )
   
   # write to file
   deparsed <- deparse(call)
   path <- tempfile("rstudio-tutorial-", fileext = ".R")
   writeLines(deparsed, con = path)
   
   # run as job
   job <- .rs.api.runScriptJob(
      path = path,
      name = paste("Tutorial:", name),
      encoding = "UTF-8"
   )
   
   # register a tutorial object
   tutorial <- .rs.tutorial.registryCreate(name, package)
   
   # add job id
   tutorial[["job"]] <- job
   
   # set as pending
   .rs.setVar("tutorial.pendingTutorial", tutorial)
   
   invisible(job)
   
})

.rs.addFunction("tutorial.stopTutorial", function(name, package)
{
   # find tutorial in registry
   tutorial <- .rs.tutorial.registryGet(name, package)
   
   # stop its associated job
   .rs.api.stopJob(tutorial[["job"]])
   
   # remove from registry
   key <- .rs.tutorial.registryKey(name, package)
   .rs.tutorial.registry[[key]] <- NULL
})

.rs.addFunction("tutorial.enqueueClientEvent", function(type, data = list())
{
   eventData <- list(type = .rs.scalar(type), data = data)
   .rs.enqueClientEvent("tutorial_command", eventData)
})

.rs.addFunction("tutorial.findTutorials", function(pkgRoot)
{
   tutorialsRoot <- file.path(pkgRoot, "tutorials")
   if (!file.exists(tutorialsRoot))
      return(list())
   
   tutorialDirs <- sort(list.files(tutorialsRoot, full.names = TRUE))
   tutorials <- lapply(tutorialDirs, .rs.tutorial.findTutorialsImpl)
   Filter(Negate(is.null), tutorials)
   
})

.rs.addFunction("tutorial.findTutorialsImpl", function(tutorialDir)
{
   tutorialFiles <- list.files(
      tutorialDir,
      pattern = "[.]Rmd$",
      full.names = TRUE,
      ignore.case = TRUE
   )
   
   if (length(tutorialFiles) == 0)
      return(NULL)
   
   tutorialFile <- tutorialFiles[[1]]
   contents <- readLines(tutorialFile, encoding = "UTF-8", warn = FALSE)
   
   # find YAML header (if any). note that we avoid using rmarkdown here
   # just because we want to avoid loading the package and all its
   # recursive dependencies, as this could introduce issues for users
   # who need to update packages
   reYamlSeparator <- "^\\s*(?:---|[.][.][.])\\s*$"
   yamlSeparators <- grep(reYamlSeparator, contents)
   if (length(yamlSeparators) == 0)
      return(NULL)

   yamlRange <- seq.int(
      from       = yamlSeparators[[1]] + 1,
      length.out = yamlSeparators[[2]] - yamlSeparators[[1]] - 1
   )
   
   yamlCode <- paste(contents[yamlRange], collapse = "\n")
   yaml <- .Call("rs_fromYAML", yamlCode, PACKAGE = "(embedding)")
   
   title <- .rs.nullCoalesce(yaml$title, "")
   desc  <- .rs.nullCoalesce(yaml$description, "")
   
   list(
      name        = .rs.scalar(basename(tutorialDir)),
      file        = .rs.scalar(tutorialFile),
      title       = .rs.scalar(title),
      description = .rs.scalar(desc)
   )
})

.rs.addFunction("tutorial.installPackageDependencies", function(name, package)
{
   pkgs <- character()

   # form path to tutorial folder   
   path <- system.file("tutorials", name, package = package)
   if (!file.exists(path))
      return(character())
   
   # find dependencies
   deps <- renv::dependencies(path, quiet = TRUE)
   
   # ensure rstudioapi is included (required for communication between
   # the child R process hosting the tutorial + the main IDE session)
   pkgs <- sort(unique(c(deps$Package, c("learnr", "rstudioapi"))))
   
   # screen out some potentially invalid package names
   pkgs <- grep("^[a-zA-Z0-9._]+$", pkgs, value = TRUE)
   
   # find packages which are not installed
   installed <- vapply(pkgs, function(pkg) {
      location <- find.package(pkg, quiet = TRUE)
      length(location) > 0
   }, FUN.VALUE = logical(1))
   
   missing <- pkgs[!installed]
   if (length(missing) == 0)
      return(character())
   
   # ask user to install these packages
   title <- "Install Required Packages"
   message <- paste(
      "The following tutorial package dependencies are missing and will be installed:\n",
      paste("-", .rs.formatListForDialog(missing)),
      "\nWould you like to proceed?",
      sep = "\n"
   )
   
   ok <- .rs.api.showQuestion(title, message)
   if (!ok) {
      fmt <- "cannot run tutorial '%s'; required dependencies not installed"
      msg <- sprintf(fmt, name)
      stop(msg, call. = FALSE)
   }
 
   # write out call to console for user
   call <- substitute(
      install.packages(missing),
      list(missing = missing)
   )
   
   writeLines(paste(getOption("prompt"), format(call), sep = ""))
   eval(call, envir = globalenv())
   
})

#
# GlobalCallingHandlers.R
#
# Copyright (C) 2025 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#


# Make sure these are in sync with AnsiEscapes.hpp.
.rs.setVar("ansiEscapeGroup", list(
   error   = "\033G1;",
   warning = "\033G2;",
   message = "\033G3;",
   end     = "\033g"
))

.rs.setVar("ansiEscapeHighlight", list(
   error   = "\033H1;",
   warning = "\033H2;",
   message = "\033H3;",
   end     = "\033h"
))


.rs.addFunction("globalCallingHandlers.initialize", function()
{
   # Install our handlers.
   if (.rs.uiPrefs$consoleHighlightConditions$get() == "errors_warnings_messages")
   {
      globalCallingHandlers(
         error   = .rs.globalCallingHandlers.onError,
         warning = .rs.globalCallingHandlers.onWarning,
         message = .rs.globalCallingHandlers.onMessage
      )
   }
   else if (.rs.uiPrefs$consoleHighlightConditions$get() == "errors_warnings")
   {
      globalCallingHandlers(
         error   = .rs.globalCallingHandlers.onError,
         warning = .rs.globalCallingHandlers.onWarning
      )
   }
   else if (.rs.uiPrefs$consoleHighlightConditions$get() == "errors")
   {
      globalCallingHandlers(
         error   = .rs.globalCallingHandlers.onError
      )
   }
})

.rs.addFunction("globalCallingHandlers.initializeCall", function()
{
   body(.rs.globalCallingHandlers.initialize)
})

.rs.addFunction("globalCallingHandlers.onError", function(cnd)
{
   .rs.globalCallingHandlers.onErrorImpl(cnd)
})

.rs.addFunction("globalCallingHandlers.onErrorImpl", function(cnd)
{
   .Call("rs_errorOutputPending", PACKAGE = "(embedding)")
})

.rs.addFunction("globalCallingHandlers.onWarning", function(cnd)
{
   .rs.globalCallingHandlers.onWarningImpl(cnd)
})

.rs.addFunction("globalCallingHandlers.onWarningImpl", function(cnd)
{
   if (.rs.globalCallingHandlers.shouldHandleWarning(cnd))
   {
      msg <- .rs.globalCallingHandlers.formatCondition(cnd, "Warning", "warning")
      writeLines(msg, con = stderr())
      invokeRestart("muffleWarning")
   }
})

.rs.addFunction("globalCallingHandlers.onMessage", function(cnd)
{
   .rs.globalCallingHandlers.onMessageImpl(cnd)
})

.rs.addFunction("globalCallingHandlers.onMessageImpl", function(cnd)
{
   if (.rs.globalCallingHandlers.shouldHandleMessage(cnd))
   {
      msg <- .rs.globalCallingHandlers.formatCondition(cnd, NULL, "message")
      cat(msg, file = stderr())
      invokeRestart("muffleMessage")
   }
})

.rs.addFunction("globalCallingHandlers.shouldHandleWarning", function(cnd)
{
   pref <- .rs.uiPrefs$consoleHighlightConditions$get()
   if (!grepl("warnings", pref, fixed = TRUE))
      return(FALSE)
   
   # If the user is opting into bundling warnings, just let the default
   # R warning handler take over. We also need to ignore if warnings are
   # disabled entirely (via a negative value for the option).
   #
   # Similarly, this handler will be invoked for warnings even when warn >= 2,
   # but in this scenario we want treat warnings as errors, and so we should
   # avoid invoking the handler here.
   warn <- getOption("warn", default = 0L)
   if (warn <= 0L || warn >= 2L)
      return(FALSE)
   
   # I can't imagine anyone is actually using this in the wild, but...
   expr <- getOption("warning.expression", default = NULL)
   if (!is.null(expr))
      return(FALSE)
   
   # rlang doesn't apply any custom styles to emitted warnings,
   # so handle warnings even if they have custom classes
   TRUE
})

.rs.addFunction("globalCallingHandlers.shouldHandleMessage", function(cnd)
{
   pref <- .rs.uiPrefs$consoleHighlightConditions$get()
   if (!grepl("messages", pref, fixed = TRUE))
      return(FALSE)
   
   !inherits(cnd, "rlang_message")
})

.rs.addFunction("globalCallingHandlers.formatCondition", function(cnd, label, type)
{
   msg <- conditionMessage(cnd)
   text <- if (is.null(label))
   {
      msg
   }
   else if (is.null(conditionCall(cnd)))
   {
      # Hacky way to respect R's available translations while only colouring
      # the first word in the prefix
      prefix <- gettext(sprintf("%s: ", label), domain = "R")
      colonIndex <- regexpr(":", prefix, fixed = TRUE)
      lhs <- substr(prefix, 1L, colonIndex - 1L)
      rhs <- substr(prefix, colonIndex, .Machine$integer.max)
      prefix <- paste0(.rs.globalCallingHandlers.highlight(lhs, type), rhs)
      sprintf("%s%s", prefix, msg)
   }
   else
   {
      # Hacky way to respect R's available translations while only colouring
      # the first word in the prefix
      prefix <- gettext(sprintf("%s in ", label), domain = "R")
      parts <- strsplit(prefix, " ", fixed = TRUE)[[1L]]
      parts[[1L]] <- .rs.globalCallingHandlers.highlight(parts[[1L]], type)
      prefix <- paste(parts, collapse = " ")
      
      # R seems to just use the first line of the deparsed call?
      cll <- .rs.deparseCall(conditionCall(cnd))[[1L]]
      header <- sprintf("%s %s :", prefix, cll)
      if (nchar(header) + nchar(msg) >= 77L)
         sprintf("%s\n  %s", header, msg)
      else
         sprintf("%s %s", header, msg)
   }
   
   .rs.globalCallingHandlers.group(text, type)
})

.rs.addFunction("globalCallingHandlers.group", function(text, type)
{
   paste0(.rs.ansiEscapeGroup[[type]], text, .rs.ansiEscapeGroup[["end"]])
})

.rs.addFunction("globalCallingHandlers.highlight", function(text, type = "error")
{
   paste0(.rs.ansiEscapeHighlight[[type]], text, .rs.ansiEscapeHighlight[["end"]])
})


.rs.addFunction("globalCallingHandlers.makePrefixRegex", function(prefixes, type)
{
   # We construct a regular expression by taking the input prefix, translating
   # it into the user's current language, and then formatting / escaping that
   # as a Boost regular expression (intended as a PCRE regex). Note that we use
   # \Q and \E escapes to support quoting of the translated text, just to avoid
   # potential issues if the translation were to also have characters that had
   # a special interpretation in a regular expression.
   
   patterns <- vapply(prefixes, function(prefix)
   {
      # translate into the user's current language
      translated <- gettext(prefix$sourceText, domain = "R")
      
      # check for a highlight rule; if we have one, apply it
      if (!is.null(prefix$highlightUntil))
      {
         index <- regexpr(prefix$highlightUntil, translated, fixed = TRUE)
         if (index > 0)
         {
            translated <- sprintf(
               "\\E(\\Q%s\\E)\\Q%s",
               substr(translated, 1L, index - 1L),
               substr(translated, index, nchar(translated))
            )
         }
      }
      
      # return translated text, with potential highlights inserted
      translated
      
   }, FUN.VALUE = character(1), USE.NAMES = FALSE)
   
   # replace '%d' -- a sequence of digits
   patterns <- gsub("%d", "\\E\\d+\\Q", patterns, fixed = TRUE)

   # replace '%s' -- %s' is usually intended to be a placeholder for
   # a deparsed call, so in theory can be just about anything...
   patterns <- gsub("%s", "\\E\\S+\\Q", patterns, fixed = TRUE)

   # put it all together
   patterns <- paste0("\\Q", patterns, "\\E")
   
   # put it together into a single regex
   sprintf("^(?:%s)", paste(patterns, collapse = "|"))
})

.rs.addFunction("globalCallingHandlers.reErrorPrefix", function()
{
   # NOTE: 'sourceText' below is chosen to match the source text used for
   # translations used by base R
   prefixes <- list(
      
      list(
         sourceText     = "Error: ",
         highlightUntil = ":"
      ),
      
      list(
         sourceText     = "Error in ",
         highlightUntil = " "
      ),
      
      list(
         sourceText     = "Error in %s : ",
         highlightUntil = " "
      ),
      
      list(
         sourceText     = "Error in %s (from %s) : ",
         highlightUntil = " "
      ),
      
      list(
         sourceText     = "Error during wrapup: ",
         highlightUntil = ":"
      )
      
   )
   
   .rs.globalCallingHandlers.makePrefixRegex(prefixes, type = "error")
})

.rs.addFunction("globalCallingHandlers.reWarningPrefix", function()
{
   # NOTE: 'sourceText' below is chosen to match the source text used for
   # translations used by base R
   prefixes <- list(
      
      list(
         sourceText     = "Warning:",
         highlightUntil = ":"
      ),
      
      list(
         sourceText     = "Warning message:",
         highlightUntil = ":"
      ),
      
      list(
         sourceText = "Warning messages:",
         highlightUntil = ":"
      ),
      
      list(
         sourceText = "Warning in %s :",
         highlightUntil = " "
      ),
      
      list(
         sourceText = "There was %d warning (use warnings() to see it)",
         highlightUntil = NULL
      ),
      
      list(
         sourceText = "There were %d warnings (use warnings() to see them)",
         highlightUntil = NULL
      ),
      
      list(
         sourceText = "There were %d or more warnings (use warnings() to see the first %d)",
         highlightUntil = NULL
      )

   )
   
   .rs.globalCallingHandlers.makePrefixRegex(prefixes, type = "warning")
})

.rs.addFunction("globalCallingHandlers.reInAdditionPrefix", function()
{
   prefixes <- list(
      
      list(
         sourceText     = "In addition: ",
         highlightUntil = NULL
      )
      
   )
   
   .rs.globalCallingHandlers.makePrefixRegex(prefixes, type = "warning")
})

#
# SessionErrors.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("isSourceCall", function(call)
{
   symbols <- list(
      quote(source),
      quote(debugSource)
   )
   
   fun <- call[[1L]]
   for (symbol in symbols)
      if (identical(fun, symbol))
         return(TRUE)
   
   FALSE
})

.rs.addFunction("tracebackCalls", function()
{
   status <- sys.status()
   
   for (n in seq_along(status$sys.calls))
   {
      fn <- sys.function(n)
      
      # Check for a registered RStudio error handler.
      type <- attr(fn, "rstudioErrorHandler", exact = TRUE)
      if (identical(type, TRUE))
      {
         n <- n - 1L
         break
      }
      
      # Check for other potential error handlers on the stack.
      if (identical(fn, .rs.globalCallingHandlers.onError))
      {
         n <- n - 1L
         break
      }
      else if (identical(fn, .handleSimpleError))
      {
         call <- status$sys.calls[[n]]
         if (is.null(attr(call, "srcref", exact = TRUE)))
         {
            n <- n - 1L
            break
         }
      }
      else if (identical(fn, stop))
      {
         break
      }
   }
   
   head(status$sys.calls, n)
})

.rs.addFunction("recordTraceback", function(userOnly, errorReporter)
{
   calls <- .rs.tracebackCalls()
   n <- length(calls)
   
   # create the traceback for the client
   stack <- lapply(seq_len(n), function(i)
   {
      call <- calls[[i]]
      
      # don't show debugger-hidden functions
      if (isTRUE(attr(call[[1L]], "hideFromDebugger")))
         return(NULL)

      # retrieve call
      lines <- .rs.deparseCall(call)
      
      # don't display more than 4 lines of a long expression
      if (length(lines) > 4) 
      {
         lines <- lines[1:4]
         lines[4] <- paste(lines[4], "...")
      }

      srcref <- .rs.nullCoalesce(
         attr(call, "srcref", exact = TRUE),
         rep.int(0L, 8L)
      )
      
      srcfile <- attr(srcref, "srcfile", exact = TRUE)
      filename <- .rs.nullCoalesce(srcfile$filename, "")
      
      c(
         list(
            func = .rs.scalar(paste(lines, collapse = "\n")),
            file = .rs.scalar(filename)
         ),
         .rs.lineDataList(srcref)
      )
         
   })

   # remove hidden entries from the stack
   stack <- Filter(Negate(is.null), stack)

   # look for python entry point and fill in the stack from reticulate if we can
   stack <- .rs.addPythonStackFrames(stack)
   
   # only report frames in we have >= 2 of them, or if we're
   # requesting all stack frames
   frames <- if (n >= 2 || !userOnly) stack else list()
   
   # construct and report error object
   error <- list(
      frames = frames,
      message = .rs.scalar(geterrmessage())
   )
   
   errorReporter(error)
})

.rs.addFunction("addPythonStackFrames", function(oldStack)
{
   newStack <- list()
   
   lapply(oldStack, function(stackItem)
   {
      if (.rs.hasPythonStackTrace(stackItem$func))
      {
         pythonStack <- .rs.getActivePythonStackTrace()
         for (pythonStackItem in pythonStack)
            newStack[[length(newStack) + 1]] <<- pythonStackItem
      }
      else
      {
         newStack[[length(newStack) + 1]] <<- stackItem
      }
   })
   
   newStack
})

.rs.addFunction("hasPythonStackTrace", function(func) {
   grepl("^py_call_impl\\(", func) && 
         .rs.isPackageVersionInstalled("reticulate", "0.7.0.9005") &&
         !is.null(reticulate::py_last_error())
})

.rs.addFunction("getActivePythonStackTrace", function() {
   stack <- list()
   # silence errors so anything unexpected doesn't mess with global RStudio error handling
   tryCatch({
      traceback <- reticulate::py_last_error()$traceback
      for (i in 1:length(traceback)) {
         lineData <- .rs.pyStackItemToLineDataList(traceback[[i]])
         if (!is.null(lineData))
            stack[[length(stack) + 1]] <- lineData
      }
   }, error = function(e) NULL)
   stack
})

.rs.addFunction("pyStackItemToLineDataList", function(item) {
   matches <- regmatches(item, regexec('^\\s+\\w+ \\"([^\\"]+)\\", \\w+ (\\d+), \\w+ ([A-Za-z_0-9]+).*$',item))[[1]]
   if (length(matches) == 4) {
      list(
         func = .rs.scalar(matches[[4]]),
         file = .rs.scalar(matches[[2]]),
         line_number = .rs.scalar(matches[[3]]),
         end_line_nubmer = .rs.scalar(matches[[3]]),
         character_number = .rs.scalar(0),
         character_number = .rs.scalar(0)
      ) 
   } else {
      NULL
   }
})

.rs.addFunction("breakOnError", function(userOnly)
{
   calls <- sys.calls()
   if (length(calls) < 4)
      return()

   foundUserCode <- FALSE
   inSource <- FALSE
   if (userOnly)
   {
      for (n in 1:(length(calls) - 1))
      {
         isSourceCall <- FALSE
         if (.rs.isSourceCall(sys.call(n)))
         {
            isSourceCall <- TRUE
            inSource <- TRUE
         }
         func <- .rs.untraced(sys.function(n))
         srcref <- attr(func, "srcref")
         if (!is.null(srcref) && 
             !is.null(attr(srcref, "srcfile")))
         {
            if (inSource && !isSourceCall)
            {
               inSource <- FALSE
            }
            else
            {
               # looks like non-top-level user code--invoke the browser below
               foundUserCode <- TRUE
               break
            }
         }
      }
   }
   if (foundUserCode || !userOnly)
   {
      # The magic value 2 here is derived from the position in the
      # stack where this error handler resides relative to where we expect
      # the user code that raised the error to be. These will need to be
      # adjusted if evaluation layers are added or removed between the
      # root error handler (set in options(error=...)) and this function.
      frame <- length(sys.frames()) - 2

      # move the frame backwards if it's on stop or stopifnot
      if (identical(deparse(sys.call(frame)[[1]]), "stop"))
         frame <- frame - 1
      if (identical(deparse(sys.call(frame)[[1]]), "stopifnot"))
         frame <- frame - 1

      eval(substitute(browser(skipCalls = pos), 
                      list(pos = (length(sys.frames()) - frame) + 2)),
           envir = sys.frame(frame))
   }
},
attrs = list(hideFromDebugger = TRUE))

.rs.addFunction("enqueueError", function(err) {
  .rs.enqueClientEvent("unhandled_error", err)
})

.rs.addErrorHandlerFunction("recordAnyTraceback", "traceback", function()
{
   .rs.recordTraceback(FALSE, .rs.enqueueError)
})

.rs.addErrorHandlerFunction("recordUserTraceback", "traceback", function()
{
   .rs.recordTraceback(TRUE, .rs.enqueueError)
})

.rs.addErrorHandlerFunction("breakOnAnyError", "break", function()
{
   .rs.breakOnError(FALSE)
})

.rs.addErrorHandlerFunction("breakOnUserError", "break", function()
{
   .rs.breakOnError(TRUE)
})

.rs.addFunction("setErrorManagementType", function(type, userOnly)
{
   if (identical(type, "message"))
      options(error = NULL)
   else if (identical(type, "traceback") && userOnly)
      options(error = .rs.recordUserTraceback) 
   else if (identical(type, "traceback") && !userOnly)
      options(error = .rs.recordAnyTraceback)
   else if (identical(type, "break") && userOnly)
      options(error = .rs.breakOnUserError)
   else if (identical(type, "break") && !userOnly)
      options(error = .rs.breakOnAnyError)
})

#
# Make sure the debug position always advances when stepping through.
#
# https://github.com/rstudio/rstudio/issues/14276
#

# trace(.rs.simulateSourceRefs, quote(str(var)))
fn <- NULL
eval(parse(text = "fn <- function() {
  x <- 1
  1 + 1
  x <- 1
  2 + 2
  3 + 3
  x <- 1
  4 + 4
}", keep.source = FALSE))

debugonce(fn)
fn()


# No issue stepping through when we have srcrefs.
fn <- function() {
  x <- 1
  1 + 1
  x <- 1
  2 + 2
  3 + 3
  x <- 1
  4 + 4
  5 + 5
}

debugonce(fn)
fn()

#
# SessionRenv.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar("renvCache", new.env(parent = emptyenv()))

.rs.addJsonRpcHandler("renv_init", function(project)
{
   # run script in child process (done so that `renv::init()` doesn't
   # change the state of the running session)
   .rs.executeFunctionInChildProcess(
      callback   = .rs.renv.initCallback,
      data       = list(repos = getOption("repos")),
      workingDir = project
   )
   
})

.rs.addJsonRpcHandler("renv_actions", function(action)
{
   project <- .rs.getProjectDirectory()
   actions <- renv:::actions(tolower(action), project = project)
   if (length(actions) == 0)
      return(list())
   
   remap <- c(
      "Package"          = "packageName",
      "Library Version"  = "libraryVersion",
      "Library Source"   = "librarySource",
      "Lockfile Version" = "lockfileVersion",
      "Lockfile Source"  = "lockfileSource",
      "Action"           = "action"
   )
   
   matches <- match(names(actions), names(remap), nomatch = 0L)
   names(actions)[matches] <- remap[matches]
   
   data <- lapply(seq_len(nrow(actions)), function(i) {
      as.list(actions[i, ])
   })
   
   .rs.scalarListFromList(data)
})

.rs.addFunction("renv.context", function()
{
   context <- list()
   
   # validate that renv is installed
   location <- find.package("renv", quiet = TRUE)
   context[["installed"]] <- length(location) != 0
   
   # check and see if renv is active
   project <- Sys.getenv("RENV_PROJECT", unset = NA)
   context[["active"]] <- !is.na(project)
   
   # return context
   lapply(context, .rs.scalar)
   
})

.rs.addFunction("renv.options", function()
{
   context <- .rs.renv.context()
   
   options <- list()
   
   options[["useRenv"]] <- context[["active"]]
   # TODO: surface options associated with
   # the current project
   
   options
   
})

.rs.addFunction("renv.refresh", function()
{
   # get file info on installed packages, lockfile
   project <- renv::project()
   libdir <- renv:::renv_paths_library(project = project)
   
   files <- c(
      file.path(project, "renv.lock"),
      list.files(libdir, full.names = TRUE)
   )
   
   info <- file.info(files, extra_cols = FALSE)
   
   # drop unneeded fields
   new <- info[c("size", "mtime")]
   
   # check for changes
   old <- .rs.renvCache[["modifiedTimes"]]
   
   # have things changed?
   if (identical(old, new))
      return()
   
   # update cache
   .rs.renvCache[["modifiedTimes"]] <- new
   
   # fire events
   .rs.updatePackageEvents()
   .Call("rs_packageLibraryMutated", PACKAGE = "(embedding)")
})

.rs.addFunction("renv.readLockfilePackages", function(project)
{
   lockpath <- file.path(project, "renv.lock")
   lockfile <- renv:::renv_lockfile_read(lockpath)
   packages <- renv:::renv_records(lockfile)
   filtered <- lapply(packages, `[`, c("Package", "Version", "Source"))
   df <- .rs.rbindList(filtered)
   rownames(df) <- NULL
   df
})

.rs.addFunction("renv.listPackages", function(project) {
   
   # get list of packages
   installedPackages <- .rs.listInstalledPackages()
   
   # try to read the lockfile (return plain library list if this fails)
   lockfilePackages <- .rs.tryCatch(.rs.renv.readLockfilePackages(project))
   if (inherits(lockfilePackages, "error"))
      return(installedPackages)
   
   # rename columns for conformity of Packrat stuff
   names(lockfilePackages) <- c("name", "packrat.version", "packrat.source")

   # note which packages are in project library
   installedPackages[["in.project.library"]] <-
      installedPackages$library_absolute == renv:::renv_paths_library(project = project)

   # merge together
   merge.data.frame(
      x = installedPackages,
      y = lockfilePackages,
      by = "name",
      all.x = TRUE,
      all.y = TRUE
   )
   
})

.rs.addFunction("renv.initCallback", function(repos)
{
   # set active repos
   options(repos = repos)
   
   # avoid timeouts when querying unresponsive R package repositories
   options(renv.config.connect.timeout = 0L)
   options(renv.config.connect.retry = 0L)

   # tell renv that we know what we're doing
   options(renv.consent = TRUE)
   
   # if we're running tests, be quiet during init
   if (!is.na(Sys.getenv("TESTTHAT", unset = NA)))
     return(renv:::quietly(renv::init()))
     
   # otherwise, do a regular init
   renv::init()
})

#
# SessionConnections.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("validateParams", function(obj, params, type, optional = FALSE) {
   for (param in params) {
      value <- obj[[param]]
      if (optional && is.null(value))
         next
      if (!inherits(value, type) || length(value) != 1)
         stop(param, " must be a single element of type '", type, "'", 
              call. = FALSE)
   }
})

.rs.addFunction("validateCharacterParams", function(params, optional = FALSE) {
   .rs.validateParams(params, names(params), "character", optional)
})

.rs.addFunction("validateConnection", function(connection) {
   .rs.validateParams(connection, 
       c("type", "host", "displayName", "connectCode"),
       "character")
   .rs.validateParams(connection, "icon", "character", optional = TRUE)
   .rs.validateParams(connection, 
       c("disconnect", "listObjects", "listColumns", "previewObject"),
       "function")
})

# create an environment which will host the known active connections
assign(".rs.activeConnections", 
       value = new.env(parent = emptyenv()), 
       envir = .rs.toolsEnv())

# given a connection type and host, find a matching active connection name, or
# NULL if no connection was found
.rs.addFunction("findConnectionName", function(type, host) {
   connections <- ls(.rs.activeConnections)
   for (name in connections) {
      connection <- get(name, envir = .rs.activeConnections)
      if (identical(connection$type, type) && 
          identical(connection$host, host)) {
         return(name)
      }
   }
   # indicates no connection was found
   NULL
})

# given a connection type and host, find an active connection object, or NULL if
# no connection was found
.rs.addFunction("findActiveConnection", function(type, host) {
   
   name <- .rs.findConnectionName(type, host)
   if (is.null(name))
      return(NULL)
   
   if (exists(name, envir = .rs.activeConnections))
      get(name, envir = .rs.activeConnections)
   
})

.rs.addFunction("connectionObserver.traceback", function()
{
   .rs.getVar("connectionObserver.lastTraceback")
})

.rs.addFunction("connectionObserver.connectionError", function(error) {
   
   # save the error and calls
   .rs.setVar("connectionObserver.lastTraceback", sys.calls())
   
   # be quiet if requested
   suppressed <- getOption("rstudio.connectionObserver.errorsSuppressed", default = FALSE)
   if (suppressed)
      return()
   
   # try to figure out what the offending package is
   package <- NULL
   
   frames <- sys.frames()
   for (frame in rev(frames)) {
      
      parent <- parent.env(frame)
      if (identical(parent, baseenv()) || identical(parent, .BaseNamespaceEnv))
         next
      
      if (isNamespace(parent)) {
         spec <- getNamespaceInfo(parent, "spec")
         package <- spec[["name"]]
         break
      }
      
   }
   
   # make header
   header <- if (is.null(package)) {
      "An error occurred while updating the RStudio Connections pane:"
   } else {
      fmt <- "An error occurred while the '%s' package was updating the RStudio Connections pane:"
      sprintf(fmt, package)
   } 
   
   # make body
   fmt <- "Error in %s: %s"
   body <- sprintf(fmt, format(error$call), format(error$message))
   
   # make footer
   footer <- "If necessary, these warnings can be squelched by setting `options(rstudio.connectionObserver.errorsSuppressed = TRUE)`."
   
   # notify user as message
   all <- paste(c(header, body, footer), collapse = "\n")
   message(all)
   
})

.rs.addFunction(
   "connectionObserver.connectionOpened",
   function(type, host, displayName, icon = NULL, 
            connectCode, disconnect, listObjectTypes,
            listObjects, listColumns, previewObject, 
            connectionObject, actions = NULL)
   {
      tryCatch(
         
         .rs.connectionObserver.connectionOpenedImpl(
            type, host, displayName, icon, 
            connectCode, disconnect, listObjectTypes,
            listObjects, listColumns, previewObject, 
            connectionObject, actions
         ),
         
         error = .rs.connectionObserver.connectionError
         
      )
   }
)

.rs.addFunction(
   "connectionObserver.connectionOpenedImpl",
   function(type, host, displayName, icon = NULL, 
            connectCode, disconnect, listObjectTypes,
            listObjects, listColumns, previewObject, 
            connectionObject, actions = NULL)
   {
      # execute the object types function once to get the list of known 
      # object types; this is presumed to be static over the lifetime of the
      # connection
      if (!inherits(listObjectTypes, "function")) {
         stop("listObjectTypes must be a function returning a list of object types", 
              call. = FALSE)
      }
      
      # function to flatten the tree of object types for more convenient storage
      promote <- function(name, l) {
         
         if (length(l) == 0)
            return(list())
         
         if (is.null(l$contains)) {
            # plain data
            return(list(list(name = name,
                             icon = l$icon,
                             contains = "data")))
         } 
         
         # subtypes
         return(unlist(append(list(list(list(
            name = name, 
            icon = l$icon, 
            contains = names(l$contains)))),
            lapply(names(l$contains), function(name) {
               promote(name, l$contains[[name]])
            })), recursive = FALSE))
         
      }
      
      # apply tree flattener to provided object tree
      objectTree <- listObjectTypes()
      objectTypes <- lapply(names(objectTree), function(name) {
         promote(name, objectTree[[name]])
      })[[1]]
      
      # manufacture and validate object representing this connection
      connection <- list(
         type             = type,            # the type of the connection
         host             = host,            # the host being connected to
         displayName      = displayName,     # the name to display 
         icon             = icon,            # an icon representing the connection
         connectCode      = connectCode,     # code to (re)establish connection
         disconnect       = disconnect,      # function that disconnects
         objectTypes      = objectTypes,     # list of object types known 
         listObjects      = listObjects,     # list objects (all or in container)
         listColumns      = listColumns,     # list columns of a data object
         previewObject    = previewObject,   # preview an object
         actions          = actions,         # list of actions possible on conn
         connectionObject = connectionObject # raw connection object
      )
      class(connection) <- "rstudioConnection"
      .rs.validateConnection(connection)
      
      # generate an internal key for this connection in the local cache
      uuid <- .Call("rs_generateShortUuid", PACKAGE = "(embedding)")
      cacheKey <- paste(connection$type, connection$host, uuid, sep = "_")
      assign(cacheKey, value = connection, envir = .rs.activeConnections)
      
      # serialize and generate client events
      invisible(.Call("rs_connectionOpened", connection, PACKAGE = "(embedding)"))
   }
)

.rs.addFunction(
   "connectionObserver.connectionClosed",
   function(type, host, ...)
   {
      tryCatch(
         .rs.connectionObserver.connectionClosedImpl(type, host, ...),
         error = .rs.connectionObserver.connectionError
      )
   }
)

.rs.addFunction(
   "connectionObserver.connectionClosedImpl",
   function(type, host, ...)
   {
      .rs.validateCharacterParams(list(type = type, host = host))
      
      # clean up reference in environment
      name <- .rs.findConnectionName(type, host)
      if (!is.null(name))
         rm(list = name, envir = .rs.activeConnections)
      
      invisible(.Call("rs_connectionClosed", type, host, PACKAGE = "(embedding)"))
   }
)

.rs.addFunction(
   "connectionObserver.connectionUpdated",
   function(type, host, hint, ...)
   {
      tryCatch(
         .rs.connectionObserver.connectionUpdatedImpl(type, host, hint, ...),
         error = .rs.connectionObserver.connectionError
      )
   }
)


.rs.addFunction(
   "connectionObserver.connectionUpdatedImpl",
   function(type, host, hint, ...)
   {
      .rs.validateCharacterParams(list(type = type, host = host, hint = hint))
      invisible(.Call("rs_connectionUpdated", type, host, hint, PACKAGE = "(embedding)"))
   }
)


options(
   connectionObserver = list(
      connectionOpened  = .rs.connectionObserver.connectionOpened,
      connectionClosed  = .rs.connectionObserver.connectionClosed,
      connectionUpdated = .rs.connectionObserver.connectionUpdated
   )
)

.rs.addFunction("getConnectionObjectName", function(finder, host) {
   finderFunc <- eval(parse(text = finder))
   finderFunc(globalenv(), host)
})

.rs.addFunction("getConnectionObject", function(type, host) {
   name <- .rs.getConnectionObjectName(type, host)
   get(name, envir = globalenv())
})

.rs.addFunction("connectionDisconnect", function(type, host) {
   connection <- .rs.findActiveConnection(type, host)
   if (!is.null(connection))
      connection$disconnect()
})

.rs.addFunction("connectionListObjects", function(type, host, ...) {

   connection <- .rs.findActiveConnection(type, host)

   if (!is.null(connection)) 
      connection$listObjects(...)
   else
      character()
})

.rs.addFunction("connectionListColumns", function(type, host, ...) {

   connection <- .rs.findActiveConnection(type, host)

   if (!is.null(connection))
      listColumnsCode <- connection$listColumns(...)
   else
      NULL
})

.rs.addFunction("connectionPreviewObject", function(type, host, limit, ...) {

   connection <- .rs.findActiveConnection(type, host)

   if (!is.null(connection)) {
      df <- connection$previewObject(limit, ...)

      # use the last element of the specifier to caption the frame
      args <- list(...)
      .rs.viewDataFrame(df, args[[length(args)]], TRUE)
   }

   NULL
})

.rs.addFunction("connectionExecuteAction", function(type, host, action) {

   connection <- .rs.findActiveConnection(type, host)

   if (!is.null(connection) && action %in% names(connection$actions)) {
      connection$actions[[action]]$callback()
   }

   NULL
})

.rs.addFunction("connectionFilesPath", function() {
   snippetsPath <- getOption("connections-path", "/etc/rstudio/connections/")

   if (!is.null(getOption("connections-path")) && !dir.exists(snippetsPath)) {
      warning(
         "Path '", snippetsPath, "' does not exist. ",
         "Configure the connections-path option appropriately.")
   }

   snippetsPath
})

.rs.addFunction("connectionOdbcInstallerPath", function() {
   normalizePath(
      file.path(
         .Call("rs_connectionOdbcInstallPath"),
         "odbc",
         "installers"),
      mustWork = FALSE
   )
})

.rs.addFunction("connectionFiles", function(include, defaultPath) {
   connectionFiles <- list()
   
   if (!is.null(defaultPath)) {
      connectionFiles <- list.files(defaultPath)
   }

   files <- lapply(connectionFiles, function(file) {
      fullPath <- file.path(defaultPath, file)
   })

   names(files) <- gsub(include, "", connectionFiles)

   files <- files[grepl(include, files)]
   sapply(files, normalizePath)
})

.rs.addFunction("connectionHasInstaller", function(name) {
   installerName <- paste(name, "dcf", sep = ".")
   connectionFiles <- as.character(.rs.connectionFiles("\\.dcf$", .rs.connectionOdbcInstallerPath()))
   
   any(basename(connectionFiles) == installerName)
})

.rs.addFunction("connectionInstallerInfo", function(name) {
   installerName <- paste(name, "dcf", sep = ".")
   installerFile <- as.character(.rs.connectionFiles(installerName, .rs.connectionOdbcInstallerPath()))

   fileContents <- read.dcf(installerFile)
   list(
      name = if ("Name" %in% colnames(fileContents)) fileContents[,"Name"][[1]] else NULL,
      version = if ("Version" %in% colnames(fileContents)) fileContents[,"Version"][[1]] else NULL
   )
})

.rs.addFunction("connectionReadSnippets", function() {
   snippetsPaths <- .rs.connectionFiles("\\.R$", .rs.connectionFilesPath())

   snippets <- lapply(snippetsPaths, function(fullPath) {
      paste(readLines(fullPath), collapse = "\n")
   })

   lapply(names(snippets), function(snippetName) {
      tryCatch({
         snippet <- snippets[[snippetName]]

         list(
            package = .rs.scalar(NULL),
            version = .rs.scalar(NULL),
            name = .rs.scalar(snippetName),
            type = .rs.scalar("Snippet"),
            snippet = .rs.scalar(snippet),
            help = .rs.scalar(NULL),
            iconData = .rs.scalar(.Call("rs_connectionIcon", snippetName)),
            licensed = .rs.scalar(FALSE),
            source = .rs.scalar("Snippet"),
            hasInstaller = .rs.scalar(FALSE)
         )
      }, error = function(e) {
         warning(e$message)
         NULL
      })
   })
})

.rs.addFunction("connectionOdbcInstallPath", function()
{
   normalizePath(
      file.path(
         .Call("rs_connectionOdbcInstallPath"),
         "odbc",
         "drivers"),
      mustWork = FALSE
   )
})

.rs.addFunction("connectionReadInstallers", function() {
   if (!.rs.isDesktop()) return(list())
   
   installerPaths <- .rs.connectionFiles("\\.dcf$", .rs.connectionOdbcInstallerPath())

   installers <- lapply(installerPaths, function(fullPath) {
      read.dcf(fullPath)
   })

   valueOrDefault <- function(name, data, default) {
      cols <- colnames(data)
      ifelse(name %in% cols, data[,name], default)
   }

   valueOrEmpty <- function(name, data) {
      cols <- colnames(data)
      ifelse(name %in% cols, data[,name], "")
   }

   lapply(names(installers), function(installerName) {
      tryCatch({
         installer <- installers[[installerName]]
         cols <- colnames(installer)

         warning <- gsub(
            "\n",
            " ",
            valueOrDefault(
               paste("Warning", .Platform$OS.type, sep = "."),
               installer,
               valueOrEmpty("Warning", installer)
            )
         )

         list(
            package = .rs.scalar(NULL),
            version = .rs.scalar(NULL),
            name = .rs.scalar(installerName),
            type = .rs.scalar("Install"),
            subtype = .rs.scalar("Odbc"),
            help = .rs.scalar(NULL),
            iconData = .rs.scalar(.Call("rs_connectionIcon", installerName)),
            licensed = .rs.scalar("Licensed" %in% colnames(installer)),
            source = .rs.scalar("Snippet"),
            snippet = .rs.scalar(""),
            # odbc installer dcf fields
            odbcVersion = .rs.scalar(valueOrEmpty("Version", installer)),
            odbcLicense = .rs.scalar(gsub("\n", " ", valueOrEmpty("License", installer))),
            odbcDownload = .rs.scalar(installer[,"Download"]),
            odbcFile = .rs.scalar(valueOrEmpty("File", installer)),
            odbcLibrary = .rs.scalar(valueOrEmpty("Library", installer)),
            odbcWarning = .rs.scalar(warning),
            odbcInstallPath = .rs.scalar(.rs.connectionOdbcInstallPath()),
            odbcMD5 = .rs.scalar(gsub("\n", " ", valueOrEmpty("MD5", installer))),
            hasInstaller = .rs.scalar(TRUE)
         )
      }, error = function(e) {
         warning(e$message)
         NULL
      })
   })
})

.rs.addFunction("connectionSupportedPackages", function() {
   list(
      list(
         name = "ODBC",
         package = "odbc",
         version = "1.1.1"
      ),
      list(
         name = "Spark",
         package = "sparklyr",
         version = "0.5.6"
      )
   )
})

.rs.addFunction("connectionReadWindowsRegistry", function() {
   registryOdbcPath <- "SOFTWARE\\ODBC\\ODBCINST.INI\\"

   registryEntries <- lapply(names(readRegistry(registryOdbcPath)), function(driver) {
     driverPath <- readRegistry(paste(registryOdbcPath, driver, sep = ""))$Driver
     list(name = driver, attribute = "Driver", value = driverPath)
   })

   registryEntriesValue <- Filter(function(e) !is.null(e$value), registryEntries)

   do.call(rbind, lapply(registryEntriesValue, function(e) data.frame(e, stringsAsFactors = FALSE)))
})

.rs.addFunction("connectionReadOdbcEntry", function(drivers, uniqueDriverNames, driver) {
   tryCatch({
      currentDriver <- drivers[drivers$attribute == "Driver" & drivers$name == driver, ]
      driverInstaller <- drivers[drivers$attribute == "Installer" & drivers$name == driver, ]
      driverId <- gsub(.rs.connectionOdbcRStudioDriver(), "", driver)

      basePath <- sub(paste(tolower(driver), ".*$", sep = ""), "", currentDriver$value)
      snippetsFile <- file.path(
         basePath,
         tolower(driver),
         "snippets",
         paste(tolower(driverId), ".R", sep = "")
      )
      
      if (identical(file.exists(snippetsFile), TRUE)) {
         snippet <- paste(readLines(snippetsFile), collapse = "\n")
      }
      else {
         snippet <- paste(
            "library(DBI)\n",
            "con <- dbConnect(odbc::odbc(), .connection_string = \"", 
            "Driver={", driver, "};${1:Parameters}\", timeout = 10)",
            sep = "")
      }

      licenseFile <- file.path(dirname(currentDriver$value), "license.lock")

      iconData <- .Call("rs_connectionIcon", driverId)
      if (nchar(iconData) == 0)
         iconData <- .Call("rs_connectionIcon", "ODBC")

      hasInstaller <- identical(driverInstaller$value, "RStudio")
      warningMessage <- NULL

      if (hasInstaller) {
         installerVersion <- .rs.connectionInstallerInfo(driverId)$version

         currentVersion <- drivers[drivers$attribute == "Version" & drivers$name == driver, ]
         if (nrow(currentVersion) == 1) {
            if (compareVersion(installerVersion, currentVersion$value) > 0) {
               warningMessage <- "A new driver version is available, to upgrade, uninstall and then reinstall."
            }
         }
      }

      list(
         package = .rs.scalar(NULL),
         version = .rs.scalar(NULL),
         name = .rs.scalar(driver),
         type = .rs.scalar("Snippet"),
         snippet = .rs.scalar(snippet),
         help = .rs.scalar(NULL),
         iconData = .rs.scalar(iconData),
         licensed = .rs.scalar(identical(file.exists(licenseFile), TRUE)),
         source = .rs.scalar("ODBC"),
         hasInstaller = .rs.scalar(hasInstaller),
         warning = .rs.scalar(warningMessage),
         installer = .rs.scalar(driverInstaller$value)
      )
   }, error = function(e) {
      warning(e$message)
      NULL
   })
})

.rs.addFunction("connectionReadOdbc", function() {
   if (.rs.isPackageInstalled("odbc")) {
      drivers <- data.frame()

      tryCatch({
         drivers <- get("odbcListDrivers", envir = asNamespace("odbc"))()
         
         if (.Platform$OS.type == "windows") {
            drivers <- rbind(drivers, .rs.connectionReadWindowsRegistry())
         }
      }, error = function(e) warning(e$message))

      uniqueDriverNames <- unique(drivers$name)

      lapply(uniqueDriverNames, function(driver) {
         .rs.connectionReadOdbcEntry(drivers, uniqueDriverNames, driver)
      })
   }
})

.rs.addFunction("connectionReadPackages", function() {
   rawConnections <- .rs.fromJSON(.Call("rs_availableConnections"))

   pacakgeConnections <- lapply(rawConnections, function(con) {
      tryCatch({
         ns <- asNamespace(con$package)

         connectionType <- if (nchar(con$shinyapp) == 0) "Snippet" else "Shiny"
         snippetFile <- file.path("rstudio", "connections", paste(con$name, ".R", sep = ""))
         snippet <- ""

         if (nchar(con$shinyapp) == 0) {
            snippetPath <- system.file(snippetFile, package = con$package)
            if (!file.exists(snippetPath)) {
               warning(
                  "The file \"", con$name, ".R\" does not exist under \"rstudio/connections\" for ",
                  "package \"", con$package , "\".")
            }
            else {
               snippet <- paste(readLines(snippetPath), collapse = "\n")
            }
         }
         else {
            if (!exists(con$shinyapp, envir = ns, mode="function")) {
               warning(
                  "The function \"", con$shinyapp, "\" does not exist. ",
                  "Check the ShinyApp DCF field in the ", con$package, " package.")
            }
         }

         iconData <- if (nchar(con$icon) > 0) {
            iconPath <- system.file(con$icon, package = con$package)
            if (file.exists(iconPath)) {
               paste0("data:image/png;base64,", .rs.base64encodeFile(iconPath));
            }
         }
         else {
            .Call("rs_connectionIcon", con$name)
         }

         list(
            package = .rs.scalar(con$package),
            version = .rs.scalar(NULL),
            name = .rs.scalar(con$name),
            type = .rs.scalar(connectionType),
            newConnection = .rs.scalar(paste(con$package, "::", con$shinyapp, "()", sep = "")),
            snippet = .rs.scalar(snippet),
            help = .rs.scalar(con$help),
            iconData = .rs.scalar(iconData),
            licensed = .rs.scalar(FALSE),
            source = .rs.scalar("Package"),
            hasInstaller = .rs.scalar(FALSE)
         )
      }, error = function(e) {
         warning(e$message)
         NULL
      })
   })

   names(pacakgeConnections) <- NULL
   pacakgeConnections
})

.rs.addFunction("connectionReadDSN", function() {
   if (.rs.isPackageInstalled("odbc")) {
      dataSources <- data.frame()

      tryCatch({
         if (exists("list_data_sources", envir = asNamespace("odbc"))) {
            listSources <- get("list_data_sources", envir = asNamespace("odbc"))
         }
         else {
            listSources <- get("odbcListDataSources", envir = asNamespace("odbc"))
         }
         dataSources <- listSources()
      }, error = function(e) warning(e$message))

      lapply(dataSources$name, function(dataSourceName) {
         tryCatch({

            dataSource <- dataSources[dataSources$name == dataSourceName, ]

            snippet <- paste(
               "library(DBI)\n",
               "con <- dbConnect(odbc::odbc(), \"${1:Data Source Name=", 
               dataSource$name,
               "}\", timeout = 10)",
               sep = "")

            iconData <- .Call("rs_connectionIcon", dataSource$name)
            if (nchar(iconData) == 0)
               iconData <- .Call("rs_connectionIcon", "ODBC")

            list(
               package = .rs.scalar(NULL),
               version = .rs.scalar(NULL),
               name = .rs.scalar(dataSource$name),
               type = .rs.scalar("Snippet"),
               snippet = .rs.scalar(snippet),
               help = .rs.scalar(NULL),
               iconData = .rs.scalar(iconData),
               licensed = .rs.scalar(FALSE),
               source = .rs.scalar("DSN"),
               hasInstaller = .rs.scalar(FALSE)
            )
         }, error = function(e) {
            warning(e$message)
            NULL
         })
      })
   }
})

.rs.addFunction("connectionReadPackageInstallers", function() {

   supportedNotInstsalled <- Filter(function(e) {
      !.rs.isPackageVersionInstalled(e$package, e$version)
   }, .rs.connectionSupportedPackages())

   lapply(supportedNotInstsalled, function(supportedPackage) {
      iconData <- .Call("rs_connectionIcon", supportedPackage$name)
      list(
         package = .rs.scalar(supportedPackage$package),
         version = .rs.scalar(supportedPackage$version),
         name = .rs.scalar(supportedPackage$name),
         type = .rs.scalar("Install"),
         subtype = .rs.scalar("Package"),
         newConnection = .rs.scalar(NULL),
         snippet = .rs.scalar(NULL),
         help = .rs.scalar(NULL),
         iconData = .rs.scalar(iconData),
         licensed = .rs.scalar(FALSE),
         hasInstaller = .rs.scalar(FALSE)
      )
   })
})

.rs.addJsonRpcHandler("get_new_connection_context", function() {
   connectionList <- c(
      list(),
      .rs.connectionReadSnippets(),         # add snippets to connections list
      .rs.connectionReadDSN(),              # add ODBC DSNs to connections list
      .rs.connectionReadPackages(),         # add packages to connections list
      .rs.connectionReadOdbc(),             # add ODBC drivers to connections list
      .rs.connectionReadInstallers(),       # add installers to connections list
      .rs.connectionReadPackageInstallers() # add package installers to connection list
   )
   
   connectionList <- Filter(function(e) !is.null(e), connectionList)

   # remove duplicate names, in order
   connectionNames <- list()
   for (i in seq_along(connectionList)) {
      entryName <- connectionList[[i]]$name
      if (!is.null(connectionNames[[entryName]])) {
         existingDriver <- connectionNames[[entryName]]
         withRStudioName <- paste(entryName, .rs.connectionOdbcRStudioDriver(), sep = "")

         if (identical(as.character(connectionList[[i]]$type), "Install") &&
             !identical(as.character(existingDriver$installer), "RStudio") &&
             is.null(connectionNames[[withRStudioName]])) {
            connectionList[[i]]$name <- entryName <- .rs.scalar(withRStudioName)
         }
         else {
            connectionList[[i]]$remove <- TRUE
         }
      }

      if (is.null(connectionNames[[entryName]])) {
         connectionNames[[entryName]] <- connectionList[[i]]
      }
   }
   
   connectionList <- Filter(function(e) !identical(e$remove, TRUE), connectionList)

   context <- list(
      connectionsList = unname(connectionList)
   )

   context
})

.rs.addJsonRpcHandler("get_new_odbc_connection_context", function(name, retries = 1) {
   singleEntryFilter <- function(e) {
      identical(as.character(e$name), name)
   }

   connectionContext <- Filter(singleEntryFilter, .rs.connectionReadOdbc())

   while (length(connectionContext) != 1 && (retries <- retries - 1) >= 0)
      Sys.sleep(1)

   if (length(connectionContext) != 1)
      list(
         error = .rs.scalar(
            paste("The", name, "driver is not registered.")
         )
      )
   else {
      connectionContext[[1]]
   }
})

.rs.addFunction("embeddedViewer", function(url)
{
   .Call("rs_embeddedViewer", url)
})

.rs.addJsonRpcHandler("launch_embedded_shiny_connection_ui", function(package, name)
{
   if (package == "sparklyr" && packageVersion("sparklyr") <= "0.5.4") {
      return(.rs.error(
         "sparklyr ", packageVersion("sparklyr"), " does not support this functionality. ",
         "Please upgrade to sparklyr 0.5.5 or newer."
      ))
   }

   connectionContext <- .rs.rpc.get_new_connection_context()$connectionsList
   connectionInfo <- Filter(
      function(e)
        identical(as.character(e$package), as.character(package)) &
        identical(as.character(e$name), as.character(name)),
      connectionContext
   )

   if (length(connectionInfo) != 1) {
      return(.rs.error(
         "Connection for package ", package, " and name ", name, " is not registered"
      ))
   }

   connectionInfo <- connectionInfo[[1]]

   consoleCommand <- paste(
      "shiny::runGadget(",
      connectionInfo$newConnection,
      ", viewer = .rs.embeddedViewer)",
      sep = ""
   )

   .rs.api.sendToConsole(consoleCommand, echo = FALSE, execute = TRUE, focus = FALSE)

   .rs.success()
})

.rs.addJsonRpcHandler("connection_test", function(code) {
   error <- ""

   oldConnectionObserver <- getOption("connectionObserver")
   on.exit(options(connectionObserver = oldConnectionObserver))

   disconnectCalls <- list()

   options(connectionObserver = list(
      connectionOpened = function(type, host, displayName, icon = NULL, 
                                  connectCode, disconnect, listObjectTypes,
                                  listObjects, listColumns, previewObject, 
                                  connectionObject, actions = NULL) {
         disconnectCalls <<- c(disconnectCalls, disconnect)
      },
      connectionClosed = function(type, host, ...) {

      },
      connectionUpdated = function(type, host, hint, ...) {
      }
   ))

   .envir <- .rs.getActiveFrame()
   tryCatch({
      eval(parse(text = code), envir = .envir)
   }, error = function(e) {
      error <<- e$message
   })

   lapply(disconnectCalls, function(e) e())

   .rs.scalar(error)
})

.rs.addJsonRpcHandler("connection_add_package", function(package) {
   extensionPath <- system.file("rstudio/connections.dcf", package = package)
   invisible(.Call("rs_connectionAddPackage", package, extensionPath))
})

.rs.addFunction("connectionInstallerCommand", function(driverName, installationPath) {
   connectionContext <- Filter(function(e) {
      identical(
         as.character(e$name),
         gsub(.rs.connectionOdbcRStudioDriver(), "", driverName)
      )
   }, .rs.connectionReadInstallers())[[1]]

   placeholder <-  connectionContext$odbcFile
   driverUrl <- connectionContext$odbcDownload
   libraryPattern <- connectionContext$odbcLibrary
   targetMD5 <- connectionContext$odbcMD5
   driverVersion <- connectionContext$odbcVersion

   if (any(grepl("'", c(driverName, driverUrl, placeholder, installationPath, libraryPattern, targetMD5, driverVersion)))) {
      stop("Single quote can't be used in installer definitions.")
   }

   paste(
      ".rs.odbcBundleInstall(",
      "name = '", driverName, "', ",
      "url = '", driverUrl, "', ",
      "placeholder = '", placeholder, "', ",
      "installPath = '", normalizePath(installationPath, winslash = "/"), "', ",
      "libraryPattern = '", libraryPattern, "', ",
      "md5 = '", targetMD5, "', ",
      "version = '", driverVersion, "'",
      ")",
      sep = ""
   )
})

.rs.addFunction("connectionUnregisterOdbcinstDriver", function(driverName) {
   odbcinstPath <- .rs.odbcBundleOdbcinstPath()
   odbcinstData <- .rs.odbcBundleReadIni(odbcinstPath)

   if (driverName %in% names(odbcinstData)) {
      odbcinstData[[driverName]] <- NULL

      .rs.odbcBundleWriteIni(odbcinstPath, odbcinstData)
   }
})

.rs.addFunction("connectionUnregisterWindowsDriver", function(driverName) {
   .rs.odbcBundleRegistryRemove(
      list(
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", "ODBC Drivers", fsep = "\\"),
            key = driverName
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", driverName, fsep = "\\")
         )
      )
   )
})

.rs.addJsonRpcHandler("uninstall_odbc_driver", function(driverName) {
   tryCatch({
      defaultInstallPath <- file.path(.rs.connectionOdbcInstallPath(), tolower(driverName))
      defaultInstallExists <- dir.exists(defaultInstallPath)

      # delete the driver
      if (defaultInstallExists) {
         unlink(defaultInstallPath, recursive = TRUE)
      }

      # unregister driver
      if (identical(tolower(Sys.info()["sysname"][[1]]), "windows")) {
         .rs.connectionUnregisterWindowsDriver(driverName)
      }
      else {
         .rs.connectionUnregisterOdbcinstDriver(driverName)
      }

      # if driver was not installed in default location
      if (!defaultInstallExists) {
         list(
            message = .rs.scalar(
               paste(
                  "The", driverName, "driver was not found in the default installation path;",
                  "if appropriate, please manually remove this driver."
               )
            )
         )
      }
      else {
         list(
         )
      }
   }, error = function(e) {
      list(
         error = .rs.scalar(e$message)
      )
   })
})

.rs.addJsonRpcHandler("update_odbc_installers", function() {
   installerUrl <- getOption("connections-installer")
   connectionsWarning <- NULL

   if (!.rs.isDesktop()) return(list())

   # once per session, attempt to download driver updates
   if (!is.null(installerUrl) && nchar(installerUrl) > 0) {
      installerHostName <- gsub("https?://|/[^:].+$", "", installerUrl)

      connectionsWarning <- tryCatch({
         installersFile <- file.path(tempdir(), basename(installerUrl))
         download.file(installerUrl, installersFile, quiet = TRUE)

         untar(installersFile, exdir = .rs.connectionOdbcInstallerPath())

         NULL
      }, error = function(e) {
         paste(
            "Could not retrieve driver updates from ",
            installerHostName,
            sep = ""
         )
      })
   }

   list(
      warning = connectionsWarning
   )
})

#
# ModuleTools.R
#
# Copyright (C) 2009-19 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("enqueClientEvent", function(type, data = NULL)
{
   .Call("rs_enqueClientEvent", type, data, PACKAGE = "(embedding)")
})

.rs.addFunction("invokeRpc", function(method, ...) 
{
   # callback to session to invoke RPC
   args <- list(...)
   .Call("rs_invokeRpc", method, .rs.scalarListFromList(args), PACKAGE = "(embedding)")
})

.rs.addFunction("showErrorMessage", function(title, message)
{
   .Call("rs_showErrorMessage", title, message, PACKAGE = "(embedding)")
})

.rs.addFunction("logErrorMessage", function(message)
{
   .Call("rs_logErrorMessage", message, PACKAGE = "(embedding)")
})

.rs.addFunction("logWarningMessage", function(message)
{
   .Call("rs_logWarningMessage", message, PACKAGE = "(embedding)")
})

.rs.addFunction("getSignature", function(object)
{
   signature <- base::format.default(base::args(object))
   length(signature) <- length(signature) - 1
   trimmed <- gsub("^\\s+", "", signature)
   paste(trimmed, collapse = "")
})

# Wrap a return value in this to give a hint to the
# JSON serializer that one-element vectors should be
# marshalled as scalar types instead of arrays
.rs.addFunction("scalar", function(obj)
{
   if (!is.null(obj))
      class(obj) <- 'rs.scalar'
   return(obj)
})

.rs.addFunction("validateAndNormalizeEncoding", function(encoding)
{
   iconvList <- toupper(iconvlist())
   encodingUpper <- toupper(encoding)
   if (encodingUpper %in% iconvList)
   {
      return (encodingUpper)
   }
   else
   {
      encodingUpper <- gsub("[_]", "-", encodingUpper)
      if (encodingUpper %in% iconvList)
         return (encodingUpper)
      else
         return ("")
   }
})

.rs.addFunction("usingUtf8Charset", function()
{
   l10n_info()$`UTF-8` || identical(utils::localeToCharset(), "UTF-8")
})


.rs.addFunction("isRtoolsOnPath", function()
{
   # ensure that the Rtools utility 'bin' directory is on the PATH
   # (this is just a heuristic but works okay in general)
   if (!nzchar(Sys.which("ls.exe")))
      return(FALSE)
   
   # for newer versions of R, ensure that BINPREF is set
   # (since BINPREF may be going away in R 4.0.0 we don't require its
   # existence here)
   rv <- getRversion()
   if (rv >= "3.3.0" && rv < "4.0.0")
   {
      if (is.na(Sys.getenv("BINPREF", unset = NA)))
         return(FALSE)
   }
   
   # for older versions of R (with the old toolchain) check for 'gcc.exe'
   # on the PATH (assuming the old, multilib-variant of gcc)
   if (rv < "3.3.0")
   {
      if (!nzchar(Sys.which("gcc.exe")))
         return(FALSE)
   }
   
   # survived all checks; return TRUE
   TRUE
})

.rs.addFunction("getPackageFunction", function(name, packageName)
{
   tryCatch(eval(parse(text=paste(packageName, ":::", name, sep=""))),
            error = function(e) NULL)
})

.rs.addFunction("libPathsString", function()
{
   paste(.libPaths(), collapse = .Platform$path.sep)
})

.rs.addFunction("parseLinkingTo", function(linkingTo)
{
   if (is.null(linkingTo))
      return (character())

   linkingTo <- strsplit(linkingTo, "\\s*\\,")[[1]]
   result <- gsub("\\s", "", linkingTo)
   gsub("\\(.*", "", result)
})


.rs.addFunction("isPackageInstalled", function(name, libLoc = NULL)
{
   paths <- vapply(name, FUN.VALUE = character(1), USE.NAMES = FALSE, function(pkg) {
      system.file(package = pkg, lib.loc = libLoc)
   })
   nzchar(paths)
})

.rs.addFunction("isPackageVersionInstalled", function(name, version) {  
  .rs.isPackageInstalled(name) && (.rs.getPackageVersion(name) >= version)
})

.rs.addFunction("packageCRANVersionAvailable", function(name, version, source) {
  # get the specified CRAN repo
  repo <- NA
  repos <- getOption("repos")
  # the repos option is canonically a named character vector, but could also
  # be a named list
  if (is.character(repos) || is.list(repos)) {
    # check for a repo named "CRAN"
    repo <- as.character(repos["CRAN"])

    # if no repo named "CRAN", blindly guess that the first repo is a CRAN mirror 
    if (length(repo) < 1 || is.na(repo)) {
      repo <- as.character(repos[[1]])
    }
  }

  # if no default repo and no repo marked CRAN, give up
  if (length(repo) < 1 || is.na(repo)) {
    return(list(version = "", satisfied = FALSE))
  }

  # get the available packages and extract the version information
  type <- ifelse(source, "source", getOption("pkgType"))
  pkgs <- available.packages(
            contriburl = contrib.url(repo, type = type))
  if (!(name %in% row.names(pkgs))) {
    return(list(version = "", satisfied = FALSE))
  }
  pkgVersion <- pkgs[name, "Version"]
  return(list(
    version = pkgVersion, 
    satisfied = package_version(pkgVersion) >= package_version(version)))
})

.rs.addFunction("packageVersionString", function(pkg) {
   as.character(packageVersion(pkg))
})

.rs.addFunction("getPackageCompatStatus", 
  function(name, packageVersion, protocolVersion) 
  {  
     if (!.rs.isPackageInstalled(name))
       return(1L)  # COMPAT_MISSING
     else if (!.rs.getPackageVersion(name) >= packageVersion) 
       return(2L)  # COMPAT_TOO_OLD
     else if (!.rs.getPackageRStudioProtocol(name) >= protocolVersion) 
       return(3L)  # COMPAT_TOO_NEW
     return (0L)   # COMPAT_OK
  }
)

.rs.addFunction("getPackageRStudioProtocol", function(name) {

   ## First check to see if the package has a 'rstudio-protocol' file
   path <- system.file("rstudio/rstudio-protocol", package = name)
   if (path != "") {
      tryCatch(
         expr = {
            return(as.integer(read.dcf(path, all = TRUE)$Version))
         },
         warning = function(e) {},
         error = function(e) {}
      )
   }

   ## Otherwise, check the namespace
   needsUnloadAfter <- !(name %in% loadedNamespaces())
   rpv <- ".RStudio_protocol_version"
   env <- asNamespace(name)
   if (exists(rpv, envir = env, mode = "integer")) {
      version <- get(rpv, envir = env)
   } else {
      version <- 0L
   }
   if (needsUnloadAfter)
      unloadNamespace(name)
   version
})

.rs.addFunction("rstudioIDEPackageRequiresUpdate", function(name, sha1) {
   
  if (.rs.isPackageInstalled(name))
  {
     f <- utils::packageDescription(name, fields=c("Origin", "GithubSHA1"))
     identical(f$Origin, "RStudioIDE") && !identical(f$GithubSHA1, sha1)
  }
  else
  {
     TRUE
  }
})

.rs.addFunction("updateRStudioIDEPackage", function(name, archive)
{
  pkgDir <- find.package(name)
  .rs.forceUnloadPackage(name)
  .Call("rs_installPackage",  archive, dirname(pkgDir), PACKAGE = "(embedding)")
})


.rs.addFunction("userPrompt", function(type,
                                       caption,
                                       message,
                                       yesLabel = NULL,
                                       noLabel = NULL,
                                       includeCancel = FALSE,
                                       yesIsDefault = TRUE) {

   if (identical(type, "info"))
      type <- 1
   else if (identical(type, "warning"))
      type <- 2
   else if (identical(type, "error"))
      type <- 3
   else if (identical(type, "question"))
      type <- 4
   else
      stop("Invalid type specified")

   result <- .Call("rs_userPrompt",
         type,
         caption,
         message,
         yesLabel,
         noLabel,
         includeCancel,
         yesIsDefault, PACKAGE = "(embedding)")

   if (result == 0)
      "yes"
   else if (result == 1)
      "no"
   else if (result == 2)
      "cancel"
   else
      stop("Invalid result")
})

.rs.addFunction("restartR", function(afterRestartCommand = "") {
   afterRestartCommand <- paste(as.character(afterRestartCommand),
                                collapse = "\n")
   .Call("rs_restartR", afterRestartCommand, PACKAGE = "(embedding)")
})

.rs.addFunction("markdownToHTML", function(content) {
   .Call("rs_markdownToHTML", content, PACKAGE = "(embedding)")
})

.rs.addFunction("readPrefInternal", function(method, prefName) {
  if (missing(prefName) || is.null(prefName))
    stop("No preference name supplied")
  .Call(method, prefName, PACKAGE = "(embedding)")
})

.rs.addFunction("writePrefInternal", function(method, prefName, value) {
  if (missing(prefName) || is.null(prefName))
    stop("No preference name supplied")
  if (missing(value))
    stop("No value supplied")
  invisible(.Call(method, prefName, .rs.scalar(value), PACKAGE = "(embedding)"))
})

.rs.addFunction("readApiPref", function(prefName) {
  .rs.readPrefInternal("rs_readApiPref", prefName)
})

.rs.addFunction("writeApiPref", function(prefName, value) {
  .rs.writePrefInternal("rs_writeApiPref", prefName, value)
})

.rs.addFunction("readUiPref", function(prefName) {
  .rs.readPrefInternal("rs_readUserPref", prefName)
})
.rs.addFunction("readUserPref", .rs.readUiPref)

.rs.addFunction("writeUiPref", function(prefName, value) {
  .rs.writePrefInternal("rs_writeUserPref", prefName, value)
})
.rs.addFunction("writeUserPref", .rs.writeUiPref)

.rs.addFunction("readUserState", function(stateName) {
  if (missing(stateName) || is.null(stateName))
    stop("No state name supplied")
  .Call("rs_readUserState", stateName, PACKAGE = "(embedding)")
})

.rs.addFunction("allPrefs", function() {
  .Call("rs_allPrefs", PACKAGE = "(embedding)")
})

.rs.addFunction("writeUserState", function(stateName, value) {
  if (missing(stateName) || is.null(stateName))
    stop("No state name supplied")
  if (missing(value))
    stop("No value supplied")
  invisible(.Call("rs_writeUserState", stateName, .rs.scalar(value), PACKAGE = "(embedding)"))
})

.rs.addFunction("removePref", function(prefName) {
  if (missing(prefName) || is.null(prefName))
    stop("No preference name supplied")
  invisible(.Call("rs_removePref", prefName, PACKAGE = "(embedding)"))
})

.rs.addFunction("setUsingMingwGcc49", function(usingMingwGcc49) {
  invisible(.Call("rs_setUsingMingwGcc49", usingMingwGcc49, PACKAGE = "(embedding)"))
})


.rs.addGlobalFunction("rstudioDiagnosticsReport", function() {
  invisible(.Call(getNativeSymbolInfo("rs_sourceDiagnostics", PACKAGE="")))
})


.rs.addFunction("pandocSelfContainedHtml", function(input, template, output) {
   
   # make input file path absolute
   input <- normalizePath(input)

   # create a temporary copy of the file for conversion
   inputFile <- tempfile(tmpdir = dirname(input), fileext = ".html")
   inputLines <- readLines(con = input, warn = FALSE)

   # write all the lines from the input except the DOCTYPE declaration, which pandoc will not treat
   # as HTML (starting in pandoc 2)
   writeLines(text = inputLines[!grepl("<!DOCTYPE", inputLines, fixed = TRUE)],
              con  = inputFile)

   # ensure output file exists and make its path absolute
   if (!file.exists(output))
      file.create(output)
   output <- normalizePath(output)
   
   # convert from markdown to html to get base64 encoding. note there is no markdown in the source
   # document but we still need to do this "conversion" to get the base64 encoding; we also don't
   # want to convert from HTML since that will cause pandoc to convert only the <body>
   args <- c(inputFile)
   args <- c(args, "--from", "markdown_strict")
   args <- c(args, "--output", output)

   # define a title for the document. this value is not actually consumed by the template, but
   # pandoc requires it in metadata when converting to HTML, so supply a dummy value to keep the
   # output clean.
   args <- c(args, "--metadata", "title:RStudio")
   
   # set stack size
   stack_size <- getOption("pandoc.stack.size", default = "512m")
   args <- c(c("+RTS", paste0("-K", stack_size), "-RTS"), args)
   
   # additional options
   args <- c(args, "--self-contained")
   args <- c(args, "--template", template)
   
   # build the conversion command
   pandoc <- file.path(Sys.getenv("RSTUDIO_PANDOC"), "pandoc")
   command <- paste(shQuote(c(pandoc, args)), collapse = " ")
   
   # setwd temporarily
   wd <- getwd()
   on.exit(setwd(wd), add = TRUE)
   setwd(dirname(inputFile))
   
   # execute it
   result <- system(command)
   if (result != 0) {
      stop("pandoc document conversion failed with error ", result,
           call. = FALSE)
   }
   
   # return output file
   invisible(output)
})

# create an environment to hold original versions of S3 functions we have overridden
assign(".rs.S3Originals", new.env(parent = emptyenv()), envir = .rs.toolsEnv())

# create an environment to hold current S3 overrides
assign(".rs.S3Overrides", new.env(parent = emptyenv()), envir = .rs.toolsEnv())

if (getRversion() < "3.5") {
   # prior to R 3.5, we can override S3 methods just by installing the override function into the
   # tools:rstudio namespace, which is on the search path
   .rs.addFunction("addS3Override", function(name, method) {
      assign(name, method, envir = .rs.toolsEnv())
   })

   .rs.addFunction("removeS3Override", function(name) {
      if (exists(name, envir = .rs.toolsEnv(), inherits = FALSE)) {
         rm(list = name, envir = .rs.toolsEnv(), inherits = FALSE)
      }
   })

   .rs.addFunction("reattachS3Overrides", function() {
      # S3 methods on the search path maintain precedence
   })
} else {
   # after R 3.5, S3 methods are not discovered on the search path, so we resort to injecting our
   # overrides directly into the base namespace's S3 methods table
   .rs.addFunction("addS3Override", function(name, method) {
      # get a reference to the table of S3 methods stored in the base namespace
      table <- .BaseNamespaceEnv[[".__S3MethodsTable__."]]

      # cache old dispatch table entry if it exists
      if (exists(name, envir = table)) {
         assign(name, get(name, envir = table), envir = .rs.S3Originals)
      }

      # add a flag indicating that this method belongs to us
      attr(method, ".rs.S3Override") <- TRUE

      # ... and inject our own entry
      assign(name, method, envir = table)

      # make a copy in our override table so we can restore when overwritten by e.g. an attached
      # package
      assign(name, method, envir = .rs.S3Overrides)

      invisible(NULL)
   })

   .rs.addFunction("removeS3Override", function(name) {
      table <- .BaseNamespaceEnv[[".__S3MethodsTable__."]]

      # see if there's an override to remove; if not, no work to do
      if (!exists(name, envir = table))
         return(invisible(NULL))
      
      # see if the copy that exists in the methods table is one that we put there.
      if (!isTRUE(attr(get(name, envir = table), ".rs.S3Override", exact = TRUE)))
      {
         # it isn't, so don't touch it. we do this so that changes to the S3 dispatch table that
         # have occurred since the call to .rs.addS3Override are persisted
         return(invisible(NULL))
      }

      # see if we have a copy to restore
      if (exists(name, envir = .rs.S3Originals))
      {
         # we do, so overwrite with our copy
         assign(name, get(name, envir = .rs.S3Originals), envir = table)
      }
      else
      {
         # no copy to restore, so just remove from the dispatch table
         rm(list = name, envir = table)
      }

      # remove from our override table if present
      if (exists(name, envir = .rs.S3Overrides))
         rm(list = name, envir = .rs.S3Overrides)

      invisible(NULL)
   })

   # recovers from changes made to the S3 method dispatch table during e.g. package load
   .rs.addFunction("reattachS3Overrides", function() {
      # get a list of all of the methods that are currently overridden
      names <- ls(envir = .rs.S3Overrides)
      table <- .BaseNamespaceEnv[[".__S3MethodsTable__."]]
      for (name in names) {
         if (exists(name, envir = table)) {
            # retrieve reference to method
            method = get(name, envir = table)

            # if we didn't put the method there, we've been replaced; reattach our own method. 
            if (!isTRUE(attr(get(name, envir = table), ".rs.S3Override", exact = TRUE)))
               .rs.addS3Override(name, get(name, envir = .rs.S3Overrides))
         }
      }
   })
}

.rs.addFunction("sessionModulePath", function() {
   .Call("rs_sessionModulePath", PACKAGE = "(embedding)")
})

#
# SessionSource.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("save_active_document", function(contents,
                                                       sweave,
                                                       rnwWeave)
{
   # manage working directory
   previousWd = getwd()
   setwd("~/")
   on.exit(setwd(previousWd))

   activeRStudioDoc <- "~/.active-rstudio-document"
   if (file.exists(activeRStudioDoc))
      file.remove(activeRStudioDoc)

   # The contents are always passed as UTF-8 from the client and
   # we want to make sure this is preserved on disk. Note that
   # when the source command is issued by the client for
   # "~/active-rstudio-document" UTF-8 is specified explicitly
   # (see TextEditingTarget.sourceActiveDocument)
   Encoding(contents) <- "UTF-8"
   writeLines(contents, activeRStudioDoc, useBytes = TRUE)
  
   if (sweave)
   {
      op <- function() {
         .Call("rs_rnwTangle", activeRStudioDoc, "UTF-8", rnwWeave)
         file.remove(activeRStudioDoc)
         file.rename(paste(activeRStudioDoc, ".R", sep=""), activeRStudioDoc)
      }
      capture.output(op())
   }

   .Call("rs_ensureFileHidden", activeRStudioDoc)

   return()
})

.rs.addFunction("iconvcommon", function()
{
   # NOTE: we originally included MacRoman and HZ-GB-2312 in our list of
   # common encodings however MacRoman isn't available on Windows or Linux
   # and HZ-GB-2312 isn't available on Linux so we removed them from the
   # common list (in the interest of providing a list of portable encodings
   # so that projects could reliably use common encodings and not run
   # into issues moving from system to system
   #

   common <- c(
      'ASCII', 'UTF-8',
      # Western
      'ISO-8859-1', 'Windows-1252', # 'MacRoman',
      # Japanese
      'Shift-JIS', 'ISO-2022-JP', #'EUC-JP', 'Shift-JISX0213',
      # Trad Chinese
      'Big5', #'Big5-HKSCS',
      # Korean
      'ISO-2022-KR',
      # Arabic
      #'ISO-8859-6', #'Windows-1256',
      # Hebrew
      #'ISO-8859-8', #'Windows-1255',
      # Greek
      'ISO-8859-7', #'Windows-1253',
      # Cyrillic
      #'ISO-8859-5', 'MacCyrillic', 'KOI8-R', 'Windows-1251',
      # Ukrainian
      #'KOI8-U',
      # Simplified Chinese
      'GB2312', #'HZ-GB-2312',
      # Chinese
      'GB18030',
      # Central European
      'ISO-8859-2' #'ISO-8859-4', 'MacCentralEurope', 'Windows-1250'
      # Vietnamese
      #'Windows-1258',
      # Turkish
      #'ISO-8859-5', 'Windows-1254',
      # Baltic
      #'Windows-1257'
   )

   toupper(common)
})

.rs.addJsonRpcHandler("iconvlist", function()
{
   list(common=sort(intersect(.rs.iconvcommon(), toupper(iconvlist()))),
        all=sort(iconvlist()))
})

.rs.addGlobalFunction('source.with.encoding',
   function(path, encoding,
         echo=getOption('verbose'),
         print.eval=echo,
         max.deparse.length=150,
         chdir=FALSE)
{
   warning("source.with.encoding is deprecated and will be removed in a ",
           "future release of RStudio. Use source(..., encoding = '", encoding,
           "') instead.")
   conn = file(path, open='r', encoding=encoding)
   on.exit(close(conn))
   source(conn,
          echo=echo,
          print.eval=print.eval,
          max.deparse.length=max.deparse.length,
          chdir=chdir)
})

.rs.addFunction("detectFreeVarsExpr", function(node)
{
   .rs.detectFreeVars(substitute(node))
})

.rs.addFunction("detectFreeVars", function(node, globals = new.env(parent = baseenv()))
{
   vars <- .rs.stack(mode = "character")
   
   .rs.recursiveWalkIf(node, function(node)
   {
      # check and analyze call objects
      if (is.call(node))
      {
         # skip functions which are likely to perform non-standard evaluation
         if (is.symbol(node[[1L]]))
         {
            lhs <- as.character(node[[1L]])
            if (lhs %in% .rs.nse.primitives)
               return(FALSE)
         }
         
         # recurse into for loops with variable binding active
         isFor <-
            length(node) == 4L &&
            identical(node[[1L]], as.symbol("for"))
         
         if (isFor)
         {
            seqGlobals <- new.env(parent = globals)
            seqVars <- .rs.detectFreeVars(node[[3L]], seqGlobals)
            for (seqVar in seqVars)
               vars$push(seqVar)
            
            forGlobals <- new.env(parent = globals)
            forGlobals[[as.character(node[[2L]])]] <- TRUE
            
            forVars <- .rs.detectFreeVars(node[[4L]], forGlobals)
            for (forVar in forVars)
               vars$push(forVar)
            
            return(FALSE)
         }
      
         # recurse into function definitions; add bindings for
         # the function parameters
         isFunction <-
            identical(node[[1L]], as.symbol("function")) &&
            length(node) >= 3L
         
         if (isFunction)
         {
            functionGlobals <- new.env(parent = globals)
            for (functionParam in names(node[[2L]]))
               functionGlobals[[functionParam]] <- TRUE
            
            functionVars <- .rs.detectFreeVars(node[[3L]], functionGlobals)
            for (functionVar in functionVars)
               vars$push(functionVar)
            
            return(FALSE)
         }
      
         # don't descend into `::` or `:::` qualified lookups
         isNamespace <-
            is.symbol(node[[1L]]) &&
            as.character(node[[1L]]) %in% c("::", ":::")
         
         if (isNamespace)
         {
            return(FALSE)
         }
         
         # for `$` and `@`, only look at left hand side
         isMemberAccess <-
            is.symbol(node[[1L]]) &&
            as.character(node[[1L]]) %in% c("$", "@")
         
         if (isMemberAccess)
         {
            lhs <- node[[2L]]
            if (is.symbol(lhs))
               vars$push(as.character(lhs))
            
            return(FALSE)
         }
         
         # check for assignments
         isAssignment <-
            length(node) == 3L &&
            is.symbol(node[[1L]]) &&
            as.character(node[[1L]]) %in% c("=", "<-", "<<-")
         
         if (isAssignment)
         {
            assignee <- node[[2L]]
            if (is.symbol(assignee))
               assign(as.character(assignee), assignee, envir = globals)
         }
      }
      
      # if we encounter a symbol, it's a free var
      else if (is.symbol(node))
      {
         value <- as.character(node)
         if (nzchar(value) && !exists(value, envir = globals))
            vars$push(value)
         
         return(FALSE)
      }
      
      # try to recurse other objects by default
      TRUE
      
   })
   
   unique(vars$data())
   
})

.rs.addJsonRpcHandler("detect_free_vars", function(code)
{
   node <- parse(text = code, keep.source = FALSE)[[1L]]
   .rs.detectFreeVars(node)
})

.rs.addFunction("createDefaultShellRd", function(`_name`, `_type`)
{  
  # create a tempdir and switch to it for the duration of the function
  dirName <- tempfile("RdShell")
  dir.create(dirName)
  previousWd <- getwd()
  on.exit(setwd(previousWd))
  setwd(dirName)
  
  if (identical(`_type`, "function"))
  {
    assign(`_name`, function(x) {})
    return (.rs.normalizePath(paste(getwd(),
                                utils::prompt(name = `_name`),
                                sep="/")))
  }
  else if (identical(`_type`, "data"))
  {
    assign(`_name`, data.frame(x=integer(), y=integer()))
    return (.rs.normalizePath(paste(getwd(),
                                utils::promptData(name = `_name`),
                                sep="/")))
  }
  else
  {
    return ("")
  }
})

.rs.addFunction("createShellRd", function(name, type, package) 
{  
  # create a tempdir and switch to it for the duration of the function
  dirName <- tempfile("RdShell")
  dir.create(dirName)
  previousWd <- getwd()
  on.exit(setwd(previousWd))
  setwd(dirName)
  
  if (identical(type, "function"))
  {
    func <- .rs.getPackageFunction(name, package)
    if (!is.null(func))
    {
      funcRd <- utils::prompt(func, name = name)
      return (.rs.normalizePath(paste(getwd(),funcRd,sep="/")))
    }
    else
    {
      return ("")
    }
  }
  else if (identical(type, "data"))
  {
    dataRd <- tryCatch(suppressWarnings({
      library(package,character.only=TRUE)
      eval(parse(text = paste("data(", name, "); ", 
                              "utils::promptData(", name, ");", sep="")),
           envir = globalenv())    
    }), error = function(e) {print(e); ""})
    
    if (nzchar(dataRd) == TRUE)
      return (.rs.normalizePath(paste(getwd(), dataRd, sep="/")))
    else
      return ("")
  }
  else
  {
    return ("")
  }
})

.rs.addFunction("initSource", function()
{
   .rs.registerReplaceHook("file.edit", "utils", function(original, ...)
   {
      # just take unnamed arguments (those are the files)
      args <- c(...)
      names <- names(args)
      if (!is.null(names))
        args <- args[names(args) == ""]

      # call rstudio fileEdit function
      invisible(.Call("rs_fileEdit", args, PACKAGE = "(embedding)"))
   })
})

.rs.addFunction("getSourceDocument", function(id, includeContents = FALSE)
{
   .Call(
      "rs_getSourceDocument",
      as.character(id),
      as.logical(includeContents),
      PACKAGE = "(embedding)"
   )
})

.rs.addFunction("getSourceDocumentProperties", function(path, includeContents = FALSE)
{
   if (is.null(path) || !file.exists(path))
      return(NULL)

   path <- normalizePath(path, winslash = "/", mustWork = TRUE)
   .Call("rs_getDocumentProperties", path, includeContents)
})

.rs.addFunction("generateStylerFormatDocumentScript", function(documentPath,
                                                               scriptPath)
{
   # only invoke 'styler' on supported file types
   ext <- tools::file_ext(documentPath)
   if (!tolower(ext) %in% c("r", "rmd", "rmarkdown", "qmd", "rnw"))
      return()

   # figure out where 'styler' is installed
   stylerPath <- find.package("styler")
   libraryPaths <- .libPaths(c(dirname(stylerPath), .libPaths()))

   # create a tidyverse styler, using the current indentation settings
   indent <- .rs.readUserPref("num_spaces_for_tab", 2L)
   strict <- .rs.readUserPref("code_formatter_styler_strict", TRUE)
   
   # try to infer the base indentation
   contents <- readLines(documentPath, warn = FALSE)
   indents <- regexpr("\\S", contents, perl = TRUE)
   baseIndent <- min(indents[indents >= 0]) - 1L

   # generate and write code to file
   expr <- rlang::expr({
      .libPaths(!!libraryPaths)
      styler::style_file(
         path = !!documentPath,
         indent_by = !!indent,
         strict = !!strict,
         base_indention = !!baseIndent
      )
   })

   writeLines(deparse(expr), con = scriptPath)
})

#
# SessionCodeTools.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("discover_package_dependencies", function(docId, fileType)
{
   available <- .rs.availablePackages()
   ready <- !is.null(available$value)
   packages <- .rs.discoverPackageDependencies(docId, fileType)
   list(ready = .rs.scalar(ready), packages = packages)
})

.rs.addFunction("stopf", function(fmt, ..., call. = FALSE)
{
   msg <- sprintf(fmt, ...)
   stop(msg, call. = call.)
})

.rs.addFunction("error", function(...)
{
   list(
      result  = NULL,
      message = .rs.scalar(paste(..., sep = ""))
   )
})

.rs.addFunction("success", function(result = NULL)
{
   list(
      result  = result,
      message = NULL
   )
})

.rs.addFunction("withTimeLimit", function(seconds,
                                          expr,
                                          fail = NULL)
{
   setTimeLimit(elapsed = seconds, transient = TRUE)
   on.exit(setTimeLimit(), add = TRUE)
   tryCatch(expr, error = function(e) fail)
})

.rs.addFunction("startsWith", function(strings, string)
{
   if (!length(string))
      string <- ""

   n <- nchar(string)
   (nchar(strings) >= n) & (substring(strings, 1, n) == string)
})

.rs.addFunction("selectStartsWith", function(strings, string)
{
   strings[.rs.startsWith(strings, string)]
})

.rs.addFunction("endsWith", function(strings, string)
{
   if (!length(string))
      string <- ""

   nstrings <- nchar(strings)
   nstring <- nchar(string)
   (nstrings >= nstring) &
      (substring(strings, nstrings - nstring + 1, nstrings) == string)
})

.rs.addFunction("selectEndsWith", function(strings, string)
{
   strings[.rs.endsWith(strings, string)]
})

# Return the scope names in which the given names exist
.rs.addFunction("which", function(names) {
   scopes = search()
   sapply(names, function(name) {
      for (scope in scopes) {
         if (exists(name, where=scope, inherits=F))
            return(scope)
      }
      return("")
   })
})

.rs.addFunction("surround", function(string, with)
{
   paste(with, string, with, sep = "")
})

.rs.addFunction("guessToken", function(line, cursorPos)
{
   utils:::.assignLinebuffer(line)
   utils:::.assignEnd(cursorPos)
   utils:::.guessTokenFromLine()
})

.rs.addFunction("findFunctionNamespace", function(name, fromWhere)
{
   if (!identical(fromWhere, ""))
   {
      if ( ! (fromWhere %in% search()) )
         return ("")

      where = as.environment(fromWhere)
   }
   else
   {
      where = globalenv()
   }

   envList <- methods:::findFunction(name, where = where)
   if (length(envList) > 0)
   {
      env <- envList[[1]]
      if (identical(env, baseenv()))
      {
         return ("package:base")
      }
      else if (identical(env, globalenv()))
      {
         return(".GlobalEnv")
      }
      else
      {
         envName = attr(envList[[1]], "name")
         if (!is.null(envName))
            return (envName)
         else
            return ("")
      }
   }
   else
   {
      return ("")
   }
})

.rs.addFunction("getFunction", function(name, envir = globalenv())
{
   tryCatch(
      .rs.getFunctionImpl(name, envir),
      error = function(e) NULL
   )
})

.rs.addFunction("getFunctionImpl", function(name, envir = globalenv())
{
   envir <- .rs.resolveEnvironment(envir)
   parsed <- parse(text = name)[[1L]]

   # for plain symbols, we can attempt lookup of a function object
   # directly; for more complex calls, we try to evaluate it in
   # the requested environment and hope we got a function
   fn <- if (is.symbol(parsed))
      get(name, envir = envir, mode = "function")
   else
      eval(parsed, envir = envir)

   if (!is.function(fn))
      return(NULL)

   fn
})


.rs.addFunction("functionHasSrcRef", function(func)
{
   !is.null(attr(func, "srcref"))
})

# Returns a function's code as a string. Arguments:
# useSource -- Whether to use the function's source references (if available)
# asString -- Whether to return the result as a single string
#             (otherwise a character vector of lines is returned)
.rs.addFunction("deparseFunction", function(func, useSource, asString)
{
   # If we're being asked to return the source references as-is, read the source
   # references directly instead of going through deparse (which has a known
   # issue that corrupts output with backslashes in R 4.0.0 and perhaps other
   # versions; see R bug 17800).
   if (useSource)
   {
      srcref <- attr(func, "srcref", exact = TRUE)
      if (!is.null(srcref))
      {
         code <- as.character(srcref, useSource = TRUE)
         if (asString)
           return(paste(code, collapse = "\n"))
         else
           return(code)
      }
   }

   control <- c("keepInteger", "keepNA")
   if (useSource)
     control <- append(control, "useSource")

   code <- deparse(func, width.cutoff = 59, control = control)

   # if we were asked not to use source refs, or we were but there wasn't a
   # source ref to use, then format the code according to user pref
   if (!useSource || is.null(attr(func, "srcref", exact = TRUE)))
   {
     replaceText <- "\t"

     # determine the replacement text based on the user's current editing
     # preferences
     if (isTRUE(.rs.readUiPref("use_spaces_for_tab")))
     {
       replaceText <- paste(rep(" ", .rs.readUiPref("num_spaces_for_tab")),
                                collapse = "")
     }

     # split the code into individual lines -- R's immutable strings make it
     # quicker to process these small chunks than on the whole code text
     lines <- unlist(strsplit(code, "\n", fixed = TRUE))
     for (l in seq_along(lines))
     {
       line <- lines[[l]]
       pos <- 1
       # convert up to 20 indentation levels per line
       for (lvl in seq_len(20))
       {
         # NOTE: the 4 spaces comes from the implementation of printtab2buff in
         # deparse.c -- it is hard-coded to use 4 spaces for the first 4 levels
         # of indentation and then 2 spaces for subsequent levels.
         indent <- if (lvl <= 4) "    " else "  "
         if (substring(line, pos, pos + (nchar(indent) - 1)) == indent)
         {
           # convert this indent to the user's preferred indentation
           line <- paste(substring(line, 0, pos - 1),
                         replaceText,
                         substring(line, pos + nchar(indent)),
                         sep = "")
           pos <- pos + nchar(replaceText)
         }
         else
         {
           # no more indents we want to convert on this line
           break
         }
       }
       lines[[l]] <- line
     }

     # if we were asked to return individual lines, we're done now
     if (!asString)
       return(lines)
     else
       code <- lines
   }

   # return (possibly formatted) code
   if (asString)
     paste(code, collapse = "\n")
   else
     code
})

.rs.addFunction("isS3Generic", function(object)
{
   if (!is.function(object))
      return(FALSE)

   if (inherits(object, "groupGenericFunction"))
      return(TRUE)

   .rs.callsUseMethod(body(object))

})

.rs.addFunction("callsUseMethod", function(x)
{
   if (missing(x))
      return(FALSE)

   if (!is.call(x))
      return(FALSE)

   if (identical(x[[1]], quote(UseMethod)))
      return(TRUE)

   if (length(x) == 1)
      return(FALSE)

   for (arg in as.list(x[-1]))
      if (.rs.callsUseMethod(arg))
         return(TRUE)

   FALSE
})

.rs.addFunction("getUseMethodGeneric", function(x)
{
   if (is.function(x))
      x <- body(x)

   if (!is.call(x))
      return(NULL)

   UseMethod <- as.name("UseMethod")
   generic <- NULL
   .rs.recursiveSearch(x, function(node) {

      if (!is.call(node) || length(node) < 2 || length(node) > 3)
         return(FALSE)

      lhs <- node[[1]]
      if (!identical(lhs, UseMethod))
         return(FALSE)

      matched <- tryCatch(
         match.call(function(generic, object) {}, node),
         error = function(e) NULL
      )

      if (is.character(matched[["generic"]]))
      {
         generic <<- matched[["generic"]]
         return(TRUE)
      }

      FALSE
   })

   generic
})

.rs.addFunction("getS3MethodDefinitions", function(generic)
{
   if (is.function(generic))
      generic <- .rs.getUseMethodGeneric(generic)

   if (!is.character(generic))
      return(NULL)

   call <- substitute(
      methods(generic),
      list(generic = generic)
   )

   methods <- eval(call, envir = globalenv())
   info <- attr(methods, "info")
   if (!is.data.frame(info))
      return(NULL)

   defns <- lapply(seq_len(nrow(info)), function(i) {
      method <- rownames(info)[[i]]
      generic <- info$generic[[i]]
      class <- substring(method, nchar(generic) + 2)

      call <- substitute(
         utils::getS3method(generic, class, optional = TRUE),
         list(generic = generic, class = class)
      )

      eval(call, envir = globalenv())
   })

   names(defns) <- rownames(info)
   defns
})

.rs.addFunction("getS3MethodsForFunction", function(func, envir = parent.frame())
{
  tryCatch({
     call <- call("methods", func)
     as.character(suppressWarnings(eval(call, envir = envir)))
  }, error = function(e) character())
})


# Return a list of S4 methods formatted as  functionName {className, className}
# NOTE: should call isGeneric prior to calling this (it will yield an error
# for functions that aren't generic)
.rs.addFunction("getS4MethodsForFunction", function(func)
{
  sigs <- findMethodSignatures(methods = findMethods(func))
  apply(sigs,
        1,
        function(sig)
        {
           paste(func,
                 " {",
                 paste(sig, collapse=", "),
                 "}",
                 sep="",
                 collapse = "")
        })
})

.rs.addFunction("getS4MethodNamespaceName", function(method)
{
  env <- environment(method)
  if (identical(env, baseenv()))
    return ("package:base")
  else if (identical(env, globalenv()))
    return (".GlobalEnv")
  else
  {
    envName <- environmentName(env)
    if (envName %in% search())
      return (envName)
    else
      paste("package:", envName, sep="")
  }
})

.rs.addFunction("getPendingInput", function()
{
   .Call("rs_getPendingInput")
})

.rs.addFunction("doStripSurrounding", function(string, complements)
{
   result <- gsub("^\\s*([`'\"])(.*?)\\1.*", "\\2", string, perl = TRUE)
   for (item in complements)
   {
      result <- sub(
         paste("^\\", item[[1]], "(.*)\\", item[[2]], "$", sep = ""),
         "\\1",
         result,
         perl = TRUE
      )
   }
   result

})

.rs.addFunction("stripSurrounding", function(string)
{
   complements <- list(
      c("(", ")"),
      c("{", "}"),
      c("[", "]"),
      c("<", ">")
   )

   result <- .rs.doStripSurrounding(string, complements)
   while (result != string)
   {
      string <- result
      result <- .rs.doStripSurrounding(string, complements)
   }
   result
})

.rs.addFunction("resolveObjectSource", function(object, envir)
{
   # Try to find the associated namespace of the object
   namespace <- NULL
   if (is.primitive(object))
      namespace <- "base"
   else if (is.function(object))
   {
      envString <- capture.output(environment(object))[1]
      match <- regexpr("<environment: namespace:(.*)>", envString, perl = TRUE)
      if (match == -1L)
         return()

      start <- attr(match, "capture.start")[1]
      end <- start + attr(match, "capture.length")[1]
      namespace <- substring(envString, start, end - 1)
   }
   else if (isS4(object))
      namespace <- attr(class(object), "package")

   if (is.null(namespace))
      return()

   # Get objects from that namespace
   ns <- asNamespace(namespace)
   objectNames <- objects(ns, all.names = TRUE)
   objects <- tryCatch(
      mget(objectNames, envir = ns),
      error = function(e) NULL
   )

   if (is.null(objects))
      return()

   # Find which object is actually identical to the one we have
   success <- FALSE
   for (i in seq_along(objects))
   {
      if (identical(object, objects[[i]], ignore.environment = TRUE))
      {
         success <- TRUE
         break
      }
   }

   # Use that name for the help lookup
   if (success)
      return(list(
         name = objectNames[[i]],
         package = namespace
      ))

})

.rs.addFunction("resolveAliasedSymbol", function(object)
{
   if (!is.function(object))
      return(object)

   if (is.primitive(object))
      return(object)

   body <- body(object)
   if (is.symbol(body))
     return(object)

   env <- environment(object)
   if (length(body) && .rs.isSymbolCalled(body[[1]], ".rs.callAs"))
      return(env$original)

   return(object)
})

.rs.addFunction("getAnywhere", function(name, envir = parent.frame())
{
   result <- NULL

   if (!length(name))
      return(NULL)

   if (is.character(name) && (length(name) != 1 || name == ""))
      return(NULL)

   # Don't evaluate any functions -- skip any 'name' that contains a paren
   if (is.character(name) && regexpr("(", name, fixed = TRUE) > 0)
      return(FALSE)

   # Helper function for evaluating an expression with warnings + messages
   # suppressed, and errors coerced to NULL
   quietly <- function(expr) {
      withCallingHandlers(
         tryCatch(expr, error = function(e) NULL),
         warning = function(e) invokeRestart("muffleWarning"),
         message = function(e) invokeRestart("muffleMessage")
      )
   }

   if (is.character(name) && is.character(envir))
   {
      # If envir is the name of something on the search path, get it from there
      pos <- match(envir, search(), nomatch = -1L)
      if (pos >= 0)
      {
         object <- quietly(get(name, pos = pos))
         if (!is.null(object))
            return(.rs.resolveAliasedSymbol(object))
      }

      # Otherwise, maybe envir is the name of a package -- search there
      if (envir %in% loadedNamespaces())
      {
         object <- quietly(get(name, envir = asNamespace(envir)))
         if (!is.null(object))
            return(.rs.resolveAliasedSymbol(object))
      }
   }

   if (is.character(name))
   {
      name <- quietly(parse(text = .rs.stripSurrounding(name)))
      if (is.null(name))
         return(NULL)
   }

   if (is.language(name))
      result <- quietly(eval(name, envir = envir))

   .rs.resolveAliasedSymbol(result)

})

.rs.addFunction("getFunctionArgumentNames", function(object)
{
   # for primitive objects, 'args()' can be used to extract
   # a function object with compatible prototype -- although
   # primitive functions that power control flow (e.g. `if()`,
   # `return()` can return NULL)
   if (is.primitive(object))
      object <- args(object)

   result <- character()
   if (is.function(object))
      result <- names(formals(object))

   result
})

.rs.addFunction("getNames", function(object)
{
   tryCatch({
      if (is.environment(object))
         ls(object, all.names = TRUE)
      else if (inherits(object, "tbl") && "dplyr" %in% loadedNamespaces())
         dplyr::tbl_vars(object)
      # For some reason, `jobjRef` objects (from rJava) return names containing
      # parentheses after the associated function call, which confuses our completion
      # system.
      else if (inherits(object, "jobjRef"))
         gsub("[\\(\\)]", "", names(object))
      else
         names(object)
   }, error = function(e) NULL)
})

.rs.addJsonRpcHandler("get_help_at_cursor", function(line, cursorPos)
{
   token <- .rs.guessToken(line, cursorPos)
   if (token == '')
      return()

   pieces <- strsplit(token, ':{2,3}')[[1]]

   # use devtools shim for help if available
   if ("devtools_shims" %in% search() &&
       "devtools" %in% loadedNamespaces() &&
       exists("shim_help", envir = asNamespace("devtools")))
   {
      help <- devtools:::shim_help
   }
   else
   {
      help <- utils::help
   }

   capture.output(suppressMessages({
      if (length(pieces) > 1) {
         print(help(pieces[2], package = pieces[1], help_type = 'html'))
      } else {
         # try custom help handler, otherwise fall through to default handler
         helpUrl <- .rs.getCustomHelpUrl(token)
         if (!is.null(helpUrl)) {
            if (nzchar(helpUrl)) # handlers return "" to indicate no help available
               utils::browseURL(helpUrl)
         } else {
            print(help(pieces[1], help_type = 'html', try.all.packages = TRUE))
         }
      }
   }))
})

.rs.addFunction("findCustomHelpContext", function(token, handler) {

   # if the token has a '$' in it then it might have a custom
   # help handler that can field this request
   if (grepl("\\$", token)) {

      # split on $ (it has at least one so components will be > 1)
      components <- strsplit(token, "\\$")[[1]]
      topic <- components[[length(components)]]
      source <- paste(components[1:(length(components)-1)], collapse = "$")

      # evaluate the source
      source <- tryCatch(eval(parse(text = source), envir = globalenv()),
                         error = function(e) NULL)

      # look for a help url handler
      if (!is.null(source)) {
         for (cls in class(source)) {
            res <- utils::getAnywhere(paste(handler, ".", cls, sep=""))
            if (length(res$objs) > 0) {
               return(list(
                  topic = topic,
                  source = source,
                  handler = res$objs[[1]]
               ))
            }
         }
      }
   }

   # default to none found
   NULL

})

# check to see whether there is a custom help handler for this token
.rs.addFunction("getCustomHelpUrl", function(token) {
   custom <- .rs.findCustomHelpContext(token, "help_url_handler")
   if (!is.null(custom))
      custom$handler(custom$topic, custom$source)
   else
      NULL
})

.rs.addJsonRpcHandler("execute_r_code", function(code)
{
   # allow 2 seconds to execute code
   setTimeLimit(elapsed = 2, transient = TRUE)
   on.exit(setTimeLimit(), add = TRUE)

   # evaluate requested code
   envir <- parent.frame(2)
   result <- .rs.tryCatch({

      output <- capture.output(
         evaled <- suppressWarnings(
            eval(parse(text = code), envir = envir)
         )
      )

      object <- if (length(output))
         output
      else
         deparse(evaled)

   })

   if (inherits(result, "error"))
      return(.rs.scalar(""))

   .rs.scalar(paste(as.character(object), collapse = "\n"))
})

.rs.addJsonRpcHandler("is_function", function(nameString, envString)
{
   object <- NULL

   if (envString == "")
   {
      object <- .rs.getAnywhere(nameString, parent.frame())
   }
   else
   {
      envString <- .rs.stripSurrounding(envString)
      if (envString %in% search())
      {
         object <- tryCatch(
            get(nameString, pos = which(envString == search())),
            error = function(e) NULL
         )
      }
      else if (envString %in% loadedNamespaces())
      {
         object <- tryCatch(
            get(nameString, envir = asNamespace(envString)),
            error = function(e) NULL
         )
      }
      else if (!is.null(container <- .rs.getAnywhere(envString, parent.frame())))
      {
         if (isS4(container))
         {
            object <- tryCatch(
               eval(call("@", container, nameString)),
               error = function(e) NULL
            )
         }
         else
         {
            object <- tryCatch(
               eval(call("$", container, nameString)),
               error = function(e) NULL
            )
         }
      }
   }
   .rs.scalar(!is.null(object) && is.function(object))
})

.rs.addFunction("asCaseInsensitiveRegex", function(string)
{
   if (string == "")
      return(string)

   splat <- strsplit(string, "", fixed = TRUE)[[1]]
   lowerSplat <- tolower(splat)
   upperSplat <- toupper(splat)
   result <- vapply(1:length(splat), FUN.VALUE = character(1), USE.NAMES = FALSE, function(i) {
      if (lowerSplat[i] == upperSplat[i])
         splat[i]
      else
         paste("[", lowerSplat[i], upperSplat[i], "]", sep = "")
   })
   paste(result, collapse = "")
})

.rs.addFunction("asCaseInsensitiveSubsequenceRegex", function(string)
{
   if (string == "")
      return(string)

   splat <- strsplit(string, "", fixed = TRUE)[[1]]
   lowerSplat <- tolower(splat)
   upperSplat <- toupper(splat)

   result <- vapply(1:length(splat), FUN.VALUE = character(1), USE.NAMES = FALSE, function(i) {
      if (lowerSplat[i] == upperSplat[i])
         splat[i]
      else
         paste("[", lowerSplat[i], upperSplat[i], "]", sep = "")
   })

   negated <- vapply(1:length(splat), FUN.VALUE = character(1), USE.NAMES = FALSE, function(i) {
      if (lowerSplat[i] == upperSplat[i])
         paste("[^", splat[i], "]*", sep = "")
      else
         paste("[^", lowerSplat[i], upperSplat[i], "]*", sep = "")
   })

   negated <- c(negated[-1L], "")
   paste(result, negated, sep = "", collapse = "")
})

.rs.addFunction("isSubsequence", function(strings, string)
{
   .Call("rs_isSubsequence", strings, string)
})

.rs.addFunction("whichIsSubsequence", function(strings, string)
{
   which(.rs.isSubsequence(strings, string))
})

.rs.addFunction("selectIsSubsequence", function(strings, string)
{
   .subset(strings, .rs.isSubsequence(strings, string))
})

.rs.addFunction("escapeForRegex", function(regex)
{
   gsub("([\\-\\[\\]\\{\\}\\(\\)\\*\\+\\?\\.\\,\\\\\\^\\$\\|\\#\\s])", "\\\\\\1", regex, perl = TRUE)
})

# Escapes HTML entities in a character vector (text); "attribute" is a boolean indicating whether
# additional characters specific to HTML attributes should be escaped (newlines).
.rs.addFunction("htmlEscape", function(text, attribute = FALSE)
{
   .Call("rs_htmlEscape", text, attribute, PACKAGE = "(embedding)")
})

.rs.addFunction("objectsOnSearchPath", function(token = "",
                                                caseInsensitive = FALSE,
                                                excludeGlobalEnv = FALSE)
{
   search <- search()
   startIdx <- 1
   range <- 1:length(search)

   if (excludeGlobalEnv)
   {
      startIdx <- 2
      search <- search[-1]
      range <- range[-1]
   }

   if (nzchar(token))
   {
      token <- .rs.escapeForRegex(token)
      if (caseInsensitive)
         token <- .rs.asCaseInsensitiveRegex(token)
      pattern <- paste("^", token, sep = "")

      objects <- lapply(range, function(i) {
         ls(pos = i, all.names = TRUE, pattern = pattern)
      })
   }
   else
   {
      objects <- lapply(range, function(i) {
         ls(pos = i, all.names = TRUE)
      })
   }

   names(objects) <- search
   objects
})

.rs.addFunction("assign", function(x, value)
{
   assign(paste(".rs.cache.", x, sep = ""), value, envir = .rs.toolsEnv())
})

.rs.addFunction("get", function(x)
{
   tryCatch(
      get(paste(".rs.cache.", x, sep = ""), envir = .rs.toolsEnv()),
      error = function(e) NULL
   )
})

.rs.addFunction("mget", function(x = NULL)
{
   tryCatch(
      {
         objects <- if (is.null(x))
            .rs.selectStartsWith(objects(envir = .rs.toolsEnv(), all.names = TRUE), ".rs.cache")
         else
            paste(".rs.cache.", x, sep = "")

         mget(objects, envir = .rs.toolsEnv())
      },

      error = function(e) NULL
   )
})

.rs.addFunction("packageNameForSourceFile", function(filePath)
{
   .Call("rs_packageNameForSourceFile", filePath)
})

.rs.addFunction("isRScriptInPackageBuildTarget", function(filePath)
{
   .Call("rs_isRScriptInPackageBuildTarget", filePath)
})

.rs.addFunction("namedVectorAsList", function(vector)
{
   values <- unlist(vector, use.names = FALSE)
   if (!length(values))
      return(list(names = NULL, values = NULL))
   vectorNames <- names(vector)
   names <- unlist(lapply(seq_along(vector), function(i) {
      rep.int(vectorNames[i], length(vector[[i]]))
   }))

   list(names = names, values = values)
})

.rs.addFunction("getDollarNamesMethod", function(object,
                                                 excludeBaseClasses = FALSE,
                                                 envir = globalenv())
{
   classAndSuper <- function(cl)
   {
      # selectSuperClasses throws an error if the class is unknown
      super <- tryCatch(
         methods::selectSuperClasses(cl),
         error = function(e) NULL
      )

      c(cl, super)
   }

   # interleave super classes after the corresponding original classes
   classes <- unlist(lapply(class(object), classAndSuper), recursive = TRUE)

   # either remove or add an explicit (=non-mode) list/environment class
   classes <- if (excludeBaseClasses)
      setdiff(classes, c("list", "environment"))
   else
      c(classes, mode(object))

   for (class in classes)
   {
      # support older getS3method() definitions (without envir)
      method <- if ("envir" %in% names(formals(utils::getS3method)))
      {
         utils::getS3method(
            f = ".DollarNames",
            class = class,
            optional = TRUE,
            envir = envir
         )
      }
      else
      {
         utils::getS3method(
            f = ".DollarNames",
            class = class,
            optional = TRUE
         )
      }

      if (!is.null(method))
         return(method)
   }

   NULL
})

.rs.addJsonRpcHandler("get_args", function(name, src, helpHandler)
{
   # call custom help handler if provided
   if (nzchar(helpHandler)) {

      # resolve help handler
      helpHandlerFunc <- tryCatch(
         eval(parse(text = helpHandler)),
         error = function(e) NULL
      )

      if (!is.function(helpHandlerFunc))
         return(NULL)

      # invoke handler function
      help <- tryCatch(
         helpHandlerFunc("completion", name, src),
         error = function(e) NULL
      )

      if (is.null(help))
         return(NULL)

      # attempt to retrieve signature
      signature <- help$signature
      if (!is.null(signature)) {
         paren <- regexpr("\\(", signature)[[1]]
         if (paren != -1)
            signature <- substring(signature, paren)
      }
      return(.rs.scalar(signature))
   }

   # if we're getting arguments for 'write.csv', infer arguments
   # based on 'write.table'
   isUtils <-
      identical(src, "package:utils") ||
      identical(src, "utils")

   if (isUtils)
   {
      if (identical(name, "write.csv") ||
          identical(name, "write.csv2"))
      {
         name <- "write.table"
      }
   }

   # NOTE: 'src' can refer either to a package for usages of the form
   # 'utils::alarm()', or an object for usages of the form 'object$method()'.
   # We need to be careful to handle both types.

   # first, try to resolve as environment
   envir <- .rs.tryCatch(.rs.resolveEnvironment(src))
   if (is.environment(envir))
   {
      method <- .rs.tryCatch(get(name, envir = envir, mode = "function"))
      if (is.function(method))
      {
         signature <- .rs.getSignature(method)
         result <- sub("function ", "", signature)
         return(.rs.scalar(result))
      }
   }

   # next, try to resolve as regular R object
   envir <- .rs.getActiveFrame()
   object <- .rs.getAnywhere(src, envir = envir)
   if (!is.null(object))
   {
      # if the user is calling 'R6$new', try inferring objects from the
      # initialize method instead
      method <- if (inherits(object, "R6ClassGenerator") &&
                    identical(name, "new"))
      {
         object$public_methods$initialize
      }
      else
      {
         .rs.tryCatch(object[[name]])
      }

      if (is.function(method))
      {
         signature <- .rs.getSignature(method)
         result <- sub("function ", "", signature)
         return(.rs.scalar(result))
      }
   }

   # all else fails, just provide a dummy return value
   .rs.scalar("(...)")

})

.rs.addFunction("getActiveArgument", function(object,
                                              matchedCall)
{
   allArgs <- .rs.getFunctionArgumentNames(object)
   matchedArgs <- names(matchedCall)[-1L]
   qualifiedArgsInCall <- setdiff(matchedArgs, "")
   setdiff(allArgs, qualifiedArgsInCall)[1]
})

.rs.addFunction("swap", function(vector, ..., default)
{
   dotArgs <- list(...)

   nm <- names(dotArgs)

   to <- unlist(lapply(seq_along(dotArgs), function(i)
      rep(nm[i], each = length(dotArgs[[i]]))
   ))

   from <- unlist(dotArgs)

   tmp <- to[match(vector, from)]
   tmp[is.na(tmp)] <- default
   tmp
})

.rs.addFunction("scoreMatches", function(strings, string)
{
   .Call("rs_scoreMatches", strings, string)
})

.rs.addFunction("getProjectDirectory", function()
{
   .Call("rs_getProjectDirectory")
})

.rs.addFunction("hasFileMonitor", function()
{
   .Call("rs_hasFileMonitor")
})

.rs.addFunction("doListIndex", function(routine, term, inDirectory, maxCount)
{
   if (!.rs.hasFileMonitor() || is.null(inDirectory))
      return(NULL)

   inDirectory <- suppressWarnings(.rs.normalizePath(inDirectory))
   inDirectory <- gsub("[/\\\\]+$", "", inDirectory)

   .Call(routine, term, inDirectory, as.integer(maxCount))
})

.rs.addFunction("listIndexedFiles", function(term = "",
                                             inDirectory = .rs.getProjectDirectory(),
                                             maxCount = 200L)
{
   .rs.doListIndex("rs_listIndexedFiles", term, inDirectory, as.integer(maxCount))
})

.rs.addFunction("listIndexedFolders", function(term = "",
                                               inDirectory = .rs.getProjectDirectory(),
                                               maxCount = 200L)
{
   .rs.doListIndex("rs_listIndexedFolders", term, inDirectory, maxCount)
})

.rs.addFunction("listIndexedFilesAndFolders", function(term = "",
                                                       inDirectory = .rs.getProjectDirectory(),
                                                       maxCount = 200L)
{
   .rs.doListIndex("rs_listIndexedFilesAndFolders", term, inDirectory, maxCount)
})

.rs.addFunction("doGetIndex", function(term = "",
                                       inDirectory = .rs.getProjectDirectory(),
                                       maxCount = 200L,
                                       getter)
{
   if (is.null(inDirectory))
      return(character())

   inDirectory <- suppressWarnings(
      .rs.normalizePath(inDirectory)
   )

   index <- getter(term, inDirectory, maxCount)

   if (is.null(index))
   {
      return(list(
         paths = character(),
         more_available = FALSE
      ))
   }

   paths <- suppressWarnings(.rs.normalizePath(index$paths, winslash = "/"))
   scores <- .rs.scoreMatches(basename(paths), term)
   index$paths <- paths[order(scores)]
   index

})

.rs.addFunction("getIndexedFiles", function(term = "",
                                            inDirectory = .rs.getProjectDirectory(),
                                            maxCount = 200L)
{
   .rs.doGetIndex(term, inDirectory, maxCount, .rs.listIndexedFiles)
})

.rs.addFunction("getIndexedFolders", function(term = "",
                                              inDirectory = .rs.getProjectDirectory(),
                                              maxCount = 200L)
{
   .rs.doGetIndex(term, inDirectory, maxCount, .rs.listIndexedFolders)
})

.rs.addFunction("getIndexedFilesAndFolders", function(term = "",
                                                      inDirectory = .rs.getProjectDirectory(),
                                                      maxCount = 200L)
{
   .rs.doGetIndex(term, inDirectory, maxCount, .rs.listIndexedFilesAndFolders)
})

## NOTE: Function may be used by async R process; must not call back into
## 'rs_' compiled code!
.rs.addFunction("jsonEscapeString", function(value)
{
   if (is.na(value)) return("null")
   chars <- strsplit(value, "", fixed = TRUE)[[1]]
   chars <- vapply(chars, function(x) {
      if (x %in% c('"', '\\', '/'))
         paste('\\', x, sep = '')
      else if (length(charToRaw(x)) == 1 && charToRaw(x) < 32)
         paste('\\u', toupper(format(as.hexmode(as.integer(charToRaw(x))),
                                     width = 4)),
               sep = '')
      else
         x
   }, character(1))
   paste(chars, sep = "", collapse = "")
})

## NOTE: Function may be used by async R process; must not call back into
## 'rs_' compiled code!
.rs.addFunction("jsonProperty", function(name, value)
{
   paste(sep = "",
         "\"",
         .rs.jsonEscapeString(enc2utf8(name)),
         "\":\"",
         .rs.jsonEscapeString(enc2utf8(value)),
         "\""
   )
})

## NOTE: Specify that a JSON value should be returned as a scalar by
## giving it the 'AsIs' class; ie, by writing 'foo = I(1)', or otherwise
## by using the '.rs.scalar' function.
##
## NOTE: Function may be used by async R process; must not call back into
## 'rs_' compiled code!
##
## NOTE: lists are considered as objects if they are named, and as arrays if
## they are not. If you have an empty list that you want to treat as an object,
## you must give it a names attribute.
##
## Unbox will automatically unbox any 1-length non-list vectors.
.rs.addFunction("toJSON", function(object, unbox = FALSE)
{
   AsIs <- inherits(object, "AsIs") || inherits(object, ".rs.scalar")
   if (is.list(object))
   {
      if (is.null(names(object)))
      {
         return(paste('[', paste(lapply(seq_along(object), function(i) {
            .rs.toJSON(object[[i]], unbox = unbox)
         }), collapse = ','), ']', sep = '', collapse=','))
      }
      else
      {
         return(paste('{', paste(lapply(seq_along(object), function(i) {
            paste(sep = "",
                  '"',
                  .rs.jsonEscapeString(enc2utf8(names(object)[[i]])),
                  '":',
                  .rs.toJSON(object[[i]], unbox = unbox)
            )
         }), collapse = ','), '}', sep = '', collapse = ','))
      }
   }
   else
   {
      n <- length(object)

      # NOTE: For type safety we cannot unmarshal NULL as '{}' as e.g. jsonlite does.
      if (is.null(object))
      {
         if (unbox)
            return('null')
         else
            return('[]')
      }
      else if (n == 0)
      {
         return('[]')
      }
      else if (is.character(object) || is.factor(object))
      {
         object <- paste(collapse = ",", vapply(as.character(object), FUN.VALUE = character(1), USE.NAMES = FALSE, function(x) {
            if (is.na(x)) "null"
            else paste("\"", .rs.jsonEscapeString(enc2utf8(x)), "\"", sep = "")
         }))
      }
      else if (is.numeric(object))
      {
         object[is.na(object)] <- '\"NA\"'
      }
      else if (is.logical(object))
      {
         object <- ifelse(object, "true", "false")
         object[is.na(object)] <- 'null'
      }

      if (AsIs || (unbox && n == 1))
         return(paste(object))
      else
         return(paste('[', paste(object, collapse = ','), ']', sep = '', collapse = ','))
   }
})

.rs.addFunction("recordFunctionInformation", function(node,
                                                      missingEnv,
                                                      symbolsUsedEnv)
{
   if (is.call(node) && length(node) == 2)
   {
      head <- node[[1]]
      second <- node[[2]]
      if (.rs.isSymbolCalled(head, "missing") &&
          is.symbol(second))
      {
         missingEnv[[as.character(second)]] <- TRUE
      }
   }

   ## TODO: Obviously not perfect because of NSE.
   if (is.symbol(node) && !identical(node, quote(expr = )))
      symbolsUsedEnv[[as.character(node)]] <- TRUE
})

.rs.addFunction("emptyNamedList", function()
{
   `names<-`(list(), character())
})

.rs.addFunction("emptyFunctionInfo", function()
{
   list(
      formal_names = character(),
      formal_info  = list(),
      performs_nse = I(0L)
   )
})

# NOTE: This function is used in asynchronous R processes and so
# cannot call back into any RStudio compiled code! Even further,
# `SessionAsyncPackageInformation.cpp` decodes fields based on
# their names, so if you re-name a field here you must modify the
# extraction implementation there as well.
.rs.addFunction("getPackageInformation", function(...)
{
   # force 'rgl' to use the NULL graphics device (avoid inadvertently
   # opening a graphics device / XQuartz window when retrieving completions)
   rgl.useNULL <- getOption("rgl.useNULL")
   options(rgl.useNULL = TRUE)
   on.exit(options(rgl.useNULL = rgl.useNULL), add = TRUE)

   packages <- list(...)
   lapply(packages, function(package) {
      tryCatch(
         .rs.emitPackageInformation(package),
         error = function(e) .rs.emptyFunctionInfo()
      )
   })
})

.rs.addFunction("emitPackageInformation", function(package)
{
   # Explicitly load the library, and do everything we can to hide any
   # package startup messages (because we don't want to put non-JSON
   # on stdout)
   invisible(capture.output(suppressPackageStartupMessages(suppressWarnings({

      ## Don't load the package if a corresponding 00LOCK directory exists.
      ## This gives partial protection against attempting to load a package
      ## while another R process is attempting to modify the library directory.
      has00LOCK <- FALSE
      for (libPath in .libPaths())
      {
         globalLockPath <- file.path(libPath, "00LOCK")
         pkgLockPath <- file.path(libPath, paste("00LOCK", basename(package), sep = "-"))
         if (file.exists(globalLockPath) || file.exists(pkgLockPath))
         {
            has00LOCK <- TRUE
            break
         }
      }

      success <- if (has00LOCK)
         FALSE
      else
         library(package, character.only = TRUE, quietly = TRUE, logical.return = TRUE)

   }))))

   if (!success)
      return(.rs.emptyFunctionInfo())

   # Get the exported items in the NAMESPACE
   # (for search path + `::` completions).
   ns <- asNamespace(package)
   exports <- getNamespaceExports(ns)
   objects <- mget(exports, ns, inherits = TRUE)
   isFunction <- vapply(objects, FUN.VALUE = logical(1), USE.NAMES = FALSE, is.function)
   functions <- objects[isFunction]

   # Figure out the completion types for these objects
   types <- vapply(objects, FUN.VALUE = numeric(1), USE.NAMES = FALSE, .rs.getCompletionType)

   # Find the functions, and generate information on each formal
   # (does it have a default argument; is missingness handled; etc)
   functionInfo <- lapply(functions, function(f) {

      formals <- formals(f)
      if (!length(formals))
         return(.rs.emptyFunctionInfo())

      formalNames <- names(formals)
      hasDefault <- vapply(formals, FUN.VALUE = integer(1), USE.NAMES = FALSE, function(x) {
         !identical(x, quote(expr = ))
      })

      # Record which symbols in the function body handle missingness,
      # to check if missingness of default arguments is handled
      missingEnv <- new.env(parent = emptyenv())
      usedSymbolsEnv <- new.env(parent = emptyenv())
      .rs.recursiveWalk(body(f), function(node) {
         .rs.recordFunctionInformation(node, missingEnv, usedSymbolsEnv)
      })

      # Figure out which functions perform NSE.
      # TODO: Figure out which arguments are actually involved in NSE.
      performsNse <- .rs.performsNonstandardEvaluation(f)

      formalInfo <- lapply(seq_along(formalNames), function(i) {
         as.integer(c(
            hasDefault[[i]],
            formalNames[[i]] == "..." || exists(formalNames[[i]], envir = missingEnv),
            exists(formalNames[[i]], envir = usedSymbolsEnv)
         ))
      })

      list(
         formal_names = formalNames,
         formal_info  = formalInfo,
         performs_nse = I(as.integer(performsNse))
      )
   })

   # List data objects exported by this package
   datasets <- .rs.listDatasetsProvidedByPackage(package)

   # Generate the output
   output <- list(
      package = I(package),
      exports = exports,
      types = types,
      function_info = functionInfo,
      datasets = datasets
   )

   # Write the JSON to stdout; parent processes
   json <- paste("#!json:", .rs.toJSON(output))
   cat(json, sep = "\n")

   # Return output for debug purposes
   invisible(output)
})

.rs.setVar("nse.primitives", c(
   "quote", "substitute", "match.call", "eval.parent",
   "enquote", "bquote", "evalq", "lazy_dots", "compat_as_lazy_dots",
   "select_vars", "quo", "quos", "enquo", "named_quos"
))

.rs.addFunction("performsNonstandardEvaluation", function(object)
{
   # For S3 generics, search methods as well as the generic for
   # potential usages of non-standard evaluation.
   methods <- .rs.getS3MethodDefinitions(object)
   for (method in methods)
      if (.rs.performsNonstandardEvaluation(method))
         return(TRUE)

   if (is.function(object))
      object <- body(object)

   nsePrimitives <- .rs.getVar("nse.primitives")
   .rs.recursiveSearch(object,
                       .rs.performsNonstandardEvaluationImpl,
                       nsePrimitives = nsePrimitives)
})

.rs.addFunction("performsNonstandardEvaluationImpl", function(node, nsePrimitives)
{
   # Check if this is a call to an NSE primitive.
   if (is.call(node))
   {
      head <- node[[1]]
      if (!is.symbol(head))
         return(FALSE)

      headString <- as.character(head)
      if (headString %in% nsePrimitives)
         return(TRUE)

      # Check if this is a call to an NSE primitive, qualified through
      # `::` or `:::`.
      if (headString %in% c("::", ":::") && length(node) == 3)
      {
         export <- node[[3]]
         if (as.character(export) %in% nsePrimitives)
            return(TRUE)
      }
   }

   return(FALSE)
})

.rs.addFunction("recursiveSearch", function(`_node`, fn, ...)
{
   if (fn(`_node`, ...))
      return(TRUE)

   if (is.recursive(`_node`))
      for (i in seq_along(`_node`))
         if (.rs.recursiveSearch(`_node`[[i]], fn, ...))
            return(TRUE)

   return(FALSE)
})

.rs.addFunction("recursiveWalk", function(`_node`, fn, ...)
{
   fn(`_node`, ...)

   if (is.recursive(`_node`))
      for (i in seq_along(`_node`))
         .rs.recursiveWalk(`_node`[[i]], fn, ...)
})

.rs.addFunction("trimWhitespace", function(x)
{
   gsub("^[\\s\\n]+|[\\s\\n]+$", "", x, perl = TRUE)
})

.rs.addFunction("trimCommonIndent", function(string, ...)
{
   splat <- strsplit(string, "\n", fixed = TRUE)[[1]]
   indents <- regexpr("\\S", splat, perl = TRUE)
   indents[indents == -1] <- Inf
   common <- min(indents)
   result <- paste(substring(splat, common, nchar(string)), collapse = "\n")
   dots <- list(...)
   formatted <- if (length(dots)) sprintf(result, ...) else result
   .rs.trimWhitespace(formatted)
})

.rs.addFunction("parseNamespaceImports", function(path)
{
   output <- list(
      import = character(),
      importFrom = list()
   )

   if (!file.exists(path))
      return(output)

   parsed = tryCatch(
      suppressWarnings(parse(path)),
      error = function(e) NULL
   )

   if (is.null(parsed))
      return(output)

   # Loop over parsed entries and fill 'output'
   for (i in seq_along(parsed))
   {
      directive <- parsed[[i]]
      if (length(directive) < 2) next

      directiveName <- as.character(directive[[1]])
      pkgName <- as.character(directive[[2]])

      if (directiveName == "import")
      {
         output$import <- sort(unique(c(output$import, pkgName)))
         next
      }

      if (directiveName == "importFrom")
      {
         exports <- character(length(directive) - 2)
         for (i in 3:length(directive))
            exports[[i - 2]] <- as.character(directive[[i]])
         output$importFrom[[pkgName]] <- sort(unique(c(output$importFrom[[pkgName]], exports)))
         next
      }
   }

   output

})

.rs.addFunction("isSymbolCalled", function(maybeSymbol, name)
{
   is.symbol(maybeSymbol) && as.character(maybeSymbol) == name
})

.rs.addJsonRpcHandler("get_set_class_slots", function(setClassCallString)
{
   onFail <- list()
   parsed <- tryCatch(
      suppressWarnings(parse(text = setClassCallString))[[1]],
      error = function(e) NULL
   )

   if (is.null(parsed))
      return(onFail)

   matched <- tryCatch(
      match.call(methods::setClass, parsed),
      error = function(e) NULL
   )

   if (is.null(parsed))
      return(onFail)

   # NOTE: Previously, R has used 'representation' to
   # store the information about slots; it is now
   # deprecated (from 3.0.0) and the use of 'slots' is
   # encouraged. We'll check for 'slots' first, then
   # fall back to representation if necessary.
   #
   # NOTE: Okay to define a class with no slots / fields.
   field <- if ("slots" %in% names(matched))
      matched[["slots"]]
   else if ("representation" %in% names(matched))
      matched[["representation"]]
   else
      list()

   if (!("Class" %in% names(matched)))
      return(onFail)

   Class <- matched[["Class"]]

   slots <- if (length(field))
      names(field)[-1]
   else
      character()

   types <- if (length(field))
      unlist(lapply(2:length(field), function(i) {
         tryCatch(as.character(field[[i]]), error = function(e) "")
      }))
   else
      character()

   result <- list(
      Class = Class,
      slots = slots,
      types = types
   )
   return(result)
})

.rs.addFunction("tryParseCall", function(text)
{
   tryCatch(
      suppressWarnings(parse(text = text))[[1]],
      error = function(e) NULL
   )
})

.rs.addFunction("tryMatchCall", function(method, call)
{
   tryCatch(
      suppressWarnings(match.call(method, call)),
      error = function(e) NULL
   )
})

.rs.addFunction("extractElement", function(object,
                                           name,
                                           default = NULL)
{
   if (name %in% names(object))
      object[[name]]
   else
      default
})

.rs.addJsonRpcHandler("get_set_generic_call", function(call)
{
   parsed <- .rs.tryParseCall(call)
   if (is.null(parsed))
      return(list())

   matched <- .rs.tryMatchCall(methods::setGeneric, parsed)
   if (is.null(matched))
      return(list())

   generic <- .rs.extractElement(matched, "name", "")
   parameters <- character()
   if ("def" %in% names(matched))
   {
      def <- matched[["def"]]
      if (as.character(def[[1]]) == "function" &&
          length(def) > 1)
      {
         parameters <- names(def[[2]])
      }
   }

   list(
      generic = generic,
      parameters = parameters
   )
})

.rs.addJsonRpcHandler("get_set_method_call", function(call)
{
   parsed <- .rs.tryParseCall(call)
   if (is.null(parsed))
      return(list())

   matched <- .rs.tryMatchCall(methods::setMethod, parsed)
   if (is.null(matched))
      return(list())

   generic <- .rs.extractElement(matched, "f", "")
   parameter.names <- character()
   parameter.types <- character()

   signature <- .rs.extractElement(matched, "signature")
   if (!is.null(signature))
   {
      if (is.call(signature) &&
          length(signature) > 1)
      {
         parameter.names <- names(signature)[-1]
         parameter.types <- unlist(lapply(2:length(signature), function(i) {
            if (is.character(signature[[i]]))
               signature[[i]]
            else
               ""
         }))
      }
      else if (is.character(signature))
      {
         parameter.names <- signature
      }
   }

   list(
      generic = generic,
      parameter.names = parameter.names,
      parameter.types = parameter.types
   )

})

.rs.addJsonRpcHandler("get_set_ref_class_call", function(call)
{
   parsed <- .rs.tryParseCall(call)
   if (is.null(parsed))
      return(list())

   matched <- .rs.tryMatchCall(methods::setRefClass, parsed)
   if (is.null(matched))
      return(list())

   Class <- .rs.extractElement(matched, "Class", "")

   field.names <- character()
   field.types <- character()
   fields <- .rs.extractElement(matched, "fields")

   if (length(fields) > 1)
   {
      field.names <- names(fields)[-1]
      field.types <- unlist(lapply(2:length(fields), function(i) {
         if (is.character(fields[[i]]))
            fields[[i]]
         else
            ""
      }))
   }

   methods <- .rs.extractElement(matched, "methods")
   method.names <- if (length(methods))
      names(methods)[-1]
   else
      character()

   list(
      Class = Class,
      field.names = field.names,
      field.types = field.types,
      method.names = method.names
   )

})

.rs.addFunction("getSetRefClassSymbols", function(callString)
{
   parsed <- .rs.rpc.get_set_ref_class_call(callString)
   unique(as.character(c(
      ".self",
      parsed$field.names,
      parsed$method.names
   )))
})

.rs.addFunction("getR6ClassSymbols", function(callString)
{
   parsed <- .rs.tryParseCall(callString)
   if (is.null(parsed)) return(character())

   symbols <- c("self", "public", "private", "super")
   public <- .rs.extractElement(parsed, "public")
   if (!is.null(public))
      symbols <- c(symbols, names(public)[-1])

   symbols
})

.rs.addFunction("setEncodingUnknownToUTF8", function(object)
{
   if (is.character(object) && Encoding(object) == "unknown")
      Encoding(object) <- "UTF-8"
   else if (is.list(object))
      return(lapply(object, .rs.setEncodingUnknownToUTF8))

   object
})

.rs.addFunction("makePrimitiveWrapper", function(x)
{
   # from the R documentation, args returns:
   #
   #   For a closure, a closure with identical formal argument list but an empty
   #   (NULL) body.
   #
   #   For a primitive, a closure with the documented usage and NULL body. Note
   #   that some primitives do not make use of named arguments and match by
   #   position rather than name.
   #
   # we just need an R closure with the right formals, so args fits nicely
   args(x)
})

.rs.addFunction("extractNativeSymbols", function(DLL, collapse = TRUE)
{
   info <- getDLLRegisteredRoutines(DLL)
   result <- lapply(info, function(routine) {
      as.character(names(routine))
   })

   if (collapse)
      result <- as.character(unlist(result))

   result
})

.rs.addFunction("getNativeSymbols", function(package)
{
   loadedDLLs <- getLoadedDLLs()
   if (package %in% names(loadedDLLs))
      return(.rs.extractNativeSymbols(loadedDLLs[[package]]))

   # we used to try to load and unload the package library to
   # extract symbol information, but this is not safe to do now
   # loading the DLL also implies running its R_init_* hook, and
   # this can imply loading the package (+ its dependencies) --
   # something we normally want to avoid
   character()
})

.rs.addJsonRpcHandler("extract_chunk_options", function(chunkText)
{
   # Attempt to parse the chunk as R code
   parsed <- try(parse(text = chunkText), silent = TRUE)
   if (inherits(parsed, "try-error"))
      return(list())

   # Iterate through the expression tree, looking for calls to opts_chunk$set and
   # extracting their values. Load them up into an environment (which we then return
   # as a list back to the client)
   chunkOptionsEnv <- new.env(parent = emptyenv())
   lapply(parsed, function(node) {
      .rs.recursiveWalk(node, function(node) {

         if (!is.call(node) || length(node) < 2)
            return()

         # Perhaps not the most efficient, but probably the easiest way to detect
         # appropriate calls to `opts_chunk$set`.
         callName <- as.character(node)[[1L]]
         if (callName == "knitr:::opts_chunk$set" ||
             callName == "knitr::opts_chunk$set" ||
             callName == "opts_chunk$set")
         {
            names <- names(node)
            for (i in 2:length(node))
            {
               key <- names[[i]]
               if (key == "")
                  next

               val <- if (is.character(node[[i]]))
                  .rs.surround(node[[i]], with = "\"")
               else
                  format(node[[i]])
               chunkOptionsEnv[[key]] <- val
            }
         }
      })
   })

   # Convert to a list, and ensure each element is interpreted as a scalar
   # (rather than an array containing a single element)
   result <- as.list(chunkOptionsEnv)
   for (i in seq_along(result))
      result[[i]] <- .rs.scalar(result[[i]])

   return(result)
})

.rs.addFunction("enumerate", function(X, FUN, ...)
{
   keys <- if (is.environment(X)) {
      sort(ls(envir = X))
   } else {
      names(X)
   }

   result <- lapply(keys, function(key) {
      FUN(key, X[[key]], ...)
   })

   names(result) <- keys

   result
})

.rs.addFunction("cutpoints", function(data)
{
   diffed <- diff(c(data[1], data))
   which(diffed != 0)
})

.rs.addFunction("recode", function(data, ..., envir = parent.frame())
{
   dots <- eval(substitute(alist(...)))

   for (expr in dots)
   {
      if (length(expr) != 3)
         stop("malformed recoding in .rs.recode()", call. = FALSE)

      lhs <- eval(expr[[2]], envir = envir)
      rhs <- eval(expr[[3]], envir = envir)
      data[data == lhs] <- rhs
   }

   data
})

.rs.addFunction("evalWithAvailableArguments", function(fn, args)
{
   filtered <- args[names(args) %in% names(formals(fn))]
   call <- c(substitute(fn), filtered)
   mode(call) <- "call"
   eval(call, envir = parent.frame())
})

.rs.addFunction("transposeList", function(list)
{
   do.call(Map, c(c, list, USE.NAMES = FALSE))
})

.rs.addFunction("base64encode", function(data, binary = FALSE)
{
   .Call("rs_base64encode", data, binary)
})

.rs.addFunction("base64encodeFile", function(path)
{
   .Call("rs_base64encodeFile", path)
})

.rs.addFunction("base64decode", function(data, binary = FALSE)
{
   .Call("rs_base64decode", data, binary)
})

.rs.addFunction("CRANDownloadOptionsString", function()
{

   # collect options of interest
   options <- options("repos", "download.file.method", "download.file.extra", "HTTPUserAgent")
   if (identical(options[["download.file.method"]], "curl"))
      options[["download.file.extra"]] <- .rs.downloadFileExtraWithCurlArgs()

   # if there is no repo option set in the R session, read it from preferences
   if (identical(length(options[["repos"]]), 0L)) {
      options[["repos"]]["CRAN"] <- .rs.readUiPref("cran_mirror")$url
   }

   # drop NULL entries
   options <- Filter(Negate(is.null), options)

   # deparse values individually. avoid relying on the format
   # of the deparsed output of the whole expression; see e.g.
   # https://github.com/rstudio/rstudio/issues/4916 for example
   # of where this can fail
   vals <- lapply(options, function(option) {

      # replace single quotes with double quotes, so that
      # deparse automatically escapes the inner quotes
      # see: https://github.com/rstudio/rstudio/issues/6597
      # (note these will be translated to single quotes later)
      if (is.character(option))
         option <- gsub("'", "\"", option)

      .rs.deparse(option)
   })

   # join keys and values
   keyvals <- paste(names(options), vals, sep = " = ")

   # create final options command
   opts <- sprintf("options(%s)", paste(keyvals, collapse = ", "))

   # NOTE: we need to quote arguments with single quotes as the command will be
   # submitted using double quotes, and embedded quotes in the command are not
   # properly escaped.
   #
   # TODO: handle embedded quotes properly
   gsub("\"", "'", opts, fixed = TRUE)

})

.rs.addFunction("slice", function(object,
                                  start = 1,
                                  end = length(object))
{
   n <- length(object)
   if (n == 0)
      return(object)

   if (start < 0) start <- n + start
   if (end < 0)   end <- n + end

   start <- max(1, start)
   end   <- min(n, end)

   if (start > end)
      return(object[0])

   return(object[start:end])
})

.rs.addFunction("slotNames", function(object)
{
   # non-S4 objects don't have slot names
   if (!isS4(object))
      return(character())

   # try using the official API to retrieve slot names
   slots <- methods::slotNames(object)
   if (is.character(slots))
      return(slots)

   # if that fails for some reason (e.g. the package that
   # provides the associated class definition is not loaded)
   # then fall back to using object attributes
   slots <- names(attributes(object))
   setdiff(slots, "class")

})

# like deparse(), but always deparsed to a length-one character vector
.rs.addFunction("deparse", function(object,
                                    width.cutoff = 500L,
                                    nlines       = -1L,
                                    collapse     = " ")
{
   # deparse the call
   deparsed <- deparse(
      expr         = object,
      width.cutoff = width.cutoff,
      nlines       = nlines
   )

   # un-escape our inline R objects
   deparsed <- gsub("`<(.*?)>`", "<\\1>", deparsed, perl = TRUE)

   # paste to return as length-one character vector
   paste(deparsed, collapse = collapse)
})

.rs.addFunction("ensureScalarCharacter", function(object)
{
   if (is.character(object) && length(object) == 1)
      return(object)

   fmt <- "'%s' is not a length-one character vector"
   stop(sprintf(fmt, .rs.deparse(substitute(object))), call. = FALSE)
})

.rs.addFunction("isR6NewMethod", function(object)
{
   if (!is.function(object))
      return(FALSE)

   envir <- environment(object)
   if (!inherits(envir, "R6ClassGenerator"))
      return(FALSE)

   identical(object, envir$new)
})

.rs.addFunction("getR6ClassGeneratorMethod", function(object, method)
{
   if (is.function(object))
      object <- environment(object)

   if (!is.environment(object))
      return(NULL)

   if (!inherits(object, "R6ClassGenerator"))
      return(NULL)

   tryCatch(
      object$public_methods[[method]],
      error = function(e) NULL
   )
})

.rs.addFunction("isExternalPointer", function(object)
{
   identical(typeof(object), "externalptr")
})

.rs.addFunction("fileInfo", function(..., extra_cols = TRUE)
{
   suppressWarnings(file.info(..., extra_cols = extra_cols))
})

.rs.addFunction("listDatasetsProvidedByPackage", function(package)
{
   # verify we have a non-empty length-one string
   if (!is.character(package) || length(package) != 1 || !nzchar(package))
      return(character())

   # find the installed package location (returns empty vector on failure)
   location <- find.package(package, quiet = TRUE)
   if (!length(location) || !file.exists(location))
      return(character())

   # construct path to datalist file
   datalist <- file.path(location, "data/datalist")
   if (!file.exists(datalist))
      return(character())

   # read the names of the provided objects
   readLines(datalist, warn = FALSE)

})

.rs.addFunction("tryCatch", function(expr)
{
   tryCatch(

      withCallingHandlers(
         expr,
         warning = function(w) invokeRestart("muffleWarning"),
         message = function(m) invokeRestart("muffleMessage")
      ),

      error = identity
   )
})

.rs.addFunction("resolveAliasedPath", function(path)
{
   .Call("rs_resolveAliasedPath", path, PACKAGE = "(embedding)")
})

.rs.addFunction("readPackageDescription", function(packagePath)
{
   # if this is an installed package with a package metafile,
   # read from that location
   metapath <- file.path(packagePath, "Meta/package.rds")
   if (file.exists(metapath)) {
      metadata <- readRDS(metapath)
      return(as.list(metadata$DESCRIPTION))
   }

   # otherwise, attempt to read DESCRIPTION directly
   descPath <- file.path(packagePath, "DESCRIPTION")
   read.dcf(descPath, all = TRUE)
})

.rs.addFunction("readSourceDocument", function(id)
{
   contents <- .Call("rs_readSourceDocument", as.character(id), PACKAGE = "(embedding)")
   if (is.character(contents))
      Encoding(contents) <- "UTF-8"
   contents
})

.rs.addFunction("parsePackageDependencies", function(contents, extension)
{
   # NOTE: the following regular expressions were extracted from knitr;
   # They were modified to search only R code chunks and skip other chunks
   # such as python, bash, sql, etc that do not contain R dependencies
   # Inline R code in markdown docs is also skipped
   code <- if (identical(extension, ".R"))
      contents
   else if (identical(extension, ".Rmd"))
      .rs.extractRCode(contents,
                       "^[\t >]*```+\\s*\\{[Rr]\\b.*\\}\\s*$",
                       "^[\t >]*```+\\s*$")
   else if (identical(extension, ".Rnw"))
      .rs.extractRCode(contents,
                       "^\\s*<<(.*)>>=.*$",
                       "^\\s*@\\s*(%+.*|)$")
   else if (identical(extension, ".qmd"))
     .rs.extractRCode(contents,
                      "^[\t >]*```+\\s*\\{[Rr]\\b.*\\}\\s*$",
                      "^[\t >]*```+\\s*$")
   if (is.null(code))
      return(NULL)
   # If Quarto and no R code chunks, don't parse further
   # Rmd may have yaml front matter to parse even if no R chunks
   if (identical(gsub("\n", "", code), .rs.scalar("")) && identical(extension, ".qmd"))
      return(NULL)

   # attempt to parse extracted R code
   parsed <- .rs.tryCatch(parse(text = code, encoding = "UTF-8"))
   if (inherits(parsed, "error")) {

      # call 'Sys.setlocale()' to work around an R issue where flags
      # set during parse can effectively be 'leaked' -- 'Sys.setlocale()'
      # effectively resets those flags. see:
      #
      # https://bugs.r-project.org/bugzilla3/show_bug.cgi?id=17484
      # https://github.com/rstudio/rstudio/issues/3658
      #
      if (getRversion() < "3.5.2")
         Sys.setlocale()

      return(character())

   }

   discoveries <- new.env(parent = emptyenv())

   # for R Markdown docs, scan the YAML header (requires the rmarkdown package and the yaml package,
   # a dependency of rmarkdown)
   if (identical(extension, ".Rmd") &&
       is.null(dynGet("__NameSpacesLoading__", NULL)) &&
       requireNamespace("rmarkdown", quietly = TRUE) &&
       requireNamespace("yaml", quietly = TRUE))
   {
      # extract the front matter from the document; accepts a list of lines and returns a list with
      # $front_matter and $body elements
      partitions <- rmarkdown:::partition_yaml_front_matter(
            strsplit(x = contents, split = "\n", fixed = TRUE)[[1]])

      # did we find some front matter?
      front_matter <- partitions[["front_matter"]]
      if (!is.null(front_matter))
      {
         front <- NULL

         tryCatch({
            front <- yaml::read_yaml(text = front_matter, eval.expr = TRUE)
         }, error = function(e) {
            # ignore errors when reading YAML; it's very possible that the document's YAML will not
            # be correct at all times (e.g. during editing)
         })

         # start with an empty output
         output <- NULL

         if (!is.null(names(front[["output"]])))
         {
            # if the output key has children, it will appear as a list name
            # output:
            #   pkg_name::out_fmt:
            #     foo: bar
            output <- names(front[["output"]])[[1]]
         }
         else if (is.character(front[["output"]]))
         {
            # if the output key doesn't have children, it will appear as a plain character
            #
            # output: pkg_name::out_fmt
            output <- front[["output"]]
         }

         # check for references to an R package in output format
         if (!is.null(output))
         {
            format <- unlist(strsplit(output, "::"))
            if (length(format) > 1)
            {
               discoveries[[format[[1]]]] <- TRUE
            }
         }

         # check for runtime: shiny or parameters (requires the Shiny R package)
         runtime <- front[["runtime"]]
         server <- front[["server"]]
         params  <- front[["params"]]
         if (identical(runtime, "shiny") ||
             identical(runtime, "shinyrmd") ||
             identical(runtime, "shiny_prerendered") ||
             identical(server, "shiny") ||
             (is.list(server) && identical(server[["type"]], "shiny")) ||
             !is.null(params))
         {
            discoveries[["shiny"]] <- TRUE
         }

      }
   }

   handleLibraryRequireCall <- function(node) {

      # make sure this is a call to the 'library' or 'require' function
      if (!is.call(node))
         return(FALSE)

      isLibraryOrRequire <-
         identical(node[[1]], as.name("library")) ||
         identical(node[[1]], as.name("require"))

      if (!isLibraryOrRequire)
         return(FALSE)

      # attempt to match the call
      matched <- .rs.tryCatch(match.call(base::library, node))
      if (inherits(matched, "error"))
         return(FALSE)

      # if the 'package' argument is a character vector of length one, we're done
      isPackageArgumentString <-
         is.character(matched$package) &&
         length(matched$package) == 1

      if (isPackageArgumentString) {
         discoveries[[matched$package]] <<- TRUE
         return(TRUE)
      }

      # if it's a symbol, double check character.only argument
      isSafeSymbolLibraryCall <-
         is.symbol(matched$package) &&
         (is.null(matched$character.only) || identical(matched$character.only, FALSE))

      if (isSafeSymbolLibraryCall) {
         discoveries[[as.character(matched$package)]] <<- TRUE
         return(TRUE)
      }

      FALSE

   }

   handleRequireNamespaceCall <- function(node) {

      if (!is.call(node))
         return(FALSE)

      if (!identical(node[[1]], as.name("requireNamespace")))
         return(FALSE)

      matched <- .rs.tryCatch(match.call(base::requireNamespace, node))
      if (inherits(matched, "error"))
         return(FALSE)

      if (is.character(matched$package) && length(matched$package == 1)) {
         discoveries[[matched$package]] <<- TRUE
         return(TRUE)
      }

      FALSE

   }

   handleColonCall <- function(node) {

      # make sure this is a call to the 'library' or 'require' function
      if (!is.call(node))
         return(FALSE)

      isColonCall <-
         length(node) == 3 &&
         (identical(node[[1]], as.name("::")) || identical(node[[1]], as.name(":::")))

      if (!isColonCall)
         return(FALSE)

      # extract package used. note that one can specify the package as
      # both a symbol and as a character string; e.g. this is legal R code
      #
      #   "dplyr"::"mutate"
      #
      # so guard against such usages
      package <- node[[2L]]
      if (is.symbol(package))
         package <- as.character(package)
      if (!is.character(package) || length(package) != 1)
         return(FALSE)

      # all looks good; add the discovery
      discoveries[[package]] <<- TRUE
      TRUE

   }

   .rs.recursiveWalk(parsed, function(node) {
      handleLibraryRequireCall(node) ||
      handleColonCall(node) ||
      handleRequireNamespaceCall(node)
   })

   # return discovered packages
   ls(envir = discoveries)
})

.rs.addFunction("discoverPackageDependencies", function(id, extension)
{
   # check to see if we have available packages -- if none, bail
   available <- .rs.availablePackages()
   if (is.null(available$value))
      return(character())

   # read the associated source file
   contents <- .rs.readSourceDocument(id)
   if (is.null(contents))
      return(character())

   # parse to find packages
   packages <- .rs.parsePackageDependencies(contents, extension)
   # return early if no R code is parsed
   if (is.null(packages))
      return(character())

   # If file is qmd or rmd, and there is R code, rmarkdown is REQUIRED
   if (identical(extension, ".Rmd") || identical(extension, ".qmd"))
      packages <- c("rmarkdown", packages)
   # keep only packages that are available in an active repository
   packages <- packages[packages %in% rownames(available$value)]

   # figure out which packages aren't actually installed. note that we avoid
   # calling 'installed.packages()' explicitly here as this can be very slow
   # on some NFSes; a plain `list.files()` is fine
   installed <- list.files(.libPaths())
   missing <- setdiff(packages, installed)

   # return that list
   missing

})

# like strsplit, but doesn't omit a trailing last entry as in e.g.
#
#    > strsplit("a.b.", ".", fixed = TRUE)
#    [[1]]
#    [1] "a" "b"
#
# also unlists the string by default (as the most common usage is to
# split a single string)
.rs.addFunction("strsplit", function(x, pattern, ..., simplify = TRUE)
{
   m <- gregexpr(pattern, x, ...)
   matches <- regmatches(x, m, invert = TRUE)
   if (simplify && length(matches) == 1)
      matches[[1]]
   else
      matches
})

.rs.addJsonRpcHandler("replace_comment_header", function(command, path, code)
{
   .rs.scalar(
      paste(
         deparse(
            do.call(
               "substitute",
               args = list(
                  eval(
                     parse(
                        text = paste("quote(", command, ")", sep = "")
                     )
                  ),
                  list(
                     .code = code,
                     .file = path
                  )
               )
            )
         ),
         collapse = ""
      )
   )
})

.rs.addFunction("withCache", function(name, expr)
{
   cache <- .rs.getVar(name)
   if (!is.null(cache))
      return(cache)

   result <- force(expr)
   .rs.setVar(name, result)
   result
})

.rs.addFunction("nullCoalesce", function(x, y)
{
   if (is.null(x)) y else x
})

.rs.addFunction("truncate", function(string, n = 200, marker = "<...>")
{
   if (nchar(string) <= n)
      return(string)

   truncated <- substring(string, 1, n - nchar(marker))
   return(paste(truncated, marker))

})

.rs.addFunction("formatListForDialog", function(list, sep = ", ", max = 50L)
{
   # count index entries until we get too long
   nc <- 0L
   ns <- nchar(sep)
   for (index in seq_along(list)) {
      nc <- nc + ns + nchar(list[[index]])
      if (nc > max)
         break
   }

   # collect items
   n <- length(list)
   items <- list

   # subset the list if we overflowed (index didn't reach end)
   # avoid printing 'and 1 other'; no need to subset in that case
   if (index < n - 1L)
      items <- c(list[1:index], paste("and", n - index, "others"))

   # paste and truncate once more for safety
   text <- paste(items, collapse = sep)
   .rs.truncate(text, n = max * 2L)

})

.rs.addFunction("resolveEnvironment", function(envir)
{
   # if this is already an environment, just return it
   if (is.environment(envir))
      return(envir)

   # if this is a numeric, then assume we want an
   # environment by position on the search path
   if (is.numeric(envir))
      return(as.environment(envir))

   # treat empty strings as request for globalenv
   if (is.null(envir) || identical(envir, ""))
      return(globalenv())

   # if this is the name of something on the search path,
   # then as.environment should suffice
   index <- match(envir, search())
   if (!is.na(index))
      return(as.environment(index))

   # if this is the name of a namespace, retrieve that namespace
   if (substring(envir, 1L, 10L) == "namespace:") {
      package <- substring(envir, 11L)
      return(getNamespace(package))
   }

   # otherwise, treat 'envir' directly as the name of a namespace
   getNamespace(envir)

})

#
# test-renv.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("renv")

# TODO: This test appears to be unreliable; some runs appear to be
# unable to contact RSPM?
# test_that(".rs.rpc.renv_init() preserves current repositories", {
#    
#    skip_if_not_installed("renv")
#    
#    # scope repos option in this scope
#    renv:::renv_scope_options(
#       repos = list(RSPM = "https://packagemanager.posit.co/cran/latest")
#    )
#    
#    # initialize project
#    project <- tempfile("renv-project-")
#    on.exit(unlink(project, recursive = TRUE), add = TRUE)
#    renv:::quietly(.rs.rpc.renv_init(project))
#    
#    # check that the renv lockfile has the expected repositories
#    lockpath <- file.path(project, "renv.lock")
#    lockfile <- renv:::renv_lockfile_read(lockpath)
#    
#    # validate correct repositories
#    expect_identical(
#       as.list(lockfile$R$Repositories),
#       list(RSPM = "https://packagemanager.posit.co/cran/latest")
#    )
#    
# })

#
# NotebookErrors.R
#
# Copyright (C) 2009-16 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("handleNotebookError", function() {
  .rs.recordTraceback(FALSE, 2, function(err) {
    .Call("rs_recordNotebookError", err)
  })
},
attrs = list(hideFromDebugger = TRUE,
             errorHandlerType = 4L))

.rs.addFunction("registerNotebookErrHandler", function() {
  options(error = .rs.handleNotebookError)
})

#
# NotebookData.R
#
# Copyright (C) 2009-18 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("dataCaptureOverrides", function(outputFolder, libraryFolder)
{
  defaultOverride <- function(x, options) list(x = x, options = options, className = class(x), nRow = .rs.scalar(nrow(x)), nCol = .rs.scalar(ncol(x)))
  c(
    "print.data.frame" = defaultOverride,
    "print.tbl_df"     = defaultOverride,
    "print.paged_df"   = defaultOverride,
    "print.grouped_df" = defaultOverride,
    "print.rowwise_df" = defaultOverride,
    "print.tbl_sql"    = defaultOverride,
    "print.data.table" = function(x, options) {
      shouldPrintTable <- TRUE

      if ("data.table" %in% loadedNamespaces() &&
          exists("shouldPrint", envir = asNamespace("data.table")))
      {
        shouldPrint <- get("shouldPrint", envir = asNamespace("data.table"))
        shouldPrintTable <- tryCatch(
          shouldPrint(x) || !inherits(x, "data.table"),
          error = function(e) TRUE
        )
      }

      if (!shouldPrintTable) {
        return(NULL)
      }

      list(x = x, options = options, className = class(x), nRow = .rs.scalar(nrow(x)), nCol = .rs.scalar(ncol(x)))
    },
    "print.tbl_lazy" = function(x, options) {
      tblLazyData <- lapply(dplyr::tbl_vars(x), function(e) character(0))
      names(tblLazyData) <- dplyr::tbl_vars(x)
      lazyFrame <- do.call("data.frame", tblLazyData)

      list(
        x = lazyFrame,
        options = options,
        className = class(x),
        nRow = "?",
        nCol = "?"
      )
    }

  )
})

.rs.addFunction("initDataCapture", function(outputFolder, options)
{
  pagedOption <- if (!is.null(options[["paged.print"]])) options[["paged.print"]] else getOption("paged.print")
  if (identical(pagedOption, FALSE)) {
    return()
  }

  overridePrint <- function(x, options, className, nRow, nCol) {
    original <- x
    options <- if (is.null(options)) list() else options
    
    optionRowNames <- options[["rownames.print"]]
    options[["rownames.print"]] <- if (is.null(optionRowNames)) (.row_names_info(x, type = 1) > 0) else optionRowNames
    options[["rows.total"]] <- nrow(x)
    options[["cols.total"]] <- ncol(x)

    output <- tempfile(pattern = "_rs_rdf_", tmpdir = outputFolder, 
                       fileext = ".rdf")

    max.print <- if (is.null(options$max.print)) getOption("max.print", 1000) else options$max.print

    cols.max.print <- if (is.null(options$cols.max.print)) getOption("cols.max.print", 1000) else options$cols.max.print
    if (NCOL(x) > cols.max.print) {
      x <- x[,c(1:cols.max.print)]
    }

    x <- as.data.frame(head(x, max.print))

    save(
      x,
      options,
      file = output)

    .Call("rs_recordData", output, list(classes = className,
                                        nrow = nRow, 
                                        ncol = nCol))
    invisible(original)
  }

  overrides <- .rs.dataCaptureOverrides()
  lapply(names(overrides), function(overrideName) {
    overrideMap <- overrides[[overrideName]]
    overrideFun <- function(x, ...) {
        o <- overrideMap(x, options)
        if (!is.null(o)) {
          overridePrint(o$x, o$options, o$className, o$nRow, o$nCol)
        }
      }
     .rs.addS3Override(overrideName, overrideFun)
  })

  assign(
    "dplyr_tibble_print_original",
    getOption("dplyr.tibble.print"),
    envir = as.environment("tools:rstudio")
  )

  options("dplyr.tibble.print" = function(x, n, width, ...) {
    isSQL <- "tbl_sql" %in% class(x)
    n <- if (isSQL) getOption("sql.max.print", 1000) else getOption("max.print", 1000)

    print(as.data.frame(head(x, n)))
  })

  .rs.addS3Override("print.knitr_kable", function(x, ...) {
    print(
      knitr::asis_output(x)
    )
    invisible(x)
  })
})

.rs.addFunction("releaseDataCapture", function()
{
  if (!is.null(getOption("dplyr_tibble_print_original"))) {
    options(
      "dplyr.tibble.print" = get(
        "dplyr_tibble_print_original",
        envir = as.environment("tools:rstudio")
      )
    )
  }

  overrides <- .rs.dataCaptureOverrides()
  lapply(names(overrides), function(override) {
    .rs.removeS3Override(override)
  })
  .rs.removeS3Override("print.knitr_kable")
})

.rs.addFunction("readDataCapture", function(path)
{
  type_sum <- function(x) {
    format_sum <- switch (class(x)[[1]],
                          ordered = "ord",
                          factor = "fctr",
                          POSIXt = "dttm",
                          difftime = "time",
                          Date = "date",
                          data.frame = class(x)[[1]],
                          tbl_df = "tibble",
                          NULL
    )
    if (!is.null(format_sum)) {
      format_sum
    } else if (!is.object(x)) {
      switch(typeof(x),
             logical = "lgl",
             integer = "int",
             double = "dbl",
             character = "chr",
             complex = "cplx",
             closure = "fun",
             environment = "env",
             typeof(x)
      )
    } else if (!isS4(x)) {
      paste0("S3: ", class(x)[[1]])
    } else {
      paste0("S4: ", methods::is(x)[[1]])
    }
  }

  "%||%" <- function(x, y) {
    if(is.null(x)) y else x
  }

  big_mark <- function(x, ...) {
    mark <- if (identical(getOption("OutDec"), ",")) "." else ","
    formatC(x, big.mark = mark, ...)
  }

  dim_desc <- function(x) {
    dim <- dim(x) %||% length(x)
    format_dim <- vapply(dim, big_mark, character(1))
    format_dim[is.na(dim)] <- "??"
    paste0(format_dim, collapse = " \u00d7 ")
  }

  is_atomic <- function(x) {
    is.atomic(x) && !is.null(x)
  }

  is_vector <- function(x) {
    is_atomic(x) || is.list(x)
  }

  paged_table_is_vector_s3 <- function(x) {
    switch(class(x)[[1]],
      ordered = TRUE,
      factor = TRUE,
      Date = TRUE,
      POSIXct = TRUE,
      difftime = TRUE,
      data.frame = TRUE,
      !is.object(x) && is_vector(x))
  }

  size_sum <- function(x) {
    if (!paged_table_is_vector_s3(x)) return("")

    paste0(" [", dim_desc(x), "]" )
  }

  obj_sum.default <- function(x) {
    paste0(type_sum(x), size_sum(x))
  }

  obj_sum <- function(x) {
    switch(class(x)[[1]],
      POSIXlt = rep("POSIXlt", length(x)),
      list = vapply(x, obj_sum.default, character(1L)),
      paste0(type_sum(x), size_sum(x))
    )
  }

  e <- new.env(parent = emptyenv())
  load(file = path, envir = e)
  
  # this works around a strange bug in R 3.5.1 on Windows
  # where output can be mis-encoded after a save / load
  cat(NULL, sep = "")

  data <- head(e$x, getOption("max.print", 1000))
  data <- if (is.null(data)) as.data.frame(list()) else data
  options <- e$options

  columnNames <- names(data)
  columnSequence <- seq_len(ncol(data))
  
  columns <- lapply(
    columnSequence,
    function(columnIdx) {
      column <- data[[columnIdx]]
      baseType <- class(column)[[1]]
      tibbleType <- type_sum(column)

      list(
        label = if (!is.null(columnNames)) columnNames[[columnIdx]] else "",
        name = columnIdx,
        type = tibbleType,
        align = if (baseType == "character" || baseType == "factor") "left" else "right"
      )
    }
  )

  names(data) <- as.character(columnSequence)

  addRowNames = isTRUE(options[["rownames.print"]])
  if (addRowNames) {
    columns <- c(
      list(
        list(
          label = "",
          name = "_rn_",
          type = "",
          align = "left"
        )
      ),
      columns
    )

    data$`_rn_` <- rownames(data)
  }

  columns <- unname(columns)

  is_list <- vapply(data, is.list, logical(1))
  data[is_list] <- lapply(data[is_list], function(x) {
        summary <- obj_sum(x)
        paste0("<", summary, ">")
      })

  # R 3.6.0 on Windows has an issue where RGui escapes can 'leak'
  # into encoded strings; detect and remove those post-hoc.
  # (should be fixed in R 3.6.1)
  #
  # https://bugs.r-project.org/bugzilla/show_bug.cgi?id=17567
  needsEncodeFix <-
    .Platform$OS.type == "windows" &&
    getRversion() == "3.6.0"
  
  data <- as.data.frame(
    lapply(
      data,
      function (y) {
        
        # escape NAs from character columns
        if (typeof(y) == "character") {
          y[y == "NA"] <- "__NA__"
        }

        # encode string (ensure control characters are escaped)
        y <- encodeString(format(y))
        if (needsEncodeFix) {
          y <- gsub("^\002\377\376", "", y)
          y <- gsub("\003\377\376$", "", y)
        }

        # trim spaces
        gsub("^\\s+|\\s+$", "", y)
      }
    ),
    stringsAsFactors = FALSE,
    optional = TRUE)
  
  pagedTableOptions <- list(
    columns = list(
      min = options[["cols.min.print"]],
      max = if (is.null(options[["cols.print"]])) 10 else options[["cols.print"]],
      total = options[["cols.total"]]
    ),
    rows = list(
      min = if (is.null(options[["rows.print"]])) 10 else options[["rows.print"]],
      max = if (is.null(options[["rows.print"]])) 10 else options[["rows.print"]],
      total = options[["rows.total"]]
    ),
    pages = options[["pages.print"]]
  )

  list(
    columns = columns,
    data = if (length(data) == 0) list() else data,
    options = pagedTableOptions
  )
})

.rs.addFunction("runSqlForDataCapture", function(sql, outputFile, options)
{
  is_sql_update_query <- function(query) {
    # remove line comments
    query <- gsub("^\\s*--.*\n", "", query)

    # remove multi-line comments
    if (grepl("^\\s*\\/\\*.*", query)) {
      query <- gsub(".*\\*\\/", "", query)
    }

    grepl("^\\s*(INSERT|UPDATE|DELETE|CREATE|DROP).*", query, ignore.case = TRUE)
  }

  # precreate directories if needed
  dir.create(dirname(outputFile), recursive = TRUE, showWarnings = FALSE)

  max.print <- if (is.null(options$max.print)) getOption("max.print", 1000) else as.numeric(options$max.print)
  max.print <- if (is.null(options$sql.max.print)) max.print else as.numeric(options$sql.max.print)

  conn <- options$connection
  
  if (is.numeric(options$connection)) {
    chunkReferences <- get(".rs.knitr.chunkReferences", envir = .rs.toolsEnv())
    conn <- chunkReferences[[chunkOptions$connection]]
  }

  if (is.null(conn)) {
    stop("The 'connection' option (DBI connection) is required for sql chunks.")
  }

  if (is.character(options$connection)) {
    conn <- get(options$connection, envir = globalenv())
    if (is.null(conn)) stop(
      "The 'connection' option must be a valid DBI connection."
    )
  }

  # Return char vector of sql interpolation param names
  varnames_from_sql <- function(conn, sql) {
    varPos <- DBI::sqlParseVariables(conn, sql)
    if (length(varPos$start) > 0) {
      varNames <- substring(sql, varPos$start, varPos$end)
      sub("^\\?", "", varNames)
    }
  }

  # Vectorized version of exists
  mexists <- function(x, env = globalenv(), inherits = TRUE) {
    vapply(x, exists, logical(1), where = env, inherits = inherits)
  }

  # Interpolate a sql query based on the variables in an environment
  interpolate_from_env <- function(conn, sql, env = globalenv(), inherits = TRUE) {
    names <- unique(varnames_from_sql(conn, sql))
    names_missing <- names[!mexists(names, env, inherits)]
    if (length(names_missing) > 0) {
      stop("Object(s) not found: ", paste('"', names_missing, '"', collapse = ", "))
    }

    args <- if (length(names) > 0) setNames(
      mget(names, envir = env, inherits = inherits), names
    )

    do.call(DBI::sqlInterpolate, c(list(conn, sql), args))
  }

  # extract options
  varname <- options$output.var

  # execute query -- when we are printing with an enforced max.print we
  # use dbFetch so as to only pull down the required number of records
  query <- interpolate_from_env(conn, sql)
  if (is_sql_update_query(query)) {
    DBI::dbExecute(conn, query)
    data <- NULL
  } else if (is.null(varname) && max.print > 0) {
    res <- DBI::dbSendQuery(conn, query)
    data <- DBI::dbFetch(res, n = max.print)
    DBI::dbClearResult(res)
  } else {
    data <- DBI::dbGetQuery(conn, query)
  }

  # assign varname if requested, otherwise print
  if (!is.null(varname)) {
    assign(varname, data, envir = globalenv())
  }
  else if(!is.null(data)) {
    x <- data
    save(
      x, 
      file = outputFile
    )
  }
})

.rs.addJsonRpcHandler("default_sql_connection_name", function()
{
  dbiClassNames <- lapply(methods::.S4methods("dbGetQuery"), function(methodInfo) {
    methodInfoSplit <- strsplit(methodInfo, split = ",")[[1]]
    methodInfoSplit[[2]]
  })

  dbiObjectNames <- Filter(function(objName) {
    any(class(get(objName, envir = globalenv())) %in% dbiClassNames)
  }, ls(envir = globalenv()))

  if (length(dbiObjectNames) > 0) .rs.scalar(dbiObjectNames[[1]]) else NULL
})

#
# SessionPPM.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar("ppm.vulns", new.env(parent = emptyenv()))
.rs.setVar("ppm.metadataCache", new.env(parent = emptyenv()))

# per-repo set of "name==version" keys we've asked the C++ backend to fetch
# but haven't yet recorded a response for; keyed by repository URL. The fetch
# itself happens asynchronously in C++ (see SessionPPM.cpp), so this is how the
# request plan communicates the requested keys to the response handler.
.rs.setVar("ppm.pending", new.env(parent = emptyenv()))

# once-per-session flags for noisy diagnostics we don't want to repeat
# on every package-list refresh
.rs.setVar("ppm.warnings", new.env(parent = emptyenv()))

.rs.addFunction("ppm.isIntegrationEnabled", function()
{
   .Call("rs_ppmIntegrationEnabled", PACKAGE = "(embedding)")
})

.rs.addFunction("ppm.isMetadataColumnEnabled", function()
{
   .Call("rs_ppmMetadataColumnEnabled", PACKAGE = "(embedding)")
})

.rs.addFunction("ppm.installedPackageKeys", function()
{
   # PPM's filter/packages endpoint defaults to the current snapshot's latest
   # version of each package, so a vuln that only affects an older installed
   # version is silently dropped. We key everything on the installed (name,
   # version) pairs instead so older versions still get checked.
   db <- as.data.frame(
      installed.packages(priority = "NA"),
      stringsAsFactors = FALSE
   )
   paste(db[["Package"]], db[["Version"]], sep = "==")
})

.rs.addFunction("ppm.repoVulnCache", function(repoUrl)
{
   # Per-repo cache lives in an environment keyed by "name==version" so we can
   # request only newly-installed (or upgraded) packages on subsequent
   # refreshes. Stale "old==version" entries linger in the cache but are
   # filtered out at aggregation by pkgKeys.
   cache <- .rs.ppm.vulns[[repoUrl]]
   if (is.null(cache))
   {
      cache <- new.env(parent = emptyenv())
      assign(repoUrl, cache, envir = .rs.ppm.vulns)
   }
   cache
})

.rs.addFunction("ppm.repoMetadataCache", function(repoUrl)
{
   # Per-repo metadata cache, keyed by "name==version" like the vuln cache and
   # populated from the same response (see ppm.recordVulnerabilityResponse). Read
   # cache-only by ppm.getMetadata; no network access happens at read time.
   cache <- .rs.ppm.metadataCache[[repoUrl]]
   if (is.null(cache))
   {
      cache <- new.env(parent = emptyenv())
      assign(repoUrl, cache, envir = .rs.ppm.metadataCache)
   }
   cache
})

# Build the request plan for an asynchronous vulnerability refresh. The actual
# network request is performed by the C++ backend (off the main thread); this
# helper only inspects local, already-installed state to decide *what* to
# request and how to authenticate. It returns one entry per PPM repository that
# has packages we haven't yet checked this session:
#
#   list(repoUrl, endpoint, authHeader, body)
#
# and records the requested (name==version) keys in .rs.ppm.pending so the
# response handler (ppm.recordVulnerabilityResponse) knows which keys the
# response covers.
.rs.addFunction("ppm.getVulnerabilityRequestPlan", function(repos = NULL)
{
   # NOTE: enablement is driven by whether the session's repositories point at a
   # Posit Package Manager instance -- NOT by .rs.ppm.isIntegrationEnabled() (the
   # PWB_PPM_* env vars). Vulnerability display is intentionally not opt-in: it
   # is shown whenever a PPM repo is in use, including open-source / desktop
   # RStudio. The env-var gate gates the Workbench-only metadata column
   # (.rs.ppm.isMetadataColumnEnabled), not vulnerabilities. See 88778df845
   # "always try to provide vuln info if available"; an async rewrite had briefly
   # re-applied the env-var gate here, which regressed that behavior.
   repos <- .rs.nullCoalesce(repos, getOption("repos"))
   if (length(repos) == 0L)
      return(list())

   # bail out early -- before the potentially-expensive installed.packages() call
   # below -- if none of the configured repositories is a PPM instance
   isPpmRepo <- vapply(repos, function(url) {
      length(.rs.ppm.fromRepositoryUrl(url)) > 0L
   }, logical(1))
   if (!any(isPpmRepo))
      return(list())

   pkgKeys <- .rs.ppm.installedPackageKeys()
   if (length(pkgKeys) == 0L)
      return(list())

   plan <- list()
   for (repoUrl in repos)
   {
      ppmUrl <- .rs.ppm.fromRepositoryUrl(repoUrl)
      if (length(ppmUrl) == 0L)
         next

      # only ask PPM about (name, version) pairs we haven't seen this session
      cache <- .rs.ppm.repoVulnCache(repoUrl)
      cachedKeys <- ls(envir = cache, all.names = TRUE)
      newKeys <- setdiff(pkgKeys, cachedKeys)
      if (length(newKeys) == 0L)
         next

      # the legacy /repos/{repo}/vulns endpoint was effectively anonymous;
      # filter/packages requires auth on locked-down PPM instances, so compute
      # a Basic auth header from the user's .netrc when one is configured
      endpoint <- file.path(ppmUrl[["root"]], "__api__/filter/packages")
      authHeader <- .rs.computeAuthorizationHeader(endpoint)

      # remember which keys this request covers so the response handler can
      # mark them (including the ones with no vulns) as checked
      assign(repoUrl, newKeys, envir = .rs.ppm.pending)

      plan[[length(plan) + 1L]] <- list(
         repoUrl    = .rs.scalar(repoUrl),
         endpoint   = .rs.scalar(endpoint),
         authHeader = .rs.scalar(authHeader),
         body       = .rs.scalar(.rs.ppm.buildVulnerabilityRequestBody(ppmUrl[["repos"]], newKeys))
      )
   }

   plan
})

.rs.addFunction("ppm.buildVulnerabilityRequestBody", function(reposName, pkgKeys)
{
   # NOTE: we intentionally do NOT set has_vulns. has_vulns is a server-side
   # *filter* (true => only vulnerable packages); omitting it returns a record
   # for every requested package, each carrying both its vulns array (when the
   # package is vulnerable) and its custom metadata. That lets this single
   # request feed both the vulnerability badges and the PPM metadata column --
   # see ppm.recordVulnerabilityResponse, which folds both out of one response.
   #
   # omit_package_details drops the heavier package-detail fields but does NOT
   # suppress the custom metadata array, so we keep it for a leaner response.
   data <- list(
      repo                 = reposName,
      names                = as.list(pkgKeys),
      omit_dependencies    = TRUE,
      omit_downloads       = TRUE,
      omit_package_details = TRUE
   )

   .rs.toJSON(data, unbox = TRUE)
})

# Record the response to an asynchronous filter/packages request. Called by the
# C++ backend on the main thread once the network request for 'repoUrl' has
# completed successfully; 'body' is the raw (NDJSON) response payload. A single
# response carries both vulnerability and custom-metadata data, so this folds
# both into their per-repo caches. The backend publishes the aggregated vulns
# (via .rs.ppm.getCachedVulnerabilities) and re-delivers the package list (for
# the metadata column) once the whole batch of requests has drained, so this
# only needs to update the caches.
.rs.addFunction("ppm.recordVulnerabilityResponse", function(repoUrl, body)
{
   newKeys <- .rs.ppm.pending[[repoUrl]]
   if (is.null(newKeys))
      newKeys <- character()

   records <- .rs.ppm.parsePackageRecords(body)

   # NULL means the request failed (an empty body, or the server reported an
   # error on one of its records); leave the caches (and the pending keys)
   # untouched so a later refresh retries rather than masking vulns or metadata
   # with empty entries
   if (is.null(records))
      return(invisible(NULL))

   vulnsByKey <- .rs.ppm.vulnsByKey(records)
   metadataByKey <- .rs.ppm.metadataByKey(records)

   vulnCache <- .rs.ppm.repoVulnCache(repoUrl)
   metaCache <- .rs.ppm.repoMetadataCache(repoUrl)

   # record every requested key (an empty/NA marker for the ones PPM didn't
   # report on) so we don't keep re-querying packages with no vulns or metadata
   for (key in newKeys)
   {
      vulnEntry <- vulnsByKey[[key]]
      assign(key, if (is.null(vulnEntry)) list() else vulnEntry, envir = vulnCache)

      metaEntry <- metadataByKey[[key]]
      assign(key, if (is.null(metaEntry)) NA_character_ else metaEntry, envir = metaCache)
   }

   if (!is.null(.rs.ppm.pending[[repoUrl]]))
      rm(list = repoUrl, envir = .rs.ppm.pending)

   invisible(NULL)
})

# Aggregate the cached vulnerability data for all configured repositories,
# without performing any network access. Returns a list (one element per repo)
# of package-name -> vulnerability lists.
.rs.addFunction("ppm.getCachedVulnerabilities", function(repos = NULL)
{
   repos <- .rs.nullCoalesce(repos, getOption("repos"))
   pkgKeys <- .rs.ppm.installedPackageKeys()

   lapply(repos, function(repoUrl)
   {
      empty <- structure(list(), names = character())

      cache <- .rs.ppm.vulns[[repoUrl]]
      if (is.null(cache))
         return(empty)

      # isolate per-repo failures so one repo's malformed cache entry can't take
      # down the aggregation (and therefore the client update) for every repo
      tryCatch(
         .rs.ppm.aggregateVulnsByName(cache, pkgKeys),
         error = function(e) {
            .rs.logWarningMessage(paste(
               "error aggregating PPM vulnerabilities for", repoUrl, "-", conditionMessage(e)
            ))
            empty
         }
      )
   })
})

# Parse a filter/packages NDJSON body into a list of per-package records.
# Returns:
#   - an empty list for a missing body (character(0)): "nothing to record"
#   - NULL for a failure: an empty/whitespace-only 2xx body, or a body in which
#     the server reported an error on any line. NULL is the "request failed"
#     signal that tells callers to leave their caches untouched and retry on a
#     later refresh rather than caching every package as "checked, nothing".
#   - otherwise, the parsed records (lines that aren't valid JSON are skipped)
.rs.addFunction("ppm.parsePackageRecords", function(contents)
{
   # a missing body (character(0)) has no records to parse. Guarding here also
   # avoids a "subscript out of bounds" error from strsplit(character(0), ...),
   # which returns an empty list with no [[1L]] element. Treat this as "nothing
   # to record" rather than an error, matching the crash-guard intent.
   if (length(contents) == 0L)
      return(list())

   # a 2xx with an empty or whitespace-only body tells us nothing about the
   # packages we asked about. Return NULL (the "request failed" signal) so the
   # caller leaves the cache untouched and retries on a later refresh, rather
   # than caching every requested package as "checked, nothing" and silently
   # clearing any badges. trimws() is needed here because nzchar() considers a
   # whitespace-only string non-empty.
   if (!any(nzchar(trimws(contents))))
      return(NULL)

   # tolerate CRLF in case a proxy or PPM build rewrites line endings
   contents <- gsub("\r", "", contents, fixed = TRUE)
   splat <- strsplit(contents, "\n", fixed = TRUE)[[1L]]
   splat <- splat[nzchar(splat)]
   records <- lapply(splat, .rs.fromJSON)

   # bail out if the server reported an error on any line. Returning NULL
   # (rather than empty) lets the caller distinguish "nothing reported" from
   # "request failed" and skip the cache, so a transient failure doesn't
   # mask vulns for the rest of the session.
   for (record in records)
   {
      if (is.character(record[["error"]]))
      {
         code <- .rs.nullCoalesce(record[["code"]], "unknown")
         warning(sprintf(
            "error requesting package vulnerabilities; %s [error code %s]",
            record[["error"]], as.character(code)
         ), call. = FALSE)
         return(NULL)
      }
   }

   records
})

# Group the vulns out of a parsed record list, keyed by "name==version" so a
# cached entry can be invalidated individually when an installed version is
# upgraded. Records missing a name/version, or with no vulns, are skipped.
.rs.addFunction("ppm.vulnsByKey", function(records)
{
   byKey <- structure(list(), names = character())
   for (record in records)
   {
      name <- record[["name"]]
      version <- record[["version"]]
      pkgVulns <- record[["vulns"]]

      # name or version missing means PPM emitted something we can't key on --
      # warn once per session if it ever happens, then move on
      if (is.null(name) || is.null(version))
      {
         if (is.null(.rs.ppm.warnings$malformedRecord))
         {
            .rs.logWarningMessage(
               "PPM vulnerability response included a record missing 'name' or 'version'; subsequent malformed records will be silently skipped"
            )
            .rs.ppm.warnings$malformedRecord <- TRUE
         }
         next
      }

      if (length(pkgVulns) == 0L)
         next

      key <- paste(name, version, sep = "==")
      byKey[[key]] <- c(byKey[[key]], pkgVulns)
   }

   .rs.markScalars(byKey)
})

# Pull the custom metadata out of a parsed record list, keyed by "name==version"
# to match the vuln cache. A record with no metadata maps to NA so the response
# handler can still mark the key as checked (avoiding a re-query).
.rs.addFunction("ppm.metadataByKey", function(records)
{
   byKey <- list()
   for (record in records)
   {
      name <- record[["name"]]
      version <- record[["version"]]
      if (is.null(name) || is.null(version))
         next

      key <- paste(name, version, sep = "==")
      metadata <- record[["metadata"]]
      byKey[[key]] <- if (is.null(metadata)) NA_character_ else metadata
   }

   byKey
})

# Thin wrapper retained for callers/tests that only care about vulnerability
# data. Returns the by-"name==version" vuln map, or NULL on request failure.
.rs.addFunction("ppm.parseVulnerabilityResponse", function(contents)
{
   records <- .rs.ppm.parsePackageRecords(contents)
   if (is.null(records))
      return(NULL)

   .rs.ppm.vulnsByKey(records)
})

.rs.addFunction("ppm.aggregateVulnsByName", function(cache, pkgKeys)
{
   # pull only the cache entries for currently-installed (name, version)
   # keys, then re-label by just the package name
   keys <- intersect(pkgKeys, ls(envir = cache, all.names = TRUE))
   entries <- mget(keys, envir = cache)
   names(entries) <- sub("==.*$", "", names(entries))

   # group by package name and concatenate; a single installed version is
   # the common case, but the same package can show up across multiple
   # libraries, in which case we concatenate without deduping -- the
   # frontend filters per row via each vuln's versions map
   groups <- split(entries, names(entries))
   vulns <- lapply(groups, function(group) do.call(c, unname(group)))

   # drop packages with no vulns
   .rs.markScalars(vulns[lengths(vulns) > 0L])
})

.rs.addFunction("ppm.fromRepositoryUrl", function(url)
{
   # guard against non-string / NA repo entries before .rs.regexMatches: a
   # gregexpr-driven substring() on NA throws "invalid substring arguments",
   # which would abort the whole vulnerability plan. getOption("repos") can
   # legitimately carry an NA entry (e.g. an unset named repo), and this is now
   # scanned unconditionally for every session, so handle it here.
   if (!is.character(url) || length(url) != 1L || is.na(url))
      return(NULL)

   pattern <- paste0(
      "^",                                  # start of url
      "(?<root>",                           # start of root of url
         "(?<scheme>[^:]+)://",             # scheme
         "(?<authority>[^/]+)",             # authority
      ")/",                                 # end of root of url
      "(?<repos>[^/]+)/",                   # repository name
      "(?:",                                # begin optional binary parts
         "(?<binary>__[^_]+__)/",           # binary prefix
         "(?<platform>[^/]+)/",             # platform for binaries
      ")?",                                 # end optional binary parts
      "(?<snapshot>[^/]+)",                 # snapshot
      "/?",                                 # tolerate a trailing slash
      "$"
   )
   
   matches <- .rs.regexMatches(pattern, url)
   if (length(matches) == 0L || !any(nzchar(matches)))
      return(NULL)
   
   as.list(c(url = url, matches))

})

.rs.addFunction("ppm.toRepositoryUrl", function(parts)
{
   components <- c(
      parts[["root"]],
      parts[["repos"]],
      if (nzchar(parts[["binary"]])) c(
         parts[["binary"]],
         parts[["platform"]]
      ),
      parts[["snapshot"]]
   )
   
   paste(components, collapse = "/")
})

.rs.addFunction("ppm.getActiveRepository", function()
{
   repos <- getOption("repos")
   if (length(repos) == 0L)
      return(list())

   .rs.ppm.fromRepositoryUrl(repos[[1L]])
})

.rs.addFunction("ppm.getMetadataKey", function()
{
   .Call("rs_ppmMetadataKey", PACKAGE = "(embedding)")
})

#' Read cached PPM metadata for the active repository.
#'
#' Returns a (package-name -> value) map for the requested metadata key, drawn
#' entirely from the local cache. The cache is populated off the main thread by
#' the asynchronous filter/packages refresh (see ppm.recordVulnerabilityResponse
#' in this file and ppm::refreshVulnerabilitiesAsync in SessionPPM.cpp), so this
#' performs NO network access -- a slow or unreachable PPM can never block the
#' package list (and therefore the IDE) here. Packages with no cached metadata
#' yet (or none available) map to "".
#'
#' @param key The name of the metadata key which should be pulled.
.rs.addFunction("ppm.getMetadata", function(key = NULL)
{
   parts <- .rs.ppm.getActiveRepository()
   if (length(parts) == 0L)
      return(list())

   # figure out what metadata key should be used
   key <- .rs.nullCoalesce(key, .rs.ppm.getMetadataKey())

   # read whatever the asynchronous refresh has cached for the active repo
   cache <- .rs.ppm.metadataCache[[parts[["url"]]]]
   if (is.null(cache))
      return(list())

   metadata <- as.list.environment(cache, all.names = TRUE)
   if (length(metadata) == 0L)
      return(list())

   # filter to requested metadata key
   result <- lapply(metadata, function(data) {
      for (datum in data)
         if (identical(datum[[1L]], key))
            return(datum[[2L]])
      ""
   })
   names(result) <- names(metadata)

   # return sorted metadata
   result[order(names(result))]
})

#
# SessionHTMLPreview.R
#
# Copyright (C) 2009-12 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction( "getHTMLCapabilities", function(markdownVersion,
                                                 stitchVersion)
{
   caps <- list()
   caps$r_markdown_supported = .rs.scalar(FALSE)
   caps$stitch_supported = .rs.scalar(FALSE)
   if (.rs.isPackageInstalled("knitr"))
   {
      knitrVersion <- .rs.getPackageVersion("knitr")
      caps$r_markdown_supported = .rs.scalar(knitrVersion >= markdownVersion)
      caps$stitch_supported = .rs.scalar(knitrVersion >= stitchVersion)
   }
   return (caps)
})


.rs.addFunction( "spinScript", function(script, signature)
{
   # do the spin
   rmd <- knitr::spin(script, knit = FALSE, format = "Rmd")

   # append the signature (for overwrite protection)
   cat(signature, file = rmd, append = TRUE)
})

#
# SessionTutorial.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# State ----

.rs.setVar("tutorial.registry", new.env(parent = emptyenv()))



# JSON RPC ----
.rs.addJsonRpcHandler("tutorial_started", function(name, package, url)
{
   # tag the associated tutorial with the browser url
   tutorial <- .rs.tutorial.registryGet(name, package)
   tutorial[["browser_url"]] <- url
})

.rs.addJsonRpcHandler("tutorial_stop", function(url)
{
   tutorial <- .rs.tutorial.registryFind(url)
   if (is.null(tutorial))
      return(FALSE)
   
   .rs.tutorial.stopTutorial(
      name    = tutorial[["name"]],
      package = tutorial[["package"]]
   )
   
   TRUE
   
})

.rs.addJsonRpcHandler("tutorial_metadata", function(url)
{
   tutorial <- .rs.tutorial.registryFind(url)
   if (is.null(tutorial))
      return(list())
   
   .rs.scalarListFromList(as.list(tutorial))
})

# Methods ----

.rs.addFunction("tutorial.registryKey", function(name, package)
{
   paste(package, name, sep = "::")
})

.rs.addFunction("tutorial.registryCreate", function(name, package)
{
   # NOTE: we use an R environment here just so we can get reference semantics
   # (makes mutation of existing tutorial objects more straight-forward, which
   # is necessary as we'll need to tag tutorial objects with extra meta-data
   # after creation)
   tutorial <- as.environment(list(name = name, package = package))
   
   # store in registry
   key <- .rs.tutorial.registryKey(name, package)
   .rs.tutorial.registry[[key]] <- tutorial
   
   # return tutorial object
   tutorial
})

.rs.addFunction("tutorial.registryGet", function(name, package)
{
   key <- .rs.tutorial.registryKey(name, package)
   .rs.tutorial.registry[[key]]
})

.rs.addFunction("tutorial.registryFind", function(url)
{
   keys <- ls(envir = .rs.tutorial.registry)
   for (key in keys)
   {
      tutorial <- .rs.tutorial.registry[[key]]
      
      match <-
         identical(url, tutorial[["shiny_url"]]) ||
         identical(url, tutorial[["browser_url"]])
      
      if (match)
         return(tutorial)
   }
   
   NULL
   
})

# TODO: local jobs are stopped when the session is suspended, and so running
# tutorials are stopped as well. do we want to take the extra step to allow
# sessions to suspend with running tutorials active?
.rs.addFunction("tutorial.onSuspend", function(path)
{
})

.rs.addFunction("tutorial.onResume", function(path)
{
})

.rs.addFunction("tutorial.launchBrowser", function(url)
{
   # get the pending tutorial
   tutorial <- .rs.getVar("tutorial.pendingTutorial")
   .rs.clearVar("tutorial.pendingTutorial")
   
   # tag that tutorial with the shiny url
   tutorial[["shiny_url"]] <- url
   
   # open tutorial in pane
   meta <- .rs.scalarListFromList(tutorial)
   .rs.invokeShinyTutorialViewer(url, meta)
})

.rs.addFunction("tutorial.openExistingTutorial", function(name, package)
{
   # find tutorial in registry
   tutorial <- .rs.tutorial.registryGet(name, package)
   if (is.null(tutorial))
      return(FALSE)

   # get underlying shiny url
   url <- tutorial[["shiny_url"]]
   if (is.null(url))
      return(FALSE)   
   
   # check for an associated active job
   job <- tutorial[["job"]]
   running <- .rs.tryCatch(.Call("rs_isJobRunning", job, PACKAGE = "(embedding)"))
   if (!identical(running, TRUE))
      return(FALSE)
   
   # open tutorial in pane
   meta <- .rs.scalarListFromList(tutorial)
   .rs.invokeShinyTutorialViewer(url, meta)
   
   TRUE
})

.rs.addFunction("tutorial.runTutorial", function(name, package, shiny_args = NULL)
{
   # if we already have a running tutorial, just open the associated URL
   if (.rs.tutorial.openExistingTutorial(name, package))
      return()
   
   # install any required package dependencies before running tutorial
   .rs.tutorial.installPackageDependencies(name, package)
   
   # prepare the call to learnr to run the tutorial
   shiny_args$launch.browser <- quote(rstudioapi:::tutorialLaunchBrowser)
   
   call <- substitute(
      
      learnr::run_tutorial(
         name = name,
         package = package,
         shiny_args = shiny_args
      ),
      
      list(
         name = name,
         package = package,
         shiny_args = shiny_args
      )
      
   )
   
   # write to file
   deparsed <- deparse(call)
   path <- tempfile("rstudio-tutorial-", fileext = ".R")
   writeLines(deparsed, con = path)
   
   # run as job
   job <- .rs.api.runScriptJob(
      path = path,
      name = paste("Tutorial:", name),
      encoding = "UTF-8"
   )
   
   # register a tutorial object
   tutorial <- .rs.tutorial.registryCreate(name, package)
   
   # add job id
   tutorial[["job"]] <- job
   
   # set as pending
   .rs.setVar("tutorial.pendingTutorial", tutorial)
   
   invisible(job)
   
})

.rs.addFunction("tutorial.stopTutorial", function(name, package)
{
   # find tutorial in registry
   tutorial <- .rs.tutorial.registryGet(name, package)
   
   # stop its associated job
   .rs.api.stopJob(tutorial[["job"]])
   
   # remove from registry
   key <- .rs.tutorial.registryKey(name, package)
   .rs.tutorial.registry[[key]] <- NULL
})

.rs.addFunction("tutorial.enqueueClientEvent", function(type, data = list())
{
   eventData <- list(type = .rs.scalar(type), data = data)
   .rs.enqueClientEvent("tutorial_command", eventData)
})

.rs.addFunction("tutorial.findTutorials", function(pkgRoot)
{
   tutorialsRoot <- file.path(pkgRoot, "tutorials")
   if (!file.exists(tutorialsRoot))
      return(list())
   
   tutorialDirs <- sort(list.files(tutorialsRoot, full.names = TRUE))
   tutorials <- lapply(tutorialDirs, .rs.tutorial.findTutorialsImpl)
   Filter(Negate(is.null), tutorials)
   
})

.rs.addFunction("tutorial.findTutorialsImpl", function(tutorialDir)
{
   tutorialFiles <- list.files(
      tutorialDir,
      pattern = "[.]Rmd$",
      full.names = TRUE,
      ignore.case = TRUE
   )
   
   if (length(tutorialFiles) == 0)
      return(NULL)
   
   tutorialFile <- tutorialFiles[[1]]
   contents <- readLines(tutorialFile, encoding = "UTF-8", warn = FALSE)
   
   # find YAML header (if any). note that we avoid using rmarkdown here
   # just because we want to avoid loading the package and all its
   # recursive dependencies, as this could introduce issues for users
   # who need to update packages
   reYamlSeparator <- "^\\s*(?:---|[.][.][.])\\s*$"
   yamlSeparators <- grep(reYamlSeparator, contents)
   if (length(yamlSeparators) == 0)
      return(NULL)

   yamlRange <- seq.int(
      from       = yamlSeparators[[1]] + 1,
      length.out = yamlSeparators[[2]] - yamlSeparators[[1]] - 1
   )
   
   yamlCode <- paste(contents[yamlRange], collapse = "\n")
   yaml <- .Call("rs_fromYAML", yamlCode, PACKAGE = "(embedding)")
   
   title <- .rs.nullCoalesce(yaml$title, "")
   desc  <- .rs.nullCoalesce(yaml$description, "")
   
   list(
      name        = .rs.scalar(basename(tutorialDir)),
      file        = .rs.scalar(tutorialFile),
      title       = .rs.scalar(title),
      description = .rs.scalar(desc)
   )
})

.rs.addFunction("tutorial.installPackageDependencies", function(name, package)
{
   pkgs <- character()

   # form path to tutorial folder   
   path <- system.file("tutorials", name, package = package)
   if (!file.exists(path))
      return(character())
   
   # find dependencies
   deps <- renv::dependencies(path, quiet = TRUE)
   
   # ensure rstudioapi is included (required for communication between
   # the child R process hosting the tutorial + the main IDE session)
   pkgs <- sort(unique(c(deps$Package, c("learnr", "rstudioapi"))))
   
   # screen out some potentially invalid package names
   pkgs <- grep("^[a-zA-Z0-9._]+$", pkgs, value = TRUE)
   
   # find packages which are not installed
   installed <- vapply(pkgs, function(pkg) {
      location <- find.package(pkg, quiet = TRUE)
      length(location) > 0
   }, FUN.VALUE = logical(1))
   
   missing <- pkgs[!installed]
   if (length(missing) == 0)
      return(character())
   
   # ask user to install these packages
   title <- "Install Required Packages"
   message <- paste(
      "The following tutorial package dependencies are missing and will be installed:\n",
      paste("-", .rs.formatListForDialog(missing)),
      "\nWould you like to proceed?",
      sep = "\n"
   )
   
   ok <- .rs.api.showQuestion(title, message)
   if (!ok) {
      fmt <- "cannot run tutorial '%s'; required dependencies not installed"
      msg <- sprintf(fmt, name)
      stop(msg, call. = FALSE)
   }
 
   # write out call to console for user
   call <- substitute(
      install.packages(missing),
      list(missing = missing)
   )
   
   writeLines(paste(getOption("prompt"), format(call), sep = ""))
   eval(call, envir = globalenv())
   
})

#
# NotebookPlots.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# creates the notebook graphics device 
.rs.addFunction("createNotebookGraphicsDevice", function(filename,
                                                         height,
                                                         width,
                                                         units,
                                                         pixelRatio,
                                                         extraArgs)
{
   if (units == "px") # px = automatic size behavior 
   {
    height <- height * pixelRatio
    width <- width * pixelRatio
   }

   # form the arguments to the graphics device creator
   args <- list(
      filename = filename,
      width    = width,
      height   = height, 
      units    = units,
      res      = 96 * pixelRatio
   )

   if (nchar(extraArgs) > 0)
   {
      # trim leading comma from extra args if present
      if (identical(substr(extraArgs, 1, 1), ","))
         extraArgs <- substring(extraArgs, 2)
      
      # parse extra args and merge with existing args
      extraList <- NULL
      tryCatch({
         extraList <- eval(parse(text = paste("list(", extraArgs, ")")))
      }, error = function(e) {
         # failure to parse implies we won't merge below
      })
      
      if (is.list(extraList))
         args <- c(args, extraList)
   }

   gdBackend <- getOption("RStudioGD.backend")
   if (!identical(gdBackend, "default"))
   {
     # pass along graphics device backend if set
     # we allow this option to be temporarily set by the knitr chunk option while the notebook
     # chunk is executing; this takes precedence over the device passed via extraArgs
     args$type <- gdBackend
   }
   
   # if it looks like we're using AGG, delegate to that
   if (identical(args$type, "ragg"))
   {
      device <- ragg::agg_png(
         filename = filename,
         width    = width,
         height   = height,
         units    = units,
         res      = 96 * pixelRatio
      )
      
      return(device)
   }
   
   # create the device
   require(grDevices, quietly = TRUE)
   do.call(what = png, args = args)
})

# this seems like it is the only thing manipulated from NotebookPlots.cpp side
# this is where pixelRatio is introduced to the machinery
# it likely originates in RClientMetrics.cpp where it is drawn from
# "r.session.client_metrics.device-pixel-ratio"
.rs.addFunction("setNotebookGraphicsOption", function(filename,
                                                      height,
                                                      width,
                                                      units,
                                                      pixelRatio,
                                                      extraArgs)
{
   options(device = function()
   {
      .rs.createNotebookGraphicsDevice(filename, height, width, units,  pixelRatio, extraArgs)
      dev.control(displaylist = "enable")
      # this introduces margins that makes the figure different from the actual output
      # as seen in the rendered document, so disable it
      # .rs.setNotebookMargins()
   })
})

.rs.addFunction("saveNotebookGraphics", function(plot, filename)
{
   save(plot, file = filename)
})

# this should not be used in my opinion (it is never called with
# the change of setNotebookGraphicsOption above)
.rs.addFunction("setNotebookMargins", function() {
   #           bot  left top  right
   par(mar = c(5.1, 4.1, 2.1, 2.1))
})

.rs.addFunction("replayNotebookPlots", function(width, height, pixelRatio, tempFile, extraArgs) {
   # open stdin (for consuming snapshots from parent process)
   stdin <- file("stdin")
   
   require(grDevices, quietly = TRUE)
   
   snapshots <- readLines(stdin, warn = FALSE)
   lapply(snapshots, function(snapshot) {
      
      # ignore empty lines
      if (nchar(tools::file_ext(snapshot)) < 1)
         return(invisible(NULL))
      
      # create the PNG device on which we'll regenerate the plot -- it's somewhat
      # wasteful to use a separate device per plot, but the alternative is
      # doing a lot of state management and post-processing of the files
      # output from the device
      output <- paste(tools::file_path_sans_ext(snapshot), "resized.png",
                      sep = ".")
      
      height <- if (height <= 0) width / 1.618 else height
      
      .rs.createNotebookGraphicsDevice(output, height, width, 
                                       "px", pixelRatio, extraArgs)
      
      # actually replay the plot onto the device
      tryCatch({
         .rs.restoreGraphics(snapshot)
      }, error = function(e) {
         # nothing reasonable we can do here; we'll just omit this file from the
         # output
      })
      
      # close the device; has the side effect of committing the plot to disk
      dev.off()
      
      # if the plot file was written out, emit to standard out for the caller to 
      # consume
      if (file.exists(output)) {
         if (tempFile)
         {
            chunksPath <- dirname(snapshot)
            chunksTempPath <- file.path(chunksPath, "temp")
            
            if (!dir.exists(chunksTempPath))
               dir.create(chunksTempPath)
            
            chunkBaseName <- basename(tools::file_path_sans_ext(snapshot))
            
            final <- file.path(
               chunksTempPath,
               paste(chunkBaseName, "png", sep = ".")
            )
         }
         else
         {
            final <- paste(tools::file_path_sans_ext(snapshot), "png", sep = ".")
         }
         
         # remove the old copy of the plot if it existed
         if (file.exists(final))
            unlink(final)
         
         file.copy(output, final)
         
         if (file.exists(output))
            unlink(output)
         
         if (file.exists(final)) {
            cat(final, "\n")
         }
      }
   })
   
   invisible(NULL)
})

#
# NotebookHtmlWidgets.R
#
# Copyright (C) 2009-18 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("recordHtmlWidget", function(x, htmlfile, depfile)
{
   .Call("rs_recordHtmlWidget", htmlfile, depfile, list(
      classes = class(x),
      sizingPolicy = if (is.list(x)) x$sizingPolicy else list()
   ))
})

.rs.addFunction("rnb.setHtmlCaptureContext", function(...)
{
   .rs.setVar("rnb.htmlCaptureContext", list(...))
})

.rs.addFunction("rnb.getHtmlCaptureContext", function()
{
   .rs.getVar("rnb.htmlCaptureContext")
})

# Hooks ----

.rs.addFunction("rnb.saveHtmlToCache", function(x, ...)
{
   ctx <- .rs.rnb.getHtmlCaptureContext()
   
   # tempfile paths for html resources
   htmlfile <- tempfile("_rs_html_", tmpdir = ctx$outputFolder, fileext = ".html")
   depfile <- tempfile("_rs_html_deps_", tmpdir = ctx$outputFolder, fileext = ".json")
   
   # render html tags (to discover recursive dependencies + get html)
   rendered <- htmltools::renderTags(x)
   htmldeps <- rendered$dependencies
   html <- rendered$html
   
   if (length(htmldeps)) {
      # if we have html dependencies, write those to file and use 'save_html'
      cat(.rs.toJSON(htmldeps, unbox = TRUE), file = depfile, sep = "\n")
      htmltools::save_html(x, file = htmlfile, libdir = ctx$libraryFolder)
   } else {
      # otherwise, just write html to file as-is
      cat(as.character(html), file = htmlfile, sep = "\n")
   }
   
   # record the generated artefacts
   .rs.recordHtmlWidget(x, htmlfile, depfile)
})

.rs.addFunction("rnbHooks.print.html",           .rs.rnb.saveHtmlToCache)
.rs.addFunction("rnbHooks.print.shiny.tag",      .rs.rnb.saveHtmlToCache)
.rs.addFunction("rnbHooks.print.shiny.tag.list", .rs.rnb.saveHtmlToCache)

.rs.addFunction("rnbHooks.print.knit_asis", function(x, ...) 
{
   ctx <- .rs.rnb.getHtmlCaptureContext()

   # create temporary file paths
   mdfile   <- tempfile("_rs_md_", fileext = ".md")
   htmlfile <- tempfile("_rs_html_", tmpdir = ctx$outputFolder, 
                        fileext = ".html")

   # save contents to temporary file
   writeLines(enc2utf8(x), con = mdfile, useBytes = TRUE)
   
   # render to HTML with pandoc
   rmarkdown::pandoc_convert(input = rmarkdown::pandoc_path_arg(mdfile), 
                             to = "html",
                             output = rmarkdown::pandoc_path_arg(htmlfile))

   # record in cache
   .rs.recordHtmlWidget(x, htmlfile, NULL)
})

.rs.addFunction("rnbHooks.print.knit_image_paths", function(x, ...) 
{
   .Call("rs_recordExternalPlot", vapply(x, function(path) {
      dest <- tempfile(fileext = paste(".", tools::file_ext(path), sep = ""))
      if (identical(substr(path, 1, 7), "http://") ||
          identical(substr(path, 1, 8), "https://")) {
         # if the path appears to be a URL, download it locally 
         tryCatch({
            suppressMessages(download.file(path, dest, quiet = TRUE))
         },
         error = function(e) {})
      } else {
         # not a URL, presume it to be an ordinary path on disk
         file.copy(path, dest, copy.mode = FALSE)
      }
      dest
   }, ""))
})

.rs.addFunction("rnbHooks.print.htmlwidget", function(x, ...) {
   ctx <- .rs.rnb.getHtmlCaptureContext()
   
   outputFolder  <- ctx$outputFolder
   chunkOptions  <- ctx$chunkOptions
   libraryFolder <- ctx$libraryFolder
   
   if (!requireNamespace("htmlwidgets", quietly = TRUE))
      stop("print.htmlwidget called without 'htmlwidgets' available")
   
   htmlfile <- tempfile(pattern = "_rs_html_",
                        tmpdir = outputFolder, 
                        fileext = ".html")
   
   # extract dependencies (for our own accounting)
   dependencies <- c(
      htmlwidgets:::widget_dependencies(class(x)[1], attr(x, "package")), 
      x$dependencies
   )
   
   # write them to JSON 
   depfile <- tempfile(pattern = "_rs_html_deps_",
                       tmpdir = outputFolder,
                       fileext = ".json")
   
   cat(.rs.toJSON(dependencies, unbox = TRUE), file = depfile, sep = "\n")
   
   # force a responsive viewer sizing policy
   x$sizingPolicy$viewer.padding <- 0
   x$sizingPolicy$viewer.fill <- TRUE

   # make width dinamic to size correctly non-figured
   if (!is.null(x$sizingPolicy$knitr) && identical(x$sizingPolicy$knitr$figure, FALSE)) {
      x$sizingPolicy$defaultWidth <- "auto"
      x$sizingPolicy$browser$fill <- FALSE
   }
   
   # collect knitr options
   knitrOptions <- knitr::opts_current$get()
   `%||%` <- function(x, y) if (length(x)) x else y
   
   defaultDpi <- 96
   defaultFigWidth  <- 7
   defaultFigHeight <- 5
   
   # detect if the default knitr chunk fig.width, fig.height have been set
   # TODO: could this be made more robust? are we setting these values,
   # or are they coming from rmarkdown / knitr?
   
   # infer the DPI (be careful to handle fig.retina)
   if (!is.null(chunkOptions$dpi)) {
      dpi <- chunkOptions$dpi
   } else if (!is.null(knitrOptions$dpi)) {
      dpi <- knitrOptions$dpi
      if (is.numeric(knitrOptions$fig.retina))
         dpi <- dpi / knitrOptions$fig.retina
   } else {
      dpi <- defaultDpi
   }
   
   isDefaultKnitrSizing <-
      identical(knitrOptions$fig.width, defaultFigWidth) &&
      identical(knitrOptions$fig.height, defaultFigHeight) &&
      identical(dpi, defaultDpi) &&
      is.null(knitrOptions$fig.asp)
   
   # detect if the user has explicitly set fig.width, fig.height for
   # the currently executing chunk
   isDefaultChunkSizing <-
      is.null(chunkOptions$fig.width) &&
      is.null(chunkOptions$fig.height) &&
      is.null(chunkOptions$fig.asp)
   
   if (isDefaultKnitrSizing && isDefaultChunkSizing) {
      
      # if the user has not set any options related to chunk sizing, then
      # rely on the pre-computed values in 'knitrOptions', which should
      # have been set based on the htmlwidget sizing policy. (recompute
      # those values if not set)
      knitrOptions$out.width.px <- .rs.firstOf(
         knitrOptions$out.width.px,
         defaultFigWidth * defaultDpi
      )
      
      knitrOptions$out.height.px <- .rs.firstOf(
         knitrOptions$out.height.px,
         defaultFigHeight * defaultDpi
      )
      
   } else {
      
      # otherwise, set the figure width + height according to those chunk options
      
      # compute fig.width, fig.height
      figWidth  <- .rs.firstOf(chunkOptions$fig.width,  knitrOptions$fig.width) * dpi
      figHeight <- .rs.firstOf(chunkOptions$fig.height, knitrOptions$fig.height) * dpi
      figAsp    <- .rs.firstOf(chunkOptions$fig.asp,    knitrOptions$fig.asp, 1)
      
      # if fig.width or fig.height is null, compute from the companion
      knitrOptions$out.width.px  <- figWidth
      knitrOptions$out.height.px <- figHeight %||% figWidth * figAsp
   }
   
   # if, for some reason, we don't have an out.width.px or out.height.px
   # at this point, then just set some sane defaults
   knitrOptions$out.width.px  <- floor(knitrOptions$out.width.px %||% 500)
   knitrOptions$out.height.px <- floor(knitrOptions$out.height.px %||% 500)
   
   # save as HTML -- save a modified version of the 'standalone' representation
   # that works effectively the same way as the 'embedded' representation;
   # we use a filter on the server side to disentangle things as needed
   html <- htmlwidgets:::toHTML(x, standalone = TRUE, knitrOptions = knitrOptions)
   
   # validate some expectations about the data structure
   if (length(html) != 3)
      stop("unexpected htmlwidget structure: expected taglist of length 3")
   
   if (html[[1]]$attribs$id != "htmlwidget_container")
      stop("expected a container div with id 'htmlwidget_container'")
   
   if (length(html[[1]]$children) == 0)
      stop("expected one or more children for htmlwidget container div")
   
   # force knitr styling on 'standalone' widget (will be overridden by sizing policy
   # in dynamic environments; this ensures that the 'preview' will be displayed as
   # though the widget were generated through 'rmarkdown::render()')
   #
   # note that this make assumptions about the widget structure that might not be
   # true in all cases so we wrap this in tryCatch
   embedded <- htmlwidgets:::toHTML(x, standalone = FALSE, knitrOptions = knitrOptions)
   .rs.tryCatch(html[[1]]$children[[1]][[2]]$attribs$style <- embedded[[1]][[2]]$attribs$style)
   
   # split up into parts
   div <- html[[1]]$children[[1]]
   json <- html[[2]]
   policy <- html[[3]]
   
   # encode the htmlwidget sizing policy as base64 (disentangled on the server
   # as appropriate, e.g. when showing viewer element in IDE)
   fmt <- "<!-- htmlwidget-sizing-policy-base64 %s -->"
   encodedPolicy <- .rs.base64encode(paste(as.character(policy), collapse = "\n"))
   htmlPolicy <- htmltools::HTML(sprintf(fmt, encodedPolicy))
   
   # generate annotated version of standalone html that we can disentangle
   # with a server-side filter as needed
   # NOTE: if you touch this make sure you update the parsing code in NotebookOutput.cpp
   htmlProduct <- htmltools::tagList(
      htmltools::HTML("<!-- htmlwidget-container-begin -->"),
      div,
      htmltools::HTML("<!-- htmlwidget-container-end -->"),
      json,
      htmlPolicy
   )
   attributes(htmlProduct) <- attributes(html)
   
   # write html
   htmltools::save_html(htmlProduct, file = htmlfile, libdir = libraryFolder)
   
   # record the saved artefacts
   .rs.recordHtmlWidget(x, htmlfile, depfile)
})


# HTML Capture ----

.rs.addFunction("rnb.htmlCaptureHooks", function()
{
   list(
      "print.htmlwidget"       = .rs.rnbHooks.print.htmlwidget,
      "print.html"             = .rs.rnbHooks.print.html,
      "print.shiny.tag"        = .rs.rnbHooks.print.shiny.tag,
      "print.shiny.tag.list"   = .rs.rnbHooks.print.shiny.tag.list,
      "print.knit_asis"        = .rs.rnbHooks.print.knit_asis,
      "print.knit_image_paths" = .rs.rnbHooks.print.knit_image_paths
   )
})

.rs.addFunction("initHtmlCapture", function(outputFolder,
                                            libraryFolder,
                                            chunkOptions)
{
   # cache context
   .rs.rnb.setHtmlCaptureContext(
      outputFolder = outputFolder,
      libraryFolder = libraryFolder,
      chunkOptions = chunkOptions
   )
   
   # get and load hooks
   hooks <- .rs.rnb.htmlCaptureHooks()
   .rs.enumerate(hooks, function(key, value) {
      .rs.addS3Override(key, value)
   })
})

.rs.addFunction("releaseHtmlCapture", function()
{
   # remove hooks
   hooks <- .rs.rnb.htmlCaptureHooks()
   for (name in names(hooks)) {
      .rs.removeS3Override(name)
   }
})

.rs.addFunction("firstOf", function(...)
{
   for (item in list(...))
      if (length(item)) return(item)
   return(NULL)
})

#
# SessionJobs.R
#
# Copyright (C) 2009-18 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# Helpers --------------------------------------------------------------------

.rs.addFunction("scriptActions", function() {
   list(stop = function(id) {
      .Call("rs_stopScriptJob", id, PACKAGE = "(embedding)")
   })
})

# API functions --------------------------------------------------------------

.rs.addApiFunction("addJob", function(name, status = "", progressUnits = 0L,
      actions = NULL, running = FALSE, autoRemove = TRUE, group = "", show = TRUE,
      launcherJob = FALSE, tags = NULL) {

   # validate arguments
   if (missing(name))
      stop("Cannot add a job without a name.")
   if (!is.integer(progressUnits) || progressUnits < 0L || progressUnits > 1000000L)
      stop("progressUnits must be an integer between 1 and 1000000, or 0 to disable progress.")

   # begin tracking job
   .Call("rs_addJob", name, status, progressUnits,
      actions, running, autoRemove, group, show, launcherJob, tags, PACKAGE = "(embedding)")
})

.rs.addApiFunction("removeJob", function(job) {
   if (missing(job))
      stop("Must specify job ID to remove.")
   .Call("rs_removeJob", job, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("setJobProgress", function(job, units) {
   if (missing(job))
      stop("Must specify job ID to set progress for.")
   if (missing(units))
      stop("Must specify number of progress units to set.")
   .Call("rs_setJobProgress", job, units, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("addJobProgress", function(job, units) {
   if (missing(job))
      stop("Must specify job ID to add progress to.")
   if (missing(units))
      stop("Must specify number of progress units to add")
   .Call("rs_addJobProgress", job, units, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("setJobStatus", function(job, status) {
   if (missing(job))
      stop("Must specify job ID to set status for.")
   if (missing(status))
      stop("Must specify job status to update.")
   .Call("rs_setJobStatus", job, status, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("setJobState", function(job, state = c("idle", "running", "succeeded",
                                                          "cancelled", "failed")) {
   if (missing(job))
      stop("Must specify job ID to change state for.")
   state <- match.arg(state)
   .Call("rs_setJobState", job, state, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("addJobOutput", function(job, output, error = FALSE) {
   .Call("rs_addJobOutput", job, output, error, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("runScriptJob", function(path, 
                                            name = NULL,
                                            encoding = "unknown",
                                            workingDir = NULL, 
                                            importEnv = FALSE,
                                            exportEnv = "") {
   if (missing(path))
      stop("Must specify path to R script to run.")
   if (!file.exists(path))
      stop("The R script '", path, "' does not exist.")
   .Call("rs_runScriptJob", path, name, encoding, workingDir, importEnv, exportEnv, 
         PACKAGE = "(embedding)")
})

.rs.addApiFunction("executeJobAction", function(job, action) {
   if (missing(job))
      stop("Must specify job ID to execute action for.")
   .Call("rs_executeJobAction", job, action)
})

.rs.addApiFunction("stopJob", function(job) {
   .rs.api.executeJobAction(job, "stop")
})

#
# RStudioAPI.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("rstudioapi.processRequest", function(requests,
                                                      response,
                                                      secret)
{
   result <- .rs.tryCatch(
      .rs.rstudioapi.processRequestImpl(requests, response, secret)
   )
   
   unlink(requests)
   if (inherits(result, "error")) {
      saveRDS(result, response)
      return(FALSE)
   }
   
   TRUE
})

.rs.addFunction("rstudioapi.processRequestImpl", function(requests,
                                                          response,
                                                          secret)
{
   data <- readRDS(requests)
   if (!identical(data$secret, secret))
      stop("invalid secret in rstudioapi IPC")
   
   call <- data$call
   output <- eval(call, envir = baseenv())
   saveRDS(output, file = response)
})

#
# Hooks.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

assign(".rs.downloadFile", utils::download.file, envir = .rs.toolsEnv())

.rs.defineGlobalHook(
   package = "utils",
   binding = "download.file",
   when    = getRversion() < "4.6.0" && "headers" %in% names(formals(utils::download.file)),
   function(url, destfile, method)
   {
      ""
      "This is an RStudio hook."
      "Use `.rs.downloadFile` to bypass this hook if necessary."
      ""

      # Note that R also supports downloading multiple files in parallel,
      # so the 'url' parameter may be a vector of URLs.
      #
      # Unfortunately, it doesn't support the use of URL-specific headers,
      # so we try to handle this appropriately here.
      if (missing(method))
         method <- getOption("download.file.method", default = "auto")

      # Silence diagnostic warnings.
      headers <- get("headers", envir = environment(), inherits = FALSE)

      # Handle the simpler length-one URL case up front.
      if (length(url) == 1L)
      {
         # Build relevant headers for the call.
         callHeaders <- headers
         authHeader <- .rs.computeAuthorizationHeader(url)
         if (length(authHeader) && nzchar(authHeader))
            callHeaders <- c(callHeaders, Authorization = authHeader)

         # Build a call to invoke the base R downloader.
         call <- match.call(expand.dots = TRUE)
         call[[1L]] <- quote(.rs.downloadFile)
         if (length(callHeaders))
            call["headers"] <- list(callHeaders)
         status <- eval(call, envir = parent.frame())
         return(invisible(status))
      }

      # Otherwise, do some more work to map headers to URLs as appropriate.
      retvals <- vector("integer", length = length(url))
      authHeaders <- .rs.mapChr(url, .rs.computeAuthorizationHeader)
      for (authHeader in unique(authHeaders))
      {
         # Figure out which URLs are associated with the current header.
         idx <- which(authHeaders == authHeader)

         # Build relevant headers for the call.
         callHeaders <- headers
         if (length(authHeader) && nzchar(authHeader))
            callHeaders <- c(callHeaders, Authorization = authHeader)

         # Build a call to download these files all in one go.
         call <- match.call(expand.dots = TRUE)
         call[[1L]] <- quote(.rs.downloadFile)
         call["url"] <- list(url[idx])
         call["destfile"] <- list(destfile[idx])
         if (length(callHeaders))
            call["headers"] <- list(callHeaders)
         retvals[idx] <- eval(call, envir = parent.frame())
      }

      # Note that even if multiple files are downloaded, R only reports
      # a single status code, with 0 implying that all downloads succeeded.
      status <- if (all(retvals == 0L)) 0L else 1L
      if (getRversion() >= "4.5.0")
         attr(status, "retvals") <- retvals
      invisible(status)

   })

#
# SessionStan.R
#
# Copyright (C) 2009-18 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("stan_get_completions", function(line)
{
   .rs.stan.getCompletions(line)
})

.rs.addJsonRpcHandler("stan_get_arguments", function(f)
{
   .rs.stan.getArguments(f)
})

.rs.addJsonRpcHandler("stan_run_diagnostics", function(file, useSourceDatabase)
{
   .rs.stan.runDiagnostics(file, useSourceDatabase)
})

.rs.addFunction("stan.getCompletions", function(line)
{
   Encoding(line) <- "UTF-8"
   completions <- .rs.emptyCompletions()
   
   # extract token from line
   parts <- .rs.strsplit(line, "\\W+")
   token <- tail(parts, n = 1)
   
   # TODO: what kind of completions to supply when we have no token?
   if (!nzchar(token))
      return(.rs.emptyCompletions(language = "Stan"))
   
   # construct keyword completions
   keywords <- c(
      .rs.stan.keywords(),
      .rs.stan.types(),
      .rs.stan.blocks()
   )
   
   completions <- .rs.appendCompletions(
      completions,
      .rs.makeCompletions(
         token   = token,
         results = .rs.selectFuzzyMatches(keywords, token),
         type = .rs.acCompletionTypes$KEYWORD
      )
   )
   
   # construct function completions
   rosetta <- .rs.stan.rosetta()
   matches <- .rs.fuzzyMatches(rosetta$StanFunction, token)
   
   completions <- .rs.appendCompletions(
      completions,
      .rs.makeCompletions(
         token    = token,
         results  = rosetta$StanFunction[matches],
         packages = "function",
         type     = .rs.acCompletionTypes$FUNCTION,
         meta     = rosetta$Arguments[matches]
      )
   )
   
   completions
   
})

.rs.addFunction("stan.getArguments", function(f)
{
   none <- .rs.scalar("")
   
   rosetta <- .rs.stan.rosetta()
   if (is.null(rosetta))
      return(none)
   
   idx <- match(f, rosetta$StanFunction)
   if (is.na(idx))
      return(none)
   
   arguments <- rosetta$Arguments[idx]
   
   # if this is a distribution function, borrow arguments from the
   # corresponding '_lpdf' or '_lpmf' function
   if (identical(arguments, "~"))
   {
      for (suffix in c("lpdf", "lpmf"))
      {
         method <- paste(f, suffix, sep = "_")
         idx <- match(method, rosetta$StanFunction)
         if (!is.na(idx))
            break
      }
      
      if (is.na(idx))
         return(none)
      
      arguments <- rosetta$Arguments[idx]
   }
   
   .rs.scalar(arguments)
})

.rs.addFunction("stan.runDiagnostics", function(file, useSourceDatabase)
{
   if (!requireNamespace("rstan", quietly = TRUE))
      return(list())
   
   # update the file path if we're using the source database
   if (useSourceDatabase)
   {
      candidate <- .rs.stan.copySourceDatabaseToTempfile(file)
      if (!is.null(candidate))
      {
         file <- candidate
         on.exit(unlink(dirname(candidate), recursive = TRUE), add = TRUE)
      }
   }
   
   # invoke stan compiler and capture messages; note that the Stan
   # compiler will write some things to stderr and so we need to be careful
   # to capture that as well
   so <- textConnection(NULL, open = "w")
   on.exit(close(so), add = TRUE)
   
   se <- textConnection(NULL, open = "w")
   on.exit(close(se), add = TRUE)
   
   sink(so, type = "output")
   sink(se, type = "message")
   
   messages <- c()
   result <- tryCatch(
      withCallingHandlers(
         rstan::stanc_builder(file),
         message = function(m) {
            messages <<- c(messages, conditionMessage(m))
            invokeRestart("muffleMessage")
         },
         warning = function(w) invokeRestart("muffleWarning")
      ),
      error = identity
   )
   
   # close our sinks
   sink(NULL, type = "output")
   sink(NULL, type = "message")
   
   # bail if we failed to invoke the compiler
   if (!inherits(result, "error"))
      return(list())
   
   # search for relevant information
   pattern <- "^\\s*error in '([^']+)' at line (\\d+), column (\\d+)"
   line <- grep(pattern, messages, value = TRUE)
   if (length(line) != 1)
      return(list())
   
   m <- regexec(pattern, line)
   matches <- regmatches(line, m)[[1]]
   if (length(matches) != 4)
      return(list())
   
   # keep all lines without indent for messages
   lines <- grep("^\\s+", messages, value = TRUE, invert = TRUE)
   message <- paste(tail(lines, n = -1), collapse = "")
   
   # TODO: although we only ever get one error now, return a vector of
   # error objects in anticipation of that changing in the future.
   # (unfortunately diagnostics emitted on stderr don't provide line information)
   errors <- list(
      list(
         row    = as.numeric(matches[[3]]) - 1,
         column = as.numeric(matches[[4]]) - 1,
         type   = "error",
         text   = message
      )
   )
   
   # make all entries scalar
   rapply(errors, .rs.scalar, how = "replace")
   
})

.rs.addFunction("stan.extractFromNamespace", function(key)
{
   if (!requireNamespace("rstan", quietly = TRUE))
      return(NULL)
   
   rstan <- asNamespace("rstan")
   rstan[[key]]
})

.rs.addFunction("stan.keywords", function()
{
   keywords <- .rs.stan.extractFromNamespace("stan_kw1")
   if (is.character(keywords))
      return(keywords)
   
   c("for", "in", "while", "repeat", "until",
     "if", "then", "else",  "true", "false")
})

.rs.addFunction("stan.types", function()
{
   types <- .rs.stan.extractFromNamespace("stan_kw2")
   if (is.character(types))
      return(types)
   
   c("int", "real", "vector", "simplex", "ordered",
     "positive_ordered", "row_vector", "matrix",
     "corr_matrix", "cov_matrix", "lower",  "upper")
})

.rs.addFunction("stan.blocks", function()
{
   blocks <- .rs.stan.extractFromNamespace("stan_kw3")
   if (is.character(blocks))
      return(blocks)
   
   c("model", "data", "parameters",
     "quantities", "transformed", "generated")
})

.rs.addFunction("stan.rosetta", function()
{
   rosetta <- .rs.stan.extractFromNamespace("rosetta")
   if (!is.data.frame(rosetta))
      return(data.frame())
   
   # remove operator functions
   rosetta <- rosetta[grep("^operator", rosetta$StanFunction, invert = TRUE), ]
   
   # remove duplicates
   rosetta <- rosetta[!duplicated(rosetta$StanFunction), ]
   
   rosetta
})

.rs.addFunction("stan.copySourceDatabaseToTempfile", function(file)
{
   properties <- .rs.getSourceDocumentProperties(file, includeContents = TRUE)
   if (is.null(properties) || is.null(properties$contents))
      return(NULL)
   
   dir <- tempfile("rstudio-stan-diagnostics-")
   if (!dir.create(dir, showWarnings = FALSE))
      return(NULL)
   
   newPath <- file.path(dir, basename(file))
   status <- tryCatch(
      writeLines(properties$contents, con = newPath, useBytes = TRUE),
      error = identity
   )
   
   if (inherits(status, "error") || !file.exists(newPath))
      return(NULL)
   
   newPath
})

#
# SessionJobs.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# Helpers --------------------------------------------------------------------

.rs.addFunction("scriptActions", function() {
   list(
     stop = function(id) {
        .Call("rs_stopScriptJob", id, PACKAGE = "(embedding)")
     },
     replay = function(id) {
        .Call("rs_replayScriptJob", id, PACKAGE = "(embedding)")
     }
   )
})

# API functions --------------------------------------------------------------

.rs.addApiFunction("addJob", function(name, status = "", progressUnits = 0L,
      actions = NULL, running = FALSE, autoRemove = TRUE, group = "", show = TRUE,
      launcherJob = FALSE, tags = NULL) {

   # validate arguments
   if (missing(name))
      stop("Cannot add a job without a name.")
   if (!is.integer(progressUnits) || progressUnits < 0L || progressUnits > 1000000L)
      stop("progressUnits must be an integer between 1 and 1000000, or 0 to disable progress.")

   # begin tracking job
   .Call("rs_addJob", name, status, progressUnits,
      actions, running, autoRemove, group, show, launcherJob, tags, PACKAGE = "(embedding)")
})

.rs.addApiFunction("removeJob", function(job) {
   if (missing(job))
      stop("Must specify job ID to remove.")
   .Call("rs_removeJob", job, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("setJobProgress", function(job, units) {
   if (missing(job))
      stop("Must specify job ID to set progress for.")
   if (missing(units))
      stop("Must specify number of progress units to set.")
   .Call("rs_setJobProgress", job, units, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("addJobProgress", function(job, units) {
   if (missing(job))
      stop("Must specify job ID to add progress to.")
   if (missing(units))
      stop("Must specify number of progress units to add")
   .Call("rs_addJobProgress", job, units, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("setJobStatus", function(job, status) {
   if (missing(job))
      stop("Must specify job ID to set status for.")
   if (missing(status))
      stop("Must specify job status to update.")
   .Call("rs_setJobStatus", job, status, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("setJobState", function(job, state = c("idle", "running", "succeeded",
                                                          "cancelled", "failed")) {
   if (missing(job))
      stop("Must specify job ID to change state for.")
   state <- match.arg(state)
   .Call("rs_setJobState", job, state, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("addJobOutput", function(job, output, error = FALSE) {
   .Call("rs_addJobOutput", job, output, error, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("runScriptJob", function(path, 
                                            name = NULL,
                                            encoding = "unknown",
                                            workingDir = NULL, 
                                            importEnv = FALSE,
                                            exportEnv = "") {
   if (missing(path))
      stop("Must specify path to R script to run.")
   if (!file.exists(path))
      stop("The R script '", path, "' does not exist.")
   .Call("rs_runScriptJob", path, name, encoding, workingDir, importEnv, exportEnv, 
         PACKAGE = "(embedding)")
})

.rs.addApiFunction("executeJobAction", function(job, action) {
   if (missing(job))
      stop("Must specify job ID to execute action for.")
   .Call("rs_executeJobAction", job, action, PACKAGE = "(embedding)")
})

.rs.addApiFunction("stopJob", function(job) {
   .rs.api.executeJobAction(job, "stop")
})

.rs.addApiFunction("getJobState", function(job) {
   .Call("rs_getJobState", job, PACKAGE = "(embedding)")
})

#
# test-download.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("download")

expect_download <- function(url, destfile = NULL, method = "libcurl") {

   destfile <- .rs.nullCoalesce(destfile, {
       .rs.mapChr(seq_along(url), function(i) tempfile())
   })

   lhs <- .rs.downloadFile(
      url      = url,
      destfile = destfile,
      method   = method,
      quiet    = TRUE
   )

   rhs <- utils::download.file(
      url      = url,
      destfile = destfile,
      method   = method,
      quiet    = TRUE
   )

   expect_equal(lhs, rhs)

}

test_that("download.file hooks work as expected", {

   url <- "https://cran.rstudio.com"

   expect_download(url)
   expect_download(c(url, url))

})

# https://github.com/rstudio/rstudio/issues/16446
test_that("download hooks don't set an empty authorization header", {

   skip_if(!"headers" %in% names(formals(utils::download.file)))   
   
   url <- "https://cran.rstudio.com"
   
   trace(.rs.downloadFile, quote({
      expect_identical(headers, NULL)
      stop("exiting early")
   }), print = FALSE)
   on.exit(untrace(.rs.downloadFile))
   
   tryCatch(
      download.file(url, tempfile(), quiet = TRUE),
      error = function(cnd) NULL
   )
   
})

test_that("we can download packages from repositories", {
   
   info <- download.packages(
      pkgs    = "rlang",
      destdir = tempdir(),
      repos   = "https://cloud.r-project.org",
      quiet   = TRUE
   )

   path <- info[1, 2]
   expect_true(file.exists(path))
   files <- untar(path, list = TRUE)
   expect_true("rlang/DESCRIPTION" %in% files)

   info <- download.packages(
      pkgs    = "rlang",
      destdir = tempdir(),
      repos   = "https://packagemanager.posit.co/cran/latest",
      quiet   = TRUE
   )
   
   path <- info[1, 2]
   expect_true(file.exists(path))
   files <- untar(path, list = TRUE)
   expect_true("rlang/DESCRIPTION" %in% files)
   
})

#
# SessionAskSecret.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("getSecretService", function() {
   "RStudio Keyring Secrets"
})

.rs.addFunction("askForSecret", function(name, title = name, prompt = paste(name, ":", sep = ""))
{
   result <- .Call(
      "rs_askForSecret",
      name,
      title,
      prompt,
      .rs.isPackageInstalled("keyring"),
      .rs.hasSecret(name)
   )

   if (is.null(result)) stop("Ask for secret operation was cancelled.")
   
   result
})

.rs.addFunction("hasSecret", function(name)
{
   if (!.rs.isPackageInstalled("keyring"))
   {
      FALSE
   }
   else
   {
      keyring_list <- get("key_list", envir = asNamespace("keyring"))
      keys <- keyring_list(.rs.getSecretService())
      name %in% keys$username
   }
})

.rs.addFunction("retrieveSecret", function(name)
{
   if (!.rs.isPackageInstalled("keyring") || !.rs.hasSecret(name))
   {
      NULL
   }
   else 
   {
      keyring_get <- get("key_get", envir = asNamespace("keyring"))
      keyring_get(.rs.getSecretService(), username = name)
   }
})

.rs.addFunction("rememberSecret", function(name, secret)
{
   if (.rs.isPackageInstalled("keyring"))
   {
      keyring_set <- get("key_set_with_value", envir = asNamespace("keyring"))
      keyring_set(.rs.getSecretService(), username = name, password = secret)
   }
})

.rs.addFunction("forgetSecret", function(name)
{
   if (.rs.isPackageInstalled("keyring") && .rs.hasSecret(name))
   {
      keyring_remove <- get("key_delete", envir = asNamespace("keyring"))
      keyring_remove(.rs.getSecretService(), username = name)
   }
})

#
# SessionPackages.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# cached URLs for package NEWS files
.rs.setVar("packageNewsURLsEnv", new.env(parent = emptyenv()))

# cached information on available R packages
.rs.setVar("availablePackagesEnv", new.env(parent = emptyenv()))

# for asynchronous requests on available package information,
# map the repository string to the directory containing produced output
.rs.setVar("availablePackagesPendingEnv", new.env(parent = emptyenv()))

# a vectorized function that takes any number of paths and aliases the home
# directory in those paths (i.e. "/Users/bob/foo" => "~/foo"), leaving any 
# paths outside the home directory untouched
.rs.addFunction("createAliasedPath", function(path)
{
   homeDir <- path.expand("~/")
   homePathIdx <- substr(path, 1, nchar(homeDir)) == homeDir
   homePaths <- path[homePathIdx]
   path[homePathIdx] <-
          paste("~", substr(homePaths, nchar(homeDir), nchar(homePaths)), sep="")
   path
})

# Some R commands called during packaging-related operations (such as untar)
# delegate to the system tar binary specified in TAR. On OS X, R may set TAR to
# /usr/bin/gnutar, which exists prior to Mavericks (10.9) but not in later
# rleases of the OS. In the special case wherein the TAR environment variable
# on OS X is set to a non-existent gnutar and there exists a tar at
# /usr/bin/tar, tell R to use that binary instead.
if (identical(as.character(Sys.info()["sysname"]), "Darwin") &&
    identical(Sys.getenv("TAR"), "/usr/bin/gnutar") && 
    !file.exists("/usr/bin/gnutar") &&
    file.exists("/usr/bin/tar"))
{
   Sys.setenv(TAR = "/usr/bin/tar")
}

.rs.addFunction("beforePackageUnloaded", function(package)
{
   # force any promises associated with package's registered S3 methods --
   # this is necessary as otherwise the lazy-load database may become corrupt
   # if a new version of this package is later installed as the old promises
   # will now have invalid pointers to the old lazy-load database.
   #
   # note that we iterate over all loaded packages here because loading a
   # package might entail registering S3 methods in the namespace of the
   # package owning the generic, which typically is a separate package
   #
   # https://bugs.r-project.org/bugzilla/show_bug.cgi?id=16644
   # https://github.com/rstudio/rstudio/issues/8265
   for (namespaceName in loadedNamespaces())
   {
      .rs.tryCatch({
         ns <- asNamespace(namespaceName)
         table <- ns[[".__S3MethodsTable__."]]
         as.list(table)
      })
   }
})

.rs.addFunction( "updatePackageEvents", function()
{
   reportPackageStatus <- function(status)
      function(pkgname, ...)
      {
         packageStatus = list(name=pkgname,
                              path=.rs.createAliasedPath(
                                     .rs.pathPackage(pkgname, quiet=TRUE)),
                              loaded=status)
         .rs.enqueClientEvent("package_status_changed", packageStatus)
      }
   
   notifyPackageLoaded <- function(pkgname, ...)
   {
      .Call("rs_packageLoaded", pkgname, PACKAGE = "(embedding)")

      # when a package is loaded, it can register S3 methods which replace overrides we've
      # attached manually; take this opportunity to reattach them.
      .rs.reattachS3Overrides()
   }

   notifyPackageUnloaded <- function(pkgname, ...)
   {
      .rs.beforePackageUnloaded(pkgname)
      .Call("rs_packageUnloaded", pkgname, PACKAGE = "(embedding)")
   }
   
   pkgNames <-
      base::list.dirs(.libPaths(), full.names = FALSE, recursive = FALSE)
   
   sapply(pkgNames, function(packageName)
   {
      if ( !(packageName %in% .rs.hookedPackages) )
      {
         attachEventName = packageEvent(packageName, "attach")
         setHook(attachEventName, reportPackageStatus(TRUE), action="append")
         
         loadEventName = packageEvent(packageName, "onLoad")
         setHook(loadEventName, notifyPackageLoaded, action="append")

         unloadEventName = packageEvent(packageName, "onUnload")
         setHook(unloadEventName, notifyPackageUnloaded, action="append")
             
         detachEventName = packageEvent(packageName, "detach")
         setHook(detachEventName, reportPackageStatus(FALSE), action="append")
          
         .rs.setVar("hookedPackages", append(.rs.hookedPackages, packageName))
      }
   })
})

.rs.addFunction( "packages.initialize", function()
{  
   # list of packages we have hooked attach/detach for
   .rs.setVar( "hookedPackages", character() )

   # set flag indicating we should not ignore loadedPackageUpdates checks
   .rs.setVar("ignoreNextLoadedPackageCheck", FALSE)
    
   # ensure we are subscribed to package attach/detach events
   .rs.updatePackageEvents()
   
   # whenever a package is installed notify the client and make sure
   # we are subscribed to its attach/detach events
   .rs.registerReplaceHook("install.packages", "utils", function(original,
                                                                pkgs,
                                                                lib,
                                                                repos = getOption("repos"),
                                                                ...) 
   {
      if (missing(pkgs))
         return(utils::install.packages())
      
      if (!.Call("rs_canInstallPackages", PACKAGE = "(embedding)"))
      {
        stop("Package installation is disabled in this version of RStudio",
             call. = FALSE)
      }
      
      packratMode <- !is.na(Sys.getenv("R_PACKRAT_MODE", unset = NA))
      
      if (!is.null(repos) && !packratMode && .rs.loadedPackageUpdates(pkgs)) {

         # attempt to determine the install command
         installCmd <- NULL
         for (i in seq_along(sys.calls()))
         {
           if (identical(deparse(sys.call(i)[[1]]), "install.packages"))
           {
             installCmd <- gsub("\\s+"," ", 
                                paste(deparse(sys.call(i)), collapse = " "))
             break
           }
         }

         # call back into rsession to send an event to the client
         .rs.enqueLoadedPackageUpdates(installCmd)

         # throw error
         stop("Updating loaded packages")
      }

      # fixup path as necessary
      .rs.addRToolsToPath()

      # do housekeeping after we execute the original
      on.exit({
         .rs.updatePackageEvents()
         .Call("rs_packageLibraryMutated", PACKAGE = "(embedding)")
         .rs.restorePreviousPath()
      })
      
      # call original
      original(pkgs, lib, repos, ...)
   })
   
   # whenever a package is removed notify the client (leave attach/detach
   # alone because the dangling event is harmless and removing it would
   # requrie somewhat involved code
   .rs.registerReplaceHook("remove.packages", "utils", function(original,
                                                               pkgs,
                                                               lib,
                                                               ...) 
   {
      # do housekeeping after we execute the original
      on.exit(.Call("rs_packageLibraryMutated", PACKAGE = "(embedding)"))
                         
      # call original
      original(pkgs, lib, ...) 
   })
})

.rs.addFunction( "addRToolsToPath", function()
{
    .Call("rs_addRToolsToPath", PACKAGE = "(embedding)")
})

.rs.addFunction( "restorePreviousPath", function()
{
    .Call("rs_restorePreviousPath", PACKAGE = "(embedding)")
})

.rs.addFunction( "uniqueLibraryPaths", function()
{
   # get library paths (normalize on unix to get rid of duplicate symlinks)
   libPaths <- .libPaths()
   if (!identical(.Platform$OS.type, "windows"))
      libPaths <- .rs.normalizePath(libPaths)

   uniqueLibPaths <- subset(libPaths, !duplicated(libPaths))
   return (uniqueLibPaths)
})

.rs.addFunction( "writeableLibraryPaths", function()
{
   uniqueLibraryPaths <- .rs.uniqueLibraryPaths()
   writeableLibraryPaths <- character()
   for (libPath in uniqueLibraryPaths)
      if (.rs.isLibraryWriteable(libPath))
         writeableLibraryPaths <- append(writeableLibraryPaths, libPath)
   return (writeableLibraryPaths)
})

.rs.addFunction("defaultUserLibraryPath", function()
{
   unlist(strsplit(Sys.getenv("R_LIBS_USER"),
                              .Platform$path.sep))[1L]
})

.rs.addFunction("defaultLibraryPath", function()
{
  .libPaths()[1]
})

.rs.addFunction("isPackageLoaded", function(packageName, libName)
{
   if (packageName %in% .packages())
   {
      # get the raw path to the package 
      packagePath <- .rs.pathPackage(packageName, quiet=TRUE)

      # alias (for comparison against libName, which comes from the client and
      # is aliased)
      packagePath <- .rs.createAliasedPath(packagePath)

      # compare with the library given by the client
      .rs.scalar(identical(packagePath, paste(libName, packageName, sep="/")))
   }
   else 
      .rs.scalar(FALSE)
})

.rs.addJsonRpcHandler( "is_package_loaded", function(packageName, libName)
{
   .rs.isPackageLoaded(packageName, libName)
})

.rs.addFunction("isPackageHyperlinkSafe", function(packageName)
{
   allowed <- setdiff(
      c(.packages(), "testthat", "rlang", "devtools", "usethis"), 
      c("base", "stats", "utils")
   )
   .rs.scalar(
      packageName %in% allowed
   )
})

.rs.addJsonRpcHandler("is_package_hyperlink_safe", function(packageName)
{
   .rs.isPackageHyperlinkSafe(packageName)
})

.rs.addFunction("forceUnloadPackage", function(package)
{
   tryCatch(
      withCallingHandlers(
         .rs.forceUnloadPackageImpl(package),
         warning = function(w) invokeRestart("muffleWarning")
      ),
      error = warning
   )
})

.rs.addFunction("forceUnloadPackageImpl", function(package)
{
   .rs.beforePackageUnloaded(package)
   
   searchPathName <- paste("package", package, sep = ":")
   if (searchPathName %in% search())
   {
      detach(
         name = searchPathName,
         unload = TRUE,
         character.only = TRUE,
         force = TRUE
      )
   }
   else if (package %in% loadedNamespaces())
   {
      unloadNamespace(package)
   }
})

.rs.addFunction("packageVersion", function(name, libPath, pkgs)
{
   pkgs <- subset(pkgs, Package == name & LibPath == libPath)
   if (nrow(pkgs) == 1)
      pkgs$Version
   else
      ""
})

.rs.addFunction( "initDefaultUserLibrary", function()
{
  userdir <- .rs.defaultUserLibraryPath()
  dir.create(userdir, showWarnings = FALSE, recursive = TRUE)
  .libPaths(c(userdir, .libPaths()))
})

.rs.addFunction("ensureWriteableUserLibrary", function()
{
   if (!.rs.defaultLibPathIsWriteable())
      .rs.initDefaultUserLibrary()
})

.rs.addFunction("lastCharacterIs", function(value, ending) {
   identical(tail(strsplit(value, "")[[1]], n = 1), ending)
})

.rs.addFunction("listInstalledPackages", function()
{
   # get the CRAN repository URL, and remove a trailing slash if required
   repos <- getOption("repos")
   cran <- if ("CRAN" %in% names(repos))
      repos[["CRAN"]]
   else
      .Call("rs_rstudioCRANReposUrl", PACKAGE = "(embedding)")
   
   # trim trailing slashes if necessary
   cran <- gsub("/*", "", cran)
   
   # helper function for extracting information from a package's
   # DESCRIPTION file
   readPackageInfo <- function(pkgPath) {
      
      # attempt to read package metadata
      desc <- .rs.tryCatch({
         metapath <- file.path(pkgPath, "Meta", "package.rds")
         metadata <- readRDS(metapath)
         as.list(metadata$DESCRIPTION)
      })
      
      # if that failed, try reading the DESCRIPTION
      if (inherits(desc, "error"))
         desc <- read.dcf(file.path(pkgPath, "DESCRIPTION"), all = TRUE)
      
      # attempt to infer an appropriate URL for this package
      if (identical(as.character(desc$Priority), "base")) {
         source <- "Base"
         url <- ""
      } else if (!is.null(desc$URL)) {
         source <- "Custom"
         url <- strsplit(desc$URL, "\\s*,\\s*")[[1]][[1]]
      } else if ("biocViews" %in% names(desc)) {
         source <- "Bioconductor"
         url <- sprintf("https://www.bioconductor.org/packages/release/bioc/html/%s.html", desc$Package)
      } else if (identical(desc$Repository, "CRAN")) {
         source <- "CRAN"
         url <- sprintf("%s/package=%s", cran, desc$Package)
      } else if (!is.null(desc$GithubRepo)) {
         source <- "GitHub"
         url <- sprintf("https://github.com/%s/%s", desc$GithubUsername, desc$GithubRepo)
      } else {
         source <- "Unknown"
         url <- sprintf("%s/package=%s", cran, desc$Package)
      }
      
      list(
         Package     = .rs.nullCoalesce(desc$Package, "[Unknown]"),
         LibPath     = dirname(pkgPath),
         Version     = .rs.nullCoalesce(desc$Version, "[Unknown]"),
         Title       = .rs.nullCoalesce(desc$Title, "[No description available]"),
         Source      = source,
         BrowseUrl   = utils::URLencode(url)
      )
      
   }
   
   # to be called if our attempt to read the package DESCRIPTION file failed
   # for some reason
   emptyPackageInfo <- function(pkgPath) {
      
      package <- basename(pkgPath)
      libPath <- dirname(pkgPath)
      
      list(
         Package   = package,
         LibPath   = libPath,
         Version   = "[Unknown]",
         Title     = "[Failed to read package metadata]",
         Source    = "Unknown",
         BrowseUrl = ""
      )
      
   }
   
   # now, find packages. we'll only include packages that have
   # a Meta folder. note that the pseudo-package 'translations'
   # lives in the R system library, and has a DESCRIPTION file,
   # but cannot be loaded as a regular R package.
   packagePaths <- list.files(.rs.uniqueLibraryPaths(), full.names = TRUE)
   hasMeta <- file.exists(file.path(packagePaths, "Meta"))
   packagePaths <- packagePaths[hasMeta]
   
   # now, iterate over these to generate the requisite package
   # information and combine into a data.frame
   parts <- lapply(packagePaths, function(pkgPath) {
      
      tryCatch(
         readPackageInfo(pkgPath),
         error = function(e) emptyPackageInfo(pkgPath)
      )
      
   })
   
   # combine into a data.frame
   info <- .rs.rbindList(parts)
   
   # find which packages are currently attached (be careful to handle
   # cases where package is installed into multiple libraries)
   #
   # we suppress warnings here as 'find.packages(.packages())' can warn
   # if a package that is attached is no longer actually installed
   loaded <- suppressWarnings(
      normalizePath(file.path(info$LibPath, info$Package), winslash = "/", mustWork = FALSE) %in%
      normalizePath(find.package(.packages(), quiet = TRUE), winslash = "/", mustWork = FALSE)
   )
   
   # extract fields relevant to us
   packages <- data.frame(
      name             = info$Package,
      library          = .rs.createAliasedPath(info$LibPath),
      library_absolute = info$LibPath,
      library_index    = match(info$LibPath, .libPaths(), nomatch = 0L),
      version          = info$Version,
      desc             = info$Title,
      loaded           = loaded,
      source           = info$Source,
      browse_url       = info$BrowseUrl,
      check.rows       = TRUE,
      stringsAsFactors = FALSE
   )
   
   # sort and return
   packages[order(packages$name), ]
})

.rs.addJsonRpcHandler("get_package_install_context", function()
{
   # cran mirror configured
   repos = getOption("repos")
   cranMirrorConfigured <- !is.null(repos) && !any(repos == "@CRAN@")
   
   # selected repository names (assume an unnamed repo == CRAN)
   selectedRepositoryNames <- names(repos)
   if (is.null(selectedRepositoryNames))
     selectedRepositoryNames <- "CRAN"

   # package archive extension
   if (identical(.Platform$OS.type, "windows"))
      packageArchiveExtension <- ".zip; .tar.gz"
   else if (identical(substr(.Platform$pkgType, 1L, 10L), "mac.binary"))
      packageArchiveExtension <- ".tgz; .tar.gz"
   else
      packageArchiveExtension <- ".tar.gz"

   # default library path (normalize on unix)
   defaultLibraryPath = .libPaths()[1L]
   if (!identical(.Platform$OS.type, "windows"))
      defaultLibraryPath <- .rs.normalizePath(defaultLibraryPath)
   
   # return context
   list(cranMirrorConfigured = cranMirrorConfigured,
        selectedRepositoryNames = selectedRepositoryNames,
        packageArchiveExtension = packageArchiveExtension,
        defaultLibraryPath = defaultLibraryPath,
        defaultLibraryWriteable = .rs.defaultLibPathIsWriteable(),
        writeableLibraryPaths = .rs.writeableLibraryPaths(),
        defaultUserLibraryPath = .rs.defaultUserLibraryPath(),
        devModeOn = .rs.devModeOn())
})

.rs.addJsonRpcHandler( "get_cran_mirrors", function()
{
   # get CRAN mirrors (securely if we are configured to do so)
   haveSecureMethod <- .rs.haveSecureDownloadFileMethod()
   protocol <- ifelse(haveSecureMethod, "https", "http")
   cranMirrors <- try(silent = TRUE, {
      mirrors_csv_url <- paste(protocol, "://cran.r-project.org/CRAN_mirrors.csv",
                               sep = "")
      mirrors_csv <- tempfile("mirrors", fileext = ".csv")
      download.file(mirrors_csv_url, destfile = mirrors_csv, quiet = TRUE)
      
      # read them
      read.csv(mirrors_csv, as.is = TRUE, encoding = "UTF-8")
   })
   
   # if we got an error then use local only
   if (is.null(cranMirrors) || inherits(cranMirrors, "try-error"))
      cranMirrors <- utils::getCRANmirrors(local.only = TRUE)
   
   # create data frame
   cranDF <- data.frame(name = cranMirrors$Name,
                        host = cranMirrors$Host,
                        url = cranMirrors$URL,
                        country = cranMirrors$CountryCode,
                        ok = cranMirrors$OK,
                        stringsAsFactors = FALSE)

   # filter by OK status
   cranDF <- cranDF[as.logical(cranDF$ok), ]

   # filter by mirror type supported by the current download.file.method
   # (also verify that https urls are provided inline -- if we didn't do
   # this and CRAN changed the format we could end up with no mirrors)
   secureMirror <- grepl("^https", cranDF[, "url"])
   useHttpsURL <- haveSecureMethod && any(secureMirror)
   if (useHttpsURL)
      cranDF <- cranDF[secureMirror,]
   else
      cranDF <- cranDF[!secureMirror,]

   # prepend RStudio mirror and return
   rstudioDF <- data.frame(name = "Global (CDN)",
                           host = "RStudio",
                           url = paste(ifelse(useHttpsURL, "https", "http"), 
                                       "://cran.rstudio.com/", sep=""),
                           country = "us",
                           ok = TRUE,
                           stringsAsFactors = FALSE)
   rbind(rstudioDF, cranDF)
})

.rs.addJsonRpcHandler("get_cran_actives", function()
{
   data.frame(name = names(getOption("repos")),
              host = "",
              url = as.character(getOption("repos")),
              country = "",
              ok = TRUE,
              stringsAsFactors = FALSE)
})

.rs.addJsonRpcHandler( "init_default_user_library", function()
{
  .rs.initDefaultUserLibrary()
})

.rs.addJsonRpcHandler("check_for_package_updates", function()
{
   # get updates writeable libraries and convert to a data frame
   updates <- as.data.frame(
      utils::old.packages(lib.loc = .rs.writeableLibraryPaths()),
      stringsAsFactors = FALSE
   )
   row.names(updates) <- NULL
   
   # see which ones are from CRAN and add a news column for them
   # NOTE: defend against length-one repos with no name set
   repos <- getOption("repos")
   cranRep <- if ("CRAN" %in% names(repos))
      repos["CRAN"]
   else
      c(CRAN = repos[[1]])
   
   data.frame(
      packageName = updates$Package,
      libPath     = updates$LibPath,
      installed   = updates$Installed,
      available   = updates$ReposVer,
      stringsAsFactors = FALSE
   )
   
})

.rs.addJsonRpcHandler("get_package_citations", function(packageName, libraryPath)
{
   toPerson <- function(author) {
      list(
         given = author[["given"]],
         family = .rs.scalar(author[["family"]]),
         email = .rs.scalar(author[["email"]]),
         role = .rs.scalar(author[["role"]])
      )
   }
   
   cites <- citation(packageName)
   lapply(unclass(cites), function(cite) {
      list(
         # bibtex type
         type = .rs.scalar(attr(cite, "bibtype")),
         
         title = .rs.scalar(cite[["title"]]),
         url = .rs.scalar(cite[["url"]]),
         note = .rs.scalar(cite[["note"]]),
         doi = .rs.scalar(cite[["doi"]]),
         
         publisher = .rs.scalar(cite[["publisher"]]),
         institution = .rs.scalar(cite[["institution"]]),
         address = .rs.scalar(cite[["address"]]),
         
         journal = .rs.scalar(cite[["journal"]]),
         year = .rs.scalar(cite[["year"]]),
         booktitle = .rs.scalar(cite[["booktitle"]]),
         chapter = .rs.scalar(cite[["chapter"]]),
         number = .rs.scalar(cite[["number"]]),
         volume = .rs.scalar(cite[["volume"]]),
         pages = .rs.scalar(cite[["pages"]]),
         series = .rs.scalar(cite[["series"]]),
         school = .rs.scalar(cite[["school"]]),
         
         
         # person
         author = lapply(unclass(cite[["author"]]), toPerson),
         editor = lapply(unclass(cite[["editor"]]), toPerson)
      )
   })
})

.rs.addJsonRpcHandler("get_package_news_url", function(packageName, libraryPath)
{
   # first, check if we've already discovered a NEWS link
   cache <- .rs.packageNewsURLsEnv
   entry <- file.path(libraryPath, packageName)
   if (exists(entry, envir = cache))
      return(get(entry, envir = cache))
   
   # determine an appropriate CRAN URL
   repos <- getOption("repos")
   cran <- if ("CRAN" %in% names(repos))
      repos[["CRAN"]]
   else if (length(repos))
      repos[[1]]
   else
      .Call("rs_rstudioCRANReposUrl", PACKAGE = "(embedding)")
   cran <- gsub("/*$", "", cran)
   
   # check to see if this package was from Bioconductor. if so, we'll need
   # to construct a more appropriate url
   desc <- .rs.tryCatch(.rs.readPackageDescription(file.path(libraryPath, packageName)))
   prefix <- if (inherits(desc, "error") || !"biocViews" %in% names(desc))
      file.path(cran, "web/packages")
   else
      "https://bioconductor.org/packages/release/bioc/news"
   
   # the set of candidate URLs -- we use the presence of a NEWS or NEWS.md
   # to help us prioritize the order of checking.
   #
   # in theory, the current-installed package might not have NEWS at all, but
   # the latest released version might have it after all, so checking the
   # current installed package is just a heuristic and won't be accurate
   # 100% of the time
   pkgPath <- file.path(libraryPath, packageName)
   candidates <- if (file.exists(file.path(pkgPath, "NEWS.md"))) {
      c("news/news.html", "news.html", "NEWS", "ChangeLog")
   } else if (file.exists(file.path(pkgPath, "NEWS"))) {
      c("NEWS", "news/news.html", "news.html", "ChangeLog")
   } else {
      c("news/news.html", "news.html", "NEWS", "ChangeLog")
   }
   
   
   # we do some special handling for 'curl'
   isCurl <- identical(getOption("download.file.method"), "curl")
   if (isCurl) {
      
      download.file.extra <- getOption("download.file.extra")
      on.exit(options(download.file.extra = download.file.extra), add = TRUE)
      
      # guard against NULL, empty extra
      extra <- if (length(download.file.extra))
         download.file.extra
      else
         ""
      
      # add in some extra flags for nicer download output
      addons <- c()
      
      # follow redirects if necessary
      hasLocation <-
         grepl("\b-L\b", extra) ||
         grepl("\b--location\b", extra)
      
      if (!hasLocation)
         addons <- c(addons, "-L")
      
      # fail on 404
      hasFail <-
         grepl("\b-f\b", extra) ||
         grepl("\b--fail\b", extra)
      
      if (!hasFail)
         addons <- c(addons, "-f")
      
      # don't print error output to the console
      hasSilent <-
         grepl("\b-s\b", extra) ||
         grepl("\b--silent\b", extra)
      
      if (!hasSilent)
         addons <- c(addons, "-s")
      
      if (nzchar(extra))
         extra <- paste(extra, paste(addons, collapse = " "))
      else
         extra <- paste(addons, collapse = " ")
      
      options(download.file.extra = extra)
   }
   
   # timeout a bit more quickly when forming web requests
   timeout <- getOption("timeout")
   on.exit(options(timeout = timeout), add = TRUE)
   options(timeout = 4L)
   
   for (candidate in candidates) {
      
      url <- file.path(prefix, packageName, candidate)
      
      # attempt to download the file (note that R preserves curl's printing of errors
      # to the console with 'quiet = TRUE' so we disable it there)
      destfile <- tempfile()
      on.exit(unlink(destfile), add = TRUE)
      status <- .rs.tryCatch(download.file(url, destfile = destfile, quiet = !isCurl, mode = "wb"))
      
      # handle explicit errors
      if (is.null(status) || inherits(status, "error"))
         next
      
      # check for success status
      if (identical(status, 0L)) {
         cache[[entry]] <- .rs.scalar(url)
         return(.rs.scalar(url))
      }
   }
   
   # we failed to figure out the NEWS url; provide our first candidate
   # as the best guess
   fmt <- "Failed to infer appropriate NEWS URL: using '%s' as best-guess candidate"
   warning(sprintf(fmt, candidates[[1]]))
   
   # return that URL
   .rs.scalar(candidates[[1]])
})

.rs.addFunction("packagesLoaded", function(pkgs) {
   # first check loaded namespaces
   if (any(pkgs %in% loadedNamespaces()))
      return(TRUE)

   # now check if there are libraries still loaded in spite of the
   # namespace being unloaded 
   libs <- .dynLibs()
   libnames <- vapply(libs, "[[", character(1), "name")
   return(any(pkgs %in% libnames))
})

.rs.addFunction("loadedPackageUpdates", function(pkgs)
{
   # are we ignoring?
   ignore <- .rs.ignoreNextLoadedPackageCheck
   .rs.setVar("ignoreNextLoadedPackageCheck", FALSE)
   if (ignore)
      return(FALSE)

   # if the default set of namespaces in rstudio are loaded
   # then skip the check
   defaultNamespaces <- c("base", "datasets", "graphics", "grDevices",
                          "methods", "stats", "tools", "utils")
   if (identical(defaultNamespaces, loadedNamespaces()) &&
       length(.dynLibs()) == 4)
      return(FALSE)

   if (.rs.packagesLoaded(pkgs)) {
      return(TRUE)
   }
   else {
      avail <- available.packages()
      deps <- suppressMessages(suppressWarnings(
         utils:::getDependencies(pkgs, available=avail)))
      return(.rs.packagesLoaded(deps))
   }
})

.rs.addFunction("loadedPackagesAndDependencies", function(pkgs) {
  
  # if the default set of namespaces in rstudio are loaded
  # then skip the check
  defaultNamespaces <- c("base", "datasets", "graphics", "grDevices",
                         "methods", "stats", "tools", "utils")
  if (identical(defaultNamespaces, loadedNamespaces()) && length(.dynLibs()) == 4)
    return(character())
  
  packagesLoaded <- function(pkgList) {
    
    # first check loaded namespaces
    loaded <- pkgList[pkgList %in% loadedNamespaces()]
    
    # now check if there are libraries still loaded in spite of the
    # namespace being unloaded 
    libs <- .dynLibs()
    libnames <- vapply(libs, "[[", character(1), "name")
    loaded <- c(loaded, pkgList[pkgList %in% libnames])
    loaded
  }
  
  # package loaded
  loaded <- packagesLoaded(pkgs)
  
  # dependencies loaded
  avail <- available.packages()
  deps <- suppressMessages(suppressWarnings(
    utils:::getDependencies(pkgs, available=avail)))
  loaded <- c(loaded, packagesLoaded(deps))
  
  # return unique list
  unique(loaded)  
})

.rs.addFunction("forceUnloadForPackageInstall", function(pkgs) {
  
  # figure out which packages are loaded and/or have dependencies loaded
  pkgs <- .rs.loadedPackagesAndDependencies(pkgs)
  
  # force unload them
  sapply(pkgs, .rs.forceUnloadPackage)
  
  # return packages unloaded
  pkgs
})


.rs.addFunction("enqueLoadedPackageUpdates", function(installCmd)
{
   .Call("rs_enqueLoadedPackageUpdates", installCmd, PACKAGE = "(embedding)")
})

.rs.addJsonRpcHandler("loaded_package_updates_required", function(pkgs)
{
   .rs.scalar(.rs.loadedPackageUpdates(as.character(pkgs)))
})

.rs.addJsonRpcHandler("ignore_next_loaded_package_check", function() {
   .rs.setVar("ignoreNextLoadedPackageCheck", TRUE)
   return(NULL)
})

.rs.addFunction("getCachedAvailablePackages", function(contribUrl)
{
   .Call("rs_getCachedAvailablePackages", contribUrl, PACKAGE = "(embedding)")
})

.rs.addFunction("downloadAvailablePackages", function(contribUrl)
{
   .Call("rs_downloadAvailablePackages", contribUrl, PACKAGE = "(embedding)")
})

.rs.addJsonRpcHandler("package_skeleton", function(packageName,
                                                   packageDirectory,
                                                   sourceFiles,
                                                   usingRcpp)
{
   # mark encoding
   Encoding(packageDirectory) <- "UTF-8"

   # sourceFiles is passed in as a list -- convert back to
   # character vector
   sourceFiles <- as.character(sourceFiles)
   
   # Make sure we expand the aliased path if necessary
   # (note this is a no-op if there is no leading '~')
   packageDirectory <- path.expand(packageDirectory)
   
   ## Validate the package name -- note that we validate this upstream
   ## but it is sensible to validate it once more here
   if (!grepl("^[[:alpha:]][[:alnum:].]*", packageName))
      return(.rs.error(
         "Invalid package name: the package name must start ",
         "with a letter and follow with only alphanumeric characters"))
   
   ## Validate the package directory -- if it exists, make sure it's empty,
   ## otherwise, try to create it
   if (file.exists(packageDirectory))
   {
      containedFiles <- list.files(packageDirectory) ## what about hidden files?
      if (length(containedFiles))
      {
         return(.rs.error(
            "Folder '", packageDirectory, "' ",
            "already exists and is not empty"))
      }
   }
   
   # Otherwise, create it
   else
   {
      if (!dir.create(packageDirectory, recursive = TRUE))
         return(.rs.error(
            "Failed to create directory '", packageDirectory, "'"))
   }
   
   ## Create a DESCRIPTION file
   
   # Fill some bits based on devtools options if they're available.
   # Protect against vectors with length > 1
   getDevtoolsOption <- function(optionName, default, collapse = " ")
   {
      devtoolsDesc <- getOption("devtools.desc")
      if (!length(devtoolsDesc))
         return(default)
      
      option <- devtoolsDesc[[optionName]]
      if (is.null(option))
         return(default)
      
      paste(option, collapse = collapse)
   }
   
   
   Author <- getDevtoolsOption("Author", "Who wrote it")
   
   Maintainer <- getDevtoolsOption(
      "Maintainer",
      "The package maintainer <yourself@somewhere.net>"
   )
   
   License <- getDevtoolsOption(
      "License",
      "What license is it under?",
      ", "
   )
   
   DESCRIPTION <- list(
      Package = packageName,
      Type = "Package",
      Title = "What the Package Does (Title Case)",
      Version = "0.1.0",
      Author = Author,
      Maintainer = Maintainer,
      Description = c(
         "More about what it does (maybe more than one line)",
         "Use four spaces when indenting paragraphs within the Description."
      ),
      License = License,
      Encoding = "UTF-8",
      LazyData = "true"
   )
   
   # Create a NAMESPACE file
   NAMESPACE <- c(
      'exportPattern("^[[:alpha:]]+")'
   )
   
   # If we are using Rcpp, update DESCRIPTION and NAMESPACE
   if (usingRcpp)
   {
      dir.create(file.path(packageDirectory, "src"), showWarnings = FALSE)
      
      rcppImportsStatement <- "Rcpp"
      
      # We'll enforce Rcpp > (installed version)
      ip <- installed.packages()
      if ("Rcpp" %in% rownames(ip))
         rcppImportsStatement <- sprintf("Rcpp (>= %s)", ip["Rcpp", "Version"])
      
      DESCRIPTION$Imports <- c(DESCRIPTION$Imports, rcppImportsStatement)
      DESCRIPTION$LinkingTo <- c(DESCRIPTION$LinkingTo, "Rcpp")
      
      # Add .registration = TRUE for Rcpp >= 0.12.11
      if (.rs.isPackageVersionInstalled("Rcpp", "0.12.11"))
         registration <- ", .registration = TRUE"
      else
         registration <- ""
      
      # Add an import from Rcpp, and also useDynLib
      NAMESPACE <- c(
         NAMESPACE,
         "importFrom(Rcpp, evalCpp)",
         sprintf("useDynLib(%s%s)", packageName, registration)
      )
   }
   
   # Get other fields from devtools options
   if (length(getOption("devtools.desc.suggests")))
      DESCRIPTION$Suggests <- getOption("devtools.desc.suggests")
   
   if (length(getOption("devtools.desc")))
   {
      devtools.desc <- getOption("devtools.desc")
      for (i in seq_along(devtools.desc))
      {
         name <- names(devtools.desc)[[i]]
         value <- devtools.desc[[i]]
         DESCRIPTION[[name]] <- value
      }
   }
   
   # If we are using 'testthat' and 'devtools' is available, use it to
   # add test infrastructure
   if ("testthat" %in% DESCRIPTION$Suggests)
   {
      dir.create(file.path(packageDirectory, "tests"))
      dir.create(file.path(packageDirectory, "tests", "testthat"))
      
      if ("devtools" %in% rownames(installed.packages()))
      {
         # NOTE: Okay to load devtools as we will restart the R session
         # soon anyhow
         ns <- asNamespace("devtools")
         if (exists("render_template", envir = ns))
         {
            tryCatch(
               writeLines(
                  devtools:::render_template(
                     "testthat.R",
                     list(name = packageName)
                  ),
                  file.path(packageDirectory, "tests", "testthat.R")
               ), error = function(e) NULL
            )
         }
      }
   }
   
   # If we are using the MIT license, add the template
   if (grepl("MIT\\s+\\+\\s+file\\s+LICEN[SC]E", DESCRIPTION$License, perl = TRUE))
   {
      # Guess the copyright holder
      holder <- if (!is.null(getOption("devtools.name")))
         Author
      else
         "<Copyright holder>"
      
      msg <- c(
         paste("YEAR:", format(Sys.time(), "%Y")),
         paste("COPYRIGHT HOLDER:", holder)
      )
      
      cat(msg,
          file = file.path(packageDirectory, "LICENSE"),
          sep = "\n")
   }
   
   # Always create 'R/', 'man/' directories
   dir.create(file.path(packageDirectory, "R"), showWarnings = FALSE)
   dir.create(file.path(packageDirectory, "man"))
   
   # If there were no source files specified, create a simple 'hello world'
   # function -- but only if the user hasn't implicitly opted into the 'devtools'
   # ecosystem
   if ((!length(getOption("devtools.desc"))) &&
       (!length(sourceFiles)))
   {
      
      # Some simple shortcuts that authors should know
      sysname <- Sys.info()[["sysname"]]
      
      buildShortcut <- if (sysname == "Darwin")
         "Cmd + Shift + B"
      else
         "Ctrl + Shift + B"
      
      checkShortcut <- if (sysname == "Darwin")
         "Cmd + Shift + E"
      else
         "Ctrl + Shift + E"
      
      testShortcut <- if (sysname == "Darwin")
         "Cmd + Shift + T"
      else
         "Ctrl + Shift + T"
      
      helloWorld <- .rs.trimCommonIndent('
         # Hello, world!
         #
         # This is an example function named \'hello\' 
         # which prints \'Hello, world!\'.
         #
         # You can learn more about package authoring with RStudio at:
         #
         #   http://r-pkgs.had.co.nz/
         #
         # Some useful keyboard shortcuts for package authoring:
         #
         #   Install Package:           \'%s\'
         #   Check Package:             \'%s\'
         #   Test Package:              \'%s\'
         
         hello <- function() {
           print(\"Hello, world!\")
         }
      ', buildShortcut, checkShortcut, testShortcut)
      
      cat(helloWorld,
          file = file.path(packageDirectory, "R", "hello.R"),
          sep = "\n")
      
      # Similarly, create a simple example .Rd for this 'hello world' function
      helloWorldRd <- .rs.trimCommonIndent('
         \\name{hello}
         \\alias{hello}
         \\title{Hello, World!}
         \\usage{
         hello()
         }
         \\description{
         Prints \'Hello, world!\'.
         }
         \\examples{
         hello()
         }
      ')
      
      cat(helloWorldRd,
          file = file.path(packageDirectory, "man", "hello.Rd"),
          sep = "\n")
      
      if (usingRcpp)
      {
         ## Ensure 'src/' directory exists
         if (!file.exists(file.path(packageDirectory, "src")))
            dir.create(file.path(packageDirectory, "src"))
         
         ## Write a 'hello world' for C++
         helloWorldCpp <- .rs.trimCommonIndent('
            #include <Rcpp.h>
            using namespace Rcpp;
            
            // This is a simple function using Rcpp that creates an R list
            // containing a character vector and a numeric vector.
            //
            // Learn more about how to use Rcpp at:
            //
            //   http://www.rcpp.org/
            //   http://adv-r.had.co.nz/Rcpp.html
            //
            // and browse examples of code using Rcpp at:
            // 
            //   http://gallery.rcpp.org/
            //

            // [[Rcpp::export]]
            List rcpp_hello() {
              CharacterVector x = CharacterVector::create("foo", "bar");
              NumericVector y   = NumericVector::create(0.0, 1.0);
              List z            = List::create(x, y);
              return z;
            }

         ')

         helloWorldDoc <- .rs.trimCommonIndent('
            \\name{rcpp_hello}
            \\alias{rcpp_hello}
            \\title{Hello, Rcpp!}
            \\usage{
            rcpp_hello()
            }
            \\description{
            Returns an \\R \\code{list} containing the character vector
            \\code{c("foo", "bar")} and the numeric vector \\code{c(0, 1)}.
            }
            \\examples{
            rcpp_hello()
            }
         ')
         
         cat(helloWorldCpp,
             file = file.path(packageDirectory, "src", "rcpp_hello.cpp"),
             sep = "\n")

         cat(helloWorldDoc,
             file = file.path(packageDirectory, "man", "rcpp_hello.Rd"),
             sep = "\n")
         
      }
   }
   else if (length(sourceFiles))
   {
      # Copy the source files to the appropriate sub-directory
      sourceFileExtensions <- tolower(gsub(".*\\.", "", sourceFiles, perl = TRUE))
      sourceDirs <- .rs.swap(
         sourceFileExtensions,
         "R" = c("r", "q", "s"),
         "src" = c("c", "cc", "cpp", "h", "hpp"),
         "vignettes" = c("rmd", "rnw"),
         "man" = "rd",
         "data" = c("rda", "rdata"),
         default = ""
      )
      
      copyPaths <- gsub("/+", "/", file.path(
         packageDirectory,
         sourceDirs,
         basename(sourceFiles)
      ))
      
      dirPaths <- dirname(copyPaths)
      
      success <- unlist(lapply(dirPaths, function(path) {
         
         if (isTRUE(file.info(path)$isdir))
            return(TRUE)
         
         dir.create(path, recursive = TRUE, showWarnings = FALSE)
         
      }))
      
      if (!all(success))
         return(.rs.error("Failed to create package directory structure"))
      
      success <- file.copy(sourceFiles, copyPaths)
      
      if (!all(success))
         return(.rs.error("Failed to copy one or more source files"))
   }
   
   # Write various files out
   
   # NOTE: write.dcf mangles whitespace so we manually construct
   # the text we wish to write out
   DESCRIPTION <- lapply(DESCRIPTION, function(field) {
      paste(field, collapse = "\n    ")
   })
   
   names <- names(DESCRIPTION)
   values <- unlist(DESCRIPTION)
   text <- paste(names, ": ", values, sep = "", collapse = "\n")
   cat(text, file = file.path(packageDirectory, "DESCRIPTION"), sep = "\n")
   
   cat(NAMESPACE, file = file.path(packageDirectory, "NAMESPACE"), sep = "\n")
   
   RprojPath <- file.path(
      packageDirectory,
      paste(packageName, ".Rproj", sep = "")
   )
   
   if (!.Call("rs_writeProjectFile", RprojPath, PACKAGE = "(embedding)"))
      return(.rs.error("Failed to create package .Rproj file"))
   
   # Ensure new packages get AutoAppendNewLine + StripTrailingWhitespace
   Rproj <- readLines(RprojPath)
   
   appendNewLineIndex <- grep("AutoAppendNewline:", Rproj, fixed = TRUE)
   if (length(appendNewLineIndex))
      Rproj[appendNewLineIndex] <- "AutoAppendNewline: Yes"
   else
      Rproj <- c(Rproj, "AutoAppendNewline: Yes")
   
   stripTrailingWhitespace <- grep("StripTrailingWhitespace:", Rproj, fixed = TRUE)
   if (length(stripTrailingWhitespace))
      Rproj[stripTrailingWhitespace] <- "StripTrailingWhitespace: Yes"
   else
      Rproj <- c(Rproj, "StripTrailingWhitespace: Yes")
   
   cat(Rproj, file = RprojPath, sep = "\n")
   
   # compute scratch paths
   scratchPaths <- .Call("rs_computeScratchPaths", RprojPath, PACKAGE = "(embedding)")
   scratchPath <- scratchPaths$scratch_path
   
   # NOTE: this file is not always generated (e.g. people who have implicitly opted
   # into using devtools won't need the template file)
   if (!is.null(scratchPath) &&
       file.exists(file.path(packageDirectory, "R", "hello.R")))
   {
      .Call("rs_addFirstRunDoc", scratchPath, "R/hello.R", PACKAGE = "(embedding)")
   }

   ## NOTE: This must come last to ensure the other package
   ## infrastructure bits have been generated; otherwise
   ## compileAttributes can fail
   if (usingRcpp &&
       .rs.isPackageVersionInstalled("Rcpp", "0.10.1") &&
       require(Rcpp, quietly = TRUE))
   {
      Rcpp::compileAttributes(packageDirectory)
      if (!is.null(scratchPath) &&
          file.exists(file.path(packageDirectory, "src/rcpp_hello.cpp")))
      {
         .Call("rs_addFirstRunDoc", scratchPath, "src/rcpp_hello.cpp", PACKAGE = "(embedding)")
      }
   }
   
   .rs.success()
   
})


.rs.addFunction("secureDownloadMethod", function()
{
   # Function to determine whether R checks for 404 in libcurl calls
   libcurlHandles404 <- function() {
      getRversion() >= "3.3" && .rs.haveRequiredRSvnRev(69197)
   }

   # Check whether we are running R 3.2+, R 4.2+, and whether we have libcurl
   isR32 <- getRversion() >= "3.2"
   isR42 <- getRversion() >= "4.2"
   haveLibcurl <- isR32 && capabilities("libcurl") && libcurlHandles404()
   
   # Utility function to bind to libcurl or a fallback utility (e.g. wget)
   posixMethod <- function(utility) {
      if (haveLibcurl)
         "libcurl"
      else if (nzchar(Sys.which(utility)))
         utility
      else
         ""
   }
   
   # Determine the right secure download method per-system
   sysName <- Sys.info()[['sysname']]
   
   # For windows, with R versions >= 3.2 to <= 4.1, we prefer binding directly to wininet
   # if we can (since that doesn't rely on the value of setInternet2).
   # In R 4.2+ wininet is deprecated, so we use libcurl instead when available.
   # If it's R <= 3.1 then we can use "internal" for https so long as internet2 is enabled
   if (identical(sysName, "Windows")) {
      if (isR42 && haveLibcurl)
         "libcurl"
      else if (isR32)
         "wininet"
      else if (isTRUE(.rs.setInternet2(NA)))
         "internal"
      else
         ""
   }
   
   # For Darwin and Linux we use libcurl if we can and then fall back
   # to curl or wget as appropriate. We prefer libcurl because it honors
   # the same proxy configuration that "internal" does so it less likely
   # to break downloads for users behind proxy servers. 
   
   else if (identical(sysName, "Darwin")) {
      posixMethod("curl")
   }
   
   else if (identical(sysName, "Linux")) {
      method <- posixMethod("wget")
      if (!nzchar(method))
         method <- posixMethod("curl")
      method
   } 
   
   # Another OS, don't even attempt detection since RStudio currently
   # only runs on Windows, Linux, and Mac
   else {
      ""
   }
})

.rs.addFunction("autoDownloadMethod", function() {
   if (capabilities("http/ftp"))
      "internal"
   else if (nzchar(Sys.which("wget")))
      "wget"
   else if (nzchar(Sys.which("curl")))
      "curl"
   else
      ""
})

.rs.addFunction("isDownloadMethodSecure", function(method) {
   
   # resolve auto if needed
   if (identical(method, "auto"))
      method <- .rs.autoDownloadMethod()
   
   # check for methods known to work securely
   if (method %in% c("wininet", "libcurl", "wget", "curl")) {
      TRUE
   }
   
   # if internal then see if were using windows internal with inet2
   else if (identical(method, "internal")) {
      identical(Sys.info()[['sysname']], "Windows") && isTRUE(.rs.setInternet2(NA))
   }
   
   # method with unknown properties (e.g. "lynx") or unresolved auto
   else {
      FALSE
   }
})

.rs.addFunction("haveSecureDownloadFileMethod", function() {
   .rs.isDownloadMethodSecure(getOption("download.file.method", "auto"))
})

.rs.addFunction("showSecureDownloadWarning", function() {
   is.na(Sys.getenv("RSTUDIO_DISABLE_SECURE_DOWNLOAD_WARNING", unset = NA))
})

.rs.addFunction("insecureReposWarning", function(msg) {
   if (.rs.showSecureDownloadWarning()) {
      message("WARNING: ", msg, " You should either switch to a repository ",
              "that supports HTTPS or change your RStudio options to not require HTTPS ",
              "downloads.\n\nTo learn more and/or disable this warning ",
              "message see the \"Use secure download method for HTTP\" option ",
              "in Tools -> Global Options -> Packages.")
   }
})

.rs.addFunction("insecureDownloadWarning", function(msg) {
   if (.rs.showSecureDownloadWarning()) {
      message("WARNING: ", msg,
              "\n\nTo learn more and/or disable this warning ",
              "message see the \"Use secure download method for HTTP\" option ",
              "in Tools -> Global Options -> Packages.")
   }
})

.rs.addFunction("initSecureDownload", function() {
      
   # check if the user has already established a download.file.method and
   # if so verify that it is secure
   method <- getOption("download.file.method")
   if (!is.null(method)) {
      if (!.rs.isDownloadMethodSecure(method)) {
         .rs.insecureDownloadWarning(
             paste("The download.file.method option is \"", method, "\" ",
                   "however that method cannot provide secure (HTTPS) downloads ",
                   "on this platform. ", 
                   "This option was likely specified in .Rprofile or ",
                   "Rprofile.site so if you wish to change it you may need ",
                   "to edit one of those files.",
                   sep = "")
         )
      }
   } 
   
   # no user specified method, automatically set a secure one if we can
   else {
      secureMethod <- .rs.secureDownloadMethod()
      if (nzchar(secureMethod)) {
         options(download.file.method = secureMethod) 
         if (secureMethod == "curl")
            options(download.file.extra = .rs.downloadFileExtraWithCurlArgs())
      }
      else {
         .rs.insecureDownloadWarning(
            paste("Unable to set a secure (HTTPS) download.file.method (no",
                  "compatible method available in this installation of R).")
         )
      }
   }
})
   

.rs.addFunction("downloadFileExtraWithCurlArgs", function() {
   newArgs <- "-L -f -g"
   curArgs <- getOption("download.file.extra")
   if (!is.null(curArgs) && !grepl(newArgs, curArgs, fixed = TRUE))
      curArgs <- paste(newArgs, curArgs)
   curArgs
})

.rs.addFunction("setInternet2", function(value = NA) {
   
   # from R 3.3.x, 'setInternet2' is defunct and does nothing
   if (getRversion() >= "3.3.0")
      return(TRUE)
   
   # should only be called on Windows, but sanity check
   if (Sys.info()[["sysname"]] != "Windows")
      return(TRUE)
   
   # delegate to 'setInternet2'
   utils::setInternet2(value)
})

.rs.addFunction("availablePackages", function()
{
   # short-circuit for empty repositories case
   repos <- getOption("repos")
   if (length(repos) == 0) {
      value <- available.packages()
      attr(value, "time") <- Sys.time()
      return(list(state = "CACHED", value = value))
   }
   
   # figure out the current state. possibilities:
   #
   # - STALE:    we need to request available packages
   # - PENDING:  another process is requesting packages
   # - CACHED:   available packages ready in cache
   #
   reposString <- paste(deparse(repos), collapse = " ")
   state <- .rs.availablePackagesState(reposString)
   value <- switch(
      state,
      STALE   = .rs.onAvailablePackagesStale(reposString),
      PENDING = .rs.onAvailablePackagesPending(reposString),
      CACHED  = .rs.onAvailablePackagesCached(reposString),
      NULL
   )
   
   list(state = state, value = value)
})

.rs.addFunction("availablePackagesState", function(reposString)
{
   # do we have a cache entry?
   entry <- .rs.availablePackagesEnv[[reposString]]
   if (!is.null(entry)) {
      
      # verify the cache entry is not stale
      time <- attr(entry, "time", exact = TRUE)
      elapsed <- difftime(Sys.time(), time, units = "secs")
      limit <- as.numeric(Sys.getenv("R_AVAILABLE_PACKAGES_CACHE_CONTROL_MAX_AGE", 3600))
      
      if (elapsed > limit)
         return("STALE")
      else
         return("CACHED")
   }
   
   # do we have a pending dir? if none, we're stale
   dir <- .rs.availablePackagesPendingEnv[[reposString]]
   if (is.null(dir))
      return("STALE")
   
   # is the directory old? if so, assume the prior R process launched
   # to produce available.packages crashed or similar
   info <- file.info(dir)
   time <- info$mtime
   
   # in some cases, mtime may not be available -- in that case, fall
   # back to the time that was serialized when the process was launched
   #
   # https://github.com/rstudio/rstudio/issues/4312
   #
   # if all-else fails, just use the current time. this effectively means
   # that we will never mark the directory as 'stale', which means that
   # the dependency discovery feature may not work -- but at this point
   # there's not much else we can do
   if (is.na(time)) {
      time <- .rs.tryCatch(readRDS(file.path(dir, "time.rds")))
      if (inherits(time, "error"))
         time <- Sys.time()
   }
   
   # check to see if the directory is 'stale'
   diff <- difftime(Sys.time(), time, units = "secs")
   if (diff > 120)
      return("STALE")
   
   # we have a directory, and it's not too old -- we're waiting
   # for a new process to finish
   return("PENDING")
})

.rs.addFunction("onAvailablePackagesStale", function(reposString)
{
   # evict a stale cache entry (if any)
   .rs.availablePackagesEnv[[reposString]] <- NULL
   
   # defend against '@CRAN@' within the repositories, as this will
   # cause R to present the user with an interactive prompt when
   # invoking 'contrib.url()'
   repos <- getOption("repos")
   repos <- repos[repos != "@CRAN@"]
   
   # check and see if R has already queried available packages;
   # if so we can ask R for available packages as it will use
   # the cache
   paths <- vapply(repos, function(url) {
      sprintf("%s/repos_%s.rds", 
              tempdir(), 
              URLencode(contrib.url(url), TRUE)
   )
   }, FUN.VALUE = character(1))
   
   if (all(file.exists(paths))) {
      
      # request available packages
      packages <- if (getRversion() >= "3.5")
         available.packages(max_repo_cache_age = Inf)
      else
         available.packages()
      
      # note accessed time
      attr(packages, "time") <- Sys.time()
      
      # add it to the cache
      .rs.availablePackagesEnv[[reposString]] <- packages
      
      # we're done!
      packages
      
   }
   
   # prepare directory for discovery of available packages
   dir <- tempfile("rstudio-available-packages-")
   dir.create(dir, showWarnings = FALSE)
   .rs.availablePackagesPendingEnv[[reposString]] <- dir
   
   # mtime may be unreliable (or access could fail in some cases) so
   # instead serialize the current time to a file rather than relying on OS
   saveRDS(Sys.time(), file = file.path(dir, "time.rds"))
   
   # move there
   owd <- setwd(dir)
   on.exit(setwd(owd), add = TRUE)
   
   # define our helper script that will download + save available.packages
   template <- .rs.trimCommonIndent('
      options(repos = %s, pkgType = %s)
      packages <- available.packages()
      attr(packages, "time") <- Sys.time()
      saveRDS(packages, file = "packages.rds")
   ')
   
   script <- sprintf(
      template,
      .rs.deparse(getOption("repos")),
      .rs.deparse(getOption("pkgType"))
   )
   
   # fire off the process
   .rs.runAsyncRProcess(
      script,
      onCompleted = function(exitStatus) {
         
         # bail on error (don't log since this might occur
         # for reasons not actionable by the user; e.g. restarting
         # the R session while a lookup is happening)
         if (exitStatus)
            return()
         
         available <- .rs.onAvailablePackagesReady(reposString)
         data <- list(
            ready = .rs.scalar(TRUE),
            packages = rownames(available)
         )
         .rs.enqueClientEvent("available_packages_ready", data)
      }
   )
   
   # NULL indicates we don't have available packages yet
   return(NULL)
   
})

.rs.addFunction("onAvailablePackagesPending", function(reposString)
{
   # nothing to do here
   invisible(NULL)
})

.rs.addFunction("onAvailablePackagesReady", function(reposString)
{
   # get the directory and read packages.rds
   dir <- .rs.availablePackagesPendingEnv[[reposString]]
   rds <- file.path(dir, "packages.rds")
   
   # attempt to read the database and add it to the cache
   packages <- .rs.tryCatch(readRDS(rds))
   if (!inherits(packages, "error"))
      .rs.availablePackagesEnv[[reposString]] <- packages
   
   # remove state directory and mark as no longer pending
   unlink(dir, recursive = TRUE)
   .rs.availablePackagesPendingEnv[[reposString]] <- NULL
   
   # we're done!
   packages
})

.rs.addFunction("onAvailablePackagesCached", function(reposString)
{
   .rs.availablePackagesEnv[[reposString]]
})

.rs.addFunction("parseSecondaryReposIni", function(conf) {
   entries <- .rs.readIniFile(conf)
   repos <- list()

   for (entryName in names(entries)) {
     repo <- list(
        name  = .rs.scalar(trimws(entryName)),
        url = .rs.scalar(trimws(entries[[entryName]])),
        host = .rs.scalar("Custom"),
        country = .rs.scalar("")
     )

     if (identical(tolower(as.character(repo$name)), "cran")) {
        repo$name <- .rs.scalar("CRAN")
        repos <- append(list(repo), repos, 1)
     } else {
        repos[[length(repos) + 1]] <- repo
     }
   }

   repos
})

.rs.addFunction("parseSecondaryReposJson", function(conf) {
   lines <- readLines(conf)
   repos <- list()

   entries <- .rs.fromJSON(paste(lines, collpse = "\n"))

   for (entry in entries) {
      url <- if (is.null(entry$url)) "" else url

      repo <- list(
         name  = .rs.scalar(entry$name),
         url = .rs.scalar(url),
         host = .rs.scalar("Custom"),
         country = .rs.scalar("")
      )

      if (identical(tolower(as.character(repo$name)), "cran")) {
         repo$name <- .rs.scalar("CRAN")
         repos <- append(list(repo), repos, 1)
      } else {
         repos[[length(repos) + 1]] <- repo
      }
   }

   repos
})

.rs.addFunction("getSecondaryRepos", function(cran = getOption("repos")[[1]], custom = TRUE) {
   result <- list(
      repos = list()
   )
   
   rCranReposUrl <- .Call("rs_getCranReposUrl", PACKAGE = "(embedding)")
   isDefault <- identical(rCranReposUrl, NULL) || nchar(rCranReposUrl) == 0

   if (isDefault) {
      slash <- if (.rs.lastCharacterIs(cran, "/")) "" else "/"
      rCranReposUrl <- paste(slash, "../../__api__/repos", sep = "")
   }
   else {
      custom <- TRUE
   }

   if (.rs.startsWith(rCranReposUrl, "..") ||
       .rs.startsWith(rCranReposUrl, "/..")) {
      rCranReposUrl <- .rs.completeUrl(cran, rCranReposUrl)
   }

   if (custom) {
      conf <- tempfile(fileext = ".conf")
      
      result <- tryCatch({
         download.file(
            rCranReposUrl,
            conf,
            method = "curl",
            extra = "-H 'Accept: text/ini'",
            quiet = TRUE
         )
         
         result$repos <- .rs.parseSecondaryReposIni(conf)
         if (length(result$repos) == 0) {
            result$repos <- .rs.parseSecondaryReposJson(conf)
         }

         result
      }, error = function(e) {
         list(
            error = .rs.scalar(
               paste(
                  "Failed to process repos list from ",
                  rCranReposUrl, ". ", e$message, ".", sep = ""
               )
            )
         )
      })
   }

   result
})

.rs.addJsonRpcHandler("get_secondary_repos", function(cran, custom) {
   .rs.getSecondaryRepos(cran, custom)
})

.rs.addFunction("appendSlashIfNeeded", function(url) {
   slash <- if (.rs.lastCharacterIs(url, "/")) "" else "/"
   paste(url, slash, sep = "")
})

.rs.addJsonRpcHandler("validate_cran_repo", function(url) {
   packagesFile <- tempfile(fileext = ".gz")
   
   tryCatch({
      download.file(
         .rs.completeUrl(.rs.appendSlashIfNeeded(url), "src/contrib/PACKAGES.gz"),
         packagesFile,
         quiet = TRUE
      )

      .rs.scalar(TRUE)
   }, error = function(e) {
      .rs.scalar(FALSE)
   })
})

.rs.addJsonRpcHandler("is_package_installed", function(package, version)
{
   installed <- if (is.null(version))
      .rs.isPackageInstalled(package)
   else
      .rs.isPackageVersionInstalled(package, version)
   .rs.scalar(installed)
})

#
# https://github.com/rstudio/rstudio/issues/14306
#

# trace(.rs.simulateSourceRefs, quote(str(var)), print = FALSE)
fn <- NULL
eval(parse(text = "
fn <- function() {
  identity({
    1 + 1
    2 + 2
    3 + 3
  })
}
", keep.source = FALSE))

debugonce(fn)
fn()


# Compare with source references
fn <- function() {
  identity({
    1 + 1
    2 + 2
    3 + 3
    4 + 4
  })
}

debugonce(fn)
fn()

#
# This is a Shiny web application. You can run the application by clicking
# the 'Run App' button above.
#
# Find out more about building applications with Shiny here:
#
#    http://shiny.rstudio.com/
#

library(shiny)

# Define UI for application that draws a histogram
ui <- fluidPage(

    # Application title
    titlePanel("Old Faithful Geyser Data"),

    # Sidebar with a slider input for number of bins 
    sidebarLayout(
        sidebarPanel(
            sliderInput("bins",
                        "Number of bins:",
                        min = 1,
                        max = 50,
                        value = 30)
        ),

        # Show a plot of the generated distribution
        mainPanel(
           plotOutput("distPlot")
        )
    )
)

# Define server logic required to draw a histogram
server <- function(input, output) {

    output$distPlot <- renderPlot({
        # generate bins based on input$bins from ui.R
        x    <- faithful[, 2]
        bins <- seq(min(x), max(x), length.out = input$bins + 1)

        # draw the histogram with the specified number of bins
        hist(x, breaks = bins, col = 'darkgray', border = 'white',
             xlab = 'Waiting time to next eruption (in mins)',
             main = 'Histogram of waiting times')
    })
}

# Run the application 
shinyApp(ui = ui, server = server)

#
# NotebookPlots.R
#
# Copyright (C) 2009-16 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# creates the notebook graphics device 
.rs.addFunction("createNotebookGraphicsDevice", function(filename,
  height, width, units, pixelRatio, extraArgs)
{
  # form the arguments to the graphics device creator
  require(grDevices, quietly = TRUE)
  args <- list(
    filename = filename,
    width    = width * pixelRatio,
    height   = height * pixelRatio, 
    units    = units,
    res      = 96 * pixelRatio)
  
  if (nchar(extraArgs) > 0)
  {
    # trim leading comma from extra args if present
    if (identical(substr(extraArgs, 1, 1), ","))
      extraArgs <- substring(extraArgs, 2)

    # parse extra args and merge with existing args
    extraList <- NULL
    tryCatch({
      extraList <- eval(parse(text = paste("list(", extraArgs, ")")))
    }, error = function(e) {
      # failure to parse implies we won't merge below
    })

    if (is.list(extraList))
      args <- c(args, extraList)
  }

  # create the device
  do.call(what = png, args = args)
})

.rs.addFunction("setNotebookGraphicsOption", function(filename,
  height, width, units, pixelRatio, extraArgs)
{
  options(device = function() {
    .rs.createNotebookGraphicsDevice(filename, height, width, units, 
                                     pixelRatio, extraArgs)
    dev.control(displaylist = "enable")
    .rs.setNotebookMargins()
  })
})

.rs.addFunction("saveNotebookGraphics", function(plot, filename)
{
   save(plot, file = filename)
})

.rs.addFunction("setNotebookMargins", function() {
  #           bot  left top  right
  par(mar = c(5.1, 4.1, 2.1, 2.1))
})

.rs.addFunction("replayNotebookPlots", function(width, height, pixelRatio, tempFile, extraArgs) {
  # open stdin (for consuming snapshots from parent process)
  stdin <- file("stdin")

  require(grDevices, quietly = TRUE)

  snapshots <- readLines(stdin, warn = FALSE)
  lapply(snapshots, function(snapshot) {

    # ignore empty lines
    if (nchar(tools::file_ext(snapshot)) < 1)
      return(invisible(NULL))

    # create the PNG device on which we'll regenerate the plot -- it's somewhat
    # wasteful to use a separate device per plot, but the alternative is
    # doing a lot of state management and post-processing of the files
    # output from the device
    output <- paste(tools::file_path_sans_ext(snapshot), "resized.png",
                    sep = ".")

    height <- if (height <= 0) width / 1.618 else height

    .rs.createNotebookGraphicsDevice(output, height, width, 
                                     "px", pixelRatio, extraArgs)

    # actually replay the plot onto the device
    tryCatch({
      .rs.restoreGraphics(snapshot)
    }, error = function(e) {
      # nothing reasonable we can do here; we'll just omit this file from the
      # output
    })

    # close the device; has the side effect of committing the plot to disk
    dev.off()

    # if the plot file was written out, emit to standard out for the caller to 
    # consume
    if (file.exists(output)) {
      if (tempFile)
      {
        chunksPath <- dirname(snapshot)
        chunksTempPath <- file.path(chunksPath, "temp")

        if (!dir.exists(chunksTempPath))
          dir.create(chunksTempPath)

        chunkBaseName <- basename(tools::file_path_sans_ext(snapshot))

        final <- file.path(
          chunksTempPath,
          paste(chunkBaseName, "png", sep = ".")
        )
      }
      else
      {
        final <- paste(tools::file_path_sans_ext(snapshot), "png", sep = ".")
      }

      # remove the old copy of the plot if it existed
      if (file.exists(final))
        unlink(final)

      file.copy(output, final)

      if (file.exists(output))
        unlink(output)

      if (file.exists(final)) {
        cat(final, "\n")
      }
    }
  })

  invisible(NULL)
})

#
# SessionProfiler.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setOptionDefault("profvis.print", function(x)
{
   .rs.profilePrint(x)
})

.rs.setOptionDefault("profvis.prof_extension", ".Rprof")

.rs.addFunction("profilesPath", function()
{
   .Call("rs_profilesPath", PACKAGE = "(embedding)")
})

.rs.addFunction("profileResources", function()
{
   tempPath <- getOption(
      "profvis.prof_output",
      default = .rs.profilesPath()
   )

   # NOTE: this code runs on IDE startup, and so errors can cause
   # session initialization to fail. for that reason, we catch and
   # log errors as warnings just so we avoid taking down the session
   #
   # https://github.com/rstudio/rstudio/issues/8256
   tryCatch(
      dir.create(tempPath, recursive = TRUE, showWarnings = FALSE),
      error = warning
   )

   list(tempPath = tempPath)
})

.rs.addJsonRpcHandler("start_profiling", function(profilerOptions)
{
   tryCatch({
      resources <- .rs.profileResources()
      fileName <- tempfile(fileext = ".Rprof", tmpdir = resources$tempPath)

      Rprof(filename = fileName, line.profiling = TRUE, memory.profiling = TRUE)

      list(fileName = .rs.scalar(fileName))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

.rs.addJsonRpcHandler("stop_profiling", function(profilerOptions)
{
   tryCatch({
      Rprof(NULL)

      if (!identical(profilerOptions$fileName, NULL))
      {
         .rs.enqueClientEvent("rprof_created", list(
            path = .rs.scalar(profilerOptions$fileName)
         ));
      }

      return(list(
         fileName = .rs.scalar(profilerOptions$fileName)
      ))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

.rs.addJsonRpcHandler("open_profile", function(profilerOptions)
{
   tryCatch({
      resources <- .rs.profileResources()
      htmlFile <- normalizePath(tempfile(fileext = ".html", tmpdir = resources$tempPath), winslash = "/", mustWork = FALSE)

      if (identical(profilerOptions$profvis, NULL))
      {
         if (identical(tools::file_ext(profilerOptions$fileName), "Rprof"))
         {
            profvis <- profvis::profvis(prof_input = profilerOptions$fileName, split = "h")
            htmlwidgets::saveWidget(profvis, htmlFile, selfcontained = TRUE)
         }
         else
         {
            .rs.rpc.copy_profile(profilerOptions$fileName, htmlFile)
         }
      }
      else
      {
         profvis <- profilerOptions$profvis
         htmlwidgets::saveWidget(profvis, htmlFile, selfcontained = TRUE)
      }

      return(list(
         htmlPath = .rs.scalar(paste("profiles/", basename(htmlFile), sep = "")),
         htmlLocalPath = .rs.scalar(htmlFile)
      ))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

.rs.addJsonRpcHandler("copy_profile", function(fromPath, toPath)
{
   tryCatch({
      file.copy(fromPath, toPath, overwrite = TRUE)

      return(list(
      ))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

.rs.registerNotifyHook("Rprof", "utils", function(...) 
{
   args <- c(...)
   if (!identical(args, NULL))
   {
      .rs.enqueClientEvent("rprof_started");
   }
   else
   {
      .rs.enqueClientEvent("rprof_stopped");
   }
}, namespace = TRUE)

.rs.addFunction("profilePrint", function(x)
{
   result <- .rs.rpc.open_profile(list(
      profvis = x
   ))

   .rs.enqueClientEvent("rprof_created", result);
})

.rs.addJsonRpcHandler("clear_profile", function(filePath, htmlPath)
{
   tryCatch({
      resources <- .rs.profileResources()

      pathPrefix <- tools::file_path_sans_ext(basename(filePath))
      filePrefix <- tools::file_path_sans_ext(basename(htmlPath))
      
      rprofFile <- file.path(resources$tempPath, paste(pathPrefix, ".Rprof", sep = ""))
      if (file.exists(rprofFile)) {
         file.remove(rprofFile)
      }

      profileHtml <- file.path(resources$tempPath, paste(filePrefix, ".html", sep = ""))
      if (file.exists(profileHtml)) {
         file.remove(profileHtml)
      }

      profileDir <- file.path(resources$tempPath, paste(filePrefix, "_files", sep = ""))
      if (file.exists(profileDir)) {
         unlink(profileDir, recursive = TRUE)
      }

      rsconnectDir <- file.path(resources$tempPath, "rsconnect", "documents", paste(filePrefix, ".html", sep = ""))
      if (.rs.dirExists(rsconnectDir)) {
         unlink(rsconnectDir, recursive = TRUE)
      }

      return(list(
      ))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

.rs.addJsonRpcHandler("profile_sources", function(filePath, normPath)
{
   tryCatch({
      validPath <- ""
      paths <- c(filePath, normPath)
      found <- file.exists(paths)
      
      if (any(found == TRUE)) {
         validPath <- paths[[which(found == TRUE)[[1]]]]
      }

      return(.rs.scalar(validPath))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

#
# SessionBuild.R
#
# Copyright (C) 2009-12 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

setHook("sourceCpp.onBuild", function(file, fromCode, showOutput) {
   .Call("rs_sourceCppOnBuild", file, fromCode, showOutput)
})

setHook("sourceCpp.onBuildComplete", function(succeeded, output) {
   .Call("rs_sourceCppOnBuildComplete", succeeded, output)
})

.rs.addFunction("installBuildTools", function(action) {
   response <- .rs.userPrompt(
      "question",
      "Install Build Tools",
      paste(action, " requires installation of additional build tools.\n\n",
      "Do you want to install the additional tools now?", sep = ""))
   if (identical(response, "yes")) {
      .Call("rs_installBuildTools")
      return(TRUE)
   } else {
      return(FALSE)
   }
})

.rs.addFunction("checkBuildTools", function(action) {

   if (identical(.Platform$pkgType, "mac.binary.mavericks")) {
      # this will auto-prompt to install on mavericks
      .Call("rs_canBuildCpp")
   } else {
      if (!.Call("rs_canBuildCpp")) {
        .rs.installBuildTools(action)
        FALSE
      }
      else {
        TRUE;
      }
   }
})

.rs.addFunction("withBuildTools", function(code) {
    .rs.addRToolsToPath()
    on.exit(.rs.restorePreviousPath(), add = TRUE)
    force(code)
})

options(buildtools.check = .rs.checkBuildTools)
options(buildtools.with = .rs.withBuildTools)


.rs.addFunction("websiteOutputDir", function(siteDir) {
   siteGenerator <- rmarkdown::site_generator(siteDir)
   if (!is.null(siteGenerator))
      if (siteGenerator$output_dir != ".")
         file.path(siteDir, siteGenerator$output_dir)
      else
         siteDir
   else
      siteDir
})

.rs.addFunction("builtWithRtoolsGcc493", function() {
   identical(.Platform$OS.type, "windows") &&
   getRversion() >= "3.3" && 
   .rs.haveRequiredRSvnRev(70462)
})

.rs.addFunction("readShinytestResultRds", function(rdsPath) {
   failures <- Filter(function(e) !identical(e$pass, TRUE), readRDS(rdsPath)$results)
   sapply(failures, function(e) e$name)
})

.rs.addFunction("findShinyTestsDir", function(appDir) {
   if (exists("findTestsDir", where = asNamespace("shinytest"))) {
      # Newer versions of shinytest can report their own test directories.
      shinytest:::findTestsDir(appDir = appDir, mustExist = FALSE, quiet = TRUE)
   } else {
      # Older versions require us to know.
      file.path(appDir, "tests")
   }
})

#
# ServerOptions.R
#
# Copyright (C) 2009-11 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# set save defaults for high-performance (only if the administrator
# or user hasn't set them explicitly already)

if (is.null(getOption("save.defaults")))
   options(save.defaults=list(ascii=FALSE, compress=FALSE))

if (is.null(getOption("save.image.defaults")))
   options(save.image.defaults=list(ascii=FALSE, safe=TRUE, compress=FALSE))

# no support for email
options(mailer = "none")

# use internal unzip
options(unzip = "internal")

#
# SessionConnectionsInstaller.R
#
# Copyright (C) 2009-18 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("odbcBundleOsName", function() {
   osMapping <- list (
      linux = "linux",
      windows = "windows",
      darwin = "osx"
   )
   
   if (!tolower(Sys.info()["sysname"]) %in% names(osMapping))
      stop("Operating system \"", Sys.info()["sysname"], "\" is unsupported.")
   
   osMapping[[tolower(Sys.info()[["sysname"]])]]
})

.rs.addFunction("odbcOsBitness", function() {
   if (grepl("64", Sys.info()["machine"])) {
      "64"
   }
   else {
      "32"
   }
})

.rs.addFunction("odbcIsWow", function() {
   identical(tolower(Sys.info()["sysname"])[[1]], "windows") &&
      identical(.rs.odbcOsBitness(), "32") &&
      nchar(Sys.getenv("ProgramW6432")) > 0
})

.rs.addFunction("odbcBundleName", function(placeholder) {
   osName <- .rs.odbcBundleOsName()
   bitness <- .rs.odbcOsBitness()
   
   bundleName <- gsub("\\(os\\)", osName, placeholder)
   bundleName <- gsub("\\(bitness\\)", bitness, bundleName)
   
   bundleName
})

.rs.addFunction("odbcBundleDownload", function(url, placeholder, bundleTemp) {
   bundleName <- .rs.odbcBundleName(placeholder)
   bundleUrl <- file.path(url, bundleName)
   
   if (exists(bundleTemp)) unlink(bundleTemp, recursive = TRUE)
   dir.create(bundleTemp, recursive = TRUE)
   
   bundleFileTemp <- file.path(bundleTemp, bundleName)
   download.file(bundleUrl, bundleFileTemp)
   
   bundleFileTemp
})

.rs.addFunction("odbcBundleExtract", function(bundleFileTemp, installPath) {
   untar(bundleFileTemp, exdir = installPath)
})

.rs.addFunction("odbcBundleCheckPrereqsUnixodbc", function() {
   identical(
      suppressWarnings(
         system2(
            "odbcinst",
            stdout = getOption("odbc.installer.verbose", FALSE),
            stderr = getOption("odbc.installer.verbose", FALSE)
         )
      ),
      1L
   )
})

.rs.addFunction("odbcBundleCheckPrereqsBrew", function() {
   identical(
      suppressWarnings(
         system2(
            "brew",
            stdout = getOption("odbc.installer.verbose", FALSE),
            stderr = getOption("odbc.installer.verbose", FALSE)
         )
      ),
      1L
   )
})

.rs.addFunction("odbcBundleCheckPrereqsOsx", function() {
   if (!.rs.odbcBundleCheckPrereqsUnixodbc()) {
      if (!.rs.odbcBundleCheckPrereqsBrew()) {
         stop(
            "unixODBC is required but missing, you can install from http://www.unixodbc.org/. ",
            "Alternatively, install Brew and RStudio will install unixODBC automatically, ",
            "you can install Brew by running: ",
            "/usr/bin/ruby -e \"$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/install)\""
         )
      }
      
      message("Installing unixODBC...")
      system2(
         "brew",
         args = list("install", "unixodbc")
      )
   }
   
   if (!.rs.odbcBundleCheckPrereqsUnixodbc())
      stop("Failed to install unixODBC, please install from www.unixodbc.org")
})

.rs.addFunction("odbcBundleCheckPrereqsLinux", function() {
   if (!.rs.odbcBundleCheckPrereqsUnixodbc())
      stop("unixODBC is not installed, please install from www.unixodbc.org")
})

.rs.addFunction("odbcBundleRegistryAdd", function(entries) {
   validateEntry <- function(entry) {
      tryCatch({
         verify <- readRegistry(entry$path, "HLM", view = .rs.odbcOsBitness())
         identical(verify[[entry$key]], entry$value)
      }, error = function(e) {
         FALSE
      })
   }

   odbcFileEscape <- function(value) {
    gsub("\\\\", "\\\\\\\\", value)
   }

   if (all(sapply(entries, function(e) validateEntry(e))))
      return()

   bitness <- .rs.odbcOsBitness()

   allAdded <- TRUE
   for (entry in entries) {
     fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")
     system2(
        "REG",
        args = list(
           "ADD",
           shQuote(fullPath),
           "/v",
           shQuote(entry$key),
           "/t",
           "REG_SZ",
           "/d",
           shQuote(entry$value),
           "/f",
           paste("/reg:", bitness, sep = "")
        ),
        stdout = getOption("odbc.installer.verbose", FALSE),
        stderr = getOption("odbc.installer.verbose", FALSE)
     )

     if (!validateEntry(entry)) {
      allAdded <- FALSE
      break
     }
   }

   if (!allAdded) {
      if (.rs.odbcIsWow()) {
         stop("Failed to install x86 driver in x64 machine, retry running as administrator.")
      }

      message("Could not add registry keys from R, retrying using registry prompt.")
      addReg <- tempfile(fileext = ".reg")

      lineEntries <- sapply(entries, function(entry) {
         fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")
         c(
            paste("[", fullPath, "]", sep = ""),
            paste(
               "\"",
               entry$key,
               "\"=\"",
               odbcFileEscape(entry$value),
               "\"",
               sep = ""
            ),
            ""
         )
      })

      lines <- c(
         "REGEDIT4",
         "",
         lineEntries
      )

      writeLines(lines, addReg)

      message("Waiting for ", addReg, " to be registered.")
      system2(
         "explorer",
         addReg
      )

      allEntriesValid <- function() {
        all(sapply(entries, function(e) validateEntry(e)))
      }

      registryStart <- Sys.time()
      registryWait <- 30
      while (!allEntriesValid() && Sys.time() < registryStart + registryWait) {
         Sys.sleep(1)
         cat(".")
      }

      if (!allEntriesValid()) {
         stop("Failed to add all registry keys using registry file.")
      }
   }
})

.rs.addFunction("odbcBundleRegistryRemove", function(entries) {
   validateEntry <- function(entry) {
      tryCatch({
         regEntry <- readRegistry(entry$path, "HLM", view = .rs.odbcOsBitness())
         if (!is.null(entry$key))
            is.null(regEntry[[entry$key]])
         else
            FALSE
      }, error = function(e) {
         TRUE
      })
   }

   if (all(sapply(entries, function(e) validateEntry(e))))
      return()

   bitness <- .rs.odbcOsBitness()

   for (entry in entries) {
      fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")

      if (!is.null(entry$key)) {
         regArgs <- list(
            "DELETE",
            shQuote(fullPath),
            "/v",
            shQuote(entry$key),
            "/f",
            paste("/reg:", bitness, sep = "")
         )
      }
      else {
         regArgs <- list(
            "DELETE",
            shQuote(fullPath),
            "/f",
            paste("/reg:", bitness, sep = "")
         )
      }

      system2(
         "REG",
         args = regArgs
      )
   }

   if (all(sapply(entries, function(e) validateEntry(e))))
      return()

   addReg <- tempfile(fileext = ".reg")

   lineEntries <- sapply(entries, function(entry) {
      fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")

      if (is.null(entry$key)) {
         paste("[-", fullPath, "]", sep = "")
      }
      else {
         c(
            paste("[", fullPath, "]", sep = ""),
            paste(
               "\"",
               entry$key,
               "\"=-",
               sep = ""
            ),
            ""
         )
      }
   })

   lines <- c(
      "REGEDIT4",
      "",
      unlist(lineEntries)
   )

   writeLines(lines, addReg)
   system2(
      "explorer",
      addReg
   )
})

.rs.addFunction("odbcBundleRegistryDelete", function(path) {
   system2(
      "REG",
      args = list(
         "DELETE",
         shQuote(path),
         "/f"
      )
   )
   
   identical(ret, 0L)
})

.rs.addFunction("odbcBundleCheckPrereqsWindows", function() {
})

.rs.addFunction("odbcBundleCheckPrereqs", function() {
   osPrereqs <- list(
      osx = .rs.odbcBundleCheckPrereqsOsx,
      windows = .rs.odbcBundleCheckPrereqsWindows,
      linux = .rs.odbcBundleCheckPrereqsLinux
   )
   
   prereqs <- osPrereqs[[.rs.odbcBundleOsName()]]
   prereqs()
})

.rs.addFunction("odbcBundleOdbcinstPathWithOdbcinst", function() {
   config <- system2("odbcinst", "-j", stdout = TRUE)
   odbciniEntry <- config[grepl("odbcinst.ini", config)]
   gsub("^[^/\\\\]*", "", odbciniEntry)
})

.rs.addFunction("odbcBundleOdbcinstPathUseHome", function() {
   normalizePath("~/.odbcinst.ini", mustWork = FALSE)
})

.rs.addFunction("odbcBundleOdbcinstPath", function() {
   osOdbcinstPath <- list(
      osx = .rs.odbcBundleOdbcinstPathWithOdbcinst,
      windows = .rs.odbcBundleOdbcinstPathWithOdbcinst,
      linux = .rs.odbcBundleOdbcinstPathUseHome
   )

   osOdbcinstPath[[.rs.odbcBundleOsName()]]()
})

.rs.addFunction("odbcBundleReadIni", function(odbcinstPath) {
   lines <- readLines(odbcinstPath)
   data <- list()
   
   currentDriver <- "__header__"
   
   for (line in lines) {
      # Is header?
      if (grepl(" *\\[[^]]+\\] *", line)) {
         currentDriver <- gsub("^ *\\[|\\] *", "", line)
         data[[currentDriver]] <- ""
      }
      else if (!grepl("^ *$", line)) {
         if (identical(data[[currentDriver]], ""))
            data[[currentDriver]] <- line
         else
            data[[currentDriver]] <- c(
               data[[currentDriver]],
               line
            )
      }
   }
   
   data
})

.rs.addFunction("odbcBundleWriteIni", function(odbcinstPath, data) {
   lines <- c()
   for (name in names(data)) {
      lines <- c(
         lines, 
         if (identical(name, "__header__")) 
            ""
         else
            paste("[", name, "]", sep = "")
      )
      
      lines <- c(
         lines,
         unlist(data[[name]]),
         ""
      )
   }
   
   if (is.null(lines)) lines <- c("")

   writeLines(lines, odbcinstPath)
})

.rs.addFunction("odbcOdbcInstLibPath", function() {
   odbcinstLib <- NULL

   odbcinstBin <- Sys.which("odbcinst")
   if (nchar(odbcinstBin) == 0) {
      warning("Could not find path to odbcinst.")
   }
   else {
      odbcinstLink <- Sys.readlink(odbcinstBin)
      if (!is.na(odbcinstLink)) {
         odbcinstBinPath <- normalizePath(file.path(dirname(odbcinstBin), dirname(odbcinstLink)))
         odbcinstLibPath <- normalizePath(file.path(odbcinstBinPath, "..", "lib"))
         odbcinstLib <- dir(odbcinstLibPath, pattern = "libodbcinst.*\\.dylib", full.names = TRUE)[[1]]
      }
   }

   odbcinstLib
})

.rs.addFunction("odbcBundleRegisterLinux", function(name, driverPath, version, installPath) {
   # Find odbcinst.ini file
   odbcinstPath <- .rs.odbcBundleOdbcinstPath()
   
   # Read odbcinst.ini
   odbcinst <- .rs.odbcBundleReadIni(odbcinstPath)
   
   # Set odbcinst.ini entries
   odbcinst[[name]] <- list(
      paste("Driver", "=", driverPath),
      paste("Version", "=", version),
      paste("Installer", "=", "RStudio")
   )
   
   # Write odbcinst.ini
   .rs.odbcBundleWriteIni(odbcinstPath, odbcinst)
})

.rs.addFunction("odbcBundleDriverIniPath", function(name, driverPath) {
   dir(driverPath, pattern = paste(tolower(name), ".*\\.ini", sep = ""), recursive = TRUE, full.names = T)
})

.rs.addFunction("odbcBundleRegisterOSX", function(name, driverPath, version, installPath) {
   # Update odbcinst.ini
   .rs.odbcBundleRegisterLinux(name, driverPath, version, installPath)

   # Find driver.ini file
   driverIniFile <- .rs.odbcBundleDriverIniPath(name, installPath)
   
   if (length(driverIniFile) == 0) {
      warning("Could not find '", name, "' driver INI file under: ", installPath)
   }
   else {
      # Read driver.ini
      driverIni <- .rs.odbcBundleReadIni(driverIniFile)

      # In OSX register to use unixODBC
      odbcinstLib <- .rs.odbcOdbcInstLibPath()
      if (!is.null(odbcinstLib)) {
         driverIni[["Driver"]] <- c(
            driverIni[["Driver"]],
            paste("ODBCInstLib", "=", odbcinstLib)
         )
      }
      
      # Write odbcinst.ini
      .rs.odbcBundleWriteIni(driverIniFile, driverIni)
   }
})

.rs.addFunction("odbcBundleRegisterWindows", function(name, driverPath, version, installPath) {
   .rs.odbcBundleRegistryAdd(
      list(
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", "ODBC Drivers", fsep = "\\"),
            key = name,
            value = "installed"
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Driver",
            value = driverPath
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Setup",
            value = driverPath
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Version",
            value = version
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Installer",
            value = "RStudio"
         )
      )
   )
})

.rs.addFunction("odbcBundleFindDriver", function(name, installPath, libraryPattern) { 
   osExtensions <- list(
      osx = "dylib$",
      windows = "dll$",
      linux = "so$"
   )
   
   osExtension <- osExtensions[[.rs.odbcBundleOsName()]]
   driverName <- gsub(paste(" |", trimws(.rs.connectionOdbcRStudioDriver()), sep = ""), "", name)
   
   if (is.null(libraryPattern) || nchar(libraryPattern) == 0) {
      libraryPattern <- paste(
         driverName,
         "[^/\\\\]+\\.",
         osExtension,
         sep = ""
      )
   }

   # apply dynamic patterns
   osName <- .rs.odbcBundleOsName()
   bitness <- .rs.odbcOsBitness()
   libraryPattern <- gsub("\\(os\\)", osName, libraryPattern)
   libraryPattern <- gsub("\\(bitness\\)", bitness, libraryPattern)
   
   allFiles <- dir(installPath, recursive = TRUE, full.names = TRUE)
   driverPath <- allFiles[grepl(libraryPattern, allFiles, ignore.case = TRUE)]

   if (!identical(length(driverPath), 1L))
      stop("Failed to find ", library, " inside driver bundle.")
   
   normalizePath(driverPath)
})

.rs.addFunction("odbcBundleRegister", function(name, driverPath, version, installPath) {
   osRegistrations <- list(
      osx = .rs.odbcBundleRegisterOSX,
      windows = .rs.odbcBundleRegisterWindows,
      linux = .rs.odbcBundleRegisterLinux
   )
   
   osRegistration <- osRegistrations[[.rs.odbcBundleOsName()]]
   
   osRegistration(name, driverPath, version, installPath) 
})

.rs.addFunction("odbcBundleValidate", function(bundleFile, md5) {
   if (!is.null(md5) && nchar(md5) > 0) {
      validMd5s <- strsplit(as.character(md5), "[ \n,]+")[[1]]
      bundleMd5 <- tools::md5sum(bundleFile)
      if (!bundleMd5 %in% validMd5s) {
         stop("Failed to validate bundle with signature ", md5, " but got ", bundleMd5, " instead.")
      }
   }
})

.rs.addFunction("odbcBundleInstall", function(
   name,
   url,
   placeholder,
   installPath,
   libraryPattern = NULL,
   md5 = NULL,
   version = "") {

   installPath <- file.path(
      normalizePath(installPath, mustWork = FALSE),
      tolower(name)
   )
   
   bundleTemp <- tempfile()
   on.exit(unlink(bundleTemp, recursive = TRUE), add = TRUE)

   message("Installing")
   message("  Driver: ", name)
   message("  Version: ", version)
   message("  Path: ", installPath)

   message("Checking prerequisites")
   .rs.odbcBundleCheckPrereqs()
   
   message("Downloading bundle")
   bundleFileTemp <- .rs.odbcBundleDownload(url, placeholder, bundleTemp)

   message("Validating bundle")
   .rs.odbcBundleValidate(bundleFileTemp, md5)
   
   message("Extracting bundle")
   .rs.odbcBundleExtract(bundleFileTemp, installPath)
   
   message("Inspecting driver")
   driverPath <- .rs.odbcBundleFindDriver(name, installPath, libraryPattern)
   
   message("Registering driver")
   .rs.odbcBundleRegister(name, driverPath, version, installPath)

   message("")
   message("Installation complete")

   invisible(NULL)
})

.rs.addFunction("connectionOdbcRStudioDriver", function() {
   " with RStudio Driver"
})

#
# SessionTests.R
#
# Copyright (C) 2009-19 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("has_shinytest_dependencies", function() {

   if (.rs.isPackageInstalled("shinytest")) {
      if (!exists("dependenciesInstalled", envir = asNamespace("shinytest"))) {
         # assume dependencies installed if shinytest does not provide dependencies state
         .rs.scalar(TRUE)
      } else {
         shinytestDepsInstalled <- get("dependenciesInstalled", envir = asNamespace("shinytest"))()
         .rs.scalar(shinytestDepsInstalled)
      }
   } else {
      .rs.scalar(FALSE)
   }

})

.rs.addJsonRpcHandler("has_shinytest_results", function(testFile) {

   # The test result is stored in a directory alongside the test file
   dirExists <- dir.exists(file.path(
      dirname(testFile), 
      paste(tools::file_path_sans_ext(basename(testFile)), "current", sep = "-")))

   # Find the Shiny app directory
   shinyDir <- dirname(testFile)
   if (identical(basename(shinyDir), "shinytests")) {
      # Newer versions of shinytest store tests in a "shinytests" folder
      shinyDir <- dirname(shinyDir)
   } 
   if (identical(basename(shinyDir), "tests")) {
      # Move up from the tests folder to the app folder
      shinyDir <- dirname(shinyDir)
   } else {
      stop("Could not find Shiny app for test file ", testFile)
   }

   # Return the discovered application directory, and whether the test exists 
   list(
      appDir = .rs.scalar(shinyDir),
      testDirExists = .rs.scalar(dirExists))
})

#
# NotebookAlternateEngines.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("isSystemInterpreter", function(engine)
{
   # check to see if a knitr engine is defined
   knitr <- asNamespace("knitr")
   engines <- knitr$knit_engines$get()
   if (engine %in% names(engines))
   {
      # knitr engine defined; check to see if the engine uses 'eng_interpeted'
      isInterpreted <-
         is.function(knitr$eng_interpreted) &&
         is.function(engines[[engine]]) &&
         identical(engines[[engine]], knitr$eng_interpreted)
      isInterpreted
   }
   else
   {
      # no knitr engine defined; assume that the user intended to use a system
      # interpreter
      TRUE
   }
})

.rs.addFunction("runUserDefinedEngine", function(engine, code, options)
{
   Encoding(code) <- "UTF-8" 
   
   # trim common indent (this ensures that indented chunks of code can be run)
   # https://github.com/rstudio/rstudio/issues/3731
   code <- .rs.trimCommonIndent(code)
   
   # if we're using the python engine, attempt to load reticulate (this
   # will load the reticulate knitr engine and set it as the default engine)
   useReticulate <-
      identical(engine, "python") &&
      !identical(getOption("python.reticulate"), FALSE)
   
   if (useReticulate) {
      # TODO: prompt user for installation of reticulate?
      requireNamespace("reticulate", quietly = TRUE)
   }
   
   # retrieve the engine
   knitrEngines <- knitr::knit_engines$get()
   if (!engine %in% names(knitrEngines))
   {
      fmt <- "engine '%s' has not yet been registered"
      stop(sprintf(fmt, options))
   }
   
   # double-check that this is indeed a function (shouldn't happen
   # but should guard against invalid user-defined engines)
   knitrEngine <- knitrEngines[[engine]]
   if (!is.function(knitrEngine))
   {
      fmt <- "engine '%s' is not a function"
      stop(sprintf(fmt, options))
   }
   
   # prepare the R environment for reticulate Python engine
   if (useReticulate)
   {
      # install our own matplotlib hook -- TODO here is to save the plot
      # object itself so we can redraw the plot if needed on resize
      show <- getOption("reticulate.engine.matplotlib.show")
      on.exit(options(reticulate.engine.matplotlib.show = show), add = TRUE)
      options(reticulate.engine.matplotlib.show = function(plt, options) {
         path <- tempfile("reticulate-matplotlib-plot-", fileext = ".png")
         plt$savefig(path, dpi = options$dpi)
         structure(list(path = path), class = "reticulate_matplotlib_plot")
      })
      
      # install our own wrap hook -- we want to avoid the post-processing
      # typically done by knitr; we implement our own wrap behavior for
      # notebooks
      wrap <- getOption("reticulate.engine.wrap")
      on.exit(options(reticulate.engine.wrap = wrap), add = TRUE)
      options(reticulate.engine.wrap = function(outputs, options) {
         
         # take this opportunity to clear matplotlib figure if appropriate
         sys <- reticulate::import("sys", convert = TRUE)
         if (!is.null(sys$modules$matplotlib$pyplot)) {
            plt <- reticulate::import("matplotlib.pyplot", convert = TRUE)
            tryCatch(plt$clf(), error = identity)
         }
         
         # return outputs
         outputs
         
      })
      
      # use the global environment for rendering
      environment <- getOption("reticulate.engine.environment")
      on.exit(options(reticulate.engine.environment = environment), add = TRUE)
      options(reticulate.engine.environment = globalenv())
   }
   
   # prepare chunk options
   mergedOptions <- knitr::opts_chunk$merge(options)
   code <- strsplit(code, "\n", fixed = TRUE)[[1]]
   mergedOptions$code <- code
   
   # when invoking engines, we don't want to echo user code
   mergedOptions$echo <- FALSE
   
   # invoke engine
   knitrEngine(mergedOptions)
   
})

#
# SessionPackages.R
#
# Copyright (C) 2009-19 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# cached URLs for package NEWS files
.rs.setVar("packageNewsURLsEnv", new.env(parent = emptyenv()))

# cached information on available R packages
.rs.setVar("availablePackagesEnv", new.env(parent = emptyenv()))

# for asynchronous requests on available package information,
# map the repository string to the directory containing produced output
.rs.setVar("availablePackagesPendingEnv", new.env(parent = emptyenv()))

# a vectorized function that takes any number of paths and aliases the home
# directory in those paths (i.e. "/Users/bob/foo" => "~/foo"), leaving any 
# paths outside the home directory untouched
.rs.addFunction("createAliasedPath", function(path)
{
   homeDir <- path.expand("~/")
   homePathIdx <- substr(path, 1, nchar(homeDir)) == homeDir
   homePaths <- path[homePathIdx]
   path[homePathIdx] <-
          paste("~", substr(homePaths, nchar(homeDir), nchar(homePaths)), sep="")
   path
})

# Some R commands called during packaging-related operations (such as untar)
# delegate to the system tar binary specified in TAR. On OS X, R may set TAR to
# /usr/bin/gnutar, which exists prior to Mavericks (10.9) but not in later
# rleases of the OS. In the special case wherein the TAR environment variable
# on OS X is set to a non-existant gnutar and there exists a tar at
# /usr/bin/tar, tell R to use that binary instead.
if (identical(as.character(Sys.info()["sysname"]), "Darwin") &&
    identical(Sys.getenv("TAR"), "/usr/bin/gnutar") && 
    !file.exists("/usr/bin/gnutar") &&
    file.exists("/usr/bin/tar"))
{
   Sys.setenv(TAR = "/usr/bin/tar")
}

.rs.addFunction( "updatePackageEvents", function()
{
   reportPackageStatus <- function(status)
      function(pkgname, ...)
      {
         packageStatus = list(name=pkgname,
                              path=.rs.createAliasedPath(
                                     .rs.pathPackage(pkgname, quiet=TRUE)),
                              loaded=status)
         .rs.enqueClientEvent("package_status_changed", packageStatus)
      }
   
   notifyPackageLoaded <- function(pkgname, ...)
   {
      .Call("rs_packageLoaded", pkgname, PACKAGE = "(embedding)")

      # when a package is loaded, it can register S3 methods which replace overrides we've
      # attached manually; take this opportunity to reattach them.
      .rs.reattachS3Overrides()
   }

   notifyPackageUnloaded <- function(pkgname, ...)
   {
      .Call("rs_packageUnloaded", pkgname, PACKAGE = "(embedding)")
   }
   
   # NOTE: `list.dirs()` was introduced with R 2.13 but was buggy until 3.0
   # (the 'full.names' argument was not properly respected)
   pkgNames <- if (getRversion() >= "3.0.0")
      base::list.dirs(.libPaths(), full.names = FALSE, recursive = FALSE)
   else
      .packages(TRUE)
   
   sapply(pkgNames, function(packageName)
   {
      if ( !(packageName %in% .rs.hookedPackages) )
      {
         attachEventName = packageEvent(packageName, "attach")
         setHook(attachEventName, reportPackageStatus(TRUE), action="append")
         
         loadEventName = packageEvent(packageName, "onLoad")
         setHook(loadEventName, notifyPackageLoaded, action="append")

         unloadEventName = packageEvent(packageName, "onUnload")
         setHook(unloadEventName, notifyPackageUnloaded, action="append")
             
         detachEventName = packageEvent(packageName, "detach")
         setHook(detachEventName, reportPackageStatus(FALSE), action="append")
          
         .rs.setVar("hookedPackages", append(.rs.hookedPackages, packageName))
      }
   })
})

.rs.addFunction( "packages.initialize", function()
{  
   # list of packages we have hooked attach/detach for
   .rs.setVar( "hookedPackages", character() )

   # set flag indicating we should not ignore loadedPackageUpdates checks
   .rs.setVar("ignoreNextLoadedPackageCheck", FALSE)
    
   # ensure we are subscribed to package attach/detach events
   .rs.updatePackageEvents()
   
   # whenever a package is installed notify the client and make sure
   # we are subscribed to its attach/detach events
   .rs.registerReplaceHook("install.packages", "utils", function(original,
                                                                pkgs,
                                                                lib,
                                                                repos = getOption("repos"),
                                                                ...) 
   {
      if (missing(pkgs))
         return(utils::install.packages())
      
      if (!.Call("rs_canInstallPackages", PACKAGE = "(embedding)"))
      {
        stop("Package installation is disabled in this version of RStudio",
             call. = FALSE)
      }
      
      packratMode <- !is.na(Sys.getenv("R_PACKRAT_MODE", unset = NA))
      
      if (!is.null(repos) && !packratMode && .rs.loadedPackageUpdates(pkgs)) {

         # attempt to determine the install command
         installCmd <- NULL
         for (i in seq_along(sys.calls()))
         {
           if (identical(deparse(sys.call(i)[[1]]), "install.packages"))
           {
             installCmd <- gsub("\\s+"," ", 
                                paste(deparse(sys.call(i)), collapse = " "))
             break
           }
         }

         # call back into rsession to send an event to the client
         .rs.enqueLoadedPackageUpdates(installCmd)

         # throw error
         stop("Updating loaded packages")
      }

      # fixup path as necessary
      .rs.addRToolsToPath()

      # do housekeeping after we execute the original
      on.exit({
         .rs.updatePackageEvents()
         .Call("rs_packageLibraryMutated", PACKAGE = "(embedding)")
         .rs.restorePreviousPath()
      })
      
      # call original
      original(pkgs, lib, repos, ...)
   })
   
   # whenever a package is removed notify the client (leave attach/detach
   # alone because the dangling event is harmless and removing it would
   # requrie somewhat involved code
   .rs.registerReplaceHook("remove.packages", "utils", function(original,
                                                               pkgs,
                                                               lib,
                                                               ...) 
   {
      # do housekeeping after we execute the original
      on.exit(.Call("rs_packageLibraryMutated", PACKAGE = "(embedding)"))
                         
      # call original
      original(pkgs, lib, ...) 
   })
})

.rs.addFunction( "addRToolsToPath", function()
{
    .Call("rs_addRToolsToPath", PACKAGE = "(embedding)")
})

.rs.addFunction( "restorePreviousPath", function()
{
    .Call("rs_restorePreviousPath", PACKAGE = "(embedding)")
})

.rs.addFunction( "uniqueLibraryPaths", function()
{
   # get library paths (normalize on unix to get rid of duplicate symlinks)
   libPaths <- .libPaths()
   if (!identical(.Platform$OS.type, "windows"))
      libPaths <- .rs.normalizePath(libPaths)

   uniqueLibPaths <- subset(libPaths, !duplicated(libPaths))
   return (uniqueLibPaths)
})

.rs.addFunction( "writeableLibraryPaths", function()
{
   uniqueLibraryPaths <- .rs.uniqueLibraryPaths()
   writeableLibraryPaths <- character()
   for (libPath in uniqueLibraryPaths)
      if (.rs.isLibraryWriteable(libPath))
         writeableLibraryPaths <- append(writeableLibraryPaths, libPath)
   return (writeableLibraryPaths)
})

.rs.addFunction("defaultUserLibraryPath", function()
{
   unlist(strsplit(Sys.getenv("R_LIBS_USER"),
                              .Platform$path.sep))[1L]
})

.rs.addFunction("defaultLibraryPath", function()
{
  .libPaths()[1]
})

.rs.addFunction("isPackageLoaded", function(packageName, libName)
{
   if (packageName %in% .packages())
   {
      # get the raw path to the package 
      packagePath <- .rs.pathPackage(packageName, quiet=TRUE)

      # alias (for comparison against libName, which comes from the client and
      # is alised)
      packagePath <- .rs.createAliasedPath(packagePath)

      # compare with the library given by the client
      .rs.scalar(identical(packagePath, paste(libName, packageName, sep="/")))
   }
   else 
      .rs.scalar(FALSE)
})

.rs.addJsonRpcHandler( "is_package_loaded", function(packageName, libName)
{
   .rs.isPackageLoaded(packageName, libName)
})

.rs.addFunction("forceUnloadPackage", function(name)
{
  if (name %in% .packages())
  {
    fullName <- paste("package:", name, sep="")
    suppressWarnings(detach(fullName, 
                            character.only=TRUE, 
                            unload=TRUE, 
                            force=TRUE))
    
    pkgDLL <- getLoadedDLLs()[[name]]
    if (!is.null(pkgDLL)) {
      suppressWarnings(library.dynam.unload(name, 
                                            system.file(package=name)))
    }
  }
})

.rs.addFunction("packageVersion", function(name, libPath, pkgs)
{
   pkgs <- subset(pkgs, Package == name & LibPath == libPath)
   if (nrow(pkgs) == 1)
      pkgs$Version
   else
      ""
})

.rs.addFunction( "initDefaultUserLibrary", function()
{
  userdir <- .rs.defaultUserLibraryPath()
  dir.create(userdir, showWarnings = FALSE, recursive = TRUE)
  .libPaths(c(userdir, .libPaths()))
})

.rs.addFunction("ensureWriteableUserLibrary", function()
{
   if (!.rs.defaultLibPathIsWriteable())
      .rs.initDefaultUserLibrary()
})

.rs.addFunction("lastCharacterIs", function(value, ending) {
   identical(tail(strsplit(value, "")[[1]], n = 1), ending)
})

.rs.addFunction("listInstalledPackages", function()
{
   # get the CRAN repository URL, and remove a trailing slash if required
   repos <- getOption("repos")
   cran <- if ("CRAN" %in% names(repos))
      repos[["CRAN"]]
   else
      .Call("rs_rstudioCRANReposUrl", PACKAGE = "(embedding)")
   
   # trim trailing slashes if necessary
   cran <- gsub("/*", "", cran)
   
   # helper function for extracting information from a package's
   # DESCRIPTION file
   readPackageInfo <- function(pkgPath) {
      
      # attempt to read package metadata
      desc <- .rs.tryCatch({
         metapath <- file.path(pkgPath, "Meta", "package.rds")
         metadata <- readRDS(metapath)
         as.list(metadata$DESCRIPTION)
      })
      
      # if that failed, try reading the DESCRIPTION
      if (inherits(desc, "error"))
         desc <- read.dcf(file.path(pkgPath, "DESCRIPTION"), all = TRUE)
      
      # attempt to infer an appropriate URL for this package
      if (identical(as.character(desc$Priority), "base")) {
         source <- "Base"
         url <- ""
      } else if (!is.null(desc$URL)) {
         source <- "Custom"
         url <- strsplit(desc$URL, "\\s*,\\s*")[[1]][[1]]
      } else if ("biocViews" %in% names(desc)) {
         source <- "Bioconductor"
         url <- sprintf("https://www.bioconductor.org/packages/release/bioc/html/%s.html", desc$Package)
      } else if (identical(desc$Repository, "CRAN")) {
         source <- "CRAN"
         url <- sprintf("%s/package=%s", cran, desc$Package)
      } else if (!is.null(desc$GithubRepo)) {
         source <- "GitHub"
         url <- sprintf("https://github.com/%s/%s", desc$GithubUsername, desc$GithubRepo)
      } else {
         source <- "Unknown"
         url <- sprintf("%s/package=%s", cran, desc$Package)
      }
      
      list(
         Package     = .rs.nullCoalesce(desc$Package, "[Unknown]"),
         LibPath     = dirname(pkgPath),
         Version     = .rs.nullCoalesce(desc$Version, "[Unknown]"),
         Title       = .rs.nullCoalesce(desc$Title, "[No description available]"),
         Source      = source,
         BrowseUrl   = utils::URLencode(url)
      )
      
   }
   
   # to be called if our attempt to read the package DESCRIPTION file failed
   # for some reason
   emptyPackageInfo <- function(pkgPath) {
      
      package <- basename(pkgPath)
      libPath <- dirname(pkgPath)
      
      list(
         Package   = package,
         LibPath   = libPath,
         Version   = "[Unknown]",
         Title     = "[Failed to read package metadata]",
         Source    = "Unknown",
         BrowseUrl = ""
      )
      
   }
   
   # now, find packages. we'll only include packages that have
   # a Meta folder. note that the pseudo-package 'translations'
   # lives in the R system library, and has a DESCRIPTION file,
   # but cannot be loaded as a regular R package.
   packagePaths <- list.files(.rs.uniqueLibraryPaths(), full.names = TRUE)
   hasMeta <- file.exists(file.path(packagePaths, "Meta"))
   packagePaths <- packagePaths[hasMeta]
   
   # now, iterate over these to generate the requisite package
   # information and combine into a data.frame
   parts <- lapply(packagePaths, function(pkgPath) {
      
      tryCatch(
         readPackageInfo(pkgPath),
         error = function(e) emptyPackageInfo(pkgPath)
      )
      
   })
   
   # combine into a data.frame
   info <- .rs.rbindList(parts)
   
   # find which packages are currently attached (be careful to handle
   # cases where package is installed into multiple libraries)
   #
   # we suppress warnings here as 'find.packages(.packages())' can warn
   # if a package that is attached is no longer actually installed
   loaded <- suppressWarnings(
      normalizePath(file.path(info$LibPath, info$Package), winslash = "/", mustWork = FALSE) %in%
      normalizePath(find.package(.packages(), quiet = TRUE), winslash = "/", mustWork = FALSE)
   )
   
   # extract fields relevant to us
   packages <- data.frame(
      name             = info$Package,
      library          = .rs.createAliasedPath(info$LibPath),
      library_absolute = info$LibPath,
      library_index    = match(info$LibPath, .libPaths(), nomatch = 0L),
      version          = info$Version,
      desc             = info$Title,
      loaded           = loaded,
      source           = info$Source,
      browse_url       = info$BrowseUrl,
      check.rows       = TRUE,
      stringsAsFactors = FALSE
   )
   
   # sort and return
   packages[order(packages$name), ]
})

.rs.addJsonRpcHandler("get_package_install_context", function()
{
   # cran mirror configured
   repos = getOption("repos")
   cranMirrorConfigured <- !is.null(repos) && !any(repos == "@CRAN@")
   
   # selected repository names (assume an unnamed repo == CRAN)
   selectedRepositoryNames <- names(repos)
   if (is.null(selectedRepositoryNames))
     selectedRepositoryNames <- "CRAN"

   # package archive extension
   if (identical(.Platform$OS.type, "windows"))
      packageArchiveExtension <- ".zip; .tar.gz"
   else if (identical(substr(.Platform$pkgType, 1L, 10L), "mac.binary"))
      packageArchiveExtension <- ".tgz; .tar.gz"
   else
      packageArchiveExtension <- ".tar.gz"

   # default library path (normalize on unix)
   defaultLibraryPath = .libPaths()[1L]
   if (!identical(.Platform$OS.type, "windows"))
      defaultLibraryPath <- .rs.normalizePath(defaultLibraryPath)
   
   # return context
   list(cranMirrorConfigured = cranMirrorConfigured,
        selectedRepositoryNames = selectedRepositoryNames,
        packageArchiveExtension = packageArchiveExtension,
        defaultLibraryPath = defaultLibraryPath,
        defaultLibraryWriteable = .rs.defaultLibPathIsWriteable(),
        writeableLibraryPaths = .rs.writeableLibraryPaths(),
        defaultUserLibraryPath = .rs.defaultUserLibraryPath(),
        devModeOn = .rs.devModeOn())
})

.rs.addJsonRpcHandler( "get_cran_mirrors", function()
{
   # get CRAN mirrors (securely if we are configured to do so)
   haveSecureMethod <- .rs.haveSecureDownloadFileMethod()
   protocol <- ifelse(haveSecureMethod, "https", "http")
   cranMirrors <- try(silent = TRUE, {
      mirrors_csv_url <- paste(protocol, "://cran.r-project.org/CRAN_mirrors.csv",
                               sep = "")
      mirrors_csv <- tempfile("mirrors", fileext = ".csv")
      download.file(mirrors_csv_url, destfile = mirrors_csv, quiet = TRUE)
      
      # read them
      read.csv(mirrors_csv, as.is = TRUE, encoding = "UTF-8")
   })
   
   # if we got an error then use local only
   if (is.null(cranMirrors) || inherits(cranMirrors, "try-error"))
      cranMirrors <- utils::getCRANmirrors(local.only = TRUE)
   
   # create data frame
   cranDF <- data.frame(name = cranMirrors$Name,
                        host = cranMirrors$Host,
                        url = cranMirrors$URL,
                        country = cranMirrors$CountryCode,
                        ok = cranMirrors$OK,
                        stringsAsFactors = FALSE)

   # filter by OK status
   cranDF <- cranDF[as.logical(cranDF$ok), ]

   # filter by mirror type supported by the current download.file.method
   # (also verify that https urls are provided inline -- if we didn't do
   # this and CRAN changed the format we could end up with no mirrors)
   secureMirror <- grepl("^https", cranDF[, "url"])
   useHttpsURL <- haveSecureMethod && any(secureMirror)
   if (useHttpsURL)
      cranDF <- cranDF[secureMirror,]
   else
      cranDF <- cranDF[!secureMirror,]

   # prepend RStudio mirror and return
   rstudioDF <- data.frame(name = "Global (CDN)",
                           host = "RStudio",
                           url = paste(ifelse(useHttpsURL, "https", "http"), 
                                       "://cran.rstudio.com/", sep=""),
                           country = "us",
                           ok = TRUE,
                           stringsAsFactors = FALSE)
   rbind(rstudioDF, cranDF)
})

.rs.addJsonRpcHandler("get_cran_actives", function()
{
   data.frame(name = names(getOption("repos")),
              host = "",
              url = as.character(getOption("repos")),
              country = "",
              ok = TRUE,
              stringsAsFactors = FALSE)
})

.rs.addJsonRpcHandler( "init_default_user_library", function()
{
  .rs.initDefaultUserLibrary()
})

.rs.addJsonRpcHandler("check_for_package_updates", function()
{
   # get updates writeable libraries and convert to a data frame
   updates <- as.data.frame(
      utils::old.packages(lib.loc = .rs.writeableLibraryPaths()),
      stringsAsFactors = FALSE
   )
   row.names(updates) <- NULL
   
   # see which ones are from CRAN and add a news column for them
   # NOTE: defend against length-one repos with no name set
   repos <- getOption("repos")
   cranRep <- if ("CRAN" %in% names(repos))
      repos["CRAN"]
   else
      c(CRAN = repos[[1]])
   
   data.frame(
      packageName = updates$Package,
      libPath     = updates$LibPath,
      installed   = updates$Installed,
      available   = updates$ReposVer,
      stringsAsFactors = FALSE
   )
   
})

.rs.addJsonRpcHandler("get_package_news_url", function(packageName, libraryPath)
{
   # first, check if we've already discovered a NEWS link
   cache <- .rs.packageNewsURLsEnv
   entry <- file.path(libraryPath, packageName)
   if (exists(entry, envir = cache))
      return(get(entry, envir = cache))
   
   # determine an appropriate CRAN URL
   repos <- getOption("repos")
   cran <- if ("CRAN" %in% names(repos))
      repos[["CRAN"]]
   else if (length(repos))
      repos[[1]]
   else
      .Call("rs_rstudioCRANReposUrl", PACKAGE = "(embedding)")
   cran <- gsub("/*$", "", cran)
   
   # check to see if this package was from Bioconductor. if so, we'll need
   # to construct a more appropriate url
   desc <- .rs.tryCatch(.rs.readPackageDescription(file.path(libraryPath, packageName)))
   prefix <- if (inherits(desc, "error") || !"biocViews" %in% names(desc))
      file.path(cran, "web/packages")
   else
      "https://bioconductor.org/packages/release/bioc/news"
   
   # the set of candidate URLs -- we use the presence of a NEWS or NEWS.md
   # to help us prioritize the order of checking.
   #
   # in theory, the current-installed package might not have NEWS at all, but
   # the latest released version might have it after all, so checking the
   # current installed package is just a heuristic and won't be accurate
   # 100% of the time
   pkgPath <- file.path(libraryPath, packageName)
   candidates <- if (file.exists(file.path(pkgPath, "NEWS.md"))) {
      c("news/news.html", "news.html", "NEWS", "ChangeLog")
   } else if (file.exists(file.path(pkgPath, "NEWS"))) {
      c("NEWS", "news/news.html", "news.html", "ChangeLog")
   } else {
      c("news/news.html", "news.html", "NEWS", "ChangeLog")
   }
   
   
   # we do some special handling for 'curl'
   isCurl <- identical(getOption("download.file.method"), "curl")
   if (isCurl) {
      
      download.file.extra <- getOption("download.file.extra")
      on.exit(options(download.file.extra = download.file.extra), add = TRUE)
      
      # guard against NULL, empty extra
      extra <- if (length(download.file.extra))
         download.file.extra
      else
         ""
      
      # add in some extra flags for nicer download output
      addons <- c()
      
      # follow redirects if necessary
      hasLocation <-
         grepl("\b-L\b", extra) ||
         grepl("\b--location\b", extra)
      
      if (!hasLocation)
         addons <- c(addons, "-L")
      
      # fail on 404
      hasFail <-
         grepl("\b-f\b", extra) ||
         grepl("\b--fail\b", extra)
      
      if (!hasFail)
         addons <- c(addons, "-f")
      
      # don't print error output to the console
      hasSilent <-
         grepl("\b-s\b", extra) ||
         grepl("\b--silent\b", extra)
      
      if (!hasSilent)
         addons <- c(addons, "-s")
      
      if (nzchar(extra))
         extra <- paste(extra, paste(addons, collapse = " "))
      else
         extra <- paste(addons, collapse = " ")
      
      options(download.file.extra = extra)
   }
   
   # timeout a bit more quickly when forming web requests
   timeout <- getOption("timeout")
   on.exit(options(timeout = timeout), add = TRUE)
   options(timeout = 4L)
   
   for (candidate in candidates) {
      
      url <- file.path(prefix, packageName, candidate)
      
      # attempt to download the file (note that R preserves curl's printing of errors
      # to the console with 'quiet = TRUE' so we disable it there)
      destfile <- tempfile()
      on.exit(unlink(destfile), add = TRUE)
      status <- .rs.tryCatch(download.file(url, destfile = destfile, quiet = !isCurl, mode = "wb"))
      
      # handle explicit errors
      if (is.null(status) || inherits(status, "error"))
         next
      
      # check for success status
      if (identical(status, 0L)) {
         cache[[entry]] <- .rs.scalar(url)
         return(.rs.scalar(url))
      }
   }
   
   # we failed to figure out the NEWS url; provide our first candidate
   # as the best guess
   fmt <- "Failed to infer appropriate NEWS URL: using '%s' as best-guess candidate"
   warning(sprintf(fmt, candidates[[1]]))
   
   # return that URL
   .rs.scalar(candidates[[1]])
})

.rs.addFunction("packagesLoaded", function(pkgs) {
   # first check loaded namespaces
   if (any(pkgs %in% loadedNamespaces()))
      return(TRUE)

   # now check if there are libraries still loaded in spite of the
   # namespace being unloaded 
   libs <- .dynLibs()
   libnames <- vapply(libs, "[[", character(1), "name")
   return(any(pkgs %in% libnames))
})

.rs.addFunction("loadedPackageUpdates", function(pkgs)
{
   # are we ignoring?
   ignore <- .rs.ignoreNextLoadedPackageCheck
   .rs.setVar("ignoreNextLoadedPackageCheck", FALSE)
   if (ignore)
      return(FALSE)

   # if the default set of namespaces in rstudio are loaded
   # then skip the check
   defaultNamespaces <- c("base", "datasets", "graphics", "grDevices",
                          "methods", "stats", "tools", "utils")
   if (identical(defaultNamespaces, loadedNamespaces()) &&
       length(.dynLibs()) == 4)
      return(FALSE)

   if (.rs.packagesLoaded(pkgs)) {
      return(TRUE)
   }
   else {
      avail <- available.packages()
      deps <- suppressMessages(suppressWarnings(
         utils:::getDependencies(pkgs, available=avail)))
      return(.rs.packagesLoaded(deps))
   }
})

.rs.addFunction("loadedPackagesAndDependencies", function(pkgs) {
  
  # if the default set of namespaces in rstudio are loaded
  # then skip the check
  defaultNamespaces <- c("base", "datasets", "graphics", "grDevices",
                         "methods", "stats", "tools", "utils")
  if (identical(defaultNamespaces, loadedNamespaces()) && length(.dynLibs()) == 4)
    return(character())
  
  packagesLoaded <- function(pkgList) {
    
    # first check loaded namespaces
    loaded <- pkgList[pkgList %in% loadedNamespaces()]
    
    # now check if there are libraries still loaded in spite of the
    # namespace being unloaded 
    libs <- .dynLibs()
    libnames <- vapply(libs, "[[", character(1), "name")
    loaded <- c(loaded, pkgList[pkgList %in% libnames])
    loaded
  }
  
  # package loaded
  loaded <- packagesLoaded(pkgs)
  
  # dependencies loaded
  avail <- available.packages()
  deps <- suppressMessages(suppressWarnings(
    utils:::getDependencies(pkgs, available=avail)))
  loaded <- c(loaded, packagesLoaded(deps))
  
  # return unique list
  unique(loaded)  
})

.rs.addFunction("forceUnloadForPackageInstall", function(pkgs) {
  
  # figure out which packages are loaded and/or have dependencies loaded
  pkgs <- .rs.loadedPackagesAndDependencies(pkgs)
  
  # force unload them
  sapply(pkgs, .rs.forceUnloadPackage)
  
  # return packages unloaded
  pkgs
})


.rs.addFunction("enqueLoadedPackageUpdates", function(installCmd)
{
   .Call("rs_enqueLoadedPackageUpdates", installCmd, PACKAGE = "(embedding)")
})

.rs.addJsonRpcHandler("loaded_package_updates_required", function(pkgs)
{
   .rs.scalar(.rs.loadedPackageUpdates(as.character(pkgs)))
})

.rs.addJsonRpcHandler("ignore_next_loaded_package_check", function() {
   .rs.setVar("ignoreNextLoadedPackageCheck", TRUE)
   return(NULL)
})

.rs.addFunction("getCachedAvailablePackages", function(contribUrl)
{
   .Call("rs_getCachedAvailablePackages", contribUrl, PACKAGE = "(embedding)")
})

.rs.addFunction("downloadAvailablePackages", function(contribUrl)
{
   .Call("rs_downloadAvailablePackages", contribUrl, PACKAGE = "(embedding)")
})

.rs.addJsonRpcHandler("package_skeleton", function(packageName,
                                                   packageDirectory,
                                                   sourceFiles,
                                                   usingRcpp)
{
   # sourceFiles is passed in as a list -- convert back to
   # character vector
   sourceFiles <- as.character(sourceFiles)
   
   # Make sure we expand the aliased path if necessary
   # (note this is a no-op if there is no leading '~')
   packageDirectory <- path.expand(packageDirectory)
   
   ## Validate the package name -- note that we validate this upstream
   ## but it is sensible to validate it once more here
   if (!grepl("^[[:alpha:]][[:alnum:].]*", packageName))
      return(.rs.error(
         "Invalid package name: the package name must start ",
         "with a letter and follow with only alphanumeric characters"))
   
   ## Validate the package directory -- if it exists, make sure it's empty,
   ## otherwise, try to create it
   if (file.exists(packageDirectory))
   {
      containedFiles <- list.files(packageDirectory) ## what about hidden files?
      if (length(containedFiles))
      {
         return(.rs.error(
            "Folder '", packageDirectory, "' ",
            "already exists and is not empty"))
      }
   }
   
   # Otherwise, create it
   else
   {
      if (!dir.create(packageDirectory, recursive = TRUE))
         return(.rs.error(
            "Failed to create directory '", packageDirectory, "'"))
   }
   
   ## Create a DESCRIPTION file
   
   # Fill some bits based on devtools options if they're available.
   # Protect against vectors with length > 1
   getDevtoolsOption <- function(optionName, default, collapse = " ")
   {
      devtoolsDesc <- getOption("devtools.desc")
      if (!length(devtoolsDesc))
         return(default)
      
      option <- devtoolsDesc[[optionName]]
      if (is.null(option))
         return(default)
      
      paste(option, collapse = collapse)
   }
   
   
   Author <- getDevtoolsOption("Author", "Who wrote it")
   
   Maintainer <- getDevtoolsOption(
      "Maintainer",
      "The package maintainer <yourself@somewhere.net>"
   )
   
   License <- getDevtoolsOption(
      "License",
      "What license is it under?",
      ", "
   )
   
   DESCRIPTION <- list(
      Package = packageName,
      Type = "Package",
      Title = "What the Package Does (Title Case)",
      Version = "0.1.0",
      Author = Author,
      Maintainer = Maintainer,
      Description = c(
         "More about what it does (maybe more than one line)",
         "Use four spaces when indenting paragraphs within the Description."
      ),
      License = License,
      Encoding = "UTF-8",
      LazyData = "true"
   )
   
   # Create a NAMESPACE file
   NAMESPACE <- c(
      'exportPattern("^[[:alpha:]]+")'
   )
   
   # If we are using Rcpp, update DESCRIPTION and NAMESPACE
   if (usingRcpp)
   {
      dir.create(file.path(packageDirectory, "src"), showWarnings = FALSE)
      
      rcppImportsStatement <- "Rcpp"
      
      # We'll enforce Rcpp > (installed version)
      ip <- installed.packages()
      if ("Rcpp" %in% rownames(ip))
         rcppImportsStatement <- sprintf("Rcpp (>= %s)", ip["Rcpp", "Version"])
      
      DESCRIPTION$Imports <- c(DESCRIPTION$Imports, rcppImportsStatement)
      DESCRIPTION$LinkingTo <- c(DESCRIPTION$LinkingTo, "Rcpp")
      
      # Add .registration = TRUE for Rcpp >= 0.12.11
      if (.rs.isPackageVersionInstalled("Rcpp", "0.12.11"))
         registration <- ", .registration = TRUE"
      else
         registration <- ""
      
      # Add an import from Rcpp, and also useDynLib
      NAMESPACE <- c(
         NAMESPACE,
         "importFrom(Rcpp, evalCpp)",
         sprintf("useDynLib(%s%s)", packageName, registration)
      )
   }
   
   # Get other fields from devtools options
   if (length(getOption("devtools.desc.suggests")))
      DESCRIPTION$Suggests <- getOption("devtools.desc.suggests")
   
   if (length(getOption("devtools.desc")))
   {
      devtools.desc <- getOption("devtools.desc")
      for (i in seq_along(devtools.desc))
      {
         name <- names(devtools.desc)[[i]]
         value <- devtools.desc[[i]]
         DESCRIPTION[[name]] <- value
      }
   }
   
   # If we are using 'testthat' and 'devtools' is available, use it to
   # add test infrastructure
   if ("testthat" %in% DESCRIPTION$Suggests)
   {
      dir.create(file.path(packageDirectory, "tests"))
      dir.create(file.path(packageDirectory, "tests", "testthat"))
      
      if ("devtools" %in% rownames(installed.packages()))
      {
         # NOTE: Okay to load devtools as we will restart the R session
         # soon anyhow
         ns <- asNamespace("devtools")
         if (exists("render_template", envir = ns))
         {
            tryCatch(
               writeLines(
                  devtools:::render_template(
                     "testthat.R",
                     list(name = packageName)
                  ),
                  file.path(packageDirectory, "tests", "testthat.R")
               ), error = function(e) NULL
            )
         }
      }
   }
   
   # If we are using the MIT license, add the template
   if (grepl("MIT\\s+\\+\\s+file\\s+LICEN[SC]E", DESCRIPTION$License, perl = TRUE))
   {
      # Guess the copyright holder
      holder <- if (!is.null(getOption("devtools.name")))
         Author
      else
         "<Copyright holder>"
      
      msg <- c(
         paste("YEAR:", format(Sys.time(), "%Y")),
         paste("COPYRIGHT HOLDER:", holder)
      )
      
      cat(msg,
          file = file.path(packageDirectory, "LICENSE"),
          sep = "\n")
   }
   
   # Always create 'R/', 'man/' directories
   dir.create(file.path(packageDirectory, "R"), showWarnings = FALSE)
   dir.create(file.path(packageDirectory, "man"))
   
   # If there were no source files specified, create a simple 'hello world'
   # function -- but only if the user hasn't implicitly opted into the 'devtools'
   # ecosystem
   if ((!length(getOption("devtools.desc"))) &&
       (!length(sourceFiles)))
   {
      
      # Some simple shortcuts that authors should know
      sysname <- Sys.info()[["sysname"]]
      
      buildShortcut <- if (sysname == "Darwin")
         "Cmd + Shift + B"
      else
         "Ctrl + Shift + B"
      
      checkShortcut <- if (sysname == "Darwin")
         "Cmd + Shift + E"
      else
         "Ctrl + Shift + E"
      
      testShortcut <- if (sysname == "Darwin")
         "Cmd + Shift + T"
      else
         "Ctrl + Shift + T"
      
      helloWorld <- .rs.trimCommonIndent('
         # Hello, world!
         #
         # This is an example function named \'hello\' 
         # which prints \'Hello, world!\'.
         #
         # You can learn more about package authoring with RStudio at:
         #
         #   http://r-pkgs.had.co.nz/
         #
         # Some useful keyboard shortcuts for package authoring:
         #
         #   Install Package:           \'%s\'
         #   Check Package:             \'%s\'
         #   Test Package:              \'%s\'
         
         hello <- function() {
           print(\"Hello, world!\")
         }
      ', buildShortcut, checkShortcut, testShortcut)
      
      cat(helloWorld,
          file = file.path(packageDirectory, "R", "hello.R"),
          sep = "\n")
      
      # Similarly, create a simple example .Rd for this 'hello world' function
      helloWorldRd <- .rs.trimCommonIndent('
         \\name{hello}
         \\alias{hello}
         \\title{Hello, World!}
         \\usage{
         hello()
         }
         \\description{
         Prints \'Hello, world!\'.
         }
         \\examples{
         hello()
         }
      ')
      
      cat(helloWorldRd,
          file = file.path(packageDirectory, "man", "hello.Rd"),
          sep = "\n")
      
      if (usingRcpp)
      {
         ## Ensure 'src/' directory exists
         if (!file.exists(file.path(packageDirectory, "src")))
            dir.create(file.path(packageDirectory, "src"))
         
         ## Write a 'hello world' for C++
         helloWorldCpp <- .rs.trimCommonIndent('
            #include <Rcpp.h>
            using namespace Rcpp;
            
            // This is a simple function using Rcpp that creates an R list
            // containing a character vector and a numeric vector.
            //
            // Learn more about how to use Rcpp at:
            //
            //   http://www.rcpp.org/
            //   http://adv-r.had.co.nz/Rcpp.html
            //
            // and browse examples of code using Rcpp at:
            // 
            //   http://gallery.rcpp.org/
            //

            // [[Rcpp::export]]
            List rcpp_hello() {
              CharacterVector x = CharacterVector::create("foo", "bar");
              NumericVector y   = NumericVector::create(0.0, 1.0);
              List z            = List::create(x, y);
              return z;
            }

         ')

         helloWorldDoc <- .rs.trimCommonIndent('
            \\name{rcpp_hello}
            \\alias{rcpp_hello}
            \\title{Hello, Rcpp!}
            \\usage{
            rcpp_hello()
            }
            \\description{
            Returns an \\R \\code{list} containing the character vector
            \\code{c("foo", "bar")} and the numeric vector \\code{c(0, 1)}.
            }
            \\examples{
            rcpp_hello()
            }
         ')
         
         cat(helloWorldCpp,
             file = file.path(packageDirectory, "src", "rcpp_hello.cpp"),
             sep = "\n")

         cat(helloWorldDoc,
             file = file.path(packageDirectory, "man", "rcpp_hello.Rd"),
             sep = "\n")
         
      }
   }
   else if (length(sourceFiles))
   {
      # Copy the source files to the appropriate sub-directory
      sourceFileExtensions <- tolower(gsub(".*\\.", "", sourceFiles, perl = TRUE))
      sourceDirs <- .rs.swap(
         sourceFileExtensions,
         "R" = c("r", "q", "s"),
         "src" = c("c", "cc", "cpp", "h", "hpp"),
         "vignettes" = c("rmd", "rnw"),
         "man" = "rd",
         "data" = c("rda", "rdata"),
         default = ""
      )
      
      copyPaths <- gsub("/+", "/", file.path(
         packageDirectory,
         sourceDirs,
         basename(sourceFiles)
      ))
      
      dirPaths <- dirname(copyPaths)
      
      success <- unlist(lapply(dirPaths, function(path) {
         
         if (isTRUE(file.info(path)$isdir))
            return(TRUE)
         
         dir.create(path, recursive = TRUE, showWarnings = FALSE)
         
      }))
      
      if (!all(success))
         return(.rs.error("Failed to create package directory structure"))
      
      success <- file.copy(sourceFiles, copyPaths)
      
      if (!all(success))
         return(.rs.error("Failed to copy one or more source files"))
   }
   
   # Write various files out
   
   # NOTE: write.dcf mangles whitespace so we manually construct
   # the text we wish to write out
   DESCRIPTION <- lapply(DESCRIPTION, function(field) {
      paste(field, collapse = "\n    ")
   })
   
   names <- names(DESCRIPTION)
   values <- unlist(DESCRIPTION)
   text <- paste(names, ": ", values, sep = "", collapse = "\n")
   cat(text, file = file.path(packageDirectory, "DESCRIPTION"), sep = "\n")
   
   cat(NAMESPACE, file = file.path(packageDirectory, "NAMESPACE"), sep = "\n")
   
   RprojPath <- file.path(
      packageDirectory,
      paste(packageName, ".Rproj", sep = "")
   )
   
   if (!.Call("rs_writeProjectFile", RprojPath, PACKAGE = "(embedding)"))
      return(.rs.error("Failed to create package .Rproj file"))
   
   # Ensure new packages get AutoAppendNewLine + StripTrailingWhitespace
   Rproj <- readLines(RprojPath)
   
   appendNewLineIndex <- grep("AutoAppendNewline:", Rproj, fixed = TRUE)
   if (length(appendNewLineIndex))
      Rproj[appendNewLineIndex] <- "AutoAppendNewline: Yes"
   else
      Rproj <- c(Rproj, "AutoAppendNewline: Yes")
   
   stripTrailingWhitespace <- grep("StripTrailingWhitespace:", Rproj, fixed = TRUE)
   if (length(stripTrailingWhitespace))
      Rproj[stripTrailingWhitespace] <- "StripTrailingWhitespace: Yes"
   else
      Rproj <- c(Rproj, "StripTrailingWhitespace: Yes")
   
   cat(Rproj, file = RprojPath, sep = "\n")
   
   # NOTE: this file is not always generated (e.g. people who have implicitly opted
   # into using devtools won't need the template file)
   if (file.exists(file.path(packageDirectory, "R", "hello.R")))
      .Call("rs_addFirstRunDoc", RprojPath, "R/hello.R", PACKAGE = "(embedding)")

   ## NOTE: This must come last to ensure the other package
   ## infrastructure bits have been generated; otherwise
   ## compileAttributes can fail
   if (usingRcpp &&
       .rs.isPackageVersionInstalled("Rcpp", "0.10.1") &&
       require(Rcpp, quietly = TRUE))
   {
      Rcpp::compileAttributes(packageDirectory)
      if (file.exists(file.path(packageDirectory, "src/rcpp_hello.cpp")))
         .Call("rs_addFirstRunDoc", RprojPath, "src/rcpp_hello.cpp", PACKAGE = "(embedding)")
   }
   
   .rs.success()
   
})


.rs.addFunction("secureDownloadMethod", function()
{
   # Function to determine whether R checks for 404 in libcurl calls
   libcurlHandles404 <- function() {
      getRversion() >= "3.3" && .rs.haveRequiredRSvnRev(69197)
   }

   # Check whether we are running R 3.2 and whether we have libcurl
   isR32 <- getRversion() >= "3.2"
   haveLibcurl <- isR32 && capabilities("libcurl") && libcurlHandles404()
   
   # Utility function to bind to libcurl or a fallback utility (e.g. wget)
   posixMethod <- function(utility) {
      if (haveLibcurl)
         "libcurl"
      else if (nzchar(Sys.which(utility)))
         utility
      else
         ""
   }
   
   # Determine the right secure download method per-system
   sysName <- Sys.info()[['sysname']]
   
   # For windows we prefer binding directly to wininet if we can (since
   # that doesn't rely on the value of setInternet2). If it's R <= 3.1
   # then we can use "internal" for https so long as internet2 is enabled 
   # (we don't use libcurl on Windows because it doesn't check certs).
   if (identical(sysName, "Windows")) {
      if (isR32)
         "wininet"
      else if (isTRUE(.rs.setInternet2(NA)))
         "internal"
      else
         ""
   }
   
   # For Darwin and Linux we use libcurl if we can and then fall back
   # to curl or wget as appropriate. We prefer libcurl because it honors
   # the same proxy configuration that "internal" does so it less likely
   # to break downloads for users behind proxy servers. 
   
   else if (identical(sysName, "Darwin")) {
      posixMethod("curl")
   }
   
   else if (identical(sysName, "Linux")) {
      method <- posixMethod("wget")
      if (!nzchar(method))
         method <- posixMethod("curl")
      method
   } 
   
   # Another OS, don't even attempt detection since RStudio currently
   # only runs on Windows, Linux, and Mac
   else {
      ""
   }
})

.rs.addFunction("autoDownloadMethod", function() {
   if (capabilities("http/ftp"))
      "internal"
   else if (nzchar(Sys.which("wget")))
      "wget"
   else if (nzchar(Sys.which("curl")))
      "curl"
   else
      ""
})

.rs.addFunction("isDownloadMethodSecure", function(method) {
   
   # resolve auto if needed
   if (identical(method, "auto"))
      method <- .rs.autoDownloadMethod()
   
   # check for methods known to work securely
   if (method %in% c("wininet", "libcurl", "wget", "curl")) {
      TRUE
   }
   
   # if internal then see if were using windows internal with inet2
   else if (identical(method, "internal")) {
      identical(Sys.info()[['sysname']], "Windows") && isTRUE(.rs.setInternet2(NA))
   }
   
   # method with unknown properties (e.g. "lynx") or unresolved auto
   else {
      FALSE
   }
})

.rs.addFunction("haveSecureDownloadFileMethod", function() {
   .rs.isDownloadMethodSecure(getOption("download.file.method", "auto"))
})

.rs.addFunction("showSecureDownloadWarning", function() {
   is.na(Sys.getenv("RSTUDIO_DISABLE_SECURE_DOWNLOAD_WARNING", unset = NA))
})

.rs.addFunction("insecureReposWarning", function(msg) {
   if (.rs.showSecureDownloadWarning()) {
      message("WARNING: ", msg, " You should either switch to a repository ",
              "that supports HTTPS or change your RStudio options to not require HTTPS ",
              "downloads.\n\nTo learn more and/or disable this warning ",
              "message see the \"Use secure download method for HTTP\" option ",
              "in Tools -> Global Options -> Packages.")
   }
})

.rs.addFunction("insecureDownloadWarning", function(msg) {
   if (.rs.showSecureDownloadWarning()) {
      message("WARNING: ", msg,
              "\n\nTo learn more and/or disable this warning ",
              "message see the \"Use secure download method for HTTP\" option ",
              "in Tools -> Global Options -> Packages.")
   }
})

.rs.addFunction("initSecureDownload", function() {
      
   # check if the user has already established a download.file.method and
   # if so verify that it is secure
   method <- getOption("download.file.method")
   if (!is.null(method)) {
      if (!.rs.isDownloadMethodSecure(method)) {
         .rs.insecureDownloadWarning(
             paste("The download.file.method option is \"", method, "\" ",
                   "however that method cannot provide secure (HTTPS) downloads ",
                   "on this platform. ", 
                   "This option was likely specified in .Rprofile or ",
                   "Rprofile.site so if you wish to change it you may need ",
                   "to edit one of those files.",
                   sep = "")
         )
      }
   } 
   
   # no user specified method, automatically set a secure one if we can
   else {
      secureMethod <- .rs.secureDownloadMethod()
      if (nzchar(secureMethod)) {
         options(download.file.method = secureMethod) 
         if (secureMethod == "curl")
            options(download.file.extra = .rs.downloadFileExtraWithCurlArgs())
      }
      else {
         .rs.insecureDownloadWarning(
            paste("Unable to set a secure (HTTPS) download.file.method (no",
                  "compatible method available in this installation of R).")
         )
      }
   }
})
   

.rs.addFunction("downloadFileExtraWithCurlArgs", function() {
   newArgs <- "-L -f -g"
   curArgs <- getOption("download.file.extra")
   if (!is.null(curArgs) && !grepl(newArgs, curArgs, fixed = TRUE))
      curArgs <- paste(newArgs, curArgs)
   curArgs
})

.rs.addFunction("setInternet2", function(value = NA) {
   
   # from R 3.3.x, 'setInternet2' is defunct and does nothing
   if (getRversion() >= "3.3.0")
      return(TRUE)
   
   # should only be called on Windows, but sanity check
   if (Sys.info()[["sysname"]] != "Windows")
      return(TRUE)
   
   # delegate to 'setInternet2'
   utils::setInternet2(value)
})

.rs.addFunction("availablePackages", function()
{
   # short-circuit for empty repositories case
   repos <- getOption("repos")
   if (length(repos) == 0) {
      value <- available.packages()
      attr(value, "time") <- Sys.time()
      return(list(state = "CACHED", value = value))
   }
   
   # figure out the current state. possibilities:
   #
   # - STALE:    we need to request available packages
   # - PENDING:  another process is requesting packages
   # - CACHED:   available packages ready in cache
   #
   reposString <- paste(deparse(repos), collapse = " ")
   state <- .rs.availablePackagesState(reposString)
   value <- switch(
      state,
      STALE   = .rs.onAvailablePackagesStale(reposString),
      PENDING = .rs.onAvailablePackagesPending(reposString),
      CACHED  = .rs.onAvailablePackagesCached(reposString),
      NULL
   )
   
   list(state = state, value = value)
})

.rs.addFunction("availablePackagesState", function(reposString)
{
   # do we have a cache entry?
   entry <- .rs.availablePackagesEnv[[reposString]]
   if (!is.null(entry)) {
      
      # verify the cache entry is not stale
      time <- attr(entry, "time", exact = TRUE)
      elapsed <- difftime(Sys.time(), time, units = "secs")
      limit <- as.numeric(Sys.getenv("R_AVAILABLE_PACKAGES_CACHE_CONTROL_MAX_AGE", 3600))
      
      if (elapsed > limit)
         return("STALE")
      else
         return("CACHED")
   }
   
   # do we have a pending dir? if none, we're stale
   dir <- .rs.availablePackagesPendingEnv[[reposString]]
   if (is.null(dir))
      return("STALE")
   
   # is the directory old? if so, assume the prior R process launched
   # to produce available.packages crashed or similar
   info <- file.info(dir)
   time <- info$mtime
   
   # in some cases, mtime may not be available -- in that case, fall
   # back to the time that was serialized when the process was launched
   #
   # https://github.com/rstudio/rstudio/issues/4312
   #
   # if all-else fails, just use the current time. this effectively means
   # that we will never mark the directory as 'stale', which means that
   # the dependency discovery feature may not work -- but at this point
   # there's not much else we can do
   if (is.na(time)) {
      time <- .rs.tryCatch(readRDS(file.path(dir, "time.rds")))
      if (inherits(time, "error"))
         time <- Sys.time()
   }
   
   # check to see if the directory is 'stale'
   diff <- difftime(Sys.time(), time, units = "secs")
   if (diff > 120)
      return("STALE")
   
   # we have a directory, and it's not too old -- we're waiting
   # for a new process to finish
   return("PENDING")
})

.rs.addFunction("onAvailablePackagesStale", function(reposString)
{
   # evict a stale cache entry (if any)
   .rs.availablePackagesEnv[[reposString]] <- NULL
   
   # defend against '@CRAN@' within the repositories, as this will
   # cause R to present the user with an interactive prompt when
   # invoking 'contrib.url()'
   repos <- getOption("repos")
   repos <- repos[repos != "@CRAN@"]
   
   # check and see if R has already queried available packages;
   # if so we can ask R for available packages as it will use
   # the cache
   paths <- vapply(repos, function(url) {
      sprintf("%s/repos_%s.rds", 
              tempdir(), 
              URLencode(contrib.url(url), TRUE)
   )
   }, FUN.VALUE = character(1))
   
   if (all(file.exists(paths))) {
      
      # request available packages
      packages <- if (getRversion() >= "3.5")
         available.packages(max_repo_cache_age = Inf)
      else
         available.packages()
      
      # note accessed time
      attr(packages, "time") <- Sys.time()
      
      # add it to the cache
      .rs.availablePackagesEnv[[reposString]] <- packages
      
      # we're done!
      packages
   }
   
   # prepare directory for discovery of available packages
   dir <- tempfile("rstudio-available-packages-")
   dir.create(dir, showWarnings = FALSE)
   .rs.availablePackagesPendingEnv[[reposString]] <- dir
   
   # mtime may be unreliable (or access could fail in some cases) so
   # instead serialize the current time to a file rather than relying on OS
   saveRDS(Sys.time(), file = file.path(dir, "time.rds"))
   
   # move there
   owd <- setwd(dir)
   on.exit(setwd(owd), add = TRUE)
   
   # define our helper script that will download + save available.packages
   template <- .rs.trimCommonIndent('
      options(repos = %s, pkgType = %s)
      packages <- available.packages()
      attr(packages, "time") <- Sys.time()
      saveRDS(packages, file = "packages.rds")
   ')
   
   script <- sprintf(
      template,
      .rs.deparse(getOption("repos")),
      .rs.deparse(getOption("pkgType"))
   )
   
   # fire off the process
   .rs.runAsyncRProcess(
      script,
      onCompleted = function(exitStatus) {
         
         # bail on error (don't log since this might occur
         # for reasons not actionable by the user; e.g. restarting
         # the R session while a lookup is happening)
         if (exitStatus)
            return()
         
         available <- .rs.onAvailablePackagesReady(reposString)
         data <- list(
            ready = .rs.scalar(TRUE),
            packages = rownames(available)
         )
         .rs.enqueClientEvent("available_packages_ready", data)
      }
   )
   
   # NULL indicates we don't have available packages yet
   return(NULL)
   
})

.rs.addFunction("onAvailablePackagesPending", function(reposString)
{
   # nothing to do here
   invisible(NULL)
})

.rs.addFunction("onAvailablePackagesReady", function(reposString)
{
   # get the directory and read packages.rds
   dir <- .rs.availablePackagesPendingEnv[[reposString]]
   rds <- file.path(dir, "packages.rds")
   
   # attempt to read the database and add it to the cache
   packages <- .rs.tryCatch(readRDS(rds))
   if (!inherits(packages, "error"))
      .rs.availablePackagesEnv[[reposString]] <- packages
   
   # remove state directory and mark as no longer pending
   unlink(dir, recursive = TRUE)
   .rs.availablePackagesPendingEnv[[reposString]] <- NULL
   
   # we're done!
   packages
})

.rs.addFunction("onAvailablePackagesCached", function(reposString)
{
   .rs.availablePackagesEnv[[reposString]]
})

.rs.addFunction("parseSecondaryReposIni", function(conf) {
   entries <- .rs.readIniFile(conf)
   repos <- list()

   for (entryName in names(entries)) {
     repo <- list(
        name  = .rs.scalar(trimws(entryName)),
        url = .rs.scalar(trimws(entries[[entryName]])),
        host = .rs.scalar("Custom"),
        country = .rs.scalar("")
     )

     if (identical(tolower(as.character(repo$name)), "cran")) {
        repo$name <- .rs.scalar("CRAN")
        repos <- append(list(repo), repos, 1)
     } else {
        repos[[length(repos) + 1]] <- repo
     }
   }

   repos
})

.rs.addFunction("parseSecondaryReposJson", function(conf) {
   lines <- readLines(conf)
   repos <- list()

   entries <- .rs.fromJSON(paste(lines, collpse = "\n"))

   for (entry in entries) {
      url <- if (is.null(entry$url)) "" else url

      repo <- list(
         name  = .rs.scalar(entry$name),
         url = .rs.scalar(url),
         host = .rs.scalar("Custom"),
         country = .rs.scalar("")
      )

      if (identical(tolower(as.character(repo$name)), "cran")) {
         repo$name <- .rs.scalar("CRAN")
         repos <- append(list(repo), repos, 1)
      } else {
         repos[[length(repos) + 1]] <- repo
      }
   }

   repos
})

.rs.addFunction("getSecondaryRepos", function(cran = getOption("repos")[[1]], custom = TRUE) {
   result <- list(
      repos = list()
   )
   
   rCranReposUrl <- .Call("rs_getCranReposUrl", PACKAGE = "(embedding)")
   isDefault <- identical(rCranReposUrl, NULL) || nchar(rCranReposUrl) == 0

   if (isDefault) {
      slash <- if (.rs.lastCharacterIs(cran, "/")) "" else "/"
      rCranReposUrl <- paste(slash, "../../__api__/repos", sep = "")
   }
   else {
      custom <- TRUE
   }

   if (.rs.startsWith(rCranReposUrl, "..") ||
       .rs.startsWith(rCranReposUrl, "/..")) {
      rCranReposUrl <- .rs.completeUrl(cran, rCranReposUrl)
   }

   if (custom) {
      conf <- tempfile(fileext = ".conf")
      
      result <- tryCatch({
         download.file(
            rCranReposUrl,
            conf,
            method = "curl",
            extra = "-H 'Accept: text/ini'",
            quiet = TRUE
         )
         
         result$repos <- .rs.parseSecondaryReposIni(conf)
         if (length(result$repos) == 0) {
            result$repos <- .rs.parseSecondaryReposJson(conf)
         }

         result
      }, error = function(e) {
         list(
            error = .rs.scalar(
               paste(
                  "Failed to process repos list from ",
                  rCranReposUrl, ". ", e$message, ".", sep = ""
               )
            )
         )
      })
   }

   result
})

.rs.addJsonRpcHandler("get_secondary_repos", function(cran, custom) {
   .rs.getSecondaryRepos(cran, custom)
})

.rs.addFunction("appendSlashIfNeeded", function(url) {
   slash <- if (.rs.lastCharacterIs(url, "/")) "" else "/"
   paste(url, slash, sep = "")
})

.rs.addJsonRpcHandler("validate_cran_repo", function(url) {
   packagesFile <- tempfile(fileext = ".gz")
   
   tryCatch({
      download.file(
         .rs.completeUrl(.rs.appendSlashIfNeeded(url), "src/contrib/PACKAGES.gz"),
         packagesFile,
         quiet = TRUE
      )

      .rs.scalar(TRUE)
   }, error = function(e) {
      .rs.scalar(FALSE)
   })
})

.rs.addJsonRpcHandler("is_package_installed", function(package, version)
{
   installed <- if (is.null(version))
      .rs.isPackageInstalled(package)
   else
      .rs.isPackageVersionInstalled(package, version)
   .rs.scalar(installed)
})

#
# This is the server logic of a Shiny web application. You can run the
# application by clicking 'Run App' above.
#
# Find out more about building applications with Shiny here:
#
#    http://shiny.rstudio.com/
#

library(shiny)

# Define server logic required to draw a histogram
shinyServer(function(input, output) {

    output$distPlot <- renderPlot({

        # generate bins based on input$bins from ui.R
        x    <- faithful[, 2]
        bins <- seq(min(x), max(x), length.out = input$bins + 1)

        # draw the histogram with the specified number of bins
        hist(x, breaks = bins, col = 'darkgray', border = 'white',
             xlab = 'Waiting time to next eruption (in mins)',
             main = 'Histogram of waiting times')

    })

})

#
# SessionFiles.R
#
# Copyright (C) 2021 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("listZipFile", function(zipfile)
{
   as.character(utils::unzip(zipfile, list=TRUE)$Name)
})


.rs.addFunction("createZipFile", function(zipfile, parent, files)
{
   # set working dir to parent (and restore on exit)
   previous_wd = getwd()
   setwd(parent)
   on.exit(setwd(previous_wd))
   
   # build zip command
   quotedFiles = paste(shQuote(files), collapse = " ")
   createZipCommand = paste("zip", "-r", shQuote(zipfile), quotedFiles, "2>&1")  
   
   # execute the command (return output of command)
   system(createZipCommand, intern = TRUE)
})

.rs.addJsonRpcHandler("list_all_files", function(path, pattern) {
   list.files(path, pattern = pattern, recursive = TRUE)
})

.rs.addJsonRpcHandler("ensure_file_exists", function(path)
{
   if (!file.exists(path))
      if (!file.create(path, recursive = TRUE))
         return(.rs.scalar(FALSE))
   
   .rs.scalar(identical(file.info(path)$isdir, FALSE))
})

.rs.addFunction("scanFiles", function(path,
                                      pattern,
                                      asRelativePath = TRUE,
                                      maxCount = 200L)
{
   .Call("rs_scanFiles",
         as.character(path),
         as.character(pattern),
         as.logical(asRelativePath),
         as.integer(maxCount))
})

.rs.addFunction("readLines", function(filePath)
{
   .Call("rs_readLines", path.expand(filePath))
})

#
# SessionDataPreview.R
#
# Copyright (C) 2009-18 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("preview_sql", function(code)
{
   # helper function for reporting errors
   onError <- function(reason) {
      .rs.scalar(.rs.truncate(reason))
   }
   
   # parse the user-provided code
   parsed <- .rs.tryCatch(parse(text = code)[[1]])
   if (inherits(parsed, "error"))
      return(onError("Failed to parse SQL preview comment."))
   
   # substitute missing arguments for NULL, so that match.call
   # does what we expect
   for (i in seq_along(parsed))
      if (identical(parsed[[i]], quote(expr = )))
         parsed[i] <- list(NULL)

   # attempt to match the call
   matched <- .rs.tryCatch(match.call(.rs.previewSql, parsed))
   if (inherits(matched, "error"))
      return(onError("Unexpected SQL preview comment."))
   
   # validate that the user provided a connection
   if (is.null(matched$conn))
      return(onError("No connection was specified in SQL preview comment."))
   
   # okay, try to evaluate it
   status <- .rs.tryCatch(eval(parsed, envir = globalenv()))
   if (inherits(status, "error"))
      return(onError(conditionMessage(status)))
   
   invisible(status)
})

.rs.addFunction("previewDataFrame", function(data, script)
{
   preparedData <- .rs.prepareViewerData(
      data,
      maxFactors = 100,
      maxCols = 100,
      maxRows = 1000
   )

   preview <- list(
      data = preparedData$data,
      columns = preparedData$columns,
      title = if (is.character(script)) .rs.scalar(script) else NULL
   )

   .rs.enqueClientEvent("data_output_completed", preview)
   
   invisible(NULL)

})

.rs.addFunction("previewSql", function(conn, statement, ...)
{
   script <- NULL
   if (file.exists(statement)) {
      script <- statement
      statement <- paste(readLines(script), collapse = "\n")
   }

   # remove comments since some drivers might not support them
   statement <- gsub("--[^\n]*\n+", "", statement)

   # force the connection to let DBI and others initialize S3
   conn <- .rs.tryCatch(force(conn))
   if (inherits(conn, "error")) {
      msg <- paste("Failed to retrieve connection:", conditionMessage(conn))
      return(.rs.scalar(msg))
   }

   # fetch at most 100 records as a preview
   status <- .rs.tryCatch({
      rs <- DBI::dbSendQuery(conn, statement = statement, ...)
      data <- DBI::dbFetch(rs, n = 1000)
      DBI::dbClearResult(rs)
   })
   
   if (inherits(status, "error")) {
      msg <- paste("Failed to query database:", conditionMessage(status))
      return(.rs.scalar(msg))
   }

   .rs.previewDataFrame(data, script)
})

#
# SessionSql.R
#
# Copyright (C) 2009-18 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar("sql.connectionBlacklist", new.env(parent = emptyenv()))

.rs.addJsonRpcHandler("sql_get_completions", function(...)
{
   .rs.sql.getCompletions(...)
})

.rs.addFunction("sql.getCompletions", function(line, conn, ctx)
{
   # extract token
   parts <- .rs.strsplit(line, "\\s+")
   token <- tail(parts, n = 1L)

   # trim out operators
   matches <- gregexpr("[-+*/%&|^=><]", token)[[1]]
   if (!identical(c(matches), -1L))
      token <- substring(token, tail(matches, n = 1L) + 1)
   
   # if we have a '.' in the token, then we're either trying
   # to complete field names from a table, or table names from
   # a schema. use the context keyword to figure out which
   if (grepl(".", token, fixed = TRUE))
   {
      if (.rs.sql.isTableScopedKeyword(ctx$contextKeyword))
         return(.rs.sql.getCompletionsTables(token, conn, ctx))
      else
         return(.rs.sql.getCompletionsFields(token, conn, ctx))
   }
   
   # if we're requesting completions within 'from', we either want
   # schemas or table names
   if (.rs.sql.isTableScopedKeyword(ctx$contextKeyword))
   {
      completions <- Reduce(.rs.appendCompletions, list(
         .rs.sql.getCompletionsTables(token, conn, ctx),
         .rs.sql.getCompletionsSchemas(token, conn, ctx)
      ))
      
      return(completions)
   }
   
   # otherwise, gather completions from other sources
   Reduce(.rs.appendCompletions, list(
      .rs.sql.getCompletionsKeywords(token, conn, ctx),
      .rs.sql.getCompletionsFields(token, conn, ctx),
      .rs.sql.getCompletionsTables(token, conn, ctx),
      .rs.sql.getCompletionsIdentifiers(token, conn, ctx)
   ))
})

.rs.addFunction("sql.getCompletionsKeywords", function(token, conn, ctx)
{
   if (!nzchar(token))
      return(.rs.emptyCompletions(language = "SQL"))
   
   # collect keywords (convert to lowercase to match token when appropriate)
   lowercase <- if (nzchar(token))
      identical(token, tolower(token))
   else
      ctx$preferLowercaseKeywords
    
   keywords <- if (lowercase)
      tolower(.rs.sql.keywords(conn))
   else
      toupper(.rs.sql.keywords(conn))
   
   results <- .rs.selectFuzzyMatches(keywords, token)
   .rs.makeCompletions(
      token = token,
      results = results,
      packages = "keyword",
      type = .rs.acCompletionTypes$KEYWORD,
      language = "SQL"
   )
})

.rs.addFunction("sql.getCompletionsSchemas", function(token, conn, ctx)
{
   conn <- .rs.sql.asDBIConnection(conn)
   if (is.null(conn))
      return(.rs.emptyCompletions(language = "SQL"))
   
   schemas <- .rs.tryCatch(.rs.db.listSchemas(conn))
   if (inherits(schemas, "error"))
      return(.rs.emptyCompletions(language = "SQL"))
   
   schemas <- setdiff(schemas, token)
   
   results <- .rs.selectFuzzyMatches(schemas, token)
   .rs.makeCompletions(
      token = token,
      results = results,
      packages = "schema",
      type = .rs.acCompletionTypes$ENVIRONMENT
   )
})

.rs.addFunction("sql.getCompletionsTables", function(token, conn, ctx)
{
   conn <- .rs.sql.asDBIConnection(conn)
   
   # if we have a '.' in the token, assume that we're attempting to
   # complete table names from a particular schema
   if (grepl(".", token, fixed = TRUE))
   {
      parts  <- .rs.strsplit(token, ".", fixed = TRUE)
      schema <- parts[[1]]
      token  <- parts[[2]]
      
      tables <- .rs.tryCatch(.rs.db.listTables(conn, schema))
      if (inherits(tables, "error"))
         return(.rs.emptyCompletions(language = "SQL"))
      
      results <- .rs.selectFuzzyMatches(tables, token)
      completions <- .rs.makeCompletions(
         token = token,
         results = results,
         packages = "table",
         type = .rs.acCompletionTypes$DATAFRAME
      )
      
      return(completions)
   }
   
   # use context-completed tables by default
   tables <- as.character(ctx$tables)
   
   # attempt to derive table names from connection
   if (!is.null(conn))
   {
      listedTables <- .rs.sql.listTables(conn)
      if (length(listedTables))
         tables <- listedTables
   }
   
   # add in alias names since the user might want to use those in lieu
   # of the 'real' table name in certain contexts
   tables <- c(tables, names(ctx$aliases))
   
   # remove current token as candidate
   tables <- setdiff(tables, token)
   
   results <- .rs.selectFuzzyMatches(tables, token)
   .rs.makeCompletions(
      token = token,
      results = results,
      packages = "table",
      type = .rs.acCompletionTypes$DATAFRAME
   )
})

.rs.addFunction("sql.getCompletionsFields", function(token, conn, ctx)
{
   conn <- .rs.sql.asDBIConnection(conn)
   if (is.null(conn))
      return(.rs.emptyCompletions(language = "SQL"))
   
   # if we have a '.' in the token, then only retrieve
   # completions from the requested table
   tables <- ctx$tables
   if (grepl(".", token, fixed = TRUE))
   {
      parts <- .rs.strsplit(token, ".", fixed = TRUE)
      tables <- parts[[length(parts) - 1]]
      token  <- parts[[length(parts) - 0]]
   }
   
   Reduce(.rs.appendCompletions, lapply(tables, function(table) {
      
      # if this table is an alias, find the 'true' table name
      if (table %in% names(ctx$aliases))
         table <- ctx$aliases[[table]]
      
      # if we know the schema associated with this table, then use it
      schema <- ctx$schemas[[match(table, ctx$tables)]]
      
      # retireve fields
      fields <- .rs.tryCatch(.rs.db.listFields(conn, schema = schema, table = table))
      if (inherits(fields, "error"))
         return(.rs.emptyCompletions(language = "SQL"))
      
      fields <- setdiff(fields, token)
      
      .rs.makeCompletions(
         token = token,
         results = .rs.selectFuzzyMatches(fields, token),
         packages = table,
         type = .rs.acCompletionTypes$DATASET
      )
      
   }))
   
})

.rs.addFunction("sql.getCompletionsIdentifiers", function(token, conn, ctx)
{
   identifiers <- setdiff(as.character(ctx$identifiers), token)
   results <- .rs.selectFuzzyMatches(identifiers, token)
   .rs.makeCompletions(
      token = token,
      results = results,
      type = .rs.acCompletionTypes$CONTEXT,
      language = "SQL"
   )
})

.rs.addFunction("sql.listTables", function(conn)
{
   conn <- .rs.sql.asDBIConnection(conn)
   if (is.null(conn))
      return(character())
   
   # purge any disconnected connections (avoid keeping a live reference)
   keys <- ls(envir = .rs.sql.connectionBlacklist)
   for (key in keys)
      if (!DBI::dbIsValid(.rs.sql.connectionBlacklist[[key]]))
         rm(key, envir = .rs.sql.connectionBlacklist)
   
   # if the user has opted out of completions altogether
   # then just use context completions
   timeout <- as.numeric(getOption("sql.completion.timeout", 2))
   if (timeout == 0)
      return(character())
   
   # check and see whether we've blacklisted this connection
   id <- digest::digest(conn)
   if (!is.null(.rs.sql.connectionBlacklist[[id]]))
      return(character())
   
   # request completions; if we take too long then blacklist further
   # attempts to get completions
   time <- system.time(tables <- .rs.tryCatch(DBI::dbListTables(conn)))
   if (time[["user.self"]] > timeout)
   {
      .rs.sql.connectionBlacklist[[id]] <- conn
      return(character())
   }
   
   # we got completions in time; use them
   if (inherits(tables, "error"))
      return(character())
   
   tables
})

.rs.addFunction("sql.keywords", function(conn)
{
   # allow users to define their own set of keywords if preferred
   keywords <- getOption("sql.keywords")
   if (is.function(keywords))
   {
      if (length(formals(keywords)))
         return(keywords(conn))
      else
         return(keywords())
   }
   else if (is.character(keywords))
   {
      return(keywords)
   }
   
   if ("DBI" %in% loadedNamespaces()) {
      DBI <- asNamespace("DBI")
      keywords <- DBI$.SQL92Keywords
      if (is.character(keywords))
         return(keywords)
   }
   
   # NOTE: these are the keywords understood by SQLite, as per
   # https://www.sqlite.org/lang_keywords.html
   c(
      "ABORT", "ACTION", "ADD", "AFTER", "ALL", "ALTER", "ANALYZE", "AND",
      "AS", "ASC", "ATTACH", "AUTOINCREMENT", "BEFORE", "BEGIN", "BETWEEN",
      "BY", "CASCADE", "CASE", "CAST", "CHECK", "COLLATE", "COLUMN", "COMMIT",
      "CONFLICT", "CONSTRAINT", "CREATE", "CROSS", "CURRENT_DATE", "CURRENT_TIME",
      "CURRENT_TIMESTAMP", "DATABASE", "DEFAULT", "DEFERRABLE", "DEFERRED",
      "DELETE", "DESC", "DETACH", "DISTINCT", "DROP", "EACH", "ELSE", "END",
      "ESCAPE", "EXCEPT", "EXCLUSIVE", "EXISTS", "EXPLAIN", "FAIL", "FOR",
      "FOREIGN", "FROM", "FULL", "GLOB", "GROUP", "HAVING", "IF", "IGNORE",
      "IMMEDIATE", "IN", "INDEX", "INDEXED", "INITIALLY", "INNER", "INSERT",
      "INSTEAD", "INTERSECT", "INTO", "IS", "ISNULL", "JOIN", "KEY", "LEFT",
      "LIKE", "LIMIT", "MATCH", "NATURAL", "NO", "NOT", "NOTNULL", "NULL", "OF",
      "OFFSET", "ON", "OR", "ORDER", "OUTER", "PLAN", "PRAGMA", "PRIMARY", "QUERY",
      "RAISE", "RECURSIVE", "REFERENCES", "REGEXP", "REINDEX", "RELEASE", "RENAME",
      "REPLACE", "RESTRICT", "RIGHT", "ROLLBACK", "ROW", "SAVEPOINT", "SELECT",
      "SET", "TABLE", "TEMP", "TEMPORARY", "THEN", "TO", "TRANSACTION", "TRIGGER",
      "UNION", "UNIQUE", "UPDATE", "USING", "VACUUM", "VALUES", "VIEW", "VIRTUAL",
      "WHEN", "WHERE", "WITH", "WITHOUT"
   )
})

.rs.addFunction("sql.asDBIConnection", function(conn)
{
   if (inherits(conn, "DBIConnection"))
      return(conn)
   
   if (is.character(conn))
   {
      if (!requireNamespace("DBI", quietly = TRUE))
         return(NULL)
      
      conn <- .rs.tryCatch(eval(parse(text = conn), envir = globalenv()))
      if (inherits(conn, "error"))
         return(NULL)
   }
   
   conn
})

.rs.addFunction("db.listFields", function(conn, schema = NULL, table = NULL)
{
   if (length(schema) && nzchar(schema))
   {
      # work around an issue in odbc when attempting to list fields using a qualified ID
      if ("odbc" %in% loadedNamespaces() && inherits(conn, "OdbcConnection"))
      {
         columns <- odbc:::connection_sql_columns(
            conn@ptr,
            schema_name = schema,
            table_name = table
         )
         return(columns[["name"]])
      }
      
      # otherwise, use the regular DBI interface
      return(DBI::dbListFields(conn, DBI::Id(schema = schema, table = table)))
   }
   
   # no schema: just use the regular API
   DBI::dbListFields(conn, table)
})

.rs.addFunction("db.listSchemas", function(conn)
{
   # work around issue in odbc where schema names are not returned as part
   # of DBI::dbListObjects()
   if ("odbc" %in% loadedNamespaces() && inherits(conn, "OdbcConnection"))
   {
      objects <- odbc::odbcListObjects(conn)
      return(objects$name[objects$type == "schema"])
   }
   
   objects <- DBI::dbListObjects(conn)
   items <- Filter(function(x) "schema" %in% names(x@name), objects$table)
   schemas <- vapply(items, function(item) item@name[["schema"]],  character(1))
   
   # for RSQLite connections, also list databases
   if ("RSQLite" %in% loadedNamespaces() && inherits(conn, "SQLiteConnection"))
   {
      databases <- DBI::dbGetQuery(conn, "PRAGMA database_list;")
      schemas <- unique(c(databases$name, schemas))
   }
   
   schemas
})

.rs.addFunction("db.listTables", function(conn, schema = NULL)
{
   # work around issue in odbc where requests for table names
   # faile when a schema is specified
   if ("odbc" %in% loadedNamespaces() && inherits(conn, "OdbcConnection"))
      return(odbc::dbListTables(conn, schema = schema))
   
   objects <- DBI::dbListObjects(conn, DBI::Id(schema = schema))
   vapply(objects$table, function(object) tail(object@name, n = 1), character(1))
})

.rs.addFunction("sql.isTableScopedKeyword", function(keyword) {
   keyword %in% c("from", "into", "join", "update", "drop")
})

library(Matrix)

env <- function(...) {
   list2env(list(...))
}

object <- list(
   integer = c(a = 1L, b = 2L, c = 3L),
   double  = 1,
   string  = "string",
   symbol  = as.name("symbol"),
   list    = list(1, 2, 3),
   environment = env(a = 1, b = 2, c = 3),
   expression = quote(1 + 1),
   formula = y ~ x + 1,
   factor = factor(letters),
   ordered = ordered(letters),
   closure = function() {},
   primitive = c
)

# debug(.rs.rpc.explorer_inspect_object)
context <- .rs.explorer.createContext(recursive = 1)
i <- .rs.explorer.inspectObject(object, context)
.rs.explorer.viewObject(object)

library(xml2)
doc <- read_xml("<root id='1'><child id ='a' /><child id='b' d='b'/></root>")
.rs.explorer.viewObject(doc)

f <- function(x) {
   c(1)
   c(2)
   c(3)
}

context <- .rs.explorer.createContext(recursive = 1)
inspected <- .rs.explorer.inspectObject(f, context)
str(inspected)
.rs.explorer.viewObject(f)

.rs.explorer.viewObject(rnorm)

big <- replicate(1000, setNames(letters, LETTERS), simplify = FALSE)
context <- .rs.explorer.createContext(recursive = 1)
i <- .rs.explorer.inspectObject(big, context)
.rs.explorer.viewObject(big)

#
# ModuleTools.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("enqueClientEvent", function(type, data = NULL)
{
   .Call("rs_enqueClientEvent", type, data, PACKAGE = "(embedding)")
})

.rs.addFunction("invokeRpc", function(method, ...) 
{
   # callback to session to invoke RPC
   args <- list(...)
   .Call("rs_invokeRpc", method, .rs.scalarListFromList(args), PACKAGE = "(embedding)")
})

.rs.addFunction("showErrorMessage", function(title, message)
{
   .Call("rs_showErrorMessage", title, message, PACKAGE = "(embedding)")
})

.rs.addFunction("logErrorMessage", function(message)
{
   .Call("rs_logErrorMessage", message, PACKAGE = "(embedding)")
})

.rs.addFunction("logWarningMessage", function(message)
{
   .Call("rs_logWarningMessage", message, PACKAGE = "(embedding)")
})

.rs.addFunction("format", function(object, ...)
{
   if (is.symbol(object))
      as.character(object)
   else
      base::format.default(object, ...)
})

.rs.addFunction("getSignature", function(object)
{
   signature <- .rs.format(base::args(object))
   length(signature) <- length(signature) - 1
   trimmed <- gsub("^\\s+", "", signature)
   paste(trimmed, collapse = "")
})

# Wrap a return value in this to give a hint to the
# JSON serializer that one-element vectors should be
# marshalled as scalar types instead of arrays
.rs.addFunction("scalar", function(obj)
{
   if (!is.null(obj))
      class(obj) <- 'rs.scalar'
   return(obj)
})

.rs.addFunction("validateAndNormalizeEncoding", function(encoding)
{
   iconvList <- toupper(iconvlist())
   encodingUpper <- toupper(encoding)
   if (encodingUpper %in% iconvList)
   {
      return (encodingUpper)
   }
   else
   {
      encodingUpper <- gsub("[_]", "-", encodingUpper)
      if (encodingUpper %in% iconvList)
         return (encodingUpper)
      else
         return ("")
   }
})

.rs.addFunction("usingUtf8Charset", function()
{
   l10n_info()$`UTF-8` || identical(utils::localeToCharset(), "UTF-8")
})


.rs.addFunction("isRtoolsOnPath", function()
{
   # ensure that the Rtools utility 'bin' directory is on the PATH
   # (this is just a heuristic but works okay in general)
   if (!nzchar(Sys.which("ls.exe")))
      return(FALSE)
   
   # for newer versions of R, ensure that BINPREF is set
   # (since BINPREF may be going away in R 4.0.0 we don't require its
   # existence here)
   rv <- getRversion()
   if (rv >= "3.3.0" && rv < "4.0.0")
   {
      if (is.na(Sys.getenv("BINPREF", unset = NA)))
         return(FALSE)
   }
   
   # for older versions of R (with the old toolchain) check for 'gcc.exe'
   # on the PATH (assuming the old, multilib-variant of gcc)
   if (rv < "3.3.0")
   {
      if (!nzchar(Sys.which("gcc.exe")))
         return(FALSE)
   }
   
   # survived all checks; return TRUE
   TRUE
})

.rs.addFunction("getPackageFunction", function(name, packageName)
{
   tryCatch(eval(parse(text=paste(packageName, ":::", name, sep=""))),
            error = function(e) NULL)
})

.rs.addFunction("libPathsString", function()
{
   paste(.libPaths(), collapse = .Platform$path.sep)
})

.rs.addFunction("parseLinkingTo", function(linkingTo)
{
   if (is.null(linkingTo))
      return (character())

   linkingTo <- strsplit(linkingTo, "\\s*\\,")[[1]]
   result <- gsub("\\s", "", linkingTo)
   gsub("\\(.*", "", result)
})


.rs.addFunction("isPackageInstalled", function(name, libLoc = NULL)
{
   paths <- vapply(name, FUN.VALUE = character(1), USE.NAMES = FALSE, function(pkg) {
      system.file(package = pkg, lib.loc = libLoc)
   })
   nzchar(paths)
})

.rs.addFunction("isPackageVersionInstalled", function(name, version) {  
  .rs.isPackageInstalled(name) && (.rs.getPackageVersion(name) >= version)
})

.rs.addFunction("packageCRANVersionAvailable", function(name, version, source) {
  # get the specified CRAN repo
  repo <- NA
  repos <- getOption("repos")
  # the repos option is canonically a named character vector, but could also
  # be a named list
  if (is.character(repos) || is.list(repos)) {
    # check for a repo named "CRAN"
    repo <- as.character(repos["CRAN"])

    # if no repo named "CRAN", blindly guess that the first repo is a CRAN mirror 
    if (length(repo) < 1 || is.na(repo)) {
      repo <- as.character(repos[[1]])
    }
  }

  # if no default repo and no repo marked CRAN, give up
  if (length(repo) < 1 || is.na(repo)) {
    return(list(version = "", satisfied = FALSE))
  }

  # get the available packages and extract the version information
  type <- ifelse(source, "source", getOption("pkgType"))
  pkgs <- available.packages(
            contriburl = contrib.url(repo, type = type))
  if (!(name %in% row.names(pkgs))) {
    return(list(version = "", satisfied = FALSE))
  }
  pkgVersion <- pkgs[name, "Version"]
  return(list(
    version = pkgVersion, 
    satisfied = package_version(pkgVersion) >= package_version(version)))
})

.rs.addFunction("packageVersionString", function(pkg) {
   as.character(packageVersion(pkg))
})

.rs.addFunction("getPackageCompatStatus", 
  function(name, packageVersion, protocolVersion) 
  {  
     if (!.rs.isPackageInstalled(name))
       return(1L)  # COMPAT_MISSING
     else if (!.rs.getPackageVersion(name) >= packageVersion) 
       return(2L)  # COMPAT_TOO_OLD
     else if (!.rs.getPackageRStudioProtocol(name) >= protocolVersion) 
       return(3L)  # COMPAT_TOO_NEW
     return (0L)   # COMPAT_OK
  }
)

.rs.addFunction("getPackageRStudioProtocol", function(name) {

   ## First check to see if the package has a 'rstudio-protocol' file
   path <- system.file("rstudio/rstudio-protocol", package = name)
   if (path != "") {
      tryCatch(
         expr = {
            return(as.integer(read.dcf(path, all = TRUE)$Version))
         },
         warning = function(e) {},
         error = function(e) {}
      )
   }

   ## Otherwise, check the namespace
   needsUnloadAfter <- !(name %in% loadedNamespaces())
   rpv <- ".RStudio_protocol_version"
   env <- asNamespace(name)
   if (exists(rpv, envir = env, mode = "integer")) {
      version <- get(rpv, envir = env)
   } else {
      version <- 0L
   }
   if (needsUnloadAfter)
      unloadNamespace(name)
   version
})

.rs.addFunction("rstudioIDEPackageRequiresUpdate", function(name, sha1) {
   
  if (.rs.isPackageInstalled(name))
  {
     f <- utils::packageDescription(name, fields=c("Origin", "GithubSHA1"))
     identical(f$Origin, "RStudioIDE") && !identical(f$GithubSHA1, sha1)
  }
  else
  {
     TRUE
  }
})

.rs.addFunction("updateRStudioIDEPackage", function(name, archive)
{
  pkgDir <- find.package(name)
  .rs.forceUnloadPackage(name)
  .Call("rs_installPackage",  archive, dirname(pkgDir), PACKAGE = "(embedding)")
})


.rs.addFunction("userPrompt", function(type,
                                       caption,
                                       message,
                                       yesLabel = NULL,
                                       noLabel = NULL,
                                       includeCancel = FALSE,
                                       yesIsDefault = TRUE) {

   if (identical(type, "info"))
      type <- 1
   else if (identical(type, "warning"))
      type <- 2
   else if (identical(type, "error"))
      type <- 3
   else if (identical(type, "question"))
      type <- 4
   else
      stop("Invalid type specified")

   result <- .Call("rs_userPrompt",
         type,
         caption,
         message,
         yesLabel,
         noLabel,
         includeCancel,
         yesIsDefault, PACKAGE = "(embedding)")

   if (result == 0)
      "yes"
   else if (result == 1)
      "no"
   else if (result == 2)
      "cancel"
   else
      stop("Invalid result")
})

.rs.addFunction("restartR", function(afterRestartCommand = "") {
   afterRestartCommand <- paste(as.character(afterRestartCommand),
                                collapse = "\n")
   .Call("rs_restartR", afterRestartCommand, PACKAGE = "(embedding)")
})

.rs.addFunction("markdownToHTML", function(content) {
   .Call("rs_markdownToHTML", content, PACKAGE = "(embedding)")
})

.rs.addFunction("readPrefInternal", function(method, prefName) {
  if (missing(prefName) || is.null(prefName))
    stop("No preference name supplied")
  .Call(method, prefName, PACKAGE = "(embedding)")
})

.rs.addFunction("writePrefInternal", function(method, prefName, value) {
  if (missing(prefName) || is.null(prefName))
    stop("No preference name supplied")
  if (missing(value))
    stop("No value supplied")
  invisible(.Call(method, prefName, .rs.scalar(value), PACKAGE = "(embedding)"))
})

.rs.addFunction("readApiPref", function(prefName) {
  .rs.readPrefInternal("rs_readApiPref", prefName)
})

.rs.addFunction("writeApiPref", function(prefName, value) {
  .rs.writePrefInternal("rs_writeApiPref", prefName, value)
})

.rs.addFunction("readUiPref", function(prefName) {
  .rs.readPrefInternal("rs_readUserPref", prefName)
})
.rs.addFunction("readUserPref", .rs.readUiPref)

.rs.addFunction("writeUiPref", function(prefName, value) {
  # some preferences can take values that are lists of scalars; ensure the deserializer treats lists
  # accordingly                 
  if (is.list(value)) {
     value <- .rs.scalarListFromList(value)
  }
  .rs.writePrefInternal("rs_writeUserPref", prefName, value)
})
.rs.addFunction("writeUserPref", .rs.writeUiPref)

.rs.addFunction("readUserState", function(stateName) {
  if (missing(stateName) || is.null(stateName))
    stop("No state name supplied")
  .Call("rs_readUserState", stateName, PACKAGE = "(embedding)")
})

.rs.addFunction("allPrefs", function() {
  .Call("rs_allPrefs", PACKAGE = "(embedding)")
})

.rs.addFunction("writeUserState", function(stateName, value) {
  if (missing(stateName) || is.null(stateName))
    stop("No state name supplied")
  if (missing(value))
    stop("No value supplied")
  invisible(.Call("rs_writeUserState", stateName, .rs.scalar(value), PACKAGE = "(embedding)"))
})

.rs.addFunction("removePref", function(prefName) {
  if (missing(prefName) || is.null(prefName))
    stop("No preference name supplied")
  invisible(.Call("rs_removePref", prefName, PACKAGE = "(embedding)"))
})

.rs.addFunction("setUsingMingwGcc49", function(usingMingwGcc49) {
  invisible(.Call("rs_setUsingMingwGcc49", usingMingwGcc49, PACKAGE = "(embedding)"))
})


.rs.addGlobalFunction("rstudioDiagnosticsReport", function() {
  invisible(.Call(getNativeSymbolInfo("rs_sourceDiagnostics", PACKAGE="")))
})


.rs.addFunction("pandocSelfContainedHtml", function(input, template, output) {
   
   # make input file path absolute
   input <- normalizePath(input)

   # create a temporary copy of the file for conversion
   inputFile <- tempfile(tmpdir = dirname(input), fileext = ".html")
   on.exit(unlink(inputFile), add=TRUE)
   inputLines <- readLines(con = input, warn = FALSE)

   # write all the lines from the input except the DOCTYPE declaration, which pandoc will not treat
   # as HTML (starting in pandoc 2)
   writeLines(text = inputLines[!grepl("<!DOCTYPE", inputLines, fixed = TRUE)],
              con  = inputFile)

   # ensure output file exists and make its path absolute
   if (!file.exists(output))
      file.create(output)
   output <- normalizePath(output)
   
   # convert from markdown to html to get base64 encoding. note there is no markdown in the source
   # document but we still need to do this "conversion" to get the base64 encoding; we also don't
   # want to convert from HTML since that will cause pandoc to convert only the <body>
   args <- c(inputFile)
   args <- c(args, "--from", "markdown_strict")
   args <- c(args, "--output", output)

   # define a title for the document. this value is not actually consumed by the template, but
   # pandoc requires it in metadata when converting to HTML, so supply a dummy value to keep the
   # output clean.
   args <- c(args, "--metadata", "title:RStudio")
   
   # set stack size
   stack_size <- getOption("pandoc.stack.size", default = "512m")
   args <- c(c("+RTS", paste0("-K", stack_size), "-RTS"), args)
   
   # additional options
   args <- c(args, "--self-contained")
   args <- c(args, "--template", template)
   
   # build the conversion command
   pandoc <- file.path(Sys.getenv("RSTUDIO_PANDOC"), "pandoc")
   command <- paste(shQuote(c(pandoc, args)), collapse = " ")
   
   # setwd temporarily
   wd <- getwd()
   on.exit(setwd(wd), add = TRUE)
   setwd(dirname(inputFile))
   
   # execute it
   result <- system(command)
   if (result != 0) {
      stop("pandoc document conversion failed with error ", result,
           call. = FALSE)
   }
   
   # return output file
   invisible(output)
})

# create an environment to hold original versions of S3 functions we have overridden
assign(".rs.S3Originals", new.env(parent = emptyenv()), envir = .rs.toolsEnv())

# create an environment to hold current S3 overrides
assign(".rs.S3Overrides", new.env(parent = emptyenv()), envir = .rs.toolsEnv())

if (getRversion() < "3.5") {
   # prior to R 3.5, we can override S3 methods just by installing the override function into the
   # tools:rstudio namespace, which is on the search path
   .rs.addFunction("addS3Override", function(name, method) {
      assign(name, method, envir = .rs.toolsEnv())
   })

   .rs.addFunction("removeS3Override", function(name) {
      if (exists(name, envir = .rs.toolsEnv(), inherits = FALSE)) {
         rm(list = name, envir = .rs.toolsEnv(), inherits = FALSE)
      }
   })

   .rs.addFunction("reattachS3Overrides", function() {
      # S3 methods on the search path maintain precedence
   })
} else {
   # after R 3.5, S3 methods are not discovered on the search path, so we resort to injecting our
   # overrides directly into the base namespace's S3 methods table
   .rs.addFunction("addS3Override", function(name, method) {
      # get a reference to the table of S3 methods stored in the base namespace
      table <- .BaseNamespaceEnv[[".__S3MethodsTable__."]]

      # cache old dispatch table entry if it exists
      if (exists(name, envir = table)) {
         assign(name, get(name, envir = table), envir = .rs.S3Originals)
      }

      # add a flag indicating that this method belongs to us
      attr(method, ".rs.S3Override") <- TRUE

      # ... and inject our own entry
      assign(name, method, envir = table)

      # make a copy in our override table so we can restore when overwritten by e.g. an attached
      # package
      assign(name, method, envir = .rs.S3Overrides)

      invisible(NULL)
   })

   .rs.addFunction("removeS3Override", function(name) {
      table <- .BaseNamespaceEnv[[".__S3MethodsTable__."]]

      # see if there's an override to remove; if not, no work to do
      if (!exists(name, envir = table))
         return(invisible(NULL))
      
      # see if the copy that exists in the methods table is one that we put there.
      if (!isTRUE(attr(get(name, envir = table), ".rs.S3Override", exact = TRUE)))
      {
         # it isn't, so don't touch it. we do this so that changes to the S3 dispatch table that
         # have occurred since the call to .rs.addS3Override are persisted
         return(invisible(NULL))
      }

      # see if we have a copy to restore
      if (exists(name, envir = .rs.S3Originals))
      {
         # we do, so overwrite with our copy
         assign(name, get(name, envir = .rs.S3Originals), envir = table)
      }
      else
      {
         # no copy to restore, so just remove from the dispatch table
         rm(list = name, envir = table)
      }

      # remove from our override table if present
      if (exists(name, envir = .rs.S3Overrides))
         rm(list = name, envir = .rs.S3Overrides)

      invisible(NULL)
   })

   # recovers from changes made to the S3 method dispatch table during e.g. package load
   .rs.addFunction("reattachS3Overrides", function() {
      # get a list of all of the methods that are currently overridden
      names <- ls(envir = .rs.S3Overrides)
      table <- .BaseNamespaceEnv[[".__S3MethodsTable__."]]
      for (name in names) {
         if (exists(name, envir = table)) {
            # retrieve reference to method
            method = get(name, envir = table)

            # if we didn't put the method there, we've been replaced; reattach our own method. 
            if (!isTRUE(attr(get(name, envir = table), ".rs.S3Override", exact = TRUE)))
               .rs.addS3Override(name, get(name, envir = .rs.S3Overrides))
         }
      }
   })
}

.rs.addFunction("sessionModulePath", function() {
   .Call("rs_sessionModulePath", PACKAGE = "(embedding)")
})

import IJulia

# The julia kernel has built in support for Revise.jl, so this is the 
# recommended approach for long-running sessions:
# https://github.com/JuliaLang/IJulia.jl/blob/9b10fa9b879574bbf720f5285029e07758e50a5e/src/kernel.jl#L46-L51

# Users should enable revise within .julia/config/startup_ijulia.jl:
# https://timholy.github.io/Revise.jl/stable/config/#Using-Revise-automatically-within-Jupyter/IJulia-1

# clear console history
IJulia.clear_history()

fig_width = {0}
fig_height = {1}
fig_format = :{2}
fig_dpi = {3}

# no retina format type, use svg for high quality type/marks
if fig_format == :retina
  fig_format = :svg
elseif fig_format == :pdf
  fig_dpi = 96
  # Enable PDF support for IJulia
  IJulia.register_mime(MIME("application/pdf"))
end

# convert inches to pixels
fig_width = fig_width * fig_dpi
fig_height = fig_height * fig_dpi

# Intialize Plots w/ default fig width/height
try
  import Plots

  # Plots.jl doesn't support PDF output for versions < 1.28.1
  # so use png (if the DPI remains the default of 300 then set to 96)
  if (Plots._current_plots_version < v"1.28.1") & (fig_format == :pdf)
    Plots.gr(size=(fig_width, fig_height), fmt = :png, dpi = fig_dpi)
  else
    Plots.gr(size=(fig_width, fig_height), fmt = fig_format, dpi = fig_dpi)
  end
catch e
  # @warn "Plots init" exception=(e, catch_backtrace())
end

# Initialize CairoMakie with default fig width/height
try
  import CairoMakie
  
  CairoMakie.activate!(type = string(fig_format))
  CairoMakie.update_theme!(resolution=(fig_width, fig_height))
catch e
    # @warn "CairoMakie init" exception=(e, catch_backtrace())
end
  
# Set run_path if specified
try
  run_path = raw"{4}"
  if !isempty(run_path)
    cd(run_path)
  end
catch e
  @warn "Run path init:" exception=(e, catch_backtrace())
end


# emulate old Pkg.installed beahvior, see
# https://discourse.julialang.org/t/how-to-use-pkg-dependencies-instead-of-pkg-installed/36416/9
import Pkg
function isinstalled(pkg::String)
  any(x -> x.name == pkg && x.is_direct_dep, values(Pkg.dependencies()))
end

# ojs_define
if isinstalled("JSON") && isinstalled("DataFrames")
  import JSON, DataFrames
  global function ojs_define(; kwargs...)
    convert(x) = x
    convert(x::DataFrames.AbstractDataFrame) = Tables.rows(x)
    content = Dict("contents" => [Dict("name" => k, "value" => convert(v)) for (k, v) in kwargs])
    tag = "<script type='ojs-define'>$(JSON.json(content))</script>"
    IJulia.display(MIME("text/html"), tag)
  end
elseif isinstalled("JSON")
  import JSON
  global function ojs_define(; kwargs...)
    content = Dict("contents" => [Dict("name" => k, "value" => v) for (k, v) in kwargs])
    tag = "<script type='ojs-define'>$(JSON.json(content))</script>"
    IJulia.display(MIME("text/html"), tag)
  end
else
  global function ojs_define(; kwargs...)
    @warn "JSON package not available. Please install the JSON.jl package to use ojs_define."
  end
end


# don't return kernel dependencies (b/c Revise should take care of dependencies)
nothing

#
# SessionProfiler.R
#
# Copyright (C) 2009-16 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("profileResources", function()
{
   rStudioVersion <- package_version(
      .Call(getNativeSymbolInfo("rs_rstudioVersion", PACKAGE=""))
   )
   resetOptions <- rStudioVersion > "0.99.1053" && rStudioVersion < "0.99.1099"

   if (identical(getOption("profvis.print"), NULL) || resetOptions) {
      options(profvis.print = function(x) {
         envir <- as.environment(which(search() == "tools:rstudio"))
         eval(
            substitute(.rs.profilePrint(x), list(x = x)),
            envir = envir
         )
      })
   }

   if (identical(getOption("profvis.prof_extension"), NULL) ||
       identical(getOption("profvis.prof_extension"), ".rprof") ||
       resetOptions) {
      options("profvis.prof_extension" = ".Rprof")
   }

   tempPath <- .Call("rs_profilesPath")
   if (!.rs.dirExists(tempPath)) {
      dir.create(tempPath, recursive = TRUE)
   }

   if (identical(getOption("profvis.prof_output"), NULL) || resetOptions) {
      options("profvis.prof_output" = tempPath)
   }

   return (list(
      tempPath = tempPath
   ))
})

.rs.addJsonRpcHandler("start_profiling", function(profilerOptions)
{
   tryCatch({
      resources <- .rs.profileResources()
      fileName <- tempfile(fileext = ".Rprof", tmpdir = resources$tempPath)

      Rprof(filename = fileName, line.profiling = TRUE, memory.profiling = TRUE)

      return(list(
         fileName = .rs.scalar(fileName)
      ))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

.rs.addJsonRpcHandler("stop_profiling", function(profilerOptions)
{
   tryCatch({
      Rprof(NULL)

      if (!identical(profilerOptions$fileName, NULL))
      {
         .rs.enqueClientEvent("rprof_created", list(
            path = .rs.scalar(profilerOptions$fileName)
         ));
      }

      return(list(
         fileName = .rs.scalar(profilerOptions$fileName)
      ))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

.rs.addJsonRpcHandler("open_profile", function(profilerOptions)
{
   tryCatch({
      resources <- .rs.profileResources()
      htmlFile <- normalizePath(tempfile(fileext = ".html", tmpdir = resources$tempPath), winslash = "/", mustWork = FALSE)

      if (identical(profilerOptions$profvis, NULL)) {
         if (identical(tools::file_ext(profilerOptions$fileName), "Rprof")) {
            profvis <- profvis::profvis(prof_input = profilerOptions$fileName, split="h")
            htmlwidgets::saveWidget(profvis, htmlFile, selfcontained = TRUE)
         }
         else {
            .rs.rpc.copy_profile(profilerOptions$fileName, htmlFile)
         }
      }
      else {
         profvis <- profilerOptions$profvis
         htmlwidgets::saveWidget(profvis, htmlFile, selfcontained = TRUE)
      }

      return(list(
         htmlPath = .rs.scalar(paste("profiles/", basename(htmlFile), sep = "")),
         htmlLocalPath = .rs.scalar(htmlFile)
      ))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

.rs.addJsonRpcHandler("copy_profile", function(fromPath, toPath)
{
   tryCatch({
      file.copy(fromPath, toPath, overwrite = TRUE)

      return(list(
      ))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

.rs.registerNotifyHook("Rprof", "utils", function(...) 
{
   args <- c(...)
   if (!identical(args, NULL))
   {
      .rs.enqueClientEvent("rprof_started");
   }
   else
   {
      .rs.enqueClientEvent("rprof_stopped");
   }
}, namespace = TRUE)

.rs.addFunction("profilePrint", function(x)
{
   result <- .rs.rpc.open_profile(list(
      profvis = x
   ))

   .rs.enqueClientEvent("rprof_created", result);
})

.rs.addJsonRpcHandler("clear_profile", function(filePath, htmlPath)
{
   tryCatch({
      resources <- .rs.profileResources()

      pathPrefix <- tools::file_path_sans_ext(basename(filePath))
      filePrefix <- tools::file_path_sans_ext(basename(htmlPath))
      
      rprofFile <- file.path(resources$tempPath, paste(pathPrefix, ".Rprof", sep = ""))
      if (file.exists(rprofFile)) {
         file.remove(rprofFile)
      }

      profileHtml <- file.path(resources$tempPath, paste(filePrefix, ".html", sep = ""))
      if (file.exists(profileHtml)) {
         file.remove(profileHtml)
      }

      profileDir <- file.path(resources$tempPath, paste(filePrefix, "_files", sep = ""))
      if (file.exists(profileDir)) {
         unlink(profileDir, recursive = TRUE)
      }

      rsconnectDir <- file.path(resources$tempPath, "rsconnect", "documents", paste(filePrefix, ".html", sep = ""))
      if (.rs.dirExists(rsconnectDir)) {
         unlink(rsconnectDir, recursive = TRUE)
      }

      return(list(
      ))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

.rs.addJsonRpcHandler("profile_sources", function(filePath, normPath)
{
   tryCatch({
      validPath <- ""
      paths <- c(filePath, normPath)
      found <- file.exists(paths)
      
      if (any(found == TRUE)) {
         validPath <- paths[[which(found == TRUE)[[1]]]]
      }

      return(.rs.scalar(validPath))
   }, error = function(e) {
      return(list(error = .rs.scalar(e$message)))
   })
})

#
# SessionPlumberViewer.R
#
# Copyright (C) 2009-19 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("invokePlumberPaneViewer", function(url) {
   invisible(.Call("rs_plumberviewer", url, getwd(), "pane", PACKAGE = "(embedding)"))
}, attrs = list(plumberViewerType = "pane"))

.rs.addFunction("invokePlumberWindowViewer", function(url) {
   invisible(.Call("rs_plumberviewer", url, getwd(), "window", PACKAGE = "(embedding)"))
}, attrs = list(plumberViewerType = "window"))

.rs.addFunction("invokePlumberWindowExternal", function(url) {
   invisible(.Call("rs_plumberviewer", url, getwd(), "browser", PACKAGE = "(embedding)"))
}, attrs = list(plumberViewerType = "browser"))

.rs.addFunction("setPlumberViewerType", function(type) {
   if (identical(type, "none"))
      options(plumber.swagger.url = NULL)
   else if (identical(type, "pane"))
      options(plumber.swagger.url = .rs.invokePlumberPaneViewer)
   else if (identical(type, "window"))
      options(plumber.swagger.url = .rs.invokePlumberWindowViewer)
   else if (identical(type, "browser"))
      options(plumber.swagger.url = .rs.invokePlumberWindowExternal)
})

.rs.addFunction("getPlumberViewerType", function() {
   viewer <- getOption("plumber.swagger.url")
   if (identical(viewer, FALSE))
      return("none")
   else if (identical(viewer, TRUE))
      return("browser")
   else if (is.function(viewer) && is.character(attr(viewer, "plumberViewerType")))
      return(attr(viewer, "plumberViewerType"))
   return("user")
})

.rs.addJsonRpcHandler("get_plumber_viewer_type", function() {
   .rs.scalar(.rs.getPlumberViewerType())
})

#
# SessionFiles.R
#
# Copyright (C) 2009-12 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("listZipFile", function(zipfile)
{
   as.character(utils::unzip(zipfile, list=TRUE)$Name)
})


.rs.addFunction("createZipFile", function(zipfile, parent, files)
{
   # set working dir to parent (and restore on exit)
   previous_wd = getwd()
   setwd(parent)
   on.exit(setwd(previous_wd))
   
   # build zip command
   quotedFiles = paste(shQuote(files), collapse = " ")
   createZipCommand = paste("zip", "-r", shQuote(zipfile), quotedFiles, "2>&1")  
   
   # execute the command (return output of command)
   system(createZipCommand, intern = TRUE)
})

.rs.addJsonRpcHandler("list_all_files", function(path, pattern) {
   list.files(path, pattern = pattern, recursive = TRUE)
})

.rs.addJsonRpcHandler("ensure_file_exists", function(path)
{
   if (!file.exists(path))
      if (!file.create(path, recursive = TRUE))
         return(.rs.scalar(FALSE))
   
   .rs.scalar(identical(file.info(path)$isdir, FALSE))
})

.rs.addFunction("scanFiles", function(path,
                                      pattern,
                                      asRelativePath = TRUE,
                                      maxCount = 200L)
{
   .Call("rs_scanFiles",
         as.character(path),
         as.character(pattern),
         as.logical(asRelativePath),
         as.integer(maxCount))
})

.rs.addFunction("readLines", function(filePath)
{
   .Call("rs_readLines", path.expand(filePath))
})

#
# SessionAuthoring.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#


.rs.addFunction("knitrChunkOptions", function()
{
   if (!requireNamespace("knitr", quietly = TRUE))
      return(list())
   
   chunkOptions <- knitr:::opts_chunk_attr
   
   # paged.print is numeric, but it's normally used as logical
   # https://github.com/rstudio/rstudio/issues/9895
   chunkOptions$paged.print <- "logical"
   
   chunkOptions
})

.rs.addFunction( "sweaveChunkOptions", function()
{
   sweaveOptions <- list()
   
   sweaveOptions$label <- "character"
   sweaveOptions$engine <- list("R", "S")
   sweaveOptions$echo <- "logical"
   sweaveOptions$keep.source <- "logical"
   sweaveOptions$eval <- "logical"
   sweaveOptions$results <- list("verbatim", "tex", "hide")
   sweaveOptions$print <- "logical"
   sweaveOptions$term <- "logical"
   sweaveOptions$split <- "logical"
   sweaveOptions$strip.white <- list("true", "all", "false")
   sweaveOptions$prefix <- "logical"
   sweaveOptions$prefix.string <- "character"
   sweaveOptions$include <- "logical"
   sweaveOptions$fig <- "logical"
   sweaveOptions$eps <- "logical"
   sweaveOptions$pdf <- "logical"
   sweaveOptions$pdf.version <- "character"
   sweaveOptions$pdf.encoding <- "character"
   sweaveOptions$pdf.compress <-"logical"
   sweaveOptions$png <- "logical"
   sweaveOptions$jpeg <- "logical"
   sweaveOptions$grdevice <- "character"
   sweaveOptions$width <- "numeric"
   sweaveOptions$height <- "numeric"
   sweaveOptions$resolution <- "numeric"
   sweaveOptions$figs.only <- "logical"
   
   return (sweaveOptions)
})

#
# SessionClang.R
#
# Copyright (C) 2009-12 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#



.rs.addFunction("clangPCHPath", function(pkg, clangVersion)
{
   paste(
      packageVersion(pkg),
      R.version$platform,
      R.version$`svn rev`,
      clangVersion,
      sep = "-"
   )
})

.rs.addFunction("isClangAvailable", function() {
   cat("Attemping to load libclang for", R.version$platform, "\n")
   .Call("rs_isLibClangAvailable", PACKAGE = "(embedding)")
})

.rs.addFunction("setClangDiagnostics", function(level)
{
   if (!is.numeric(level) || (level < 0) || (level > 2))
      stop("level must be 0, 1, or 2")
   
   if (level > 0)
      .rs.isClangAvailable()
   
   .Call("rs_setClangDiagnostics", level, PACKAGE = "(embedding)")
   
   .rs.restartR()
   invisible(NULL)
})

.rs.addFunction("packagePCH", function(linkingTo)
{
   linkingTo <- .rs.parseLinkingTo(linkingTo)
   packages <- c("RcppArmadillo", "RcppEigen", "Rcpp11", "Rcpp")
   for (package in packages)
      if (package %in% linkingTo)
         return(package)
   ""
})

.rs.addFunction("includesForLinkingTo", function(linkingTo)
{
   includes <- character()
   
   linkingTo <- .rs.parseLinkingTo(linkingTo)
   for (pkg in linkingTo) {
      includeDir <- system.file("include", package = pkg)
      if (file.exists(includeDir)) {
         includes <- c(
            includes,
            paste("-I", .rs.asBuildPath(includeDir), sep = "")
         )
      }
   }
   
   includes
})

.rs.addFunction("asBuildPath", function(path)
{
   if (.Platform$OS.type == "windows") {
      path <- normalizePath(path)
      if (grepl(' ', path, fixed = TRUE))
         path <- utils::shortPathName(path)
      path <- gsub("\\\\", "/", path)
   }
   
   return(path)
})

#
# Execute the function definition below with Cmd + Enter.
# Then, run foo() to run the code.
# The debugger should open into a view of the document.
# Try editing the function definition while stepping through.
# The debug highlight should be removed, and a warning should be displayed.
#

foo <- function() {
   1 + 1
   browser()
   2 + 2
   3 + 3
   4 + 4
}

#
# SessionBuild.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

setHook("sourceCpp.onBuild", function(file, fromCode, showOutput)
{
   .Call("rs_sourceCppOnBuild", file, fromCode, showOutput, PACKAGE = "(embedding)")
})

setHook("sourceCpp.onBuildComplete", function(succeeded, output)
{
   .Call("rs_sourceCppOnBuildComplete", succeeded, output, PACKAGE = "(embedding)")
})

.rs.addFunction("installBuildTools", function(action)
{
   fmt <- .rs.trimWhitespace("
%s requires installation of additional build tools.

Do you want to install the additional tools now?
")
   
   response <- .rs.userPrompt(
      "question",
      "Install Build Tools",
      sprintf(fmt, action)
   )
   
   if (!identical(response, "yes"))
      return(FALSE)
   
   .Call("rs_installBuildTools", PACKAGE = "(embedding)")
   invisible(TRUE)
   
})

.rs.addFunction("checkBuildTools", function(action)
{
   # TODO: should this check for other flavors of mac.binary?
   if (identical(.Platform$pkgType, "mac.binary.mavericks"))
      return(.Call("rs_canBuildCpp", PACKAGE = "(embedding)"))
   
   ok <- .Call("rs_canBuildCpp", PACKAGE = "(embedding)")
   if (ok)
      return(TRUE)
   
   .rs.installBuildTools(action)
   FALSE
})

.rs.addFunction("withBuildTools", function(code)
{
    .rs.addRToolsToPath()
    on.exit(.rs.restorePreviousPath(), add = TRUE)
    force(code)
})

options(buildtools.check = function(action)
{
   .rs.checkBuildTools(action)
})

options(buildtools.with = function(code)
{
   .rs.withBuildTools(code)
})

.rs.addFunction("websiteOutputDir", function(siteDir)
{
   siteGenerator <- rmarkdown::site_generator(siteDir)
   if (!is.null(siteGenerator))
      if (siteGenerator$output_dir != ".")
         file.path(siteDir, siteGenerator$output_dir)
      else
         siteDir
   else
      siteDir
})

.rs.addFunction("generateCommandScript", function(command)
{
   # Generate header, which allows us to forward the 'repos' option.
   header <- substitute({
      options(repos = repos)
   }, list(repos = getOption("repos")))
   
   # Append the command to be executed.
   all <- c(deparse(header), command)
   
   # Write to file and return that path.
   scriptPath <- tempfile("rstudio-script-", fileext = ".R")
   writeLines(all, con = scriptPath)
   
   scriptPath
})

.rs.addFunction("prependLibraryPath", function(libPath)
{
   .libPaths(c(libPath, .libPaths()))
})

.rs.addFunction("makeBuildLibraryPath", function()
{
   for (libPath in .libPaths())
   {
      buildLibPath <- file.path(libPath, "_build")
      if (dir.exists(buildLibPath) || dir.create(buildLibPath, showWarnings = FALSE))
         return(buildLibPath)
   }
})

.rs.addFunction("removeBuildLibraryPath", function(buildLibraryPath)
{
   .libPaths(setdiff(.libPaths(), buildLibraryPath))
})

#
# SessionHelp.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# use html help
options(help_type = "html")

# cached encoding of help files for installed packages
.rs.setVar("packageHelpEncodingEnv", new.env(parent = emptyenv()))

.rs.addFunction("httpdPortIsFunction", function()
{
   is.function(tools:::httpdPort)
})

.rs.addFunction("httpdPort", function()
{
   if (.rs.httpdPortIsFunction())
      as.character(tools:::httpdPort())
   else
      as.character(tools:::httpdPort)
})

.rs.addFunction("initHelp", function(port, isDesktop)
{ 
   # function to set the help port
   setHelpPort <- function() {
      if (.rs.httpdPortIsFunction()) {
         tools:::httpdPort(port)
      } else {
         env <- environment(tools::startDynamicHelp)
         unlockBinding("httpdPort", env)
         assign("httpdPort", port, envir = env)
         lockBinding("httpdPort", env)   
      }
   }
   
   # for desktop mode see if R can successfully initialize the httpd
   # server -- if it can't then perhaps localhost ports are blocked,
   # in this case we take over help entirely
   if (isDesktop) 
   {
      # start the help server if it hasn't previously been started
      # (suppress warnings and messages because if there is a problem
      # binding to a local port we are going to patch this up by 
      # redirecting all traffic to our local peer)
      if (.rs.httpdPort() <= 0L)
         suppressWarnings(suppressMessages(tools::startDynamicHelp()))
      
      # if couldn't start it then set the help port directly so that
      # help requests still flow through our local peer connection
      if (.rs.httpdPort() <= 0L)
      {
         setHelpPort()
         return (TRUE)
      }
      else
      {
         return (FALSE)
      }
   }
   # always take over help in server mode
   else 
   { 
      # stop the help server if it was previously started e.g. by .Rprofile
      if (.rs.httpdPort() > 0L)
         suppressMessages(tools::startDynamicHelp(start=FALSE))
      
      # set the help port
      setHelpPort()
      
      # indicate we should handle custom internally
      return (TRUE)
   }
})

.rs.addFunction( "handlerLookupError", function(path, query=NULL, ...)
{
   payload = paste(
      "<h3>R Custom HTTP Handler Not Found</h3>",
      "<p>Unable to locate custom HTTP handler for",
      "<i>", .rs.htmlEscape(path), "</i>",
      "<p>Is the package which implements this HTTP handler loaded?</p>")
   
   list(payload, "text/html", character(), 404)
});

.rs.setVar("topicsEnv", new.env(parent = emptyenv()))

.rs.addJsonRpcHandler("suggest_topics", function(query)
{
   pkgpaths <- path.package(quiet = TRUE)
   
   # read topics from
   topics <- lapply(pkgpaths, function(pkgpath) tryCatch({
      
      if (exists(pkgpath, envir = .rs.topicsEnv))
         return(get(pkgpath, envir = .rs.topicsEnv))
      
      aliases <- file.path(pkgpath, "help/aliases.rds")
      index <- file.path(pkgpath, "help/AnIndex")
      
      value <- if (file.exists(aliases)) {
         names(readRDS(aliases))
      } else if (file.exists(index)) {
         data <- read.table(index, sep = "\t")
         data[, 1]
      }
      
      assign(pkgpath, value, envir = .rs.topicsEnv)
      
   }, error = function(e) NULL))
   
   flat <- unlist(topics, use.names = FALSE)
   
   # order matches by subsequence match score
   scores <- .rs.scoreMatches(tolower(flat), tolower(query))
   ordered <- flat[order(scores, nchar(flat))]
   matches <- unique(ordered[.rs.isSubsequence(tolower(ordered), tolower(query))])
   
   # force first character to match, but allow typos after.
   # also keep matches with one or more leading '.', so that e.g.
   # the prefix 'libpaths' can match '.libPaths'
   if (nzchar(query)) {
      first <- .rs.escapeForRegex(substring(query, 1L, 1L))
      pattern <- sprintf("^[.]*[%s]", first)
      matches <- grep(pattern, matches, value = TRUE, perl = TRUE)
   }
   
   matches
   
})

.rs.addFunction("getHelpFromObject", function(object, envir, name = NULL)
{
   # Try to find the associated namespace of the object
   namespace <- NULL
   if (is.primitive(object))
      namespace <- "base"
   else if (is.function(object))
   {
      envString <- .rs.format(environment(object))[[1L]]
      
      # Strip out the irrelevant bits of the package name. We'd like
      # to just use 'regexpr' but its output is funky with older versions
      # of R.
      if (!grepl("namespace:", envString))
         return()
      
      namespace <- sub(".*namespace:", "", envString)
      namespace <- sub(">.*", "", namespace)
   }
   else if (isS4(object))
      namespace <- attr(class(object), "package")
   
   if (is.null(namespace))
      return()
   
   # Get objects from that namespace
   ns <- try(asNamespace(namespace), silent = TRUE)
   if (inherits(ns, "try-error"))
      return()
   
   # Datasets don't live in the namespace -- ennumerate them separately
   # We have to avoid the 'base' package, though.
   datasets <- tryCatch(
      suppressWarnings(data(package = namespace)),
      error = function(e) NULL
   )
   
   objectNames <- objects(ns, all.names = TRUE)
   datasetNames <- unname(grep(" ", datasets$results[, "Item"], fixed = TRUE, value = TRUE, invert = TRUE))
   
   objects <- tryCatch(
      mget(objectNames, envir = ns, inherits = TRUE),
      error = function(e) NULL
   )
   
   # Try to get the datasets from the namespace. These will only exist if they have
   # been explicitly loaded, so be careful to tryCatch here.
   data <- lapply(datasetNames, function(x) {
      tryCatch(
         get(x, envir = ns),
         error = function(e) NULL
      )
   })
   
   # Combine them together
   if (length(data))
   {
      objects <- c(objects, data)
      objectNames <- c(objectNames, datasetNames)
   }
   
   # Find which object is actually identical to the one we have
   success <- FALSE
   for (i in seq_along(objects))
   {
      if (!identical(class(object), class(objects[[i]])))
         next
      
      # Once again, 'ignore.environment' is not available in older R's
      # identical, so construct and eval a call to 'base::identical'.
      formals <- as.list(formals(base::identical))
      formals$x <- object
      formals$y <- objects[[i]]
      if ("ignore.environment" %in% names(formals))
         formals[["ignore.environment"]] <- TRUE
      
      result <- tryCatch(
         do.call(base::identical, formals),
         error = function(e) FALSE
      )
      
      if (result)
      {
         success <- TRUE
         break
      }
   }
   
   if (success)
   {
      # Use that name for the help lookup
      object <- objects[[i]]
      objectName <- objectNames[[i]]
      
      # use the function name seen in the
      # source document if provided
      sigName <- if (is.null(name))
         objectName
      else
         name
      
      # Get the associated signature for functions
      signature <- NULL
      if (is.function(object))
         signature <- sub("function ", sigName, .rs.getSignature(object))
      
      result <- .rs.getHelp(topic = objectName, package = namespace, sig = signature)
      if (length(result))
         return(result)
      
      # If the previous lookup failed, perhaps it was an S3 method for which no
      # documentation was available. Fall back to generic documentation.
      dotPos <- gregexpr(".", objectName, fixed = TRUE)[[1]]
      for (i in seq_along(dotPos))
      {
         maybeGeneric <- substring(objectName, 1, dotPos[[i]] - 1)
         methods <- suppressWarnings(
            tryCatch(
               eval(substitute(methods(x), list(x = maybeGeneric)), envir = envir),
               error = function(e) NULL
            )
         )
         
         if (objectName %in% methods)
         {
            result <- .rs.getHelp(maybeGeneric)
            if (length(result))
               return(result)
         }
      }
   }
   
   # Fail -- return NULL
   NULL
})

.rs.addFunction("getHelpRpcImpl", function(what, from, type, envir)
{
   # If we've encoded the package and function in 'what', pull it out
   if (grepl("::.", what))
   {
      splat <- strsplit(what, "::", fixed = TRUE)[[1]]
      from <- splat[[1]]
      what <- splat[[2]]
   }
   
   # Avoid install.packages hook
   if (what == "install.packages" &&
       type == .rs.acCompletionTypes$ARGUMENT &&
       is.null(from))
   {
      return(.rs.getHelp("install.packages", "utils"))
   }
   
   # Help for options
   if (type == .rs.acCompletionTypes$OPTION)
      return(.rs.getHelp("options", "base", subset = FALSE))
   
   if (type %in% c(.rs.acCompletionTypes$S4_GENERIC,
                   .rs.acCompletionTypes$S4_METHOD))
   {
      # Try getting methods for the method from the associated package
      if (!is.null(help <- .rs.getHelp(paste(what, "methods", sep = "-"), from)))
         return(help)
      
      # Try getting help from anywhere
      if (!is.null(help <- .rs.getHelp(what, from)))
         return(help)
      
      # Give up
      return()
   }
   
   if (type %in% c(.rs.acCompletionTypes$FUNCTION,
                   .rs.acCompletionTypes$S4_GENERIC,
                   .rs.acCompletionTypes$S4_METHOD,
                   .rs.acCompletionTypes$R5_METHOD))
      return(.rs.getHelpFunction(what, from))
   else if (type %in% c(.rs.acCompletionTypes$ARGUMENT, .rs.acCompletionTypes$SECUNDARY_ARGUMENT))
      return(.rs.getHelpArgument(what, from, parent.frame()))
   else if (type == .rs.acCompletionTypes$PACKAGE)
      return(.rs.getHelpPackage(what))
   else if (type == .rs.acCompletionTypes$DATATABLE_SPECIAL_SYMBOL)
      return(.rs.getHelpDataTableSpecialSymbol(what))
   else if (type == .rs.acCompletionTypes$COLUMN)
      return(.rs.getHelpColumn(what, from, envir))
   else if (type == .rs.acCompletionTypes$DATAFRAME)
      return(.rs.getHelpDataFrame(what, from, envir))
   else if (length(from) && length(what))
      return(.rs.getHelp(what, from))
   else
      return()
})

.rs.addJsonRpcHandler("get_help", function(what, from, type)
{
   # Protect against missing type
   if (!length(type))
      return()
   
   envir <- .rs.getActiveFrame()
   out <- tryCatch(
      .rs.getHelpRpcImpl(what, from, type, envir),
      error = function(e) NULL
   )
   if (is.null(out))
      return()
   
   out$type <- type
   out
})

.rs.addJsonRpcHandler("get_custom_help", function(helpHandler,
                                                  topic,
                                                  source,
                                                  language)
{
   # use own handler for Python language help
   if (identical(language, "Python"))
      return(.rs.python.getHelp(topic, source))
   
   helpHandlerFunc <- tryCatch(eval(parse(text = helpHandler)), 
                               error = function(e) NULL)
   if (!is.function(helpHandlerFunc))
      return()
   
   results <- helpHandlerFunc("completion", topic, source)
   if (!is.null(results)) {
      results$description <- .rs.markdownToHTML(results$description)
   }
     
   results 
})

.rs.addJsonRpcHandler("get_custom_parameter_help", function(helpHandler,
                                                            source,
                                                            language)
{
   # use own handler for Python language help
   if (identical(language, "Python"))
      return(.rs.python.getParameterHelp(source))
   
   helpHandlerFunc <- tryCatch(eval(parse(text = helpHandler)), 
                               error = function(e) NULL)
   if (!is.function(helpHandlerFunc))
      return()
   
   results <- helpHandlerFunc("parameter", NULL, source)
   if (!is.null(results)) {
      results$type <- .rs.acCompletionTypes$ARGUMENT
      results$arg_descriptions <- sapply(results$arg_descriptions, .rs.markdownToHTML)
   }
   
   results
})

.rs.addJsonRpcHandler("show_custom_help_topic", function(helpHandler, topic, source) {
   
   helpHandlerFunc <- tryCatch(
      eval(parse(text = helpHandler)), 
      error = function(e) NULL
   )
   
   if (!is.function(helpHandlerFunc))
      return()
   
   # workaround for broken help in reticulate 1.18
   if (identical(helpHandler, "reticulate:::help_handler"))
   {
      text <- paste(source, topic, sep = ".")
      .Call("rs_showPythonHelp", text, PACKAGE = "(embedding)")
      return()
   }
   
   url <- helpHandlerFunc("url", topic, source)
   if (!is.null(url) && nzchar(url)) # handlers return "" for no help topic
      utils::browseURL(url)
})

.rs.addJsonRpcHandler("get_vignette_title", function(topic, package)
{
   title <- tryCatch(utils::vignette(topic, package)$Title, 
                     error = function(e) "", 
                     warning = function(e) "")
   .rs.scalar(title)         
})

.rs.addJsonRpcHandler("get_vignette_description", function(topic, package)
{
   description <- tryCatch(
      {
         v <- vignette(topic, package)

         Dir <- v$Dir
         File <- v$File
         if (grepl("[.]Rmd$", File))
         {
            description <- rmarkdown::yaml_front_matter(file.path(Dir, "doc", File))$description
            if (is.null(description))
            {
               description <- ""
            }
            description
         }
         else ""

      }, 
      error = function(e) "", 
      warning = function(e) "")
   .rs.scalar(description)         
})

.rs.addJsonRpcHandler("show_vignette", function(topic, package)
{
   # First, check for an explicitly registered vignette
   vignette <- tryCatch(utils::vignette(topic, package), condition = identity)
   if (!inherits(vignette, "condition"))
      return(print(vignette))
   
   # Try falling back to opening bundled documentation that's not
   # explicitly registered as a vignette.
   exts <- c("pdf", "html")
   for (ext in exts) {
      suffix <- sprintf("doc/%s.%s", topic, ext)
      path <- system.file(suffix, package = package, mustWork = FALSE)
      if (nzchar(path))
         return(browseURL(path))
   }
 
   # If we couldn't find the vignette, re-throw the original error.
   stop(conditionMessage(vignette), call. = FALSE)
})

.rs.addFunction("getHelpColumn", function(name, src, envir = parent.frame())
{
   tryCatch(
      .rs.getHelpColumnImpl(name, src, envir),
      error = function(e) NULL
   )
})

.rs.addFunction("getHelpColumnImpl", function(name, src, envir = parent.frame())
{
   data <- .rs.getAnywhere(src, envir)
   if (is.null(data))
      return(NULL)
   
   described <- .rs.describeObject(name, data)
   description <- described$description
   type <- described$type
   size <- described$length
   
   list(
      html = paste0("<h2></h2><h3>Description</h3><p>", description, "</p>"),
      signature = paste0("<", type, "> [", size, "]"),
      pkgname = src,
      help = FALSE
   )
   
})

.rs.addFunction("getHelpDataFrame", function(name, src, envir = parent.frame())
{
   # try and retrieve the help documentation
   out <- .rs.getHelp(name, src)
   
   # Return help page as-is if requested by user
   showDataPreview <- getOption("rstudio.help.showDataPreview", default = TRUE)
   if (!showDataPreview)
      return(out)
   
   showDataPreview <- .rs.readUserPref("show_data_preview")
   if (!identical(showDataPreview, TRUE))
      return(out)

   # try and figure out the data + title
   data <- NULL
   title <- name
   
   # If 'src' is the name of something on the search path, grab the data
   pos <- match(src, search(), nomatch = -1L)
   if (pos >= 0)
   {
      data <- tryCatch(get(name, pos = pos), error = function(e) NULL)
   }

   dataFoundAnywhere <- FALSE
   # if that failed, try to look it up anywhere
   if (is.null(data))
   {
      title <- paste0(src, "$", name)
      data <- .rs.getAnywhere(title, envir)

      # if we still couldn't find any data, just use the help document
      if (is.null(data))
      {
         return(out)
      }
   
      dataFoundAnywhere <- TRUE
   }

   # Generate the help pre-amble
   if (is.null(out))
   {
      fmt <- paste(
         "<h2>%s</h2>",
         "<h3>Description</h3>",
         "<p>%i obs. of %i %s</p>",
         sep = ""
      )
      
      vbls <- if (ncol(data) == 1) "variable" else "variables"
      html <- sprintf(fmt, name, nrow(data), ncol(data), vbls)
      
      out <- list(
         html = html,
         signature = "-", 
         pkgname = src, 
         help = FALSE   
      )
   }
   
   # NOTE: We previously tried assigning and using cached data, but this is
   # not safe since help documents are cached after they are first created.
   #
   # Instead, we need to make sure the data viewer references the actual
   # object in the place it's defined.
   
   # Limit the number of columns to the first `maxDisplayColumns`
   # number of columns. E.g. if data_viewer_max_columns=200, then
   # we'll only load and show the first 200 columns of the data frame
   # in the help preview.
   maxDisplayColumns <- .rs.readUiPref("data_viewer_max_columns")

   # build a uri
   #
   # The column-summary sidebar is hidden in the help preview: the help
   # document already describes the data frame, so the summary is redundant
   # here and would crowd out the rows the preview is meant to surface. Other
   # hosts (the standalone Data Viewer) continue to honor the user preference.
   attrs <- c(
      obj          = title,
      max_rows     = 1000,
      max_cols     = maxDisplayColumns,
      show_summary = 0
   )
   
   # only include env if we didn't find the data from "anywhere"
   if (!dataFoundAnywhere)
   {
      attrs <- c(attrs, env = src)
   }
   
   uri <- paste(
      "grid_resource/gridviewer.html",
      paste(names(attrs), attrs, sep = "=", collapse = "&"),
      sep = "?"
   )
   
   out$view <- uri
   out
})

.rs.addFunction("getHelpFunction", function(name, src, envir = parent.frame())
{
   # If 'src' is the name of something on the search path, get that object
   # from the search path, then attempt to get help based on that object
   pos <- match(src, search(), nomatch = -1L)
   if (pos >= 0)
   {
      object <- tryCatch(get(name, pos = pos), error = function(e) NULL)
      if (!is.null(object))
         return(.rs.getHelpFromObject(object, envir, name))
   }
   
   # Otherwise, check to see if there is an object 'src' in the global env
   # from which we can pull the object
   container <- tryCatch(eval(parse(text = src), envir = .GlobalEnv), error = function(e) NULL)
   if (!is.null(container))
   {
      object <- tryCatch(eval(call("$", container, name)), error = function(e) NULL)
      if (!is.null(object))
         return(.rs.getHelpFromObject(object, envir, name))
   }
   
   # Otherwise, try to get help in the vanilla way
   .rs.getHelp(name, src, getSignature = TRUE)
})

.rs.addFunction("getHelpPackage", function(pkgName)
{
   # We might be getting the completion with colons appended, so strip those out.
   pkgName <- sub(":*$", "", pkgName, perl = TRUE)
   topic <- paste(pkgName, "-package", sep = "")
   out <- .rs.getHelp(topic, pkgName)
   if (is.null(out))
   {
      pkgDescription <- suppressWarnings(utils::packageDescription(pkgName))
      if (!identical(pkgDescription, NA)) 
      {
         title <- .rs.htmlEscape(pkgDescription$Title)
         description <- .rs.htmlEscape(pkgDescription$Description)
         
         # Format like what HelpInfo.parse() expects
         out <- list(
            html = paste0("<h2>", title, "</h2><h3>Description</h3><p>", description, "</p>"),
            signature = NULL, 
            pkgname = pkgName
         )
      }
   }
   out
})

.rs.addFunction("getHelpDataTableSpecialSymbol", function(what)
{
   html <- strsplit(.rs.getHelp(what, "data.table", subset = FALSE)$html, "\n")[[1L]]
   description <- grep(paste0("<p><code>", what, "</code>[^,]"), html, value = TRUE)
   description <- sub("<li><p>", "", description)

   out <- list(
      html = paste0("<h2>data.table special symbol ", what, "</h2><h3>Description</h3><p>", description, "</p>"),
      signature = NULL, 
      pkgname = "data.table"
   )
   out
})

.rs.addFunction("getHelpArgument", function(functionName, src, envir)
{
   if (is.null(src))
   {
      object <- .rs.getAnywhere(functionName, envir)
         if (!is.null(object))
         return(.rs.getHelpFromObject(object, envir, functionName))
   }
   else
   {
      pos <- match(src, search(), nomatch = -1L)
      
      if (pos >= 0)
      {
         object <- tryCatch(get(functionName, pos = pos), error = function(e) NULL)
         if (!is.null(object))
            return(.rs.getHelpFromObject(object, envir, functionName))
      }
   }
   
   .rs.getHelp(functionName, src)
})

.rs.addFunction("makeHelpCall", function(topic,
                                         package = NULL,
                                         help_type = "html")
{
   # build help call
   call <- substitute(
      utils::help(TOPIC, package = PACKAGE, help_type = "html"),
      list(TOPIC = topic, PACKAGE = package)
   )
   
   # support devtools shims
   if ("devtools_shims" %in% search())
      call[[1L]] <- quote(help)
   
   # return generated call
   call
})

.rs.addFunction("packageHelpEncoding", function(packagePath)
{
   if (!is.character(packagePath) || !file.exists(packagePath))
      return(.rs.packageHelpEncodingDefault())
   
   if (exists(packagePath, envir = .rs.packageHelpEncodingEnv))
      return(get(packagePath, envir = .rs.packageHelpEncodingEnv))
   
   encoding <- tryCatch(
      .rs.packageHelpEncodingImpl(packagePath),
      error = function(e) .rs.packageHelpEncodingDefault()
   )
   
   assign(packagePath, encoding, envir = .rs.packageHelpEncodingEnv)
   encoding
   
})

.rs.addFunction("packageHelpEncodingImpl", function(packagePath)
{
   desc <- .rs.readPackageDescription(packagePath)
   .rs.nullCoalesce(desc$Encoding, .rs.packageHelpEncodingDefault())
})

.rs.addFunction("packageHelpEncodingDefault", function()
{
   pref <- .rs.readUiPref("default_encoding")
   .rs.nullCoalesce(pref, "UTF-8")
})

.rs.addFunction("getHelp", function(topic,
                                    package = "",
                                    sig = NULL,
                                    subset = TRUE,
                                    getSignature = FALSE)
{
   # ensure topic and package are not zero-length
   if (!length(package))
      package <- ""
   
   if (!length(topic))
      topic <- ""
   
   # completions from the search path might have the 'package:' prefix;
   # let's strip that out
   package <- sub("package:", "", package, fixed = TRUE)
   
   # if the package is not provided, but we're getting help on e.g.
   # 'stats::rnorm', then split up the topic into the appropriate pieces
   if (package == "" && any(grepl(":{2,3}", topic, perl = TRUE)))
   {
      splat <- strsplit(topic, ":{2,3}", perl = TRUE)[[1]]
      topic <- splat[[2]]
      package <- splat[[1]]
   }
   
   # don't provide help for objects in the global environment
   if (identical(package, ".GlobalEnv"))
      return()
   
   helpfiles <- .rs.tryCatch({
      call <- .rs.makeHelpCall(topic, if (nzchar(package)) package)
      eval(call, envir = globalenv())
   })
   
   # if we failed to retrieve any help files, check if this might
   # happen to be an S3 method where the generic is documented
   #
   # https://github.com/rstudio/rstudio/issues/14232
   if (length(helpfiles) <= 0)
   {
      topic <- gsub("\\..*", "", topic)
      call <- .rs.makeHelpCall(topic, if (nzchar(package)) package)
      helpfiles <- eval(call, envir = globalenv())
   }
   
   if (length(helpfiles) <= 0)
      return()
   
   # handle devtools help topics specially
   isDevTopic <- inherits(helpfiles, "dev_topic") && "pkgload" %in% loadedNamespaces()
   if (isDevTopic)
   {
      # devtools help
      status <- .rs.tryCatch({
         package <- helpfiles$pkg
         docPath <- file.path(tempdir(), sprintf(".R/doc/html/%s.html", helpfiles$topic))
         dir.create(dirname(docPath), recursive = TRUE, showWarnings = FALSE)
         pkgload:::topic_write_html(helpfiles, path = docPath)
      })
      
      if (inherits(status, "error"))
         return()
      
      html <- paste(readLines(docPath, warn = FALSE), collapse = "\n")
   }
   else
   {
      # regular old help
      file <- helpfiles[[1]]
      path <- dirname(file)
      dirpath <- dirname(path)
      package <- basename(dirpath)
      
      query <- sprintf("/library/%s/html/%s.html", package, basename(file))
      html <- suppressWarnings(tools:::httpd(query, NULL, NULL))$payload
   }
   
   # try to figure out the encoding for the provided HTML
   if (nzchar(package))
   {
      packagePath <- system.file(package = package)
      if (nzchar(packagePath))
      {
         encoding <- .rs.packageHelpEncoding(packagePath)
         if (identical(encoding, "UTF-8"))
            Encoding(html) <- "UTF-8"
      }
   }
   
   # older releases of R may return HTML (notably, error pages) as
   # a character vector with one line for each bit of output
   #
   # https://github.com/wch/r-source/commit/e22517c9036a2a06d8778b2a782d393224e355af
   html <- paste(html, collapse = "\n")
   
   # try to extract HTML body
   match <- suppressWarnings(regexpr('<body>.*</body>', html))
   if (match < 0)
   {
      html <- NULL
   }
   else
   {
      html <- substring(html, match + 6, match + attr(match, 'match.length') - 1 - 7)
      
      if (subset)
      {   
         slotsMatch <- suppressWarnings(regexpr('<h3>Slots</h3>', html))
         detailsMatch <- suppressWarnings(regexpr('<h3>Details</h3>', html))
         
         match <- if (slotsMatch > detailsMatch) slotsMatch else detailsMatch
         if (match >= 0)
            html <- substring(html, 1, match - 1)
      }
   }
   
   # Try to resolve function signatures for help
   if (is.null(sig) && getSignature)
   {
      object <- NULL
      if (package %in% loadedNamespaces())
      {
         object <- tryCatch(
            get(topic, envir = asNamespace(package)),
            error = function(e) NULL
         )
      }
      
      if (!length(object))
      {
         object <- tryCatch(
            get(topic, pos = globalenv()),
            error = function(e) NULL
         )
      }
      
      if (is.function(object))
      {
         sig <- .rs.getSignature(object)
         sig <- gsub('^function ', topic, sig)
      }
   }
   
   list(
      html = html,
      signature = sig,
      pkgname = package
   )
})

.rs.addJsonRpcHandler("show_help_topic", function(what, from, type)
{
   # strip off a 'package:' prefix if necessary
   if (is.character(from) && nzchar(from))
      from <- sub("^package:", "", from)

   # handle dev topics and objects imported in NAMESPACE if F1 is pressed
   if ("devtools_shims" %in% search() && requireNamespace("pkgload", quietly = TRUE))
   {
     # Find packages loaded via load_all()
     packages <- .rs.tryCatch(pkgload:::dev_packages())
     if (is.character(packages) && from %in% packages)
     {
       from <- NULL
       dev_help <- tryCatch(pkgload::dev_help(what), error = function(e) NULL)
       if (length(dev_help) > 0)
         return(print(dev_help))
     }
   }

   if (type == .rs.acCompletionTypes$FUNCTION)
      .rs.showHelpTopicFunction(what, from)
   else if (type == .rs.acCompletionTypes$ARGUMENT)
      .rs.showHelpTopicArgument(from)
   else if (type == .rs.acCompletionTypes$PACKAGE)
      .rs.showHelpTopicPackage(what)
   else
      .rs.showHelpTopic(what, from)
})

.rs.addFunction("showHelpTopicFunction", function(topic, package)
{
   if (is.null(package) && grepl(":{2,3}", topic, perl = TRUE))
   {
      splat <- strsplit(topic, ":{2,3}", perl = TRUE)[[1]]
      topic <- splat[[2]]
      package <- splat[[1]]
   }
   
   if (!is.null(package))
      requireNamespace(package, quietly = TRUE)
   
   call <- .rs.makeHelpCall(topic, package)
   print(eval(call, envir = parent.frame()))
})

.rs.addFunction("showHelpTopicArgument", function(functionName)
{
   topic <- functionName
   pkgName <- NULL
   
   if (grepl(":{2,3}", functionName, perl = TRUE))
   {
      splat <- strsplit(functionName, ":{2,3}", perl = TRUE)[[1]]
      topic <- splat[[2]]
      pkgName <- splat[[1]]
   }
   
   call <- .rs.makeHelpCall(topic, pkgName)
   print(eval(call, envir = parent.frame()))
})

.rs.addFunction("showHelpTopicPackage", function(pkgName)
{
   pkgName <- sub(":*$", "", pkgName)
   topic <- paste(pkgName, "-package", sep = "")
   call <- .rs.makeHelpCall(topic, pkgName)
   helpfile <- eval(call, envir = parent.frame())
   if (length(helpfile) == 0)
      browseURL(paste0("http://127.0.0.1:", .rs.httpdPort(), "/library/", pkgName, "/html/00Index.html"))
   else 
      print(helpfile)
})

.rs.addFunction("showHelpTopic", function(topic, package)
{
   call <- .rs.makeHelpCall(topic, package)
   print(eval(call, envir = parent.frame()))
})

.rs.addJsonRpcHandler("search", function(query)
{
   # first, check and see if we can get an exact match
   exactMatch <- help(query, help_type = "html")
   if (length(exactMatch) == 1)
   {
      print(exactMatch)
      return()
   }
   
   # if that failed, then we'll do an explicit search
   # if the search term is not a valid regular expression, then escape it
   status <- .rs.tryCatch(grep(query, "", perl = TRUE))
   if (inherits(status, "error"))
      query <- .rs.escapeForRegex(query)
   
   fmt <- "help/doc/html/Search?pattern=%s&title=1&keyword=1&alias=1"
   sprintf(fmt, utils::URLencode(query, reserved = TRUE))
})

.rs.addFunction("followHelpTopic", function(pkg, topic)
{
   tryCatch({
      # first look in the specified package
      file <- utils::help(topic, package = (pkg), help_type = "text", try.all.packages = FALSE)

      # TODO: copy behaviour from utils:::str2logical()
      linksToTopics <- identical(Sys.getenv("_R_HELP_LINKS_TO_TOPICS_", "TRUE"), "TRUE")
      
      # check if topic.Rd exist 
      if (!length(file) && linksToTopics) {
         helppath <- system.file("help", package = pkg)
         if (nzchar(helppath)) {
            contents <- readRDS(sub("/help$", "/Meta/Rd.rds", helppath, fixed = FALSE))
            helpfiles <- sub("\\.[Rr]d$", "", contents$File)
            if (topic %in% helpfiles) file <- file.path(helppath, topic)
         }
      }

      # next, search for topic in all installed packages
      if (!length(file)) {
         file <- utils::help(topic, help_type = "text", try.all.packages = TRUE)
      }

      as.character(file)

   }, error = function(e) character())
   
})

.rs.addJsonRpcHandler("follow_help_topic", function(url)
{
   rx <- "^.*/help/library/([^/]*)/help/(.*)$"
   pkg <- sub(rx, "\\1", url)
   topic <- utils::URLdecode(sub(rx, "\\2", url))

   .rs.followHelpTopic(pkg = pkg, topic = topic)
})

.rs.addFunction("RdLoadMacros", function(file)
{
   maybePackageDir <- dirname(dirname(file))
   if (file.exists(file.path(maybePackageDir, "DESCRIPTION")) ||
       file.exists(file.path(maybePackageDir, "DESCRIPTION.in")))
   {
      # NOTE: ?loadPkgRdMacros has:
      #
      #   loadPkgRdMacros loads the system Rd macros by default
      #
      # so it shouldn't be necessary to load system macros ourselves here
      tools::loadPkgRdMacros(maybePackageDir)
   }
   else
   {
      rMacroPath <- file.path(R.home("share"), "Rd/macros/system.Rd")
      tools::loadRdMacros(rMacroPath)
   }
})

.rs.addFunction("Rd2HTML", function(file, package = "")
{
   tf <- tempfile(); on.exit(unlink(tf))
   macros <- .rs.RdLoadMacros(file)
   tools::Rd2HTML(file, out = tf, package = package, macros = macros, dynamic = TRUE)
   lines <- readLines(tf, warn = FALSE)
   lines <- sub("R Documentation</td></tr></table>", "(preview) R Documentation</td></tr></table>", lines)
   if (nzchar(package))
   {
      # replace with "dev-figure" and parameters so that the server 
      # can look for figures in `man/` of the dev package
      lines <- sub('img src="figures/([^"]*)"', sprintf('img src="dev-figure?pkg=%s&figure=\\1"', package), lines)

      # add ?dev=<topic>
      lines <- gsub('a href="../../([^/]*/help/)([^/]*)">', 'a href="/library/\\1\\2?dev=\\2">', lines)
   }
   
   paste(lines, collapse = "\n")
})

.rs.addFunction("exampleCodeLaunchesApp", function(code)
{
   # Returns TRUE if the supplied example/demo code appears to launch a blocking
   # application (e.g. a Shiny app). Such code, when run inline by R's enhanced
   # HTML help, locks up the session (issue #17178), so we run it in the console
   # instead. We parse the code and inspect the function calls it makes, so that
   # comments and strings mentioning these names don't trigger a false positive.
   exprs <- tryCatch(
      parse(text = code, keep.source = TRUE),
      error = function(e) NULL
   )

   if (is.null(exprs))
      return(FALSE)

   parseData <- utils::getParseData(exprs)
   if (is.null(parseData))
      return(FALSE)

   calls <- parseData$text[parseData$token == "SYMBOL_FUNCTION_CALL"]

   launchers <- c(
      "runApp", "runExample", "runGadget",
      "runUrl", "runGist", "runGitHub",
      "shinyApp", "shinyAppDir", "shinyAppFile",
      "run_tutorial"
   )

   any(calls %in% launchers)
})

.rs.addFunction("helpExampleDivertCommand", function(type, package, topic)
{
   # Fetch the example (or demo) source without running it. Note that
   # 'give.lines = TRUE' applies the same \dontrun{} / \donttest{} commenting
   # as a real example() call, so a launcher living only inside \dontrun{}
   # arrives commented out, doesn't trip detection, and isn't diverted --
   # consistent with the diverted example() call below, which wouldn't have
   # run it either.
   code <- tryCatch(
      suppressWarnings(
         if (identical(type, "Demo"))
            readLines(system.file("demo", paste0(topic, ".R"), package = package, mustWork = TRUE))
         else
            utils::example(
               topic,
               package = package,
               character.only = TRUE,
               give.lines = TRUE
            )
      ),
      error = function(e) {
         # Log before swallowing so a residual lockup stays debuggable.
         msg <- sprintf(
            "Error retrieving %s source for %s::%s: %s",
            tolower(type), package, topic, conditionMessage(e)
         )
         .rs.logWarningMessage(msg)
         NULL
      }
   )

   # If we couldn't read the source, or it doesn't look like it launches a
   # blocking application, let the normal (inline) help server path handle it.
   if (is.null(code) || !.rs.exampleCodeLaunchesApp(code))
      return(NULL)

   sprintf(
      "%s(%s, package = %s)",
      if (identical(type, "Demo")) "demo" else "example",
      deparse(topic),
      deparse(package)
   )
})

.rs.addFunction("runExampleInConsoleIfBlocking", function(type, package, topic)
{
   command <- .rs.helpExampleDivertCommand(type, package, topic)
   if (is.null(command))
      return(FALSE)

   .rs.api.sendToConsole(command, echo = TRUE, execute = TRUE, focus = TRUE)
   TRUE
})

#!/usr/bin/env Rscript

if (!"tools:rstudio" %in% search())
{
   # Needed to source the file below.
   .rs.Env <- attach(NULL, name="tools:rstudio")
   # add a function to the tools:rstudio environment
   assign( envir = .rs.Env, ".rs.addFunction", function(
      name, FN, attrs = list())
   { 
      fullName = paste(".rs.", name, sep="")
      for (attrib in names(attrs))
         attr(FN, attrib) <- attrs[[attrib]]
      assign(fullName, FN, .rs.Env)
      environment(.rs.Env[[fullName]]) <- .rs.Env
   })
}

source(file.path("..", "..", "cpp", "session", "resources", "themes", "compile-themes.R"))

theme_details_map <- list(
   "ambiance" = list(name = "Ambiance", isDark = TRUE),
   "chaos" = list(name = "Chaos", isDark = TRUE),
   "chrome" = list(name = "Chrome", isDark = FALSE),
   "clouds" = list(name = "Clouds", isDark = FALSE),
   "clouds_midnight" = list(name = "Clouds Midnight", isDark = TRUE),
   "cobalt" = list(name = "Cobalt", isDark = TRUE),
   "crimson_editor" = list(name = "Crimson Editor", isDark = FALSE),
   "dawn" = list(name = "Dawn", isDark = FALSE),
   "dracula" = list(name = "Dracula", isDark = TRUE),
   "dreamweaver" = list(name = "Dreamweaver", isDark = FALSE),
   "eclipse" = list(name = "Eclipse", isDark = FALSE),
   "gob" = list(name = "Gob", isDark = TRUE),
   "idle_fingers" = list(name = "Idle Fingers", isDark = TRUE),
   "iplastic" = list(name = "iPlastic", isDark = FALSE),
   "katzenmilch" = list(name = "Katzenmilch", isDark = FALSE),
   "kr_theme" = list(name = "Kr Theme", isDark = TRUE),
   "merbivore" = list(name = "Merbivore", isDark = TRUE),
   "merbivore_soft" = list(name = "Merbivore Soft", isDark = TRUE),
   "mono_industrial" = list(name = "Mono Industrial", isDark = TRUE),
   "monokai" = list(name = "Monokai", isDark = TRUE),
   "pastel_on_dark" = list(name = "Pastel On Dark", isDark = TRUE),
   "solarized_dark" = list(name = "Solarized Dark", isDark = TRUE),
   "solarized_light" = list(name = "Solarized Light", isDark = FALSE),
   "sqlserver" = list(name = "SQL Server", isDark = FALSE),
   "textmate" = list(name = "Textmate (default)", isDark = FALSE),
   "tomorrow" = list(name = "Tomorrow", isDark = FALSE),
   "tomorrow_night" = list(name = "Tomorrow Night", isDark = TRUE),
   "tomorrow_night_blue" = list(name = "Tomorrow Night Blue", isDark = TRUE),
   "tomorrow_night_bright" = list(name = "Tomorrow Night Bright", isDark = TRUE),
   "tomorrow_night_eighties" = list(name = "Tomorrow Night 80s", isDark = TRUE),
   "twilight" = list(name = "Twilight", isDark = TRUE),
   "vibrant_ink" = list(name = "Vibrant Ink", isDark = TRUE),
   "xcode" = list(name = "Xcode", isDark = FALSE)
)

## A set of operator colors to use, for each theme. Should match the name
## of the theme file in ace.
## We need to explicitly set themes that should be overridden with the default 
## value to NULL
operator_theme_map <- list(
   "solarized_light" = "#93A1A1",
   "solarized_dark" = "#B58900",
   "twilight" = "#7587A6",
   "idle_fingers" = "#6892B2",
   "clouds_midnight" = "#A53553",
   "cobalt" = "#BED6FF",
   "kr_theme" = "#A56464",
   "clouds" = NULL,
   "dawn" = NULL,
   "eclipse" = NULL,
   "katzenmilch" = NULL,
   "merbivore" = NULL,
   "merbivore_soft" = NULL,
   "monokai" = NULL,
   "pastel_on_dark" = NULL,
   "vibrant_ink" = NULL,
   "xcode" = NULL,
   NULL
)

node_selector_map <- list(
   "solarized_light" = NULL,
   "solarized_dark" = NULL,
   "twilight" = NULL,
   "idle_fingers" = NULL,
   "clouds_midnight" = NULL,
   "cobalt" = NULL,
   "kr_theme" = NULL,
   "clouds" = NULL,
   "dawn" = NULL,
   "eclipse" = NULL,
   "katzenmilch" = NULL,
   "merbivore" = NULL,
   "merbivore_soft" = NULL,
   "monokai" = NULL,
   "pastel_on_dark" = NULL,
   "vibrant_ink" = NULL,
   "xcode" = NULL,
   NULL
)

comment_bg_map <- list(
   "solarized_light" = list( "fg" = "#5A776B", "bg" = "#FAE5B7" ),
   "solarized_dark" = NULL,
   "twilight" = NULL,
   "idle_fingers" = NULL,
   "clouds_midnight" = NULL,
   "cobalt" = NULL,
   "kr_theme" = NULL,
   "clouds" = NULL,
   "dawn" = NULL,
   "eclipse" = NULL,
   "katzenmilch" = NULL,
   "merbivore" = NULL,
   "merbivore_soft" = NULL,
   "monokai" = NULL,
   "pastel_on_dark" = NULL,
   "vibrant_ink" = NULL,
   "xcode" = NULL,
   NULL
)

## Similarly, colors for keywords that we might override.
keyword_theme_map <- list(
   "eclipse" = "#800080",
   "clouds" = "#800080",
   NULL
)

chunk_bg_proportion_map <- list(
   "tomorrow_night_bright" = 0.85
)

active_dgb_line_map <- list(
   "solarized_dark" = "#585B2C"
)

generate_xterm_16color_map <- function(path = "xrdb") {
   files <- list.files(path = path, full.names = TRUE, pattern = ".*[.]xrdb")

   parse_xrdb_file <- function(file) {
      data <- read.table(file, col.names = c("define", "color", "value"), stringsAsFactors = FALSE, comment.char = "")

      # Keep only the ANSI color definitions
      data <- data[grepl("^Ansi", data$color), ]

      # Rename them
      data$color <- sub("Ansi_(\\d+)_Color", "\\1", data$color)

      setNames(data$value, data$color)
   }

   nms <- sub("[.]xrdb", "", basename(files))

   lapply(setNames(files, nms), parse_xrdb_file)
}

xterm_16color_map <- generate_xterm_16color_map()

applyFixups <- function(content, fileName, parsed) {
   
   methodName <- paste("applyFixups", fileName, sep = ".")
   method <- try(get(methodName), silent = TRUE)
   if (inherits(method, "try-error"))
      return(content)
   
   method(content, parsed)
}

applyFixups.ambiance <- function(content, parsed) {
   
   aceCursorLayerLoc <- grep("^\\s*\\.ace_cursor-layer\\s*{", content, perl = TRUE)
   nextBraceLoc <- .rs.findNext("}", content, aceCursorLayerLoc)
   
   content[aceCursorLayerLoc:nextBraceLoc] <- ""
   
   content
}

applyFixups.cobalt <- function(content, parsed) {
   content <- .rs.setPrintMarginColor(content, "#246")
   content
}

applyFixups.clouds_midnight <- function(content, parsed) {
   content <- .rs.setPrintMarginColor(content, "#333")
   content
}

applyFixups.idle_fingers <- function(content, parsed) {
   content <- .rs.setPrintMarginColor(content, "#555")
   content
}

applyFixups.kr_theme <- function(content, parsed) {
   content <- .rs.setPrintMarginColor(content, "#333")
   content
}

applyFixups.merbivore_soft <- applyFixups.kr_theme
applyFixups.pastel_on_dark <- function(content, parsed)
{
   content <- .rs.setPrintMarginColor(content, "#333")
   content <- .rs.updateSetting(content, "#3F3B3B", "ace_foreign_line", "background-color")
   content <- .rs.updateSetting(content, "#524E4E", "ace_find_line", "background-color")
   content <- .rs.updateSetting(content, "#524E4E", "ace_console_error", "background-color")
   content <- .rs.updateSetting(content, "#EAEAEA", "terminal", "color")
   
   termBgLine <- grep(".xtermInvertBgColor( *){", content, perl = TRUE)
   content[termBgLine] <- paste0(".xtermInvertBgColor { background-color: #EAEAEA; }")
   
   content
}

applyFixups.tomorrow_night_blue <- applyFixups.kr_theme
applyFixups.tomorrow_night_bright <- applyFixups.kr_theme

applyFixups.tomorrow_night_eighties <- function(content, parsed) {
   content <- .rs.setPrintMarginColor(content, "#444")
   content
}
applyFixups.tomorrow_night <- applyFixups.tomorrow_night_eighties

applyFixups.twilight <- function(content, parsed) {
   content <- .rs.setPrintMarginColor(content, "#333")
   content
}

applyFixups.vibrant_ink <- applyFixups.tomorrow_night_eighties

## Get the set of all theme .css files
aceRoot <- "./rstudio-ace"
args <- commandArgs(trailingOnly=TRUE)
if (length(args) >= 1)
   aceRoot <- args[1]

outDir <- "../../cpp/session/resources/themes"
themeDir <- file.path(aceRoot, "/lib/ace/theme")

if (!file.exists(themeDir))
   stop("Ace directory not found. Usage: Rscript compile-themes.R <path-to-ace-reposiotry>")

themeFiles <- list.files(
   path = themeDir,
   full.names = TRUE,
   pattern = "\\.css$"
)

## Process the theme files -- we strip out the name preceding the theme,
## and then add some custom rules.
for (themeFile in themeFiles) {
   content <- suppressWarnings(readLines(themeFile))
   fileName <- gsub("\\.css$", "", basename(themeFile))
   
   # Get whether it's dark or not
   jsContents <- readLines(sub("css$", "js", themeFile), warn = FALSE)
   isDark <- any(grepl("exports.isDark = true;", jsContents))
   
   content <- .rs.compile_theme(
      content,
      isDark,
      fileName,
      chunkBgPropOverrideMap = chunk_bg_proportion_map,
      operatorOverrideMap = operator_theme_map,
      keywordOverrideMap = keyword_theme_map,
      nodeSelectorOverrideMap = node_selector_map,
      commentBgOverrideMap = comment_bg_map, 
      xterm16ColorMap = xterm_16color_map[[fileName]])

   if (length(content) > 0)
   {
      content <- unlist(strsplit(content, "\n"))
      ## Tweak pastel on dark -- we want the foreground color to be white.
      if (identical(basename(themeFile), "pastel_on_dark.css"))
      {
         foreground <- "#EAEAEA"
         content <- .rs.add_content(
            content,
            paste(
               ".ace_editor, ",
               ".ace_editor_theme .profvis-flamegraph, ",
               ".ace_editor_theme {",
               sep = ""
            ),
            "  color: %s !important;",
            "}",
            replace = foreground
         )
      }
      
      ## Tweak chaos on dark -- we want the margin column to not overlap the chunk
      if (identical(basename(themeFile), "chaos.css"))
      {
         content <- .rs.add_content(
            content,
            ".ace_print-margin {",
            "  width: 0px;",
            "}",
            replace = ""
         )
      }
      
      # Add vim and emacs cursor rules generated from fold colors
      # Will fall back to the ace defaults (red) if fold
      # colors aren't found
     
      defaultVimCursorBg <- "rgba(255, 0, 0, 0.5)"
      defaultVimCursorBorder <- "rgb(255, 0, 0)" 
      
      if (!".ace_fold {" %in% content) {
        cursor_background <- defaultVimCursorBg 
        cursor_border <- defaultVimCursorBorder 
      } else {
        # Pull .ace_fold element
        aceFoldLoc <- grep(".ace_fold {", content, perl = TRUE)
        nextBraceLoc <- .rs.findNext("}", content, aceFoldLoc)
        aceFold <- content[-c(1:aceFoldLoc, nextBraceLoc:length(content))] |>
          gsub(pattern = ";", replacement = "", x = _)
        # Get any background color set in .ace_fold element (strangely, chrome
        # has this element, but it's empty)
        if (length(grep("background-color", aceFold, perl = TRUE)) == 1) {
          aceFoldBgLoc <- grep("background-color", aceFold, perl = TRUE)
          aceFoldBgColor <- .rs.strip_color_from_field(aceFold[aceFoldBgLoc])
          # Add transparency/alpha to cursor color so it doesn't completely
          # obscure anything it's directly on top of
          vimCursorBgColor <- .rs.getRgbColor(aceFoldBgColor) |>
            .rs.format_css_color() |>
            gsub("rgb", "rgba", x = _, perl = TRUE) |>
            gsub("\\)", ", 0\\.7\\)", x = _, perl = TRUE)
          cursor_background <- vimCursorBgColor
        } else {
          cursor_background <- defaultVimCursorBg 
        }
       
        # Get any border-color set in .ace_fold 
        if (length(grep("border-color", aceFold, perl = TRUE)) == 1) {
          aceFoldBorderLoc <- grep("border-color", aceFold, perl = TRUE)
          aceFoldBorderColor <- .rs.strip_color_from_field(aceFold[aceFoldBorderLoc]) 
          cursor_border <- aceFoldBorderColor
        } else {
          # Probably makes more sense for inactive cursor border
          # to just fall back to the same color as active cursor,
          # rather than going all the way back to the default red
          cursor_border <- defaultVimCursorBg 
        } 
      }
     
      # Add rule for vim normal-mode cursor 
      content <- .rs.add_content(
          content,
          ".normal-mode .ace_cursor {",
          "  background: %s;",
          "}",
          replace = cursor_background
      )
      
      # Add rule for emacs-mode cursor
      content <- .rs.add_content(
        content,
        ".emacs-mode .ace_cursor{",
        paste("border: 1px", cursor_background,"solid!important;"),
        "box-sizing: border-box!important;",
        "background-color: %s;",
        "opacity: 0.5;",
        "}",
        replace = cursor_background
      )
       
      
      # Add rule for vim cursor
      # when focus is on another window 
      content <- .rs.add_content(
          content,
          ".normal-mode .ace_hidden-cursors .ace_cursor{",  
          "  background-color: transparent;",
          "  border: 1px solid %s;",  
          "}",
          replace = cursor_border
        )
      
     # The rules for the emacs-mode cursor in 
     # the ace stylesheets don't seem to modify
     # colors when not in focus, and the active
     # rule already sets a border. So no need for
     # an equivalent to the above rule for emacs
  
      # Apply final custom fixups
      content <- applyFixups(content, fileName, parsed)
      
      # Add final details
      themeDetails <- if (is.null(theme_details_map[[fileName]])) list(name = fileName, isDark = FALSE)
                      else theme_details_map[[fileName]]
      content <- c(
         paste("/* rs-theme-name:", themeDetails$name, "*/"),
         paste("/* rs-theme-is-dark:", themeDetails$isDark, "*/"),
         content)
      
      ## Phew! Write it out.
      outputPath <- file.path(outDir, paste0(fileName, ".rstheme"))
      cat(content, file = outputPath, sep = "\n")
   }
}

## A script that helps in updating AceThemes.java.

dir <- "/Users/kevin/git/rstudio/src/gwt/src/org/rstudio/studio/client/workbench/views/source/editors/text/themes"
files <- list.files(dir, pattern = "css$")
names <- sub("\\.css$", "", files)

.simpleCap <- function(x) {
   paste(unlist(lapply(x, function(x) {
      s <- strsplit(x, " ")[[1]]
      paste(toupper(substring(s, 1, 1)), substring(s, 2),
            sep = "", collapse = " ")
   })))
}

capcase <- unlist(lapply(names, function(x) {
   splat <- strsplit(x, "_")[[1]]
   paste(.simpleCap(splat), collapse = " ")
}))

Kmisc::cat.cb(sprintf("public static final String %s = \"%s\";",
                      toupper(names),
                      capcase), sep = "\n")

Kmisc::cat.cb(sprintf("addTheme(%s, res.%s());",
              toupper(names),
              names), sep = "\n")

Kmisc::cat.cb(sprintf("@Source(\"%s\")\nStaticDataResource %s();\n",
                      paste(names, ".css", sep = ""),
                      names), sep = "\n")

BOOST_VERSION <- Sys.getenv("BOOST_VERSION", unset = "1.91.0")
MSVC_TOOLSET_VERSION <- Sys.getenv("MSVC_TOOLSET_VERSION", unset = "143")

# derive the b2 toolset from the MSVC toolset version (e.g. 143 => msvc-14.3),
# unless explicitly overridden in the environment
BOOST_TOOLSET_DEFAULT <- paste0(
   "msvc-",
   substring(MSVC_TOOLSET_VERSION, 1L, 2L),
   ".",
   substring(MSVC_TOOLSET_VERSION, 3L)
)
BOOST_TOOLSET <- Sys.getenv("BOOST_TOOLSET", unset = BOOST_TOOLSET_DEFAULT)

argument <- function(index, default) {
   args <- commandArgs(TRUE)
   if (length(args) < index)
      default
   else
      args[[index]]
}

# parse some command line arguments
args <- as.list(commandArgs(TRUE))
variant <- argument(1, "debug")
link    <- argument(2, "static")

# some laziness to ensure we move to the 'install-boost' folder
if (file.exists("rstudio.Rproj"))
   setwd("dependencies/windows/install-boost")

source("../tools.R")
owd <- getwd()

section("Building Boost %s [msvc%s-%s-%s]", BOOST_VERSION, MSVC_TOOLSET_VERSION, variant, link)

# initialize log directory (for when things go wrong)
dir.create("logs", showWarnings = FALSE)
options(log.dir = normalizePath("logs"))

# put RStudio tools on PATH
PATH$prepend("../tools")

# initialize variables
boost_name <- sprintf("boost_%s.7z", chartr(".", "_", BOOST_VERSION))
boost_url <- sprintf("https://s3.amazonaws.com/rstudio-buildtools/Boost/%s", boost_name)
output_name <- sprintf("boost-%s-win-msvc%s-%s-%s.zip", BOOST_VERSION, MSVC_TOOLSET_VERSION, variant, link)
output_dir <- normalizePath(file.path(owd, ".."), winslash = "/")
output_file <- file.path(output_dir, output_name)
install_dir <- file.path(owd, "..", tools::file_path_sans_ext(output_name))

# clear out the directory we'll create boost in
unlink(install_dir, recursive = TRUE)
dir.create(install_dir, recursive = TRUE, showWarnings = FALSE)
install_dir <- normalizePath(install_dir)

# construct paths of interest
boost_filename <- basename(boost_url)
boost_dirname <- tools::file_path_sans_ext(boost_filename)
boost_archive <- boost_filename

if (!file.exists(boost_dirname)) {

   # download boost if we don't have it
   if (!file.exists(boost_archive)) {
      section("Downloading Boost")
      download(boost_url, destfile = boost_archive)
      if (!file.exists(boost_archive))
         fatal("Failed to download '%s'", boost_archive)
   }

   # extract boost (be patient, this will take a while)
   progress("Extracting archive -- please wait a moment...")
   progress("Feel free to get up and grab a coffee.")
   exec("7z.exe", "x -mmt4", boost_filename)

}

# double-check that we generated the boost folder
if (!file.exists(boost_dirname))
   fatal("'%s' doesn't exist (download / extract failed?)", boost_dirname)

# enter boost folder
enter(boost_dirname)

# TODO: Boost has trouble finding the vcvarsall.bat script for some reason?
# We set this environment variable here to help it find the tools.
if (is.na(Sys.getenv("B2_TOOLSET_ROOT", unset = NA))) {
   vcVarsAll <- normalizePath(Sys.which("vcvarsall.bat"), winslash = "/")
   if (nzchar(vcVarsAll)) {
      toolsetRoot <- gsub("VC/.*", "VC/", vcVarsAll)
      Sys.setenv(B2_TOOLSET_ROOT = toolsetRoot)
   }
}

# use rstudio_boost for namespaces
section("Patching Boost namespaces")
source("../../../tools/use-rstudio-boost-namespace.R")

# bootstrap the project
section("Bootstrapping boost")
run("bootstrap.bat", paste0("vc", MSVC_TOOLSET_VERSION))

# construct common arguments for 32bit, 64bit boost builds
build <- function(bitness) {

   buildroot <- "C:/rstudio-tools/boost"
   buildname <- tools::file_path_sans_ext(output_name)
   builddir <- file.path(buildroot, buildname)
   
   unlink(builddir, recursive = TRUE)
   dir.create(builddir, recursive = TRUE, showWarnings = FALSE)
   builddir <- utils::shortPathName(builddir)
   
   prefix <- file.path(install_dir, sprintf("boost%s", bitness), fsep = "/")
   unlink(prefix, recursive = TRUE)
   dir.create(prefix, recursive = TRUE, showWarnings = FALSE)
   prefix <- utils::shortPathName(prefix)

   args <- paste(
      "-q",
      "--with-atomic",
      "--with-chrono",
      "--with-date_time",
      "--with-filesystem",
      "--with-iostreams",
      "--with-program_options",
      "--with-random",
      "--with-regex",
      "--with-thread",
      "--with-url",
      "--abbreviate-paths",
      sprintf("--build-dir=%s", builddir),
      sprintf("--prefix=%s", prefix),
      sprintf("address-model=%s", bitness),
      sprintf("toolset=%s", BOOST_TOOLSET),
      sprintf("variant=%s", variant),
      sprintf("link=%s", link),
      "runtime-link=shared",
      "threading=multi",
      "define=BOOST_USE_WINDOWS_H",
      "define=NOMINMAX",
      "install"
   )
   
   exec("b2", args, output = TRUE)
   
   
}

# build 32bit Boost
section("Building Boost 32bit")
build(bitness = "32")

# build 64bit Boost
section("Building Boost 64bit")
build(bitness = "64")
# rejoice
progress("Boost built successfully!")

#
# SessionTests.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("has_shinytest2_results", function(testFile) {

   # Find the Shiny app directory by walking up from the test file.
   # shinytest2 stores tests in: <appDir>/tests/testthat/
   shinyDir <- dirname(testFile)
   if (identical(basename(shinyDir), "testthat")) {
      shinyDir <- dirname(shinyDir)
   }
   if (identical(basename(shinyDir), "tests")) {
      shinyDir <- dirname(shinyDir)
   } else {
      stop("Could not find Shiny app for test file ", testFile)
   }

   # testthat 3 records pending snapshot diffs as files matching '*.new.*'
   # (e.g. snapshot.new.png) under tests/testthat/_snaps/. Their presence is
   # what 'snapshot_review()' will offer to compare.
   snapsDir <- file.path(shinyDir, "tests", "testthat", "_snaps")
   hasPendingDiffs <- length(list.files(
      snapsDir,
      pattern = "\\.new\\.",
      recursive = TRUE)) > 0

   list(
      appDir = .rs.scalar(shinyDir),
      testDirExists = .rs.scalar(hasPendingDiffs))
})

#
# Source this file, run test(), and then check whether the highlighted code is correct.
#

eval(parse(keep.source = FALSE, text = "
test <- function() {
   apple() + banana() + cherry()
}

apple <- function() {
   'apple'
   browser()
}

banana <- function() {
   'banana'
   browser()
}

cherry <- function() {
   'cherry'
   browser()
}
"))

#
# SessionChat.R
#
# Copyright (C) 2025 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# NOTE: The guardrails implemented here are intended to prevent accidental
# misuse and unintentionally destructive AI-generated code. They should
# not be relied upon to defend against deliberately malicious code.

# Base package names, excluded from "trusted caller" detection
# because the agent could call them directly to access files.
.rs.setVar("chat.basePackages", rownames(
   installed.packages(priority = "base", lib.loc = .Library)
))

# Specific functions from base/recommended packages that are allowed to
# access credential files as part of their legitimate operation (e.g.
# reading ~/.netrc for HTTP authentication). These are captured before
# hook injection so that if they were ever added to the hook list in the
# future, the safe list would still hold the original pre-hook closures.
#
# An explicit allowlist is needed because these functions live in packages
# (like 'utils') that are in the basePkgs set, and therefore excluded
# from the usual trusted-caller namespace check.
.rs.setVar("chat.safeFunctions", list(
   utils::install.packages,
   utils::download.packages,
   utils::available.packages
))


# Each hooked namespace gets its own environment within this container,
# keyed by the namespace name. The per-namespace environment maps
# binding names to their original values.
.rs.setVar("chat.hookedBindings", new.env(parent = emptyenv()))
.rs.setVar("chat.bindingsInjected", FALSE)


# PCRE patterns matched against normalized paths to deny reads.
# Paths are always absolute and normalized before matching.
#
# NOTE: The primary defense against credential file reads is the file
# permission check in isFileReadAllowed (denying files without world-
# readable permissions). These patterns are defense-in-depth for common
# credential paths, in case file permissions are misconfigured.
.rs.setVar("chat.denyReadPatterns", c(

   # Deny files that are likely to contain credentials
   "/\\.aws/credentials$",
   "/\\.aws/config$",
   "/\\.netrc$",
   "/\\.npmrc$",
   "/\\.ssh/config$",

   # Deny container/cloud credential directories
   "/\\.docker(/|$)",
   "/\\.kube(/|$)",

   # Deny cloud provider credential directories
   "/\\.config/gcloud(/|$)",
   "/\\.azure(/|$)",

   # Deny GPG private keys
   "/\\.gnupg(/|$)",

   # Deny package registry credential files
   "/\\.pypirc$",
   "/\\.gem/credentials$",

   # Deny database credential files
   "/\\.pgpass$",
   "/\\.my(login)?\\.cnf$",

   # Deny git credential store
   "/\\.git-credentials$",

   # Deny CLI/API token files
   "/\\.config/gh/hosts\\.ya?ml$",
   "/\\.huggingface/token$",

   # Deny files like .env, .env.local, .Renviron, .Rprofile, and so on.
   "/\\.env(\\.|$)",
   "/\\.Renviron(\\.|$)",
   "/\\.Rprofile(\\.|$)",

   # Deny access to non-public files within the .ssh directory.
   "/\\.ssh/id.*(?<!\\.pub)$"
   
))


# PCRE patterns matched against normalized paths to deny edits.
# Note that file edits are disallowed by default, except for files within
#
# - The R temporary directory
# - The project directory (when a project is open)
# - The current working directory
# - The RStudio scratch path
# - R library paths (.libPaths())
# - R user directories (data, config, cache)
#
# This list serves to deny edits for certain files even if they're within
# one of the above 'allowed' directories.
.rs.setVar("chat.denyEditPatterns", c(

   # Deny edits on or within the .ssh directory.
   "/\\.ssh(/|$)"

))

# PCRE patterns matched against normalized paths to deny access to
# sensitive system files.
.rs.setVar("chat.denySystemPatterns", c(
   "/etc/master\\.passwd$",
   "/etc/passwd$",
   "/etc/shadow$",
   "/etc/sudoers$",
   "/proc/self/environ$"
))


#' Add a preflight validation hook to an existing function.
#'
#' Prepends the body of `hook` to the body of the target function,
#' so that the hook runs before the original implementation. The
#' original binding is saved for later restoration by
#' `.rs.chat.restoreBindings`.
#'
#' @param package The name of the package containing the binding.
#' @param binding The name of the function to hook.
#' @param hook A function whose body will be prepended to the original.
.rs.addFunction("chat.addPreflightHook", function(package, binding, hook)
{
   # resolve the namespace environment
   envir <- asNamespace(package)

   # skip bindings that don't exist (e.g. removed in a future R version)
   if (!exists(binding, envir = envir, inherits = FALSE))
   {
      warning(sprintf("binding '%s' not found in '%s'; skipping hook", binding, package))
      return(invisible(NULL))
   }

   # grab the original binding
   original <- envir[[binding]]

   # get or create the per-namespace storage for original bindings
   if (!exists(package, envir = .rs.chat.hookedBindings, inherits = FALSE))
      .rs.chat.hookedBindings[[package]] <- new.env(parent = emptyenv())
   .rs.chat.hookedBindings[[package]][[binding]] <- original

   # set hook environment and formals to match original (replaceBinding
   # will also set the environment, but we need it here so the merged
   # body can resolve symbols from the original namespace)
   environment(hook) <- environment(original)
   formals(hook) <- formals(original)

   # inject the body of our hook as a prefix to the original code
   body(hook) <- call("{", body(hook), body(original))

   # replace in both namespace and search path
   .rs.replaceBinding(binding, package, hook)

   # return old binding in case caller needs it
   invisible(original)
})

.rs.addFunction("chat.addPreflightHooks", function(package, hooks)
{
   if (!isNamespaceLoaded(package))
      return(invisible())

   .rs.enumerate(hooks, function(binding, hook)
   {
      .rs.chat.addPreflightHook(package, binding, hook)
   })
})


#' Match paths against a pattern.
#'
#' Wrapper around grepl that uses case-insensitive matching on
#' platforms with case-insensitive filesystems (macOS, Windows).
#'
#' @param pattern A PCRE regular expression.
#' @param x A character vector of file paths.
#' @param ... Additional arguments passed to `grepl()`.
.rs.addFunction("chat.pathMatches", function(pattern, x, ...)
{
   grepl(pattern, x, ignore.case = !.rs.platform.isLinux, perl = TRUE, ...)
})

#' Check whether a path lies within a directory.
#'
#' Both `path` and `directory` should be normalized before calling
#' this function.
#'
#' @param path A character vector of file paths.
#' @param directory A single directory path.
.rs.addFunction("chat.isPathWithin", function(path, directory)
{
   # guard against empty, root, or bare Windows drive root directory,
   # any of which would match all (or nearly all) paths
   if (!nzchar(directory) || directory == "/" || grepl("^[A-Za-z]:/?$", directory))
      return(rep.int(FALSE, length(path)))

   pattern <- paste0("^\\Q", directory, "\\E(/|$)")
   .rs.chat.pathMatches(pattern, path)
})

#' Normalize file paths for use in guardrail path comparisons.
#'
#' Expands leading '~' via `path.expand()`, then uses Boost filesystem to
#' resolve symlinks, normalize separators to '/', and remove '.' and '..'
#' components.
#'
#' @param path A character vector of file paths.
.rs.addFunction("chat.normalizePath", function(path)
{
   path[is.na(path)] <- ""
   .Call("rs_chatNormalizePath", path.expand(path), PACKAGE = "(embedding)")
})

#' Check whether a list of functions contains a trusted caller.
#'
#' Given a list of functions (typically extracted from the call stack),
#' returns `TRUE` if any function's environment is a non-base, non-recommended
#' package namespace, or if any function matches the `chat.safeFunctions`
#' allowlist. When either condition is met, the call is considered "trusted" --
#' package code legitimately accessing files should not be blocked by the
#' credential-path deny list.
#'
#' Base packages are excluded because they are general-purpose utilities that
#' the agent could call directly to launder file access (e.g.
#' `base::readLines("~/.aws/credentials")`). Specific functions from these
#' excluded packages (e.g. `utils::install.packages`) that legitimately need
#' credential access are granted trust via the `chat.safeFunctions` allowlist.
#'
#' @param fns A list of functions to check.
#' @return `TRUE` if a trusted caller is found (either a non-base package
#'   namespace or an explicitly safe function).
.rs.addFunction("chat.hasTrustedCallerImpl", function(fns)
{
   basePkgs <- .rs.chat.basePackages
   safeFns  <- .rs.chat.safeFunctions

   for (fn in fns)
   {
      # Allow explicitly safe functions from base/recommended packages
      # (e.g. install.packages) that legitimately access credential files.
      # These are checked before the basePkgs guard below because their
      # namespace would otherwise cause them to be skipped.
      for (safeFn in safeFns)
      {
         if (identical(fn, safeFn))
            return(TRUE)
      }

      envir <- environment(fn)
      if (is.null(envir))
         next

      if (!isNamespace(envir))
         next

      pkg <- getNamespaceName(envir)
      if (pkg %in% basePkgs)
         next

      return(TRUE)
   }

   FALSE
})

#' Check whether the current call has a trusted caller.
#'
#' Collects the functions on the call stack and delegates to
#' `.rs.chat.hasTrustedCallerImpl()`.
#'
#' @return `TRUE` if a trusted caller is on the call stack.
.rs.addFunction("chat.hasTrustedCaller", function()
{
   nframe <- sys.nframe() - 1L  # exclude our own frame
   if (nframe < 1L)
      return(FALSE)
   fns <- lapply(seq_len(nframe), sys.function)
   .rs.chat.hasTrustedCallerImpl(fns)
})

#' Check whether reading the given paths is allowed.
#'
#' Reads are allowed by default, but denied for files that lack
#' world-readable permissions, match well-known sensitive path
#' patterns (e.g. `~/.aws/credentials`, `.env`, `.Renviron`).
#'
#' When `trusted` is `TRUE` (i.e. the call originates from a
#' non-base package), the deny-pattern check is skipped so that
#' package code can legitimately access credential files.
#'
#' @param path A character vector of file paths.
#' @param trusted Whether to skip the deny-pattern check.
#' @return A character vector the same length as `path`, where
#'   empty strings indicate allowed reads and non-empty strings
#'   give the reason the read was denied.
.rs.addFunction("chat.isFileReadAllowed", function(path, trusted = FALSE)
{
   # normalize path for comparison
   path <- .rs.chat.normalizePath(path)

   # assume file reads are permitted by default
   reasons <- rep.int("", length(path))

   # deny reads on files that lack read permission for 'others'
   # (use which() to drop NA modes from non-existent files)
   info <- suppressWarnings(file.info(path))
   deny <- bitwAnd(info$mode, 4L) == 0L
   reasons[which(deny)] <- "File is not world-readable."

   # deny reads matching sensitive path patterns
   # (skip for trusted callers, i.e. non-base package code)
   if (!trusted)
   {
      pattern <- paste(.rs.chat.denyReadPatterns, collapse = "|")
      reasons[.rs.chat.pathMatches(pattern, path)] <- "File may contain secret keys or credentials."
   }

   # deny reads on sensitive system files
   pattern <- paste(.rs.chat.denySystemPatterns, collapse = "|")
   reasons[.rs.chat.pathMatches(pattern, path)] <- "File may contain sensitive system information."

   reasons
})

#' Compute the RStudio user scratch path.
#'
#' Delegates to the C++ `xdg::userDataDir()` so the resolution logic
#' (environment variable overrides, platform defaults, directory
#' creation) stays in one place.
#'
#' @return A single normalized directory path.
.rs.addFunction("chat.userScratchPath", function()
{
   .Call("rs_userDataDir", PACKAGE = "(embedding)")
})

#' Check whether editing the given paths is allowed.
#'
#' Edits are denied by default, but allowed within the R temporary
#' directory, the active project directory, the current working
#' directory, the RStudio user scratch path, R library paths, and
#' R user directories (data, config, cache). Edits within sensitive
#' directories (e.g. `~/.ssh`) are always denied.
#'
#' @param path A character vector of file paths.
#' @return A character vector the same length as `path`, where
#'   empty strings indicate allowed edits and non-empty strings
#'   give the reason the edit was denied.
.rs.addFunction("chat.isFileEditAllowed", function(path)
{
   # normalize path for comparison
   path <- .rs.chat.normalizePath(path)

   # assume file edits are disallowed by default
   reasons <- rep.int(
      "Path is not within the project, working directory, or other allowed locations.",
      length(path)
   )

   # allow edits within the R temporary directory
   tempDir <- .rs.chat.normalizePath(tempdir())
   reasons[.rs.chat.isPathWithin(path, tempDir)] <- ""

   # allow edits within the project directory
   projectDir <- .rs.getProjectDirectory()
   if (!is.null(projectDir))
   {
      projectDir <- .rs.chat.normalizePath(projectDir)
      reasons[.rs.chat.isPathWithin(path, projectDir)] <- ""
   }

   # allow edits within the current working directory
   workingDir <- .rs.chat.normalizePath(getwd())
   reasons[.rs.chat.isPathWithin(path, workingDir)] <- ""

   # allow edits within the RStudio scratch path (e.g. ~/.local/share/rstudio),
   # since tool-invoked code may update files there
   scratchDir <- .rs.chat.userScratchPath()
   reasons[.rs.chat.isPathWithin(path, scratchDir)] <- ""

   # allow edits within R library paths (e.g. for package installation)
   for (libPath in .libPaths())
   {
      libPath <- .rs.chat.normalizePath(libPath)
      reasons[.rs.chat.isPathWithin(path, libPath)] <- ""
   }

   # allow edits within R user directories (data, config, cache),
   # e.g. ~/.local/share/R, ~/.config/R, ~/.cache/R on Linux.
   # Use dirname() to obtain the parent directory from a dummy package name.
   # tools::R_user_dir was introduced in R 4.0.0.
   if (getRversion() >= "4.0.0")
   {
      for (which in c("data", "config", "cache"))
      {
         rDir <- .rs.chat.normalizePath(dirname(tools::R_user_dir("_", which = which)))
         reasons[.rs.chat.isPathWithin(path, rDir)] <- ""
      }
   }

   # deny edits matching sensitive path patterns (both read and edit
   # deny lists apply, since edits should be at least as restrictive)
   pattern <- paste(c(.rs.chat.denyReadPatterns, .rs.chat.denyEditPatterns), collapse = "|")
   reasons[.rs.chat.pathMatches(pattern, path)] <- "File may contain secret keys or credentials."

   # deny edits on sensitive system files
   pattern <- paste(.rs.chat.denySystemPatterns, collapse = "|")
   reasons[.rs.chat.pathMatches(pattern, path)] <- "File may contain sensitive system information."

   reasons
})

.rs.addFunction("chat.validateFileEdit", function(action, path)
{
   reasons <- .rs.chat.isFileEditAllowed(path)
   denied <- nzchar(reasons)
   if (!any(denied))
      return(TRUE)

   details <- sprintf("- Action: %s()\n- Path:   %s\n- Reason: %s",
      action, path[denied], reasons[denied])
   msg <- paste(c("One or more agent file operations were blocked.", details), collapse = "\n\n")
   stop(msg, call. = FALSE)
})

.rs.addFunction("chat.validateFileRead", function(action, path)
{
   trusted <- .rs.chat.hasTrustedCaller()
   reasons <- .rs.chat.isFileReadAllowed(path, trusted = trusted)
   denied <- nzchar(reasons)
   if (!any(denied))
      return(TRUE)

   details <- sprintf("- Action: %s()\n- Path:   %s\n- Reason: %s",
      action, path[denied], reasons[denied])
   msg <- paste(c("One or more agent file operations were blocked.", details), collapse = "\n\n")
   stop(msg, call. = FALSE)
})

#' Validate a connection open based on the open mode.
#'
#' When `open` is "" (deferred), the connection could later be used for
#' reading or writing, so it is validated as an edit (which applies both
#' the read and edit deny lists).
#'
#' @param name The name of the connection function (e.g. "file", "gzfile").
#' @param description The file path passed to the connection constructor.
#' @param open The open mode string.
.rs.addFunction("chat.validateConnection", function(name, description, open)
{
   if (!nzchar(description))
      return()

   if (!nzchar(open) || grepl("[wWaA+]", open))
   {
      .rs.chat.validateFileEdit(name, description)
   }
   else
   {
      .rs.chat.validateFileRead(name, description)
   }
})

# inject preflight validation hooks into security-sensitive R
# functions. Each hook is prepended to the original function body via
# .rs.chat.addPreflightHook so that calls are validated before the real
# implementation executes. hooks are removed by .rs.chat.restoreBindings.
.rs.addFunction("chat.injectBindings", function()
{
   # guard against reentrant calls -- if hooks are already injected,
   # skip injection to avoid overwriting saved originals
   if (.rs.chat.bindingsInjected)
      return(invisible())

   baseHooks <- list(

      unlink = function()
      {
         # Block recursive deletes in the user's home directory
         if ("*" %in% x)
         {
            workDir <- .rs.chat.normalizePath(getwd())
            homeDir <- .rs.chat.normalizePath("~")
            if (identical(workDir, homeDir))
            {
               msg <- "denied agent from executing unlink(\"*\") on user home directory"
               stop(msg, call. = FALSE)
            }
         }
         
         # The 'expand' formal was added in R 4.0.0; on older versions,
         # unlink always performed glob expansion.
         doExpand <- getRversion() < "4.0.0" || expand
         paths <- if (doExpand) Sys.glob(x) else x
         .rs.chat.validateFileEdit("unlink", paths)
      },

      file.create = function()
      {
         .rs.chat.validateFileEdit("file.create", c(...))
      },

      file.remove = function()
      {
         .rs.chat.validateFileEdit("file.remove", c(...))
      },

      file.rename = function()
      {
         .rs.chat.validateFileEdit("file.rename", c(from, to))
      },

      file.append = function()
      {
         .rs.chat.validateFileEdit("file.append", file1)
         .rs.chat.validateFileRead("file.append", file2)
      },

      file.copy = function()
      {
         .rs.chat.validateFileRead("file.copy", from)
         .rs.chat.validateFileEdit("file.copy", to)
      },

      file.symlink = function()
      {
         .rs.chat.validateFileRead("file.symlink", from)
         .rs.chat.validateFileEdit("file.symlink", to)
      },

      file.link = function()
      {
         .rs.chat.validateFileRead("file.link", from)
         .rs.chat.validateFileEdit("file.link", to)
      },

      file = function()
      {
         .rs.chat.validateConnection("file", description, open)
      },

      gzfile = function()
      {
         .rs.chat.validateConnection("gzfile", description, open)
      },

      bzfile = function()
      {
         .rs.chat.validateConnection("bzfile", description, open)
      },

      xzfile = function()
      {
         .rs.chat.validateConnection("xzfile", description, open)
      },

      readLines = function()
      {
         if (is.character(con) && nzchar(con))
            .rs.chat.validateFileRead("readLines", con)
      },
      
      writeLines = function()
      {
         if (is.character(con) && nzchar(con))
            .rs.chat.validateFileEdit("writeLines", con)
      },

      cat = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileEdit("cat", file)
      },

      readChar = function()
      {
         if (is.character(con) && nzchar(con))
            .rs.chat.validateFileRead("readChar", con)
      },

      writeChar = function()
      {
         if (is.character(con) && nzchar(con))
            .rs.chat.validateFileEdit("writeChar", con)
      },

      readBin = function()
      {
         if (is.character(con) && nzchar(con))
            .rs.chat.validateFileRead("readBin", con)
      },

      writeBin = function()
      {
         if (is.character(con) && nzchar(con))
            .rs.chat.validateFileEdit("writeBin", con)
      },

      save = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileEdit("save", file)
      },

      load = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileRead("load", file)
      },

      source = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileRead("source", file)
      },

      sys.source = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileRead("sys.source", file)
      },

      readRDS = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileRead("readRDS", file)
      },

      saveRDS = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileEdit("saveRDS", file)
      },

      dput = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileEdit("dput", file)
      },

      dump = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileEdit("dump", file)
      },

      dir.create = function()
      {
         .rs.chat.validateFileEdit("dir.create", path)
      },

      Sys.chmod = function()
      {
         .rs.chat.validateFileEdit("Sys.chmod", paths)
      },

      Sys.setFileTime = function()
      {
         .rs.chat.validateFileEdit("Sys.setFileTime", path)
      },

      sink = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileEdit("sink", file)
      }

   )

   .rs.chat.addPreflightHooks("base", baseHooks)

   utilsHooks <- list(

      download.file = function()
      {
         .rs.chat.validateFileEdit("download.file", destfile)
      },

      write.table = function()
      {
         if (is.character(file) && nzchar(file))
            .rs.chat.validateFileEdit("write.table", file)
      }

   )

   .rs.chat.addPreflightHooks("utils", utilsHooks)

   fsHooks <- list(

      file_create = function()
      {
         .rs.chat.validateFileEdit("file_create", path)
      },

      file_delete = function()
      {
         .rs.chat.validateFileEdit("file_delete", path)
      },

      file_copy = function()
      {
         .rs.chat.validateFileRead("file_copy", path)
         .rs.chat.validateFileEdit("file_copy", new_path)
      },

      file_move = function()
      {
         .rs.chat.validateFileEdit("file_move", c(path, new_path))
      },

      file_chmod = function()
      {
         .rs.chat.validateFileEdit("file_chmod", path)
      },

      file_chown = function()
      {
         .rs.chat.validateFileEdit("file_chown", path)
      },

      file_touch = function()
      {
         .rs.chat.validateFileEdit("file_touch", path)
      },

      file_show = function()
      {
         .rs.chat.validateFileRead("file_show", path)
      }

   )

   .rs.chat.addPreflightHooks("fs", fsHooks)

   .rs.setVar("chat.bindingsInjected", TRUE)
   invisible(TRUE)
})

.rs.addFunction("chat.restoreBindings", function()
{
   packages <- ls(envir = .rs.chat.hookedBindings, all.names = TRUE)
   allRestored <- TRUE
   
   for (package in packages)
   {
      originals <- .rs.chat.hookedBindings[[package]]
      bindings <- ls(envir = originals, all.names = TRUE)
      
      for (binding in bindings)
      {
         status <- .rs.tryCatch(.rs.replaceBinding(binding, package, originals[[binding]]))
         if (inherits(status, "error"))
         {
            warning(sprintf(
               "failed to restore binding '%s' in '%s': %s",
               binding, package, conditionMessage(status)
            ))
            allRestored <- FALSE
         }
         else
         {
            rm(list = binding, envir = originals)
         }
      }
      
      # only remove the package entry if all bindings were restored
      if (length(ls(envir = originals, all.names = TRUE)) == 0L)
         rm(list = package, envir = .rs.chat.hookedBindings)
   }
   
   if (allRestored)
      .rs.setVar("chat.bindingsInjected", FALSE)
})


# Run an expression with the chat guardrail bindings active, restoring the
# originals on exit (even if `expr` errors). Errors propagate to the caller;
# this is the building block for safeEval (which swallows them) and for
# Playwright tests that want to drive each path deterministically without
# installing a per-suite test helper that races with R startup.
.rs.addFunction("chat.withGuardrails", function(expr, envir = parent.frame())
{
   on.exit({
      tryCatch(
         .rs.chat.restoreBindings(),
         error = function(e) {
            warning("failed to restore bindings: ", conditionMessage(e))
         }
      )
   }, add = TRUE)
   .rs.chat.injectBindings()
   eval(expr, envir = envir)
})


# Helper function for evaluating code for the 'runCode' tool.
.rs.addFunction("chat.safeEval", function(expr, envir = globalenv())
{
   conditionState <- new.env(parent = emptyenv())
   conditionState$conditions <- list()

   tryCatch(
      error = function(e) {
         attr(e, "assistant_conditions") <- conditionState$conditions
         e
      },
      interrupt = function(e) {
         attr(e, "assistant_conditions") <- conditionState$conditions
         e
      },
      {

         # Register cleanup first so bindings are restored even if
         # injectBindings() itself errors partway through
         on.exit({
            tryCatch(
               .rs.chat.restoreBindings(),
               error = function(e) {
                  warning("failed to restore bindings: ", conditionMessage(e))
               }
            )
         }, add = TRUE)
         .rs.chat.injectBindings()

         # Evaluate the provided code. Warnings are muffled after recording:
         # left alone, R defers them to the end of the whole batch and prints
         # them with the internal eval() call as context. The caller re-emits
         # them per expression instead (see writeWarningMessages in
         # SessionChat.cpp, fed by .rs.chat.formatWarningMessages below).
         # Recording follows the REPL's warn option: with warn < 0 warnings
         # are suppressed entirely, and with warn >= 2 muffling would defeat
         # the warning-to-error conversion (which happens after calling
         # handlers run) and the warning surfaces as the error itself, so
         # neither is recorded for re-emission. (warn = 1's immediate
         # printing becomes end-of-expression printing here -- a deliberate
         # divergence that keeps output attached to its expression.)
         result <- withCallingHandlers(
            withVisible(eval(expr, envir = envir)),
            warning = function(w) {
               warnLevel <- getOption("warn", 0L)
               if (warnLevel >= 2L)
                  return()
               if (warnLevel >= 0L)
               {
                  conditionState$conditions[[length(conditionState$conditions) + 1L]] <- list(
                     type = "warning",
                     text = conditionMessage(w)
                  )
               }
               invokeRestart("muffleWarning")
            },
            message = function(m) {
               conditionState$conditions[[length(conditionState$conditions) + 1L]] <- list(
                  type = "message",
                  text = conditionMessage(m)
               )
            }
         )
         result$conditions <- conditionState$conditions
         result

      }
   )
})

# Format warnings recorded by chat.safeEval approximately the way the REPL
# prints deferred warnings after an expression completes. Only the message
# text is recorded, so the REPL's "In <call> :" context and its ">50
# warnings" collapsing are not reproduced.
.rs.addFunction("chat.formatWarningMessages", function(conditions)
{
   texts <- character(0)
   for (condition in conditions)
   {
      if (identical(condition$type, "warning"))
         texts <- c(texts, condition$text)
   }

   if (length(texts) == 0L)
      ""
   else if (length(texts) == 1L)
      paste0("Warning message:\n", texts, "\n")
   else
      paste0(
         "Warning messages:\n",
         paste0(seq_along(texts), ": ", texts, "\n", collapse = "")
      )
})

.rs.addFunction("chat.callExpressionBoundaryHook", function(name, expr, value, ok, visible, error = NULL, conditions = list())
{
   if (!nzchar(name))
      return(invisible(NULL))

   hook <- get0(name, envir = globalenv(), inherits = FALSE)
   if (!is.function(hook))
      return(invisible(NULL))

   # Swallow hook errors so a buggy hook can't abort the user's code, but
   # log them -- otherwise a hook bug degrades interleaving with no signal.
   tryCatch(
      hook(
         expr = expr,
         value = value,
         ok = ok,
         visible = visible,
         error = error,
         conditions = conditions
      ),
      error = function(e) {
         .rs.logWarningMessage(paste0(
            "expression boundary hook '", name, "' failed: ", conditionMessage(e)
         ))
         NULL
      }
   )

   invisible(NULL)
})

# Helper function to capture a recorded plot as base64-encoded PNG
.rs.addFunction("chat.capturePlotFromRecorded", function(recordedPlot)
{
   # Get plot dimensions from options or use defaults
   # Default: 7x7 inches at 96 DPI (R's standard default)
   width <- getOption("repr.plot.width", 7)
   height <- getOption("repr.plot.height", 7)
   dpi <- 96

   # Calculate pixel dimensions
   widthPx <- as.integer(width * dpi)
   heightPx <- as.integer(height * dpi)

   # Create temporary file for PNG output
   tmpFile <- tempfile(fileext = ".png")
   on.exit(unlink(tmpFile), add = TRUE)

   # Open PNG device and replay plot
   tryCatch({
      png(tmpFile, width = widthPx, height = heightPx, res = dpi)
      replayPlot(recordedPlot)
      dev.off()

      # Base64 encode the PNG file using built-in C++ implementation
      encoded <- .rs.base64encodeFile(tmpFile)

      list(
         data = encoded,
         mimeType = "image/png",
         width = widthPx,
         height = heightPx
      )
   }, error = function(e) {
      # Ensure device is closed on error
      if (dev.cur() > 1) dev.off()
      warning(paste("Failed to capture plot:", conditionMessage(e)))
      NULL
   })
})

# Get the current recorded plot (used to detect if plotting occurred)
.rs.addFunction("chat.getRecordedPlot", function()
{
   if (dev.cur() <= 1)
      return(NULL)

   tryCatch(recordPlot(), error = function(e) NULL)
})

# Capture the current plot, but only if plotting occurred since the given
# recorded plot snapshot (to avoid returning stale plots from previous executions).
#
# NOTE: This only captures the final plot state. If code creates multiple plots
# (e.g., plot(1); plot(2)), only the last one is captured. This is a known
# limitation compared to the previous evaluate-based approach.
#
# Returns NULL if no NEW plot is available, otherwise returns a list with:
#   - data: base64-encoded PNG
#   - mimeType: "image/png"
#   - width: pixel width
#   - height: pixel height
.rs.addFunction("chat.captureCurrentPlot", function(plotBefore = NULL)
{
   # No graphics device open
   if (dev.cur() <= 1)
      return(NULL)

   # Try to record the current plot
   recordedPlot <- tryCatch({
      recorded <- recordPlot()
      # Check if the display list is non-empty
      if (is.null(recorded) || length(recorded[[1]]) == 0)
         return(NULL)
      recorded
   }, error = function(e) {
      NULL
   })

   if (is.null(recordedPlot))
      return(NULL)

   # Check if the plot changed since before execution
   # If the plots are identical, this is a stale plot from a previous execution
   if (!is.null(plotBefore)) {
      # Compare the plot objects to see if plotting actually occurred
      if (identical(recordedPlot, plotBefore))
         return(NULL)
   }

   # Use the helper to capture and encode the plot
   plotData <- .rs.chat.capturePlotFromRecorded(recordedPlot)

   if (!is.null(plotData)) {
      # Also replay the plot to the current RStudio device so it appears in the plots pane
      tryCatch({
         replayPlot(recordedPlot)
      }, error = function(e) {
         # Ignore errors in replay - the plot was already captured successfully
      })
   }

   plotData
})

#' Build the R command run in a --vanilla child process to fetch the manifest.
#'
#' The parent session has already resolved download.file.* options (profile +
#' runtime), so capture them here and inject them so the vanilla child reproduces
#' the parent's proxy/method configuration. options(timeout = 30L) is the
#' documented transfer-timeout knob; download.file() has no timeout argument.
#'
#' @param url The manifest URL to download.
.rs.addFunction("chat.manifestDownloadCommand", function(url)
{
   serialize <- function(value) paste(deparse(value), collapse = " ")

   args <- c(serialize(url), "destfile = tmp", "quiet = TRUE")

   method <- getOption("download.file.method")
   if (!is.null(method))
      args <- c(args, sprintf("method = %s", serialize(method)))

   extra <- getOption("download.file.extra")
   if (!is.null(extra))
      args <- c(args, sprintf("extra = %s", serialize(extra)))

   # Propagate download failures as a non-zero process exit. Some methods return
   # a non-zero status with only a warning (rather than erroring), so capture the
   # status and stop() before reading the file -- the manifest subprocess
   # contract is that a download failure surfaces as a non-zero exit status, not
   # a clean exit with a partial/empty body on stdout.
   # cat() with the default sep = " " would replace newlines with spaces; use
   # sep = "\n" so the downloaded body round-trips verbatim on stdout rather than
   # relying on JSON tolerating that substitution.
   sprintf(
      "{ options(timeout = 30L); tmp <- tempfile(); status <- download.file(%s); if (!isTRUE(status == 0)) stop(paste('download.file failed, status', status)); cat(readLines(tmp, warn = FALSE), sep = '\\n') }",
      paste(args, collapse = ", ")
   )
})

#
# test-dataviewer.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("data viewer")

test_that(".rs.formatDataColumnDispatch() iterates over the classes", {
    registerS3method("[", "foo",  function(x, ...) {
        structure(NextMethod(), class = class(x))
    })
    registerS3method("format", "foo", function(x, ...) {
        rep("Hi there!", length(x))
    })
    
    x <- structure("x", class = c("foo", "bar", "character"))
    expect_equal(.rs.formatDataColumnDispatch(x), "Hi there!")
    expect_equal(.rs.formatDataColumn(x, 1, 1), "Hi there!")

    x <- structure("x", class = c("bar", "foo", "character"))
    expect_equal(.rs.formatDataColumnDispatch(x), "Hi there!")
    expect_equal(.rs.formatDataColumn(x, 1, 1), "Hi there!")
})

test_that(".rs.formatDataColumn() truncates lists", {
    col <- list(
        paste0(rep("a", 100), collapse = ""), 
        "small"
    )
    x <- .rs.formatDataColumn(col, 1, 2)
    expect_equal(
        grepl("\\[\\.{3}\\]$", x), 
        c(TRUE, FALSE)
    )
})

test_that(".rs.flattenFrame() handles matrices and data frames", {
   tbl1 <- data.frame(x = 1:2)
   df_col <- data.frame(y = 1:2, z = 1:2)
   tbl1$df_col <- df_col
   tbl1$mat_col <- matrix(1:4, ncol = 2)
   flat1 <- .rs.flattenFrame(tbl1)

   # same but matrix has colnames
   tbl2 <- tbl1
   tbl2$mat_col <- matrix(1:4, ncol = 2, dimnames = list(1:2, c("a", "b")))
   flat2 <- .rs.flattenFrame(tbl2)
   
   # further df nesting 
   tbl3 <- tbl2
   df_col$df <- df_col
   tbl3$df_col <- df_col
   flat3 <- .rs.flattenFrame(tbl3)

   expect_equal(names(flat1), c("x", "df_col$y", "df_col$z", "mat_col[, 1]", "mat_col[, 2]"))
   expect_equal(names(flat2), c("x", "df_col$y", "df_col$z", 'mat_col[, "a"]', 'mat_col[, "b"]'))
   expect_equal(names(flat3), c("x", "df_col$y", "df_col$z", "df_col$df$y", "df_col$df$z", 'mat_col[, "a"]', 'mat_col[, "b"]'))
})

test_that(".rs.describeColsByIndex() describes the requested columns", {
   tbl <- data.frame(x = 1:2, y = 1:2, x = 1:2)
   # length includes the always-present rownames column at the front
   expect_equal(length(.rs.describeColsByIndex(tbl, 1)), 2)
   expect_equal(length(.rs.describeColsByIndex(tbl, c(1, 2))), 3)
   expect_equal(length(.rs.describeColsByIndex(tbl, 1:3)), 4)
   # out-of-range indices are dropped
   expect_equal(length(.rs.describeColsByIndex(tbl, c(1, 99))), 2)
   # an empty / all-invalid request falls back to the full frame
   expect_equal(length(.rs.describeColsByIndex(tbl, integer())), 4)
   expect_equal(length(.rs.describeColsByIndex(tbl, c(0, -1))), 4)
})

test_that(".rs.describeColsByIndex() preserves order and reports absolute col_index", {
   tbl <- data.frame(a = 1:2, b = 1:2, c = 1:2, d = 1:2)

   # An arbitrary, non-contiguous request (pinned column first, then a window)
   # is honored in order, and each column carries its absolute index.
   res <- .rs.describeColsByIndex(tbl, c(1, 3, 4))
   expect_equal(length(res), 4)
   expect_equal(res[[1]]$col_type, .rs.scalar("rownames"))
   expect_equal(res[[1]]$col_index, .rs.scalar(0L))
   expect_equal(res[[2]]$col_index, .rs.scalar(1L))
   expect_equal(res[[2]]$col_name, .rs.scalar("a"))
   expect_equal(res[[3]]$col_index, .rs.scalar(3L))
   expect_equal(res[[3]]$col_name, .rs.scalar("c"))
   expect_equal(res[[4]]$col_index, .rs.scalar(4L))
   expect_equal(res[[4]]$col_name, .rs.scalar("d"))

   # The non-paginated path reports contiguous absolute indices by default.
   direct <- .rs.describeCols(tbl)
   expect_equal(direct[[1]]$col_index, .rs.scalar(0L))
   expect_equal(direct[[2]]$col_index, .rs.scalar(1L))
   expect_equal(direct[[5]]$col_index, .rs.scalar(4L))
})

test_that(".rs.describeColsByIndex() returns NULL for empty data frames", {
   tbl <- data.frame()
   expect_equal(.rs.describeColsByIndex(tbl, 1), NULL)
})

test_that(".rs.describeColsByIndex() emits a fingerprint stable across pagination", {
   tbl <- as.data.frame(setNames(
      replicate(20, 1:5, simplify = FALSE),
      paste0("X", 1:20)
   ))
   slice_a <- .rs.describeColsByIndex(tbl, 1:5)
   slice_b <- .rs.describeColsByIndex(tbl, 6:10)
   slice_c <- .rs.describeColsByIndex(tbl, 16:20)

   # The rownames slot is always the first column and is where the
   # fingerprint is attached. Anchor that here so a refactor that moves
   # the slot doesn't make the rest of the test silently pass on NULLs.
   expect_equal(slice_a[[1]]$col_type, .rs.scalar("rownames"))

   # Same underlying frame -> identical fingerprint regardless of slice.
   expect_identical(slice_a[[1]]$cols_fingerprint, slice_b[[1]]$cols_fingerprint)
   expect_identical(slice_a[[1]]$cols_fingerprint, slice_c[[1]]$cols_fingerprint)

   # A different frame produces a different fingerprint.
   other <- data.frame(a = 1:5, b = 1:5, c = 1:5)
   slice_other <- .rs.describeColsByIndex(other, 1:3)
   expect_false(identical(slice_a[[1]]$cols_fingerprint,
                          slice_other[[1]]$cols_fingerprint))

   # describeCols (the non-paginated path) also emits a fingerprint, and it
   # matches the slice-path fingerprint for the same underlying frame.
   direct <- .rs.describeCols(tbl)
   expect_identical(direct[[1]]$cols_fingerprint,
                    slice_a[[1]]$cols_fingerprint)
})

test_that(".rs.describeCols() fingerprint distinguishes hyphen-collisions", {
   # Reassignments like c("a-b", "c") vs c("a", "b-c") must not produce
   # identical fingerprints, otherwise the per-object state check intended
   # to detect object reassignment would silently apply mismatched indices.
   x1 <- setNames(data.frame(1:3, 4:6), c("a-b", "c"))
   x2 <- setNames(data.frame(1:3, 4:6), c("a", "b-c"))
   fp1 <- .rs.describeCols(x1)[[1]]$cols_fingerprint
   fp2 <- .rs.describeCols(x2)[[1]]$cols_fingerprint
   expect_false(identical(fp1, fp2))
})

test_that(".rs.dataViewer.colsFingerprint() reflects column types and factor levels", {
   # Saved filters are typed (numeric ranges, factor level indices), so a
   # column changing type -- or a factor being re-leveled -- with unchanged
   # names must change the fingerprint; otherwise a restored filter is
   # silently applied with the wrong semantics.
   numeric_x <- data.frame(a = 1:3, b = c(1.5, 2.5, 3.5))
   character_x <- data.frame(a = as.character(1:3), b = c(1.5, 2.5, 3.5))
   expect_false(identical(.rs.dataViewer.colsFingerprint(numeric_x),
                          .rs.dataViewer.colsFingerprint(character_x)))

   # Re-leveling a factor changes the meaning of a saved level-index filter.
   levels_ab <- data.frame(f = factor(c("a", "b")))
   levels_ba <- data.frame(f = factor(c("a", "b"), levels = c("b", "a")))
   expect_false(identical(.rs.dataViewer.colsFingerprint(levels_ab),
                          .rs.dataViewer.colsFingerprint(levels_ba)))

   # Same names and same types -> stable fingerprint, even when values differ
   # (saved state should survive plain data edits).
   values_1 <- data.frame(a = 1:3, b = c("x", "y", "z"))
   values_2 <- data.frame(a = 4:6, b = c("p", "q", "r"))
   expect_identical(.rs.dataViewer.colsFingerprint(values_1),
                    .rs.dataViewer.colsFingerprint(values_2))
})

test_that(".rs.dataViewer.colsFingerprint() returns NA for empty/NULL names", {
   # The client treats a null/missing fingerprint as always-mismatch and
   # discards any saved per-object state -- there's no anchor to align
   # positional indices against, so applying them would be unsafe.
   expect_true(is.na(.rs.dataViewer.colsFingerprint(data.frame())))

   noNames <- data.frame(1:3, 4:6)
   names(noNames) <- NULL
   expect_true(is.na(.rs.dataViewer.colsFingerprint(noNames)))

   # Empty character vector (the zero-length-names case the client guards
   # against) must hash to NA, not to digest("")
   expect_true(is.na(.rs.dataViewer.colsFingerprint(structure(list(), names = character()))))
})

test_that(".rs.digest() distinguishes character vectors that concat-collide", {
   # A naive delimiter join would let c("a","b") and c("ab") hash
   # identically; serialize() encodes element boundaries unambiguously
   # so these always differ.
   expect_false(identical(.rs.digest(c("a", "b")), .rs.digest("ab")))
   expect_false(identical(.rs.digest(c("a-b", "c")), .rs.digest(c("a", "b-c"))))

   # Stable across calls.
   expect_identical(.rs.digest(c("x", "y")), .rs.digest(c("x", "y")))
})

test_that(".rs.digest() matches the canonical Adler-32 reference value", {
   # 0x024d0127 is the standard Adler-32 of "abc" -- guards against
   # accidental algorithm drift in the chunked integer rewrite.
   expect_identical(.rs.digest(charToRaw("abc")), "024d0127")

   # Adler-32 of the empty input is defined as 1.
   expect_identical(.rs.digest(raw()), "00000001")

   # Pin a serialize()-routed input. Real callers (colsFingerprint,
   # log-once dedup) pass character vectors. .rs.digest() pins
   # serialize(version = 2L) and zeroes the writer-version field so the
   # hash is stable across R upgrades; if either of those guards is
   # dropped, this expectation will fire on whichever R version doesn't
   # match the value the test was originally pinned against.
   expect_identical(.rs.digest(c("a", "b")), "1732015b")
})

test_that(".rs.digest() zeroes the v2 writer-version field", {
   # serialize(version = 2L) embeds the writer's R version in bytes
   # 7-10 of its output. The character-input path of .rs.digest()
   # zeroes those bytes before hashing so the colsFingerprint
   # persisted alongside data-viewer state stays stable across R
   # upgrades. Verify by reproducing the post-patch bytes manually
   # and feeding them in via the raw path (which hashes directly,
   # without re-patching).
   manuallyPatched <- serialize(c("a", "b"), connection = NULL,
                                ascii = FALSE, version = 2L)
   manuallyPatched[7:10] <- as.raw(0L)
   expect_identical(.rs.digest(c("a", "b")), .rs.digest(manuallyPatched))

   # And without the patch, the writer-version bytes change the hash
   # -- if .rs.digest() ever stops patching, this would silently
   # invalidate every persisted data-viewer state token after an R
   # upgrade.
   unpatched <- serialize(c("a", "b"), connection = NULL,
                          ascii = FALSE, version = 2L)
   expect_false(identical(.rs.digest(c("a", "b")), .rs.digest(unpatched)))
})

test_that(".rs.digest() chunked path matches the recursive Adler-32 spec", {
   # Cross-check the chunked implementation against a byte-at-a-time
   # reference taken straight from the spec. Inputs deliberately span
   # several chunks (chunk size is 1024) and include a non-multiple
   # length so the partial trailing chunk is exercised.
   refAdler32 <- function(bytes) {
      a <- 1L
      b <- 0L
      for (byte in as.integer(bytes))
      {
         a <- (a + byte) %% 65521L
         b <- (b + a) %% 65521L
      }
      sprintf("%04x%04x", b, a)
   }

   uniform <- as.raw(rep(255L, 5000L))
   expect_identical(.rs.digest(uniform), refAdler32(uniform))

   mixed <- as.raw(rep_len(0:255, 5000L))
   expect_identical(.rs.digest(mixed), refAdler32(mixed))

   # Bracket the chunk-size boundary: n=1023 (just under, single short
   # chunk), n=1024 (exact single chunk), n=1025 (two iterations, with
   # a degenerate k=1 trailing chunk). An off-by-one in either
   # `end <- min(pos + size - 1L, n)` or the `pos <= n` loop condition
   # would slip through a multi-chunk test like n=2048 but get caught
   # by at least one of these.
   under <- as.raw(rep_len(0:255, 1023L))
   expect_identical(.rs.digest(under), refAdler32(under))

   exact <- as.raw(rep_len(0:255, 1024L))
   expect_identical(.rs.digest(exact), refAdler32(exact))

   over <- as.raw(rep_len(0:255, 1025L))
   expect_identical(.rs.digest(over), refAdler32(over))

   # Two full chunks -- guards against the chunk-stitching arithmetic
   # (k*a carry between iterations) drifting from the recursive form.
   twoChunks <- as.raw(rep_len(0:255, 2048L))
   expect_identical(.rs.digest(twoChunks), refAdler32(twoChunks))
})

# Helper: strip the rs.scalar class wrapper so tests can compare against
# bare R values without forcing every expect_equal to know the wrapping.
.rs.summarize.bare <- function(x) {
   if (is.null(x)) return(NULL)
   unclass(x)
}

test_that(".rs.summarizeColumn() reports out-of-range column indices", {
   df <- data.frame(x = 1:3, y = letters[1:3], stringsAsFactors = FALSE)
   expect_true(!is.null(.rs.summarizeColumn(df, 0)$error))
   expect_true(!is.null(.rs.summarizeColumn(df, -1)$error))
   expect_true(!is.null(.rs.summarizeColumn(df, 99)$error))
})

test_that(".rs.summarizeColumn() summarizes numeric columns", {
   df <- data.frame(x = c(1, 2, NA, 4, 5))
   r <- .rs.summarizeColumn(df, 1)
   expect_equal(.rs.summarize.bare(r$n), 5L)
   expect_equal(.rs.summarize.bare(r$n_na), 1L)
   expect_equal(.rs.summarize.bare(r$n_unique), 4L)
   expect_equal(.rs.summarize.bare(r$min), 1)
   expect_equal(.rs.summarize.bare(r$max), 5)
   expect_equal(.rs.summarize.bare(r$mean), 3)
   expect_equal(.rs.summarize.bare(r$median), 3)
})

test_that(".rs.summarizeColumn() handles all-NA numeric columns without producing min/max", {
   df <- data.frame(x = NA_real_)
   r <- .rs.summarizeColumn(df, 1)
   expect_equal(.rs.summarize.bare(r$n), 1L)
   expect_equal(.rs.summarize.bare(r$n_na), 1L)
   expect_null(r$min)
   expect_null(r$max)
   expect_null(r$mean)
})

test_that(".rs.summarizeColumn() summarizes character columns", {
   df <- data.frame(
      x = c("apple", "banana", "", NA, "cherry"),
      stringsAsFactors = FALSE
   )
   r <- .rs.summarizeColumn(df, 1)
   expect_equal(.rs.summarize.bare(r$n_unique), 4L)
   expect_equal(.rs.summarize.bare(r$min_length), 0L)
   expect_equal(.rs.summarize.bare(r$max_length), 6L)
   # n_empty counts only "" not NA values
   expect_equal(.rs.summarize.bare(r$n_empty), 1L)
})

test_that(".rs.summarizeColumn() preserves factor level order and aligns counts", {
   # Use a non-alphabetical level ordering to confirm we don't sort.
   df <- data.frame(
      x = factor(c("medium", "high", "low", "medium", "low", "low"),
                 levels = c("low", "medium", "high"))
   )
   r <- .rs.summarizeColumn(df, 1)
   expect_equal(r$top_levels, c("low", "medium", "high"))
   # top_counts must align positionally with top_levels.
   expect_equal(r$top_counts, c(3L, 2L, 1L))
   expect_null(r$truncated)
})

test_that(".rs.summarizeColumn() truncates factors with > 50 levels and flags truncated", {
   lvls <- sprintf("L%03d", 1:75)
   df <- data.frame(x = factor(sample(lvls, 200, replace = TRUE), levels = lvls))
   r <- .rs.summarizeColumn(df, 1)
   expect_equal(length(r$top_levels), 50L)
   expect_equal(length(r$top_counts), 50L)
   # Truncation preserves encoding order: first 50 levels, in order.
   expect_equal(r$top_levels, lvls[1:50])
   expect_equal(.rs.summarize.bare(r$truncated), TRUE)
})

test_that(".rs.summarizeColumn() summarizes logical columns", {
   df <- data.frame(x = c(TRUE, TRUE, FALSE, NA, TRUE))
   r <- .rs.summarizeColumn(df, 1)
   expect_equal(.rs.summarize.bare(r$n_true), 3L)
   expect_equal(.rs.summarize.bare(r$n_false), 1L)
})

test_that(".rs.summarizeColumn() summarizes Date columns", {
   df <- data.frame(x = as.Date(c("2024-01-01", "2024-06-15", NA, "2024-12-31")))
   r <- .rs.summarizeColumn(df, 1)
   expect_equal(.rs.summarize.bare(r$min), "2024-01-01")
   expect_equal(.rs.summarize.bare(r$max), "2024-12-31")
})

test_that(".rs.summarizeColumn() summarizes POSIXct columns", {
   df <- data.frame(x = as.POSIXct(c("2024-01-01 09:00:00", "2024-06-15 17:30:00"),
                                   tz = "UTC"))
   r <- .rs.summarizeColumn(df, 1)
   expect_match(.rs.summarize.bare(r$min), "^2024-01-01")
   expect_match(.rs.summarize.bare(r$max), "^2024-06-15")
})

test_that(".rs.summarizeColumn() returns base stats for unsupported column types", {
   # complex and raw don't match any of the typed branches.
   df <- data.frame(x = as.complex(c(1, 2, NA)))
   r <- .rs.summarizeColumn(df, 1)
   expect_equal(.rs.summarize.bare(r$n), 3L)
   expect_equal(.rs.summarize.bare(r$n_na), 1L)
   # No type-specific stats keys.
   expect_null(r$min)
   expect_null(r$top_levels)
   expect_null(r$n_true)
})

test_that(".rs.summarizeColumn() handles zero-row data frames", {
   df <- data.frame(x = integer(0))
   r <- .rs.summarizeColumn(df, 1)
   expect_equal(.rs.summarize.bare(r$n), 0L)
   expect_equal(.rs.summarize.bare(r$n_na), 0L)
   expect_equal(.rs.summarize.bare(r$n_unique), 0L)
   expect_null(r$min)
})

test_that(".rs.describeCols() reports col_type as typeof() and col_class as class()", {
   df <- data.frame(
      d = c(1.5, 2.5),
      i = 1:2,
      c = c("a", "b"),
      l = c(TRUE, FALSE),
      f = factor(c("x", "y")),
      stringsAsFactors = FALSE
   )
   # a list column whose elements are themselves atomic vectors -- this is the
   # shape from #17863 that the old first-element heuristic misclassified as
   # "unknown" rather than "list"
   df$lst <- list(1:3, 4:6)

   cols <- .rs.describeCols(df)

   # cols[[1]] is the synthetic rownames column
   expect_equal(cols[[1]]$col_type, .rs.scalar("rownames"))
   expect_equal(cols[[1]]$col_class, "rownames")

   # data columns follow, in order, reporting typeof() and class()
   types   <- vapply(cols[-1], function(col) as.character(col$col_type), "")
   classes <- lapply(cols[-1], function(col) col$col_class)
   expect_equal(types, c("double", "integer", "character", "logical", "integer", "list"))
   expect_equal(classes, list("numeric", "integer", "character", "logical", "factor", "list"))

   # the Data Import preview keys its column-type detection on col_class[[1]]
   # (read as col_class[0] in DataImportOptions.java), so the most-specific
   # class must be the first element of the array for every column
   first_class <- vapply(cols[-1], function(col) col$col_class[[1]], "")
   expect_equal(first_class, c("numeric", "integer", "character", "logical", "factor", "list"))
})

test_that(".rs.describeCols() handles integer columns whose range overflows", {
   # max_v - min_v overflows integer arithmetic here; the integer-breaks
   # heuristic must compute the range in double precision rather than
   # erroring with "missing value where TRUE/FALSE needed". See #17951.
   df <- data.frame(id = c(-2000000000L, 2000000000L))

   cols <- .rs.describeCols(df)

   col <- cols[[2L]]
   expect_equal(col$col_search_type, .rs.scalar("numeric"))
   expect_true(length(col$col_breaks) > 1)
   expect_equal(sum(col$col_counts), 2)
})

test_that(".rs.describeCols() summarizes large-magnitude whole-number columns", {
   # Whole-number doubles at very large magnitudes (here ~ -2^53) within a
   # narrow range trip the integer-breaks heuristic, but seq(min - 0.5, max +
   # 0.5, by = 1) collapses to a single value at that floating-point
   # resolution. hist() then treats the lone break as a scalar bin count and
   # errors with "invalid number of 'breaks'" (negative values are < 1),
   # which previously aborted the whole describe call and broke the data
   # viewer. We now fall back to default binning instead. See #17990.
   df <- data.frame(id = c(-2^53, -2^53 + 2, -2^53 + 4))

   cols <- .rs.describeCols(df)

   col <- cols[[2L]]
   expect_equal(col$col_search_type, .rs.scalar("numeric"))
   expect_true(length(col$col_breaks) > 1)
   expect_equal(sum(col$col_counts), 3)
})

test_that(".rs.describeCols() reports the data range for numeric columns", {
   # col_min / col_max carry the actual finite data range (the histogram
   # breaks can extend past it: pretty()-ed for default binning, padded by
   # 0.5 for integer bins); the sidebar displays them under the sparkline,
   # which has no axis ticks. Non-numeric columns omit the fields entirely,
   # as does a numeric column with too few finite values to summarize.
   df <- data.frame(x = c(1.5, NA, 4.25, 3), y = letters[1:4], z = c(NA, NA, NA, 7))

   cols <- .rs.describeCols(df)

   x <- cols[[2L]]
   expect_equal(x[["col_min"]], .rs.scalar(1.5))
   expect_equal(x[["col_max"]], .rs.scalar(4.25))

   # exact [[ indexing: $col_max would partial-match col_max_chars
   expect_null(cols[[3L]][["col_min"]])
   expect_null(cols[[3L]][["col_max"]])
   expect_null(cols[[4L]][["col_min"]])
   expect_null(cols[[4L]][["col_max"]])
})

test_that(".rs.describeCols() excludes infinite values from the data range", {
   # the range is computed over finite values only (matching the histogram);
   # an Inf endpoint would not survive JSON serialization as a number and
   # would silently blank the sidebar footer
   df <- data.frame(x = c(1, 2, Inf), y = c(-Inf, 5, 10))

   cols <- .rs.describeCols(df)

   expect_equal(cols[[2L]][["col_min"]], .rs.scalar(1))
   expect_equal(cols[[2L]][["col_max"]], .rs.scalar(2))
   expect_equal(cols[[3L]][["col_min"]], .rs.scalar(5))
   expect_equal(cols[[3L]][["col_max"]], .rs.scalar(10))
})

test_that(".rs.describeCols() ships category counts for low-cardinality columns", {
   df <- data.frame(
      f = factor(c("a", "b", "b", NA), levels = c("a", "b", "c")),
      s = c("x", "y", "y", "y"),
      stringsAsFactors = FALSE)

   cols <- .rs.describeCols(df)

   # factors: one count per level, in level order (unused levels included,
   # NA values excluded); col_vals (the filter dropdown's source) unchanged
   f <- cols[[2L]]
   expect_equal(f$col_vals, c("a", "b", "c"))
   expect_equal(f[["col_cat_vals"]], c("a", "b", "c"))
   expect_equal(f[["col_cat_counts"]], c(1L, 2L, 0L))

   # characters: most frequent first, with the distinct-value count
   s <- cols[[3L]]
   expect_equal(s[["col_cat_vals"]], c("y", "x"))
   expect_equal(s[["col_cat_counts"]], c(3L, 1L))
   expect_equal(s[["col_n_unique"]], .rs.scalar(2L))
})

test_that(".rs.describeCols() falls back to a text summary above the bar cutoff", {
   # 26 distinct values > the 24-bar cutoff (maxCategoryBars), so no
   # category counts are shipped -- just the cardinality and the dominant
   # value
   df <- data.frame(
      f = factor(rep(letters, times = c(3, rep(1, 25)))),
      s = rep(LETTERS, times = c(3, rep(1, 25))),
      stringsAsFactors = FALSE)

   cols <- .rs.describeCols(df)

   f <- cols[[2L]]
   expect_null(f[["col_cat_counts"]])
   expect_equal(f$col_vals, letters)
   expect_equal(f[["col_top_value"]], .rs.scalar("a"))
   expect_equal(f[["col_top_count"]], .rs.scalar(3L))

   s <- cols[[3L]]
   expect_null(s[["col_cat_counts"]])
   expect_equal(s[["col_n_unique"]], .rs.scalar(26L))
   expect_equal(s[["col_top_value"]], .rs.scalar("A"))
   expect_equal(s[["col_top_count"]], .rs.scalar(3L))
})

test_that(".rs.describeCols() draws the line at exactly 24 categories", {
   # the cutoff (maxCategoryBars) is inclusive: exactly 24 distinct values
   # still get bars, 25 fall back to the text summary
   vals24 <- c(letters[1:24], letters[1:24])
   vals25 <- c(letters[1:25], letters[1:25])
   df24 <- data.frame(f = factor(vals24), s = vals24, stringsAsFactors = FALSE)
   df25 <- data.frame(f = factor(vals25), s = vals25, stringsAsFactors = FALSE)

   cols24 <- .rs.describeCols(df24)
   cols25 <- .rs.describeCols(df25)

   expect_equal(cols24[[2L]][["col_cat_vals"]], letters[1:24])
   expect_equal(cols24[[2L]][["col_cat_counts"]], rep(2L, 24L))
   expect_length(cols24[[3L]][["col_cat_vals"]], 24L)
   expect_equal(cols24[[3L]][["col_cat_counts"]], rep(2L, 24L))

   expect_null(cols25[[2L]][["col_cat_counts"]])
   expect_equal(cols25[[2L]][["col_top_count"]], .rs.scalar(2L))
   expect_null(cols25[[3L]][["col_cat_counts"]])
   expect_equal(cols25[[3L]][["col_n_unique"]], .rs.scalar(25L))
})

test_that(".rs.describeCols() tolerates list columns of character / factor vectors", {
   # branch selection peeks at the column's first element, so a list column
   # of character vectors enters the character branch (and a list of factors
   # the factor branch); the category computation must gate on the column
   # type, or table() / as.integer() on a ragged list errors and takes the
   # whole describe call (and thus the grid) down with it
   df <- data.frame(x = 1:3)
   df$tokens <- strsplit(c("a b", "c", "d e f"), " ")
   df$f <- list(factor("a"), factor("b"), factor("c"))

   cols <- .rs.describeCols(df)

   # no category metadata ships for either list column...
   tokens <- cols[[3L]]
   expect_null(tokens[["col_cat_counts"]])
   expect_null(tokens[["col_n_unique"]])
   expect_null(tokens[["col_top_value"]])
   f <- cols[[4L]]
   expect_null(f[["col_cat_counts"]])
   expect_null(f[["col_top_value"]])

   # ...but the pre-existing branch behavior is preserved
   expect_equal(tokens$col_search_type, .rs.scalar("character"))
   expect_equal(f$col_search_type, .rs.scalar("factor"))
})

test_that(".rs.describeCols() survives a malformed maxCategorizeRows option", {
   # the option is user-supplied; NA (or any non-scalar / non-numeric value)
   # must fall back to the default rather than erroring out of describeCols
   old <- options(rstudio.dataViewer.maxCategorizeRows = NA)
   on.exit(options(old), add = TRUE)

   df <- data.frame(s = c("a", "b", "a"), stringsAsFactors = FALSE)
   cols <- .rs.describeCols(df)

   s <- cols[[2L]]
   expect_equal(s[["col_cat_vals"]], c("a", "b"))
   expect_equal(s[["col_cat_counts"]], c(2L, 1L))

   options(rstudio.dataViewer.maxCategorizeRows = "banana")
   cols <- .rs.describeCols(df)
   expect_equal(cols[[2L]][["col_cat_counts"]], c(2L, 1L))
})

test_that(".rs.describeCols() skips character categorization above the row limit", {
   # table() over a long character column is not free, so categorization is
   # gated on a row-count limit (default 1e6, here lowered for the test)
   old <- options(rstudio.dataViewer.maxCategorizeRows = 2L)
   on.exit(options(old), add = TRUE)

   df <- data.frame(
      s = c("a", "b", "a"),
      f = factor(c("x", "y", "x")),
      stringsAsFactors = FALSE)
   cols <- .rs.describeCols(df)

   s <- cols[[2L]]
   expect_null(s[["col_cat_counts"]])
   expect_null(s[["col_n_unique"]])
   expect_null(s[["col_top_value"]])

   # the gate is character-only by design: factor counts come from a cheap
   # tabulate() over the integer codes, so they survive on frames of any
   # length
   f <- cols[[3L]]
   expect_equal(f[["col_cat_vals"]], c("x", "y"))
   expect_equal(f[["col_cat_counts"]], c(2L, 1L))
})

test_that(".rs.describeCols() reports a nested data.frame column faithfully", {
   df <- data.frame(a = 1:2)
   # a column that is itself a data.frame. describeCols does not flatten (that
   # happens upstream in the viewer pipeline via .rs.flattenFrame), so it must
   # report the column as typeof() "list" with class() "data.frame" -- the
   # shape the frontend's isDataFrameColumn relies on to tell list and
   # data.frame columns apart.
   df$nested <- data.frame(x = c(1.5, 2.5), y = c(3L, 4L))

   cols <- .rs.describeCols(df)

   # cols[[1]] rownames, cols[[2]] = a, cols[[3]] = nested
   nested <- cols[[3L]]
   expect_equal(nested$col_type, .rs.scalar("list"))
   expect_equal(nested$col_class, "data.frame")
})

test_that(".rs.applyTransform() does not error when sorting a list column", {
   df <- data.frame(a = c(3L, 1L, 2L))
   df$b <- list(10:12, 1:2, 100)

   # column 2 is the list column; sorting it must be a no-op rather than an
   # error ("unimplemented type 'list' in 'orderVector1'"). See #17863.
   asc  <- .rs.applyTransform(df, character(), "", 2L, "asc")
   desc <- .rs.applyTransform(df, character(), "", 2L, "desc")
   expect_equal(asc$a, df$a)
   expect_equal(desc$a, df$a)

   # sorting an atomic column still works
   sorted <- .rs.applyTransform(df, character(), "", 1L, "asc")
   expect_equal(sorted$a, c(1L, 2L, 3L))
})

test_that(".rs.applyTransform() applies a character filter as case-insensitive substring", {
   df <- data.frame(x = c("apple", "Grape", "pineapple", "cherry"),
                    y = 1:4)

   # substring match, not anchored to the start
   out <- .rs.applyTransform(df, c("character|apple", ""), "", integer(), character())
   expect_equal(out$x, c("apple", "pineapple"))

   # case-insensitive
   out <- .rs.applyTransform(df, c("character|GRAPE", ""), "", integer(), character())
   expect_equal(out$x, "Grape")

   # regex metacharacters are matched literally
   df <- data.frame(x = c("a.b", "axb"))
   out <- .rs.applyTransform(df, "character|a.b", "", integer(), character())
   expect_equal(out$x, "a.b")
})

test_that(".rs.applyTransform() applies a factor filter by level index", {
   df <- data.frame(f = factor(c("b", "a", "c", "a"), levels = c("a", "b", "c")),
                    y = 1:4)

   # "factor|1" selects the first level ("a"), not the first value
   out <- .rs.applyTransform(df, c("factor|1", ""), "", integer(), character())
   expect_equal(as.character(out$f), c("a", "a"))
   expect_equal(out$y, c(2L, 4L))

   # NA entries never match
   df$f[1] <- NA
   out <- .rs.applyTransform(df, c("factor|2", ""), "", integer(), character())
   expect_equal(nrow(out), 0L)
})

test_that(".rs.applyTransform() applies numeric range and equality filters", {
   df <- data.frame(x = c(1, 5, 10, NA, Inf, 7), y = 1:6)

   # inclusive range; NA and infinite values are dropped implicitly
   out <- .rs.applyTransform(df, c("numeric|5_10", ""), "", integer(), character())
   expect_equal(out$x, c(5, 10, 7))

   # single-value equality
   out <- .rs.applyTransform(df, c("numeric|7", ""), "", integer(), character())
   expect_equal(out$y, 6L)

   # negative bounds
   df <- data.frame(x = c(-10, -5, 0, 5))
   out <- .rs.applyTransform(df, "numeric|-7_0", "", integer(), character())
   expect_equal(out$x, c(-5, 0))
})

test_that(".rs.applyTransform() applies a boolean filter and drops NA rows", {
   df <- data.frame(b = c(TRUE, FALSE, NA, TRUE), y = 1:4)

   out <- .rs.applyTransform(df, c("boolean|TRUE", ""), "", integer(), character())
   expect_equal(out$y, c(1L, 4L))

   out <- .rs.applyTransform(df, c("boolean|FALSE", ""), "", integer(), character())
   expect_equal(out$y, 2L)
})

test_that(".rs.applyTransform() ignores malformed and empty column filters", {
   df <- data.frame(x = c("a", "b"), y = 1:2)

   # no type prefix: skipped rather than applied or errored
   out <- .rs.applyTransform(df, c("justtext", ""), "", integer(), character())
   expect_equal(nrow(out), 2L)

   # empty filter strings leave the frame untouched
   out <- .rs.applyTransform(df, c("", ""), "", integer(), character())
   expect_equal(nrow(out), 2L)
})

test_that(".rs.applyTransform() global search matches data and row names", {
   df <- data.frame(x = c("apple", "banana"), y = c("zucchini", "apricot"),
                    row.names = c("first", "second"))

   # substring across all columns, case-insensitive
   out <- .rs.applyTransform(df, character(2L), "AP", integer(), character())
   expect_equal(rownames(out), c("first", "second"))

   out <- .rs.applyTransform(df, character(2L), "zucc", integer(), character())
   expect_equal(rownames(out), "first")

   # matches against row names too
   out <- .rs.applyTransform(df, character(2L), "second", integer(), character())
   expect_equal(out$x, "banana")
})

test_that(".rs.applyTransform() column filters compose with search and sort", {
   df <- data.frame(x = c("ab", "ab", "ab", "cd"),
                    y = c("u", "v", "u", "u"),
                    z = c(3, 1, 2, 0))

   out <- .rs.applyTransform(df, c("character|ab", "", ""), "u", 3L, "desc")
   expect_equal(out$z, c(3, 2))
})

test_that(".rs.applyTransform() sorts non-numeric column types in both directions", {
   # character
   df <- data.frame(x = c("pear", "apple", "fig"))
   expect_equal(.rs.applyTransform(df, character(), "", 1L, "asc")$x,
                c("apple", "fig", "pear"))
   expect_equal(.rs.applyTransform(df, character(), "", 1L, "desc")$x,
                c("pear", "fig", "apple"))

   # factor: sorts by level order, not alphabetically
   df <- data.frame(f = factor(c("high", "low", "mid"),
                               levels = c("low", "mid", "high")))
   expect_equal(as.character(.rs.applyTransform(df, character(), "", 1L, "asc")$f),
                c("low", "mid", "high"))
   expect_equal(as.character(.rs.applyTransform(df, character(), "", 1L, "desc")$f),
                c("high", "mid", "low"))

   # logical
   df <- data.frame(b = c(TRUE, FALSE, TRUE))
   expect_equal(.rs.applyTransform(df, character(), "", 1L, "asc")$b,
                c(FALSE, TRUE, TRUE))
   expect_equal(.rs.applyTransform(df, character(), "", 1L, "desc")$b,
                c(TRUE, TRUE, FALSE))

   # Date
   df <- data.frame(d = as.Date(c("2024-06-01", "2023-01-15", "2025-12-31")))
   expect_equal(.rs.applyTransform(df, character(), "", 1L, "asc")$d,
                sort(df$d))
   expect_equal(.rs.applyTransform(df, character(), "", 1L, "desc")$d,
                sort(df$d, decreasing = TRUE))

   # POSIXct
   df <- data.frame(t = as.POSIXct(c("2024-06-01 12:00:00",
                                     "2024-06-01 09:30:00",
                                     "2024-06-01 23:59:59"), tz = "UTC"))
   expect_equal(.rs.applyTransform(df, character(), "", 1L, "desc")$t,
                sort(df$t, decreasing = TRUE))
})

test_that(".rs.applyTransform() applies every key in a multi-column sort", {
   # primary key 'a' has ties that the tiebreaker 'c' resolves; 'b' is a list
   # column sitting between them so it is skipped without disturbing the
   # dirs/vals alignment of the remaining keys. The old "for (i in length(cols))"
   # loop ran once with the last key only, sorting by 'c' alone.
   df <- data.frame(a = c(1L, 1L, 2L, 2L))
   df$b <- list(1, 2:3, 4:6, 7)
   df$c <- c(2L, 1L, 2L, 1L)

   sorted <- .rs.applyTransform(df, character(3L), "",
                                c(1L, 2L, 3L), c("asc", "asc", "asc"))

   # correct multi-key result: primary 'a' ascending, ties broken by 'c'
   expect_equal(sorted$a, c(1L, 1L, 2L, 2L))
   expect_equal(sorted$c, c(1L, 2L, 1L, 2L))
})

#
# test-source-progress.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("source-progress")

# one-time setup; load progress script
source(file.path(.rs.sessionModulePath(), "SourceWithProgress.R"))

# given the output of an R script, extract the progress markers and build a list with name/value
# pairs for each one (note that this will capture only the last value emitted when multiple markers
# with the same category exist)
processOutput <- function(output) {
   values <- list()
   for (line in seq_along(output)) {
      result <- regexec("__rs_progress_0__ (\\w+) __ (.*) __rs_progress_1__", output[[line]])
      if (length(result[[1]]) > 2) {
         matches <- regmatches(output[[line]], result)[[1]]
         values[[matches[[2]]]] <- matches[[3]]
      }
   }
   values
}

# sources the given script with progress and returns the value of all emitted progress markers
progressResult <- function(path) {
   p <- tempfile(fileext = ".txt")
   on.exit(file.remove(p), add = TRUE)
   con <- file(p, open = "at")

   .rs.sourceWithProgress(script = path, con = con)
   close(con)

   processOutput(readLines(p))
}

test_that("progress reports include expected values", {
   output <- progressResult("resources/source-progress/three.R")

   expect_equal("3", output[["count"]])
   expect_equal("3", output[["statement"]])
   expect_equal("1", output[["completed"]])
})

test_that("sections in source are emitted as status", {
   output <- progressResult("resources/source-progress/sections.R")

   expect_equal("Compute", output[["section"]])
})

test_that("environment import/export works", {
   # create a new environment with a couple of values
   inputEnv <- new.env(parent = emptyenv())
   assign("x", 1, envir = inputEnv)
   assign("y", 2, envir = inputEnv)

   # write the environment to disk
   inputRdata <- tempfile(fileext = ".Rdata")
   on.exit(file.remove(inputRdata), add = TRUE)
   save(list = ls(inputEnv), file = inputRdata, envir = inputEnv)

   # create filename for output
   outputRdata <- tempfile(fileext = ".Rdata")
   on.exit(file.remove(outputRdata), add = TRUE)

   # source the script; it simply adds x and y to make z
   .rs.sourceWithProgress(script = "resources/source-progress/assignment.R",
                      con = NULL,
                      importRdata = inputRdata,
                      exportRdata = outputRdata)

   # load results into a new environment
   outputEnv <- new.env(parent = emptyenv())
   load(file = outputRdata, envir = outputEnv)

   # validate results
   expect_equal(3, get("z", envir = outputEnv))
})

#
# test-rsconnect.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("rsconnect")

test_that("setting UI prefs updates options", {
   # save old preference values and restore on exit
   checkCerts <- getOption("rsconnect.check.certificate")
   caBundle <- getOption("rsconnect.ca.bundle")
   on.exit({
      options(rsconnect.check.certificate = checkCerts,
              rsconnect.ca.bundle         = caBundle)
   }, add = TRUE)

   # save old UI prefs and restore on exit
   publishCheckCertificates <- .rs.readUiPref("publish_check_certificates")
   usePublishCaBundle <- .rs.readUiPref("use_publish_ca_bundle")
   publishCaBundle <- .rs.readUiPref("publish_ca_bundle")
   on.exit({
      .rs.writeUiPref("publish_check_certificates", publishCheckCertificates)
      .rs.writeUiPref("use_publish_ca_bundle", usePublishCaBundle)
      .rs.writeUiPref("publish_ca_bundle", publishCaBundle)
   }, add = TRUE)

   # check toggle for certificates
   .rs.writeUiPref("publish_check_certificates", TRUE)
   expect_true(getOption("rsconnect.check.certificate"))
   .rs.writeUiPref("publish_check_certificates", FALSE)
   expect_false(getOption("rsconnect.check.certificate"))

   # use a custom bundle
   .rs.writeUiPref("publish_ca_bundle", "42")
   .rs.writeUiPref("use_publish_ca_bundle", TRUE)
   expect_equal(getOption("rsconnect.ca.bundle"), "42")

   # don't use a bundle
   .rs.writeUiPref("use_publish_ca_bundle", FALSE)
   expect_null(getOption("rsconnect.ca.bundle"))
})

test_that(".rs.rsconnectDeployList() includes _quarto.yml and _metadata.yml files (#10995 )", {
   skip_if_not_installed("quarto")
   dir.create(tf <- tempfile()); on.exit(unlink(tf, TRUE, TRUE))
   dir.create(file.path(tf, "sub"))

   #---- quarto file not included in a quarto project
   # i.e. not _quarto.yml file
   main <- file.path(tf, "main.qmd")
   writeLines("---\ntitle: quarto document\n---\n", main)

   sub <- file.path(tf, "sub", "sub.qmd")
   writeLines("---\ntitle: quarto document\n---\n", sub)

   res <- .rs.rsconnectDeployList(main, FALSE, main)[[1L]]
   expect_true(!any(grepl("_quarto.yml", res)))

   res <- .rs.rsconnectDeployList(sub, FALSE, sub)[[1L]]
   expect_true(!any(grepl("_quarto.yml", res)))

   #---- quarto file in a quarto project
   writeLines('project:\n  title: "test"\n', file.path(tf, "_quarto.yml"))
   res <- .rs.rsconnectDeployList(main, FALSE, main)[[1L]]
   expect_true("_quarto.yml" %in% res)

   res <- .rs.rsconnectDeployList(sub, FALSE, sub)[[1L]]
   expect_true("../_quarto.yml" %in% res)

   #--- also with _metadata.yml
   writeLines('meta: data\n', file.path(tf, "_metadata.yml"))
   res <- .rs.rsconnectDeployList(main, FALSE, main)[[1L]]
   expect_true("_quarto.yml" %in% res)
   expect_true("_metadata.yml" %in% res)

   writeLines('meta: data\n', file.path(tf, "sub", "_metadata.yml"))
   res <- .rs.rsconnectDeployList(sub, FALSE, sub)[[1L]]
   expect_true("../_quarto.yml" %in% res)
   expect_true("_metadata.yml" %in% res)
})

test_that(".rs.docDeployList() tolerates non-existent resource files", {
   dir.create(tf <- tempfile()); on.exit(unlink(tf, TRUE, TRUE))

   main <- file.path(tf, "main.qmd")
   writeLines("---\ntitle: test\n---\n", main)

   # Stub quartoFileProject to return a resource that doesn't exist on disk,
   # simulating Quarto v1.9 reporting project metadata for standalone files
   rsEnv <- as.environment("tools:rstudio")
   origFn <- get(".rs.quartoFileProject", envir = rsEnv)
   assign(".rs.quartoFileProject", function(target) {
      list(project = character(), resources = c("nonexistent_output.html"))
   }, envir = rsEnv)
   on.exit(assign(".rs.quartoFileProject", origFn, envir = rsEnv), add = TRUE)

   result <- .rs.docDeployList(main, FALSE, main)

   # totalSize must be a finite number, not NA
   expect_true(is.finite(result$totalSize))

   # the non-existent file should be excluded from the contents
   expect_false("nonexistent_output.html" %in% result$contents)

   # the .qmd file itself should still be present
   expect_true("main.qmd" %in% result$contents)
})

#
# test-air.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("air")

# Point the air installation roots at sandboxes by overriding the data
# directory used by .rs.air.rootDir() and the home directory used by
# .rs.air.oldRootDir(). RSTUDIO_DATA_HOME is honored on every platform and is
# used verbatim (no 'rstudio' suffix), so .rs.air.rootDir() resolves to
# '<data>/air'. Returns the (current) sandbox root.
local_air_root <- function(envir = parent.frame()) {

   data <- tempfile("air-data-")
   home <- tempfile("air-home-")
   dir.create(data, recursive = TRUE)
   dir.create(home, recursive = TRUE)

   withr::local_envvar(
      c(RSTUDIO_DATA_HOME = data, HOME = home, USERPROFILE = home),
      .local_envir = envir
   )

   withr::defer(unlink(c(data, home), recursive = TRUE), envir = envir)

   .rs.air.rootDir()
}

# Create a fake air installation for the given version, in the given root.
install_fake_air <- function(version, withExe = TRUE, root = .rs.air.rootDir()) {

   binDir <- .rs.air.binDir(version, root)
   dir.create(binDir, recursive = TRUE, showWarnings = FALSE)

   if (withExe) {
      exe <- if (.rs.platform.isWindows) "air.exe" else "air"
      file.create(file.path(binDir, exe))
   }
}

test_that(".rs.air.installedVersions() finds and sorts installed versions", {

   local_air_root()

   # nothing installed yet
   expect_identical(.rs.air.installedVersions(), character())

   install_fake_air("0.4.0")
   install_fake_air("0.10.1")
   install_fake_air("0.9.0")
   install_fake_air("0.5.0", withExe = FALSE)  # missing binary; excluded
   install_fake_air("not-a-version")           # unparseable; excluded
   install_fake_air("v0.11.0")                 # v-prefixed tag; honored
   install_fake_air("0.12.0-beta.1")           # pre-release; excluded

   expect_identical(
      .rs.air.installedVersions(),
      c("v0.11.0", "0.10.1", "0.9.0", "0.4.0")
   )

})

test_that(".rs.air.installedVersions() also discovers copies in the legacy root", {

   local_air_root()

   # one copy in the current root, one only in the legacy root
   install_fake_air("0.9.0")
   install_fake_air("0.4.0", root = .rs.air.oldRootDir())

   expect_identical(
      .rs.air.installedVersions(),
      c("0.9.0", "0.4.0")
   )

})

test_that(".rs.air.ensureAvailable() reuses a copy from the legacy root", {

   local_air_root()

   # only available in the legacy location
   install_fake_air("0.7.1", root = .rs.air.oldRootDir())

   # make sure any 'air' on the PATH is not used
   oldPath <- Sys.getenv("PATH")
   Sys.setenv(PATH = tempdir())
   on.exit(Sys.setenv(PATH = oldPath), add = TRUE)

   # never query GitHub or install; the legacy copy must be reused as-is
   options(rstudio.air.version = "0.7.1", rstudio.air.autoinstall = FALSE)
   on.exit(options(rstudio.air.version = NULL, rstudio.air.autoinstall = NULL), add = TRUE)

   exe <- .rs.air.ensureAvailable()
   expect_identical(
      normalizePath(exe),
      normalizePath(.rs.air.exePath("0.7.1", .rs.air.oldRootDir()))
   )

})

test_that(".rs.air.ensureAvailable() prefers a copy of air on the PATH", {

   local_air_root()

   # an installed copy that should *not* win over the PATH
   install_fake_air("0.9.0")

   # put a fake air executable on the PATH
   pathDir <- tempfile("air-path-")
   dir.create(pathDir)
   on.exit(unlink(pathDir, recursive = TRUE), add = TRUE)

   exeName <- if (.rs.platform.isWindows) "air.exe" else "air"
   pathExe <- file.path(pathDir, exeName)
   file.create(pathExe)
   Sys.chmod(pathExe, mode = "0755")

   oldPath <- Sys.getenv("PATH")
   Sys.setenv(PATH = pathDir)
   on.exit(Sys.setenv(PATH = oldPath), add = TRUE)

   exe <- .rs.air.ensureAvailable()
   expect_identical(normalizePath(exe), normalizePath(pathExe))

})

test_that(".rs.air.ensureAvailable() errors when missing and autoinstall is disabled", {

   local_air_root()

   # make sure any 'air' on the PATH is not used
   oldPath <- Sys.getenv("PATH")
   Sys.setenv(PATH = tempdir())
   on.exit(Sys.setenv(PATH = oldPath), add = TRUE)

   # request a version that isn't installed, with autoinstall disabled
   options(rstudio.air.version = "0.7.1", rstudio.air.autoinstall = FALSE)
   on.exit(options(rstudio.air.version = NULL, rstudio.air.autoinstall = NULL), add = TRUE)

   expect_error(.rs.air.ensureAvailable(), "Air binary not found")

})

test_that(".rs.air.ensureAvailable() prefers installed versions over GitHub", {

   local_air_root()

   install_fake_air("0.7.1")
   install_fake_air("0.9.0")

   # make sure any 'air' on the PATH is not used
   oldPath <- Sys.getenv("PATH")
   Sys.setenv(PATH = tempdir())
   on.exit(Sys.setenv(PATH = oldPath), add = TRUE)

   # fail if we attempt to resolve the default version, as doing
   # so requires querying GitHub for the latest release
   trace(.rs.air.defaultVersion, quote(stop("GitHub was queried")), print = FALSE)
   on.exit(untrace(.rs.air.defaultVersion), add = TRUE)

   # with no version requested, the newest installed version is used
   exe <- .rs.air.ensureAvailable()
   expect_identical(normalizePath(exe), normalizePath(.rs.air.exePath("0.9.0")))

   # an explicitly-requested version takes precedence
   options(rstudio.air.version = "0.7.1")
   on.exit(options(rstudio.air.version = NULL), add = TRUE)

   exe <- .rs.air.ensureAvailable()
   expect_identical(normalizePath(exe), normalizePath(.rs.air.exePath("0.7.1")))

})

#
# test-notebook.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

test_that("#| comments are removed by .rs.extractChunkInnerCode() (#11606)", {
   code <- "```{sql}\n#| connection = db\n\nSELECT 'test'\n```"
   extract <- .rs.extractChunkInnerCode(code)
   expect_true(!any(grepl("#[|]", extract)))
})

test_that(".rs.rnb.extractInlineRCode() finds inline R code in prose only", {
   contents <- c(
      "---",
      "title: test",
      "output: html_notebook",
      "---",
      "",
      "```{r}",
      "x <- 42  # `r 1 + 1` within a chunk is not inline code",
      "```",
      "",
      "The answer is `r 1 + 1`.",
      "Today is `r Sys.Date()`."
   )

   code <- .rs.rnb.extractInlineRCode(contents)
   expect_equal(code, c("1 + 1", "Sys.Date()"))
})

test_that(".rs.rnb.evaluateInlineChunks() evaluates inline chunks (#17521)", {
   rmdPath <- tempfile(fileext = ".Rmd")
   writeLines(c(
      "---",
      "title: test",
      "output: html_notebook",
      "---",
      "",
      "Broken: `r .rs.test.noSuchObject`",
      "Value: `r .rs.test.inlineValue * 2`"
   ), con = rmdPath)
   on.exit(unlink(rmdPath), add = TRUE)

   # inline chunks are evaluated against the global environment
   assign(".rs.test.inlineValue", 21, envir = globalenv())
   on.exit(rm(".rs.test.inlineValue", envir = globalenv()), add = TRUE)

   cachePath <- .rs.rnb.evaluateInlineChunks(rmdPath)
   expect_true(file.exists(cachePath))
   on.exit(unlink(cachePath), add = TRUE)

   # NOTE: the broken expression comes first in the document, so this also
   # verifies that an evaluation failure does not abort later expressions
   outputs <- readRDS(cachePath)
   expect_equal(outputs[[".rs.test.inlineValue * 2"]]$text, "42")
   expect_match(outputs[[".rs.test.noSuchObject"]]$error, "not found")
})

test_that(".rs.rnb.extractInlineRCode() handles fence edge cases", {

   # tilde fences are recognized
   contents <- c("~~~", "`r 1 + 1`", "~~~", "Value: `r 2 + 2`")
   expect_equal(.rs.rnb.extractInlineRCode(contents), "2 + 2")

   # an unclosed fence swallows the rest of the document
   contents <- c("Before: `r 1 + 1`", "```", "`r 2 + 2`")
   expect_equal(.rs.rnb.extractInlineRCode(contents), "1 + 1")

   # blockquoted fences are recognized
   contents <- c("> ```", "> `r 1 + 1`", "> ```", "Value: `r 2 + 2`")
   expect_equal(.rs.rnb.extractInlineRCode(contents), "2 + 2")

   # a display-only block delimited by four backticks can contain inner
   # three-backtick fences; nothing within it is inline code
   contents <- c(
      "````markdown",
      "```{r}",
      "x <- 1",
      "```",
      "`r displayOnly()`",
      "````",
      "Value: `r 3 + 3`"
   )
   expect_equal(.rs.rnb.extractInlineRCode(contents), "3 + 3")

   # a tilde fence line inside an open backtick fence does not close it
   contents <- c("```", "~~~", "`r 1 + 1`", "```", "Value: `r 2 + 2`")
   expect_equal(.rs.rnb.extractInlineRCode(contents), "2 + 2")
})

test_that(".rs.rnb.evaluateInlineChunks() handles asis, multi-line, and duplicate expressions", {
   rmdPath <- tempfile(fileext = ".Rmd")
   writeLines(c(
      "---",
      "title: test",
      "output: html_notebook",
      "---",
      "",
      "Asis: `r knitr::asis_output('**bold**')`",
      "",
      "Multi: `r paste('a',",
      "   'b')`",
      "",
      "Dup: `r 6 * 7` and again `r 6 * 7`"
   ), con = rmdPath)
   on.exit(unlink(rmdPath), add = TRUE)

   cachePath <- .rs.rnb.evaluateInlineChunks(rmdPath)
   expect_true(file.exists(cachePath))
   on.exit(unlink(cachePath), add = TRUE)

   outputs <- readRDS(cachePath)

   # knit_asis results pass through knitr:::sew()
   expect_equal(outputs[["knitr::asis_output('**bold**')"]]$text, "**bold**")

   # multi-line inline expressions are evaluated
   texts <- vapply(outputs, function(output) as.character(output$text)[[1]], "")
   expect_true("a b" %in% texts)

   # duplicate expressions are evaluated (and stored) once
   expect_equal(sum(names(outputs) == "6 * 7"), 1L)
   expect_equal(outputs[["6 * 7"]]$text, "42")
})

test_that(".rs.rnb.installInlineOutputs() installs the inline output hook (#17521)", {
   outputs <- list(
      "6 * 7" = list(text = "42"),
      "stop('boom')" = list(error = "boom")
   )
   cachePath <- tempfile(fileext = ".rds")
   saveRDS(outputs, file = cachePath)

   # installation mutates knitr's global hook state; restore when done
   defaultHook <- knitr::knit_hooks$get("evaluate.inline")
   on.exit(knitr::knit_hooks$set(evaluate.inline = defaultHook), add = TRUE)

   .rs.rnb.installInlineOutputs(cachePath)

   # the cache file is consumed on installation
   expect_false(file.exists(cachePath))

   hook <- knitr::knit_hooks$get("evaluate.inline")

   # cache hit: the cached text is substituted verbatim
   expect_equal(hook("6 * 7", globalenv()), "42")

   # cached error: re-signaled loudly
   expect_error(hook("stop('boom')", globalenv()), "boom")

   # cache miss: falls back to evaluating in this process
   expect_equal(hook("2 + 2", globalenv()), 4)
})

test_that(".rs.rnb.installInlineOutputs() removes the cache file even on failure", {
   cachePath <- tempfile(fileext = ".rds")
   writeLines("not an rds file", con = cachePath)

   expect_error(.rs.rnb.installInlineOutputs(cachePath))
   expect_false(file.exists(cachePath))
})

test_that(".rs.rnb.evaluateInlineChunks() returns '' when knitr lacks the evaluate.inline hook", {
   rmdPath <- tempfile(fileext = ".Rmd")
   writeLines("Value: `r 1 + 1`", con = rmdPath)
   on.exit(unlink(rmdPath), add = TRUE)

   # simulate an older knitr without the 'evaluate.inline' hook; setting a
   # hook to NULL removes it, and we restore the original when done
   defaultHook <- knitr::knit_hooks$get("evaluate.inline")
   knitr::knit_hooks$set(evaluate.inline = NULL)
   on.exit(knitr::knit_hooks$set(evaluate.inline = defaultHook), add = TRUE)

   expect_equal(.rs.rnb.evaluateInlineChunks(rmdPath), "")
})

test_that(".rs.rnb.evaluateInlineChunks() returns '' when no inline code present", {
   rmdPath <- tempfile(fileext = ".Rmd")
   writeLines(c(
      "---",
      "title: test",
      "output: html_notebook",
      "---",
      "",
      "Just prose; the chunk below is not inline code.",
      "",
      "```{r}",
      "1 + 1",
      "```"
   ), con = rmdPath)
   on.exit(unlink(rmdPath), add = TRUE)

   expect_equal(.rs.rnb.evaluateInlineChunks(rmdPath), "")
})

#
# test-jobs.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("jobs")

test_that("jobs can be added and removed", {
   # add a job
   jobId <- .rs.api.addJob(name = "job1")

   # retrieve all jobs
   jobs <- .rs.invokeRpc("get_jobs")

   # find job in the resultant list
   job <- jobs[[jobId]]
   expect_equal("job1", job[["name"]])

   # clean up
   .rs.api.removeJob(jobId)
   jobs <- .rs.invokeRpc("get_jobs")
   expect_equal(NULL, jobs[[jobId]])
})

test_that("job progress is updated", {
   jobId <- .rs.api.addJob(name = "job2", progressUnits = 100L)

   .rs.api.setJobProgress(jobId, 50L)
   .rs.api.addJobProgress(jobId, 10L)

   jobs <- .rs.invokeRpc("get_jobs")
   job <- jobs[[jobId]]

   # progress should be updated
   expect_equal(job[["progress"]], 60L)

   # adding progress to the job should put it in the running state
   expect_equal(job[["state_description"]], "running")
})

test_that("can't set progress of a non-ranged job", {
   jobId <- .rs.api.addJob(name = "job3")

   expect_error(.rs.api.addJobProgress(jobId, 10L))
})

test_that("property writes persist", {
   jobId <- .rs.api.addJob(name = "job4", status = "initializing")

   jobs <- .rs.invokeRpc("get_jobs")
   expect_equal(jobs[[jobId]][["status"]], "initializing")
   expect_equal(jobs[[jobId]][["state_description"]], "idle")

   .rs.api.setJobStatus(jobId, "reticulating splines")
   .rs.api.setJobState(jobId, "running")
   jobs <- .rs.invokeRpc("get_jobs")

   expect_equal(jobs[[jobId]][["status"]], "reticulating splines")
   expect_equal(jobs[[jobId]][["state_description"]], "running")
})

test_that("auto remove property is respected", {
   jobId <- .rs.api.addJob(name = "job5", autoRemove = FALSE)
   .rs.api.setJobState(jobId, "succeeded")

   jobs <- .rs.invokeRpc("get_jobs")
   expect_equal(jobs[[jobId]][["id"]], jobId)

   jobId <- .rs.api.addJob(name = "job6", autoRemove = TRUE)
   .rs.api.setJobState(jobId, "succeeded")

   jobs <- .rs.invokeRpc("get_jobs")
   expect_equal(jobs[[jobId]], NULL)
})

test_that("job timers are started", {
   jobId <- .rs.api.addJob(name = "job7", autoRemove = FALSE)

   # complete job immediately
   .rs.api.setJobState(jobId, "succeeded")

   jobs <- .rs.invokeRpc("get_jobs")
   job <- jobs[[jobId]]

   expect_true(job[["recorded"]] > 0)
   expect_true(job[["started"]] > 0)
   expect_true(job[["completed"]] > 0)
   expect_true(job[["recorded"]] <= job[["started"]])
   expect_true(job[["completed"]] <= job[["started"]])
})

test_that("job output is persisted", {
   jobId <- .rs.api.addJob(name = "job8", autoRemove = FALSE, running = TRUE)
   .rs.api.addJobOutput(jobId, "NormalOutput1")
   .rs.api.addJobOutput(jobId, "NormalOutput2")
   .rs.api.addJobOutput(jobId, "ErrorOutput", error = TRUE)
   .rs.api.setJobState(jobId, "failed")
   output <- .rs.invokeRpc("job_output", jobId, 0L)
   expect_true(length(output) == 3)
})

test_that("jobs can be cleaned up", {
    # add a couple of jobs
   job8 <- .rs.api.addJob(name = "job8", autoRemove = FALSE, running = TRUE)
   job9 <- .rs.api.addJob(name = "job9", autoRemove = FALSE, running = TRUE)

   # complete one
   .rs.api.setJobState(job8, "failed")

   jobs <- .rs.invokeRpc("get_jobs")
   expect_true(job8 %in% names(jobs))

   # clean it up
   .rs.invokeRpc("clear_background_jobs")

   # there should be 1 job remaining (only the completed job should be cleared)
   jobs <- .rs.invokeRpc("get_jobs")
   expect_true(job9 %in% names(jobs))
   expect_false(job8 %in% names(jobs))
})

test_that("custom job actions are executed", {
   mutable <- 0
   job10 <- .rs.api.addJob(name = "job10", autoRemove = FALSE, running = TRUE,
                           actions = list(
                              mutate = function(id) { mutable <<- 1 }))
   expect_equal(0, mutable)

   # execute the custom action and validate that the value becomes what we want
   .rs.api.executeJobAction(job10, "mutate")
   expect_equal(1, mutable)
})

test_that("job tags can be set and retrieved", {
   theTags <- c("one", "two", "four")
   jobId <- .rs.api.addJob(name = "job11", tags = theTags)
   jobs <- .rs.invokeRpc("get_jobs")
   job <- jobs[[jobId]]
   expect_true(sum(job[["tags"]] == theTags) == length(theTags))
})

test_that("script jobs run and can be replayed", {
   
   # helper function to wait for a job to finish running
   waitForJob <- function(id)
   {
      # wait a bit before first query to avoid timing failures
      Sys.sleep(1L)
      
      # wait for the job to finish
      tries <- 0L
      repeat
      {
         state <- .Call("rs_getJobState", id, PACKAGE = "(embedding)")
         if (is.null(state))
            stop("Job ", id, " does not exist.")
         
         if (state %in% c("idle", "running"))
         {
            tries <- tries + 1L
            if (tries > 60L)
               stop("Giving up on job ", id, " after 60 seconds (state: ", state, ")")

            # wait and perform background processing
            Sys.sleep(1L)
            .Call("rs_performBackgroundProcessing", FALSE, PACKAGE = "(embedding)")
         }
         else if (state %in% c("succeeded", "cancelled", "failed"))
         {
            return(state)
         }
         else
         {
            stop("Unexpected job state '", state, "'")
         }
         
      }
   }

   # tell the script job which file to create by creating a global variable
   filePath <- tempfile(pattern = "test", fileext = ".txt")
   assign("filePath", filePath, envir = globalenv())

   # create a script to run as a job
   scriptPath <- tempfile("script-job-", fileext = ".R")
   scriptCode <- quote({
      writeLines("Hello, world!", con = filePath)
   })
   writeLines(deparse(scriptCode), con = scriptPath)
   
   # run the script job
   jobId <- .rs.api.runScriptJob(
      path = scriptPath,
      name = "Test Job",
      importEnv = TRUE
   )

   # wait for the script job to finish running
   status <- waitForJob(jobId)
   expect_equal(status, "succeeded")
   expect_true(file.exists(filePath))

   # clean up the file it made and verify that it's gone
   unlink(filePath)
   expect_false(file.exists(filePath))

   # now replay the job to put the file back
   .rs.api.executeJobAction(jobId, "replay")
   status <- waitForJob(jobId)

   # it should be back
   expect_equal(status, "succeeded")
   expect_true(file.exists(filePath))

   # clean it up one last time
   unlink(filePath)
})

#
# test-cpp.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("cpp")

test_that("cppSourceFile() uses correct package", {
    tf <- tempfile(fileext = ".cpp")
    
    writeLines('#include <Rcpp.h>\n//[[Rcpp::export]]\nvoid fun(){}', tf)
    call <- .rs.cppSourceFile(tf)
    expect_match(call, "Rcpp::sourceCpp")

    writeLines('void fun(){}', tf)
    call <- .rs.cppSourceFile(tf)
    expect_match(call, "Rcpp::sourceCpp")

    writeLines('#include <cpp11.hpp>\n[[cpp11::register]]\nvoid fun(){}', tf)
    call <- .rs.cppSourceFile(tf)
    expect_match(call, "cpp11::cpp_source")
    
    unlink(tf)
    call <- .rs.cppSourceFile(tf)
    expect_match(call, "Rcpp::sourceCpp")
})

#
# test-files.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("files")

test_that("file listings are correct", {

  # Create temporary directory to host a directory listing
  testdir <- file.path(tempdir(), "file-listings")
  dir.create(testdir, recursive = TRUE)
  on.exit(unlink(testdir, recursive = TRUE), add = TRUE)

  # Read old pref values
  alwaysShownFiles <- .rs.api.readRStudioPreference("always_shown_files")
  on.exit(.rs.api.writeRStudioPreference("always_shown_files", as.list(alwaysShownFiles)))
  alwaysShownExts <- .rs.api.readRStudioPreference("always_shown_extensions")
  on.exit(.rs.api.writeRStudioPreference("always_shown_extensions", as.list(alwaysShownExts)))

  # Prepare dummy set of files
  files <- c(
    ".shown",
    ".hidden",
    ".shown.yml",
    ".also.shown.yml",
    ".hidden.yml",
    "normal.R",
    "data.csv")
  for (f in files) {
    writeLines(text = "", con = file.path(testdir, f))
  }

  # Set up preferences
  .rs.api.writeRStudioPreference("always_shown_files", list(
    ".shown.yml",
    ".also.shown.yml"
  ))
  .rs.api.writeRStudioPreference("always_shown_extensions", list(
    ".shown"
   ))

  # Perform a file listing on the directory
  listing <- .rs.invokeRpc("list_files",
                testdir, # Dir to list
                FALSE,   # Monitor listing
                FALSE    # Show hidden files
  )

  # Extract the filenames that were returned
  filenames <- unlist(lapply(listing$files, function(f) {
    basename(f$path)
  }))

  # Check to ensure that we got what we expected
  expect_equal(sort(filenames), c(
    ".also.shown.yml",  # An always shown file
    ".shown",           # An always shown extension
    ".shown.yml",       # An always shown file
    "data.csv",         # A regular file
    "normal.R"          # A regular file
  ))

})

test_that("our list.files, list.dirs hooks function as expected", {
   # use native R routines
   .rs.files.restoreBindings()
   on.exit(.rs.files.replaceBindings(), add = TRUE)
   
   # work in temporary directory
   tdir <- tempfile()
   dir.create(tdir)
   owd <- setwd(tdir)
   on.exit(setwd(owd), add = TRUE)
   
   # create a bunch of sample files
   file.create(".hidden")
   
   file.create("file")
   file.create("test.csv")
   
   dir.create("dir")
   dir.create("dir/subdir")
   file.create("dir/file")
   file.create("dir/subdir/file")
   
   dir.create("empty")
   
   dir.create("hasEmptyDir")
   dir.create("hasEmptyDir/empty")
   
   dir.create("~/RStudioTestDirectory", showWarnings = FALSE)
   file.create("~/RStudioTestDirectory/file")
   dir.create("~/RStudioTestDirectory/dir", showWarnings = FALSE)
   file.create("~/RStudioTestDirectory/dir/file2")
   on.exit(unlink("~/RStudioTestDirectory", recursive = TRUE), add = TRUE)
   
   if (identical(R.version$crt, "ucrt")) {
      nihao <- enc2utf8("\u4f60\u597d")  # nihao
      dir.create(nihao)
      file.create(paste(nihao, "file", sep = "/"))
      file.create(paste(nihao, "R", sep = "."))
   }
   
   paths <- list(
      ".",
      "./",
      ".\\",
      ".//",
      ".\\/",
      "*.csv",  # not technically a valid regex but R accepts it
      "~/RStudioTestDirectory",
      "~/RStudioTestDirectory/",
      "~/RStudioTestDirectory//",
      getwd(),
      chartr("/", "\\", getwd()),
      file.path("..", basename(getwd())),
      paste("..", basename(getwd()), sep = "\\"),
      "ThisPathDoesNotExist"
   )
   
   arglist <- list(
      path = paths,
      pattern = list(NULL, "[.]R$"),
      all.files = list(FALSE, TRUE),
      full.names = list(FALSE, TRUE),
      recursive = list(FALSE, TRUE),
      ignore.case = list(FALSE, TRUE),
      include.dirs = list(FALSE, TRUE),
      no.. = list(FALSE, TRUE)
   )
   
   grid <- do.call(expand.grid, lapply(arglist, seq_along))
   crossed <- lapply(seq_len(nrow(grid)), function(i) {
      Map(function(lst, j) lst[[j]], arglist, grid[i, ])
   })
   for (i in seq_along(crossed)) {

      args <- crossed[[i]]
      lhs <- do.call(list.files, args)
      rhs <- do.call(.rs.listFiles, args)
      
      if (.rs.platform.isWindows)
         Encoding(lhs) <- "UTF-8"
      
      expect_equal(lhs, rhs)
      
   }
   
   arglist <- list(
      path = paths,
      full.names = list(FALSE, TRUE),
      recursive = list(FALSE, TRUE)
   )
   
   grid <- do.call(expand.grid, lapply(arglist, seq_along))
   crossed <- lapply(seq_len(nrow(grid)), function(i) {
      Map(function(lst, j) lst[[j]], arglist, grid[i, ])
   })
   for (i in seq_along(crossed)) {

      args <- crossed[[i]]
      lhs <- do.call(list.dirs, args)
      rhs <- do.call(.rs.listDirs, args)
      
      if (.rs.platform.isWindows)
         Encoding(lhs) <- "UTF-8"
      
      expect_equal(lhs, rhs)
      
   }
   
   setwd(owd)
   unlink(tdir, recursive = TRUE)
   unlink("~/RStudioTestDirectory", recursive = TRUE)
   
})

#
# test-connections.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

library(testthat)

context("connections")

test_that("ODBC ini file is read", {
   # write a test file containing a sample driver
   test_file <- file.path(tempdir(), "odbcinst.ini")
   on.exit(unlink(test_file), add = TRUE)
   writeLines(text = c(
      "[PostgreSQL]",
      "Description = PostgreSQL driver for GNU/Linux",
      "Driver = /usr/lib/psqlodbcw.so",
      "Setup = /usr/lib/libodbcpsqlS.so"),
     con = test_file)

   # ensure this file is read
   bundle <- .rs.odbcBundleReadIni(test_file)
   expect_equal(bundle, 
      list(PostgreSQL = c("Description = PostgreSQL driver for GNU/Linux",
                          "Driver = /usr/lib/psqlodbcw.so",
                          "Setup = /usr/lib/libodbcpsqlS.so")))

   # ensure we get an empty list if no file is present
   bundle <- .rs.odbcBundleReadIni(file.path(tempdir(), "missing.ini"))
   expect_equal(bundle, list())
})

test_that("connection list filter removes duplicates appropriately", {
   # Test that duplicates are filtered appropriately
   # Entries can be listed with a modified name if they have a matching installer
   # - 'RStudio'
   # - 'RStudio Pro Drivers'
   # - 'Posit Pro Drivers'

   to_duplicate <- .rs.scalarListFromList(list(
      # connectionReadSnippets()
      list(name="Athena", source="Snippet", type="Snippet"),
      list(name="BigQuery", source="Snippet", type="Snippet"),
      # connectionReadDSN()
      list(name="Databricks", source="DSN", type="Snippet"),
      list(name="MySQL", source="DSN", type="Snippet"),
      list(name="PostgresSQL", source="DSN", type="Snippet"),
      list(name="SQLServer", source="DSN", type="Snippet"),
      # connectionReadPackages()
      list(name="Spark", source="Package", type="Shiny", package="sparklyr"),
      # connectionReadOdbc()
      list(name="Snowflake", source="ODBC", type="Snippet", installer="Homebrew")
   ))
   duplicates_keep <- .rs.scalarListFromList(list(
      # connectionReadOdbc()
      list(name="Databricks", source="ODBC", type="Snippet", installer="RStudio Pro Drivers"),
      list(name="MySQL", source="ODBC", type="Snippet", installer="RStudio"),
      list(name="PostgresSQL", source="ODBC", type="Snippet", installer="Posit Pro Drivers"),
      # connectionReadInstallers()
      list(name="SQLServer", source="Snippet", type="Install", subtype="Odbc")
   ))
   duplicates_reject <- .rs.scalarListFromList(list(
      # connectionReadSnippets()
      list(name="Snowflake", source="Snippet", type="Snippet"),
      # connectionReadDSN()
      list(name="Athena", source="DSN", type="Snippet"),
      # connectionReadOdbc()
      list(name="Spark", source="ODBC", type="Snippet", installer="AWS"),
      list(name="Databricks", source="ODBC", type="Snippet"),
      list(name="Athena", source="ODBC", type="Snippet", installer="apt"),
      # connectionReadPackageInstallers()
      list(name="BigQuery", source="Snippet", type="Install", subtype="Package")
   ))

   connections <- c(to_duplicate, duplicates_keep, duplicates_reject)
   connectionList <- .rs.connectionListFilter(connections)

   expect_length(connectionList, length(to_duplicate) + length(duplicates_keep))
   expect_in(to_duplicate, connectionList)

   # duplicates with updated name
   duplicates_expected <- .rs.scalarListFromList(lapply(duplicates_keep, function(entry) {
      entry$name <- paste(entry$name, .rs.connectionOdbcRStudioDriver(), sep = "")
      entry
   }))
   expect_in(duplicates_expected, connectionList)

   # duplicates that should be removed
   expect_false(any(duplicates_reject %in% connectionList))
})

#
# test-chat-guardrails.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("chat guardrails")

# -- Deny-read patterns -------------------------------------------------------

test_that("deny-read patterns block credential files", {

   pattern <- paste(.rs.chat.denyReadPatterns, collapse = "|")
   matches <- function(path) .rs.chat.pathMatches(pattern, path)

   # AWS
   expect_true(matches("/home/user/.aws/credentials"))
   expect_true(matches("/home/user/.aws/config"))

   # SSH
   expect_true(matches("/home/user/.ssh/config"))
   expect_true(matches("/home/user/.ssh/id_rsa"))
   expect_true(matches("/home/user/.ssh/id_ed25519"))

   # SSH public keys should be allowed
   expect_false(matches("/home/user/.ssh/id_rsa.pub"))
   expect_false(matches("/home/user/.ssh/id_ed25519.pub"))

   # Docker / Kubernetes (entire directories denied)
   expect_true(matches("/home/user/.docker/config.json"))
   expect_true(matches("/home/user/.docker/cli-plugins/docker-compose"))
   expect_true(matches("/home/user/.docker"))
   expect_true(matches("/home/user/.kube/config"))
   expect_true(matches("/home/user/.kube/cache/discovery"))
   expect_true(matches("/home/user/.kube"))

   # Cloud provider credentials
   expect_true(matches("/home/user/.config/gcloud/credentials.db"))
   expect_true(matches("/home/user/.config/gcloud"))
   expect_true(matches("/home/user/.azure/accessTokens.json"))
   expect_true(matches("/home/user/.azure"))

   # GPG private keys
   expect_true(matches("/home/user/.gnupg/private-keys-v1.d/key.key"))
   expect_true(matches("/home/user/.gnupg"))

   # Package registry credentials
   expect_true(matches("/home/user/.pypirc"))
   expect_true(matches("/home/user/.gem/credentials"))

   # Database credentials
   expect_true(matches("/home/user/.pgpass"))
   expect_true(matches("/home/user/.my.cnf"))
   expect_true(matches("/home/user/.mylogin.cnf"))

   # Git credential store
   expect_true(matches("/home/user/.git-credentials"))

   # CLI/API tokens
   expect_true(matches("/home/user/.config/gh/hosts.yml"))
   expect_true(matches("/home/user/.config/gh/hosts.yaml"))
   expect_true(matches("/home/user/.huggingface/token"))

   # .env files
   expect_true(matches("/project/.env"))
   expect_true(matches("/project/.env.local"))
   expect_true(matches("/project/.env.production"))

   # .Renviron / .Rprofile
   expect_true(matches("/home/user/.Renviron"))
   expect_true(matches("/project/.Renviron.local"))
   expect_true(matches("/home/user/.Rprofile"))

   # .netrc / .npmrc
   expect_true(matches("/home/user/.netrc"))
   expect_true(matches("/home/user/.npmrc"))

   # Non-sensitive files should not match
   expect_false(matches("/home/user/project/analysis.R"))
   expect_false(matches("/home/user/.config/rstudio/config.json"))
   expect_false(matches("/home/user/documents/notes.txt"))

})

# -- Deny-edit patterns --------------------------------------------------------

test_that("deny-edit patterns block .ssh directory", {

   pattern <- paste(.rs.chat.denyEditPatterns, collapse = "|")
   matches <- function(path) .rs.chat.pathMatches(pattern, path)

   expect_true(matches("/home/user/.ssh/authorized_keys"))
   expect_true(matches("/home/user/.ssh/known_hosts"))
   expect_true(matches("/home/user/.ssh"))

   expect_false(matches("/home/user/project/file.R"))

})

# -- isPathWithin --------------------------------------------------------------

test_that("isPathWithin correctly checks containment", {

   expect_true(.rs.chat.isPathWithin("/home/user/project/file.R", "/home/user/project"))
   expect_true(.rs.chat.isPathWithin("/home/user/project", "/home/user/project"))
   expect_false(.rs.chat.isPathWithin("/home/user/project2/file.R", "/home/user/project"))
   expect_false(.rs.chat.isPathWithin("/home/other/file.R", "/home/user/project"))

})

test_that("isPathWithin guards against empty, root, and drive root directories", {

   expect_equal(.rs.chat.isPathWithin("/any/path", ""), FALSE)
   expect_equal(.rs.chat.isPathWithin("/any/path", "/"), FALSE)
   expect_equal(.rs.chat.isPathWithin("C:/Users/file.R", "C:"), FALSE)
   expect_equal(.rs.chat.isPathWithin("C:/Users/file.R", "C:/"), FALSE)

})

# -- normalizePath -------------------------------------------------------------

test_that("chat.normalizePath handles NA inputs", {

   td <- tempdir()
   result <- .rs.chat.normalizePath(c(file.path(td, "file.R"), NA, file.path(td, "other.R")))
   expect_equal(length(result), 3)
   expect_equal(result[2], "")

})

test_that("chat.normalizePath resolves . and .. components", {

   base <- .rs.chat.normalizePath(tempdir())
   result <- .rs.chat.normalizePath(file.path(tempdir(), "a", ".", "b", "..", "c"))
   expect_equal(result, file.path(base, "a", "c"))

})

# -- isFileEditAllowed ---------------------------------------------------------

test_that("isFileEditAllowed permits edits in temp directory", {

   path <- file.path(tempdir(), "test-file.R")
   expect_equal(.rs.chat.isFileEditAllowed(path), "")

})

test_that("isFileEditAllowed denies edits in arbitrary directories", {

   expect_true(nzchar(.rs.chat.isFileEditAllowed(file.path(path.expand("~"), "..", "nowhere", "file.R"))))

})

test_that("isFileEditAllowed denies edits in .ssh even within allowed dirs", {

   path <- file.path(getwd(), ".ssh/id_rsa")
   expect_true(nzchar(.rs.chat.isFileEditAllowed(path)))

})

test_that("isFileEditAllowed permits edits in R library paths", {

   for (libPath in .libPaths())
   {
      path <- file.path(libPath, "testpkg/DESCRIPTION")
      expect_equal(.rs.chat.isFileEditAllowed(path), "")
   }

})

test_that("isFileEditAllowed permits edits in R user directories", {

   skip_if(getRversion() < "4.0.0", "tools::R_user_dir requires R >= 4.0.0")

   for (which in c("data", "config", "cache"))
   {
      path <- file.path(tools::R_user_dir("testpkg", which = which), "config.yml")
      expect_equal(.rs.chat.isFileEditAllowed(path), "")
   }

})

# -- isFileReadAllowed ---------------------------------------------------------

test_that("isFileReadAllowed denies reads on credential files", {

   home <- path.expand("~")

   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".aws/credentials"))))
   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".ssh/id_rsa"))))
   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".env"))))
   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".docker/config.json"))))
   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".docker/trust/private/root.key"))))
   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".kube/config"))))
   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".kube/cache/oidc-login/token"))))
   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".git-credentials"))))

})

test_that("isFileReadAllowed permits reads on SSH public keys", {

   home <- path.expand("~")
   expect_equal(.rs.chat.isFileReadAllowed(file.path(home, ".ssh/id_rsa.pub")), "")
   expect_equal(.rs.chat.isFileReadAllowed(file.path(home, ".ssh/id_ed25519.pub")), "")

})

test_that("isFileReadAllowed allows credential files when trusted", {

   home <- path.expand("~")

   # denied by default (untrusted)
   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".aws/credentials"))))
   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".Renviron"))))
   expect_true(nzchar(.rs.chat.isFileReadAllowed(file.path(home, ".Rprofile"))))

   # allowed when trusted
   expect_equal(.rs.chat.isFileReadAllowed(file.path(home, ".aws/credentials"), trusted = TRUE), "")
   expect_equal(.rs.chat.isFileReadAllowed(file.path(home, ".Renviron"), trusted = TRUE), "")
   expect_equal(.rs.chat.isFileReadAllowed(file.path(home, ".Rprofile"), trusted = TRUE), "")

})

# -- hasTrustedCallerImpl ----------------------------------------------------

test_that("hasTrustedCallerImpl returns TRUE for safe functions", {

   expect_true(.rs.chat.hasTrustedCallerImpl(list(utils::install.packages)))
   expect_true(.rs.chat.hasTrustedCallerImpl(list(utils::download.packages)))
   expect_true(.rs.chat.hasTrustedCallerImpl(list(utils::available.packages)))

})

test_that("hasTrustedCallerImpl rejects non-safe utils functions", {

   expect_false(.rs.chat.hasTrustedCallerImpl(list(utils::str)))
   expect_false(.rs.chat.hasTrustedCallerImpl(list(utils::read.table)))

})

test_that("hasTrustedCallerImpl returns FALSE for empty stack", {

   expect_false(.rs.chat.hasTrustedCallerImpl(list()))

})

test_that("hasTrustedCallerImpl returns FALSE when agent calls base functions directly", {

   # Simulates: agent calls readLines("~/.aws/credentials")
   fns <- list(base::readLines)
   expect_false(.rs.chat.hasTrustedCallerImpl(fns))

})

test_that("hasTrustedCallerImpl returns FALSE for primitive / NULL-env functions", {

   fns <- list(base::`+`, base::`[`)
   expect_false(.rs.chat.hasTrustedCallerImpl(fns))

})

test_that("hasTrustedCallerImpl returns TRUE when package code reads a file", {

   # Simulates: devtools::document() -> ... -> base::readLines()
   skip_if_not_installed("devtools")
   fns <- list(devtools::document, base::readLines)
   expect_true(.rs.chat.hasTrustedCallerImpl(fns))

})

#
# test-install-packages.R
#
# Copyright (C) 2025 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

expect_install <- function(pkgs, ...) {
   
   # create temporary library for installation
   lib <- tempfile("library-")
   dir.create(lib, recursive = TRUE)
   on.exit(unlink(lib, recursive = TRUE), add = TRUE)
   
   # install the package
   install.packages(pkgs, lib = lib, quiet = TRUE, ...)
   
   # check that the package was installed
   installedPkgs <- list.files(lib, full.names = TRUE)
   expect_length(installedPkgs, 1L)
   
   # check that we can read the package DESCRIPTION file
   pkgInfo <- .rs.readPackageDescription(installedPkgs)
   expect_true(is.list(pkgInfo))
   
}

test_that("packages can be installed", {

   expect_install("rlang", repos = "https://cloud.r-project.org")
   expect_install("rlang", repos = "https://packagemanager.posit.co/cran/latest")

   if (!identical(.Platform$pkgType, "source"))
   {
      withr::local_options(repos = c(CRAN = "https://cloud.R-project.org"))
      info <- download.packages("rlang", destdir = tempdir(), type = "binary", quiet = TRUE)
      expect_install(info[1, 2], repos = NULL, type = "binary")
   }

   if (!.rs.platform.isWindows)
   {
      withr::local_options(repos = c(CRAN = "https://cloud.R-project.org"))
      info <- download.packages("rlang", destdir = tempdir(), type = "source", quiet = TRUE)
      expect_install(info[1, 2], repos = NULL, type = "source")
   }

})

test_that(".rs.installPackagesWhichDeps maps the 'dependencies' argument correctly", {

   hard <- c("Depends", "Imports", "LinkingTo")
   all  <- c("Depends", "Imports", "LinkingTo", "Suggests")

   # NA (install.packages's default) and unrecognized values fall back to hard deps.
   expect_identical(.rs.installPackagesWhichDeps(NA),
                    list(direct = hard, transitive = hard))
   expect_identical(.rs.installPackagesWhichDeps(NULL),
                    list(direct = hard, transitive = hard))

   # TRUE includes Suggests directly but only recurses through strong deps,
   # mirroring install.packages's getDependencies() behavior.
   expect_identical(.rs.installPackagesWhichDeps(TRUE),
                    list(direct = all, transitive = hard))
   expect_identical(.rs.installPackagesWhichDeps(FALSE),
                    list(direct = character(), transitive = character()))

   # Explicit character vector is passed through verbatim for both direct and
   # transitive (install.packages applies the user's choice on every level).
   expect_identical(
      .rs.installPackagesWhichDeps(c("Depends", "Suggests")),
      list(direct = c("Depends", "Suggests"),
           transitive = c("Depends", "Suggests"))
   )
   expect_identical(.rs.installPackagesWhichDeps(character()),
                    list(direct = character(), transitive = character()))

   # NA values inside a character vector are dropped so they don't propagate
   # into tools::package_dependencies(which = ...).
   expect_identical(
      .rs.installPackagesWhichDeps(c("Depends", NA_character_)),
      list(direct = "Depends", transitive = "Depends")
   )

})

test_that(".rs.installedPackagesFileInfo(paths=) returns NA mtime for missing paths", {

   lib <- tempfile("library-")
   dir.create(lib)
   on.exit(unlink(lib, recursive = TRUE), add = TRUE)

   present <- file.path(lib, "pkgPresent")
   dir.create(present)
   absent  <- file.path(lib, "pkgMissing")

   info <- .rs.installedPackagesFileInfo(paths = c(present, absent))

   expect_equal(nrow(info), 2L)
   expect_setequal(info$path, c(present, absent))

   # Present directory yields a real mtime.
   presentRow <- info[info$path == present, , drop = FALSE]
   expect_false(is.na(presentRow$mtime))

   # Missing directory yields NA mtime, which the install hook relies on
   # to filter out non-existent install targets.
   absentRow <- info[info$path == absent, , drop = FALSE]
   expect_true(is.na(absentRow$mtime))

})

# --- helpers for hook integration tests ---------------------------------------

# Build one or more source packages into a local file:// repository.
# 'pkgSpecs' is a named list whose names are package names and whose
# values are named character vectors of extra DESCRIPTION fields
# (e.g. c(Imports = "otherPkg")). The default builds a single package
# with no extras for back-compat with single-package tests.
.rs.tests.makeLocalSourceRepo <- function(pkgSpecs = list(rstudioTestPkg = character()))
{
   base <- tempfile("rstudio-test-repo-")
   dir.create(base)
   src     <- file.path(base, "src")
   contrib <- file.path(base, "repo", "src", "contrib")
   dir.create(src)
   dir.create(contrib, recursive = TRUE)

   pkgNames <- names(pkgSpecs)

   for (pkgName in pkgNames)
   {
      pkgDir <- file.path(src, pkgName)
      dir.create(pkgDir)
      lines <- c(
         paste0("Package: ", pkgName),
         "Version: 0.0.1",
         "Title: Demo",
         "Description: Test fixture for RStudio install-hook tests.",
         "License: GPL-3",
         "Encoding: UTF-8"
      )
      extras <- pkgSpecs[[pkgName]]
      if (length(extras))
         lines <- c(lines, paste0(names(extras), ": ", extras))
      writeLines(lines, file.path(pkgDir, "DESCRIPTION"))
      writeLines(paste0("# generated namespace for ", pkgName),
                 file.path(pkgDir, "NAMESPACE"))
   }

   oldwd <- setwd(src)
   on.exit(setwd(oldwd), add = TRUE)
   for (pkgName in pkgNames)
   {
      system2(
         "R",
         c("CMD", "build", "--no-build-vignettes", "--no-manual", pkgName),
         stdout = FALSE,
         stderr = FALSE
      )
   }
   tarballs <- list.files(src, pattern = "\\.tar\\.gz$", full.names = TRUE)
   file.copy(tarballs, contrib)
   tools::write_PACKAGES(contrib, type = "source")

   list(
      base     = base,
      pkgName  = pkgNames[[1L]],   # back-compat: first package
      pkgNames = pkgNames,
      reposUrl = paste0("file://", file.path(base, "repo"))
   )
}

test_that("install hook tags DESCRIPTION correctly across a no-op reinstall", {

   skip_on_os("windows")  # 'R CMD build' availability varies in CI

   r <- .rs.tests.makeLocalSourceRepo()
   on.exit(unlink(r$base, recursive = TRUE), add = TRUE)

   lib <- tempfile("library-")
   dir.create(lib)
   on.exit(unlink(lib, recursive = TRUE), add = TRUE)

   install.packages(
      r$pkgName,
      lib   = lib,
      repos = r$reposUrl,
      type  = "source",
      quiet = TRUE
   )

   descPath <- file.path(lib, r$pkgName, "DESCRIPTION")
   expect_true(file.exists(descPath))

   firstDesc <- read.dcf(descPath)
   expect_true("RemoteType" %in% colnames(firstDesc))
   expect_true("RemoteRepos" %in% colnames(firstDesc))
   firstRemote <- firstDesc[1, "RemoteType"]

   # Reinstall the same package; install.packages will overwrite the
   # DESCRIPTION, then the hook should re-apply the same tagging.
   install.packages(
      r$pkgName,
      lib   = lib,
      repos = r$reposUrl,
      type  = "source",
      quiet = TRUE
   )

   secondDesc <- read.dcf(descPath)
   expect_true("RemoteType" %in% colnames(secondDesc))
   expect_true("RemoteRepos" %in% colnames(secondDesc))
   expect_identical(secondDesc[1, "RemoteType"], firstRemote)

})

test_that(".rs.recordPackageSource(db=) tags without a network call", {

   skip_on_os("windows")

   r <- .rs.tests.makeLocalSourceRepo()
   on.exit(unlink(r$base, recursive = TRUE), add = TRUE)

   lib <- tempfile("library-")
   dir.create(lib)
   on.exit(unlink(lib, recursive = TRUE), add = TRUE)

   install.packages(
      r$pkgName,
      lib   = lib,
      repos = r$reposUrl,
      type  = "source",
      quiet = TRUE
   )
   pkgPath <- file.path(lib, r$pkgName)

   # Drop any tagging the install hook applied so we can re-tag from a
   # synthesized 'db' below. packageDescription() prefers Meta/package.rds
   # over the DESCRIPTION file, so both must be stripped.
   descPath <- file.path(pkgPath, "DESCRIPTION")
   desc <- read.dcf(descPath)
   desc <- desc[, setdiff(colnames(desc), grep("^Remote", colnames(desc), value = TRUE)),
                drop = FALSE]
   write.dcf(desc, file = descPath)

   metaPath <- file.path(pkgPath, "Meta", "package.rds")
   if (file.exists(metaPath))
   {
      meta <- readRDS(metaPath)
      meta$DESCRIPTION <- meta$DESCRIPTION[
         !grepl("^Remote", names(meta$DESCRIPTION))
      ]
      saveRDS(meta, metaPath)
   }

   # Force any network lookup to fail loudly: an unreachable URL would
   # throw or return empty if recordPackageSource fell back to it.
   withr::local_options(repos = c(CRAN = "http://localhost:1"))

   db <- data.frame(
      Package    = r$pkgName,
      Version    = "0.0.1",
      Repository = paste0(r$reposUrl, "/src/contrib"),
      stringsAsFactors = FALSE
   )

   expect_no_error(.rs.recordPackageSource(pkgPath, db = db))

   tagged <- read.dcf(descPath)
   expect_true("RemoteType" %in% colnames(tagged))
   expect_identical(unname(tagged[1, "RemoteType"]), "standard")
   expect_identical(unname(tagged[1, "RemotePkgRef"]), r$pkgName)

})

test_that(".rs.recordPackageSource is a no-op for empty pkgPaths", {

   # Pass a non-empty 'db' so the function skips its network-fetch
   # branch entirely; the loop body should then be a zero-iteration
   # no-op rather than tripping any code path.
   db <- data.frame(
      Package    = "ignored",
      Version    = "0.0.1",
      Repository = "ignored",
      stringsAsFactors = FALSE
   )
   expect_no_error(.rs.recordPackageSource(character(), db = db))

})

test_that("install hook tags transitive dependency DESCRIPTIONs", {

   skip_on_os("windows")  # 'R CMD build' availability varies in CI

   r <- .rs.tests.makeLocalSourceRepo(list(
      rstudioTestPkgA = character(),
      rstudioTestPkgB = c(Imports = "rstudioTestPkgA")
   ))
   on.exit(unlink(r$base, recursive = TRUE), add = TRUE)

   lib <- tempfile("library-")
   dir.create(lib)
   on.exit(unlink(lib, recursive = TRUE), add = TRUE)

   install.packages(
      "rstudioTestPkgB",
      lib   = lib,
      repos = r$reposUrl,
      type  = "source",
      quiet = TRUE
   )

   # Both the requested package and its transitive dependency should
   # have their DESCRIPTIONs tagged with the source repo. Before this
   # change, only packages directly named to install.packages got
   # tagged; the dependency closure was scanned but not recorded.
   for (name in c("rstudioTestPkgA", "rstudioTestPkgB"))
   {
      descPath <- file.path(lib, name, "DESCRIPTION")
      expect_true(file.exists(descPath), info = name)
      desc <- read.dcf(descPath)
      expect_true("RemoteType" %in% colnames(desc), info = name)
      expect_true("RemoteRepos" %in% colnames(desc), info = name)
      expect_identical(unname(desc[1, "RemoteType"]), "standard", info = name)
   }

})

#
# test-linter.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

library(testthat)

context("diagnostics")
setwd("../../session/modules")

lint <- function(x) {
   invisible(.rs.lintRFile(x))
}

test_that("R source files do not contain non-ASCII characters", {

   root <- normalizePath("../..", mustWork = TRUE)

   rFiles <- list.files(
      root,
      pattern = "[.]R$",
      full.names = TRUE,
      recursive = TRUE
   )

   nonAsciiFiles <- Filter(function(path) {
      bytes <- readBin(path, what = "raw", n = file.info(path)$size)
      any(bytes > as.raw(0x7f))
   }, rFiles)

   nonAsciiFiles <- sub(paste0(root, "/"), "", nonAsciiFiles, fixed = TRUE)

   expect_equal(
      nonAsciiFiles,
      character(),
      label = "Files with non-ASCII characters"
   )

})

test_that("RStudio .R files can be linted", {
   
   rFiles <- list.files(
      pattern = "R$",
      full.names = TRUE,
      recursive = TRUE
   )
   
   lapply(rFiles, function(x) {
      results <- lint(x)
      errors <- results[unlist(lapply(results, function(x) {
         x$type == "error"
      }))]
      expect_equal(length(errors), 0)
      if (length(errors))
         warning("Lint errors in file: '",
                 x,
                 "'",
                 call. = FALSE)
   })
})

#
# test-help.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

library(testthat)

context("help")

# tools::parse_Rd() loads user-macro definitions from R's system.Rd by
# default, but minimal R installations can ship without that file, turning
# parsing into an error. The Rd fixtures in these tests use only base Rd
# tags, so when system.Rd is missing, fall back to a structurally-valid but
# empty user-macro set loaded from an empty file; this parses identically.
parseRd <- function(file) {
    macros <- file.path(R.home("share"), "Rd", "macros", "system.Rd")
    if (!file.exists(macros)) {
        macros <- tempfile(fileext = ".Rd")
        file.create(macros)
        on.exit(unlink(macros), add = TRUE)
    }
    tools::parse_Rd(file, macros = macros)
}

test_that(".rs.getHelp() handles empty and NULL package", {
    help_rnorm1 <- .rs.getHelp("rnorm")
    help_rnorm2 <- .rs.getHelp("rnorm", package = "")
    help_rnorm3 <- .rs.getHelp("rnorm", package = NULL)
    help_rnorm4 <- .rs.getHelp("rnorm", package = "stats")
    help_rnorm5 <- .rs.getHelp("stats::rnorm")
    help_rnorm6 <- .rs.getHelp("rnorm", "package:stats")

    expect_identical(help_rnorm1, help_rnorm2)
    expect_identical(help_rnorm1, help_rnorm3)
    expect_identical(help_rnorm1, help_rnorm4)
    expect_identical(help_rnorm1, help_rnorm5)
    expect_identical(help_rnorm1, help_rnorm6)
})

test_that(".rs.exampleCodeLaunchesApp() detects blocking application launchers", {
    shiny_code <- c(
        "captureVals <- function() {",
        "  ui <- shiny::fluidPage(shiny::textInput(\"the_text\", \"Enter text\"))",
        "  server <- function(input, output, session) {}",
        "  shiny::runApp(shiny::shinyApp(ui, server))",
        "}",
        "captureVals()"
    )

    expect_true(.rs.exampleCodeLaunchesApp(shiny_code))
    expect_true(.rs.exampleCodeLaunchesApp("shiny::runApp(app)"))
    expect_true(.rs.exampleCodeLaunchesApp("learnr::run_tutorial(\"hello\")"))

    # every launcher in the detection list, bare and namespace-qualified
    launchers <- c(
        "runApp", "runExample", "runGadget",
        "runUrl", "runGist", "runGitHub",
        "shinyApp", "shinyAppDir", "shinyAppFile",
        "run_tutorial"
    )

    for (launcher in launchers) {
        expect_true(.rs.exampleCodeLaunchesApp(sprintf("%s(x)", launcher)), info = launcher)
        expect_true(.rs.exampleCodeLaunchesApp(sprintf("pkg::%s(x)", launcher)), info = launcher)
    }
})

test_that(".rs.exampleCodeLaunchesApp() ignores launcher names in comments and strings", {
    # mentions runApp, but never actually calls it
    benign_code <- c(
        "# call shiny::runApp() to launch the app yourself",
        "x <- 1:10",
        "msg <- \"use runApp() to start\"",
        "mean(x)"
    )

    expect_false(.rs.exampleCodeLaunchesApp(benign_code))
    expect_false(.rs.exampleCodeLaunchesApp("plot(1:10)"))

    # unparseable input should never error -- it just isn't diverted
    expect_false(.rs.exampleCodeLaunchesApp("this is not valid R code ("))
})

test_that(".rs.helpExampleDivertCommand() handles demos", {
    # build a fake installed package with demos, in a temporary library
    lib <- tempfile("rstudio-test-lib-")
    pkg <- file.path(lib, "fakepkg")
    dir.create(file.path(pkg, "demo"), recursive = TRUE)
    on.exit(unlink(lib, recursive = TRUE), add = TRUE)

    writeLines(
        c("Package: fakepkg", "Version: 0.1.0"),
        file.path(pkg, "DESCRIPTION")
    )

    writeLines(
        c(
            "ui <- shiny::fluidPage()",
            "server <- function(input, output, session) {}",
            "shiny::runApp(shiny::shinyApp(ui, server))"
        ),
        file.path(pkg, "demo", "blocking.R")
    )

    writeLines("plot(1:10)", file.path(pkg, "demo", "benign.R"))

    libPaths <- .libPaths()
    .libPaths(c(lib, libPaths))
    on.exit(.libPaths(libPaths), add = TRUE)

    # a demo that launches an app is diverted to the console
    expect_identical(
        .rs.helpExampleDivertCommand("Demo", "fakepkg", "blocking"),
        "demo(\"blocking\", package = \"fakepkg\")"
    )

    # a benign demo, and a missing one, are not diverted
    expect_null(.rs.helpExampleDivertCommand("Demo", "fakepkg", "benign"))
    expect_null(.rs.helpExampleDivertCommand("Demo", "fakepkg", "nosuchdemo"))
})

test_that(".rs.helpExampleDivertCommand() handles examples", {
    # build a fake installed package with a help database, in a temporary
    # library; this mirrors what R CMD INSTALL produces (an Rd lazy-load db
    # plus an aliases index), which is what example(give.lines = TRUE) reads
    lib <- tempfile("rstudio-test-lib-")
    pkg <- file.path(lib, "fakehelppkg")
    dir.create(file.path(pkg, "help"), recursive = TRUE)
    on.exit(unlink(lib, recursive = TRUE), add = TRUE)

    writeLines(
        c("Package: fakehelppkg", "Version: 0.1.0"),
        file.path(pkg, "DESCRIPTION")
    )

    blockingRd <- tempfile("blocking-", fileext = ".Rd")
    writeLines(
        c(
            "\\name{blocking}",
            "\\alias{blocking}",
            "\\alias{it's \"blocking\"}",
            "\\title{Blocking}",
            "\\description{Launches a Shiny app.}",
            "\\examples{",
            "ui <- shiny::fluidPage()",
            "server <- function(input, output, session) {}",
            "shiny::runApp(shiny::shinyApp(ui, server))",
            "}"
        ),
        blockingRd
    )

    benignRd <- tempfile("benign-", fileext = ".Rd")
    writeLines(
        c(
            "\\name{benign}",
            "\\alias{benign}",
            "\\title{Benign}",
            "\\description{Just plots.}",
            "\\examples{",
            "plot(1:10)",
            "}"
        ),
        benignRd
    )

    db <- list(
        blocking = parseRd(blockingRd),
        benign = parseRd(benignRd)
    )
    tools:::makeLazyLoadDB(db, file.path(pkg, "help", "fakehelppkg"))

    aliases <- c(
        "blocking" = "blocking",
        "it's \"blocking\"" = "blocking",
        "benign" = "benign"
    )
    saveRDS(aliases, file.path(pkg, "help", "aliases.rds"))

    libPaths <- .libPaths()
    .libPaths(c(lib, libPaths))
    on.exit(.libPaths(libPaths), add = TRUE)

    # an example that launches an app is diverted to the console
    expect_identical(
        .rs.helpExampleDivertCommand("Example", "fakehelppkg", "blocking"),
        "example(\"blocking\", package = \"fakehelppkg\")"
    )

    # topics needing escaping survive the round-trip through deparse()
    expect_identical(
        .rs.helpExampleDivertCommand("Example", "fakehelppkg", "it's \"blocking\""),
        "example(\"it's \\\"blocking\\\"\", package = \"fakehelppkg\")"
    )

    # a benign example, and a missing one, are not diverted
    expect_null(.rs.helpExampleDivertCommand("Example", "fakehelppkg", "benign"))
    expect_null(.rs.helpExampleDivertCommand("Example", "fakehelppkg", "nosuchtopic"))
})

test_that(".rs.helpExampleDivertCommand() ignores launchers inside dontrun blocks", {
    # \dontrun{} code is commented out by example(give.lines = TRUE), exactly
    # as it would be in the diverted example() call, so it must not divert
    lib <- tempfile("rstudio-test-lib-")
    pkg <- file.path(lib, "fakedontrunpkg")
    dir.create(file.path(pkg, "help"), recursive = TRUE)
    on.exit(unlink(lib, recursive = TRUE), add = TRUE)

    writeLines(
        c("Package: fakedontrunpkg", "Version: 0.1.0"),
        file.path(pkg, "DESCRIPTION")
    )

    dontrunRd <- tempfile("dontrun-", fileext = ".Rd")
    writeLines(
        c(
            "\\name{dontrun}",
            "\\alias{dontrun}",
            "\\title{Dontrun}",
            "\\description{Launches an app, but only via dontrun.}",
            "\\examples{",
            "x <- 1:10",
            "\\dontrun{",
            "shiny::runApp(app)",
            "}",
            "}"
        ),
        dontrunRd
    )

    db <- list(dontrun = parseRd(dontrunRd))
    tools:::makeLazyLoadDB(db, file.path(pkg, "help", "fakedontrunpkg"))
    saveRDS(c("dontrun" = "dontrun"), file.path(pkg, "help", "aliases.rds"))

    libPaths <- .libPaths()
    .libPaths(c(lib, libPaths))
    on.exit(.libPaths(libPaths), add = TRUE)

    expect_null(.rs.helpExampleDivertCommand("Example", "fakedontrunpkg", "dontrun"))
})

#
# test-chat.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("chat")

test_that("manifestDownloadCommand sets a 30s timeout and downloads to a temp file", {
   cmd <- .rs.chat.manifestDownloadCommand("https://cdn.posit.co/posit-ai/manifest.json")
   expect_true(grepl("options(timeout = 30L)", cmd, fixed = TRUE))
   expect_true(grepl("tempfile()", cmd, fixed = TRUE))
   expect_true(grepl("download.file(", cmd, fixed = TRUE))
   expect_true(grepl("cat(readLines(", cmd, fixed = TRUE))
   # the URL is deparsed (quoted) into the command
   expect_true(grepl("https://cdn.posit.co/posit-ai/manifest.json", cmd, fixed = TRUE))
})

test_that("manifestDownloadCommand injects download.file.method when set", {
   withr::with_options(list(download.file.method = "libcurl"), {
      cmd <- .rs.chat.manifestDownloadCommand("https://example.test/m.json")
      expect_true(grepl("method = \"libcurl\"", cmd, fixed = TRUE))
   })
})

test_that("manifestDownloadCommand injects download.file.extra when set", {
   withr::with_options(list(download.file.extra = c("--cacert", "/etc/ca.pem")), {
      cmd <- .rs.chat.manifestDownloadCommand("https://example.test/m.json")
      expect_true(grepl("extra = ", cmd, fixed = TRUE))
      expect_true(grepl("--cacert", cmd, fixed = TRUE))
   })
})

test_that("manifestDownloadCommand omits method/extra when unset", {
   withr::with_options(list(download.file.method = NULL, download.file.extra = NULL), {
      cmd <- .rs.chat.manifestDownloadCommand("https://example.test/m.json")
      expect_false(grepl("method = ", cmd, fixed = TRUE))
      expect_false(grepl("extra = ", cmd, fixed = TRUE))
   })
})

test_that("manifestDownloadCommand errors when download.file reports a non-zero status", {
   # Some download.file methods return a non-zero status with only a warning, so
   # the command must check the status and stop() -- otherwise a failed download
   # would exit 0 with a partial/empty body and be parsed as a valid manifest.
   # Exercise the behavior (the command throws), not the command text. cmd is the
   # trusted output of the function under test, evaluated in a sandbox env whose
   # download.file is stubbed to report failure -- this is how the generated R
   # command is meant to be run.
   cmd <- .rs.chat.manifestDownloadCommand("https://example.test/m.json")

   env <- new.env()
   env$download.file <- function(...) 1L  # non-zero status, no file written
   expect_error(eval(parse(text = cmd), envir = env), "download.file failed")
})

test_that("manifestDownloadCommand emits the downloaded body with newlines intact", {
   # cat() defaults to sep = " "; the command uses sep = "\n" so a multi-line body
   # round-trips verbatim rather than having its line breaks collapsed to spaces.
   cmd <- .rs.chat.manifestDownloadCommand("https://example.test/m.json")

   env <- new.env()
   env$download.file <- function(url, destfile, ...) {
      writeLines(c("{", '  "v": 1', "}"), destfile)
      0L
   }
   out <- paste(capture.output(eval(parse(text = cmd), envir = env)), collapse = "\n")
   expect_identical(out, "{\n  \"v\": 1\n}")
})

test_that("chat.safeEval returns value and visibility with no conditions", {
   result <- .rs.chat.safeEval(quote(42))
   # a plain list, not a condition: the C++ dispatch discriminates on class
   expect_false(inherits(result, "error"))
   expect_false(inherits(result, "interrupt"))
   expect_equal(result$value, 42)
   expect_true(result$visible)
   expect_equal(result$conditions, list())

   result <- .rs.chat.safeEval(quote(invisible(42)))
   expect_false(result$visible)
})

test_that("chat.safeEval records and muffles warnings when warn < 2", {
   expect_warning(
      result <- .rs.chat.safeEval(quote(warning("beware"))),
      regexp = NA
   )
   expect_equal(result$conditions, list(list(type = "warning", text = "beware")))
})

test_that("chat.safeEval records multiple warnings from one expression in order", {
   expect_warning(
      result <- .rs.chat.safeEval(quote({ warning("first"); warning("second") })),
      regexp = NA
   )
   expect_equal(result$conditions, list(
      list(type = "warning", text = "first"),
      list(type = "warning", text = "second")
   ))
})

test_that("chat.safeEval records interleaved messages and warnings in order", {
   expect_warning(
      expect_message(
         result <- .rs.chat.safeEval(
            quote({ message("m1"); warning("w1"); message("m2") })
         ),
         "m1"
      ),
      regexp = NA
   )
   expect_equal(result$conditions, list(
      list(type = "message", text = "m1\n"),
      list(type = "warning", text = "w1"),
      list(type = "message", text = "m2\n")
   ))
})

test_that("chat.safeEval does not record warnings when warn < 0 (REPL suppresses them)", {
   withr::with_options(list(warn = -1), {
      expect_warning(
         result <- .rs.chat.safeEval(quote(warning("quiet"))),
         regexp = NA
      )
   })
   expect_equal(result$conditions, list())
})

test_that("chat.safeEval leaves warning-to-error conversion intact under warn = 2", {
   withr::with_options(list(warn = 2), {
      result <- .rs.chat.safeEval(quote(warning("beware")))
   })
   expect_true(inherits(result, "error"))
   # the warning surfaces as the error itself, so it is not also recorded
   # for re-emission as a deferred warning
   expect_equal(attr(result, "assistant_conditions"), list())
})

test_that("chat.safeEval returns errors with recorded conditions attached", {
   expect_message(
      result <- .rs.chat.safeEval(quote({ message("progress"); stop("boom") })),
      "progress"
   )
   expect_true(inherits(result, "error"))
   expect_equal(conditionMessage(result), "boom")
   expect_equal(
      attr(result, "assistant_conditions"),
      list(list(type = "message", text = "progress\n"))
   )
})

test_that("chat.formatWarningMessages formats deferred warnings like the REPL", {
   expect_equal(.rs.chat.formatWarningMessages(list()), "")

   one <- list(list(type = "warning", text = "beware"))
   expect_equal(.rs.chat.formatWarningMessages(one), "Warning message:\nbeware\n")

   several <- list(
      list(type = "warning", text = "first"),
      list(type = "message", text = "not a warning\n"),
      list(type = "warning", text = "second")
   )
   expect_equal(
      .rs.chat.formatWarningMessages(several),
      "Warning messages:\n1: first\n2: second\n"
   )
})

test_that("chat.callExpressionBoundaryHook calls a hidden global hook with its arguments", {
   calls <- list()
   assign(".test_boundary_hook", function(expr, value, ok, visible, error, conditions) {
      calls[[length(calls) + 1L]] <<- list(value = value, ok = ok, visible = visible)
   }, envir = globalenv())
   on.exit(rm(".test_boundary_hook", envir = globalenv()), add = TRUE)

   .rs.chat.callExpressionBoundaryHook(".test_boundary_hook", quote(1 + 1), 2, TRUE, TRUE)
   expect_equal(calls, list(list(value = 2, ok = TRUE, visible = TRUE)))
})

test_that("chat.callExpressionBoundaryHook passes expr unevaluated and forwards error/conditions", {
   calls <- list()
   assign(".test_full_hook", function(expr, value, ok, visible, error, conditions) {
      calls[[length(calls) + 1L]] <<- list(
         expr = expr, error = error, conditions = conditions
      )
   }, envir = globalenv())
   on.exit(rm(".test_full_hook", envir = globalenv()), add = TRUE)

   err <- simpleError("boom")
   conditions <- list(list(type = "warning", text = "beware"))
   # expr is stop("boom"): evaluating it anywhere in the dispatch would fail
   .rs.chat.callExpressionBoundaryHook(
      ".test_full_hook", quote(stop("boom")), NULL, FALSE, FALSE,
      error = err, conditions = conditions
   )

   expect_length(calls, 1L)
   expect_identical(calls[[1L]]$expr, quote(stop("boom")))
   expect_identical(calls[[1L]]$error, err)
   expect_identical(calls[[1L]]$conditions, conditions)
})

test_that("chat.callExpressionBoundaryHook is a no-op for missing or invalid hooks", {
   expect_silent(.rs.chat.callExpressionBoundaryHook("", quote(1), 1, TRUE, TRUE))
   expect_silent(.rs.chat.callExpressionBoundaryHook(".no_such_hook", quote(1), 1, TRUE, TRUE))

   assign(".test_not_a_function", 42, envir = globalenv())
   on.exit(rm(".test_not_a_function", envir = globalenv()), add = TRUE)
   expect_silent(.rs.chat.callExpressionBoundaryHook(".test_not_a_function", quote(1), 1, TRUE, TRUE))
})

test_that("chat.callExpressionBoundaryHook swallows hook errors", {
   assign(".test_error_hook", function(...) stop("hook failed"), envir = globalenv())
   on.exit(rm(".test_error_hook", envir = globalenv()), add = TRUE)

   expect_silent(.rs.chat.callExpressionBoundaryHook(".test_error_hook", quote(1), 1, TRUE, TRUE))
})

#
# test-themes.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("themes")

# We need this file for .rs.parseCss
source(file.path("..", "..", "session", "resources", "themes", "compile-themes.R"))

inputFileLocation <- file.path(normalizePath("."), "themes")
tempOutputDir <- file.path(inputFileLocation, "temp")
localInstallDir <- file.path(inputFileLocation, "localInstall")
globalInstallDir <- file.path(inputFileLocation, "globalInstall")
noPermissionDir <- file.path(inputFileLocation, "nopermission")

themes <- list(
   "Active4D" = list("fileName" ="active4d",isDark = FALSE),
   "All Hallow's Eve" = list("fileName" ="all_hallows_eve", isDark = TRUE),
   "Amy" = list("fileName" ="amy", isDark = TRUE),
   "Blackboard" = list("fileName" ="blackboard", isDark = TRUE),
   "Brilliance Black" = list("fileName" ="brilliance_black", isDark = TRUE),
   "Brilliance Dull" = list("fileName" ="brilliance_dull", isDark = TRUE),
   "Chrome DevTools" = list("fileName" ="chrome_dev_tools", isDark = FALSE),
   "Clouds Midnight" = list("fileName" ="clouds_midnight", isDark = TRUE),
   "Clouds" = list("fileName" ="clouds", isDark = FALSE),
   "Cobalt" = list("fileName" ="cobalt", isDark = TRUE),
   "Dawn" = list("fileName" ="dawn", isDark = FALSE),
   "Debug Line" = list("fileName" = "DebugLine", isDark = TRUE),
   "Dreamweaver" = list("fileName" ="dreamweaver", isDark = FALSE),
   "Eiffel" = list("fileName" ="eiffel", isDark = FALSE),
   "Espresso Libre" = list("fileName" ="espresso_libre", isDark = TRUE),
   "GitHub" = list("fileName" ="git_hub", isDark = FALSE),
   "IDLE" = list("fileName" ="idle", isDark = FALSE),
   "idleFingers" = list("fileName" ="idle_fingers", isDark = TRUE),
   "iPlastic" = list("fileName" ="i_plastic", isDark = FALSE),
   "Katzenmilch" = list("fileName" ="katzenmilch", isDark = FALSE),
   "krTheme" = list("fileName" ="kr_theme", isDark = TRUE),
   "Kuroir Theme" = list("fileName" ="kuroir_theme", isDark = FALSE),
   "LAZY" = list("fileName" ="lazy", isDark = FALSE),
   "MagicWB (Amiga)" = list("fileName" ="magic_wb_amiga", isDark = FALSE),
   "Merbivore Soft" = list("fileName" ="merbivore_soft", isDark = TRUE),
   "Merbivore" = list("fileName" ="merbivore", isDark = TRUE),
   "mono industrial" = list("fileName" ="mono_industrial", isDark = TRUE),
   "Monokai" = list("fileName" ="monokai", isDark = TRUE),
   "Pastels on Dark" = list("fileName" ="pastels_on_dark", isDark = TRUE),
   "Slush & Poppies" = list("fileName" ="slush_and_poppies", isDark = FALSE),
   "Solarized (dark)" = list("fileName" ="solarized_dark", isDark = TRUE),
   "Solarized (light)" = list("fileName" ="solarized_light", isDark = FALSE),
   "Sunburst" = list("fileName" ="sunburst", isDark = TRUE),
   "Textmate" = list("fileName" ="textmate", isDark = FALSE),
   "Tomorrow Night - Blue" = list("fileName" ="tomorrow_night_blue", isDark = TRUE),
   "Tomorrow Night - Bright" = list("fileName" ="tomorrow_night_bright", isDark = TRUE),
   "Tomorrow Night - Eighties" = list("fileName" ="tomorrow_night_eighties", isDark = TRUE),
   "Tomorrow Night" = list("fileName" ="tomorrow_night", isDark = TRUE),
   "Tomorrow" = list("fileName" ="tomorrow", isDark = FALSE),
   "Twilight" = list("fileName" ="twilight", isDark = TRUE),
   "Vibrant Ink" = list("fileName" ="vibrant_ink", isDark = TRUE),
   "Xcode default" = list("fileName" ="xcode_default", isDark = FALSE),
   "Zenburnesque" = list("fileName" ="zenburnesque", isDark = TRUE))

defaultThemes <- list(
   "Ambiance" = list("fileName" = "ambiance", isDark =  TRUE),
   "Chaos" = list("fileName" = "chaos", isDark = TRUE),
   "Chrome" = list("fileName" = "chrome", isDark = FALSE),
   "Clouds Midnight" = list("fileName" = "clouds_midnight", isDark = TRUE),
   "Clouds" = list("fileName" = "clouds", isDark = FALSE),
   "Cobalt" = list("fileName" = "cobalt", isDark = TRUE),
   "Crimson Editor" = list("fileName" = "crimson_editor", isDark = FALSE),
   "Dawn" = list("fileName" = "dawn", isDark = FALSE),
   "Dracula" = list("fileName" = "dracula", isDark = TRUE),
   "Dreamweaver" = list("fileName" = "dreamweaver", isDark = FALSE),
   "Eclipse" = list("fileName" = "eclipse", isDark = FALSE),
   "Gob" = list("fileName" = "gob", isDark = TRUE),
   "Idle Fingers" = list("fileName" = "idle_fingers", isDark = TRUE),
   "iPlastic" = list("fileName" = "iplastic", isDark = FALSE),
   "Katzenmilch" = list("fileName" = "katzenmilch", isDark = FALSE),
   "Kr Theme" = list("fileName" = "kr_theme", isDark = TRUE),
   "Material" = list("fileName" = "material", isDark = TRUE),
   "Merbivore" = list("fileName" = "merbivore", isDark = TRUE),
   "Merbivore Soft" = list("fileName" = "merbivore_soft", isDark = TRUE),
   "Mono Industrial" = list("fileName" = "mono_industrial", isDark = TRUE),
   "Monokai" = list("fileName" = "monokai", isDark = TRUE),
   "Pastel On Dark" = list("fileName" = "pastel_on_dark", isDark = TRUE),
   "Solarized Dark" = list("fileName" = "solarized_dark", isDark = TRUE),
   "Solarized Light" = list("fileName" = "solarized_light", isDark = FALSE),
   "SQL Server" = list("fileName" = "sqlserver", isDark = FALSE),
   "Textmate (default)" = list("fileName" = "textmate", isDark = FALSE),
   "Tomorrow Night Blue" = list("fileName" = "tomorrow_night_blue", isDark = TRUE),
   "Tomorrow Night Bright" = list("fileName" = "tomorrow_night_bright", isDark = TRUE),
   "Tomorrow Night 80s" = list("fileName" = "tomorrow_night_eighties", isDark = TRUE),
   "Tomorrow Night" = list("fileName" = "tomorrow_night", isDark = TRUE),
   "Tomorrow" = list("fileName" = "tomorrow", isDark = FALSE),
   "Twilight" = list("fileName" = "twilight", isDark = TRUE),
   "Vibrant Ink" = list("fileName" = "vibrant_ink", isDark = TRUE),
   "Xcode" = list("fileName" = "xcode", isDark = FALSE))

# Helpers ==========================================================================================
compareCss <- function(actual, expected, infoStr, parent = NULL, shouldBreak = FALSE)
{
   browser(expr = shouldBreak)
   equal <- TRUE
   msgStart <- paste0("\n", infoStr, "\nCSS")
   if (!is.null(parent)) msgStart <- paste0("\n", infoStr, "\nElement \"", parent, "\"")

   if (!all(actual %in% expected) || !all(expected %in% actual))
   {
      # Check length
      acLen <- length(actual)
      exLen <- length(expected)
      msg <- sprintf("elements than expected. Actual: %d, Expected: %d", acLen, exLen)
      if (acLen < exLen)
      {
         cat(msgStart, "has fewer", msg, "\n")
         equal <- FALSE
      }
      else if (acLen > exLen)
      {
         cat(msgStart, "has more", msg, "\n")
         equal <- FALSE
      }

      acNames <- names(actual)
      exNames <- names(expected)
      if (!all(acNames %in% exNames) || !all(exNames %in% acNames))
      {
         equal <- FALSE
         extraNames <- c()
         missingNames <- c()
         # Check that all the names are included
         for (name in acNames)
         {
            if (!(name %in% exNames))
            {
               extraNames <- c(extraNames, name)
            }
         }
         for (name in exNames)
         {
            if(!(name %in% acNames))
            {
               missingNames <- c(missingNames, name)
            }
         }

         extraMsg <- sprintf(
            "had %d unexpected elements with names: \n   \"%s\"",
            length(extraNames),
            paste0(extraNames, collapse = "\",\n   \""))
         missingMsg <- sprintf(
            "was missing %d elements with names: \n   \"%s\"",
            length(missingNames),
            paste0(missingNames, collapse = "\",\n   \""))

         if (length(extraNames) > 0)
         {
            cat(msgStart, extraMsg, "\n")
         }
         if (length(missingNames) > 0)
         {
            cat(msgStart, missingMsg, "\n")
         }
      }

      # Handle the CSS contents
      for (name in acNames)
      {
         if (name %in% exNames)
         {
            acVal <- actual[[name]]
            exVal <- expected[[name]]
            if (!is.list(acVal)) acVal <- gsub(" +", " ", gsub("^\\s*|\\s*$", "", acVal, perl = TRUE), perl = TRUE)

            if (is.list(acVal) && is.list(exVal))
            {
               equal <- equal && compareCss(acVal, exVal, infoStr, name)
            }
            else if (is.list(acVal) || is.list(exVal))
            {
               msg <- sprintf("value type (%s) does not match expected (%s)", typeof(acVal), typeof(exVal))
               cat(msgStart, msg, "\n")
               equal <- FALSE
            }
            else if (acVal != exVal)
            {
               colorRegex <- "^(#[a-fA-F\\d]{6}|rgba?\\(\\s*\\d{1,3}\\s*(?:,\\s*\\d{1,3}\\s*){2}(?:,\\s*[01](?:\\.\\d+)?)?\\s*\\))$"
               if (grepl(colorRegex, acVal, perl = TRUE) && grepl(colorRegex, exVal, perl = TRUE))
               {
                  acRgb <- .rs.getRgbColor(acVal)
                  exRgb <- .rs.getRgbColor(exVal)
                  if (!identical(acRgb, exRgb))
                  {
                     msg <- sprintf("\"%s\" rule doesn't match. Actual: %s, Expected: %s", name, acVal, exVal)
                     cat(msgStart, msg, "\n")
                     equal <- FALSE
                  }
               }
               else
               {
                  msg <- sprintf("\"%s\" rule doesn't match. Actual: %s, Expected: %s", name, acVal, exVal)
                  cat(msgStart, msg, "\n")
                  equal <- FALSE
               }
            }
         }
      }
   }

   equal
}

getFirstMatchInLines <- function(regex, lines)
{
   matchingLine <- lines[grep(regex, lines, perl = TRUE)[1]]
   regmatches(matchingLine, regexec(regex, matchingLine, perl = TRUE))[[1]][2]
}

getRsThemeName <- function(lines)
{
   getFirstMatchInLines("rs-theme-name\\s*:\\s*([^\\*]+?)\\s*(?:\\*|$)", lines)
}

getRsIsDark <- function(lines)
{
   isDarkStr <- getFirstMatchInLines("rs-theme-is-dark\\s*:\\s*([^\\*]+?)\\s*(?:\\*|$)", lines)
   if(!grepl("^(?:true|false)$", isDarkStr, ignore.case = TRUE))
   {
      stop("Unable to convert isDark value to logical.")
   }
   as.logical(toupper(isDarkStr))
}

test_that_wrapped <- function(desc, FUN, BEFORE_FUN = NULL, AFTER_FUN = NULL)
{
   if (!is.null(BEFORE_FUN))
   {
      BEFORE_FUN()
   }

   test_that(desc, FUN)

   if (!is.null(AFTER_FUN))
   {
      AFTER_FUN()
   }
}

setThemeLocations <- function()
{
   Sys.setenv(
      RS_THEME_GLOBAL_HOME = globalInstallDir,
      RS_THEME_LOCAL_HOME = localInstallDir)
}

unsetThemeLocations <- function()
{
   Sys.unsetenv("RS_THEME_GLOBAL_HOME")
   Sys.unsetenv("RS_THEME_LOCAL_HOME")
}

makeNoPermissionDir <- function()
{
   if (dir.exists(noPermissionDir))
      Sys.chmod(noPermissionDir, mode = "0555")
   else
      dir.create(noPermissionDir, mode = "0555")
}

makeGlobalThemeDir <- function()
{
   if (!dir.exists(globalInstallDir))
      dir.create(globalInstallDir, recursive = TRUE)
}

# Test getRgbColor =================================================================================
test_that("rgb conversion from hex format works", {
   # All lowercase
   expect_equal(.rs.getRgbColor("#ffffff"), c(255, 255, 255))

   # All digits
   expect_equal(.rs.getRgbColor("#000000"), c(0, 0, 0))

   # Uppercase & digits
   expect_equal(.rs.getRgbColor("#DD8EBD"), c(221, 142, 189))

   # Mix case & digits
   expect_equal(.rs.getRgbColor("#569cD6"), c(86, 156, 214))
})

test_that("rgb conversion from rgb string format works", {
   expect_equal(.rs.getRgbColor("rgb(86, 156, 214)"), c(86, 156, 214))
   expect_equal(.rs.getRgbColor("rgb(0, 0, 0)"), c(0, 0, 0))
   expect_equal(.rs.getRgbColor("rgb(255,255,255)"), c(255, 255, 255))
})

test_that("rgb conversion from rgba string format works", {
   # 'a' value shouldn't impact outcome.
   expect_equal(.rs.getRgbColor("rgba(86, 156, 214, 10)"), c(86, 156, 214))
   expect_equal(.rs.getRgbColor("rgba(86,156,214,90)"), c(86, 156, 214))

   expect_equal(.rs.getRgbColor("rgba(0, 0, 0, 55)"), c(0, 0, 0))
   expect_equal(.rs.getRgbColor("rgba(255, 255, 255, 72)"), c(255, 255, 255))
})

test_that("rgb conversion handles out of bounds values correctly", {
   # Negatvie RGB value.
   expect_error(
      .rs.getRgbColor("rgb(-10, 156, 214)"),
      "invalid color supplied: rgb(-10, 156, 214). RGB value cannot be negative",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgb(86, -1, 214)"),
      "invalid color supplied: rgb(86, -1, 214). RGB value cannot be negative",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgb(86, 156, -214)"),
      "invalid color supplied: rgb(86, 156, -214). RGB value cannot be negative",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgb(-86, -156, -214)"),
      "invalid color supplied: rgb(-86, -156, -214). RGB value cannot be negative",
      fixed = TRUE)

   # RGB value > 255
   expect_error(
      .rs.getRgbColor("rgb(300, 156, 214)"),
      "invalid color supplied: rgb(300, 156, 214). RGB value cannot be greater than 255",
      fixed = TRUE
   )
   expect_error(
      .rs.getRgbColor("rgb(86, 455, 214)"),
      "invalid color supplied: rgb(86, 455, 214). RGB value cannot be greater than 255",
      fixed = TRUE
   )
   expect_error(
      .rs.getRgbColor("rgb(86, 156, 1024)"),
      "invalid color supplied: rgb(86, 156, 1024). RGB value cannot be greater than 255",
      fixed = TRUE
   )
   expect_error(
      .rs.getRgbColor("rgb(300, 455, 1024)"),
      "invalid color supplied: rgb(300, 455, 1024). RGB value cannot be greater than 255",
      fixed = TRUE
   )

   # Negative & too large values
   negOrTooLarge = "(?:negative|greater than 255)"
   expect_error(
      .rs.getRgbColor("rgb(-300, 455, 1024)"),
      paste0(
         "invalid color supplied: rgb\\(-300, 455, 1024\\). RGB value cannot be ",
         negOrTooLarge))
   expect_error(
      .rs.getRgbColor("rgb(300, -455, 1024)"),
      paste0(
         "invalid color supplied: rgb\\(300, -455, 1024\\). RGB value cannot be ",
         negOrTooLarge))

   # Negatvie RGBA value.
   expect_error(
      .rs.getRgbColor("rgba(-10, 156, 214, 92)"),
      "invalid color supplied: rgba(-10, 156, 214, 92). RGB value cannot be negative",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgba(86, -1, 214, 14)"),
      "invalid color supplied: rgba(86, -1, 214, 14). RGB value cannot be negative",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgba(86, 156, -214, 100)"),
      "invalid color supplied: rgba(86, 156, -214, 100). RGB value cannot be negative",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgba(-86, -156, -214, 39)"),
      "invalid color supplied: rgba(-86, -156, -214, 39). RGB value cannot be negative",
      fixed = TRUE)

   # RGB value > 255
   expect_error(
      .rs.getRgbColor("rgba(300, 156, 214, 100)"),
      "invalid color supplied: rgba(300, 156, 214, 100). RGB value cannot be greater than 255",
      fixed = TRUE
   )
   expect_error(
      .rs.getRgbColor("rgba(86, 455, 214, 0)"),
      "invalid color supplied: rgba(86, 455, 214, 0). RGB value cannot be greater than 255",
      fixed = TRUE
   )
   expect_error(
      .rs.getRgbColor("rgba(86, 156, 1024, 40)"),
      "invalid color supplied: rgba(86, 156, 1024, 40). RGB value cannot be greater than 255",
      fixed = TRUE
   )
   expect_error(
      .rs.getRgbColor("rgba(300, 455, 1024, 60)"),
      "invalid color supplied: rgba(300, 455, 1024, 60). RGB value cannot be greater than 255",
      fixed = TRUE
   )

   # Negative & too large values
   expect_error(
      .rs.getRgbColor("rgba(-300, 455, 1024, 55)"),
      paste0(
         "invalid color supplied: rgba\\(-300, 455, 1024, 55\\). RGB value cannot be ",
         negOrTooLarge))
   expect_error(
      .rs.getRgbColor("rgba(300, -455, 1024, 55)"),
      paste0(
         "invalid color supplied: rgba\\(300, -455, 1024, 55\\). RGB value cannot be ",
         negOrTooLarge))

   # Non-integer RGB values
   expect_error(
      .rs.getRgbColor("rgb(30,10f,5)"),
      "invalid color supplied: rgb(30,10f,5). One or more RGB values could not be converted to an integer",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgb(2.1,10,5)"),
      "invalid color supplied: rgb(2.1,10,5). One or more RGB values could not be converted to an integer",
      fixed = TRUE)

   # Non-integer RGBA values
   expect_error(
      .rs.getRgbColor("rgba(30,10f,5,67)"),
      "invalid color supplied: rgba(30,10f,5,67). One or more RGB values could not be converted to an integer",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgba(2.1,10,5,45)"),
      "invalid color supplied: rgba(2.1,10,5,45). One or more RGB values could not be converted to an integer",
      fixed = TRUE)

   # Non-hex hex representation values
   expect_error(
      .rs.getRgbColor("#afga01"),
      "invalid color supplied: #afga01. One or more RGB values could not be converted to an integer",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("#af1a6T"),
      "invalid color supplied: #af1a6T. One or more RGB values could not be converted to an integer",
      fixed = TRUE)
})

test_that("rgb conversion handles invalid values correctly", {
   # Too many characters in hex representation
   expect_error(
      .rs.getRgbColor("#123456ab"),
      "hex representation of RGB values should have the format \"#RRGGBB\", where `RR`, `GG` and `BB` are in [0x00, 0xFF]. Found: #123456ab",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("#FfFfFf0"),
      "hex representation of RGB values should have the format \"#RRGGBB\", where `RR`, `GG` and `BB` are in [0x00, 0xFF]. Found: #FfFfFf0",
      fixed = TRUE)

   # Too few values in rgb/rgba representation
   expect_error(
      .rs.getRgbColor("rgb(1, 10)"),
      "non-hex representation of RGB values should have the format \"rgb(R, G, B)\" or \"rgba(R, G, B, A)\" where `R`, `G`, and `B` are integer values in [0, 255] and `A` is decimal value in [0, 1.0]. Found: rgb(1, 10)",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgba(1, 10)"),
      "non-hex representation of RGB values should have the format \"rgb(R, G, B)\" or \"rgba(R, G, B, A)\" where `R`, `G`, and `B` are integer values in [0, 255] and `A` is decimal value in [0, 1.0]. Found: rgba(1, 10)",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgb(255)"),
      "non-hex representation of RGB values should have the format \"rgb(R, G, B)\" or \"rgba(R, G, B, A)\" where `R`, `G`, and `B` are integer values in [0, 255] and `A` is decimal value in [0, 1.0]. Found: rgb(255)",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("rgba(255)"),
      "non-hex representation of RGB values should have the format \"rgb(R, G, B)\" or \"rgba(R, G, B, A)\" where `R`, `G`, and `B` are integer values in [0, 255] and `A` is decimal value in [0, 1.0]. Found: rgba(255)",
      fixed = TRUE)

   # Completely wrong format
   expect_error(
      .rs.getRgbColor("86, 154, 214"),
      "supplied color has an invalid format: 86, 154, 214. Expected \"#RRGGBB\", \"rgb(R, G, B) or \"rgba(R, G, B, A)\", where `RR`, `GG` and `BB` are in [0x00, 0xFF], `R`, `G`, and `B` are integer values in [0, 255], and `A` is decimal value in [0, 1.0]",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("Not a color"),
      "supplied color has an invalid format: Not a color. Expected \"#RRGGBB\", \"rgb(R, G, B) or \"rgba(R, G, B, A)\", where `RR`, `GG` and `BB` are in [0x00, 0xFF], `R`, `G`, and `B` are integer values in [0, 255], and `A` is decimal value in [0, 1.0]",
      fixed = TRUE)
   expect_error(
      .rs.getRgbColor("0xaaaaaa"),
      "supplied color has an invalid format: 0xaaaaaa. Expected \"#RRGGBB\", \"rgb(R, G, B) or \"rgba(R, G, B, A)\", where `RR`, `GG` and `BB` are in [0x00, 0xFF], `R`, `G`, and `B` are integer values in [0, 255], and `A` is decimal value in [0, 1.0]",
      fixed = TRUE)
})

# Test mixColors ===================================================================================
test_that("mixColors works correctly", {
   expect_equal(.rs.mixColors("#aa11bb", "rgb(21, 140, 231)", 0.6, 0.2), "#6B279F")
   expect_equal(.rs.mixColors("rgb(0, 0, 0)", "rgb(255, 255, 255)", 0.5), "#808080")
   expect_equal(.rs.mixColors("rgb(0, 0, 0)", "rgb(255, 255, 255)", 0.51), "#7D7D7D")
   expect_equal(.rs.mixColors("rgb(10,10,10)", "rgb(30,30,30)", 1, 1), "#282828")
   expect_equal(.rs.mixColors("rgb(10,10,10)", "rgb(28,230,57)", 1), "#0A0A0A")
})

# Test getLuma =====================================================================================
test_that("getLuma works correctly", {
   expect_equal(.rs.getLuma("rgb(0,0,0)"), 0)
   expect_equal(.rs.getLuma("#FFFFFF"), 1)
   expect_equal(.rs.getLuma("rgb(128, 128, 128)"), 0.5019608, tolerance = 5e-7)
   expect_equal(.rs.getLuma("#569cD6"), 0.5700392, tolerance = 5e-7)
})

# Test parseColor ==================================================================================
test_that("parseColor works correctly", {
   # Non-error cases
   expect_equal(.rs.parseColor("#aBc"), "#aaBBcc")
   expect_equal(.rs.parseColor("#123"), "#112233")
   expect_equal(.rs.parseColor("#F5d"), "#FF55dd")
   expect_equal(.rs.parseColor("#86D4C2"), "#86D4C2")
   expect_equal(.rs.parseColor("#86D4C2FF"), "rgba(134, 212, 194, 1.00)")
   expect_equal(.rs.parseColor("#1B22A7D6"), "rgba(27, 34, 167, 0.84)")
   expect_null(.rs.parseColor(""))

   # Error cases
   expect_error(.rs.parseColor("1a2b"), "Unable to parse color: 11aa22bb", fixed = TRUE)
   expect_error(.rs.parseColor("654"), "Unable to parse color: 654", fixed = TRUE)
   expect_error(
      .rs.parseColor("rgb(10, 223, 186)"), "Unable to parse color: rgb(10, 223, 186)",
      fixed = TRUE)
   expect_error(.rs.parseColor("1234567"), "Unable to parse color: 1234567", fixed = TRUE)
})

# Test parseStyles =================================================================================
test_that("parseStyles works correctly", {
   # Setup objects for the test case
   allValues <- list(
      "foreground" = "#a12d96",
      "fontStyle" = "underline italic bold",
      "background" = "#1ad269")
   noFont <- list("foreground" = "#863021", "background" = "#A1A1A1")
   onlyItalic <- list("fontStyle" = "italic")
   underLineBg <- list("fontStyle" = "underline", "background" = "#A1A1A1FF")
   nonsense <- list("fontStyle" = "afgaeda", "background" = "afdafag", "foreground" = "asdafwegwr")
   nonsenseFont <- list("fontStyle" = "afsafefaf", "background" = "#123", "foreground" = "#1A2B3C4D")
   nonsenseFont2 <- list(
      "background" = "#1a2b3c",
      "fontStyle" = "asdafafeaunderlineadafweglkj;op",
      "foreground" = "#ccc")
   emptyList <- list()

   # Expected Values
   allValuesEx <- list(
      "text-decoration" = "underline",
      "font-style" = "italic",
      "font-weight" = "bold",
      "color" = "#a12d96",
      "background-color" = "#1ad269")
   noFontEx <- list("color" = "#863021", "background-color" = "#A1A1A1")
   onlyItalicEx <- list("font-style" = "italic")
   underLineBgEx <- list(
      "text-decoration" = "underline",
      "background-color" = "rgba(161, 161, 161, 1.00)")
   nonsenseFontEx <- list("color" = "rgba(26, 43, 60, 0.30)", "background-color" = "#112233")
   nonsenseFont2Ex <- list(
      "text-decoration" = "underline",
      "color" = "#cccccc",
      "background-color" = "#1a2b3c")
   emptyListEx <- list()

   # Test cases (no error)
   expect_equal(.rs.parseStyles(allValues), allValuesEx)
   expect_equal(.rs.parseStyles(noFont), noFontEx)
   expect_equal(.rs.parseStyles(onlyItalic), onlyItalicEx)
   expect_equal(.rs.parseStyles(underLineBg), underLineBgEx)
   expect_equal(.rs.parseStyles(nonsenseFont), nonsenseFontEx)
   expect_equal(.rs.parseStyles(nonsenseFont2), nonsenseFont2Ex)
   expect_equal(.rs.parseStyles(emptyList), emptyListEx)

   # Test cases (error)
   expect_error(.rs.parseStyles(nonsense), "Unable to parse color: asdafwegwr", fixed = TRUE)
})

# Test extractStyles ===============================================================================
test_that("extractStyles works correctly", {
   # Static supported scopes list that extractStyle requires. It's defined in the function that
   # calls extractStyles (.rs.convertTmTheme)
   supportedScopes <- list()

   supportedScopes[["keyword"]] <- "keyword"
   supportedScopes[["keyword.operator"]] <- "keyword.operator"
   supportedScopes[["keyword.other.unit"]] <- "keyword.other.unit"

   supportedScopes[["constant"]] <- "constant"
   supportedScopes[["constant.language"]] <- "constant.language"
   supportedScopes[["constant.library"]] <- "constant.library"
   supportedScopes[["constant.numeric"]] <- "constant.numeric"
   supportedScopes[["constant.character"]] <- "constant.character"
   supportedScopes[["constant.character.escape"]] <- "constant.character.escape"
   supportedScopes[["constant.character.entity"]] <- "constant.character.entity"

   supportedScopes[["support"]] <- "support"
   supportedScopes[["support.function"]] <- "support.function"
   supportedScopes[["support.function.dom"]] <- "support.function.dom"
   supportedScopes[["support.function.firebug"]] <- "support.firebug"
   supportedScopes[["support.function.constant"]] <- "support.function.constant"
   supportedScopes[["support.constant"]] <- "support.constant"
   supportedScopes[["support.constant.property-value"]] <- "support.constant.property-value"
   supportedScopes[["support.class"]] <- "support.class"
   supportedScopes[["support.type"]] <- "support.type"
   supportedScopes[["support.other"]] <- "support.other"

   supportedScopes[["function"]] <- "function"
   supportedScopes[["function.buildin"]] <- "function.buildin"

   supportedScopes[["storage"]] <- "storage"
   supportedScopes[["storage.type"]] <- "storage.type"

   supportedScopes[["invalid"]] <- "invalid"
   supportedScopes[["invalid.illegal"]] <- "invalid.illegal"
   supportedScopes[["invalid.deprecated"]] <- "invalid.deprecated"

   supportedScopes[["string"]] <- "string"
   supportedScopes[["string.regexp"]] <- "string.regexp"

   supportedScopes[["comment"]] <- "comment"
   supportedScopes[["comment.documentation"]] <- "comment.doc"
   supportedScopes[["comment.documentation.tag"]] <- "comment.doc.tag"

   supportedScopes[["variable"]] <- "variable"
   supportedScopes[["variable.language"]] <- "variable.language"
   supportedScopes[["variable.parameter"]] <- "variable.parameter"

   supportedScopes[["meta"]] <- "meta"
   supportedScopes[["meta.tag.sgml.doctype"]] <- "xml-pe"
   supportedScopes[["meta.tag"]] <- "meta.tag"
   supportedScopes[["meta.selector"]] <- "meta.selector"

   supportedScopes[["entity.other.attribute-name"]] <- "entity.other.attribute-name"
   supportedScopes[["entity.name.function"]] <- "entity.name.function"
   supportedScopes[["entity.name"]] <- "entity.name"
   supportedScopes[["entity.name.tag"]] <- "entity.name.tag"

   supportedScopes[["markup.heading"]] <- "markup.heading"
   supportedScopes[["markup.heading.1"]] <- "markup.heading.1"
   supportedScopes[["markup.heading.2"]] <- "markup.heading.2"
   supportedScopes[["markup.heading.3"]] <- "markup.heading.3"
   supportedScopes[["markup.heading.4"]] <- "markup.heading.4"
   supportedScopes[["markup.heading.5"]] <- "markup.heading.5"
   supportedScopes[["markup.heading.6"]] <- "markup.heading.6"
   supportedScopes[["markup.list"]] <- "markup.list"

   supportedScopes[["collab.user1"]] <- "collab.user1"

   supportedScopes[["marker-layer.bracket"]] <- "marker-layer.bracket"

   # Setup objects for test cases
   tomorrowTmTheme <- list()
   tomorrowTmTheme$comment <- "http://chriskempson.com"
   tomorrowTmTheme$name <- "Tomorrow"
   tomorrowTmTheme$settings <- list()

   tomorrowTmTheme$settings[[1]] <- list()
   tomorrowTmTheme$settings[[1]]$settings <- list(
      "background" = "#FFFFFF",
      "caret" ="#AEAFAD",
      "foreground" = "#4D4D4C",
      "invisibles" = "#D1D1D1",
      "lineHighlight" = "#EFEFEF",
      "selection" = "#D6D6D6")

   tomorrowTmTheme$settings[[2]] <- list()
   tomorrowTmTheme$settings[[2]]$name <- "Comment"
   tomorrowTmTheme$settings[[2]]$scope <- "comment"
   tomorrowTmTheme$settings[[2]]$settings <- list("foreground" = "#8E908C")

   tomorrowTmTheme$settings[[3]] <- list()
   tomorrowTmTheme$settings[[3]]$name <- "Foreground"
   tomorrowTmTheme$settings[[3]]$scope <- "keyword.operator.class, constant.other, source.php.embedded.line"
   tomorrowTmTheme$settings[[3]]$settings <- list()
   tomorrowTmTheme$settings[[3]]$settings$fontStyle <- ""
   tomorrowTmTheme$settings[[3]]$settings$foreground <- "#666969"

   tomorrowTmTheme$settings[[4]] <- list()
   tomorrowTmTheme$settings[[4]]$name <- "Variable, String Link, Regular Expression, Tag Name, GitGutter deleted"
   tomorrowTmTheme$settings[[4]]$scope <- "variable, support.other.variable, string.other.link, string.regexp, entity.name.tag, entity.other.attribute-name, meta.tag, declaration.tag, markup.deleted.git_gutter"
   tomorrowTmTheme$settings[[4]]$settings <- list("foreground" = "#C82829")

   tomorrowTmTheme$settings[[5]] <- list()
   tomorrowTmTheme$settings[[5]]$name <- "Number, Constant, Function Argument, Tag Attribute, Embedded"
   tomorrowTmTheme$settings[[5]]$scope <- "constant.numeric, constant.language, support.constant, constant.character, variable.parameter, punctuation.section.embedded, keyword.other.unit"
   tomorrowTmTheme$settings[[5]]$settings <- list("fontStyle" = "", "foreground" = "#F5871F")

   tomorrowTmTheme$settings[[6]] <- list()
   tomorrowTmTheme$settings[[6]]$name <- "Class, Support"
   tomorrowTmTheme$settings[[6]]$scope <- "entity.name.class, entity.name.type.class, support.type, support.class"
   tomorrowTmTheme$settings[[6]]$settings <- list("fontStyle" = "", "foreground" = "#C99E00")

   tomorrowTmTheme$settings[[7]] <- list()
   tomorrowTmTheme$settings[[7]]$name <- "String, Symbols, Inherited Class, Markup Heading, GitGutter inserted"
   tomorrowTmTheme$settings[[7]]$scope <- "string, constant.other.symbol, entity.other.inherited-class, entity.name.filename, markup.heading, markup.inserted.git_gutter"
   tomorrowTmTheme$settings[[7]]$settings <- list("fontStyle" = "", "foreground" = "#718C00")

   tomorrowTmTheme$settings[[8]] <- list()
   tomorrowTmTheme$settings[[8]]$name <- "Operator, Misc"
   tomorrowTmTheme$settings[[8]]$scope <- "keyword.operator, constant.other.color"
   tomorrowTmTheme$settings[[8]]$settings <- list("foreground" = "#3E999F")

   tomorrowTmTheme$settings[[9]] <- list()
   tomorrowTmTheme$settings[[9]]$name <- "Function, Special Method, Block Level, GitGutter changed"
   tomorrowTmTheme$settings[[9]]$scope <- "entity.name.function, meta.function-call, support.function, keyword.other.special-method, meta.block-level, markup.changed.git_gutter"
   tomorrowTmTheme$settings[[9]]$settings <- list("fontStyle" = "", "foreground" = "#4271AE")

   tomorrowTmTheme$settings[[10]] <- list()
   tomorrowTmTheme$settings[[10]]$name <- "Keyword, Storage"
   tomorrowTmTheme$settings[[10]]$scope <- "keyword, storage, storage.type"
   tomorrowTmTheme$settings[[10]]$settings <- list("fontStyle" = "", "foreground" = "#8959A8")

   tomorrowTmTheme$settings[[11]] <- list()
   tomorrowTmTheme$settings[[11]]$name <- "Invalid"
   tomorrowTmTheme$settings[[11]]$scope <- "invalid"
   tomorrowTmTheme$settings[[11]]$settings <- list("background" = "#C82829", "fontStyle" = "", "foreground" = "#FFFFFF")

   tomorrowTmTheme$settings[[12]] <- list()
   tomorrowTmTheme$settings[[12]]$name <- "Separator"
   tomorrowTmTheme$settings[[12]]$scope <- "meta.separator"
   tomorrowTmTheme$settings[[12]]$settings <- list("background" = "#4271AE", "foreground" = "#FFFFFF")

   tomorrowTmTheme$settings[[13]] <- list()
   tomorrowTmTheme$settings[[13]]$name <- "Deprecated"
   tomorrowTmTheme$settings[[13]]$scope <- "invalid.deprecated"
   tomorrowTmTheme$settings[[13]]$settings <- list("background" = "#8959A8", "fontStyle" = "", "foreground" = "#FFFFFF")

   tomorrowTmTheme$settings[[14]] <- list()
   tomorrowTmTheme$settings[[14]]$name <- "Diff foreground"
   tomorrowTmTheme$settings[[14]]$scope <- "markup.inserted.diff, markup.deleted.diff, meta.diff.header.to-file, meta.diff.header.from-file"
   tomorrowTmTheme$settings[[14]]$settings <- list("foreground" = "#FFFFFF")

   tomorrowTmTheme$settings[[15]] <- list()
   tomorrowTmTheme$settings[[15]]$name <- "Diff insertion"
   tomorrowTmTheme$settings[[15]]$scope <- "markup.inserted.diff, meta.diff.header.to-file"
   tomorrowTmTheme$settings[[15]]$settings <- list("background" = "#718c00")

   tomorrowTmTheme$settings[[16]] <- list()
   tomorrowTmTheme$settings[[16]]$name <- "Diff deletion"
   tomorrowTmTheme$settings[[16]]$scope <- "markup.deleted.diff, meta.diff.header.from-file"
   tomorrowTmTheme$settings[[16]]$settings <- list("background" = "#c82829")

   tomorrowTmTheme$settings[[17]] <- list()
   tomorrowTmTheme$settings[[17]]$name <- "Diff header"
   tomorrowTmTheme$settings[[17]]$scope <- "meta.diff.header.from-file, meta.diff.header.to-file"
   tomorrowTmTheme$settings[[17]]$settings <- list("foreground" = "#FFFFFF", "background" = "#4271ae")

   tomorrowTmTheme$settings[[18]] <- list()
   tomorrowTmTheme$settings[[18]]$name <- "Diff range"
   tomorrowTmTheme$settings[[18]]$scope <- "meta.diff.range"
   tomorrowTmTheme$settings[[18]]$settings <- list("fontStyle" = "italic", "foreground" = "#3e999f")

   tomorrowTmTheme$uuid <- "82CCD69C-F1B1-4529-B39E-780F91F07604"
   tomorrowTmTheme$colorSpaceName <- "sRGB"

   # Expected Results
   tomorrowStyles <- list()
   tomorrowStyles$printMargin = "#e8e8e8"
   tomorrowStyles$background = "#FFFFFF"
   tomorrowStyles$foreground = "#4D4D4C"
   tomorrowStyles$gutter = "#f0f0f0"
   tomorrowStyles$selection = "#D6D6D6"
   tomorrowStyles$step = "rgb(198, 219, 174)"
   tomorrowStyles$bracket = "#D1D1D1"
   tomorrowStyles$active_line = "#EFEFEF"
   tomorrowStyles$cursor = "#AEAFAD"
   tomorrowStyles$invisible =  "#D1D1D1"
   tomorrowStyles$comment = list("color" = "#8E908C")
   tomorrowStyles$variable = list("color" = "#C82829")
   tomorrowStyles$string.regexp = list("color" = "#C82829")
   tomorrowStyles$entity.name.tag = list("color" = "#C82829")
   tomorrowStyles$`entity.other.attribute-name` = list("color" = "#C82829")
   tomorrowStyles$meta.tag = list("color" = "#C82829")
   tomorrowStyles$constant.numeric = list("color" = "#F5871F")
   tomorrowStyles$constant.language = list("color" = "#F5871F")
   tomorrowStyles$support.constant = list("color" = "#F5871F")
   tomorrowStyles$constant.character = list("color" = "#F5871F")
   tomorrowStyles$variable.parameter = list("color" = "#F5871F")
   tomorrowStyles$keyword.other.unit = list("color" = "#F5871F")
   tomorrowStyles$support.type = list("color" = "#C99E00")
   tomorrowStyles$support.class =  list("color" = "#C99E00")
   tomorrowStyles$string = list("color" = "#718C00")
   tomorrowStyles$markup.heading = list("color" = "#718C00")
   tomorrowStyles$keyword.operator = list("color" = "#3E999F")
   tomorrowStyles$entity.name.function = list("color" = "#4271AE")
   tomorrowStyles$support.function = list("color" = "#4271AE")
   tomorrowStyles$keyword = list("color" = "#8959A8")
   tomorrowStyles$storage = list("color" = "#8959A8")
   tomorrowStyles$storage.type = list("color" = "#8959A8")
   tomorrowStyles$invalid = list("color" = "#FFFFFF", "background-color" = "#C82829")
   tomorrowStyles$invalid.deprecated = list("color" = "#FFFFFF", "background-color" = "#8959A8")
   tomorrowStyles$fold = "#4271AE"
   tomorrowStyles$gutterBg = "#FFFFFF"
   tomorrowStyles$gutterFg = "#A6A6A6"
   tomorrowStyles$selected_word_highlight = "border: 1px solid #D6D6D6"
   tomorrowStyles$isDark = "false"

   unsupportedScopes = list(
      "keyword.operator.class" = 0,
      "constant.other" = 0,
      "source.php.embedded.line" = 0,
      "support.other.variable" = 0,
      "string.other.link" = 0,
      "declaration.tag" = 0,
      "markup.deleted.git_gutter" = 0,
      "punctuation.section.embedded" = 0,
      "entity.name.class" = 0,
      "entity.name.type.class" = 0,
      "constant.other.symbol" = 0,
      "entity.other.inherited-class" = 0,
      "entity.name.filename" = 0,
      "markup.inserted.git_gutter" = 0,
      "constant.other.color" = 0,
      "meta.function-call" = 0,
      "keyword.other.special-method" = 0,
      "meta.block-level" = 0,
      "markup.changed.git_gutter" = 0,
      "meta.separator" = 0,
      "markup.inserted.diff" = 1,
      "markup.deleted.diff" = 1,
      "meta.diff.header.to-file" = 2,
      "meta.diff.header.from-file" = 2,
      "meta.diff.range" = 0)

   expect_equal(
      .rs.extractStyles(tomorrowTmTheme, supportedScopes),
      list(
         "styles" = tomorrowStyles,
         "unsupportedScopes" = unsupportedScopes))
})

# Test convertTmTheme ==============================================================================
test_that("convertTmTheme works correctly without parseTmTheme", {
   library("xml2")

   # Setup objects for test cases
   tomorrowTmTheme <- list()
   tomorrowTmTheme$comment <- "http://chriskempson.com"
   tomorrowTmTheme$name <- "Tomorrow"
   tomorrowTmTheme$settings <- list()

   tomorrowTmTheme$settings[[1]] <- list()
   tomorrowTmTheme$settings[[1]]$settings <- list(
      "background" = "#FFFFFF",
      "caret" ="#AEAFAD",
      "foreground" = "#4D4D4C",
      "invisibles" = "#D1D1D1",
      "lineHighlight" = "#EFEFEF",
      "selection" = "#D6D6D6")

   tomorrowTmTheme$settings[[2]] <- list()
   tomorrowTmTheme$settings[[2]]$name <- "Comment"
   tomorrowTmTheme$settings[[2]]$scope <- "comment"
   tomorrowTmTheme$settings[[2]]$settings <- list("foreground" = "#8E908C")

   tomorrowTmTheme$settings[[3]] <- list()
   tomorrowTmTheme$settings[[3]]$name <- "Foreground"
   tomorrowTmTheme$settings[[3]]$scope <- "keyword.operator.class, constant.other, source.php.embedded.line"
   tomorrowTmTheme$settings[[3]]$settings <- list()
   tomorrowTmTheme$settings[[3]]$settings$fontStyle <- ""
   tomorrowTmTheme$settings[[3]]$settings$foreground <- "#666969"

   tomorrowTmTheme$settings[[4]] <- list()
   tomorrowTmTheme$settings[[4]]$name <- "Variable, String Link, Regular Expression, Tag Name, GitGutter deleted"
   tomorrowTmTheme$settings[[4]]$scope <- "variable, support.other.variable, string.other.link, string.regexp, entity.name.tag, entity.other.attribute-name, meta.tag, declaration.tag, markup.deleted.git_gutter"
   tomorrowTmTheme$settings[[4]]$settings <- list("foreground" = "#C82829")

   tomorrowTmTheme$settings[[5]] <- list()
   tomorrowTmTheme$settings[[5]]$name <- "Number, Constant, Function Argument, Tag Attribute, Embedded"
   tomorrowTmTheme$settings[[5]]$scope <- "constant.numeric, constant.language, support.constant, constant.character, variable.parameter, punctuation.section.embedded, keyword.other.unit"
   tomorrowTmTheme$settings[[5]]$settings <- list("fontStyle" = "", "foreground" = "#F5871F")

   tomorrowTmTheme$settings[[6]] <- list()
   tomorrowTmTheme$settings[[6]]$name <- "Class, Support"
   tomorrowTmTheme$settings[[6]]$scope <- "entity.name.class, entity.name.type.class, support.type, support.class"
   tomorrowTmTheme$settings[[6]]$settings <- list("fontStyle" = "", "foreground" = "#C99E00")

   tomorrowTmTheme$settings[[7]] <- list()
   tomorrowTmTheme$settings[[7]]$name <- "String, Symbols, Inherited Class, Markup Heading, GitGutter inserted"
   tomorrowTmTheme$settings[[7]]$scope <- "string, constant.other.symbol, entity.other.inherited-class, entity.name.filename, markup.heading, markup.inserted.git_gutter"
   tomorrowTmTheme$settings[[7]]$settings <- list("fontStyle" = "", "foreground" = "#718C00")

   tomorrowTmTheme$settings[[8]] <- list()
   tomorrowTmTheme$settings[[8]]$name <- "Operator, Misc"
   tomorrowTmTheme$settings[[8]]$scope <- "keyword.operator, constant.other.color"
   tomorrowTmTheme$settings[[8]]$settings <- list("foreground" = "#3E999F")

   tomorrowTmTheme$settings[[9]] <- list()
   tomorrowTmTheme$settings[[9]]$name <- "Function, Special Method, Block Level, GitGutter changed"
   tomorrowTmTheme$settings[[9]]$scope <- "entity.name.function, meta.function-call, support.function, keyword.other.special-method, meta.block-level, markup.changed.git_gutter"
   tomorrowTmTheme$settings[[9]]$settings <- list("fontStyle" = "", "foreground" = "#4271AE")

   tomorrowTmTheme$settings[[10]] <- list()
   tomorrowTmTheme$settings[[10]]$name <- "Keyword, Storage"
   tomorrowTmTheme$settings[[10]]$scope <- "keyword, storage, storage.type"
   tomorrowTmTheme$settings[[10]]$settings <- list("fontStyle" = "", "foreground" = "#8959A8")

   tomorrowTmTheme$settings[[11]] <- list()
   tomorrowTmTheme$settings[[11]]$name <- "Invalid"
   tomorrowTmTheme$settings[[11]]$scope <- "invalid"
   tomorrowTmTheme$settings[[11]]$settings <- list("background" = "#C82829", "fontStyle" = "", "foreground" = "#FFFFFF")

   tomorrowTmTheme$settings[[12]] <- list()
   tomorrowTmTheme$settings[[12]]$name <- "Separator"
   tomorrowTmTheme$settings[[12]]$scope <- "meta.separator"
   tomorrowTmTheme$settings[[12]]$settings <- list("background" = "#4271AE", "foreground" = "#FFFFFF")

   tomorrowTmTheme$settings[[13]] <- list()
   tomorrowTmTheme$settings[[13]]$name <- "Deprecated"
   tomorrowTmTheme$settings[[13]]$scope <- "invalid.deprecated"
   tomorrowTmTheme$settings[[13]]$settings <- list("background" = "#8959A8", "fontStyle" = "", "foreground" = "#FFFFFF")

   tomorrowTmTheme$settings[[14]] <- list()
   tomorrowTmTheme$settings[[14]]$name <- "Diff foreground"
   tomorrowTmTheme$settings[[14]]$scope <- "markup.inserted.diff, markup.deleted.diff, meta.diff.header.to-file, meta.diff.header.from-file"
   tomorrowTmTheme$settings[[14]]$settings <- list("foreground" = "#FFFFFF")

   tomorrowTmTheme$settings[[15]] <- list()
   tomorrowTmTheme$settings[[15]]$name <- "Diff insertion"
   tomorrowTmTheme$settings[[15]]$scope <- "markup.inserted.diff, meta.diff.header.to-file"
   tomorrowTmTheme$settings[[15]]$settings <- list("background" = "#718c00")

   tomorrowTmTheme$settings[[16]] <- list()
   tomorrowTmTheme$settings[[16]]$name <- "Diff deletion"
   tomorrowTmTheme$settings[[16]]$scope <- "markup.deleted.diff, meta.diff.header.from-file"
   tomorrowTmTheme$settings[[16]]$settings <- list("background" = "#c82829")

   tomorrowTmTheme$settings[[17]] <- list()
   tomorrowTmTheme$settings[[17]]$name <- "Diff header"
   tomorrowTmTheme$settings[[17]]$scope <- "meta.diff.header.from-file, meta.diff.header.to-file"
   tomorrowTmTheme$settings[[17]]$settings <- list("foreground" = "#FFFFFF", "background" = "#4271ae")

   tomorrowTmTheme$settings[[18]] <- list()
   tomorrowTmTheme$settings[[18]]$name <- "Diff range"
   tomorrowTmTheme$settings[[18]]$scope <- "meta.diff.range"
   tomorrowTmTheme$settings[[18]]$settings <- list("fontStyle" = "italic", "foreground" = "#3e999f")

   tomorrowTmTheme$uuid <- "82CCD69C-F1B1-4529-B39E-780F91F07604"
   tomorrowTmTheme$colorSpaceName <- "sRGB"

   tomorrowConverted <- .rs.convertTmTheme(tomorrowTmTheme)

   # expected results
   expect_true(
      compareCss(
         .rs.parseCss(tomorrowConverted$theme),
         .rs.parseCss(
            readLines(
               file.path(inputFileLocation, "acecss", "tomorrow.css"),
               encoding = "UTF-8")),
         "Theme: Tomorrow"))
   expect_false(tomorrowConverted$isDark)
})

test_that("convertTmTheme works correctly with parseTmTheme", {
   library("xml2")

   .rs.enumerate(themes, function(key, value) {
      # Actual Results
      actualConverted <- .rs.convertTmTheme(
         .rs.parseTmTheme(
            file.path(
               inputFileLocation,
               "tmThemes",
               paste0(key, ".tmTheme"))))

      # Expected Results
      expectedCss <- .rs.parseCss(
         readLines(file.path(inputFileLocation, "acecss", paste0(value$fileName, ".css")),
         encoding = "UTF-8"))

      infoStr <- paste("Theme:", key)
      expect_true(compareCss(.rs.parseCss(actualConverted$theme), expectedCss, infoStr), info = infoStr)
      expect_equal(actualConverted$isDark, value$isDark, info = infoStr)
   })
})

# Test parseKeyElement =============================================================================
test_that("parseKeyElement works correctly", {
   library("xml2")

   # Setup objects for the test cases
   settingsNode <- xml2::read_xml("<key>settings</key>")
   valueNode <- xml2::read_xml("<key>VALUE</key>")
   emptyNode <- xml2::read_xml("<key></key>")
   noTextNode <- xml2::read_xml("<key/>")

   # Test cases
   expect_equal(.rs.parseKeyElement(settingsNode), "settings")
   expect_equal(.rs.parseKeyElement(valueNode), "VALUE")
   expect_error(
      .rs.parseKeyElement(emptyNode),
      "The value of a \"key\" element may not be empty.")
   expect_error(
      .rs.parseKeyElement(noTextNode),
      "The value of a \"key\" element may not be empty.")
})

# Test parseStringElement ==========================================================================
test_that("parseStringElement works correctly", {
   library("xml2")

   # Setup objects for the test cases
   nameNode <- xml2::read_xml("<string>Tomorrow</string>")
   colorNode <- xml2::read_xml("<string>#8e908c</string>")
   emptyNode <- xml2::read_xml("<string></string>")
   noTextNode <- xml2::read_xml("<string/>")

   # Test cases (no errors)
   expect_equal(.rs.parseStringElement(nameNode, "name"), "Tomorrow")
   expect_equal(.rs.parseStringElement(colorNode, "foreground"), "#8e908c")
   expect_equal(.rs.parseStringElement(nameNode, ""), "Tomorrow")
   expect_equal(.rs.parseStringElement(emptyNode, "scope"), "")
   expect_equal(.rs.parseStringElement(emptyNode, "settings"), "")

   # Test cases (errors)
   expect_error(
      .rs.parseStringElement(colorNode, NULL),
      "Unable to find a key for the \"string\" element with value \"#8e908c\".")
})

# Test parseDictElement ============================================================================
test_that("parseDictElement works correctly", {
   library("xml2")

   # Setup input objects for the test cases
   simpleDictEl <- xml2::read_xml(
      "<dict>
         <key>fontStyle</key>
         <string/>
         <key>foreground</key>
         <string>#F5871F</string>
      </dict>")

   simpleDictEl2 <- xml2::read_xml(
      "<dict>
         <key>background</key>
         <string>#FFFFFF</string>
         <key>caret</key>
         <string>#AEAFAD</string>
         <key>foreground</key>
         <string>#4D4D4C</string>
         <key>invisibles</key>
         <string>#D1D1D1</string>
         <key>lineHighlight</key>
         <string>#EFEFEF</string>
         <key>selection</key>
         <string>#D6D6D6</string>
      </dict>")

   badDictEl <- xml2::read_xml(
      "<dict>
         <key>caret</key>
         <string>#AEAFAD</string>
         <string>#FFFFFF</string>
      </dict>")

   badDictEl2 <- xml2::read_xml(
      "<dict>
         <string>#4D4D4C</string>
         <key>caret</key>
         <string>#AEAFAD</string>
      </dict>")

   badDictEl3 <- xml2::read_xml(
      "<dict>
         <key>caret</key>
         <string>#AEAFAD</string>
         <other>#000000</other>
      </dict>")

   badDictEl4 <- xml2::read_xml(
      "<dict>
         <bad>#1D1D1D</bad>
         <key>caret</key>
         <string>#AEAFAD</string>
      </dict>")

   emptyDictEl <- xml2::read_xml("<dict/>")

   recursiveDictEl <- xml2::read_xml(
      "<dict>
         <key>settings</key>
         <dict>
            <key>background</key>
            <string>#FFFFFF</string>
            <key>caret</key>
            <string>#AEAFAD</string>
            <key>foreground</key>
            <string>#4D4D4C</string>
            <key>invisibles</key>
            <string>#D1D1D1</string>
            <key>lineHighlight</key>
            <string>#EFEFEF</string>
            <key>selection</key>
            <string>#D6D6D6</string>
         </dict>
      </dict>")

   recursiveDictEl2 <- xml2::read_xml(
      "<dict>
         <key>name</key>
         <string>Number, Constant, Function Argument, Tag Attribute, Embedded</string>
         <key>scope</key>
         <string>constant.numeric, constant.language, support.constant, constant.character, variable.parameter, punctuation.section.embedded, keyword.other.unit</string>
         <key>settings</key>
         <dict>
            <key>fontStyle</key>
            <string/>
            <key>foreground</key>
            <string>#F5871F</string>
         </dict>
      </dict>")

   # Setup expected objects for the test cases
   simpleExpect <- list()
   simpleExpect[["fontStyle"]] <- ""
   simpleExpect[["foreground"]] <- "#F5871F"

   simpleExpect2 <- list()
   simpleExpect2[["background"]] <- "#FFFFFF"
   simpleExpect2[["caret"]] <-"#AEAFAD"
   simpleExpect2[["foreground"]] <- "#4D4D4C"
   simpleExpect2[["invisibles"]] <- "#D1D1D1"
   simpleExpect2[["lineHighlight"]] <-"#EFEFEF"
   simpleExpect2[["selection"]] <- "#D6D6D6"

   recursiveExpect <- list()
   recursiveExpect[["settings"]] <- simpleExpect2

   recursiveExpect2 <- list()
   recursiveExpect2[["name"]] <- "Number, Constant, Function Argument, Tag Attribute, Embedded"
   recursiveExpect2[["scope"]] <- "constant.numeric, constant.language, support.constant, constant.character, variable.parameter, punctuation.section.embedded, keyword.other.unit"
   recursiveExpect2[["settings"]] <- simpleExpect

   # Test Cases (no error)
   expect_equal(.rs.parseDictElement(simpleDictEl, "settings"), simpleExpect)
   expect_equal(.rs.parseDictElement(simpleDictEl2, "settings"), simpleExpect2)
   expect_equal(.rs.parseDictElement(recursiveDictEl, ""), recursiveExpect)
   expect_equal(.rs.parseDictElement(recursiveDictEl2, "someName"), recursiveExpect2)
   expect_equal(.rs.parseDictElement(emptyDictEl, "settings"), list())

   # Test Cases (errors)
   expect_error(
      .rs.parseDictElement(simpleDictEl, NULL),
      "Unable to find a key for the current \"dict\" element.",
      fixed = TRUE)
   expect_error(
      .rs.parseDictElement(badDictEl, "settings"),
      "Unable to find a key for the \"string\" element with value \"#FFFFFF\".",
      fixed = TRUE)
   expect_error(
      .rs.parseDictElement(badDictEl2, "settings"),
      "Unable to find a key for the \"string\" element with value \"#4D4D4C\".",
      fixed = TRUE)
   expect_error(
      .rs.parseDictElement(badDictEl3, "settings"),
      "Encountered unexpected element as a child of the current \"dict\" element: \"other\". Expected \"key\", \"string\", \"array\", or \"dict\".",
      fixed = TRUE)
   expect_error(
      .rs.parseDictElement(badDictEl4, "settings"),
      "Encountered unexpected element as a child of the current \"dict\" element: \"bad\". Expected \"key\", \"string\", \"array\", or \"dict\".",
      fixed = TRUE)
})

# Test parseArrayElement ===========================================================================
test_that("parseArrayElement works correctly", {
   library("xml2")

   # Setup test case input objects
   emptyArrayEl <- xml2::read_xml("<array/>")
   textArrayEl <- xml2::read_xml("<array>some text</array>")
   badArrayEl <- xml2::read_xml(
      "<array>
         <dict>
            <key>fontStyle</key>
            <string/>
            <key>foreground</key>
            <string>#F5871F</string>
         </dict>
         <bad/>
      </array>")
   badArrayEl2 <- xml2::read_xml(
      "<array>
         <notGood/>
         <dict>
            <key>fontStyle</key>
            <string/>
            <key>foreground</key>
            <string>#F5871F</string>
         </dict>
      </array>")

   arrayEl <- xml2::read_xml(
      "<array>
         <dict>
            <key>settings</key>
            <dict>
               <key>background</key>
               <string>#FFFFFF</string>
               <key>caret</key>
               <string>#AEAFAD</string>
               <key>foreground</key>
               <string>#4D4D4C</string>
               <key>invisibles</key>
               <string>#D1D1D1</string>
               <key>lineHighlight</key>
               <string>#EFEFEF</string>
               <key>selection</key>
               <string>#D6D6D6</string>
            </dict>
         </dict>
         <dict>
            <key>name</key>
            <string>Number, Constant, Function Argument, Tag Attribute, Embedded</string>
            <key>scope</key>
            <string>constant.numeric, constant.language, support.constant, constant.character, variable.parameter, punctuation.section.embedded, keyword.other.unit</string>
            <key>settings</key>
            <dict>
               <key>fontStyle</key>
               <string/>
               <key>foreground</key>
               <string>#F5871F</string>
            </dict>
         </dict>
      </array>")

   # Setup expected output
   arrayExpected <- list()
   arrayExpected[[1]] <- list()
   arrayExpected[[1]][["settings"]] <- list()
   arrayExpected[[1]][["settings"]][["background"]] <- "#FFFFFF"
   arrayExpected[[1]][["settings"]][["caret"]] <- "#AEAFAD"
   arrayExpected[[1]][["settings"]][["foreground"]] <- "#4D4D4C"
   arrayExpected[[1]][["settings"]][["invisibles"]] <- "#D1D1D1"
   arrayExpected[[1]][["settings"]][["lineHighlight"]] <- "#EFEFEF"
   arrayExpected[[1]][["settings"]][["selection"]] <- "#D6D6D6"
   arrayExpected[[2]] <- list()
   arrayExpected[[2]][["name"]] <- "Number, Constant, Function Argument, Tag Attribute, Embedded"
   arrayExpected[[2]][["scope"]] <- "constant.numeric, constant.language, support.constant, constant.character, variable.parameter, punctuation.section.embedded, keyword.other.unit"
   arrayExpected[[2]][["settings"]] <- list()
   arrayExpected[[2]][["settings"]][["fontStyle"]] <- ""
   arrayExpected[[2]][["settings"]][["foreground"]] <- "#F5871F"

   # Test cases (no error)
   expect_equal(.rs.parseArrayElement(arrayEl, "settings"), arrayExpected)

   # Test cases (error)
   expect_error(
      .rs.parseArrayElement(arrayEl, NULL),
      "Unable to find a key for array value.",
      fixed = TRUE)
   expect_error(
      .rs.parseArrayElement(arrayEl, "notSettings"),
      "Incorrect key for array element. Expected: \"settings\"; Actual: \"notSettings\".",
      fixed = TRUE)
   expect_error(
      .rs.parseArrayElement(emptyArrayEl, "settings"),
      "\"array\" element cannot be empty.",
      fixed = TRUE)
   expect_error(
      .rs.parseArrayElement(textArrayEl, "settings"),
      "\"array\" element cannot be empty.",
      fixed = TRUE)
   expect_error(
      .rs.parseArrayElement(badArrayEl, "settings"),
      "Expecting \"dict\" element; found \"bad\".",
      fixed = TRUE)
   expect_error(
      .rs.parseArrayElement(badArrayEl2, "settings"),
      "Expecting \"dict\" element; found \"notGood\".",
      fixed = TRUE)
})

# Test parseTmTheme ================================================================================
test_that("parseTmTheme handles correct input", {
   library("xml2")

   # Setup expected output
   expected <- list()
   expected$comment <- "http://chriskempson.com"
   expected$name <- "Tomorrow"
   expected$settings <- list()

   expected$settings[[1]] <- list()
   expected$settings[[1]]$settings <- list(
      "background" = "#FFFFFF",
      "caret" ="#AEAFAD",
      "foreground" = "#4D4D4C",
      "invisibles" = "#D1D1D1",
      "lineHighlight" = "#EFEFEF",
      "selection" = "#D6D6D6")

   expected$settings[[2]] <- list()
   expected$settings[[2]]$name <- "Comment"
   expected$settings[[2]]$scope <- "comment"
   expected$settings[[2]]$settings <- list("foreground" = "#8E908C")

   expected$settings[[3]] <- list()
   expected$settings[[3]]$name <- "Foreground"
   expected$settings[[3]]$scope <- "keyword.operator.class, constant.other, source.php.embedded.line"
   expected$settings[[3]]$settings <- list()
   expected$settings[[3]]$settings$fontStyle <- ""
   expected$settings[[3]]$settings$foreground <- "#666969"

   expected$settings[[4]] <- list()
   expected$settings[[4]]$name <- "Variable, String Link, Regular Expression, Tag Name, GitGutter deleted"
   expected$settings[[4]]$scope <- "variable, support.other.variable, string.other.link, string.regexp, entity.name.tag, entity.other.attribute-name, meta.tag, declaration.tag, markup.deleted.git_gutter"
   expected$settings[[4]]$settings <- list("foreground" = "#C82829")

   expected$settings[[5]] <- list()
   expected$settings[[5]]$name <- "Number, Constant, Function Argument, Tag Attribute, Embedded"
   expected$settings[[5]]$scope <- "constant.numeric, constant.language, support.constant, constant.character, variable.parameter, punctuation.section.embedded, keyword.other.unit"
   expected$settings[[5]]$settings <- list("fontStyle" = "", "foreground" = "#F5871F")

   expected$settings[[6]] <- list()
   expected$settings[[6]]$name <- "Class, Support"
   expected$settings[[6]]$scope <- "entity.name.class, entity.name.type.class, support.type, support.class"
   expected$settings[[6]]$settings <- list("fontStyle" = "", "foreground" = "#C99E00")

   expected$settings[[7]] <- list()
   expected$settings[[7]]$name <- "String, Symbols, Inherited Class, Markup Heading, GitGutter inserted"
   expected$settings[[7]]$scope <- "string, constant.other.symbol, entity.other.inherited-class, entity.name.filename, markup.heading, markup.inserted.git_gutter"
   expected$settings[[7]]$settings <- list("fontStyle" = "", "foreground" = "#718C00")

   expected$settings[[8]] <- list()
   expected$settings[[8]]$name <- "Operator, Misc"
   expected$settings[[8]]$scope <- "keyword.operator, constant.other.color"
   expected$settings[[8]]$settings <- list("foreground" = "#3E999F")

   expected$settings[[9]] <- list()
   expected$settings[[9]]$name <- "Function, Special Method, Block Level, GitGutter changed"
   expected$settings[[9]]$scope <- "entity.name.function, meta.function-call, support.function, keyword.other.special-method, meta.block-level, markup.changed.git_gutter"
   expected$settings[[9]]$settings <- list("fontStyle" = "", "foreground" = "#4271AE")

   expected$settings[[10]] <- list()
   expected$settings[[10]]$name <- "Keyword, Storage"
   expected$settings[[10]]$scope <- "keyword, storage, storage.type"
   expected$settings[[10]]$settings <- list("fontStyle" = "", "foreground" = "#8959A8")

   expected$settings[[11]] <- list()
   expected$settings[[11]]$name <- "Invalid"
   expected$settings[[11]]$scope <- "invalid"
   expected$settings[[11]]$settings <- list("background" = "#C82829", "fontStyle" = "", "foreground" = "#FFFFFF")

   expected$settings[[12]] <- list()
   expected$settings[[12]]$name <- "Separator"
   expected$settings[[12]]$scope <- "meta.separator"
   expected$settings[[12]]$settings <- list("background" = "#4271AE", "foreground" = "#FFFFFF")

   expected$settings[[13]] <- list()
   expected$settings[[13]]$name <- "Deprecated"
   expected$settings[[13]]$scope <- "invalid.deprecated"
   expected$settings[[13]]$settings <- list("background" = "#8959A8", "fontStyle" = "", "foreground" = "#FFFFFF")

   expected$settings[[14]] <- list()
   expected$settings[[14]]$name <- "Diff foreground"
   expected$settings[[14]]$scope <- "markup.inserted.diff, markup.deleted.diff, meta.diff.header.to-file, meta.diff.header.from-file"
   expected$settings[[14]]$settings <- list("foreground" = "#FFFFFF")

   expected$settings[[15]] <- list()
   expected$settings[[15]]$name <- "Diff insertion"
   expected$settings[[15]]$scope <- "markup.inserted.diff, meta.diff.header.to-file"
   expected$settings[[15]]$settings <- list("background" = "#718c00")

   expected$settings[[16]] <- list()
   expected$settings[[16]]$name <- "Diff deletion"
   expected$settings[[16]]$scope <- "markup.deleted.diff, meta.diff.header.from-file"
   expected$settings[[16]]$settings <- list("background" = "#c82829")

   expected$settings[[17]] <- list()
   expected$settings[[17]]$name <- "Diff header"
   expected$settings[[17]]$scope <- "meta.diff.header.from-file, meta.diff.header.to-file"
   expected$settings[[17]]$settings <- list("foreground" = "#FFFFFF", "background" = "#4271ae")

   expected$settings[[18]] <- list()
   expected$settings[[18]]$name <- "Diff range"
   expected$settings[[18]]$scope <- "meta.diff.range"
   expected$settings[[18]]$settings <- list("fontStyle" = "italic", "foreground" = "#3e999f")

   expected$uuid <- "82CCD69C-F1B1-4529-B39E-780F91F07604"
   expected$colorSpaceName <- "sRGB"

   # Test cases (no error)
   expect_equal(.rs.parseTmTheme(file.path(inputFileLocation, "tmThemes", "Tomorrow.tmTheme")), expected)
})

test_that("parseTmTheme handles incorrect input", {
   library("xml2")

   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "EmptyBody.tmTheme")),
      "Expected 1 non-text child of the root, found: 0",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "EmptyDictEl.tmTheme")),
      "\"dict\" element cannot be empty.",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "ExtraChildAfter.tmTheme")),
      "Expected 1 non-text child of the root, found: 2",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "ExtraChildBefore.tmTheme")),
      "Expected 1 non-text child of the root, found: 2",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "ExtraChildMid.tmTheme")),
      "Expecting \"dict\" element; found \"otherChild\".",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "Malformed1.tmTheme")),
      "error parsing attribute name [68]",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "Malformed2.tmTheme")),
      "Opening and ending tag mismatch: string line 223 and notstring [76]",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "Malformed3.tmTheme")),
      "StartTag: invalid element name [68]",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "Malformed4.tmTheme")),
      "StartTag: invalid element name [68]",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "MissingKeyEnd.tmTheme")),
      "Unable to find a key for the \"string\" element with value \"sRGB\".",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "MissingKeyMid.tmTheme")),
      "Unable to find a key for the \"string\" element with value \"keyword.operator, constant.other.color\".",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "MissingKeyStart.tmTheme")),
      "Unable to find a key for the \"string\" element with value \"http://chriskempson.com\".",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "MissingValueEnd.tmTheme")),
      "Unable to find a value for the key \"colorSpaceName\".",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "MissingValueMid.tmTheme")),
      "Unable to find a value for the key \"settings\".",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "MissingValueStart.tmTheme")),
      "Unable to find a value for the key \"comment\".",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "NoBody.tmTheme")),
      "Expected 1 non-text child of the root, found: 0",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "WrongArrayKey.tmTheme")),
      "Incorrect key for array element. Expected: \"settings\"; Actual: \"notSettings\".",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "WrongTagEnd.tmTheme")),
      "Encountered unexpected element as a child of the current \"dict\" element: \"other\". Expected \"key\", \"string\", \"array\", or \"dict\".",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "WrongTagMid.tmTheme")),
      "Encountered unexpected element as a child of the current \"dict\" element: \"something\". Expected \"key\", \"string\", \"array\", or \"dict\".",
      fixed = TRUE)
   expect_error(
      .rs.parseTmTheme(file.path(inputFileLocation, "errorthemes", "WrongTagStart.tmTheme")),
      "Encountered unexpected element as a child of the current \"dict\" element: \"a-tag\". Expected \"key\", \"string\", \"array\", or \"dict\".",
      fixed = TRUE)
})

# Test convertAceTheme =============================================================================
test_that("convertAceTheme works correctly", {
   .rs.enumerate(themes, function(key, value) {
      inputAceFile <- file.path(inputFileLocation, "acecss", paste0(value$fileName, ".css"))
      expectedResultFile <- file.path(inputFileLocation, "rsthemes", paste0(value$fileName, ".rstheme"))

      expected <- readLines(expectedResultFile, encoding = "UTF-8")
      aceActualLines <- readLines(inputAceFile, encoding = "UTF-8")

      actual <- .rs.convertAceTheme(key, aceActualLines, value$isDark)

      # Check the css values
      infoStr = paste0("Theme: ", key)
      expect_true(compareCss(.rs.parseCss(actual), .rs.parseCss(expected), infoStr), info = infoStr)

      # Check the metadata values
      expect_equal(getRsThemeName(actual), getRsThemeName(expected), fixed = TRUE, info = infoStr)
      expect_equal(getRsIsDark(actual), getRsIsDark(expected), fixed = TRUE, info = infoStr)
   })
})

# Test convertTheme ================================================================================
test_that_wrapped("convertTheme works correctly", {
   .rs.enumerate(themes, function(themeName, themeDesc) {
      name <- .rs.convertTheme(
         file.path(inputFileLocation, "tmThemes", paste0(themeName, ".tmTheme")),
         FALSE,
         tempOutputDir,
         FALSE,
         FALSE,
         FALSE)

      actualCssLines <- readLines(
         file.path(tempOutputDir, paste0(themeName, ".rstheme")),
         encoding = "UTF-8")
      expectedCssLines <- readLines(
         file.path(inputFileLocation, "rsthemes", paste0(themeDesc$fileName, ".rstheme")),
         encoding = "UTF-8")

      infoStr <- paste("Theme:", themeName)
      expect_true(compareCss(.rs.parseCss(actualCssLines), .rs.parseCss(expectedCssLines), infoStr), info = infoStr)

      # Check name values
      expectedName <- getRsThemeName(expectedCssLines)
      expect_equal(name, expectedName, info = infoStr)
      expect_equal(getRsThemeName(actualCssLines), expectedName, info = infoStr)

      # Check dark value
      expect_equal(getRsIsDark(actualCssLines), getRsIsDark(expectedCssLines), info = infoStr)
      expect_equal(getRsIsDark(actualCssLines), themeDesc$isDark, info = infoStr)
   })
},
BEFORE_FUN = function() {
   # Make an output location.
   dir.create(tempOutputDir)
},
AFTER_FUN = function() {
   # Clean up the output location.
   if (unlink(tempOutputDir, recursive = TRUE, force = TRUE) != 0)
   {
      warning("Unable to clean up the actual results in: ", tempOutputDir)
   }
})

test_that_wrapped("convertTheme gives error for file permission issues", {
   expect_error(
      suppressWarnings(.rs.convertTheme(
         file.path(inputFileLocation, "tmThemes", paste0(names(themes)[1], ".tmTheme")),
         FALSE,
         file.path(inputFileLocation, "nopermission"),
         FALSE,
         FALSE,
         FALSE)),
      sprintf(
         "Unable to create the theme file in the requested location: %s. Please see above for relevant warnings.",
         file.path(inputFileLocation, "nopermission", paste0(names(themes)[1], ".rstheme"))),
      fixed = TRUE)
},
BEFORE_FUN = makeNoPermissionDir)

# Test addTheme ====================================================================================
test_that_wrapped("addTheme works correctly with local install", {
   themeName <- names(themes)[4]
   themeDesc <- themes[[themeName]]

   fileName <- paste0(themeDesc$fileName, ".rstheme")
   installPath <- file.path(localInstallDir, fileName)

   if (file.exists(installPath))
   {
      skip(
         paste0(
            "Skipping addTheme(",
            themeName,
            ") because it already exists in the local install location."))
   }

   actualName <- .rs.addTheme(
      file.path(inputFileLocation, "rsthemes", fileName),
      FALSE,
      FALSE,
      FALSE)

   infoStr <- paste("Theme:", themeName)
   expect_equal(actualName, themeName, info = infoStr)
   expect_true(file.exists(installPath), info = infoStr)

   actualLines <- readLines(installPath, encoding = "UTF-8")
   expectedLines <- readLines(file.path(inputFileLocation, "rsthemes", fileName), encoding = "UTF-8")
   expect_equal(actualLines, expectedLines, info = infoStr)
},
BEFORE_FUN = setThemeLocations,
AFTER_FUN = function() {
   unsetThemeLocations()
   if (!all(file.remove(file.path(localInstallDir, dir(localInstallDir)))))
   {
      if (length(dir(localInstallDir)) != 0)
      {
         warning(
            "Unable to remove the following files: \"",
            paste0(
               file.path(localInstallDir, dir(localInstallDir)),
               collapse = "\", \""),
            '\"')
      }
   }
})

test_that_wrapped("addTheme works correctly with global install", {
   themeName <- names(themes)[4]
   themeDesc <- themes[[themeName]]

   fileName <- paste0(themeDesc$fileName, ".rstheme")
   installPath <- file.path(globalInstallDir, fileName)

   if (file.exists(installPath))
   {
      skip(
         paste0(
            "Skipping addTheme(",
            themeName,
            ") because it already exists in the local install location."))
   }

   actualName <- .rs.addTheme(
      file.path(inputFileLocation, "rsthemes", fileName),
      FALSE,
      FALSE,
      TRUE)

   infoStr <- paste("Theme:", themeName)
   expect_equal(actualName, themeName, info = infoStr)
   expect_true(file.exists(installPath), info = infoStr)

   actualLines <- readLines(installPath, encoding = "UTF-8")
   expectedLines <- readLines(file.path(inputFileLocation, "rsthemes", fileName), encoding = "UTF-8")
   expect_equal(actualLines, expectedLines, info = infoStr)

   if (file.exists(installPath))
   {
      if (!file.remove(installPath))
      {
         warning(
            "Unable to remove \"",
            installPath,
            "\" from the system. Please check file system permissions.")
      }
   }
},
BEFORE_FUN = function() {
   setThemeLocations()
   makeGlobalThemeDir()
},
AFTER_FUN = function() {
   unsetThemeLocations()
   if (!all(file.remove(dir(globalInstallDir))))
   {
      if (length(dir(globalInstallDir)) != 0)
      {
         warning(
            "Unable to remove the following files: \"",
            paste0(
               file.path(globalInstallDir, dir(globalInstallDir)),
               collapse = "\", \""),
            '\"')
      }
   }
})

test_that("addTheme gives an error when adding an empty theme", {
   themePath <- file.path(inputFileLocation, "rsthemes", "empty.rstheme")
   expect_error(
      .rs.addTheme(themePath, FALSE, FALSE, FALSE),
      paste0("The theme file is empty."))
})

test_that_wrapped("addTheme gives error when the theme already exists", {
   themePath <- file.path(inputFileLocation, "rsthemes", paste0(themes[[40]]$fileName, ".rstheme"))
   # suppress warning for theme overwrite
   suppressWarnings(
      .rs.addTheme(themePath, FALSE, force=TRUE, globally=FALSE))
   expect_error(
      .rs.addTheme(themePath, FALSE, force=FALSE, globally=FALSE),
      paste0(
         "The specified theme, \"",
         names(themes)[40],
         "\", already exists in the target location. Please delete the existing theme and try again."))
},
BEFORE_FUN = setThemeLocations,
AFTER_FUN = function()
{
   .rs.removeTheme(names(themes)[40], .rs.getThemes())
   unsetThemeLocations()
})

test_that_wrapped("addTheme works correctly with force = TRUE", {
   inputThemePath <- file.path(inputFileLocation, "rsthemes", paste0(themes[[14]]$fileName, ".rstheme"))
   # suppress warning for theme overwrite
   suppressWarnings({
      name <- .rs.addTheme(inputThemePath, FALSE, TRUE, FALSE)})
   exLines <- readLines(inputThemePath, encoding = "UTF-8")

   installedTheme <- .rs.getThemes()[[tolower(name)]]
   acLines <- readLines(.rs.getThemeDirFromUrl(installedTheme$url), encoding = "UTF-8")

   expect_equal(name, names(themes)[14])
   expect_equal(acLines, exLines)
},
BEFORE_FUN = function() {
   setThemeLocations()
   file.create(file.path(localInstallDir, paste0(themes[[14]]$fileName, ".rstheme")))
},
AFTER_FUN = function() {
   .rs.removeTheme(names(themes)[14], .rs.getThemes())
   unsetThemeLocations()
})

test_that_wrapped("addTheme gives error when permission are bad", {
   expect_error(
      suppressWarnings(.rs.addTheme(
         file.path(inputFileLocation, "rsthemes", paste0(themes[[20]]$fileName, ".rstheme")),
         FALSE,
         FALSE,
         FALSE)),
      message = "Unable to create the theme file. Please check file system permissions.",
      FIXED = TRUE)
},
BEFORE_FUN = function() {
   makeNoPermissionDir()
   Sys.setenv(RS_THEME_LOCAL_HOME = noPermissionDir)
},
AFTER_FUN = unsetThemeLocations)

# Test rs_getThemes ================================================================================
test_that_wrapped("rs_getThemes gets default themes correctly", {
   themeList <- .rs.getThemes()
   expect_equal(length(themeList), length(defaultThemes))
   .rs.enumerate(themeList, function(themeName, themeDetails) {
      infoStr <- paste("Theme:", themeDetails$name)
      expect_true(themeDetails$name %in% names(defaultThemes), info = infoStr)
      expect_equal(themeName, tolower(themeDetails$name))

      expectedTheme <- defaultThemes[[themeDetails$name]]
      expect_equal(
         themeDetails$url,
         paste0("theme/default/", expectedTheme$fileName, ".rstheme"),
         info = infoStr)
      expect_equal(themeDetails$isDark, expectedTheme$isDark, info = infoStr)
   })
},
BEFORE_FUN = setThemeLocations,
AFTER_FUN = unsetThemeLocations)

test_that_wrapped("rs_getThemes works correctly", {
   addedThemes <- list()
   .rs.enumerate(themes, function(themeName, themeDesc) {
      fileName <- paste0(themeDesc$fileName, ".rstheme")
      isGlobal <- (sample.int(2, 1) > 1)
      themeLocation <- if (isGlobal) file.path(globalInstallDir, fileName)
                       else file.path(localInstallDir, fileName)
      file.copy(file.path(inputFileLocation, "rsthemes", fileName), themeLocation)
      addedThemes[[themeName]] <<- if (isGlobal) paste0("theme/custom/global/", fileName)
                                   else paste0("theme/custom/local/", fileName)
      })

   themeList <- .rs.getThemes()
   .rs.enumerate(addedThemes, function(themeName, themeLocation)
   {
      infoStr <- paste("Theme:", themeName)
      expect_true(tolower(themeName) %in% names(themeList), info = infoStr)
      expect_equal(themeList[[tolower(themeName)]]$url, themeLocation, info = infoStr)
      expect_equal(themeList[[tolower(themeName)]]$isDark, themes[[themeName]]$isDark, info = infoStr)
   })
},
BEFORE_FUN = function() {
   setThemeLocations()
   makeGlobalThemeDir()
},
AFTER_FUN = function() {
   toRemove <- c(
      file.path(localInstallDir, dir(localInstallDir)),
      file.path(globalInstallDir, dir(globalInstallDir)))
   foundLen <- length(toRemove)
   removed <- file.remove(toRemove)
   for (i in 1:foundLen)
   {
      if (!removed[i])
      {
         warning(
            "Unable to remove ",
            file.path(path.expand(localInstallDir), toRemove[i]),
            call. = FALSE)
      }
   }
})

test_that_wrapped("rs_getThemes location override works correctly", {
   # Nothing installed
   themeName <- "Dawn"
   dawnTheme <- .rs.getThemes()[[tolower(themeName)]]
   expect_equal(
      dawnTheme$url,
      paste0("theme/default/", defaultThemes[[themeName]]$fileName, ".rstheme"),
      info = "default location")

   # Install globally; ignore overwrite warning
   expectedDawn <- themes[[themeName]]
   suppressWarnings(
      .rs.addTheme(
         file.path(inputFileLocation, "rsthemes", paste0(expectedDawn$fileName, ".rstheme")),
         FALSE,
         FALSE,
         TRUE))
   dawnTheme <- .rs.getThemes()[[tolower(themeName)]]
   expect_equal(
      dawnTheme$url,
      paste0("theme/custom/global/", expectedDawn$fileName, ".rstheme"),
      info = "global location")

   # Install locally
   expectedDawn <- themes[[themeName]]
   suppressWarnings(
      .rs.addTheme(
         file.path(inputFileLocation, "rsthemes", paste0(expectedDawn$fileName, ".rstheme")),
         FALSE,
         FALSE,
         FALSE))
   dawnTheme <- .rs.getThemes()[[tolower(themeName)]]
   expect_equal(
      dawnTheme$url,
      paste0("theme/custom/local/", expectedDawn$fileName, ".rstheme"),
      info = "local location")
},
BEFORE_FUN = function() {
   setThemeLocations()
   makeGlobalThemeDir()
},
AFTER_FUN = function() {
   # Remove the theme from the local & global locations.
   .rs.removeTheme(themeName, .rs.getThemes())
   .rs.removeTheme(themeName, .rs.getThemes())
   unsetThemeLocations()
})

# Test removeTheme =================================================================================
test_that_wrapped("removeTheme works correctly locally", {
   .rs.removeTheme(names(themes)[19], .rs.getThemes())
   expect_false(file.exists(file.path(localInstallDir, paste0(themes[[19]]$fileName, ".rstheme"))))
},
BEFORE_FUN = function() {
   setThemeLocations()
   toAdd <- paste0(themes[[19]]$fileName, ".rstheme")
   file.copy(file.path(inputFileLocation, "rsthemes", toAdd), file.path(localInstallDir, toAdd))
},
AFTER_FUN = function() {
   unsetThemeLocations()
   toRemove <- file.path(localInstallDir, paste0(themes[[19]]$fileName, ".rstheme"))
   if (file.exists(toRemove))
   {
      if (!file.remove(toRemove))
      {
         warning("Unable to remove the file ", toRemove)
      }
   }
})

test_that_wrapped("removeTheme works correctly globally", {
   .rs.removeTheme(names(themes)[22], .rs.getThemes())
   expect_false(file.exists(file.path(globalInstallDir, paste0(themes[[22]]$fileName, ".rstheme"))))
},
BEFORE_FUN = function() {
   setThemeLocations()
   makeGlobalThemeDir()
   toAdd <- paste0(themes[[22]]$fileName, ".rstheme")
   file.copy(file.path(inputFileLocation, "rsthemes", toAdd), file.path(globalInstallDir, toAdd))
},
AFTER_FUN = function() {
   unsetThemeLocations()
   toRemove <- file.path(globalInstallDir, paste0(themes[[22]]$fileName, ".rstheme"))
   if (file.exists(toRemove))
   {
      if (!file.remove(toRemove))
      {
         warning("Unable to remove the file ", toRemove)
      }
   }
})

test_that_wrapped("removeTheme gives correct error when unable to remove locally", {
   expect_error(
      suppressWarnings(.rs.removeTheme(names(themes)[5], .rs.getThemes())),
      "Please check your file system permissions.",
      fixed = TRUE)
},
BEFORE_FUN = function() {
   makeNoPermissionDir()
   Sys.setenv(RS_THEME_LOCAL_HOME = noPermissionDir)
   Sys.chmod(noPermissionDir, mode = "0777")
   .rs.addTheme(
      file.path(inputFileLocation, "rsthemes", paste0(themes[[5]]$fileName, ".rstheme")),
      FALSE,
      FALSE,
      FALSE)
   Sys.chmod(noPermissionDir, mode = "0555")
   Sys.chmod(dir(noPermissionDir, full.names = TRUE, all.files = TRUE), mode = "0555")
},
AFTER_FUN = function() {
   unsetThemeLocations()
   Sys.chmod(dir(noPermissionDir, full.names = TRUE, all.files = TRUE), mode = "0777")
   file.remove(file.path(noPermissionDir, paste0(themes[[5]]$fileName, ".rstheme")))
})

test_that_wrapped("removeTheme gives correct error when unable to remove globally", {
   expect_error(
      suppressWarnings(.rs.removeTheme(names(themes)[32], .rs.getThemes())),
      "The specified theme is installed for all users. Please contact your system administrator to remove the theme.",
      fixed = TRUE)
},
BEFORE_FUN = function() {
   makeNoPermissionDir()
   Sys.setenv(RS_THEME_GLOBAL_HOME = noPermissionDir)
   Sys.chmod(noPermissionDir, mode = "0777")
   .rs.addTheme(
      file.path(inputFileLocation, "rsthemes", paste0(themes[[32]]$fileName, ".rstheme")),
      FALSE,
      FALSE,
      TRUE)
   Sys.chmod(dir(noPermissionDir, full.names = TRUE, all.files = TRUE), mode = "0555")
},
AFTER_FUN = function() {
   unsetThemeLocations()
   Sys.chmod(dir(noPermissionDir, full.names = TRUE, all.files = TRUE), mode = "0777")
   file.remove(file.path(noPermissionDir, paste0(themes[[32]]$fileName, ".rstheme")))
})

#
# SourceWithProgress.R
#
# Copyright (C) 2022 by RStudio, PBC
#
# Unless you have received this program directly from RStudio pursuant
# to the terms of a commercial license agreement with RStudio, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

emitProgress <- function(kind, arg, con) {
   if (!is.null(con)) {
      cat(paste0("__rs_progress_0__ ", kind, " __ ", arg, 
                 " __rs_progress_1__\n"), file = con)
   }
}

sourceWithProgress <- function(script,               # path to R script
                               encoding = "unknown", # character encoding of script
                               con = NULL,           # connection to write progress
                               importRdata = NULL,   # RData file to import on start 
                               exportRdata = NULL    # RData file to export when done
                               ) {
   # create a new environment to host any values created; make its parent the global env so any
   # variables inside this function's environment aren't visible to the script
   sourceEnv <- new.env(parent = globalenv())

   # parse the script
   statements <- parse(file = script, keep.source = TRUE, encoding = encoding)
   units <- length(statements)
   unit <- 0

   # add extra steps for importing/exporting
   if (!is.null(importRdata))
      units <- units + 1
   if (!is.null(exportRdata))
      units <- units + 1

   # notify host process of 
   emitProgress("count", units, con)

   if (!is.null(importRdata)) {
      # indicate that we're importing the requested env
      emitProgress("section", "Importing environment", con)
      load(importRdata, envir = globalenv())

      # clear progress text and advance marker
      unit <- unit + 1
      emitProgress("section", "", con)
      emitProgress("statement", unit, con)
   }

   # find the sections
   lines <- readLines(con = script, encoding = encoding, warn = FALSE)
   sections <- regmatches(lines, regexec("^\\s*#+ (.+) -----*$", lines))
   sectLines <- which(sapply(sections, length) > 0)

   # evaluate each statement
   for (idx in seq_along(statements)) {
      # check to see if this is the first statement in a section
      ref <- attr(statements[idx], "srcref", exact = TRUE)
      if (!is.null(ref)) {
         line <- ref[[1]][[1]]

         # look for sections that begin above this line
         candidates <- which(sectLines <= line)

         if (length(candidates) > 0) {
            # find line on which section starts
            line <- sectLines[[length(candidates)]]

            # emit indicator that we've started this section
            emitProgress("section", sections[[line]][[2]], con)

            # remove this from the set of sections so we don't emit again
            sectLines <- sectLines[sectLines != line]
         }
      }
      
      # evaluate the statement
      eval(statements[[idx]], envir = sourceEnv)

      # update progress; statement is complete
      unit <- unit + 1
      emitProgress("statement", unit, con)
   }

   if (!is.null(exportRdata))
   {
      # export any created values
      emitProgress("section", "Exporting environment", con)
      save(list = ls(envir = sourceEnv, all.names = TRUE), 
           file = exportRdata, 
           envir = sourceEnv)

      # update progress
      unit <- unit + 1
      emitProgress("statement", unit, con)
   }

   emitProgress("completed", 1, con)
}

# NOTE: this script may run more than once over the same tree (on Windows,
# install-boost.cmd invokes install-boost.R once per build variant), so every
# replacement below must be idempotent: re-applying it to already-patched
# sources must be a no-op.

# figure out which files to explore
exts <- c("cpp", "h", "hpp", "inc", "inl", "ipp")
pattern <- sprintf("[.](%s)$", paste(exts, collapse = "|"))

# find all the files we might need to modify
files <- list.files(
   path       = c("boost", "libs"),
   pattern    = pattern,
   full.names = TRUE,
   recursive  = TRUE
)

# skip examples
files <- grep("/(examples?)/", files, value = TRUE, invert = TRUE)

for (file in files) {
   
   # read the file as a string
   contents <- readLines(file, warn = FALSE, encoding = "latin1")
   original <- paste(contents, collapse = "\n")
   replacement <- original
   
   # make replacements
   replacement <- gsub(
      pattern     = "namespace[[:space:]]+boost[[:space:]\\\\\\\\]*{",
      replacement = "namespace rstudio_boost {} namespace boost = rstudio_boost; namespace rstudio_boost {",
      x           = replacement,
      perl        = TRUE
   )
   
   # also needed for some macro Boost stuff
   replacement <- gsub(
      pattern     = "(boost)",
      replacement = "(rstudio_boost)",
      x           = replacement,
      fixed       = TRUE
   )
   
   # for nested namespaces
   replacement <- gsub(
      pattern     = "namespace boost::",
      replacement = "namespace rstudio_boost::",
      x           = replacement,
      fixed       = TRUE
   )

   # Boost.Exception (1.91+) parses __PRETTY_FUNCTION__ at compile time by
   # matching string literals that hard-code the 'boost' namespace; after the
   # rename the compiler emits 'rstudio_boost', so no pattern matches and a
   # static assert fires. Patch the literals to match the renamed namespace.
   # (boost/exception/detail/type_info.hpp)
   replacement <- gsub(
      pattern     = "(?<!rstudio_)boost::n::",
      replacement = "rstudio_boost::n::",
      x           = replacement,
      perl        = TRUE
   )
   
   if (!identical(original, replacement)) {
      writeLines(replacement, con = file, useBytes = TRUE)
      writeLines(sprintf("-- Updated \"%s\"", file))
   }
   
}

#
# NotebookPlots.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar("notebooks.defaultPlotDpi", 96)

# creates the notebook graphics device 
.rs.addFunction("createNotebookGraphicsDevice", function(filename,
                                                         width,
                                                         height,
                                                         dpi,
                                                         units,
                                                         pixelRatio,
                                                         extraArgs)
{
   dpi <- if (dpi <= 0) .rs.notebooks.defaultPlotDpi else dpi
   
   if (units == "px") # px = automatic size behavior
   {
      height <- height * pixelRatio
      width <- width * pixelRatio
   }
   dpi <- dpi * pixelRatio

   # form the arguments to the graphics device creator
   args <- list(
      filename = filename,
      height   = height, 
      width    = width,
      units    = units,
      res      = dpi
   )

   if (nchar(extraArgs) > 0)
   {
      # trim leading comma from extra args if present
      if (identical(substr(extraArgs, 1, 1), ","))
         extraArgs <- substring(extraArgs, 2)
      
      # parse extra args and merge with existing args
      extraList <- tryCatch(
         eval(parse(text = paste("list(", extraArgs, ")"))),
         error = function(e) NULL
      )
      
      if (is.list(extraList))
         args <- c(args, extraList)
   }

   gdBackend <- getOption("RStudioGD.backend")
   if (!identical(gdBackend, "default"))
   {
     # pass along graphics device backend if set
     # we allow this option to be temporarily set by the knitr chunk option while the notebook
     # chunk is executing; this takes precedence over the device passed via extraArgs
     args$type <- gdBackend
   }
   
   # if it looks like we're using AGG, delegate to that
   if (identical(args$type, "ragg"))
   {
      device <- ragg::agg_png(
         filename = filename,
         width    = width,
         height   = height,
         units    = units,
         res      = dpi
      )
      
      return(device)
   }
   
   # create the device
   require(grDevices, quietly = TRUE)
   do.call(what = png, args = args)
})

# this seems like it is the only thing manipulated from NotebookPlots.cpp side
# this is where pixelRatio is introduced to the machinery
# it likely originates in RClientMetrics.cpp where it is drawn from
# "r.session.client_metrics.device-pixel-ratio"
.rs.addFunction("setNotebookGraphicsOption", function(filename,
                                                      width,
                                                      height,
                                                      dpi,
                                                      units,
                                                      pixelRatio,
                                                      extraArgs)
{
   options(device = function()
   {
      .rs.createNotebookGraphicsDevice(filename, width, height, dpi, units, pixelRatio, extraArgs)
      dev.control(displaylist = "enable")
      # this introduces margins that makes the figure different from the actual output
      # as seen in the rendered document, so disable it
      # .rs.setNotebookMargins()
   })
})

.rs.addFunction("saveNotebookGraphics", function(plot, filename)
{
   # ensure output directory exists; it may have been moved if the notebook
   # was saved during chunk execution
   # https://github.com/rstudio/rstudio/issues/6260
   dir.create(dirname(filename), recursive = TRUE, showWarnings = FALSE)
   save(plot, file = filename)
})

# this should not be used in my opinion (it is never called with
# the change of setNotebookGraphicsOption above)
.rs.addFunction("setNotebookMargins", function() {
   #           bot  left top  right
   par(mar = c(5.1, 4.1, 2.1, 2.1))
})

.rs.addFunction("replayNotebookPlotsPackages", function()
{
   grid <- asNamespace("grid")
   names <- vapply(grid$.__S3MethodsTable__., function(method) {
      environmentName(environment(method))
   }, FUN.VALUE = character(1))
   sort(unique(names))
})

.rs.addFunction("replayNotebookPlots", function(chunkDefsPath,
                                                width,
                                                height,
                                                pixelRatio,
                                                persistOutput,
                                                extraArgs)
{
   require(grDevices, quietly = TRUE)
   
   # Load any required packages
   requiredPackages <- Sys.getenv("RS_NOTEBOOK_PACKAGES", unset = "")
   requiredPackages <- strsplit(requiredPackages, ",", fixed = TRUE)[[1L]]
   
   suppressPackageStartupMessages({
      for (package in requiredPackages) {
         require(package, character.only = TRUE, quietly = TRUE)
      }
   })
   
   # Read the chunk definitions
   chunkDefs <- jsonlite::read_json(chunkDefsPath)
   
   # Read the chunk ids we'll use for this render
   stdin <- file("stdin")
   chunkIds <- readLines(stdin, warn = FALSE)
   
   for (chunkId in chunkIds) {
      
      chunkDef <- chunkDefs[[chunkId]]
      if (is.null(chunkDef))
         next
      
      snapshots <- chunkDef[["snapshot_files"]]
      if (length(snapshots) == 0)
         next
      
      height <- if (height <= 0) width / 1.618 else height
      dpi <- .rs.nullCoalesce(chunkDef$options$dpi, .rs.notebooks.defaultPlotDpi)
      
      .rs.replayNotebookSnapshots(
         snapshots = snapshots,
         width = width,
         height = height,
         dpi = dpi,
         pixelRatio = pixelRatio,
         persistOutput = persistOutput,
         extraArgs = extraArgs
      )
      
   }
   
})

.rs.addFunction("replayNotebookSnapshots", function(snapshots,
                                                    width,
                                                    height,
                                                    dpi,
                                                    pixelRatio,
                                                    persistOutput,
                                                    extraArgs)
{
   lapply(snapshots, function(snapshot) {
      
      # ignore empty lines
      if (nchar(tools::file_ext(snapshot)) < 1)
         return(invisible(NULL))
      
      # create the PNG device on which we'll regenerate the plot -- it's somewhat
      # wasteful to use a separate device per plot, but the alternative is
      # doing a lot of state management and post-processing of the files
      # output from the device
      output <- paste(
         tools::file_path_sans_ext(snapshot),
         "resized.png",
         sep = "."
      )
      
      .rs.createNotebookGraphicsDevice(
         filename = output,
         width = width,
         height = height,
         dpi = dpi,
         units = "px",
         pixelRatio = pixelRatio,
         extraArgs = extraArgs
      )
      
      # actually replay the plot onto the device
      tryCatch(
         .rs.restoreGraphics(snapshot),
         error = function(err) {
            writeLines(conditionMessage(err), con = stderr())
         }
      )
      
      # close the device; has the side effect of committing the plot to disk
      dev.off()
      
      # if the plot file was written out, emit to standard out for caller
      if (!file.exists(output))
         return(invisible(NULL))
      
      # build output path
      final <- paste(tools::file_path_sans_ext(snapshot), "png", sep = ".")
      if (!persistOutput) {
         
         chunksPath <- dirname(snapshot)
         chunksTempPath <- file.path(chunksPath, "temp")
         
         if (!dir.exists(chunksTempPath))
            dir.create(chunksTempPath)
         
         chunkBaseName <- basename(tools::file_path_sans_ext(snapshot))
         
         final <- file.path(
            chunksTempPath,
            paste(chunkBaseName, "png", sep = ".")
         )
      }
      
      # remove the old copy of the plot if it existed
      file.copy(output, final, overwrite = TRUE)
      unlink(output)
      
      if (file.exists(final))
         writeLines(final)
      
   })
})

# in case we're invoked from the root of the project
if (file.exists("dependencies/windows/install-openssl"))
   setwd("dependencies/windows/install-openssl")

OWD <- getwd()
URL <- "https://www.openssl.org/source/openssl-3.1.4.tar.gz"
NAME <- sub(".tar.gz$", "", basename(URL))

source("../tools.R")
dir.create("logs", showWarnings = FALSE)
options(log.dir = normalizePath("logs", winslash = "/"))

PATH$prepend("../tools")

# download and extract
if (!file.exists(basename(URL))) {
   section("Downloading OpenSSL")
   download.file(URL, destfile = basename(URL))
}

section("Extracting OpenSSL")
unlink(NAME, recursive = TRUE)
untar(basename(URL))

xcopy <- function(src, dst) {
   fmt <- "xcopy %s %s /E /I /Y /S"
   cmd <- sprintf(fmt, src, dst)
   exec("cmd.exe", "/C", shQuote(cmd))
}

section("Building OpenSSL 32bit (Debug)")
TARGET <- sprintf("build-%s-debug-32", NAME)
unlink(TARGET, recursive = TRUE)
xcopy(NAME, TARGET)
setwd(TARGET)
prefix <- file.path(getwd(), "build")
openssldir <- file.path(prefix, "SSL")
OPTS <- paste("no-asm no-shared -DUNICODE -D_UNICODE --prefix=", prefix, " --openssldir=", openssldir, sep = "")
exec("vcvarsall.bat", "x86 && perl Configure debug-VC-WIN32 -d", OPTS)
exec("vcvarsall.bat", "x86 && nmake")
exec("vcvarsall.bat", "x86 && nmake test")
exec("vcvarsall.bat", "x86 && nmake install")
setwd("..")

section("Building OpenSSL 64bit (Debug)")
TARGET <- sprintf("build-%s-debug-64", NAME)
unlink(TARGET, recursive = TRUE)
xcopy(NAME, TARGET)
setwd(TARGET)
prefix <- file.path(getwd(), "build")
openssldir <- file.path(prefix, "SSL")
OPTS <- paste("no-asm no-shared -DUNICODE -D_UNICODE --prefix=", prefix, " --openssldir=", openssldir, sep = "")
exec("vcvarsall.bat", "amd64 && perl Configure debug-VC-WIN64A -d", OPTS)
exec("vcvarsall.bat", "amd64 && nmake")
exec("vcvarsall.bat", "amd64 && nmake test")
exec("vcvarsall.bat", "amd64 && nmake install")
setwd("..")

section("Building OpenSSL 32bit (Release)")
TARGET <- sprintf("build-%s-release-32", NAME)
unlink(TARGET, recursive = TRUE)
xcopy(NAME, TARGET)
setwd(TARGET)
prefix <- file.path(getwd(), "build")
openssldir <- file.path(prefix, "SSL")
OPTS <- paste("no-asm no-shared -DUNICODE -D_UNICODE --prefix=", prefix, " --openssldir=", openssldir, sep = "")
exec("vcvarsall.bat", "x86 && perl Configure VC-WIN32", OPTS)
exec("vcvarsall.bat", "x86 && nmake")
exec("vcvarsall.bat", "x86 && nmake test")
exec("vcvarsall.bat", "x86 && nmake install")
setwd("..")

section("Building OpenSSL 64bit (Release)")
TARGET <- sprintf("build-%s-release-64", NAME)
unlink(TARGET, recursive = TRUE)
xcopy(NAME, TARGET)
setwd(TARGET)
prefix <- file.path(getwd(), "build")
openssldir <- file.path(prefix, "SSL")
OPTS <- paste("no-asm no-shared -DUNICODE -D_UNICODE --prefix=", prefix, " --openssldir=", openssldir, sep = "")
exec("vcvarsall.bat", "amd64 && perl Configure VC-WIN64A", OPTS)
exec("vcvarsall.bat", "amd64 && nmake")
exec("vcvarsall.bat", "amd64 && nmake test")
exec("vcvarsall.bat", "amd64 && nmake install")
setwd("..")

section("Building redistributible")
unlink("dist", recursive = TRUE)
dir.create(file.path("dist", NAME), recursive = TRUE)
dirs <- list.files(pattern = sprintf("^build-%s-", NAME))
lapply(dirs, function(dir) {
   src <- file.path(dir, "build", fsep = "\\")
   dst <- file.path("dist", NAME, sub("^build-", "", dir), fsep = "\\")
   xcopy(src, dst)
   unlink(file.path(dst, "bin"), recursive = TRUE)
   unlink(file.path(dst, "build"), recursive = TRUE)
})

setwd("dist")
zipfile <- sprintf("%s.zip", NAME)
zip(zipfile = zipfile, files = NAME, extras = "-q")

install <- function(name) {
   unlink(file.path(OWD, "..", name), recursive = TRUE)
   file.rename(name, file.path(OWD, "..", name))
}

install(NAME)
install(zipfile)

setwd("..")

#!/usr/bin/env Rscript
#
# generate-prefs.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.


# This script generates RStudio preference and state accessors for the R
# session (C++) and the front end (GWT Java) from JSON schema files. 
#
# To add a preference or state value, do the following:
#
# 1. Add your preference to the schema file (user-prefs-schema.json or user-state-schema.json)
# 2. In a terminal, navigate to this folder (src/gwt/tools)
# 3. Run this script: ./generate-prefs.R
# 4. Commit the .cpp, .hpp, and .java files the script changes

library(here)
library(jsonlite)
library(renv)
library(stringi)

root <- here::here()

writeLines("Generating preferences...")

# Helper to capitalize a string
capitalize <- function(s) {
   paste0(toupper(substring(s, 1, 1)), substring(s, 2))
}

`%||%` <- function(x, y) if (is.null(x)) y else x

# Builds "enum" values in Java (really just named constants)
javaenum <- function(def, pref, type, indent) {
   java <- ""
   # Emit convenient enum constants if supplied
   if (!is.null(def[["enum"]])) {
      for (enumval in def[["enum"]]) {
         # Create syntactically valid variable name
         varname <- toupper(pref)
         valname <- toupper(gsub("[^A-Za-z0-9_]", "_", enumval))
         java <- paste0(java, indent,
            "public final static ", type, " ", varname, "_", 
            valname, " = \"", enumval, "\";\n"
         )
      }
      java <- paste0(java, "\n")
   }
   java
}

# Builds "enum" values in C++ (again, just named constants)
cppenum <- function(def, pref, type, indent) {
   cpp <- ""
   # Emit convenient enum constants if supplied
   if (!is.null(def[["enum"]])) {
      for (enumval in def[["enum"]]) {
         # Create syntactically valid variable name
         varname <- paste0("k", capitalize(pref))
         valname <- gsub("[^A-Za-z0-9_]", "_", enumval)
         valname <- gsub("_(.)", "\\U\\1\\E", valname, perl = TRUE)
         cpp <- paste0(cpp, indent,
            "#define ", varname, capitalize(valname), " \"", enumval, "\"\n")
      }
   }
   cpp
}

# Master function to generate code from JSON schema path
generate <- function(schemaPath, className) {
   
   # Extract prefs from JSON schema
   schema <- jsonlite::read_json(schemaPath)
   prefs <- schema$properties

   javaKeys <- "" # Java string constants for preference names
   java <- ""   # The contents of the Java file we'll be creating
   javaConstants <- ""   # The contents of the Java constants (i18n) file we'll be creating
   javaProperties <- ""  # The contents of the Java properties (i18n) file we'll be creating
   cpp <- ""    # The contents of the C++ file we'll be creating
   hpp <- ""    # The contents of the C++ header file we'll be creating
   r <- ""      # The contents of the R file we'll be creating

   # DEBUG: Text prepended to all i18n outputs (so we can spot which is being displayed, if any)
   prefixDefault <- ""
   prefixProperties <- ""

   # Components
   
   # R starts with copyright header
   r <- renv:::heredoc('
      #
      # SessionUserPrefValues.R
      #
      # Copyright (C) 2025 by Posit Software, PBC
      #
      # Unless you have received this program directly from Posit Software pursuant
      # to the terms of a commercial license agreement with Posit Software, then
      # this program is licensed to you under the terms of version 3 of the
      # GNU Affero General Public License. This program is distributed WITHOUT
      # ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
      # MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
      # AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
      #
      
      #
      # This file was automatically generated -- please do not modify it by hand.
      #
      
      .rs.setVar("uiPrefs", new.env(parent = emptyenv()))
   ')

   # A list in C++ of all preference keys, as a function
   cpplist <- paste0("std::vector<std::string> ", className, "::allKeys()\n{\n",
                     "   return std::vector<std::string>({\n")

   # A list in C++ of local project preference keys (local: true)
   cppLocalProjectPrefs <- paste0("std::set<std::string> ", className, "::localProjectPrefs()\n{\n",
                                  "   return std::set<std::string>({\n")

   # A Java function that syncs every pref
   javasync <- "   public void syncPrefs(String layer, JsObject source)\n   {\n"

   # A Java function that lists every pref
   javalist <- paste0("   public List<PrefValue<?>> allPrefs()\n   {\n",
               "      ArrayList<PrefValue<?>> prefs = new ArrayList<PrefValue<?>>();\n");
   
   # C++ string constants for preference names
   cppstrings <- ""
   
   for (pref in names(prefs)) {
      
      # Convert the preference name from camel case to snake case
      camel <- gsub("_(.)", "\\U\\1\\E", pref, perl = TRUE)
      def <- prefs[[pref]]

      # Prefs with enumReadable values must have valid enum entry of equal length
      if (!is.null(def[["enumReadable"]]) &&
          (is.null(def[["enum"]]) || length(def[["enumReadable"]]) != length(def[["enum"]]))) {

         warningMsg <- sprintf("\nPreference \"%s\" does not have [[enum]] and [[enumReadable]] of equal length and will be skipped (not generated)", pref)
         cat(warningMsg)
         next
      }
      
      # Convert JSON schema type to corresponding Java type
      type <- def[["type"]]
      if (type == "object") {
         # Rich objects are converted to JavaScript native types
         type <- capitalize(camel) 
      } else if (type == "numeric" || type == "number") {
         # Numerics (not integers) become Double objects
         type <- "Double"
      } else if (type == "array") {
         # Arrays are presumed to be arrays of strings (we do not currently support
         # other types)
         type <- "JsArrayString"
      } else {
         # For all other types, we uppercase the type name to get a class name
         type <- capitalize(type)
      }
      
      # Map JSON schema types to Java and C++ data types
      preftype <- def[["type"]]
      if (identical(preftype, "boolean")) {
         preftype <- "bool"
         cpptype <- "bool"
      } else if (identical(preftype, "numeric") || identical(preftype, "number")) {
         preftype <- "dbl"
         cpptype <- "double"
      } else if (identical(preftype, "array")) {
         preftype <- "object"
         cpptype <- "core::json::Array"
      } else if (identical(preftype, "integer")) {
         preftype <- "integer"
         cpptype <- "int"
      } else if (identical(preftype, "string")) {
         preftype <- if (!is.null(def[["enum"]])) "enumeration" else "string"
         cpptype <- "std::string"
      } else if (identical(preftype, "object")) {
         preftype <- "object"
         cpptype <- "core::json::Object"
      }
      
      # Format the default value for the preference
      defaultval <- as.character(def[["default"]])
      if (identical(def[["type"]], "string")) {
         # Quote string defaults
         defaultval <- paste0("\"", defaultval, "\"")
      } else if (identical(def[["type"]], "boolean")) {
         # Convert Booleans from R-style (TRUE, FALSE) to Java style (true, false)
         defaultval <- tolower(defaultval)
      } else if (identical(def[["type"]], "numeric") || 
                 identical(def[["type"]], "number")) {
         # Ensure floating point numbers have a decimal
         if (!grepl(".", defaultval, fixed = TRUE)) {
            defaultval <- paste0(defaultval, ".0")
         }
      } else if (identical(def[["type"]], "array")) {
         # We currently only support string arrays
         defaultval <- sapply(defaultval, function(d) { 
            paste0("\"", d, "\"")}
         )
         defaultval <- paste0("JsArrayUtil.createStringArray(", paste(defaultval, collapse = ", "), ")")
      } else if (identical(def[["type"]], "object")) {
         # No current mechanism for construction default objects
         defaultval <- "null"
      }
      
      # Define a C++ string constant for this preference name
      cppstrings <- paste0(cppstrings,
                           "#define k", capitalize(camel), " \"", pref, "\"\n")
      cppstrings <- paste0(cppstrings, cppenum(def, camel, type, ""))
      cpplist <- paste0(cpplist, "      k", capitalize(camel), ",\n")

      # Track local project preferences (local: true)
      if (identical(def[["local"]], TRUE)) {
         cppLocalProjectPrefs <- paste0(cppLocalProjectPrefs,
            "      k", capitalize(camel), ",\n")
      }

      # Add Java string constant for preference name
      line <- paste0(
         "   public static final String ", toupper(pref), " = \"", pref, "\";")
      if (grepl("(api_key|secret|token|password)", pref, ignore.case = TRUE))
         line <- paste0(line, " // pragma: allowlist secret")
      javaKeys <- paste0(javaKeys, line, "\n")

      # Create a Java (and C++) comment header for the preference
      comment <- paste0(
         "   /**\n",
         "    * ", def[["description"]], "\n",
         "    */\n")

      # Create a Java/GWT Properties file header for the preference
      commentProperties <- paste0(
         "# ", def[["description"]], "\n")

      # Add title and description entries for the java constants file
      prefTitle <- if (is.null(def[["title"]])) "" else def[["title"]]
      javaConstants <- paste0(javaConstants,
         comment,
         "   @DefaultStringValue(\"", prefixDefault, prefTitle, "\")\n",
         "   String ", camel, "Title", "();\n",
         "   @DefaultStringValue(\"", prefixDefault, def[["description"]], "\")\n",
         "   String ", camel, "Description", "();\n")

      if (!is.null(def[["enumReadable"]]))
      {
         javaConstants <- paste0(javaConstants,
                                 paste0(mapply(function (enumVal, enumReadable) {
                                    paste0(
                                       "   @DefaultStringValue(\"", prefixDefault, enumReadable, "\")\n",
                                       "   String ", camel, "Enum_", gsub("[^A-Za-z0-9_]", "_", enumVal), "();"
                                    )
                                 }, def[["enum"]], def[["enumReadable"]]), collapse = "\n"
                                 ), "\n"
         )
      }

      javaConstants <- paste0(javaConstants, "\n")

      # Add title and description entries for the java properties file
      javaProperties <- paste0(javaProperties,
         commentProperties,
         camel, "Title = ", prefixProperties, prefTitle, "\n",
         camel, "Description = ", prefixProperties, def[["description"]], "\n")

      if (!is.null(def[["enumReadable"]]))
      {
         javaProperties <- paste0(javaProperties,
                                  paste0(mapply(function (enumVal, enumReadable) {
                                     paste0(
                                        camel, "Enum_", gsub("[^A-Za-z0-9_]", "_", enumVal), "=", prefixProperties, enumReadable
                                     )
                                  }, def[["enum"]], def[["enumReadable"]]), collapse = "\n"
                                  ), "\n"
         )
      }

      javaProperties <- paste0(javaProperties, "\n")

      prefTitle <- paste0("_constants.", camel, "Title()")
      prefDescription <- paste0("_constants.", camel, "Description()")
      java <- paste0(java,
         comment,
         "   public PrefValue<", type, "> ", camel, "()\n",
         "   {\n",
         "      return ", preftype, "(\n         \"", pref, "\",\n",
                       "         ", prefTitle, ", \n",
                       "         ", prefDescription, ", \n")
      if (!is.null(def[["enum"]]))
      {
         java <- paste0(java, "         new String[] {\n",
                        paste(lapply(def[["enum"]], function(enumval) {
                           toupper(paste0("            ",
                                          pref,
                                          "_",
                                          gsub("[^A-Za-z0-9_]", "_", enumval)))
                        }), collapse = ",\n"),
                        "\n         },\n")
      }
      java <- paste0(java, 
                       "         ", defaultval)
      if (!is.null(def[["enumReadable"]]))
      {
         java <- paste0(java, ",\n", "         new String[] {\n",
                        paste(lapply(def[["enum"]], function(enumval) {
                           paste0("            _constants.", camel, "Enum_", gsub("[^A-Za-z0-9_]", "_", enumval), "()")
                        }), collapse = ",\n"),
                        "\n         }")
      }
      java <- paste0(java, ");\n   }\n\n")
      synctype <- if (identical(preftype, "enumeration")) "String" else capitalize(preftype)
      javasync <- paste0(javasync,
         "      if (source.hasKey(\"", pref, "\"))\n",
         "         ", camel, "().setValue(layer, source.get", synctype, "(\"", 
                pref, "\"));\n")
      javalist <- paste0(javalist,
         "      prefs.add(", camel, "());\n")

      
      # Add C++ header and implementation accessors for the preferences
      hpp <- paste0(hpp, comment,
                    "   ", cpptype, " ", camel, "();\n")
      hpp <- paste0(hpp,
                    "   core::Error set", capitalize(camel), "(", cpptype, " val);\n\n")

      # Check for fallback preference (for backwards compatibility)
      fallback <- def[["fallback"]]
      readPrefCall <- if (!is.null(fallback)) {
         paste0("   return readPref<", cpptype, ">(\"", pref, "\", \"", fallback, "\");\n")
      } else {
         paste0("   return readPref<", cpptype, ">(\"", pref, "\");\n")
      }

      cpp <- paste0(cpp,
         "/**\n",
         " * ", def[["description"]], "\n",
         " */\n",
         cpptype, " ", className, "::", camel, "()\n",
         "{\n",
         readPrefCall,
         "}\n\n",
         "core::Error ", className, "::set", capitalize(camel), "(", cpptype, " val)\n",
         "{\n",
         "   return writePref(\"", pref, "\", val);\n",
         "}\n\n")
      
      # Emit JSNI for object types
      if (identical(def[["type"]], "object")) {
         java <- paste0(java,
            "   public static class ", type, " extends JavaScriptObject\n",
            "   {\n",
            "      protected ", type, "() {} \n\n")
         props <- def[["properties"]]
         for (prop in names(props)) {
            
            propdef <- props[[prop]]
            propname <- gsub("(^|_)(.)", "\\U\\2\\E", prop, perl = TRUE)
            proptype <- propdef[["type"]]
            
            default <- propdef[["default"]] %||% def[["default"]][[prop]]
            if (!is.null(default))
               default <- paste(" ||", jsonlite::toJSON(default, auto_unbox = TRUE))
            
            if (identical(proptype, "object")) {
               proptype <- "JavaScriptObject"
            } else if (identical(proptype, "array")) {
               proptype <- "JsArrayString"
               default <- default %||% " || []"
               if (!is.null(propdef[["items"]])) {
                  enumtype <- capitalize(propdef[["items"]][["type"]])
                  java <- paste0(java, javaenum(propdef[["items"]], propname, 
                                                enumtype, "      "))
               }
            } else if (identical(proptype, "string")) {
               proptype <- "String"
               default <- default %||% " || \"\""
            } else if (identical(proptype, "integer")) {
               proptype <- "int"
               default <- default %||% " || 0"
            } else if (identical(proptype, "number")) {
               proptype <- "double"
               default <- default %||% " || 0"
            } else if (identical(proptype, "boolean")) {
               default <- default %||% " || false"
            } else {
               default <- ""
            }
            
            java <- paste0(java,
              "      public final native ", proptype, " get",  propname, "() /*-{\n",
              "         return this && this.", prop, default, ";\n",
              "      }-*/;\n\n")
            cppstrings <- paste0(cppstrings,
                                 "#define k", capitalize(camel), propname, " \"", prop, "\"\n")
         }
         java <- paste0(java, "   }\n\n")
      }
      
      # Add enums if present
      java <- paste0(java, javaenum(def, pref, type, "   "))
      
      # generate code for R wrapper
      fmt <- renv:::heredoc('
         %s
         #
         %s
         .rs.uiPrefs$%s <- list(
            get = function() { .rs.getUserPref("%s") },
            set = function(value) { .rs.setUserPref("%s", value) },
            clear = function() { .rs.clearUserPref("%s") }
         )
      ')
      
      rtitle <- paste(paste("#", strwrap(def$title, width = 80)), collapse = "\n")
      rdesc <- paste(paste("#", strwrap(def$description, width = 80)), collapse = "\n")
      rcode <- sprintf(fmt, rtitle, rdesc, camel, pref, pref, pref)
      r <- paste(r, rcode, sep = "\n\n")
   }
   
   # Close off blocks and lists
   cpplist <- paste0(cpplist, "   });\n}\n")
   cppLocalProjectPrefs <- paste0(cppLocalProjectPrefs, "   });\n}\n")
   cpp <- paste0(cpp, cpplist, "\n", cppLocalProjectPrefs)
   hpp <- paste0(cppstrings, "\n",
                 "class ", className, ": public Preferences\n",
                 "{\n",
                 "public:\n",
                 "   static std::vector<std::string> allKeys();\n",
                 "   static std::set<std::string> localProjectPrefs();\n",
                 hpp,
                 "};\n")
   javasync <- paste0(javasync, "   }\n")
   java <- paste0(javaKeys, "\n", java, javasync)
   javalist <- paste0(javalist, "      return prefs;\n   }\n")
   java <- paste0(java, javalist)
   
   # Return computed Java and C++ code
   list(
      java = java,
      javaConstants = javaConstants,
      javaProperties = javaProperties,
      cpp = cpp,
      hpp = hpp,
      r = r
   )
}

# Generate preferences
setwd(root)

result <- generate("src/cpp/session/resources/schema/user-prefs-schema.json", "UserPrefValues")

template <- readLines("src/gwt/tools/prefs/UserPrefsAccessor.java")
writeLines(gsub("%PREFS%", result$java, template), 
           con = "src/gwt/src/org/rstudio/studio/client/workbench/prefs/model/UserPrefsAccessor.java")

template <- readLines("src/gwt/tools/prefs/UserPrefsAccessorConstants.java")
writeLines(gsub("%PREFS%", result$javaConstants, template),
           con = "src/gwt/src/org/rstudio/studio/client/workbench/prefs/model/UserPrefsAccessorConstants.java")

template <- readLines("src/gwt/tools/prefs/UserPrefsAccessorConstants_en.properties")
writeLines(gsub("%PREFS%", result$javaProperties, template),
           con = "src/gwt/src/org/rstudio/studio/client/workbench/prefs/model/UserPrefsAccessorConstants_en.properties")

template <- readLines("src/gwt/tools/prefs/UserPrefValues.hpp")
writeLines(gsub("%PREFS%", result$hpp, template), 
           con = "src/cpp/session/include/session/prefs/UserPrefValues.hpp")

template <- readLines("src/gwt/tools/prefs/UserPrefValues.cpp")
writeLines(gsub("%PREFS%", result$cpp, template), 
           con = "src/cpp/session/prefs/UserPrefValues.cpp")

writeLines(result$r, con = "src/cpp/session/modules/SessionUserPrefValues.R")

# Generate state
result <- generate("src/cpp/session/resources/schema/user-state-schema.json", "UserStateValues")

javaTemplate <- readLines("src/gwt/tools/prefs/UserStateAccessor.java")
writeLines(gsub("%STATE%", result$java, javaTemplate), 
           con = "src/gwt/src/org/rstudio/studio/client/workbench/prefs/model/UserStateAccessor.java")

javaTemplate <- readLines("src/gwt/tools/prefs/UserStateAccessorConstants.java")
writeLines(gsub("%STATE%", result$javaConstants, javaTemplate),
           con = "src/gwt/src/org/rstudio/studio/client/workbench/prefs/model/UserStateAccessorConstants.java")

javaTemplate <- readLines("src/gwt/tools/prefs/UserStateAccessorConstants_en.properties")
writeLines(gsub("%STATE%", result$javaProperties, javaTemplate),
           con = "src/gwt/src/org/rstudio/studio/client/workbench/prefs/model/UserStateAccessorConstants_en.properties")

template <- readLines("src/gwt/tools/prefs/UserStateValues.hpp")
writeLines(gsub("%STATE%", result$hpp, template), 
           con = "src/cpp/session/include/session/prefs/UserStateValues.hpp")

template <- readLines("src/gwt/tools/prefs/UserStateValues.cpp")
writeLines(gsub("%STATE%", result$cpp, template), 
           con = "src/cpp/session/prefs/UserStateValues.cpp")

writeLines("Preference generation complete.")

#
# SessionPackageProvidedExtension.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("ppe.invokeHook", function(hook, data)
{
   # Treat single function as list of functions
   if (is.function(hook))
      hook <- list(hook)
   
   # Disable warnings in this scope
   op <- options(warn = -1L)
   on.exit(options(op), add = TRUE)
   
   # Invoke hooks
   lapply(hook, .rs.ppe.invokeHookImpl, data = data)
})

.rs.addFunction("ppe.invokeHookImpl", function(hook, data)
{
   status <- tryCatch(do.call(hook, data), error = identity)
   if (inherits(status, "error"))
      warning(conditionMessage(status))
})

#
# https://github.com/rstudio/rstudio/issues/10664
#
# Make sure that you can still step through the function
# even after evaluating some of the variables during the
# debug session.
#
# Install the package with:
#
# install.packages("slider", type = "source", INSTALL_opts = "--with-keep.source")
#

library(slider)
debugonce(slider:::slide_impl)
slide_dbl(1:5, identity)

#
# SessionSystemResources.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("getRMemoryUsed", function()
{
   # Perform a garbage collection to collect memory statistics
   mem_used <- gc()

   # A cons cell is 28 bytes on a 32 bit R and 56 on 64 bit (see ?gc)
   cons_size <- .Machine$sizeof.pointer * 7
   cons_kb <- (mem_used["Ncells", "used"] * cons_size) / 1024

   # Vector cells are always 8 bytes (see ?gc)
   vector_kb <- mem_used["Vcells", "used"] / 128

   # Return stats
   list(
      cons = .rs.scalar(round(cons_kb)),
      vector = .rs.scalar(round(vector_kb))
   )
})

#
# Try debugging this file with:
# - First, source() this file, then run foo().
# - Try executing code via Cmd + Enter, then run foo().
#

bar <- function()
{
   browser()
   { 1 + 1; 2 +
         2}
   1 + 1
   3 + 3
}

foo <- function() {
   withCallingHandlers({
      tryCatch({
         identity({
            eval({
               bar()
               2 + 2
            })
         })
      })
   })
}

#
# test-dependencies.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("dependencies")

test_that("simple topological sort works", {
   # unsorted nodes
   nodes <- c("b", "a", "c")

   # edges a -> b -> c
   edges <- list(
      list(from = "a", to = "b"),
      list(from = "b", to = "c"))
   
   # in this configuration we'd expect to install package c, then package b, then package a
   expect_equal(.rs.topoSortPackages(nodes, edges), 
                c("c", "b", "a"))
})

test_that("simple expansion and sorting is done correctly", {
   # simulation of available.packages for a simple set of packages, foo -> bar -> baz
   available <- rbind(
         # Pkg    # Ver  # Depends                  # Imports   # LinkingTo
         c("foo", "1.0", "R (>= 3.2), bar (>= 1.1)", NA,        NA),
         c("bar", "1.1", NA,                         "baz",     NA),
         c("baz", "2.0", NA,                         NA,        NA))
   colnames(available) <- c("Package", "Version", "Depends", "Imports", "LinkingTo") 
   rownames(available) <- available[,1]

   # simulation of the dependencies we want to install; just one package
   dependencies <- list(list(
         name     = "foo",
         location = "cran",
         version  = "1.0",
         source   = FALSE))

   result <- .rs.expandDependencies(available, data.frame(), dependencies)

   expect_equal(!!result, list(
         list(name     = "bar",
              location = "cran",
              version  = "1.1",
              source   = FALSE),
         list(name     = "foo",
              location = "cran",
              version  = "1.0",
              source   = FALSE)))
})


test_that("dependencies already installed are not installed again", {

   # simulation of available.packages for a simple set of packages, foo -> bar -> baz
   available <- rbind(
         # Pkg    # Ver  # Depends                  # Imports   # LinkingTo
         c("foo", "1.0", "R (>= 3.2), bar (>= 1.1)", NA,        NA),
         c("bar", "1.1", NA,                         "baz",     NA),
         c("baz", "2.0", NA,                         NA,        NA))
   colnames(available) <- c("Package", "Version", "Depends", "Imports", "LinkingTo") 
   rownames(available) <- available[,1]

   # simulation of installed.packages
   installed <- data.frame(
         Package   = c("baz"),
         Version   = c("2.0"),
         Depends   = c("NA"),
         Imports   = c("NA"),
         LinkingTo = c("NA"),
         stringsAsFactors = FALSE)
   rownames(installed) <- installed[[1]]

   # simulation of the dependencies we want to install; just one package
   dependencies <- list(list(
         name     = "bar",
         location = "cran",
         version  = "1.1",
         source   = FALSE))

   # if the baz package is not installed, we should install it
   result <- .rs.expandDependencies(available, data.frame(), dependencies)

   expect_equal(!!result, list(
         list(name     = "baz",
              location = "cran",
              version  = "2.0",
              source   = FALSE),
         list(name     = "bar",
              location = "cran",
              version  = "1.1",
              source   = FALSE)))

   # if it is installed already, we should not install it
   result <- .rs.expandDependencies(available, installed, dependencies)

   expect_equal(!!result, list(
         list(name     = "bar",
              location = "cran",
              version  = "1.1",
              source   = FALSE)))
})

test_that("dependencies are replaced when too old", {
   # simulation of available.packages for a simple set of packages, foo -> bar -> baz
   available <- rbind(
         # Pkg    # Ver  # Depends                  # Imports   # LinkingTo
         c("foo", "1.0", "R (>= 3.2), bar (>= 1.1)", NA,        NA),
         c("bar", "1.1", NA,                         "baz",     NA),
         c("baz", "2.0", NA,                         NA,        NA))
   colnames(available) <- c("Package", "Version", "Depends", "Imports", "LinkingTo") 
   rownames(available) <- available[,1]

   # simulation of installed.packages; bar is installed but is an older version
   installed <- rbind(
         # Pkg    # Ver  # Depends                  # Imports   # LinkingTo
         c("bar", "1.0", NA,                         "baz",     NA))
   colnames(installed) <- c("Package", "Version", "Depends", "Imports", "LinkingTo") 
   rownames(installed) <- installed[,1]

   # simulation of the dependencies we want to install; just one package
   dependencies <- list(list(
         name     = "foo",
         location = "cran",
         version  = "1.0",
         source   = FALSE))

   result <- .rs.expandDependencies(available, installed, dependencies)

   # even though the 'bar' package is installed, it needs to be reinstalled since we need 1.1 and
   # have 1.0 installed
   expect_equal(!!result, list(
         list(name     = "bar",
              location = "cran",
              version  = "1.1",
              source   = FALSE),
         list(name     = "foo",
              location = "cran",
              version  = "1.0",
              source   = FALSE)))
})


test_that("dependencies are installed only once", {
   # simulation of available.packages; toast for breakfast and lunch
   available <- rbind(
         # Pkg          # Ver  # Depends                    # Imports   # LinkingTo
         c("breakfast", "1.0", "toast",                     NA,         NA),
         c("lunch",     "1.1", "breakfast, toast (>= 1.0)", NA,         NA),
         c("toast",     "2.0", NA,                          NA,         NA))
   colnames(available) <- c("Package", "Version", "Depends", "Imports", "LinkingTo") 
   rownames(available) <- available[,1]

   # simulation of the dependencies we want to install -- breakfast and lunch
   dependencies <- list(list(
         name     = "breakfast",
         location = "cran",
         version  = "1.0",
         source   = FALSE),
      list(
         name     = "lunch",
         location = "cran",
         version  = "1.1",
         source   = FALSE))

   result <- .rs.expandDependencies(available, data.frame(), dependencies)

   # this will require us to install breakfast, lunch, and toast -- but only once each!
   expect_equal(!!result, list(
         list(name     = "toast",
              location = "cran",
              version  = "2.0",
              source   = FALSE),
         list(name     = "breakfast",
              location = "cran",
              version  = "1.0",
              source   = FALSE),
         list(name     = "lunch",
              location = "cran",
              version  = "1.1",
              source   = FALSE)))
})

#
# NotebookHtmlWidgets.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("recordHtmlWidget", function(x, htmlfile, depfile)
{
   .Call("rs_recordHtmlWidget", htmlfile, depfile, list(
      classes = class(x),
      sizingPolicy = if (is.list(x)) x$sizingPolicy else list()
   ))
})

.rs.addFunction("rnb.setHtmlCaptureContext", function(...)
{
   .rs.setVar("rnb.htmlCaptureContext", list(...))
})

.rs.addFunction("rnb.getHtmlCaptureContext", function()
{
   .rs.getVar("rnb.htmlCaptureContext")
})

# Hooks ----

.rs.addFunction("rnb.saveHtmlToCache", function(x, ...)
{
   ctx <- .rs.rnb.getHtmlCaptureContext()
   
   # tempfile paths for html resources
   htmlfile <- tempfile("_rs_html_", tmpdir = ctx$outputFolder, fileext = ".html")
   depfile <- tempfile("_rs_html_deps_", tmpdir = ctx$outputFolder, fileext = ".json")
   
   # render html tags (to discover recursive dependencies + get html)
   rendered <- htmltools::renderTags(x)
   htmldeps <- rendered$dependencies
   html <- rendered$html
   
   if (length(htmldeps)) {
      # if we have html dependencies, write those to file and use 'save_html'
      cat(.rs.toJSON(htmldeps, unbox = TRUE), file = depfile, sep = "\n")
      htmltools::save_html(x, file = htmlfile, libdir = ctx$libraryFolder)
   } else {
      # otherwise, just write html to file as-is
      cat(as.character(html), file = htmlfile, sep = "\n")
   }
   
   # record the generated artefacts
   .rs.recordHtmlWidget(x, htmlfile, depfile)
})

.rs.addFunction("rnbHooks.print.html",           .rs.rnb.saveHtmlToCache)
.rs.addFunction("rnbHooks.print.shiny.tag",      .rs.rnb.saveHtmlToCache)
.rs.addFunction("rnbHooks.print.shiny.tag.list", .rs.rnb.saveHtmlToCache)

.rs.addFunction("rnbHooks.print.knit_asis", function(x, ...) 
{
   ctx <- .rs.rnb.getHtmlCaptureContext()

   # create temporary file paths
   mdfile   <- tempfile("_rs_md_", fileext = ".md")
   htmlfile <- tempfile("_rs_html_", tmpdir = ctx$outputFolder, 
                        fileext = ".html")

   # save contents to temporary file
   writeLines(enc2utf8(x), con = mdfile, useBytes = TRUE)
   
   # render to HTML with pandoc
   rmarkdown::pandoc_convert(input = rmarkdown::pandoc_path_arg(mdfile), 
                             to = "html",
                             output = rmarkdown::pandoc_path_arg(htmlfile))

   # record in cache
   .rs.recordHtmlWidget(x, htmlfile, NULL)
})

.rs.addFunction("rnbHooks.print.knit_image_paths", function(x, ...) 
{
   .Call("rs_recordExternalPlot", vapply(x, function(path) {
      dest <- tempfile(fileext = paste(".", tools::file_ext(path), sep = ""))
      if (identical(substr(path, 1, 7), "http://") ||
          identical(substr(path, 1, 8), "https://")) {
         # if the path appears to be a URL, download it locally 
         tryCatch({
            suppressMessages(download.file(path, dest, quiet = TRUE))
         },
         error = function(e) {})
      } else {
         # not a URL, presume it to be an ordinary path on disk
         file.copy(path, dest, copy.mode = FALSE)
      }
      dest
   }, ""))
})

.rs.addFunction("rnbHooks.print.htmlwidget", function(x, ...) {
   ctx <- .rs.rnb.getHtmlCaptureContext()
   
   outputFolder  <- ctx$outputFolder
   chunkOptions  <- ctx$chunkOptions
   libraryFolder <- ctx$libraryFolder
   
   if (!requireNamespace("htmlwidgets", quietly = TRUE))
      stop("print.htmlwidget called without 'htmlwidgets' available")
   
   htmlfile <- tempfile(pattern = "_rs_html_",
                        tmpdir = outputFolder, 
                        fileext = ".html")
   
   # extract dependencies (for our own accounting)
   dependencies <- c(
      htmlwidgets:::widget_dependencies(class(x)[1], attr(x, "package")), 
      x$dependencies
   )
   
   # write them to JSON 
   depfile <- tempfile(pattern = "_rs_html_deps_",
                       tmpdir = outputFolder,
                       fileext = ".json")
   
   cat(.rs.toJSON(dependencies, unbox = TRUE), file = depfile, sep = "\n")
   
   # force a responsive viewer sizing policy
   x$sizingPolicy$viewer.padding <- 0
   x$sizingPolicy$viewer.fill <- TRUE

   # make width dynamic to size correctly non-figured
   if (!is.null(x$sizingPolicy$knitr) && identical(x$sizingPolicy$knitr$figure, FALSE)) {
      x$sizingPolicy$defaultWidth <- "auto"
      x$sizingPolicy$browser$fill <- FALSE
   }
   
   # collect knitr options
   knitrOptions <- knitr::opts_current$get()
   `%||%` <- function(x, y) if (length(x)) x else y
   
   defaultDpi <- 96
   defaultFigWidth  <- 7
   defaultFigHeight <- 5
   
   # detect if the default knitr chunk fig.width, fig.height have been set
   # TODO: could this be made more robust? are we setting these values,
   # or are they coming from rmarkdown / knitr?
   
   # infer the DPI (be careful to handle fig.retina)
   if (!is.null(chunkOptions$dpi)) {
      dpi <- chunkOptions$dpi
   } else if (!is.null(knitrOptions$dpi)) {
      dpi <- knitrOptions$dpi
      if (is.numeric(knitrOptions$fig.retina))
         dpi <- dpi / knitrOptions$fig.retina
   } else {
      dpi <- defaultDpi
   }
   
   isDefaultKnitrSizing <-
      identical(knitrOptions$fig.width, defaultFigWidth) &&
      identical(knitrOptions$fig.height, defaultFigHeight) &&
      identical(dpi, defaultDpi) &&
      is.null(knitrOptions$fig.asp)
   
   # detect if the user has explicitly set fig.width, fig.height for
   # the currently executing chunk
   isDefaultChunkSizing <-
      is.null(chunkOptions$fig.width) &&
      is.null(chunkOptions$fig.height) &&
      is.null(chunkOptions$fig.asp)
   
   if (isDefaultKnitrSizing && isDefaultChunkSizing) {
      
      # if the user has not set any options related to chunk sizing, then
      # rely on the pre-computed values in 'knitrOptions', which should
      # have been set based on the htmlwidget sizing policy. (recompute
      # those values if not set)
      knitrOptions$out.width.px <- .rs.firstOf(
         knitrOptions$out.width.px,
         defaultFigWidth * defaultDpi
      )
      
      knitrOptions$out.height.px <- .rs.firstOf(
         knitrOptions$out.height.px,
         defaultFigHeight * defaultDpi
      )
      
   } else {
      
      # otherwise, set the figure width + height according to those chunk options
      
      # compute fig.width, fig.height
      figWidth  <- .rs.firstOf(chunkOptions$fig.width,  knitrOptions$fig.width) * dpi
      figHeight <- .rs.firstOf(chunkOptions$fig.height, knitrOptions$fig.height) * dpi
      figAsp    <- .rs.firstOf(chunkOptions$fig.asp,    knitrOptions$fig.asp, 1)
      
      # if fig.width or fig.height is null, compute from the companion
      knitrOptions$out.width.px  <- figWidth
      knitrOptions$out.height.px <- figHeight %||% figWidth * figAsp
   }
   
   # if, for some reason, we don't have an out.width.px or out.height.px
   # at this point, then just set some sane defaults
   knitrOptions$out.width.px  <- floor(knitrOptions$out.width.px %||% 500)
   knitrOptions$out.height.px <- floor(knitrOptions$out.height.px %||% 500)
   
   # save as HTML -- save a modified version of the 'standalone' representation
   # that works effectively the same way as the 'embedded' representation;
   # we use a filter on the server side to disentangle things as needed
   html <- htmlwidgets:::toHTML(x, standalone = TRUE, knitrOptions = knitrOptions)
   
   # validate some expectations about the data structure
   if (length(html) != 3)
      stop("unexpected htmlwidget structure: expected taglist of length 3")
   
   if (html[[1]]$attribs$id != "htmlwidget_container")
      stop("expected a container div with id 'htmlwidget_container'")
   
   if (length(html[[1]]$children) == 0)
      stop("expected one or more children for htmlwidget container div")
   
   # force knitr styling on 'standalone' widget (will be overridden by sizing policy
   # in dynamic environments; this ensures that the 'preview' will be displayed as
   # though the widget were generated through 'rmarkdown::render()')
   #
   # note that this make assumptions about the widget structure that might not be
   # true in all cases so we wrap this in tryCatch
   embedded <- htmlwidgets:::toHTML(x, standalone = FALSE, knitrOptions = knitrOptions)
   .rs.tryCatch(html[[1]]$children[[1]][[2]]$attribs$style <- embedded[[1]][[2]]$attribs$style)
   
   # split up into parts
   div <- html[[1]]$children[[1]]
   json <- html[[2]]
   policy <- html[[3]]
   
   # encode the htmlwidget sizing policy as base64 (disentangled on the server
   # as appropriate, e.g. when showing viewer element in IDE)
   fmt <- "<!-- htmlwidget-sizing-policy-base64 %s -->"
   encodedPolicy <- .rs.base64encode(paste(as.character(policy), collapse = "\n"))
   htmlPolicy <- htmltools::HTML(sprintf(fmt, encodedPolicy))
   
   # generate annotated version of standalone html that we can disentangle
   # with a server-side filter as needed
   # NOTE: if you touch this make sure you update the parsing code in NotebookOutput.cpp
   htmlProduct <- htmltools::tagList(
      htmltools::HTML("<!-- htmlwidget-container-begin -->"),
      div,
      htmltools::HTML("<!-- htmlwidget-container-end -->"),
      json,
      htmlPolicy
   )
   attributes(htmlProduct) <- attributes(html)
   
   # write html
   htmltools::save_html(htmlProduct, file = htmlfile, libdir = libraryFolder)
   
   # record the saved artefacts
   .rs.recordHtmlWidget(x, htmlfile, depfile)
})


# HTML Capture ----

.rs.addFunction("rnb.htmlCaptureHooks", function()
{
   list(
      "print.htmlwidget"       = .rs.rnbHooks.print.htmlwidget,
      "print.html"             = .rs.rnbHooks.print.html,
      "print.shiny.tag"        = .rs.rnbHooks.print.shiny.tag,
      "print.shiny.tag.list"   = .rs.rnbHooks.print.shiny.tag.list,
      "print.knit_asis"        = .rs.rnbHooks.print.knit_asis,
      "print.knit_image_paths" = .rs.rnbHooks.print.knit_image_paths
   )
})

.rs.addFunction("initHtmlCapture", function(outputFolder,
                                            libraryFolder,
                                            chunkOptions)
{
   # cache context
   .rs.rnb.setHtmlCaptureContext(
      outputFolder = outputFolder,
      libraryFolder = libraryFolder,
      chunkOptions = chunkOptions
   )
   
   # get and load hooks
   hooks <- .rs.rnb.htmlCaptureHooks()
   .rs.enumerate(hooks, function(key, value) {
      .rs.addS3Override(key, value)
   })
})

.rs.addFunction("releaseHtmlCapture", function()
{
   # remove hooks
   hooks <- .rs.rnb.htmlCaptureHooks()
   for (name in names(hooks)) {
      .rs.removeS3Override(name)
   }
})

.rs.addFunction("firstOf", function(...)
{
   for (item in list(...))
      if (length(item)) return(item)
   return(NULL)
})

# compute five-number summary
fivenum <- function(x) {
  
  # handle empty input
  n <- length(x)
  if (n == 0)
     return(rep.int(NA, 5))
  
  # compute quartile indices
  n5 <- 1
  n4 <- ((n + 3) %/% 2) / 2
  n3 <- (n + 1) / 2
  n2 <- n + 1 - n4
  n1 <- n
  i <- c(n5, n4, n3, n2, n1)
  
  # compute quartile values
  x <- sort(x)
  xf <- x[floor(i)]
  xc <- x[ceiling(i)]
  0.5 * (xf + xc)

}

#!/usr/bin/env Rscript

# Add the 'rstudio' top-level namespace to every part of our code base
# where we've used 'core' or 'session'. This script is mostly a terrible
# hack, but hey, it works!

strip <- function(x) {
   x <- gsub("'.*(?<!\\\\)'", "", x, perl = TRUE)
   x <- gsub('".*(?<!\\\\)"', "", x, perl = TRUE)
   gsub("\\s*//.*", "", x, perl = TRUE)
}

add_rstudio_namespace <- function(file, nsNames) {
   
   content <- suppressWarnings(readLines(file))
   stripped <- strip(content)
   
   for (nsName in nsNames)
   {
      startPattern <- paste("^\\s*namespace\\s+", nsName, "\\s*\\{", sep = "")
      namespaceStartPos <- grep(startPattern, stripped, perl = TRUE)
      
      for (i in namespaceStartPos)
      {
         if (grepl("namespace", stripped[[i - 1]]))
            next
         
         j <- i + 1
         braceCount <- 1
         n <- length(stripped)
         
         while (j <= n)
         {
            line <- stripped[[j]]
            openBraces <- gregexpr("{", line, fixed = TRUE)[[1]]
            closedBraces <- gregexpr("}", line, fixed = TRUE)[[1]]
            
            if (openBraces[[1]] != -1)
               braceCount <- braceCount + length(openBraces)
            
            if (closedBraces[[1]] != -1)
               braceCount <- braceCount - length(closedBraces)
            
            if (braceCount <= 0)
            {
               if (braceCount < 0)
                  warning("Unexpected brace stack")
               
               content[[i]] <- paste("namespace rstudio {", content[[i]], sep = "\n")
               
               if (grepl("^\\s*\\}\\s*//\\s*name", content[[j]], perl = TRUE))
               {
                  closeNamespace <-
                     paste(content[[j]], "} // namespace rstudio", sep = "\n")
               }
               else
               {
                  closeNamespace <-
                     paste(content[[j]], "}", sep = "\n")
               }
               
               content[[j]] <- closeNamespace
               break
            }
            j <- j + 1
         }
         
      }
      
      # Re-normalize content
      splat <- strsplit(content, "\n", fixed = TRUE)
      splat <- lapply(splat, function(x) if (!length(x)) "" else x)
      content <- unlist(splat)
      
      content <- gsub("^(\\s*)using namespace core([^;]*);\\s*$",
                      "\\1using namespace rstudio::core\\2;",
                      content,
                      perl = TRUE)
      
      content <- gsub("^(\\s*)using namespace desktop([^;]*);\\s*$",
                      "\\1using namespace rstudio::desktop\\2;",
                      content,
                      perl = TRUE)
      
      stripped <- strip(content)
   }
   
   # We have to define error codes for some items
   # within the boost namespace. When these are
   # encountered we need a fully qualified namespace.
   content <- gsub(
      "\\<(.*)::errc::errc_t\\>",
      "<rstudio::\\1::errc::errc_t>",
      content,
      perl = TRUE
   )
      
   
   cat(content, file = file, sep = "\n")
   
}

# files <- "src/cpp/core/include/core/json/JsonRpc.hpp"
files <- list.files(
   path = "src/cpp",
   pattern = "cpp$|hpp$|h$|mm$|cpp\\.in$|hpp\\.in$",
   full.names = TRUE,
   recursive = TRUE
)

r_files <- grep("^src/cpp/r/", files, value = TRUE)
files <- setdiff(files, r_files)

nsNames <- c("core", "monitor", "session", "desktop", 
             "diagnostics", "server", "session_proxy")
for (file in files)
   add_rstudio_namespace(file, nsNames)

for (file in r_files)
   add_rstudio_namespace(file, c("core", "r"))

# A couple files need special handling
add_rstudio_namespace("src/cpp/session/include/session/SessionModuleContext.hpp", "r")

prefix_core_with_rstudio <- function(file) {
   content <- suppressWarnings(readLines(file))
   content <- gsub("core::", "rstudio::core::", content, fixed = TRUE)
   cat(content, file = file, sep = "\n")
}

prefix_core_with_rstudio("src/cpp/core/Assert.cpp")

fix_up_main <- function(file) {
   content <- suppressWarnings(readLines(file))
   content <- gsub("^(\\s*)using namespace rstudio::core\\s*;",
                   "\\1using namespace rstudio;\n\\1using namespace rstudio::core;",
                   content,
                   perl = TRUE)
   cat(content, file = file, sep = "\n")
}

main_files <- files[grep("Main.cpp", basename(files))]
lapply(main_files, function(file)
   fix_up_main(file))

add_using_rstudio_namespace <- function(file) {
   
   content <- suppressWarnings(readLines(file))
   
   if (!any(grepl("#include <core", content, perl = TRUE)))
      return()
   
   if (any(grepl("using namespace rstudio;", content)))
      return()
   
   idx <- grep("using namespace", content)
   sep <- "\n"
   if (!length(idx))
   {
      idx <- grep("[@{]", strip(content), perl = TRUE)[[1]]
      sep <- "\n\n"
   }
   idx <- idx[[1]]
   indent <- gsub("^(\\s*).*", "\\1", content[[idx]])
   content[[idx]] <- paste0(indent, "using namespace rstudio;", sep, content[[idx]])
   cat(content, file = file, sep = "\n")
}

needs_rstudio_namespace <- grep("mm$", files, value = TRUE)

lapply(needs_rstudio_namespace, function(file)
   add_using_rstudio_namespace(file))

webview <- "src/cpp/desktop-mac/WebViewController.mm"
content <- readLines(webview)
content[[23]] <- "using namespace rstudio;\n"
cat(content, file = webview, sep = "\n")

prefix_r_with_rstudio <- function(file) {
   content <- suppressWarnings(readLines(file))
   content <- gsub("using namespace r::([^;]*);",
                   "using namespace rstudio::r::\\1;",
                   content,
                   perl = TRUE)
   cat(content, file = file, sep = "\n")
}

session_files <- grep("^src/cpp/session", files, value = TRUE)
lapply(session_files, function(file)
   prefix_r_with_rstudio(file))

#
# SessionPackages.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# cached URLs for package NEWS files
.rs.setVar("packageNewsURLsEnv", new.env(parent = emptyenv()))

# cached information on available R packages
.rs.setVar("availablePackagesEnv", new.env(parent = emptyenv()))

# for asynchronous requests on available package information,
# map the repository string to the directory containing produced output
.rs.setVar("availablePackagesPendingEnv", new.env(parent = emptyenv()))

.rs.addJsonRpcHandler("is_package_installed", function(package, version)
{
   installed <- if (is.null(version))
      .rs.isPackageInstalled(package)
   else
      .rs.isPackageVersionInstalled(package, version)
   .rs.scalar(installed)
})

.rs.addJsonRpcHandler("is_package_attached", function(packageName, libraryPath)
{
   # quick check first if the package is loaded
   if (!isNamespaceLoaded(packageName))
      return(.rs.scalar(FALSE))

   # get the raw path to the package
   packagePath <- .rs.pathPackage(packageName, quiet = TRUE)
   if (length(packagePath) == 0L)
      return(.rs.scalar(FALSE))

   # Check if the package at the given library path (possibly a symlink)
   # resolves to the same location as the loaded package. This handles the
   # renv cache case where packages in the project library are symlinks.
   clientPackagePath <- file.path(libraryPath, packageName)
   samePath <- identical(
      normalizePath(clientPackagePath, winslash = "/", mustWork = FALSE),
      normalizePath(packagePath, winslash = "/", mustWork = FALSE)
   )

   .rs.scalar(samePath)
})

.rs.addJsonRpcHandler("is_package_hyperlink_safe", function(packageName)
{
   .rs.isPackageHyperlinkSafe(packageName)
})

.rs.addJsonRpcHandler("get_package_install_context", function()
{
   # check if the '@CRAN@' placeholder is present in repos
   repos <- getOption("repos")
   cranMirrorConfigured <- !"@CRAN@" %in% repos
   
   # selected repository names (assume an unnamed repo == CRAN)
   # TODO: What if no repositories are set?
   selectedRepositoryNames <- names(repos)
   if (is.null(selectedRepositoryNames))
      selectedRepositoryNames <- "CRAN"
   
   # package archive extension
   packageArchiveExtension <- switch(
      Sys.info()[["sysname"]],
      Windows = ".zip; .tar.gz",
      Darwin  = ".tgz; .tar.gz",
      ".tar.gz"
   )
   
   # default library path (normalize on unix)
   defaultLibraryPath = .libPaths()[1L]
   if (!identical(.Platform$OS.type, "windows"))
      defaultLibraryPath <- .rs.normalizePath(defaultLibraryPath)
   
   # return context
   list(
      cranMirrorConfigured = cranMirrorConfigured,
      selectedRepositoryNames = selectedRepositoryNames,
      packageArchiveExtension = packageArchiveExtension,
      defaultLibraryPath = defaultLibraryPath,
      defaultLibraryWriteable = .rs.defaultLibPathIsWriteable(),
      writeableLibraryPaths = .rs.writeableLibraryPaths(),
      defaultUserLibraryPath = .rs.defaultUserLibraryPath(),
      devModeOn = .rs.devModeOn()
   )
})

.rs.addJsonRpcHandler("get_cran_mirrors", function()
{
   # get CRAN mirrors (securely if we are configured to do so)
   haveSecureMethod <- .rs.haveSecureDownloadFileMethod()
   protocol <- ifelse(haveSecureMethod, "https", "http")
   cranMirrors <- try(silent = TRUE, {
      mirrors_csv_url <- paste(protocol, "://cran.r-project.org/CRAN_mirrors.csv",
                               sep = "")
      mirrors_csv <- tempfile("mirrors", fileext = ".csv")
      download.file(mirrors_csv_url, destfile = mirrors_csv, quiet = TRUE)
      
      # read them
      read.csv(mirrors_csv, as.is = TRUE, encoding = "UTF-8")
   })
   
   # if we got an error then use local only
   if (is.null(cranMirrors) || inherits(cranMirrors, "try-error"))
      cranMirrors <- utils::getCRANmirrors(local.only = TRUE)
   
   # create data frame
   cranDF <- data.frame(name = cranMirrors$Name,
                        host = cranMirrors$Host,
                        url = cranMirrors$URL,
                        country = cranMirrors$CountryCode,
                        ok = cranMirrors$OK,
                        stringsAsFactors = FALSE)
   
   # filter by OK status
   cranDF <- cranDF[as.logical(cranDF$ok), ]
   
   # filter by mirror type supported by the current download.file.method
   # (also verify that https urls are provided inline -- if we didn't do
   # this and CRAN changed the format we could end up with no mirrors)
   secureMirror <- grepl("^https", cranDF[, "url"])
   useHttpsURL <- haveSecureMethod && any(secureMirror)
   if (useHttpsURL)
      cranDF <- cranDF[secureMirror,]
   else
      cranDF <- cranDF[!secureMirror,]
   
   # prepend RStudio mirror and return
   rstudioDF <- data.frame(name = "Global (CDN)",
                           host = "RStudio",
                           url = paste(ifelse(useHttpsURL, "https", "http"), 
                                       "://cran.rstudio.com/", sep=""),
                           country = "us",
                           ok = TRUE,
                           stringsAsFactors = FALSE)
   rbind(rstudioDF, cranDF)
})

.rs.addJsonRpcHandler("get_cran_actives", function()
{
   data.frame(name = names(getOption("repos")),
              host = "",
              url = as.character(getOption("repos")),
              country = "",
              ok = TRUE,
              stringsAsFactors = FALSE)
})

.rs.addJsonRpcHandler( "init_default_user_library", function()
{
   .rs.initDefaultUserLibrary()
})

.rs.addJsonRpcHandler("check_for_package_updates", function()
{
   # Exit early if we don't have any repositories set.
   repos <- getOption("repos")
   if (length(repos) == 0L)
      return(list())
   
   # Get all of the currently-installed packages. We list packages for each
   # library separately, so we can merge them appropriately after.
   installedPkgsList <- lapply(.libPaths(), function(libPath)
   {
      pkgPaths <- list.files(libPath, full.names = TRUE)
      
      pkgDescs <- lapply(pkgPaths, function(pkgPath)
      {
         pkgDesc <- tryCatch(
            .rs.readPackageDescription(pkgPath),
            condition = function(cnd) NULL
         )
         
         pkgDesc[c("Package", "Version")]
      })
      
      pkgDescs <- Filter(length, pkgDescs)
      if (length(pkgDescs) == 0L)
         return(NULL)
      
      pkgResult <- .rs.rbindList(pkgDescs)
      pkgResult[["LibPath"]] <- libPath
      pkgResult
   })
   
   installedPkgs <- .rs.rbindList(installedPkgsList)
   
   # Remove duplicates.
   installedPkgs <- installedPkgs[!duplicated(installedPkgs$Package), ]
   
   # Compare installed packages with what's available from package repositories.
   availablePkgs <- as.data.frame(
      utils::available.packages(),
      stringsAsFactors = FALSE
   )
   
   # Keep only the package name and version component.
   availablePkgs <- data.frame(
      Package  = availablePkgs[["Package"]],
      ReposVer = availablePkgs[["Version"]],
      stringsAsFactors = FALSE
   )
   
   # Merge in the repository version components.
   allPkgs <- merge(
      x  = installedPkgs,
      y  = availablePkgs,
      by = "Package"
   )
   
   # Figure out which packages are out-of-date.
   oldPkgs <- subset(allPkgs, numeric_version(Version) < numeric_version(ReposVer))
   
   # Add in version fields as appropriate.
   data.frame(
      packageName = oldPkgs[["Package"]],
      libPath     = oldPkgs[["LibPath"]],
      installed   = oldPkgs[["Version"]],
      available   = oldPkgs[["ReposVer"]],
      stringsAsFactors = FALSE
   )
   
})

.rs.addJsonRpcHandler("get_package_citations", function(packageName, libraryPath)
{
   toPerson <- function(author) {
      list(
         given = author[["given"]],
         family = .rs.scalar(author[["family"]]),
         email = .rs.scalar(author[["email"]]),
         role = .rs.scalar(author[["role"]])
      )
   }
   
   cites <- citation(packageName)
   lapply(unclass(cites), function(cite) {
      list(
         # bibtex type
         type = .rs.scalar(attr(cite, "bibtype")),
         
         title = .rs.scalar(cite[["title"]]),
         url = .rs.scalar(cite[["url"]]),
         note = .rs.scalar(cite[["note"]]),
         doi = .rs.scalar(cite[["doi"]]),
         
         publisher = .rs.scalar(cite[["publisher"]]),
         institution = .rs.scalar(cite[["institution"]]),
         address = .rs.scalar(cite[["address"]]),
         
         journal = .rs.scalar(cite[["journal"]]),
         year = .rs.scalar(cite[["year"]]),
         booktitle = .rs.scalar(cite[["booktitle"]]),
         chapter = .rs.scalar(cite[["chapter"]]),
         number = .rs.scalar(cite[["number"]]),
         volume = .rs.scalar(cite[["volume"]]),
         pages = .rs.scalar(cite[["pages"]]),
         series = .rs.scalar(cite[["series"]]),
         school = .rs.scalar(cite[["school"]]),
         
         
         # person
         author = lapply(unclass(cite[["author"]]), toPerson),
         editor = lapply(unclass(cite[["editor"]]), toPerson)
      )
   })
})

.rs.addJsonRpcHandler("get_package_news_url", function(packageName, libraryPath)
{
   # first, check if we've already discovered a NEWS link
   cache <- .rs.packageNewsURLsEnv
   entry <- file.path(libraryPath, packageName)
   if (exists(entry, envir = cache))
      return(get(entry, envir = cache))
   
   # determine an appropriate repository URL for this package
   # default to our public CRAN repository
   cran <- .Call("rs_rstudioCRANReposUrl", PACKAGE = "(embedding)")
   
   # check whether the requested package is from a separate repository URL
   # note that the 'Repository' entry below will include a suffix based on the
   # package type, so we need to trim that after
   db <- as.data.frame(available.packages(), stringsAsFactors = FALSE)
   if ("Repository" %in% names(db)) {
      index <- match(packageName, db$Package)
      if (!is.na(index)) {
         repo <- db$Repository[index]
         cran <- gsub("/(?:src|bin)/.*", "", repo)
      }
   }
   
   # re-route PPM URLs to CRAN for now
   # https://github.com/rstudio/rstudio/issues/12648
   isPpm <-
      grepl("^\\Qhttp://rspm/\\E", cran, perl = TRUE) ||
      grepl("^\\Qhttps://packagemanager.posit.co/\\E", cran, perl = TRUE) ||
      grepl("^\\Qhttps://packagemanager.rstudio.com/\\E", cran, perl = TRUE) ||
      grepl("^\\Qhttps://p3m.dev/\\E", cran, perl = TRUE)
   
   if (isPpm)
      cran <- "https://cloud.R-project.org"
   
   # check to see if this package was from Bioconductor. if so, we'll need
   # to construct a more appropriate url
   desc <- .rs.tryCatch(.rs.readPackageDescription(file.path(libraryPath, packageName)))
   prefix <- if ("biocViews" %in% names(desc))
      "https://bioconductor.org/packages/release/bioc/news"
   else
      file.path(cran, "web/packages")
   
   # the set of candidate URLs -- we use the presence of a NEWS or NEWS.md
   # to help us prioritize the order of checking.
   #
   # in theory, the current-installed package might not have NEWS at all, but
   # the latest released version might have it after all, so checking the
   # current installed package is just a heuristic and won't be accurate
   # 100% of the time
   pkgPath <- file.path(libraryPath, packageName)
   candidates <- if (file.exists(file.path(pkgPath, "NEWS.md"))) {
      c("news/news.html", "news.html", "NEWS", "ChangeLog")
   } else if (file.exists(file.path(pkgPath, "NEWS"))) {
      c("NEWS", "news/news.html", "news.html", "ChangeLog")
   } else {
      c("news/news.html", "news.html", "NEWS", "ChangeLog")
   }
   
   # we do some special handling for 'curl'
   isCurl <- identical(getOption("download.file.method"), "curl")
   if (isCurl) {
      
      download.file.extra <- getOption("download.file.extra")
      on.exit(options(download.file.extra = download.file.extra), add = TRUE)
      
      # guard against NULL, empty extra
      extra <- if (length(download.file.extra))
         download.file.extra
      else
         ""
      
      # add in some extra flags for nicer download output
      addons <- c()
      
      # follow redirects if necessary
      hasLocation <-
         grepl("\b-L\b", extra) ||
         grepl("\b--location\b", extra)
      
      if (!hasLocation)
         addons <- c(addons, "-L")
      
      # fail on 404
      hasFail <-
         grepl("\b-f\b", extra) ||
         grepl("\b--fail\b", extra)
      
      if (!hasFail)
         addons <- c(addons, "-f")
      
      # don't print error output to the console
      hasSilent <-
         grepl("\b-s\b", extra) ||
         grepl("\b--silent\b", extra)
      
      if (!hasSilent)
         addons <- c(addons, "-s")
      
      if (nzchar(extra))
         extra <- paste(extra, paste(addons, collapse = " "))
      else
         extra <- paste(addons, collapse = " ")
      
      options(download.file.extra = extra)
   }
   
   # timeout a bit more quickly when forming web requests
   timeout <- getOption("timeout")
   on.exit(options(timeout = timeout), add = TRUE)
   options(timeout = 4L)
   
   for (candidate in candidates) {
      
      url <- file.path(prefix, packageName, candidate)
      
      # attempt to download the file (note that R preserves curl's printing of errors
      # to the console with 'quiet = TRUE' so we disable it there)
      destfile <- tempfile()
      on.exit(unlink(destfile), add = TRUE)
      status <- .rs.tryCatch(download.file(url, destfile = destfile, quiet = !isCurl, mode = "wb"))
      
      # handle explicit errors
      if (is.null(status) || inherits(status, "error"))
         next
      
      # check for success status
      if (identical(status, 0L)) {
         cache[[entry]] <- .rs.scalar(url)
         return(.rs.scalar(url))
      }
   }
   
   # we failed to figure out the NEWS url; provide our first candidate
   # as the best guess
   fmt <- "Failed to infer appropriate NEWS URL: using '%s' as best-guess candidate"
   warning(sprintf(fmt, candidates[[1]]))
   
   # return that URL
   .rs.scalar(candidates[[1]])
})

.rs.addJsonRpcHandler("loaded_package_updates_required", function(pkgs)
{
   .rs.scalar(.rs.loadedPackageUpdates(as.character(pkgs)))
})

.rs.addJsonRpcHandler("ignore_next_loaded_package_check", function() {
   .rs.setVar("ignoreNextLoadedPackageCheck", TRUE)
   return(NULL)
})

.rs.addJsonRpcHandler("package_skeleton", function(packageName,
                                                   packageDirectory,
                                                   sourceFiles,
                                                   usingRcpp)
{
   # mark encoding
   Encoding(packageDirectory) <- "UTF-8"
   
   # sourceFiles is passed in as a list -- convert back to
   # character vector
   sourceFiles <- as.character(sourceFiles)
   
   # Make sure we expand the aliased path if necessary
   # (note this is a no-op if there is no leading '~')
   packageDirectory <- path.expand(packageDirectory)
   
   ## Validate the package name -- note that we validate this upstream
   ## but it is sensible to validate it once more here
   if (!grepl("^[[:alpha:]][[:alnum:].]*", packageName))
      return(.rs.error(
         "Invalid package name: the package name must start ",
         "with a letter and follow with only alphanumeric characters"))
   
   ## Validate the package directory -- if it exists, make sure it's empty,
   ## otherwise, try to create it
   if (file.exists(packageDirectory))
   {
      containedFiles <- list.files(packageDirectory) ## what about hidden files?
      if (length(containedFiles))
      {
         return(.rs.error(
            "Folder '", packageDirectory, "' ",
            "already exists and is not empty"))
      }
   }
   
   # Otherwise, create it
   else
   {
      if (!dir.create(packageDirectory, recursive = TRUE))
         return(.rs.error(
            "Failed to create directory '", packageDirectory, "'"))
   }
   
   ## Create a DESCRIPTION file
   
   # Fill some bits based on devtools options if they're available.
   # Protect against vectors with length > 1.
   getDevtoolsOption <- function(optionName,
                                 default = NULL,
                                 collapse = " ")
   {
      for (descKey in c("usethis.description", "devtools.desc"))
      {
         descValue <- getOption(descKey)
         if (length(descValue) == 0L)
            next
         
         optionValue <- descValue[[optionName]]
         if (length(optionValue) == 0L)
            next
         
         # Check for 'person' objects, and expand those in a way
         # that will be formatted nicely in the DESCRIPTION file.
         if (inherits(optionValue, "person"))
            optionValue <- .rs.formatPerson(optionValue)
         
         return(paste(optionValue, collapse = collapse))
      }
      
      default
   }
   
   authorsDefault <- .rs.heredoc('
      c(
        person(
          "Jane", "Doe",
          email = "jane@example.com",
          role = c("aut", "cre")
        )
      )
   ')
   
   authors <- getDevtoolsOption(
      "Authors@R",
      gsub("\n", "\n  ", authorsDefault, fixed = TRUE),
      collapse = "\n"
   )
   
   license <- getDevtoolsOption(
      "License",
      "What license is it under?",
      ", "
   )
   
   DESCRIPTION <- list(
      Package = packageName,
      Type = "Package",
      Title = "What the Package Does (Title Case)",
      Version = "0.1.0",
      "Authors@R" = authors,
      Description = c(
         "More about what it does (maybe more than one line).",
         "Continuation lines should be indented."
      ),
      License = license,
      Encoding = "UTF-8",
      LazyData = "true"
   )
   
   # Create a NAMESPACE file
   NAMESPACE <- c(
      'exportPattern("^[[:alpha:]]+")'
   )
   
   # If we are using Rcpp, update DESCRIPTION and NAMESPACE
   if (usingRcpp)
   {
      dir.create(file.path(packageDirectory, "src"), showWarnings = FALSE)
      
      rcppImportsStatement <- "Rcpp"
      
      # We'll enforce Rcpp > (installed version)
      ip <- installed.packages()
      if ("Rcpp" %in% rownames(ip))
         rcppImportsStatement <- sprintf("Rcpp (>= %s)", ip["Rcpp", "Version"])
      
      DESCRIPTION$Imports <- c(DESCRIPTION$Imports, rcppImportsStatement)
      DESCRIPTION$LinkingTo <- c(DESCRIPTION$LinkingTo, "Rcpp")
      
      # Add .registration = TRUE for Rcpp >= 0.12.11
      if (.rs.isPackageVersionInstalled("Rcpp", "0.12.11"))
         registration <- ", .registration = TRUE"
      else
         registration <- ""
      
      # Add an import from Rcpp, and also useDynLib
      NAMESPACE <- c(
         NAMESPACE,
         "importFrom(Rcpp, evalCpp)",
         sprintf("useDynLib(%s%s)", packageName, registration)
      )
   }
   
   # Get other fields from devtools options
   suggests <- .rs.nullCoalesce(
      getOption("devtools.desc.suggests"),
      getDevtoolsOption("Suggests")
   )
   
   if (length(suggests))
      DESCRIPTION$Suggests <- suggests
   
   # Add in any other options
   desc <- .rs.nullCoalesce(
      getOption("usethis.description"),
      getOption("devtools.desc")
   )
   
   .rs.enumerate(desc, function(key, value)
   {
      DESCRIPTION[[key]] <<- .rs.nullCoalesce(
         DESCRIPTION[[key]],
         value
      )
   })
   
   # If we are using 'testthat' and 'devtools' is available, use it to
   # add test infrastructure
   if ("testthat" %in% DESCRIPTION$Suggests)
   {
      dir.create(file.path(packageDirectory, "tests"))
      dir.create(file.path(packageDirectory, "tests", "testthat"))
      
      if ("devtools" %in% rownames(installed.packages()))
      {
         # NOTE: Okay to load devtools as we will restart the R session
         # soon anyhow
         ns <- asNamespace("devtools")
         if (exists("render_template", envir = ns))
         {
            tryCatch(
               writeLines(
                  devtools:::render_template(
                     "testthat.R",
                     list(name = packageName)
                  ),
                  file.path(packageDirectory, "tests", "testthat.R")
               ), error = function(e) NULL
            )
         }
      }
   }
   
   # If we are using the MIT license, add the template
   if (grepl("MIT\\s+\\+\\s+file\\s+LICEN[SC]E", DESCRIPTION$License, perl = TRUE))
   {
      # Guess the copyright holder
      holder <- .rs.nullCoalesce(
         getOption("usethis.full_name"),
         getOption("devtools.name"),
         "<Copyright holder>"
      )
      
      msg <- c(
         paste("YEAR:", format(Sys.time(), "%Y")),
         paste("COPYRIGHT HOLDER:", holder)
      )
      
      cat(msg,
          file = file.path(packageDirectory, "LICENSE"),
          sep = "\n")
   }
   
   # Always create 'R/', 'man/' directories
   dir.create(file.path(packageDirectory, "R"), showWarnings = FALSE)
   dir.create(file.path(packageDirectory, "man"))
   
   # If there were no source files specified, create a simple 'hello world'
   # function -- but only if the user hasn't implicitly opted into the 'devtools'
   # ecosystem
   if ((!length(getOption("devtools.desc"))) &&
       (!length(sourceFiles)))
   {
      
      # Some simple shortcuts that authors should know
      sysname <- Sys.info()[["sysname"]]
      
      buildShortcut <- if (sysname == "Darwin")
         "Cmd + Shift + B"
      else
         "Ctrl + Shift + B"
      
      checkShortcut <- if (sysname == "Darwin")
         "Cmd + Shift + E"
      else
         "Ctrl + Shift + E"
      
      testShortcut <- if (sysname == "Darwin")
         "Cmd + Shift + T"
      else
         "Ctrl + Shift + T"
      
      helloWorld <- .rs.trimCommonIndent('
         # Hello, world!
         #
         # This is an example function named \'hello\' 
         # which prints \'Hello, world!\'.
         #
         # You can learn more about package authoring with RStudio at:
         #
         #   https://r-pkgs.org
         #
         # Some useful keyboard shortcuts for package authoring:
         #
         #   Install Package:           \'%s\'
         #   Check Package:             \'%s\'
         #   Test Package:              \'%s\'
         
         hello <- function() {
           print(\"Hello, world!\")
         }
      ', buildShortcut, checkShortcut, testShortcut)
      
      cat(helloWorld,
          file = file.path(packageDirectory, "R", "hello.R"),
          sep = "\n")
      
      # Similarly, create a simple example .Rd for this 'hello world' function
      helloWorldRd <- .rs.trimCommonIndent('
         \\name{hello}
         \\alias{hello}
         \\title{Hello, World!}
         \\usage{
         hello()
         }
         \\description{
         Prints \'Hello, world!\'.
         }
         \\examples{
         hello()
         }
      ')
      
      cat(helloWorldRd,
          file = file.path(packageDirectory, "man", "hello.Rd"),
          sep = "\n")
      
      if (usingRcpp)
      {
         ## Ensure 'src/' directory exists
         if (!file.exists(file.path(packageDirectory, "src")))
            dir.create(file.path(packageDirectory, "src"))
         
         ## Write a 'hello world' for C++
         helloWorldCpp <- .rs.trimCommonIndent('
            #include <Rcpp.h>
            using namespace Rcpp;
            
            // This is a simple function using Rcpp that creates an R list
            // containing a character vector and a numeric vector.
            //
            // Learn more about how to use Rcpp at:
            //
            //   https://www.rcpp.org/
            //   https://adv-r.hadley.nz/rcpp.html
            //
            // and browse examples of code using Rcpp at:
            // 
            //   https://gallery.rcpp.org/
            //

            // [[Rcpp::export]]
            List rcpp_hello() {
              CharacterVector x = CharacterVector::create("foo", "bar");
              NumericVector y   = NumericVector::create(0.0, 1.0);
              List z            = List::create(x, y);
              return z;
            }

         ')
         
         helloWorldDoc <- .rs.trimCommonIndent('
            \\name{rcpp_hello}
            \\alias{rcpp_hello}
            \\title{Hello, Rcpp!}
            \\usage{
            rcpp_hello()
            }
            \\description{
            Returns an \\R \\code{list} containing the character vector
            \\code{c("foo", "bar")} and the numeric vector \\code{c(0, 1)}.
            }
            \\examples{
            rcpp_hello()
            }
         ')
         
         cat(helloWorldCpp,
             file = file.path(packageDirectory, "src", "rcpp_hello.cpp"),
             sep = "\n")
         
         cat(helloWorldDoc,
             file = file.path(packageDirectory, "man", "rcpp_hello.Rd"),
             sep = "\n")
         
      }
   }
   else if (length(sourceFiles))
   {
      # Copy the source files to the appropriate sub-directory
      sourceFileExtensions <- tolower(gsub(".*\\.", "", sourceFiles, perl = TRUE))
      sourceDirs <- .rs.swap(
         sourceFileExtensions,
         "R" = c("r", "q", "s"),
         "src" = c("c", "cc", "cpp", "h", "hpp"),
         "vignettes" = c("rmd", "rnw", "qmd"),
         "man" = "rd",
         "data" = c("rda", "rdata"),
         default = ""
      )
      
      copyPaths <- gsub("/+", "/", file.path(
         packageDirectory,
         sourceDirs,
         basename(sourceFiles)
      ))
      
      dirPaths <- dirname(copyPaths)
      
      success <- unlist(lapply(dirPaths, function(path) {
         
         if (isTRUE(file.info(path)$isdir))
            return(TRUE)
         
         dir.create(path, recursive = TRUE, showWarnings = FALSE)
         
      }))
      
      if (!all(success))
         return(.rs.error("Failed to create package directory structure"))
      
      success <- file.copy(sourceFiles, copyPaths)
      
      if (!all(success))
         return(.rs.error("Failed to copy one or more source files"))
   }
   
   # Write various files out
   
   # NOTE: write.dcf mangles whitespace so we manually construct
   # the text we wish to write out
   DESCRIPTION <- lapply(DESCRIPTION, function(field) {
      paste(field, collapse = "\n    ")
   })
   
   names <- names(DESCRIPTION)
   values <- unlist(DESCRIPTION)
   text <- paste(names, ": ", values, sep = "", collapse = "\n")
   cat(text, file = file.path(packageDirectory, "DESCRIPTION"), sep = "\n")
   
   cat(NAMESPACE, file = file.path(packageDirectory, "NAMESPACE"), sep = "\n")
   
   RprojPath <- file.path(
      packageDirectory,
      paste(packageName, ".Rproj", sep = "")
   )
   
   if (!.Call("rs_writeProjectFile", RprojPath, PACKAGE = "(embedding)"))
      return(.rs.error("Failed to create package .Rproj file"))
   
   # Ensure new packages get AutoAppendNewLine + StripTrailingWhitespace
   Rproj <- readLines(RprojPath)
   
   appendNewLineIndex <- grep("AutoAppendNewline:", Rproj, fixed = TRUE)
   if (length(appendNewLineIndex))
      Rproj[appendNewLineIndex] <- "AutoAppendNewline: Yes"
   else
      Rproj <- c(Rproj, "AutoAppendNewline: Yes")
   
   stripTrailingWhitespace <- grep("StripTrailingWhitespace:", Rproj, fixed = TRUE)
   if (length(stripTrailingWhitespace))
      Rproj[stripTrailingWhitespace] <- "StripTrailingWhitespace: Yes"
   else
      Rproj <- c(Rproj, "StripTrailingWhitespace: Yes")
   
   cat(Rproj, file = RprojPath, sep = "\n")
   
   # compute scratch paths
   scratchPaths <- .Call("rs_computeScratchPaths", RprojPath, PACKAGE = "(embedding)")
   scratchPath <- scratchPaths$scratch_path
   
   # NOTE: this file is not always generated (e.g. people who have implicitly opted
   # into using devtools won't need the template file)
   if (!is.null(scratchPath) &&
       file.exists(file.path(packageDirectory, "R", "hello.R")))
   {
      .Call("rs_addFirstRunDoc", scratchPath, "R/hello.R", PACKAGE = "(embedding)")
   }
   
   ## NOTE: This must come last to ensure the other package
   ## infrastructure bits have been generated; otherwise
   ## compileAttributes can fail
   if (usingRcpp &&
       .rs.isPackageVersionInstalled("Rcpp", "0.10.1") &&
       require(Rcpp, quietly = TRUE))
   {
      Rcpp::compileAttributes(packageDirectory)
      if (!is.null(scratchPath) &&
          file.exists(file.path(packageDirectory, "src/rcpp_hello.cpp")))
      {
         .Call("rs_addFirstRunDoc", scratchPath, "src/rcpp_hello.cpp", PACKAGE = "(embedding)")
      }
   }
   
   .rs.success()
   
})

.rs.addJsonRpcHandler("validate_cran_repo", function(url) {
   
   url <- .rs.completeUrl(.rs.appendSlashIfNeeded(url), "src/contrib/PACKAGES.gz")
   packagesFile <- tempfile(fileext = ".gz")
   
   # ensure warnings are not suppressed in this scope
   op <- options(warn = 1L)
   on.exit(options(op), add = TRUE)
   
   # execute download.file(), but capture warnings and errors
   warnings <- list()
   error <- NULL
   
   withCallingHandlers(
      
      tryCatch(
         download.file(url, packagesFile, quiet = TRUE),
         error = function(cnd) error <<- cnd
      ),
      
      warning = function(cnd) {
         warnings[[length(warnings) + 1L]] <<- cnd
         restart <- findRestart("muffleWarning")
         if (isRestart(restart))
            invokeRestart(restart)
      }
      
   )
   
   
   # build a message for display to client if an error occurred
   message <- ""
   if (length(error))
      message <- paste("Error:", conditionMessage(error))
   
   if (length(warnings)) {
      msgs <- vapply(warnings, conditionMessage, FUN.VALUE = character(1))
      message <- paste(message, paste("Warning:", msgs, collapse = "\n"), sep = "\n")
   }
   
   result <- list(
      valid = file.exists(packagesFile) && is.null(error),
      error = message
   )
   
   .rs.scalarListFromList(result)
   
})

.rs.addJsonRpcHandler("get_repositories", function()
{
   # Figure out the PPM repository URL, if any
   repos <- getOption("repos")
   parts <- .rs.ppm.fromRepositoryUrl(repos[[1L]])
   root <- parts[["root"]]
   if (is.null(root))
      return(list())
   
   # Ask it for the set of available repositories
   endpoint <- file.path(root, "__api__/repos")
   destfile <- tempfile("rstudio-ppm-repos", fileext = ".json")
   status <- download.file(endpoint, destfile = destfile, quiet = TRUE)
   contents <- readLines(destfile, warn = FALSE)
   result <- .rs.fromJSON(contents)
   
   .rs.scalarListFromList(result)
})

.rs.addJsonRpcHandler("select_repository", function(repoName, repoSnapshot)
{
   repos <- getOption("repos")
   
   oldRepoUrl <- repos[[1L]]
   parts <- .rs.ppm.fromRepositoryUrl(oldRepoUrl)
   if (length(parts) == 0L)
      return(NULL)
   
   parts[["repos"]] <- repoName
   if (!is.null(repoSnapshot) && nzchar(repoSnapshot))
      parts[["snapshot"]] <- repoSnapshot
   
   newRepoUrl <- .rs.ppm.toRepositoryUrl(parts)
   
   list(
      name  = .rs.scalar(names(repos)[[1L]]),
      value = .rs.scalar(newRepoUrl)
   )
})

.rs.addJsonRpcHandler("get_secondary_repos", function(cran, custom)
{
   .rs.getSecondaryRepos(cran, custom)
})


# Some R commands called during packaging-related operations (such as untar)
# delegate to the system tar binary specified in TAR. On OS X, R may set TAR to
# /usr/bin/gnutar, which exists prior to Mavericks (10.9) but not in later
# rleases of the OS. In the special case wherein the TAR environment variable
# on OS X is set to a non-existent gnutar and there exists a tar at
# /usr/bin/tar, tell R to use that binary instead.
if (identical(as.character(Sys.info()["sysname"]), "Darwin") &&
    identical(Sys.getenv("TAR"), "/usr/bin/gnutar") && 
    !file.exists("/usr/bin/gnutar") &&
    file.exists("/usr/bin/tar"))
{
   Sys.setenv(TAR = "/usr/bin/tar")
}

.rs.addFunction("beforePackageUnloaded", function(package)
{
   # force any promises associated with package's registered S3 methods --
   # this is necessary as otherwise the lazy-load database may become corrupt
   # if a new version of this package is later installed as the old promises
   # will now have invalid pointers to the old lazy-load database.
   #
   # note that we iterate over all loaded packages here because loading a
   # package might entail registering S3 methods in the namespace of the
   # package owning the generic, which typically is a separate package
   #
   # https://bugs.r-project.org/bugzilla/show_bug.cgi?id=16644
   # https://github.com/rstudio/rstudio/issues/8265
   for (namespaceName in loadedNamespaces())
   {
      .rs.tryCatch({
         ns <- asNamespace(namespaceName)
         table <- ns[[".__S3MethodsTable__."]]
         as.list(table)
      })
   }
})

.rs.addFunction("updatePackageEvents", function()
{
   reportPackageStatus <- function(attached)
   {
      function(pkgname, ...)
      {
         packagePath <- .rs.pathPackage(pkgname, quiet = TRUE)
         libraryPath <- dirname(packagePath)

         # For renv with shared cache, the loaded package path might be in the cache,
         # but we want to report the library path that contains a symlink to it.
         # This ensures the status update matches the listed package.
         normalizedPackagePath <- normalizePath(packagePath, winslash = "/", mustWork = FALSE)
         for (libPath in .libPaths())
         {
            pkgInLib <- file.path(libPath, pkgname)
            if (file.exists(pkgInLib))
            {
               normalizedPkgInLib <- normalizePath(pkgInLib, winslash = "/", mustWork = FALSE)
               if (identical(normalizedPkgInLib, normalizedPackagePath))
               {
                  libraryPath <- libPath
                  break
               }
            }
         }

         packageStatus = list(
            name     = I(pkgname),
            library  = I(.rs.createAliasedPath(libraryPath)),
            path     = I(.rs.createAliasedPath(packagePath)),
            attached = I(attached)
         )
         .rs.enqueClientEvent("package_status_changed", packageStatus)
      }
   }
   
   notifyPackageLoaded <- function(pkgname, ...)
   {
      .Call("rs_packageLoaded", pkgname, PACKAGE = "(embedding)")

      # when a package is loaded, it can register S3 methods which replace overrides we've
      # attached manually; take this opportunity to reattach them.
      .rs.reattachS3Overrides()
   }

   notifyPackageUnloaded <- function(pkgname, ...)
   {
      .rs.beforePackageUnloaded(pkgname)
      .Call("rs_packageUnloaded", pkgname, PACKAGE = "(embedding)")
   }
   
   pkgNames <-
      base::list.dirs(.libPaths(), full.names = FALSE, recursive = FALSE)
   
   sapply(pkgNames, function(packageName)
   {
      if ( !(packageName %in% .rs.hookedPackages) )
      {
         attachEventName = packageEvent(packageName, "attach")
         setHook(attachEventName, reportPackageStatus(TRUE), action = "append")
         
         loadEventName = packageEvent(packageName, "onLoad")
         setHook(loadEventName, notifyPackageLoaded, action = "append")

         unloadEventName = packageEvent(packageName, "onUnload")
         setHook(unloadEventName, notifyPackageUnloaded, action = "append")
             
         detachEventName = packageEvent(packageName, "detach")
         setHook(detachEventName, reportPackageStatus(FALSE), action = "append")
          
         .rs.setVar("hookedPackages", append(.rs.hookedPackages, packageName))
      }
   })
})

.rs.addFunction("packages.initialize", function()
{  
   # list of packages we have hooked attach/detach for
   .rs.setVar("hookedPackages", character())

   # set flag indicating we should not ignore loadedPackageUpdates checks
   .rs.setVar("ignoreNextLoadedPackageCheck", FALSE)
    
   # ensure we are subscribed to package attach/detach events
   .rs.updatePackageEvents()
})

.rs.addFunction( "addRToolsToPath", function()
{
    .Call("rs_addRToolsToPath", PACKAGE = "(embedding)")
})

.rs.addFunction( "restorePreviousPath", function()
{
    .Call("rs_restorePreviousPath", PACKAGE = "(embedding)")
})

.rs.addFunction( "uniqueLibraryPaths", function()
{
   # get library paths (normalize on unix to get rid of duplicate symlinks)
   libPaths <- .libPaths()
   if (!identical(.Platform$OS.type, "windows"))
      libPaths <- .rs.normalizePath(libPaths)

   subset(libPaths, !duplicated(libPaths))
})

.rs.addFunction( "writeableLibraryPaths", function()
{
   uniqueLibraryPaths <- .rs.uniqueLibraryPaths()
   writeableLibraryPaths <- character()
   for (libPath in uniqueLibraryPaths)
      if (.rs.isLibraryWriteable(libPath))
         writeableLibraryPaths <- append(writeableLibraryPaths, libPath)
   writeableLibraryPaths
})

.rs.addFunction("defaultUserLibraryPath", function()
{
   unlist(strsplit(Sys.getenv("R_LIBS_USER"), .Platform$path.sep))[1L]
})

.rs.addFunction("defaultLibraryPath", function()
{
  .libPaths()[1]
})

.rs.addFunction("isPackageHyperlinkSafe", function(packageName)
{
   allowed <- setdiff(
      c(.packages(), "testthat", "rlang", "devtools", "usethis", "pkgload", "pkgdown"), 
      c("base", "stats", "utils")
   )
   .rs.scalar(
      packageName %in% allowed
   )
})

.rs.addFunction("forceUnloadPackage", function(package)
{
   tryCatch(
      withCallingHandlers(
         .rs.forceUnloadPackageImpl(package),
         warning = function(w) invokeRestart("muffleWarning")
      ),
      error = warning
   )
})

.rs.addFunction("forceUnloadPackageImpl", function(package)
{
   .rs.beforePackageUnloaded(package)
   
   # Figure out where the package was loaded from before unloading it.
   pkgPath <- if (package %in% loadedNamespaces())
   {
      getNamespaceInfo(package, "path")
   }
   
   # Now, try to unload the package. If it's attached, detach it;
   # if the namespace is loaded, unload it.
   searchPathName <- paste("package", package, sep = ":")
   if (searchPathName %in% search())
   {
      detach(
         name = searchPathName,
         unload = TRUE,
         character.only = TRUE,
         force = TRUE
      )
   }
   else if (package %in% loadedNamespaces())
   {
      unloadNamespace(package)
   }
   
   # Now, unload a loaded DLL (if any) associated with the package.
   dllInfo <- getLoadedDLLs()[[package]]
   if (!is.null(dllInfo) && !is.null(pkgPath))
   {
      suppressWarnings(
         library.dynam.unload(package, pkgPath)
      )
   }
})

.rs.addFunction("packageVersion", function(name, libPath, pkgs)
{
   pkgs <- subset(pkgs, Package == name & LibPath == libPath)
   if (nrow(pkgs) == 1)
      pkgs$Version
   else
      ""
})

.rs.addFunction( "initDefaultUserLibrary", function()
{
  userdir <- .rs.defaultUserLibraryPath()
  dir.create(userdir, showWarnings = FALSE, recursive = TRUE)
  .libPaths(c(userdir, .libPaths()))
})

.rs.addFunction("ensureWriteableUserLibrary", function()
{
   if (!.rs.defaultLibPathIsWriteable())
      .rs.initDefaultUserLibrary()
})

.rs.addFunction("lastCharacterIs", function(value, ending) {
   identical(tail(strsplit(value, "")[[1]], n = 1), ending)
})

.rs.addFunction("findPackage", function(pkgPath)
{
   if (grepl("/", pkgPath, fixed = TRUE))
      pkgPath
   else
      find.package(pkgPath, quiet = TRUE)
})

.rs.addFunction("inferPackageSource", function(pkgDesc)
{
   # Check for 'base' packages.
   if (identical(pkgDesc[["Priority"]], "base"))
      return("Base")
   
   # Compute the package remote type, assuming "stanadrd" if none specified.
   rtype <- .rs.nullCoalesce(pkgDesc[["RemoteType"]], "standard")
   
   # Handle 'local' remotes.
   if (identical(rtype, "local"))
   {
      path <- pkgDesc[["RemoteUrl"]]
      if (is.null(path))
      {
         path <- pkgDesc[["RemoteUrl"]]
         if (!is.null(path))
         {
            path <- sub("^local::", "", path, perl = TRUE)
         }
      }
      
      return(sprintf("Local [%s]", .rs.nullCoalesce(path, "?")))
   }
   
   # Handle 'standard' remotes.
   
   if (identical(rtype, "standard"))
   {
      source <- .rs.nullCoalesce(
         pkgDesc[["RemoteReposName"]],
         pkgDesc[["RemoteRepos"]],
         pkgDesc[["Repository"]]
      )
      
      # Shorten the name for Bioconductor remotes.
      source <- sub("Bioconductor", "BioC", source, fixed = TRUE)
      
      # Check for R-universe remotes, and format them specially.
      pattern <- "^https?://(.*)\\.r-universe\\.dev/?$"
      m <- regexec(pattern, source)
      matches <- regmatches(source, m)[[1L]]
      if (length(matches))
         source <- sprintf("R-universe [%s]", matches[[2L]])
      
      # Check for PPM remorts, and format them specially.
      if (identical(pkgDesc[["Repository"]], "RSPM"))
      {
         repos <- pkgDesc[["RemoteRepos"]]
         if (!is.null(repos))
         {
            ppm <- if (grepl("https://p3m.dev/", repos, fixed = TRUE))
               "p3m.dev"
            else if (grepl("https://packagemanager.posit.co/", repos, fixed = TRUE))
               "P3M"
            else
               "PPM"
            
            parts <- .rs.ppm.fromRepositoryUrl(repos)
            if (length(parts))
            {
               snapshot <- parts[["snapshot"]]
               name <- parts[["repos"]]
               source <- sprintf("%s [%s/%s]", ppm, name, snapshot)
            }
            else
            {
               snapshot <- basename(repos)
               name <- basename(dirname(repos))
               source <- sprintf("%s [%s/%s]", ppm, name, snapshot)
            }
         }
      }
      
      return(source)
   }
   
   # Handle other remotes. Start by mapping the RemoteType field
   # into a "pretty" version of the type.
   aliases <- list(
      bioc         = "Bioconductor",
      bioconductor = "Bioconductor",
      bitbucket    = "Bitbucket",
      cran         = "CRAN",
      git2r        = "Git",
      github       = "GitHub",
      gitlab       = "GitLab",
      local        = "Local",
      repository   = "Repository",
      standard     = "Repository",
      url          = "URL",
      xgit         = "Git"
   )
   
   type <- .rs.nullCoalesce(aliases[[rtype]], rtype)
   
   # Check for packages installed from e.g. hosted Git repositories.
   user <- pkgDesc[["RemoteUsername"]]
   repo <- pkgDesc[["RemoteRepo"]]
   if (!is.null(user) && !is.null(repo))
   {
      source <- sprintf("%s [%s/%s]", type, user, repo)
      return(source)
   }
   
   # If we couldn't infer any more details, just use the type.
   type
   
})

.rs.addFunction("inferPackageBrowseUrl", function(pkgDesc)
{
   repos <- as.list(getOption("repos"))
   
   # For packages that were installed from CRAN or RSPM, browse
   # to the package page associated with the repository.
   repository <- pkgDesc[["Repository"]]
   if (identical(repository, "RSPM") || identical(repository, "CRAN"))
   {
      repoUrl <- .rs.nullCoalesce(
         pkgDesc[["RemoteRepos"]],
         repos[[repository]],
         repos[[1L]]
      )
      
      if (length(repoUrl))
      {
         url <- sprintf("%s/package=%s", repoUrl[[1L]], pkgDesc[["Package"]])
         return(url)
      }
   }
   
   # Try to build a link for packages installed from other remotes.
   host <- pkgDesc[["RemoteHost"]]
   user <- pkgDesc[["RemoteUsername"]]
   repo <- pkgDesc[["RemoteRepo"]]
   
   if (!is.null(host) && !is.null(user) && !is.null(repo))
   {
      host <- sub("api.github.com", "github.com", host, fixed = TRUE)
      url <- sprintf("https://%s/%s/%s", host, user, repo)
      return(url)
   }
   
   # If 'Repository' appears to be a URL, use it directly.
   if (is.character(repository) && grepl("^https://", repository))
   {
      return(repository)
   }
   
   # If this appears to be a Bioconductor package, link there.
   if (!is.null(pkgDesc[["biocViews"]]))
   {
      mirror <- getOption("BioC_mirror", default = "https://bioconductor.org")
      fmt <- "%s/packages/release/bioc/html/%s.html"
      url <- sprintf(fmt, mirror, pkgDesc[["Package"]])
      return(url)
   }
   
   # Give up.
   ""
})

.rs.addFunction("inferPackageDocumentationUrl", function(pkgDesc)
{
   url <- .rs.nullCoalesce(pkgDesc[["URL"]], "")
   sub("[[:space:],].*", "", url)
})

.rs.addFunction("listInstalledPackages", function()
{
   includePpmMeta <- .rs.ppm.isMetadataColumnEnabled()
   ppmMeta <- if (includePpmMeta) .rs.ppm.getMetadata()
   
   # Look for packages in the library paths.
   pkgPaths <- list.files(.rs.uniqueLibraryPaths(), full.names = TRUE)
   
   # Include only packages which have a 'Meta' sub-directory.
   hasMeta <- file.exists(file.path(pkgPaths, "Meta"))
   pkgPaths <- pkgPaths[hasMeta]
   
   # Iterate over these packages, and read their DESCRIPTION files.
   pkgInfos <- lapply(pkgPaths, function(pkgPath) {
      
      pkgDesc <- tryCatch(
         .rs.readPackageDescription(pkgPath),
         condition = function(e) list(Package = basename(pkgPath))
      )
      
      # Pull out package name for later use.
      pkgName <- pkgDesc[["Package"]]
      
      # Keep only fields of interest.
      pkgInfo <- pkgDesc[c("Package", "Title", "Version")]
      
      # Re-map names. Note that these names are also used and expected by
      # panmirror / Quarto.
      names(pkgInfo) <- c("name", "desc", "version")
      
      # Also record metadata about the library where it was found.
      libraryPath <- dirname(pkgPath)
      pkgInfo[["library"]] <- .rs.createAliasedPath(libraryPath)
      pkgInfo[["library_absolute"]] <- libraryPath
      pkgInfo[["library_index"]] <- match(libraryPath, .libPaths(), nomatch = 0L)
      
      # Also note which packages appear to be loaded or attached.
      # NOTE: We use normalizePath() to resolve symlinks, which is necessary
      # for renv projects using a shared cache (where packages in the project
      # library are symlinks to packages in the cache).
      isLoaded <- FALSE
      if (pkgName %in% loadedNamespaces())
      {
         isLoaded <-
            identical(pkgDesc[["Priority"]], "base") ||
            identical(
               normalizePath(getNamespaceInfo(pkgName, "path"), winslash = "/", mustWork = FALSE),
               normalizePath(pkgPath, winslash = "/", mustWork = FALSE)
            )
      }
      
      isAttached <-
         isLoaded &&
         paste("package", pkgName, sep = ":") %in% search()
      
      pkgInfo[["loaded"]] <- isLoaded
      pkgInfo[["attached"]] <- isAttached
      
      pkgInfo[["source"]] <- tryCatch(
         .rs.inferPackageSource(pkgDesc),
         error = function(cnd) "[Unknown]"
      )
      
      pkgInfo[["browse_url"]] <- tryCatch(
         .rs.inferPackageBrowseUrl(pkgDesc),
         error = function(cnd) ""
      )
      
      pkgInfo[["package_url"]] <- tryCatch(
         .rs.inferPackageDocumentationUrl(pkgDesc),
         error = function(cnd) ""
      )
      
      if (includePpmMeta)
      {
         ppmMetaKey <- paste(pkgInfo[["name"]], pkgInfo[["version"]], sep = "==")
         pkgInfo[["metadata"]] <- ppmMeta[[ppmMetaKey]]
      }
      
      # Return the resulting object.
      .rs.scalarListFromList(pkgInfo)
      
   })
   
   # Sort based on the package name.
   pkgOrder <- order(.rs.mapChr(pkgInfos, `[[`, "name"))
   pkgInfos <- pkgInfos[pkgOrder]
   
   # And we're done.
   pkgInfos
})

.rs.addFunction("readPackageImports", function(pkg)
{
   pkgPath <- find.package(pkg, quiet = TRUE)
   if (length(pkgPath) == 0L)
      return(character())
   
   metaPath <- file.path(pkgPath, "Meta/package.rds")
   if (!file.exists(metaPath))
      return(character())
   
   metaInfo <- readRDS(metaPath)
   importInfo <- metaInfo$Imports
   sort(unique(names(importInfo)))
})

.rs.addFunction("recursivePackageDependenciesImpl", function(pkg, envir)
{
   if (exists(pkg, envir = envir))
      return()
   
   deps <- setdiff(.rs.readPackageImports(pkg), "base")
   assign(pkg, deps, envir = envir)
   
   for (dep in deps)
      .rs.recursivePackageDependenciesImpl(dep, envir)
})

.rs.addFunction("recursivePackageDependencies", function(pkgs)
{
   envir <- new.env(parent = emptyenv())
   for (pkg in pkgs)
      .rs.recursivePackageDependenciesImpl(pkg, envir)
   as.list(envir, all.names = TRUE)
})

.rs.addFunction("packagesLoaded", function(pkgs)
{
   # exclude base packages
   basePkgs <- rownames(installed.packages(lib.loc = .Library, priority = "base"))
   pkgs <- setdiff(pkgs, basePkgs)
   
   # first check loaded namespaces
   if (any(pkgs %in% loadedNamespaces()))
      return(TRUE)

   # now check if there are libraries still loaded in spite of the
   # namespace being unloaded 
   libs <- .dynLibs()
   libnames <- vapply(libs, "[[", character(1), "name")
   return(any(pkgs %in% libnames))
})

.rs.addFunction("loadedPackageUpdates", function(pkgs)
{
   # are we ignoring?
   ignore <- .rs.ignoreNextLoadedPackageCheck
   .rs.setVar("ignoreNextLoadedPackageCheck", FALSE)
   if (ignore)
      return(FALSE)
   
   # first, check if the packages themselves are loaded
   if (.rs.packagesLoaded(pkgs))
      return(TRUE)
   
   # next, check if any of these package's dependencies are loaded
   recdeps <- .rs.recursivePackageDependencies(pkgs)
   if (.rs.packagesLoaded(recdeps))
      return(TRUE)
   
   FALSE
})

.rs.addFunction("loadedPackagesAndDependencies", function(pkgs)
{
   recdeps <- .rs.recursivePackageDependencies(pkgs)
   sort(unique(unlist(recdeps)))
})

.rs.addFunction("forceUnloadForPackageInstall", function(pkgs)
{
   sapply(pkgs, .rs.forceUnloadPackage)
   pkgs
})

.rs.addFunction("enqueLoadedPackageUpdates", function(installCmd)
{
   .Call("rs_enqueLoadedPackageUpdates", installCmd, PACKAGE = "(embedding)")
})

.rs.addFunction("getCachedAvailablePackages", function(contribUrl)
{
   .Call("rs_getCachedAvailablePackages", contribUrl, PACKAGE = "(embedding)")
})

.rs.addFunction("downloadAvailablePackages", function(contribUrl)
{
   .Call("rs_downloadAvailablePackages", contribUrl, PACKAGE = "(embedding)")
})

# Formats a person object in a way suitable for the Authors@R
# section of a DESCRIPTION file.
.rs.addFunction("formatPerson", function(person)
{
   personFields <- unclass(person)
   if (length(personFields) == 1L)
   {
      formattedPerson <- .rs.formatPersonImpl(personFields[[1L]])
      return(gsub("\n", "\n  ", formattedPerson))
   }
   
   formattedPersons <- paste(
      .rs.mapChr(personFields, .rs.formatPersonImpl, indent = "    "),
      collapse = ",\n"
   )
   
   paste(c("c(", formattedPersons, "  )"), collapse = "\n")
})

.rs.addFunction("formatPersonImpl", function(fields, indent = identity)
{
   if (is.character(indent))
   {
      indentWidth <- indent
      indent <- function(x) sprintf("%s%s", indentWidth, x)
   }
   
   # Build header from given + family name.
   fullName <- c(fields$given, fields$family, fields$middle)
   header <- paste(shQuote(fullName, type = "cmd"), collapse = ", ")
   
   # Build body from remaining fields
   rest <- fields[setdiff(names(fields), c("given", "family", "middle"))]
   other <- .rs.enumerate(rest, function(key, value)
   {
      sprintf("%s = %s", key, .rs.deparse(value))
   })
   
   body <- as.character(c(header, other))
   body <- sprintf("  %s", body)
   
   parts <- c(
      indent("person("),
      paste(indent(body), collapse = ",\n"),
      indent(")")
   )
   
   paste(parts, collapse = "\n")
})

.rs.addFunction("secureDownloadMethod", function()
{
   # Function to determine whether R checks for 404 in libcurl calls
   libcurlHandles404 <- function() {
      getRversion() >= "3.3" && .rs.haveRequiredRSvnRev(69197)
   }

   # Check whether we are running R 3.2+, R 4.2+, and whether we have libcurl
   isR32 <- getRversion() >= "3.2"
   isR42 <- getRversion() >= "4.2"
   haveLibcurl <- isR32 && capabilities("libcurl") && libcurlHandles404()
   
   # Utility function to bind to libcurl or a fallback utility (e.g. wget)
   posixMethod <- function(utility) {
      if (haveLibcurl)
         "libcurl"
      else if (nzchar(Sys.which(utility)))
         utility
      else
         ""
   }
   
   # Determine the right secure download method per-system
   sysName <- Sys.info()[['sysname']]
   
   # For windows, with R versions >= 3.2 to <= 4.1, we prefer binding directly to wininet
   # if we can (since that doesn't rely on the value of setInternet2).
   # In R 4.2+ wininet is deprecated, so we use libcurl instead when available.
   # If it's R <= 3.1 then we can use "internal" for https so long as internet2 is enabled
   if (identical(sysName, "Windows")) {
      if (isR42 && haveLibcurl)
         "libcurl"
      else if (isR32)
         "wininet"
      else if (isTRUE(.rs.setInternet2(NA)))
         "internal"
      else
         ""
   }
   
   # For Darwin and Linux we use libcurl if we can and then fall back
   # to curl or wget as appropriate. We prefer libcurl because it honors
   # the same proxy configuration that "internal" does so it less likely
   # to break downloads for users behind proxy servers. 
   
   else if (identical(sysName, "Darwin")) {
      posixMethod("curl")
   }
   
   else if (identical(sysName, "Linux")) {
      method <- posixMethod("wget")
      if (!nzchar(method))
         method <- posixMethod("curl")
      method
   } 
   
   # Another OS, don't even attempt detection since RStudio currently
   # only runs on Windows, Linux, and Mac
   else {
      ""
   }
})

.rs.addFunction("autoDownloadMethod", function() {
   if (capabilities("http/ftp"))
      "internal"
   else if (nzchar(Sys.which("wget")))
      "wget"
   else if (nzchar(Sys.which("curl")))
      "curl"
   else
      ""
})

.rs.addFunction("isDownloadMethodSecure", function(method) {
   
   # resolve auto if needed
   if (identical(method, "auto"))
      method <- .rs.autoDownloadMethod()
   
   # check for methods known to work securely
   if (method %in% c("wininet", "libcurl", "wget", "curl")) {
      TRUE
   }
   
   # if internal then see if were using windows internal with inet2
   else if (identical(method, "internal")) {
      identical(Sys.info()[['sysname']], "Windows") && isTRUE(.rs.setInternet2(NA))
   }
   
   # method with unknown properties (e.g. "lynx") or unresolved auto
   else {
      FALSE
   }
})

.rs.addFunction("haveSecureDownloadFileMethod", function() {
   .rs.isDownloadMethodSecure(getOption("download.file.method", "auto"))
})

.rs.addFunction("showSecureDownloadWarning", function() {
   is.na(Sys.getenv("RSTUDIO_DISABLE_SECURE_DOWNLOAD_WARNING", unset = NA))
})

.rs.addFunction("insecureReposWarning", function(msg) {
   if (.rs.showSecureDownloadWarning()) {
      message("WARNING: ", msg, " You should either switch to a repository ",
              "that supports HTTPS or change your RStudio options to not require HTTPS ",
              "downloads.\n\nTo learn more and/or disable this warning ",
              "message see the \"Use secure download method for HTTP\" option ",
              "in Tools -> Global Options -> Packages.")
   }
})

.rs.addFunction("insecureDownloadWarning", function(msg) {
   if (.rs.showSecureDownloadWarning()) {
      message("WARNING: ", msg,
              "\n\nTo learn more and/or disable this warning ",
              "message see the \"Use secure download method for HTTP\" option ",
              "in Tools -> Global Options -> Packages.")
   }
})

.rs.addFunction("initSecureDownload", function() {
      
   # check if the user has already established a download.file.method and
   # if so verify that it is secure
   method <- getOption("download.file.method")
   if (!is.null(method)) {
      if (!.rs.isDownloadMethodSecure(method)) {
         .rs.insecureDownloadWarning(
             paste("The download.file.method option is \"", method, "\" ",
                   "however that method cannot provide secure (HTTPS) downloads ",
                   "on this platform. ", 
                   "This option was likely specified in .Rprofile or ",
                   "Rprofile.site so if you wish to change it you may need ",
                   "to edit one of those files.",
                   sep = "")
         )
      }
   } 
   
   # no user specified method, automatically set a secure one if we can
   else {
      secureMethod <- .rs.secureDownloadMethod()
      if (nzchar(secureMethod)) {
         options(download.file.method = secureMethod) 
         if (secureMethod == "curl")
            options(download.file.extra = .rs.downloadFileExtraWithCurlArgs())
      }
      else {
         .rs.insecureDownloadWarning(
            paste("Unable to set a secure (HTTPS) download.file.method (no",
                  "compatible method available in this installation of R).")
         )
      }
   }
})
   

.rs.addFunction("downloadFileExtraWithCurlArgs", function() {
   newArgs <- "-L -f -g"
   curArgs <- getOption("download.file.extra")
   if (!is.null(curArgs) && !grepl(newArgs, curArgs, fixed = TRUE))
      curArgs <- paste(newArgs, curArgs)
   curArgs
})

.rs.addFunction("setInternet2", function(value = NA) {
   
   # from R 3.3.x, 'setInternet2' is defunct and does nothing
   if (getRversion() >= "3.3.0")
      return(TRUE)
   
   # should only be called on Windows, but sanity check
   if (Sys.info()[["sysname"]] != "Windows")
      return(TRUE)
   
   # delegate to 'setInternet2'
   utils::setInternet2(value)
})

.rs.addFunction("availablePackages", function()
{
   # short-circuit for empty repositories case
   repos <- getOption("repos")
   if (length(repos) == 0) {
      value <- available.packages()
      attr(value, "time") <- Sys.time()
      return(list(state = "CACHED", value = value))
   }
   
   # figure out the current state. possibilities:
   #
   # - STALE:    we need to request available packages
   # - PENDING:  another process is requesting packages
   # - CACHED:   available packages ready in cache
   #
   reposString <- paste(deparse(repos), collapse = " ")
   state <- .rs.availablePackagesState(reposString)
   value <- switch(
      state,
      STALE   = .rs.onAvailablePackagesStale(reposString),
      PENDING = .rs.onAvailablePackagesPending(reposString),
      CACHED  = .rs.onAvailablePackagesCached(reposString),
      NULL
   )
   
   list(state = state, value = value)
})

.rs.addFunction("availablePackagesState", function(reposString)
{
   # do we have a cache entry?
   entry <- .rs.availablePackagesEnv[[reposString]]
   if (!is.null(entry)) {
      
      # verify the cache entry is not stale
      time <- attr(entry, "time", exact = TRUE)
      elapsed <- difftime(Sys.time(), time, units = "secs")
      limit <- as.numeric(Sys.getenv("R_AVAILABLE_PACKAGES_CACHE_CONTROL_MAX_AGE", 3600))
      
      if (elapsed > limit)
         return("STALE")
      else
         return("CACHED")
   }
   
   # do we have a pending dir? if none, we're stale
   dir <- .rs.availablePackagesPendingEnv[[reposString]]
   if (is.null(dir))
      return("STALE")
   
   # is the directory old? if so, assume the prior R process launched
   # to produce available.packages crashed or similar
   info <- file.info(dir)
   time <- info$mtime
   
   # in some cases, mtime may not be available -- in that case, fall
   # back to the time that was serialized when the process was launched
   #
   # https://github.com/rstudio/rstudio/issues/4312
   #
   # if all-else fails, just use the current time. this effectively means
   # that we will never mark the directory as 'stale', which means that
   # the dependency discovery feature may not work -- but at this point
   # there's not much else we can do
   if (is.na(time)) {
      time <- .rs.tryCatch(readRDS(file.path(dir, "time.rds")))
      if (inherits(time, "error"))
         time <- Sys.time()
   }
   
   # check to see if the directory is 'stale'
   diff <- difftime(Sys.time(), time, units = "secs")
   if (diff > 120)
      return("STALE")
   
   # we have a directory, and it's not too old -- we're waiting
   # for a new process to finish
   return("PENDING")
})

.rs.addFunction("onAvailablePackagesStale", function(reposString)
{
   # evict a stale cache entry (if any)
   .rs.availablePackagesEnv[[reposString]] <- NULL
   
   # defend against '@CRAN@' within the repositories, as this will
   # cause R to present the user with an interactive prompt when
   # invoking 'contrib.url()'
   repos <- getOption("repos")
   repos <- repos[repos != "@CRAN@"]
   
   # check and see if R has already queried available packages;
   # if so we can ask R for available packages as it will use
   # the cache
   paths <- vapply(repos, function(url) {
      sprintf("%s/repos_%s.rds", 
              tempdir(), 
              URLencode(contrib.url(url), TRUE)
   )
   }, FUN.VALUE = character(1))
   
   if (all(file.exists(paths))) {
      
      # request available packages
      packages <- if (getRversion() >= "3.5")
         available.packages(max_repo_cache_age = Inf)
      else
         available.packages()
      
      # note accessed time
      attr(packages, "time") <- Sys.time()
      
      # add it to the cache
      .rs.availablePackagesEnv[[reposString]] <- packages
      
      # we're done!
      packages
      
   }
   
   # prepare directory for discovery of available packages
   dir <- tempfile("rstudio-available-packages-")
   dir.create(dir, showWarnings = FALSE)
   .rs.availablePackagesPendingEnv[[reposString]] <- dir
   
   # mtime may be unreliable (or access could fail in some cases) so
   # instead serialize the current time to a file rather than relying on OS
   saveRDS(Sys.time(), file = file.path(dir, "time.rds"))
   
   # move there
   owd <- setwd(dir)
   on.exit(setwd(owd), add = TRUE)
   
   # define our helper script that will download + save available.packages
   template <- .rs.trimCommonIndent('
      options(repos = %s, pkgType = %s)
      packages <- available.packages()
      attr(packages, "time") <- Sys.time()
      saveRDS(packages, file = "packages.rds")
   ')
   
   script <- sprintf(
      template,
      .rs.deparse(getOption("repos")),
      .rs.deparse(getOption("pkgType"))
   )
   
   # fire off the process
   .rs.runAsyncRProcess(
      script,
      onCompleted = function(exitStatus) {
         
         # bail on error (don't log since this might occur
         # for reasons not actionable by the user; e.g. restarting
         # the R session while a lookup is happening)
         if (exitStatus)
            return()
         
         available <- .rs.onAvailablePackagesReady(reposString)
         data <- list(
            ready = .rs.scalar(TRUE),
            packages = rownames(available)
         )
         .rs.enqueClientEvent("available_packages_ready", data)
      }
   )
   
   # NULL indicates we don't have available packages yet
   return(NULL)
   
})

.rs.addFunction("onAvailablePackagesPending", function(reposString)
{
   # nothing to do here
   invisible(NULL)
})

.rs.addFunction("onAvailablePackagesReady", function(reposString)
{
   # get the directory and read packages.rds
   dir <- .rs.availablePackagesPendingEnv[[reposString]]
   rds <- file.path(dir, "packages.rds")
   
   # attempt to read the database and add it to the cache
   packages <- .rs.tryCatch(readRDS(rds))
   if (!inherits(packages, "error"))
      .rs.availablePackagesEnv[[reposString]] <- packages
   
   # remove state directory and mark as no longer pending
   unlink(dir, recursive = TRUE)
   .rs.availablePackagesPendingEnv[[reposString]] <- NULL
   
   # we're done!
   packages
})

.rs.addFunction("onAvailablePackagesCached", function(reposString)
{
   .rs.availablePackagesEnv[[reposString]]
})

.rs.addFunction("parseSecondaryReposIni", function(conf) {
   entries <- .rs.readIniFile(conf)
   repos <- list()

   for (entryName in names(entries)) {
     repo <- list(
        name  = .rs.scalar(trimws(entryName)),
        url = .rs.scalar(trimws(entries[[entryName]])),
        host = .rs.scalar("Custom"),
        country = .rs.scalar("")
     )

     if (identical(tolower(as.character(repo$name)), "cran")) {
        repo$name <- .rs.scalar("CRAN")
        repos <- append(list(repo), repos, 1)
     } else {
        repos[[length(repos) + 1]] <- repo
     }
   }

   repos
})

.rs.addFunction("parseSecondaryReposJson", function(conf) {
   lines <- readLines(conf)
   repos <- list()

   entries <- .rs.fromJSON(paste(lines, collpse = "\n"))

   for (entry in entries) {
      url <- if (is.null(entry$url)) "" else url

      repo <- list(
         name  = .rs.scalar(entry$name),
         url = .rs.scalar(url),
         host = .rs.scalar("Custom"),
         country = .rs.scalar("")
      )

      if (identical(tolower(as.character(repo$name)), "cran")) {
         repo$name <- .rs.scalar("CRAN")
         repos <- append(list(repo), repos, 1)
      } else {
         repos[[length(repos) + 1]] <- repo
      }
   }

   repos
})

.rs.addFunction("getSecondaryRepos", function(cran = getOption("repos")[[1]], custom = TRUE) {
   result <- list(
      repos = list()
   )
   
   rCranReposUrl <- .Call("rs_getCranReposUrl", PACKAGE = "(embedding)")
   isDefault <- identical(rCranReposUrl, NULL) || nchar(rCranReposUrl) == 0

   if (isDefault) {
      slash <- if (.rs.lastCharacterIs(cran, "/")) "" else "/"
      rCranReposUrl <- paste(slash, "../../__api__/repos", sep = "")
   }
   else {
      custom <- TRUE
   }

   if (.rs.startsWith(rCranReposUrl, "..") ||
       .rs.startsWith(rCranReposUrl, "/..")) {
      rCranReposUrl <- .rs.completeUrl(cran, rCranReposUrl)
   }

   if (custom) {
      conf <- tempfile(fileext = ".conf")
      
      result <- tryCatch({
         download.file(
            rCranReposUrl,
            conf,
            method = "curl",
            extra = "-H 'Accept: text/ini'",
            quiet = TRUE
         )
         
         result$repos <- .rs.parseSecondaryReposIni(conf)
         if (length(result$repos) == 0) {
            result$repos <- .rs.parseSecondaryReposJson(conf)
         }

         result
      }, error = function(e) {
         list(
            error = .rs.scalar(
               paste(
                  "Failed to process repos list from ",
                  rCranReposUrl, ". ", e$message, ".", sep = ""
               )
            )
         )
      })
   }

   result
})

.rs.addFunction("appendSlashIfNeeded", function(url) {
   slash <- if (.rs.lastCharacterIs(url, "/")) "" else "/"
   paste(url, slash, sep = "")
})

.rs.addFunction("installPackagesRequiresRestart", function(pkgs)
{
   # only required on Windows; on other operating systems,
   # we can install an already-loaded package without issue
   if (!.rs.platform.isWindows)
      return(FALSE)

   # if we're in an renv project, no need
   if ("renv" %in% loadedNamespaces())
   {
      project <- renv::project()
      if (!is.null(project))
         return(FALSE)
   }
   
   # if we're in a packrat project, no need
   mode <- Sys.getenv("R_PACKRAT_MODE", unset = NA)
   if (identical(mode, "1"))
      return(FALSE)
   
   # in other cases, restart if one of the requested packages is loaded
   .rs.loadedPackageUpdates(pkgs)
})

# Hooks -------------------------------------------------------------------

.rs.defineHook(
   package = "utils",
   binding = "install.packages",
   function(pkgs, lib, repos)
   {
      ""
      "This is an RStudio hook."
      "Use `utils::install.packages()` to bypass this hook if necessary."
      ""

      if (interactive())
      {
         # Check if package installation was disabled in this version of RStudio.
         canInstallPackages <- .Call("rs_canInstallPackages", PACKAGE = "(embedding)")
         if (!canInstallPackages)
         {
            msg <- "Package installation is disabled in this version of RStudio."
            stop(msg, call. = FALSE)
         }

         # Notify if we're about to update an already-loaded package.
         # Skip this within renv and packrat projects.
         if (.rs.installPackagesRequiresRestart(pkgs))
         {
            response <- .rs.askForRestart("install.packages")
            if (identical(response, TRUE))
            {
               call <- do.call(substitute, list(match.call(), parent.frame()))
               call[[1L]] <- quote(install.packages)
               names(call)[[2L]] <- ""
               command <- paste(.rs.deparseCall(call), collapse = " ")

               .rs.enqueLoadedPackageUpdates(command)
               invokeRestart("abort")
            }
            else if (identical(response, FALSE))
            {
               # fall-through
            }
            else
            {
               invokeRestart("abort")
            }
         }

         # Make sure Rtools is on the PATH for Windows.
         .rs.addRToolsToPath()
         on.exit(.rs.restorePreviousPath(), add = TRUE)
      }

      # Resolve library path.
      if (missing(lib) || is.null(lib))
         lib <- .libPaths()[1L]

      # Check if we're installing a package from the filesystem,
      # versus installing a package from CRAN.
      isLocal <- is.null(repos) || any(grepl("/", pkgs, fixed = TRUE))

      # Allow administrators to suppress post-install source tagging via
      # the 'allow-package-source-recording' session option.
      recordSources <- .Call("rs_shouldRecordPackageSources", PACKAGE = "(embedding)")

      if (!recordSources)
      {
         # Source recording disabled; invoke install.packages with no
         # post-install bookkeeping.
         call <- sys.call()
         call[[1L]] <- quote(utils::install.packages)
         result <- eval(call, envir = parent.frame())
      }
      else if (isLocal)
      {
         # Invoke the original function.
         call <- sys.call()
         call[[1L]] <- quote(utils::install.packages)
         result <- eval(call, envir = parent.frame())

         # Record the package source. Note that we need to resolve the path
         # to the newly-installed package post-hoc from the provided path.
         shouldRecord <- is.character(pkgs) && length(pkgs) == 1L
         if (shouldRecord)
         {
            pkgDesc <- tryCatch(
               .rs.readPackageDescription(pkgs),
               error = function(cnd) NULL
            )

            if (length(pkgDesc))
            {
               pkgPath <- file.path(lib, pkgDesc[["Package"]])
               if (file.exists(pkgPath))
               {
                  tryCatch(
                     .rs.recordPackageSource(pkgPath, pkgs),
                     error = .rs.logWarningMessage
                  )
               }
            }
         }
      }
      else
      {
         # Scope the before/after scan to the requested packages plus the
         # dependency closure install.packages will actually traverse. A full
         # library enumeration can be very slow on network filesystems with
         # large libraries; the candidate set is an upper bound on what
         # install.packages can touch.
         #
         # Query available.packages() against the same 'repos' install.packages
         # will use (the hook's formal is either the user's explicit argument
         # or the install.packages default, getOption("repos")), so the
         # Repository column used by recordPackageSource matches the repo the
         # package was actually fetched from. On a transient network/DNS
         # failure or stale 'repos =', surface a warning and skip source
         # recording rather than poisoning the user's install with an error
         # from a bookkeeping lookup.
         db <- tryCatch(
            as.data.frame(
               utils::available.packages(repos = repos),
               stringsAsFactors = FALSE
            ),
            error = function(cnd)
            {
               fmt <- "available.packages() failed; skipping post-install source recording: %s"
               msg <- sprintf(fmt, conditionMessage(cnd))
               .rs.logWarningMessage(msg)
               NULL
            }
         )

         # 'dependencies' is a formal of utils::install.packages;
         # .rs.defineHookImpl copies the original function's formals onto this
         # hook, so the argument (or its default, NA) is bound in our frame
         # even though it doesn't appear in the source signature here.
         userDeps <- tryCatch(
            get("dependencies", envir = environment(), inherits = FALSE),
            error = function(e) NA
         )

         whichDeps <- .rs.installPackagesWhichDeps(userDeps)

         candidates <- pkgs
         if (!is.null(db))
         {
            # If any requested packages aren't present in db (Bioconductor,
            # R-universe, a private mirror, etc.), tools::package_dependencies
            # returns an empty character vector for those entries and their
            # transitive deps won't be tagged. Surface the mismatch so the
            # user can cross-check 'repos'.
            absent <- setdiff(pkgs, db$Package)
            if (length(absent) > 0L)
            {
               fmt <- "package(s) not present in available.packages(): %s; dependencies may not be tagged (check 'repos')"
               msg <- sprintf(fmt, paste(absent, collapse = ", "))
               .rs.logWarningMessage(msg)
            }

            # Mirror install.packages's getDependencies(): expand 'direct'
            # types for the requested pkgs (which may include Suggests when
            # dependencies = TRUE), then recurse only through 'transitive'
            # types over those deps. Querying the full set with
            # recursive = TRUE would over-expand the candidate scan via
            # Suggests-of-Suggests chains that install.packages won't follow.
            if (length(whichDeps$direct) > 0L)
            {
               directDeps <- tools::package_dependencies(
                  pkgs,
                  db = db,
                  recursive = FALSE,
                  which = whichDeps$direct
               )
               directDeps <- unique(unlist(directDeps, use.names = FALSE))

               transDeps <- if (length(directDeps) > 0L &&
                                length(whichDeps$transitive) > 0L)
               {
                  out <- tools::package_dependencies(
                     directDeps,
                     db = db,
                     recursive = TRUE,
                     which = whichDeps$transitive
                  )
                  unique(unlist(out, use.names = FALSE))
               }

               candidates <- unique(c(candidates, directDeps, transDeps))
            }
         }

         # install.packages recycles 'lib' against 'pkgs' (see ?install.packages),
         # so candidates can land in any of the supplied library entries; scan
         # all of them rather than just the first. install.packages itself
         # errors out if any 'lib' entry is non-writable, so each entry here
         # is a possible install target.
         paths <- as.vector(outer(lib, candidates, file.path))

         # Pin a reference timestamp in each library filesystem's own clock
         # domain, so NFS / CIFS clock skew between this R session and the
         # fs server can't cause us to miss packages whose mtime lands just
         # before Sys.time(). When 'lib' has multiple entries on different
         # filesystems, a single sentinel from lib[[1L]] isn't comparable to
         # mtimes from the other entries, so create one sentinel per entry.
         # If sentinel creation fails (read-only library, full disk,
         # restrictive umask), file.create() returns FALSE and
         # file.info()$mtime would be NA, silently disabling all tagging for
         # that entry; fall back to Sys.time() so install.packages still
         # runs and we still attempt source recording.
         libStarts <- .POSIXct(rep_len(NA_real_, length(lib)))
         sentinels <- character(length(lib))
         on.exit(unlink(sentinels[nzchar(sentinels)], force = TRUE), add = TRUE)
         for (i in seq_along(lib))
         {
            sentinels[i] <- tempfile("rstudio-install-sentinel-", tmpdir = lib[[i]])
            sentinelOk <- isTRUE(suppressWarnings(file.create(sentinels[i])))
            libStarts[i] <- if (sentinelOk)
            {
               file.info(sentinels[i])$mtime
            }
            else
            {
               .rs.logWarningMessage(sprintf(
                  "could not create sentinel file in '%s'; falling back to Sys.time() for install timestamp",
                  lib[[i]]
               ))
               Sys.time()
            }
         }

         # Invoke the original function.
         call <- sys.call()
         call[[1L]] <- quote(utils::install.packages)
         result <- eval(call, envir = parent.frame())

         # Any candidate whose directory mtime is at or after the sentinel
         # in its library was created or replaced during this install.
         # 'paths' was built via outer(lib, candidates, ...), which fills
         # column-major: paths[1..nLibs] correspond to candidate 1 across
         # each lib, paths[nLibs+1..] to candidate 2, etc. So libStarts
         # recycles position-wise against 'paths'.
         after <- .rs.installedPackagesFileInfo(paths = paths)
         pathStarts <- rep_len(libStarts, length(paths))
         changed <- !is.na(after$mtime) & after$mtime >= pathStarts

         # Tag each updated package's DESCRIPTION with its installation
         # source. Skip when available.packages() failed earlier; without
         # 'db' we can't match repository entries.
         if (!is.null(db))
            .rs.recordPackageSource(after$path[changed], db = db)
      }

      # Notify the front-end that we've made some updates.
      if (interactive())
      {
         .rs.updatePackageEvents()
         .Call("rs_packageLibraryMutated", PACKAGE = "(embedding)")
      }

      # Return installation result, invisibly.
      invisible(result)
   })

.rs.defineHook(
   package = "utils",
   binding = "remove.packages",
   function(pkgs, lib)
   {
      ""
      "This is an RStudio hook."
      "Use `utils::remove.packages()` to bypass this hook if necessary."
      ""

      # Invoke original.
      result <- utils::remove.packages(pkgs, lib)

      # Notify front-end that the package library was mutated.
      if (interactive())
      {
         .Call("rs_packageLibraryMutated", PACKAGE = "(embedding)")
      }

      # Return original result.
      invisible(result)
   })

#!/usr/bin/env Rscript

#
# r-api-report.R
#
# Reports which R C API symbols used by RStudio are not part of R's public API.
#
# The public API is determined by @apifun, @eapifun, @apivar, and @eapivar
# annotations in R-exts.texi. The embedding API (@embfun, @embvar) and
# formerly-API symbols (@forfun) are reported separately.
#
# Fetches the latest R-exts.texi and R headers from
# https://github.com/r-devel/r-svn (trunk branch).
#
# Usage:
#   Rscript scripts/r-api-report.R

# -- Paths ----

this_script <- sub("--file=", "", grep("--file=", commandArgs(FALSE), value = TRUE))
rstudio_root <- normalizePath(file.path(dirname(this_script), ".."))
rstudio_cpp <- file.path(rstudio_root, "src", "cpp")
stopifnot(dir.exists(rstudio_cpp))

outfile <- file.path(rstudio_root, "scripts", "r-api-report.txt")

# -- Step 0: Clone or update r-devel/r-svn ----

r_svn_repo <- "https://github.com/r-devel/r-svn.git"
r_svn_cache <- file.path(Sys.getenv("HOME"), ".cache", "rstudio", "r-svn")

if (dir.exists(file.path(r_svn_cache, ".git"))) {
   message("Updating r-devel/r-svn cache...")
   system2("git", c("-C", r_svn_cache, "fetch", "--depth=1", "origin", "trunk"))
   system2("git", c("-C", r_svn_cache, "checkout", "FETCH_HEAD", "--", "doc/manual", "src/include"))
} else {
   message("Cloning r-devel/r-svn (sparse, shallow)...")
   dir.create(dirname(r_svn_cache), recursive = TRUE, showWarnings = FALSE)
   system2("git", c("clone", "--depth=1", "--filter=blob:none", "--sparse", r_svn_repo, r_svn_cache))
   system2("git", c("-C", r_svn_cache, "sparse-checkout", "set", "doc/manual", "src/include"))
}

texi_path <- file.path(r_svn_cache, "doc", "manual", "R-exts.texi")
r_include <- file.path(r_svn_cache, "src", "include")
stopifnot(file.exists(texi_path))

texi <- readLines(texi_path)

# -- Step 1: Extract API symbols from R-exts.texi ----

extract_texi_symbols <- function(tags) {
   pattern <- paste0("@(", paste(tags, collapse = "|"), ") ([A-Za-z_][A-Za-z0-9_]*)")
   m <- regmatches(texi, regexec(pattern, texi))
   unique(vapply(m[lengths(m) > 0], `[[`, character(1), 3))
}

public_api <- extract_texi_symbols(c("apifun", "eapifun", "apivar", "eapivar"))

# Treat symbols exported by graphics headers as public API
for (gfx_header in c("R_ext/GraphicsEngine.h", "R_ext/GraphicsDevice.h")) {
   path <- file.path(r_include, gfx_header)
   if (file.exists(path)) {
      lines <- readLines(path)
      m <- regmatches(lines, gregexpr("\\b(R_|Rf_|GE)[A-Za-z_][A-Za-z0-9_]*", lines))
      public_api <- unique(c(public_api, unlist(m)))
   }
}

embed_api <- extract_texi_symbols(c("embfun", "embvar"))
embed_extras <- c(
   "Rf_initialize_R", "Rf_mainloop", "R_Suicide", "R_Consolefile", "R_Outputfile",
   "R_CStackStart", "R_running_as_main_program", "R_DirtyImage", "R_HomeDir",
   "R_Quiet", "R_NoEcho", "R_Verbose", "R_SignalHandlers",
   "R_SaveGlobalEnvToFile", "R_RestoreGlobalEnvFromFile"
)
embed_api <- unique(c(embed_api, embed_extras))

former_api <- extract_texi_symbols("forfun")

# -- Step 2: Extract R C API symbols used by RStudio ----

# Scan source files (excluding RInternal.hpp, RRuntime.cpp, and binary files)
source_files <- list.files(
   rstudio_cpp,
   pattern = "\\.(c|cc|cpp|h|hpp|mm)$",
   recursive = TRUE,
   full.names = TRUE
)
source_files <- source_files[!grepl("RInternal\\.hpp$|RRuntime\\.cpp$", source_files)]

all_source <- unlist(lapply(source_files, readLines, warn = FALSE))

extract_matches <- function(pattern) {
   m <- regmatches(all_source, gregexpr(pattern, all_source, perl = TRUE))
   unique(unlist(m))
}

rf_symbols <- extract_matches("\\bRf_[a-zA-Z_][a-zA-Z0-9_]*")
r_symbols <- extract_matches("\\bR_[a-zA-Z][a-zA-Z0-9_]*")

r_macros <- c(
   "ALTREP", "ATTRIB", "BODY", "CAAR", "CADR", "CADDR", "CADDDR", "CAD4R",
   "CAD5R", "CAR", "CDAR", "CDDDR", "CDDR", "CDR", "CHAR", "CLEAR_ATTRIB",
   "CLOENV", "COMPLEX", "COMPLEX_ELT", "DATAPTR", "DATAPTR_OR_NULL",
   "DATAPTR_RO", "DUPLICATE_ATTRIB", "ENCLOS", "FORMALS", "FRAME", "HASHTAB",
   "INTEGER", "INTEGER_ELT", "INTERNAL", "IS_SCALAR", "IS_SIMPLE_SCALAR",
   "LENGTH", "LEVELS", "LOGICAL", "LOGICAL_ELT", "MARK_NOT_MUTABLE", "MISSING",
   "NAMED", "OBJECT", "PRCODE", "PRENV", "PRINTNAME", "PROTECT",
   "PROTECT_WITH_INDEX", "PRVALUE", "RAW", "RAW_ELT", "REAL", "REAL_ELT",
   "REAL_RO", "INTEGER_RO", "LOGICAL_RO", "COMPLEX_RO", "RAW_RO", "SETCAR",
   "SETCDR", "SETCADR", "SETCADDR", "SETCADDDR", "SETCAD4R", "SETLEVELS",
   "SET_ATTRIB", "SET_COMPLEX_ELT", "SET_INTEGER_ELT", "SET_LOGICAL_ELT",
   "SET_MISSING", "SET_NAMED", "SET_RAW_ELT", "SET_REAL_ELT", "SET_S4_OBJECT",
   "SET_STRING_ELT", "SET_TAG", "SET_TYPEOF", "SET_VECTOR_ELT",
   "SHALLOW_DUPLICATE_ATTRIB", "STRING_ELT", "SYMVALUE", "TAG", "TYPEOF",
   "UNPROTECT", "VECTOR_ELT", "XLENGTH"
)
macro_pattern <- paste0("\\b(", paste(r_macros, collapse = "|"), ")\\s*\\(")
macro_matches <- regmatches(all_source, gregexpr(macro_pattern, all_source, perl = TRUE))
macro_matches <- unique(trimws(gsub("\\($", "", unlist(macro_matches))))

all_symbols <- unique(c(rf_symbols, r_symbols, macro_matches))

# Filter R_/Rf_ symbols to only those that appear in R's headers
r_header_files <- list.files(r_include, pattern = "\\.h$", recursive = TRUE, full.names = TRUE)
r_header_content <- paste(unlist(lapply(r_header_files, readLines, warn = FALSE)), collapse = "\n")

all_symbols <- Filter(function(sym) {
   if (grepl("^(R_|Rf_)", sym)) {
      grepl(paste0("\\b", sym, "\\b"), r_header_content, perl = TRUE)
   } else {
      TRUE
   }
}, all_symbols)

# Remove types, header guards, preprocessor macros
type_excludes <- c(
   "R_xlen_t", "R_SIZE_T", "R_ARCH", "R_HOME", "R_ext", "R_INTERFACE_PTRS",
   "R_INTERNALS_H_", "R_NO_REMAP", "R_USE_PROTOTYPES", "R_USE_SIGNALS",
   "SEXP", "R_CFinalizer_t", "R_CallMethodDef", "R_ObjectTable",
   "R_INCLUDE_", "R_LEN_T", "R_INLINE"
)
all_symbols <- setdiff(all_symbols, type_excludes)

# -- Step 3: Classify each symbol ----

classify <- function(sym) {
   short <- sub("^Rf_", "", sym)
   if (sym %in% public_api || short %in% public_api) return("public")
   if (sym %in% embed_api || short %in% embed_api) return("embed")
   if (sym %in% former_api || short %in% former_api) return("former")
   "nonapi"
}

classes <- vapply(all_symbols, classify, character(1))

result <- split(names(classes), classes)
for (cls in c("public", "embed", "former", "nonapi")) {
   if (is.null(result[[cls]])) result[[cls]] <- character(0)
}

# -- Step 4: Count uses for display ----

count_uses <- function(sym) {
   pattern <- paste0("\\b", sym, "\\b")
   matches <- grep(pattern, all_source, perl = TRUE, value = TRUE)
   # exclude comment-only lines
   matches <- matches[!grepl("^\\s*//", matches)]
   matches <- matches[!grepl("^\\s*\\*", matches)]
   length(matches)
}

# -- Step 5: Write report ----

out <- character()
ln <- function(...) out <<- c(out, paste0(...))

ln("R API Compliance Report")
ln("============================================================")
ln("")
ln("Generated: ", format(Sys.Date()))
ln("Source:    ", r_svn_repo, " (trunk)")
ln("Scanned:  src/cpp/ (excluding RInternal.hpp, RRuntime.cpp)")
ln("")
ln("Public API symbols used:    ", length(result$public))
ln("Embedding API symbols used: ", length(result$embed))
if (length(result$former) > 0) {
   ln("Former API symbols used:    ", length(result$former))
}
ln("Non-API symbols used:       ", length(result$nonapi))
ln("")

write_symbol_table <- function(symbols, header, subtitle = NULL) {
   if (length(symbols) == 0) return()

   ln(header)
   ln("------------------------------------------------------------")
   if (!is.null(subtitle)) ln(subtitle)
   ln("")
   ln(sprintf("%-35s %s", "Symbol", "Uses"))
   ln(sprintf("%-35s %s", "------", "----"))

   counts <- vapply(sort(symbols), count_uses, integer(1))
   for (sym in names(counts[counts > 0])) {
      ln(sprintf("%-35s %d", sym, counts[[sym]]))
   }
   ln("")
}

write_symbol_table(result$nonapi, "Non-Public API Symbols")
write_symbol_table(
   result$embed,
   "Embedding API Symbols",
   "(Documented in the \"Embedding R\" chapter, separate from public C API)"
)

if (length(result$former) > 0) {
   ln("Former API Symbols")
   ln("------------------------------------------------------------")
   ln("")
   for (sym in sort(result$former)) ln("  ", sym)
   ln("")
}

writeLines(out, outfile)
message("Report written to ", outfile)
message("")
writeLines(readLines(outfile))

#
# SessionPatches.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.registerPackageLoadHook("rstudioapi", function(...)
{
   # bail if we're not version 0.7
   if (packageVersion("rstudioapi") != "0.7")
      return()
   
   # re-assign the 'selectDirectory()' function
   rstudioapi <- asNamespace("rstudioapi")
   override <- function(caption = "Select Directory",
                        label = "Select",
                        path = rstudioapi::getActiveProject())
   {
      callFun("selectDirectory", caption, label, path)
   }
   environment(override) <- rstudioapi
   
   .rs.replaceBinding("selectDirectory", "rstudioapi", override)
})

.rs.registerPackageLoadHook("parallel", function(...)
{
   # enforce sequential setup of cluster
   # https://github.com/rstudio/rstudio/issues/6692
   parallel:::setDefaultClusterOptions(setup_strategy = "sequential")
})

.rs.registerPackageLoadHook("renv", function(...)
{
   # if 'renv.download.headers' has already been set, do nothing
   headers <- getOption("renv.download.headers")
   if (!is.null(headers))
      return(NULL)
   
   # compute authorization headers for renv using .netrc if available
   options(renv.download.headers = function(url) {
      authorization <- .rs.computeAuthorizationHeader(url)
      if (length(authorization) && nzchar(authorization))
         c(Authorization = authorization)
   })
})

# On Windows, because we now set the active code page to UTF-8,
# we need to be careful to ensure the outputs from list.files(), list.dirs()
# and dir() have their encoding properly marked. We do this here.
if (.rs.platform.isWindows)
{
   setHook("rstudio.sessionInit", function(...)
   {
      enabled <- getOption("rstudio.enableFileHooks", default = getRversion() < "4.2.0")
      if (identical(enabled, TRUE))
         .rs.files.replaceBindings()
   })
}

#
# SessionDebugging.R
#
# Copyright (C) 2024 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar("debugging.activeSink", NULL)

.rs.addFunction("debugging.beginSinkOutput", function(file)
{
   # Open write connection to file.
   conn <- file(file, open = "a")
   .rs.setVar("debugging.activeSink", conn)
   
   # Sink output to this file.
   sink(conn, append = TRUE, type = "output")
   sink(conn, append = TRUE, type = "message")
})

.rs.addFunction("debugging.endSinkOutput", function()
{
   # Close the sinks.
   sink(NULL, type = "output")
   sink(NULL, type = "message")
   
   # Close the fifo connection.
   conn <- .rs.getVar("debugging.activeSink")
   close(conn)
})

.rs.addFunction("debugging.printTraceback", function()
{
   if (requireNamespace("rlang", quietly = TRUE))
   {
      opts <- options("rlang:::visible_bottom" = parent.frame())
      on.exit(options(opts), add = TRUE)
      print(rlang::trace_back())
   }
   else
   {
      print(sys.calls())
   }
})

#
# SessionBreakpoints.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# given a function name and filename, find the environment that contains a
# function with the given name that originated from the given file.
.rs.addFunction("getEnvironmentOfFunction", function(objName,
                                                     fileName,
                                                     packageName)
{
   objName <- .rs.unquote(objName)
   
   # assume fileName is UTF-8 encoded unless it's already got a labelled
   # encoding
   if (Encoding(fileName) == "unknown")
      Encoding(fileName) <- "UTF-8"

   isPackage <- nzchar(packageName)

   # when searching specifically for a function in a package, search from the
   # package namespace to the global environment (considers package imports and
   # non-exported functions); otherwise, search from the global environment to
   # the empty namespace
   lastEnvir <- if (isPackage) "R_GlobalEnv" else "R_EmptyEnv"
   env <- if (isPackage)
             asNamespace(packageName)
          else
             globalenv()
   while (environmentName(env) != lastEnvir)
   {
      # if the function with the given name exists in this environment...
      if (!is.null(env) &&
          exists(objName, env, mode = "function", inherits = FALSE))
      {
         # we need the source reference to look up the filename; we may need to
         # access the original copy of a traced function to get this
         srcref <- .rs.getSrcref(get(objName, env))
         if (!is.null(srcref))
         {
            # get the name of the file from which the function originated, and
            # trim off the trailing space
            fileattr <- attr(srcref, "srcfile")

            # if the srcref has a srcfile, resolve it (if it exists) and
            # compare with the input we were given
            if (!is.null(fileattr) &&
                (normalizePath(fileattr$filename, mustWork = FALSE) == 
                 normalizePath(fileName)))
            {
               return(env)
            }
         }
      }
      env <- parent.env(env)
   }
   return(NULL)
})

# given the body of a function, search recursively through its parsed
# representation for a step with a given source reference line number.
.rs.addFunction("stepsAtLine", function(funBody, line)
{
   if (!is.call(funBody))
      return(NULL)

   # only consider source references attached to braced function bodies.
   # otherwise, we could end up recursing into source references that
   # aren't relevant to our current debug attempts.
   #
   # https://github.com/rstudio/rstudio/issues/14815
   refs <- if (identical(funBody[[1L]], as.symbol("{")))
   {
      attr(funBody, "srcref", exact = TRUE)
   }
   
   for (idx in 1:length(funBody))
   {
      # if there's a source ref on this line, check it against the line number
      # provided by the caller.
      ref <- refs[[idx]]
      if (length(ref) > 0)
      {
         if (line > ref[3] || line < ref[1])
         {
            next
         }
      }

      # check for sub-steps--these exist when there's a nested function
      nestedFunSteps <- .rs.stepsAtLine(funBody[[idx]], line)
      if (!is.null(nestedFunSteps))
      {
         return(c(idx, nestedFunSteps))
      }

      # match functions rather than opening brackets
      if (length(ref) > 0 &&
          !(typeof(funBody[[idx]]) == "symbol" &&
            identical(as.character(funBody[[idx]]), "{")))
      {
         return(idx)
      }
   }
   return(NULL)
})

# Given the body of the function, return the substeps of the function on which
# a breakpoint was set (not the substep of the breakpoint itself).
.rs.addFunction("findBreakpointSteps", function(funBody)
{
   if (typeof(funBody) != "language")
   {
      return(NULL)
   }
   for (idx in 1:length(funBody))
   {
      # if this is a doTrace call, we found a breakpoint; stop recursion here
      if (is.call(funBody[[idx]]) && 
          identical(as.character(funBody[[idx]][[1]])[[1]], ".doTrace"))
      {
         return(idx + 1)
      }
      nestedSteps <- .rs.findBreakpointSteps(funBody[[idx]])
      if (!is.null(nestedSteps))
      {
         return(c(idx, nestedSteps))
      }
   }
})

# Given a function, return the function with all of the breakpoints removed.
.rs.addFunction("removeBreakpoints", function(fun)
{
   repeat
   {
      # Find the step on which a breakpoint was set
      inner <- .rs.findBreakpointSteps(body(fun))
      if (length(inner) < 2)
         break;

      # Replace the outer expression (which contains the breakpoint) with the
      # inner one (which contains the expression formerly wrapped by the
      # breakpoint)
      outer <- inner[1:(length(inner)-1)]
      body(fun)[[outer]] <- body(fun)[[inner]]
   }
   fun
})

# given a traced function body and the original function body, recursively copy
# the source references from the original body to the traced body, adding
# source references to the injected trace code from the line being traced
.rs.addFunction("tracedSourceRefs", function(funBody, originalFunBody)
{
   if (is.call(funBody) &&
       is.call(originalFunBody) &&
       length(funBody) == length(originalFunBody))
   {
      for (i in seq_along(funBody))
      {
         # Check for an invocation of trace.
         #
         # {
         #   .doTrace(browser())
         #   <expr>
         # }
         #
         isTraceCall <-
            is.call(funBody[[i]]) &&
            length(funBody[[i]]) >= 2 &&
            identical(funBody[[i]][[1L]], as.symbol("{")) &&
            is.call(funBody[[i]][[2L]]) &&
            identical(funBody[[i]][[2L]][[1L]], as.symbol(".doTrace"))
         
         if (isTraceCall)
         {
            # We found a trace call; copy the source references from
            # the original function body into each node of the call
            # to `.doTrace(browser())`.
            srcRefs <- .rs.nullCoalesce(
               attr(funBody, "srcref")[[i]],
               attr(originalFunBody, "srcref")[[i]]
            )
            
            repSrcRefs <- rep(list(srcRefs), length(funBody[[i]]))
            attr(funBody[[i]], "srcref") <- repSrcRefs
         }
         else if (is.call(funBody[[i]]) &&
                  is.call(originalFunBody[[i]]) &&
                  length(funBody[[i]]) == length(originalFunBody[[i]]))
         {
            # Recurse into non-traced body elements
            funBody[[i]] <- .rs.tracedSourceRefs(
               funBody[[i]],
               originalFunBody[[i]]
            )
         }
      }
   }
   
   funBody
})

.rs.addFunction("getFunctionSteps", function(fun, functionName, lineNumbers)
{
   funBody <- body(fun)
   lineNumbers <- unique(lineNumbers)

   # attempt to find the end line of the function
   funStartLine <- 0
   funEndLine <- 0
   funSrcRef <- attr(fun, "srcref")
   if (!is.null(funSrcRef) && length(funSrcRef) > 3)
   {
      funStartLine <- funSrcRef[1]
      funEndLine <- funSrcRef[3]
   }
   else
   {
      return(list())
   }

   # process each line on which a breakpoint was requested
   lapply(lineNumbers, function(lineNumber)
   {
      # don't try to process lines that aren't inside the body of the function
      steps <- integer()
      if (lineNumber >= funStartLine &&
          lineNumber <= funEndLine)
      {
         # if we don't find any function steps associated with the given line
         # number, keep trying the next one until we do, up to the end of the
         # function (as marked by its source references)
         repeat
         {
            steps <- .rs.stepsAtLine(funBody, lineNumber)
            if (length(steps) > 0 ||
                lineNumber >= funEndLine)
            {
               break
            }
            lineNumber <- lineNumber + 1
         }
      }

      list(
         name = .rs.scalar(functionName),
         line = .rs.scalar(lineNumber),
         at = .rs.scalar(paste(steps, collapse = ","))
      )
   })

})

# this function is used to get the steps in the given function that are
# associated with the given line number, using the function's source
# references.
.rs.addFunction("getSteps", function(functionName,
                                     fileName,
                                     packageName,
                                     lineNumbers)
{
   .rs.getFunctionSteps(
                  .rs.getUntracedFunction(functionName, fileName, packageName),
                  functionName,
                  lineNumbers)
})

.rs.addFunction("setFunctionBreakpoints", function(functionName,
                                                   envir,
                                                   steps)
{
   functionName <- .rs.unquote(functionName)
   if (length(steps) == 0 || all(nchar(steps) == 0))
   {
      # Restore the function to its original state. Note that trace/untrace
      # emit messages when they act on a function in a package environment; hide
      # those messages since they're just noise to the user.
      fun <- get(functionName, envir = envir)
      if (.rs.isTraced(fun))
      {
         suppressMessages(untrace(
            what = functionName,
            where = envir))
      }
   }
   else
   {
      # unlock the binding if necessary to inject the source references;
      # bindings are often locked in package environments
      if (bindingIsLocked(functionName, envir))
      {
         unlockBinding(functionName, envir)
         on.exit(lockBinding(functionName, envir), add = TRUE)
      }
      
      # inject the browser calls
      suppressMessages(
         trace(
            what = functionName,
            where = envir,
            at = lapply(strsplit(as.character(steps), ","), as.numeric),
            tracer = browser,
            print = FALSE
         )
      )

      # remap the source references so that the code injected by trace() is
      # mapped back to the line on which the breakpoint was set.  We need to
      # assign directly to the @.Data internal slot since assignment to the
      # public-facing body of the function will remove the tracing information.
      body(envir[[functionName]]@.Data) <- .rs.tracedSourceRefs(
         body(envir[[functionName]]@.Data),
         body(envir[[functionName]]@original)
      )
      
      # we also need to manually remap source refs for registered S3 methods
      s3methods <- envir$.__S3MethodsTable__.
      if (is.function(s3methods[[functionName]]))
      {
         # unlock the binding if necessary to inject the source references;
         # bindings are often locked in package environments
         if (bindingIsLocked(functionName, s3methods))
         {
            unlockBinding(functionName, s3methods)
            on.exit(lockBinding(functionName, s3methods), add = TRUE)
         }

         body(s3methods[[functionName]]@.Data) <- .rs.tracedSourceRefs(
            body(s3methods[[functionName]]@.Data),
            body(s3methods[[functionName]]@original)
         )
      }
   }
   return(functionName)
})

.rs.addFunction("getUntracedFunctionS7Method", function(functionName,
                                                        fileName,
                                                        packageName)
{
   # Check if the S7 package is loaded
   if (!"S7" %in% loadedNamespaces())
      return(NULL)
   
   # Try to parse functionName as an expression
   expr <- parse(text = functionName)[[1L]]
   if (!is.call(expr) || length(expr) < 3L)
      return(NULL)
   
   # Check if this appears to be an invocation of `S7::method`.
   S7 <- asNamespace("S7")
   method <- .rs.safeEval(expr[[1L]], envir = globalenv())
   if (!identical(method, S7$method))
      return(NULL)
   
   # It looks like an S7 method. Let's see if we can figure out
   # where the actual definition lives.
   matched <- match.call(method, expr)
   generic <- eval(matched[["generic"]], envir = globalenv())
   s7generic <- S7$as_generic(generic)
   
   if (inherits(s7generic, "S7_S3_generic"))
   {
      f <- as.character(matched[["generic"]])
      class <- eval(matched[["class"]], envir = globalenv())
      getS3method(f, class@name)
   }
   else if (inherits(s7generic, "S7_generic"))
   {
      eval(matched, envir = globalenv())
   }
})

.rs.addFunction("getUntracedFunction", function(functionName,
                                                fileName,
                                                packageName)
{
   functionName <- .rs.unquote(functionName)
   
   # If this appears to be an S7 method definition, we need
   # to look up the actual underlying function by hand.
   method <- tryCatch(
      .rs.getUntracedFunctionS7Method(functionName, fileName, packageName),
      error = function(cnd) NULL
   )
   
   if (is.function(method))
      return(.rs.untraced(method))
   
   envir <- .rs.getEnvironmentOfFunction(functionName, fileName, packageName)
   if (is.null(envir))
      return(NULL)
   
   .rs.untraced(get(functionName, mode = "function", envir = envir))
})

.rs.addFunction("isFunctionInSync", function(functionName,
                                             filePath,
                                             packageName)
{
   tryCatch(
      .rs.isFunctionInSyncImpl(functionName, filePath, packageName),
      error = function(e) FALSE
   )
})

.rs.addFunction("isFunctionInSyncImpl", function(functionName,
                                                 filePath,
                                                 packageName)
{
   # Screen out ~/.active-rstudio-document, just in case.
   if (identical(filePath, "~/.active-rstudio-document"))
      return(FALSE)
   
   # Find the function definition.
   functionName <- .rs.unquote(functionName)
   funcDefn <- .rs.getUntracedFunction(functionName, filePath, packageName)
   if (is.null(funcDefn))
      return(FALSE)
   
   # Get the source definition of this function.
   srcref <- attr(funcDefn, "srcref")
   functionLines <- .rs.deparseSrcref(srcref, FALSE)
   
   # Check if this matches the file contents. Note that we intentionally
   # use 'first_line' and 'last_line' below, as we're referencing against
   # the "real" source file as opposed to an alias of copy (as might be
   # used for e.g. package code).
   fileContents <- .rs.readLines(filePath)
   srcPos <- .rs.parseSrcref(srcref)
   srcLines <- seq(from = srcPos$first_line, to = srcPos$last_line)
   functionSrcLines <- fileContents[srcLines]
   
   # Check if they match.
   identical(functionLines, functionSrcLines)
   
})

# Parses and executes a file for debugging
.rs.addFunction("executeDebugSource", function(fileName, encoding, breaklines, local)
{
   envir <-
      if (isTRUE(local)) {
         # If local is TRUE, we take the first frame as it's what was artificially
         # constructed in earlier code
         sys.frames()[[1]]
      } else if (identical(local, FALSE)) {
         .GlobalEnv
      } else if (is.environment(local)) {
         local
      } else {
         stop("'local' must be TRUE, FALSE or an environment")
      }

   # Create a function containing the parsed contents of the file
   env <- new.env(parent = emptyenv())
   env$fun <- .rs.makeSourceEquivFunction(fileName, encoding, envir)
   breakSteps <- character()

   # Inject the breakpoints
   if (length(breaklines) > 0)
   {
      steps <- .rs.getFunctionSteps(env$fun, "fun", breaklines)
      breakSteps <- unlist(lapply(steps, function(step) step$at))
      suppressWarnings(.rs.setFunctionBreakpoints(
            "fun", env, lapply(steps, function(step) { step$at } )))
   }

   # Run it!
   env$fun()

   # We injected function breakpoints above, but we don't want to leave them
   # in the in-memory copies of the functions. Replay the assignment that 
   # created the original copy of the function. The client will set proper
   # breakpoints on the functions later.
   env$fun <- .rs.removeBreakpoints(env$fun)
   breakSteps <- breakSteps[nchar(breakSteps) > 6]
   for (steps in breakSteps) {
      step <- as.numeric(strsplit(breakSteps, ",")[[1]][3]) 
      op <- deparse(body(env$fun)[[2]][[2]][[step]][[1]]) 
      if (op == "<-" || op == "=") 
         eval(body(env$fun)[[2]][[2]][[step]], envir = globalenv())
   }

   return(NULL)

}, attrs = list(hideFromDebugger = TRUE))

.rs.addFunction("getShinyFunction", function(name, where)
{
   if (is(where, "refClass"))
      where$field(name)
   else 
      get(name, where)
})

.rs.addFunction("setShinyFunction", function(name, where, val)
{
   if (is(where, "refClass"))
      where$field(name, val)
   else
      assign(name, val, where)
})

.rs.addFunction("setShinyBreakpoints", function(name, where, lines)
{
   # Create a blank environment and load the function into it
   env <- new.env(parent = emptyenv())
   env$fun <- .rs.getShinyFunction(name, where) 

   # Get the steps of the function corresponding to the lines on
   # which breakpoints are to be set, and set breakpoints there
   steps <- .rs.getFunctionSteps(env$fun, "fun", lines)

   suppressWarnings(.rs.setFunctionBreakpoints(
         "fun", env, lapply(steps, function(step) { step$at } )))

   # Store the updated copy of the function back into Shiny
   .rs.setShinyFunction(name, where, env$fun)
})

# Given a filename, creates a source-equivalent function: a function that,
# when executed, has the same effect as sourcing the file.
.rs.addFunction("makeSourceEquivFunction", function(filename, encoding, envir = globalenv())
{
   content <- suppressWarnings(parse(filename, encoding = encoding))

   # Create an empty function to host the expressions in the file
   fun <- function() 
   {
      evalq({ 1 }, envir = envir)
   }

   # Copy each statement from the file into the eval body of the function
   for (i in 1:length(content)) {
     body(fun)[[2]][[2]][[i + 1]] <- content[[i]]
   }

   # Set up the source references 
   refs <- attr(content, "srcref")
   lastref <- length(refs)
   attr(body(fun), "srcfile") <- attr(content, "srcfile")

   # Simulate a source reference that contains the whole function by 
   # combining the first and last source references of each statement in 
   # the function
   ref <- structure(c(refs[[1]][1], refs[[1]][2], 
                      refs[[lastref]][3], refs[[lastref]][[4]], 
                      refs[[1]][5], refs[[lastref]][6], 
                      refs[[1]][1], refs[[lastref]][3]), 
                    srcfile = attr(content, "srcfile"), 
                    class = "srcref")
   attr(body(fun), "srcref")[[2]] <- ref
   linerefs <- list(attr(content, "srcref")[[1]])
   for (i in 1:length(content)) {
      linerefs[[i + 1]] <- attr(content, "srcref")[[i]]
   }
   attr(body(fun)[[2]][[2]], "srcref") <- linerefs
   attr(fun, "srcref") <- ref
   return(fun)
})

.rs.addGlobalFunction("debugSource", function(fileName,
                                              echo = FALSE,
                                              encoding = "unknown",
                                              local = FALSE)
{
   # NYI: Consider whether we need to implement source with echo for debugging.
   # This would likely involve injecting print statements into the generated
   # source-equivalent function.

   # convert filename to UTF-8 before proceeding 
   invisible(.Call("rs_debugSourceFile", enc2utf8(fileName), encoding, local))
})

# Parameters expected to be in environment:
# where - environment or reference object 
# name - name of function or reference field name
# label - friendly label for function to show in callstack
.rs.addGlobalFunction("registerShinyDebugHook", function(params)
{
   # Get the function from storage in Shiny, and remove any breakpoints it may
   # already contain
   fun <- .rs.getShinyFunction(params$name, params$where)
   fun <- .rs.removeBreakpoints(fun)
   params$expr <- body(fun)

   # Copy source refs to the body of the function 
   attr(fun, "srcref") <- attr(body(fun), "wholeSrcref")
   params$fun <- fun

   # Register the function with RStudio (may set breakpoints)
   .Call("rs_registerShinyFunction", params)
})

.rs.addJsonRpcHandler("get_function_steps", function(
   functionName,
   fileName,
   packageName,
   lineNumbers)
{
   .rs.getSteps(functionName, fileName, packageName, lineNumbers)
})

.rs.addFunction("haveAdvancedSteppingCommands", function() {
   getRversion() >= "3.1" && .rs.haveRequiredRSvnRev(63400)
})

.rs.addFunction("unquote", function(strings)
{
   tryCatch(
      .rs.unquoteImpl(strings),
      error = function(e) strings
   )
})

.rs.addFunction("unquoteImpl", function(strings)
{
   if (!is.character(strings))
      return(strings)
   parsed <- parse(text = strings)
   vapply(parsed, as.character, FUN.VALUE = character(1))
})


.rs.addFunction("setBreakpointImpl", function(functionName,
                                              fileName,
                                              packageName,
                                              steps)
{
   if (!"S7" %in% loadedNamespaces())
      return(FALSE)
   
   expr <- parse(text = functionName)[[1L]]
   if (!is.call(expr) || length(expr) < 3L)
      return(FALSE)
   
   method <- .rs.safeEval(expr[[1L]], envir = globalenv())
   if (!identical(method, S7::method))
      return(FALSE)
   
   expr <- match.call(S7::method, expr)
   generic <- eval(expr[["generic"]], envir = globalenv())
   if (!is.function(generic))
      return(FALSE)
   
   s7generic <- S7:::as_generic(generic)
   s7class <- eval(expr[["class"]], envir = globalenv())
   if (inherits(s7generic, "S7_S3_generic"))
   {
      methodName <- paste(s7generic$name, s7class@name, sep = ".")
      methodEnvir <- environment(generic)[[".__S3MethodsTable__."]]
   }
   else if (inherits(s7generic, "S7_generic"))
   {
      methodName <- s7class@name
      methodEnvir <- s7generic@methods
   }
   else
   {
      return(FALSE)
   }
   
   .rs.setFunctionBreakpoints(
      functionName = methodName,
      envir = methodEnvir,
      steps = steps
   )
})

.rs.addFunction("setBreakpoint", function(functionName,
                                          fileName,
                                          packageName,
                                          steps)
{
   ok <- tryCatch(
      .rs.setBreakpointImpl(functionName, fileName, packageName, steps),
      error = function(cnd) FALSE
   )
   
   if (!identical(ok, FALSE))
      return(TRUE)
   
   envir <- .rs.getEnvironmentOfFunction(functionName, fileName, packageName)
   if (is.null(envir))
      return(FALSE)

   .rs.setFunctionBreakpoints(functionName, envir, steps)
})

# some laziness to ensure we move to the 'install-soci' folder
if (file.exists("rstudio.Rproj"))
   setwd("dependencies/windows/install-soci")

SOCI_VERSION         <- Sys.getenv("SOCI_VERSION", unset = "4.0.3")
BOOST_VERSION        <- Sys.getenv("BOOST_VERSION", unset = "1.91.0")
MSVC_TOOLSET_VERSION <- Sys.getenv("MSVC_TOOLSET_VERSION", unset = "143")
CMAKE_GENERATOR      <- Sys.getenv("CMAKE_GENERATOR", unset = "Visual Studio 17 2022")

# the source-tree folder containing this script and its helpers
script_dir <- getwd()
source("../tools.R")
section("Building SOCI %s", SOCI_VERSION)

# put RStudio tools on PATH (resolve now; the working directory may change)
PATH$prepend(normalizePath("../tools"))

# build into RSTUDIO_TOOLS_ROOT when set (see install-dependencies.cmd), so
# that build artifacts land outside the source tree; otherwise, build within
# the source tree as before
tools_root <- Sys.getenv("RSTUDIO_TOOLS_ROOT", unset = "")
if (nzchar(tools_root)) {
   install_dir <- file.path(tools_root, "dependencies/windows/install-soci")
   dir.create(install_dir, recursive = TRUE, showWarnings = FALSE)
   setwd(install_dir)
}

owd <- getwd()

# initialize log directory (for when things go wrong)
unlink("logs", recursive = TRUE)
dir.create("logs")
options(log.dir = normalizePath("logs"))

# initialize variables
output_dir <- normalizePath("..", winslash = "/")

soci_base_name <- paste0("soci-", SOCI_VERSION)
soci_tar <- paste0(soci_base_name, ".tar")
soci_archive <- paste0(soci_tar, ".gz")
soci_url <- paste0("https://rstudio-buildtools.s3.amazonaws.com/soci-", SOCI_VERSION, ".tar.gz")
soci_dir <- file.path(owd, soci_base_name)
soci_install_name <- sprintf("soci-msvc%s-%s", MSVC_TOOLSET_VERSION, SOCI_VERSION)
soci_install_dir <- file.path(owd, soci_install_name)
soci_build_dir <- file.path(soci_install_dir, "build")

sqlite_dir <- file.path(owd, "sqlite")
sqlite_header_zip_url <- "https://sqlite.org/2020/sqlite-amalgamation-3310100.zip"
sqlite_header_zip <- file.path(sqlite_dir, "sqlite-header.zip")
sqlite_header_dir <- file.path(sqlite_dir, "sqlite-amalgamation-3310100")

downloadAndUnzip <- function(outputFile, extractDir, url) {

   # download zip if we don't already have it
   if (!file.exists(outputFile)) {
      section("Downloading '%s' from '%s'", outputFile, url)
	  download(url, destfile = outputFile)
	  if (!file.exists(outputFile))
	     fatal("Failed to download '%s'", outputFile)
   }

   # extract zip file
   progress("Extracting zip file '%s'", outputFile)
   unzip(outputFile, exdir = extractDir)
}

soci_core_lib <- file.path(soci_build_dir, "x64/lib/Release/libsoci_core_4_0.lib")
if (file.exists(soci_core_lib)) {
   progress("SOCI is already installed; nothing to do.")
   if (!interactive()) quit()
}

# remove Rtools from the path, as it can confuse cmake and cause it
# to find standard library headers in the wrong location
path <- strsplit(Sys.getenv("PATH"), ";", fixed = TRUE)[[1L]]
path <- grep("C:\\\\(?:rtools|rbuildtools)", path, value = TRUE, invert = TRUE, ignore.case = TRUE)
Sys.setenv(PATH = paste(path, collapse = ";"))


# download and install sqlite source
dir.create(sqlite_dir, recursive = TRUE, showWarnings = FALSE)
downloadAndUnzip(sqlite_header_zip, sqlite_dir, sqlite_header_zip_url)

# build SQLite static library (the script lives in the source tree; its
# artifacts are placed relative to the current working directory)
run(shQuote(normalizePath(file.path(script_dir, "build-sqlite.cmd"))))

# clone repository if we dont already have it
if (!file.exists(soci_base_name)) {
   section("Downloading SOCI sources")
   download(soci_url, destfile = soci_archive)
   section("Unzipping SOCI sources")
   exec("7z.exe", "-aoa", "e", soci_archive)
   exec("7z.exe", "-aoa", "x", soci_tar)
}

# move extracted directory
file.rename(soci_dir, soci_install_dir)
setwd(soci_install_dir)

# create build directories
unlink("build", recursive = TRUE)
dir.create("build", showWarnings = FALSE, recursive = TRUE)
setwd("build")

build <- function(arch, config) {

   # compute architecture
   winarch <- if (arch == "x86") "Win32" else "x64"

   # build cmake arguments
   boost_arch <- if (arch == "x86") "boost32" else "boost64"
   boost_name <- sprintf("boost-%s-win-msvc%s-%s-static", BOOST_VERSION, MSVC_TOOLSET_VERSION, tolower(config))
   boost_root <- file.path(output_dir, boost_name, boost_arch)
   boost_include_dir <- list.files(file.path(boost_root, "include"), full.names = TRUE)
   boost_library_dir <- file.path(boost_root, "lib")

   boost_version_major <- format(numeric_version(BOOST_VERSION)[1, 1])
   boost_version_minor <- format(numeric_version(BOOST_VERSION)[1, 2])
   boost_version_patch <- format(numeric_version(BOOST_VERSION)[1, 3])

   sqlite_library_name <- sprintf("sqlite3-%s-%s.lib", tolower(config), arch)
   sqlite_library_path <- file.path(sqlite_dir, sqlite_library_name)

   # put together intro big string
   args <- interpolate('
      -G "{CMAKE_GENERATOR}"
      -A {winarch}
      -DCMAKE_VERBOSE_MAKEFILE=ON
      -DCMAKE_POLICY_VERSION_MINIMUM=3.5
      -DCMAKE_CXX_FLAGS="/FS /EHsc"
      -DBOOST_INCLUDEDIR="{boost_include_dir}"
      -DBOOST_LIBRARYDIR="{boost_library_dir}"
      -DBoost_MAJOR_VERSION="{boost_version_major}"
      -DBoost_MINOR_VERSION="{boost_version_minor}"
      -DBoost_SUBMINOR_VERSION="{boost_version_patch}"
      -DBoost_USE_STATIC_LIBS=ON
      -DSOCI_TESTS=OFF
      -DSOCI_SHARED=OFF
      -DWITH_POSTGRESQL=OFF
      -DWITH_SQLITE3=ON
      -DSQLITE3_INCLUDE_DIR="{sqlite_header_dir}"
      -DSQLITE3_LIBRARY="{sqlite_library_path}"
      ../..
   ')

   args <- gsub("\\s+", " ", args, perl = TRUE)

   # move to build directory
   dir.create(arch, showWarnings = FALSE)
   owd <- setwd(arch)
   on.exit(setwd(owd), add = TRUE)

   progress(sprintf("Configuring SOCI [%s-%s]", arch, config))
   run("cmake", args)

   progress(sprintf("Building SOCI [%s-%s]", arch, config))
   run("cmake --build . --config", config)

}

build("x86", "Debug")
build("x86", "Release")

build("x64", "Debug")
build("x64", "Release")

#
# NotebookConditions.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("notebookConditions.onWarning", function(cnd)
{
   msg <- if (.rs.globalCallingHandlers.shouldHandleWarning(cnd))
   {
      .rs.globalCallingHandlers.formatCondition(cnd, "Warning", "warning")
   }
   else
   {
      paste(as.character(cnd), collapse = "\n")
   }
   
   .Call("rs_signalNotebookCondition", 1L, msg, PACKAGE = "(embedding)")
   invokeRestart("muffleWarning")
})

.rs.addFunction("notebookConditions.onMessage", function(cnd)
{
   msg <- if (.rs.globalCallingHandlers.shouldHandleMessage(cnd))
   {
      .rs.globalCallingHandlers.formatCondition(cnd, NULL, "message")
   }
   else
   {
      # By default, `base::message()` will append a newline to the signalled
      # message condition, but `rlang::inform()` will not. Because our downstream
      # message handler expects a newline to be appended, we add one here for
      # rlang messages.
      if (inherits(cnd, "rlang_message"))
         paste(c(conditionMessage(cnd), ""), collapse = "\n")
      else
         paste(conditionMessage(cnd), collapse = "\n")
   }
   
   .Call("rs_signalNotebookCondition", 0L, msg, PACKAGE = "(embedding)")
   invokeRestart("muffleMessage")
})


# NOTE: we need to add condition handlers to the top level, but cannot
# actually do so if there is an R function context on the stack.
#
# To circumvent this, we define R functions with the code we need to run,
# but explicitly extract the body of that function, and then execute that
# at the top level.
.rs.addFunction("notebookConditions.connectCall", function()
{
   body(.rs.notebookConditions.connectImpl)
})

.rs.addFunction("notebookConditions.connectImpl", function()
{
   # NOTE: because the body of this function will be evaluated in the
   # global environment, we need to avoid defining variables here.
   #
   # https://github.com/rstudio/rstudio/issues/8834
   .rs.notebookConditions.handlerStack <-
      .Internal(.addCondHands(
         c("warning", "message"),
         list(
            warning = .rs.notebookConditions.onWarning,
            message = .rs.notebookConditions.onMessage
         ),
         base::globalenv(),
         NULL,
         TRUE
      ))
   
   base::assign(x = ".rs.notebookConditions.handlerStack",
                value = .rs.notebookConditions.handlerStack,
                envir = .rs.toolsEnv())
   
   base::rm(.rs.notebookConditions.handlerStack)
})

.rs.addFunction("notebookConditions.disconnectCall", function()
{
   body(.rs.notebookConditions.disconnectImpl)
})

.rs.addFunction("notebookConditions.disconnectImpl", function()
{
   # NOTE: because the body of this function will be evaluated in the
   # global environment, we need to avoid defining variables here.
   #
   # https://github.com/rstudio/rstudio/issues/8834
   .Internal(.resetCondHands(
      base::get(
         x = ".rs.notebookConditions.handlerStack",
         envir = .rs.toolsEnv()
      )
   ))
   base::rm(.rs.notebookConditions.handlerStack, envir = .rs.toolsEnv())
})

#
# SessionReticulate.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# synchronize with ReticulateEvent.java
.rs.setVar("reticulateEvents", list(
   PYTHON_INITIALIZED = "python_initialized",
   REPL_INITIALIZED   = "repl_initialized",
   REPL_ITERATION     = "repl_iteration",
   REPL_BUSY          = "repl_busy",
   REPL_TEARDOWN      = "repl_teardown"
))

.rs.setVar("reticulate.hookedMatplotlibModules", new.env(parent = emptyenv()))

.rs.setVar("python.moduleCache", new.env(parent = emptyenv()))

.rs.addJsonRpcHandler("python_get_completions", function(line, ctx)
{
   if (!requireNamespace("reticulate", quietly = TRUE))
      return(.rs.emptyCompletions())
   
   completions <- .rs.tryCatch(.rs.python.getCompletions(line, ctx))
   if (inherits(completions, "error"))
      return(.rs.emptyCompletions(language = "Python"))
   
   .rs.makeCompletions(
      token       = attr(completions, "token"),
      results     = as.character(completions),
      type        = attr(completions, "types"),
      packages    = attr(completions, "source"),
      quote       = FALSE,
      helpHandler = "reticulate:::help_handler",
      language    = "Python"
   )
})

.rs.addJsonRpcHandler("python_go_to_definition", function(line, offset)
{
   result <- .rs.python.goToDefinition(line, offset)
   .rs.scalar(result)
})

.rs.addFunction("python.goToDefinition", function(line, offset)
{
   # extract the line providing the object definition we're looking for
   text <- .rs.python.extractCurrentExpression(line, offset)
   if (!nzchar(text))
      return(FALSE)
   
   # try extracting this object
   object <- .rs.tryCatch(reticulate::py_eval(text, convert = FALSE))
   if (inherits(object, "error"))
      return(FALSE)
   
   # TODO: use object explorer to view modules? or navigate
   # to their module path? or something similar?
   if (inherits(object, "python.builtin.module"))
      return(FALSE)
   
   # check to see if 'inspect' can find the object sources
   inspect <- reticulate::import("inspect", convert = TRUE)
   info <- .rs.tryCatch(
      list(
         source = inspect$getsourcefile(object),
         line = inspect$findsource(object)[[2]]
      )
   )
   
   if (inherits(info, "error"))
      return(FALSE)
   
   .rs.api.navigateToFile(info$source, info$line + 1L, 1L)
   return(TRUE)
   
})

.rs.addJsonRpcHandler("python_go_to_help", function(line, offset)
{
   result <- .rs.python.goToHelp(line, offset)
   .rs.scalar(result)
})

.rs.addFunction("python.goToHelp", function(line, offset)
{
   text <- .rs.python.extractCurrentExpression(line, offset)
   if (!nzchar(text))
      return(FALSE)
   
   .Call("rs_showPythonHelp", text, PACKAGE = "(embedding)")
   return(TRUE)
})

.rs.addFunction("reticulate.enqueueClientEvent", function(type, data)
{
   data <- list(type = .rs.scalar(type), data = data)
   .rs.enqueClientEvent("reticulate_event", data)
})

.rs.addFunction("reticulate.initialize", function()
{
   # try to default to the tkAgg backend (note that we'll
   # force a vanilla 'agg' backend when required otherwise)
   engine <- tolower(Sys.getenv("MPLENGINE"))
   if (engine %in% c("", "qt5agg"))
      Sys.setenv(MPLENGINE = "tkAgg")
   
   # update default version of Python to be used when reticulate is loaded
   .rs.registerPackageLoadHook("reticulate", function(...)
   {
      python <- .rs.readUiPref("python_path")
      .rs.reticulate.usePython(python)
      
      if (packageVersion("reticulate") >= "1.23")
      {
         .rs.addFunction("reticulate.describeObjectLength", function(object)
         {
            reticulate::py_len(object, -1L)
         })
      }
   })
   
})

.rs.addFunction("reticulate.onPythonInitialized", function()
{
   builtins <- reticulate::import_builtins(convert = FALSE)
   
   # override help method (Python's interactive help does
   # not play well with RStudio)
   help <- builtins$help
   .rs.setVar("reticulate.help", builtins$help)
   builtins$help <- function(...) {
      dots <- list(...)
      if (length(dots) == 0) {
         message("Error: Interactive Python help not available within RStudio")
         return()
      }
      help(...)
   }
   
   # ensure matplotlib hooks are injected on load
   setHook(
      "reticulate::matplotlib.pyplot::load",
      function(...) .rs.reticulate.matplotlib.onLoaded()
   )
   
   setHook(
      "reticulate::matplotlib.pylab::load",
      function(...) .rs.reticulate.matplotlib.onLoaded()
   )
   
   # NOTE: Depending on how pyplot is loaded, the reticulate hooks might
   # not 'see' it. For that reason, we also hook the base 'matplotlib'
   # load hook, and override show when that is loaded.
   #
   # https://github.com/rstudio/rstudio/issues/12053
   setHook(
      "reticulate::matplotlib::load",
      function(...) .rs.reticulate.matplotlib.onLoaded()
   )
   
})

.rs.addFunction("reticulate.matplotlib.onLoaded", function()
{
   # install matplotlib hook if available
   canInstallHooks <-
      requireNamespace("png", quietly = TRUE) &&
      reticulate::py_module_available("matplotlib")
   
   if (!canInstallHooks)
      return()
   
   matplotlib <- reticulate::import("matplotlib", convert = TRUE)
   
   # force the "Agg" backend (this is necessary as other backends may
   # fail with RStudio if requisite libraries are not available)
   backend <- matplotlib$get_backend()
   if (!identical(tolower(backend), "agg"))
   {
      sys <- reticulate::import("sys", convert = TRUE)
      if ("matplotlib.backends" %in% names(sys$modules))
         matplotlib$pyplot$switch_backend("agg")
      else
         matplotlib$use("agg", warn = FALSE, force = TRUE)
   }
   
   moduleNames <- c("matplotlib.pyplot", "matplotlib.pylab")
   for (moduleName in moduleNames) {
      
      # if we've already hooked this module, nothing to do
      if (exists(moduleName, envir = .rs.reticulate.hookedMatplotlibModules))
         next
      
      # if the requisite module hasn't been loaded yet, nothing to do
      sys <- reticulate::import("sys", convert = TRUE)
      if (is.null(sys$modules[[moduleName]]))
         next
   
      # otherwise, install our hook
      module <- reticulate::import(moduleName, convert = TRUE)
      module$show <- .rs.reticulate.matplotlib.showHook
      assign(moduleName, TRUE, envir = .rs.reticulate.hookedMatplotlibModules)
      
   }
   
})

.rs.addFunction("reticulate.matplotlib.showHook", function(...)
{
   # read device size
   size <- dev.size(units = "in")
   width  <- size[1]
   height <- size[2]
   dpi    <- 92
   
   # adjust for pixel ratio
   ratio  <- .Call("rs_devicePixelRatio", PACKAGE = "(embedding)")
   dpi    <- dpi * ratio
   
   # TODO: get device requested from matplotlib?
   # TODO: handle HTML content?
   path <- tempfile("matplotlib-plot-", fileext = ".png")
   
   plt <- reticulate::import("matplotlib.pyplot", convert = TRUE)
   
   # resize the figure
   figure <- plt$gcf()
   figure$set_dpi(dpi)
   figure$set_size_inches(width, height)
   plt$savefig(path, dpi = figure$dpi)
   
   # now, read that in and create an R plot using e.g. image
   data <- png::readPNG(path, native = TRUE, info = TRUE)
   
   # don't display margins and ensure R doesn't nudge margin size
   opar <- par(
      xaxt = "n", yaxt = "n",
      xaxs = "i", yaxs = "i",
      mar = c(0, 0, 0, 0),
      oma = c(0, 0, 0, 0),
      xpd = NA
   )
   on.exit(par(opar), add = TRUE)
   
   # generate raster
   plot.new()
   graphics::rasterImage(data, 0, 0, 1, 1)
})

.rs.addFunction("reticulate.replInitialize", function()
{
   # compute interpreter info (only needs to be done once as the Python
   # interpreter cannot be re-initialized again in the same session)
   info <- .rs.getVar("python.activeInterpreterInfo")
   if (is.null(info))
   {
      config <- reticulate::py_config()
      info <- .rs.python.describeInterpreter(config$python)
      .rs.setVar("python.activeInterpreterInfo", info)
   }
   
   # signal a switch to Python context
   .rs.reticulate.enqueueClientEvent(
      .rs.reticulateEvents$REPL_INITIALIZED,
      info
   )
   
})

.rs.addFunction("reticulate.replHook", function(buffer, contents, trimmed)
{
   # ensure we call repl_iteration hook on exit
   on.exit(
      .rs.reticulate.enqueueClientEvent(
         .rs.reticulateEvents$REPL_ITERATION,
         list()
      ),
      add = TRUE
   )
   
   # special handling for commands when buffer is currently empty
   if (buffer$empty())
   {
      # detect help requests, and route to Help pane
      if (grepl("^[?]", trimmed))
      {
         text <- substring(trimmed, 2)
         .Call("rs_showPythonHelp", text, PACKAGE = "(embedding)")
         return(TRUE)
      }
      
      reHelp <- "help\\s*\\((.*)\\)"
      if (grepl(reHelp, trimmed))
      {
         text <- .rs.trimWhitespace(gsub(reHelp, "\\1", trimmed))
         .Call("rs_showPythonHelp", text, PACKAGE = "(embedding)")
         return(TRUE)
      }
      
      # detect View calls, and use View hook instead
      pattern <- "^View\\s*\\((.*)\\)$"
      matches <- regmatches(trimmed, regexec(pattern, trimmed))
      if (length(matches) && length(matches[[1]]) == 2)
      {
         name <- gsub("^\\s*|\\s*$", "", matches[[1]][[2]])
         object <- reticulate::py_eval(name, convert = FALSE)
         .rs.reticulate.viewHook(object, name)
         return(TRUE)
      }
   }
   
   FALSE
})

.rs.addFunction("reticulate.replBusy", function(busy)
{
   .rs.reticulate.enqueueClientEvent(
      .rs.reticulateEvents$REPL_BUSY,
      list(busy = .rs.scalar(busy))
   )
})

.rs.addFunction("reticulate.replTeardown", function()
{
   # client event
   .rs.reticulate.enqueueClientEvent(
      .rs.reticulateEvents$REPL_TEARDOWN,
      list()
   )
})

.rs.addFunction("reticulate.replIsActive", function()
{
   if (.rs.isBrowserActive())
      return(FALSE)
   
   if (!"reticulate" %in% loadedNamespaces())
      return(FALSE)
   
   active <- tryCatch(reticulate:::py_repl_active(), error = identity)
   if (inherits(active, "error"))
      return(FALSE)
   
   active
})

.rs.addFunction("python.tokenizationRules", function() {
   
   list(
      
      list(
         pattern = sprintf("(?:%s)\\b", paste(.rs.python.keywords(), collapse = "|")),
         type    = "keyword"
      ),
      
      list(
         pattern = "[[:alpha:]_][[:alnum:]_]*\\b",
         type    = "identifier"
      ),
      
      list(
         pattern = "((\\d+[jJ]|((\\d+\\.\\d*|\\.\\d+)([eE][-+]?\\d+)?|\\d+[eE][-+]?\\d+)[jJ])|((\\d+\\.\\d*|\\.\\d+)([eE][-+]?\\d+)?|\\d+[eE][-+]?\\d+)|(0[xX][\\da-fA-F]+[lL]?|0[bB][01]+[lL]?|(0[oO][0-7]+)|(0[0-7]*)[lL]?|[1-9]\\d*[lL]?))\\b",
         type    = "number"
      ),
      
      list(
         pattern = '["]{3}(.*?)(?:["]{3}|$)',
         type    = "string"
      ),
      
      list(
         pattern = "[']{3}(.*?)(?:[']{3}|$)",
         type    = "string"
      ),
      
      list(
         pattern = '["](?:(?:\\\\.)|(?:[^"\\\\]))*?(?:["]|$)',
         type    = "string"
      ),
      
      list(
         pattern = "['](?:(?:\\\\.)|(?:[^'\\\\]))*?(?:[']|$)",
         type    = "string"
      ),
      
      list(
         pattern = "\\*\\*=?|>>=?|<<=?|<>|!+|//=?|[%&|^=<>*/+-]=?|~",
         type    = "operator"
      ),
      
      list(
         pattern = "[:;.,`@]",
         type    = "special"
      ),
      
      list(
         pattern = "[][)(}{]",
         type    = "bracket"
      ),
      
      list(
         pattern = "#[^\n]*",
         type    = "comment"
      ),
      
      list(
         pattern = "[[:space:]]+",
         type    = "whitespace"
      )
      
   )
   
})

.rs.addFunction("python.token", function(value, type, offset)
{
   list(value = value, type = type, offset = offset)
})

.rs.addFunction("python.tokenize", function(
   code,
   exclude = character(),
   keep.unknown = TRUE)
{
   # vector of tokens
   tokens <- list()
   
   # rules to use
   rules <- .rs.python.tokenizationRules()
   
   # convert to raw vector so we can use 'grepRaw',
   # which supports offset-based search
   raw <- charToRaw(code)
   n <- length(raw)
   
   # record current offset
   offset <- 1
   
   while (offset <= n) {
      
      # record whether we successfully matched a rule
      matched <- FALSE
      
      # iterate through rules, looking for a match
      for (rule in rules) {
         
         # augment pattern to search only from start of requested offset
         pattern <- paste("^(?:", rule$pattern, ")", sep = "")
         match <- grepRaw(pattern, raw, offset = offset, value = TRUE)
         if (length(match) == 0)
            next
         
         # we found a match; record that
         matched <- TRUE
         
         # update our vector of tokens
         token <- .rs.python.token(rawToChar(match), rule$type, offset)
         if (!token$type %in% exclude)
            tokens[[length(tokens) + 1]] <- token
         
         # update offset and break
         offset <- offset + length(match)
         break
         
      }
      
      # if we failed to match anything, consume a single character
      if (!matched) {
         # update tokens
         token <- .rs.python.token(rawToChar(raw[[offset]]), "unknown", offset)
         if (keep.unknown)
            tokens[[length(tokens) + 1]] <- token
         
         # update offset
         offset <- offset + 1
      }
      
   }
   
   class(tokens) <- "tokens"
   tokens
   
})

.rs.addFunction("python.tokenCursor", function(tokens)
{
   .tokens <- tokens
   .offset <- 1L
   .n <- length(tokens)
   
   .lbrackets <- c("(", "{", "[")
   .rbrackets <- c(")", "}", "]")
   .complements <- list(
      "(" = ")", "[" = "]", "{" = "}",
      ")" = "(", "]" = "[", "}" = "{"
   )
   
   tokenValue   <- function() { .tokens[[.offset]]$value  }
   tokenType    <- function() { .tokens[[.offset]]$type   }
   tokenOffset  <- function() { .tokens[[.offset]]$offset }
   cursorOffset <- function() { .offset                   }
   
   moveToOffset <- function(offset) {
      if (offset < 1L)
         .offset <<- 1L
      else if (offset > .n)
         .offset <<- .n
      else
         .offset <<- offset
   }
   
   moveToNextToken <- function(i = 1L) {
      offset <- .offset + i
      if (offset > .n)
         return(FALSE)
      
      .offset <<- offset
      return(TRUE)
   }
   
   moveToPreviousToken <- function(i = 1L) {
      offset <- .offset - i
      if (offset < 1L)
         return(FALSE)
      
      .offset <<- offset
      return(TRUE)
   }
   
   moveRelative <- function(i = 1L) {
      offset <- .offset + i
      if (offset < 1L || offset > .n)
         return(FALSE)
      
      .offset <<- offset
      return(TRUE)
   }
   
   fwdToMatchingBracket <- function() {
      
      token <- .tokens[[.offset]]
      value <- token$value
      if (!value %in% .lbrackets)
         return(FALSE)
      
      lhs <- value
      rhs <- .complements[[lhs]]
      
      count <- 1
      while (moveToNextToken()) {
         value <- tokenValue()
         if (value == lhs) {
            count <- count + 1
         } else if (value == rhs) {
            count <- count - 1
            if (count == 0)
               return(TRUE)
         }
      }
      
      return(FALSE)
   }
   
   bwdToMatchingBracket <- function() {
      
      token <- .tokens[[.offset]]
      value <- token$value
      if (!value %in% .rbrackets)
         return(FALSE)
      
      lhs <- value
      rhs <- .complements[[lhs]]
      
      count <- 1
      while (moveToPreviousToken()) {
         value <- tokenValue()
         if (value == lhs) {
            count <- count + 1
         } else if (value == rhs) {
            count <- count - 1
            if (count == 0)
               return(TRUE)
         }
      }
      
      return(FALSE)
   }
   
   peek <- function(i = 0L) {
      offset <- .offset + i
      if (offset < 1L || offset > .n)
         return(.rs.python.token("", "unknown", -1L))
      return(.tokens[[offset]])
   }
   
   find <- function(predicate, forward = TRUE) {
      if (forward) {
         offset <- .offset + 1L
         while (offset <= .n) {
            token <- .tokens[[offset]]
            if (predicate(token)) {
               .offset <<- offset
               return(TRUE)
            }
            offset <- offset + 1L
         }
         return(FALSE)
      } else {
         offset <- .offset - 1L
         while (offset >= 1L) {
            token <- .tokens[[offset]]
            if (predicate(token)) {
               .offset <<- offset
               return(TRUE)
            }
            offset <- offset - 1L
         }
         return(FALSE)
      }
   }
   
   # move to the start of a Python statement, e.g.
   #
   #    alpha.beta["gamma"]
   #    ^~~~~~~~~<~~~~~~~~^
   #
   moveToStartOfEvaluation <- function() {
      
      repeat {
         
         # skip matching brackets
         if (bwdToMatchingBracket()) {
            if (!moveToPreviousToken())
               return(TRUE)
            next
         }
         
         # if the previous token is an identifier or a '.', move on to it
         previous <- peek(-1L)
         if (previous$value %in% "." || previous$type %in% "identifier") {
            moveToPreviousToken()
            next
         }
         
         break
         
      }
      
      TRUE
   }
   
   list(
      tokenValue              = tokenValue,
      tokenType               = tokenType,
      tokenOffset             = tokenOffset,
      cursorOffset            = cursorOffset,
      moveToNextToken         = moveToNextToken,
      moveToPreviousToken     = moveToPreviousToken,
      fwdToMatchingBracket    = fwdToMatchingBracket,
      bwdToMatchingBracket    = bwdToMatchingBracket,
      moveToOffset            = moveToOffset,
      moveRelative            = moveRelative,
      peek                    = peek,
      find                    = find,
      moveToStartOfEvaluation = moveToStartOfEvaluation
   )
})

.rs.addFunction("python.completions", function(token,
                                               candidates,
                                               source = NULL,
                                               type = NULL,
                                               reorder = TRUE)
{
   # figure out the completions to keep
   pattern <- paste("^\\Q", token, "\\E", sep = "")
   indices <- grep(pattern, candidates, perl = TRUE)
   if (reorder)
      indices <- indices[order(candidates[indices])]
   
   # extract our completions
   completions <- candidates[indices]
   
   # re-order source and type if they were provided
   if (!is.null(source) && length(source) == length(candidates))
      source <- source[indices]
   
   if (!is.null(type) && length(type) == length(candidates))
      type <- type[indices]
   
   attr(completions, "token") <- token
   attr(completions, "source") <- source
   attr(completions, "types") <- type
   attr(completions, "helpHandler") <- "reticulate:::help_handler"
   
   completions
})

.rs.addFunction("python.emptyCompletions", function()
{
   character()
})

.rs.addFunction("python.getCompletionsImports", function(token)
{
   # split into pieces (note that strsplit drops an empty final match
   # so we need to add it back if the token is e.g. 'a.b.')
   pieces <- strsplit(token, ".", fixed = TRUE)[[1]]
   if (grepl("[.]$", token))
      pieces <- c(pieces, "")
   
   # no '.' implies we're completing top-level modules
   if (length(pieces) < 2) {
      completions <- .rs.python.listModules()
      return(.rs.python.completions(token, completions))
   }
   
   # we're completing a sub-module. try to import that module, and
   # then list things we can import from that module. note that importing
   # a module does imply running a load of Python code but other Python
   # front-ends (e.g. IPython) do this as well.
   module <- paste(head(pieces, n = -1), collapse = ".")
   imported <- tryCatch(reticulate::import(module), error = identity)
   if (inherits(imported, "error"))
      return(.rs.emptyCompletions())
   exports <- sort(unique(names(imported)))
   
   postfix <- pieces[length(pieces)]
   completions <- .rs.python.completions(postfix, exports)
   
   # now, bring back full prefix for completions
   if (length(completions)) {
      prefix <- paste(pieces[-length(pieces)], collapse = ".")
      completions <- paste(prefix, completions, sep = ".")
   }
   
   # add in metadata
   attr(completions, "token") <- token
   attr(completions, "types") <- 21
   
   completions
})

.rs.addFunction("python.getCompletionsImportsFrom", function(module, token)
{
   # request completions as though this were <module>.<token>
   pasted <- paste(module, token, sep = ".")
   completions <- .rs.python.getCompletionsImports(pasted)
   
   # fix up the completions (remove the module prefix)
   if (length(completions)) {
      prefix <- paste(module, ".", sep = "")
      completions <- sub(prefix, "", completions, fixed = TRUE)
   }
   
   attr(completions, "token") <- token
   completions
})

.rs.addFunction("python.getCompletionsFiles", function(token)
{
   os <- reticulate::import("os", convert = TRUE)
   token <- gsub("^['\"]|['\"]$", "", token)
   expanded <- path.expand(token)
   
   # find the index of the last slash -- everything following is
   # the completion token; everything before is the directory to
   # search for completions in
   indices <- gregexpr("/", expanded, fixed = TRUE)[[1]]
   if (!identical(c(indices), -1L)) {
      lhs <- substring(expanded, 1, tail(indices, n = 1))
      rhs <- substring(expanded, tail(indices, n = 1) + 1)
      files <- paste(lhs, list.files(lhs), sep = "")
   } else {
      lhs <- "."
      rhs <- expanded
      files <- list.files(os$getcwd())
   }
   
   # form completions (but add extra metadata after)
   completions <- .rs.python.completions(expanded, files)
   attr(completions, "token") <- token
   
   info <- file.info(completions)
   attr(completions, "types") <- ifelse(info$isdir, 16, 15)
   
   completions
})

.rs.addFunction("python.getCompletionsKeys", function(source, token)
{
   builtins <- reticulate::import_builtins(convert = TRUE)
   
   object <- tryCatch(reticulate::py_eval(source, convert = FALSE), error = identity)
   if (inherits(object, "error"))
      return(.rs.python.emptyCompletions())
   
   method <- reticulate::py_get_attr(object, "keys", silent = TRUE)
   if (!inherits(method, "python.builtin.object"))
      return(.rs.python.emptyCompletions())
   
   keys <- reticulate::py_to_r(method)
   candidates <- if (.rs.python.isPython3())
      as.character(builtins$list(reticulate::py_to_r(keys())))
   else
      reticulate::py_to_r(keys())
   
   .rs.python.completions(token, candidates)
   
})

.rs.addFunction("python.getCompletionsArguments", function(source, token)
{
   object <- tryCatch(reticulate::py_eval(source, convert = FALSE), error = identity)
   if (inherits(object, "error"))
      return(.rs.python.emptyCompletions())
   
   arguments <- .rs.python.getFunctionArguments(object)
   
   # paste on an '=' for completions (Python users seem to prefer no
   # spaces between the argument name and value)
   .rs.python.completions(
      token = token,
      candidates = paste(arguments, "=", sep = ""),
      source = source,
      type = .rs.acCompletionTypes$ARGUMENT,
      reorder = FALSE
   )
   
})

.rs.addFunction("python.getFunctionArguments", function(object)
{
   inspect <- reticulate::import("inspect", convert = TRUE)
   
   # for class objects, we'll look up arguments on the associated
   # __init__ method instead
   if (inspect$isclass(object)) {
      
      init <- .rs.tryCatch(reticulate::py_get_attr(object, "__init__"))
      if (inherits(init, "error"))
         return(.rs.python.emptyCompletions())
      
      arguments <- .rs.tryCatch(inspect$getargspec(init)$args)
      if (inherits(arguments, "error"))
         return(.rs.python.emptyCompletions())
      
      return(setdiff(arguments, "self"))
   }
   
   # try a set of methods for extracting these arguments
   methods <- list(
      function() inspect$getargspec(object)$args,
      function() .rs.python.getNumpyFunctionArguments(object)
   )
   
   for (method in methods) {
      arguments <- .rs.tryCatch(method())
      if (!inherits(arguments, "error"))
         return(arguments)
   }
   
   character()
   
})

.rs.addFunction("python.getNumpyFunctionArguments", function(object)
{
   # extract the docstring
   docs <- reticulate::py_get_attr(object, "__doc__")
   if (inherits(docs, "python.builtin.object"))
      docs <- reticulate::py_to_r(docs)
   
   pieces <- strsplit(docs, "\n", fixed = TRUE)[[1]]
   first <- pieces[[1]]
   
   # try munging so that it 'looks' like an R function definition,
   # and then parse it that way. this will obviously fail for certain
   # kinds of Python default arguments but this seems to catch the
   # most common cases for now
   munged <- paste(gsub("[^(]*[(]", "function (", first), "{}")
   parsed <- parse(text = munged)[[1]]
   
   # extract the formal names
   names(parsed[[2]])
})

.rs.addFunction("python.getCompletionsMain", function(token, ctx)
{
   dots <- gregexpr(".", token, fixed = TRUE)[[1]]
   if (identical(c(dots), -1L)) {
      
      # provide completions for main, builtins, keywords
      main     <- reticulate::import_main(convert = FALSE)
      builtins <- reticulate::import_builtins(convert = FALSE)
      
      # figure out object types for main, builtins
      keywords <- .rs.python.keywords()
      candidates <- c(names(main), names(builtins), keywords)
      
      source <- c(
         rep("reticulate:::import_main(convert = FALSE)", length(names(main))),
         rep("reticulate:::import_builtins(convert = FALSE)", length(names(builtins))),
         rep("", length(keywords))
      )
      
      # figure out object types
      type <- c(
         .rs.python.inferObjectTypes(main, names(main)),
         .rs.python.inferObjectTypes(builtins, names(builtins)),
         rep(.rs.acCompletionTypes$KEYWORD, length(keywords))
      )
      
      completions <- .rs.python.completions(
         token = token,
         candidates = candidates,
         source = source,
         type = type
      )
      
      return(completions)
   }
   
   # we had dots; try to evaluate each component piece-by-piece to get
   # to the relevant object providing us with completions
   pieces <- .rs.strsplit(token, ".", fixed = TRUE)
   
   # for the first piece, check to see if it might be a module
   first <- .rs.python.sanitizeForCompletion(pieces[[1]])
   object <- if (first %in% names(ctx$aliases))
   {
      module <- ctx$aliases[[first]]
      .rs.tryCatch(reticulate::import(module, convert = FALSE))
   }
   else
   {
      reticulate::py_eval(first, convert = FALSE)
   }
   
   # now, try to extract sub-pieces from the module / object we received
   i <- 2
   while (i < length(pieces))
   {
      if (inherits(object, "error"))
         break
      
      code <- .rs.python.sanitizeForCompletion(pieces[[i]])
      object <- .rs.tryCatch(reticulate::py_get_attr(object, code))
      i <- i + 1
   }
   if (inherits(object, "error"))
      return(.rs.python.emptyCompletions())
   
   # attempt to get completions
   candidates <- if (inherits(object, "__main__.R"))
   {
      # for the custom 'R' object, return objects in the global environment
      # we might want to consider whether data objects should be returned too
      ls(envir = globalenv())
   }
   else
   {
      # otherwise, use object attributes instead
      tryCatch(reticulate::py_list_attributes(object), error = identity)
   }
    
   # split string into source (module or sub-module providing object)
   # and token
   token <- tail(pieces, n = 1L)
   source <- paste(head(pieces, n = -1L), collapse = ".")
   
   # build completions object
   completions <- .rs.python.completions(
      token      = token,
      candidates = candidates,
      source     = source,
      type       = .rs.python.inferObjectTypes(object, candidates)
   )
   
   completions
})

.rs.addFunction("python.getCompletions", function(line, ctx)
{
   # check for completion of a module name in e.g. 'import nu' or 'from nu'
   re_import <- paste(
      "^[[:space:]]*",      # leading whitespace
      "(?:from|import)",    # from or import
      "[[:space:]]+",       # separating spaces
      "([[:alnum:]._]*)$",  # module name
      sep = ""
   )
   
   matches <- regmatches(line, regexec(re_import, line, perl = TRUE))[[1]]
   if (length(matches) == 2)
      return(.rs.python.getCompletionsImports(matches[[2]]))
   
   # check for completion of submodule
   re_import_from <- paste(
      "^[[:space:]]*",     # leading space
      "from",              # 'from'
      "[[:space:]]+",      # separating spaces
      "([[:alnum:]._]+)",  # module name
      "[[:space:]]+",      # separating spaces
      "import",            # 'import'
      "[[:space:]]+",      # separating spaces
      "\\(?",              # an optional opening bracket (tuple style)
      "[[:space:]]*",      # optional whitespace
      "([^)]*)",           # the rest (including whitespace)
      sep = ""
   )
   
   matches <- regmatches(line, regexec(re_import_from, line, perl = TRUE))[[1]]
   if (length(matches) == 3) {
      
      # extract module from which imports are being drawn
      module <- matches[[2]]
      imports <- matches[[3]]
      
      # figure out the text following the last comma (if any)
      token <- ""
      if (nzchar(imports))
         token <- gsub(".*[[:space:],]", "", imports)
      
      return(.rs.python.getCompletionsImportsFrom(module, token))
      
   }
   
   # tokenize the line and grab the last token
   tokens <- .rs.python.tokenize(
      code = line,
      exclude = c("whitespace", "comment"),
      keep.unknown = FALSE
   )
   
   if (length(tokens) == 0)
      return(.rs.python.emptyCompletions())
   
   # construct token cursor
   cursor <- .rs.python.tokenCursor(tokens)
   cursor$moveToOffset(length(tokens))
   token <- cursor$peek()
   
   # for strings, we may be either completing dictionary keys or files
   if (token$type %in% "string") {
      
      # if there's no prior token, assume this is a file name
      if (!cursor$moveToPreviousToken())
         return(.rs.python.getCompletionsFiles(token$value))
      
      # if the prior token is an open bracket, assume we're completing
      # a dictionary key
      if (cursor$tokenValue() == "[") {
         
         saved <- cursor$peek()
         
         if (!cursor$moveToPreviousToken())
            return(.rs.python.emptyCompletions())
         
         if (!cursor$moveToStartOfEvaluation())
            return(.rs.python.emptyCompletions())
         
         # grab text from this offset
         lhs <- substring(line, cursor$tokenOffset(), saved$offset - 1)
         rhs <- gsub("^['\"]|['\"]$", "", token$value)
         
         # bail if there are any '(' tokens (avoid arbitrary function eval)
         # in theory this screens out tuples but that's okay for now
         tokens <- .rs.python.tokenize(lhs)
         lparen <- Find(function(token) token$value == "(", tokens)
         if (!is.null(lparen))
            return(.rs.python.emptyCompletions())
         
         return(.rs.python.getCompletionsKeys(lhs, rhs))
         
      }
      
      # doesn't look like a dictionary; perform filesystem completion
      return(.rs.python.getCompletionsFiles(token$value))
      
   }
   
   # try to guess if we're trying to autocomplete function arguments
   maybe_function <-
      cursor$peek(0 )$value %in% c("(", ",") ||
      cursor$peek(-1)$value %in% c("(", ",")
   
   if (maybe_function) {
      offset <- cursor$cursorOffset()
      
      # try to find an opening bracket
      repeat {
         
         # skip matching brackets
         if (cursor$bwdToMatchingBracket()) {
            if (!cursor$moveToPreviousToken())
               break
            next
         }
         
         # if we find an opening bracket, check to see if the token to the
         # left is something that is, or could produce, a function
         if (cursor$tokenValue() == "(" &&
             cursor$moveToPreviousToken() &&
             (cursor$tokenValue() == "]" || cursor$tokenType() %in% "identifier"))
         {
            # find code to be evaluated that will produce function
            endToken   <- cursor$peek()
            cursor$moveToStartOfEvaluation()
            startToken <- cursor$peek()
            
            # extract the associated text
            start <- startToken$offset
            end   <- endToken$offset + nchar(endToken$value) - 1
            source <- substring(line, start, end)
            
            # get argument completions
            rhs <- if (token$type %in% "identifier") token$value else ""
            return(.rs.python.getCompletionsArguments(source, rhs))
         }
         
         if (!cursor$moveToPreviousToken())
            break
      }
      
      # if we got here, our attempts to find a function failed, so
      # go home and fall back to the default completion solution
      cursor$moveToOffset(offset)
   }
   
   # start looking backwards
   repeat {
      
      # skip matching brackets
      if (cursor$bwdToMatchingBracket()) {
         if (!cursor$moveToPreviousToken())
            break
         next
      }
      
      # consume identifiers, strings, '.'
      if (cursor$tokenType() %in% c("string", "identifier") ||
          cursor$tokenValue() %in% ".")
      {
         lastType <- cursor$tokenType()
         
         # if we can't move to the previous token, we must be at the
         # start of the token stream, so just consume from here
         if (!cursor$moveToPreviousToken())
            break
         
         # if we moved on to a token of the same type, move back and break
         if (lastType == cursor$tokenType()) {
            cursor$moveToNextToken()
            break
         }
         
         next
      }
      
      # if this isn't a matched token, then move back up a single
      # token and break
      if (!cursor$moveToNextToken())
         return(.rs.python.emptyCompletions())
      
      break
      
   }
   
   source <- substring(line, cursor$tokenOffset())
   .rs.python.getCompletionsMain(source, ctx)
})

.rs.addFunction("python.isPython3", function()
{
   config <- reticulate::py_config()
   grepl("^3", config$version)
})

.rs.addFunction("python.listModules", function()
{
   pkgutil  <- reticulate::import("pkgutil", convert = FALSE)
   builtins <- reticulate::import_builtins(convert = FALSE)
   
   modules <- tryCatch(
      builtins$list(pkgutil$iter_modules()),
      error = identity
   )
   
   if (inherits(modules, "error"))
      return(character())
   
   # convert to R object and extract module names
   modules <- reticulate::py_to_r(modules)
   key <- if (.rs.python.isPython3()) "name" else 2L
   names <- vapply(modules, `[[`, key, FUN.VALUE = character(1))
   sort(unique(names))
})

.rs.addFunction("python.inferObjectTypes", function(object, names)
{
   vapply(names, function(name) {
      
      # attempt to grab attribute (note that this can fail if
      # the object as implemented a custom __getattr__ or similar)
      item <- .rs.tryCatch(reticulate::py_get_attr(object, name))
      if (inherits(item, "error"))
         return(.rs.acCompletionTypes$UNKNOWN)
      
      # try to infer the completion type
      if (inherits(item, "python.builtin.module"))
         .rs.acCompletionTypes$ENVIRONMENT
      else if (.rs.reticulate.isFunction(item))
         .rs.acCompletionTypes$FUNCTION
      else if (inherits(item, "pandas.core.frame.DataFrame"))
         .rs.acCompletionTypes$DATAFRAME
      else
         .rs.acCompletionTypes$UNKNOWN
   }, numeric(1))
})

.rs.addFunction("python.isHelpTopicValid", function(code)
{
   # a valid Python help topic is a simple qualified name; that is, a
   # sequence of identifiers joined by dots (e.g. 'numpy', 'os.path',
   # 'pandas.DataFrame'). the topic is evaluated as a Python expression
   # when generating help, so anything that isn't a plain dotted name is
   # rejected to guard against code injection.
   pattern <- "^[A-Za-z_][A-Za-z0-9_]*([.][A-Za-z_][A-Za-z0-9_]*)*$"
   grepl(pattern, code, perl = TRUE)
})

.rs.addFunction("python.generateHtmlHelp", function(code)
{
   Encoding(code) <- "UTF-8"

   # remove a '.html' suffix if present
   code <- sub("[.]html$", "", code)

   # validate the requested topic before attempting to resolve it; the
   # topic is otherwise evaluated as a Python expression below, so an
   # invalid topic could be used to inject and execute arbitrary code
   if (!.rs.python.isHelpTopicValid(code)) {
      warning(sprintf("'%s' is not a valid Python help topic", code), call. = FALSE)
      return("")
   }

   # check for pre-existing generated HTML
   dir <- file.path(tempdir(), "reticulate-python-help")
   if (!.rs.ensureDirectory(dir)) {
      warning("Failed to create Python help directory", call. = FALSE)
      return("")
   }
   
   stem <- utils::URLencode(code, reserved = TRUE)
   path <- file.path(dir, paste(stem, "html", sep = "."))
   if (file.exists(path))
      return(path)
   
   # no HTML file exists; attempt to generate it. try
   # to evaluate the Python code supplied to gain access
   # to the associated object. first attempt to just py_eval
   # it; if that fails, try the more generic pydoc resolver
   pydoc <- reticulate::import("pydoc", convert = TRUE)
   methods <- list(
      function() reticulate::py_eval(code),
      function() pydoc$resolve(code)[[1]]
   )
   
   resolved <- NULL
   for (method in methods) {
      resolved <- .rs.tryCatch(method())
      if (!inherits(resolved, "error"))
         break
   }
   
   if (inherits(resolved, "error")) {
      fmt <- "No Python documentation found for '%s'."
      warning(sprintf(fmt, code), call. = FALSE)
      return("")
   }
   
   # the text provided by the user is likely an alias for
   # the true definition location, so attempt to recover
   # that from the object.
   #
   # TODO: should we maintain our cache of help topics
   # within a session state directory, so they can be
   # reloaded when RStudio is restarted?
   module <- "<unknown>"
   if (reticulate::py_has_attr(resolved, "__module__"))
      module <- resolved[["__module__"]]
   
   name <- "<unknown>"
   if (reticulate::py_has_attr(resolved, "__name__"))
      name <- resolved[["__name__"]]
   
   # if we don't know the module, try to guess based on the class
   if (identical(module, "<unknown>") &&
       reticulate::py_has_attr(resolved, "__class__"))
   {
      builtins <- reticulate::import_builtins(convert = TRUE)
      output <- builtins$repr(resolved[["__class__"]])
      if (grepl("<type '(.*)'>", output))
      {
         class <- gsub("<type '(.*)'>", "\\1", output)
         splat <- .rs.strsplit(class, ".", fixed = TRUE)
         module <- paste(head(splat, n = 1), collapse = ".")
      }
   }
   
   # we have a Python object: generate HTML help for it. we
   # monkey-patch our own HTMLDoc instance so that the heading
   # comes out a little more cleanly
   #
   # TODO: this might fit more naturally as a helper class
   # in the reticulate package
   #
   # NOTE: we explicitly use `py_run_string(..., local = FALSE)` to avoid
   # issues with reticulate 1.20 -- normally we'd just update the version
   # of reticulate on CRAN, but because R 4.1.0 was just published a number
   # of people will only be able to install the reticulate 1.20 binary and
   # so it behooves us to support that version for now
   reticulate::py_run_string("

# Create HTML documentation object
def _rstudio_html_generator_():
   import pydoc
   html = pydoc.HTMLDoc()

   # Override the heading function
   def _heading(title, fgcol, bgcol, extra = ''):
      return '''
   <table width=\"100%%\" cellspacing=0 cellpadding=2 border=0 summary=\"heading\">
   <tr><td><h2>%s</h2></td></tr>
   </table>
      ''' % (title)
   
   html.heading = _heading
   return html
", local = FALSE)
   
   # create html object, then remove generator function
   main <- reticulate::import_main(convert = TRUE)
   generator <- reticulate::py_to_r(reticulate::py_get_attr(main, "_rstudio_html_generator_"))
   html <- generator()
   reticulate::py_del_attr(main, "_rstudio_html_generator_")
   
   # generate page (handle numpy specially)
   page <- if (inherits(resolved, "numpy.ufunc")) {
      html$page(paste("numpy function", name), html$docroutine(resolved, name))
   } else {
      pydoc <- reticulate::import("pydoc", convert = TRUE)
      html$page(pydoc$describe(resolved), html$document(resolved, name))
   }
   
   # remove hard-coded background colors for rows
   page <- gsub("\\s?bgcolor=\"#[0-9a-fA-F]{6}\"", "", page, perl = TRUE)
   
   writeLines(page, con = path)
   path
   
})

.rs.addFunction("python.extractCurrentExpression", function(line, offset)
{
   # tokenize the line
   tokens <- .rs.python.tokenize(line, exclude = c("whitespace", "comment"))
   if (length(tokens) == 0)
      return("")
   
   # find the current token
   n <- length(tokens); index <- n
   while (index >= 1) {
      if (tokens[[index]]$offset <= offset)
         break
      index <- index - 1
   }
   
   cursor <- .rs.python.tokenCursor(tokens)
   cursor$moveToOffset(index)
   
   # try to move to the start of an expression
   while (TRUE) {
      
      # move over matching brackets
      while (cursor$bwdToMatchingBracket())
         if (!cursor$moveToPreviousToken())
            break
      
      # bail if we hit an operator or a ';' -- these
      # are tokens that 'stop' a previous expression
      if (cursor$tokenType() %in% c("operator", "keyword") ||
          cursor$tokenValue() %in% c(";", ","))
      {
         cursor$moveToNextToken()
         break
      }
      
      # if we hit an opening bracket, check to see
      # if there's an identifier before it. if not,
      # this is defining a tuple or a list, and we
      # should bail
      if (cursor$tokenType() %in% "bracket" &&
          cursor$cursorOffset() > 1)
      {
         peek <- tokens[[cursor$cursorOffset() - 1]]
         if (peek$type %in% c("operator", "bracket", "keyword") ||
             peek$value %in% c(";", ","))
         {
            cursor$moveToNextToken()
            break
         }
      }
      
      # move back a token
      if (!cursor$moveToPreviousToken())
         break
   }
   
   startOffset <- cursor$tokenOffset()
   
   # now find the end of the expression
   while (TRUE) {
      
      # bail if we hit a '('
      if (cursor$tokenValue() %in% c("(")) {
         cursor$moveToPreviousToken()
         break
      }
      
      # skip other brackets
      if (cursor$fwdToMatchingBracket())
         if (!cursor$moveToNextToken())
            break
      
      # bail if we hit an operator or a ';' -- these
      # are tokens that 'stop' a previous expression
      if (cursor$tokenType() %in% c("operator", "keyword") ||
          cursor$tokenValue() %in% c(";", ","))
      {
         cursor$moveToPreviousToken()
         break
      }
      
      # move up a token
      if (!cursor$moveToNextToken())
         break
   }
   
   endOffset <- cursor$tokenOffset() + nchar(cursor$tokenValue()) - 1
   
   # extract line of text providing the object to be looked at
   substring(line, startOffset, endOffset)
   
})

.rs.addFunction("python.keywords", function()
{
   keywords <- .rs.getVar("python.keywordList")
   if (length(keywords))
      return(keywords)
   
   keyword <- reticulate::import("keyword", convert = TRUE)
   kwlist <- keyword$kwlist
   
   .rs.setVar("python.keywordList", kwlist)
   kwlist
})

# $ title      : chr "DataFrame"
# $ signature  : chr "DataFrame()"
# $ description: chr "Two-dimensional size-mutable, potentially heterogeneous tabular data"
.rs.addFunction("python.getHelp", function(topic, source)
{
   object <- .rs.tryCatch(reticulate::py_eval(source, convert = FALSE))
   if (inherits(object, "error"))
      return(NULL)
   
   handler <- reticulate:::help_completion_handler.python.builtin.object
   .rs.tryCatch(reticulate::py_suppress_warnings(handler(topic, object)))
})

# $ args            : chr [1:9] "cls" "path" "header" "sep" ...
# $ arg_descriptions: Named chr [1:9] "cls" "path" "header" "sep" ...
.rs.addFunction("python.getParameterHelp", function(source)
{
   error <- list(args = character(), arg_descriptions = character())
   object <- .rs.tryCatch(reticulate::py_eval(source, convert = FALSE))
   if (inherits(object, "error"))
      return(error)
   
   # extract argument names using inspect (note that this can fail for
   # some Python function types; e.g. builtin Python functions)
   inspect <- reticulate::import("inspect", convert = TRUE)
   spec <- .rs.tryCatch(inspect$getargspec(object))
   if (inherits(spec, "error"))
      return(error)
   
   args <- spec$args
   
   # attempt to scrape parameter documentation
   docs <- reticulate::py_get_attr(object, "__doc__", silent = TRUE)
   if (inherits(docs, "python.builtin.object"))
      docs <- reticulate::py_to_r(docs)
   if (is.null(docs))
      docs <- ""
   
   lines <- strsplit(docs, "\n", fixed = TRUE)[[1]]
   
   arg_descriptions <- lapply(args, function(arg) {
      tryCatch({
         # try to find the line where the parameter documentation starts
         pattern <- sprintf("^\\s*%s\\s*:", arg)
         index <- grep(pattern, lines)
         if (!length(index))
            return("")
         index <- index[[1]]
         line <- lines[[index]]
         
         # split into argument name, initial part of description
         desc <- ""
         colon <- regexpr(":", line, fixed = TRUE)
         if (colon != -1L)
            desc <- substring(line, colon + 1)
         
         # now, look to see if the documentation spans multiple lines
         # consume lines of greater indent that the current
         indent <- regexpr("(?:\\S|$)", line)
         start <- end <- index + 1
         while (TRUE) {
            if (regexpr("(?:\\S|$)", lines[[end]]) <= indent)
               break
            end <- end + 1
         }
         
         if (start != end)
            desc <- c(desc, lines[start:(end - 1L)])
         
         paste(gsub("^\\s*|\\s*$", "", desc), collapse = "\n")
         
      }, error = function(e) "")
   })
   
   list(
      args             = as.character(args),
      arg_descriptions = as.character(arg_descriptions)
   )
})

.rs.addFunction("python.sanitizeForCompletion", function(item)
{
   if (.rs.startsWith(item, "[") && .rs.endsWith(item, "]"))
      "[]"
   else if (.rs.startsWith(item, "{") && .rs.endsWith(item, "}"))
      "{}"
   else if (.rs.startsWith(item, "(") && .rs.endsWith(item, ")"))
      "()"
   else
      item
})

#    > str(.rs.describeObject("a", globalenv()))
# List of 10
#  $ name             : 'rs.scalar' chr "a"
#  $ type             : 'rs.scalar' chr "numeric"
#  $ clazz            : chr [1:2] "numeric" "double"
#  $ is_data          : 'rs.scalar' logi FALSE
#  $ value            : 'rs.scalar' chr "1"
#  $ description      : 'rs.scalar' chr " num 1"
#  $ size             : 'rs.scalar' num 56
#  $ length           : 'rs.scalar' int 1
#  $ contents         : list()
#  $ contents_deferred: 'rs.scalar' logi FALSE
.rs.addFunction("reticulate.describeObject", function(name, parent)
{

   object <- if (inherits(parent, "python.builtin.dict"))
      reticulate::py_get_item(parent, name)
   else if (inherits(parent, "python.builtin.object"))
      reticulate::py_get_attr(parent, name)
   else
      get(name, envir = parent)

   # is this a null pointer? if so, handle that up-front
   if (reticulate:::py_is_null_xptr(object))
   {
      result <- list(
         name              = .rs.scalar(name),
         type              = .rs.scalar("<unknown>"),
         clazz             = "<unknown>",
         is_data           = .rs.scalar(TRUE),
         value             = .rs.scalar("<Null pointer>"),
         description       = .rs.scalar("<Null pointer>"),
         size              = .rs.scalar(0L),
         length            = .rs.scalar(0L),
         contents          = list(),
         contents_deferred = .rs.scalar(FALSE)
      )

      return(result)
   }

   # is this object 'data'? consider non-callable, non-module objects as data
   isData <- !(
      grepl("^__.*__$", name) ||
      reticulate:::py_is_callable(object) ||
      reticulate:::py_is_module(object)
   )
   
   # NOTE: there isn't really a distinction between an objects "type"
   # and an objects "class" in Python 3; whereas R objects might have
   # some internal type and multiple (S3, S4, R6) classes, depending
   # on what form of OOP is used for dispatch
   
   # get object type, value
   type <- if (.rs.reticulate.isFunction(object))
      "function"
   else
      .rs.reticulate.describeObjectType(object)
   
   value <- .rs.reticulate.describeObjectValue(object)
   
   # get object size
   sys <- reticulate::import("sys")
   size <- tryCatch(sys$getsizeof(object), error = function(cnd) -1)
   
   # get object length (note: not all objects in Python have a length)
   length <- .rs.reticulate.describeObjectLength(object)
   
   # get object summary when appropriate
   contents <- .rs.reticulate.describeObjectContents(object)
   
   list(
      name              = .rs.scalar(name),
      type              = .rs.scalar(type),
      clazz             = type,
      is_data           = .rs.scalar(isData),
      value             = .rs.scalar(value),
      description       = .rs.scalar(value),
      size              = .rs.scalar(size),
      length            = .rs.scalar(length),
      contents          = contents,
      contents_deferred = .rs.scalar(FALSE)
   )

})

.rs.addFunction("reticulate.describeObjectType", function(object)
{
   builtins <- reticulate::import_builtins(convert = TRUE)
   builtins$type(object)$`__name__`
})

.rs.addFunction("reticulate.describeObjectValue", function(object)
{
   if (inherits(object, "pandas.core.frame.DataFrame"))
   {
      builtins <- reticulate::import_builtins(convert = TRUE)
      rows     <- builtins$len(object)
      columns  <- builtins$len(object$columns) 
      
      fmt <- "DataFrame: [%i rows x %i columns]"
      sprintf(fmt, rows, columns)
   }
   else if (inherits(object, "__main__.R"))
   {
      "[R interface object]"
   }
   else
   {
      pprint <- reticulate::import("pprint", convert = TRUE)
      
      printer <- pprint$PrettyPrinter(
         indent = 1L,
         width  = as.integer(getOption("width")),
         depth  = 1L
      )
      
      formatted <- printer$pformat(object)
      .rs.truncate(formatted)
   }
   
})

.rs.addFunction("reticulate.describeObjectLength", function(object)
{
   # this function is overwritten in .rs.registerPackageLoadHook if 
   # reticulate version >= 1.23
   builtins <- reticulate::import_builtins(convert = TRUE)
   tryCatch(
      builtins$len(object),
      error = function(e) -1L
   )
})

.rs.addFunction("reticulate.describeObjectContents", function(object)
{
   tryCatch(
      .rs.reticulate.describeObjectContentsImpl(object),
      error = warning
   )
})

.rs.addFunction("reticulate.describeObjectContentsImpl", function(object)
{
   if (inherits(object, "pandas.core.frame.DataFrame"))
   {
      text <- reticulate::py_to_r(object$to_string(max_rows = 150L, show_dimensions = FALSE))
      strsplit(text, "\n", fixed = TRUE)[[1]]
   }
   else
   {
      list()
   }
})

.rs.addFunction("reticulate.resolveModule", function(module)
{
   # return module objects as-is
   if (inherits(module, "python.builtin.object"))
      return(module)
   
   # resolve modules by name otherwise
   if (module %in% c("main", "__main__"))
      reticulate::import_main(convert = FALSE)
   else if (module %in% c("builtins", "__builtins__"))
      reticulate::import_builtins(convert = FALSE)
   else
      reticulate::import(module, convert = FALSE)
})

#   "result": {
#     "language": "r",
#     "environment_monitoring": true,
#     "environment_list": [],
#     "context_depth": 0,
#     "call_frames": [],
#     "function_name": "",
#     "environment_name": ".GlobalEnv",
#     "environment_is_local": false,
#     "use_provided_source": false,
#     "function_code": ""
#   }
.rs.addFunction("reticulate.environmentState", function(module)
{
   # resolve the requested module
   module <- .rs.reticulate.resolveModule(module)
   
   # update detect changes cache
   .rs.reticulate.detectChanges(module, cacheOnly = TRUE)
   
   # list objects within the requested module
   builtins <- reticulate::import_builtins()
   objects <- builtins$dir(module)
   
   # don't include double-under (dunder; e.g __foo__) objects from main
   name <- as.character(reticulate::py_get_attr(module, "__name__", silent = TRUE))
   if (identical(name, "__main__"))
      objects <- grep("^__.*__$", objects, perl = TRUE, value = TRUE, invert = TRUE)
   
   # obtain a description of each Python object, using the already-understood
   # format used for R objects
   descriptions <- lapply(objects, .rs.reticulate.describeObject, parent = module)
   
   # try to get the module name (if any)
   name <- tryCatch(
      as.character(reticulate::py_get_attr(module, "__name__")),
      error = function(e) as.character(module)
   )
   
   list(
      language               = .rs.scalar("Python"),
      environment_monitoring = .rs.scalar(TRUE),
      environment_list       = descriptions,
      
      # included for compatibility with existing R environment list code
      context_depth          = .rs.scalar(0L),
      call_frames            = list(),
      function_name          = .rs.scalar(""),
      environment_name       = .rs.scalar(name),
      environment_is_local   = .rs.scalar(FALSE),
      use_provided_source    = .rs.scalar(FALSE),
      function_code          = .rs.scalar("")
   )
   
})

# > str(.rs.environmentList(globalenv()))
# List of 9
#  $ :List of 3
#   ..$ name : 'rs.scalar' chr "R_GlobalEnv"
#   ..$ frame: 'rs.scalar' int 0
#   ..$ local: 'rs.scalar' logi FALSE
# < ... >
.rs.addFunction("reticulate.listLoadedModules", function(includeBuiltins = FALSE)
{
   if (!requireNamespace("reticulate", quietly = TRUE))
      return(list())
   
   # read available loaded modules
   stack <- .rs.listBuilder()
   
   globals <- reticulate::py_run_string("globals()", convert = FALSE)
   reticulate::iterate(globals, function(variable) {
      
      object <- reticulate::py_get_item(globals, variable, silent = TRUE)
      if (!inherits(object, "python.builtin.module"))
         return(FALSE)
      
      # take module name rather than binding name discovered in globals
      name <- .rs.nullCoalesce(
         reticulate::py_get_attr(object, "__name__", silent = TRUE),
         variable
      )
      
      # ignore builtins if requested
      name <- as.character(name)
      if (!includeBuiltins && name %in% c("builtins", "__builtins__"))
         return(FALSE)
      
      stack$append(name)
      TRUE
      
   })
   
   # retrieve modules
   modules <- stack$data()
   
   # ensure main module is always included first
   modules <- c("__main__", setdiff(modules, "__main__"))
   
   # return in format suitable for environment pane
   lapply(modules, function(module) {
      list(
         name  = .rs.scalar(module),
         frame = .rs.scalar(0L),
         local = .rs.scalar(FALSE)
      )
   })
   
})

.rs.addFunction("reticulate.detectChanges", function(moduleName,
                                                     cacheOnly = FALSE)
{
   # resolve module
   module <- .rs.reticulate.resolveModule(moduleName)
   
   # list objects within this module
   newObjects <- reticulate::py_get_attr(module, "__dict__")
   
   # retrieve previously-cached objects in this module
   oldObjects <- .rs.nullCoalesce(
      .rs.getVar("reticulate.monitoredModuleObjects"),
      newObjects
   )
   
   # create copy of dictionary
   copy <- reticulate::import("copy", convert = FALSE)
   newObjects <- copy$copy(newObjects)
   
   # update cached globals
   .rs.setVar("reticulate.monitoredModuleObjects", newObjects)
   
   # if we're only updating the cache, bail now
   if (cacheOnly)
      return()
   
   # collect all vars
   vars <- sort(union(names(oldObjects), names(newObjects)))
   
   # iterate and check for changes
   changedObjects <- .rs.listBuilder()
   removedObjects <- .rs.listBuilder()
   
   for (var in vars)
   {
      old <- reticulate::py_get_item(oldObjects, var, silent = TRUE)
      new <- reticulate::py_get_item(newObjects, var, silent = TRUE)
      
      if (is.null(old) && is.null(new))
      {
         # shouldn't happen, but this implies no object before or after
      }
      else if (is.null(old))
      {
         # an object was added (treat as 'changed')
         changedObjects$append(.rs.reticulate.describeObject(var, newObjects))
      }
      else if (is.null(new))
      {
         # an object was removed
         removedObjects$append(var)
      }
      else if (!.rs.reticulate.objectsEqual(old, new))
      {
         # an object was changed
         changedObjects$append(.rs.reticulate.describeObject(var, newObjects))
      }
   }
   
   # bail if nothing to report
   if (changedObjects$empty() && removedObjects$empty())
      return()
   
   # emit change event
   .rs.enqueClientEvent("environment_changed", list(
      changed = changedObjects$data(),
      removed = as.character(removedObjects$data())
   ))
   
})

.rs.addFunction("reticulate.isPythonInitialized", function()
{
   "reticulate" %in% loadedNamespaces() &&
      reticulate::py_available(initialize = FALSE)
})

.rs.addFunction("reticulate.objectsEqual", function(lhs, rhs)
{
   # compare Pandas DataFrame objects with special method
   pandas <-
      inherits(lhs, "pandas.core.frame.DataFrame") &&
      inherits(rhs, "pandas.core.frame.DataFrame")
   
   if (pandas)
   {
      pandas <- reticulate::import("pandas", convert = TRUE)
      return(pandas$DataFrame$equals(lhs, rhs))
   }
   
   # default comparison method
   # otherwise, fall back to default '!=' comparison method
   tryCatch(
      reticulate:::py_compare(lhs, rhs, "=="),
      error = function(e) FALSE
   )

})

.rs.addFunction("reticulate.isFunction", function(object)
{
   inherits(object, c(
      "python.builtin.builtin_function_or_method",
      "python.builtin.function",
      "python.builtin.instancemethod"
   ))
})

.rs.addFunction("reticulate.viewHook", function(object, name)
{
   # TODO: assign complex expressions to temporary variable before view
   reticulate:::disable_conversion_scope(object)
   
   # convert Pandas DataFrames to R data.frames for now
   # (consider adapting data viewer to arbitrary tabular data in future?)
   if (inherits(object, "pandas.core.frame.DataFrame"))
   {
      # create object
      object <- reticulate::py_to_r(object)
      
      # assign as 'name', then view that
      assign(name, object, envir = environment())
      eval(call("View", as.name(name)), envir = environment())
   }
   else
   {
      # create dummy environment for this object
      envir <- new.env(parent = emptyenv())
      assign(name, object, envir = envir)
      
      # view object
      .rs.explorer.viewObject(
         object = object,
         title  = name,
         envir  = envir
      )
   }
   
})

.rs.addFunction("reticulate.isStructSeq", function(object)
{
   all(
      reticulate::py_has_attr(object, "n_sequence_fields"),
      reticulate::py_has_attr(object, "n_fields"),
      reticulate::py_has_attr(object, "n_unnamed_fields")
   )
})

.rs.addFunction("reticulate.listAttributes", function(object, includeDunderMethods = TRUE)
{
   attributes <- reticulate::py_list_attributes(object)
   
   # remove dunder methods if requested
   if (!includeDunderMethods)
      attributes <- grep("^__", attributes, value = TRUE, invert = TRUE)
   
   # sort so that dunder methods are shown last
   indices <- order(
      .rs.startsWith(attributes, "__"),
      .rs.startsWith(attributes, "_")
   )

   # return sorted attributes
   attributes[indices]
   
})

.rs.addFunction("reticulate.explorerCache", function()
{
   key <- "reticulate.explorerCacheDictionary"
   if (!.rs.hasVar(key))
      .rs.setVar(key, reticulate::dict())
   .rs.getVar(key)
})

.rs.addFunction("reticulate.usePython", function(python)
{
   # sanity check value of param
   ok <-
      is.character(python) &&
      length(python) == 1 &&
      file.exists(python)
   
   if (!ok)
      return(FALSE)
   
   # no-op if Python has already been initialized
   if (reticulate::py_available(initialize = FALSE))
      return(FALSE)
   
   # if we're working in an renv project that is already
   # managing the default version of python, then do nothing
   renvPython <- Sys.getenv("RENV_PYTHON", unset = NA)
   if (!is.na(renvPython))
      return(FALSE)

   # ok, request use of Python
   reticulate::use_python(python, required = TRUE)
})

# hook to be invoked when the Python session has been initialized by reticulate
options(reticulate.initialized = function()
{
   # clear hook
   options(reticulate.initialized = NULL)
   
   # call R hook
   .rs.reticulate.onPythonInitialized()
   
   # notify client that Python is being initialized
   .rs.reticulate.enqueueClientEvent(
      .rs.reticulateEvents$PYTHON_INITIALIZED,
      list()
   )
   
   # invoke lower-level callbacks
   .Call("rs_reticulateInitialized", PACKAGE = "(embedding)")
   
})

options(reticulate.repl.initialize = function()
{
   .rs.reticulate.replInitialize()
})

options(reticulate.repl.hook = function(buffer, contents, trimmed)
{
   .rs.reticulate.replHook(buffer, contents, trimmed)
})

options(reticulate.repl.busy = function(busy)
{
   .rs.reticulate.replBusy(busy)
})

options(reticulate.repl.teardown = function()
{
   .rs.reticulate.replTeardown()
})

# Attempts to infer the current Python interpreter used by reticulate
.rs.addFunction("inferReticulatePython", function() {
   
   # Use existing RETICULATE_PYTHON if set
   python <- Sys.getenv("RETICULATE_PYTHON", unset = NA)
   if (!is.na(python))
      return(python)
   
   # if reticulate is already loaded, check and see if it's already
   # configured to use a particular copy of Python
   loaded <-
      "reticulate" %in% loadedNamespaces() &&
      reticulate::py_available(initialize = FALSE)
   
   if (loaded) {
      config <- reticulate::py_config()
      return(config$python)
   }

   # if the user has configured RStudio to use a particular version
   # of Python, then use that
   python <- .rs.readUiPref("python_path")
   if (!is.null(python) && !identical(python, ""))
      return(path.expand(python))
   
   
   # if reticulate is installed, then try to load it in a child process and 
   # ask what version of Python it would choose to bind to.
   
   # Use existing RETICULATE_PYTHON_FALLBACK if set
   python <- Sys.getenv("RETICULATE_PYTHON_FALLBACK", unset = NA)
   if (!is.na(python))
      return(python)
   if (.rs.isPackageInstalled("reticulate")) {
      
      # avoid miniconda prompts
      prev_miniconda <- Sys.getenv("RETICULATE_MINICONDA_ENABLED")
      Sys.setenv(RETICULATE_MINICONDA_ENABLED = "FALSE")

      # Then perform a Python version scan/discovery
      # do this in child process so we don't pollute the namespace
      # callback must be passed as a func within a func to avoid loading reticulate
      py_config <- NULL
      tryCatch({
         py_config <- .rs.executeFunctionInChildProcess(
            callback = function() {
               suppressWarnings(tryCatch(reticulate::py_discover_config(),
                                         error = function(e) NULL))
      })
       }, finally = {
         Sys.setenv(RETICULATE_MINICONDA_ENABLED = prev_miniconda)
      })

      # Return a Python binary if we found one
      if (!is.null(py_config) && !is.null(py_config$python)) {
         return(py_config$python)
      }
      
   }

   # we didn't find any indication of the python version
   ""
   
})

#
# SessionDataPreview.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# Expressions which the user has explicitly permitted to run during a preview
# this session. Membership is checked with identical() against the
# (srcref-stripped) parsed expression; we deliberately do not persist this set
# to disk, so an approval never silently re-arms across sessions or projects.
.rs.setVar("preview.permittedExprs", new.env(parent = emptyenv()))

# Cache for the administrator-configured allowlist extension (read lazily from
# the 'preview-allowed-functions' session option); NULL until first read.
.rs.setVar("preview.allowedFunctions", NULL)

# The set of function calls we consider safe to evaluate without prompting when
# resolving a preview expression (a SQL '!preview conn=' connection, or an
# argument to an r2d3 preview). These are database connection constructors plus
# a handful of pure helpers commonly used to build arguments. The list is
# intentionally small; any call whose callee is not named here is treated as
# unsafe and requires explicit consent.
.rs.addFunction("preview.safeCallAllowlist", function()
{
   builtin <- c(
      # database connection constructors (sorted alphabetically)
      "bigquery", "bigrquery::bigquery",
      "dbConnect", "DBI::dbConnect",
      "dbDriver", "DBI::dbDriver",
      "dbPool", "pool::dbPool",
      "duckdb", "duckdb::duckdb",
      "MariaDB", "RMariaDB::MariaDB",
      "MySQL", "RMySQL::MySQL",
      "odbc", "odbc::odbc",
      "Postgres", "RPostgres::Postgres",
      "PostgreSQL", "RPostgreSQL::PostgreSQL",
      "Redshift", "RPostgres::Redshift",
      "Spark", "sparklyr::spark_connect",
      "SQLite", "RSQLite::SQLite",

      # pure helpers for constructing arguments (sorted alphabetically)
      "c", "file.path", "getOption", "list",
      "paste", "paste0", "sprintf", "Sys.getenv"
   )

   # Sites can extend the allowlist with their own connection helpers (for
   # example, an internally-built package) via the 'preview-allowed-functions'
   # session option (set in rsession.conf or by the session launcher). This
   # only widens which *callees* are permitted; their arguments are still
   # validated recursively, so it cannot be used to wave through arbitrary
   # code. It is safe to honor here because untrusted file content can never
   # reach this configuration: a preview expression's code does not run until
   # the classifier has already approved it.
   c(builtin, .rs.preview.configuredAllowlist())
})

# Additional safe callees configured by an administrator via the
# 'preview-allowed-functions' session option. The option is a single string of
# function names ('pkg::fn' or bare 'fn') separated by commas or whitespace.
# The value is fixed for the lifetime of the session, so cache it after the
# first read.
.rs.addFunction("preview.configuredAllowlist", function()
{
   if (is.null(.rs.preview.allowedFunctions))
   {
      value <- .rs.tryCatch(.Call("rs_previewAllowedFunctions", PACKAGE = "(embedding)"))
      parts <- if (is.character(value) && length(value))
         unlist(strsplit(value, "[,[:space:]]+"))
      else
         character()

      .rs.setVar("preview.allowedFunctions", parts[nzchar(parts)])
   }

   .rs.preview.allowedFunctions
})

# Resolve the name of a call's function position to a character string, for
# matching against the allowlist. Handles bare symbols ('dbConnect') and
# namespace-qualified access ('DBI::dbConnect'). Returns NULL for anything
# else (e.g. a call that itself produces a function).
.rs.addFunction("preview.callName", function(callee)
{
   if (is.symbol(callee))
      return(as.character(callee))

   if (is.call(callee) &&
       (identical(callee[[1L]], as.symbol("::")) ||
        identical(callee[[1L]], as.symbol(":::"))))
   {
      # deliberately normalize both '::' and ':::' to a single '::' form so one
      # allowlist entry (e.g. 'DBI::dbConnect') matches either spelling; the
      # exported/internal distinction does not affect whether the call is safe,
      # so do not "fix" this to preserve ':::'
      return(paste0(as.character(callee[[2L]]), "::", as.character(callee[[3L]])))
   }

   NULL
})

# Determine, via static analysis, whether a parsed preview expression is safe
# to evaluate without prompting the user. The expression comes from a file's
# '!preview' header, so it is fully attacker-controlled when the file comes
# from an untrusted source.
#
# An expression is safe when it is:
#   - a literal constant (no evaluation runs code), or
#   - a bare symbol that is not an active binding (a plain variable lookup), or
#   - namespace access ('pkg::name', 'pkg:::name'), or
#   - a parenthesized safe expression, or
#   - a call to an allow-listed function in which every argument is itself safe.
#
# Everything else (notably arbitrary function calls such as system(...)) is
# unsafe. Note that namespace qualification does not make a call safe:
# 'base::system(...)' is just as dangerous as 'system(...)', so the allowlist
# is consulted by name and the arguments are validated recursively.
#
# 'envir' is the environment in which the expression would ultimately be
# evaluated (the preview code path uses globalenv()). It is required to decide
# whether a bare symbol would trigger an active binding on lookup, so it is a
# parameter rather than being hard-coded -- both to keep the contract honest
# and so the classifier can be tested against a constructed environment.
.rs.addFunction("preview.isSafeExpr", function(expr, envir = globalenv())
{
   # literal constants (strings, numbers, logicals, NULL, ...) are safe
   if (!is.language(expr))
      return(TRUE)

   # a bare symbol is a plain variable lookup; safe unless it is an active
   # binding, in which case the lookup itself would execute a function
   if (is.symbol(expr))
   {
      name <- as.character(expr)
      if (!nzchar(name))
         return(FALSE)

      # eval() resolves symbols starting in 'envir' and walking its enclosing
      # environments (for globalenv() that is the attached search path), so an
      # active binding anywhere along that chain -- not just in 'envir' itself
      # -- would execute code on lookup. Walk from 'envir' up its parents (the
      # same order eval uses) to the environment that actually holds the name,
      # and reject it if that binding is active.
      env <- envir
      while (!identical(env, emptyenv()))
      {
         if (exists(name, envir = env, inherits = FALSE))
         {
            if (bindingIsActive(name, env))
               return(FALSE)
            break
         }
         env <- parent.env(env)
      }

      return(TRUE)
   }

   # anything that is not a literal or symbol must be a call to be safe
   if (!is.call(expr))
      return(FALSE)

   callee <- expr[[1L]]

   # namespace access ('pkg::name') only resolves a binding; it does not call
   if (identical(callee, as.symbol("::")) || identical(callee, as.symbol(":::")))
      return(TRUE)

   # a parenthesized expression is safe iff its body is safe
   if (identical(callee, as.symbol("(")))
      return(.rs.preview.isSafeExpr(expr[[2L]], envir = envir))

   # a regular call is safe only if the callee is allow-listed by name and
   # every argument is itself safe (checked recursively)
   name <- .rs.preview.callName(callee)
   if (is.null(name) || !(name %in% .rs.preview.safeCallAllowlist()))
      return(FALSE)

   args <- as.list(expr)[-1L]
   for (arg in args)
      if (!.rs.preview.isSafeExpr(arg, envir = envir))
         return(FALSE)

   TRUE
})

.rs.addFunction("preview.isPermittedExpr", function(expr)
{
   permitted <- .rs.preview.permittedExprs$items
   for (item in permitted)
      if (identical(item, expr))
         return(TRUE)
   FALSE
})

.rs.addFunction("preview.permitExpr", function(expr)
{
   if (!.rs.preview.isPermittedExpr(expr))
      .rs.preview.permittedExprs$items <-
         c(.rs.preview.permittedExprs$items, list(expr))

   invisible(NULL)
})

# Classify a parsed preview expression as "safe" (statically safe to
# evaluate), "permitted" (the user has explicitly allowed it this session), or
# "unsafe" (requires explicit consent before evaluation).
.rs.addFunction("preview.exprStatus", function(expr, envir = globalenv())
{
   if (.rs.preview.isSafeExpr(expr, envir = envir))
      return("safe")

   if (.rs.preview.isPermittedExpr(expr))
      return("permitted")

   "unsafe"
})

.rs.addJsonRpcHandler("preview_sql", function(code, allow = FALSE)
{
   # result helpers; the front-end dispatches on 'action'
   onError <- function(reason) {
      list(action = .rs.scalar("error"),
           message = .rs.scalar(.rs.truncate(reason)))
   }

   onConfirm <- function(expr) {
      list(action = .rs.scalar("confirm"),
           expression = .rs.scalar(.rs.truncate(.rs.deparse(expr))))
   }

   onSuccess <- function() {
      list(action = .rs.scalar("ok"))
   }

   # parse the user-provided code (strip srcref so connection expressions
   # compare equal against the permitted set maintained in SessionSql.R)
   parsed <- .rs.tryCatch(parse(text = code, keep.source = FALSE))
   if (inherits(parsed, "error"))
      return(onError("Failed to parse SQL preview comment."))

   # a preview comment is a single '.rs.previewSql(...)' call; require exactly
   # one statement so trailing statements cannot be silently dropped (here the
   # call is evaluated server-side, but we keep the contract symmetric with the
   # r2d3 handler, where multi-statement input is a code-injection vector)
   if (length(parsed) != 1L)
      return(onError("Unsupported SQL preview comment."))
   parsed <- parsed[[1L]]

   # require the canonical preview call shape. the '!preview' header lets the
   # user override the function name (e.g. '-- !preview system(...)'), so we
   # must confirm the callee is our own preview helper before evaluating --
   # otherwise the function position is itself a code-injection vector.
   if (!is.call(parsed) || !identical(parsed[[1L]], quote(.rs.previewSql)))
      return(onError("Unsupported SQL preview comment."))

   # substitute missing arguments for NULL, so that match.call
   # does what we expect
   for (i in seq_along(parsed))
      if (identical(parsed[[i]], quote(expr = )))
         parsed[i] <- list(NULL)

   # attempt to match the call
   matched <- .rs.tryCatch(match.call(.rs.previewSql, parsed))
   if (inherits(matched, "error"))
      return(onError("Unexpected SQL preview comment."))

   # validate that the user provided a connection
   if (is.null(matched$conn))
      return(onError("No connection was specified in SQL preview comment."))

   # every argument other than the connection (the statement path, plus any
   # extra arguments forwarded to DBI::dbSendQuery) must be statically safe,
   # so they cannot smuggle in arbitrary code alongside a benign connection
   others <- as.list(matched)[-1L]
   others$conn <- NULL
   for (arg in others)
      if (!.rs.preview.isSafeExpr(arg))
         return(onError("Unsupported SQL preview comment."))

   # classify the connection expression itself; arbitrary expressions require
   # the user's explicit consent before we evaluate them
   connExpr <- matched$conn
   if (identical(.rs.preview.exprStatus(connExpr), "unsafe"))
   {
      if (!isTRUE(allow))
         return(onConfirm(connExpr))

      # the user approved this expression; remember it for the rest of the
      # session so future previews and completions resolve it without prompting
      .rs.preview.permitExpr(connExpr)
   }

   # okay, try to evaluate it
   status <- .rs.tryCatch(eval(parsed, envir = globalenv()))
   if (inherits(status, "error"))
      return(onError(conditionMessage(status)))

   # .rs.previewSql reports connection/query failures by returning a
   # (non-empty) message string rather than by signaling an error; surface
   # those to the user just as the previous string-returning contract did
   if (is.character(status) && length(status) && nzchar(status))
      return(onError(status))

   onSuccess()
})

# Consent check for the r2d3 ('// !preview r2d3 ...') file preview. Unlike SQL
# preview, the built 'r2d3::r2d3(...)' call is run in the console (so r2d3 can
# render the widget), so this handler classifies the command and reports
# whether it is safe to run -- the front-end performs the console execution.
#
# Because the front-end runs the command string verbatim, the command must be
# a single statement: classifying only the first expression while the console
# runs every statement would let a multi-statement header (e.g.
# 'r2d3::r2d3(...); system(...)') smuggle code past the classifier. We reject
# anything that does not parse to exactly one statement.
.rs.addJsonRpcHandler("preview_r2d3", function(code, allow = FALSE)
{
   onError <- function(reason) {
      list(action = .rs.scalar("error"),
           message = .rs.scalar(.rs.truncate(reason)))
   }

   onConfirm <- function(expr) {
      list(action = .rs.scalar("confirm"),
           expression = .rs.scalar(.rs.truncate(.rs.deparse(expr))))
   }

   onSuccess <- function() {
      list(action = .rs.scalar("ok"))
   }

   parsed <- .rs.tryCatch(parse(text = code, keep.source = FALSE))
   if (inherits(parsed, "error"))
      return(onError("Failed to parse preview comment."))

   # the front-end runs the command verbatim in the console, so it must be a
   # single statement; reject multi-statement input that would otherwise run
   # extra code the classifier (which inspects only the first expression) never
   # examined
   if (length(parsed) != 1L)
      return(onError("Unsupported preview comment."))
   parsed <- parsed[[1L]]

   # the front-end forces the call to r2d3::r2d3; confirm that here so the
   # function position cannot itself be used to inject code
   if (!is.call(parsed) || !identical(parsed[[1L]], quote(r2d3::r2d3)))
      return(onError("Unsupported preview comment."))

   # every argument (the source path plus header arguments such as 'data=')
   # must be statically safe or already permitted; otherwise ask for consent
   args <- as.list(parsed)[-1L]
   unsafe <- Filter(function(arg) identical(.rs.preview.exprStatus(arg), "unsafe"), args)
   if (length(unsafe))
   {
      if (!isTRUE(allow))
         return(onConfirm(unsafe[[1L]]))

      for (arg in unsafe)
         .rs.preview.permitExpr(arg)
   }

   onSuccess()
})

.rs.addFunction("previewDataFrame", function(data, script)
{
   preparedData <- .rs.prepareViewerData(
      data,
      maxFactors = 100,
      maxCols = 100,
      maxRows = 1000
   )

   preview <- list(
      data = preparedData$data,
      columns = preparedData$columns,
      title = if (is.character(script)) .rs.scalar(script) else NULL
   )

   .rs.enqueClientEvent("data_output_completed", preview)
   
   invisible(NULL)

})

.rs.addFunction("previewSql", function(conn, statement, ...)
{
   script <- NULL
   if (file.exists(statement)) {
      script <- statement
      statement <- paste(readLines(script), collapse = "\n")
   }

   # remove comments since some drivers might not support them
   statement <- gsub("--[^\n]*\n+", "", statement)

   # force the connection to let DBI and others initialize S3
   conn <- .rs.tryCatch(force(conn))
   if (inherits(conn, "error")) {
      msg <- paste("Failed to retrieve connection:", conditionMessage(conn))
      return(.rs.scalar(msg))
   }

   # fetch at most 100 records as a preview
   status <- .rs.tryCatch({
      rs <- DBI::dbSendQuery(conn, statement = statement, ...)
      data <- DBI::dbFetch(rs, n = 1000)
      DBI::dbClearResult(rs)
   })
   
   if (inherits(status, "error")) {
      msg <- paste("Failed to query database:", conditionMessage(status))
      return(.rs.scalar(msg))
   }

   .rs.previewDataFrame(data, script)
})

root <- rprojroot::find_rstudio_root_file()
setwd(root)

transformations <- list(
   
   list(
      name = "Integer",
      type = "int",
      null = "0"
   ),
   
   list(
      name = "Number",
      type = "double",
      null = "0"
   ),
   
   list(
      name = "String",
      type = "String",
      null = "null"
   ),
   
   list(
      name = "Boolean",
      type = "boolean",
      null = "false"
   )
   
)

SOURCE <- "src/gwt/src/org/rstudio/core/client/JsVector.java"

contents <- readLines(SOURCE)
lapply(transformations, function(transformation) {
   
   replaced <- contents
   
   name <- transformation$name
   type <- transformation$type
   null <- transformation$null
   
   fileName <- paste("JsVector", name, ".java", sep = "")
   className <- paste("JsVector", name, sep = "")
   
   replaced <- gsub(" <T> ", " ", replaced)
   replaced <- gsub("<T>", "", replaced)
   replaced <- gsub("JsVector<T>", className, replaced)
   replaced <- gsub("JsVector", className, replaced)
   replaced <- gsub("\\bT\\b", type, replaced)
   replaced <- gsub("\\bnull\\b", null, replaced)
   
   target <- file.path(dirname(SOURCE), fileName)
   writeLines(replaced, con = target, sep = "\n")
   
})

#
# RStudioAPI.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("rstudioapi.processRequest", function(requests,
                                                      response,
                                                      secret)
{
   result <- .rs.tryCatch(
      .rs.rstudioapi.processRequestImpl(requests, response, secret)
   )
   
   unlink(requests)
   if (inherits(result, "error")) {
      saveRDS(result, response)
      return(FALSE)
   }
   
   TRUE
})

.rs.addFunction("rstudioapi.processRequestImpl", function(requests,
                                                          response,
                                                          secret)
{
   data <- readRDS(requests)
   if (!identical(data$secret, secret))
      stop("invalid secret in rstudioapi IPC")
   
   call <- data$call
   output <- eval(call, envir = baseenv())
   saveRDS(output, file = response)
})

#
# Tools.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# target environment for rstudio supplemental tools
# (guard against attempts to duplicate this environment)
.rs.Env <- if ("tools:rstudio" %in% search()) {
   as.environment("tools:rstudio")
} else {
   attach(NULL, name = "tools:rstudio")
}

# allow access to tools env from helper function
assign(".rs.toolsEnv", function()
{
   .rs.Env
}, envir = .rs.Env)

# target environment for symbol lookup, with all necessary base packages
assign(".rs.symbolLookupEnv", function()
{
   new.env(parent = .rs.toolsEnv())
}, envir = .rs.Env)

# platform detection
assign(".rs.platform.isUnix",    .Platform$OS.type == "unix",         envir = .rs.Env)
assign(".rs.platform.isWindows", .Platform$OS.type == "windows",      envir = .rs.Env)
assign(".rs.platform.isLinux",   Sys.info()[["sysname"]] == "Linux",  envir = .rs.Env)
assign(".rs.platform.isMacos",   Sys.info()[["sysname"]] == "Darwin", envir = .rs.Env)

#' Add a function to the 'tools:rstudio' environment.
#'
#' This environment is placed on the search path, and so is accessible and
#' readable during regular evaluation in an R session.
#'
#' @param name The name of the R function. The prefix '.rs.' will be pre-pended
#'   to the supplied function name.
#'
#' @param FN The \R function to be added.
#'
#' @param attrs An optional list of attributes, to be set on the function.
#'
#' @param envir An optional environment, to be set as the enclosing environment
#'   for the function `f`. By default, newly-defined functions use the
#'   'tools:rstudio' environment as the parent function. For functions which
#'   might be exposed to users (e.g. via options), you may want to instead use
#'   the base environment to avoid issues with serialization.
assign(".rs.addFunction", function(name, FN, attrs = list(), envir = .rs.toolsEnv())
{
   # add optional attributes
   for (attrib in names(attrs))
      attr(FN, attrib) <- attrs[[attrib]]

   # ensure function evaluates in requested environment
   environment(FN) <- envir

   # assign in tools env
   fullName <- paste(".rs.", name, sep = "")
   assign(fullName, FN, envir = .rs.toolsEnv())

}, envir = .rs.Env)

# force helper function to also execute in tools environment
environment(.rs.Env[[".rs.addFunction"]]) <- .rs.Env

# add a global (non-scoped) variable to the tools:rstudio environment
.rs.addFunction("addGlobalVariable", function(name, var)
{
   envir <- .rs.toolsEnv()
   environment(var) <- envir
   assign(name, var, envir = envir)
})

# add a global (non-scoped) function to the tools:rstudio environment
.rs.addFunction("addGlobalFunction", function(name, FN)
{
   envir <- .rs.toolsEnv()
   environment(FN) <- envir
   assign(name, FN, envir = envir)
})

# add an rpc handler to the tools:rstudio environment
.rs.addFunction("addApiFunction", function(name, FN)
{
   fullName <- paste("api.", name, sep = "")
   envir <- .rs.symbolLookupEnv()
   environment(FN) <- envir
   .rs.addFunction(fullName, FN, envir = envir)
})

# for functions which might act as error handlers
.rs.addFunction("addErrorHandlerFunction", function(name, type, handler)
{
   attrs <- list(
      rstudioErrorHandler = TRUE,
      hideFromDebugger    = TRUE,
      errorHandlerType    = type
   )

   .rs.addFunction(name, handler, attrs, envir = .rs.toolsEnv())
})

.rs.addFunction("setVar", function(name, var)
{
   envir <- .rs.toolsEnv()
   if (!is.null(var))
      environment(var) <- envir

   fullName <- paste(".rs.", name, sep = "")
   assign(fullName, var, envir = envir)
})

.rs.addFunction("defineVar", function(name, var)
{
   envir <- .rs.toolsEnv()
   if (!is.null(var))
      environment(var) <- envir

   fullName <- paste(".rs.", name, sep = "")
   if (!exists(fullName, envir = envir, inherits = FALSE))
      assign(fullName, var, envir = envir)
})

.rs.addFunction("clearVar", function(name)
{
   envir <- .rs.toolsEnv()
   fullName <- paste(".rs.", name, sep = "")
   remove(list = fullName, pos = envir)
})

.rs.addFunction("getVar", function(name)
{
   envir <- .rs.toolsEnv()
   fullName <- paste(".rs.", name, sep = "")
   envir[[fullName]]
})

.rs.addFunction("hasVar", function(name)
{
   envir <- .rs.toolsEnv()
   fullName <- paste(".rs.", name, sep = "")
   exists(fullName, envir = envir)
})

.rs.addFunction("defineHookImpl", function(package, binding, hook, all)
{
   # get reference to original function definition
   namespace <- getNamespace(package)
   original <- get(binding, envir = namespace)

   # update our hook to match definition of original
   environment(hook) <- environment(original)
   formals(hook) <- formals(original)

   # replace binding in search path environment
   envir <- as.environment(paste("package", package, sep = ":"))
   .rs.replaceBindingImpl(envir, binding, hook)

   # also replace the binding in the package namespace if requested
   if (all)
   {
      .rs.registerPackageAttachedHook(package, function(...)
      {
         .rs.replaceBindingImpl(namespace, binding, hook)
      })
   }
})

.rs.addFunction("defineGlobalHook", function(package, binding, hook, when = TRUE)
{
   if (when)
      .rs.defineHookImpl(package, binding, hook, all = TRUE)
})

.rs.addFunction("defineHook", function(package, binding, hook, when = TRUE)
{
   if (when)
      .rs.defineHookImpl(package, binding, hook, all = FALSE)
})

.rs.addFunction("setOption", function(name, value)
{
   data <- list(value)
   names(data) <- name
   options(data)
})

.rs.addFunction("setOptionDefault", function(name, value)
{
   # if the option is already set, nothing to do
   if (!is.null(getOption(name)))
      return(FALSE)

   # otherwise, set it
   data <- list(value)
   names(data) <- name
   options(data)

   TRUE
})

.rs.addFunction("evalInGlobalEnv", function(code)
{
   eval(
      parse(text = code),
      envir = globalenv()
   )
})

# attempts to restore the global environment from a file
# on success, returns an empty string; on failure, returns
# the error message
.rs.addFunction("restoreGlobalEnvFromFile", function(path)
{
   Encoding(path) <- "UTF-8"

   # avoid path encoding issues by moving to directory first
   if (!file.exists(path))
      return(paste(path, "does not exist"))

   owd <- setwd(dirname(path))
   on.exit(setwd(owd), add = TRUE)

   status <- try(
      load(basename(path), envir = .GlobalEnv),
      silent = TRUE
   )

   if (!inherits(status, "try-error"))
      return("")

   # older versions of R don't provide a 'condition' attribute
   # for 'try()' errors
   condition <- attr(status, "condition")
   if (is.null(condition)) {
      if (is.character(status))
         return(paste(c(status), collapse = "\n"))
      else
         return("Unknown Error")
   }

   # has condition, but no message? should not happen
   if (!"message" %in% names(condition))
      return("Unknown Error")

   paste(condition$message, collapse = "\n")
})

# save current state of options() to file
.rs.addFunction("saveOptions", function(filename)
{
   # get reference to current options
   opt <- options()

   # don't attempt to serialize cpp11 preserve env as it may
   # contain recursive R objects which cause crashes when serialized
   #
   # https://github.com/rstudio/rstudio-pro/issues/2052
   opt$cpp11_preserve_env  <- NULL
   opt$cpp11_preserve_xptr <- NULL

   # don't serialize these RStudio-managed options. their values are functions
   # (or lists of functions) that close over the large internal '.rs' tools
   # environment, so serializing them is slow -- each one drags the whole
   # environment into the saved image. it is also pointless: RStudio re-sets
   # each of these on every session start (see SessionConnections.R, Api.R,
   # SessionReticulate.R), so any restored value is overwritten on resume.
   rsManagedOptions <- c(
      "connectionObserver",
      "terminal.manager",
      "reticulate.initialized",
      "reticulate.repl.initialize",
      "reticulate.repl.hook",
      "reticulate.repl.busy",
      "reticulate.repl.teardown"
   )
   opt[rsManagedOptions] <- NULL

   # 'error' is commonly set by users, so only drop it when it is one of the
   # error handlers RStudio itself installs. those are tagged with the
   # 'rstudioErrorHandler' attribute via .rs.addErrorHandlerFunction (see
   # SessionErrors.R) and are re-installed on every session start; a
   # user-supplied handler carries no such tag and is preserved.
   #
   # note that R coerces a function assigned to options(error=) into a call
   # that wraps the function, so the attribute is found on the embedded
   # function (the first element of the call) rather than on the option value.
   errorHandler <- opt$error
   if (is.call(errorHandler))
      errorHandler <- errorHandler[[1L]]
   if (isTRUE(attr(errorHandler, "rstudioErrorHandler", exact = TRUE)))
      opt$error <- NULL

   # first write to sidecar file, and then rename that file
   # (don't let failed serialization leave behind broken workspace)
   sidecarFile <- paste(filename, "incomplete", sep = ".")

   # remove an old sidecar file if any -- these would be leftover from
   # a previously-failed attempt to save the session
   unlink(sidecarFile)

   status <- tryCatch(
      suppressWarnings(save(opt, file = sidecarFile)),
      error = identity
   )

   # if we manage to catch the error (might not be possible for stack overflow)
   # then clean up the sidecar file and re-propagate the error (caller will take
   # care of reporting further errors to user)
   if (inherits(status, "error"))
   {
      unlink(sidecarFile)
      stop(status)
   }

   # save completed successfully -- rename sidecar file to final location
   file.rename(sidecarFile, filename)
})

# restore options() from file
.rs.addFunction("restoreOptions", function(filename)
{
   load(filename)
   options(opt)
})

# save current state of .libPaths() to file
.rs.addFunction("saveLibPaths", function(filename)
{
  libPaths <- .libPaths()
  save(libPaths, file = filename)
})

# restore .libPaths() from file
.rs.addFunction("restoreLibPaths", function(filename)
{
  load(filename)
  .libPaths(libPaths)
})


# try to determine if devtools::dev_mode is on
.rs.addFunction("devModeOn", function(){

  # determine devmode path (devtools <= 0.6 hard-coded it)
  devToolsPath <- getOption("devtools.path")
  if (is.null(devToolsPath))
    if ("devtools" %in% .packages())
      devToolsPath <- "~/R-dev"

  # no devtools path
  if (is.null(devToolsPath))
    return (FALSE)

  # is the devtools path active?
  devToolsPath <- .rs.normalizePath(devToolsPath, winslash = "/", mustWork = FALSE)
  devToolsPath %in% .libPaths()
})

.rs.addFunction("isDevPackage", function(name) {
   "pkgload" %in% loadedNamespaces() && pkgload::is_dev_package(name)
})

# load a package by name
.rs.addFunction("loadPackage", function(packageName, lib)
{
   # when R loads package dependencies through a call to `library()`, dependent
   # packages will be searched for on the current library paths rather than the
   # library path(s) passed to the lib.loc argument. for that reason, it is
   # prudent to set the library paths explicitly when loading a package.
   #
   # note that we want to preserve the existing library paths as well since
   # dependencies may live within a separate library path from the package to be
   # loaded; it should suffice to place the requested library at the front of
   # the library paths
   if (nzchar(lib)) {
      libPaths <- .libPaths()
      .libPaths(c(lib, libPaths))
      on.exit(.libPaths(libPaths), add = TRUE)
   }

   library(packageName, character.only = TRUE)
})

# unload a package by name
.rs.addFunction("unloadPackage", function(packageName)
{
   pkg = paste("package:", packageName, sep="")
   detach(pos = match(pkg, search()))
})

# Install a package only if it isn't already installed. Checks the on-disk
# library for the package directory rather than calling requireNamespace(),
# so the package's namespace is not loaded as a side effect. Useful for test
# setup and other contexts that need a package present but don't want the
# cost of a redundant download + reinstall when it's already there.
.rs.addFunction("ensurePackageInstalled", function(packageName,
                                                   repos = getOption("repos"),
                                                   type = getOption("pkgType"))
{
   if (!nzchar(system.file(package = packageName)))
      install.packages(packageName, repos = repos, type = type)
})

.rs.addFunction("getPackageVersion", function(packageName)
{
   v <- suppressWarnings(utils:::packageDescription(packageName,
                                              fields="Version"))
   package_version(v)
})

# save an environment to a file
.rs.addFunction("saveEnvironment", function(env, filename)
{
   # suppress warnings emitted here, as they are not actionable
   # by the user (and seem to be harmless)
   suppressWarnings(
      save(list = ls(envir = env, all.names = TRUE),
           file = filename,
           envir = env)
   )

   invisible (NULL)
})

.rs.addFunction("disableSaveCompression", function()
{
  options(save.defaults=list(ascii=FALSE, compress=FALSE))
  options(save.image.defaults=list(ascii=FALSE, safe=TRUE, compress=FALSE))
})

.rs.addFunction("attachDataFile", function(filename, name, pos = 2)
{
   if (!file.exists(filename))
      stop(gettextf("file '%s' not found", filename), domain = NA)

   .Internal(attach(NULL, pos, name))
   load(filename, envir = as.environment(pos))

   invisible (NULL)
})

.rs.addGlobalFunction("RStudioGD", function()
{
   .Call("rs_createGD")
})

# set our graphics device as the default and cause it to be created/set
.rs.addFunction("initGraphicsDevice", function()
{
   options(device="RStudioGD")
   grDevices::deviceIsInteractive("RStudioGD")
})

.rs.addFunction("activateGraphicsDevice", function()
{
   invisible(.Call("rs_activateGD"))
})

.rs.addFunction("newDesktopGraphicsDevice", function()
{
   sysName <- Sys.info()[['sysname']]
   if (identical(sysName, "Windows"))
      windows()
   else if (identical(sysName, "Darwin"))
      quartz()
   else if (capabilities("X11"))
      X11()
   else {
      warning("Unable to create a new graphics device ",
              "(RStudio device already active and only a ",
              "single RStudio device is supported)",
              call. = FALSE)
   }
})

# record an object to a file
.rs.addFunction("saveGraphicsSnapshot", function(snapshot, filename)
{
   # make a copy of the snapshot into plot and set its metadata in a way
   # that is compatible with recordPlot
   plot = snapshot
   attr(plot, "version") <- as.character(getRversion())
   class(plot) <- "recordedplot"

   save(plot, file=filename)
})

.rs.addFunction("GEplayDisplayList", function()
{
   tryCatch(
      .Call("rs_GEplayDisplayList"),
      error = function(e) warning(e)
   )
})

.rs.addFunction("GEcopyDisplayList", function(fromDevice)
{
   tryCatch(
      .Call("rs_GEcopyDisplayList", fromDevice),
      error = function(e) warning(e)
   )
})

# record an object to a file
.rs.addFunction("saveGraphics", function(filename)
{
   plot <- grDevices::recordPlot()
   save(plot, file = filename)
})

# restore an object from a file
.rs.addFunction("restoreGraphics", function(filename)
{
   # load the 'plot' object
   envir <- new.env(parent = emptyenv())
   load(filename, envir = envir)
   plot <- envir$plot

   # restore native symbols
   dlls <- getLoadedDLLs()
   rVersion <- getRversion()
   wasPairlist <- is.pairlist(plot[[1]])

   # convert to list (iterating large pairlist in R is slow; especially
   # since we need to update the data structure as we read through)
   items <- as.list(plot[[1]])

   # iterate through and update native symbols (this is necessary as the
   # saved object will contain native routines with incorrect or null
   # addresses; we need to re-discover the correct address for the routines
   # required in generating the plot)
   restored <- lapply(items, function(item) {

      # extract saved symbol
      symbol <- item[[2]][[1]]
      if (!inherits(symbol, "NativeSymbolInfo"))
         return(item)

      # extract associated package name
      name <- if (is.null(symbol$package))
         symbol$dll[["name"]]
      else
         symbol$package[["name"]]

      # re-construct the required symbol
      nativeSymbol <- getNativeSymbolInfo(
         name    = symbol$name,
         PACKAGE = dlls[[name]]
      )

      # replace the old symbol
      item[[2]][[1]] <- nativeSymbol
      item

   })

   # turn back into pairlist after
   if (wasPairlist)
      restored <- as.pairlist(restored)

   # update plot items
   if (!is.null(restored))
      plot[[1]] <- restored

   # tag plot with process pid
   plotPid <- attr(plot, "pid")
   if (is.null(plotPid) || (plotPid != Sys.getpid()))
      attr(plot, "pid") <- Sys.getpid()

   # if this plot depends on the grid package, and we don't have a graphics
   # device open, then we'll have to create a new one
   # https://github.com/rstudio/rstudio/issues/2919
   for (item in plot) {
      name <- attr(item, "pkgName", exact = TRUE)
      if (is.character(name) && name[[1L]] %in% c("grid", "ggplot2")) {
         if (requireNamespace("grid", quietly = TRUE))
            grid::grid.newpage()
         break
      }
   }

   # we suppressWarnings so that R doesn't print a warning if we restore
   # a plot saved from a previous version of R (which will occur if we
   # do a resume after upgrading the version of R on the server)
   suppressWarnings(grDevices::replayPlot(plot))

})

# generate a uuid
.rs.addFunction("createUUID", function()
{
  .Call("rs_createUUID")
})

# check the current R architecture
.rs.addFunction("getRArch", function()
{
   .Platform$r_arch
})

# pager
.rs.addFunction("pager", function(files, header, title, delete.file)
{
   for (i in 1:length(files)) {
      if ((i > length(header)) || !nzchar(header[[i]]))
         fileTitle <- title
      else
         fileTitle <- header[[i]]

      .Call("rs_showFile", fileTitle, files[[i]], delete.file)
   }
})

.rs.addFunction("canonicalizePath", function(path, winslash = "/")
{
   file.path(
      normalizePath(dirname(path), winslash = winslash, mustWork = FALSE),
      basename(path),
      fsep = winslash
   )
})

# alias for normalizePath function
.rs.addFunction("normalizePath", normalizePath)

# alias for path.package function
.rs.addFunction("pathPackage", path.package)

# handle viewing a pdf differently on each platform:
#  - windows: shell.exec
#  - mac: Preview
#  - linux: getOption("pdfviewer")
.rs.addFunction("shellViewPdf", function(path)
{
   sysName <- Sys.info()[['sysname']]

   if (identical(sysName, "Windows"))
   {
     shell.exec(path)
   }
   else
   {
      # force preview on osx to workaround acrobat reader crashing bug
      if (identical(sysName, "Darwin"))
         cmd <- paste("open", "-a", "Preview")
      else
         cmd <- shQuote(getOption("pdfviewer"))
      system(paste(cmd, shQuote(path)), wait = FALSE)
   }
})

.rs.addFunction("replaceBindingImpl", function(envir, binding, value)
{
   if (exists(binding, envir = envir, inherits = FALSE))
   {
      if (bindingIsLocked(binding, envir))
      {
         unlockBinding(binding, envir)
         on.exit(lockBinding(binding, envir), add = TRUE)
      }

      assign(binding, value, envir = envir)
   }
})

.rs.addFunction("replaceBinding", function(binding, package, override)
{
   # override in namespace
   if (!requireNamespace(package, quietly = TRUE))
      stop(sprintf("Failed to load namespace for package '%s'", package))

   namespace <- asNamespace(package)

   # get reference to original binding
   original <- get(binding, envir = namespace)

   # replace the binding
   if (is.function(override))
      environment(override) <- namespace

   .rs.replaceBindingImpl(namespace, binding, override)

   # if package is attached, override there as well
   searchPathName <- paste("package", package, sep = ":")
   if (searchPathName %in% search()) {
      env <- as.environment(searchPathName)
      if (exists(binding, envir = env))
         .rs.replaceBindingImpl(env, binding, override)
   }

   # return original
   original
})

# hook an internal R function
.rs.addFunction("replacePackageBinding", function(name,
                                                  package,
                                                  hook,
                                                  namespace = FALSE)
{
   # replace in environment on search path
   envir <- as.environment(paste("package", package, sep = ":"))
   .rs.replaceBindingImpl(envir, name, hook)

   # remap in function namespace if requested as well
   if (namespace)
   {
      envir <- asNamespace(package)
      .rs.replaceBindingImpl(envir, name, hook)
   }
})

.rs.addFunction("registerHook", function(name,
                                         package,
                                         hookFactory,
                                         namespace = FALSE)
{
   # ensure the package is loaded and attached (since we need to modify
   # the version of the function normally placed on the search path)
   library(package, character.only = TRUE, quietly = TRUE)

   # construct search path environment name for package
   packageName <- paste("package", package, sep = ":")

   # get original version of function (bail if it doesn't exist)
   original <- base::get(name, packageName, mode = "function")
   if (is.null(original)) {
      fmt <- "internal error: function %s not found"
      msg <- sprintf(fmt, shQuote(name))
      stop(msg, call. = FALSE)
   }

   # new function definition
   new <- hookFactory(original)

   # replace the bindings
   .rs.replacePackageBinding(name, package, new, namespace)
})

.rs.addFunction("callAs", function(name, f, ...)
{
   # TODO: figure out how to print the args (...) as part of the message

   # run the original function (f). setup condition handlers solely so that
   # we can correctly print the name of the function called in error
   # and warning messages -- otherwise R prints "original(...)"
   withCallingHandlers(
      tryCatch(
         f(...),
         error = function(e)
         {
            cat("Error in ", name, " : ", e$message, "\n", sep = "")
         }
      ),
      warning = function(w)
      {
         if (getOption("warn") >= 0)
            cat("Warning in ", name, " :\n  ",  w$message, "\n", sep = "")
         invokeRestart("muffleWarning")
      }
   )
})

# replacing an internal R function
.rs.addFunction("registerReplaceHook", function(name, package, hook, namespace = FALSE)
{
   hookFactory <- function(original) function(...) .rs.callAs(name, hook,  original, ...)
   .rs.registerHook(name, package, hookFactory, namespace)
})

# notification that an internal R function was called
.rs.addFunction("registerNotifyHook", function(name, package, hook, namespace = FALSE)
{
   hookFactory <- function(original) function(...)
   {
      # call hook after original is executed
      on.exit(hook(...))

      # call original
      .rs.callAs(name, original, ...)
   }
   .rs.registerHook(name, package, hookFactory, namespace);
})

# marking functions in R packages as unsupported
.rs.addFunction("registerUnsupported", function(name, package, alternative = "")
{
   unsupported <- function(...)
   {
      msg <- "function not supported in RStudio"
      if (nzchar(alternative))
        msg <- paste(msg, "(try", alternative, "instead)")
      msg <- paste(msg, "\n", sep = "")
      stop(msg)
   }

   .rs.registerReplaceHook(name, package, unsupported)
})

.rs.addFunction("parseCRANReposList", function(repos) {
  parts <- strsplit(repos, "\\|")[[1]]
  indexes <- seq_len(length(parts) / 2)

  r <- list()
  for (i in indexes)
    r[[parts[[2 * i - 1]]]] <- parts[[2 * i]]

  r
})

.rs.addFunction("setCRANRepos", function(cran, secondary)
{
  local({

      r <- c(
        list(CRAN = cran),
        .rs.parseCRANReposList(secondary)
      )

      # ensure repos is character (many packages assume the
      # repos option will be a character vector)
      n <- names(r)
      r <- as.character(r)
      names(r) <- n

      # attribute indicating the repos was set from rstudio prefs
      attr(r, "RStudio") <- TRUE

      options(repos=r)
    })
})

.rs.addFunction("setCRANReposAtStartup", function(cran, secondary)
{
   # check whether the user has already set a CRAN repository
   # in their .Rprofile
   repos <- getOption("repos")
   cranMirrorConfigured <- !"@CRAN@" %in% repos
   if (!cranMirrorConfigured)
      .rs.setCRANRepos(cran, secondary)
})

.rs.addFunction("isCRANReposFromSettings", function()
{
   !is.null(attr(getOption("repos"), "RStudio"))
})


.rs.addFunction("setCRANReposFromSettings", function(cran, secondary)
{
   # only set the repository if the repository was set by us
   # in the first place (it wouldn't be if the user defined a
   # repository in .Rprofile or called setRepositories directly)
   if (.rs.isCRANReposFromSettings())
      .rs.setCRANRepos(cran, secondary)
})


.rs.addFunction("libPathsAppend", function(path)
{
   # remove it if it already exists
   .libPaths(.libPaths()[.libPaths() != path])

   # append it
   .libPaths(append(.libPaths(), path))
})


.rs.addFunction("isLibraryWriteable", function(lib)
{
   # file.access() can be unreliable here, as it's
   # possible for a directory to be un-writable despite
   # having writable permissions set. the best way to
   # be sure is to try to create and remove a file in
   # that directory
   file <- tempfile(pattern = ".rstudio-", tmpdir = lib)
   status <- tryCatch(file.create(file), condition = identity)

   # treat any conditions as errors, since R will emit a
   # warning (rather than error) if file creation fails
   if (inherits(status, "condition"))
      return(FALSE)

   # now, try to remove the temporary file (it would stink
   # if we could create files but not remove them ...)
   status <- tryCatch(file.remove(file), condition = identity)
   if (inherits(status, "condition"))
      return(FALSE)

   # we successfully created and removed a file in the library
   # directory; treat it as writable
   TRUE

})

.rs.addFunction("defaultLibPathIsWriteable", function()
{
   .rs.isLibraryWriteable(.libPaths()[1L])
})

# Support for implementing json-rpc methods directly in R:
#
# - json-rpc method endpoints can be installed by calling the
#   .rs.addJsonRpcHandler function (all R files within the handlers directory
#   are sourced so that they can install handlers)
#
# - these endpoints are installed within the tools:rstudio environment,
#   therefore if common helper methods are required they should be added to
#   the same environment using .rs.addFunction
#
# - Json <-> R marshalling is implemented within RJsonRpc.cpp
#   details on how this works can be found in the comments therin
#

# add an rpc handler to the tools:rstudio environment
.rs.addFunction("addJsonRpcHandler", function(name, FN)
{
   fullName <- paste("rpc.", name, sep = "")
   .rs.addFunction(fullName, FN, TRUE)
})

# list all rpc handlers in the tools:rstudio environment
.rs.addFunction("listJsonRpcHandlers", function()
{
   objects(
      name      = "tools:rstudio",
      pattern   = utils:::glob2rx(".rs.rpc.*"),
      all.names = TRUE
   )
})


.rs.addFunction("showDiagnostics", function()
{
  diagPath <- shQuote(.rs.normalizePath("~/rstudio-diagnostics"))
  sysName <- Sys.info()[['sysname']]
  if (identical(sysName, "Windows"))
    shell.exec(diagPath)
  else if (identical(sysName, "Darwin"))
    system(paste("open", diagPath))
  else if (nzchar(Sys.which("nautilus")))
    system(paste("nautilus", diagPath))
})

.rs.addFunction("history", function(max.show = 25, reverse = FALSE, pattern, ...)
{
   invisible(.Call("rs_activatePane", "history", PACKAGE = "(embedding)"))
})

.rs.addFunction("savehistory", function(file = ".Rhistory")
{
   invisible(.Call("rs_saveHistory", file, PACKAGE = "(embedding)"))
})

.rs.addFunction("loadhistory", function(file = ".Rhistory")
{
   invisible(.Call("rs_loadHistory", file, PACKAGE = "(embedding)"))
})

.rs.addFunction("timestamp", function(stamp = date(),
                                      prefix = "##------ ",
                                      suffix = " ------##",
                                      quiet = FALSE)
{
   stamps <- paste(prefix, stamp, suffix, sep = "")

   lapply(stamps, function(stamp) {
      invisible(.Call("rs_timestamp", stamp, PACKAGE = "(embedding)"))
   })

   if (!quiet)
      cat(stamps, sep = "\n")

   invisible(stamps)
})

.rs.replacePackageBinding("history", "utils", .rs.history)

.rs.addFunction("registerHistoryFunctions", function()
{
   .rs.replacePackageBinding("savehistory", "utils", .rs.savehistory, namespace = TRUE)
   .rs.replacePackageBinding("loadhistory", "utils", .rs.loadhistory, namespace = TRUE)
   .rs.replacePackageBinding("timestamp", "utils", .rs.timestamp, namespace = TRUE)
})


.rs.addFunction("parseQuitArguments", function(command) {

   # parse the command
   expr <- parse(text = command)
   if (length(expr) == 0)
      stop("Not a fully formed command: ", command)

   # match args
   call <- as.call(expr[[1]])
   call <- match.call(quit, call)

   # return as list without the function name
   as.list(call)[-1]
})

.rs.addFunction("isTraced", function(fun) {
   isS4(fun) && class(fun) == "functionWithTrace"
})

# when a function is traced, some data about the function (such as its original
# body and source references) exist only on the untraced copy
.rs.addFunction("untraced", function(fun) {
   if (.rs.isTraced(fun))
      fun@original
   else
      fun
})

.rs.addFunction("getSrcref", function(fun) {
   attr(.rs.untraced(fun), "srcref")
})

# returns a list containing line data from the given source reference,
# formatted for output to the client
.rs.addFunction("lineDataList", function(srcref) {
   list(
      line_number = .rs.scalar(srcref[1]),
      end_line_number = .rs.scalar(srcref[3]),
      character_number = .rs.scalar(srcref[5]),
      end_character_number = .rs.scalar(srcref[6]))
})

.rs.addFunction("haveRequiredRSvnRev", function(requiredSvnRev) {
   svnRev <- R.version$`svn rev`
   if (!is.null(svnRev)) {
      svnRevNumeric <- suppressWarnings(as.numeric(svnRev))
      if (!is.na(svnRevNumeric) && length(svnRevNumeric) == 1)
         svnRevNumeric >= requiredSvnRev
      else
         FALSE
   } else {
      FALSE
   }
})

.rs.addFunction("rVersionString", function() {
   as.character(getRversion())
})

.rs.addFunction("listFilesFuzzy", function(directory, token)
{
   pattern <- if (nzchar(token))
      paste("^", .rs.asCaseInsensitiveRegex(.rs.escapeForRegex(token)), sep = "")

   # Manually construct a call to `list.files` which should work across
   # versions of R >= 2.11.
   formals <- as.list(formals(base::list.files))

   formals$path <- directory
   formals$pattern <- pattern
   formals$all.files <- TRUE
   formals$full.names <- TRUE

   # NOTE: not available in older versions of R, but defaults to FALSE
   # with newer versions.
   if ("include.dirs" %in% names(formals))
      formals[["include.dirs"]] <- TRUE

   # NOTE: not available with older versions of R, but defaults to FALSE
   if ("no.." %in% names(formals))
      formals[["no.."]] <- TRUE

   # Generate the call, and evaluate it.
   result <- do.call(base::list.files, formals)

   # Clean up duplicated '/'.
   absolutePaths <- gsub("/+", "/", result)

   # Remove un-needed `.` paths. These paths will look like
   #
   #     <path>/.
   #     <path>/..
   #
   # This is only unnecessary if we couldn't use 'no..'.
   if (!("no.." %in% names(formals)))
   {
      absolutePaths <- grep("/\\.+$",
                            absolutePaths,
                            invert = TRUE,
                            value = TRUE)
   }

   absolutePaths
})

.rs.addFunction("callWithRDS", function(functionName, inputLocation, outputLocation)
{
   params <- readRDS(inputLocation)
   result <- do.call(functionName, params)

   saveRDS(file = outputLocation, object = result)
})

.rs.addFunction("readFile", function(file,
                                     binary = FALSE,
                                     encoding = NULL)
{
   size <- file.info(file)$size
   if (binary)
      return(readBin(file, "raw", size))
   contents <- readChar(file, size, TRUE)
   if (is.character(encoding))
      Encoding(contents) <- encoding
   contents
})

# Adler-32 fingerprint of an R value. Not cryptographic -- this is for
# stable, bounded identity tokens (e.g. the data viewer's column-names
# fingerprint), where a hypothetical collision means reapplying saved
# UI state to the wrong frame, not a security boundary.
#
# Raw vectors hash directly; everything else goes through serialize() so
# element boundaries are encoded unambiguously and we don't have to
# invent our own framing -- a delimiter-joined string can collide on
# names that contain the delimiter.
#
# We pin serialize(version = 2L) and zero out bytes 7-10 (the writer's R
# version field) so the hash is stable across R upgrades. Otherwise the
# colsFingerprint persisted alongside the data viewer's saved UI state
# would silently invalidate after every R upgrade. Version 2 has been
# the stable archival format since R 1.4.0; version 3 additionally
# embeds the native encoding name in the header, which can vary by
# platform.
#
# The modulus 65521 is the largest prime below 2^16, per the spec.
# Each loop iteration evaluates
#   b + k*a + sum_{i=1..k} (k+1-i) * chunk[i]
# before the %% reduction. Worst case (a, b near 65520; chunk[i] = 255)
# bounds at 65520*(k+1) + 255*k*(k+1)/2; staying within R's signed
# 32-bit integer range gives k <= 3854, so chunk size 1024 has plenty
# of headroom.
.rs.addFunction("digest", function(x)
{
   if (is.raw(x))
   {
      bytes <- x
   }
   else
   {
      bytes <- serialize(x, connection = NULL, ascii = FALSE, version = 2L)
      bytes[7:10] <- as.raw(0L)
   }

   n <- length(bytes)
   a <- 1L
   b <- 0L
   size <- 1024L

   pos <- 1L
   while (pos <= n)
   {
      end <- min(pos + size - 1L, n)
      k <- end - pos + 1L
      chunk <- as.integer(bytes[pos:end])

      s1 <- sum(chunk)
      weighted <- sum(seq.int(k, 1L) * chunk)

      b <- (b + k * a + weighted) %% 65521L
      a <- (a + s1) %% 65521L

      pos <- end + 1L
   }

   sprintf("%04x%04x", b, a)
})

.rs.addFunction("fromJSON", function(string)
{
   .Call("rs_fromJSON", string, PACKAGE = "(embedding)")
})

.rs.addFunction("stringBuilder", function()
{
   (function() {
      indent_ <- "  "
      indentSize_ <- 0
      data_ <- character()

      indented_ <- function(data) {
         indent <- paste(character(indentSize_ + 1), collapse = indent_)
         for (i in seq_along(data))
            if (is.list(data[[i]]))
               data[[i]] <- indented_(data[[i]])
            else
               data[[i]] <- paste(indent, data[[i]], sep = "")
            data
      }

      list(

         append = function(...) {
            data_ <<- c(data_, indented_(list(...)))
         },

         appendf = function(...) {
            data_ <<- c(data_, indented_(sprintf(...)))
         },

         indent = function() {
            indentSize_ <<- indentSize_ + 1
         },

         unindent = function() {
            indentSize_ <<- max(0, indentSize_ - 1)
         },

         data = function() unlist(data_)

      )

   })()
})

.rs.addFunction("listBuilder", function()
{
   (function() {
      capacity_ <- 1024
      index_ <- 0
      data_ <- vector("list", capacity_)

      append <- function(data) {

         # increment index and check capacity
         index_ <<- index_ + 1
         if (index_ > capacity_) {
            capacity_ <<- capacity_ * 2
            data_[capacity_] <<- list(NULL)
         }

         # append data
         if (is.null(data))
            data_[index_] <<- list(NULL)
         else
            data_[[index_]] <<- data
      }

      data <- function() {
         data_[seq_len(index_)]
      }

      clear <- function() {
         capacity_ <<- 1024
         index_ <<- 0
         data_ <<- vector("list", capacity_)
      }

      empty <- function() {
         index_ == 0
      }

      list(append = append, clear = clear, empty = empty, data = data)

   })()
})

.rs.addFunction("regexMatches", function(pattern, x) {

   matches <- gregexpr(pattern, x, perl = TRUE)[[1]]
   starts <- attr(matches, "capture.start")
   ends <- starts + attr(matches, "capture.length") - 1
   strings <- substring(x, starts, ends)

   names(strings) <- attr(matches, "capture.names")
   strings

})

.rs.addFunction("withChangedExtension", function(path, ext)
{
   ext <- sub("^\\.+", "", ext)
   if (.rs.endsWith(path, ".nb.html"))
      paste(substring(path, 1, nchar(path) - 8), ext, sep = ".")
   else if (.rs.endsWith(path, ".tar.gz"))
      paste(substring(path, 1, nchar(path) - 7), ext, sep = ".")
   else
      paste(tools::file_path_sans_ext(path), ext, sep = ".")
})

.rs.addFunction("dirExists", function(path)
{
   utils::file_test('-d', path)
})

.rs.addFunction("ensureDirectory", function(path)
{
   if (file.exists(path)) {
      if (!utils::file_test("-d", path))
         stop("file at path '", path, "' exists but is not a directory")
      return(TRUE)
   }

   success <- dir.create(path, recursive = TRUE)
   if (!success)
      stop("failed to create directory at path '", path, "'")

   TRUE
})

# adapted from merge_lists in the rmarkdown package
.rs.addFunction("mergeLists", function(baseList, overlayList, recursive = TRUE) {
  if (length(baseList) == 0)
    overlayList
  else if (length(overlayList) == 0)
    baseList
  else {
    mergedList <- baseList
    for (name in names(overlayList)) {
      base <- baseList[[name]]
      overlay <- overlayList[[name]]
      if (is.list(base) && is.list(overlay) && recursive)
        mergedList[[name]] <- .rs.mergeLists(base, overlay)
      else {
        mergedList[[name]] <- NULL
        mergedList <- append(mergedList,
                              overlayList[which(names(overlayList) %in% name)])
      }
    }
    mergedList
  }
})

.rs.addFunction("nBytes", function(x) {
   nchar(x, type = "bytes")
})

.rs.addFunction("randomString", function(prefix = "",
                                         postfix = "",
                                         candidates = c(letters, LETTERS, 0:9),
                                         n = 16L)
{
   sampled <- sample(candidates, n, TRUE)
   paste(prefix, paste(sampled, collapse = ""), postfix, sep = "")
})

.rs.addFunction("rbindList", function(data)
{
   data <- Filter(length, data)
   result <- do.call(mapply, c(c, data, USE.NAMES = FALSE, SIMPLIFY = FALSE))
   names(result) <- names(data[[1]])
   as.data.frame(result, stringsAsFactors = FALSE)
})

# NOTE: Used by 'rstudioapi'; unofficially part of the API.
.rs.addFunction("isDesktop", function()
{
   identical(.Call("rs_rstudioProgramMode", PACKAGE = "(embedding)"), "desktop")
})

# complete url with path
.rs.addFunction("completeUrl", function(url, path)
{
  .Call("rs_completeUrl", url, path, PACKAGE = "(embedding)")
})

.rs.addFunction("defaultHttpUserAgent", function()
{
   fields <- c(
      format(getRversion()),
      format(R.version$platform),
      format(R.version$arch),
      format(R.version$os)
   )

   sprintf("R (%s)", paste(fields, collapse = " "))
})

.rs.addFunction("initHttpUserAgent", function()
{
   utils <- asNamespace("utils")

   defaultAgent <- if (is.function(utils$defaultUserAgent))
      utils$defaultUserAgent()
   else
      .rs.defaultHttpUserAgent()

   if (identical(defaultAgent, getOption("HTTPUserAgent")))
   {
      info <- .rs.api.versionInfo()
      fields <- c(
         "RStudio",
         if (info$mode == "desktop") "Desktop" else "Server",
         if (!is.null(info$edition)) "Pro",
         paste("(", format(info$version), ")", sep = "")
      )

      rstudioAgent <- paste(fields, collapse = " ")
      newAgent <- paste(rstudioAgent, defaultAgent, sep = "; ")
      options(HTTPUserAgent = newAgent)
   }
})

.rs.addFunction("hasCapability", function(what)
{
   cap <- capabilities(what)
   length(cap) && cap
})

# NOTE: registered hooks will be run immediately if the
# package has already been loaded.
.rs.addFunction("registerPackageLoadHook", function(package, hook)
{
   if (package %in% loadedNamespaces())
      return(hook())

   setHook(
      hookName = packageEvent(package, "onLoad"),
      value    = hook,
      action   = "append"
   )

})

.rs.addFunction("registerPackageAttachedHook", function(package, hook)
{
   searchPathName <- paste("package", package, sep = ":")
   if (searchPathName %in% search())
      return(hook())

   setHook(
      hookName = packageEvent(package, "attach"),
      value    = hook,
      action   = "append"
   )
})

.rs.addFunction("prependToPath", function(entry)
{
   # Make sure we use native separators, and expand tildes.
   entry <- normalizePath(entry, mustWork = FALSE)

   # Get the current PATH.
   oldPath <- strsplit(Sys.getenv("PATH"), .Platform$path.sep, fixed = TRUE)[[1L]]

   # Prepend the new entry, removing it from the old PATH if is already exists.
   newPath <- c(entry, setdiff(oldPath, entry))

   # Update the PATH.
   Sys.setenv(PATH = paste(newPath, collapse = .Platform$path.sep))
})

.rs.addFunction("callSafely", function(call, args)
{
   call <- match.fun(call)
   args <- args[intersect(names(formals(call)), names(args))]
   envir <- parent.frame()
   do.call(call, args, envir = envir)
})

.rs.addFunction("attachConflicts", function(envirs)
{
   if ("conflicted" %in% loadedNamespaces())
   {
      tryCatch(
         conflicted:::conflicts_register(),
         error = function(e) {
            .rs.logErrorMessage(conditionMessage(e))
         }
      )
   }
})

.rs.addFunction("detachConflicts", function()
{
   # check for .conflicts on the search path
   pos <- which(search() == ".conflicts")
   if (length(pos) == 0)
      return(NULL)

   # empty out the .conflicts environment
   envirs <- lapply(pos, as.environment)
   for (envir in envirs)
   {
      symbols <- ls(envir = envir, all.names = TRUE)
      rm(list = symbols, envir = envir)
   }

   # return the environments
   envirs
})

.rs.addFunction("heredoc", function(text, ...)
{
   # remove leading, trailing whitespace
   trimmed <- gsub("^[^\\S\\r\\n]*\\n|\\n[^\\S\\r\\n]*$", "", text, perl = TRUE)

   # split into lines
   lines <- strsplit(trimmed, "\n", fixed = TRUE)[[1L]]

   # compute common indent
   indent <- regexpr("[^[:space:]]", lines)
   common <- min(setdiff(indent, -1L))

   # put it together
   rendered <- paste(substring(lines, common), collapse = "\n")

   # if any dots were supplied, assume they're sprintf format arguments
   dots <- eval(substitute(alist(...)))
   if (length(dots))
      rendered <- sprintf(rendered, ...)

   # return rendered text
   rendered
})

#' Wait Until
#'
#' Wait until a predicate expression returns TRUE.
#'
#' The effective timeout is approximately `retryCount * waitTimeSecs` seconds.
#' With the defaults (`retryCount = 30`, `waitTimeSecs = 1`), the timeout is
#' approximately 30 seconds.
#'
#' @param reason A description of what we're waiting for (used in timeout error message).
#' @param predicate A function returning TRUE when the wait condition is satisfied.
#' @param swallowErrors If TRUE, errors thrown by predicate are treated as FALSE.
#' @param retryCount Number of times to check the predicate before timing out.
#' @param waitTimeSecs Seconds to wait between each predicate check.
.rs.addFunction("waitUntil", function(reason,
                                      predicate,
                                      swallowErrors = FALSE,
                                      retryCount = 30L,
                                      waitTimeSecs = 1)
{
   pollForEvents <- if (isNamespaceLoaded("later"))
      later::run_now
   else
      function() {}

   callback <- if (swallowErrors)
   {
      function()
         tryCatch(predicate(), error = function(cnd) FALSE)
   }
   else
   {
      predicate
   }

   for (i in seq_len(retryCount))
   {
      pollForEvents()

      result <- callback()
      if (!identical(result, FALSE))
         return(result)

      Sys.sleep(waitTimeSecs)
   }

   stop(sprintf("timed out waiting until '%s'", reason))
})

.rs.addFunction("bugReport", function(pro = NULL)
{
   # collect information about the running version of R / RStudio
   rstudioInfo <- .rs.api.versionInfo()
   rstudioVersion <- format(rstudioInfo$long_version)

   rstudioEdition <- sprintf(
      "%s [%s]",
      if (rstudioInfo$mode == "desktop") "Desktop" else "Server",
      if (is.null(rstudioInfo$edition)) "Open Source" else toupper(rstudioInfo$edition)
   )

   rInfo <- utils::sessionInfo()
   rVersion <- rInfo$R.version$version.string
   rVersion <- sub("^R version", "", rVersion, fixed = TRUE)
   osVersion <- rInfo$running

   rInfoText <- local({
      op <- options(width = 78)
      on.exit(options(op), add = TRUE)
      paste(capture.output(print(rInfo)), collapse = "\n")
   })

   # create issue template and fill in the pieces
   template <- .rs.heredoc("
      ### System details

          RStudio Edition : %s
          RStudio Version : %s
          OS Version      : %s
          R Version       : %s

      ### Steps to reproduce the problem

      ### Describe the problem in detail

      ### Describe the behavior you expected

      ---

      <details>

      <summary>Session Info</summary>

      ``` r
      %s
      ```

      </details>
   ")

   rendered <- sprintf(template, rstudioVersion, rstudioEdition, osVersion, rVersion, rInfoText)

   if (rstudioInfo$mode == "desktop") {

      # on desktop, we copy the text directly to the clipboard
      text <- paste(rendered, collapse = "\n")
      .Call("rs_clipboardSetText", text, PACKAGE = "(embedding)")

      writeLines(.rs.heredoc("
         * The bug report template has been written to the clipboard.
         * Please paste the clipboard contents into the issue comment section,
         * and then fill out the rest of the issue details.
         *
      "))

   } else {

      # on server, we ask the user to copy the text to the clipboard
      header <- .rs.heredoc("
         <!--
         Please copy the following text to your clipboard,
         and then click 'Cancel' to close the dialog.
         -->
      ")

      # write generated text to file, then open it in an editor
      text <- c(header, "", rendered)
      file <- tempfile("rstudio-bug-report-", fileext = ".html")
      on.exit(unlink(file), add = TRUE)
      writeLines(text, con = file)
      utils::file.edit(file)

   }

   # if 'pro' wasn't supplied, then try to guess based on the running edition
   if (is.null(pro))
      pro <- !is.null(rstudioInfo$edition)

   # tell the user we're about to navigate away
   url <- if (pro) {
      "https://github.com/rstudio/rstudio-pro/issues/new"
   } else {
      "https://github.com/rstudio/rstudio/issues/new"
   }

   # notify the user
   fmt <- " * Navigating to '%s' in 3 seconds ... "
   msg <- sprintf(fmt, url)
   writeLines(msg)
   Sys.sleep(3)

   # perform navigation
   utils::browseURL(url)
})

.rs.addFunction("mapChr", function(x, f, ...)
{
   f <- match.fun(f)
   vapply(x, f, ..., FUN.VALUE = character(1))
})

.rs.addFunction("mapDbl", function(x, f, ...)
{
   f <- match.fun(f)
   vapply(x, f, ..., FUN.VALUE = double(1))
})

.rs.addFunction("mapInt", function(x, f, ...)
{
   f <- match.fun(f)
   vapply(x, f, ..., FUN.VALUE = integer(1))
})

.rs.addFunction("mapLgl", function(x, f, ...)
{
   f <- match.fun(f)
   vapply(x, f, ..., FUN.VALUE = logical(1))
})

# An R data.frame may have so-called "compact row names", where
# row names are set with an integer placeholder that defines the
# number of rows in the data.frame, without actually having a
# fully materialized vector of that length.
.rs.addFunction("hasCompactRowNames", function(data)
{
   info <- .row_names_info(data, type = 0L)
   is.integer(info) && length(info) == 2L && is.na(info[[1L]])
})

.rs.addFunction("nullCoalesce", function(...)
{
   for (i in seq_len(...length()))
   {
      value <- ...elt(i)
      if (!is.null(value))
         return(value)
   }
})

.rs.addFunction("tryOr", function(default, expr)
{
   tryCatch(expr, error = function(cnd) default)
})

.rs.addFunction("emptyCoalesce", function(...)
{
   for (i in seq_len(...length()))
   {
      value <- ...elt(i)
      if (length(value))
         return(value)
   }
})

.rs.addFunction("restoreSearchPath", function(searchPathsFile,
                                              packagePathsFile,
                                              environmentDataDir)
{
   tryCatch(

      .rs.restoreSearchPathImpl(
         searchPathsFile,
         packagePathsFile,
         environmentDataDir
      ),

      error = function(cnd) {
         header <- "Error restoring search paths:"
         message <- paste(c(header, conditionMessage(cnd)), collapse = "\n\t")
         writeLines(message, con = stderr())
      }

   )
})

.rs.addFunction("restoreSearchPathImpl", function(searchPathsFile,
                                                  packagePathsFile,
                                                  environmentDataDir)
{
   # First, read the package paths file, and try to load those packages.
   packagePaths <- .rs.readProperties(
      path = packagePathsFile,
      delimiter = "=",
      dequote = TRUE,
      trim = TRUE
   )

   # Exclude 'base' if it was serialized, since that's always loaded.
   packagePaths[["base"]] <- NULL

   # Restore the packages.
   .rs.restorePackages(packagePaths)

   # Read the search paths file.
   searchPaths <- readLines(searchPathsFile, warn = FALSE)

   # Detach anything that's on the search path right now, but not in the search path list.
   currentSearchPaths <- setdiff(
      search(),
      c(".GlobalEnv", "tools:rstudio", "package:base", "package:tools", "package:utils")
   )

   for (entry in currentSearchPaths)
   {
      if (!entry %in% searchPaths)
      {
         detach(entry, character.only = TRUE)
      }
   }

   # Build our iteration indices.
   # - Iterate in reverse order, since 'library()' always attaches entries to the front of the search path.
   # - Iterate by index, since we use those to map certain search path elements to data files.
   indices <- seq.int(
      from = length(searchPaths) - 1L,
      to = 2L,
      by = -1L
   )

   # Using our index from above, iterate and attach packages.
   for (index in indices)
   {
      searchPathEl <- searchPaths[[index]]
      if (grepl("^package:", searchPathEl))
      {
         packageName <- substring(searchPathEl, 9L)
         library(packageName, character.only = TRUE)
      }
      else
      {
         # NOTE: Subtract by 1 to accommodate 0-based versus 1-based indexing.
         dataFilePath <- file.path(environmentDataDir, index - 1L)
         if (file.exists(dataFilePath))
            .rs.attachDataFile(dataFilePath, searchPathEl)
      }
   }

})

.rs.addFunction("restorePackages", function(packagePaths)
{
   # Use environment to track visited packages.
   visitedPackages <- new.env(parent = emptyenv())

   # Treat 'R' as already visited, so that we skip it.
   # (Some packages include R version requirements in their DESCRIPTION files.)
   visitedPackages[["R"]] <- TRUE

   # Start loading.
   for (package in names(packagePaths))
      .rs.restorePackagesImpl(package, packagePaths, visitedPackages)
})

.rs.addFunction("restorePackagesImpl", function(package,
                                                packagePaths,
                                                visitedPackages)
{
   # Check if we've already visited this package.
   if (exists(package, envir = visitedPackages))
      return()

   # Mark this package as visited.
   visitedPackages[[package]] <- TRUE

   # If we don't have a known namespace path for this package, skip it.
   # This can occur for packages which import a package in their DESCRIPTION file,
   # but don't explicitly import it in their NAMESPACE.
   #
   # In other words, such packages are loaded only on first use, which is somewhat
   # awkward -- especially since whether or not that package can be loaded does
   # depend on the library paths set at load time!
   packagePath <- packagePaths[[package]]
   if (is.null(packagePath))
      return()

   libLoc <- dirname(packagePath)
   packageDesc <- as.list(utils::packageDescription(package, lib.loc = libLoc))

   # Load any of its dependencies first.
   fields <- c("Depends", "Imports", "LinkingTo")
   for (field in fields)
   {
      splitDeps <- tools:::.split_dependencies(packageDesc[[field]])
      for (packageDep in names(splitDeps))
      {
         .rs.restorePackagesImpl(packageDep, packagePaths, visitedPackages)
      }
   }

   # Load the package.
   loadNamespace(package, lib.loc = libLoc)
})

.rs.addFunction("dequote", function(value)
{
   for (i in seq_along(value))
   {
      if (grepl("^[\x22\x27]", value[[i]], perl = TRUE))
      {
         value[[i]] <- tryCatch(
            parse(text = value[[i]])[[1L]],
            error = function(cnd) value[[i]]
         )
      }
   }

   value
})

.rs.addFunction("readProperties", function(path = NULL,
                                           text = NULL,
                                           delimiter = ":",
                                           dequote = TRUE,
                                           trim = TRUE)
{
   # disable warnings in this scope
   op <- options(warn = -1L)
   on.exit(options(op), add = TRUE)

   # read file
   text <- .rs.nullCoalesce(text, readLines(path, warn = FALSE))
   contents <- paste(text, collapse = "\n")

   # split on newlines; allow spaces to continue a value
   parts <- strsplit(contents, "\\n(?=\\S)", perl = TRUE)[[1L]]

   # remove comments and blank lines
   parts <- grep("^\\s*(?:#|$)", parts, perl = TRUE, value = TRUE, invert = TRUE)

   # split into key / value pairs
   index <- regexpr(delimiter, parts, fixed = TRUE)
   keys <- substring(parts, 1L, index - 1L)
   vals <- substring(parts, index + 1L)

   # trim whitespace when requested
   if (trim)
   {
      keys <- .rs.trimWhitespace(keys)
      vals <- gsub("\n\\s*", " ", .rs.trimWhitespace(vals), perl = TRUE)
   }

   # strip quotes if requested
   if (dequote)
   {
      keys <- .rs.dequote(keys)
      vals <- .rs.dequote(vals)
   }

   # return as named list
   storage.mode(vals) <- "list"
   names(vals) <- keys

   vals
})

.rs.addFunction("packagePaths", function()
{
   packages <- setdiff(loadedNamespaces(), "base")
   names(packages) <- packages
   lapply(packages, getNamespaceInfo, "path")
})

.rs.addFunction("startsWith", function(strings, string)
{
   if (!length(string))
      string <- ""

   n <- nchar(string)
   (nchar(strings) >= n) & (substring(strings, 1, n) == string)
})

.rs.addFunction("selectStartsWith", function(strings, string)
{
   strings[.rs.startsWith(strings, string)]
})

.rs.addFunction("endsWith", function(strings, string)
{
   if (!length(string))
      string <- ""

   nstrings <- nchar(strings)
   nstring <- nchar(string)
   (nstrings >= nstring) &
      (substring(strings, nstrings - nstring + 1, nstrings) == string)
})

.rs.addFunction("selectEndsWith", function(strings, string)
{
   strings[.rs.endsWith(strings, string)]
})

.rs.addFunction("netrcPath", function(overridePath = NULL)
{
   .rs.nullCoalesce(
      overridePath,
      getOption("netrc", default = Sys.getenv("NETRC", unset = "~/.netrc"))
   )
})

.rs.addFunction("readNetrc", function(netrcPath = NULL)
{
   # Resolve the path to the .netrc file.
   netrcPath <- .rs.netrcPath(netrcPath)
   
   info <- file.info(netrcPath, extra_cols = FALSE)
   if (is.na(info$mode))
      return(NULL)

   # Read the contents of the file.
   contents <- readLines(netrcPath, warn = FALSE)

   # Remove any 'macdef' entries within the file.
   macdefLines <- rev(grep("^\\s*macdef\\b", contents, perl = TRUE))
   if (length(macdefLines))
   {
      blankLines <- c(which(contents == ""), length(contents) + 1L)
      for (macdefLine in macdefLines)
      {
         lhs <- macdefLine
         rhs <- blankLines[blankLines > macdefLine][[1L]]
         contents <- c(
            head(contents, n = +(lhs - 1L)),
            tail(contents, n = -(rhs - 1L))
         )
      }
   }

   # Read the tokens within the file.
   tokens <- scan(
      text         = paste(contents, collapse = "\n"),
      what         = character(),
      quote        = "\"",
      comment.char = "#",
      quiet        = TRUE
   )

   # Add some blank tokens at end, to support lookahead.
   tokens <- c(tokens, "", "")

   # Make a simple token walker.
   i <- 0L; n <- length(tokens)
   pop <- function() {
      i <<- i + 1L
      tokens[[i]]
   }

   # netrc can have machine, login, password, and account fields.
   machine <- ""

   # Start parsing the .netrc entries within the file.
   stack <- .rs.stack(mode = "list")

   token <- pop()
   while (nzchar(token))
   {
      entry <- list()

      # Get the machine definition. Handle 'default' here as well.
      entry[["machine"]] <- if (token == "default")
         ""
      else if (token == "machine")
         pop()
      else
         stop("unexpected token '", token, "'; expected 'machine' or 'default'")

      # Handle the optional fields.
      token <- pop()
      while (token %in% c("login", "password", "account"))
      {
         entry[[token]] <- pop()
         token <- pop()
      }

      # Add it to the result stack.
      stack$push(entry)
   }

   # Return result as named list.
   result <- stack$data()
   names(result) <- .rs.mapChr(result, `[[`, "machine")

   result
})

.rs.addFunction("rBase64EncodeMain", function(input, table)
{
   ni <- as.integer(length(input))
   if (ni < 3L)
      return(integer())

   no <- ni %/% 3L * 4L
   output <- integer(no)

   i0 <- seq.int(1L, ni - 2L, by = 3L)
   i1 <- seq.int(2L, ni - 1L, by = 3L)
   i2 <- seq.int(3L, ni - 0L, by = 3L)

   o0 <- seq.int(1L, no - 3L, by = 4L)
   o1 <- seq.int(2L, no - 2L, by = 4L)
   o2 <- seq.int(3L, no - 1L, by = 4L)
   o3 <- seq.int(4L, no - 0L, by = 4L)

   output[o0] <- table[1L + bitwShiftR(input[i0], 2L)]

   output[o1] <- table[1L + bitwOr(
      bitwShiftL(bitwAnd(input[i0], 0x03L), 4L),
      bitwShiftR(bitwAnd(input[i1], 0xF0L), 4L)
   )]

   output[o2] <- table[1L + bitwOr(
      bitwShiftL(bitwAnd(input[i1], 0x0FL), 2L),
      bitwShiftR(bitwAnd(input[i2], 0xC0L), 6L)
   )]

   output[o3] <- table[1L + bitwAnd(input[i2], 0x3FL)]

   output
})

.rs.addFunction("rBase64EncodeRest", function(input, table)
{
   ni <- as.integer(length(input))
   remaining <- ni %% 3L
   if (remaining == 0L)
      return(integer())

   output <- rep.int(61L, 4L)
   i <- ni - remaining + 1

   output[1L] <- table[1L + bitwShiftR(input[i + 0L], 2L)]

   if (remaining == 1L)
   {
      output[2L] <- table[1L + bitwShiftL(bitwAnd(input[i + 0L], 0x03L), 4L)]
   }
   else if (remaining == 2L)
   {
      output[2L] <- table[1L + bitwOr(
         bitwShiftL(bitwAnd(input[i + 0L], 0x03L), 4L),
         bitwShiftR(bitwAnd(input[i + 1L], 0xF0L), 4L)
      )]

      output[3L] <- table[1L + bitwShiftL(bitwAnd(input[i + 1L], 0x0FL), 2L)]
   }

   output
})

.rs.addFunction("rBase64Encode", function(text)
{
   # coerce input
   input <- if (is.character(text))
      as.integer(charToRaw(text))
   else if (is.raw(text))
      as.integer(text)
   else
      stop("unexpected input type ", typeof(text))

   # build base64 table
   chars <- "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="  # pragma: allowlist secret
   table <- as.integer(charToRaw(chars))

   # encode the data
   encoded <- c(
      .rs.rBase64EncodeMain(input, table),
      .rs.rBase64EncodeRest(input, table)
   )

   # convert back to character
   rawToChar(as.raw(encoded))
})

.rs.addFunction("computeAuthorizationHeader", function(url)
{
   # Read user's .netrc file (if any)
   netrcEntries <- .rs.readNetrc()
   if (is.null(netrcEntries))
      return("")

   # Parse the URL into its component parts.
   pattern <- paste0(
      "^",
      "(?:(?<scheme>[a-z][a-z0-9+\\-.]*)://)?",            # Scheme
      "(?:(?<user>[^:@/?#]+)(?::(?<pass>[^@/?#]*))?@)?",   # User, Password
      "(?<host>\\[[^\\]]+\\]|[^:/?#]+)",                   # Host (IPv6 in [])
      "(?::(?<port>\\d+))?",                               # Port
      "(?<path>/[^?#]*)?",                                 # Path
      "(?:\\?(?<query>[^#]*))?",                           # Query
      "(?:#(?<fragment>.*))?",                             # Fragment
      "$"
   )

   matches <- .rs.regexMatches(pattern, url)
   parts <- as.list(matches)

   # Look for valid credentials for the provided URLs.
   for (netrcEntry in netrcEntries)
   {
      if (.rs.startsWith(parts$host, netrcEntry$machine))
      {
         userPass <- paste(netrcEntry$login, netrcEntry$password, sep = ":")
         result <- paste("Basic", .rs.rBase64Encode(userPass))
         return(result)
      }
   }

   ""
})

.rs.addFunction("recordPackageSource", function(pkgPaths, pkgSrc = NULL, db = NULL)
{
   # Request available packages when not using an explicit source and no db was provided.
   if (is.null(pkgSrc) && is.null(db))
   {
      db <- as.data.frame(
         utils::available.packages(),
         stringsAsFactors = FALSE
      )
   }

   # Record sources for each package.
   for (pkgPath in pkgPaths)
      .rs.recordPackageSourceImpl(pkgPath, pkgSrc, db)
})

.rs.addFunction("recordPackageSourceImpl", function(pkgPath, pkgSrc, db)
{
   # Infer package name from installed path.
   pkgName <- basename(pkgPath)

   # Read the DESCRIPTION file directly. The skip-if-tagged check below
   # must read from the same source we write to; packageDescription()
   # prefers Meta/package.rds, which can be out of sync with DESCRIPTION
   # (e.g. after a manual rebuild) and would let us silently append a
   # duplicate set of Remote* lines.
   descPath <- file.path(pkgPath, "DESCRIPTION")
   descMatrix <- tryCatch(read.dcf(descPath), error = function(e) NULL)
   if (is.null(descMatrix) || nrow(descMatrix) == 0L)
      return()

   # If the package already has some remote fields recorded, then skip.
   # Currently, this is relevant for packages installed from R-universe.
   if (length(grep("^Remote", colnames(descMatrix))))
      return()

   remoteFields <- if (!is.null(pkgSrc))
   {
      c(
         RemoteType   = "local",
         RemotePkgRef = sprintf("local::%s", pkgSrc),
         RemoteUrl    = normalizePath(pkgSrc, winslash = "/", mustWork = TRUE)
      )
   }
   else
   {
      # Try to figure out post-hoc from where the package was retrieved.
      pkgEntry <- subset(db, Package == pkgName)
      if (nrow(pkgEntry) == 0L)
         return()

      # Grab the package version.
      pkgVersion <- if ("Version" %in% colnames(descMatrix))
         descMatrix[1L, "Version"]
      else
         NA_character_

      # Normalize the repository path, removing source / binary suffixes.
      pkgSource <- gsub("/(src|bin)/.*", "", pkgEntry$Repository, perl = TRUE)

      # Also remove a potential binary component.
      pkgSource <- sub("/__[^_]+__/[^/]+/", "/", pkgSource)

      c(
         RemoteType   = "standard",
         RemotePkgRef = pkgName,
         RemoteRef    = pkgName,
         RemoteRepos  = pkgSource,
         RemoteSha    = pkgVersion
      )
   }

   remoteText <- sprintf(
      "%s: %s",
      names(remoteFields),
      unlist(remoteFields)
   )

   # Update the DESCRIPTION file. We read and write the DESCRIPTION file
   # just to avoid issues with potential trailing lines.
   descContents <- readLines(descPath, warn = FALSE)
   descContents <- descContents[nzchar(descContents)]
   descContents <- c(descContents, remoteText)
   writeLines(descContents, con = descPath, useBytes = TRUE)

   # Update `Meta/package.rds`.
   metaPackagePath <- file.path(pkgPath, "Meta/package.rds")
   if (file.exists(metaPackagePath))
   {
      metaPackageInfo <- readRDS(metaPackagePath)
      metaPackageInfo[["DESCRIPTION"]][names(remoteFields)] <- remoteFields
      saveRDS(metaPackageInfo, file = metaPackagePath)
   }
})

.rs.addFunction("isReadingUserInput", function()
{
   for (i in seq_len(sys.nframe()))
   {
      fn <- sys.function(i)
      if (identical(fn, base::readline))
         return(TRUE)
   }

   FALSE
})

.rs.addFunction("markScalars", function(object)
{
   if (is.recursive(object))
      for (i in seq_along(object))
         object[[i]] <- .rs.markScalars(object[[i]])

   if (is.atomic(object) && length(object) == 1L)
      .rs.scalar(object)
   else
      object
})

.rs.addFunction("installedPackagesFileInfo", function(lib = .libPaths(), paths = NULL)
{
   if (is.null(paths))
      paths <- list.files(lib, full.names = TRUE)
   pkgInfo <- file.info(paths, extra_cols = FALSE)
   pkgInfo$path <- row.names(pkgInfo)
   pkgInfo
})

.rs.addFunction("installPackagesWhichDeps", function(userDeps)
{
   # Maps the user's 'dependencies' argument onto the dependency types
   # tools::package_dependencies should query. Returns a list with
   # 'direct' (types to expand for the requested pkgs) and 'transitive'
   # (types to recurse through for added dependencies) so we can mirror
   # install.packages's getDependencies(): when dependencies = TRUE, the
   # requested pkgs pull in Suggests but their dependencies do not.
   strong <- c("Depends", "Imports", "LinkingTo")
   userDeps <- if (is.character(userDeps)) userDeps[!is.na(userDeps)] else userDeps
   if (isTRUE(userDeps))
      list(direct = c(strong, "Suggests"), transitive = strong)
   else if (isFALSE(userDeps))
      list(direct = character(), transitive = character())
   else if (is.character(userDeps))
      list(direct = userDeps, transitive = userDeps)
   else
      list(direct = strong, transitive = strong)
})

.rs.addFunction("installedPackagesFileInfoDiff", function(before, after)
{
   result <- merge(before, after, by = "path", all = TRUE)

   diffs <-
      (is.na(result$ctime.x) & !is.na(result$ctime.y)) |
      (is.na(result$mtime.x) & !is.na(result$mtime.y)) |
      (result$ctime.x != result$ctime.y) |
      (result$mtime.x != result$mtime.y)

   result[which(diffs), ]
})

.rs.addFunction("stack", function(mode = "list")
{
   .data <- list()
   storage.mode(.data) <- mode

   list(

      push = function(...) {
         dots <- list(...)
         for (data in dots) {
            if (is.null(data))
               .data[length(.data) + 1] <<- list(NULL)
            else
               .data[[length(.data) + 1]] <<- data
         }
      },

      pop = function() {
         item <- .data[[length(.data)]]
         length(.data) <<- length(.data) - 1
         item
      },

      peek = function() {
         .data[[length(.data)]]
      },

      contains = function(data) {
         data %in% .data
      },

      empty = function() {
         length(.data) == 0
      },

      get = function(index) {
         if (index <= length(.data)) .data[[index]]
      },

      set = function(index, value) {
         .data[[index]] <<- value
      },

      clear = function() {
         .data <<- list()
      },

      data = function() {
         .data
      }

   )

})

.rs.addFunction("isAbsolutePath", function(path)
{
   grepl("^(?:/|~|[a-zA-Z]:[/\\])", path)
})

.rs.addFunction("readPackageDescription", function(packagePath)
{
   info <- file.info(packagePath, extra_cols = FALSE)
   if (identical(info$isdir, TRUE))
      .rs.readPackageDescriptionFromDirectory(packagePath)
   else
      .rs.readPackageDescriptionFromArchive(packagePath)
})

.rs.addFunction("readPackageDescriptionFromDirectory", function(packagePath)
{
   # if this is an installed package with a package metafile,
   # read from that location
   metapath <- file.path(packagePath, "Meta/package.rds")
   if (file.exists(metapath)) {
      metadata <- readRDS(metapath)
      return(as.list(metadata$DESCRIPTION))
   }
   
   # otherwise, attempt to read DESCRIPTION directly
   descPath <- file.path(packagePath, "DESCRIPTION")
   read.dcf(descPath, all = TRUE)
})

.rs.addFunction("readPackageDescriptionFromArchive", function(packagePath)
{
   # figure out what files are in the archive
   isZip <- .rs.endsWith(packagePath, ".zip")
   files <- if (isZip)
      unzip(packagePath, list = TRUE)[["Name"]]
   else
      untar(packagePath, list = TRUE)
   
   # infer the path to the DESCRIPTION file we want to extract
   descPaths <- grep("(?:^|/)DESCRIPTION$", files, perl = TRUE, value = TRUE)
   
   # a package might have multiple DESCRIPTION files;
   # we want the top-level DESCRIPTION file
   n <- nchar(descPaths)
   descPath <- descPaths[n == min(n)]
   
   # extract to temporary directory
   tmpdir <- tempfile("description-")
   dir.create(tmpdir, recursive = TRUE)
   on.exit(unlink(tmpdir, recursive = TRUE), add = TRUE)
   
   if (isZip)
      unzip(packagePath, files = descPath, exdir = tmpdir)
   else
      untar(packagePath, files = descPath, exdir = tmpdir)
   
   # read the extracted DESCRIPTION file
   tmpDescPath <- file.path(tmpdir, descPath)
   read.dcf(tmpDescPath, all = TRUE)
})

.rs.addFunction("askForRestart", function(reason)
{
   testing <- getOption("rstudio.tests.running", default = FALSE)
   if (testing)
      return(FALSE)

   payload <- list(
      reason  = .rs.scalar(reason)
   )
   
   request <- .rs.api.createRequest(
      type    = .rs.api.eventTypes$TYPE_ASK_FOR_RESTART,
      sync    = TRUE,
      target  = .rs.api.eventTargets$TYPE_ACTIVE_WINDOW,
      payload = payload
   )
   
   response <- .rs.api.sendRequest(request)
   response[["value"]]
})

.rs.addFunction("ifElse", function(condition, consequence, alternative)
{
   if (condition) consequence else alternative
})

.rs.addFunction("safeEval", function(expr, envir)
{
   # Allow evaluation of symbols
   if (is.symbol(expr))
      return(eval(expr, envir))
   
   # Allow evaluation of `::` calls
   ok <-
      is.call(expr) &&
      length(expr) == 3L &&
      is.symbol(expr[[1L]]) &&
      as.character(expr[[1L]]) %in% c("::", ":::") &&
      is.symbol(expr[[2L]]) &&
      is.symbol(expr[[3L]])
   
   if (ok)
      return(eval(expr, envir))
   
   # Disallow other evaluation
   NULL
})

#!/usr/bin/env Rscript

themes <- read.delim("theme_urls.tsv", sep = "\t")
themes <- themes[!is.na(themes$url), ]

for (i in seq_len(nrow(themes))) {
    cat(themes$url[i], " ...\n")
    download.file(themes$url[i], themes$filename[i], quiet = TRUE)
}

# fix some invisible colors
patches <- list(
    dracula = c(Ansi_0_Color = "#4f4f4f"),
    # just here for the record, but material needs manual updating
    material = c(Ansi_0_Color = "#4f4f4f"), 
    monokai = c(Ansi_0_Color = "#4f4f4f", Ansi_5_Color = "#ff73fd", Ansi_13_Color = "#ff9cfe"), 
    pastel_on_dark = c(Ansi_8_Color = "#7c7c7c"),
    solarized_dark = c(Ansi_0_Color = "#4f4f4f", Ansi_8_Color = "#7c7c7c"), 
    solarized_light = c(Ansi_7_Color = "#d3d7cf", Ansi_8_Color = "#acacac", Ansi_15_Color = "#d3d7cf"),
    tomorrow = c(Ansi_7_Color = "#d3d7cf", Ansi_15_Color = "#eeeeec"),
    tomorrow_night = c(Ansi_0_Color = "#4f4f4f", Ansi_8_Color = "#7c7c7c"), 
    tomorrow_night_blue = c(Ansi_0_Color = "#4f4f4f", Ansi_8_Color = "#7c7c7c"), 
    tomorrow_night_bright = c(Ansi_0_Color = "#4f4f4f", Ansi_8_Color = "#7c7c7c"),
    tomorrow_night_eighties = c(Ansi_0_Color = "#4f4f4f", Ansi_8_Color = "#7c7c7c"),
    twilight = c(Ansi_0_Color = "#4f4f4f", Ansi_8_Color = "#7c7c7c", Ansi_4_Color = "#0b44a4", Ansi_12_Color = "#0058df", Ansi_5_Color = "#9b309b", Ansi_13_Color = "#d93bd9", Ansi_6_Color = "#219899", Ansi_14_Color = "#19d6d8"), 
    vibrant_ink = c(Ansi_8_Color = "#7c7c7c", Ansi_12_Color = "#5959ff")
)

for (i in seq_along(patches)) {
    filename <- paste0(names(patches)[i], ".xrdb")
    txt <- readLines(filename)

    patch <- patches[[i]]
    for (j in seq_along(patch)) {
        name <- names(patch)[j]
        color <- patch[j]

        line <- grep(paste("#define", name), txt)
        txt[line] <- paste("#define", name, color)
    }
    writeLines(txt, filename)
}

#
# Test that the debugger is able to highlight within
# files that are currently open, even for code that
# was executed via 'Cmd + Enter'. Note that this relies
# on some heuristics (matching source references against
# the document contents itself) so it may not be perfect.
#
# https://github.com/rstudio/rstudio/issues/13925
#

inner <- function() {
   3 + 3
   4 + 4
}

outer <- function() {
   1 + 1
   inner()
   2 + 2
}

debugonce(outer)
outer()

#
# SessionThemes.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

# ACE/tools/tmThemes.js Functions ==================================================================

# Determines the luma of a color. This refers to the perceived luminance of the color. More 
# information can be found at https://en.wikipedia.org/wiki/Relative_luminance.
# 
# @param color    The color for which to determine the luma.
#
# Returns the luma of the specified color.
.rs.addFunction("getLuma", function(color) {
   rgb <- .rs.getRgbColor(color)
   (0.21 * rgb[[1]] + 0.72 * rgb[[2]] + 0.07 * rgb[[3]]) / 255
})

# Parses a color.
# 
# @param color    The color to parse.
#
# Returns the parsed color.
.rs.addFunction("parseColor", function(color) {
   colorLen <- nchar(color)
   if (colorLen < 1)
   {
      return(NULL)
   }
   
   if (colorLen == 4)
   {
      color <- gsub("([a-fA-F0-9])", "\\1\\1", color)
   }
   if (!grepl("^#[a-fA-F0-9]{6}$", color))
   {
      if (!grepl("^#[a-fA-F0-9]{8}$", color))
      {
         stop(
            "Unable to parse color: ",
            color, 
            "it must have format \"#RGB\", \"#RRGGBB\" or \"#RRGGBBAA\" where `R`, `G`, `B`, and `A` are in [0x00, 0xFF].",
            call. = FALSE)
      }
      
      aVal <- format(
         round(strtoi(substr(color, 8, 9), base = 16L) / 255, digits = 2),
         nsmall = 2)
      color <- paste0(
         "rgba(",
         paste(
            c(.rs.getRgbColor(substr(color, 1, 7)), aVal),
            collapse = ", "),
         ")")
   }
   
   color
})

# Parses a font style and converts it to CSS.
#
# @param styles      The style(s) to convert.
#
# Returns the converted font style.
.rs.addFunction("parseStyles", function(styles) {
   css <- list()
   fontStyle <- if (is.null(styles$fontStyle)) "" else styles$fontStyle
   
   if (grepl("underline", fontStyle))
   {
      # Not the most efficient, but this shouldn't be an overly common operation.
      css[["text-decoration"]] = "underline"
   }
   if (grepl("italic", fontStyle))
   {
      css[["font-style"]] <- "italic"
   }
   if (grepl("bold", fontStyle))
   {
      css[["font-weight"]] <- "bold"
   }
   
   if (!is.null(styles$foreground))
   {
      css[["color"]] <- .rs.parseColor(styles$foreground)
   }
   if (!is.null(styles$background))
   {
      css[["background-color"]] <- .rs.parseColor(styles$background)
   }
   
   css
})

# Extracts the style information from a parsed tmTheme object.
#
# @param theme             The parsed tmTheme object.
# @param supportScopes     tmTheme scopes that are supported by ace and a mapping to their ace
#                          value.
# 
# Returns a list which contains the styles and unsupportedScopes in named elements.
.rs.addFunction("extractStyles", function(theme, supportedScopes) {
   # Fallback Scopes
   fallbackScopes <- list(
      "keyword" = "meta",
      "keyword.operator" = "keyword",
      "support.type" = "storage.type",
      "variable" = "entity.name.function")
   
   # Default Global Values
   defaultGlobals <- list(
      "printMargin" = "#e8e8e8",
      "background" = "#ffffff",
      "foreground" = "#000000",
      "gutter" = "#f0f0f0",
      "selection" = "rgb(181, 213, 255)",
      "step" = "rgb(198, 219, 174)",
      "bracket" = "rgb(192, 192, 192)",
      "active_line" = "rgba(0, 0, 0, 0.07)",
      "cursor" = "#000000",
      "invisible" = "rgb(191, 191, 191)",
      "fold" = "#6b72e6")
   
   globalSettings <- theme$settings[[1]]$settings
   
   # Get the global colors
   invisColor <- .rs.parseColor(globalSettings$invisibles)
   if (is.null(invisColor)) invisColor <- defaultGlobals$invisibles
   
   styles <- list(
      "printMargin" = defaultGlobals$printMargin,
      "background" = .rs.parseColor(globalSettings$background),
      "foreground" = .rs.parseColor(globalSettings$foreground),
      "gutter" = defaultGlobals$gutter,
      "selection" = .rs.parseColor(globalSettings$selection),
      "step" = defaultGlobals$step,
      "bracket" =  invisColor,
      "active_line" = .rs.parseColor(globalSettings$lineHighlight),
      "cursor" = .rs.parseColor(globalSettings$caret),
      "invisible" = invisColor)
   
   if (!("background" %in% names(styles))) styles$background <- defaultGlobals$background
   if (!("foreground" %in% names(styles))) styles$foreground <- defaultGlobals$foreground
   if (!("selection" %in% names(styles))) styles$selection <- defaultGlobals$selection
   if (!("active_line" %in% names(styles))) styles$active_line <- defaultGlobals$active_line
   if (!("cursor" %in% names(styles))) styles$cursor <- defaultGlobals$cursor
   
   # Get the specified scopes
   unsupportedScopes <- list()
   supportedScopeNames <- names(supportedScopes)
   for (element in theme$settings)
   {
      if (!is.null(element$scope) && !is.null(element$settings))
      {
         # Split on commas and strip whitespace.
         scopes <- strsplit(gsub("^\\s*|\\s*$", "", element$scope), "\\s*(,|\\|\\s)\\s*")[[1]]
         for (scope in scopes)
         {
            style <- .rs.parseStyles(element$settings)
            haveStyle <- !is.null(style) && any(!is.na(style)) && (length(style) > 0)
            if ((scope %in% supportedScopeNames) && haveStyle)
            {
               styles[[ supportedScopes[[scope]] ]] <- style
            }
            else if (haveStyle)
            {
               if (!(scope %in% names(unsupportedScopes)))
               {
                  unsupportedScopes[[scope]] <- 0
               }
               else 
               {
                  unsupportedScopes[[scope]] <- unsupportedScopes[[scope]] + 1
               }
            }
         }
      }
   }
   
   if (!("fold" %in% names(styles)))
   {
      if (("entity.name.function" %in% names(styles)) 
          && ("color" %in% names(styles[["entity.name.function"]]))
          && (styles[["entity.name.function"]][["color"]] != ""))
      {
         styles[["fold"]] <- styles[["entity.name.function"]][["color"]]
      }
      else if (("keyword" %in% names(styles))
               && ("color" %in% names(styles[["keyword"]]))
               && (styles[["keyword"]][["color"]] != ""))
      {
         styles[["fold"]] <- styles[["keyword"]][["color"]]
      }
      else
      {
         styles[["fold"]] <- defaultGlobals$fold
      }
   }
   
   styles[["gutterBg"]] <- styles$background
   styles[["gutterFg"]] <- .rs.mixColors(styles$foreground, styles$background, 0.5)
   styles[["selected_word_highlight"]] <- paste0("border: 1px solid ", styles$selection)
   
   styles$isDark = tolower(as.character(.rs.getLuma(styles$background) <  0.5))
   
   fScopeNames <- names(fallbackScopes)
   for (i in 1:length(fallbackScopes))
   {
      name <- fScopeNames[i]
      scope <- fallbackScopes[[i]]
      if (!(name %in% names(styles)) || !("color" %in% names(styles[[name]])))
      {
         if (!(scope %in% names(styles)) || !("color" %in% names(styles[[scope]])))
         {
            # All fallback elements are foreground for now.
            if (!(name %in% names(styles))) styles[[name]] <- list()
            styles[[name]][["color"]] <- styles$foreground
         }
         else if (name %in% names(styles))
         {
            styles[[name]][["color"]] <- styles[[scope]][["color"]]
         }
         else
         {
            styles[[name]] <- styles[[scope]]
         }
      }
   }
   
   list("styles" = styles, "unsupportedScopes" = unsupportedScopes)
})

# Converts a theme from a tmTheme to an Ace css theme.
#
# @param tmTheme     The parsed tmTheme object.
# 
# Returns Ace css theme as a string.
.rs.addFunction("convertTmTheme", function(tmTheme) {
   # Helper functions 
   
   # Fills a template value with the given replacements.
   #
   # @param template          The template to fill.
   # @param replacements      The replacements to fill the template with.
   #
   # Returns a string of the filled template.
   fillTemplate <- function(template, replacements) {
      repeat
      {
         matches <- regmatches(template, regexec("%(.+?)%", template))[[1]]
         if (length(matches) != 2)
         {
            break
         }
         
         replacement <- replacements[[matches[2]]]
         if (is.null(replacement)) replacement <- ""
         template <- sub(matches[1], replacement, template)
      }
      
      template
   }
   
   # Hyphenates a title or camel case string, separating words and replacing "_" with "-".
   # 
   # @param string      The string to convert to lower case with hyphens.
   #
   # Returns the converted string.
   hyphenate <- function(string) {
      tolower(
         gsub("-+", "-", # Get rid of duplicate hyphens
              sub(
                 "^-", "", # Get rid of leading hyphen
                 gsub(
                    "_",
                    "-", # Replace _ with hyphen
                    gsub(
                       "([^0-9A-Z])([A-Z])", # Insert hyphen before capital letters which are not immediately preceded by a digit or another capital letter
                       "\\1-\\2",
                       gsub("(?:'|\"|\\(([^\\)]*)\\))", "\\1", # Remove special characters and anything encased in parentheses
                            gsub("&","-and-", # Replace & with And
                                 gsub("\\s", "-", string)))))))) # Replace whitespace with hyphen
   }
   
   # Quotes a string and adds extra escapes to escape characters.
   #
   # @param string      The string to quoted.
   #
   # Returns the processed string
   quoteStr <- function(string) {
      paste0(
         "\"",
         gsub("\n", "\\n", gsub("\"", "\\\"", gsub("\\", "\\\\", string))),
         "\"")
   }
   
   # Syntax highlighting scopes
   supportedScopes <- list()
   
   # Keywords
   supportedScopes[["keyword"]] <- "keyword"
   supportedScopes[["keyword.operator"]] <- "keyword.operator"
   supportedScopes[["keyword.other.unit"]] <- "keyword.other.unit"
   
   # Constants
   supportedScopes[["constant"]] <- "constant"
   supportedScopes[["constant.language"]] <- "constant.language"
   supportedScopes[["constant.library"]] <- "constant.library"
   supportedScopes[["constant.numeric"]] <- "constant.numeric"
   supportedScopes[["constant.character"]] <- "constant.character"
   supportedScopes[["constant.character.escape"]] <- "constant.character.escape"
   supportedScopes[["constant.character.entity"]] <- "constant.character.entity"
   supportedScopes[["constant.other"]] <- "constant.other"
   
   # Supports
   supportedScopes[["support"]] <- "support"
   supportedScopes[["support.function"]] <- "support.function"
   supportedScopes[["support.function.dom"]] <- "support.function.dom"
   supportedScopes[["support.function.firebug"]] <- "support.firebug"
   supportedScopes[["support.function.constant"]] <- "support.function.constant"
   supportedScopes[["support.constant"]] <- "support.constant"
   supportedScopes[["support.constant.property-value"]] <- "support.constant.property-value"
   supportedScopes[["support.class"]] <- "support.class"
   supportedScopes[["support.type"]] <- "support.type"
   supportedScopes[["support.other"]] <- "support.other"
   
   # Functions
   supportedScopes[["function"]] <- "function"
   supportedScopes[["function.buildin"]] <- "function.buildin"
   
   # Storages
   supportedScopes[["storage"]] <- "storage"
   supportedScopes[["storage.type"]] <- "storage.type"
   
   # Invalids
   supportedScopes[["invalid"]] <- "invalid"
   supportedScopes[["invalid.illegal"]] <- "invalid.illegal"
   supportedScopes[["invalid.deprecated"]] <- "invalid.deprecated"
   
   # Strings
   supportedScopes[["string"]] <- "string"
   supportedScopes[["string.regexp"]] <- "string.regexp"
   
   # Comments
   supportedScopes[["comment"]] <- "comment"
   supportedScopes[["comment.documentation"]] <- "comment.doc"
   supportedScopes[["comment.documentation.tag"]] <- "comment.doc.tag"
   
   # Variables
   supportedScopes[["variable"]] <- "variable"
   supportedScopes[["variable.language"]] <- "variable.language"
   supportedScopes[["variable.parameter"]] <- "variable.parameter"
   
   # Meta
   supportedScopes[["meta"]] <- "meta"
   supportedScopes[["meta.tag.sgml.doctype"]] <- "xml-pe"
   supportedScopes[["meta.tag"]] <- "meta.tag"
   supportedScopes[["meta.selector"]] <- "meta.selector"
   
   # Entities
   supportedScopes[["entity.other.attribute-name"]] <- "entity.other.attribute-name"
   supportedScopes[["entity.name.function"]] <- "entity.name.function"
   supportedScopes[["entity.name"]] <- "entity.name"
   supportedScopes[["entity.name.tag"]] <- "entity.name.tag"
   
   # Markup
   supportedScopes[["markup.heading"]] <- "markup.heading"
   supportedScopes[["markup.heading.1"]] <- "markup.heading.1"
   supportedScopes[["markup.heading.2"]] <- "markup.heading.2"
   supportedScopes[["markup.heading.3"]] <- "markup.heading.3"
   supportedScopes[["markup.heading.4"]] <- "markup.heading.4"
   supportedScopes[["markup.heading.5"]] <- "markup.heading.5"
   supportedScopes[["markup.heading.6"]] <- "markup.heading.6"
   supportedScopes[["markup.list"]] <- "markup.list"
   
   # Collaborators
   supportedScopes[["collab.user1"]] <- "collab.user1"
   
   # RStudio Supported Scopes
   supportedScopes[["marker-layer.active_debug_line"]] <- "marker-layer .active_debug_line"
   # Read the template files
   conn <- file(
      description = file.path(.Call("rs_rResourcesPath", PACKAGE = "(embedding)"), "templates", "ace_theme_template.css"),
      open = "rt")
   on.exit(close(conn), add = TRUE)
   cssTemplate <- paste0(readLines(conn, encoding = "UTF-8"), collapse ="\n")
   
   # Extract styles
   name <- tmTheme$name
   if (is.null(name)) name <- ""
   styleRes <- .rs.extractStyles(tmTheme, supportedScopes)
   styles <- styleRes$styles
   unsupportedScopes <- styleRes$unsupportedScopes
   
   # Fill template
   styles$cssClass = paste0("ace-", hyphenate(name))
   styles$uuid <- tmTheme$uuid
   css <- fillTemplate(cssTemplate, styles)
   
   for (scope in supportedScopes)
   {
      if (scope %in% names(styles))
      {
         if (grepl("active_debug_line", scope, fixed = TRUE))
         {
            css = paste0(
               css,
               "\n\n.",
               styles$cssClass,
               " ",
               gsub("^|\\.", ".ace_", scope),
               " {\n")
            for (rule in names(styles[[scope]]))
            {
               if (!grepl("^\\s*$", styles[[scope]][[rule]], perl = TRUE))
               {
                  css = paste0(css, "  ", rule, ": ", styles[[scope]][[rule]], ";\n")
               }
            }
            
            css = paste0(
               css,
               "\n  position: absolute;",
               "\n  z-index: -1;",
               "\n}")
         }
         else if (length(styles[[scope]]) > 0)
         {
            css = paste0(
               css,
               "\n\n.",
               styles$cssClass,
               " ",
               gsub("^|\\.", ".ace_", scope),
               " {\n")
            for (rule in names(styles[[scope]]))
            {
               if (!grepl("^\\s*$", styles[[scope]][[rule]], perl = TRUE))
               {
                  css = paste0(css, "  ", rule, ": ", styles[[scope]][[rule]], ";\n")
               }
            }
            
            css = paste0(css, "\n}")
         }
      }
   }
   
   list(
      "theme" = strsplit(gsub("[^\\{\\}]+\\{\\s*\\}", "", css, perl = TRUE), "\n")[[1]],
      "isDark" = as.logical(styles$isDark))
})

# TmTheme XML Parsing functions ====================================================================

# Parses a "key" element from a tmtheme document and raises appropriate error.
#
# @param element     The element to parse.
#
# Returns the text value of the element.
.rs.addFunction("parseKeyElement", function(element) {
   key <- xml2::xml_text(element)
   if (key == "")
   {
      stop("The value of a \"key\" element may not be empty.", call. = FALSE)
   }
   
   key
})

# Parses a "string" element from a tmtheme document and raises appropriate errors.
#
# @param element     The element to parse.
# @param keyName     The name of the key for this value.
#
# Returns the text value of the element.
.rs.addFunction("parseStringElement", function(element, keyName) {
   value <- xml2::xml_text(element)
   
   # The key can only be null if there was no <key> element immediately preceding the <string>
   # element in the provided xml. If any <key> element was found (even a <key/>), the key name
   # will at least be "".
   if (is.null(keyName))
   {
      stop(
         "Unable to find a key for the \"string\" element with value \"",
         value,
         "\".",
         call. = FALSE)
   }
   
   value
})

# Recursively parses a dictionary element from a tmtheme document and raises the correct errors.
#
# @param dictElement    The element to parse.
# @param keyName        The name of the dictionary.
#
# Returns a list with named values.
.rs.addFunction("parseDictElement", function(dictElement, keyName) {
   if (is.null(keyName))
   {
      stop("Unable to find a key for the current \"dict\" element.", call. = FALSE)
   }
   
   values <- list()
   if (xml2::xml_length(dictElement) >= 1)
   {
      key <- NULL
      for (element in xml2::xml_children(dictElement))
      {
         elName <- xml2::xml_name(element)
         if (elName != "comment")
         {
            if (elName == "key")
            {
               if (!is.null(key))
               {
                  stop(
                     "Unable to find a value for the key \"",
                     key,
                     "\".",
                     call. = FALSE)
               }
               key <- .rs.parseKeyElement(element)
            }
            else if (elName == "string")
            {
               # Add the key-value pair to the theme object and reset the key to NULL to avoid erroneously
               # using the same key twice.
               values[[key]] <- .rs.parseStringElement(element, key)
               key <- NULL
            }
            else if (elName == "dict")
            {
               values[[key]] <- .rs.parseDictElement(element, key)
               key <- NULL
            }
            else if (elName == "array")
            {
               values[[key]] <- .rs.parseArrayElement(element, key)
               key <- NULL
            }
            else
            {
               stop(
                  "Encountered unexpected element as a child of the current \"dict\" element: \"",
                  elName,
                  "\". Expected \"key\", \"string\", \"array\", or \"dict\".",
                  call. = FALSE)
            }
         }
      }
      
      if (!is.null(key))
      {
         stop(
            "Unable to find a value for the key \"",
            key,
            "\".",
            call. = FALSE)
      }
   }
   
   values
})

# Recursively parses the list of settings from a tmtheme document.
#
# @param arrayElement      The <array> element to parse.
# @param keyName           The name of the key for this array element.
#
# Returns a list() of named settings.
.rs.addFunction("parseArrayElement", function(arrayElement, keyName) {
   if (xml2::xml_length(arrayElement) < 1)
   {
      stop("\"array\" element cannot be empty.", call. = FALSE)
   }
   
   if (is.null(keyName))
   {
      stop("Unable to find a key for array value.", call. = FALSE)
   }
   if (keyName != "settings")
   {
      stop(
         "Incorrect key for array element. Expected: \"settings\"; Actual: \"",
         keyName,
         "\".",
         call. = FALSE)
   }
   
   values <- list()
   index <- 1
   for (element in xml2::xml_children(arrayElement))
   {
      elName <- xml2::xml_name(element)
      if (elName != "comment")
      {
         if (elName != "dict")
         {
            stop(
               "Expecting \"dict\" element; found \"",
               elName,
               "\".",
               call. = FALSE)
         }
         
         # Intentionally empty key here
         values[[index]] <- .rs.parseDictElement(element, "")
         index <- index + 1
      }
   }
   
   values
})

# Parses a tmtheme document and stores the relevant values in a list with named values.
#
# @param filePath     The path of the file to parse.
# 
# Returns a list with named values.
.rs.addFunction("parseTmTheme", function(filePath) {
   if (!file.exists(filePath))
   {
      stop(
         "The specified file, \"",
         filePath,
         "\", does not exist.",
         call. = FALSE)
   }
   xmlStr <- paste(readLines(filePath, encoding = "UTF-8", warn = FALSE), collapse = "\n")
   
   tmThemeDoc <- xml2::xml_root(xml2::read_xml(
      xmlStr, 
      error = function(msg, code, domain, line, col, level, filename) {
         stop(
            "An error occurred while parsing ",
            filename,
            " at line ",
            line,
            ": ",
            msg,
            call. = FALSE)
      },
      encoding = "UTF-8"))
   
   # Check for the right number of children
   childrenCount <- xml2::xml_length(tmThemeDoc)
   if (childrenCount != 1)
   {
      stop("Expected 1 non-text child of the root, found: ",
           childrenCount,
           call. = FALSE)
   }
   
   # Check the structure at the root is correct before continuing.
   if (xml2::xml_name(xml2::xml_child(tmThemeDoc, 1)) != "dict")
   {
      stop("Expecting \"dict\" element; found \"",
           xml2::xml_name(xml2::xml_child(tmThemeDoc, 1)),
           "\".",
           call. = FALSE)
   }
   if (xml2::xml_length(xml2::xml_child(tmThemeDoc, 1)) < 1)
   {
      stop(
         "\"dict\" element cannot be empty.",
         call. = FALSE)
   }
   
   # Skip the plist (root), first child is a <dict>.
   # Intentionally empty key here
   .rs.parseDictElement(xml2::xml_child(tmThemeDoc, 1), "")
})

# compile-themes Functions =========================================================================

# Converts an ace theme to an RStudio theme.
# 
# @param aceCss      The ace CSS to convert.
# @param name        The name 
.rs.addFunction("convertAceTheme", function(name, aceCss, isDark) {
   rsTheme <- .rs.compile_theme(aceCss, isDark, name = name)
   if (length(rsTheme) == 0)
   {
      stop("Please see above for warnings.",
           .call = FALSE)
   }
   
   c(
      paste0("/* rs-theme-name: ", name, " */"),
      paste0("/* rs-theme-is-dark: ", isDark, " */"),
      rsTheme,
      "\n")
})

# Worker Functions =================================================================================
.rs.addFunction("isGlobalTheme", function(themeUrl)
{
   grepl("^theme/custom/global/.*?\\.rstheme$", themeUrl, ignore.case = TRUE)
})

.rs.addFunction("isLocalTheme", function(themeUrl)
{
   grepl("^theme/custom/local/.*\\.rstheme$", themeUrl, ignore.case = TRUE)
})

.rs.addFunction("isDefaultTheme", function(themeUrl)
{
   grepl("^theme/default/.*\\.rstheme$", themeUrl, ignore.case = TRUE)
})

.rs.addFunction("getThemeName", function(themeLines, fileName)
{
   tmThemeNameRegex <- "<key>name</key>\\s*<string>([^>]*)</string>"
   rsthemeNameRegex <- "rs-theme-name\\s*:\\s*([^\\*]+?)\\s*(?:\\*|$)"
   nameRegex <- tmThemeNameRegex
   nameLine <- themeLines[grep(tmThemeNameRegex, themeLines, perl = TRUE, ignore.case = TRUE)]
   if (length(nameLine) == 0)
   {
      nameRegex <- rsthemeNameRegex
      nameLine <- themeLines[grep(rsthemeNameRegex, themeLines, perl = TRUE, ignore.case = TRUE)]
   }
   if (length(nameLine) == 0)
   {
      regmatches(
         basename(fileName),
         regexec(
            "^([^\\.]*)(?:\\.[^\\.]*)?",
            basename(fileName),
            perl = TRUE))[[1]][2]
   }
   else
   {
      sub(
         "^\\s*(.+?)\\s*$",
         "\\1",
         regmatches(
            nameLine,
            regexec(
               nameRegex,
               nameLine,
               perl = TRUE))[[1]][2],
         perl = TRUE)
   }
})

# Gets the install location.
#
# @param global    Whether to get the global or local install dir.
#
# Returns the install location.
.rs.addFunction("getThemeInstallDir", function(global) 
{
   if (global)
      .Call("rs_getGlobalThemeDir", PACKAGE = "(embedding)")
   else
      .Call("rs_getLocalThemeDir", PACKAGE = "(embedding)")
})

.rs.addFunction("getThemeDirFromUrl", function(url) 
{
   decodedUrl <- URLdecode(url)
   if (.rs.isGlobalTheme(decodedUrl))
   {
      file.path(.rs.getThemeInstallDir(TRUE), basename(decodedUrl))
   }
   else if (.rs.isLocalTheme(decodedUrl))
   {
      .Call("rs_getLocalThemePath", basename(decodedUrl), PACKAGE="(embedding)")
   }
   else
   {
      NULL
   }
})

# Converts a tmtheme file into an rstheme file.
# 
# @param themePath         The tmtheme file to convert.
# @param add               Whether to add the converted custom theme to RStudio.
# @param outputLocation    Where to place a local copy of the converted theme.
# @param apply             Whether to immediately apply the new custom theme.
# @param force             Whether to force the operation when it may involve an overwrite.
# @param globally          Whether to add the theme for all users (true) or just this user (false).
#
# Returns the name of the theme on success.
.rs.addFunction("convertTheme", function(themePath, add, outputLocation, apply, force, globally) {
   tmTheme <- .rs.parseTmTheme(themePath)
   name <- tmTheme$name
   fileName <- paste0(tools::file_path_sans_ext(basename(themePath)), ".rstheme")
   
   
   aceTheme <- .rs.convertTmTheme(tmTheme)
   rsTheme <- .rs.convertAceTheme(name, aceTheme$theme, aceTheme$isDark)
   
   
   isTemp <- is.null(outputLocation)
   location <- if (is.null(outputLocation)) file.path(tempdir(), fileName)
   else file.path(outputLocation, fileName)
   
   if (!file.create(location))
   {
      stop(
         "Unable to create the theme file in the requested location: ",
         location,
         ". Please see above for relevant warnings.",
         call. = FALSE)
   }
   
   cat(paste(rsTheme, collapse="\n"), file = location)
   
   if (add)
   {
      .rs.addTheme(location, apply, force, globally)
   }
   else if (apply)
   {
      stop("Invalid input: unable to apply a theme which has not been added.", call. = FALSE)
   }
   
   name
})

# Adds a custom rstheme to RStudio.
#
# @param themePath   The full or relative path of the rstheme file to add.
# @param apply       Whether to immediately apply the newly added theme.
# @param force       Whether to force the operation when it may involve an overwrite.
# @param globally    Whether to add the theme for all users (true) or for the current user (false).
#
# Returns the name of the theme on success.
.rs.addFunction("addTheme", function(themePath, apply, force, globally) {
   # Get the name of the file without extension.
   fileName <- basename(themePath)
   
   # Get the name of the theme either from the first occurrence of "rs-theme-name:" in the css or 
   # the name of the file.
   themeLines <- readLines(themePath, encoding = "UTF-8", warn = FALSE)
   name <- .rs.getThemeName(paste0(themeLines, collapse = "\n"), fileName)
   
   if (is.na(name) || (name == "") || is.null(name))
   {
      stop(
         "Unable to find a name for the new theme. Please check that the file \"",
         themePath,
         "\" is valid.",
         call. = FALSE)
   }
   
   if (length(themeLines) == 0)
   {
      stop("The theme file is empty.", call. = FALSE);
   }
      
   # Check if a theme with the same name already exists in the current location.
   dupTheme <- .rs.getThemes()[[tolower(name)]]
   if (!is.null(dupTheme) && 
       ((globally && .rs.isGlobalTheme(dupTheme$url)) ||
        (!globally && .rs.isLocalTheme(dupTheme$url))) &&
       !force)
   {
      stop(
         "The specified theme, \"",
         name,
         "\", already exists in the target location. Please delete the existing theme and try again.",
         call. = FALSE)
   }
   else if (!is.null(dupTheme))
   {
      willBeOverridden <- if (!globally || .rs.isDefaultTheme(dupTheme$url)) "The existing theme will be overridden by the new theme."
      else "The newly added theme will be overridden by the existing theme."
      warning("There is another theme with the same name, \"",
              name,
              "\". ",
              willBeOverridden,
              call. = FALSE)
   }
   
   outputDir <- .rs.getThemeInstallDir(globally)
   if (!dir.exists(outputDir))
   {
      if (globally)
      {
         stop(
            "The global installation directory does not exist: \"",
            outputDir,
            "\".",
            call. = FALSE)
      }
      if (!dir.create(outputDir, recursive = TRUE))
      {
         stop(
            "Please check file system permissions.",
            call. = FALSE)
      }
   }
   
   addedTheme <- file.path(outputDir, fileName)
   if (file.exists(addedTheme) && !force)
   {
      stop(
         "A file with the same name, \"",
         fileName,
         "\", already exists in the target location. To add the theme anyway, try again with `force = TRUE`.",
         call. = FALSE)
   }
   
   if (!file.copy(
      themePath,
      addedTheme,
      overwrite = force))
   {
      msg <- "Please check file system permissions"
      if (!force)
      {
         msg <- paste0(msg, " or try again with `force = TRUE`.")
      }
      
      stop(msg, ".", call. = FALSE)
   }
   
   if (apply)
   {
      .rs.applyTheme(name, .rs.getThemes())
   }
   
   name
})

# Applies a theme to RStudio.
#
# @param name     The name of the theme to apply.
.rs.addFunction("applyTheme", function(name, themeList) {
   theme <- themeList[[tolower(name)]]
   if (is.null(theme))
   {
      stop("The specified theme \"", name, "\" does not exist.", call. = FALSE)
   }
   
   themeValue <- list(
      "name"= .rs.scalar(theme$name),
      "isDark" = .rs.scalar(theme$isDark),
      "url" = .rs.scalar(theme$url))

   # Save theme details to user state
   .rs.writeUserState("theme", themeValue)

   # Save theme itself as a user pref
   .rs.writeUserPref("editor_theme", name)
})

# Removes a theme from RStudio. If the removed theme is the current theme, the current theme will be
# set to the default theme.
#
# @param The name of the theme to remove.
.rs.addFunction("removeTheme", function(name, themeList) {
   currentTheme <- .rs.api.getThemeInfo()$editor
   lowerCaseName <- tolower(name)
   
   if (is.null(themeList[[lowerCaseName]]))
   {
      stop("The specified theme \"", name, "\" does not exist.")
   }
   
   if (identical(lowerCaseName, tolower(currentTheme)))
   {
      nextTheme <- if (themeList[[lowerCaseName]]$isDark) "Tomorrow Night" else "TextMate (default)"
      warning("Removing the active theme - setting the current theme to ", nextTheme)
      .rs.applyTheme(nextTheme, themeList)
   }
   
   filePath <- .rs.getThemeDirFromUrl(themeList[[lowerCaseName]]$url)
   
   if (is.null(filePath))
   {
      stop("Please verify that the theme is installed as a custom theme.")
   }
   if (!file.remove(filePath))
   {
      if (file.exists(filePath))
      {
         justFileName <- basename(filePath)
         actualPath <- normalizePath(filePath, mustWork = FALSE, winslash = "/")
         globalPath <- normalizePath(.rs.getThemeInstallDir(TRUE), mustWork = FALSE, winslash = "/")
         if (identical(file.path(globalPath, justFileName), actualPath))
         {
            stop("The specified theme is installed for all users. Please contact your system administrator to remove the theme.")
         }
         else
         {
            stop("Please check your file system permissions.")
         }
      }
   }
})

.rs.addFunction("getThemes", function() {
   themeList <- .Call("rs_getThemes", PACKAGE = "(embedding)")
   for (i in seq_along(themeList))
   {
      Encoding(themeList[[i]]$name) <- "UTF-8"
      Encoding(themeList[[i]]$url) <- "UTF-8"
   }
   themeList
})

# C++ Wrappers =====================================================================================
.rs.addFunction("internal.convertTheme", function(themePath) {
   Encoding(themePath) <- "UTF-8"
   
   warnings <- c()
   tryCatch(
      withCallingHandlers(
         .rs.convertTheme(
            themePath,
            add = TRUE,
            outputLocation = NULL,
            apply = FALSE,
            force = TRUE,
            globally = FALSE),
         warning = function(w) 
         { 
            warnings <<- conditionMessage(w)
            invokeRestart("muffleWarning")
         }),
      error = function(e) 
      { 
         if (length(warnings) > 0)
            e$message <- paste(
               e$message,
               paste0(warnings, collapse = "\n    "),
               sep = "\nAlso, warnings:\n    ")
         e 
      })
})

.rs.addFunction("internal.addTheme", function(themePath) {
   Encoding(themePath) <- "UTF-8"
   
   warnings <- c()
   tryCatch(
      withCallingHandlers(
         .rs.addTheme(themePath, apply = FALSE, force = FALSE, globally = FALSE),
         warning = function(w) 
         { 
            warnings <<- conditionMessage(w)
            invokeRestart("muffleWarning")
         }),
      error = function(e) 
      {
         if (length(warnings) > 0)
            e$message <- paste(
               e$message,
               paste0(warnings, collapse = "\n    "),
               sep = "\nAlso, warnings:\n    ")
         e 
      })
})

.rs.addFunction("internal.removeTheme", function(name, themeList) {
   Encoding(name) <- "UTF-8"
   
   warnings <- c()
   tryCatch(
      withCallingHandlers(
         .rs.removeTheme(name, themeList),
         warning = function(w) 
         { 
            warnings <<- c(warnings, conditionMessage(w))
            invokeRestart("muffleWarning")
         }),
      error = function(e) 
      { 
         if (length(warnings) > 0)
            e$message <- paste(
               e$message,
               paste0(warnings, collapse = "\n    "),
               sep = "\nAlso, warnings:\n    ")
         e 
      })
})

# API Functions ====================================================================================

# Convert a tmtheme to rstheme and optionally add it to RStudio.
.rs.addApiFunction("convertTheme", function(themePath, add = TRUE, outputLocation = NULL, apply = FALSE, force = FALSE, globally = FALSE) {
   # Require XML package for parsing the tmtheme files.
   missingLibraryMsg <- "Taking this action requires the %pkg% library. Please run 'install.packages(\"%pkg%\")' before continuing."
   if (!suppressWarnings(require("xml2", quietly = TRUE)))
   {
      stop(gsub("%pkg%", "xml2", missingLibraryMsg, fixed = TRUE))
   }
   
   tryCatch(
      .rs.convertTheme(themePath, add, outputLocation, apply, force, globally),
      error = function(e) { stop("Unable to convert the tmTheme to an rstheme. ", e$message) })
})

# Add a theme to RStudio.
.rs.addApiFunction("addTheme", function(themePath, apply = FALSE, force = FALSE, globally = FALSE) {
   tryCatch(
      .rs.addTheme(themePath, apply, force, globally),
      error = function(e) 
      {
         stop("Unable to add the theme file \"", themePath, "\". ", e$message)
      })
})

# Apply a theme to RStudio.
.rs.addApiFunction("applyTheme", function(name) {
   tryCatch(
      .rs.applyTheme(name, .rs.getThemes()),
      error = function(e) { stop("Unable to apply the theme \"", name, "\". ", e$message) })
})

# Remove a theme from RStudio.
.rs.addApiFunction("removeTheme", function(name) {
   tryCatch(
      .rs.removeTheme(name, .rs.getThemes()),
      error = function(e) { stop("Unable to remove the theme \"", name, "\". ", e$message) })
})

# Get the list of installed themes.
.rs.addApiFunction("getThemes", function() {
   lapply(.rs.getThemes(), function(theme) {
      theme[names(theme) != "url"]
   })
})

# RPC Functions ====================================================================================
.rs.addJsonRpcHandler("get_theme_name", function(themeFile) {
   Encoding(themeFile) <- "UTF-8"
   lines <- readLines(themeFile, encoding = "UTF-8")
   .rs.scalar(.rs.getThemeName(paste0(lines, collapse = "\n"), themeFile))
})

#
# SessionRUtil.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("suspendSession", function(force = FALSE, exitStatus = 0L)
{
   .Call("rs_suspendSession",
         as.logical(force),
         as.integer(exitStatus),
         PACKAGE = "(embedding)")
})

.rs.addFunction("enc2native", function(text)
{
   # try converting to native encoding
   native <- iconv(text, from = "UTF-8", to = "")

   # iconv will return NA for any strings that we couldn't
   # re-encode into the native encoding -- replace those
   # back with their UTF-8 originals
   failed <- is.na(native)
   native[failed] <- text[failed]

   # return the converted string
   native
})

.rs.addFunction("isNullExternalPointer", function(object)
{
   .Call("rs_isNullExternalPointer", object, PACKAGE = "(embedding)")
})

.rs.addFunction("readIniFile", function(filePath)
{
   as.list(.Call("rs_readIniFile", filePath, PACKAGE = "(embedding)"))
})

.rs.addFunction("runConsoleProcess", function(command, caption = "Console Process")
{
   .Call("rs_runConsoleProcess",
         as.character(command),
         as.character(caption),
         PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addFunction("runAsyncRProcess", function(
   code,
   workingDir  = getwd(),
   onStarted   = function() {},
   onContinue  = function() {},
   onStdout    = function(output) {},
   onStderr    = function(output) {},
   onCompleted = function(exitStatus) {})
{
   callbacks <- list(
      started   = onStarted,
      continue  = onContinue,
      stdout    = onStdout,
      stderr    = onStderr,
      completed = onCompleted
   )
   
   .Call(
      "rs_runAsyncRProcess",
      as.character(code),
      normalizePath(workingDir, mustWork = TRUE),
      as.list(callbacks),
      PACKAGE = "(embedding)"
   )
})

#' Run an R script in a separate R process, via `system2()`.
#' 
#' Run `code` in a child \R process, launched via `system2()`.
#' 
#' @param callback An \R function, to be executed within the child process.
#'   It should take a single parameter, which represents the `data` to
#'   be supplied to the callback.
#' 
#' @param data An optional list of side-car data, to be referenced from
#'   `code` via the `data` argument. These arguments will be applied to
#'   the callback via `do.call(callback, data)`, and so should normally
#'   be a named list mapping argument names to their appropriate values.
#'   
#' @param workingDir An optional working directory in which `code`
#'   should be run.
#' 
#' @param libPaths The library paths to be set and used by the child process.
#'   By default, the parent's library paths are used.
#'
#' @param ... Optional arguments passed to `system2()`.
#' 
#' @return The return value of the callback will be returned. Any returned
#'   values should be cheap to serialize with RDS.
#' 
.rs.addFunction("executeFunctionInChildProcess", function(callback, 
                                                          data = list(),
                                                          workingDir = NULL,
                                                          libPaths = .libPaths(),
                                                          ...)
{
   # create and move to directory we'll use to stage our scripts
   scriptDir <- tempfile("rstudio-script-")
   dir.create(scriptDir, recursive = TRUE, showWarnings = FALSE)
   owd <- setwd(scriptDir)
   
   # clean up when we're done
   on.exit({
      setwd(owd)
      unlink(scriptDir, recursive = TRUE)
   }, add = TRUE)
   
   # set R_LIBS so that library paths are propagated to child process
   rlibs <- Sys.getenv("R_LIBS", unset = NA)
   Sys.setenv(R_LIBS = paste(libPaths, collapse = .Platform$path.sep))
   on.exit({
      if (is.na(rlibs))
         Sys.unsetenv("R_LIBS")
      else
         Sys.setenv(R_LIBS = rlibs)
   }, add = TRUE)
   
   # create data bundle powering script
   bundle <- list(
      callback   = callback,
      data       = data,
      workingDir = workingDir
   )
   
   # define runner script (will load data and execute user-defined callback)
   script <- quote({
      
      # save the original working directory
      originalWorkingDir <- getwd()
      
      # read side-car data file
      bundle <- readRDS("bundle.rds")
      
      # move to requested working directory
      workingDir <- bundle[["workingDir"]]
      if (!is.null(workingDir)) {
         dir.create(workingDir, recursive = TRUE, showWarnings = FALSE)
         owd <- setwd(workingDir)
         on.exit(setwd(owd), add = TRUE)
      }
      
      # retrieve callback data
      callback <- bundle[["callback"]]
      data     <- bundle[["data"]]
      
      # execute callback
      result <- do.call(callback, data)
      
      # return to original directory
      setwd(originalWorkingDir)
      saveRDS(object = result, file = "output.rds")
      
   })
   
   # write bundle to file
   # (suppress 'may not be available when loading' warnings)
   suppressWarnings(saveRDS(bundle, file = "bundle.rds"))
   
   # write script to file
   writeLines(deparse(script), con = "script.R")
   
   # form path to R
   exe <- if (Sys.info()[["sysname"]] == "Windows") "R.exe" else "R"
   r <- file.path(R.home("bin"), exe)
   
   # form command line arguments
   args <- c("--vanilla", "-s", "-f", shQuote("script.R"))
   
   # run the script
   system2(r, args, ...)
   
   # read in the serialized return value of the callback and return it
   if (file.exists("output.rds"))
      readRDS("output.rds")
})

# NOTE: this uses a bundled YAML library in the IDE as opposed to the R
# yaml package; primarily to avoid issues that can arise when attempting
# to load R packages in a session (users will then struggle to update or
# reinstall such packages)
.rs.addFunction("fromYAML", function(yamlCode)
{
   yamlCode <- paste(yamlCode, collapse = "\n")
   .Call("rs_fromYAML", yamlCode, PACKAGE = "(embedding)")
})

.rs.addFunction("systemToUtf8", function(text)
{
   .Call("rs_systemToUtf8", as.character(text), PACKAGE = "(embedding)")
})

.rs.addFunction("utf8ToSystem", function(text)
{
   .Call("rs_utf8ToSystem", as.character(text), PACKAGE = "(embedding)")
})

.rs.addFunction("isSerializable", function(object)
{
   .Call("rs_isSerializable", object, PACKAGE = "(embedding)")
})

.rs.addFunction("reindexRange", function(range, offset = 1)
{
   if (is.list(range))
      rapply(range, `+`, e2 = offset, how = "replace")
})

.rs.addFunction("getSessionOverlayOption", function(key)
{
   .Call("rs_getSessionOverlayOption", as.character(key), PACKAGE = "(embedding)")
})

#
# SessionFiles.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar("files.savedBindings", new.env(parent = emptyenv()))

# save old implementations, in case we need to restore them
bindings <- c("list.files", "list.dirs", "dir")
for (binding in bindings)
{
   original <- get(binding, envir = baseenv(), inherits = FALSE)
   assign(binding, original, envir = .rs.files.savedBindings)
}


.rs.addJsonRpcHandler("list_all_files", function(path, pattern)
{
   list.files(path, pattern = pattern, recursive = TRUE)
})

.rs.addJsonRpcHandler("ensure_file_exists", function(path)
{
   if (!file.exists(path))
      if (!file.create(path, recursive = TRUE))
         return(.rs.scalar(FALSE))
   
   .rs.scalar(identical(file.info(path)$isdir, FALSE))
})

.rs.addJsonRpcHandler("create_aliased_path", function(path)
{
   if (!file.exists(path))
      return(.rs.scalar(""))
   
   # make sure we use forward slashes here, since otherwise our
   # home path detection will fail to work
   # https://github.com/rstudio/rstudio/issues/13134
   normalized <- normalizePath(path, winslash = "/", mustWork = FALSE)
   .rs.scalar(.rs.createAliasedPath(normalized))
})

.rs.addJsonRpcHandler("get_issue_url", function(id)
{
   project <- .rs.getProjectDirectory()
   if (is.null(project)) {
      return(.rs.scalar(""))
   }
   
   DESCRIPTION <- file.path(project, "DESCRIPTION")
   if (!file.exists(DESCRIPTION)) {
      return(.rs.scalar(""))
   }

   BugReports <- tryCatch(
      read.dcf(DESCRIPTION, fields = "BugReports"), 
      error = function(e) NA, 
      warning = function(w) NA
   )
   if (is.na(BugReports)) {
      return(.rs.scalar(""))
   }

   if (!is.character(BugReports) || length(BugReports) != 1L) {
      return(.rs.scalar(""))
   }

   # make sure BugReports is a url and append the id to it
   if (grepl("^(https?://|www.)", BugReports)) {
      .rs.scalar(paste0(BugReports, "/", sub("#", "", id)))
   } else {
      .rs.scalar("")
   }
})


# these hooks are added to support RStudio's transition into
# the use of a UTF-8 code page
.rs.addFunction("files.replaceBindings", function()
{
   .rs.replaceBinding("list.files", "base", function(path = ".",
                                                     pattern = NULL,
                                                     all.files = FALSE,
                                                     full.names = FALSE,
                                                     recursive = FALSE,
                                                     ignore.case = FALSE,
                                                     include.dirs = FALSE,
                                                     no.. = FALSE)
   {
      "RStudio hook: restore original with `.rs.files.restoreBindings()`"
      .Call(
         "rs_listFiles",
         path,
         pattern,
         all.files,
         full.names,
         recursive,
         ignore.case,
         include.dirs,
         no..,
         PACKAGE = "(embedding)"
      )
   })

   .rs.replaceBinding("list.dirs", "base", function(path = ".",
                                                    full.names = TRUE,
                                                    recursive = TRUE)
   {
      "RStudio hook: restore original with `.rs.files.restoreBindings()`"
      .Call(
         "rs_listDirs",
         path,
         full.names,
         recursive,
         PACKAGE = "(embedding)"
      )
   })

   # dir and list.files should refer to the same thing
   .rs.replaceBinding("dir", "base", list.files)

})

# this is provided just in case users need an escape hatch
# from our overridden list.files() implementations on windows
.rs.addFunction("files.restoreBindings", function()
{
   bindings <- ls(envir = .rs.files.savedBindings)
   for (binding in bindings)
      .rs.replaceBinding(binding, "base", .rs.files.savedBindings[[binding]])
})

.rs.addFunction("listFiles", function(path = ".",
                                      pattern = NULL,
                                      all.files = FALSE,
                                      full.names = FALSE,
                                      recursive = FALSE,
                                      ignore.case = FALSE,
                                      include.dirs = FALSE,
                                      no.. = FALSE)
{
   .Call(
      "rs_listFiles",
      path,
      pattern,
      all.files,
      full.names,
      recursive,
      ignore.case,
      include.dirs,
      no..,
      PACKAGE = "(embedding)"
   )
})

.rs.addFunction("listDirs", function(path = ".",
                                     full.names = TRUE,
                                     recursive = TRUE)
{
   .Call(
      "rs_listDirs",
      path,
      full.names,
      recursive,
      PACKAGE = "(embedding)"
   )
})

.rs.addFunction("listZipFile", function(zipfile)
{
   as.character(utils::unzip(zipfile, list=TRUE)$Name)
})

.rs.addFunction("createZipFile", function(zipfile, parent, files)
{
   # set working dir to parent (and restore on exit)
   previous_wd = getwd()
   setwd(parent)
   on.exit(setwd(previous_wd))
   
   # build zip command
   quotedFiles = paste(shQuote(files), collapse = " ")
   createZipCommand = paste("zip", "-r", shQuote(zipfile), quotedFiles, "2>&1")  
   
   # execute the command (return output of command)
   system(createZipCommand, intern = TRUE)
})

.rs.addFunction("scanFiles", function(path,
                                      pattern,
                                      asRelativePath = TRUE,
                                      maxCount = 200L)
{
   .Call("rs_scanFiles",
         as.character(path),
         as.character(pattern),
         as.logical(asRelativePath),
         as.integer(maxCount))
})

.rs.addFunction("readLines", function(filePath)
{
   .Call("rs_readLines", path.expand(filePath), PACKAGE = "(embedding)")
})

# Vectorized: replaces each path's HOME prefix with "~" (and HOME itself with
# "~"), leaving paths outside HOME unchanged. Delegates to the C++
# FilePath::createAliasedPath so the R-callable layer and the C++ session
# share a single implementation -- see rs_createAliasedPath in SessionFiles.cpp.
.rs.addFunction("createAliasedPath", function(path)
{
   .Call("rs_createAliasedPath", path, PACKAGE = "(embedding)")
})

#
#  compile-themes.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

.rs.addFunction("parseCss", function(lines)
{
   css <- list()
   
   # Split any lines with "\n" for proper parsing.
   cssLines <- unlist(strsplit(gsub("\\}", "\\}\n", lines), c("\n"), perl = TRUE))
   
   currKeys <-list()
   isLastDescForKey <- FALSE
   inCommentBlock <- FALSE
   candidateKey <- NULL
   for (currLine in cssLines)
   {
      orgLine <- currLine
      
      # We use this to still parse the code before the start of the comment, if any.
      startCommentBlock <- FALSE
      
      # Remove all in-line comments.
      currLine <- gsub("/\\*.*?\\*/", "", currLine)
      
      # If we're not in a comment block and the current line has a comment opener, start the comment
      # block and update the line by removing the commented section. This allows for CSS before the
      # start of a comment. Note that this comment can't be contained wholly on a single line
      # because of the gsub above this.
      if (!inCommentBlock && grepl("/\\*", currLine))
      {
         startCommentBlock <- TRUE
         currLine <- sub("/\\*.*$", "", currLine)
      }
      
      # If we're in a comment block and the current line has a comment closer, end the comment block
      # and update the line by removing the commented section. This allows for CSS after the end of
      # a comment.
      if (inCommentBlock && grepl("\\*/", currLine))
      {
         inCommentBlock <- FALSE
         currLine <- sub("^.*?\\*/", "", currLine)
      }
      
      if (!inCommentBlock)
      {
         # Check for a change of key. A "key" in this context is the name of a CSS rule block. For example, in
         # .ace_editor {
         #     font-weight: bold;
         #     color: #AAAAAA
         # }
         # ".ace_editor" is the key and "font-weight: bold" and "color: #AAAAAA" are descriptions for that key.
         if (grepl("^\\s*\\.[^\\{]+\\{", currLine))
         {
            candidateKey <- paste(
               candidateKey, 
               regmatches(
                  currLine,
                  regexec("^\\s*([^\\{]*?)\\s*\\{", currLine))[[1]][2],
               sep = " ")
            candidateKey <- gsub("^\\s*|\\s*$", "", candidateKey, perl = TRUE)
            
            if (!grepl("^\\s*$", candidateKey))
            {
               if (length(currKeys) > 0)
               {
                  warning("Malformed CSS: ", orgLine, ". No closing bracket for last block.")
               }
               currKeys <- unlist(strsplit(candidateKey, "\\s*,\\s*", perl = TRUE))
               candidateKey <- NULL
               
               for (currKey in currKeys)
               {
                  css[[currKey]] <- list()
               }
               currLine <- sub("^\\s*[^\\{]*?\\s*\\{", "", currLine)
            }
         }
         
         # If there is currently a key, look for it's descriptions.
         if (length(currKeys) > 0)
         {
            # Determine if we're at the end of the block and remove the closing bracket to be able
            # to parse anything that comes before it on the same line.
            if (grepl("\\}", currLine))
            {
               isLastDescForKey <- TRUE
               currLine <- sub("^([^\\}]*)\\}\\s*$", "\\1", currLine)
               if (grepl("\\}", currLine))
               {
                  warning("Maformed CSS: ", orgLine, ". Extra closing brackets.")
               }
            }
            
            # Handle any URL fields, because they're too complex to be parsed as below.
            urlPattern <-"\\s*(background(?:-image)?)\\s*:\\s*(url\\((?:\"[^\"]*\"|[^)]*)\\)[^();]*?)\\s*(?:;|$)"
            
            while (grepl(urlPattern, currLine, ignore.case = TRUE, perl = TRUE))
            {
               ruleName = sub(urlPattern, "\\1", currLine, ignore.case = TRUE, perl = TRUE)
               ruleValue = sub(urlPattern, "\\2", currLine, ignore.case = TRUE, perl = TRUE)
               currLine <- sub(urlPattern, "", currLine, ignore.case = TRUE, perl = TRUE)
               
               for (currKey in currKeys) css[[currKey]][[ruleName]] <- ruleValue
            }
            
            # Look for a : on the line. CSS rules always have the format "name: style", so this
            # indicates there is a description on this line..
            if (grepl(":", currLine))
            {
               # Split on the rule separator. There may be multiple descriptions on one line.
               descValues <- strsplit(currLine, "\\s*;\\s*")[[1]]
               for (value in descValues)
               {
                  # If there is a non-empty value, parse the description.
                  if (value != "")
                  {
                     # Strip whitespace and ;, if any, and then split on :.
                     desc <- strsplit(sub("^\\s*([^;]+);?\\s*$", "\\1", value), "\\s*:\\s*")[[1]]
                     if (length(desc) != 2)
                     {
                        warning("Malformed CSS: ", orgLine, ". Invalid element within block.")
                     }
                     else
                     {
                        for (currKey in currKeys) css[[currKey]][[ desc[1] ]] <- tolower(desc[2])
                     }
                  }
               }
            }
            # If the line doesn't contain a description and is non-empty, it is malformed.
            else if (!grepl("^\\s*$", currLine))
            {
               warning("Malformd CSS: ", orgLine, ". Unexpected non-css line.")
            }
         }
         else if (!grepl("^\\s*$", currLine))
         {
            if (is.null(candidateKey))
            {
               candidateKey <- currLine
            }
            else
            {
               # selectors for CSS rule blocks may be split over multiple lines.
               candidateKey <- paste(candidateKey, currLine)
            }
         }
         
         # If we've finished a block, reset the key and the block-end indicator.
         if (isLastDescForKey)
         {
            currKeys <- list()
            isLastDescForKey <- FALSE
         }
         
         # If we started a comment block this line, update the inCommentBlock status so we ignore
         # all lines until the end of the comment block is found.
         if (startCommentBlock)
         {
            inCommentBlock <- TRUE
         }
      }
   }
   
   css
})

.rs.addFunction("add_operator_color", function(content, name, isDark = FALSE, overrideMap = list()) {
   color <- overrideMap[[name]]
   
   if (is.null(color))
      color <- if (isDark) "#AAAAAA" else "#888888"
   
   .rs.add_content(
      content,
      ".ace_keyword.ace_operator {",
      "  color: %s !important;",
      "}",
      replace = color
   )
})

.rs.addFunction("add_keyword_color", function(content, name, overrideMap) {
   .rs.add_content(
      content,
      ".ace_keyword {",
      "  color: %s !important;",
      "}",
      replace = overrideMap[[name]]
   )
})

# Converts a color to an array of the RGB values of the color.
#
# @param color    The color to convert.
#
# Returns the RGB color.
.rs.addFunction("getRgbColor", function(color) {

   # Named CSS colors we can decode. Source:
   # https://developer.mozilla.org/en-US/docs/Web/CSS/color_value
   namedCssColors <- list(
      black                  = c(0L, 0L, 0L),
      silver                 = c(192L, 192L, 192L),
      gray                   = c(128L, 128L, 128L),
      white                  = c(255L, 255L, 255L),
      maroon                 = c(128L, 0L, 0L),
      red                    = c(255L, 0L, 0L),
      purple                 = c(128L, 0L, 128L),
      fuchsia                = c(255L, 0L, 255L),
      green                  = c(0L, 128L, 0L),
      lime                   = c(0L, 255L, 0L),
      olive                  = c(128L, 128L, 0L),
      yellow                 = c(255L, 255L, 0L),
      navy                   = c(0L, 0L, 128L),
      blue                   = c(0L, 0L, 255L),
      teal                   = c(0L, 128L, 128L),
      aqua                   = c(0L, 255L, 255L),
      orange                 = c(255L, 165L, 0L),
      aliceblue              = c(240L, 248L, 255L),
      antiquewhite           = c(250L, 235L, 215L),
      aquamarine             = c(127L, 255L, 212L),
      azure                  = c(240L, 255L, 255L),
      beige                  = c(245L, 245L, 220L),
      bisque                 = c(255L, 228L, 196L),
      blanchedalmond         = c(255L, 235L, 205L),
      blueviolet             = c(138L, 43L, 226L),
      brown                  = c(165L, 42L, 42L),
      burlywood              = c(222L, 184L, 135L),
      cadetblue              = c(95L, 158L, 160L),
      chartreuse             = c(127L, 255L, 0L),
      chocolate              = c(210L, 105L, 30L),
      coral                  = c(255L, 127L, 80L),
      cornflowerblue         = c(100L, 149L, 237L),
      cornsilk               = c(255L, 248L, 220L),
      crimson                = c(220L, 20L, 60L),
      cyan                   = c(0L, 255L, 255L),
      darkblue               = c(0L, 0L, 139L),
      darkcyan               = c(0L, 139L, 139L),
      darkgoldenrod          = c(184L, 134L, 11L),
      darkgray               = c(169L, 169L, 169L),
      darkgreen              = c(0L, 100L, 0L),
      darkgrey               = c(169L, 169L, 169L),
      darkkhaki              = c(189L, 183L, 107L),
      darkmagenta            = c(139L, 0L, 139L),
      darkolivegreen         = c(85L, 107L, 47L),
      darkorange             = c(255L, 140L, 0L),
      darkorchid             = c(153L, 50L, 204L),
      darkred                = c(139L, 0L, 0L),
      darksalmon             = c(233L, 150L, 122L),
      darkseagreen           = c(143L, 188L, 143L),
      darkslateblue          = c(72L, 61L, 139L),
      darkslategray          = c(47L, 79L, 79L),
      darkslategrey          = c(47L, 79L, 79L),
      darkturquoise          = c(0L, 206L, 209L),
      darkviolet             = c(148L, 0L, 211L),
      deeppink               = c(255L, 20L, 147L),
      deepskyblue            = c(0L, 191L, 255L),
      dimgray                = c(105L, 105L, 105L),
      dimgrey                = c(105L, 105L, 105L),
      dodgerblue             = c(30L, 144L, 255L),
      firebrick              = c(178L, 34L, 34L),
      floralwhite            = c(255L, 250L, 240L),
      forestgreen            = c(34L, 139L, 34L),
      gainsboro              = c(220L, 220L, 220L),
      ghostwhite             = c(248L, 248L, 255L),
      gold                   = c(255L, 215L, 0L),
      goldenrod              = c(218L, 165L, 32L),
      greenyellow            = c(173L, 255L, 47L),
      grey                   = c(128L, 128L, 128L),
      honeydew               = c(240L, 255L, 240L),
      hotpink                = c(255L, 105L, 180L),
      indianred              = c(205L, 92L, 92L),
      indigo                 = c(75L, 0L, 130L),
      ivory                  = c(255L, 255L, 240L),
      khaki                  = c(240L, 230L, 140L),
      lavender               = c(230L, 230L, 250L),
      lavenderblush          = c(255L, 240L, 245L),
      lawngreen              = c(124L, 252L, 0L),
      lemonchiffon           = c(255L, 250L, 205L),
      lightblue              = c(173L, 216L, 230L),
      lightcoral             = c(240L, 128L, 128L),
      lightcyan              = c(224L, 255L, 255L),
      lightgoldenrodyellow   = c(250L, 250L, 210L),
      lightgray              = c(211L, 211L, 211L),
      lightgreen             = c(144L, 238L, 144L),
      lightgrey              = c(211L, 211L, 211L),
      lightpink              = c(255L, 182L, 193L),
      lightsalmon            = c(255L, 160L, 122L),
      lightseagreen          = c(32L, 178L, 170L),
      lightskyblue           = c(135L, 206L, 250L),
      lightslategray         = c(119L, 136L, 153L),
      lightslategrey         = c(119L, 136L, 153L),
      lightsteelblue         = c(176L, 196L, 222L),
      lightyellow            = c(255L, 255L, 224L),
      limegreen              = c(50L, 205L, 50L),
      linen                  = c(250L, 240L, 230L),
      magenta                = c(255L, 0L, 255L),
      mediumaquamarine       = c(102L, 205L, 170L),
      mediumblue             = c(0L, 0L, 205L),
      mediumorchid           = c(186L, 85L, 211L),
      mediumpurple           = c(147L, 112L, 219L),
      mediumseagreen         = c(60L, 179L, 113L),
      mediumslateblue        = c(123L, 104L, 238L),
      mediumspringgreen      = c(0L, 250L, 154L),
      mediumturquoise        = c(72L, 209L, 204L),
      mediumvioletred        = c(199L, 21L, 133L),
      midnightblue           = c(25L, 25L, 112L),
      mintcream              = c(245L, 255L, 250L),
      mistyrose              = c(255L, 228L, 225L),
      moccasin               = c(255L, 228L, 181L),
      navajowhite            = c(255L, 222L, 173L),
      oldlace                = c(253L, 245L, 230L),
      olivedrab              = c(107L, 142L, 35L),
      orangered              = c(255L, 69L, 0L),
      orchid                 = c(218L, 112L, 214L),
      palegoldenrod          = c(238L, 232L, 170L),
      palegreen              = c(152L, 251L, 152L),
      paleturquoise          = c(175L, 238L, 238L),
      palevioletred          = c(219L, 112L, 147L),
      papayawhip             = c(255L, 239L, 213L),
      peachpuff              = c(255L, 218L, 185L),
      peru                   = c(205L, 133L, 63L),
      pink                   = c(255L, 192L, 203L),
      plum                   = c(221L, 160L, 221L),
      powderblue             = c(176L, 224L, 230L),
      rosybrown              = c(188L, 143L, 143L),
      royalblue              = c(65L, 105L, 225L),
      saddlebrown            = c(139L, 69L, 19L),
      salmon                 = c(250L, 128L, 114L),
      sandybrown             = c(244L, 164L, 96L),
      seagreen               = c(46L, 139L, 87L),
      seashell               = c(255L, 245L, 238L),
      sienna                 = c(160L, 82L, 45L),
      skyblue                = c(135L, 206L, 235L),
      slateblue              = c(106L, 90L, 205L),
      slategray              = c(112L, 128L, 144L),
      slategrey              = c(112L, 128L, 144L),
      snow                   = c(255L, 250L, 250L),
      springgreen            = c(0L, 255L, 127L),
      steelblue              = c(70L, 130L, 180L),
      tan                    = c(210L, 180L, 140L),
      thistle                = c(216L, 191L, 216L),
      tomato                 = c(255L, 99L, 71L),
      turquoise              = c(64L, 224L, 208L),
      violet                 = c(238L, 130L, 238L),
      wheat                  = c(245L, 222L, 179L),
      whitesmoke             = c(245L, 245L, 245L),
      yellowgreen            = c(154L, 205L, 50L),
      rebeccapurple          = c(102L, 51L, 153L)
   )

   if (is.vector(color) && any(is.integer(color)))
   {
      if (length(color) != 3)
      {
         stop(
            "expected 3 values for RGB color, not ",
            length(color),
            call. = FALSE)
      }
      colorVec <- color
   }
   else if (substr(color, 0, 1) == "#") 
   {
      if (nchar(color) != 7)
      {
         stop(
            "hex representation of RGB values should have the format \"#RRGGBB\", where `RR`, `GG` and `BB` are in [0x00, 0xFF]. Found: ",
            color,
            call. = FALSE)
      }
      else
      {
         colorVec <- sapply(
            c(substr(color, 2, 3), substr(color, 4, 5), substr(color, 6, 7)),
            function(str) { strtoi(str, 16L) },
            USE.NAMES = FALSE)
      }
   }
   else if (grepl("^rgba?", color))
   {
      matches = regmatches(color, regexec("\\(([^,\\)]+),([^,\\)]+),([^,\\)]+)", color))[[1]]
      if (length(matches) != 4)
      {
         stop(
            "non-hex representation of RGB values should have the format \"rgb(R, G, B)\" or \"rgba(R, G, B, A)\" where `R`, `G`, and `B` are integer values in [0, 255] and `A` is decimal value in [0, 1.0]. Found: ",
            color,
            call. = FALSE)
      }
      colorVec <- strtoi(matches[2:4])
   }
   else if (color %in% names(namedCssColors))
   {
      colorVec <- namedCssColors[[color]]
   }
   else
   {
      stop(
         "supplied color has an invalid format: ",
         color,
         ". Expected \"#RRGGBB\", \"rgb(R, G, B) or \"rgba(R, G, B, A)\", where `RR`, `GG` and `BB` are in [0x00, 0xFF], `R`, `G`, and `B` are integer values in [0, 255], and `A` is decimal value in [0, 1.0]",
         call. = FALSE)
   }
   
   # Check for inconsistencies.
   invalidMsg <- paste0("invalid color supplied: ", color, ". ")
   if (any(is.na(colorVec)) || any(!is.integer(colorVec)))
   {
      stop(
         invalidMsg,
         "One or more RGB values could not be converted to an integer",
         call. = FALSE)
   }
   if (any(colorVec < 0))
   {
      stop(invalidMsg, "RGB value cannot be negative", call. = FALSE)
   }
   if (any(colorVec > 255))
   {
      stop(invalidMsg, "RGB value cannot be greater than 255", call. = FALSE)
   }
   
   colorVec
})

.rs.addFunction("format_css_color", function(color) {
   sprintf("rgb(%s, %s, %s)",
           color[1],
           color[2],
           color[3])
})

.rs.addFunction("color_as_hex", function(color) {
   paste("#", paste(format(as.hexmode(as.integer(color[1:3])), upper.case = TRUE, width = 2), collapse = ""), sep = "")
})

# Strip color from field
.rs.addFunction("strip_color_from_field", function(css) {
   if (grepl("rgb", css)) {
      gsub(".*rgb", "rgb", css)
   } else {
      gsub(".*#", "#", css)
   }
})

# Mixes two colors together.
#
# @param color1   The first color.
# @param color2   The second color.
# @param alpha1   The alpha of the first color.
# @param alpha2   The alpha of the second color.
# 
# Returns the mixed color in string format.
.rs.addFunction("mixColors", function(color1, color2, alpha1, alpha2 = NULL) {
   c1rgb <- .rs.getRgbColor(color1)
   c2rgb <- .rs.getRgbColor(color2)
   
   if (is.null(alpha2))
   {
      alpha2 = 1 - alpha1
   }
   
   .rs.color_as_hex(
      c(
         ceiling(alpha1 * c1rgb[[1]] + alpha2 * c2rgb[[1]]),
         ceiling(alpha1 * c1rgb[[2]] + alpha2 * c2rgb[[2]]),
         ceiling(alpha1 * c1rgb[[3]] + alpha2 * c2rgb[[3]]),
         sep = ","))
})

.rs.addFunction("add_content", function(content, ..., replace)
   c(
      content,
      do.call(sprintf, list(paste(..., sep = "\n"), replace))
   ))

.rs.addFunction("create_line_marker_rule", function(markerName, markerColor) {
   sprintf(paste(sep = "\n",
                 ".ace_marker-layer %s {",
                 "  position: absolute;",
                 "  z-index: -1;",
                 "  background-color: %s;",
                 "}"),
           markerName,
           markerColor)
})

.rs.addFunction("createNodeSelectorRule", function(themeName, isDark, overrides = list()) {
   nodeSelectorColor <- overrides[[themeName]]
   if (is.null(nodeSelectorColor))
      nodeSelectorColor <- if (isDark) "#fb6f1c" else "rgb(102, 155, 243)"
   
   sprintf(paste(sep = "\n",
                 ".ace_node-selector {",
                 "  background-color: %s",
                 "}"),
           nodeSelectorColor)
})

.rs.addFunction("createCommentBgRule", function(themeName, isDark, overrides = list()) {
   commentFgColor <- if (isDark) "#4D4333" else "#3C4C72"
   commentBgColor <- if (isDark) "#D1B78A" else "#FFECCB"
   
   override <- overrides[[themeName]]
   if (!is.null(override) && !is.null(override$fg))
      commentFgColor <- override$fg
   
   if (!is.null(override) && !is.null(override$bg))
      commentBgColor <- override$bg
   
   sprintf(paste(sep = "\n",
                 ".ace_comment-highlight {",
                 "  color: %s;",
                 "  background-color: %s;",
                 "}"),
           commentFgColor,
           commentBgColor)
})

.rs.addFunction("get_chunk_bg_color", function(themeName, isDark, overrides = list()) {
   p <- overrides[[themeName]]
   if (is.null(p))
      if (isDark) 0.9 else 0.95
   else
      p
})

.rs.addFunction("findNext", function(regex, content, start = 1, end = length(content)) {
   matches <- grep(regex, content, perl = TRUE)
   matches[(matches > start) & (matches < end)][1]
})

.rs.addFunction("updateSetting", function(content, newValue, cssClass, settingName) {
   classPat <- paste0("\\.", cssClass, "( *){")
   if (any(grepl(classPat, content, perl = TRUE)))
   {
      settingName <- paste0(settingName, ":")
      blockLoc <- grep(classPat, content, perl = TRUE)
      
      newLine <-  paste0("  ", settingName, " ", newValue, ";")
      settingPat <- paste0("(^| )",settingName)
      if (!any(grepl(settingPat, content, perl = TRUE)))
      {
         settingLoc <- grep("}",  content, perl = TRUE)
         
         loc <- settingLoc[settingLoc > blockLoc][1]
         content <- c(content[1:loc-1], newLine, content[loc:length(content)])
      }
      else
      {
         settingLoc <- grep(settingPat,  content, perl = TRUE)
      
         loc <- settingLoc[settingLoc > blockLoc][1]
         content[loc] <- newLine
      }
   }
   content
})

.rs.addFunction("setPrintMarginColor", function(content, color) {
   .rs.updateSetting(content, color, "ace_print-margin", "background")
})

.rs.addFunction("setSelectionStartBorderRadius", function(content) {
   .rs.updateSetting(content, "2px", "ace_selection.ace_start", "border-radius")
})

.rs.addFunction("create_terminal_cursor_rules", function(isDark) {
   termCursorBgColorFirst <-  "#333"
   termCursorBgColorSecond <- "#CCC"
   if (isDark) {
      termCursorBgColorFirst <-  "#CCC"
      termCursorBgColorSecond <- "#1e1e1e"
   }
   
   sprintf(paste(sep = "\n",
                 ".terminal.xterm-cursor-style-block.focus:not(.xterm-cursor-blink-on) .terminal-cursor {",
                 "  background-color: %s;",
                 "  color: %s;",
                 "}",
                 ".terminal.focus.xterm-cursor-style-bar:not(.xterm-cursor-blink-on) .terminal-cursor::before,",
                 ".terminal.focus.xterm-cursor-style-underline:not(.xterm-cursor-blink-on) .terminal-cursor::before {",
                 "  content: \'\';",
                 "  position: absolute;",
                 "  background-color: %s;",
                 "}",
                 ".terminal:not(.focus) .terminal-cursor {",
                 "  outline: 1px solid %s;",
                 "  outline-offset: -1px;",
                 "}",
                 ".terminal .xterm-selection div {",
                 "   position: absolute;",
                 "   background-color: %s;",
                 "}"),
           
           # .terminal.xterm-cursor-style-block.focus:not(.xterm-cursor-blink-on) .terminal-cursor
           termCursorBgColorFirst,
           termCursorBgColorSecond,
           
           # .terminal.focus.xterm-cursor-style-bar:not(.xterm-cursor-blink-on) .terminal-cursor::before,
           # .terminal.focus.xterm-cursor-style-underline:not(.xterm-cursor-blink-on) .terminal-cursor::before
           termCursorBgColorFirst,
           
           # .terminal:not(.focus) .terminal-cursor
           termCursorBgColorFirst,
           
           # .terminal .xterm-selection div
           termCursorBgColorFirst)
})

.rs.addFunction("create_terminal_rule", function(background, foreground) {
   sprintf(paste(sep = "\n",
                 ".terminal {",
                 "  background-color: %s;",
                 "  color: %s;",
                 "  font-feature-settings: \"liga\" 0;",
                 "  position: relative;",
                 "  user-select: none;",
                 "  -ms-user-select: none;",
                 "  -webkit-user-select: none;",
                 "}"),
           background, foreground)
})

.rs.addFunction("create_terminal_viewport_rule", function(background) {
   sprintf(paste(sep = "\n",
                 ".terminal .xterm-viewport {",
                 "  background-color: %s;",
                 "  overflow-y: scroll;",
                 "}"),
           background)
})

.rs.addFunction("show_xterm16", function() {
  names <- sprintf("%-8s ", c("black", "red", "green", "yellow", "blue", "magenta", "cyan", "white"))
  colors <- glue::glue(
    "{names}  ", 
    "\033[{40 + 0:7}m     \033[49m \033[{30 + 0:7}mxtermColor{0:7}\033[39m", "    ",
    "\033[{100 + 0:7}m     \033[49m \033[{90 + 0:7}mxtermColor{8 + 0:7}\033[39m", 
  )
  cat("name       standard             bright\n\n")
  writeLines(colors)
  cat("\n")
})

.rs.addFunction("create_xterm_color_rules", function(background, foreground, isDark, xterm16ColorMap = NULL) {

   default_16_colors_light <- c(
      "0"  = "#2e3436", 
      "1"  = "#cc0000", 
      "2"  = "#4e9a06", 
      "3"  = "#c4a000", 
      "4"  = "#3465a4", 
      "5"  = "#75507b", 
      "6"  = "#06989a", 
      "7"  = "#d3d7cf", 
      "8"  = "#555753", 
      "9"  = "#ef2929", 
      "10" = "#8ae234", 
      "11" = "#fce94f", 
      "12" = "#729fcf", 
      "13" = "#ad7fa8", 
      "14" = "#34e2e2", 
      "15" = "#eeeeec"
   )

   # borrowed from "pastel on dark" theme
   default_16_colors_dark <- c(
      "0"  = "#4f4f4f", 
      "1"  = "#ff6c60", 
      "2"  = "#a8ff60", 
      "3"  = "#ffffb6", 
      "4"  = "#96cbfe", 
      "5"  = "#ff73fd", 
      "6"  = "#c6c5fe", 
      "7"  = "#eeeeee", 
      "8"  = "#7c7c7c", 
      "9"  = "#ffb6b0", 
      "10" = "#ceffac", 
      "11" = "#ffffcc", 
      "12" = "#b5dcff", 
      "13" = "#ff9cfe", 
      "14" = "#dfdffe", 
      "15" = "#ffffff"
   )

   generate_16_colors <- function(xterm16ColorMap) {
     if (is.null(xterm16ColorMap)) {
       colors <- if (isDark) default_16_colors_dark else default_16_colors_light
     } else {
       colors <- xterm16ColorMap[order(as.numeric(names(xterm16ColorMap)))]
     }

     paste0(collapse = "\n",
       sprintf(names(colors), colors, names(colors), colors,
         fmt =
".xtermColor%s { color: %s !important; }
.xtermBgColor%s { background-color: %s; }")
     )
   }

   paste(sep = "\n",
         sprintf(".xtermInvertColor { color: %s; }", background),
         sprintf(".xtermInvertBgColor { background-color: %s; }", foreground),
         ".xtermBold { font-weight: bold; }",
         ".xtermBlur { filter: brightness(75%); }", 
         ".xtermUnderline { text-decoration: underline; }",
         ".xtermBlink { text-decoration: blink; }",
         ".xtermHidden { visibility: hidden; }",
         ".xtermItalic { font-style: italic; }",
         ".xtermStrike { text-decoration: line-through; }",
         generate_16_colors(xterm16ColorMap),
         ".xtermColor16 { color: #000000 !important; }",
         ".xtermBgColor16 { background-color: #000000; }",
         ".xtermColor17 { color: #00005f !important; }",
         ".xtermBgColor17 { background-color: #00005f; }",
         ".xtermColor18 { color: #000087 !important; }",
         ".xtermBgColor18 { background-color: #000087; }",
         ".xtermColor19 { color: #0000af !important; }",
         ".xtermBgColor19 { background-color: #0000af; }",
         ".xtermColor20 { color: #0000d7 !important; }",
         ".xtermBgColor20 { background-color: #0000d7; }",
         ".xtermColor21 { color: #0000ff !important; }",
         ".xtermBgColor21 { background-color: #0000ff; }",
         ".xtermColor22 { color: #005f00 !important; }",
         ".xtermBgColor22 { background-color: #005f00; }",
         ".xtermColor23 { color: #005f5f !important; }",
         ".xtermBgColor23 { background-color: #005f5f; }",
         ".xtermColor24 { color: #005f87 !important; }",
         ".xtermBgColor24 { background-color: #005f87; }",
         ".xtermColor25 { color: #005faf !important; }",
         ".xtermBgColor25 { background-color: #005faf; }",
         ".xtermColor26 { color: #005fd7 !important; }",
         ".xtermBgColor26 { background-color: #005fd7; }",
         ".xtermColor27 { color: #005fff !important; }",
         ".xtermBgColor27 { background-color: #005fff; }",
         ".xtermColor28 { color: #008700 !important; }",
         ".xtermBgColor28 { background-color: #008700; }",
         ".xtermColor29 { color: #00875f !important; }",
         ".xtermBgColor29 { background-color: #00875f; }",
         ".xtermColor30 { color: #008787 !important; }",
         ".xtermBgColor30 { background-color: #008787; }",
         ".xtermColor31 { color: #0087af !important; }",
         ".xtermBgColor31 { background-color: #0087af; }",
         ".xtermColor32 { color: #0087d7 !important; }",
         ".xtermBgColor32 { background-color: #0087d7; }",
         ".xtermColor33 { color: #0087ff !important; }",
         ".xtermBgColor33 { background-color: #0087ff; }",
         ".xtermColor34 { color: #00af00 !important; }",
         ".xtermBgColor34 { background-color: #00af00; }",
         ".xtermColor35 { color: #00af5f !important; }",
         ".xtermBgColor35 { background-color: #00af5f; }",
         ".xtermColor36 { color: #00af87 !important; }",
         ".xtermBgColor36 { background-color: #00af87; }",
         ".xtermColor37 { color: #00afaf !important; }",
         ".xtermBgColor37 { background-color: #00afaf; }",
         ".xtermColor38 { color: #00afd7 !important; }",
         ".xtermBgColor38 { background-color: #00afd7; }",
         ".xtermColor39 { color: #00afff !important; }",
         ".xtermBgColor39 { background-color: #00afff; }",
         ".xtermColor40 { color: #00d700 !important; }",
         ".xtermBgColor40 { background-color: #00d700; }",
         ".xtermColor41 { color: #00d75f !important; }",
         ".xtermBgColor41 { background-color: #00d75f; }",
         ".xtermColor42 { color: #00d787 !important; }",
         ".xtermBgColor42 { background-color: #00d787; }",
         ".xtermColor43 { color: #00d7af !important; }",
         ".xtermBgColor43 { background-color: #00d7af; }",
         ".xtermColor44 { color: #00d7d7 !important; }",
         ".xtermBgColor44 { background-color: #00d7d7; }",
         ".xtermColor45 { color: #00d7ff !important; }",
         ".xtermBgColor45 { background-color: #00d7ff; }",
         ".xtermColor46 { color: #00ff00 !important; }",
         ".xtermBgColor46 { background-color: #00ff00; }",
         ".xtermColor47 { color: #00ff5f !important; }",
         ".xtermBgColor47 { background-color: #00ff5f; }",
         ".xtermColor48 { color: #00ff87 !important; }",
         ".xtermBgColor48 { background-color: #00ff87; }",
         ".xtermColor49 { color: #00ffaf !important; }",
         ".xtermBgColor49 { background-color: #00ffaf; }",
         ".xtermColor50 { color: #00ffd7 !important; }",
         ".xtermBgColor50 { background-color: #00ffd7; }",
         ".xtermColor51 { color: #00ffff !important; }",
         ".xtermBgColor51 { background-color: #00ffff; }",
         ".xtermColor52 { color: #5f0000 !important; }",
         ".xtermBgColor52 { background-color: #5f0000; }",
         ".xtermColor53 { color: #5f005f !important; }",
         ".xtermBgColor53 { background-color: #5f005f; }",
         ".xtermColor54 { color: #5f0087 !important; }",
         ".xtermBgColor54 { background-color: #5f0087; }",
         ".xtermColor55 { color: #5f00af !important; }",
         ".xtermBgColor55 { background-color: #5f00af; }",
         ".xtermColor56 { color: #5f00d7 !important; }",
         ".xtermBgColor56 { background-color: #5f00d7; }",
         ".xtermColor57 { color: #5f00ff !important; }",
         ".xtermBgColor57 { background-color: #5f00ff; }",
         ".xtermColor58 { color: #5f5f00 !important; }",
         ".xtermBgColor58 { background-color: #5f5f00; }",
         ".xtermColor59 { color: #5f5f5f !important; }",
         ".xtermBgColor59 { background-color: #5f5f5f; }",
         ".xtermColor60 { color: #5f5f87 !important; }",
         ".xtermBgColor60 { background-color: #5f5f87; }",
         ".xtermColor61 { color: #5f5faf !important; }",
         ".xtermBgColor61 { background-color: #5f5faf; }",
         ".xtermColor62 { color: #5f5fd7 !important; }",
         ".xtermBgColor62 { background-color: #5f5fd7; }",
         ".xtermColor63 { color: #5f5fff !important; }",
         ".xtermBgColor63 { background-color: #5f5fff; }",
         ".xtermColor64 { color: #5f8700 !important; }",
         ".xtermBgColor64 { background-color: #5f8700; }",
         ".xtermColor65 { color: #5f875f !important; }",
         ".xtermBgColor65 { background-color: #5f875f; }",
         ".xtermColor66 { color: #5f8787 !important; }",
         ".xtermBgColor66 { background-color: #5f8787; }",
         ".xtermColor67 { color: #5f87af !important; }",
         ".xtermBgColor67 { background-color: #5f87af; }",
         ".xtermColor68 { color: #5f87d7 !important; }",
         ".xtermBgColor68 { background-color: #5f87d7; }",
         ".xtermColor69 { color: #5f87ff !important; }",
         ".xtermBgColor69 { background-color: #5f87ff; }",
         ".xtermColor70 { color: #5faf00 !important; }",
         ".xtermBgColor70 { background-color: #5faf00; }",
         ".xtermColor71 { color: #5faf5f !important; }",
         ".xtermBgColor71 { background-color: #5faf5f; }",
         ".xtermColor72 { color: #5faf87 !important; }",
         ".xtermBgColor72 { background-color: #5faf87; }",
         ".xtermColor73 { color: #5fafaf !important; }",
         ".xtermBgColor73 { background-color: #5fafaf; }",
         ".xtermColor74 { color: #5fafd7 !important; }",
         ".xtermBgColor74 { background-color: #5fafd7; }",
         ".xtermColor75 { color: #5fafff !important; }",
         ".xtermBgColor75 { background-color: #5fafff; }",
         ".xtermColor76 { color: #5fd700 !important; }",
         ".xtermBgColor76 { background-color: #5fd700; }",
         ".xtermColor77 { color: #5fd75f !important; }",
         ".xtermBgColor77 { background-color: #5fd75f; }",
         ".xtermColor78 { color: #5fd787 !important; }",
         ".xtermBgColor78 { background-color: #5fd787; }",
         ".xtermColor79 { color: #5fd7af !important; }",
         ".xtermBgColor79 { background-color: #5fd7af; }",
         ".xtermColor80 { color: #5fd7d7 !important; }",
         ".xtermBgColor80 { background-color: #5fd7d7; }",
         ".xtermColor81 { color: #5fd7ff !important; }",
         ".xtermBgColor81 { background-color: #5fd7ff; }",
         ".xtermColor82 { color: #5fff00 !important; }",
         ".xtermBgColor82 { background-color: #5fff00; }",
         ".xtermColor83 { color: #5fff5f !important; }",
         ".xtermBgColor83 { background-color: #5fff5f; }",
         ".xtermColor84 { color: #5fff87 !important; }",
         ".xtermBgColor84 { background-color: #5fff87; }",
         ".xtermColor85 { color: #5fffaf !important; }",
         ".xtermBgColor85 { background-color: #5fffaf; }",
         ".xtermColor86 { color: #5fffd7 !important; }",
         ".xtermBgColor86 { background-color: #5fffd7; }",
         ".xtermColor87 { color: #5fffff !important; }",
         ".xtermBgColor87 { background-color: #5fffff; }",
         ".xtermColor88 { color: #870000 !important; }",
         ".xtermBgColor88 { background-color: #870000; }",
         ".xtermColor89 { color: #87005f !important; }",
         ".xtermBgColor89 { background-color: #87005f; }",
         ".xtermColor90 { color: #870087 !important; }",
         ".xtermBgColor90 { background-color: #870087; }",
         ".xtermColor91 { color: #8700af !important; }",
         ".xtermBgColor91 { background-color: #8700af; }",
         ".xtermColor92 { color: #8700d7 !important; }",
         ".xtermBgColor92 { background-color: #8700d7; }",
         ".xtermColor93 { color: #8700ff !important; }",
         ".xtermBgColor93 { background-color: #8700ff; }",
         ".xtermColor94 { color: #875f00 !important; }",
         ".xtermBgColor94 { background-color: #875f00; }",
         ".xtermColor95 { color: #875f5f !important; }",
         ".xtermBgColor95 { background-color: #875f5f; }",
         ".xtermColor96 { color: #875f87 !important; }",
         ".xtermBgColor96 { background-color: #875f87; }",
         ".xtermColor97 { color: #875faf !important; }",
         ".xtermBgColor97 { background-color: #875faf; }",
         ".xtermColor98 { color: #875fd7 !important; }",
         ".xtermBgColor98 { background-color: #875fd7; }",
         ".xtermColor99 { color: #875fff !important; }",
         ".xtermBgColor99 { background-color: #875fff; }",
         ".xtermColor100 { color: #878700 !important; }",
         ".xtermBgColor100 { background-color: #878700; }",
         ".xtermColor101 { color: #87875f !important; }",
         ".xtermBgColor101 { background-color: #87875f; }",
         ".xtermColor102 { color: #878787 !important; }",
         ".xtermBgColor102 { background-color: #878787; }",
         ".xtermColor103 { color: #8787af !important; }",
         ".xtermBgColor103 { background-color: #8787af; }",
         ".xtermColor104 { color: #8787d7 !important; }",
         ".xtermBgColor104 { background-color: #8787d7; }",
         ".xtermColor105 { color: #8787ff !important; }",
         ".xtermBgColor105 { background-color: #8787ff; }",
         ".xtermColor106 { color: #87af00 !important; }",
         ".xtermBgColor106 { background-color: #87af00; }",
         ".xtermColor107 { color: #87af5f !important; }",
         ".xtermBgColor107 { background-color: #87af5f; }",
         ".xtermColor108 { color: #87af87 !important; }",
         ".xtermBgColor108 { background-color: #87af87; }",
         ".xtermColor109 { color: #87afaf !important; }",
         ".xtermBgColor109 { background-color: #87afaf; }",
         ".xtermColor110 { color: #87afd7 !important; }",
         ".xtermBgColor110 { background-color: #87afd7; }",
         ".xtermColor111 { color: #87afff !important; }",
         ".xtermBgColor111 { background-color: #87afff; }",
         ".xtermColor112 { color: #87d700 !important; }",
         ".xtermBgColor112 { background-color: #87d700; }",
         ".xtermColor113 { color: #87d75f !important; }",
         ".xtermBgColor113 { background-color: #87d75f; }",
         ".xtermColor114 { color: #87d787 !important; }",
         ".xtermBgColor114 { background-color: #87d787; }",
         ".xtermColor115 { color: #87d7af !important; }",
         ".xtermBgColor115 { background-color: #87d7af; }",
         ".xtermColor116 { color: #87d7d7 !important; }",
         ".xtermBgColor116 { background-color: #87d7d7; }",
         ".xtermColor117 { color: #87d7ff !important; }",
         ".xtermBgColor117 { background-color: #87d7ff; }",
         ".xtermColor118 { color: #87ff00 !important; }",
         ".xtermBgColor118 { background-color: #87ff00; }",
         ".xtermColor119 { color: #87ff5f !important; }",
         ".xtermBgColor119 { background-color: #87ff5f; }",
         ".xtermColor120 { color: #87ff87 !important; }",
         ".xtermBgColor120 { background-color: #87ff87; }",
         ".xtermColor121 { color: #87ffaf !important; }",
         ".xtermBgColor121 { background-color: #87ffaf; }",
         ".xtermColor122 { color: #87ffd7 !important; }",
         ".xtermBgColor122 { background-color: #87ffd7; }",
         ".xtermColor123 { color: #87ffff !important; }",
         ".xtermBgColor123 { background-color: #87ffff; }",
         ".xtermColor124 { color: #af0000 !important; }",
         ".xtermBgColor124 { background-color: #af0000; }",
         ".xtermColor125 { color: #af005f !important; }",
         ".xtermBgColor125 { background-color: #af005f; }",
         ".xtermColor126 { color: #af0087 !important; }",
         ".xtermBgColor126 { background-color: #af0087; }",
         ".xtermColor127 { color: #af00af !important; }",
         ".xtermBgColor127 { background-color: #af00af; }",
         ".xtermColor128 { color: #af00d7 !important; }",
         ".xtermBgColor128 { background-color: #af00d7; }",
         ".xtermColor129 { color: #af00ff !important; }",
         ".xtermBgColor129 { background-color: #af00ff; }",
         ".xtermColor130 { color: #af5f00 !important; }",
         ".xtermBgColor130 { background-color: #af5f00; }",
         ".xtermColor131 { color: #af5f5f !important; }",
         ".xtermBgColor131 { background-color: #af5f5f; }",
         ".xtermColor132 { color: #af5f87 !important; }",
         ".xtermBgColor132 { background-color: #af5f87; }",
         ".xtermColor133 { color: #af5faf !important; }",
         ".xtermBgColor133 { background-color: #af5faf; }",
         ".xtermColor134 { color: #af5fd7 !important; }",
         ".xtermBgColor134 { background-color: #af5fd7; }",
         ".xtermColor135 { color: #af5fff !important; }",
         ".xtermBgColor135 { background-color: #af5fff; }",
         ".xtermColor136 { color: #af8700 !important; }",
         ".xtermBgColor136 { background-color: #af8700; }",
         ".xtermColor137 { color: #af875f !important; }",
         ".xtermBgColor137 { background-color: #af875f; }",
         ".xtermColor138 { color: #af8787 !important; }",
         ".xtermBgColor138 { background-color: #af8787; }",
         ".xtermColor139 { color: #af87af !important; }",
         ".xtermBgColor139 { background-color: #af87af; }",
         ".xtermColor140 { color: #af87d7 !important; }",
         ".xtermBgColor140 { background-color: #af87d7; }",
         ".xtermColor141 { color: #af87ff !important; }",
         ".xtermBgColor141 { background-color: #af87ff; }",
         ".xtermColor142 { color: #afaf00 !important; }",
         ".xtermBgColor142 { background-color: #afaf00; }",
         ".xtermColor143 { color: #afaf5f !important; }",
         ".xtermBgColor143 { background-color: #afaf5f; }",
         ".xtermColor144 { color: #afaf87 !important; }",
         ".xtermBgColor144 { background-color: #afaf87; }",
         ".xtermColor145 { color: #afafaf !important; }",
         ".xtermBgColor145 { background-color: #afafaf; }",
         ".xtermColor146 { color: #afafd7 !important; }",
         ".xtermBgColor146 { background-color: #afafd7; }",
         ".xtermColor147 { color: #afafff !important; }",
         ".xtermBgColor147 { background-color: #afafff; }",
         ".xtermColor148 { color: #afd700 !important; }",
         ".xtermBgColor148 { background-color: #afd700; }",
         ".xtermColor149 { color: #afd75f !important; }",
         ".xtermBgColor149 { background-color: #afd75f; }",
         ".xtermColor150 { color: #afd787 !important; }",
         ".xtermBgColor150 { background-color: #afd787; }",
         ".xtermColor151 { color: #afd7af !important; }",
         ".xtermBgColor151 { background-color: #afd7af; }",
         ".xtermColor152 { color: #afd7d7 !important; }",
         ".xtermBgColor152 { background-color: #afd7d7; }",
         ".xtermColor153 { color: #afd7ff !important; }",
         ".xtermBgColor153 { background-color: #afd7ff; }",
         ".xtermColor154 { color: #afff00 !important; }",
         ".xtermBgColor154 { background-color: #afff00; }",
         ".xtermColor155 { color: #afff5f !important; }",
         ".xtermBgColor155 { background-color: #afff5f; }",
         ".xtermColor156 { color: #afff87 !important; }",
         ".xtermBgColor156 { background-color: #afff87; }",
         ".xtermColor157 { color: #afffaf !important; }",
         ".xtermBgColor157 { background-color: #afffaf; }",
         ".xtermColor158 { color: #afffd7 !important; }",
         ".xtermBgColor158 { background-color: #afffd7; }",
         ".xtermColor159 { color: #afffff !important; }",
         ".xtermBgColor159 { background-color: #afffff; }",
         ".xtermColor160 { color: #d70000 !important; }",
         ".xtermBgColor160 { background-color: #d70000; }",
         ".xtermColor161 { color: #d7005f !important; }",
         ".xtermBgColor161 { background-color: #d7005f; }",
         ".xtermColor162 { color: #d70087 !important; }",
         ".xtermBgColor162 { background-color: #d70087; }",
         ".xtermColor163 { color: #d700af !important; }",
         ".xtermBgColor163 { background-color: #d700af; }",
         ".xtermColor164 { color: #d700d7 !important; }",
         ".xtermBgColor164 { background-color: #d700d7; }",
         ".xtermColor165 { color: #d700ff !important; }",
         ".xtermBgColor165 { background-color: #d700ff; }",
         ".xtermColor166 { color: #d75f00 !important; }",
         ".xtermBgColor166 { background-color: #d75f00; }",
         ".xtermColor167 { color: #d75f5f !important; }",
         ".xtermBgColor167 { background-color: #d75f5f; }",
         ".xtermColor168 { color: #d75f87 !important; }",
         ".xtermBgColor168 { background-color: #d75f87; }",
         ".xtermColor169 { color: #d75faf !important; }",
         ".xtermBgColor169 { background-color: #d75faf; }",
         ".xtermColor170 { color: #d75fd7 !important; }",
         ".xtermBgColor170 { background-color: #d75fd7; }",
         ".xtermColor171 { color: #d75fff !important; }",
         ".xtermBgColor171 { background-color: #d75fff; }",
         ".xtermColor172 { color: #d78700 !important; }",
         ".xtermBgColor172 { background-color: #d78700; }",
         ".xtermColor173 { color: #d7875f !important; }",
         ".xtermBgColor173 { background-color: #d7875f; }",
         ".xtermColor174 { color: #d78787 !important; }",
         ".xtermBgColor174 { background-color: #d78787; }",
         ".xtermColor175 { color: #d787af !important; }",
         ".xtermBgColor175 { background-color: #d787af; }",
         ".xtermColor176 { color: #d787d7 !important; }",
         ".xtermBgColor176 { background-color: #d787d7; }",
         ".xtermColor177 { color: #d787ff !important; }",
         ".xtermBgColor177 { background-color: #d787ff; }",
         ".xtermColor178 { color: #d7af00 !important; }",
         ".xtermBgColor178 { background-color: #d7af00; }",
         ".xtermColor179 { color: #d7af5f !important; }",
         ".xtermBgColor179 { background-color: #d7af5f; }",
         ".xtermColor180 { color: #d7af87 !important; }",
         ".xtermBgColor180 { background-color: #d7af87; }",
         ".xtermColor181 { color: #d7afaf !important; }",
         ".xtermBgColor181 { background-color: #d7afaf; }",
         ".xtermColor182 { color: #d7afd7 !important; }",
         ".xtermBgColor182 { background-color: #d7afd7; }",
         ".xtermColor183 { color: #d7afff !important; }",
         ".xtermBgColor183 { background-color: #d7afff; }",
         ".xtermColor184 { color: #d7d700 !important; }",
         ".xtermBgColor184 { background-color: #d7d700; }",
         ".xtermColor185 { color: #d7d75f !important; }",
         ".xtermBgColor185 { background-color: #d7d75f; }",
         ".xtermColor186 { color: #d7d787 !important; }",
         ".xtermBgColor186 { background-color: #d7d787; }",
         ".xtermColor187 { color: #d7d7af !important; }",
         ".xtermBgColor187 { background-color: #d7d7af; }",
         ".xtermColor188 { color: #d7d7d7 !important; }",
         ".xtermBgColor188 { background-color: #d7d7d7; }",
         ".xtermColor189 { color: #d7d7ff !important; }",
         ".xtermBgColor189 { background-color: #d7d7ff; }",
         ".xtermColor190 { color: #d7ff00 !important; }",
         ".xtermBgColor190 { background-color: #d7ff00; }",
         ".xtermColor191 { color: #d7ff5f !important; }",
         ".xtermBgColor191 { background-color: #d7ff5f; }",
         ".xtermColor192 { color: #d7ff87 !important; }",
         ".xtermBgColor192 { background-color: #d7ff87; }",
         ".xtermColor193 { color: #d7ffaf !important; }",
         ".xtermBgColor193 { background-color: #d7ffaf; }",
         ".xtermColor194 { color: #d7ffd7 !important; }",
         ".xtermBgColor194 { background-color: #d7ffd7; }",
         ".xtermColor195 { color: #d7ffff !important; }",
         ".xtermBgColor195 { background-color: #d7ffff; }",
         ".xtermColor196 { color: #ff0000 !important; }",
         ".xtermBgColor196 { background-color: #ff0000; }",
         ".xtermColor197 { color: #ff005f !important; }",
         ".xtermBgColor197 { background-color: #ff005f; }",
         ".xtermColor198 { color: #ff0087 !important; }",
         ".xtermBgColor198 { background-color: #ff0087; }",
         ".xtermColor199 { color: #ff00af !important; }",
         ".xtermBgColor199 { background-color: #ff00af; }",
         ".xtermColor200 { color: #ff00d7 !important; }",
         ".xtermBgColor200 { background-color: #ff00d7; }",
         ".xtermColor201 { color: #ff00ff !important; }",
         ".xtermBgColor201 { background-color: #ff00ff; }",
         ".xtermColor202 { color: #ff5f00 !important; }",
         ".xtermBgColor202 { background-color: #ff5f00; }",
         ".xtermColor203 { color: #ff5f5f !important; }",
         ".xtermBgColor203 { background-color: #ff5f5f; }",
         ".xtermColor204 { color: #ff5f87 !important; }",
         ".xtermBgColor204 { background-color: #ff5f87; }",
         ".xtermColor205 { color: #ff5faf !important; }",
         ".xtermBgColor205 { background-color: #ff5faf; }",
         ".xtermColor206 { color: #ff5fd7 !important; }",
         ".xtermBgColor206 { background-color: #ff5fd7; }",
         ".xtermColor207 { color: #ff5fff !important; }",
         ".xtermBgColor207 { background-color: #ff5fff; }",
         ".xtermColor208 { color: #ff8700 !important; }",
         ".xtermBgColor208 { background-color: #ff8700; }",
         ".xtermColor209 { color: #ff875f !important; }",
         ".xtermBgColor209 { background-color: #ff875f; }",
         ".xtermColor210 { color: #ff8787 !important; }",
         ".xtermBgColor210 { background-color: #ff8787; }",
         ".xtermColor211 { color: #ff87af !important; }",
         ".xtermBgColor211 { background-color: #ff87af; }",
         ".xtermColor212 { color: #ff87d7 !important; }",
         ".xtermBgColor212 { background-color: #ff87d7; }",
         ".xtermColor213 { color: #ff87ff !important; }",
         ".xtermBgColor213 { background-color: #ff87ff; }",
         ".xtermColor214 { color: #ffaf00 !important; }",
         ".xtermBgColor214 { background-color: #ffaf00; }",
         ".xtermColor215 { color: #ffaf5f !important; }",
         ".xtermBgColor215 { background-color: #ffaf5f; }",
         ".xtermColor216 { color: #ffaf87 !important; }",
         ".xtermBgColor216 { background-color: #ffaf87; }",
         ".xtermColor217 { color: #ffafaf !important; }",
         ".xtermBgColor217 { background-color: #ffafaf; }",
         ".xtermColor218 { color: #ffafd7 !important; }",
         ".xtermBgColor218 { background-color: #ffafd7; }",
         ".xtermColor219 { color: #ffafff !important; }",
         ".xtermBgColor219 { background-color: #ffafff; }",
         ".xtermColor220 { color: #ffd700 !important; }",
         ".xtermBgColor220 { background-color: #ffd700; }",
         ".xtermColor221 { color: #ffd75f !important; }",
         ".xtermBgColor221 { background-color: #ffd75f; }",
         ".xtermColor222 { color: #ffd787 !important; }",
         ".xtermBgColor222 { background-color: #ffd787; }",
         ".xtermColor223 { color: #ffd7af !important; }",
         ".xtermBgColor223 { background-color: #ffd7af; }",
         ".xtermColor224 { color: #ffd7d7 !important; }",
         ".xtermBgColor224 { background-color: #ffd7d7; }",
         ".xtermColor225 { color: #ffd7ff !important; }",
         ".xtermBgColor225 { background-color: #ffd7ff; }",
         ".xtermColor226 { color: #ffff00 !important; }",
         ".xtermBgColor226 { background-color: #ffff00; }",
         ".xtermColor227 { color: #ffff5f !important; }",
         ".xtermBgColor227 { background-color: #ffff5f; }",
         ".xtermColor228 { color: #ffff87 !important; }",
         ".xtermBgColor228 { background-color: #ffff87; }",
         ".xtermColor229 { color: #ffffaf !important; }",
         ".xtermBgColor229 { background-color: #ffffaf; }",
         ".xtermColor230 { color: #ffffd7 !important; }",
         ".xtermBgColor230 { background-color: #ffffd7; }",
         ".xtermColor231 { color: #ffffff !important; }",
         ".xtermBgColor231 { background-color: #ffffff; }",
         ".xtermColor232 { color: #080808 !important; }",
         ".xtermBgColor232 { background-color: #080808; }",
         ".xtermColor233 { color: #121212 !important; }",
         ".xtermBgColor233 { background-color: #121212; }",
         ".xtermColor234 { color: #1c1c1c !important; }",
         ".xtermBgColor234 { background-color: #1c1c1c; }",
         ".xtermColor235 { color: #262626 !important; }",
         ".xtermBgColor235 { background-color: #262626; }",
         ".xtermColor236 { color: #303030 !important; }",
         ".xtermBgColor236 { background-color: #303030; }",
         ".xtermColor237 { color: #3a3a3a !important; }",
         ".xtermBgColor237 { background-color: #3a3a3a; }",
         ".xtermColor238 { color: #444444 !important; }",
         ".xtermBgColor238 { background-color: #444444; }",
         ".xtermColor239 { color: #4e4e4e !important; }",
         ".xtermBgColor239 { background-color: #4e4e4e; }",
         ".xtermColor240 { color: #585858 !important; }",
         ".xtermBgColor240 { background-color: #585858; }",
         ".xtermColor241 { color: #626262 !important; }",
         ".xtermBgColor241 { background-color: #626262; }",
         ".xtermColor242 { color: #6c6c6c !important; }",
         ".xtermBgColor242 { background-color: #6c6c6c; }",
         ".xtermColor243 { color: #767676 !important; }",
         ".xtermBgColor243 { background-color: #767676; }",
         ".xtermColor244 { color: #808080 !important; }",
         ".xtermBgColor244 { background-color: #808080; }",
         ".xtermColor245 { color: #8a8a8a !important; }",
         ".xtermBgColor245 { background-color: #8a8a8a; }",
         ".xtermColor246 { color: #949494 !important; }",
         ".xtermBgColor246 { background-color: #949494; }",
         ".xtermColor247 { color: #9e9e9e !important; }",
         ".xtermBgColor247 { background-color: #9e9e9e; }",
         ".xtermColor248 { color: #a8a8a8 !important; }",
         ".xtermBgColor248 { background-color: #a8a8a8; }",
         ".xtermColor249 { color: #b2b2b2 !important; }",
         ".xtermBgColor249 { background-color: #b2b2b2; }",
         ".xtermColor250 { color: #bcbcbc !important; }",
         ".xtermBgColor250 { background-color: #bcbcbc; }",
         ".xtermColor251 { color: #c6c6c6 !important; }",
         ".xtermBgColor251 { background-color: #c6c6c6; }",
         ".xtermColor252 { color: #d0d0d0 !important; }",
         ".xtermBgColor252 { background-color: #d0d0d0; }",
         ".xtermColor253 { color: #dadada !important; }",
         ".xtermBgColor253 { background-color: #dadada; }",
         ".xtermColor254 { color: #e4e4e4 !important; }",
         ".xtermBgColor254 { background-color: #e4e4e4; }",
         ".xtermColor255 { color: #eeeeee !important; }",
         ".xtermBgColor255 { background-color: #eeeeee; }")
})

.rs.addFunction("themes_rainbow_indent_guides", function(colors = c("#ed90a4", "#d3a263", "#99b657", "#33c192", "#00bdce", "#94a9eb", "#dc91db")) {
   n <- length(colors)

   content <- "/* Rainbow indent lines */"
   for (i in seq_len(n)) {
      content <- c(content, 
         paste0(".rstudio_rainbow_indent_guides .ace_line .ace_indent-guide:nth-child(", n ,"n+", i, "){" ), 
         paste0("    background: linear-gradient(to left, ", colors[i], "bb 1px, transparent 1px, transparent);"),
         "}"
      )
   }

   content <- c(content, "/* Rainbow indent fills */")
   for (i in seq_len(n)) {
      content <- c(content, 
         paste0(".rstudio_rainbow_indent_fills .ace_line .ace_indent-guide:nth-child(", n ,"n+", i, "){" ), 
         paste0("    background: linear-gradient(to left, ", colors[i], "bb 1px, ", colors[i], "77 1px, ",colors[i],"77 );"),
         "}"
      )
   }

   content
})

.rs.addFunction("themes_static_rules", function(isDark) {
   content <- paste(".editor_dark.ace_editor_theme a {",
                    "   color: #FFF !important;",
                    "}",
                    "",
                    ".ace_layer {",
                    "   z-index: 3;",
                    "}",
                    "",
                    # support for showing margin line over nodebook code chunks 
                    ".ace_layer.ace_print-margin-layer {",
                    "   z-index: 2;",
                    "}",
                    "",
                    ".ace_layer.ace_marker-layer {",
                    "   z-index: 1;",
                    "}",
                    sep = "\n")
   
   if (isDark) {
      content <- c(
         content,
         paste(
            ".rstudio-themes-dark-menus .ace_editor.ace_autocomplete {",
            "   background: #2f3941;",                    # darkGreyMenuBackground
            "   border: solid 1px #4e5c68 !important;",   # darkGreyMenuBorder
            "   color: #f0f0f0;",
            "}",
            "",
            ".rstudio-themes-dark-menus .ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line,",
            ".rstudio-themes-dark-menus .ace_editor.ace_autocomplete .ace_marker-layer .ace_line-hover {",
            "   background: rgba(255, 255, 255, 0.15);",  # darkGreyMenuSelected 
            "   border: none",
            "}",
            sep = "\n"
         )
      )
   }
   
   content
})

.rs.addFunction("compile_theme", function(
   lines,
   isDark,
   name = "",
   chunkBgPropOverrideMap = list(),
   operatorOverrideMap = list(),
   keywordOverrideMap = list(),
   nodeSelectorOverrideMap = list(),
   commentBgOverrideMap = list(), 
   xterm16ColorMap = NULL)
{
   ## Guess the theme name -- all rules should start with it.
   stripped <- sub(" .*", "", lines)
   stripped <- grep("^\\.", stripped, value = TRUE)
   
   ## Get the most common value; this is the theme name.
   ## We do this because some rules will have e.g.
   ## '.ace-<theme>.normal-mode', or other things we don't use.
   themeNameCssClass <- names(sort(c(table(stripped)), decreasing = TRUE))[[1]]
   
   ## There may (should) be a rule for just '.ace-<theme> { ... }'; we need
   ## to preserve this theme, but apply it to the '.ace_editor' directly.
   regex <- paste("^\\s*", themeNameCssClass, "\\s*\\{\\s*$", sep = "")
   content <- gsub(regex, paste(
      ".ace_editor",
      ".ace_editor_theme .profvis-flamegraph",
      ".ace_editor_theme {",
      sep = ", "), lines)
   
   ## Strip the theme name rule from the CSS.
   regex <- paste("^\\", themeNameCssClass, "\\S*\\s+", sep = "")
   content <- gsub(regex, "", content)
   
   ## Add border radius
   content <- .rs.setSelectionStartBorderRadius(content)
   
   ## Parse the css
   parsed <- .rs.parseCss(lines = content)
   
   names(parsed)[grep("^\\.ace_editor(,.*|)$", names(parsed), perl = TRUE)] <- "ace_editor"
   
   if (!any(grepl("^\\.ace_keyword", names(parsed)))) {
      warning("No field 'ace_keyword' in file '", paste0(name,".css"), "'; skipping", call. = FALSE)
      return(c())
   }
   
   key <- grep("^\\.ace_keyword\\s*$", names(parsed), value = TRUE)
   keywordColor <- NULL
   if (length(key) > 0) {
      keywordColor <- parsed[[key[[1]]]]$color
   }
   if (is.null(keywordColor)) {
      warning("No field 'color' for rule 'ace_keyword' in file '", paste0(name,".css"), "'", call. = FALSE)
      return(c())
   }
   
   content <- .rs.add_content(
      content,
      ".nocolor.ace_editor .ace_line span {",
      "  color: %s !important;",
      "}",
      replace = keywordColor
   )
   
   ## Coloring for brackets, discarding the ace bounding box shown
   ## on highlight.
   layerName <- ".ace_marker-layer .ace_bracket"
   if (!(layerName %in% names(parsed))) {
      warning("Expected rule for '", layerName, "' in file '", paste0(name,".css"), "'; skipping", call. = FALSE)
      return(c())
   }
   
   borderField <- parsed[[layerName]]$border
   if (is.null(borderField)) {
      warning("No field 'border' for rule '", layerName, "' in file '", paste0(name,".css"), "'; skipping", call. = FALSE)
      return(c())
   }
   
   operatorBgColor <- if (isDark)
      "rgba(128, 128, 128, 0.5)"
   else
      "rgba(192, 192, 192, 0.5)"
   
   content <- .rs.add_content(
      content,
      ".ace_bracket {",
      "  margin: 0 !important;",
      "  border: 0 !important;",
      "  background-color: %s;",
      "}",
      replace = operatorBgColor
   )
   
   ## Get the default background, foreground color for the theme.
   background <- parsed$ace_editor$`background-color`
   if (is.null(background))
      background <- if (isDark) "#000000" else "#FFFFFF"
   
   foreground <- parsed$ace_editor$color
   if (is.null(foreground))
      foreground <- if (isDark) "#FFFFFF" else "#000000"
   
   
   ## Generate a color used for chunks, e.g. in .Rmd documents.
   ## Determine an appropriate mixing proportion, and override for certain
   ## themes.
   mix <- .rs.get_chunk_bg_color(name, isDark, chunkBgPropOverrideMap)
   
   mergedColor <- .rs.mixColors(
      background,
      foreground,
      mix
   )
   
   content <- c(
      content,
      .rs.create_line_marker_rule(".ace_foreign_line", mergedColor),
      .rs.createNodeSelectorRule(name, isDark, nodeSelectorOverrideMap),
      .rs.createCommentBgRule(name, isDark, commentBgOverrideMap)
   )
   
   ## Generate a color used for 'debugging' backgrounds.
   if (!any(grepl(".ace_active_debug_line", content, fixed = TRUE)))
   {
      debugPrimary <- "#FFDE38"
      debugBg <- .rs.mixColors(background, debugPrimary, 0.5)
   
      content <- c(
         content,
         .rs.create_line_marker_rule(".ace_active_debug_line", debugBg)
      )
   }
   
   ## Generate a background color used for console errors, as well as
   ## 'find_line' (used for highlighting e.g. 'sourceCpp' errors).
   
   ## Dark backgrounds need a bit more contrast than light ones for
   ## a nice visual display.
   mixingProportion <- if (isDark) 0.8 else 0.9
   errorBgColor <- .rs.mixColors(background, foreground, mixingProportion)
   
   content <- c(
      content,
      .rs.create_line_marker_rule(".ace_find_line", errorBgColor)
   )
   
   content <- .rs.add_content(
      content,
      ".ace_console_error {",
      "  background-color: %s;",
      "}",
      replace = errorBgColor
   )
   
   ## Add operator colors if necessary.
   if (name %in% names(operatorOverrideMap))
      content <- .rs.add_operator_color(content, name, isDark, operatorOverrideMap)
   
   ## Add keyword colors if necessary.
   if (name %in% names(keywordOverrideMap))
      content <- .rs.add_keyword_color(content, name, keywordOverrideMap)
   
   # Apply terminal-specifics
   content <- c(content,
                .rs.create_terminal_rule(background, foreground)) 
   content <- c(content,
                .rs.create_terminal_cursor_rules(isDark))
   content <- c(content,
                .rs.create_terminal_viewport_rule(background))
   
   # Add xterm-256 colors for colorized console output
   content <- c(content,
                .rs.create_xterm_color_rules(background, foreground, isDark, xterm16ColorMap = xterm16ColorMap))
   
   # Theme rules
   content <- c(content,
                .rs.themes_static_rules(isDark)) 
   
   # rainbow indent guides
   content <- c(content, 
      .rs.themes_rainbow_indent_guides()
   )

   # All done, return the lines.
   content
})

#
# SessionTrust.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("trust.grant", function(directory = getwd())
{
   directory <- normalizePath(directory, mustWork = TRUE)
   error <- .Call("rs_trustGrant", directory, PACKAGE = "(embedding)")
   if (is.character(error))
      stop("Failed to grant trust: ", error)
   invisible(directory)
})

.rs.addFunction("trust.revoke", function(directory = getwd())
{
   directory <- normalizePath(directory, mustWork = TRUE)
   error <- .Call("rs_trustRevoke", directory, PACKAGE = "(embedding)")
   if (is.character(error))
      stop("Failed to revoke trust: ", error)
   invisible(directory)
})

.rs.addFunction("trust.reset", function(directory = getwd())
{
   directory <- normalizePath(directory, mustWork = TRUE)
   error <- .Call("rs_trustReset", directory, PACKAGE = "(embedding)")
   if (is.character(error))
      stop("Failed to reset trust: ", error)
   invisible(directory)
})

.rs.addFunction("trust.status", function(directory = getwd())
{
   directory <- normalizePath(directory, mustWork = TRUE)
   .Call("rs_trustStatus", directory, PACKAGE = "(embedding)")
})

#
# regenerate-css.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

# Manual helper for updating expected CSS values for tmTheme conversion. 
# 
# Preconditions:
# 
# 1. "themes" object in environment from test-themes.R
# 2. Working directory set to "testthat"
#

units <- as.integer(length(themes))
job <- rstudioapi::jobAdd("Update themes", 
                          progressUnits = units, 
                          running = TRUE,
                          autoRemove = FALSE)

.rs.enumerate(themes, function(key, value) {
  tryCatch({
     rstudioapi::jobAddOutput(job, paste0(key, "... "))
     converted <- .rs.convertTmTheme(
        .rs.parseTmTheme(
           file.path(
              "themes",
              "tmThemes",
              paste0(key, ".tmTheme"))))
     rstudioapi::jobSetStatus(job, key)
     writeLines(converted$theme,
                file.path("themes", "acecss", paste0(value$fileName, ".css")))
     rstheme <- .rs.convertAceTheme(key, converted$theme, value$isDark)
     writeLines(rstheme, file.path("themes", "rsthemes", paste0(value$fileName, ".rstheme")))
     rstudioapi::jobAddOutput(job, "OK\n")
     rstudioapi::jobAddProgress(job, 1)
  }, error = function(e) {
    rstudioapi::jobSetState(job, "failed")
    stop(e)
  })
})

rstudioapi::jobSetState(job, "succeeded")

#
# SessionSpelling.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("downloadAllDictionaries", function(targetDir, secure)
{
   # form url to dictionaries
   fmt <- "%s://s3.amazonaws.com/rstudio-buildtools/dictionaries/%s"
   protocol <- if (secure) "https" else "http"
   archive <- "all-dictionaries.zip"
   url <- sprintf(fmt, protocol, archive)
   
   # form path to downloaded dictionaries in tempdir
   archivePath <- file.path(tempdir(), archive)
   if (file.exists(archivePath))
      file.remove(archivePath)
   
   # download the dictionary
   download.file(
      url = url,
      destfile = archivePath,
      cacheOK = FALSE,
      quiet = TRUE
   )
   
   # remove existing dictionaries if they exist
   unlink(targetDir, recursive = TRUE)
   dir.create(targetDir, showWarnings = FALSE, recursive = TRUE)
   
   # unzip downloaded dictionaries into target -- if this fails for any
   # reason then remove any files that were unpacked (because we don't 
   # know if the partially unzipped archive is valid)
   tryCatch(
      unzip(archivePath, exdir = targetDir),
      error = function(e) {
         unlink(targetDir, recursive = TRUE)
         stop(e)
      }
   )
   
   # remove the downloaded archive
   unlink(archivePath)
   
   invisible(targetDir)
})

#
# SessionClang.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#



.rs.addFunction("clangPCHPath", function(pkg, clangVersion)
{
   paste(
      packageVersion(pkg),
      R.version$platform,
      R.version$`svn rev`,
      clangVersion,
      sep = "-"
   )
})

.rs.addFunction("isClangAvailable", function() {
   cat("Attempting to load libclang for", R.version$platform, "\n")
   .Call("rs_isLibClangAvailable", PACKAGE = "(embedding)")
})

.rs.addFunction("setClangDiagnostics", function(level)
{
   if (!is.numeric(level) || (level < 0) || (level > 3))
      stop("level must be within the range [0, 3]")
   
   if (level > 0)
      .rs.isClangAvailable()
   
   .Call("rs_setClangDiagnostics", level, PACKAGE = "(embedding)")
   
   .rs.restartR()
   invisible(NULL)
})

.rs.addFunction("packagePCH", function(linkingTo)
{
   linkingTo <- .rs.parseLinkingTo(linkingTo)
   packages <- c("RcppArmadillo", "RcppEigen", "Rcpp11", "Rcpp", "cpp11")
   for (package in packages)
      if (package %in% linkingTo)
         return(package)
   ""
})

.rs.addFunction("includesForLinkingTo", function(linkingTo)
{
   includes <- character()
   
   linkingTo <- .rs.parseLinkingTo(linkingTo)
   for (pkg in linkingTo) {
      
      includeDir <- if (identical(pkg, "R"))
         R.home("include")
      else
         system.file("include", package = pkg)
      
      if (file.exists(includeDir)) {
         includes <- c(
            includes,
            paste("-I", .rs.asBuildPath(includeDir), sep = "")
         )
      }
      
   }
   
   includes
})

.rs.addFunction("includesForPackage", function(package)
{
   # find the package path
   pkgPath <- find.package(package, quiet = TRUE)
   if (!file.exists(pkgPath))
      return(.rs.includesForLinkingTo(package))
   
   # read the description file
   desc <- .rs.readPackageDescription(pkgPath)
   if (is.null(desc$LinkingTo))
      return(.rs.includesForLinkingTo(package))
   
   linkingTo <- paste(package, desc$LinkingTo, "R", sep = ", ")
   .rs.includesForLinkingTo(linkingTo)
})

.rs.addFunction("asBuildPath", function(path)
{
   if (.Platform$OS.type == "windows") {
      path <- normalizePath(path)
      if (grepl(' ', path, fixed = TRUE))
         path <- utils::shortPathName(path)
      path <- gsub("\\\\", "/", path)
   }
   
   return(path)
})

# this function can be useful when updating an Rtools definition,
# when you need to determine the default compiler include paths
.rs.addFunction("libclang.defaultCompilerIncludeDirectories", function(compiler = NULL,
                                                                       isCpp = TRUE)
{
   # put rtools on PATH for windows
   if (.rs.platform.isWindows)
   {
      path <- Sys.getenv("PATH")
      on.exit(Sys.setenv(PATH = path), add = TRUE)
      .rs.addRToolsToPath()
   }
   
   if (is.null(compiler))
   {
      # if compiler is not set, then use the default C++ compiler
      exe <- if (.rs.platform.isWindows) "R.exe" else "R"
      R <- file.path(R.home("bin"), exe)
      compiler <- if (isCpp) "CXX" else "CC"
      cxx <- system2(R, c("CMD", "config", compiler), stdout = TRUE, stderr = TRUE)
      
      # take only last line, in case R or the compiler spat out other output
      compiler <- tail(cxx, n = 1L)
   }
   
   # create a dummy c++ file
   file <- tempfile(fileext = if (isCpp) ".cpp" else ".c")
   writeLines("void test() {}", con = file)
   
   # build a command for printing compiler include paths
   command <- paste(compiler, "-E -v", basename(file))
   
   # run it
   output <- local({
      owd <- setwd(tempdir())
      on.exit(setwd(owd), add = TRUE)
      suppressWarnings(system(command, intern = TRUE))
   })
   
   # find the lines of interest
   start <- grep("#include <...> search starts here:", output)
   end <- grep("End of search list.", output)
   if (length(start) == 0L || length(end) == 0L)
   {
      .rs.logWarningMessage("couldn't determine compiler search list")
      return(character())
   }
   
   lines <- output[(start + 1L):(end - 1L)]
   
   # trim and normalize paths
   paths <- .rs.trimWhitespace(lines)
   normalizePath(paths, winslash = "/", mustWork = FALSE)
})

.rs.addFunction("libclang.generateCompilerDefinitions", function(path, isCpp = TRUE)
{
   # put rtools on PATH for windows
   if (.rs.platform.isWindows)
   {
      envpath <- Sys.getenv("PATH")
      on.exit(Sys.setenv(PATH = envpath), add = TRUE)
      .rs.addRToolsToPath()
   }

   # use the default compiler configured by R   
   exe <- if (.rs.platform.isWindows) "R.exe" else "R"
   R <- file.path(R.home("bin"), exe)
   args <- c("CMD", "config", if (isCpp) "CXX" else "CC")
   output <- system2(R, args, stdout = TRUE, stderr = TRUE)
   
   # take only last line, in case R or the compiler spat out other output
   compiler <- tail(output, n = 1L)
   
   # on Windows, with Rtools40, the path to the compiler is only valid
   # within an MinGW shell; we work around this by just replacing the compiler
   # path with the "real" path
   if (.rs.platform.isWindows &&
       getRversion() >= "4.0.0" &&
       getRversion() < "4.2.0" &&
       (.rs.startsWith(compiler, "/mingw32/bin") ||
        .rs.startsWith(compiler, "/mingw64/bin")))
   {
      for (root in c("C:/rtools40", "C:/RBuildTools/4.0"))
      {
         if (file.exists(root))
         {
            compiler <- paste0(root, compiler)
            break
         }
      }
   }
   
   # create a dummy c++ file
   file <- tempfile(fileext = if (isCpp) ".cpp" else ".c")
   writeLines("void test() {}", con = file)
   
   # build a command for printing compiler definitions
   command <- paste(compiler, "-dM -E", basename(file))
   
   # run it
   output <- .rs.tryCatch({
      owd <- setwd(tempdir())
      on.exit(setwd(owd), add = TRUE)
      suppressWarnings(system(command, intern = TRUE))
   })
   
   # if an error occurs, then nothing to do
   if (inherits(output, "error"))
      return()
   
   # for each line, only define if it's not already defined
   formatted <- unlist(lapply(output, function(line) {
      parts <- strsplit(line, "\\s+", perl = TRUE)[[1L]]
      fmt <- "#ifndef %s\n%s\n#endif\n"
      msg <- sprintf(fmt, gsub("\\(.*", "", parts[[2L]]), line)
      gsub("#define", "# define", msg)
   }))
   
   # libclang doesn't seem to support __float128 with a Windows target,
   # even though gcc does -- either way, remove this define so that we
   # don't get (hopefully spurious) libclang warnings
   if (.rs.platform.isWindows && isCpp)
   {
      formatted <- c(
         "#include <bits/c++config.h>",
         "",
         formatted,
         "",
         "#undef _GLIBCXX_USE_FLOAT128"
      )
   }
   
   # dump it to file
   dir.create(dirname(path), showWarnings = FALSE, recursive = TRUE)
   writeLines(formatted, con = path)
   
   # return path
   normalizePath(path)
   
})

#
# NotebookAlternateEngines.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("isSystemInterpreter", function(engine)
{
   # check to see if a knitr engine is defined
   knitr <- asNamespace("knitr")
   engines <- knitr$knit_engines$get()
   if (engine %in% names(engines))
   {
      # knitr engine defined; check to see if the engine uses 'eng_interpeted'
      isInterpreted <-
         is.function(knitr$eng_interpreted) &&
         is.function(engines[[engine]]) &&
         identical(engines[[engine]], knitr$eng_interpreted)
      isInterpreted
   }
   else
   {
      # no knitr engine defined; assume that the user intended to use a system
      # interpreter
      TRUE
   }
})

.rs.addFunction("runUserDefinedEngine", function(engine, code, options)
{
   Encoding(code) <- "UTF-8" 
   
   # trim common indent (this ensures that indented chunks of code can be run)
   # https://github.com/rstudio/rstudio/issues/3731
   code <- .rs.trimCommonIndent(code)
   
   # if we're using the python engine, attempt to load reticulate (this
   # will load the reticulate knitr engine and set it as the default engine)
   useReticulate <-
      identical(engine, "python") &&
      !identical(getOption("python.reticulate"), FALSE)
   
   if (useReticulate) {
      # TODO: prompt user for installation of reticulate?
      requireNamespace("reticulate", quietly = TRUE)
   }
   
   # retrieve the engine
   knitrEngines <- knitr::knit_engines$get()
   if (!engine %in% names(knitrEngines))
   {
      fmt <- "engine '%s' has not yet been registered"
      stop(sprintf(fmt, options))
   }
   
   # double-check that this is indeed a function (shouldn't happen
   # but should guard against invalid user-defined engines)
   knitrEngine <- knitrEngines[[engine]]
   if (!is.function(knitrEngine))
   {
      fmt <- "engine '%s' is not a function"
      stop(sprintf(fmt, options))
   }
   
   # prepare the R environment for reticulate Python engine
   if (useReticulate)
   {
      # install our own matplotlib hook -- TODO here is to save the plot
      # object itself so we can redraw the plot if needed on resize
      show <- getOption("reticulate.engine.matplotlib.show")
      on.exit(options(reticulate.engine.matplotlib.show = show), add = TRUE)
      options(reticulate.engine.matplotlib.show = function(plt, options) {
         path <- tempfile("reticulate-matplotlib-plot-", fileext = ".png")
         plt$savefig(path, dpi = options$dpi)
         structure(list(path = path), class = "reticulate_matplotlib_plot")
      })
      
      # install our own wrap hook -- we want to avoid the post-processing
      # typically done by knitr; we implement our own wrap behavior for
      # notebooks
      wrap <- getOption("reticulate.engine.wrap")
      on.exit(options(reticulate.engine.wrap = wrap), add = TRUE)
      options(reticulate.engine.wrap = function(outputs, options) {
         
         # take this opportunity to clear matplotlib figure if appropriate
         sys <- reticulate::import("sys", convert = TRUE)
         if (!is.null(sys$modules$matplotlib$pyplot)) {
            plt <- reticulate::import("matplotlib.pyplot", convert = TRUE)
            tryCatch(plt$clf(), error = identity)
         }
         
         # return outputs
         outputs
         
      })
      
      # use the global environment for rendering
      environment <- getOption("reticulate.engine.environment")
      on.exit(options(reticulate.engine.environment = environment), add = TRUE)
      options(reticulate.engine.environment = globalenv())
   }
   
   # prepare chunk options
   mergedOptions <- knitr::opts_chunk$merge(options)
   code <- strsplit(code, "\n", fixed = TRUE)[[1]]
   mergedOptions$code <- code
   
   # when invoking engines, we don't want to echo user code
   mergedOptions$echo <- FALSE

   # avoid knitr writing a message re: the command about to be run
   mergedOptions$message <- FALSE
   
   # invoke engine
   knitrEngine(mergedOptions)
   
})

#
# SessionConnectionsInstaller.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("odbcBundleOsName", function() {
   osMapping <- list (
      linux = "linux",
      windows = "windows",
      darwin = "osx"
   )
   
   if (!tolower(Sys.info()["sysname"]) %in% names(osMapping))
      stop("Operating system \"", Sys.info()["sysname"], "\" is unsupported.")
   
   osMapping[[tolower(Sys.info()[["sysname"]])]]
})

.rs.addFunction("odbcOsBitness", function() {
   if (grepl("64", Sys.info()["machine"])) {
      "64"
   }
   else {
      "32"
   }
})

.rs.addFunction("odbcIsWow", function() {
   identical(tolower(Sys.info()["sysname"])[[1]], "windows") &&
      identical(.rs.odbcOsBitness(), "32") &&
      nchar(Sys.getenv("ProgramW6432")) > 0
})

.rs.addFunction("odbcBundleName", function(placeholder) {
   osName <- .rs.odbcBundleOsName()
   bitness <- .rs.odbcOsBitness()
   
   bundleName <- gsub("\\(os\\)", osName, placeholder)
   bundleName <- gsub("\\(bitness\\)", bitness, bundleName)
   
   bundleName
})

.rs.addFunction("odbcBundleDownload", function(url, placeholder, bundleTemp) {
   bundleName <- .rs.odbcBundleName(placeholder)
   bundleUrl <- file.path(url, bundleName)
   
   if (exists(bundleTemp)) unlink(bundleTemp, recursive = TRUE)
   dir.create(bundleTemp, recursive = TRUE)
   
   bundleFileTemp <- file.path(bundleTemp, bundleName)
   download.file(bundleUrl, bundleFileTemp)
   
   bundleFileTemp
})

.rs.addFunction("odbcBundleExtract", function(bundleFileTemp, installPath) {
   untar(bundleFileTemp, exdir = installPath)
})

.rs.addFunction("odbcBundleCheckPrereqsUnixodbc", function() {
   identical(
      suppressWarnings(
         system2(
            "odbcinst",
            stdout = getOption("odbc.installer.verbose", FALSE),
            stderr = getOption("odbc.installer.verbose", FALSE)
         )
      ),
      1L
   )
})

.rs.addFunction("odbcBundleCheckPrereqsBrew", function() {
   identical(
      suppressWarnings(
         system2(
            "brew",
            stdout = getOption("odbc.installer.verbose", FALSE),
            stderr = getOption("odbc.installer.verbose", FALSE)
         )
      ),
      1L
   )
})

.rs.addFunction("odbcBundleCheckPrereqsOsx", function() {
   if (!.rs.odbcBundleCheckPrereqsUnixodbc()) {
      if (!.rs.odbcBundleCheckPrereqsBrew()) {
         stop(
            "unixODBC is required but missing, you can install from http://www.unixodbc.org/. ",
            "Alternatively, install Brew and RStudio will install unixODBC automatically, ",
            "you can install Brew by running: ",
            "/usr/bin/ruby -e \"$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/install)\""
         )
      }
      
      message("Installing unixODBC...")
      system2(
         "brew",
         args = list("install", "unixodbc")
      )
   }
   
   if (!.rs.odbcBundleCheckPrereqsUnixodbc())
      stop("Failed to install unixODBC, please install from www.unixodbc.org")
})

.rs.addFunction("odbcBundleCheckPrereqsLinux", function() {
   if (!.rs.odbcBundleCheckPrereqsUnixodbc())
      stop("unixODBC is not installed, please install from www.unixodbc.org")
})

.rs.addFunction("odbcBundleRegistryAdd", function(entries) {
   validateEntry <- function(entry) {
      tryCatch({
         verify <- readRegistry(entry$path, "HLM", view = .rs.odbcOsBitness())
         identical(verify[[entry$key]], entry$value)
      }, error = function(e) {
         FALSE
      })
   }

   odbcFileEscape <- function(value) {
    gsub("\\\\", "\\\\\\\\", value)
   }

   if (all(sapply(entries, function(e) validateEntry(e))))
      return()

   bitness <- .rs.odbcOsBitness()

   allAdded <- TRUE
   for (entry in entries) {
     fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")
     system2(
        "REG",
        args = list(
           "ADD",
           shQuote(fullPath),
           "/v",
           shQuote(entry$key),
           "/t",
           "REG_SZ",
           "/d",
           shQuote(entry$value),
           "/f",
           paste("/reg:", bitness, sep = "")
        ),
        stdout = getOption("odbc.installer.verbose", FALSE),
        stderr = getOption("odbc.installer.verbose", FALSE)
     )

     if (!validateEntry(entry)) {
      allAdded <- FALSE
      break
     }
   }

   if (!allAdded) {
      if (.rs.odbcIsWow()) {
         stop("Failed to install x86 driver in x64 machine, retry running as administrator.")
      }

      message("Could not add registry keys from R, retrying using registry prompt.")
      addReg <- tempfile(fileext = ".reg")

      lineEntries <- sapply(entries, function(entry) {
         fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")
         c(
            paste("[", fullPath, "]", sep = ""),
            paste(
               "\"",
               entry$key,
               "\"=\"",
               odbcFileEscape(entry$value),
               "\"",
               sep = ""
            ),
            ""
         )
      })

      lines <- c(
         "REGEDIT4",
         "",
         lineEntries
      )

      writeLines(lines, addReg)

      message("Waiting for ", addReg, " to be registered.")
      system2(
         "explorer",
         addReg
      )

      allEntriesValid <- function() {
        all(sapply(entries, function(e) validateEntry(e)))
      }

      registryStart <- Sys.time()
      registryWait <- 30
      while (!allEntriesValid() && Sys.time() < registryStart + registryWait) {
         Sys.sleep(1)
         cat(".")
      }

      if (!allEntriesValid()) {
         stop("Failed to add all registry keys using registry file.")
      }
   }
})

.rs.addFunction("odbcBundleRegistryRemove", function(entries) {
   validateEntry <- function(entry) {
      tryCatch({
         regEntry <- readRegistry(entry$path, "HLM", view = .rs.odbcOsBitness())
         if (!is.null(entry$key))
            is.null(regEntry[[entry$key]])
         else
            FALSE
      }, error = function(e) {
         TRUE
      })
   }

   if (all(sapply(entries, function(e) validateEntry(e))))
      return()

   bitness <- .rs.odbcOsBitness()

   for (entry in entries) {
      fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")

      if (!is.null(entry$key)) {
         regArgs <- list(
            "DELETE",
            shQuote(fullPath),
            "/v",
            shQuote(entry$key),
            "/f",
            paste("/reg:", bitness, sep = "")
         )
      }
      else {
         regArgs <- list(
            "DELETE",
            shQuote(fullPath),
            "/f",
            paste("/reg:", bitness, sep = "")
         )
      }

      system2(
         "REG",
         args = regArgs
      )
   }

   if (all(sapply(entries, function(e) validateEntry(e))))
      return()

   addReg <- tempfile(fileext = ".reg")

   lineEntries <- sapply(entries, function(entry) {
      fullPath <- file.path("HKEY_LOCAL_MACHINE", entry$path, fsep = "\\")

      if (is.null(entry$key)) {
         paste("[-", fullPath, "]", sep = "")
      }
      else {
         c(
            paste("[", fullPath, "]", sep = ""),
            paste(
               "\"",
               entry$key,
               "\"=-",
               sep = ""
            ),
            ""
         )
      }
   })

   lines <- c(
      "REGEDIT4",
      "",
      unlist(lineEntries)
   )

   writeLines(lines, addReg)
   system2(
      "explorer",
      addReg
   )
})

.rs.addFunction("odbcBundleRegistryDelete", function(path) {
   system2(
      "REG",
      args = list(
         "DELETE",
         shQuote(path),
         "/f"
      )
   )
   
   identical(ret, 0L)
})

.rs.addFunction("odbcBundleCheckPrereqsWindows", function() {
})

.rs.addFunction("odbcBundleCheckPrereqs", function() {
   osPrereqs <- list(
      osx = .rs.odbcBundleCheckPrereqsOsx,
      windows = .rs.odbcBundleCheckPrereqsWindows,
      linux = .rs.odbcBundleCheckPrereqsLinux
   )
   
   prereqs <- osPrereqs[[.rs.odbcBundleOsName()]]
   prereqs()
})

.rs.addFunction("odbcBundleOdbcinstPathWithOdbcinst", function() {
   config <- system2("odbcinst", "-j", stdout = TRUE)
   odbciniEntry <- config[grepl("odbcinst.ini", config)]
   gsub("^[^/\\\\]*", "", odbciniEntry)
})

.rs.addFunction("odbcBundleOdbcinstPathUseHome", function() {
   normalizePath("~/.odbcinst.ini", mustWork = FALSE)
})

.rs.addFunction("odbcBundleOdbcinstPath", function() {
   osOdbcinstPath <- list(
      osx = .rs.odbcBundleOdbcinstPathWithOdbcinst,
      windows = .rs.odbcBundleOdbcinstPathWithOdbcinst,
      linux = .rs.odbcBundleOdbcinstPathUseHome
   )

   osOdbcinstPath[[.rs.odbcBundleOsName()]]()
})

.rs.addFunction("odbcBundleReadIni", function(odbcinstPath) {

   # return nothing if file doesn't exist
   if (!file.exists(odbcinstPath))
      return(list())

   lines <- readLines(odbcinstPath)
   data <- list()
   
   currentDriver <- "__header__"
   
   for (line in lines) {
      # Is header?
      if (grepl("^ *\\[[^]]+\\] *", line)) {
         currentDriver <- gsub("^ *\\[|\\] *", "", line)
         data[[currentDriver]] <- ""
      }
      else if (!grepl("^ *$", line)) {
         if (identical(data[[currentDriver]], ""))
            data[[currentDriver]] <- line
         else
            data[[currentDriver]] <- c(
               data[[currentDriver]],
               line
            )
      }
   }
   
   data
})

.rs.addFunction("odbcBundleWriteIni", function(odbcinstPath, data) {
   lines <- c()
   for (name in names(data)) {
      lines <- c(
         lines, 
         if (identical(name, "__header__")) 
            ""
         else
            paste("[", name, "]", sep = "")
      )
      
      lines <- c(
         lines,
         unlist(data[[name]]),
         ""
      )
   }
   
   if (is.null(lines)) lines <- c("")

   writeLines(lines, odbcinstPath)
})

.rs.addFunction("odbcOdbcInstLibPath", function() {
   odbcinstLib <- NULL

   odbcinstBin <- Sys.which("odbcinst")
   if (nchar(odbcinstBin) == 0) {
      warning("Could not find path to odbcinst.")
   }
   else {
      odbcinstLink <- Sys.readlink(odbcinstBin)
      if (!is.na(odbcinstLink)) {
         odbcinstBinPath <- normalizePath(file.path(dirname(odbcinstBin), dirname(odbcinstLink)))
         odbcinstLibPath <- normalizePath(file.path(odbcinstBinPath, "..", "lib"))
         odbcinstLib <- dir(odbcinstLibPath, pattern = "libodbcinst.*\\.dylib", full.names = TRUE)[[1]]
      }
   }

   odbcinstLib
})

.rs.addFunction("odbcBundleRegisterLinux", function(name, driverPath, version, installPath) {
   # Find odbcinst.ini file
   odbcinstPath <- .rs.odbcBundleOdbcinstPath()
   
   # Read odbcinst.ini
   odbcinst <- .rs.odbcBundleReadIni(odbcinstPath)
   
   # Set odbcinst.ini entries
   odbcinst[[name]] <- list(
      paste("Driver", "=", driverPath),
      paste("Version", "=", version),
      paste("Installer", "=", "RStudio")
   )
   
   # Write odbcinst.ini
   .rs.odbcBundleWriteIni(odbcinstPath, odbcinst)
})

.rs.addFunction("odbcBundleDriverIniPath", function(driverPath) {
   dir(driverPath, pattern = "rstudio\\..*odbc\\.ini", recursive = TRUE, full.names = T)
})

.rs.addFunction("odbcBundleRegisterOSX", function(name, driverPath, version, installPath) {
   # Update odbcinst.ini
   .rs.odbcBundleRegisterLinux(name, driverPath, version, installPath)

   # Find driver.ini file
   driverIniFile <- .rs.odbcBundleDriverIniPath(installPath)
   
   if (length(driverIniFile) == 0) {
      warning("Could not find '", name, "' driver INI file under: ", installPath)
   }
   else {
      # Read driver.ini
      driverIni <- .rs.odbcBundleReadIni(driverIniFile)

      # In OSX register to use unixODBC
      odbcinstLib <- .rs.odbcOdbcInstLibPath()
      if (!is.null(odbcinstLib)) {
         driverIni[["Driver"]] <- c(
            driverIni[["Driver"]],
            paste("ODBCInstLib", "=", odbcinstLib)
         )
      }
      
      # Write odbcinst.ini
      .rs.odbcBundleWriteIni(driverIniFile, driverIni)
   }
})

.rs.addFunction("odbcBundleRegisterWindows", function(name, driverPath, version, installPath) {
   .rs.odbcBundleRegistryAdd(
      list(
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", "ODBC Drivers", fsep = "\\"),
            key = name,
            value = "installed"
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Driver",
            value = driverPath
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Setup",
            value = driverPath
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Version",
            value = version
         ),
         list(
            path = file.path("SOFTWARE", "ODBC", "ODBCINST.INI", name, fsep = "\\"),
            key = "Installer",
            value = "RStudio"
         )
      )
   )
})

.rs.addFunction("odbcBundleFindDriver", function(name, installPath, libraryPattern) { 
   osExtensions <- list(
      osx = "dylib$",
      windows = "dll$",
      linux = "so$"
   )
   
   osExtension <- osExtensions[[.rs.odbcBundleOsName()]]
   driverName <- .rs.connectionStripRStudioDriver(name)
   
   if (is.null(libraryPattern) || nchar(libraryPattern) == 0) {
      libraryPattern <- paste(
         driverName,
         "[^/\\\\]+\\.",
         osExtension,
         sep = ""
      )
   }

   # apply dynamic patterns
   osName <- .rs.odbcBundleOsName()
   bitness <- .rs.odbcOsBitness()
   libraryPattern <- gsub("\\(os\\)", osName, libraryPattern)
   libraryPattern <- gsub("\\(bitness\\)", bitness, libraryPattern)
   
   allFiles <- dir(installPath, recursive = TRUE, full.names = TRUE)
   driverPath <- allFiles[grepl(libraryPattern, allFiles, ignore.case = TRUE)]

   if (!identical(length(driverPath), 1L))
      stop("Failed to find ", libraryPattern, " inside driver bundle.")
   
   normalizePath(driverPath)
})

.rs.addFunction("odbcBundleRegister", function(name, driverPath, version, installPath) {
   osRegistrations <- list(
      osx = .rs.odbcBundleRegisterOSX,
      windows = .rs.odbcBundleRegisterWindows,
      linux = .rs.odbcBundleRegisterLinux
   )
   
   osRegistration <- osRegistrations[[.rs.odbcBundleOsName()]]
   
   osRegistration(name, driverPath, version, installPath) 
})

.rs.addFunction("odbcBundleValidate", function(bundleFile, md5) {
   if (!is.null(md5) && nchar(md5) > 0) {
      validMd5s <- strsplit(as.character(md5), "[ \n,]+")[[1]]
      bundleMd5 <- tools::md5sum(bundleFile)
      if (!bundleMd5 %in% validMd5s) {
         stop("Failed to validate bundle with signature ", md5, " but got ", bundleMd5, " instead.")
      }
   }
})

.rs.addFunction("odbcBundleInstall", function(
   name,
   url,
   placeholder,
   installPath,
   libraryPattern = NULL,
   md5 = NULL,
   version = "") {

   name <- .rs.connectionStripRStudioDriver(name)
   dir.create(installPath, recursive = TRUE, showWarnings = FALSE)
   installPath <- file.path(
      normalizePath(installPath, mustWork = FALSE),
      tolower(name)
   )
   
   bundleTemp <- tempfile()
   on.exit(unlink(bundleTemp, recursive = TRUE), add = TRUE)

   message("Installing")
   message("  Driver: ", name)
   message("  Version: ", version)
   message("  Path: ", installPath)

   message("Checking prerequisites")
   .rs.odbcBundleCheckPrereqs()
   
   message("Downloading bundle")
   bundleFileTemp <- .rs.odbcBundleDownload(url, placeholder, bundleTemp)

   message("Validating bundle")
   .rs.odbcBundleValidate(bundleFileTemp, md5)
   
   message("Extracting bundle")
   .rs.odbcBundleExtract(bundleFileTemp, installPath)
   
   message("Inspecting driver")
   driverPath <- .rs.odbcBundleFindDriver(name, installPath, libraryPattern)
   
   message("Registering driver")
   .rs.odbcBundleRegister(name, driverPath, version, installPath)

   message("")
   message("Installation complete")

   invisible(NULL)
})

.rs.addFunction("connectionOdbcRStudioDriver", function() {
   " with Posit Driver"
})

.rs.addFunction("connectionStripRStudioDriver", function(connection) {
   gsub(paste(" |", trimws(.rs.connectionOdbcRStudioDriver()), sep = ""), "", connection)
})

#
# SessionSql.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar("sql.defunctConnections", new.env(parent = emptyenv()))

.rs.addJsonRpcHandler("sql_get_completions", function(...)
{
   .rs.sql.getCompletions(...)
})

.rs.addFunction("sql.getCompletions", function(line, conn, ctx)
{
   # extract token
   parts <- .rs.strsplit(line, "\\s+")
   token <- tail(parts, n = 1L)

   # trim out operators
   matches <- gregexpr("[-+*/%&|^=><]", token)[[1]]
   if (!identical(c(matches), -1L))
      token <- substring(token, tail(matches, n = 1L) + 1)
   
   # if we have a '.' in the token, then we're either trying
   # to complete field names from a table, or table names from
   # a schema. use the context keyword to figure out which
   if (grepl(".", token, fixed = TRUE))
   {
      if (.rs.sql.isTableScopedKeyword(ctx$contextKeyword))
         return(.rs.sql.getCompletionsTables(token, conn, ctx))
      else
         return(.rs.sql.getCompletionsFields(token, conn, ctx))
   }
   
   # if we're requesting completions within 'from', we either want
   # schemas or table names
   if (.rs.sql.isTableScopedKeyword(ctx$contextKeyword))
   {
      completions <- Reduce(.rs.appendCompletions, list(
         .rs.sql.getCompletionsTables(token, conn, ctx),
         .rs.sql.getCompletionsSchemas(token, conn, ctx)
      ))
      
      return(completions)
   }
   
   # otherwise, gather completions from other sources
   Reduce(.rs.appendCompletions, list(
      .rs.sql.getCompletionsKeywords(token, conn, ctx),
      .rs.sql.getCompletionsFields(token, conn, ctx),
      .rs.sql.getCompletionsTables(token, conn, ctx),
      .rs.sql.getCompletionsIdentifiers(token, conn, ctx)
   ))
})

.rs.addFunction("sql.getCompletionsKeywords", function(token, conn, ctx)
{
   if (!nzchar(token))
      return(.rs.emptyCompletions(language = "SQL"))
   
   # collect keywords (convert to lowercase to match token when appropriate)
   lowercase <- if (nzchar(token))
      identical(token, tolower(token))
   else
      ctx$preferLowercaseKeywords
    
   keywords <- if (lowercase)
      tolower(.rs.sql.keywords(conn))
   else
      toupper(.rs.sql.keywords(conn))
   
   results <- .rs.selectFuzzyMatches(keywords, token)
   .rs.makeCompletions(
      token = token,
      results = results,
      packages = "keyword",
      type = .rs.acCompletionTypes$KEYWORD,
      language = "SQL"
   )
})

.rs.addFunction("sql.getCompletionsSchemas", function(token, conn, ctx)
{
   conn <- .rs.sql.asDBIConnection(conn)
   if (is.null(conn))
      return(.rs.emptyCompletions(language = "SQL"))
   
   schemas <- .rs.tryCatch(.rs.db.listSchemas(conn))
   if (inherits(schemas, "error"))
      return(.rs.emptyCompletions(language = "SQL"))
   
   schemas <- setdiff(schemas, token)
   
   results <- .rs.selectFuzzyMatches(schemas, token)
   .rs.makeCompletions(
      token = token,
      results = results,
      packages = "schema",
      type = .rs.acCompletionTypes$ENVIRONMENT
   )
})

.rs.addFunction("sql.getCompletionsTables", function(token, conn, ctx)
{
   conn <- .rs.sql.asDBIConnection(conn)
   
   # if we have a '.' in the token, assume that we're attempting to
   # complete table names from a particular schema
   if (grepl(".", token, fixed = TRUE))
   {
      parts  <- .rs.strsplit(token, ".", fixed = TRUE)
      schema <- parts[[1]]
      token  <- parts[[2]]
      
      tables <- .rs.tryCatch(.rs.db.listTables(conn, schema))
      if (inherits(tables, "error"))
         return(.rs.emptyCompletions(language = "SQL"))
      
      results <- .rs.selectFuzzyMatches(tables, token)
      completions <- .rs.makeCompletions(
         token = token,
         results = results,
         packages = "table",
         type = .rs.acCompletionTypes$DATAFRAME
      )
      
      return(completions)
   }
   
   # use context-completed tables by default
   tables <- as.character(ctx$tables)
   
   # attempt to derive table names from connection
   if (!is.null(conn))
   {
      listedTables <- .rs.sql.listTables(conn)
      if (length(listedTables))
         tables <- listedTables
   }
   
   # add in alias names since the user might want to use those in lieu
   # of the 'real' table name in certain contexts
   tables <- c(tables, names(ctx$aliases))
   
   # remove current token as candidate
   tables <- setdiff(tables, token)
   
   results <- .rs.selectFuzzyMatches(tables, token)
   .rs.makeCompletions(
      token = token,
      results = results,
      packages = "table",
      type = .rs.acCompletionTypes$DATAFRAME
   )
})

.rs.addFunction("sql.getCompletionsFields", function(token, conn, ctx)
{
   conn <- .rs.sql.asDBIConnection(conn)
   if (is.null(conn))
      return(.rs.emptyCompletions(language = "SQL"))
   
   # if we have a '.' in the token, then only retrieve
   # completions from the requested table
   tables <- ctx$tables
   if (grepl(".", token, fixed = TRUE))
   {
      parts <- .rs.strsplit(token, ".", fixed = TRUE)
      tables <- parts[[length(parts) - 1]]
      token  <- parts[[length(parts) - 0]]
   }
   
   Reduce(.rs.appendCompletions, lapply(tables, function(table) {
      
      # if this table is an alias, find the 'true' table name
      if (table %in% names(ctx$aliases))
         table <- ctx$aliases[[table]]
      
      # if we know the schema associated with this table, then use it
      schema <- ctx$schemas[[match(table, ctx$tables)]]
      
      # retireve fields
      fields <- .rs.tryCatch(.rs.db.listFields(conn, schema = schema, table = table))
      if (inherits(fields, "error"))
         return(.rs.emptyCompletions(language = "SQL"))
      
      fields <- setdiff(fields, token)
      
      .rs.makeCompletions(
         token = token,
         results = .rs.selectFuzzyMatches(fields, token),
         packages = table,
         type = .rs.acCompletionTypes$DATASET
      )
      
   }))
   
})

.rs.addFunction("sql.getCompletionsIdentifiers", function(token, conn, ctx)
{
   identifiers <- setdiff(as.character(ctx$identifiers), token)
   results <- .rs.selectFuzzyMatches(identifiers, token)
   .rs.makeCompletions(
      token = token,
      results = results,
      type = .rs.acCompletionTypes$CONTEXT,
      language = "SQL"
   )
})

.rs.addFunction("sql.listTables", function(conn)
{
   conn <- .rs.sql.asDBIConnection(conn)
   if (is.null(conn))
      return(character())
   
   # purge any disconnected connections (avoid keeping a live reference)
   keys <- ls(envir = .rs.sql.defunctConnections)
   for (key in keys)
      if (!DBI::dbIsValid(.rs.sql.defunctConnections[[key]]))
         rm(key, envir = .rs.sql.defunctConnections)
   
   # if the user has opted out of completions altogether
   # then just use context completions
   timeout <- as.numeric(getOption("sql.completion.timeout", 2))
   if (timeout == 0)
      return(character())
   
   # check and see whether we've marked the connection as defunct
   id <- digest::digest(conn)
   if (!is.null(.rs.sql.defunctConnections[[id]]))
      return(character())
   
   # request completions; if we take too long then mark the connection as 
   # defunct to avoid further attempts to get completions
   time <- system.time(tables <- .rs.tryCatch(DBI::dbListTables(conn)))
   if (time[["user.self"]] > timeout)
   {
      .rs.sql.defunctConnections[[id]] <- conn
      return(character())
   }
   
   # we got completions in time; use them
   if (inherits(tables, "error"))
      return(character())
   
   tables
})

.rs.addFunction("sql.keywords", function(conn)
{
   # allow users to define their own set of keywords if preferred
   keywords <- getOption("sql.keywords")
   if (is.function(keywords))
   {
      if (length(formals(keywords)))
         return(keywords(conn))
      else
         return(keywords())
   }
   else if (is.character(keywords))
   {
      return(keywords)
   }
   
   if ("DBI" %in% loadedNamespaces()) {
      DBI <- asNamespace("DBI")
      keywords <- DBI$.SQL92Keywords
      if (is.character(keywords))
         return(keywords)
   }
   
   # NOTE: these are the keywords understood by SQLite, as per
   # https://www.sqlite.org/lang_keywords.html
   c(
      "ABORT", "ACTION", "ADD", "AFTER", "ALL", "ALTER", "ANALYZE", "AND",
      "AS", "ASC", "ATTACH", "AUTOINCREMENT", "BEFORE", "BEGIN", "BETWEEN",
      "BY", "CASCADE", "CASE", "CAST", "CHECK", "COLLATE", "COLUMN", "COMMIT",
      "CONFLICT", "CONSTRAINT", "CREATE", "CROSS", "CURRENT_DATE", "CURRENT_TIME",
      "CURRENT_TIMESTAMP", "DATABASE", "DEFAULT", "DEFERRABLE", "DEFERRED",
      "DELETE", "DESC", "DETACH", "DISTINCT", "DROP", "EACH", "ELSE", "END",
      "ESCAPE", "EXCEPT", "EXCLUSIVE", "EXISTS", "EXPLAIN", "FAIL", "FOR",
      "FOREIGN", "FROM", "FULL", "GLOB", "GROUP", "HAVING", "IF", "IGNORE",
      "IMMEDIATE", "IN", "INDEX", "INDEXED", "INITIALLY", "INNER", "INSERT",
      "INSTEAD", "INTERSECT", "INTO", "IS", "ISNULL", "JOIN", "KEY", "LEFT",
      "LIKE", "LIMIT", "MATCH", "NATURAL", "NO", "NOT", "NOTNULL", "NULL", "OF",
      "OFFSET", "ON", "OR", "ORDER", "OUTER", "PLAN", "PRAGMA", "PRIMARY", "QUERY",
      "RAISE", "RECURSIVE", "REFERENCES", "REGEXP", "REINDEX", "RELEASE", "RENAME",
      "REPLACE", "RESTRICT", "RIGHT", "ROLLBACK", "ROW", "SAVEPOINT", "SELECT",
      "SET", "TABLE", "TEMP", "TEMPORARY", "THEN", "TO", "TRANSACTION", "TRIGGER",
      "UNION", "UNIQUE", "UPDATE", "USING", "VACUUM", "VALUES", "VIEW", "VIRTUAL",
      "WHEN", "WHERE", "WITH", "WITHOUT"
   )
})

.rs.addFunction("sql.asDBIConnection", function(conn)
{
   if (inherits(conn, "DBIConnection"))
      return(conn)

   if (is.character(conn))
   {
      if (!requireNamespace("DBI", quietly = TRUE))
         return(NULL)

      # parse the connection expression (strip srcref so equivalent
      # expressions compare equal against the permitted set)
      expr <- .rs.tryCatch(parse(text = conn, keep.source = FALSE))
      if (inherits(expr, "error") || length(expr) != 1L)
         return(NULL)
      expr <- expr[[1L]]

      # completions must never evaluate arbitrary connection expressions; only
      # statically-safe or explicitly-permitted expressions are resolved here,
      # and we never prompt from this (silent, as-you-type) code path. The
      # classifier itself lives in SessionDataPreview.R (.rs.preview.*).
      if (identical(.rs.preview.exprStatus(expr), "unsafe"))
         return(NULL)

      conn <- .rs.tryCatch(eval(expr, envir = globalenv()))
      if (inherits(conn, "error"))
         return(NULL)
   }

   conn
})

.rs.addFunction("db.listFields", function(conn, schema = NULL, table = NULL)
{
   if (length(schema) && nzchar(schema))
   {
      # work around an issue in odbc when attempting to list fields using a qualified ID
      if ("odbc" %in% loadedNamespaces() && inherits(conn, "OdbcConnection"))
      {
         columns <- odbc:::connection_sql_columns(
            conn@ptr,
            schema_name = schema,
            table_name = table
         )
         return(columns[["name"]])
      }
      
      # otherwise, use the regular DBI interface
      return(DBI::dbListFields(conn, DBI::Id(schema = schema, table = table)))
   }
   
   # no schema: just use the regular API
   DBI::dbListFields(conn, table)
})

.rs.addFunction("db.listSchemas", function(conn)
{
   # work around issue in odbc where schema names are not returned as part
   # of DBI::dbListObjects()
   if ("odbc" %in% loadedNamespaces() && inherits(conn, "OdbcConnection"))
   {
      objects <- odbc::odbcListObjects(conn)
      return(objects$name[objects$type == "schema"])
   }
   
   objects <- DBI::dbListObjects(conn)
   items <- Filter(function(x) "schema" %in% names(x@name), objects$table)
   schemas <- vapply(items, function(item) item@name[["schema"]],  character(1))
   
   # for RSQLite connections, also list databases
   if ("RSQLite" %in% loadedNamespaces() && inherits(conn, "SQLiteConnection"))
   {
      databases <- DBI::dbGetQuery(conn, "PRAGMA database_list;")
      schemas <- unique(c(databases$name, schemas))
   }
   
   schemas
})

.rs.addFunction("db.listTables", function(conn, schema = NULL)
{
   # work around issue in odbc where requests for table names
   # fail when a schema is specified
   if ("odbc" %in% loadedNamespaces() && inherits(conn, "OdbcConnection"))
      return(odbc::dbListTables(conn, schema = schema))
   
   objects <- DBI::dbListObjects(conn, DBI::Id(schema = schema))
   vapply(objects$table, function(object) tail(object@name, n = 1), character(1))
})

.rs.addFunction("sql.isTableScopedKeyword", function(keyword) {
   keyword %in% c("from", "into", "join", "update", "drop")
})

library(testthat)

runTests <- function(testDir = NULL, outputDir = NULL, filter = NULL) {

   options(rstudio.tests.running = TRUE)
   on.exit(options(rstudio.tests.running = FALSE), add = TRUE)

   # Disable ANSI escape codes in CI environments so that test output
   # is plain text in build logs.
   if (nzchar(Sys.getenv("JENKINS_URL")) || nzchar(Sys.getenv("CI")))
   {
      Sys.setenv(NO_COLOR = "1")
      options(cli.num_colors = 1)
   }

   "%||%" <- function(x, y) if (is.null(x)) y else x

   # print R information
   writeLines("# R version ----")
   print(R.version)
   writeLines("")

   # print out system information
   writeLines("# System information ----")
   info <- as.list(Sys.info())
   str(info)
   writeLines("")
   
   # print locale information
   writeLines("# Locale ----")
   writeLines(Sys.getlocale())
   writeLines("")

   # print library paths
   writeLines("# Library paths ----")
   writeLines(paste("-", .libPaths(), collapse = "\n"))
   writeLines("")

   testDir   <- testDir   %||% Sys.getenv("TESTTHAT_TESTS_DIR",  unset = NA)
   outputDir <- outputDir %||% Sys.getenv("TESTTHAT_OUTPUT_DIR", unset = NA)
   filter    <- filter    %||% Sys.getenv("TESTTHAT_FILTER",     unset = "")
   
   # run tests
   results <- testthat::test_dir(
      path            = testDir,
      filter          = filter,
      stop_on_failure = FALSE,
      stop_on_warning = FALSE
   )
   
   # compute number of failures
   df <- as.data.frame(results)
   failures <- sum(df$failed)
   
   # write to file
   cat(failures, file = file.path(outputDir, "testthat-failures.log"))
   
}

#
# SessionNotebookRender.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#
# Renders an R Notebook .nb.html file from its chunk output cache.
# Designed to run in a child R process via AsyncRProcess in augmented mode
# (Tools.R is sourced first, providing .rs.addFunction and other helpers).
#
# This file is sourced after SessionRmdNotebook.R (which provides the
# .rs.rnb.* rendering functions), so that the overrides defined here take
# precedence over functions that rely on .Call() native methods which are
# unavailable in the child process.
#
# Parameters are passed via environment variables:
#   RS_NB_RMD_PATH     -- absolute path to the .Rmd file
#   RS_NB_CACHE_PATH   -- absolute path to the chunk cache directory
#   RS_NB_OUTPUT_PATH  -- absolute path for the .nb.html output
#   RS_NB_ENCODING     -- file encoding (e.g. "UTF-8")
#   RS_NB_INLINE_CACHE -- path to an .rds file of inline chunk outputs
#                         computed by the parent session (empty or unset
#                         means inline code is evaluated in this process)
#

# --- Override / define functions not available in augmented mode -----------

# .rs.trimWhitespace is defined in SessionCodeTools.R (not sourced here)
.rs.addFunction("trimWhitespace", function(x)
{
   gsub("^[\\s\\n]+|[\\s\\n]+$", "", x, perl = TRUE)
})

# .rs.readLines uses .Call("rs_readLines") -- replace with base R
.rs.addFunction("readLines", function(filePath)
{
   readLines(path.expand(filePath), warn = FALSE)
})

# .rs.fromJSON uses .Call("rs_fromJSON") -- replace with jsonlite
.rs.addFunction("fromJSON", function(string)
{
   jsonlite::fromJSON(string, simplifyVector = FALSE)
})

# .rs.base64encode uses .Call("rs_base64encode") -- replace with pure R impl
.rs.addFunction("base64encode", function(data, binary = FALSE)
{
   if (is.character(data))
      data <- charToRaw(data)
   .rs.rBase64Encode(data)
})

# .rs.scalar is defined in ModuleTools.R which isn't sourced in augmented mode
.rs.addFunction("scalar", function(obj)
{
   if (!is.null(obj))
      class(obj) <- "rs.scalar"
   obj
})

# .rs.rnb.cachePathFromRmdPath uses .Call("rs_chunkCacheFolder") --
# we receive the cache path from C++ via environment variable
.rs.addFunction("rnb.cachePathFromRmdPath", function(rmdPath)
{
   Sys.getenv("RS_NB_CACHE_PATH")
})

# .rs.getSourceDocumentProperties uses .Call("rs_getDocumentProperties") --
# we receive the encoding from C++ via environment variable
.rs.addFunction("getSourceDocumentProperties", function(path, includeContents = FALSE)
{
   list(encoding = Sys.getenv("RS_NB_ENCODING", unset = "UTF-8"))
})

# --- Define helpers from SessionCodeTools.R needed by SessionRmdNotebook.R ---

.rs.addFunction("enumerate", function(X, FUN, ...)
{
   keys <- if (is.environment(X))
      sort(ls(envir = X))
   else
      names(X)

   result <- lapply(keys, function(key) {
      FUN(key, X[[key]], ...)
   })
   names(result) <- keys
   result
})

.rs.addFunction("cutpoints", function(data)
{
   diffed <- diff(c(data[1], data))
   which(diffed != 0)
})

# --- Define .rs.readDataCapture from NotebookData.R -----------------------
# NOTE: readDataCapture and formatDataCapture are duplicated from
# NotebookData.R because that file depends on .Call() methods unavailable
# in the child process. Keep in sync with the canonical implementations
# if the formatting logic changes.

.rs.addFunction("readDataCapture", function(path)
{
   envir <- new.env(parent = emptyenv())
   load(path, envir = envir)

   # modern caches store a pre-formatted 'result'
   result <- envir[["result"]]
   if (!is.null(result))
      return(result)

   # fallback for old caches: format on the fly
   data <- envir[["x"]]
   options <- envir[["options"]]
   .rs.formatDataCapture(data, options)
})

.rs.addFunction("formatDataCapture", function(data, options)
{
   type_sum <- function(x) {
      format_sum <- switch(class(x)[[1]],
         ordered = "ord",
         factor = "fctr",
         POSIXt = "dttm",
         difftime = "time",
         Date = "date",
         data.frame = class(x)[[1]],
         tbl_df = "tibble",
         NULL
      )
      if (!is.null(format_sum)) {
         format_sum
      } else if (!is.object(x)) {
         switch(typeof(x),
            logical = "lgl",
            integer = "int",
            double = "dbl",
            character = "chr",
            complex = "cplx",
            closure = "fun",
            environment = "env",
            typeof(x)
         )
      } else if (!isS4(x)) {
         paste0("S3: ", class(x)[[1]])
      } else {
         paste0("S4: ", methods::is(x)[[1]])
      }
   }

   size_sum <- function(x) {
      dim <- dim(x) %||% length(x)
      format_dim <- vapply(dim, function(d) {
         mark <- if (identical(getOption("OutDec"), ",")) "." else ","
         formatC(d, big.mark = mark)
      }, character(1))
      format_dim[is.na(dim)] <- "??"
      paste0(" [", paste0(format_dim, collapse = " \u00d7 "), "]")
   }

   `%||%` <- function(x, y) if (is.null(x)) y else x

   is_list_not_vctrs <- function(x) is.list(x) && !inherits(x, "vctrs_vctr")

   obj_sum <- function(x) {
      switch(class(x)[[1]],
         POSIXlt = rep("POSIXlt", length(x)),
         list = vapply(x, function(el) paste0(type_sum(el), size_sum(el)), character(1L)),
         paste0(type_sum(x), size_sum(x))
      )
   }

   columnNames <- names(data)
   columnSequence <- seq_len(ncol(data))

   columns <- lapply(columnSequence, function(columnIdx) {
      column <- data[[columnIdx]]
      baseType <- class(column)[[1]]
      tibbleType <- type_sum(column)
      list(
         label = if (!is.null(columnNames)) columnNames[[columnIdx]] else "",
         name = columnIdx,
         type = tibbleType,
         align = if (baseType == "character" || baseType == "factor") "left" else "right"
      )
   })

   addRowNames <- isTRUE(options[["rownames.print"]])
   if (addRowNames) {
      columns <- c(
         list(list(label = "", name = "_rn_", type = "", align = "left")),
         columns
      )
      data$`_rn_` <- rownames(data)
   }

   names(data) <- as.character(columnSequence)
   columns <- unname(columns)

   is_list <- vapply(data, is_list_not_vctrs, logical(1))
   data[is_list] <- lapply(data[is_list], function(x) {
      paste0("<", obj_sum(x), ">")
   })

   values <- lapply(data, function(y) {
      if (length(y) == 0) return(character())
      if (typeof(y) == "character") y[y == "NA"] <- "__NA__"
      y <- encodeString(format(y))
      gsub("^\\s+|\\s+$", "", y)
   })

   data <- as.data.frame(values, stringsAsFactors = FALSE, optional = TRUE)

   pagedTableOptions <- list(
      columns = list(
         min = options[["cols.min.print"]],
         max = if (is.null(options[["cols.print"]])) 10 else options[["cols.print"]],
         total = options[["cols.total"]]
      ),
      rows = list(
         min = if (is.null(options[["rows.print"]])) 10 else options[["rows.print"]],
         max = if (is.null(options[["rows.print"]])) 10 else options[["rows.print"]],
         total = options[["rows.total"]]
      ),
      pages = options[["pages.print"]]
   )

   list(
      columns = columns,
      data = if (length(data) == 0) list() else data,
      options = pagedTableOptions
   )
})

# --- Main render (after SessionRmdNotebook.R is sourced) ------------------

.rs.addFunction("renderNotebookAsync", function()
{
   rmdPath    <- Sys.getenv("RS_NB_RMD_PATH")
   outputPath <- Sys.getenv("RS_NB_OUTPUT_PATH")

   if (nchar(rmdPath) == 0 || nchar(outputPath) == 0)
      stop("RS_NB_RMD_PATH and RS_NB_OUTPUT_PATH must be set")

   inlinePath <- Sys.getenv("RS_NB_INLINE_CACHE")
   if (nzchar(inlinePath) && file.exists(inlinePath))
   {
      # failure to install inline outputs is not fatal -- the render proceeds
      # with inline chunks evaluated in this process -- but that fallback can
      # produce different results since the user's global environment is not
      # visible here. emit a marker on stdout so the parent can log the
      # failure even when the render itself succeeds.
      tryCatch(
         .rs.rnb.installInlineOutputs(inlinePath),
         error = function(e) {
            msg <- gsub("\\s+", " ", conditionMessage(e))
            cat(sprintf("__INLINE_CACHE_ERROR__:%s\n", msg))
         }
      )
   }

   tryCatch({
      cachePath <- .rs.rnb.cachePathFromRmdPath(rmdPath)
      rnbData <- .rs.readRnbCache(rmdPath, cachePath)

      # render to a temp file in the same directory, then atomically
      # move into place to avoid partial reads by other processes
      outputDir <- dirname(outputPath)
      tmpPath <- tempfile(tmpdir = outputDir, fileext = ".nb.html")
      on.exit(unlink(tmpPath), add = TRUE)
      .rs.createNotebookFromCacheData(rnbData, rmdPath, tmpPath)
      if (!file.rename(tmpPath, outputPath))
      {
         # rename can fail if the destination is locked; fall back to copy
         if (!file.copy(tmpPath, outputPath, overwrite = TRUE))
            stop("Failed to write notebook output to '", outputPath, "'")
      }
      cat("__RENDER_SUCCESS__\n")
   }, error = function(e) {
      msg <- tryCatch(
         jsonlite::toJSON(list(error = e$message), auto_unbox = TRUE),
         error = function(e2) e$message
      )
      cat(paste0("__RENDER_ERROR__:", msg, "\n"))
      quit(save = "no", status = 1)
   })
})

args <- commandArgs(TRUE)

# Put the path containing the C compiler on the PATH.
Sys.setenv(PATH = paste(dirname(args[1]), Sys.getenv("PATH"), sep = ";"))

# Find R DLLs.
dlls <- list.files(R.home("bin"), pattern = "dll$", full.names = TRUE)

message("Generating .lib files for DLLs in ", R.home("bin"))

# Generate corresponding 'lib' file for each DLL.
for (dll in dlls) {
   
   # check to see if we've already generated our exports
   def <- sub("dll$", "def", dll)
   if (file.exists(def))
      next
   
   # Call it on R.dll to generate exports.
   command <- sprintf("dumpbin.exe /EXPORTS /NOLOGO %s", dll)
   message("> ", command)
   output <- system(paste(command), intern = TRUE)
   
   # Remove synonyms.
   output <- sub("=.*$", "", output)
   
   # Find start, end markers
   start <- grep("ordinal\\s+hint\\s+RVA\\s+name", output)
   end <- grep("^\\s*Summary\\s*$", output)
   contents <- output[start:(end - 1)]
   contents <- contents[nzchar(contents)]
   
   # Remove forwarded fields
   contents <- grep("forwarded to", contents, invert = TRUE, value = TRUE, fixed = TRUE)
   
   # parse into a table
   tbl <- read.table(text = contents, header = TRUE, stringsAsFactors = FALSE)
   exports <- tbl$name
   
   # sort and re-format exports
   exports <- sort(exports)
   exports <- c("EXPORTS", paste("\t", tbl$name, sep = ""))
   
   # Write the exports to a def file
   def <- sub("dll$", "def", dll)
   cat(exports, file = def, sep = "\n")
   
   # Call 'lib.exe' to generate the library file.
   outfile <- sub("dll$", "lib", dll)
   fmt <- "lib.exe /def:%s /out:%s /machine:%s"
   cmd <- sprintf(fmt, def, outfile, .Platform$r_arch)
   system(cmd)
   
}

#
# SessionCodeTools.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("discover_package_dependencies", function(docId, fileType)
{
   available <- .rs.availablePackages()
   ready <- !is.null(available$value)
   packages <- .rs.discoverPackageDependencies(docId, fileType)
   list(ready = .rs.scalar(ready), packages = packages)
})

.rs.addFunction("stopf", function(fmt, ..., call. = FALSE)
{
   msg <- sprintf(fmt, ...)
   stop(msg, call. = call.)
})

.rs.addFunction("error", function(...)
{
   list(
      result  = NULL,
      message = .rs.scalar(paste(..., sep = ""))
   )
})

.rs.addFunction("success", function(result = NULL)
{
   list(
      result  = result,
      message = NULL
   )
})

.rs.addFunction("withTimeLimit", function(seconds,
                                          expr,
                                          fail = NULL)
{
   setTimeLimit(elapsed = seconds, transient = TRUE)
   on.exit(setTimeLimit(), add = TRUE)
   tryCatch(expr, error = function(e) fail)
})

# Return the scope names in which the given names exist
.rs.addFunction("which", function(names) {
   scopes = search()
   sapply(names, function(name) {
      for (scope in scopes) {
         if (exists(name, where=scope, inherits=F))
            return(scope)
      }
      return("")
   })
})

.rs.addFunction("surround", function(string, with)
{
   paste(with, string, with, sep = "")
})

.rs.addFunction("guessToken", function(line, cursorPos)
{
   utils:::.assignLinebuffer(line)
   utils:::.assignEnd(cursorPos)
   utils:::.guessTokenFromLine()
})

.rs.addFunction("findFunctionNamespace", function(name, fromWhere)
{
   if (!identical(fromWhere, ""))
   {
      if ( ! (fromWhere %in% search()) )
         return ("")

      where = as.environment(fromWhere)
   }
   else
   {
      where = globalenv()
   }

   envList <- methods:::findFunction(name, where = where)
   if (length(envList) > 0)
   {
      env <- envList[[1]]
      if (identical(env, baseenv()))
      {
         return ("package:base")
      }
      else if (identical(env, globalenv()))
      {
         return(".GlobalEnv")
      }
      else
      {
         envName = attr(envList[[1]], "name")
         if (!is.null(envName))
            return (envName)
         else
            return ("")
      }
   }
   else
   {
      return ("")
   }
})

.rs.addFunction("getFunction", function(name, envir = globalenv())
{
   tryCatch(
      .rs.getFunctionImpl(name, envir),
      error = function(e) NULL
   )
})

.rs.addFunction("getFunctionImpl", function(name, envir = globalenv())
{
   envir <- .rs.resolveEnvironment(envir)
   parsed <- parse(text = name)[[1L]]

   # for plain symbols, we can attempt lookup of a function object
   # directly; for more complex calls, we try to evaluate it in
   # the requested environment and hope we got a function
   fn <- if (is.symbol(parsed))
      get(name, envir = envir, mode = "function")
   else
      eval(parsed, envir = envir)

   if (!is.function(fn))
      return(NULL)

   fn
})


.rs.addFunction("functionHasSrcRef", function(func)
{
   !is.null(attr(func, "srcref"))
})

.rs.addFunction("parseSrcref", function(srcref)
{
   srcref <- as.list(unclass(srcref))
   
   # From ?srcref:
   #
   # Bytes (elements 2, 4) and columns (elements 5, 6) may be different due to
   # multibyte characters. If only four values are given, the columns and bytes
   # are assumed to match. Lines (elements 1, 3) and parsed lines (elements 7,
   # 8) may differ if a #line directive is used in code: the former will respect
   # the directive, the latter will just count lines. If only 4 or 6 elements
   # are given, the parsed lines will be assumed to match the lines.
   srcref <- if (length(srcref) == 4L)
   {
      c(srcref, srcref[c(2L, 4L, 1L, 3L)])
   }
   else if (length(srcref) == 6L)
   {
      c(srcref, srcref[c(1L, 3L)])
   }
   else
   {
      srcref
   }
   
   names(srcref) <- c(
      "first_line", "first_byte",
      "last_line", "last_byte",
      "first_column", "last_column",
      "first_parsed", "last_parsed"
   )
   
   as.list(srcref)
})

.rs.addFunction("readSrcrefLines", function(srcref, asString)
{
   # Try to retrieve source references from srcfile if available
   srcfile <- attr(srcref, "srcfile", exact = TRUE)
   filename <- srcfile$filename
   if (!is.null(srcfile$original))
      srcfile <- srcfile$original
   
   # It appears the 'lines' variable can either be a single string
   # with embedded newlines, or a character vector already split by newlines.
   # Normalize here so that we're always working with a split-by-newline vector.
   lines <- srcfile$lines
   if (length(lines) == 1L && grepl("\n", lines[[1L]], fixed = TRUE))
      lines <- unlist(strsplit(lines, "\n", fixed = TRUE))
   
   # For packages installed with '--with-keep.source', it appears that
   # the source references for all files within the package are collected
   # into a single file, with each file given a header of the form:
   #
   #    #line 1 "<filename>"
   #
   # The source references are given relative to those file contents,
   # so try to pull out the text content of only that file.
   #
   # In theory, R supports referencing arbitrary lines within a file;
   # in practice, whole files appear to be included?
   #
   # https://github.com/wch/r-source/blob/1bd4a842dac421b68b7a999de8342f131ce8387f/src/library/tools/src/install.c#L158-L159
   #
   if (length(filename) && nzchar(filename))
   {
      header <- sprintf("#line 1 \"%s\"", filename)
      index <- which(lines == header)
      if (length(index))
      {
         lines <- tail(lines, n = -index)
         boundaries <- c(
            grep("^#line 1 \"", lines),
            length(lines) + 1L
         )
         lines <- head(lines, n = boundaries[[1L]] - 1)
      }
   }
   
   if (asString)
      paste(lines, collapse = "\n")
   else
      lines
})

.rs.addFunction("deparseCall", function(call)
{
   srcref <- attr(call, "srcref", exact = TRUE)
   if (!is.null(srcref))
      return(as.character.srcref(srcref))
   
   deparse(call)
})

.rs.addFunction("deparseSrcref", function(srcref, asString)
{
   # Try to retrieve source references from srcfile if available
   srcfile <- attr(srcref, "srcfile", exact = TRUE)
   if (!is.null(srcfile$original))
      srcfile <- srcfile$original
   
   # It appears the 'lines' variable can either be a single string
   # with embedded newlines, or a character vector already split by newlines.
   # Normalize here so that we're always working with a split-by-newline vector.
   lines <- srcfile$lines
   if (length(lines) == 1L && grepl("\n", lines[[1L]], fixed = TRUE))
      lines <- unlist(strsplit(lines, "\n", fixed = TRUE))
   
   # We previously used 'as.character(srcref, useSource = TRUE)' by default, but
   # this also trims the leading indent from the function definition. This
   # causes issues when highlighting the first part of a source reference, as
   # the expectation here is that the full line is preserved. For that reason,
   # if we're able to, we keep all relevant lines from the source reference.
   code <- if (is.character(lines))
   {
      srcpos <- .rs.parseSrcref(srcref)
      range <- if (inherits(srcfile, c("srcfilecopy", "srcfilealias")))
      {
         seq(from = srcpos$first_parsed, to = srcpos$last_parsed)
      }
      else
      {
         seq(from = srcpos$first_line, to = srcpos$last_line)
      }

      lines[range]
   }
   else
   {
      as.character(srcref, useSource = TRUE)
   }
   
   if (asString)
   {
      code <- paste(code, collapse = "\n")
   }
   
   code
})

# Returns a function's code as a string. Arguments:
# useSource -- Whether to use the function's source references (if available)
# asString -- Whether to return the result as a single string
#             (otherwise a character vector of lines is returned)
.rs.addFunction("deparseFunction", function(func, useSource, asString)
{
   # If we're being asked to return the source references as-is, read the source
   # references directly instead of going through deparse (which has a known
   # issue that corrupts output with backslashes in R 4.0.0 and perhaps other
   # versions; see R bug 17800).
   if (useSource)
   {
      srcref <- attr(func, "srcref", exact = TRUE)
      if (!is.null(srcref))
         return(.rs.deparseSrcref(srcref, asString))
   }

   control <- c("keepInteger", "keepNA")
   if (useSource)
     control <- append(control, "useSource")

   code <- deparse(func, width.cutoff = 59, control = control)

   # if we were asked not to use source refs, or we were but there wasn't a
   # source ref to use, then format the code according to user pref
   if (!useSource || is.null(attr(func, "srcref", exact = TRUE)))
   {
     replaceText <- "\t"

     # determine the replacement text based on the user's current editing
     # preferences
     if (isTRUE(.rs.readUiPref("use_spaces_for_tab")))
     {
       replaceText <- paste(rep(" ", .rs.readUiPref("num_spaces_for_tab")),
                                collapse = "")
     }

     # split the code into individual lines -- R's immutable strings make it
     # quicker to process these small chunks than on the whole code text
     lines <- unlist(strsplit(code, "\n", fixed = TRUE))
     for (l in seq_along(lines))
     {
       line <- lines[[l]]
       pos <- 1
       # convert up to 20 indentation levels per line
       for (lvl in seq_len(20))
       {
         # NOTE: the 4 spaces comes from the implementation of printtab2buff in
         # deparse.c -- it is hard-coded to use 4 spaces for the first 4 levels
         # of indentation and then 2 spaces for subsequent levels.
         indent <- if (lvl <= 4) "    " else "  "
         if (substring(line, pos, pos + (nchar(indent) - 1)) == indent)
         {
           # convert this indent to the user's preferred indentation
           line <- paste(substring(line, 0, pos - 1),
                         replaceText,
                         substring(line, pos + nchar(indent)),
                         sep = "")
           pos <- pos + nchar(replaceText)
         }
         else
         {
           # no more indents we want to convert on this line
           break
         }
       }
       lines[[l]] <- line
     }

     # if we were asked to return individual lines, we're done now
     if (!asString)
       return(lines)
     else
       code <- lines
   }

   # return (possibly formatted) code
   if (asString)
     paste(code, collapse = "\n")
   else
     code
})

.rs.addFunction("isS3Generic", function(object)
{
   if (!is.function(object))
      return(FALSE)

   if (inherits(object, "groupGenericFunction"))
      return(TRUE)

   .rs.callsUseMethod(body(object))

})

.rs.addFunction("callsUseMethod", function(x)
{
   if (missing(x))
      return(FALSE)

   if (!is.call(x))
      return(FALSE)

   if (identical(x[[1]], quote(UseMethod)))
      return(TRUE)

   if (length(x) == 1)
      return(FALSE)

   for (arg in as.list(x[-1]))
      if (.rs.callsUseMethod(arg))
         return(TRUE)

   FALSE
})

.rs.addFunction("getUseMethodGeneric", function(x)
{
   if (is.function(x))
      x <- body(x)

   if (!is.call(x))
      return(NULL)

   UseMethod <- as.name("UseMethod")
   generic <- NULL
   .rs.recursiveSearch(x, function(node) {

      if (!is.call(node) || length(node) < 2 || length(node) > 3)
         return(FALSE)

      lhs <- node[[1]]
      if (!identical(lhs, UseMethod))
         return(FALSE)

      matched <- tryCatch(
         match.call(function(generic, object) {}, node),
         error = function(e) NULL
      )

      if (is.character(matched[["generic"]]))
      {
         generic <<- matched[["generic"]]
         return(TRUE)
      }

      FALSE
   })

   generic
})

.rs.addFunction("getS3MethodDefinitions", function(generic)
{
   if (is.function(generic))
      generic <- .rs.getUseMethodGeneric(generic)

   if (!is.character(generic))
      return(NULL)

   call <- substitute(
      methods(generic),
      list(generic = generic)
   )

   methods <- .rs.tryCatch(eval(call, envir = globalenv()))
   if (inherits(methods, "error"))
      return(NULL)
      
   info <- attr(methods, "info")
   if (!is.data.frame(info))
      return(NULL)

   defns <- lapply(seq_len(nrow(info)), function(i) {
      method <- rownames(info)[[i]]
      generic <- info$generic[[i]]
      class <- substring(method, nchar(generic) + 2)

      call <- substitute(
         utils::getS3method(generic, class, optional = TRUE),
         list(generic = generic, class = class)
      )

      eval(call, envir = globalenv())
   })

   names(defns) <- rownames(info)
   defns
})

.rs.addFunction("getS3MethodsForFunction", function(func, envir = parent.frame())
{
  tryCatch({
     call <- call("methods", func)
     as.character(suppressWarnings(eval(call, envir = envir)))
  }, error = function(e) character())
})


# Return a list of S4 methods formatted as  functionName {className, className}
# NOTE: should call isGeneric prior to calling this (it will yield an error
# for functions that aren't generic)
.rs.addFunction("getS4MethodsForFunction", function(func)
{
  sigs <- findMethodSignatures(methods = findMethods(func))
  apply(sigs,
        1,
        function(sig)
        {
           paste(func,
                 " {",
                 paste(sig, collapse=", "),
                 "}",
                 sep="",
                 collapse = "")
        })
})

.rs.addFunction("getS4MethodNamespaceName", function(method)
{
  env <- environment(method)
  if (identical(env, baseenv()))
    return ("package:base")
  else if (identical(env, globalenv()))
    return (".GlobalEnv")
  else
  {
    envName <- environmentName(env)
    if (envName %in% search())
      return (envName)
    else
      paste("package:", envName, sep="")
  }
})

.rs.addFunction("getPendingInput", function()
{
   .Call("rs_getPendingInput")
})

.rs.addFunction("doStripSurrounding", function(string, complements)
{
   result <- gsub("^\\s*([`'\"])(.*?)\\1.*", "\\2", string, perl = TRUE)
   for (item in complements)
   {
      result <- sub(
         paste("^\\", item[[1]], "(.*)\\", item[[2]], "$", sep = ""),
         "\\1",
         result,
         perl = TRUE
      )
   }
   result

})

.rs.addFunction("stripSurrounding", function(string)
{
   complements <- list(
      c("(", ")"),
      c("{", "}"),
      c("[", "]"),
      c("<", ">")
   )

   result <- .rs.doStripSurrounding(string, complements)
   while (result != string)
   {
      string <- result
      result <- .rs.doStripSurrounding(string, complements)
   }
   result
})

.rs.addFunction("resolveObjectSource", function(object, envir)
{
   # Try to find the associated namespace of the object
   namespace <- NULL
   if (is.primitive(object))
      namespace <- "base"
   else if (is.function(object))
   {
      envString <- capture.output(environment(object))[1]
      match <- regexpr("<environment: namespace:(.*)>", envString, perl = TRUE)
      if (match == -1L)
         return()

      start <- attr(match, "capture.start")[1]
      end <- start + attr(match, "capture.length")[1]
      namespace <- substring(envString, start, end - 1)
   }
   else if (isS4(object))
      namespace <- attr(class(object), "package")

   if (is.null(namespace))
      return()

   # Get objects from that namespace
   ns <- asNamespace(namespace)
   objectNames <- objects(ns, all.names = TRUE)
   objects <- tryCatch(
      mget(objectNames, envir = ns),
      error = function(e) NULL
   )

   if (is.null(objects))
      return()

   # Find which object is actually identical to the one we have
   success <- FALSE
   for (i in seq_along(objects))
   {
      if (identical(object, objects[[i]], ignore.environment = TRUE))
      {
         success <- TRUE
         break
      }
   }

   # Use that name for the help lookup
   if (success)
      return(list(
         name = objectNames[[i]],
         package = namespace
      ))

})

.rs.addFunction("resolveAliasedSymbol", function(object)
{
   if (!is.function(object))
      return(object)

   if (is.primitive(object))
      return(object)

   body <- body(object)
   if (is.symbol(body))
     return(object)

   env <- environment(object)
   if (length(body) && .rs.isSymbolCalled(body[[1]], ".rs.callAs"))
      return(env$original)

   return(object)
})

.rs.addFunction("getAnywhere", function(name, envir = parent.frame())
{
   result <- NULL

   if (!length(name))
      return(NULL)

   if (is.character(name) && (length(name) != 1 || name == ""))
      return(NULL)

   # Don't evaluate any functions -- skip any 'name' that contains a paren
   if (is.character(name) && regexpr("(", name, fixed = TRUE) > 0)
      return(FALSE)

   # Helper function for evaluating an expression with warnings + messages
   # suppressed, and errors coerced to NULL
   quietly <- function(expr) {
      withCallingHandlers(
         tryCatch(expr, error = function(e) NULL),
         warning = function(e) invokeRestart("muffleWarning"),
         message = function(e) invokeRestart("muffleMessage")
      )
   }

   if (is.character(name) && is.character(envir))
   {
      # If envir is the name of something on the search path, get it from there
      pos <- match(envir, search(), nomatch = -1L)
      if (pos >= 0)
      {
         object <- quietly(get(name, pos = pos))
         if (!is.null(object))
            return(.rs.resolveAliasedSymbol(object))
      }

      # Otherwise, maybe envir is the name of a package -- search there
      if (envir %in% loadedNamespaces())
      {
         object <- quietly(get(name, envir = asNamespace(envir)))
         if (!is.null(object))
            return(.rs.resolveAliasedSymbol(object))
      }
   }

   if (is.character(name))
   {
      name <- quietly(parse(text = .rs.stripSurrounding(name)))
      if (is.null(name))
         return(NULL)
   }

   if (is.language(name))
      result <- quietly(eval(name, envir = envir))

   .rs.resolveAliasedSymbol(result)

})

.rs.addFunction("getFunctionArgumentNames", function(object)
{
   # for primitive objects, 'args()' can be used to extract
   # a function object with compatible prototype -- although
   # primitive functions that power control flow (e.g. `if()`,
   # `return()` can return NULL)
   if (is.primitive(object))
      object <- args(object)

   result <- character()
   if (is.function(object))
      result <- names(formals(object))

   result
})

.rs.addFunction("getNames", function(object)
{
   tryCatch(
      .rs.getNamesImpl(object),
      error = function(e) NULL
   )
})

.rs.addFunction("getNamesImpl", function(object)
{
   names <- if (is.environment(object) && !inherits(object, "R6"))
      ls(object, all.names = TRUE)
   else if (inherits(object, "tbl") && "dplyr" %in% loadedNamespaces())
      dplyr::tbl_vars(object)
   
   # For some reason, `jobjRef` objects (from rJava) return names containing
   # parentheses after the associated function call, which confuses our completion
   # system.
   else if (inherits(object, "jobjRef"))
      return(gsub("[\\(\\)]", "", names(object)))
   else
      names(object)
   
   meta <- if (!inherits(object, "tbl_sql"))
   {
      if (is.environment(object) && is.character(names))
      {
         vapply(names, function(name)
         {
            if (bindingIsActive(name, object))
            {
               ""
            }
            else
            {
               label <- attr(object[[name]], "label", exact = TRUE)
               .rs.nullCoalesce(label, "")
            }
         }, FUN.VALUE = character(1))
      }
      else if (is.list(object))
      {
         # Only iterate element-wise for list-like objects. Iterating across
         # a non-list (e.g. a large sparse Matrix whose length() is nrow*ncol)
         # can allocate hundreds of millions of elements and exhaust memory.
         vapply(object, function(value)
         {
            label <- attr(value, "label", exact = TRUE)
            .rs.nullCoalesce(label, "")
         }, FUN.VALUE = character(1))
      }
   }
   
   attr(names, "meta") <- unname(meta)
   names
})

.rs.addJsonRpcHandler("get_help_at_cursor", function(line, cursorPos)
{
   token <- .rs.guessToken(line, cursorPos)
   if (token == '')
      return()
   # strip leading `?`
   token <- sub("^\\?", "", token)
   pieces <- strsplit(token, ':{2,3}')[[1]]

   # use devtools shim for help if available (old devtools version)
   if ("devtools_shims" %in% search() &&
       "devtools" %in% loadedNamespaces() &&
       exists("shim_help", envir = asNamespace("devtools")))
   {
      help <- devtools:::shim_help
   }
   # use devtools shim for help if available (from pkgload)
   else if ("devtools_shims" %in% search() &&
            "pkgload" %in% loadedNamespaces() &&
            exists("shim_help", envir = asNamespace("pkgload")))
   {
      help <- pkgload:::shim_help
   } 
   else
   {
      help <- utils::help
   }

   capture.output(suppressMessages({
      if (length(pieces) > 1) {
         print(help(pieces[2], package = pieces[1], help_type = 'html'))
      } else {
         # try custom help handler, otherwise fall through to default handler
         helpUrl <- .rs.getCustomHelpUrl(token)
         if (!is.null(helpUrl)) {
            if (nzchar(helpUrl)) # handlers return "" to indicate no help available
               utils::browseURL(helpUrl)
         } else {
            print(help(pieces[1], help_type = 'html', try.all.packages = TRUE))
         }
      }
   }))
})

.rs.addFunction("findCustomHelpContext", function(token, handler) {

   # if the token has a '$' in it then it might have a custom
   # help handler that can field this request
   if (grepl("\\$", token)) {

      # split on $ (it has at least one so components will be > 1)
      components <- strsplit(token, "\\$")[[1]]
      topic <- components[[length(components)]]
      source <- paste(components[1:(length(components)-1)], collapse = "$")

      # evaluate the source
      source <- tryCatch(eval(parse(text = source), envir = globalenv()),
                         error = function(e) NULL)

      # look for a help url handler
      if (!is.null(source)) {
         for (cls in class(source)) {
            res <- utils::getAnywhere(paste(handler, ".", cls, sep=""))
            if (length(res$objs) > 0) {
               return(list(
                  topic = topic,
                  source = source,
                  handler = res$objs[[1]]
               ))
            }
         }
      }
   }

   # default to none found
   NULL

})

# check to see whether there is a custom help handler for this token
.rs.addFunction("getCustomHelpUrl", function(token) {
   custom <- .rs.findCustomHelpContext(token, "help_url_handler")
   if (!is.null(custom))
      custom$handler(custom$topic, custom$source)
   else
      NULL
})

.rs.addJsonRpcHandler("execute_r_code", function(code)
{
   # allow 2 seconds to execute code
   setTimeLimit(elapsed = 2, transient = TRUE)
   on.exit(setTimeLimit(), add = TRUE)

   # evaluate requested code
   envir <- parent.frame(2)
   result <- .rs.tryCatch({

      output <- capture.output(
         evaled <- suppressWarnings(
            eval(parse(text = code), envir = envir)
         )
      )

      object <- if (length(output))
         output
      else
         deparse(evaled)

   })

   if (inherits(result, "error"))
      return(.rs.scalar(""))

   .rs.scalar(paste(as.character(object), collapse = "\n"))
})

.rs.addJsonRpcHandler("is_function", function(nameString, envString)
{
   object <- NULL

   if (envString == "")
   {
      object <- .rs.getAnywhere(nameString, parent.frame())
   }
   else
   {
      envString <- .rs.stripSurrounding(envString)
      if (envString %in% search())
      {
         object <- tryCatch(
            get(nameString, pos = which(envString == search())),
            error = function(e) NULL
         )
      }
      else if (envString %in% loadedNamespaces())
      {
         object <- tryCatch(
            get(nameString, envir = asNamespace(envString)),
            error = function(e) NULL
         )
      }
      else if (!is.null(container <- .rs.getAnywhere(envString, parent.frame())))
      {
         if (isS4(container))
         {
            object <- tryCatch(
               eval(call("@", container, nameString)),
               error = function(e) NULL
            )
         }
         else
         {
            object <- tryCatch(
               eval(call("$", container, nameString)),
               error = function(e) NULL
            )
         }
      }
   }
   .rs.scalar(!is.null(object) && is.function(object))
})

.rs.addFunction("asCaseInsensitiveRegex", function(string)
{
   if (string == "")
      return(string)

   splat <- strsplit(string, "", fixed = TRUE)[[1]]
   lowerSplat <- tolower(splat)
   upperSplat <- toupper(splat)
   result <- vapply(1:length(splat), FUN.VALUE = character(1), USE.NAMES = FALSE, function(i) {
      if (lowerSplat[i] == upperSplat[i])
         splat[i]
      else
         paste("[", lowerSplat[i], upperSplat[i], "]", sep = "")
   })
   paste(result, collapse = "")
})

.rs.addFunction("asCaseInsensitiveSubsequenceRegex", function(string)
{
   if (string == "")
      return(string)

   splat <- strsplit(string, "", fixed = TRUE)[[1]]
   lowerSplat <- tolower(splat)
   upperSplat <- toupper(splat)

   result <- vapply(1:length(splat), FUN.VALUE = character(1), USE.NAMES = FALSE, function(i) {
      if (lowerSplat[i] == upperSplat[i])
         splat[i]
      else
         paste("[", lowerSplat[i], upperSplat[i], "]", sep = "")
   })

   negated <- vapply(1:length(splat), FUN.VALUE = character(1), USE.NAMES = FALSE, function(i) {
      if (lowerSplat[i] == upperSplat[i])
         paste("[^", splat[i], "]*", sep = "")
      else
         paste("[^", lowerSplat[i], upperSplat[i], "]*", sep = "")
   })

   negated <- c(negated[-1L], "")
   paste(result, negated, sep = "", collapse = "")
})

.rs.addFunction("isSubsequence", function(strings, string)
{
   .Call("rs_isSubsequence", strings, string)
})

.rs.addFunction("whichIsSubsequence", function(strings, string)
{
   which(.rs.isSubsequence(strings, string))
})

.rs.addFunction("selectIsSubsequence", function(strings, string)
{
   .subset(strings, .rs.isSubsequence(strings, string))
})

.rs.addFunction("escapeForRegex", function(regex)
{
   gsub("([\\-\\[\\]\\{\\}\\(\\)\\*\\+\\?\\.\\,\\\\\\^\\$\\|\\#\\s])", "\\\\\\1", regex, perl = TRUE)
})

# Escapes HTML entities in a character vector (text); "attribute" is a boolean indicating whether
# additional characters specific to HTML attributes should be escaped (newlines).
.rs.addFunction("htmlEscape", function(text, attribute = FALSE)
{
   .Call("rs_htmlEscape", text, attribute, PACKAGE = "(embedding)")
})

.rs.addFunction("objectsOnSearchPath", function(token = "",
                                                caseInsensitive = FALSE,
                                                excludeGlobalEnv = FALSE)
{
   search <- search()
   startIdx <- 1
   range <- 1:length(search)

   if (excludeGlobalEnv)
   {
      startIdx <- 2
      search <- search[-1]
      range <- range[-1]
   }

   if (nzchar(token))
   {
      token <- .rs.escapeForRegex(token)
      if (caseInsensitive)
         token <- .rs.asCaseInsensitiveRegex(token)
      pattern <- paste("^", token, sep = "")

      objects <- lapply(range, function(i) {
         ls(pos = i, all.names = TRUE, pattern = pattern)
      })
   }
   else
   {
      objects <- lapply(range, function(i) {
         ls(pos = i, all.names = TRUE)
      })
   }

   names(objects) <- search
   objects
})

.rs.addFunction("assign", function(x, value)
{
   assign(paste(".rs.cache.", x, sep = ""), value, envir = .rs.toolsEnv())
})

.rs.addFunction("get", function(x)
{
   tryCatch(
      get(paste(".rs.cache.", x, sep = ""), envir = .rs.toolsEnv()),
      error = function(e) NULL
   )
})

.rs.addFunction("mget", function(x = NULL)
{
   tryCatch(
      {
         objects <- if (is.null(x))
            .rs.selectStartsWith(objects(envir = .rs.toolsEnv(), all.names = TRUE), ".rs.cache")
         else
            paste(".rs.cache.", x, sep = "")

         mget(objects, envir = .rs.toolsEnv())
      },

      error = function(e) NULL
   )
})

.rs.addFunction("packageNameForSourceFile", function(filePath)
{
   .Call("rs_packageNameForSourceFile", filePath)
})

.rs.addFunction("isRScriptInPackageBuildTarget", function(filePath)
{
   .Call("rs_isRScriptInPackageBuildTarget", filePath)
})

.rs.addFunction("namedVectorAsList", function(vector)
{
   values <- unlist(vector, use.names = FALSE)
   if (!length(values))
      return(list(names = NULL, values = NULL))
   vectorNames <- names(vector)
   names <- unlist(lapply(seq_along(vector), function(i) {
      rep.int(vectorNames[i], length(vector[[i]]))
   }))

   list(names = names, values = values)
})

.rs.addFunction("getDollarNamesMethod", function(object,
                                                 excludeBaseClasses = FALSE,
                                                 envir = globalenv())
{
   classAndSuper <- function(cl)
   {
      # selectSuperClasses throws an error if the class is unknown
      super <- tryCatch(
         methods::selectSuperClasses(cl),
         error = function(e) NULL
      )

      c(cl, super)
   }

   # interleave super classes after the corresponding original classes
   classes <- unlist(lapply(class(object), classAndSuper), recursive = TRUE)

   # either remove or add an explicit (=non-mode) list/environment class
   classes <- if (excludeBaseClasses)
      setdiff(classes, c("list", "environment"))
   else
      c(classes, mode(object))

   for (class in classes)
   {
      # support older getS3method() definitions (without envir)
      method <- if ("envir" %in% names(formals(utils::getS3method)))
      {
         utils::getS3method(
            f = ".DollarNames",
            class = class,
            optional = TRUE,
            envir = envir
         )
      }
      else
      {
         utils::getS3method(
            f = ".DollarNames",
            class = class,
            optional = TRUE
         )
      }

      if (!is.null(method))
         return(method)
   }

   NULL
})

.rs.addJsonRpcHandler("get_args", function(name, src, helpHandler)
{
   if (grepl("::", name) && identical(src, ""))
   {
      bits <- strsplit(name, "::")[[1L]]
      if (length(bits) == 2L)
      {
         name <- bits[2L]
         src <- bits[1L]
      }
   }

   # call custom help handler if provided
   if (nzchar(helpHandler)) {

      # resolve help handler
      helpHandlerFunc <- tryCatch(
         eval(parse(text = helpHandler)),
         error = function(e) NULL
      )

      if (!is.function(helpHandlerFunc))
         return(NULL)

      # invoke handler function
      help <- tryCatch(
         helpHandlerFunc("completion", name, src),
         error = function(e) NULL
      )

      if (is.null(help))
         return(NULL)

      # attempt to retrieve signature
      signature <- help$signature
      if (!is.null(signature)) {
         paren <- regexpr("\\(", signature)[[1]]
         if (paren != -1)
            signature <- substring(signature, paren)
      }
      return(.rs.scalar(signature))
   }

   # if we're getting arguments for 'write.csv', infer arguments
   # based on 'write.table'
   isUtils <-
      identical(src, "package:utils") ||
      identical(src, "utils")

   if (isUtils)
   {
      if (identical(name, "write.csv") ||
          identical(name, "write.csv2"))
      {
         name <- "write.table"
      }
   }

   # NOTE: 'src' can refer either to a package for usages of the form
   # 'utils::alarm()', or an object for usages of the form 'object$method()'.
   # We need to be careful to handle both types.

   # first, try to resolve as environment
   envir <- .rs.tryCatch(.rs.resolveEnvironment(src))
   if (is.environment(envir))
   {
      method <- .rs.tryCatch(get(name, envir = envir, mode = "function"))
      if (is.function(method))
      {
         signature <- .rs.getSignature(method)
         result <- sub("function ", "", signature)
         return(.rs.scalar(result))
      }
   }

   # next, try to resolve as regular R object
   envir <- .rs.getActiveFrame()
   object <- .rs.getAnywhere(src, envir = envir)
   if (!is.null(object))
   {
      # if the user is calling 'R6$new', try inferring objects from the
      # initialize method instead
      method <- if (inherits(object, "R6ClassGenerator") &&
                    identical(name, "new"))
      {
         object$public_methods$initialize
      }
      else
      {
         .rs.tryCatch(object[[name]])
      }

      if (is.function(method))
      {
         signature <- .rs.getSignature(method)
         result <- sub("function ", "", signature)
         return(.rs.scalar(result))
      }
   }

   .rs.scalar("")
})

.rs.addFunction("getActiveArgument", function(object,
                                              matchedCall)
{
   allArgs <- .rs.getFunctionArgumentNames(object)
   matchedArgs <- names(matchedCall)[-1L]
   qualifiedArgsInCall <- setdiff(matchedArgs, "")
   setdiff(allArgs, qualifiedArgsInCall)[1]
})

.rs.addFunction("swap", function(vector, ..., default)
{
   dotArgs <- list(...)

   nm <- names(dotArgs)

   to <- unlist(lapply(seq_along(dotArgs), function(i)
      rep(nm[i], each = length(dotArgs[[i]]))
   ))

   from <- unlist(dotArgs)

   tmp <- to[match(vector, from)]
   tmp[is.na(tmp)] <- default
   tmp
})

.rs.addFunction("scoreMatches", function(strings, string)
{
   .Call("rs_scoreMatches", strings, string)
})

.rs.addFunction("getProjectDirectory", function()
{
   .Call("rs_getProjectDirectory")
})

.rs.addFunction("hasFileMonitor", function()
{
   .Call("rs_hasFileMonitor")
})

.rs.addFunction("doListIndex", function(routine, term, inDirectory, maxCount)
{
   if (!.rs.hasFileMonitor() || is.null(inDirectory))
      return(NULL)

   inDirectory <- suppressWarnings(.rs.normalizePath(inDirectory))
   inDirectory <- gsub("[/\\\\]+$", "", inDirectory)

   .Call(routine, term, inDirectory, as.integer(maxCount))
})

.rs.addFunction("listIndexedFiles", function(term = "",
                                             inDirectory = .rs.getProjectDirectory(),
                                             maxCount = 200L)
{
   .rs.doListIndex("rs_listIndexedFiles", term, inDirectory, as.integer(maxCount))
})

.rs.addFunction("listIndexedFolders", function(term = "",
                                               inDirectory = .rs.getProjectDirectory(),
                                               maxCount = 200L)
{
   .rs.doListIndex("rs_listIndexedFolders", term, inDirectory, maxCount)
})

.rs.addFunction("listIndexedFilesAndFolders", function(term = "",
                                                       inDirectory = .rs.getProjectDirectory(),
                                                       maxCount = 200L)
{
   .rs.doListIndex("rs_listIndexedFilesAndFolders", term, inDirectory, maxCount)
})

.rs.addFunction("doGetIndex", function(term = "",
                                       inDirectory = .rs.getProjectDirectory(),
                                       maxCount = 200L,
                                       getter)
{
   if (is.null(inDirectory))
      return(character())

   inDirectory <- suppressWarnings(
      .rs.normalizePath(inDirectory)
   )

   index <- getter(term, inDirectory, maxCount)

   if (is.null(index))
   {
      return(list(
         paths = character(),
         more_available = FALSE
      ))
   }

   paths <- suppressWarnings(.rs.normalizePath(index$paths, winslash = "/"))
   scores <- .rs.scoreMatches(basename(paths), term)
   index$paths <- paths[order(scores)]
   index

})

.rs.addFunction("getIndexedFiles", function(term = "",
                                            inDirectory = .rs.getProjectDirectory(),
                                            maxCount = 200L)
{
   .rs.doGetIndex(term, inDirectory, maxCount, .rs.listIndexedFiles)
})

.rs.addFunction("getIndexedFolders", function(term = "",
                                              inDirectory = .rs.getProjectDirectory(),
                                              maxCount = 200L)
{
   .rs.doGetIndex(term, inDirectory, maxCount, .rs.listIndexedFolders)
})

.rs.addFunction("getIndexedFilesAndFolders", function(term = "",
                                                      inDirectory = .rs.getProjectDirectory(),
                                                      maxCount = 200L)
{
   .rs.doGetIndex(term, inDirectory, maxCount, .rs.listIndexedFilesAndFolders)
})

## NOTE: Function may be used by async R process; must not call back into
## 'rs_' compiled code!
.rs.addFunction("jsonEscapeString", function(value)
{
   if (is.na(value)) return("null")
   chars <- strsplit(value, "", fixed = TRUE)[[1]]
   chars <- vapply(chars, function(x) {
      if (x %in% c('"', '\\', '/'))
         paste('\\', x, sep = '')
      else if (length(charToRaw(x)) == 1 && charToRaw(x) < 32)
         paste('\\u', toupper(format(as.hexmode(as.integer(charToRaw(x))),
                                     width = 4)),
               sep = '')
      else
         x
   }, character(1))
   paste(chars, sep = "", collapse = "")
})

## NOTE: Function may be used by async R process; must not call back into
## 'rs_' compiled code!
.rs.addFunction("jsonProperty", function(name, value)
{
   paste(sep = "",
         "\"",
         .rs.jsonEscapeString(enc2utf8(name)),
         "\":\"",
         .rs.jsonEscapeString(enc2utf8(value)),
         "\""
   )
})

## NOTE: Specify that a JSON value should be returned as a scalar by
## giving it the 'AsIs' class; ie, by writing 'foo = I(1)', or otherwise
## by using the '.rs.scalar' function.
##
## NOTE: Function may be used by async R process; must not call back into
## 'rs_' compiled code!
##
## NOTE: lists are considered as objects if they are named, and as arrays if
## they are not. If you have an empty list that you want to treat as an object,
## you must give it a names attribute.
##
## Unbox will automatically unbox any 1-length non-list vectors.
.rs.addFunction("toJSON", function(object, unbox = FALSE)
{
   AsIs <- inherits(object, "AsIs") || inherits(object, ".rs.scalar")
   if (is.list(object))
   {
      if (is.null(names(object)))
      {
         return(paste('[', paste(lapply(seq_along(object), function(i) {
            .rs.toJSON(object[[i]], unbox = unbox)
         }), collapse = ','), ']', sep = '', collapse=','))
      }
      else
      {
         return(paste('{', paste(lapply(seq_along(object), function(i) {
            paste(sep = "",
                  '"',
                  .rs.jsonEscapeString(enc2utf8(names(object)[[i]])),
                  '":',
                  .rs.toJSON(object[[i]], unbox = unbox)
            )
         }), collapse = ','), '}', sep = '', collapse = ','))
      }
   }
   else
   {
      n <- length(object)

      # NOTE: For type safety we cannot unmarshal NULL as '{}' as e.g. jsonlite does.
      if (is.null(object))
      {
         if (unbox)
            return('null')
         else
            return('[]')
      }
      else if (n == 0)
      {
         return('[]')
      }
      else if (is.character(object) || is.factor(object))
      {
         object <- paste(collapse = ",", vapply(as.character(object), FUN.VALUE = character(1), USE.NAMES = FALSE, function(x) {
            if (is.na(x)) "null"
            else paste("\"", .rs.jsonEscapeString(enc2utf8(x)), "\"", sep = "")
         }))
      }
      else if (is.numeric(object))
      {
         object[is.na(object)] <- '\"NA\"'
      }
      else if (is.logical(object))
      {
         object <- ifelse(object, "true", "false")
         object[is.na(object)] <- 'null'
      }

      if (AsIs || (unbox && n == 1))
         return(paste(object))
      else
         return(paste('[', paste(object, collapse = ','), ']', sep = '', collapse = ','))
   }
})

.rs.addFunction("recordFunctionInformation", function(node,
                                                      missingEnv,
                                                      symbolsUsedEnv)
{
   if (is.call(node) && length(node) == 2)
   {
      head <- node[[1]]
      second <- node[[2]]
      if (.rs.isSymbolCalled(head, "missing") &&
          is.symbol(second))
      {
         missingEnv[[as.character(second)]] <- TRUE
      }
   }

   ## TODO: Obviously not perfect because of NSE.
   if (is.symbol(node) && !identical(node, quote(expr = )))
      symbolsUsedEnv[[as.character(node)]] <- TRUE
})

.rs.addFunction("emptyNamedList", function()
{
   `names<-`(list(), character())
})

.rs.addFunction("emptyFunctionInfo", function()
{
   list(
      formal_names = character(),
      formal_info  = list(),
      performs_nse = I(0L)
   )
})

# NOTE: This function is used in asynchronous R processes and so
# cannot call back into any RStudio compiled code! Even further,
# `SessionAsyncPackageInformation.cpp` decodes fields based on
# their names, so if you re-name a field here you must modify the
# extraction implementation there as well.
.rs.addFunction("getPackageInformation", function(...)
{
   # force 'rgl' to use the NULL graphics device (avoid inadvertently
   # opening a graphics device / XQuartz window when retrieving completions)
   rgl.useNULL <- getOption("rgl.useNULL")
   options(rgl.useNULL = TRUE)
   on.exit(options(rgl.useNULL = rgl.useNULL), add = TRUE)

   packages <- list(...)
   lapply(packages, function(package) {
      tryCatch(
         .rs.emitPackageInformation(package),
         error = function(e) .rs.emptyFunctionInfo()
      )
   })
})

.rs.addFunction("emitPackageInformation", function(package)
{
   # Explicitly load the library, and do everything we can to hide any
   # package startup messages (because we don't want to put non-JSON
   # on stdout)
   invisible(capture.output(suppressPackageStartupMessages(suppressWarnings({

      ## Don't load the package if a corresponding 00LOCK directory exists.
      ## This gives partial protection against attempting to load a package
      ## while another R process is attempting to modify the library directory.
      has00LOCK <- FALSE
      for (libPath in .libPaths())
      {
         globalLockPath <- file.path(libPath, "00LOCK")
         pkgLockPath <- file.path(libPath, paste("00LOCK", basename(package), sep = "-"))
         if (file.exists(globalLockPath) || file.exists(pkgLockPath))
         {
            has00LOCK <- TRUE
            break
         }
      }

      success <- if (has00LOCK)
         FALSE
      else
         library(package, character.only = TRUE, quietly = TRUE, logical.return = TRUE)

   }))))

   if (!success)
      return(.rs.emptyFunctionInfo())

   # Get the exported items in the NAMESPACE
   # (for search path + `::` completions).
   ns <- asNamespace(package)
   exports <- getNamespaceExports(ns)
   objects <- mget(exports, ns, inherits = TRUE)
   isFunction <- vapply(objects, FUN.VALUE = logical(1), USE.NAMES = FALSE, is.function)
   functions <- objects[isFunction]

   # Figure out the completion types for these objects
   types <- vapply(objects, FUN.VALUE = numeric(1), USE.NAMES = FALSE, .rs.getCompletionType)

   # Find the functions, and generate information on each formal
   # (does it have a default argument; is missingness handled; etc)
   functionInfo <- lapply(functions, .rs.generateFunctionInformation)

   # List data objects exported by this package
   datasets <- .rs.listDatasetsProvidedByPackage(package)

   # Generate the output
   output <- list(
      package = I(package),
      exports = exports,
      types = types,
      function_info = functionInfo,
      datasets = datasets
   )

   # Write the JSON to stdout; the parent will read and process it
   flush.console()
   json <- paste("#!json:", .rs.toJSON(output))
   writeLines(c("", json, ""))
   flush.console()

   # Return output for debug purposes
   invisible(output)
})

.rs.addFunction("generateFunctionInformation", function(func) {

  formals <- formals(func)
  if (!length(formals))
     return(.rs.emptyFunctionInfo())

  formalNames <- names(formals)
  hasDefault <- vapply(formals, FUN.VALUE = integer(1), USE.NAMES = FALSE, function(x) {
     !identical(x, quote(expr = ))
  })

  # Record which symbols in the function body handle missingness,
  # to check if missingness of default arguments is handled
  missingEnv <- new.env(parent = emptyenv())
  usedSymbolsEnv <- new.env(parent = emptyenv())
  .rs.recursiveWalk(body(func), function(node) {
     .rs.recordFunctionInformation(node, missingEnv, usedSymbolsEnv)
  })

  # Figure out which functions perform NSE.
  # TODO: Figure out which arguments are actually involved in NSE.
  performsNse <- .rs.performsNonstandardEvaluation(func)

  formalInfo <- lapply(seq_along(formalNames), function(i) {
     as.integer(c(
        hasDefault[[i]],
        formalNames[[i]] == "..." || exists(formalNames[[i]], envir = missingEnv),
        exists(formalNames[[i]], envir = usedSymbolsEnv)
     ))
  })

  list(
     formal_names = formalNames,
     formal_info  = formalInfo,
     performs_nse = I(as.integer(performsNse))
  )
 
})

# If a function internally calls out to one of these functions,
# we assume that it may perform non-standard evaluation, and avoid
# attempting certain diagnostics on its usages.
#
# Keep in sync with makeNsePrimitives() in RSexp.cpp
.rs.setVar("nse.primitives", c(
   
   # base R primitives
   "bquote",
   "enquote",
   "eval.parent",
   "evalq",
   "expression",
   "library",
   "match.call",
   "quote",
   "require",
   "subset",
   "substitute",
   "sys.call",
   "sys.calls",
   "sys.frame",
   "sys.frames",
   "sys.function",
   "sys.parent",

   # rlang tidy evaluation
   "enexpr",
   "enexprs",
   "enquo",
   "enquos",
   "eval_tidy",
   "quo",
   "quos",

   # dplyr -- not really primitives
   "dplyr_quosures",
   "group_by",
   "group_by_prepare"
   
))

.rs.addFunction("performsNonstandardEvaluation", function(object)
{
   # For S3 generics, search methods as well as the generic for
   # potential usages of non-standard evaluation.
   methods <- .rs.getS3MethodDefinitions(object)
   for (method in methods)
      if (.rs.performsNonstandardEvaluation(method))
         return(TRUE)

   if (is.function(object))
      object <- body(object)

   nsePrimitives <- .rs.getVar("nse.primitives")
   .rs.recursiveSearch(object,
                       .rs.performsNonstandardEvaluationImpl,
                       nsePrimitives = nsePrimitives)
})

.rs.addFunction("performsNonstandardEvaluationImpl", function(node, nsePrimitives)
{
   # Validate that we have a call.
   if (!is.call(node))
      return(FALSE)
   
   # Check for things that look like tidyr evaluation; that is, `{{}}`.
   isDoubleBracket <-
      length(node) == 2L &&
      is.symbol(node[[1L]]) &&
      as.character(node[[1L]]) == "{" &&
      is.call(node[[2L]]) &&
      length(node[[2L]]) == 2L &&
      is.symbol(node[[2L]][[1L]]) &&
      as.character(node[[2L]][[1L]]) == "{"
   
   if (isDoubleBracket)
      return(TRUE)
   
   # Check if this is a call to an NSE primitive.
   head <- node[[1L]]
   if (!is.symbol(head))
      return(FALSE)
   
   headString <- as.character(head)
   if (headString %in% nsePrimitives)
      return(TRUE)

   # Check if this is a call to an NSE primitive, qualified through
   # `::` or `:::`.
   if (headString %in% c("::", ":::") && length(node) == 3L)
   {
      rhs <- node[[3L]]
      if (is.symbol(rhs) && as.character(rhs) %in% nsePrimitives)
         return(TRUE)
   }
   
   # Doesn't appear to be using NSE.
   FALSE
})

.rs.addFunction("recursiveSearch", function(`_node`, fn, ...)
{
   if (fn(`_node`, ...))
      return(TRUE)

   if (is.recursive(`_node`))
      for (i in seq_along(`_node`))
         if (.rs.recursiveSearch(`_node`[[i]], fn, ...))
            return(TRUE)

   return(FALSE)
})

.rs.addFunction("recursiveWalk", function(`_node`, fn, ...)
{
   fn(`_node`, ...)

   if (is.recursive(`_node`))
      for (i in seq_along(`_node`))
         .rs.recursiveWalk(`_node`[[i]], fn, ...)
})

.rs.addFunction("recursiveWalkIf", function(`_node`, fn, ...)
{
   shouldRecurse <- fn(`_node`, ...)
   if (shouldRecurse && is.recursive(`_node`))
      for (i in seq_along(`_node`))
         .rs.recursiveWalkIf(`_node`[[i]], fn, ...)
})

.rs.addFunction("trimWhitespace", function(x)
{
   gsub("^[\\s\\n]+|[\\s\\n]+$", "", x, perl = TRUE)
})

.rs.addFunction("trimCommonIndent", function(string, ...)
{
   splat <- strsplit(string, "\n", fixed = TRUE)[[1]]
   indents <- regexpr("\\S", splat, perl = TRUE)
   indents[indents == -1] <- Inf
   common <- min(indents)
   result <- paste(substring(splat, common, nchar(string)), collapse = "\n")
   dots <- list(...)
   formatted <- if (length(dots)) sprintf(result, ...) else result
   .rs.trimWhitespace(formatted)
})

.rs.addFunction("parseNamespaceImports", function(path)
{
   output <- list(
      import = character(),
      importFrom = list()
   )

   if (!file.exists(path))
      return(output)

   parsed = tryCatch(
      suppressWarnings(parse(path)),
      error = function(e) NULL
   )

   if (is.null(parsed))
      return(output)

   # Loop over parsed entries and fill 'output'
   for (i in seq_along(parsed))
   {
      directive <- parsed[[i]]
      if (length(directive) < 2) next

      directiveName <- as.character(directive[[1]])
      pkgName <- as.character(directive[[2]])

      if (directiveName == "import")
      {
         output$import <- sort(unique(c(output$import, pkgName)))
         next
      }

      if (directiveName == "importFrom")
      {
         exports <- character(length(directive) - 2)
         for (i in 3:length(directive))
            exports[[i - 2]] <- as.character(directive[[i]])
         output$importFrom[[pkgName]] <- sort(unique(c(output$importFrom[[pkgName]], exports)))
         next
      }
   }

   output

})

.rs.addFunction("isSymbolCalled", function(maybeSymbol, name)
{
   is.symbol(maybeSymbol) && as.character(maybeSymbol) == name
})

.rs.addJsonRpcHandler("get_set_class_slots", function(setClassCallString)
{
   onFail <- list()
   parsed <- tryCatch(
      suppressWarnings(parse(text = setClassCallString))[[1]],
      error = function(e) NULL
   )

   if (is.null(parsed))
      return(onFail)

   matched <- tryCatch(
      match.call(methods::setClass, parsed),
      error = function(e) NULL
   )

   if (is.null(parsed))
      return(onFail)

   # NOTE: Previously, R has used 'representation' to
   # store the information about slots; it is now
   # deprecated (from 3.0.0) and the use of 'slots' is
   # encouraged. We'll check for 'slots' first, then
   # fall back to representation if necessary.
   #
   # NOTE: Okay to define a class with no slots / fields.
   field <- if ("slots" %in% names(matched))
      matched[["slots"]]
   else if ("representation" %in% names(matched))
      matched[["representation"]]
   else
      list()

   if (!("Class" %in% names(matched)))
      return(onFail)

   Class <- matched[["Class"]]

   slots <- if (length(field))
      names(field)[-1]
   else
      character()

   types <- if (length(field))
      unlist(lapply(2:length(field), function(i) {
         tryCatch(as.character(field[[i]]), error = function(e) "")
      }))
   else
      character()

   result <- list(
      Class = Class,
      slots = slots,
      types = types
   )
   return(result)
})

.rs.addFunction("tryParseCall", function(text)
{
   tryCatch(
      suppressWarnings(parse(text = text))[[1]],
      error = function(e) NULL
   )
})

.rs.addFunction("tryMatchCall", function(method, call)
{
   tryCatch(
      suppressWarnings(match.call(method, call)),
      error = function(e) NULL
   )
})

.rs.addFunction("extractElement", function(object,
                                           name,
                                           default = NULL)
{
   if (name %in% names(object))
      object[[name]]
   else
      default
})

.rs.addJsonRpcHandler("get_set_generic_call", function(call)
{
   parsed <- .rs.tryParseCall(call)
   if (is.null(parsed))
      return(list())

   matched <- .rs.tryMatchCall(methods::setGeneric, parsed)
   if (is.null(matched))
      return(list())

   generic <- .rs.extractElement(matched, "name", "")
   parameters <- character()
   if ("def" %in% names(matched))
   {
      def <- matched[["def"]]
      if (as.character(def[[1]]) == "function" &&
          length(def) > 1)
      {
         parameters <- names(def[[2]])
      }
   }

   list(
      generic = generic,
      parameters = parameters
   )
})

.rs.addJsonRpcHandler("get_set_method_call", function(call)
{
   parsed <- .rs.tryParseCall(call)
   if (is.null(parsed))
      return(list())

   matched <- .rs.tryMatchCall(methods::setMethod, parsed)
   if (is.null(matched))
      return(list())

   generic <- .rs.extractElement(matched, "f", "")
   parameter.names <- character()
   parameter.types <- character()

   signature <- .rs.extractElement(matched, "signature")
   if (!is.null(signature))
   {
      if (is.call(signature) &&
          length(signature) > 1)
      {
         parameter.names <- names(signature)[-1]
         parameter.types <- unlist(lapply(2:length(signature), function(i) {
            if (is.character(signature[[i]]))
               signature[[i]]
            else
               ""
         }))
      }
      else if (is.character(signature))
      {
         parameter.names <- signature
      }
   }

   list(
      generic = generic,
      parameter.names = parameter.names,
      parameter.types = parameter.types
   )

})

.rs.addJsonRpcHandler("get_set_ref_class_call", function(call)
{
   parsed <- .rs.tryParseCall(call)
   if (is.null(parsed))
      return(list())

   matched <- .rs.tryMatchCall(methods::setRefClass, parsed)
   if (is.null(matched))
      return(list())

   Class <- .rs.extractElement(matched, "Class", "")

   field.names <- character()
   field.types <- character()
   fields <- .rs.extractElement(matched, "fields")

   if (length(fields) > 1)
   {
      field.names <- names(fields)[-1]
      field.types <- unlist(lapply(2:length(fields), function(i) {
         if (is.character(fields[[i]]))
            fields[[i]]
         else
            ""
      }))
   }

   methods <- .rs.extractElement(matched, "methods")
   method.names <- if (length(methods))
      names(methods)[-1]
   else
      character()

   list(
      Class = Class,
      field.names = field.names,
      field.types = field.types,
      method.names = method.names
   )

})

.rs.addFunction("getSetRefClassSymbols", function(callString)
{
   parsed <- .rs.rpc.get_set_ref_class_call(callString)
   unique(as.character(c(
      ".self",
      parsed$field.names,
      parsed$method.names
   )))
})

.rs.addFunction("getR6ClassSymbols", function(callString)
{
   parsed <- .rs.tryParseCall(callString)
   if (is.null(parsed)) return(character())

   symbols <- c("self", "public", "private", "super")
   public <- .rs.extractElement(parsed, "public")
   if (!is.null(public))
      symbols <- c(symbols, names(public)[-1])

   symbols
})

.rs.addFunction("setEncodingUnknownToUTF8", function(object)
{
   if (is.character(object) && Encoding(object) == "unknown")
      Encoding(object) <- "UTF-8"
   else if (is.list(object))
      return(lapply(object, .rs.setEncodingUnknownToUTF8))

   object
})

.rs.addFunction("makePrimitiveWrapper", function(x)
{
   # from the R documentation, args returns:
   #
   #   For a closure, a closure with identical formal argument list but an empty
   #   (NULL) body.
   #
   #   For a primitive, a closure with the documented usage and NULL body. Note
   #   that some primitives do not make use of named arguments and match by
   #   position rather than name.
   #
   # we just need an R closure with the right formals, so args fits nicely
   args(x)
})

.rs.addFunction("extractNativeSymbols", function(DLL, collapse = TRUE)
{
   info <- getDLLRegisteredRoutines(DLL)
   result <- lapply(info, function(routine) {
      as.character(names(routine))
   })

   if (collapse)
      result <- as.character(unlist(result))

   result
})

.rs.addFunction("getNativeSymbols", function(package)
{
   loadedDLLs <- getLoadedDLLs()
   if (package %in% names(loadedDLLs))
      return(.rs.extractNativeSymbols(loadedDLLs[[package]]))

   # we used to try to load and unload the package library to
   # extract symbol information, but this is not safe to do now
   # loading the DLL also implies running its R_init_* hook, and
   # this can imply loading the package (+ its dependencies) --
   # something we normally want to avoid
   character()
})

.rs.addJsonRpcHandler("extract_chunk_options", function(chunkText)
{
   # Attempt to parse the chunk as R code
   parsed <- try(parse(text = chunkText), silent = TRUE)
   if (inherits(parsed, "try-error"))
      return(list())

   # Iterate through the expression tree, looking for calls to opts_chunk$set and
   # extracting their values. Load them up into an environment (which we then return
   # as a list back to the client)
   chunkOptionsEnv <- new.env(parent = emptyenv())
   lapply(parsed, function(node) {
      .rs.recursiveWalk(node, function(node) {

         if (!is.call(node) || length(node) < 2)
            return()

         # Perhaps not the most efficient, but probably the easiest way to detect
         # appropriate calls to `opts_chunk$set`.
         callName <- as.character(node)[[1L]]
         if (callName == "knitr:::opts_chunk$set" ||
             callName == "knitr::opts_chunk$set" ||
             callName == "opts_chunk$set")
         {
            names <- names(node)
            for (i in 2:length(node))
            {
               key <- names[[i]]
               if (key == "")
                  next

               val <- if (is.character(node[[i]]))
                  .rs.surround(node[[i]], with = "\"")
               else
                  format(node[[i]])
               chunkOptionsEnv[[key]] <- val
            }
         }
      })
   })

   # Convert to a list, and ensure each element is interpreted as a scalar
   # (rather than an array containing a single element)
   result <- as.list(chunkOptionsEnv)
   for (i in seq_along(result))
      result[[i]] <- .rs.scalar(result[[i]])

   return(result)
})

.rs.addFunction("enumerate", function(X, FUN, ...)
{
   keys <- if (is.environment(X)) {
      sort(ls(envir = X))
   } else {
      names(X)
   }

   result <- lapply(keys, function(key) {
      FUN(key, X[[key]], ...)
   })

   names(result) <- keys

   result
})

.rs.addFunction("cutpoints", function(data)
{
   diffed <- diff(c(data[1], data))
   which(diffed != 0)
})

.rs.addFunction("recode", function(data, ..., envir = parent.frame())
{
   dots <- eval(substitute(alist(...)))

   for (expr in dots)
   {
      if (length(expr) != 3)
         stop("malformed recoding in .rs.recode()", call. = FALSE)

      lhs <- eval(expr[[2]], envir = envir)
      rhs <- eval(expr[[3]], envir = envir)
      data[data == lhs] <- rhs
   }

   data
})

.rs.addFunction("evalWithAvailableArguments", function(fn, args)
{
   filtered <- args[names(args) %in% names(formals(fn))]
   call <- c(substitute(fn), filtered)
   mode(call) <- "call"
   eval(call, envir = parent.frame())
})

.rs.addFunction("transposeList", function(list)
{
   do.call(Map, c(c, list, USE.NAMES = FALSE))
})

.rs.addFunction("base64encode", function(data, binary = FALSE)
{
   .Call("rs_base64encode", data, binary)
})

.rs.addFunction("base64encodeFile", function(path)
{
   .Call("rs_base64encodeFile", path)
})

.rs.addFunction("base64decode", function(data, binary = FALSE)
{
   .Call("rs_base64decode", data, binary)
})

.rs.addFunction("CRANDownloadOptionsString", function()
{

   # collect options of interest
   options <- options("repos", "download.file.method", "download.file.extra", "HTTPUserAgent")

   # drop attributes on 'repos'
   options[["repos"]] <- c(options[["repos"]])

   # include extra arguments for 'curl' downloader
   if (identical(options[["download.file.method"]], "curl"))
      options[["download.file.extra"]] <- .rs.downloadFileExtraWithCurlArgs()

   # if there is no repo option set in the R session, read it from preferences
   if (identical(length(options[["repos"]]), 0L)) {
      options[["repos"]]["CRAN"] <- .rs.readUiPref("cran_mirror")$url
   }

   # drop NULL entries
   options <- Filter(Negate(is.null), options)

   # deparse values individually. avoid relying on the format
   # of the deparsed output of the whole expression; see e.g.
   # https://github.com/rstudio/rstudio/issues/4916 for example
   # of where this can fail
   vals <- lapply(options, function(option) {

      # replace single quotes with double quotes, so that
      # deparse automatically escapes the inner quotes
      # see: https://github.com/rstudio/rstudio/issues/6597
      # (note these will be translated to single quotes later)
      if (is.character(option))
         option <- gsub("'", "\"", option)

      .rs.deparse(option)
   })

   # join keys and values
   keyvals <- paste(names(options), vals, sep = " = ")

   # create final options command
   opts <- sprintf("options(%s)", paste(keyvals, collapse = ", "))

   # NOTE: we need to quote arguments with single quotes as the command will be
   # submitted using double quotes, and embedded quotes in the command are not
   # properly escaped.
   #
   # TODO: handle embedded quotes properly
   gsub("\"", "'", opts, fixed = TRUE)

})

.rs.addFunction("slice", function(object,
                                  start = 1,
                                  end = length(object))
{
   n <- length(object)
   if (n == 0)
      return(object)

   if (start < 0) start <- n + start
   if (end < 0)   end <- n + end

   start <- max(1, start)
   end   <- min(n, end)

   if (start > end)
      return(object[0])

   return(object[start:end])
})

.rs.addFunction("slotNames", function(object)
{
   # non-S4 objects don't have slot names
   if (!isS4(object))
      return(character())

   # try using the official API to retrieve slot names
   slots <- methods::slotNames(object)
   if (is.character(slots))
      return(slots)

   # if that fails for some reason (e.g. the package that
   # provides the associated class definition is not loaded)
   # then fall back to using object attributes
   slots <- names(attributes(object))
   setdiff(slots, "class")

})

# like deparse(), but always deparsed to a length-one character vector
.rs.addFunction("deparse", function(object,
                                    width.cutoff = 500L,
                                    nlines       = -1L,
                                    collapse     = " ")
{
   # deparse the call
   deparsed <- deparse(
      expr         = object,
      width.cutoff = width.cutoff,
      nlines       = nlines
   )

   # un-escape our inline R objects
   deparsed <- gsub("`<(.*?)>`", "<\\1>", deparsed, perl = TRUE)

   # paste to return as length-one character vector
   paste(deparsed, collapse = collapse)
})

.rs.addFunction("ensureScalarCharacter", function(object)
{
   if (is.character(object) && length(object) == 1)
      return(object)

   fmt <- "'%s' is not a length-one character vector"
   stop(sprintf(fmt, .rs.deparse(substitute(object))), call. = FALSE)
})

.rs.addFunction("isR6NewMethod", function(object)
{
   if (!is.function(object))
      return(FALSE)

   envir <- environment(object)
   if (!inherits(envir, "R6ClassGenerator"))
      return(FALSE)

   identical(object, envir$new)
})

.rs.addFunction("getR6ClassGeneratorMethod", function(object, method)
{
   if (is.function(object))
      object <- environment(object)

   if (!is.environment(object))
      return(NULL)

   if (!inherits(object, "R6ClassGenerator"))
      return(NULL)

   tryCatch(
      object$public_methods[[method]],
      error = function(e) NULL
   )
})

.rs.addFunction("isExternalPointer", function(object)
{
   identical(typeof(object), "externalptr")
})

.rs.addFunction("fileInfo", function(..., extra_cols = TRUE)
{
   suppressWarnings(file.info(..., extra_cols = extra_cols))
})

.rs.addFunction("listDatasetsProvidedByPackage", function(package)
{
   # verify we have a non-empty length-one string
   if (!is.character(package) || length(package) != 1 || !nzchar(package))
      return(character())

   # find the installed package location (returns empty vector on failure)
   location <- find.package(package, quiet = TRUE)
   if (!length(location) || !file.exists(location))
      return(character())

   # construct path to datalist file
   datalist <- file.path(location, "data/datalist")
   if (!file.exists(datalist))
      return(character())

   # read the names of the provided objects
   readLines(datalist, warn = FALSE)

})

.rs.addFunction("tryCatch", function(expr)
{
   tryCatch(

      withCallingHandlers(
         expr,
         warning = function(w) invokeRestart("muffleWarning"),
         message = function(m) invokeRestart("muffleMessage")
      ),

      error = identity
   )
})

.rs.addFunction("resolveAliasedPath", function(path)
{
   .Call("rs_resolveAliasedPath", path, PACKAGE = "(embedding)")
})

.rs.addFunction("readSourceDocument", function(id)
{
   contents <- .Call("rs_readSourceDocument", as.character(id), PACKAGE = "(embedding)")
   if (is.character(contents))
      Encoding(contents) <- "UTF-8"
   contents
})

.rs.addFunction("parsePackageDependencies", function(contents, extension)
{
   # NOTE: the following regular expressions were extracted from knitr;
   # They were modified to search only R code chunks and skip other chunks
   # such as python, bash, sql, etc that do not contain R dependencies
   # Inline R code in markdown docs is also skipped
   code <- if (identical(extension, ".R"))
      contents
   else if (identical(extension, ".Rmd"))
      .rs.extractRCode(contents,
                       "^[\t >]*```+\\s*\\{[Rr]\\b.*\\}\\s*$",
                       "^[\t >]*```+\\s*$")
   else if (identical(extension, ".Rnw"))
      .rs.extractRCode(contents,
                       "^\\s*<<(.*)>>=.*$",
                       "^\\s*@\\s*(%+.*|)$")
   else if (identical(extension, ".qmd"))
     .rs.extractRCode(contents,
                      "^[\t >]*```+\\s*\\{[Rr]\\b.*\\}\\s*$",
                      "^[\t >]*```+\\s*$")
   if (is.null(code))
      return(NULL)
   # If Quarto and no R code chunks, don't parse further
   # Rmd may have yaml front matter to parse even if no R chunks
   if (identical(gsub("\n", "", code), .rs.scalar("")) && identical(extension, ".qmd"))
      return(NULL)

   # attempt to parse extracted R code
   parsed <- .rs.tryCatch(parse(text = code, encoding = "UTF-8"))
   if (inherits(parsed, "error")) {

      # call 'Sys.setlocale()' to work around an R issue where flags
      # set during parse can effectively be 'leaked' -- 'Sys.setlocale()'
      # effectively resets those flags. see:
      #
      # https://bugs.r-project.org/bugzilla3/show_bug.cgi?id=17484
      # https://github.com/rstudio/rstudio/issues/3658
      #
      if (getRversion() < "3.5.2")
         Sys.setlocale()

      return(character())

   }

   discoveries <- new.env(parent = emptyenv())

   # for R Markdown docs, scan the YAML header (requires the rmarkdown package and the yaml package,
   # a dependency of rmarkdown)
   if (identical(extension, ".Rmd") &&
       is.null(dynGet("__NameSpacesLoading__", NULL)) &&
       requireNamespace("rmarkdown", quietly = TRUE) &&
       requireNamespace("yaml", quietly = TRUE))
   {
      # extract the front matter from the document; accepts a list of lines and returns a list with
      # $front_matter and $body elements
      partitions <- rmarkdown:::partition_yaml_front_matter(
            strsplit(x = contents, split = "\n", fixed = TRUE)[[1]])

      # did we find some front matter?
      front_matter <- partitions[["front_matter"]]
      if (!is.null(front_matter))
      {
         front <- NULL

         tryCatch({
            front <- yaml::read_yaml(text = front_matter, eval.expr = TRUE)
         }, error = function(e) {
            # ignore errors when reading YAML; it's very possible that the document's YAML will not
            # be correct at all times (e.g. during editing)
         })

         # start with an empty output
         output <- NULL

         if (!is.null(names(front[["output"]])))
         {
            # if the output key has children, it will appear as a list name
            # output:
            #   pkg_name::out_fmt:
            #     foo: bar
            output <- names(front[["output"]])[[1]]
         }
         else if (is.character(front[["output"]]))
         {
            # if the output key doesn't have children, it will appear as a plain character
            #
            # output: pkg_name::out_fmt
            output <- front[["output"]]
         }

         # check for references to an R package in output format
         if (!is.null(output))
         {
            format <- unlist(strsplit(output, "::"))
            if (length(format) > 1)
            {
               discoveries[[format[[1]]]] <- TRUE
            }
         }

         # check for runtime: shiny or parameters (requires the Shiny R package)
         runtime <- front[["runtime"]]
         server <- front[["server"]]
         params  <- front[["params"]]
         if (identical(runtime, "shiny") ||
             identical(runtime, "shinyrmd") ||
             identical(runtime, "shiny_prerendered") ||
             identical(server, "shiny") ||
             (is.list(server) && identical(server[["type"]], "shiny")) ||
             !is.null(params))
         {
            discoveries[["shiny"]] <- TRUE
         }

      }
   }

   handleLibraryRequireCall <- function(node) {

      # make sure this is a call to the 'library' or 'require' function
      if (!is.call(node))
         return(FALSE)

      isLibraryOrRequire <-
         identical(node[[1]], as.name("library")) ||
         identical(node[[1]], as.name("require"))

      if (!isLibraryOrRequire)
         return(FALSE)

      # attempt to match the call
      matched <- .rs.tryCatch(match.call(base::library, node))
      if (inherits(matched, "error"))
         return(FALSE)

      # if the 'package' argument is a character vector of length one, we're done
      isPackageArgumentString <-
         is.character(matched$package) &&
         length(matched$package) == 1

      if (isPackageArgumentString) {
         discoveries[[matched$package]] <<- TRUE
         return(TRUE)
      }

      # if it's a symbol, double check character.only argument
      isSafeSymbolLibraryCall <-
         is.symbol(matched$package) &&
         (is.null(matched$character.only) || identical(matched$character.only, FALSE))

      if (isSafeSymbolLibraryCall) {
         discoveries[[as.character(matched$package)]] <<- TRUE
         return(TRUE)
      }

      FALSE

   }

   handleRequireNamespaceCall <- function(node) {

      if (!is.call(node))
         return(FALSE)

      if (!identical(node[[1]], as.name("requireNamespace")))
         return(FALSE)

      matched <- .rs.tryCatch(match.call(base::requireNamespace, node))
      if (inherits(matched, "error"))
         return(FALSE)

      if (is.character(matched$package) && length(matched$package == 1)) {
         discoveries[[matched$package]] <<- TRUE
         return(TRUE)
      }

      FALSE

   }

   handleColonCall <- function(node) {

      # make sure this is a call to the 'library' or 'require' function
      if (!is.call(node))
         return(FALSE)

      isColonCall <-
         length(node) == 3 &&
         (identical(node[[1]], as.name("::")) || identical(node[[1]], as.name(":::")))

      if (!isColonCall)
         return(FALSE)

      # extract package used. note that one can specify the package as
      # both a symbol and as a character string; e.g. this is legal R code
      #
      #   "dplyr"::"mutate"
      #
      # so guard against such usages
      package <- node[[2L]]
      if (is.symbol(package))
         package <- as.character(package)
      if (!is.character(package) || length(package) != 1)
         return(FALSE)

      # all looks good; add the discovery
      discoveries[[package]] <<- TRUE
      TRUE

   }

   .rs.recursiveWalk(parsed, function(node) {
      handleLibraryRequireCall(node) ||
      handleColonCall(node) ||
      handleRequireNamespaceCall(node)
   })

   # return discovered packages
   ls(envir = discoveries)
})

.rs.addFunction("discoverPackageDependencies", function(id, extension)
{
   # check to see if we have available packages -- if none, bail
   available <- .rs.availablePackages()
   if (is.null(available$value))
      return(character())

   # read the associated source file
   contents <- .rs.readSourceDocument(id)
   if (is.null(contents))
      return(character())

   # parse to find packages
   packages <- .rs.parsePackageDependencies(contents, extension)
   # return early if no R code is parsed
   if (is.null(packages))
      return(character())

   # If file is qmd or rmd, and there is R code, rmarkdown is REQUIRED
   if (identical(extension, ".Rmd") || identical(extension, ".qmd"))
      packages <- c("rmarkdown", packages)
   # keep only packages that are available in an active repository
   packages <- packages[packages %in% rownames(available$value)]

   # figure out which packages aren't actually installed. note that we avoid
   # calling 'installed.packages()' explicitly here as this can be very slow
   # on some NFSes; a plain `list.files()` is fine
   installed <- list.files(.libPaths())
   missing <- setdiff(packages, installed)

   # return that list
   missing

})

# like strsplit, but doesn't omit a trailing last entry as in e.g.
#
#    > strsplit("a.b.", ".", fixed = TRUE)
#    [[1]]
#    [1] "a" "b"
#
# also unlists the string by default (as the most common usage is to
# split a single string)
.rs.addFunction("strsplit", function(x, pattern, ..., simplify = TRUE)
{
   m <- gregexpr(pattern, x, ...)
   matches <- regmatches(x, m, invert = TRUE)
   if (simplify && length(matches) == 1)
      matches[[1]]
   else
      matches
})

.rs.addJsonRpcHandler("replace_comment_header", function(command, path, code)
{
   .rs.scalar(
      paste(
         deparse(
            do.call(
               "substitute",
               args = list(
                  eval(
                     parse(
                        text = paste("quote(", command, ")", sep = "")
                     )
                  ),
                  list(
                     .code = code,
                     .file = path
                  )
               )
            )
         ),
         collapse = ""
      )
   )
})

.rs.addFunction("withCache", function(name, expr)
{
   cache <- .rs.getVar(name)
   if (!is.null(cache))
      return(cache)

   result <- force(expr)
   .rs.setVar(name, result)
   result
})

.rs.addFunction("truncate", function(string, n = 200, marker = "<...>")
{
   if (nchar(string) <= n)
      return(string)

   truncated <- substring(string, 1, n - nchar(marker))
   return(paste(truncated, marker))

})

.rs.addFunction("formatListForDialog", function(list, sep = ", ", max = 50L)
{
   # count index entries until we get too long
   nc <- 0L
   ns <- nchar(sep)
   for (index in seq_along(list)) {
      nc <- nc + ns + nchar(list[[index]])
      if (nc > max)
         break
   }

   # collect items
   n <- length(list)
   items <- list

   # subset the list if we overflowed (index didn't reach end)
   # avoid printing 'and 1 other'; no need to subset in that case
   if (index < n - 1L)
      items <- c(list[1:index], paste("and", n - index, "others"))

   # paste and truncate once more for safety
   text <- paste(items, collapse = sep)
   .rs.truncate(text, n = max * 2L)

})

.rs.addFunction("resolveEnvironment", function(envir)
{
   # if this is already an environment, just return it
   if (is.environment(envir))
      return(envir)

   # if this is a numeric, then assume we want an
   # environment by position on the search path
   if (is.numeric(envir))
      return(as.environment(envir))

   # treat empty strings as request for globalenv
   if (is.null(envir) || identical(envir, ""))
      return(globalenv())

   # if this is the name of something on the search path,
   # then as.environment should suffice
   index <- match(envir, search())
   if (!is.na(index))
      return(as.environment(index))

   # if this is the name of a namespace, retrieve that namespace
   if (substring(envir, 1L, 10L) == "namespace:") {
      package <- substring(envir, 11L)
      return(getNamespace(package))
   }

   # otherwise, treat 'envir' directly as the name of a namespace
   getNamespace(envir)

})

#
# AppCommands.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

#
# This file was automatically generated -- please do not modify it by hand.
# Generator: src/cpp/generate-commands-accessor.R
#

.rs.setVar("appCommands", list(
   setWorkingDir = "setWorkingDir",
   switchFocusSourceConsole = "switchFocusSourceConsole",
   reformatCode = "reformatCode",
   reformatDocument = "reformatDocument",
   newSourceDoc = "newSourceDoc",
   newRNotebook = "newRNotebook",
   newTextDoc = "newTextDoc",
   newCDoc = "newCDoc",
   newCppDoc = "newCppDoc",
   newHeaderDoc = "newHeaderDoc",
   newMarkdownDoc = "newMarkdownDoc",
   newPythonDoc = "newPythonDoc",
   newShellDoc = "newShellDoc",
   newStanDoc = "newStanDoc",
   newHtmlDoc = "newHtmlDoc",
   newJavaScriptDoc = "newJavaScriptDoc",
   newCssDoc = "newCssDoc",
   newD3Doc = "newD3Doc",
   newSweaveDoc = "newSweaveDoc",
   newRMarkdownDoc = "newRMarkdownDoc",
   newQuartoDoc = "newQuartoDoc",
   newQuartoPres = "newQuartoPres",
   newRShinyApp = "newRShinyApp",
   newRHTMLDoc = "newRHTMLDoc",
   newRDocumentationDoc = "newRDocumentationDoc",
   newRPresentationDoc = "newRPresentationDoc",
   newSqlDoc = "newSqlDoc",
   newRPlumberDoc = "newRPlumberDoc",
   openSourceDoc = "openSourceDoc",
   openSourceDocNewColumn = "openSourceDocNewColumn",
   reopenSourceDocWithEncoding = "reopenSourceDocWithEncoding",
   saveSourceDoc = "saveSourceDoc",
   saveSourceDocAs = "saveSourceDocAs",
   saveSourceDocWithEncoding = "saveSourceDocWithEncoding",
   saveAllSourceDocs = "saveAllSourceDocs",
   renameSourceDoc = "renameSourceDoc",
   copySourceDocPath = "copySourceDocPath",
   closeSourceDoc = "closeSourceDoc",
   closeOtherSourceDocs = "closeOtherSourceDocs",
   closeAllSourceDocs = "closeAllSourceDocs",
   executeAllCode = "executeAllCode",
   sourceFile = "sourceFile",
   previewJS = "previewJS",
   previewSql = "previewSql",
   sourceActiveDocument = "sourceActiveDocument",
   sourceActiveDocumentWithEcho = "sourceActiveDocumentWithEcho",
   runDocumentFromServerDotR = "runDocumentFromServerDotR",
   executeCode = "executeCode",
   executeCodeWithoutMovingCursor = "executeCodeWithoutMovingCursor",
   executeCodeWithoutFocus = "executeCodeWithoutFocus",
   executeToCurrentLine = "executeToCurrentLine",
   executeFromCurrentLine = "executeFromCurrentLine",
   executeCurrentFunction = "executeCurrentFunction",
   executeCurrentSection = "executeCurrentSection",
   executeLastCode = "executeLastCode",
   executeCurrentLine = "executeCurrentLine",
   executeCurrentStatement = "executeCurrentStatement",
   executeCurrentParagraph = "executeCurrentParagraph",
   insertChunk = "insertChunk",
   insertChunkR = "insertChunkR",
   insertChunkBash = "insertChunkBash",
   insertChunkD3 = "insertChunkD3",
   insertChunkGraphViz = "insertChunkGraphViz",
   insertChunkJulia = "insertChunkJulia",
   insertChunkMermaid = "insertChunkMermaid",
   insertChunkPython = "insertChunkPython",
   insertChunkRCPP = "insertChunkRCPP",
   insertChunkStan = "insertChunkStan",
   insertChunkSQL = "insertChunkSQL",
   switchToChunkR = "switchToChunkR",
   switchToChunkBash = "switchToChunkBash",
   switchToChunkPython = "switchToChunkPython",
   switchToChunkRCPP = "switchToChunkRCPP",
   switchToChunkStan = "switchToChunkStan",
   switchToChunkSQL = "switchToChunkSQL",
   insertSection = "insertSection",
   executePreviousChunks = "executePreviousChunks",
   executeSubsequentChunks = "executeSubsequentChunks",
   executeCurrentChunk = "executeCurrentChunk",
   executeNextChunk = "executeNextChunk",
   executeSetupChunk = "executeSetupChunk",
   goToHelp = "goToHelp",
   goToDefinition = "goToDefinition",
   sourceNavigateBack = "sourceNavigateBack",
   sourceNavigateForward = "sourceNavigateForward",
   markdownHelp = "markdownHelp",
   openRStudioIDECheatSheet = "openRStudioIDECheatSheet",
   openDataVisualizationCheatSheet = "openDataVisualizationCheatSheet",
   openDataImportCheatSheet = "openDataImportCheatSheet",
   openPackageDevelopmentCheatSheet = "openPackageDevelopmentCheatSheet",
   openDataWranglingCheatSheet = "openDataWranglingCheatSheet",
   openDataTransformationCheatSheet = "openDataTransformationCheatSheet",
   openRMarkdownCheatSheet = "openRMarkdownCheatSheet",
   openRMarkdownReferenceGuide = "openRMarkdownReferenceGuide",
   openShinyCheatSheet = "openShinyCheatSheet",
   openRoxygenQuickReference = "openRoxygenQuickReference",
   openSparklyrCheatSheet = "openSparklyrCheatSheet",
   openPurrrCheatSheet = "openPurrrCheatSheet",
   browseCheatSheets = "browseCheatSheets",
   toggleRmdVisualMode = "toggleRmdVisualMode",
   enableProsemirrorDevTools = "enableProsemirrorDevTools",
   quartoRenderDocument = "quartoRenderDocument",
   knitDocument = "knitDocument",
   previewHTML = "previewHTML",
   publishHTML = "publishHTML",
   compilePDF = "compilePDF",
   compileNotebook = "compileNotebook",
   synctexSearch = "synctexSearch",
   activateSource = "activateSource",
   layoutZoomSource = "layoutZoomSource",
   printSourceDoc = "printSourceDoc",
   vcsFileLog = "vcsFileLog",
   vcsFileDiff = "vcsFileDiff",
   vcsFileRevert = "vcsFileRevert",
   popoutDoc = "popoutDoc",
   returnDocToMain = "returnDocToMain",
   quickAddNext = "quickAddNext",
   findReplace = "findReplace",
   findNext = "findNext",
   findPrevious = "findPrevious",
   findSelectAll = "findSelectAll",
   findFromSelection = "findFromSelection",
   findAll = "findAll",
   replaceAndFind = "replaceAndFind",
   findInFiles = "findInFiles",
   refreshFindInFiles = "refreshFindInFiles",
   newSourceColumn = "newSourceColumn",
   fold = "fold",
   unfold = "unfold",
   foldAll = "foldAll",
   unfoldAll = "unfoldAll",
   jumpToMatching = "jumpToMatching",
   selectToMatching = "selectToMatching",
   expandToMatching = "expandToMatching",
   addCursorAbove = "addCursorAbove",
   addCursorBelow = "addCursorBelow",
   moveLinesUp = "moveLinesUp",
   moveLinesDown = "moveLinesDown",
   expandToLine = "expandToLine",
   copyLinesDown = "copyLinesDown",
   joinLines = "joinLines",
   removeLine = "removeLine",
   splitIntoLines = "splitIntoLines",
   editLinesFromStart = "editLinesFromStart",
   toggleDocumentOutline = "toggleDocumentOutline",
   expandSelection = "expandSelection",
   shrinkSelection = "shrinkSelection",
   goToNextSection = "goToNextSection",
   goToPrevSection = "goToPrevSection",
   goToNextChunk = "goToNextChunk",
   goToPrevChunk = "goToPrevChunk",
   goToStartOfCurrentScope = "goToStartOfCurrentScope",
   goToEndOfCurrentScope = "goToEndOfCurrentScope",
   expandRaggedSelection = "expandRaggedSelection",
   extractFunction = "extractFunction",
   extractLocalVariable = "extractLocalVariable",
   commentUncomment = "commentUncomment",
   blockIndent = "blockIndent",
   blockOutdent = "blockOutdent",
   reindent = "reindent",
   reflowComment = "reflowComment",
   setWorkingDirToActiveDoc = "setWorkingDirToActiveDoc",
   codeCompletion = "codeCompletion",
   findUsages = "findUsages",
   editRmdFormatOptions = "editRmdFormatOptions",
   knitWithParameters = "knitWithParameters",
   clearKnitrCache = "clearKnitrCache",
   clearPrerenderedOutput = "clearPrerenderedOutput",
   notebookExpandAllOutput = "notebookExpandAllOutput",
   notebookCollapseAllOutput = "notebookCollapseAllOutput",
   notebookClearOutput = "notebookClearOutput",
   notebookClearAllOutput = "notebookClearAllOutput",
   notebookToggleExpansion = "notebookToggleExpansion",
   renameInScope = "renameInScope",
   insertRoxygenSkeleton = "insertRoxygenSkeleton",
   insertSnippet = "insertSnippet",
   yankRegion = "yankRegion",
   yankBeforeCursor = "yankBeforeCursor",
   yankAfterCursor = "yankAfterCursor",
   pasteLastYank = "pasteLastYank",
   insertAssignmentOperator = "insertAssignmentOperator",
   insertPipeOperator = "insertPipeOperator",
   openNextFileOnFilesystem = "openNextFileOnFilesystem",
   openPreviousFileOnFilesystem = "openPreviousFileOnFilesystem",
   toggleSoftWrapMode = "toggleSoftWrapMode",
   toggleRainbowParens = "toggleRainbowParens",
   toggleRainbowFencedDivs = "toggleRainbowFencedDivs",
   newProject = "newProject",
   newProjectFromTemplate = "newProjectFromTemplate",
   openProject = "openProject",
   openProjectInNewWindow = "openProjectInNewWindow",
   shareProject = "shareProject",
   openSharedProject = "openSharedProject",
   projectMru0 = "projectMru0",
   projectMru1 = "projectMru1",
   projectMru2 = "projectMru2",
   projectMru3 = "projectMru3",
   projectMru4 = "projectMru4",
   projectMru5 = "projectMru5",
   projectMru6 = "projectMru6",
   projectMru7 = "projectMru7",
   projectMru8 = "projectMru8",
   projectMru9 = "projectMru9",
   projectMru10 = "projectMru10",
   projectMru11 = "projectMru11",
   projectMru12 = "projectMru12",
   projectMru13 = "projectMru13",
   projectMru14 = "projectMru14",
   clearRecentProjects = "clearRecentProjects",
   closeProject = "closeProject",
   projectOptions = "projectOptions",
   projectSweaveOptions = "projectSweaveOptions",
   setWorkingDirToProjectDir = "setWorkingDirToProjectDir",
   consoleClear = "consoleClear",
   consoleFind = "consoleFind",
   interruptR = "interruptR",
   restartR = "restartR",
   restartRClearOutput = "restartRClearOutput",
   restartRRunAllChunks = "restartRRunAllChunks",
   terminateR = "terminateR",
   activateConsole = "activateConsole",
   activateConsolePane = "activateConsolePane",
   layoutZoomConsole = "layoutZoomConsole",
   layoutZoomConsolePane = "layoutZoomConsolePane",
   activateConsolePanePane = "activateConsolePanePane",
   consoleActivateR = "consoleActivateR",
   consoleActivatePython = "consoleActivatePython",
   newFolder = "newFolder",
   touchSourceDoc = "touchSourceDoc",
   touchTextDoc = "touchTextDoc",
   touchCDoc = "touchCDoc",
   touchCppDoc = "touchCppDoc",
   touchHeaderDoc = "touchHeaderDoc",
   touchMarkdownDoc = "touchMarkdownDoc",
   touchPythonDoc = "touchPythonDoc",
   touchShellDoc = "touchShellDoc",
   touchStanDoc = "touchStanDoc",
   touchHtmlDoc = "touchHtmlDoc",
   touchJavaScriptDoc = "touchJavaScriptDoc",
   touchCssDoc = "touchCssDoc",
   touchD3Doc = "touchD3Doc",
   touchSweaveDoc = "touchSweaveDoc",
   touchRMarkdownDoc = "touchRMarkdownDoc",
   touchQuartoDoc = "touchQuartoDoc",
   touchRShinyApp = "touchRShinyApp",
   touchRHTMLDoc = "touchRHTMLDoc",
   touchSqlDoc = "touchSqlDoc",
   uploadFile = "uploadFile",
   copyFile = "copyFile",
   copyFileTo = "copyFileTo",
   moveFiles = "moveFiles",
   exportFiles = "exportFiles",
   renameFile = "renameFile",
   deleteFiles = "deleteFiles",
   refreshFiles = "refreshFiles",
   activateFiles = "activateFiles",
   layoutZoomFiles = "layoutZoomFiles",
   goToWorkingDir = "goToWorkingDir",
   setAsWorkingDir = "setAsWorkingDir",
   copyFilesPaneCurrentDirectory = "copyFilesPaneCurrentDirectory",
   openFilesInSinglePane = "openFilesInSinglePane",
   openEachFileInColumns = "openEachFileInColumns",
   setWorkingDirToFilesPane = "setWorkingDirToFilesPane",
   showFolder = "showFolder",
   vcsDiff = "vcsDiff",
   vcsCommit = "vcsCommit",
   vcsRevert = "vcsRevert",
   vcsViewOnGitHub = "vcsViewOnGitHub",
   vcsBlameOnGitHub = "vcsBlameOnGitHub",
   vcsShowHistory = "vcsShowHistory",
   vcsRefresh = "vcsRefresh",
   vcsRefreshNoError = "vcsRefreshNoError",
   vcsOpen = "vcsOpen",
   vcsIgnore = "vcsIgnore",
   vcsPull = "vcsPull",
   vcsPullRebase = "vcsPullRebase",
   vcsPush = "vcsPush",
   vcsCleanup = "vcsCleanup",
   vcsAddFiles = "vcsAddFiles",
   vcsRemoveFiles = "vcsRemoveFiles",
   activateVcs = "activateVcs",
   layoutZoomVcs = "layoutZoomVcs",
   vcsResolve = "vcsResolve",
   showPdfExternal = "showPdfExternal",
   openHtmlExternal = "openHtmlExternal",
   saveHtmlPreviewAsLocalFile = "saveHtmlPreviewAsLocalFile",
   saveHtmlPreviewAs = "saveHtmlPreviewAs",
   refreshHtmlPreview = "refreshHtmlPreview",
   showHtmlPreviewLog = "showHtmlPreviewLog",
   refreshPresentation = "refreshPresentation",
   presentationFullscreen = "presentationFullscreen",
   presentationHome = "presentationHome",
   presentationNext = "presentationNext",
   presentationPrev = "presentationPrev",
   presentationEdit = "presentationEdit",
   presentationViewInBrowser = "presentationViewInBrowser",
   presentationSaveAsStandalone = "presentationSaveAsStandalone",
   clearPresentationCache = "clearPresentationCache",
   activatePresentation2 = "activatePresentation2",
   layoutZoomPresentation2 = "layoutZoomPresentation2",
   presentation2Home = "presentation2Home",
   presentation2Next = "presentation2Next",
   presentation2Prev = "presentation2Prev",
   presentation2Edit = "presentation2Edit",
   presentation2Present = "presentation2Present",
   presentation2PresentFromBeginning = "presentation2PresentFromBeginning",
   presentation2Print = "presentation2Print",
   refreshPresentation2 = "refreshPresentation2",
   showToolbar = "showToolbar",
   hideToolbar = "hideToolbar",
   toggleToolbar = "toggleToolbar",
   toggleSidebar = "toggleSidebar",
   toggleSidebarLocation = "toggleSidebarLocation",
   zoomActualSize = "zoomActualSize",
   zoomIn = "zoomIn",
   zoomOut = "zoomOut",
   jumpTo = "jumpTo",
   goToFileFunction = "goToFileFunction",
   switchToTab = "switchToTab",
   previousTab = "previousTab",
   nextTab = "nextTab",
   firstTab = "firstTab",
   lastTab = "lastTab",
   goToLine = "goToLine",
   toggleFullScreen = "toggleFullScreen",
   moveTabLeft = "moveTabLeft",
   moveTabRight = "moveTabRight",
   moveTabToFirst = "moveTabToFirst",
   moveTabToLast = "moveTabToLast",
   activatePresentation = "activatePresentation",
   activateCompilePDF = "activateCompilePDF",
   activateFindInFiles = "activateFindInFiles",
   activateSourceCpp = "activateSourceCpp",
   activateRMarkdown = "activateRMarkdown",
   activateDeployContent = "activateDeployContent",
   activateMarkers = "activateMarkers",
   activateSQLResults = "activateSQLResults",
   activateDatabricks = "activateDatabricks",
   historySendToSource = "historySendToSource",
   historySendToConsole = "historySendToConsole",
   searchHistory = "searchHistory",
   loadHistory = "loadHistory",
   saveHistory = "saveHistory",
   historyRemoveEntries = "historyRemoveEntries",
   clearHistory = "clearHistory",
   historyDismissResults = "historyDismissResults",
   historyShowContext = "historyShowContext",
   historyDismissContext = "historyDismissContext",
   activateHistory = "activateHistory",
   layoutZoomHistory = "layoutZoomHistory",
   activateConnections = "activateConnections",
   layoutZoomConnections = "layoutZoomConnections",
   clearWorkspace = "clearWorkspace",
   refreshWorkspace = "refreshWorkspace",
   saveWorkspace = "saveWorkspace",
   loadWorkspace = "loadWorkspace",
   importDatasetFromFile = "importDatasetFromFile",
   importDatasetFromURL = "importDatasetFromURL",
   importDatasetFromCsv = "importDatasetFromCsv",
   importDatasetFromCsvUsingReadr = "importDatasetFromCsvUsingReadr",
   importDatasetFromCsvUsingBase = "importDatasetFromCsvUsingBase",
   importDatasetFromSAV = "importDatasetFromSAV",
   importDatasetFromSAS = "importDatasetFromSAS",
   importDatasetFromStata = "importDatasetFromStata",
   importDatasetFromXLS = "importDatasetFromXLS",
   activateEnvironment = "activateEnvironment",
   layoutZoomEnvironment = "layoutZoomEnvironment",
   refreshEnvironment = "refreshEnvironment",
   freeUnusedMemory = "freeUnusedMemory",
   toggleShowMemoryUsage = "toggleShowMemoryUsage",
   showMemoryUsageReport = "showMemoryUsageReport",
   nextPlot = "nextPlot",
   previousPlot = "previousPlot",
   savePlotAsImage = "savePlotAsImage",
   savePlotAsPdf = "savePlotAsPdf",
   copyPlotToClipboard = "copyPlotToClipboard",
   zoomPlot = "zoomPlot",
   removePlot = "removePlot",
   clearPlots = "clearPlots",
   refreshPlot = "refreshPlot",
   activatePlots = "activatePlots",
   layoutZoomPlots = "layoutZoomPlots",
   showManipulator = "showManipulator",
   installPackage = "installPackage",
   updatePackages = "updatePackages",
   refreshPackages = "refreshPackages",
   activatePackages = "activatePackages",
   layoutZoomPackages = "layoutZoomPackages",
   packratBootstrap = "packratBootstrap",
   packratOptions = "packratOptions",
   packratBundle = "packratBundle",
   packratHelp = "packratHelp",
   packratClean = "packratClean",
   packratCheckStatus = "packratCheckStatus",
   renvHelp = "renvHelp",
   renvSnapshot = "renvSnapshot",
   renvRestore = "renvRestore",
   versionControlHelp = "versionControlHelp",
   versionControlShowRsaKey = "versionControlShowRsaKey",
   versionControlProjectSetup = "versionControlProjectSetup",
   showProfiler = "showProfiler",
   startProfiler = "startProfiler",
   stopProfiler = "stopProfiler",
   profileCode = "profileCode",
   profileCodeWithoutFocus = "profileCodeWithoutFocus",
   saveProfileAs = "saveProfileAs",
   openProfile = "openProfile",
   profileHelp = "profileHelp",
   gotoProfileSource = "gotoProfileSource",
   openProfileInBrowser = "openProfileInBrowser",
   macPreferences = "macPreferences",
   showOptions = "showOptions",
   showCodeOptions = "showCodeOptions",
   showConsoleOptions = "showConsoleOptions",
   showAppearanceOptions = "showAppearanceOptions",
   showPackagesOptions = "showPackagesOptions",
   showRMarkdownOptions = "showRMarkdownOptions",
   showSweaveOptions = "showSweaveOptions",
   showSpellingOptions = "showSpellingOptions",
   showVcsOptions = "showVcsOptions",
   showPublishingOptions = "showPublishingOptions",
   showPythonOptions = "showPythonOptions",
   modifyKeyboardShortcuts = "modifyKeyboardShortcuts",
   editCodeSnippets = "editCodeSnippets",
   showCommandPalette = "showCommandPalette",
   clearCommandPaletteMru = "clearCommandPaletteMru",
   newTerminal = "newTerminal",
   activateTerminal = "activateTerminal",
   renameTerminal = "renameTerminal",
   closeTerminal = "closeTerminal",
   closeAllTerminals = "closeAllTerminals",
   clearTerminalScrollbackBuffer = "clearTerminalScrollbackBuffer",
   previousTerminal = "previousTerminal",
   nextTerminal = "nextTerminal",
   showTerminalInfo = "showTerminalInfo",
   interruptTerminal = "interruptTerminal",
   sendTerminalToEditor = "sendTerminalToEditor",
   sendToTerminal = "sendToTerminal",
   showTerminalOptions = "showTerminalOptions",
   openNewTerminalAtEditorLocation = "openNewTerminalAtEditorLocation",
   openNewTerminalAtFilePaneLocation = "openNewTerminalAtFilePaneLocation",
   sendFilenameToTerminal = "sendFilenameToTerminal",
   setTerminalToCurrentDirectory = "setTerminalToCurrentDirectory",
   helpBack = "helpBack",
   helpForward = "helpForward",
   helpHome = "helpHome",
   helpSearch = "helpSearch",
   printHelp = "printHelp",
   clearHelpHistory = "clearHelpHistory",
   helpPopout = "helpPopout",
   refreshHelp = "refreshHelp",
   raiseException = "raiseException",
   raiseException2 = "raiseException2",
   activateHelp = "activateHelp",
   layoutZoomHelp = "layoutZoomHelp",
   showAboutDialog = "showAboutDialog",
   showSplashScreen = "showSplashScreen",
   copyRStudioVersion = "copyRStudioVersion",
   showLicenseDialog = "showLicenseDialog",
   checkForUpdates = "checkForUpdates",
   helpUsingRStudio = "helpUsingRStudio",
   helpKeyboardShortcuts = "helpKeyboardShortcuts",
   showRequestLog = "showRequestLog",
   logFocusedElement = "logFocusedElement",
   debugDumpContents = "debugDumpContents",
   debugImportDump = "debugImportDump",
   refreshSuperDevMode = "refreshSuperDevMode",
   viewShortcuts = "viewShortcuts",
   editUserPrefs = "editUserPrefs",
   viewAllPrefs = "viewAllPrefs",
   clearUserPrefs = "clearUserPrefs",
   activateTutorial = "activateTutorial",
   layoutZoomTutorial = "layoutZoomTutorial",
   tutorialPopout = "tutorialPopout",
   tutorialBack = "tutorialBack",
   tutorialForward = "tutorialForward",
   tutorialZoom = "tutorialZoom",
   tutorialRefresh = "tutorialRefresh",
   tutorialStop = "tutorialStop",
   tutorialHome = "tutorialHome",
   activateChat = "activateChat",
   layoutZoomChat = "layoutZoomChat",
   activateViewer = "activateViewer",
   layoutZoomViewer = "layoutZoomViewer",
   viewerPopout = "viewerPopout",
   viewerBack = "viewerBack",
   viewerForward = "viewerForward",
   viewerZoom = "viewerZoom",
   viewerRefresh = "viewerRefresh",
   viewerSaveAllAndRefresh = "viewerSaveAllAndRefresh",
   viewerStop = "viewerStop",
   viewerClear = "viewerClear",
   viewerClearAll = "viewerClearAll",
   viewerSaveAsImage = "viewerSaveAsImage",
   viewerSaveAsWebPage = "viewerSaveAsWebPage",
   viewerCopyToClipboard = "viewerCopyToClipboard",
   viewerEditSource = "viewerEditSource",
   newSession = "newSession",
   suspendSession = "suspendSession",
   quitSession = "quitSession",
   forceQuitSession = "forceQuitSession",
   updateCredentials = "updateCredentials",
   diagnosticsReport = "diagnosticsReport",
   openDeveloperConsole = "openDeveloperConsole",
   reloadUi = "reloadUi",
   showGpuDiagnostics = "showGpuDiagnostics",
   showA11yDiagnostics = "showA11yDiagnostics",
   showLogFiles = "showLogFiles",
   rstudioSupport = "rstudioSupport",
   rstudioCommunityForum = "rstudioCommunityForum",
   rstudioAgreement = "rstudioAgreement",
   showWarningBar = "showWarningBar",
   signOut = "signOut",
   loadServerHome = "loadServerHome",
   clearBuild = "clearBuild",
   findBuild = "findBuild",
   buildAll = "buildAll",
   buildIncremental = "buildIncremental",
   buildFull = "buildFull",
   devtoolsLoadAll = "devtoolsLoadAll",
   serveQuartoSite = "serveQuartoSite",
   cleanAll = "cleanAll",
   buildSourcePackage = "buildSourcePackage",
   buildBinaryPackage = "buildBinaryPackage",
   roxygenizePackage = "roxygenizePackage",
   checkPackage = "checkPackage",
   testPackage = "testPackage",
   testTestthatFile = "testTestthatFile",
   testShinytestFile = "testShinytestFile",
   stopBuild = "stopBuild",
   buildToolsProjectSetup = "buildToolsProjectSetup",
   activateBuild = "activateBuild",
   layoutZoomBuild = "layoutZoomBuild",
   newConnection = "newConnection",
   removeConnection = "removeConnection",
   disconnectConnection = "disconnectConnection",
   refreshConnection = "refreshConnection",
   undoDummy = "undoDummy",
   redoDummy = "redoDummy",
   cutDummy = "cutDummy",
   copyDummy = "copyDummy",
   pasteDummy = "pasteDummy",
   pasteWithIndentDummy = "pasteWithIndentDummy",
   selectAllDummy = "selectAllDummy",
   mru0 = "mru0",
   mru1 = "mru1",
   mru2 = "mru2",
   mru3 = "mru3",
   mru4 = "mru4",
   mru5 = "mru5",
   mru6 = "mru6",
   mru7 = "mru7",
   mru8 = "mru8",
   mru9 = "mru9",
   mru10 = "mru10",
   mru11 = "mru11",
   mru12 = "mru12",
   mru13 = "mru13",
   mru14 = "mru14",
   clearRecentFiles = "clearRecentFiles",
   debugBreakpoint = "debugBreakpoint",
   debugClearBreakpoints = "debugClearBreakpoints",
   debugContinue = "debugContinue",
   debugStop = "debugStop",
   debugStep = "debugStep",
   debugStepInto = "debugStepInto",
   debugFinish = "debugFinish",
   debugHelp = "debugHelp",
   errorsMessage = "errorsMessage",
   errorsTraceback = "errorsTraceback",
   errorsBreak = "errorsBreak",
   showDiagnosticsActiveDocument = "showDiagnosticsActiveDocument",
   showDiagnosticsProject = "showDiagnosticsProject",
   reloadShinyApp = "reloadShinyApp",
   shinyRunInPane = "shinyRunInPane",
   shinyRunInViewer = "shinyRunInViewer",
   shinyRunInBrowser = "shinyRunInBrowser",
   shinyRecordTest = "shinyRecordTest",
   shinyRunAllTests = "shinyRunAllTests",
   shinyCompareTest = "shinyCompareTest",
   reloadPlumberAPI = "reloadPlumberAPI",
   plumberRunInPane = "plumberRunInPane",
   plumberRunInViewer = "plumberRunInViewer",
   plumberRunInBrowser = "plumberRunInBrowser",
   rsconnectDeploy = "rsconnectDeploy",
   rsconnectConfigure = "rsconnectConfigure",
   rsconnectManageAccounts = "rsconnectManageAccounts",
   browseAddins = "browseAddins",
   startJob = "startJob",
   sourceAsJob = "sourceAsJob",
   clearBackgroundJobs = "clearBackgroundJobs",
   activateBackgroundJobs = "activateBackgroundJobs",
   runSelectionAsBackgroundJob = "runSelectionAsBackgroundJob",
   startWorkbenchJob = "startWorkbenchJob",
   sourceAsWorkbenchJob = "sourceAsWorkbenchJob",
   runSelectionAsWorkbenchJob = "runSelectionAsWorkbenchJob",
   activateWorkbenchJobs = "activateWorkbenchJobs",
   sortWorkbenchJobsRecorded = "sortWorkbenchJobsRecorded",
   sortWorkbenchJobsState = "sortWorkbenchJobsState",
   checkSpelling = "checkSpelling",
   wordCount = "wordCount",
   layoutZoomCurrentPane = "layoutZoomCurrentPane",
   layoutEndZoom = "layoutEndZoom",
   layoutConsoleOnLeft = "layoutConsoleOnLeft",
   layoutConsoleOnRight = "layoutConsoleOnRight",
   paneLayout = "paneLayout",
   restoreDefaultPaneAndTabLayout = "restoreDefaultPaneAndTabLayout",
   restoreDefaultPaneAndTabLayoutNoPrompt = "restoreDefaultPaneAndTabLayoutNoPrompt",
   maximizeConsole = "maximizeConsole",
   maximizeSource = "maximizeSource",
   maximizeTabSet1 = "maximizeTabSet1",
   maximizeTabSet2 = "maximizeTabSet2",
   toggleEditorTokenInfo = "toggleEditorTokenInfo",
   layoutZoomLeftColumn = "layoutZoomLeftColumn",
   layoutZoomRightColumn = "layoutZoomRightColumn",
   layoutZoomSidebar = "layoutZoomSidebar",
   focusLeftSeparator = "focusLeftSeparator",
   focusRightSeparator = "focusRightSeparator",
   focusCenterSeparator = "focusCenterSeparator",
   focusSourceColumnSeparator = "focusSourceColumnSeparator",
   focusSidebarSeparator = "focusSidebarSeparator",
   showFileMenu = "showFileMenu",
   showEditMenu = "showEditMenu",
   showCodeMenu = "showCodeMenu",
   showViewMenu = "showViewMenu",
   showPlotsMenu = "showPlotsMenu",
   showSessionMenu = "showSessionMenu",
   showBuildMenu = "showBuildMenu",
   showDebugMenu = "showDebugMenu",
   showProfileMenu = "showProfileMenu",
   showToolsMenu = "showToolsMenu",
   showHelpMenu = "showHelpMenu",
   toggleScreenReaderSupport = "toggleScreenReaderSupport",
   toggleTabKeyMovesFocus = "toggleTabKeyMovesFocus",
   showAccessibilityOptions = "showAccessibilityOptions",
   focusMainToolbar = "focusMainToolbar",
   speakEditorLocation = "speakEditorLocation",
   focusConsoleOutputEnd = "focusConsoleOutputEnd",
   focusNextPane = "focusNextPane",
   focusPreviousPane = "focusPreviousPane",
   showAccessibilityHelp = "showAccessibilityHelp",
   copilotDiagnostics = "copilotDiagnostics",
   copilotSignIn = "copilotSignIn",
   copilotSignOut = "copilotSignOut",
   copilotStatus = "copilotStatus",
   copilotRequestCompletions = "copilotRequestCompletions",
   copilotAcceptNextWord = "copilotAcceptNextWord",
   copilotToggleAutomaticCompletions = "copilotToggleAutomaticCompletions",
   layoutZoomDatabricks = "layoutZoomDatabricks",
   showDomElements = "showDomElements",
   showShortcutCommand = "showShortcutCommand",
   crashDesktopApplication = "crashDesktopApplication"
))

# To test here, try typing 'Cmd + Enter' and ensure that the cursor
# executes and jumps from the consecutively numbered blocks.
library(dplyr)
library(data.table)

# 1
{
   1234 %>%
      # a comment
      rnorm() %>%
      
      sum()
}

# 2
{
   1 + 2
}

# 3
apple <- function(banana)
{
   print(1 +
            2 +
            3)
}

# 4
1 + 2

# 5
1234 %>% {
   1
   2
   3
} %>% sum()

# 6
1 + 2

# 7
list(
   1,
   list(
      2
   )
)

# 8
foo <- function(a, b, c) {
   
}

# 9
foo <- function(a, b, c)
{
   a <- 1
   b <- 2
}

# 10
f <- function(
   a = 1,
   b = 2,
   c = 3,
   d = list(
      x = 'x',
      y = 'y'
   ),
   e = 5
) {
   
}

# 11
x <- f(a = 1,
       b = 2,
       c = 3#,
       # d = 4
)

# 12: data.table style (note: two separate statements)
dt <- data.table(mtcars)
dt[ , sequence := seq_len( nrow( dt ) )

    ][ , normal := rnorm( nrow( dt ) )
       
       ][ , uniform := runif( nrow( dt ) ) ]

# 13: multi-line strings
mlstring <- "first
second
third"

# 14: roxygen comments could confuse the multiline
# expression system; e.g.
#' [name](link)
statement <- 1 + 1

# 15: certain pipe styles
mtcars %>%
   filter(
      mpg > 20
   ) %>%
   select(everything())

# 16: certain pipe styles
mtcars %>%
   filter(
      mpg > 20) %>%
   select(everything())

# 17: more pipes
mtcars %>%
   filter(
      mpg > 20) %>% select(everything())

# 18: more pipes
mtcars %>% 
   mutate(
      x1 = "ok here") %>% 
   mutate(
      x2 = "not ok") # use Ctrl + Enter in this line

# 19: multi line rawstring
r"(
 a
 b
 c
)"

# 20: multi line string preceded with opening bracket
c("a
b"
)

# 21: roxygen with function link and single-line function
#' similar to [foo()]
#' @return NULL
f <- function() {}

# 22: roxygen with function link and multi-line function
#' similar to [foo()]
#' @return NULL
f <- function() {
}

# cursor should end here after executing all lines
EOF

#
# NotebookErrors.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addErrorHandlerFunction("handleNotebookError", "notebook", function()
{
   .rs.recordTraceback(FALSE, function(err) {
      .Call("rs_recordNotebookError", err, PACKAGE = "(embedding)")
   })
})

.rs.addFunction("registerNotebookErrorHandler", function()
{
   options(error = .rs.handleNotebookError)
})

#
# SessionInstallRTools.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("findRtoolsInstaller", function(version, url)
{
   tryCatch(
      .rs.findRtoolsInstallerImpl(url, version),
      error = function(cnd) {
         .rs.findRtoolsInstallerFallback(version)
      }
   )
})

.rs.addFunction("findRtoolsInstallerImpl", function(url, version)
{
   # check whether the URL selected is associated with a CRAN mirror;
   # if not, select a "real" CRAN mirror instead
   mirrors <- utils::getCRANmirrors(local.only = TRUE)$URL
   matches <- vapply(mirrors, function(mirror) {
      .rs.startsWith(url, mirror)
   }, FUN.VALUE = logical(1))
   
   if (!any(matches)) {
      fmt <- "https://cloud.r-project.org/bin/windows/Rtools/rtools%s/rtools.html"
      shortVersion <- gsub(".", "", version, fixed = TRUE)
      url <- sprintf(fmt, shortVersion)
   }
   
   # download contents of home page
   destfile <- tempfile("rtools-home-", fileext = ".html")
   download.file(url, destfile, mode = "wb", quiet = TRUE)
   contents <- paste(readLines(destfile), collapse = "\n")
   
   # search for links included in the page
   reLinkPattern <- 'href="([^"]+)"'
   matches <- .rs.regexMatches(reLinkPattern, contents)
   
   # keep those which appear to be rtools links
   links <- grep("[.]exe$", matches, value = TRUE, perl = TRUE)
   links <- grep("rtools", links, value = TRUE, perl = TRUE)
   
   # TODO: support aarch64 builds of R on Windows
   links <- grep("aarch64", links, perl = TRUE, value = TRUE, invert = TRUE)
   if (length(links) == 0L)
      stop("couldn't determine Rtools installer URL")
   
   rtoolsInstallerUrl <- links[[1]]
   file.path(dirname(url), rtoolsInstallerUrl)
})

.rs.addFunction("findRtoolsInstallerFallback", function(version)
{
   if (version == "4.5")
   {
      "https://rstudio.org/links/rtools45"
   }
   else if (version == "4.4")
   {
      "https://rstudio.org/links/rtools44"
   }
   else if (version == "4.3")
   {
      "https://rstudio.org/links/rtools43"
   }
   else
   {
      stop("don't know how to download and install Rtools ", version)
   }
})

#
# SessionPythonEnvironments.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("python_active_interpreter", function()
{
   pythonPath <- Sys.getenv("RETICULATE_PYTHON", unset = NA)
   
   if (is.na(pythonPath))
      pythonPath <- Sys.getenv("RETICULATE_PYTHON_FALLBACK", unset = NA)
   
   info <- if (is.na(pythonPath))
   {
      .rs.python.invalidInterpreter(
         path = pythonPath,
         type = NULL,
         reason = "RETICULATE_PYTHON and RETICULATE_PYTHON_FALLBACK are unset."
      )
   }
   else
   {
      .rs.python.getPythonInfo(pythonPath, strict = TRUE)
   }
   
   .rs.scalarListFromList(info)
})

.rs.addJsonRpcHandler("python_find_interpreters", function()
{
   .rs.python.findPythonInterpreters()
})

.rs.addJsonRpcHandler("python_interpreter_info", function(pythonPath)
{
   .rs.python.describeInterpreter(pythonPath)
})

.rs.addFunction("python.activeInterpreterPath", function()
{
   if ("reticulate" %in% loadedNamespaces())
   {
      if (reticulate::py_available(initialize = FALSE))
      {
         return(path.expand(reticulate::py_exe()))
      }
   }
   
   pythonInfo <- .rs.rpc.python_active_interpreter()
   if (!is.na(pythonInfo$path))
      return(path.expand(pythonInfo$path))
   
   ""
})

.rs.addFunction("python.findCondaForEnvironment", function(envPath)
{
   # locate history file
   historyFile <- file.path(envPath, "conda-meta/history")
   if (!file.exists(historyFile))
      return("")
   
   # read first few lines
   contents <- readLines(historyFile, n = 2L, warn = FALSE)
   if (length(contents) < 2L)
      return("")
   
   # parse conda path
   line <- substring(contents[2L], 8L)
   index <- regexpr(" ", line, fixed = TRUE)
   if (index == -1L)
      return("")
   
   conda <- substring(line, 1L, index - 1L)
   if (.rs.platform.isWindows)
      conda <- file.path(dirname(conda), "conda.exe")
   
   # prefer condabin if it exists
   condabin <- file.path(dirname(conda), "../condabin", basename(conda))
   if (file.exists(condabin))
      conda <- condabin
   
   # bail if conda wasn't found
   if (!file.exists(conda))
      return("")
   
   .rs.canonicalizePath(conda)
   
})

.rs.addFunction("python.findWindowsPython", function()
{
   # if `py` and `python` are not available, nothing we can do
   pythonCommands <- c("py", "python3", "python")
   available <- nzchar(Sys.which(pythonCommands))
   
   if (!any(available))
      return("")
   else
      pythonCommand <- pythonCommands[available][1]
   
   # NOTE: ideally, we would just parse the output of 'py --list-paths',
   # but for whatever reason the '*' indicating the default version of
   # Python is omitted when run from RStudio, so we try to explicitly
   # run Python here and then ask where the executable lives.
   #
   # We pass '-E' here just to avoid things like PYTHONPATH potentially
   # influencing how the python session is launched
   pythonPath <- .rs.tryCatch(
      system2(
         command = pythonCommand,
         args    = c("-E", "-Xutf8"),
         input   = "import sys; print(sys.executable)",
         stdout  = TRUE,
         stderr  = TRUE
      )
   )
   
   if (inherits(pythonPath, "error"))
      return("")
   
   Encoding(pythonPath) <- "UTF-8"
   pythonPath
})

.rs.addFunction("python.configuredInterpreterPath", function(projectDir, checkProjectEnvs)
{
   # on Windows, check if PY_PYTHON is defined; if it is, we should use 'py'
   # to determine the version of python to be used
   if (.rs.platform.isWindows)
   {
      pyPython <- Sys.getenv("PY_PYTHON", unset = NA)
      if (!is.na(pyPython))
      {
         python <- .rs.python.findWindowsPython()
         if (file.exists(python))
            return(python)
      }
   }
   
   # check some pre-defined environment variables
   vars <- c("RENV_PYTHON", "RETICULATE_PYTHON", "RETICULATE_PYTHON_FALLBACK")
   for (var in vars)
   {
      value <- Sys.getenv(var, unset = NA)
      if (!is.na(value))
         return(value)
   }
   
   # check for an explicit Python configured for the project
   projectPrefsPython <- .rs.readProjectPref("python_path")
   if (is.character(projectPrefsPython) && file.exists(projectPrefsPython))
      return(path.expand(projectPrefsPython))
   
   # if this project has a local interpreter, use it
   if (checkProjectEnvs && !is.null(projectDir))
   {
      projectPython <- .rs.python.projectInterpreterPath(projectDir)
      if (file.exists(projectPython))
         return(projectPython)
   }
   
   # check for a global default Python configured
   prefsPython <- .rs.readUiPref("python_path")
   if (is.character(prefsPython) && file.exists(prefsPython))
      return(path.expand(prefsPython))
   
   # no interpreter configured; return "" as default
   ""
   
})

.rs.addFunction("python.fallbackInterpreterPath", function()
{
   # on Windows, help users find a default version of Python if possible
   if (.rs.platform.isWindows)
   {
      pythonPath <- .rs.python.findWindowsPython()
      if (file.exists(pythonPath))
         return(pythonPath)
   }
   
   # look for python + python3 on the PATH
   if (!.rs.platform.isWindows)
   {
      python3 <- Sys.which("python3")
      if (nzchar(python3) && python3 != "/usr/bin/python3")
         return(python3)
      
      python <- Sys.which("python")
      if (nzchar(python) && python != "/usr/bin/python")
      {
         info <- .rs.python.interpreterInfo(python, NULL)
         version <- numeric_version(info$version, strict = FALSE)
         if (!is.na(version) && version >= "3.2")
            return(python)
      }
   }
   
   # if the user has Anaconda installed, then try auto-activating
   # the base environment of that Anaconda installation
   conda <- .rs.python.findCondaBinary()
   if (file.exists(conda))
   {
      pythonPath <- if (.rs.platform.isWindows) "../python.exe" else "../bin/python"
      python <- file.path(dirname(conda), pythonPath)
      if (file.exists(python))
         return(python)
   }
   
   # no python found; return empty string placeholder
   ""
   
})

.rs.addFunction("python.projectInterpreterPath", function(projectDir)
{
   # check for virtual environments / conda environments
   pythonSuffixes <- if (.rs.platform.isWindows)
      c("Scripts/python.exe", "python.exe")
   else
      c("bin/python3", "bin/python")
   
   # look within all top-level directories for an environment
   envPaths <- list.dirs(
      path = projectDir,
      full.names = TRUE,
      recursive = FALSE
   )
   
   for (envPath in envPaths)
   {
      for (pythonSuffix in pythonSuffixes)
      {
         pythonPath <- file.path(envPath, pythonSuffix)
         if (file.exists(pythonPath))
            return(pythonPath)
      }
   }
   
   ""
})

.rs.addFunction("python.initialize", function(projectDir)
{
   # find path to python interpreter for this project
   checkProjectEnvs <- identical(.rs.readUiPref("python_project_environment_automatic_activate"), TRUE)
   pythonPath <- .rs.python.configuredInterpreterPath(projectDir, checkProjectEnvs)
   if (!file.exists(pythonPath))
      return()
   
   # normalize path (avoid following symlinks)
   pythonPath <- file.path(
      normalizePath(dirname(pythonPath), winslash = "/", mustWork = FALSE),
      basename(pythonPath)
   )
   
   # add the Python directory to the PATH
   pythonBin <- dirname(pythonPath)
   .rs.prependToPath(pythonBin)
   
   # if we have a Scripts directory, place that on the PATH as well
   # (primarily for Windows + conda environments)
   scriptsPath <- file.path(pythonBin, "Scripts")
   if (file.exists(scriptsPath))
      .rs.prependToPath(scriptsPath)
   
   pythonInfo <- .rs.python.getPythonInfo(pythonPath, strict = TRUE)
   
   # if this is a virtual environment, set VIRTUAL_ENV
   if (identical(pythonInfo$type, "virtualenv"))
   {
      envPath <- dirname(dirname(pythonPath))
      Sys.setenv(VIRTUAL_ENV = envPath)
   }
   
   # if this is a conda environment, set CONDA_PREFIX
   if (identical(pythonInfo$type, "conda"))
   {
      condaPrefix <- pythonBin
      if (!.rs.platform.isWindows)
         condaPrefix <- dirname(condaPrefix)
      
      Sys.setenv(CONDA_PREFIX = condaPrefix)
      
      # also ensure that conda is placed on the PATH
      condaPath <- .rs.python.findCondaForEnvironment(condaPrefix)
      if (file.exists(condaPath))
         .rs.prependToPath(dirname(condaPath))
   }
   
   # also set RETICULATE_PYTHON_FALLBACK so this python is used by default
   Sys.setenv(RETICULATE_PYTHON_FALLBACK = pythonPath)
   
   # return path to python
   invisible(pythonPath)
})

.rs.addFunction("python.execute", function(python, code)
{
   python <- normalizePath(python, winslash = "/", mustWork = TRUE)
   
   args <- c("-E", "-c", shQuote(code))
   result <- suppressWarnings(
      system2(python, args, stdout = TRUE, stderr = TRUE)
   )
   
   # propagate failure as error
   status <- .rs.nullCoalesce(attr(result, "status", exact = TRUE), 0L)
   if (!identical(status, 0L))
      .rs.stopf("error retrieving Python version [error code %i]", status)
   
   paste(result, collapse = "\n")
})

.rs.addFunction("python.getPythonVersion", function(pythonPath)
{
   .rs.python.execute(pythonPath, "import platform; print(platform.python_version())")
})

.rs.addFunction("python.getPythonDescription", function(pythonPath)
{
   .rs.python.execute(pythonPath, "import sys; print(sys.version)")
})

.rs.addFunction("python.getPythonInfo", function(path, strict)
{
   # default to concluding python binary path == requested path
   pythonPath <- path
   
   # if this is the path to an existing file, use the directory path
   info <- file.info(path, extra_cols = FALSE)
   if (identical(info$isdir, FALSE))
      path <- dirname(path)
   
   # if this is the path to the 'root' of an environment,
   # start from the associated bin / scripts directory
   binExt <- if (.rs.platform.isWindows) "Scripts" else "bin"
   binPath <- file.path(path, binExt)
   if (file.exists(binPath))
      path <- binPath
   
   # now form the python path
   if (!strict)
   {
      exe <- if (.rs.platform.isWindows) "python.exe" else "python"
      pythonPath <- file.path(path, exe)
   }
   
   # if this python doesn't exist, bail
   if (!file.exists(pythonPath))
   {
      info <- .rs.python.invalidInterpreter(
         path = pythonPath,
         type = NULL,
         reason = "There is no Python interpreter available at this location."
      )
      
      return(info)
   }
   
   # check for conda environment
   # (look for folders normally seen in conda installations)
   condaFiles <- c("../conda-meta", "../condabin")
   condaPaths <- file.path(path, condaFiles)
   if (any(file.exists(condaPaths)))
      return(.rs.python.interpreterInfo(pythonPath, "conda"))
   
   # check for virtual environment
   # (look for files normally seen in virtual envs)
   venvFiles <- c("activate", "pyvenv.cfg", "../pyvenv.cfg")
   venvPaths <- file.path(path, venvFiles)
   if (any(file.exists(venvPaths)))
      return(.rs.python.interpreterInfo(pythonPath, "virtualenv"))
   
   # default to assuming a system interpreter
   .rs.python.interpreterInfo(pythonPath, "system")
   
})

.rs.addFunction("python.interpreterInfo", function(path, type)
{
   # prefer UTF-8 path when possible
   path <- enc2utf8(path)
   
   # prefer unix-style slashes
   path <- chartr("\\", "/", path)
   
   # defaults for version, description
   valid <- TRUE
   version <- "[unknown]"
   description <- "[unknown]"
   
   # determine interpreter version
   version <- tryCatch(
      .rs.python.getPythonVersion(path),
      error = function(e) {
         valid <<- FALSE
         conditionMessage(e)
      }
   )
   
   # determine interpreter description
   description <- tryCatch(
      .rs.python.getPythonDescription(path),
      error = function(e) {
         valid <<- FALSE
         conditionMessage(e)
      }
   )
   
   list(
      path        = .rs.createAliasedPath(path),
      type        = type,
      version     = version,
      description = description,
      valid       = valid,
      reason      = NULL
   )
})

.rs.addFunction("python.invalidInterpreter", function(path, type, reason)
{
   list(
      path        = .rs.createAliasedPath(path),
      type        = type,
      version     = NULL,
      description = NULL,
      valid       = FALSE,
      reason      = reason
   )
})

.rs.addFunction("python.findPythonInterpreters", function()
{
   # get interpreters from all known sources
   interpreters <- unname(c(
      .rs.python.findPythonProjectInterpreters(),
      .rs.python.findPythonSystemInterpreters(),
      .rs.python.findPythonInterpretersInKnownLocations(),
      .rs.python.findPythonPyenvInterpreters(),
      .rs.python.findPythonVirtualEnvironments(),
      .rs.python.findPythonCondaEnvironments()
   ))
   
   default <- Sys.getenv("RETICULATE_PYTHON", unset = "")
   
   list(
      python_interpreters = .rs.scalarListFromList(interpreters),
      default_interpreter = .rs.scalar(default)
   )
   
})

.rs.addFunction("python.findPythonProjectInterpreters", function()
{
   projectDir <- .rs.getProjectDirectory()
   if (is.null(projectDir))
      return(list())
   
   candidateDirs <- list.files(
      path = projectDir,
      all.files = TRUE,
      full.names = TRUE
   )
   
   pythonSuffix <- if (.rs.platform.isWindows) "Scripts/python.exe" else "bin/python"
   candidatePaths <- file.path(candidateDirs, pythonSuffix)
   pythonPaths <- Filter(file.exists, candidatePaths)
   lapply(pythonPaths, .rs.python.getPythonInfo, strict = TRUE)
})

.rs.addFunction("python.findPythonSystemInterpreters", function()
{
   interpreters <- list()
   
   # look for interpreters on the PATH
   paths <- strsplit(Sys.getenv("PATH"), split = .Platform$path.sep, fixed = TRUE)[[1]]
   paths <- unique(normalizePath(paths, winslash = "/", mustWork = FALSE))
   
   for (path in paths)
   {
      
      # skip fake broken Windows Python interpreters
      skip <-
         .rs.platform.isWindows &&
         grepl("AppData\\Local\\Microsoft\\WindowsApps", path, fixed = TRUE)
      
      if (skip)
         next
      
      # create pattern matching interpreter paths
      pattern <- if (.rs.platform.isWindows)
         "^python[[:digit:].]*exe$"
      else
         "^python[[:digit:].]*$"
      
      # look for python installations
      pythons <- list.files(
         path       = path,
         pattern    = pattern,
         full.names = TRUE
      )
      
      # loop over interpreters and add them
      for (python in pythons)
      {
         # skip simple symlinks. the intention here is to avoid adding
         # all of python, python3, and python3.9 if they all ultimately
         # resolve to the same python executable
         if (!.rs.platform.isWindows)
         {
            link <- Sys.readlink(python)
            if (grepl(pattern, link))
               next
         }
         
         # add the interpreter
         info <- .rs.python.getPythonInfo(python, strict = TRUE)
         interpreters[[length(interpreters) + 1]] <- info
      }
      
   }
   
   interpreters
   
})

.rs.addFunction("python.findPythonInterpretersInKnownLocations", function()
{
   # set of discovered paths
   pythonPaths <- character()
   
   # Python root paths we'll search in
   roots <- if (.rs.platform.isWindows) {
      
      # find path to Windows local app data folder
      localAppData <- local({
         
         path <- Sys.getenv("LOCALAPPDATA", unset = NA)
         if (!is.na(path))
            return(path)
         
         profile <- Sys.getenv("USERPROFILE", unset = NA)
         if (!is.na(profile))
            return(file.path(profile, "AppData\\Local"))
         
         ""
         
      })
      
      # system-installs of Python might be in one of these folders
      drive <- Sys.getenv("SYSTEMDRIVE", unset = "C:")
      suffixes <- c("/", "/Program Files", "/Program Files (x86)")
      
      c(
         paste0(drive, suffixes),
         file.path(localAppData, "Programs/Python")
      )
      
   } else {
      
      c(
         "/opt/python",
         "/opt/local/python",
         "/usr/local/opt/python"
      )
      
   }
   
   # also include those defined via option
   roots <- c(roots, getOption("rstudio.python.installationPath"))
   
   # check and see if any of these roots point directly
   # to a particular version of Python.
   #
   # on Windows, Python is typically installed in 'Scripts/python.exe'
   # for virtual environments, and 'python.exe' for Anaconda + standalone
   suffixes <- if (.rs.platform.isWindows) {
      c("Scripts/python.exe", "python.exe")
   } else {
      c("bin/python3", "bin/python")
   }
   
   paths <- vapply(roots, function(root) {
      paths <- file.path(root, suffixes)
      paths[file.exists(paths)][1]
   }, FUN.VALUE = character(1))
   
   # collect the discovered python paths, if any
   exists <- !is.na(paths)
   pythonPaths <- c(pythonPaths, paths[exists])
   roots <- roots[!exists]
   
   # treat any remaining root directories as versioned roots
   roots <- list.files(roots, full.names = TRUE)
   
   # check and see if any of these roots point directly
   # to a particular version of Python
   paths <- vapply(roots, function(root) {
      paths <- file.path(root, suffixes)
      paths[file.exists(paths)][1]
   }, FUN.VALUE = character(1))
   
   # collect the discovered python paths, if any
   exists <- !is.na(paths)
   pythonPaths <- c(pythonPaths, paths[exists])
   
   # return the discovered paths
   lapply(pythonPaths, .rs.python.getPythonInfo, strict = TRUE)
   
})

.rs.addFunction("python.findPythonPyenvInterpreters", function()
{
   root <- Sys.getenv("PYENV_ROOT", unset = "~/.pyenv")
   
   # on Windows, Python interpreters are normally part of pyenv-windows
   if (.rs.platform.isWindows)
      root <- file.path(root, "pyenv-win")
   
   # get path to roots of Python installations
   versionsPath <- file.path(root, "versions")
   pythonRoots <- list.files(versionsPath, full.names = TRUE)
   
   # form path to Python binaries
   stem <- if (.rs.platform.isWindows) "python.exe" else "bin/python"
   pythonPaths <- file.path(pythonRoots, stem)
   
   # exclude anything that doesn't exist for some reason
   pythonPaths <- pythonPaths[file.exists(pythonPaths)]
   
   # get interpreter info for each found
   lapply(pythonPaths, .rs.python.getPythonInfo, strict = TRUE)
   
})

.rs.addFunction("python.findCondaBinary", function()
{
   # read from option (primarily for internal use / testing)
   conda <- getOption("rstudio.conda.binary")
   if (!is.null(conda))
   {
      conda <- Sys.which(conda)
      if (nzchar(conda))
         return(conda)
   }
   
   # look on PATH
   conda <- Sys.which("conda")
   if (nzchar(conda))
      return(conda)
   
   # look in some default locations
   if (.rs.platform.isWindows)
   {
      condaRoots <- c(
         file.path(Sys.getenv("USERPROFILE"), "anaconda3"),
         file.path(Sys.getenv("SYSTEMDRIVE"), "ProgramData/anaconda3")
      )
   }
   else
   {
      condaRoots <- c(
         "~/opt/anaconda3",
         "~/opt/miniconda3",
         "~/opt/miniforge3",
         "~/anaconda3",
         "~/miniconda3",
         "~/miniforge3",
         "/anaconda3",
         "/miniconda3",
         "/miniforge3"
      )
   }
   
   condaSuffix <- if (.rs.platform.isWindows)
      "condabin/conda.bat"
   else
      "condabin/conda"
   
   condaPaths <- file.path(condaRoots, condaSuffix)
   for (condaPath in condaPaths)
      if (file.exists(condaPath))
         return(path.expand(condaPath))
   
   ""
   
})

.rs.addFunction("python.findPythonCondaEnvironments", function()
{
   # look for conda
   conda <- .rs.python.findCondaBinary()
   if (!file.exists(conda))
      return(NULL)
   
   # ask it for environments
   args <- c("env", "list", "--json", "--quiet")
   tmp <- tempfile()
   output <- system2(conda, args, stdout = TRUE, stderr = tmp)
   
   status <- .rs.nullCoalesce(attr(output, "status", exact = TRUE), 0L)
   if (!identical(status, 0L)) {
      errors <- paste(readLines(tmp), collapse = "\n")
      .rs.stopf("Error executing %s %s:\n%s", conda, paste(args, collapse = " "), errors)
   }
   json <- .rs.fromJSON(paste(output, collapse = "\n"))
   envList <- unlist(json$envs)
   
   # prefer unix separators
   if (.rs.platform.isWindows)
      envList <- chartr("\\", "/", envList)
   
   # ignore certain special environments
   ignorePatterns <- c("/revdep/", "/basilisk/", "/renv/python/condaenvs/")
   pattern <- sprintf("(?:%s)", paste(ignorePatterns, collapse = "|"))
   envList <- grep(pattern, envList, value = TRUE, invert = TRUE)
   
   # get paths to Python in each environment
   pythonSuffix <- if (.rs.platform.isWindows) "python.exe" else "bin/python"
   pythonPaths <- file.path(envList, pythonSuffix)
   
   # only keep existing
   pythonPaths <- Filter(file.exists, pythonPaths)
   
   # drop duplicates, just in case
   pythonPaths <- unique(normalizePath(pythonPaths, winslash = "/"))
   
   # get information for each environment
   lapply(pythonPaths, .rs.python.getCondaEnvironmentInfo)
})

.rs.addFunction("python.getCondaEnvironmentInfo", function(pythonPath)
{
   .rs.python.interpreterInfo(
      path = pythonPath,
      type = "conda"
   )
})

.rs.addFunction("python.findPythonVirtualEnvironments", function()
{
   home <- Sys.getenv("WORKON_HOME", unset = "~/.virtualenvs")
   roots <- list.files(home, full.names = TRUE)
   lapply(roots, .rs.python.getVirtualEnvironmentInfo)
})

.rs.addFunction("python.getVirtualEnvironmentInfo", function(envPath)
{
   # form path to Python executable from root
   exeSuffix <- if (.rs.platform.isWindows)
      "Scripts/python.exe"
   else
      "bin/python"
   
   # form executable path (ensure it exists)
   exePath <- file.path(envPath, exeSuffix)
   if (!file.exists(exePath))
   {
      fmt <- "Python executable '%s' does not exist."
      reason <- sprintf(fmt, exePath)
      return(.rs.python.invalidInterpreter(
         path   = exePath,
         type   = "virtualenv",
         reason = reason
      ))
   }
   
   .rs.python.interpreterInfo(
      path = exePath,
      type = "virtualenv"
   )
   
})

.rs.addFunction("python.describeInterpreter", function(pythonPath)
{
   info <- .rs.python.getPythonInfo(pythonPath, strict = TRUE)
   .rs.scalarListFromList(info)
})

#
# SessionAir.R
#
# Copyright (C) 2025 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("air.downloadFile", function(url, destfile)
{
   # Prefer the curl binary when available -- unlike download.file(), it can
   # time out on inactivity rather than on total download time, so a slow but
   # active download is not killed prematurely.
   # https://github.com/rstudio/rstudio/issues/17746
   curl <- Sys.which("curl")
   if (nzchar(curl))
      return(.rs.air.downloadFileWithCurl(curl, url, destfile))

   # Otherwise, fall back to download.file(). The 'timeout' option caps the
   # total download time for a single file, and the 60-second default has
   # proven too short for slow connections, so bump it for this download.
   timeout <- getOption("timeout", default = 60L)
   options(timeout = max(300L, timeout))
   on.exit(options(timeout = timeout), add = TRUE)

   download.file(url, destfile = destfile, quiet = TRUE, mode = "wb")

   invisible(destfile)
})

.rs.addFunction("air.downloadFileWithCurl", function(curl, url, destfile)
{
   args <- c(
      "--fail", "--location", "--silent", "--show-error",
      "--connect-timeout", "60",
      "--speed-limit", "1",
      "--speed-time", "60",
      "--output", shQuote(destfile),
      shQuote(url)
   )

   output <- suppressWarnings(system2(curl, args, stdout = TRUE, stderr = TRUE))

   status <- attr(output, "status")
   if (!is.null(status) && status != 0L)
   {
      fmt <- "Error downloading '%s' [exit code %d]:\n%s"
      stop(sprintf(fmt, url, status, paste(output, collapse = "\n")))
   }

   invisible(destfile)
})

.rs.addFunction("air.defaultVersion", function()
{
   version <- getOption("rstudio.air.version")
   if (!is.null(version))
      return(version)

   url <- "https://api.github.com/repos/posit-dev/air/releases/latest"
   destfile <- tempfile(fileext = ".json")
   .rs.air.downloadFile(url, destfile)

   # .rs.fromJSON() takes a single string; readLines() on the pretty-printed
   # response yields one element per line, so collapse before parsing.
   contents <- paste(readLines(destfile, warn = FALSE), collapse = "\n")
   response <- .rs.fromJSON(contents)

   version <- response[["tag_name"]]
   if (is.null(version))
      stop(sprintf("Failed to determine latest Air version from '%s'.", url))

   version
})

.rs.addFunction("air.installedVersions", function()
{
   # Search every known root (the current data directory plus any legacy
   # locations) so that copies of air installed by older versions of
   # RStudio are still discovered. https://github.com/rstudio/rstudio/issues/18068
   versions <- character()
   for (root in .rs.air.rootDirs())
   {
      candidates <- list.files(root)
      candidates <- candidates[file.exists(.rs.air.exePath(candidates, root))]
      versions <- c(versions, candidates)
   }

   versions <- unique(versions)
   if (length(versions) == 0L)
      return(character())

   # Tolerate a leading 'v' when parsing, in case Air switches to
   # v-prefixed release tags; the directory name is still returned as-is.
   parsed <- numeric_version(sub("^v", "", versions), strict = FALSE)
   versions <- versions[!is.na(parsed)]
   parsed <- parsed[!is.na(parsed)]

   versions[order(parsed, decreasing = TRUE)]
})

.rs.addFunction("air.ensureAvailable", function()
{
   # If air is on the PATH, use it
   exe <- Sys.which("air")
   if (nzchar(exe))
      return(normalizePath(exe))

   # Check for a user-requested version of air
   version <- getOption("rstudio.air.version")

   # Otherwise, prefer the newest already-installed copy of air, so that
   # we can avoid querying GitHub for the latest release version
   if (is.null(version))
   {
      installed <- .rs.air.installedVersions()
      if (length(installed))
         version <- installed[[1L]]
   }

   # Otherwise, install and use our own copy of air
   if (is.null(version))
      version <- .rs.air.defaultVersion()

   # Use an existing copy if we can find one (searching legacy roots too);
   # otherwise install into the current data directory.
   exe <- .rs.air.findExe(version)
   if (is.null(exe))
   {
      autoinstall <- getOption("rstudio.air.autoinstall", default = TRUE)
      if (autoinstall)
         .rs.air.installVersion(version)

      exe <- .rs.air.findExe(version)
   }

   if (is.null(exe))
      stop(sprintf("Air binary not found at '%s'.", .rs.air.exePath(version)))

   normalizePath(exe)
})

.rs.addFunction("air.rootDir", function()
{
   # Install air underneath RStudio's per-user data directory, e.g.
   # '~/.local/share/rstudio/air' on Linux, '~/Library/.../rstudio/air' on
   # macOS, or '%LOCALAPPDATA%\rstudio\air' on Windows. The C++ helper handles
   # the platform-specific resolution (and any environment overrides).
   # https://github.com/rstudio/rstudio/issues/18068
   dataDir <- .Call("rs_userDataDir", PACKAGE = "(embedding)")
   chartr("\\", "/", file.path(dataDir, "air"))
})

.rs.addFunction("air.oldRootDir", function()
{
   # The location used by older versions of RStudio. We still look here when
   # discovering already-installed copies of air, but never install here.
   homeDir <- if (.rs.platform.isWindows)
   {
      Sys.getenv("USERPROFILE", unset = path.expand("~"))
   }
   else
   {
      Sys.getenv("HOME", unset = path.expand("~"))
   }

   chartr("\\", "/", file.path(homeDir, ".local", "lib", "air"))
})

.rs.addFunction("air.rootDirs", function()
{
   # The current root is searched first, so installations there take
   # precedence over copies left behind in a legacy location.
   unique(c(.rs.air.rootDir(), .rs.air.oldRootDir()))
})

.rs.addFunction("air.binDir", function(version, root = .rs.air.rootDir())
{
   file.path(root, version, "bin")
})

.rs.addFunction("air.exePath", function(version, root = .rs.air.rootDir())
{
   exe <- if (.rs.platform.isWindows) "air.exe" else "air"
   file.path(.rs.air.binDir(version, root), exe)
})

.rs.addFunction("air.findExe", function(version)
{
   # Return the path to an installed copy of air for the requested version,
   # preferring the current root but falling back to legacy locations.
   # Returns NULL when no installed copy exists.
   for (root in .rs.air.rootDirs())
   {
      exe <- .rs.air.exePath(version, root)
      if (file.exists(exe))
         return(exe)
   }

   NULL
})

.rs.addFunction("air.installVersion", function(version)
{
   # Work in temporary directory
   owd <- setwd(tempdir())
   on.exit(setwd(owd))
   
   # Set up installation directory
   binDir <- .rs.air.binDir(version)
   dir.create(binDir, recursive = TRUE, showWarnings = FALSE)
   
   # Download air binaries
   if (.rs.platform.isWindows)
   {
      fmt <- "https://github.com/posit-dev/air/releases/download/%s/air-%s-pc-windows-msvc.zip"
      url <- sprintf(fmt, version, R.version$arch)
      destfile <- basename(url)
      .rs.air.downloadFile(url, destfile)
      unzip(destfile)
   }
   else if (.rs.platform.isMacos)
   {
      fmt <- "https://github.com/posit-dev/air/releases/download/%s/air-%s-apple-darwin.tar.gz"
      url <- sprintf(fmt, version, R.version$arch)
      destfile <- basename(url)
      .rs.air.downloadFile(url, destfile)
      untar(destfile)
   }
   else
   {
      fmt <- "https://github.com/posit-dev/air/releases/download/%s/air-%s-unknown-linux-gnu.tar.gz"
      url <- sprintf(fmt, version, R.version$arch)
      destfile <- basename(url)
      .rs.air.downloadFile(url, destfile)
      untar(destfile)
   }
   
   # Copy air to the resulting binary directory.
   exeName <- if (.rs.platform.isWindows) "air.exe" else "air"
   exePattern <- if (.rs.platform.isWindows) "^air\\.exe$" else "^air$"
   airPath <- list.files(pattern = exePattern, full.names = TRUE, recursive = TRUE)
   if (length(airPath) != 1L)
   {
      fmt <- "Air binary not found in archive (pattern '%s'); found %d matches."
      stop(sprintf(fmt, exePattern, length(airPath)))
   }

   destPath <- file.path(binDir, exeName)
   ok <- file.copy(airPath, destPath, overwrite = TRUE)
   if (!isTRUE(ok))
      stop(sprintf("Failed to copy Air binary to '%s'.", destPath))

   fmt <- "Air %s has been installed to %s."
   msg <- sprintf(fmt, version, binDir)
   message(msg)
})

#
# This is a Plumber API. You can run the API by clicking
# the 'Run API' button above.
#
# Find out more about building APIs with Plumber here:
#
#    https://www.rplumber.io/
#

library(plumber)

#* @apiTitle Plumber Example API
#* @apiDescription Plumber example description.

#* Echo back the input
#* @param msg The message to echo
#* @get /echo
function(msg = "") {
    list(msg = paste0("The message is: '", msg, "'"))
}

#* Plot a histogram
#* @serializer png
#* @get /plot
function() {
    rand <- rnorm(100)
    hist(rand)
}

#* Return the sum of two numbers
#* @param a The first number to add
#* @param b The second number to add
#* @post /sum
function(a, b) {
    as.numeric(a) + as.numeric(b)
}

# Programmatically alter your API
#* @plumber
function(pr) {
    pr %>%
        # Overwrite the default serializer to return unboxed JSON
        pr_set_serializer(serializer_unboxed_json())
}

#
# SessionDataViewer.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# host environment for cached data; this allows us to continue to view data 
# even if the original object is deleted
.rs.setVar("CachedDataEnv", new.env(parent = emptyenv()))

# host environment for working data; this allows us to sort/filter/page the
# data without recomputing on the original object every time
.rs.setVar("WorkingDataEnv", new.env(parent = emptyenv()))

.rs.addFunction("subsetData", function(data, maxRows = -1, maxCols = -1)
{
   if (!is.na(maxRows) && maxRows != -1 && nrow(data) > maxRows)
      data <- head(data, n = maxRows)
   
   if (!is.na(maxCols) && maxCols != -1 && ncol(data) > maxCols)
      data <- data[1:maxCols]
   
   data
})

.rs.addFunction("formatDataColumn", function(x, start, len, ...)
{
   # extract the visible part of the column
   col <- x[start:min(NROW(x), start + len)]
   
   # if this object has a format method, use it. catch errors
   # and validate that the format method has given us something 'sane'
   formatted <- .rs.tryCatch(.rs.formatDataColumnDispatch(col, ...))
   if (is.character(formatted) && length(formatted) == length(col))
      return(formatted)
   
   # otherwise, delegate to internal methods
   if (is.numeric(col))
      .rs.formatDataColumnNumeric(col, ...)
   else if (is.list(col) && !is.data.frame(col))
      .rs.formatDataColumnList(col, ...)
   else
      .rs.formatDataColumnDefault(col, ...)
})

.rs.addFunction("formatDataColumnDispatch", function(col, ...)
{
   formatter <- NULL
   for (class in class(col))
   {
      formatter <- utils::getS3method(
         "format",
         class = class,
         optional = TRUE
      )
      if (!is.null(formatter))
         break
   }
   
   if (is.null(formatter))
      return(NULL)
   
   formatted <- formatter(col, trim = TRUE, justify = "none", ...)
   
   if (is.character(formatted) && length(formatted) == length(col))
      formatted[is.na(col)] <- NA
   
   formatted
   
})

.rs.addFunction("formatDataColumnNumeric", function(col, ...)
{
   # show numbers as doubles
   storage.mode(col) <- "double"
   
   # remember which values are NA 
   naVals <- is.na(col) 
   
   # format all the numeric values; this drops NAs (the na.encode option only
   # preserves NA for character cols)
   vals <- format(col, trim = TRUE, justify = "none", ...)
   
   # restore NA values if there were any
   if (any(naVals))
      vals[naVals] <- col[naVals]
   
   # return formatted values
   vals
})

.rs.addFunction("formatDataColumnList", function(col, ...)
{
   limit <- .rs.nullCoalesce(
      .rs.readUserPref("data_viewer_max_cell_size"),
      50L
   )
   
   # handle data.frame entries in a column
   # https://github.com/rstudio/rstudio/issues/14257
   for (i in seq_along(col))
   {
      if (is.data.frame(col[[i]]))
      {
         col[[i]] <- sprintf("<data.frame[%i x %i]>", nrow(col[[i]]), ncol(col[[i]]))
      }
      else
      {
         col[[i]] <- format(col[[i]])
      }
   }
   
   formatted <- as.character(col)
   na <- is.na(formatted)
   large <- !na & nchar(formatted) > limit
   formatted <- substr(formatted, 1, limit)
   formatted <- paste0(formatted, ifelse(large, " [...]", ""))
   formatted[na] <- NA_character_
   formatted
})

.rs.addFunction("formatDataColumnDefault", function(col, ...)
{
   # show everything else as characters
   as.character(col)
})

# Compact, collision-resistant hash of a frame's column structure. Used as a
# fingerprint to detect object reassignment between data viewer loads.
#
# The fingerprint covers column names, column classes, and factor levels --
# not just names. Saved filters are typed (numeric ranges, factor level
# indices), so a column changing type, or a factor being re-leveled, with
# unchanged names must also invalidate saved state; otherwise a restored
# filter is silently applied with the wrong semantics (an inexplicably empty
# grid, or a factor filter matching the wrong level).
#
# Returns NA_character_ for empty / NULL names so the client can treat
# "no anchor" as always-mismatch; without anchors there's no way to
# align saved positional state with the current frame, so we want it
# discarded.
.rs.addFunction("dataViewer.colsFingerprint", function(x)
{
   nms <- names(x)
   n <- length(nms)
   if (n == 0L)
      return(NA_character_)

   sig <- list(names = nms)
   if (is.list(x))
   {
      sig$types <- vapply(x, function(col) {
         type <- paste(class(col), collapse = "/")
         if (is.factor(col))
            type <- paste(c(type, levels(col)), collapse = "/")
         type
      }, character(1), USE.NAMES = FALSE)
   }

   paste0(n, ":", .rs.digest(sig))
})

.rs.addFunction("describeCols", function(x,
                                         maxRows = -1,
                                         maxCols = -1,
                                         maxFactors = 64,
                                         totalCols = -1,
                                         colIndices = NULL,
                                         colsFingerprint = NULL)
{
   # The client compares this fingerprint against the one stored alongside
   # saved per-object UI state (pins, widths, sort, filters, sidebar
   # visibility). A mismatch invalidates the saved state -- without it,
   # positional indices saved against one frame can land on an unrelated
   # frame after reassignment (df <- iris; df <- mtcars). Callers that have
   # already subset x (e.g. describeColsByIndex) must compute the fingerprint
   # from the underlying frame and pass it in, otherwise pagination would
   # silently invalidate state on every column-frame change.
   if (is.null(colsFingerprint))
      colsFingerprint <- .rs.dataViewer.colsFingerprint(x)

   # subset the data if requested
   x <- .rs.subsetData(x, maxRows, maxCols)

   # absolute (1-based) column indices for the columns being described. The
   # client uses these as the stable identity for pinning, sorting, and
   # filtering, so they survive column pagination (callers that describe an
   # arbitrary slice -- describeColsByIndex -- pass the original indices in).
   # Default to a contiguous range for the full-frame case.
   if (is.null(colIndices))
      colIndices <- seq_len(ncol(x))

   # get the variable labels, if any--labels may be provided either by this 
   # global attribute or by a 'label' attribute on an individual column (as in
   # e.g. Hmisc), which takes precedence if both are present
   colNames <- names(x)
   colLabels <- attr(x, "variable.labels", exact = TRUE)
   if (!is.character(colLabels)) 
      colLabels <- character()
   
   # we pass totalCols in the rownames col so we can pass this information
   # along when we retrieve column data, without changing the response format
   totalCols <- if (totalCols > 0) totalCols else ncol(x)

   # Cap the col_max_chars hint computation at this many columns. Above
   # the cap, each per-column scan would add up; the client falls back to
   # sampling the visible rows instead.
   maxCharsCap <- 200L
   computeMaxChars <- ncol(x) > 0 && ncol(x) <= maxCharsCap

   # Maximum number of distinct values for which the summary sidebar draws
   # one frequency bar per category; above this, a factor / character column
   # gets a text summary (count of uniques + dominant value) instead.
   maxCategoryBars <- 24L

   # Character columns are only categorized (a full table() hash) when they
   # have at most this many rows. The option is user-supplied, so validate
   # it here; a malformed value (NA, wrong length, non-numeric) must not be
   # able to break the whole describe call.
   maxCategorizeRows <- getOption("rstudio.dataViewer.maxCategorizeRows", 1e6)
   if (!is.numeric(maxCategorizeRows) || length(maxCategorizeRows) != 1 || is.na(maxCategorizeRows))
      maxCategorizeRows <- 1e6

   # Cheap upper bound on the displayed character count for a column.
   # Only handles types where the bound is a property of range/levels/type
   # rather than a per-element format() call. Returns NA if the column type
   # is not a known-cheap case so the client falls back to sampling.
   colMaxChars <- function(col) {
      if (length(col) == 0L)
         return(NA_integer_)
      if (is.logical(col))
         return(5L)  # "FALSE"
      if (inherits(col, "Date"))
         return(10L) # "YYYY-MM-DD"
      if (inherits(col, "POSIXt"))
         return(19L) # "YYYY-MM-DD HH:MM:SS"
      if (is.factor(col)) {
         lvls <- levels(col)
         if (length(lvls) == 0L) return(0L)
         return(max(nchar(lvls, type = "width"), na.rm = TRUE))
      }
      if (is.character(col))
         return(max(nchar(col, type = "width"), 0L, na.rm = TRUE))
      if (is.integer(col)) {
         rng <- suppressWarnings(range(col, na.rm = TRUE))
         if (!all(is.finite(rng))) return(NA_integer_)
         return(max(nchar(as.character(rng))))
      }
      if (is.numeric(col) && !is.object(col)) {
         # Treat doubles whose values are all integral the same as integer;
         # avoid format() on the full column otherwise (expensive and
         # options-dependent).
         finiteCol <- col[is.finite(col)]
         if (length(finiteCol) == 0L) return(NA_integer_)
         if (all(finiteCol == trunc(finiteCol))) {
            rng <- range(finiteCol)
            return(max(nchar(as.character(rng))))
         }
         return(NA_integer_)
      }
      NA_integer_
   }

   # the first column is always the row names
   rowNameCol <- list(
      col_name        = .rs.scalar(""),
      col_type        = .rs.scalar("rownames"),
      col_min         = .rs.scalar(0),
      col_max         = .rs.scalar(0),
      col_search_type = .rs.scalar("none"),
      col_label       = .rs.scalar(""),
      col_vals        = "",
      col_class       = "rownames",
      col_na_count    = .rs.scalar(0),
      col_index       = .rs.scalar(0L),
      total_cols      = .rs.scalar(totalCols),
      total_rows      = .rs.scalar(nrow(x)),
      cols_fingerprint = .rs.scalar(colsFingerprint))

   # Add a max-chars hint for the row names column. Use .row_names_info()
   # so we avoid materializing the full row-name vector for the common
   # case of automatic rownames -- type=1L returns a signed row count:
   # negative for the compact c(NA, -n) form (auto), positive otherwise.
   if (computeMaxChars) {
      rnInfo <- .row_names_info(x, type = 1L)
      rnChars <- NA_integer_
      if (is.integer(rnInfo) && length(rnInfo) == 1L && !is.na(rnInfo)) {
         if (rnInfo < 0L) {
            # Automatic rownames: widest displayed value is the row count.
            rnChars <- nchar(as.character(-rnInfo))
         } else if (rnInfo > 0L) {
            # Explicit rownames -- cheap to bound for integer/character.
            rnAttr <- attr(x, "row.names", exact = TRUE)
            if (is.integer(rnAttr)) {
               rng <- suppressWarnings(range(rnAttr, na.rm = TRUE))
               if (all(is.finite(rng)))
                  rnChars <- max(nchar(as.character(rng)))
            } else if (is.character(rnAttr)) {
               rnChars <- max(nchar(rnAttr, type = "width"), 0L, na.rm = TRUE)
            }
         }
      }
      if (!is.na(rnChars))
         rowNameCol$col_max_chars <- .rs.scalar(as.integer(rnChars))
   }
   
   # if there are no columns, bail out
   if (length(colNames) == 0) {
      return(rowNameCol)
   }
   
   # get the attributes for each column
   colAttrs <- lapply(seq_along(colNames), function(idx) {
      col_name <- if (idx <= length(colNames)) 
         colNames[idx] 
      else 
         as.character(idx)
      # col_type and col_class are reported faithfully from the column itself
      # (typeof / class); the cascade below only derives the search type and
      # the histogram / factor-level metadata used by the client.
      col_type <- typeof(x[[idx]])
      col_class <- class(x[[idx]])
      col_breaks <- c()
      col_counts <- c()
      col_min <- NULL
      col_max <- NULL
      col_vals <- ""
      col_search_type <- ""
      col_cat_vals <- NULL
      col_cat_counts <- NULL
      col_n_unique <- NULL
      col_top_value <- NULL
      col_top_count <- NULL
      
      # extract label, if any, or use global label, if any
      label <- attr(x[[idx]], "label", exact = TRUE)
      col_label <- if (is.character(label))
      {
         label
      }
      else if (idx <= length(colLabels))
      {
         if (!is.null(names(colLabels)))
         {
            if (col_name %in% names(colLabels))
               colLabels[[col_name]]
            else
               ""
         }
         else
         {
            colLabels[[idx]]
         }
      }
      else
      {
         ""
      }
      
      # ensure that the column contains some scalar values we can examine 
      if (length(x[[idx]]) > 0)
      {
         val <- x[[idx]][[1]]
         if (is.factor(val))
         {
            # we previously used the 'maxFactors' variable to try and guess
            # where a factor variable might have actually been intended to be
            # used as a character vector. nowdays, with stringsAsFactors = FALSE
            # being the default, this is no longer necessary and so we just
            # ignore the 'maxFactors' parameter.
            #
            # https://github.com/rstudio/rstudio/issues/14113
            col_search_type <- "factor"
            col_vals <- levels(val)

            # per-level counts for the sidebar's category mini-plot: cheap
            # via tabulate() on the underlying integer codes. at most
            # maxCategoryBars bars are drawn (in level order, preserving
            # ordinal structure); above that the sidebar falls back to a
            # text summary, so only the dominant level is shipped.
            #
            # gate on the column type, not val: list columns whose first
            # element is a factor reach this branch, and as.integer() on a
            # list is an error. the counts are decorative (the client
            # degrades gracefully without them), so any failure just drops
            # them instead of failing the whole describe call
            status <- .rs.tryCatch({
               if (is.factor(x[[idx]]) && length(col_vals) > 0)
               {
                  counts <- tabulate(as.integer(x[[idx]]), nbins = length(col_vals))
                  if (length(col_vals) <= maxCategoryBars)
                  {
                     col_cat_vals <- col_vals
                     col_cat_counts <- counts
                  }
                  else if (any(counts > 0))
                  {
                     top <- which.max(counts)
                     col_top_value <- col_vals[[top]]
                     col_top_count <- counts[[top]]
                  }
               }
            })

            if (inherits(status, "error"))
            {
               col_cat_vals <- NULL
               col_cat_counts <- NULL
               col_top_value <- NULL
               col_top_count <- NULL
               .rs.logErrorMessage(
                  "Error computing level counts for column '%s': %s",
                  col_name,
                  conditionMessage(status))
            }
         }
         # for histograms, we support only the base R numeric class and its derivatives;
         # is.numeric can return true for values that can only be manipulated using
         # packages that are currently loaded (e.g. bit64's integer64)
         else if (is.numeric(x[[idx]]) && !is.object(x[[idx]]))
         {
            # ignore missing and infinite values (i.e. let any filter applied
            # implicitly remove those values); if that leaves us with nothing,
            # treat this column as untyped since we can do no meaningful filtering
            # on it
            #
            # coerce to double up front: integer columns whose range exceeds
            # .Machine$integer.max otherwise overflow both in the range
            # computation below and in hist()'s break selection (#17951)
            hist_vals <- as.numeric(x[[idx]][is.finite(x[[idx]])])
            if (length(hist_vals) > 1)
            {
               # hist() can fail outright on some pathological numeric data
               # (e.g. it errors when its chosen breaks do not span the data
               # range), so guard the whole computation: a failure here should
               # just leave the column without a histogram, not abort the
               # describe call and render the data viewer unusable.
               # https://github.com/rstudio/rstudio/issues/17990
               status <- .rs.tryCatch({
                  # For whole-number columns spanning a small range, draw one
                  # bar per integer value (so e.g. a 1-5 Likert column shows 5
                  # distinct bars rather than Sturges' default binning, which
                  # smears the discrete structure). Gaps in the range get a
                  # zero-height bar, which is itself informative.
                  int_breaks <- NULL
                  min_v <- min(hist_vals)
                  max_v <- max(hist_vals)
                  n_distinct <- max_v - min_v + 1
                  if (n_distinct <= 12 && isTRUE(all(hist_vals %% 1 == 0)))
                     int_breaks <- seq(min_v - 0.5, max_v + 0.5, by = 1)

                  # at very large magnitudes (abs value >= ~2^52) the unit
                  # step and 0.5 offsets fall below the floating-point
                  # resolution, collapsing the sequence to a single value;
                  # hist() would then treat it as a scalar bin count -- which
                  # errors outright ("invalid number of 'breaks'") for large
                  # negative values, and is meaningless for positive ones. Drop
                  # the integer breaks in that case and fall back to default
                  # binning. https://github.com/rstudio/rstudio/issues/17990
                  if (length(int_breaks) < 2L)
                     int_breaks <- NULL

                  # create histogram for brushing -- suppress warnings as in rare cases
                  # an otherwise benign integer overflow can occurs; see
                  # https://github.com/rstudio/rstudio/issues/3232
                  h <- if (is.null(int_breaks))
                     suppressWarnings(graphics::hist(hist_vals, plot = FALSE))
                  else
                     suppressWarnings(graphics::hist(hist_vals, breaks = int_breaks, plot = FALSE))
                  col_breaks <- h$breaks
                  col_counts <- h$counts

                  # the actual (finite) data range; the histogram breaks can
                  # extend past it (pretty()-ed for default binning, padded by
                  # 0.5 on each side for integer bins). shown in the column
                  # summary sidebar, where the sparkline has no axis ticks
                  col_min <- min_v
                  col_max <- max_v

                  # record search type
                  col_search_type <- "numeric"
               })

               if (inherits(status, "error"))
               {
                  col_breaks <- c()
                  col_counts <- c()
                  col_min <- NULL
                  col_max <- NULL
                  col_search_type <- ""
                  .rs.logErrorMessage(
                     "Error computing histogram for column '%s': %s",
                     col_name,
                     conditionMessage(status))
               }
            }
         }
         else if (inherits(x[[idx]], "integer64"))
         {
            col_search_type <- "character"
         }
         else if (is.character(val))
         {
            col_search_type <- "character"

            # category counts for the sidebar mini-plot. unlike factors this
            # costs a full hash of the column (table()), so very long columns
            # skip it and the sidebar shows no categorical summary. at most
            # maxCategoryBars distinct values draws one bar per value, most
            # frequent first (no natural order to preserve); above that only
            # the text summary fields (count of uniques, dominant value) are
            # shipped.
            #
            # gate on the column type, not val: list columns whose first
            # element is a character vector reach this branch, and table()
            # on a list either errors (ragged elements) or counts the wrong
            # thing. decorative only, so any failure just drops the fields
            # instead of failing the whole describe call
            status <- .rs.tryCatch({
               if (is.character(x[[idx]]) && length(x[[idx]]) <= maxCategorizeRows)
               {
                  counts <- table(x[[idx]], useNA = "no")
                  col_n_unique <- length(counts)
                  if (col_n_unique > 0 && col_n_unique <= maxCategoryBars)
                  {
                     counts <- sort(counts, decreasing = TRUE)
                     col_cat_vals <- names(counts)
                     col_cat_counts <- as.integer(counts)
                  }
                  else if (col_n_unique > 0)
                  {
                     top <- which.max(counts)
                     col_top_value <- names(counts)[[top]]
                     col_top_count <- as.integer(counts[[top]])
                  }
               }
            })

            if (inherits(status, "error"))
            {
               col_cat_vals <- NULL
               col_cat_counts <- NULL
               col_n_unique <- NULL
               col_top_value <- NULL
               col_top_count <- NULL
               .rs.logErrorMessage(
                  "Error computing category counts for column '%s': %s",
                  col_name,
                  conditionMessage(status))
            }
         }
         else if (is.logical(val))
         {
            col_search_type <- "boolean"
         }
      }
      # count NA values
      col_na_count <- sum(is.na(x[[idx]]))

      result <- list(
         col_name        = .rs.scalar(col_name),
         col_type        = .rs.scalar(col_type),
         col_breaks      = as.character(col_breaks),
         col_counts      = col_counts,
         col_search_type = .rs.scalar(col_search_type),
         col_label       = .rs.scalar(col_label),
         col_vals        = col_vals,
         col_class       = as.character(col_class),
         col_na_count    = .rs.scalar(col_na_count),
         col_index       = .rs.scalar(as.integer(colIndices[idx]))
      )

      # data range, present only for histogram-summarized numeric columns
      if (!is.null(col_min)) {
         result$col_min <- .rs.scalar(col_min)
         result$col_max <- .rs.scalar(col_max)
      }

      # category metadata for the sidebar: bar values/counts at or below
      # the maxCategoryBars cutoff, dominant-value fields above it; the
      # distinct-value count ships whenever it was computed (character
      # columns within the row gate), regardless of the cutoff
      if (!is.null(col_cat_counts)) {
         result$col_cat_vals <- as.character(col_cat_vals)
         result$col_cat_counts <- as.integer(col_cat_counts)
      }
      if (!is.null(col_n_unique))
         result$col_n_unique <- .rs.scalar(as.integer(col_n_unique))
      if (!is.null(col_top_value)) {
         result$col_top_value <- .rs.scalar(col_top_value)
         result$col_top_count <- .rs.scalar(as.integer(col_top_count))
      }

      # Optionally include a cheap upper bound on displayed character count.
      # The client uses this for initial column width sizing instead of
      # sampling rows; absence of the field means "sample on the client."
      if (computeMaxChars) {
         maxCh <- colMaxChars(x[[idx]])
         if (!is.na(maxCh))
            result$col_max_chars <- .rs.scalar(as.integer(maxCh))
      }

      result
   })
   c(list(rowNameCol), colAttrs)
})

.rs.addFunction("describeColsByIndex", function(x, indices)
{
   totalCols <- ncol(x)
   if (is.null(totalCols) || totalCols == 0)
      return(NULL)

   # Keep only valid, in-range column indices (1-based). The client sends an
   # arbitrary ordered set -- pinned columns followed by the visible window --
   # so this is not necessarily contiguous. Fall back to the full frame if the
   # request is empty or entirely out of range.
   indices <- indices[!is.na(indices) & indices >= 1 & indices <= totalCols]
   if (length(indices) == 0)
      indices <- seq_len(totalCols)

   colSlice <- x[indices]

   # Make sure we preserve variable.labels if set.
   #
   # The structure of 'variable.labels' is not documented,
   # but it appears that the expectation is that it's a character
   # vector of the same length as 'x'.
   #
   # The vector can be optionally named (with names matching that of 'x'),
   # or it can be an unnamed vector -- in which case, the order of labels
   # needs to match the column order of 'x'.
   #
   # https://github.com/rstudio/rstudio/issues/14265
   colLabels <- attr(x, "variable.labels", exact = TRUE)
   if (!is.null(colLabels))
   {
      # Only subset 'variable.labels' if it's not named, since a named
      # attribute could potentially be in a different order than the
      # columns of 'x' itself. If 'variable.labels' is named, then all
      # we require is that it's a super-set of the names of 'x'.
      if (is.null(names(colLabels)))
         colLabels <- colLabels[indices]
      
      attr(colSlice, "variable.labels") <- colLabels
   }
      
   
   # Pass the fingerprint of the full frame so pagination doesn't fold
   # each page into a distinct fingerprint -- doing so would invalidate
   # saved UI state on every page change. The original (absolute) indices
   # are passed through as col_index so the client can track pinned/sorted/
   # filtered columns by identity rather than by their position in the slice.
   .rs.describeCols(
      x                = colSlice,
      maxRows          = -1,
      maxCols          = -1,
      maxFactors       = 64,
      totalCols        = totalCols,
      colIndices       = indices,
      colsFingerprint  = .rs.dataViewer.colsFingerprint(x)
   )
})

.rs.addFunction("summarizeColumn", function(x, columnIndex)
{
   # columnIndex is 1-based (R convention)
   if (columnIndex < 1 || columnIndex > ncol(x))
      return(list(error = .rs.scalar("Column index out of range")))

   col <- x[[columnIndex]]
   n <- length(col)

   # Each statistic is wrapped individually: exotic numerics that pass
   # is.numeric (difftime, S4 numerics, units::units, ...) and columns
   # whose is.na returns a non-logical can throw on a single call. With
   # error-surfacing in place at the C++ layer, a single throw would blank
   # the entire panel rather than degrading gracefully.
   nonNa <- .rs.tryOr(NULL, col[!is.na(col)])

   result <- list(
      n        = .rs.scalar(n),
      n_na     = .rs.scalar(.rs.tryOr(NA_integer_, sum(is.na(col)))),
      n_unique = .rs.scalar(.rs.tryOr(NA_integer_, length(unique(nonNa))))
   )

   if (is.numeric(col) && !is.factor(col))
   {
      if (!is.null(nonNa) && length(nonNa) > 0)
      {
         result$min    <- .rs.scalar(.rs.tryOr(NULL, min(nonNa)))
         result$max    <- .rs.scalar(.rs.tryOr(NULL, max(nonNa)))
         result$mean   <- .rs.scalar(.rs.tryOr(NULL, mean(nonNa)))
         result$median <- .rs.scalar(.rs.tryOr(NULL, median(nonNa)))
         result$sd     <- .rs.scalar(.rs.tryOr(NULL, sd(nonNa)))
      }
   }
   else if (is.character(col))
   {
      if (!is.null(nonNa) && length(nonNa) > 0)
      {
         lens <- .rs.tryOr(NULL, nchar(nonNa))
         if (!is.null(lens))
         {
            result$min_length <- .rs.scalar(.rs.tryOr(NULL, min(lens)))
            result$max_length <- .rs.scalar(.rs.tryOr(NULL, max(lens)))
            result$n_empty    <- .rs.scalar(.rs.tryOr(NULL, sum(lens == 0)))
         }
      }
   }
   else if (is.factor(col))
   {
      # Display levels in their R-encoded order to preserve ordered factors
      # and any user-set order. When the level count exceeds the cap we
      # truncate to the first N by encoding order, not the N most frequent.
      maxLevels <- 50L
      tbl <- .rs.tryOr(NULL, table(col, useNA = "no"))
      lvls <- .rs.tryOr(NULL, levels(col))
      if (!is.null(tbl) && !is.null(lvls))
      {
         if (length(lvls) > maxLevels)
         {
            lvls <- lvls[seq_len(maxLevels)]
            result$truncated <- .rs.scalar(TRUE)
         }
         result$top_levels  <- lvls
         result$top_counts  <- as.integer(tbl[lvls])
      }
   }
   else if (is.logical(col))
   {
      result$n_true  <- .rs.scalar(.rs.tryOr(NULL, sum(col == TRUE,  na.rm = TRUE)))
      result$n_false <- .rs.scalar(.rs.tryOr(NULL, sum(col == FALSE, na.rm = TRUE)))
   }
   else if (inherits(col, "Date") || inherits(col, "POSIXct"))
   {
      if (!is.null(nonNa) && length(nonNa) > 0)
      {
         result$min <- .rs.scalar(.rs.tryOr(NULL, as.character(min(nonNa))))
         result$max <- .rs.scalar(.rs.tryOr(NULL, as.character(max(nonNa))))
      }
   }

   result
})

.rs.addFunction("formatRowNames", function(x, start, len) 
{
   # check for a data.frame with compact row names
   if (.rs.hasCompactRowNames(x))
   {
      # the second element indicates the number of rows, and
      # is negative if they're so-called "automatic" row names
      info <- .row_names_info(x, type = 0L)
      n <- abs(info[[2L]])
      range <- seq(from = start, to = min(n, start + len))
      return(as.character(range))
   }
   
   # retrieve row names; use .row_names_info for data.frame so
   # we can detect internal non-character row names
   rowNames <- if (is.data.frame(x))
   {
      .row_names_info(x, type = 0L)
   }
   else
   {
      row.names(x)
   }
   
   # subset the retrieved row names
   rowNames <- rowNames[start:min(length(rowNames), start + len)]
   
   # encode strings as JSON to force quoting + handle escaping
   # this also lets us differentiate numeric (automatic) row names
   # from explicitly-set row names
   if (is.character(rowNames))
   {
      .rs.mapChr(rowNames, .rs.toJSON, unbox = TRUE)
   }
   else
   {
      as.character(rowNames)
   }
})

# wrappers for nrow/ncol which will report the class of object for which we
# fail to get dimensions along with the original error
.rs.addFunction("nrow", function(x)
{
   rows <- 0
   tryCatch({
      rows <- NROW(x)
   }, error = function(e) {
      stop("Failed to determine rows for object of class '", class(x), "': ", 
           e$message)
   })
   if (is.null(rows))
      0
   else
      rows
})

.rs.addFunction("ncol", function(x)
{
   cols <- 0
   tryCatch({
      cols <- NCOL(x)
   }, error = function(e) {
      stop("Failed to determine columns for object of class '", class(x), "': ", 
           e$message)
   })
   if (is.null(cols))
      0
   else
      cols
})

.rs.addFunction("toDataFrame", function(x, name, flatten)
{
   # force a non-subclassed data.frame -- this is necessary to ensure
   # that row names (or row numbers) are not dropped when subsetting
   # data, since those row names are used when generating cell-specific
   # callbacks (e.g. for viewing a cell of a list column)
   if (is.data.frame(x))
   {
      class(x) <- "data.frame"
   }
   
   # if it's not already a frame, coerce it to a frame
   if (!is.data.frame(x))
   {
      frame <- NULL
      # attempt to coerce to a data frame--this can throw errors in the case
      # where we're watching a named object in an environment and the user
      # replaces an object that can be coerced to a data frame with one that
      # cannot
      tryCatch(
         {
            # create a temporary frame to hold the value; this is necessary because
            # "x" is a function argument and therefore a promise whose value won't
            # be bound via substitute() below. we use a random-looking name so we 
            # can spot it later when relabeling columns.
            `__RSTUDIO_VIEWER_COLUMN__` <- x
            
            # perform the actual coercion in the global environment; this is 
            # necessary because we want to honor as.data.frame overrides of packages
            # which are loaded after tools:rstudio in the search path
            frame <- eval(substitute(as.data.frame(`__RSTUDIO_VIEWER_COLUMN__`, 
                                                   optional = TRUE)), 
                          envir = globalenv())
         },
         error = function(e)
         {
         })
      
      # as.data.frame uses the name of its argument to label unlabeled columns,
      # so label these back to the original name
      if (!is.null(frame) && !is.null(names(frame)))
         names(frame)[names(frame) == "__RSTUDIO_VIEWER_COLUMN__"] <- name
      x <- frame 
   }
   
   # if coercion was successful (or we started with a frame), flatten the frame
   # if necessary and requested
   if (is.data.frame(x)) {
      
      # generate column names if we didn't have any to start
      if (is.null(names(x)))
         names(x) <- paste("V", seq_along(x), sep = "")
      
      if (flatten)
         x <- .rs.flattenFrame(x)
      
      return(x)
   }
})

.rs.addFunction("multiCols", function(x) {
   fun <- function(col) is.data.frame(col) || is.matrix(col)
   which(vapply(x, fun, TRUE))
})

# given a 'data.frame' containing columns which themselves have
# multiple columns (e.g. matrices, data.frames), expand those columns
# such that we have a 'data.frame' with the nested columns e
.rs.addFunction("flattenFrame", function(x)
{
   # skip if we don't have any rectangular columns;
   # in this case, we can return the data as-is
   isRectangular <- vapply(x, function(column) {
      is.data.frame(column) || is.matrix(column)
   }, FUN.VALUE = logical(1))
   
   if (!any(isRectangular))
      return(x)
   
   # split into separate data.frames
   stack <- .rs.stack()
   .rs.enumerate(x, .rs.dataViewer.flatten, stack = stack)
   parts <- stack$data()
   
   # pull out pieces we need
   keys <- vapply(parts, `[[`, "name", FUN.VALUE = "character")
   vals <- lapply(parts, `[[`, "value")
   
   # turn it into a data.frame
   names(vals) <- keys
   attr(vals, "row.names") <- .set_row_names(length(vals[[1L]]))
   class(vals) <- "data.frame"
   
   # all done
   vals
})

.rs.addFunction("dataViewer.flatten", function(name, value, stack)
{
   if (is.matrix(value)) {
      .rs.dataViewer.flattenMatrix(name, value, stack)
   } else if (is.data.frame(value)) {
      .rs.dataViewer.flattenDataFrame(name, value, stack)
   } else {
      stack$push(list(name = name, value = value))
   }
})

.rs.addFunction("dataViewer.flattenMatrix", function(name, value, stack)
{
   colNames <- if (is.null(colnames(value)))
      as.character(seq_len(ncol(value)))
   else
      encodeString(colnames(value), quote = '"')
   
   for (i in seq_len(ncol(value))) {
      .rs.dataViewer.flatten(
         name  = sprintf("%s[, %s]", name, colNames[[i]]),
         value = value[, i, drop = TRUE],
         stack = stack
      )
   }
})

.rs.addFunction("dataViewer.flattenDataFrame", function(name, value, stack)
{
   # a data.frame should almost always have names, but check just in case
   colNames <- names(value)
   if (is.null(colNames))
      colNames <- sprintf("<%i>", seq_along(value))
   
   for (i in seq_along(value)) {
      .rs.dataViewer.flatten(
         name  = paste(name, colNames[[i]], sep = "$"),
         value = value[[i]],
         stack = stack
      )
   }
})

.rs.addFunction("applyTransform", function(x, filtered, search, cols, dirs)
{
   # mark encoding on character inputs if not already marked
   filtered <- vapply(filtered, function(colfilter) {
      if (Encoding(colfilter) == "unknown") 
         Encoding(colfilter) <- "UTF-8"
      colfilter
   }, "")
   
   if (Encoding(search) == "unknown")
      Encoding(search) <- "UTF-8"
   
   # coerce argument to data frame--data.table objects (for example) report that
   # they're data frames, but don't actually support the subsetting operations
   # needed for search/sort/filter without an explicit cast
   #
   # similarly, we need to convert tibbles to regular data.frames so that we can
   # properly invoke the list / data viewer on filtered rows
   x <- .rs.toDataFrame(x, "transformed", TRUE)
   
   # apply columnwise filters
   for (i in seq_along(filtered))
   {
      if (nchar(filtered[i]) > 0 && length(x[[i]]) > 0)
      {
         # split filter--string format is "type|value" (e.g. "numeric|12-25") 
         filter <- strsplit(filtered[i], split = "|", fixed = TRUE)[[1]]
         if (length(filter) < 2) 
         {
            # no filter type information
            next
         }
         filtertype <- filter[1]
         filterval <- filter[2]
         
         # apply filter appropriate to type
         if (identical(filtertype, "factor")) 
         {
            # apply factor filter: convert to numeric values and discard missing
            filterval <- as.numeric(filterval)
            matches <- as.numeric(x[[i]]) == filterval
            matches[is.na(matches)] <- FALSE
            x <- x[matches, , drop = FALSE]
         }
         else if (identical(filtertype, "character"))
         {
            # apply character filter: non-case-sensitive prefix
            # use PCRE and the special \Q and \E escapes to ensure no characters in
            # the search expression are interpreted as regexes 
            x <- x[grepl(paste("\\Q", filterval, "\\E", sep = ""), x[[i]], 
                         perl = TRUE, ignore.case = TRUE), , 
                   drop = FALSE]
         } 
         else if (identical(filtertype, "numeric"))
         {
            # apply numeric filter, range ("2-32") or equality ("15")
            filterval <- as.numeric(strsplit(filterval, "_")[[1]])
            if (length(filterval) > 1)
               # range filter
               x <- x[is.finite(x[[i]]) & x[[i]] >= filterval[1] & x[[i]] <= filterval[2], , drop = FALSE]
            else
               # equality filter
               x <- x[is.finite(x[[i]]) & x[[i]] == filterval, , drop = FALSE]
         }
         else if (identical(filtertype, "boolean")) 
         {
            filterval <- isTRUE(filterval == "TRUE")
            matches <- x[[i]] == filterval
            matches[is.na(matches)] <- FALSE
            x <- x[matches, , drop = FALSE]
         }
      }
   }
   
   # apply global search
   if (!is.null(search) && nchar(search) > 0)
   {
      # get columns for search
      searchColumns <- unclass(x)
      
      # also apply on row names if available
      if (is.data.frame(x))
      {
         info <- .row_names_info(x, type = 0L)
         if (is.character(info))
         {
            searchColumns[[length(searchColumns) + 1]] <- info
         }
      }
      
      # apply global search on data columns
      pattern <- paste0("\\Q", search, "\\E")
      matches <- lapply(searchColumns, function(column) {
         grepl(pattern, column, perl = TRUE, ignore.case = TRUE)
      })
      
      # collapse into single vector
      matches <- Reduce(`|`, matches)
      
      # update based on matches
      x <- x[matches, , drop = FALSE]
      
   }
   
   # apply sort
   if (length(cols) > 0)
   {
      vals <- list()
      # iterate every requested sort key; the previous "for (i in length(cols))"
      # ran the loop exactly once with i == length(cols), so multi-column sorts
      # silently applied only the last key.
      for (i in seq_along(cols))
      {
         idx <- cols[[i]]
         # list and data.frame columns are non-atomic; order() and xtfrm()
         # error out on them ("unimplemented type 'list'"), so skip them here
         # as a backstop in case the client requests a sort on such a column
         if (length(x[[idx]]) > 0 && !is.list(x[[idx]]))
         {
            if (identical(dirs[[i]], "asc"))
            {
               vals <- append(vals, list(x[[idx]]))
            }
            else
            {
               vals <- append(vals, list(-xtfrm(x[[idx]])))
            }
         }
      }
      
      if (length(vals) > 0)
      {
         x <- x[do.call(order, vals), , drop = FALSE]
      }
   }
   
   return(x)
})

# returns envName as an environment, or NULL if the conversion failed
.rs.addFunction("safeAsEnvironment", function(envName)
{
   env <- NULL
   tryCatch(
      {
         env <- as.environment(envName)
      }, 
      error = function(e) { })
   env
})

.rs.addFunction("findDataFrame", function(envName, objName, cacheKey, cacheDir) 
{
   env <- NULL
   
   # mark encoding on cache directory 
   if (Encoding(cacheDir) == "unknown")
      Encoding(cacheDir) <- "UTF-8"
   
   # do we have an object name? if so, check in a named environment
   if (!is.null(objName) && nchar(objName) > 0) 
   {
      if (is.null(envName) || identical(envName, "R_GlobalEnv") || 
          nchar(envName) == 0)
      {
         # global environment
         env <- globalenv()
      }
      else 
      {
         env <- .rs.safeAsEnvironment(envName)
         if (is.null(env))
            env <- emptyenv()
      }
      
      # if the object exists in this environment, return it (avoid creating a
      # temporary here)
      if (exists(objName, where = env, inherits = FALSE))
      {
         # attempt to coerce the object to a data frame--note that a null return
         # value here may indicate that the object exists in the environment but
         # is no longer a data frame (we want to fall back on the cache in this
         # case)
         dataFrame <- .rs.toDataFrame(get(objName, envir = env, inherits = FALSE), 
                                      objName, TRUE)
         if (!is.null(dataFrame)) 
            return(dataFrame)
      }
   }
   
   if (.rs.isNonEmptyScalarString(cacheKey))
   {
      # if the object exists in the cache environment, return it. objects
      # in the cache environment have already been coerced to data frames.
      if (exists(cacheKey, where = .rs.CachedDataEnv, inherits = FALSE))
         return(get(cacheKey, envir = .rs.CachedDataEnv, inherits = FALSE))
      
      # perhaps the object has been saved? attempt to load it into the
      # cached environment
      cacheFile <- file.path(cacheDir, paste(cacheKey, "Rdata", sep = "."))
      if (file.exists(cacheFile))
      {
         status <- try(load(cacheFile, envir = .rs.CachedDataEnv), silent = TRUE)
         if (inherits(status, "try-error"))
            return(NULL)
         
         if (exists(cacheKey, where = .rs.CachedDataEnv, inherits = FALSE))
            return(get(cacheKey, envir = .rs.CachedDataEnv, inherits = FALSE))
      }
   }
   
   # failure
   return(NULL)
})

# given a name, return the first environment on the search list that contains
# an object bearing that name. 
.rs.addFunction("findViewingEnv", function(name)
{
   # default to searching from the global environment
   env <- globalenv()
   
   # attempt to find a call frame from which View was invoked; this will allow
   # us to locate viewing environments further in the call stack
   # (e.g. in the debugger)
   for (i in seq_along(sys.calls()))
   {
      if (identical(deparse(sys.call(i)[[1]]), "View"))
      {
         env <- sys.frame(i - 1)
         break
      }
   }
   
   # NOTE: we previously looked through the parent environments of
   # the associated frame to find the actual environment hosting the
   # object being viewed, but this caused problems when attempting
   # to track object mutations. for example, the 'mtcars' dataset is
   # defined in 'package:datasets', but attempting to modify that
   # object would actually create that modified object in the R global
   # environment. for that reason, it's best to track objects from the
   # top-level environment where they were found, as that's where
   # "modified" versions of that object will be generated
   env
})

# attempts to determine whether the View(...) function the user has an 
# override (i.e. it's not the handler RStudio uses)
.rs.addFunction("isViewOverride", function()
{
   # check to see if View has been overridden: find the View() call in the 
   # stack and examine the function being evaluated there
   for (i in seq_along(sys.calls()))
   {
      if (identical(deparse(sys.call(i)[[1]]), "View"))
      {
         # the first statement in the override function should be a call to 
         # .rs.callAs
         return(!identical(deparse(body(sys.function(i))[[1]]), ".rs.callAs"))
      }
   }
   
   # if we can't find View on the callstack, presume the common case (no
   # override)
   FALSE
})

.rs.addFunction("viewHook", function(original, x, title) {
   
   # remember the expression from which the data was generated
   expr <- deparse(substitute(x), backtick = TRUE)
   
   # generate title if necessary (from deparsed expr)
   if (missing(title))
      title <- paste(expr[1])
   
   # collapse expr for serialization
   expr <- paste(expr, collapse = " ")
   
   name <- ""
   env <- emptyenv()
   
   if (.rs.isViewOverride()) 
   {
      # if the View() invoked wasn't our own, we have no way of knowing what's
      # been done to the data since the user invoked View() on it, so just view
      # a snapshot of the data
      name <- title
   }
   else if (is.name(substitute(x)))
   {
      # if the argument is the name of a variable, we can monitor it in its
      # environment, and don't need to make a copy for viewing
      name <- paste(deparse(substitute(x)))
      env <- .rs.findViewingEnv(name)
   }
   
   # is this a function? if it is, view as a function instead
   if (is.function(x)) 
   {
      # check the source refs to see if we can open the file itself instead of
      # opening a read-only source viewer
      srcref <- .rs.getSrcref(x)
      if (!is.null(srcref))
      {
         srcfile <- attr(srcref, "srcfile", exact = TRUE)
         filename <- .rs.nullCoalesce(srcfile$filename, "")
         if (!identical(filename, "~/.active-rstudio-document") &&
             file.exists(filename))
         {
            # the srcref points to a valid file--go there 
            .Call("rs_jumpToFunction",
                  normalizePath(filename, winslash = "/"),
                  srcref[[1]],
                  srcref[[5]],
                  TRUE,
                  PACKAGE = "(embedding)")
            
            return(invisible(NULL))
         }
      }
      
      # either this function doesn't have a source reference or its source
      # reference points to a file we can't locate on disk--show a deparsed
      # version of the function
      
      # remove package qualifiers from function name
      title <- sub("^[^:]+:::?", "", title)
      
      # infer environment location
      namespace <- .rs.environmentName(environment(x))
      if (identical(namespace, "R_EmptyEnv") || identical(namespace, ""))
         namespace <- "viewing"
      else if (identical(namespace, "R_GlobalEnv"))
         namespace <- ".GlobalEnv"
      invisible(.Call("rs_viewFunction", x, title, namespace, PACKAGE = "(embedding)"))
      return(invisible(NULL))
   }
   else if (inherits(x, "vignette"))
   {
      file.edit(file.path(x$Dir, "doc", x$File))
      return(invisible(NULL))
   }
   
   # delegate to object explorer if this is an 'explorable' object
   if (.rs.dataViewer.shouldUseObjectExplorer(x))
   {
      view <- .rs.explorer.viewObject(x, title = title, envir = env)
      return(invisible(view))
   }
   
   # convert Pandas DataFrames to R data.frames
   if (inherits(x, "pandas.core.frame.DataFrame"))
      x <- reticulate::py_to_r(x)
   
   # test for coercion to data frame--the goal of this expression is just to
   # raise an error early if the object can't be made into a frame; don't
   # require that we can generate row/col names
   coerced <- x
   eval(
      expr = substitute(as.data.frame(coerced, optional = TRUE)),
      envir = globalenv()
   )
   
   # save a copy into the cached environment
   cacheKey <- .rs.addCachedData(force(x), name)
   
   if (!.rs.isNonEmptyScalarString(cacheKey))
      return(invisible(NULL))
   
   # call viewData 
   invisible(.Call("rs_viewData", x, expr, title, name, env, cacheKey, FALSE))
})

.rs.registerReplaceHook("View", "utils", .rs.viewHook)

.rs.addFunction("dataViewer.shouldUseObjectExplorer", function(object)
{
   if (inherits(object, c("function", "vignette")))
      return(FALSE)
   
   # prefer data viewer for pandas DataFrames
   if (inherits(object, "pandas.core.frame.DataFrame"))
      return(FALSE)
   
   # don't explore regular data.frames
   isTabular <-
      is.data.frame(object) ||
      is.matrix(object) ||
      is.table(object)
   
   if (isTabular)
      return(FALSE)
   
   # other objects are worth using object explorer for
   TRUE
})

.rs.addFunction("viewDataFrame", function(x, title, preview) {
   cacheKey <- .rs.addCachedData(force(x), "")
   if (.rs.isNonEmptyScalarString(cacheKey))
      invisible(.Call("rs_viewData", x, "", title, "", emptyenv(), cacheKey, preview))
})

.rs.addFunction("initializeDataViewer", function(server) {
   if (server) {
      .rs.registerReplaceHook("edit", "utils", function(original, name, ...) {
         if (is.data.frame(name) || is.matrix(name))
            stop("Editing of data frames and matrixes is not supported in RStudio.", call. = FALSE)
         else
            original(name, ...)
      })
   }
})

.rs.addFunction("addCachedData", function(obj, objName) 
{
   cacheKey <- .Call("rs_generateShortUuid")
   .rs.assignCachedData(cacheKey, obj, objName)
   cacheKey
})

.rs.addFunction("assignCachedData", function(cacheKey, obj, objName) 
{
   # coerce to data frame before assigning, and don't assign if we can't coerce
   frame <- .rs.toDataFrame(obj, objName, TRUE)
   if (!is.null(frame) &&
       .rs.isNonEmptyScalarString(cacheKey))
      assign(cacheKey, frame, .rs.CachedDataEnv)
})

.rs.addFunction("removeCachedData", function(cacheKey, cacheDir)
{
   # mark encoding on cache directory 
   if (Encoding(cacheDir) == "unknown")
      Encoding(cacheDir) <- "UTF-8"
   
   if (.rs.isNonEmptyScalarString(cacheKey))
   {
      # remove data from the cache environment
      if (exists(".rs.CachedDataEnv") &&
          exists(cacheKey, where = .rs.CachedDataEnv, inherits = FALSE))
         rm(list = cacheKey, envir = .rs.CachedDataEnv, inherits = FALSE)
      
      # remove data from the cache directory
      cacheFile <- file.path(cacheDir, paste(cacheKey, "Rdata", sep = "."))
      if (file.exists(cacheFile))
         file.remove(cacheFile)
      
      # remove any working data
      .rs.removeWorkingData(cacheKey)
   }
   invisible(NULL)
})

.rs.addFunction("saveCachedData", function(cacheDir)
{
   # mark encoding on cache directory 
   if (Encoding(cacheDir) == "unknown")
      Encoding(cacheDir) <- "UTF-8"
   
   # no work to do if we have no cache
   if (!exists(".rs.CachedDataEnv")) 
      return(invisible(NULL))
   
   # save each active cache file from the cache environment
   lapply(ls(.rs.CachedDataEnv), function(cacheKey) {
      if (.rs.isNonEmptyScalarString(cacheKey))
         save(list = cacheKey, 
              file = file.path(cacheDir, paste(cacheKey, "Rdata", sep = ".")),
              envir = .rs.CachedDataEnv)
   })
   
   # clean the cache environment
   # can generate warnings if .rs.CachedDataEnv disappears (we call this on
   # shutdown); suppress these
   suppressWarnings(rm(list = ls(.rs.CachedDataEnv), where = .rs.CachedDataEnv))
   
   invisible(NULL)
})

.rs.addFunction("findWorkingData", function(cacheKey)
{
   if (.rs.isNonEmptyScalarString(cacheKey) &&
       exists(".rs.WorkingDataEnv") &&
       exists(cacheKey, where = .rs.WorkingDataEnv, inherits = FALSE))
      get(cacheKey, envir = .rs.WorkingDataEnv, inherits = FALSE)
   else
      NULL
})

.rs.addFunction("removeWorkingData", function(cacheKey)
{
   if (.rs.isNonEmptyScalarString(cacheKey) &&
       exists(".rs.WorkingDataEnv") &&
       exists(cacheKey, where = .rs.WorkingDataEnv, inherits = FALSE))
      rm(list = cacheKey, envir = .rs.WorkingDataEnv, inherits = FALSE)
   invisible(NULL)
})

.rs.addFunction("assignWorkingData", function(cacheKey, obj)
{
   if (.rs.isNonEmptyScalarString(cacheKey))
      assign(cacheKey, obj, .rs.WorkingDataEnv)
})

.rs.addFunction("findGlobalData", function(name)
{
   if (exists(name, envir = globalenv()))
   {
      if (inherits(get(name, envir = globalenv()), "data.frame"))
         return(name)
   }
   invisible("")
})

.rs.addFunction("isNonEmptyScalarString", function(x)
{
   is.character(x) && length(x) == 1 && nzchar(x)
})

#
# SessionCopilot.R
#
# Copyright (C) 2023 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("copilot.setLogLevel", function(level = 0L)
{
   .Call("rs_assistantSetLogLevel", as.integer(level), PACKAGE = "(embedding)")
})

.rs.addFunction("copilot.sendRequest", function(method, params = list())
{
   .Call("rs_assistantSendRequest", as.character(method), as.list(params), PACKAGE = "(embedding)")
})

.rs.addFunction("copilot.parseNetworkProxyUrl", function(url)
{
   # build regex
   reProxyUrl <- paste0(
      "^",
      "(?:(\\w+)://)?",         # protocol (optional)
      "(?:([^:]+):([^@]+)@)?",  # username + password (optional)
      "([^:]+):(\\d+)",         # host + port (required)
      "/?",                     # optional trailing slash, just in case
      "$"
   )
   
   # attempt to match
   networkProxy <- as.list(regmatches(url, regexec(reProxyUrl, url))[[1L]])
   if (length(networkProxy) != 6L)
      warning("couldn't parse network proxy url '", url, "'", call. = FALSE)
   
   # set names of matched values
   names(networkProxy) <- c("url", "protocol", "user", "pass", "host", "port")
   
   # drop empty strings
   networkProxy[!nzchar(networkProxy)] <- NULL
   
   # validate the protocol, if it was set
   protocol <- .rs.nullCoalesce(networkProxy$protocol, "http")
   if (protocol != "http")
      warning("only 'http' network proxies are supported by the GitHub copilot agent", call. = FALSE)
   
   # drop the 'url' and 'protocol' fields as they are not used by copilot
   networkProxy[c("url", "protocol")] <- NULL
   
   # port needs to be a number
   networkProxy[["port"]] <- as.integer(networkProxy[["port"]])

   # return rest of the data   
   .rs.scalarListFromList(networkProxy)
})

.rs.addFunction("copilot.authProvider", function()
{
   # check for auth provider from option
   authProvider <- getOption("rstudio.copilot.authProvider")
   if (is.null(authProvider))
      return(NULL)
 
   # return as scalar list
   .rs.scalarListFromList(authProvider)
})

.rs.addFunction("copilot.networkProxy", function()
{
   # check for proxy from option
   proxy <- getOption("rstudio.copilot.networkProxy")
   if (is.null(proxy))
      return(NULL)
 
   # return as scalar list
   .rs.scalarListFromList(proxy)
})

.rs.addFunction("copilot.proxyKerberosServicePrincipal", function()
{
   # check for principal from option
   principal <- getOption("rstudio.copilot.proxyKerberosServicePrincipal")
   if (is.null(principal))
      return(NULL)
 
   # return as scalar list
   .rs.scalarListFromList(principal)
})

#
# Options.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# get version
.rs.addGlobalFunction("RStudio.Version", function()
{
   .rs.api.versionInfo()
})

# custom browseURL implementation.
.rs.setOption("browser", function(url)
{
   .Call("rs_browseURL", url, PACKAGE = "(embedding)")
})

# default viewer option if not already set
.rs.setOptionDefault("viewer", function(url, height = NULL)
{
   if (!is.character(url) || (length(url) != 1))
      stop("url must be a single element character vector.", call. = FALSE)
   
   if (identical(height, "maximize"))
      height <- -1
   
   if (!is.null(height) && (!is.numeric(height) || (length(height) != 1)))
      stop("height must be a single element numeric vector or 'maximize'.", call. = FALSE)
   
   invisible(.Call("rs_viewer", url, height, PACKAGE = "(embedding)"))
})

# default page_viewer option if not already set
.rs.setOptionDefault("page_viewer", function(url,
                                             title = "RStudio Viewer",
                                             self_contained = FALSE)
{
   if (!is.character(url) || (length(url) != 1))
      stop("url must be a single element character vector.", call. = FALSE)
   
   if (!is.character(title) || (length(title) != 1))
      stop("title must be a single element character vector.", call. = FALSE)
   
   if (!is.logical(self_contained) || (length(self_contained) != 1))
      stop("self_contained must be a single element logical vector.", call. = FALSE)
   
   invisible(.Call("rs_showPageViewer", url, title, self_contained, PACKAGE = "(embedding)"))
})

# default shinygadgets.showdialog if not already set
.rs.setOptionDefault("shinygadgets.showdialog", function(caption,
                                                         url,
                                                         width = NULL,
                                                         height = NULL)
{
   if (!is.character(caption) || (length(caption) != 1))
      stop("caption must be a single element character vector.", call. = FALSE)
   
   if (!is.character(url) || (length(url) != 1))
      stop("url must be a single element character vector.", call. = FALSE)
   
   # default width and height
   if (is.null(width))
      width <- 600
   if (is.null(height))
      height <- 600
   
   # validate width and height
   if (!is.numeric(width) || (length(width) != 1))
      stop("width must be a single element numeric vector.", call. = FALSE)
   if (!is.numeric(height) || (length(height) != 1))
      stop("height must be a single element numeric vector.", call. = FALSE)
   
   invisible(.Call("rs_showShinyGadgetDialog", caption, url, width, height, PACKAGE = "(embedding)"))
})

# provide askpass function
.rs.setOption("askpass", function(prompt)
{
   .rs.askForPassword(prompt)
})

# provide asksecret function
.rs.setOption("asksecret", function(name,
                                    title = name,
                                    prompt = paste(name, ":", sep = ""))
{
   .rs.askForSecret(name, title, prompt)
})

# provide restart function
.rs.setOption("restart", function(afterRestartCommand = "")
{
   .rs.restartR(afterRestartCommand)
})

# custom pager implementation
.rs.setOption("pager", function(files, header, title, delete.file)
{
   .rs.pager(files, header, title, delete.file)
})

# never allow graphical menus
options(menu.graphics = FALSE)

# set max print to 1000 if not already set
if (is.null(getOption("max.print")) || (getOption("max.print") == 99999)) {
   options(max.print = 1000)
}

# set max print so that the DOM won't go haywire showing large datasets
if (getOption("max.print", 10000) > 10000) {
   options(max.print = 10000)
}

# set RStudio as the GUI
local({
   platform = .Platform
   if (platform$GUI != "RStudio") {
      platform$GUI = "RStudio"
      unlockBinding(".Platform", asNamespace("base"))
      assign(".Platform", platform, inherits = TRUE)
      lockBinding(".Platform", asNamespace("base"))
   }
})

# set default x display (see below for comment on why we need to do this)
if (is.na(Sys.getenv("DISPLAY", unset = NA)))
   Sys.setenv(DISPLAY = ":0")

# the above two display oriented command affect the behavior of edit.data.frame
# and edit.matrix as follows: these methods will use .Internal(edit, ...) rather
# than .Internal(dataentry, ...) if DISPLAY == "" or if the .Platform$GUI is
# "unknown". since we plan on running on a server without X available we need
# to manually make sure that the DISPLAY environment variable exists and that
# the .Platform$GUI is not "unknown"

# configure profvis to use custom path to store profiles
options(profvis.output_path = NULL)

# configure profvis to not delete generated profiles
options(profvis.keep_output = TRUE)

# indicate that we're not in a notebook by default
options(rstudio.notebook.executing = FALSE)

# avoid exceedingly-large deparsed line output
.rs.setOptionDefault("deparse.max.lines", 20L)

# provide a custom HTTP user agent
.rs.initHttpUserAgent()

#
# SessionGraphics.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("graphics.supportedBackends", function()
{
   c(
      if (Sys.info()[["sysname"]] == "Windows")
         "windows",
      
      if (.rs.hasCapability("aqua"))
         "quartz",
      
      if (.rs.hasCapability("cairo"))
         c("cairo", "cairo-png"),
      
      "ragg"
   )
   
})

.rs.addFunction("graphics.locator", function(n = 512, type = "n", ...)
{
   if (length(extras <- list(...))) {
      opar <- par(extras)
      on.exit(par(opar))
   }
   
   n <- as.integer(n)
   if (is.na(n) || n <= 0)
      stop(gettextf("invalid number of points in %s", "locator()"))
   
   p1 <- .External2(C_locator, 1L, type = type)
   if (p1[[3L]] == 0L)
      return(invisible(NULL))
   
   if (type %in% c("p", "o"))
      points(p1[[1L]], p1[[2L]])
   
   x <- numeric(n); y <- numeric(n)
   x[[1L]] <- p1[[1L]]; y[[1L]] <- p1[[2L]]
   
   range <- seq_len(n - 1L) + 1L
   for (i in range)
   {
      p2 <- .External2(C_locator, 1L, type = type)
      if (p2[[3L]] == 0L) {
         length(x) <- length(y) <- i - 1L
         break
      }
      
      x[[i]] <- p2[[1L]]; y[[i]] <- p2[[2L]]
      
      if (type %in% c("p", "o"))
         points(p2[[1L]], p2[[2L]])
      if (type %in% c("l", "o"))
         segments(p1[[1L]], p1[[2L]], p2[[1L]], p2[[2L]])
      
      p1 <- p2
   }
   
   list(x = x, y = y)
})

.rs.replaceBinding(
   binding  = "locator",
   package  = "graphics",
   override = .rs.graphics.locator
)

#
# SessionRSConnect.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("get_deployment_env_vars", function()
{
  # Find active .Renviron file
  environFile <- .rs.findEnvironFile()
  if (!nzchar(environFile) || !file.exists(environFile))
    return(character())

  # Read environment variable names from the file
  contents <- readLines(environFile, warn = FALSE)
  pattern <- "^\\s*([\\w_]+)\\s*="
  matchedLines <- grep(pattern, contents, perl = TRUE, value = TRUE)
  variables <- gsub("\\s*=.*", "", matchedLines)
  
  # Include some other special environment variables
  special <- c("DATABRICKS_HOST", "SNOWFLAKE_ACCOUNT")
  variables <- sort(union(variables, special))
  
  # Only include variables which are actually defined in the current session
  variables <- intersect(variables, names(Sys.getenv()))
  
  # All done
  variables
})

.rs.addJsonRpcHandler("forget_rsconnect_deployments", function(sourcePath, outputPath)
{
  # for R files, assume that the containing directory is treated as the
  # application path as opposed to the file itself
  ext <- tolower(tools::file_ext(sourcePath))
  if (identical(ext, "r"))
    sourcePath <- dirname(sourcePath)

  rsconnect::forgetDeployment(appPath = sourcePath, force = TRUE)
})

# this is a clone of 'applicationConfigDir' in the rsconnect package; we use it
# to detect the condition in which rsconnect has state but the package itself
# isn't installed.
.rs.addFunction("connectConfigDir", function(appName, subDir = NULL) {

  # get the home directory from the operating system (in case
  # the user has redefined the meaning of ~) but fault back
  # to ~ if there is no HOME variable defined
  homeDir <- Sys.getenv("HOME", unset="~")

  # determine application config dir (platform specific)
  sysName <- Sys.info()[['sysname']]
  if (identical(sysName, "Windows"))
    configDir <- Sys.getenv("APPDATA")
  else if (identical(sysName, "Darwin"))
    configDir <- file.path(homeDir, "Library/Application Support")
  else
    configDir <- Sys.getenv("XDG_CONFIG_HOME", file.path(homeDir, ".config"))

  # append the application name and optional subdir
  configDir <- file.path(configDir, "R", appName)
  if (!is.null(subDir))
    configDir <- file.path(configDir, subDir)

  # normalize path
  configDir <- normalizePath(configDir, mustWork=FALSE)

  # ensure that it exists
  if (!file.exists(configDir))
    dir.create(configDir, recursive=TRUE)

  # return it
  configDir
})

.rs.addFunction("scalarListFromFrame", function(frame)
{
   ret <- list()

   # return an empty list when no entries exist
   if (is.null(frame))
     return(ret)

   cols <- names(frame)

   # take apart the frame and compose a list of scalars from each row
   for (i in seq_len(nrow(frame))) {
      row <- lapply(cols,
                    function(col) { if (is.null(frame[i,col])) NULL
                                    else .rs.scalar(unlist(frame[i,col])) })
      names(row) <- cols
      ret[[i]] <- row
   }
   return(ret)
})

.rs.addFunction("getRSConnectDeployments", function(path, rpubsUploadId) {
   # start with an empty list
   deploymentsFrame <- data.frame(
     name = character(0),
     account = character(0),
     server = character(0),
     bundleId = character(0),
     appId = character(0),
     asStatic = logical(0),
     hostUrl = character(0),
     username = character(0),
     when = numeric(0))
   deployments <- list()
   servers <- data.frame(
     name = character(0),
     url = character(0))
   accounts <- data.frame(
     name = character(0),
     server = character(0))

   # attempt to populate the list from rsconnect; this can throw if e.g. the
   # package is not installed. in the case of any error we'll safely return
   # an empty list, or a stored RPubs upload ID if one was given (below)
   tryCatch({
     # included "orphaned" deployments; we will filter later
     deploymentsFrame <- rsconnect::deployments(appPath = path, excludeOrphaned = FALSE)
     deployments <- .rs.scalarListFromFrame(deploymentsFrame)

     # create the list of servers and accounts (for later filtering)
     servers <- rsconnect::servers()
     accounts <- rsconnect::accounts()
   }, error = function(e) { })

   # cross-reference registered servers against the list of deployments, so the
   # client knows without issuing a separate RPC which deployments don't have
   # registered servers
   if (nrow(deploymentsFrame) > 0) {
     # filter the list of servers by those that actually have accounts
     # registered
     servers <- servers[
         as.character(servers$name) %in% as.character(accounts$server),]

     # extract names and URLs from the remaining servers (include the virtual server rpubs.com)
     urls <- as.character(servers[["url"]])
     names <- c(as.character(servers[["name"]]), "rpubs.com")

     # compute whether the deployment is orphaned; note that this differs from
     # the definition of "orphaned" used by the rsconnect package in that it
     # considers only the server (not the account)
     deploymentsFrame <- cbind(deploymentsFrame, list(
       serverRegistered = as.character(deploymentsFrame[["server"]]) %in% names |
                          as.character(deploymentsFrame[["hostUrl"]]) %in% urls))

     # rebuild list with additional metadata
     deployments <- .rs.scalarListFromFrame(deploymentsFrame)
   }

   # no RPubs upload IDs to consider
   if (!is.character(rpubsUploadId) || nchar(rpubsUploadId) == 0) {
     return(deployments)
   }

   # if there's already a deployment to rpubs.com, ignore legacy deployment
   if ("rpubs.com" %in% deployments$server) {
     return(deployments)
   }

   # create a new list with the same names as the one we're about to return,
   # and populate the fields we know from RPubs. leave all others, including
   # user-defined fields, blank; this allows us to tolerate changes to the
   # deployment frame format.
   rpubsDeployment <- list()
   for (col in colnames(deploymentsFrame)) {
     if (col == "name")
       rpubsDeployment[col] = ""
     else if (col == "account")
       rpubsDeployment[col] = "rpubs"
     else if (col == "server")
       rpubsDeployment[col] = "rpubs.com"
     else if (col == "appId")
       rpubsDeployment[col] = rpubsUploadId
     else if (col == "bundleId")
       rpubsDeployment[col] = rpubsUploadId
     else if (col == "asStatic")
       rpubsDeployment[col] = TRUE
     else if (col == "when")
       rpubsDeployment[col] = 0
     else if (col == "hostUrl")
       rpubsDeployment[col] = "rpubs.com"
     else if (col == "username")
       rpubsDeployment[col] = "rpubs"
     else
       rpubsDeployment[col] = NA
   }

   # combine the deployments rsconnect knows about with the deployments we know
   # about
   c(deployments, list(.rs.scalarListFromList(rpubsDeployment)))
})

.rs.addJsonRpcHandler("get_rsconnect_account_list", function()
{
   accountList <- tryCatch(
     .rs.rsconnect.getAccountList(),
     error = function(e) NULL
   )
   
   .rs.scalarListFromFrame(accountList)
})

.rs.addFunction("rsconnect.getAccountList", function()
{
  accountList <- rsconnect::accounts()
  
  # if raw characters (older rsconnect), presume shinyapps.io
  if (is.character(accountList))
  {
    accountList <- data.frame(
      name   = accountList,
      server = "shinyapps.io"
    )
  }
  
  accountList
  
})

.rs.addJsonRpcHandler("remove_rsconnect_account", function(account, server) {
   rsconnect::removeAccount(name = account, server = server)
})

.rs.addJsonRpcHandler("get_rsconnect_app_list", function(account, server) {
   if (rsconnect:::isPositConnectCloudServer(server))
      return(list())
   .rs.scalarListFromFrame(rsconnect::applications(account = account, server = server))
})

.rs.addJsonRpcHandler("get_rsconnect_app", function(id, account, server, hostUrl) {

  # retrieve application associated with these parameters
  if (rsconnect:::isPositConnectCloudServer(server)) {
    app <- tryCatch(
      .rs.rsconnect.getConnectCloudContent(id, account, server),
      error = identity
    )
  } else {
    app <- tryCatch(
      rsconnect:::getAppById(id, account, server, hostUrl),
      error = identity
    )
  }

  # check for and return errors
  if (inherits(app, "error")) {
    message <- paste(conditionMessage(app), collapse = "\n")
    return(list(app = NULL, error = .rs.scalar(message)))
  }

  # if no such application is available, just return an empty list
  if (length(app) == 0L) {
    return(list(app = NULL, error = NULL))
  }

  # infer the configuration URL for this application
  app$config_url <- if (rsconnect:::isPositConnectCloudServer(server)) {
    paste(rsconnect:::connectCloudUrls()$ui, account, "content", app$id, sep = "/")
  } else if (rsconnect:::isConnectServer(server)) {
    prefix <- sub("/__api__", "", hostUrl)
    paste(prefix, "connect/#/apps", app$id, sep = "/")
  } else {
    prefix <- "https://www.shinyapps.io/admin/#/applications"
    paste(prefix, app$id, sep = "/")
  }

  # try and get environment variables for this deployment (if available)
  # (not yet supported for Connect Cloud)
  if (!rsconnect:::isPositConnectCloudServer(server)) {
    app$envVars <- .rs.rsconnect.getApplicationEnvVars(
      server  = server,
      account = account,
      guid    = app$guid
    )
  }

  list(
    app = .rs.scalarListFromList(app),
    error = NULL
  )

})

.rs.addJsonRpcHandler("validate_server_url", function(url) {
   # suppress output when validating server URL
   # (timeouts otherwise emitted to console)
   capture.output(serverInfo <- rsconnect:::validateServerUrl(url = url))
   .rs.scalarListFromList(serverInfo)
})

.rs.addJsonRpcHandler("get_auth_token", function(name) {
   .rs.scalarListFromList(rsconnect:::getAuthToken(server = name))
})

.rs.addJsonRpcHandler("get_user_from_token", function(url, token, privateKey) {
   user <- rsconnect:::getUserFromRawToken(serverUrl = url, token = token, privateKey = privateKey)
   .rs.scalarListFromList(user)
})

.rs.addJsonRpcHandler("register_user_token", function(serverName, accountName,
   userId, token, privateKey) {
  rsconnect:::registerUserToken(serverName = serverName, accountName = accountName, userId = userId,
                                token = token, privateKey = privateKey)
})

.rs.addJsonRpcHandler("get_rsconnect_lint_results", function(target) {
   err <- ""
   results <- NULL
   basePath <- ""

   # validate and lint the requested target
   if (!file.exists(target)) {
     err <- paste("The file or directory ", target, " does not exist.")
   } else {
     tryCatch({
       info <- file.info(target)
       if (info$isdir) {
         # a directory was specified--lint the whole thing
         basePath <- target
         results <- rsconnect::lint(project = basePath)
       } else if (tolower(tools::file_ext(target)) == "r") {
         # a single-file Shiny app--lint the directory (with file hint)
         basePath <- dirname(target)
         results <- rsconnect::lint(project = basePath, appPrimaryDoc = basename(target))
       } else {
         # a single file was specified--lint just that file
         basePath <- dirname(target)
         results <- rsconnect::lint(project = basePath, files = basename(target))
       }
    }, error = function(e) {
      err <<- e$message
    })
  }

  # empty or missing results; no need to do further work
  if (identical(length(results), 0) || !rsconnect:::hasLint(results)) {
    return(list(
      has_lint = .rs.scalar(FALSE),
      error_message = .rs.scalar(err)))
  }

  # we have a list of lint results; convert them to markers and emit them to
  # the Markers pane
  rsconnect:::showRstudioSourceMarkers(basePath = basePath, results)

  # return the result to the client
  list(
    has_lint = .rs.scalar(TRUE),
    error_message = .rs.scalar(err))
})

.rs.addFunction("docDeployList", function(target, asMultipleDoc, quartoSrcFile) {
  file_list <- c()
  target <- normalizePath(target, winslash = "/")

  # if deploying multiple documents, find all the files in the with a matching
  # extension; otherwise, just use the single document we were given
  if (asMultipleDoc) {
    targets <- list.files(path = dirname(target),
      pattern = glob2rx(paste("*", tools::file_ext(target), sep = ".")),
      ignore.case = TRUE, full.names = TRUE)
  } else {
    targets <- target
  }

  yaml <- NULL

  # check for a known encoding
  encoding <- getOption("encoding")
  properties <- .rs.getSourceDocumentProperties(target)
  if (!is.null(properties$encoding))
     encoding <- properties$encoding

  # attempt to parse yaml front matter
  yaml <- tryCatch(
     rmarkdown::yaml_front_matter(target, encoding = encoding),
     error = function(e) NULL
  )

  # if this failed, try again as UTF-8
  if (is.null(yaml) && !identical(encoding, "UTF-8"))
  {
     yaml <- tryCatch(
        rmarkdown::yaml_front_matter(target, encoding = "UTF-8"),
        error = function(e) NULL
     )
  }

  # check to see if the target has "runtime: shiny/prerendred", if so then
  # return a full directory deploy list
  if (is.list(yaml) && (identical(yaml$runtime, "shiny_prerendered") ||
                        identical(yaml$runtime, "shinyrmd") ||
                        identical(yaml$server, "shiny") ||
                        (is.list(yaml$server) && identical(yaml$server$type, "shiny"))
                       )
     )
  {
    return(rsconnect::listBundleFiles(appDir = dirname(target)))
  }

  # find the resources used by each document
  for (t in targets) {
    deploy_frame <- NULL
    tryCatch({
      # this operation can be expensive and could also throw if e.g. the
      # document fails to parse or render
      deploy_frame <- rmarkdown::find_external_resources(t)
    },
    error = function(e) {
      # errors are not fatal here; we just might miss some resources, which
      # the user will have to add manually
    })
    if (!is.null(deploy_frame)) {
      file_list <- c(file_list, deploy_frame$path)
    }
    file_list <- c(file_list, basename(t))
  }

  if (nzchar(quartoSrcFile)) {
    # query quarto for project and resources
    quartoSrcFile <- normalizePath(quartoSrcFile, winslash = "/")
    project <- .rs.quartoFileProject(quartoSrcFile)
    resources <- project$resources
    project <- project$project

    # query quarto for resources
    file_list <- c(file_list, resources)

    # per-directory option may be given in _metadata.yml
    if (file.exists(file.path(dirname(quartoSrcFile), "_metadata.yml"))) {
      file_list <- c(file_list, "_metadata.yml")
    }

    if (length(project)) {
      if (identical(project, "")) {
        file_list <- c(file_list, "_quarto.yml")
      } else {
        file_list <- c(file_list, file.path(project, "_quarto.yml"))
      }
    }
  }

  # discard any duplicates (the same resource may be depended upon by multiple
  # R Markdown documents)
  file_list <- unique(file_list)

  # resolve full paths and keep only files that exist on disk; Quarto v1.9
  # returns project metadata for standalone files, causing _quarto.yml to be
  # added to the file list even when no project file exists
  full_paths <- file.path(dirname(target), file_list)
  exists <- file.exists(full_paths)
  file_list <- file_list[exists]
  full_paths <- full_paths[exists]

  # compose the result
  list(
    contents = file_list,
    totalSize = sum(file.info(full_paths)$size, na.rm = TRUE))
})

.rs.addFunction("makeDeploymentList", function(target, asMultipleDoc,
                                               quartoSrcFile, max_size) {
   ext <- tolower(tools::file_ext(target))
   if (ext %in% c("qmd", "rmd", "html", "htm", "md"))
     .rs.docDeployList(target, asMultipleDoc, quartoSrcFile)
   else
     rsconnect::listBundleFiles(appDir = target)
})

.rs.addFunction("quartoFileResources", function(target) {
   .Call("rs_quartoFileResources", target)
})

.rs.addFunction("quartoFileProject", function(target) {
   .Call("rs_quartoFileProject", basename(target), dirname(target), PACKAGE = "(embedding)")
})

# Given a list of files of the form:
#
# file2.ext
# dir/file1.ext
# dir/file2.ext
# dir/file3.ext
# dir/subdir/file4.ext
# dir2/file2.ext
#
# and a threshold, collapses all directories that contain more than the threshold
# number of files. For instance, if threshold = 2, the result from the above
# would be:
#
# file2.ext
# dir2/file2.ext
# dir/

.rs.addFunction("summarizeDir", function(files, threshold) {
  # extract the subdir using a regex
  prefixes <- regexec("^([^/])+/", files)

  # extract the matching text to form a list of top-level subdirs; skip files
  # with no prefix
  prefixes <- lapply(regmatches(x = files, m = prefixes), `[`, 1)
  prefixes[is.na(prefixes)] <- ""

  # get a list of top-level directories
  toplevel <- sort(unlist(prefixes))

  # get a count of the number of files in each top-level dir
  counts <- rle(toplevel)

  # for those dirs which have more than the threshold, hide all of the contents
  rollups <- which(counts$lengths > threshold)
  include <- rep_len(TRUE, length(files))
  for (rollup in rollups) {
    if (nzchar(counts$values[rollup]))
       include <- include & prefixes != counts$values[rollup]
  }

  # combine the files to be included with the top-level directories that were
  # rolled up
  toplevel <- counts$values[rollups]
  c(files[include], toplevel[nzchar(toplevel)])
})

.rs.addFunction("rsconnectDeployList", function(target, asMultipleDoc, quartoSrcFile) {
  max_size <- getOption("rsconnect.max.bundle.size", 1048576000)
  dirlist <- .rs.makeDeploymentList(target, asMultipleDoc, quartoSrcFile, max_size)

  list (
    # if the directory is too large, no need to bother sending a potentially
    # large blob of data to the client
    dir_list = if (dirlist$totalSize >= max_size)
                  NULL
               else
                  .rs.summarizeDir(dirlist$contents, 5),
    max_size = .rs.scalar(max_size),
    dir_size = .rs.scalar(dirlist$totalSize))
})

.rs.addFunction("enableRStudioConnectUI", function(enable) {
  .rs.enqueClientEvent("enable_rstudio_connect", enable);
  message("Posit Connect UI ", if (enable) "enabled" else "disabled", ".")
  invisible(enable)
})

.rs.addFunction("hasConnectAccount", function() {
   tryCatch({
      # check for any non-shinyapps.io accounts
      accounts <- rsconnect::accounts()
      subset(accounts, !(server %in% c("shinyapps.io", "rstudio.cloud", "posit.cloud")))
      .rs.scalar(nrow(accounts) > 0)
   }, error = function(e) { FALSE })
})


.rs.addJsonRpcHandler("get_deployment_files", function(target, asMultipleDoc, quartoSrcFile) {
  .rs.rsconnectDeployList(target, asMultipleDoc, quartoSrcFile)
})

# The parameter to this function is a string containing the R command from
# the rsconnect service; we just need to parse and execute it directly.
# The client is responsible for verifying that the statement corresponds to
# a valid ::setAccountInfo command.
.rs.addJsonRpcHandler("connect_rsconnect_account", function(accountCmd) {
   cmd <- parse(text=accountCmd)
   eval(cmd, envir = globalenv())
})

# Drop-in replacement for rsconnect:::cli_menu that routes the selection
# through a GWT dialog instead of prompting on the R console. Signature
# matches rsconnect:::cli_menu(header, prompt, choices, quit = NULL, ...).
.rs.addFunction("cliMenu", function(header, prompt, choices, quit = NULL, ...) {
   selected <- .rs.api.showMenu(
      title = header,
      message = prompt,
      choices = choices
   )
   if (is.null(selected))
      stop("Account selection cancelled.", call. = FALSE)
   selected
})

# Connect a Posit Connect Cloud account via OAuth device flow. The R session
# is blocked while waiting for the browser authentication to complete. The
# override of rsconnect:::cli_menu below keeps the multi-account prompt out
# of the R console (where a modal glass panel would block it) and into a
# GWT dialog instead (see issue #17441).
.rs.addJsonRpcHandler("connect_cloud_user", function() {
   original <- .rs.tryCatch(
      .rs.replaceBinding("cli_menu", "rsconnect", .rs.cliMenu)
   )
   if (!inherits(original, "error"))
      on.exit(.rs.replaceBinding("cli_menu", "rsconnect", original), add = TRUE)

   rsconnect::connectCloudUser()
})


.rs.addFunction("getRmdPublishDetails", function(target, encoding) {

  # read yaml
  lines <- readLines(target, encoding = encoding, warn = FALSE)
  frontMatter <- rmarkdown:::parse_yaml_front_matter(lines)

  # if this is runtime: shiny_prerendered then is_multi_rmd is FALSE
  if (is.list(frontMatter) &&
      (identical(frontMatter$runtime, "shiny_prerendered") ||
       identical(frontMatter$runtime, "shinyrmd") ||
       identical(frontMatter$server, "shiny") ||
       (is.list(frontMatter$server) && identical(frontMatter$server$type, "shiny")))) {
    is_multi_rmd <- FALSE
  } else {
    # check for multiple R Markdown documents in the directory
    rmds <- list.files(path = dirname(target), pattern = glob2rx("*.Rmd"),
                       all.files = FALSE, recursive = FALSE, ignore.case = TRUE,
                       include.dirs = FALSE)
    is_multi_rmd <- length(rmds) > 1
  }

  # see if this format is self-contained (defaults to true for HTML-based
  # formats)
  selfContained <- TRUE
  outputFormat <- rmarkdown:::output_format_from_yaml_front_matter(lines)
  if (is.list(outputFormat$options) &&
      identical(outputFormat$options$self_contained, FALSE)) {
    selfContained <- FALSE
  }

  # extract the document's title
  title <- ""
  if (is.list(frontMatter) && is.character(frontMatter$title)) {
    title <- frontMatter$title
  }

  # check to see if this is an interactive doc (i.e. needs to be run rather
  # rather than rendered)
  renderFunction <- .rs.getCustomRenderFunction(target)

  list(
    is_multi_rmd        = .rs.scalar(is_multi_rmd),
    is_shiny_rmd        = .rs.scalar(renderFunction == "rmarkdown::run"),
    is_self_contained   = .rs.scalar(selfContained),
    title               = .rs.scalar(title),
    has_connect_account = .rs.scalar(.rs.hasConnectAccount()))
})

# indicates whether there appear to be accounts registered on the system that
# cannot be used because the rsconnect package isn't installed
.rs.addJsonRpcHandler("has_orphaned_accounts", function() {
  # get the folder in which we expect account data to exist
  accountDir <- .rs.connectConfigDir("rsconnect", "accounts")

  # if this folder doesn't exist, check the old location
  if (!file.exists(accountDir))
    accountDir <- .rs.connectConfigDir("connect", "accounts")

  # if we found a config folder, list all regular files (not directories) inside
  # it
  if (file.exists(accountDir)) {
    files <- list.files(accountDir, recursive = TRUE, include.dirs = FALSE)

    # if there are files and the rsconnect package isn't installed at all,
    # consider those files to correspond to orphaned accounts
    if (length(files) > 0 && !.rs.isPackageInstalled("rsconnect")) {
      return(.rs.scalar(length(files)))
    }
  }

  return(.rs.scalar(0))
})

.rs.addJsonRpcHandler("get_server_urls", function() {
  servers <- rsconnect::servers()

  # convert from factors if necessary
  for (col in c("name", "url")) {
    if (col %in% colnames(servers)) {
      servers[[col]] <- as.character(servers[[col]])
    }
  }
  .rs.scalarListFromFrame(servers)
})

.rs.addJsonRpcHandler("generate_app_name", function(appTitle, appPath, account) {
  name  <- ""
  valid <- TRUE
  error <- ""

  # attempt to generate a name from the title
  tryCatch({
    name <- rsconnect::generateAppName(appTitle = appTitle,
                                       appPath  = appPath,
                                       account  = account)
  }, error = function(e) {
    valid <<- FALSE
    error <<- e$message
  })

  # report result
  list(name  = .rs.scalar(name),
       valid = .rs.scalar(valid),
       error = .rs.scalar(error))
})

.rs.addFunction("rsconnect.getConnectCloudContent", function(id, account, server)
{
  accountDetails <- rsconnect::accountInfo(account, server)
  client <- rsconnect:::clientForAccount(accountDetails)
  client$getContent(id)
})

.rs.addFunction("rsconnect.getApplicationEnvVars", function(server, account, guid)
{
  tryCatch(
    .rs.rsconnect.getApplicationEnvVarsImpl(server, account, guid),
    error = function(e) character()
  )
})

.rs.addFunction("rsconnect.getApplicationEnvVarsImpl", function(server, account, guid)
{
  rsconnect <- asNamespace("rsconnect")
  accountDetails <- rsconnect$accountInfo(account, server)
  client <- rsconnect$clientForAccount(accountDetails)
  client$getEnvVars(guid)
})

.rs.addFunction("findEnvironFile", function()
{
   environFile <- Sys.getenv("R_ENVIRON_USER", unset = NA)
   if (!is.na(environFile))
      return(environFile)
   
   project <- .rs.getProjectDirectory()
   if (!is.null(project))
   {
      projectEnviron <- file.path(project, ".Renviron")
      if (file.exists(projectEnviron))
         return(projectEnviron)
   }
   
   userEnviron <- path.expand("~/.Renviron")
   if (file.exists(userEnviron))
      return(userEnviron)
   
   ""
})

#
# SessionAskSecret.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("getSecretService", function() {
   "RStudio Keyring Secrets"
})

.rs.addFunction("askForSecret", function(name, title = name, prompt = paste(name, ":", sep = ""))
{
   result <- .Call(
      "rs_askForSecret",
      name,
      title,
      prompt,
      .rs.isPackageInstalled("keyring"),
      .rs.hasSecret(name)
   )

   if (is.null(result)) stop("Ask for secret operation was cancelled.")
   
   result
})

.rs.addFunction("hasSecret", function(name)
{
   if (!.rs.isPackageInstalled("keyring"))
   {
      FALSE
   }
   else
   {
      keyring_list <- get("key_list", envir = asNamespace("keyring"))
      keys <- keyring_list(.rs.getSecretService())
      name %in% keys$username
   }
})

.rs.addFunction("retrieveSecret", function(name)
{
   if (!.rs.isPackageInstalled("keyring") || !.rs.hasSecret(name))
   {
      NULL
   }
   else 
   {
      keyring_get <- get("key_get", envir = asNamespace("keyring"))
      keyring_get(.rs.getSecretService(), username = name)
   }
})

.rs.addFunction("rememberSecret", function(name, secret)
{
   if (.rs.isPackageInstalled("keyring"))
   {
      keyring_set <- get("key_set_with_value", envir = asNamespace("keyring"))
      keyring_set(.rs.getSecretService(), username = name, password = secret)
   }
})

.rs.addFunction("forgetSecret", function(name)
{
   if (.rs.isPackageInstalled("keyring") && .rs.hasSecret(name))
   {
      keyring_remove <- get("key_delete", envir = asNamespace("keyring"))
      keyring_remove(.rs.getSecretService(), username = name)
   }
})

#!/usr/bin/env Rscript

#
# generate-options.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.


# This script generates binary options for various RStudio Server binaries,
# creating the necessary boiler plate options code as well as creating
# documentation for the options in the form of appendices to the admin
# guide. 
#
# To add options, do the following:
#
# 1. Add your option to the JSON options file corresponding to the binary
# that the option belongs to
# 2. In a terminal, navigate to this folder (src/cpp/)
# 3. Run this script: /generate-options.R
# 4. Commit the .gen.hpp files and the admin guide documentation files

require(here)
require(jsonlite)
require(stringi)
require(stringr)
require(tibble)

root <- here::here()
setwd(root)

defaultOptionsFiles <- c(
   "src/cpp/server/server-options.json",
   "src/cpp/session/session-options.json"
)

generateCopyright <- function (filename) {
   sprintf("/*
 * %s
 *
 * Copyright (C) 2022 by Posit Software, PBC
 *
 * Unless you have received this program directly from Posit Software pursuant
 * to the terms of a commercial license agreement with Posit Software, then
 * this program is licensed to you under the terms of version 3 of the
 * GNU Affero General Public License. This program is distributed WITHOUT
 * ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
 * AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
 *
 */", filename)
}

generateHandEditWarning <- function () {
   "// THIS FILE WAS AUTOMATICALLY GENERATED BY A TOOL (generate-options.R) - DO NOT HAND EDIT IT"
}

generateQmdHandEditWarning <- function (sourceFile, overlayFile) {
   overlayLine <- if (!is.null(overlayFile) && file.exists(overlayFile)) {
      sprintf("\n(and %s in rstudio/rstudio-pro for Pro-only options)", overlayFile)
   } else {
      ""
   }
   sprintf("<!--
THIS FILE WAS AUTOMATICALLY GENERATED BY A TOOL (generate-options.R) - DO NOT HAND EDIT IT.
To modify these options, edit %s in rstudio/rstudio%s,
then re-run: Rscript scripts/generate-options.R
-->", sourceFile, overlayLine)
}

generateIncludeGuard <- function (includeGuardName) {
   sprintf("#ifndef %s
#define %s", includeGuardName, includeGuardName)
}

generateEndIncludeGuard <- function (includeGuardName) {
   sprintf("#endif // %s", includeGuardName)
}

generateIncludes <- function (includes) {
   includeStr <- ""
   for (include in includes) {
      if (!startsWith(include, "<")) {
         include <- sprintf("\"%s\"", include)
      }
      includeStr <- paste0(includeStr, sprintf("#include %s\n", include))
   }
   includeStr
}

generateNamespace <- function (namespaceName) {
   namespaces <- strsplit(namespaceName, "::")
   namespaceStr <- ""
   for (namespace in namespaces[[1]]) {
      namespaceStr <- paste0(namespaceStr, sprintf("namespace %s {\n", namespace))
   }
   namespaceStr
}

generateEndNamespace <- function (namespaceName) {
   namespaces <- strsplit(namespaceName, "::")
   namespaceStr <- ""
   for (namespace in rev(namespaces[[1]])) {
      namespaceStr <- paste0(namespaceStr, sprintf("} // namespace %s\n", namespace))
   }
   namespaceStr
}

# converts a type specified within an options json file to the corresponding cpp type
cppTypeFromJsonType <- function (type) {
   if (!is.null(type)) {
      if (identical(type, "string")) {
         type <- "std::string"
      } else if (identical(type, "stringList")) {
         type <- "std::vector<std::string>"
      }
   }
   type
}

# generates qmd documentation for the given options
generateQmd <- function (optionsJson, overlayOptionsJson, sourceFile, overlayFile) {
   metadata <- optionsJson$metadata
   
   configFile <- metadata$configFile
   outputDocFile <- metadata$outputDocFile
   if (is.null(outputDocFile)) {
      stop(sprintf("No outputDocFile specified for %s config", configFile))
   }
   
   # header for Quarto file
   qmd <- paste("---",
                paste0("title: \"", configFile, "\""),
                "aliases:",
                paste0("  - /rstudio-configuration-1.html#", configFile),
                "---",
                "",
                generateQmdHandEditWarning(sourceFile, overlayFile),
                "",
                sep = "\n")

   docDescription <- metadata$docDescription
   if (is.null(docDescription)) {
      docDescription <- 
         sprintf("The following is a list of available options that can be specified in the `%s` configuration file",
                 configFile)
   }
   qmd <- paste0(qmd, "\n", docDescription, "\n\n")
   
   # combine options and overlay options
   options <- optionsJson$options
   overlayOptions <- overlayOptionsJson$options
   for (category in names(overlayOptions)) {
      for (option in overlayOptions[[category]]) {
         option[["isOverlay"]] <- TRUE
         options[[category]][[length(options[[category]]) + 1]] <- option
      }
   }
   
   for (category in names(options)) {
      categoryOptions <- ""
      for (option in options[[category]]) {
         optionName <- option$name
         if (is.null(optionName)) {
            # no name means this is a hidden option that should not be documented
            next
         }
         
         isHidden <- option$isHidden
         if (isTRUE(isHidden)) {
            # if marked hidden, do not document this option
            next
         }
         
         if (identical(typeof(optionName), "list")) {
            optionConstant <- optionName[["constant"]]
            optionName <- optionName[["value"]]
            if (is.null(optionName)) {
               stop(sprintf("No user constant value specified for %s - required for documentation", optionConstant))
            }
         }
         
         description <- option$description
         type <- option$tempType
         if (is.null(type)) {
            type <- option$type
         }
         
         # fix up type for commonly used non-boost types
         if (identical(type, "core::FilePath")) {
            type <- "string"
         } else if (identical(type, "stringList")) {
            type <- "string"
         }
         
         default <- option$defaultValue
         if (identical(type, "string") && (is.null(default) || identical(default, "") || identical(default, "std::string()"))) {
            default <- "<empty string>"
         } else if (identical(type, "bool") && identical(typeof(default), "logical")) {
            default <- if (default) "1" else "0"
         } else if (identical(typeof(default), "list")) {
            default <- default[["description"]]
            if (is.null(default)) {
               stop(sprintf("No code description given for default value for %s - required for documentation", optionName))
            }
         }

         isDeprecated <- option$isDeprecated
         if (isTRUE(isDeprecated)) {
            description <- sprintf("%s  \n**This option is deprecated and should not be used.**", description)
         }
         
         proHeader <- ""
         isOverlay <- option$isOverlay
         if (isTRUE(isOverlay)) {
            proHeader <- "{.pro-header}"
         }
         
         categoryOptions <- paste0(categoryOptions,
                                   sprintf("#### **%s** %s  \n", optionName, proHeader),
                                   description, "  \n  \n",
                                   sprintf("Type: %s  \n", type),
                                   sprintf("Default: `%s  `\n  \n", default))
      }
      
      if (str_length(categoryOptions) > 0) {
         qmd <- paste(qmd, sprintf("### *%s* Settings", category), sep="\n")
         qmd <- paste(qmd, categoryOptions, sep="\n\n")
      }
   }
   
   writeLines(qmd, con = outputDocFile)
}

# generates the include guard name
getIncludeGuard <- function (metadata) {
   # generate include guard
   includeGuard <- metadata$includeGuard
   if (is.null(includeGuard)) {
      # generate include guard from output file name when not specified
      includeGuard <- str_replace_all(toupper(basename(metadata$outputSourceFile)), fixed("."), "_")
   }
   includeGuard
}

# generates options CPP code in boost::program_options format
generateProgramOptions <- function (optionsJson, overlayOptionsJson) {
   metadata <- optionsJson$metadata
   
   outputSourceFile <- metadata$outputSourceFile
   if (is.null(outputSourceFile)) {
      stop("Required metadata parameter outputSourceFile not specified")
   }
   
   # generate copyright notice
   sourceFilename <- basename(outputSourceFile)
   generatedContents <- generateCopyright(sourceFilename)
   
   # generate hand edit warning
   generatedContents <- paste(generatedContents, generateHandEditWarning(), sep="\n\n")
   
   # generate include guard
   includeGuard <- getIncludeGuard(metadata)
   generatedContents <- paste(generatedContents, generateIncludeGuard(includeGuard), sep="\n\n")
   
   # generate include directives
   includes <- c("<string>", "<map>", "<shared_core/FilePath.hpp>", "<core/ProgramOptions.hpp>")
   additionalIncludes <- metadata$additionalIncludes
   includes <- c(includes, additionalIncludes)
   
   generatedContents <- paste(generatedContents, generateIncludes(includes), sep="\n\n")
   
   # generate namespace
   namespace <- metadata$namespace
   generatedContents <- paste(generatedContents, generateNamespace(namespace), sep="\n\n")
   
   # generate class which holds the options
   classContents <- paste0("class GeneratedOptions\n",
                           "{\n",
                           "public:\n",
                           "   virtual ~GeneratedOptions() {}\n",
                           "   virtual core::ProgramStatus read(int argc,\n",
                           "                                    char * const argv[],\n",
                           "                                    std::ostream& osWarnings) = 0;")
   
   # generate accessors and members
   accessors <- "public:\n"
   members <- "protected:\n"
   options <- optionsJson$options
   for (category in names(options)) {
      for (option in options[[category]]) {
         # build property for this option
         name <- option$name
         type <- cppTypeFromJsonType(option$type)
         if (is.null(type)) {
            stop(sprintf("No type specified for option %s", name))
         }
         
         # fix up member type for commonly used non-boost types
         memberType <- type
         if (identical(memberType, "core::FilePath")) {
            memberType <- "std::string"
         }
         
         memberName <- option$memberName
         if (!is.null(memberName)) {
            members <- paste0(members, sprintf("   %s %s;\n", memberType, memberName))
         }
         
         # build accessor for this option
         skipAccessor <- option$skipAccessorGeneration
         if (is.null(skipAccessor)) {
            skipAccessor <- FALSE
         }
         if (skipAccessor) {
            next
         }
         
         accessorName <- option$accessorName
         if (is.null(accessorName)) {
            if (!is.null(memberName)) {
               # default accessor to the member name without any trailing underscores
               accessorName <- str_replace(memberName, fixed("_"), "")
            } else {
               stop(sprintf("One of accessorName or memberName must be specified for option %s", name))
            }
         }
         
         accessorCode <- ""
         accessorValue <- option$accessorValue
         if (is.null(accessorValue)) {
            # handle any implicit conversions that we should support
            if (identical(type, "core::FilePath")) {
               accessorCode <- sprintf("return core::FilePath(%s);", memberName)
            } else if (identical(category, "allow")) {
               accessorCode <- sprintf("return %s || allowOverlay();", memberName)
            } else {
               accessorCode <- sprintf("return %s;", memberName)
            }
         } else {
            accessorCode <- accessorValue[["code"]]
            if (is.null(accessorCode)) {
               stop(sprintf("Invalid accessorValue specified - must be a code specification: %s", accessorValue))
            }
         }
         
         accessors <- paste0(accessors, sprintf("   %s %s() const { %s }\n", type, accessorName, accessorCode))
      }
   }
   
   # generate the buildOptions function which handles the boost options interface
   buildOptions <- paste0("protected:\n",
                          "   rstudio::core::program_options::OptionsDescription\n",
                          "   buildOptions(")
   buildOptionsArgs <- c()
   categoryVars <- c()
   for (category in names(options)) {
      # transform category names into output parameters
      categoryParam <- category
      substr(categoryParam, 1, 1) <- toupper(substr(categoryParam, 1, 1))
      categoryParam <- paste0("p", categoryParam)
      categoryVars[category] <- categoryParam
      buildOptionsArgs <- append(buildOptionsArgs, sprintf("boost::program_options::options_description* %s", categoryParam))
   }
   for (category in names(options)) {
      for (option in options[[category]]) {
         tempName <- option$tempName
         tempType <- cppTypeFromJsonType(option$tempType)
         if (!is.null(tempName) && !is.null(tempType)) {
            buildOptionsArgs <- append(buildOptionsArgs, sprintf("%s* %s", tempType, tempName))
         }
      }
   }
   buildOptionsArgsStr <- paste(buildOptionsArgs, collapse=",\n                ")
   buildOptions <- paste0(buildOptions, 
                          buildOptionsArgsStr, 
                          ")\n{\n",
                          "   using namespace rstudio::core;\n",
                          "   using namespace boost::program_options;\n")
   
   # now generate the meat of the function, the boost program options integration
   boostOptions <- c()
   for (category in names(options)) {
      if (length(boostOptions) > 0) {
         # stamp the ending semicolon for the last option in the previous category
         boostOptions <- paste0(boostOptions, ";")
      }
      boostOptions <- paste(boostOptions, sprintf("%s->add_options()", categoryVars[[category]]), sep="\n\n   ")
      
      for (option in options[[category]]) {
         optionName <- option$name
         if (is.null(optionName)) {
            # no member name means this is likely just an accessor option and should not be a true option
            # simply continue to the next
            next
         }
         
         # fixup constants for names
         isOptionNameConstant <- FALSE
         if (identical(typeof(optionName), "list")) {
            optionName <- optionName[["constant"]]
            isOptionNameConstant <- TRUE
         }
         
         isShortNameConstant <- FALSE
         shortName <- option$shortName
         if (identical(typeof(shortName), "list")) {
            shortName <- shortName[["constant"]]
            isShortNameConstant <- TRUE
         }
         
         storageType <- cppTypeFromJsonType(option$tempType)
         if (is.null(storageType)) {
            storageType <- cppTypeFromJsonType(option$type)
            if (is.null(storageType)) {
               stop(sprintf("No variable type defined for option %s", optionName))
            }
         }
         
         # last minute type fixes for commonly used non-boost types
         if (identical(storageType, "core::FilePath")) {
            storageType <- "std::string"
         }
         
         storageMember <- option$tempName
         if (is.null(storageMember)) {
            # if no temp variable was defined, then use the member variable
            storageMember <- paste0("&", option$memberName)
            if (is.null(storageMember)) {
               stop(sprintf("No memberName or tempName defined for option %s", optionName))
            }
         }
         
         # fix up the default value based on the variable type
         defaultValue <- option$defaultValue
         if (is.null(defaultValue)) {
            # resolve the default value based on the variable type
            if (identical(storageType, "std::string")) {
               defaultValue <- "std::string()"
            } else if (identical(storageType, "bool")) {
               defaultValue <- "true"
            } else if (identical(storageType, "std::vector<std::string>")) {
               defaultValue <- "std::vector<std::string>()"
            } else {
               stop(sprintf("No defaultValue specified for option %s, and could not be inferred", optionName))
            }
         } else {
            defaultValueCode <- if (identical(typeof(defaultValue), "list")) defaultValue[["code"]] else NULL
            if (is.null(defaultValueCode)) {
               if (identical(storageType, "std::string")) {
                  if (defaultValue != "std::string()") {
                     # strings need to be quoted
                     defaultValue <- sprintf("\"%s\"", defaultValue)
                  }
               } else if (identical(storageType, "bool")) {
                  defaultValue <- if (defaultValue) "true" else "false"   
               }
            } else {
               defaultValue <- defaultValueCode
            }
         }
         
         implicitValueStr <- ""
         implicitValue <- option$implicitValue
         if (is.null(implicitValue)) {
            implicitValueStr <- ""
         } else {
            implicitValueCode <- if (identical(typeof(implicitValue), "list")) implicitValue[["code"]] else NULL
            if (is.null(implicitValueCode)) {
               if (identical(storageType, "std::string")) {
                  if (implicitValue != "std::string()") {
                     # strings need to be quoted
                     implicitValue <- sprintf("\"%s\"", implicitValue)
                  }
               } else if (identical(storageType, "bool")) {
                  implicitValue <- if (implicitValue) "true" else "false"   
               }
            } else {
               implicitValue <- defaultValueCode
            }
            
            implicitValueStr <- sprintf("->implicit_value(%s)", implicitValue)
         }
         
         isMultitoken <- option$isMultitoken
         if (is.null(isMultitoken)) {
            isMultitoken <- FALSE
         }
         multitoken <- ""
         if (isMultitoken) {
            multitoken <- "->multitoken()"
         }
         
         description <- option$description
         if (is.null(description)) {
            stop(sprintf("No description specified for option %s", optionName))
         }
         description <- str_replace_all(description, fixed("\""), "\\\"")
         description <- sprintf("\"%s\"", description)
         
         optionName <- if (isOptionNameConstant) optionName else sprintf("\"%s\"", optionName)
         if (!is.null(shortName)) {
            shortName <- if (isShortNameConstant) shortName else sprintf("\"%s\"", shortName)
            shortName <- sprintf("%s", shortName)
            
            optionName <- sprintf("%s \",\" %s", optionName, shortName)
         }
         
         optionSet <- paste0(sprintf("      (%s,\n", optionName),
                             sprintf("      value<%s>(%s)->default_value(%s)%s%s,\n", storageType, storageMember, defaultValue, implicitValueStr, multitoken),
                             sprintf("      %s)", description))
         boostOptions <- paste(boostOptions, optionSet, sep="\n")                               
      }
   }
   
   boostOptions <- trimws(boostOptions, "left")
   boostOptions <- paste0(boostOptions, ";")
   buildOptions <- paste(buildOptions, boostOptions, sep="\n   ")
   
   # generate config file information
   configFile <- metadata$configFile
   binary <- str_replace(configFile, fixed(".conf"), "")
   buildOptions <- paste0(buildOptions,
                          "\n\n",
                          sprintf("   FilePath defaultConfigPath = core::system::xdg::findSystemConfigFile(\"%s configuration\", \"%s\");\n", binary, configFile),
                          "   std::string configFile = defaultConfigPath.exists() ?\n",
                          "      defaultConfigPath.getAbsolutePath() : \"\";\n",
                          sprintf("   return program_options::OptionsDescription(\"%s\", configFile);", binary))
   
   # close out the buildOptions function
   buildOptions <- paste0(buildOptions, "\n}")
   
   classContents <- paste(classContents, buildOptions, sep="\n\n")
   classContents <- paste(classContents, accessors, sep="\n\n")
   classContents <- paste(classContents, members, sep="\n\n")
   classContents <- paste(classContents, "  virtual bool allowOverlay() const { return false; };\n")
   
   # finally, close out the class
   classContents <- paste0(classContents, "};")
   classContents <- paste(classContents, generateEndNamespace(namespace), sep="\n\n")
   classContents <- paste(classContents, generateEndIncludeGuard(includeGuard), sep="\n\n")
   
   generatedContents <- paste(generatedContents, classContents, sep="\n")
   writeLines(generatedContents, con = outputSourceFile)
   
   # generate overlay options if applicable
   if (!is.null(overlayOptionsJson)) {
      generateOverlayOptions(overlayOptionsJson)
   }
}

generateOverlayOptions <- function (overlayOptionsJson) {
   metadata <- overlayOptionsJson$metadata
   if (is.null(metadata)) {
      stop("Overlay options missing required metadata parameter")
   }
   
   outputSourceFile <- metadata$outputSourceFile
   if (is.null(outputSourceFile)) {
      stop("Overlay options missing required metadata parameter outputSourceFile")
   }
   
   outputHeaderFile <- metadata$outputHeaderFile
   if (is.null(outputHeaderFile)) {
      stop("Overlay options missing required metadata parameter outputHeaderFile")
   }
   
   # generate copyright notice
   sourceFilename <- basename(outputSourceFile)
   headerFilename <- basename(outputHeaderFile)
   generatedHeaderContents <- generateCopyright(headerFilename)
   generatedSourceContents <- generateCopyright(sourceFilename)
   
   # generate hand edit warning
   warning <- generateHandEditWarning()
   generatedSourceContents <- paste(generatedSourceContents, warning, sep="\n\n")
   generatedHeaderContents <- paste(generatedHeaderContents, warning, sep="\n\n")
   
   # generate include of header file in cpp file
   pos <- str_locate(outputHeaderFile, "include/")[2]
   if (!is.na(pos)) {
      includeDirective <- sprintf("#include <%s>", substr(outputHeaderFile, pos + 1, str_length(outputHeaderFile)))
   }
   generatedSourceContents <- paste(generatedSourceContents, includeDirective, sep="\n\n")
   
   # generate include guard
   includeGuard <- getIncludeGuard(metadata)
   generatedHeaderContents <- paste(generatedHeaderContents, generateIncludeGuard(includeGuard), sep="\n\n")
   
   # generate include directives
   includes <- c("<string>", "<map>", "<shared_core/FilePath.hpp>", "<core/ProgramOptions.hpp>")
   additionalIncludes <- metadata$additionalIncludes
   if (!is.null(additionalIncludes)) {
      includes <- c(includes, additionalIncludes)
   }
   generatedHeaderContents <- paste(generatedHeaderContents, generateIncludes(includes), sep="\n\n")
   
   # generate #define directives for all of the specified overlay options constants
   options <- overlayOptionsJson$options
   constants <- data.frame(Constant=character(), Value=character())
   for (category in names(options)) {
      for (option in options[[category]]) {
         optionName <- option$name
         if (is.null(optionName)) {
            stop("Option with no name specified in overlay options. All overlay options must specify a name.")
         }
         
         optionConstant <- optionName[["constant"]]
         if (is.null(optionConstant)) {
            stop(sprintf("Overlay option %s specified without a constant. All overlay option names must be constants.", optionName))
         }
         
         optionConstantValue <- optionName[["value"]]
         if (is.null(optionConstantValue)) {
            stop(sprintf("Overlay option %s constant specified without a value. All constants must have values for documentation.", optionName))
         }
         
         skipDefine <- optionName[["skipDefine"]]
         if (!is.null(skipDefine) && skipDefine) {
            # this definition should be skipped - it is most likely an external definition
            next
         }
         
         constants <- constants %>% add_row(Constant = optionConstant, Value = optionConstantValue)
      }
   }
   
   # add additional constants
   additionalConstants <- metadata$additionalConstants
   if (!is.null(additionalConstants)) {
      for (constant in additionalConstants) {
         constants <- constants %>% add_row(Constant = constant[["constant"]], Value = constant[["value"]])
      }
   }
   
   defines <- ""
   nameLengths <- c()
   for (i in seq_len(nrow(constants))) {
      constant <- constants[i,]
      
      # ensure the constant values line up properly by tracking how many spaces they should have after the constant
      optionConstant <- constant[["Constant"]]
      optionConstantValue <- constant[["Value"]]
      
      constantLength <- str_length(optionConstant)
      nameLengths <- append(nameLengths, constantLength)
      
      defines <- paste0(defines, "#define ", optionConstant, sprintf("<SPACER%s>", i), sprintf("\"%s\"", optionConstantValue), "\n")
   }
  
   # fill in spacers to line up the constants to make them more readable
   iter <- 1
   maxNameLengths <- max(unlist(nameLengths))
   for (i in nameLengths) {
      spaces <- strrep(" ", maxNameLengths - i + 1)
      defines <- str_replace_all(defines, fixed(sprintf("<SPACER%s>", iter)), spaces)
      iter <- iter+1
   }
   
   generatedHeaderContents <- paste(generatedHeaderContents, defines, sep="\n\n")
   
   # generate namespace
   namespace <- metadata$namespace
   generatedSourceContents <- paste(generatedSourceContents, generateNamespace(namespace), sep="\n\n")
   
   # generate addOverlayOptions function
   addOverlayOptionsFunc <- paste0("void Options::addOverlayOptions(\n      ")
   
   categoryVars <- c()
   overlayOptionsArgs <- c()
   for (category in names(options)) {
      # transform category names into output parameters
      categoryParam <- category
      substr(categoryParam, 1, 1) <- toupper(substr(categoryParam, 1, 1))
      categoryParam <- paste0("p", categoryParam)
      categoryVars[category] <- categoryParam
      overlayOptionsArgs <- append(overlayOptionsArgs, sprintf("boost::program_options::options_description* %s", categoryParam))
   }
   overlayOptionsArgsStr <- paste(overlayOptionsArgs, collapse = ",\n      ")
   addOverlayOptionsFunc <- paste0(addOverlayOptionsFunc, overlayOptionsArgsStr, ")\n{\n",
                                   "   using namespace boost::program_options;\n")
   
   # now generate the meat of the function, the boost program options integration
   boostOptions <- c()
   for (category in names(options)) {
      if (length(boostOptions) > 0) {
         # stamp the ending semicolon for the last option in the previous category
         boostOptions <- paste0(boostOptions, ";")
      }
      boostOptions <- paste(boostOptions, sprintf("%s->add_options()", categoryVars[[category]]), sep="\n\n   ")
      
      for (option in options[[category]]) {
         optionName <- option$name
         optionName <- optionName[["constant"]]
                             
         type <- option$type
         defaultValue <- option$defaultValue
         
         if (is.null(defaultValue)) {
            defaultValue <- "std::string()"
         } else {
            defaultValueCode <- if (identical(typeof(defaultValue), "list")) defaultValue[["code"]] else NULL
            if (is.null(defaultValueCode)) {
               if (defaultValue != "std::string()") {
                  if (identical(type, "bool")) {
                     # convert TRUE and FALSE to "1" and "0"
                     if (identical(typeof(defaultValue), "logical")) {
                        defaultValue <- if (defaultValue) "1" else "0"
                     }
                  }
                  
                  # strings need to be quoted
                  defaultValue <- sprintf("\"%s\"", defaultValue)
               }
            } else {
               defaultValue <- defaultValueCode
            }
         }
         
         description <- option$description
         if (is.null(description)) {
            stop(sprintf("No description specified for option %s", optionName))
         }
         
         description <- str_replace_all(description, fixed("\""), "\\\"")
         description <- sprintf("\"%s\"", description)
         
         optionSet <- paste0(sprintf("      (%s,\n", optionName),
                             sprintf("      value<std::string>(&overlayOptions_[%s])->default_value(%s),\n", optionName, defaultValue),
                             sprintf("      %s)", description))
         boostOptions <- paste(boostOptions, optionSet, sep="\n")      
      }
   }
   
   boostOptions <- trimws(boostOptions, "left")
   boostOptions <- paste0(boostOptions, ";")
   addOverlayOptionsFunc <- paste(addOverlayOptionsFunc, boostOptions, sep="\n   ")
   
   generatedSourceContents <- paste(generatedSourceContents, addOverlayOptionsFunc, sep="\n")
   
   # close out the function
   generatedSourceContents <- paste(generatedSourceContents, "}", sep="\n")
   generatedSourceContents <- paste(generatedSourceContents, generateEndNamespace(namespace), sep="\n\n")
   
   generatedHeaderContents <- paste(generatedHeaderContents, generateEndIncludeGuard(includeGuard), sep="\n\n")
   
   writeLines(generatedSourceContents, con = outputSourceFile)
   writeLines(generatedHeaderContents, con = outputHeaderFile)
}

# generates options CPP code and admin guide documentation for the given options JSON file
generate <- function (optionsFile) {
   optionsJson <- jsonlite::read_json(optionsFile)

   metadata <- optionsJson$metadata
   if (is.null(metadata)) {
      stop(sprintf("Options file %s missing required metadata section", optionsFile))
   }
   
   generatorType <- metadata$generatorType
   if (is.null(generatorType)) {
      generatorType <- "ProgramOptions"
   }
   
   if (identical(generatorType, "ProgramOptions")) {
      directory <- dirname(optionsFile)
      filename <- tools::file_path_sans_ext(basename(optionsFile))
      ext <- tools::file_ext(optionsFile)
      overlayFile = file.path(directory, sprintf("%s-overlay.%s", filename, ext))
      
      overlayOptionsJson <- NULL
      if (file.exists(overlayFile)) {
         overlayOptionsJson <- jsonlite::read_json(overlayFile)
      }
      
      cat(sprintf("Generating program options from %s\n", optionsFile))
      if (!is.null(overlayOptionsJson)) {
         cat(sprintf("Using overlay options file %s\n", overlayFile))
      }
      generateProgramOptions(optionsJson, overlayOptionsJson)
      
      cat("Generating documentation\n")
      generateQmd(optionsJson, overlayOptionsJson, optionsFile, overlayFile)
   } else {
      stop(sprintf("Requested generator type %s is not supported", generatorType))
   }
}

main <- function () {

   args <- commandArgs(trailingOnly=TRUE)
   if (length(args) == 0) {
      args <- defaultOptionsFiles
   }

   for (optionsFile in args) {
      if (!file.exists(optionsFile)) {
         stop(sprintf("Options file %s does not exist - ensure your working directory is set to this script's location", 
                      optionsFile))
      }
      
      generate(optionsFile)
   }

}

main()

#
# SessionQuarto.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("quarto.servePort", function() {
   if (requireNamespace("quarto", quietly = TRUE)) {
      if (!is.null(quarto:::quarto$serve_ps) && quarto:::quarto$serve_ps$is_alive()) {
         if (is.numeric(quarto:::quarto$serve_port)) {
            quarto:::quarto$serve_port
         } else {
            0
         }
      } else {
         0
      }
   } else {
      0
   }
})

.rs.addFunction("quarto.editorConfig", function(editor) {
   scalarChar <- function(x) .rs.scalar(as.character(x))
   if (!is.null(editor$mode)) {
      editor$mode <- scalarChar(editor$mode)
   }
   
   if (is.list(editor$markdown)) {
      if (!is.null(editor$markdown$wrap)) {
         editor$markdown$wrap <- scalarChar(editor$markdown$wrap)
      }
      if (!is.null(editor$markdown$canonical)) {
         editor$markdown$canonical <- scalarChar(editor$markdown$canonical)
      }
      if (is.list(editor$markdown$references)) {
         if (!is.null(editor$markdown$references$location)) {
            editor$markdown$references$location <- scalarChar(editor$markdown$references$location)
         }
         if (!is.null(editor$markdown$references$prefix)) {
            editor$markdown$references$prefix <- scalarChar(editor$markdown$references$prefix)
         }
         if (!is.null(editor$markdown$references$links)) {
            editor$markdown$references$links <- .rs.scalar(as.logical(editor$markdown$references$links))
         }
      }
   }

   return(editor)
})

.rs.addFunction("quarto.renderPreview", function(port, token, path, format) {
   .rs.tryCatch(utils::download.file(
      paste0("http://localhost:", port, "/", token,
            "/?path=", utils::URLencode(path, TRUE),
            ifelse(nzchar(format), paste0("&format=", format), "")),
      destfile = tempfile(),
      quiet = TRUE,
      cacheOK = FALSE
   ))
})


.rs.addFunction("quarto.terminatePreview", function(port) {
   token <- "4231F431-58D3-4320-9713-994558E4CC45"
   .rs.tryCatch(utils::download.file(
      paste0("http://localhost:", port, "/", token),
      destfile = tempfile(),
      quiet = TRUE,
      cacheOK = FALSE
   ))
})

#
# SessionPlumberViewer.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addFunction("invokePlumberPaneViewer", function(url) {
   invisible(.Call("rs_plumberviewer", url, getwd(), "pane", PACKAGE = "(embedding)"))
}, attrs = list(plumberViewerType = "pane"), envir = baseenv())

.rs.addFunction("invokePlumberWindowViewer", function(url) {
   invisible(.Call("rs_plumberviewer", url, getwd(), "window", PACKAGE = "(embedding)"))
}, attrs = list(plumberViewerType = "window"), envir = baseenv())

.rs.addFunction("invokePlumberWindowExternal", function(url) {
   invisible(.Call("rs_plumberviewer", url, getwd(), "browser", PACKAGE = "(embedding)"))
}, attrs = list(plumberViewerType = "browser"), envir = baseenv())

.rs.addFunction("setPlumberViewerType", function(type) {
   viewer <-
      if (identical(type, "none"))
          NULL
      else if (identical(type, "pane"))
          .rs.invokePlumberPaneViewer
      else if (identical(type, "window"))
          .rs.invokePlumberWindowViewer
      else if (identical(type, "browser"))
          .rs.invokePlumberWindowExternal
  options(
    # plumber >= v1.0.0
    plumber.docs.callback = viewer,
    # plumber < v1.0.0
    plumber.swagger.url = viewer
  )
})

.rs.addFunction("getPlumberViewerType", function() {
   viewer <- getOption("plumber.docs.callback", getOption("plumber.swagger.url"))
   if (identical(viewer, FALSE))
      return("none")
   else if (identical(viewer, TRUE))
      return("browser")
   else if (is.function(viewer) && is.character(attr(viewer, "plumberViewerType")))
      return(attr(viewer, "plumberViewerType"))
   return("user")
})

.rs.addJsonRpcHandler("get_plumber_viewer_type", function() {
   .rs.scalar(.rs.getPlumberViewerType())
})

#
# SessionRCompletions.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# Put the autocompletion types in the .rs.Env environment so they're accessible
# everywhere (sync with RCompletionManager.java)
assign(x = ".rs.acContextTypes",
       envir = as.environment("tools:rstudio"),
       value = list(
          UNKNOWN            =  0,
          FUNCTION           =  1,
          SINGLE_BRACKET     =  2,
          DOUBLE_BRACKET     =  3,
          NAMESPACE_EXPORTED =  4,
          NAMESPACE_ALL      =  5,
          DOLLAR             =  6,
          AT                 =  7,
          FILE               =  8,
          CHUNK              =  9,
          ROXYGEN            = 10,
          HELP               = 11,
          ARGUMENT           = 12,
          PACKAGE            = 13,
          PLUMBER            = 14
       )
)

# Sync with RCompletionType.java
assign(x = ".rs.acCompletionTypes",
       envir = as.environment("tools:rstudio"),
       value = list(
          UNKNOWN     =  0,
          VECTOR      =  1,
          ARRAY       =  2,
          DATAFRAME   =  3,
          LIST        =  4,
          ENVIRONMENT =  5,
          FUNCTION    =  6,
          ARGUMENT    =  7,
          S4_CLASS    =  8,
          S4_OBJECT   =  9,
          S4_GENERIC  = 10,
          S4_METHOD   = 11,
          R5_CLASS    = 12,
          R5_OBJECT   = 13,
          R5_METHOD   = 14,
          FILE        = 15,
          DIRECTORY   = 16,
          CHUNK       = 17,
          ROXYGEN     = 18,
          HELP        = 19,
          STRING      = 20,
          PACKAGE     = 21,
          KEYWORD     = 22,
          OPTION      = 23,
          DATASET     = 24,
          COLUMN      = 27,
          R6_OBJECT   = 28, 
          DATATABLE_SPECIAL_SYMBOL = 29,
          SECUNDARY_ARGUMENT       = 30,
          ACTIVE_BINDING = 31,
          
          CONTEXT     = 99
       )
)

# Cache for @inheritDotParams Rd lookups, keyed by "pkg::fn".
# Stores both positive results (list with targetName/argNames) and negative
# results (NULL) so that functions without @inheritDotParams are not re-parsed
# on every keystroke.
.rs.setVar("inheritDotParamsCache", new.env(parent = emptyenv()))

.rs.addFunction("getCompletionType", function(object)
{
   # Control-flow keywords
   if (identical(object, base::`break`) ||
       identical(object, base::`next`) ||
       identical(object, base::`repeat`))
      .rs.acCompletionTypes$KEYWORD
   
   # Reference classes
   else if (inherits(object, "refMethodDef"))
      .rs.acCompletionTypes$R5_METHOD
   else if (inherits(object, "refObjectGenerator"))
      .rs.acCompletionTypes$R5_CLASS
   else if (inherits(object, "refClass"))
      .rs.acCompletionTypes$R5_OBJECT
   
   # R6
   else if (inherits(object, "R6"))
      .rs.acCompletionTypes$R6_OBJECT
   
   # S4
   else if (isS4(object))
   {
      if (inherits(object, "standardGeneric") ||
          inherits(object, "nonstandardGenericFunction"))
         .rs.acCompletionTypes$S4_GENERIC
      else if (inherits(object, "MethodDefinition"))
         .rs.acCompletionTypes$S4_METHOD
      else
         .rs.acCompletionTypes$S4_OBJECT
   }
   
   # Base
   else if (is.function(object))
      .rs.acCompletionTypes$FUNCTION
   else if (is.array(object))
      .rs.acCompletionTypes$ARRAY
   else if (inherits(object, "data.frame"))
      .rs.acCompletionTypes$DATAFRAME
   else if (is.list(object))
      .rs.acCompletionTypes$LIST
   else if (is.environment(object))
      .rs.acCompletionTypes$ENVIRONMENT
   else if (is.vector(object))
      .rs.acCompletionTypes$VECTOR
   else if (is.factor(object))
      .rs.acCompletionTypes$VECTOR
   else
      .rs.acCompletionTypes$UNKNOWN
})

.rs.addFunction("roxygenTagMetadata", function()
{
   if (.rs.isPackageVersionInstalled("roxygen2", "7.2.1.9000"))
   {
      tagsFile <- system.file("roxygen2-tags.yml", package = "roxygen2")
      contents <- readLines(tagsFile, warn = FALSE)
      yaml <- .rs.fromYAML(contents)
      n <- length(yaml)
      
      map_chr <- function(...) vapply(..., FUN.VALUE = character(1), USE.NAMES = FALSE)
      map_lgl <- function(...) vapply(..., FUN.VALUE = logical(1), USE.NAMES = FALSE)
      tags <- map_chr(yaml, function(.) .$name)
      snippet <- map_chr(yaml, function(.) {
         out <- .$template
         if (is.null(out)) {
            out <- ""
         } 
         out
      })
      tags <- paste0("@", tags, snippet)
      descriptions <- map_chr(yaml, function(.) {
         .rs.markdownToHTML(.$description)
      })
      vignette <- map_chr(yaml, function(.) {
         out <- .$vignette
         if (is.null(out)) out <- NA_character_
         out
      })
      recommend <- map_lgl(yaml, function(.) isTRUE(.$recommend))
   }
   else 
   {
      # All known Roxygen2 tags, in alphabetical order
      #
      # library(roxygen2)
      # methods <- as.vector(methods("roxy_tag_parse"))
      # prefix <- "roxy_tag_parse.roxy_tag_"
      # paste0("@", gsub(prefix, "", methods[grepl(prefix, methods, fixed = TRUE)], fixed = TRUE), " ")
      tags <- c(
         "@aliases ",
         "@author ",
         "@backref ",
         "@concept ",
         "@describeIn ",
         "@description ",
         "@details ",
         "@docType ",
         "@encoding ",
         "@eval ",
         "@evalNamespace ",
         "@evalRd ",
         "@example ",
         "@examples ",
         "@examplesIf ",
         "@export",
         "@exportClass ",
         "@exportMethod ",
         "@exportPattern ",
         "@exportS3Method ",
         "@family ",
         "@field ",
         "@format ",
         "@import ",
         "@importClassesFrom ",
         "@importFrom ",
         "@importMethodsFrom ",
         "@include ",
         "@includeRmd ",
         "@inherit ",
         "@inheritDotParams ",
         "@inheritParams ",
         "@inheritSection ",
         "@keywords ",
         "@md",
         "@method ",
         "@name ",
         "@note ",
         "@noMd",
         "@noRd",
         "@order ",
         "@param ",
         "@rawNamespace ",
         "@rawRd ",
         "@rdname ",
         "@references ",
         "@return ",
         "@returns ",
         "@section ",
         "@seealso ",
         "@slot ",
         "@source ",
         "@template ",
         "@templateVar ",
         "@title ",
         "@usage ",
         "@useDynLib "
      )
      n <- length(tags)
      descriptions <- rep("", n)
      vignette <- rep("", n)
      recommend <- rep(TRUE, n)
   }
   
   list(
      tags = tags, 
      descriptions = descriptions, 
      recommend = recommend, 
      vignette = vignette
   )
})

.rs.addFunction("attemptRoxygenTagCompletion", function(token, line)
{
   emptyCompletions <- .rs.emptyCompletions(excludeOtherCompletions = TRUE)
   
   # fix up tokenization
   if (grepl("^\\s*#+'\\s*$", line) && token == "'")
      token <- ""
   
   # draw from 'man-roxygen' folder for '@template' completions
   if (grepl("^\\s*#+'\\s*@template\\s+", line))
   {
      projDir <- .rs.getProjectDirectory()
      if (is.null(projDir))
         return(emptyCompletions)
      
      manRoxygen <- file.path(projDir, "man-roxygen")
      if (!utils::file_test("-d", manRoxygen))
         return(emptyCompletions)
      
      completions <- .rs.getCompletionsFile(token, path = manRoxygen, quote = FALSE)
      completions$results <- sub("[.][rR]$", "", completions$results)
      return(completions)
   }
   
   # allow the token to be empty only if we're attempting completions
   # at the start of the line
   if (token == "")
   {
      match <- grepl("^\\s*#+'\\s*$", line)
      if (!match)
         return(emptyCompletions)
   }
   else
   {
      match <- grepl("^@[a-zA-Z0-9]*$", token, perl = TRUE)
      if (!match)
         return(emptyCompletions)
   }
   
   tag <- sub(".*(?=@)", '', token, perl = TRUE)
   metadata <- .rs.roxygenTagMetadata()
   
   tags <- metadata$tags
   recommend <- metadata$recommend
   descriptions <- metadata$descriptions
   vignette <- metadata$vignette
   
   matching <- grepl(paste("^", tag, sep = ""), tags)
   
   # put recommended tags first
   keep <- c(which(matching & recommend), which(matching & !recommend))
   
   .rs.makeCompletions(tag,
                       results  = tags[keep],
                       type     = .rs.acCompletionTypes$ROXYGEN,
                       context  = .rs.acContextTypes$ROXYGEN, 
                       meta     = descriptions[keep], 
                       packages = vignette[keep],
                       excludeOtherCompletions = TRUE, 
   )
})

.rs.addFunction("attemptPlumberTagCompletion", function(token, line)
{
   emptyCompletions <- .rs.emptyCompletions(excludeOtherCompletions = TRUE)
   
   # fix up tokenization
   if (grepl("^\\s*#+\\*\\s*$", line) && token == "*")
      token <- ""
   
   # allow the token to be empty only if we're attempting completions
   # at the start of the line
   if (token == "")
   {
      match <- grepl("^\\s*#+\\*\\s*$", line)
      if (!match)
         return(emptyCompletions)
   }
   else
   {
      match <- grepl("^@[a-zA-Z0-9]*$", token, perl = TRUE)
      if (!match)
         return(emptyCompletions)
   }
   
   tag <- sub(".*(?=@)", '', token, perl = TRUE)
   
   # All known Plumber tags, in alphabetical order
   tags <- c(
      "@apiBasePath ",
      "@apiConsumes ",
      "@apiContact ",
      "@apiDescription ",
      "@apiHost ",
      "@apiLicense ",
      "@apiProduces ",
      "@apiSchemes ",
      "@apiTOS ",
      "@apiTag ",
      "@apiTitle ",
      "@apiVersion ",
      "@assets ",
      "@delete ",
      "@filter ",
      "@get ",
      "@head ",
      "@jpeg ",
      "@options ",
      "@param ",
      "@parser",
      "@patch ",
      "@plumber ",
      "@png ",
      "@post ",
      "@preempt ",
      "@put ",
      "@response ",
      "@serializer ",
      "@svg ",
      "@tag ",
      "@use "
   )
   
   matchingTags <- grep(paste("^", tag, sep = ""), tags, value = TRUE)
   
   .rs.makeCompletions(tag,
                       matchingTags,
                       type = .rs.acCompletionTypes$ROXYGEN,
                       excludeOtherCompletions = TRUE, 
                       context = .rs.acContextTypes$PLUMBER)
})

.rs.addFunction("getCompletionsVignettes", function(token)
{
   doGetCompletionsVignettes <- function(token, vignettes)
   {
      vignettes <- sort(vignettes)
      .rs.makeCompletions(token = token,
                          results = .rs.selectFuzzyMatches(vignettes, token),
                          quote = TRUE,
                          type = .rs.acCompletionTypes$VIGNETTE,
                          excludeOtherCompletions = TRUE)
   }
   
   if (!is.null(vignettes <- .rs.get("vignettes")))
      return(doGetCompletionsVignettes(token, vignettes$results[, "Item"]))
   
   vignettes <- vignette()
   .rs.assign("vignettes", vignettes)
   doGetCompletionsVignettes(token, vignettes$results[, "Item"])
})

.rs.addFunction("getCompletionsFile", function(token,
                                               path = getwd(),
                                               quote = FALSE,
                                               directoriesOnly = FALSE)
{
   path <- suppressWarnings(.rs.normalizePath(path, winslash = "/"))
   
   ## Separate the token into a 'directory' prefix, and a 'name' prefix. We need
   ## to prefix the prefix as we will need to prepend it onto completions for
   ## non-relative completions.
   tokenPrefix <- ""
   tokenName <- token
   
   tokenSlashIndices <- c(gregexpr("[/\\\\]", token, perl = TRUE)[[1]])
   if (!identical(tokenSlashIndices, -1L))
   {
      maxIndex <- max(tokenSlashIndices)
      tokenPrefix <- substring(token, 1, maxIndex)
      tokenName <- substring(token, maxIndex + 1)
   }
   
   ## Figure out the directory to list files in.
   
   # The token itself might dictate the directory we want to search in, e.g.
   # if we see `~`, `/`, `[a-zA-Z]:`. In those cases, override the path argument.
   regex <- "^[~/\\\\]|^[a-zA-Z]:[/\\\\]"
   if (nzchar(token) && length(grep(regex, token, perl = TRUE)))
   {
      directory <- path <-
         suppressWarnings(normalizePath(dirname(paste(token, ".", sep = ""))))
   }
   
   # Check to see if there are delimiters in the token. If there are, but it's
   # a relative path, we need to further qualify the directory.
   else
   {
      if (!identical(tokenSlashIndices, -1L))
      {
         maxIndex <- max(tokenSlashIndices)
         fullPath <- file.path(path, substring(token, 1, maxIndex - 1))
         directory <- suppressWarnings(.rs.normalizePath(fullPath, winslash = "/"))
      }
      else
      {
         directory <- path
      }
   }
   
   # If we're trying to get completions from a directory that doesn't
   # exist, give up
   if (!file.exists(directory))
      return(.rs.emptyCompletions(excludeOtherCompletions = TRUE))
   
   # When checking if the path lies within the project directory,
   # we just do a substring check -- so make sure that the path
   # is actually within the project directory (append a trailing
   # slash to the directory we check)
   projDirEndsWithSlash <-
      paste(gsub("/*$", "", .rs.getProjectDirectory()), "/", sep = "")
   
   directory <-
      paste(gsub("/*$", "", directory), "/", sep = "")
   
   # If the directory lies within a folder that we're monitoring
   # for indexing, use that.
   cacheable <- TRUE
   usingFileMonitor <-
      .rs.hasFileMonitor() &&
      .rs.startsWith(directory, projDirEndsWithSlash)
   
   absolutePaths <- character()
   if (usingFileMonitor)
   {
      if (directoriesOnly)
         index <- .rs.getIndexedFolders(tokenName, directory)
      else
         index <- .rs.getIndexedFilesAndFolders(tokenName, directory)
      
      cacheable <- !index$more_available
      absolutePaths <- index$paths
   }
   
   # Merge in completions from the current directory. This can be
   # slow on networked filesystems so do this with a timeout.
   dirPaths <- .rs.withTimeLimit(1, .rs.listFilesFuzzy(directory, tokenName))
   if (is.null(dirPaths))
      dirPaths <- character()
   
   if (directoriesOnly)
   {
      dirInfo <- .rs.fileInfo(dirPaths)
      dirPaths <- dirPaths[dirInfo$isdir]
   }
   absolutePaths <- sort(union(absolutePaths, dirPaths))
   
   ## Bail out early if we didn't get any completions.
   if (!length(absolutePaths))
      return(.rs.emptyCompletions(excludeOtherCompletions = TRUE))
   
   ## Because the completions returned will replace the whole token,
   ## we need to be careful in how we construct the return result. In particular,
   ## we need to preserve the way the directory has been specified.
   ##
   ## Note that the directory may or may not end with a trailing slash,
   ## depending on how it was normalized. We have to check for that when
   ## determining the offset for constructing the relative path. Normally,
   ## the trailing slash is included for root directories, e.g. `/` on Unix-alikes
   ## or `C:/` on Windows.
   offset <- if (grepl("[/\\\\]$", directory, perl = TRUE))
      nchar(directory) + 1L
   else
      nchar(directory) + 2L
   
   relativePaths <- substring(absolutePaths, offset)
   
   ## Order completions starting with alpha-numeric entries first if the
   ## token name is blank
   if (!nzchar(tokenName))
   {
      startsWithAlnum <- grepl("^[[:alnum:]]", relativePaths, perl = TRUE)
      order <- c(
         which(startsWithAlnum),
         which(!startsWithAlnum)
      )
      
      relativePaths <- relativePaths[order]
      absolutePaths <- absolutePaths[order]
   }
   
   paths <- paste(tokenPrefix, relativePaths, sep = "")
   
   # If we were able to use the file index and only wanted directories, we know that
   # all completions must be directories
   if (usingFileMonitor && directoriesOnly)
   {
      type <- rep.int(.rs.acCompletionTypes$DIRECTORY, length(absolutePaths))
   }
   
   # Otherwise, query the file info for the set of completions we're using
   else
   {
      isDir <- .rs.fileInfo(absolutePaths)[, "isdir"] %in% TRUE ## protect against NA
      type <- ifelse(isDir,
                     .rs.acCompletionTypes$DIRECTORY,
                     .rs.acCompletionTypes$FILE)
      
      if (directoriesOnly)
      {
         paths <- paths[isDir]
         type <- type[isDir]
      }
   }
   
   # Order completions by depth
   matches <- gregexpr("/", paths, fixed = TRUE)
   depth <- vapply(matches, function(match) {
      if (identical(c(match), -1L))
         0
      else
         length(match)
   }, numeric(1))
   
   idx <- order(depth)
   paths <- paths[idx]
   type <- type[idx]
   
   .rs.makeCompletions(token = token,
                       results = paths,
                       type = type,
                       quote = quote,
                       excludeOtherCompletions = TRUE,
                       cacheable = cacheable)
})

.rs.addFunction("resolveFormals", function(token,
                                           object,
                                           functionName,
                                           functionCall,
                                           matchedCall,
                                           envir)
{
   tryCatch(
      .rs.resolveFormalsImpl(token, object, functionName, functionCall, matchedCall, envir),
      error = function(e) NULL
   )
})

.rs.addFunction("resolveFormalsImpl", function(token,
                                               object,
                                               functionName,
                                               functionCall,
                                               matchedCall,
                                               envir)
{
   # first, try to resolve via S3 dispatch if possible
   data <- .rs.resolveFormalsImplS3Dispatch(
      token,
      object,
      functionName,
      functionCall,
      matchedCall,
      envir
   )
   
   # otherwise, resolve from function itself
   if (is.null(data)) {
      formals <- .rs.getFunctionArgumentNames(object)
      methods <- rep.int(functionName, length(formals))
      data <- list(formals = formals, methods = methods)
   }
   
   keep <-
      .rs.fuzzyMatches(data$formals, token) &   # keep only formals matching token
      !(data$formals %in% names(functionCall))  # leave out formals already in call
   
   # subset based on kept formals
   data$formals <- data$formals[keep]
   data$methods <- data$methods[keep]
   
   # done!
   data
   
})

.rs.addFunction("resolveFormalsImplS3Dispatch", function(token,
                                                         object,
                                                         functionName,
                                                         functionCall,
                                                         matchedCall,
                                                         envir)
{
   # validate that this is an S3 generic
   ok <-
      length(functionCall) > 1 &&
      .rs.isS3Generic(object)
   
   if (!ok)
      return(NULL)
   
   # S3 generics normally dispatch on the first argument,
   # so verify that this has been supplied
   dispatchArgumentName <- names(formals(object)[1])
   dispatchArgumentSymbol <- matchedCall[[dispatchArgumentName]]
   if (is.null(dispatchArgumentSymbol))
      return(NULL)
   
   # try to retrieve the object
   objectForDispatch <- .rs.getAnywhere(
      matchedCall[[dispatchArgumentName]],
      envir = envir
   )
   
   if (is.null(objectForDispatch))
      return(NULL)
   
   # handle e.g. dplyr::mutate(): the generic is "mutate", not "dplyr::mutate"
   functionName <- sub("^.*:{2,3}", "", functionName)
   
   # iterate over the known classes for the object, and see if we have
   # an appropriate S3 method that could be used for dispatch
   classes <- class(objectForDispatch)
   for (class in c(classes, "default"))
   {
      # It is possible that which S3 method will be used may depend on where
      # the generic f is called from: getS3method returns the method found if
      # f were called from the same environment.
      call <- substitute(
         utils::getS3method(functionName, class),
         list(functionName = functionName,
              class = class)
      )
      
      method <- tryCatch(
         eval(call, envir = envir),
         error = function(e) NULL
      )
      
      if (is.null(method))
         next
      
      # ok, we found a method -- return it
      formals <- .rs.getFunctionArgumentNames(method)
      methods <- rep.int(
         paste(functionName, class, sep = "."),
         length(formals)
      )
      
      data <- list(formals = formals, methods = methods)
      return(data)
   }
   
   # nothing found; return NULL
   NULL
   
})

.rs.addFunction("matchCall", function(func, call, numCommas = NULL)
{
   names <- names(call)
   if (is.null(names)) 
      names <- rep("", length(call))
   funFormals <- names(formals(func))
   hasDots <- any(funFormals == "...")
   
   if (is.null(numCommas))
      numCommas <- length(call)
   
   j <- 1L # used to track how many commas have been seen
   i <- 2L # the current argument, relative to modified call
   while (TRUE)
   {
      if (i > length(call))
         break
      
      # dropping from the call:
      # - explicit ...
      # - unnamed arguments after the cursor
      # - named arguments not in the formals of fun (unless fun has ...)
      if (identical(call[[i]], quote(`...`)) || (names[i] == "" && j > numCommas) || (!hasDots && names[i] != "" && !any(names[i] == funFormals)))
      {
         call <- call[-i]
         names <- names[-i]
      }  
      else
      {
         # keep this argument, and move on to the next one
         i <- i + 1
      }  
      
      # in any case, this has seen one more comma
      j <- j + 1L
   }
   
   tryCatch(match.call(func, call), error = function(e) call)
})

.rs.addFunction("getCompletionsInstallPackages", function(token)
{
   contrib.url <- contrib.url(getOption("repos"), getOption("pkgType"))
   
   packages <- Reduce(union, lapply(contrib.url, function(url) {
      
      # Try to get a package list from the cache
      result <- .rs.getCachedAvailablePackages(url)
      
      # If it's null, there were no packages available
      if (is.null(result))
         .rs.downloadAvailablePackages(url)
      
      # Try again
      result <- .rs.getCachedAvailablePackages(url)
      
      # And return
      result
   }))
   
   .rs.makeCompletions(token = token,
                       results = .rs.selectFuzzyMatches(packages, token),
                       quote = TRUE,
                       type = .rs.acCompletionTypes$PACKAGE,
                       excludeOtherCompletions = TRUE)
   
})

.rs.addFunction("resolveObjectFromFunctionCall", function(functionCall,
                                                          envir)
{
   string <- .rs.format(functionCall[[1]])[[1]]
   splat <- strsplit(string, ":{2,3}", perl = TRUE)[[1]]
   object <- NULL
   
   if (length(splat) == 1)
   {
      stripped <- .rs.stripSurrounding(string)
      envir <- .rs.resolveEnvironment(envir)
      
      object <- .rs.tryCatch(
         .rs.getAnywhere(
            name  = stripped,
            envir = envir
         )
      )
   }
   else if (length(splat) == 2)
   {
      namespaceString <- .rs.stripSurrounding(splat[[1]])
      functionString <- string <- .rs.stripSurrounding(splat[[2]])
      
      if (namespaceString %in% loadedNamespaces())
      {
         object <- .rs.tryCatch(
            eval(
               expr = parse(text = functionString),
               envir = asNamespace(namespaceString)
            )
         )
      }
   }
   
   # Special casing for variants of read.table which hide additional
   # arguments in ...
   if ("utils" %in% loadedNamespaces())
   {
      readers <- list(
         utils::read.csv,
         utils::read.csv2,
         utils::read.delim,
         utils::read.delim2
      )
      
      if (any(sapply(readers, identical, object)))
         object <- utils::read.table
      
      # Similarly for write.csv
      writers <- list(
         utils::write.csv,
         utils::write.csv2
      )
      
      if (any(sapply(writers, identical, object)))
         object <- utils::write.table
   }
   
   if (inherits(object, "error"))
      return(NULL)
   
   object
   
})

# Get completions appropriate within a particular function call.
# This typically implies retrieving the function formals.
.rs.addFunction("getCompletionsFunction", function(token,
                                                   string,
                                                   functionCall,
                                                   numCommas,
                                                   envir = parent.frame(), 
                                                   object = .rs.resolveObjectFromFunctionCall(functionCall, envir))
{
   result <- .rs.emptyCompletions()
   if (is.null(object) || !is.function(object))
      return(result)
   
   # If we're attempting to get completions for an R6 'new()' function,
   # then use a separate code path to derive that -- derive formals from
   # the 'initialize()' method instead.
   if (.rs.isR6NewMethod(object))
      object <- .rs.getR6ClassGeneratorMethod(object, "initialize")
   
   matchedCall <- .rs.matchCall(object, functionCall, numCommas = numCommas)
   
   # Try to figure out what function arguments are
   # eligible for completion. Note that, on success,
   # this should be an R list with character fields
   # 'formals' and (optionally) 'methods'.
   formals <- NULL
   
   ## Special cases
   # We handle special cases for function argument completions first.
   # If we're completing a knitr getter function, then try
   # to produce auto-completions for potential argument names
   if (.rs.isKnitrObject(object) && "knitr" %in% loadedNamespaces())
   {
      ns <- asNamespace("knitr")
      
      # Get the knitr getters and setters for various
      # options
      tryGetKnitrGetter <- function(name, ns = asNamespace("knitr"))
         tryCatch(get(name, envir = ns)$get, error = function(e) NULL)
      
      tryGetKnitrSetter <- function(name, ns = asNamespace("knitr"))
         tryCatch(get(name, envir = ns)$set, error = function(e) NULL)
      
      tryGet <- function(name, ns = asNamespace("knitr"))
         list(getter = tryGetKnitrGetter(name, ns),
              setter = tryGetKnitrSetter(name, ns))
      
      knitrOpts <- list(
         tryGet("opts_chunk", ns),
         tryGet("opts_knit", ns),
         tryGet("opts_current", ns),
         tryGet("opts_template", ns),
         tryGet("knit_hooks", ns),
         tryGet("knit_theme", ns)
      )
      
      for (opt in knitrOpts)
      {
         # If we're identical to the getter, short-circuit
         # and just return the names of parameters
         if (identical(object, opt$getter))
         {
            results <- .rs.selectFuzzyMatches(
               names(opt$getter()),
               token
            )
            
            return(.rs.makeCompletions(token = token,
                                       results = results,
                                       type = .rs.acCompletionTypes$STRING,
                                       quote = TRUE))
         }
         
         # If we're identical to the setter, get the
         # names from the getter as named arguments to use
         if (identical(object, opt$setter))
         {
            formals <- list(formals = names(opt$getter()))
            break
         }
      }
      
   }
   
   # Resolve formals from a classGeneratorFunction based
   # on its slots
   if (is.null(formals) &&
       inherits(object, "classGeneratorFunction"))
   {
      try(silent = TRUE, {
         class <- object@className
         defn <- getClass(class)
         slots <- defn@slots
         formals <- list(
            formals = names(slots),
            methods = rep(class, length(slots))
         )
      })
   }
   
   # Resolve formals from the function itself
   if (is.null(formals))
   {
      formals <- .rs.resolveFormals(token,
                                    object,
                                    string,
                                    functionCall,
                                    matchedCall,
                                    envir)
   }
   
   # If we have formals, quote them as appropriate and append ' = '.
   if (length(formals$formals))
   {
      formals$formals <- vapply(formals$formals, function(fml) {
         paste(deparse(as.name(fml), backtick = TRUE), "= ")
      }, FUN.VALUE = character(1))
   }
   
   # If we're getting completions for the `base::c` function, just discard
   # the argument completions, since other context completions are more
   # likely and more useful
   if (identical(object, base::c) ||
       identical(object, base::list))
   {
      formals <- list(formals = character(),
                      methods = character())
   }
   
   # Get the current argument -- we can resolve this based on
   # 'numCommas' and the number of named formals. The idea is, e.g.
   # in a function call
   #
   #     rnorm(|, n = 1, sd = 2)
   #
   # we should infer that the current argument name is 'mean'. We do this
   # by looking at which arguments have yet to be matched, and using the
   # first argument in that list.
   activeArg <- .rs.getActiveArgument(object, matchedCall)
   if (length(activeArg) == 0L || is.na(activeArg))
      activeArg <- ""
   
   # Special casing for 'group_by' from dplyr
   # TODO: Should we just allow for any function named 'group_by', ie,
   # enable this even if 'dplyr' isn't loaded?
   if (!is.null(activeArg) && activeArg == "..." &&
       "dplyr" %in% loadedNamespaces() &&
       identical(object, get("group_by", envir = asNamespace("dplyr"))))
   {
      .data <- .rs.getAnywhere(matchedCall[[".data"]], envir = envir)
      if (!is.null(.data))
      {
         # potential completions
         .names <- .rs.selectFuzzyMatches(.rs.getNames(.data), token)
         
         if (length(.names))
         {
            namesCall <- names(matchedCall)
            
            # drop from .names:
            # - the named argument, e.g. group_by(a = foo())
            .drop <- setdiff(namesCall, c("", ".data", ".drop", ".keep"))
            
            # - the unnamed arguments that are symbols
            unnamed <- as.list(matchedCall)[namesCall == ""][-1]
            for (arg in unnamed)
            {
               if (is.symbol(arg))
                  .drop <- c(.drop, as.character(arg))
            }
            
            groupByCompletions <- .rs.makeCompletions(token = token,
                                                      results = setdiff(.names, .drop),
                                                      quote = FALSE,
                                                      type = .rs.acCompletionTypes$COLUMN, 
                                                      packages = as.character(matchedCall[[".data"]]))
            return(groupByCompletions)
         }
      }
   }
   
   # Get completions for the current active argument
   argCompletions <- .rs.getCompletionsArgument(
      token = token,
      activeArg = activeArg,
      functionCall = functionCall,
      envir = envir
   )
   
   # If the active argument was 'formula' and we were able
   # to retrieve completions, it is unlikely that we also
   # want search path completions or otherwise -- just return
   # those completions.
   if (identical(activeArg, "formula") &&
       !is.null(argCompletions) &&
       !.rs.isEmptyCompletion(argCompletions))
   {
      return(argCompletions)
   }
   
   fguess <- if (length(formals$methods))
      formals$methods[[1]]
   else
      ""
   
   # arguments that are already used by the matched call
   includeAlreadyUsed <- .rs.uiPrefs$codeCompletionIncludeAlreadyUsed$get()
   keep <- if (includeAlreadyUsed)
   {
      rep.int(TRUE, length(formals$formals))
   }
   else
   {
      used <- names(as.list(matchedCall)[-1]) 
      keep <- !names(formals$formals) %in% used
   }
   
   # TODO: Should we include aesthetics for 'geom_*()' functions?
   # for 'geom_' functions, try to get aesthetic names
   ggplotCompletions <- NULL
   if (grepl("(?:^|::)geom_", fguess))
   {
      .rs.tryCatch({
         geomFunc <- eval(as.symbol(fguess), envir = envir)
         layerInfo <- geomFunc()
         aesthetics <- c(
            layerInfo$geom$required_aes,
            layerInfo$stat$required_aes,
            names(layerInfo$geom$default_aes),
            names(layerInfo$stat$default_aes)
         )
         aesthetics <- aesthetics[!grepl("|", aesthetics, fixed = TRUE)]
         aesthetics <- aesthetics[!duplicated(aesthetics)]
         results <- .rs.selectFuzzyMatches(aesthetics, token)
         ggplotCompletions <- .rs.makeCompletions(
            token = token,
            results = paste(results, "= "),
            packages = fguess,
            type = .rs.acCompletionTypes$ARGUMENT,
            quote = FALSE
         )
      })
   }
   
   result <- .rs.appendCompletions(
      argCompletions,
      .rs.makeCompletions(
         token = token,
         results = formals$formals[keep],
         packages = formals$methods[keep],
         type = .rs.acCompletionTypes$ARGUMENT,
         excludeOtherCompletions = FALSE,
         excludeOtherArgumentCompletions = TRUE,
         fguess = fguess,
         orderStartsWithAlnumFirst = FALSE
      )
   )
   
   result <- .rs.appendCompletions(result, ggplotCompletions)
   
   # If the function has `...` in its formals and the package author used
   # @inheritDotParams, expand those documented dot-arguments into named
   # completions, as if they were native arguments of the wrapper.
   # Primitives (e.g. list, c) cannot have @inheritDotParams documentation so
   # skip them early before the more expensive formals and environment checks.
   # NOTE: formals$formals is token-filtered by resolveFormals and values are
   # formatted as "name = ", so check for "... = " first (fast path), then
   # fall back to formals(object) if the token filtered it out.
   if (!is.primitive(object) &&
       ("... = " %in% formals$formals ||
        tryCatch("..." %in% names(formals(object)), error = function(e) FALSE)))
   {
      # Defensive guard: an unexpected error here must not break all completions
      # for the function -- the inherited params portion is best-effort only.
      inheritedCompletions <- tryCatch(
         .rs.getCompletionsInheritDotParams(token, string, object, matchedCall, formals$formals),
         error = function(e) .rs.emptyCompletions()
      )
      result <- .rs.appendCompletions(result, inheritedCompletions)
   }
   
   result
   
})

# Retrieve completions arising from @inheritDotParams documentation.
#
# When a function passes `...` to another function and has been documented
# with roxygen2's @inheritDotParams tag, the compiled help database contains
# a structured \arguments entry listing each forwarded argument name inside a
# \describe block. This function parses that Rd structure and returns
# completions for those argument names.
#
# NOTE: This implementation is tightly coupled to the Rd output structure that
# roxygen2 generates for @inheritDotParams. If roxygen2 changes its output
# format, this parsing will silently return no completions.
# TODO: work with roxygen2 to expose this information more directly
# (see r-lib/roxygen2#1808).
#
# Local (explicitly declared) formals always take precedence: any name already
# present in the wrapper's own formals is excluded from the returned set,
# matching the behaviour of @inheritParams. Only the first `...` argument is
# expanded (shallow expansion -- we do not recurse into the target function's
# own `...`).
.rs.addFunction("getCompletionsInheritDotParams", function(token,
                                                           string,
                                                           object,
                                                           matchedCall,
                                                           ownFormals)
{
   # Derive the plain function name and (optionally) package from `string`,
   # e.g. "pkg::foo" -> pkg = "pkg", fn = "foo"; "pkg:::foo" -> same;
   # "foo" -> pkg = NULL, fn = "foo".
   splat <- strsplit(string, ":{2,3}", perl = TRUE)[[1]]
   if (length(splat) > 2)
      return(.rs.emptyCompletions())
   fnName  <- splat[[length(splat)]]
   pkgName <- if (length(splat) == 2) splat[[1]] else NULL

   # If no package was specified via ::, resolve it from the function's
   # environment so the correct help database is queried.
   if (is.null(pkgName))
   {
      # environment(object) can throw for non-closure objects (builtins,
      # primitives); the empty string then fails the loadedNamespaces() check.
      envName <- tryCatch(
         environmentName(environment(object)),
         error = function(e) ""
      )
      # loadedNamespaces() serves double duty: it confirms the name is a valid
      # loaded package namespace, and implicitly rejects non-package environments
      # (R_GlobalEnv, R_EmptyEnv, etc.) which are never in the namespace registry.
      if (!nzchar(envName) || !envName %in% loadedNamespaces())
         return(.rs.emptyCompletions())

      pkgName <- envName
   }
   
   # Parse the \arguments section of the compiled help file to extract the
   # target function name and the allowed arg names documented via
   # @inheritDotParams (already filtered for partial @inheritDotParams).
   # Results (including NULL for functions without @inheritDotParams) are cached
   # by "pkg::fn" to avoid re-reading the help database on every keystroke.
   cacheKey <- paste0(pkgName, "::", fnName)
   cache    <- .rs.getVar("inheritDotParamsCache")
   if (exists(cacheKey, envir = cache, inherits = FALSE))
   {
      parsed <- get(cacheKey, envir = cache, inherits = FALSE)
   }
   else
   {
      parsed <- tryCatch(
         .rs.parseInheritDotParamsFromHelp(fnName, pkgName),
         error = function(e) {
            warning("getCompletionsInheritDotParams: unexpected error parsing '",
                    pkgName, "::", fnName, "': ", conditionMessage(e))
            NULL
         }
      )
      assign(cacheKey, parsed, envir = cache)
   }

   if (is.null(parsed) || !nzchar(parsed$targetName))
      return(.rs.emptyCompletions())

   # Use the target function as the provenance hint in the completion popup.
   # Prefer the package extracted from the \link attribute (which reflects the
   # actual target package, even when the wrapper masks it), falling back to
   # the wrapper's own package if no qualified link was present.
   sourcePkg        <- if (!is.null(parsed$targetPkg)) parsed$targetPkg else pkgName
   completionSource <- paste0(sourcePkg, "::", parsed$targetName)

   # Completions for named arguments use the "name = " format expected by the
   # RStudio completion engine (matching the format of ownFormals).
   # Filter by token against raw arg names first, then deparse only the
   # matches. This avoids deparsing 20+ names when the token is specific.
   # backtick = TRUE handles reserved words (e.g. `if`, `for`) which are
   # valid argument names but require quoting.
   usedNames        <- paste0(names(as.list(matchedCall)[-1]), " = ")
   matchedArgNames  <- parsed$argNames[.rs.fuzzyMatches(parsed$argNames, token)]
   inheritedFormals <- vapply(matchedArgNames, function(fml) {
      paste(deparse(as.name(fml), backtick = TRUE), "= ")
   }, FUN.VALUE = character(1))

   inheritedFormals <- inheritedFormals[!inheritedFormals %in% c(ownFormals, usedNames)]

   if (!length(inheritedFormals))
      return(.rs.emptyCompletions())

   .rs.makeCompletions(
      token    = token,
      results  = inheritedFormals,
      packages = rep(completionSource, length(inheritedFormals)),
      type     = .rs.acCompletionTypes$ARGUMENT,
      excludeOtherCompletions = FALSE,
      excludeOtherArgumentCompletions = TRUE,
      fguess   = string,
      orderStartsWithAlnumFirst = FALSE
   )
})

# Walk a parsed Rd object and extract argument names documented via
# @inheritDotParams. This is the pure Rd-logic layer, separated from help
# database lookup so it can be called directly in tests with a fixture Rd.
#
# Returns a list with fields `targetName` (character scalar), `targetPkg`
# (character scalar or NULL), and `argNames` (character vector), or NULL if
# the @inheritDotParams pattern is not found.
.rs.addFunction("parseInheritDotParamsFromRd", function(rd)
{
   rdTag   <- function(x) attr(x, "Rd_tag")
   nodeText <- function(x) trimws(paste(unlist(x), collapse = ""))

   argumentsNode <- Find(function(n) identical(rdTag(n), "\\arguments"), rd)
   if (is.null(argumentsNode))
      return(NULL)

   # Find the \item{...}{} node for `...` -- the entry whose description contains
   # the @inheritDotParams expansion.
   dotsItem <- Find(function(n) {
      identical(rdTag(n), "\\item") &&
      length(n) >= 2L &&
      nodeText(n[[1L]]) %in% c("...", "\\dots", "\\ldots")
   }, argumentsNode)
   if (is.null(dotsItem))
      return(NULL)
   dotsNode <- dotsItem[[2L]]

   # Check whether the dots item was generated by @inheritDotParams by looking
   # for the sentinel text "Arguments passed on to" as the first non-whitespace
   # TEXT node in the description. If it's not there, this is a regular `...`
   # argument and we have nothing to expand.
   #
   # NOTE: This implementation is tightly coupled to the specific Rd structure
   # that roxygen2 generates for @inheritDotParams: the sentinel text, the
   # \code node containing the target name, and the \describe block listing
   # forwarded args. See:
   # https://github.com/r-lib/roxygen2/blob/93b87787/R/rd-inherit.R#L281-L290
   # If roxygen2 changes this structure, parsing will silently return no completions.
   # TODO: work with roxygen2 to expose this information more directly
   # (see r-lib/roxygen2#1808).
   #
   # Note: if multiple @inheritDotParams tags exist, only the first block is
   # used. Multiple @inheritDotParams on a single function is uncommon and
   # this limitation is accepted.

   # Find the first non-whitespace TEXT node -- the sentinel "Arguments passed on to".
   # The \code node immediately following it contains the target function name.
   inheritDotParamsText <- "Arguments passed on to"
   i <- Position(
      function(n) identical(rdTag(n), "TEXT") && nzchar(nodeText(n)),
      dotsNode,
      nomatch = NULL
   )
   # Exit if the expected format from @inheritDotParams is not found -- e.g. with a regular `...` argument.
   if (is.null(i) ||
       !startsWith(nodeText(dotsNode[[i]]), inheritDotParamsText) ||
       i == length(dotsNode) ||
       !identical(rdTag(dotsNode[[i + 1L]]), "\\code"))
      return(NULL)

   # The \code node immediately following the sentinel TEXT contains the
   # target function name. roxygen2's resolve_qualified_link generates:
   #   1. Same-package:    \code{\link[=fn]{fn}}          -> nodeText = "fn"
   #   2. Cross-package:   \code{\link[pkg:topic]{pkg::fn}} -> nodeText = "pkg::fn"
   linkNode <- Find(function(n) identical(rdTag(n), "\\link"), dotsNode[[i + 1L]])
   if (is.null(linkNode))
      return(NULL)
   parts <- strsplit(nodeText(linkNode), ":{2,3}", perl = TRUE)[[1]]
   # Valid forms are "fn" (1 part) or "pkg::fn" (2 parts). Anything else --
   # empty text, empty fn name, empty pkg prefix, or too many separators -- is
   # not a recognised namespace expression and we return NULL.
   if (length(parts) == 0L || length(parts) > 2L || !nzchar(parts[[length(parts)]]))
      return(NULL)
   targetName <- parts[[length(parts)]]
   if (length(parts) == 2L && !nzchar(parts[[1L]]))
      return(NULL)
   targetPkg  <- if (length(parts) == 2L) parts[[1L]] else NULL

   descNode <- Find(function(n) identical(rdTag(n), "\\describe"), dotsNode)
   if (is.null(descNode))
      return(NULL)

   # Extract arg names from each \item in the \describe block.
   # \item label text may contain comma-separated names (e.g. "n, prop") when
   # multiple args share a description; split and trim each.
   items <- Filter(function(n) identical(rdTag(n), "\\item") && length(n) >= 1L, descNode)
   argNames <- unlist(lapply(items, function(itemNode) {
      trimws(strsplit(nodeText(itemNode[[1L]]), ",")[[1]])
   }))

   list(targetName = targetName, targetPkg = targetPkg, argNames = argNames[nzchar(argNames)])
})

# Fetch the help database entry for `fnName` (optionally in `pkgName`),
# parse it into an Rd object, and delegate to parseInheritDotParamsFromRd.
.rs.addFunction("parseInheritDotParamsFromHelp", function(fnName, pkgName)
{
   # Help lookup failing is expected for unknown functions -- return NULL silently.
   helpResult <- tryCatch(
      eval(.rs.makeHelpCall(fnName, pkgName)),
      error = function(e) NULL
   )
   if (is.null(helpResult) || length(helpResult) == 0L)
      return(NULL)

   # .getHelpFile failing is unexpected -- warn so future R changes are visible.
   rd <- tryCatch(
      get(".getHelpFile", envir = asNamespace("utils"), mode = "function")(helpResult),
      error = function(e) {
         warning("parseInheritDotParamsFromHelp: failed to load Rd for '",
                 pkgName, "::", fnName, "': ", conditionMessage(e))
         NULL
      }
   )
   if (is.null(rd))
      return(NULL)

   .rs.parseInheritDotParamsFromRd(rd)
})

.rs.addFunction("getSourceIndexCompletions", function(token)
{
   .Call("rs_getSourceIndexCompletions", token)
})

.rs.addFunction("getCompletionsNamespace", function(token, string, exportsOnly, envir)
{
   result <- .rs.emptyCompletions(excludeOtherCompletions = TRUE)
   
   if (!(string %in% loadedNamespaces()))
   {
      tryCatch(
         suppressPackageStartupMessages(requireNamespace(string, quietly = TRUE)),
         error = function(e) NULL
      )
   }
   
   if (string %in% loadedNamespaces())
   {
      namespace <- asNamespace(string)
      objectNames <- if (exportsOnly)
         getNamespaceExports(namespace)
      else
      {
         # Take advantage of 'sorted' argument if available,
         # as we only want to sort a filtered subset and will
         # sort again later
         arguments <- list()
         arguments[["name"]] <- namespace
         arguments[["all.names"]] <- TRUE
         if ("sorted" %in% names(formals(objects)))
            arguments[["sorted"]] <- FALSE
         
         do.call(objects, arguments)
      }
      
      # For `::`, we also want to grab items in the 'lazydata' environment
      # within the namespace.
      lazydata <- new.env(parent = emptyenv())
      dataNames <- character()
      if (exportsOnly && exists(".__NAMESPACE__.", envir = namespace))
      {
         .__NAMESPACE__. <- get(".__NAMESPACE__.", envir = namespace)
         if (exists("lazydata", envir = .__NAMESPACE__.))
         {
            lazydata  <- get("lazydata", envir = .__NAMESPACE__.)
            dataNames <- objects(lazydata, all.names = TRUE)
         }
      }
      
      # Filter our results
      objectNames <- .rs.selectFuzzyMatches(objectNames, token)
      dataNames   <- .rs.selectFuzzyMatches(dataNames, token)
      
      # Collect the object types
      objectTypes <- vapply(
         mget(objectNames, envir = namespace, inherits = TRUE),
         FUN.VALUE = numeric(1),
         USE.NAMES = FALSE,
         .rs.getCompletionType
      )
      
      # Let 'lazydata' be lazy -- don't force evaluation.
      dataTypes <- rep(.rs.acCompletionTypes$DATAFRAME, length(dataNames))
      
      # Construct a data.frame to hold our results (because we'll
      # need to re-sort our items)
      df <- data.frame(
         names = c(objectNames, dataNames),
         types = c(objectTypes, dataTypes),
         stringsAsFactors = FALSE
      )
      
      # Sort by 'names'
      df <- df[order(df$names), ]
      
      # Construct the completion result
      completions <- df$names
      type <- df$types
      
      result <- .rs.makeCompletions(
         token = token,
         results = completions,
         packages = string,
         quote = FALSE,
         type = type,
         excludeOtherCompletions = TRUE, 
         context = if (exportsOnly) .rs.acContextTypes$NAMESPACE_EXPORTED else .rs.acContextTypes$NAMESPACE_ALL
      )
   }
   
   result
   
})


.rs.addFunction("emptyCompletions", function(token = "",
                                             excludeOtherCompletions = FALSE,
                                             overrideInsertParens = FALSE,
                                             orderStartsWithAlnumFirst = TRUE,
                                             language = "R")
{
   .rs.makeCompletions(
      token = token,
      results = character(),
      packages = character(),
      quote = logical(),
      type = numeric(),
      fguess = "",
      excludeOtherCompletions = .rs.scalar(excludeOtherCompletions),
      overrideInsertParens = .rs.scalar(overrideInsertParens),
      orderStartsWithAlnumFirst = .rs.scalar(orderStartsWithAlnumFirst),
      language = .rs.scalar(language), 
      context = numeric()
   )
})

.rs.addFunction("isEmptyCompletion", function(completions)
{
   length(completions$results) == 0
})

.rs.addFunction("fuzzyMatches", function(completions, token)
{
   reStrip     <- "(?!^)[._]"
   token       <- gsub(reStrip, "", token, perl = TRUE)
   completions <- gsub(reStrip, "", completions, perl = TRUE)
   .rs.startsWith(tolower(completions), tolower(token))
})

.rs.addFunction("selectFuzzyMatches", function(completions, token)
{
   types <- attr(completions, "types")
   meta <- attr(completions, "meta")
   matches <- .rs.fuzzyMatches(completions, token)
   completions <- completions[matches]
   if (!is.null(types))
      attr(completions, "types") <- types[matches]
   if (!is.null(meta))
      attr(completions, "meta") <- meta[matches]
   completions
})

.rs.addFunction("formCompletionVector", function(object, default, n)
{
   if (length(object) == 0)
      rep(default, length.out = n)
   else if (length(object) == 1)
      rep.int(object, n)
   else if (length(object) == n)
      object
   else
      rep(object, length.out = n)
})

.rs.addFunction("makeCompletions", function(token,
                                            results,
                                            packages = character(),
                                            quote = logical(),
                                            type = numeric(),
                                            meta = character(),
                                            fguess = "",
                                            excludeOtherCompletions = FALSE,
                                            excludeOtherArgumentCompletions = FALSE,
                                            overrideInsertParens = FALSE,
                                            orderStartsWithAlnumFirst = TRUE,
                                            cacheable = TRUE,
                                            helpHandler = NULL,
                                            language = "R", 
                                            context = numeric(), 
                                            suggestOnAccept = NULL)
{
   if (is.null(results))
      results <- character()
   
   if (is.null(token))
      token <- ""
   
   if (length(meta) == 0L)
   {
      meta <- attr(results, "meta", exact = TRUE)
   }
   
   # Ensure other 'vector' completions are of the same length as 'results'
   n        <- length(results)
   packages <- .rs.formCompletionVector(packages, "", n)
   quote    <- .rs.formCompletionVector(quote, FALSE, n)
   type     <- .rs.formCompletionVector(type, .rs.acCompletionTypes$UNKNOWN, n)
   meta     <- .rs.formCompletionVector(meta, "", n)
   context  <- .rs.formCompletionVector(context, .rs.acCompletionTypes$UNKNOWN, n)
   
   if (!is.null(suggestOnAccept))
      suggestOnAccept <- .rs.formCompletionVector(suggestOnAccept, FALSE, n)
   
   # Favor completions starting with a letter
   if (orderStartsWithAlnumFirst)
   {
      startsWithLetter <- grepl("^[a-zA-Z0-9]", results, perl = TRUE)
      
      first <- which(startsWithLetter)
      last  <- which(!startsWithLetter)
      order <- c(first, last)
      
      results  <- results[order]
      packages <- packages[order]
      quote    <- quote[order]
      type     <- type[order]
      meta     <- meta[order]
      context  <- context[order]
      
      if (!is.null(suggestOnAccept))
         suggestOnAccept <- suggestOnAccept[order]
   }
   
   # Avoid generating too many completions
   limit <- 2000
   if (length(results) > limit)
   {
      cacheable <- FALSE
      idx <- seq_len(limit)
      
      results  <- results[idx]
      packages <- packages[idx]
      quote    <- quote[idx]
      type     <- type[idx]
      meta     <- meta[idx]
      context  <- context[idx]
      
      if (!is.null(suggestOnAccept))
         suggestOnAccept <- suggestOnAccept[idx]
   }
   
   list(token = token,
        results = results,
        packages = packages,
        quote = quote,
        type = type,
        meta = meta,
        fguess = fguess,
        excludeOtherCompletions = .rs.scalar(excludeOtherCompletions),
        excludeOtherArgumentCompletions = .rs.scalar(excludeOtherArgumentCompletions),
        overrideInsertParens = .rs.scalar(overrideInsertParens),
        cacheable = .rs.scalar(cacheable),
        helpHandler = .rs.scalar(helpHandler),
        language = .rs.scalar(language), 
        context = context, 
        suggestOnAccept = suggestOnAccept)
})

.rs.addFunction("subsetCompletions", function(completions, indices)
{
   for (name in c("results", "packages", "quote", "type", "context"))
      completions[[name]] <- completions[[name]][indices]
   
   if (!is.null(completions[["suggestOnAccept"]]))
      completions[["suggestOnAccept"]] <- completions[["suggestOnAccept"]][indices]
   
   completions
})

.rs.addFunction("appendCompletionsOptionalElement", function(old, new, name, default) 
{
   oldHas <- !is.null(old[[name]])
   newHas <- !is.null(new[[name]])
   
   if (oldHas)
   {
      if (newHas) {
         return(c(old[[name]], new[[name]]))
      } else {
         return(c(old[[name]], rep(default, length(new$results))))
      }
   }
   else 
   {
      if (newHas) {
         return(c(rep(default, length(old$results)), new[[name]]))
      } else {
         return(NULL)
      }
   }
   
})

.rs.addFunction("appendCompletions", function(old, new)
{
   if (is.null(new))
      return(old)
   
   old[["suggestOnAccept"]] <- .rs.appendCompletionsOptionalElement(old, new, "suggestOnAccept", FALSE)
   
   for (name in c("results", "packages", "quote", "type", "meta", "context"))
      old[[name]] <- c(old[[name]], new[[name]])
   
   # resolve duplicates -- a completion is duplicated if its result
   # and package are identical (if 'type' or 'quote' differs, it's probably a bug?)
   drop <- intersect(
      which(duplicated(old$results)),
      which(duplicated(old$packages))
   )
   
   if (length(drop))
   {
      for (name in c("results", "packages", "quote", "type", "meta", "context"))
         old[[name]] <- old[[name]][-c(drop)]
      
      if (!is.null(old[["suggestOnAccept"]])) {
         old[["suggestOnAccept"]] <- old[["suggestOnAccept"]][-c(drop)]
      }
   }
   
   if (length(new$token) && new$token != "")
      old$token <- new$token
   
   if (length(new$fguess) && new$fguess != "")
      old$fguess <- new$fguess
   
   if (length(new$excludeOtherCompletions) && new$excludeOtherCompletions)
      old$excludeOtherCompletions <- new$excludeOtherCompletions
   
   if (length(new$excludeOtherArgumentCompletions) && new$excludeOtherArgumentCompletions)
      old$excludeOtherArgumentCompletions <- new$excludeOtherArgumentCompletions
   
   if (length(new$overrideInsertParens) && new$overrideInsertParens)
      old$overrideInsertParens <- new$overrideInsertParens
   
   # If one completion states we are not cacheable, that setting is 'sticky'
   if (length(new$cacheable) && !new$cacheable)
      old$cacheable <- new$cacheable
   
   if (length(new$helpHandler))
      old$helpHandler <- new$helpHandler
   
   old
})

.rs.addFunction("sortCompletions", function(completions,
                                            token,
                                            shortestFirst = FALSE)
{
   
   # type based scores
   typeScores <- rep(100, length(completions$results))
   typeScores[completions$type == .rs.acCompletionTypes$ARGUMENT] <- 1
   typeScores[completions$type == .rs.acCompletionTypes$COLUMN] <- 2
   typeScores[completions$type == .rs.acCompletionTypes$DATATABLE_SPECIAL_SYMBOL] <- 3
   
   # data has high priority, unless it's requested from a :: or ::: context
   # rationale: https://github.com/rstudio/rstudio/issues/12678)
   typeScores[
      completions$type == .rs.acCompletionTypes$DATAFRAME & 
         ! completions$context %in% c(.rs.acContextTypes$NAMESPACE_EXPORTED, .rs.acContextTypes$NAMESPACE_ALL)
   ] <- 4
   typeScores[completions$type == .rs.acCompletionTypes$SECUNDARY_ARGUMENT] <- 5
   
   typeScores[completions$type == .rs.acCompletionTypes$PACKAGE] <- 101
   typeScores[completions$type == .rs.acCompletionTypes$CONTEXT] <- 102
   
   # additional scores based on the result
   scores <- if (nzchar(token)) 
      .rs.scoreMatches(completions$results, token)
   
   # Protect against NULL / otherwise invalid scores.
   # TODO: figure out what, upstream, might cause this
   if (!length(scores))
      scores <- rep(0L, length(completions$results))
   
   order <- if (shortestFirst)
      order(typeScores, scores, nchar(completions$results))
   else
      order(typeScores, scores)
   completions <- .rs.subsetCompletions(completions, order)
   
   completions
})

.rs.addFunction("getDataTableSpecialSymbolsCompletions", function(token, symbols)
{
   results <- symbols[.rs.fuzzyMatches(sub("^.", "", symbols), token)]
   .rs.makeCompletions(token = token, 
                       results = results, 
                       quote = FALSE, 
                       packages = "data.table",
                       type = .rs.acCompletionTypes$DATATABLE_SPECIAL_SYMBOL)
})

.rs.addFunction("getDataTableJCompletions", function(token)
{
   .rs.getDataTableSpecialSymbolsCompletions(token, c(".SD", ".BY", ".N", ".I", ".GRP", ".NGRP"))
})

.rs.addFunction("getDataTableByCompletions", function(token)
{
   .rs.getDataTableSpecialSymbolsCompletions(token, ".EACHI")
})

.rs.addFunction("getDataTableColumnsCompletions", function(token, name, object)
{
   .rs.makeCompletions(token = token,
                       results = .rs.selectFuzzyMatches(names(object), token),
                       packages = name,
                       quote = FALSE,
                       type = .rs.acCompletionTypes$COLUMN, 
                       fguess = "[.data.table")
})

.rs.addFunction("getDataTableUnnamedArgumentCompletions", function(token, name, object, functionCall, numCommas, includeArguments = TRUE, envir)
{
   # column names
   completions <- .rs.getDataTableColumnsCompletions(token, name, object)
   
   # j = 
   if (numCommas == 1)
      completions <- .rs.appendCompletions(completions, .rs.getDataTableJCompletions(token))
   
   # by|keyby =
   if (numCommas == 2 || numCommas == 3)
      completions <- .rs.appendCompletions(completions, .rs.getDataTableByCompletions(token))
   
   # finally, offer the arguments of data.table:::`[.data.table` 
   if (isTRUE(includeArguments) && isNamespaceLoaded("data.table"))
   {
      argCompletions <- .rs.getCompletionsFunction(token, 
                                                   "[.data.table", 
                                                   functionCall, 
                                                   numCommas, 
                                                   envir = envir, 
                                                   object = data.table:::`[.data.table`)
      argCompletions$type[argCompletions$type == .rs.acCompletionTypes$ARGUMENT] <- .rs.acCompletionTypes$SECUNDARY_ARGUMENT
      
      completions <- .rs.appendCompletions(
         completions, 
         argCompletions
      )
   }
   completions
})

.rs.addFunction("getDataTableNamedArgumentCompletions", function(token, name, object, activeArg, functionCall)
{
   # column names
   completions <- .rs.getDataTableColumnsCompletions(token, as.character(name), object)
   
   if (identical(activeArg, "j"))
      completions <- .rs.appendCompletions(completions, .rs.getDataTableJCompletions(token))
   
   if (activeArg %in% c("by", "keyby"))
      completions <- .rs.appendCompletions(completions, .rs.getDataTableByCompletions(token))
   
   completions
})

.rs.addFunction("isDataTableExtractCall", function(string, envir)
{
   tryCatch({
      # NOTE: We don't retrieve the name from the function call as this could
      # be a complex parse tree (e.g. dt[, y := 1][, y]$x); it is substantially
      # easier to strip the object name from the 'string' constituting the parsed object
      bracketIdx <- regexpr("[", string, fixed = TRUE)
      if (bracketIdx == -1)
         return(FALSE)
      
      objectName <- substring(string, 1L, bracketIdx - 1L)
      inherits(.rs.getAnywhere(objectName, envir = envir), "data.table")
   }, error = function(e) FALSE)
   
})

## NOTE: for '@' as well (set in the 'isAt' parameter)
.rs.addFunction("getCompletionsDollar", function(token, string, functionCall, envir, isAt)
{
   # bail if string would call [] on a data.table
   # because this might side-effect modify the data table
   if (.rs.isDataTableExtractCall(string, envir = envir))
      return(.rs.emptyCompletions(excludeOtherCompletions = TRUE))
   
   object <- .rs.getAnywhere(string, envir)
   if (is.null(object))
      return(.rs.emptyCompletions(excludeOtherCompletions = TRUE))
   
   allNames <- character()
   names <- character()
   type <- numeric()
   helpHandler <- NULL
   
   if (isAt)
   {
      if (exists(".AtNames"))
      {
         .rs.tryCatch({
            
            code <- substitute(
               utils::.AtNames(object, pattern = ""),
               list(object = object)
            )
            
            allNames <- eval(code, envir = globalenv())
            names <- .rs.selectFuzzyMatches(allNames, token)
            type <- attr(names, "types")
            
         })
      }
      else if (isS4(object))
      {
         .rs.tryCatch({
            
            allNames <- .slotNames(object)
            names <- .rs.selectFuzzyMatches(allNames, token)
            suppressTypeInference <- attr(allNames, "suppressTypeInference", exact = TRUE)
            
            # Skip type inference if requested.
            if (identical(suppressTypeInference, TRUE))
            {
               type <- .rs.acCompletionTypes$UNKNOWN
            }
            
            # NOTE: Getting the types forces evaluation; we avoid that if
            # there are too many names to evaluate.
            else if (length(names) > 2E2)
            {
               type <- .rs.acCompletionTypes$UNKNOWN
            }
            
            # Otherwise, evaluate each name, and check the completion type.
            else
            {
               type <- numeric(length(names))
               for (i in seq_along(names))
               {
                  type[[i]] <- suppressWarnings(tryCatch(
                     .rs.getCompletionType(eval(call("@", quote(object), names[[i]]))),
                     error = function(e) .rs.acCompletionTypes$UNKNOWN
                  ))
               }
            }
            
         })
      }
   }
   else
   {
      # Check to see if an overloaded .DollarNames method has been provided,
      # and use that to resolve names if possible.
      dollarNamesMethod <- .rs.getDollarNamesMethod(object, TRUE, envir = envir)
      if (is.function(dollarNamesMethod))
      {
         # An invocation of something like NextMethod() can fail if we try
         # to invoke the underlying method directly, so in this scenario
         # we still just allow the default S3 dispatch to take place.
         expr <- substitute(
            utils::.DollarNames(object, pattern = ""),
            list(object = object)
         )
         allNames <- eval(expr, envir = envir)
         
         # check for custom helpHandler
         helpHandler <- attr(allNames, "helpHandler", exact = TRUE)
      }
      
      # Reference class generators / objects
      else if (inherits(object, "refObjectGenerator"))
      {
         allNames <- Reduce(union, list(
            objects(object@generator@.xData, all.names = TRUE),
            objects(object$def@refMethods, all.names = TRUE),
            c("new", "help", "methods", "fields", "lock", "accessors")
         ))
      }
      
      # Reference class objects
      else if (inherits(object, "refClass"))
      {
         suppressWarnings(tryCatch({
            refClassDef <- object$.refClassDef
            allNames <- c(
               ls(refClassDef@fieldPrototypes, all.names = TRUE),
               ls(refClassDef@refMethods, all.names = TRUE)
            )
            
            # Place the 'less interesting' methods lower
            baseMethods <- c("callSuper", "copy", "export", "field",
                             "getClass", "getRefClass", "import", "initFields",
                             "show", "trace", "untrace", "usingMethods")
            
            allNames <- c(
               setdiff(allNames, baseMethods),
               baseMethods
            )
         }, error = function(e) NULL))
      }
      
      # Objects for which 'names' returns non-NULL. This branch is used
      # to provide completions for S4 objects, essentially adhering to
      # the `.DollarNames.default` behaviour. (It looks like if an S4
      # object is able to supply names through the `names` method, then
      # those names are also valid for `$` completions.)
      else if (isS4(object) && length(names(object)))
      {
         allNames <- .rs.getNames(object)
      }
      
      # Environments (note that some S4 objects 'are' environments;
      # e.g. 'hash' objects from the 'hash' package)
      else if (is.environment(object))
      {
         allNames <- .rs.getNames(object)
      }
      
      # Other objects
      else
      {
         # '$' operator is invalid for atomic vectors
         if (is.atomic(object))
            return(.rs.emptyCompletions(excludeOtherCompletions = TRUE))
         
         # Don't allow S4 objects for dollar name resolution
         # They will need to have defined a .DollarNames method, which
         # should have been resolved previously
         if (!isS4(object))
         {
            allNames <- .rs.getNames(object)
         }
      }
      
      names <- .rs.selectFuzzyMatches(allNames, token)
      suppressTypeInference <- attr(allNames, "suppressTypeInference", exact = TRUE)
            
      # See if types were provided.
      types <- attr(names, "types")
      if (is.integer(types) && length(types) == length(names))
      {
         type <- types
      }
      
      # Skip type inference if requested.
      else if (identical(suppressTypeInference, TRUE))
      {
         type <- .rs.acCompletionTypes$UNKNOWN
      }
      
      # Give all entries within a 'data.frame' a special "column" type.
      else if (inherits(object, "data.frame"))
      {
         type <- .rs.acCompletionTypes$COLUMN
      }
      
      # NOTE: Getting the types forces evaluation; we avoid that if
      # there are too many names to evaluate.
      else if (length(names) > 2E2)
      {
         type <- .rs.acCompletionTypes$UNKNOWN
      }
      
      # Avoid requesting completion types for remote tables,
      # as that could be prohibitively expensive.
      else if (inherits(object, c("tbl_dbi", "tbl_sql", "tbl_lazy")))
      {
         type <- .rs.acCompletionTypes$UNKNOWN
      }
      
      else
      {
         type <- numeric(length(names))
         looksLikeFunction <- grepl("[()]\\s*$", names, perl = TRUE)
         for (i in seq_along(names))
         {
            if (looksLikeFunction[[i]])
            {
               names[[i]] <- gsub("[()]+\\s*$", "", names[[i]], perl = TRUE)
               type[[i]] <- .rs.acCompletionTypes$FUNCTION
            }
            else
            {
               type[[i]] <- suppressWarnings(tryCatch(
                  if (is.environment(object) && bindingIsActive(names[[i]], object))
                     .rs.acCompletionTypes$UNKNOWN
                  else
                     .rs.getCompletionType(eval(call("$", quote(object), names[[i]]))),
                  error = function(e) .rs.acCompletionTypes$UNKNOWN
               ))
            }
         }
      }
   }
   
   .rs.makeCompletions(
      token = token,
      results = names,
      packages = string,
      quote = FALSE,
      type = type,
      excludeOtherCompletions = TRUE,
      helpHandler = helpHandler, 
      context = if (isAt) .rs.acContextTypes$AT else .rs.acContextTypes$DOLLAR
   )
})

.rs.addFunction("getCompletionsSingleBracket", function(token,
                                                        string,
                                                        functionCall,
                                                        numCommas,
                                                        index,
                                                        envir)
{
   result <- .rs.emptyCompletions()
   
   # bail if string would call [] on a data.table
   # because this might side-effect modify the data table
   if (.rs.isDataTableExtractCall(string, envir = envir))
      return(.rs.emptyCompletions(excludeOtherCompletions = TRUE))
   
   object <- .rs.getAnywhere(string, envir)
   if (is.null(object))
      return(result)
   
   # data.table special case
   if (inherits(object, "data.table"))
   {
      return(.rs.getDataTableUnnamedArgumentCompletions(
         token, 
         name = string, 
         object = object, 
         functionCall = functionCall, 
         numCommas = numCommas, 
         includeArguments = (index == 1L),
         envir = envir
      ))
   }
   
   completions <- character()
   
   # Get completions from dimension names for arrays (and other
   # matrix-like objects such as Matrix-package sparse matrices, which
   # have a dim() but for which is.array() returns FALSE). Exclude
   # data.frames so they continue to use the rownames special-case below;
   # otherwise auto-generated rownames like "1", "2" would be offered as
   # completions for `df[|`.
   if (!inherits(object, "data.frame") &&
       !is.null(dim(object)) &&
       !is.null(dn <- dimnames(object)))
   {
      if (numCommas + 1 <= length(dn))
         completions <- dn[[numCommas + 1]]

      string <- if (numCommas == 0)
         paste("rownames(", string, ")", sep = "")
      else if (numCommas == 1)
         paste("colnames(", string, ")", sep = "")
      else
         paste("dimnames(", string, ")[", numCommas + 1, "]", sep = "")
   }

   # Get completions from rownames for data.frames if we have no commas, e.g.
   # `mtcars[|`
   else if (inherits(object, "data.frame") &&
            numCommas == 0)
   {
      info <- .row_names_info(object, type = 0L)
      if (is.character(info))
         completions <- info
   }
   
   # Just get the names of the object
   else
   {
      completions <- .rs.getNames(object)
   }
   
   completions <- .rs.selectFuzzyMatches(completions, token)
   
   if (length(completions))
   {
      type <- if (is.data.frame(object))
         .rs.acCompletionTypes$COLUMN
      else
         .rs.acCompletionTypes$STRING
      
      result <- .rs.makeCompletions(
         token = token,
         results = completions,
         packages = string,
         quote = !inherits(object, "data.table"),
         type = type
      )
   }
   
   result
   
})

.rs.addFunction("getCompletionsDoubleBracket", function(token,
                                                        string,
                                                        functionCall,
                                                        envir = parent.frame())
{
   result <- .rs.emptyCompletions()
   
   # bail if string would call [] on a data.table
   # because this might side-effect modify the data table
   if (.rs.isDataTableExtractCall(string, envir = envir))
      return(result)
   
   object <- .rs.getAnywhere(string, envir)
   if (is.null(object))
      return(result)
   
   completions <- .rs.getNames(object)
   completions <- .rs.selectFuzzyMatches(completions, token)
   
   if (length(completions))
   {
      type <- if (is.data.frame(object))
         .rs.acCompletionTypes$COLUMN
      else
         .rs.acCompletionTypes$STRING
      
      result <- .rs.makeCompletions(
         token = token,
         results = completions,
         packages = string,
         quote = TRUE,
         type = type,
         overrideInsertParens = TRUE
      )
   }
   
   result
   
})

.rs.addFunction("listIndexedPackages", function()
{
   .Call("rs_listIndexedPackages", PACKAGE = "(embedding)")
})

.rs.addFunction("getCompletionsPackages", function(token,
                                                   appendColons = FALSE,
                                                   excludeOtherCompletions = FALSE,
                                                   quote = !appendColons)
{
   allPackages <- sort(basename(.rs.listIndexedPackages()))
   
   # In case indexing is disabled, include any loaded namespaces by default
   allPackages <- union(allPackages, loadedNamespaces())
   
   # Not sure why 'DESCRIPTION' might show up here, but let's take it out
   allPackages <- setdiff(allPackages, "DESCRIPTION")
   
   # Also remove any '00LOCK' directories -- these might be leftovers
   # from earlier failed package installations
   if (length(allPackages))
   {
      isLockDir <- substring(allPackages, 1, 6) == "00LOCK"
      allPackages <- allPackages[!isLockDir]
   }
   
   # Construct our completions, and we're done
   matches <- .rs.selectFuzzyMatches(allPackages, token)
   results <- if (appendColons && length(matches))
      paste(matches, "::", sep = "")
   else
      matches
   
   completions <- .rs.makeCompletions(
      token = token,
      results = results,
      packages = matches,
      quote = quote,
      type = .rs.acCompletionTypes$PACKAGE,
      excludeOtherCompletions = excludeOtherCompletions, 
      context = .rs.acContextTypes$PACKAGE
   )
   
   .rs.sortCompletions(
      completions   = completions,
      token         = token
   )
})

.rs.addFunction("getCompletionsData", function(token)
{
   # Suppress warnings e.g.
   #
   #    Warning messages:
   #       1: In data(package = .packages(all.available = TRUE)) :
   #       datasets have been moved from package 'base' to package 'datasets'
   #    2: In data(package = .packages(all.available = TRUE)) :
   #       datasets have been moved from package 'stats' to package 'datasets'
   #
   availableData <- suppressWarnings(data()$results)
   
   # Don't include aliases
   indices <- intersect(
      which(.rs.fuzzyMatches(availableData[, "Item"], token)),
      grep(" ", availableData[, "Item"], fixed = TRUE, invert = TRUE)
   )
   
   results <- availableData[indices, "Item"]
   packages <- availableData[indices, "Package"]
   
   .rs.makeCompletions(token,
                       results,
                       packages,
                       quote = TRUE,
                       type = .rs.acCompletionTypes$DATASET)
})

.rs.addFunction("getCompletionsGetOption", function(token)
{
   allOptions <- names(options())
   .rs.makeCompletions(token = token,
                       results = .rs.selectFuzzyMatches(allOptions, token),
                       packages = "options",
                       quote = TRUE,
                       type = .rs.acCompletionTypes$OPTION)
})

.rs.addFunction("getCompletionsOptions", function(token)
{
   allOptions <- names(options())
   completions <- .rs.selectFuzzyMatches(allOptions, token)
   if (length(completions))
      completions <- paste(completions, "= ")
   
   .rs.makeCompletions(token,
                       completions,
                       type = .rs.acCompletionTypes$OPTION)
})

.rs.addFunction("getCompletionsActiveFrame", function(token,
                                                      envir)
{
   currentEnv <- envir
   encounteredEnvs <- list()
   
   completions <- character()
   types <- numeric()
   
   empty <- emptyenv()
   while (!(identical(currentEnv, empty) ||
            identical(currentEnv, .GlobalEnv) ||
            identical(currentEnv, .BaseNamespaceEnv)))
   {
      for (i in seq_along(encounteredEnvs))
      {
         if (identical(currentEnv, encounteredEnvs[[i]]))
            return(.rs.emptyCompletions())
      }
      
      objects <- objects(currentEnv, all.names = TRUE)
      
      completions <- c(completions, objects)
      types <- c(
         types,
         vapply(objects, USE.NAMES = FALSE, FUN.VALUE = numeric(1), function(object) {
            tryCatch(
               .rs.getCompletionType(get(object, envir = currentEnv, inherits = TRUE)),
               error = function(e) .rs.acCompletionTypes$UNKNOWN
            )
         })
      )
      
      encounteredEnvs <- c(encounteredEnvs, currentEnv)
      currentEnv <- parent.env(currentEnv)
   }
   
   keep <- .rs.fuzzyMatches(completions, token)
   .rs.makeCompletions(token = token,
                       results = completions[keep],
                       type = types[keep])
})

.rs.addFunction("getNAMESPACEImportedSymbols", function(documentId)
{
   .Call("rs_getNAMESPACEImportedSymbols", documentId)
})

.rs.addFunction("getCompletionsNAMESPACE", function(token, documentId)
{
   symbols <- .rs.getNAMESPACEImportedSymbols(documentId)
   
   if (!length(symbols))
      return(.rs.emptyCompletions())
   
   n <- vapply(symbols, function(x) length(x[[1]]), USE.NAMES = FALSE, FUN.VALUE = numeric(1))
   
   output <- list(
      exports = unlist(lapply(symbols, `[[`, "exports"), use.names = FALSE),
      types = unlist(lapply(symbols, `[[`, "types"), use.names = FALSE),
      packages = rep.int(names(symbols), times = n)
   )
   
   keep <- .rs.fuzzyMatches(output$exports, token)
   
   .rs.makeCompletions(token = token,
                       results = output$exports[keep],
                       packages = output$packages[keep],
                       type = output$types[keep],
                       quote = FALSE)
})

.rs.addFunction("getCompletionsSearchPath", function(token,
                                                     overrideInsertParens = FALSE)
{
   objects <- if (.rs.startsWith(token, "."))
      .rs.objectsOnSearchPath(".")
   else
      .rs.objectsOnSearchPath()
   
   objects[["keywords"]] <- c(
      "NULL", "NA", "TRUE", "FALSE", "T", "F", "Inf", "NaN",
      "NA_integer_", "NA_real_", "NA_character_", "NA_complex_"
   )
   
   names <- names(objects)
   results <- unlist(objects, use.names = FALSE)
   packages <- unlist(lapply(1:length(objects), function(i) {
      rep.int(names[i], length(objects[[i]]))
   }))
   
   # discover completion matches for this token
   keep <- .rs.fuzzyMatches(results, token)
   results <- results[keep]
   packages <- packages[keep]
   
   # remove duplicates (assume first element masks next)
   dupes    <- duplicated(results)
   results  <- results[!dupes]
   packages <- packages[!dupes]
   
   # re-order the completion results (lexically)
   order <- order(results)
   
   # If the token is 'T' or 'F', prefer 'TRUE' and 'FALSE' completions
   if (token == "T")
   {
      TRUEpos <- which(results == "TRUE")
      order <- c(TRUEpos, order[-c(TRUEpos)])
   }
   
   if (token == "F")
   {
      FALSEpos <- which(results == "FALSE")
      order <- c(FALSEpos, order[-c(FALSEpos)])
   }
   
   results <- results[order]
   packages <- packages[order]
   
   type <- vapply(seq_along(results), function(i) {
      
      if (packages[[i]] == "keywords")
         return(.rs.acCompletionTypes$KEYWORD)
      
      if (packages[[i]] == "")
         return(.rs.acCompletionTypes$UNKNOWN)
      
      name <- results[[i]]
      env <- as.environment(packages[[i]])
      
      if (bindingIsActive(name, env))
         return(.rs.acCompletionTypes$ACTIVE_BINDING)
      
      object <- tryCatch(
         get(name, envir = env),
         error = identity
      )
      
      if (inherits(object, "error"))
         return(.rs.acCompletionTypes$UNKNOWN)
      
      type <- .rs.getCompletionType(object)
      
      # fix up source package for S4 generics
      if (type %in% .rs.acCompletionTypes$S4_GENERIC) {
         package <- attr(object, "package", exact = TRUE)
         if (is.character(package) && nzchar(package))
            packages[[i]] <<- package
      }
      
      return(type)
      
   }, FUN.VALUE = numeric(1), USE.NAMES = FALSE)
   
   # Keywords are really from the base package
   packages[packages == "keywords"] <- "base"
   
   .rs.makeCompletions(token = token,
                       results = results,
                       packages = packages,
                       quote = FALSE,
                       type = type,
                       overrideInsertParens = overrideInsertParens)
   
})

.rs.addFunction("finishExpression", function(string)
{
   .Call("rs_finishExpression", as.character(string), PACKAGE = "(embedding)")
})

.rs.addFunction("getCompletionsAttr", function(token,
                                               functionCall,
                                               envir)
{
   result <- tryCatch({
      wrapper <- function(x, which, exact = FALSE) {}
      matched <- .rs.matchCall(wrapper, functionCall)
      if (is.null(matched[["x"]]))
         return(.rs.emptyCompletions())
      objectExpr <- matched[["x"]]
      objectName <- capture.output(print(objectExpr))
      object <- eval(objectExpr, envir = envir)
      
      completions <- .rs.selectFuzzyMatches(
         names(attributes(object)),
         token
      )
      
      result <- .rs.makeCompletions(
         token,
         completions,
         paste("attributes(", objectName, ")", sep = ""),
         quote = TRUE,
         type = .rs.acCompletionTypes$STRING
      )
      
   }, error = function(e) .rs.emptyCompletions())
   result
})

.rs.addFunction("isBrowserActive", function()
{
   .Call("rs_isBrowserActive", PACKAGE = "(embedding)")
})

# NOTE: This function attempts to find an active frame (if
# any) in the current caller's context, which may be a
# function environment if we're currently in the debugger,
# and just the .GlobalEnv otherwise. Because the
# '.rs.rpc.get_completions' call gets its own set of 'stack
# frames', we must poke into 'sys.frames()' and get the last
# frame not part of that stack. In practice, this means
# discarding the current frame, as well as any extra frames
# from the caller (hence, the 'offset' argument). Of course,
# when there is no debug frame active, we just want to draw
# our completions from the global environment.
.rs.addFunction("getActiveFrame", function(offset = 1L)
{
   frames <- c(.GlobalEnv, sys.frames())
   frames[[length(frames) - 1L - offset]]
})

# Only display directory completions (not file completions)
.rs.addFunction("isDirectoryOnlyCompletionFunction", function(string)
{
   # Base R functions + fs functions that deal with dir_
   # https://fs.r-lib.org/articles/function-comparisons.html#directory-functions
   dirOnlyFuncs <- c("list.files", "list.dirs", "dir", "setwd")
   string %in% dirOnlyFuncs || grepl("^(?:fs:{2,3})?dir_", string)
})

.rs.addFunction("getCompletionsNativeRoutine", function(token, interface)
{
   # For a package which has dynamic symbol loading, just get the strings.
   # For other packages, search the namespace for the symbol.
   loadedDLLs <- getLoadedDLLs()
   routines <- lapply(loadedDLLs, getDLLRegisteredRoutines)
   
   isDynamic <- unlist(lapply(loadedDLLs, `[[`, "dynamicLookup"))
   
   dynRoutines <- c(
      routines[isDynamic],
      routines["(embedding)"]
   )
   
   dynRoutineNames <- lapply(dynRoutines, function(x) {
      names(x[[interface]])
   })
   
   if (is.null(names(dynRoutineNames)))
      return(.rs.emptyCompletions())
   
   dynResults <- .rs.namedVectorAsList(dynRoutineNames)
   dynIndices <- .rs.fuzzyMatches(dynResults$values, token)
   
   .rs.makeCompletions(token = token,
                       results = dynResults$values[dynIndices],
                       packages = dynResults$names[dynIndices],
                       quote = TRUE,
                       type = .rs.acCompletionTypes$STRING)
   
})

.rs.addFunction("mightBeShinyFunction", function(string)
{
   # Try seeing if there's a function with this name on the
   # search path, and return TRUE if it has 'inputId' or
   # 'outputId' as parameters.
   result <- tryCatch(get(string, pos = 0), error = function(e) NULL)
   if (is.function(result) && !is.primitive(result))
   {
      formalNames <- names(formals(result))
      if (any(c("inputId", "outputId") %in% formalNames))
         return(TRUE)
   }
   
   # Try seeing if there's a function of this name
   # in the 'shiny' completion database.
   shinyFunctions <- .rs.getInferredCompletions("shiny")$functions
   if (string %in% names(shinyFunctions))
      return(TRUE)
   
   return(FALSE)
})

.rs.addFunction("getKnitParamsForDocument", function(documentId)
{
   .Call("rs_getKnitParamsForDocument", documentId)
})

.rs.addFunction("knitParams", function(content)
{
   if (!("knitr" %in% loadedNamespaces()))
      if (!requireNamespace("knitr", quietly = TRUE))
         return(NULL)
   
   if (!("knit_params" %in% getNamespaceExports(asNamespace("knitr"))))
      return(NULL)
   
   Encoding(content) <- "UTF-8"
   knitr::knit_params(content)
})

.rs.addFunction("getCompletionsRMarkdownParams", function(token, type, documentId)
{
   # TODO: Bail if 'params' is already defined?
   if (exists("params", envir = .GlobalEnv))
      return(NULL)
   
   params <- .rs.getKnitParamsForDocument(documentId)
   if (!length(params))
      return(.rs.emptyCompletions())
   
   names <- vapply(params, FUN.VALUE = character(1), USE.NAMES = FALSE, function(x) {
      x$name
   })
   
   completions <- .rs.selectFuzzyMatches(names, token)
   .rs.makeCompletions(token = token,
                       results = completions)
})

.rs.addFunction("injectKnitrParamsObject", function(documentId)
{
   if (exists("params", envir = .GlobalEnv))
      return(FALSE)
   
   params <- .rs.getKnitParamsForDocument(documentId)
   if (!length(params))
      return(FALSE)
   
   mockedObject <- lapply(params, `[[`, "value")
   names(mockedObject) <- unlist(lapply(params, `[[`, "name"))
   class(mockedObject) <- "rstudio_mock"
   assign("params", mockedObject, envir = .GlobalEnv)
   
   return(TRUE)
})

.rs.addFunction("removeKnitrParamsObject", function()
{
   if (exists("params", envir = .GlobalEnv))
   {
      params <- get("params", envir = .GlobalEnv)
      if (inherits(params, "rstudio_mock"))
         remove(params, envir = .GlobalEnv) 
   }
})

.rs.addFunction("getCompletionsPythonVirtualEnvironments", function(token)
{
   home <- Sys.getenv("WORKON_HOME", unset = "~/.virtualenvs")
   candidates <- list.files(home)
   results <- .rs.selectFuzzyMatches(candidates, token)
   
   .rs.makeCompletions(token = token,
                       results = results,
                       quote = TRUE,
                       type = .rs.acCompletionTypes$STRING)
})

.rs.addFunction("getCompletionsEnvironmentVariables", function(token)
{
   candidates <- names(Sys.getenv())
   results <- .rs.selectFuzzyMatches(candidates, token)
   
   .rs.makeCompletions(token = token,
                       results = results,
                       quote = TRUE,
                       type = .rs.acCompletionTypes$STRING)
})

.rs.addFunction("readlineCompletions", function(token) 
{
   rx <- "^.*(\\(|\\[)(.*)(\\)|\\]).*$"
   
   nframes <- sys.nframe()
   for (i in seq_len(nframes))
   {
      if (!identical(sys.function(i), base::readline))
         next
      
      frame <- sys.frame(i)
      prompt <- frame$prompt
      if (!is.character(prompt) || !grepl(rx, prompt))
         return(.rs.emptyCompletions(excludeOtherCompletions = TRUE))
      
      results <- strsplit(sub(rx, "\\2", prompt), "/")[[1L]]
      if (length(results) == 1L)
         return(.rs.emptyCompletions(excludeOtherCompletions = TRUE))
      
      # remove whitespace around options
      results <- .rs.trimWhitespace(results)
      
      # capitalized first as this is likely to be the default
      cap <- grepl("^[A-Z]", results)
      results <- c(results[cap], results[!cap])
      
      # return completions
      completions <- .rs.makeCompletions(
         token = token,
         results = results,
         quote = FALSE,
         type = .rs.acCompletionTypes$STRING
      )
      return(completions)
   }
      
})

.rs.addJsonRpcHandler("get_completions", function(token,
                                                  contextData,
                                                  functionCallString,
                                                  statementBounds,
                                                  chainObjectName,
                                                  additionalArgs,
                                                  excludeArgs,
                                                  excludeArgsFromObject,
                                                  filePath,
                                                  documentId,
                                                  line,
                                                  isConsole)
{
   # Map from 0-based indexes to 1-based indexes in ranges
   for (i in seq_along(contextData))
      contextData[[i]]$range <- .rs.reindexRange(contextData[[i]]$range)
   
   statementBounds <- .rs.reindexRange(statementBounds)
   
   # To avoid too much code churn, unpack the contextData members into
   # the expected (older) variable names.
   string <- lapply(contextData, `[[`, 1L)
   context <- lapply(contextData, `[[`, 2L)
   numCommas <- lapply(contextData, `[[`, 3L)
   
   # Ensure UTF-8 encoding, as that's the encoding set when passed down from
   # the client
   token <- .rs.setEncodingUnknownToUTF8(token)
   string <- .rs.setEncodingUnknownToUTF8(string)
   functionCallString <- .rs.setEncodingUnknownToUTF8(functionCallString)
   chainObjectName <- .rs.setEncodingUnknownToUTF8(chainObjectName)
   additionalArgs <- .rs.setEncodingUnknownToUTF8(additionalArgs)
   excludeArgs <- .rs.setEncodingUnknownToUTF8(excludeArgs)
   excludeArgsFromObject <- .rs.setEncodingUnknownToUTF8(excludeArgsFromObject)
   filePath <- .rs.setEncodingUnknownToUTF8(filePath)
   
   # if base::readline() is on the stack, try to extract choices i.e. (yes/no)
   # and offer those as completions.
   readLineCompletions <- .rs.readlineCompletions(token)
   if (!is.null(readLineCompletions))
      return(readLineCompletions)
   
   # If the R console is requesting completions, but the Python REPL is
   # active, then delegate to that machinery.
   if (isConsole && .rs.reticulate.replIsActive())
      return(.rs.rpc.python_get_completions(line, NULL))
   
   # Inject 'params' into the global env to provide for completions in
   # parameterized R Markdown documents
   if (.rs.injectKnitrParamsObject(documentId))
      on.exit(.rs.removeKnitrParamsObject(), add = TRUE)
   
   # If custom completions have been set through
   # 'rc.options("custom.completions")',
   # then use the internal R completions instead.
   if (.rs.isCustomCompletionsEnabled()) {
      
      completions <- tryCatch(
         .rs.getCustomRCompletions(line),
         error = identity
      )
      
      if (!inherits(completions, "error"))
         return(completions)
   }
   
   # Get the currently active frame
   envir <- .rs.getActiveFrame()
   
   filePath <- suppressWarnings(.rs.normalizePath(filePath))
   
   ## NOTE: these are passed in as lists of strings; convert to character
   additionalArgs <- as.character(additionalArgs)
   excludeArgs <- as.character(excludeArgs)
   
   ## For magrittr completions, we may see a pipe thrown in as part of the 'string'
   ## and 'functionCallString'. In such a case, we need to strip off everything before
   ## a '%>%' and augment the numCommas.
   isPiped <- nzchar(chainObjectName)
   functionContexts <- which(context == .rs.acContextTypes$FUNCTION)
   if (length(functionContexts) == 1L)
   {
      i <- functionContexts
      pipes <- c("%>%", "%<>%", "%T>%", "%>>%", "\\|>")
      pattern <- paste(pipes, collapse = "|")
      
      stringPipeMatches <- gregexpr(pattern, string[[i]], perl = TRUE)[[1]]
      if (!identical(c(stringPipeMatches), -1L))
      {
         n <- length(stringPipeMatches)
         idx <- stringPipeMatches[n] + attr(stringPipeMatches, "match.length")[n]
         isPiped <- TRUE
         string[[i]] <- gsub("^[\\s\\n]*", "", substring(string[[i]], idx), perl = TRUE)
         
         ## Figure out the 'parent object' of the call. We munge the
         ## function call and place that back in, so S3 dispatch and such
         ## can work.
         firstPipeIdx <- stringPipeMatches[[1]]
         parentObject <- .rs.trimWhitespace(
            substring(functionCallString, 1, firstPipeIdx - 1L)
         )
         
         functionCallString <- gsub(
            "^\\s*",
            "",
            substring(functionCallString, idx),
            perl = TRUE
         )
         
         # Add the argument back in
         functionCallString <- sub(
            "(",
            paste("(", parentObject, ",", sep = ""),
            functionCallString,
            fixed = TRUE
         )
         
      }
      else if (nzchar(chainObjectName))
      {
         
         functionCallString <- sub(
            "(",
            paste("(", chainObjectName, ",", sep = ""),
            functionCallString,
            fixed = TRUE
         )
      }
   }
   
   # the functionCallString was altered, so we need to bump the first numCommas
   if (isPiped && length(context) && context[[1L]] == .rs.acContextTypes$FUNCTION)
      numCommas[[1L]] <- numCommas[[1L]] + 1L
   
   ## Try to parse the function call string
   functionCall <- tryCatch({
      parse(text = .rs.finishExpression(functionCallString))[[1]]
   }, error = function(e)
      NULL
   )
   
   ## Handle some special cases early
   
   # custom help handler for arguments
   if (length(context) && .rs.acContextTypes$FUNCTION %in% context[[1]]) {
      completions <- .rs.getCompletionsCustomHelpHandler(token, string[[1]])
      if (!is.null(completions))
         return(completions)
   }
   
   # help
   if (.rs.acContextTypes$HELP %in% context)
      return(.rs.getCompletionsHelp(token))
   
   # Roxygen
   if (.rs.acContextTypes$ROXYGEN %in% context)
      return(.rs.attemptRoxygenTagCompletion(token, line))
   
   # Plumber
   if (.rs.acContextTypes$PLUMBER %in% context)
      return(.rs.attemptPlumberTagCompletion(token, line))
   
   # install.packages
   if (length(string) && string[[1]] == "install.packages" && numCommas[[1]] == 0)
      return(.rs.getCompletionsInstallPackages(token))
   
   # example / help
   if (nzchar(token) &&
       length(string) &&
       string[[1]] %in% c("help", "example") &&
       numCommas[[1]] == 0)
   {
      return(.rs.getCompletionsHelp(token, quote = TRUE))
   }
   
   # vignettes
   if (length(string) && string[[1]] == "vignette" && numCommas[[1]] == 0)
      return(.rs.getCompletionsVignettes(token))
   
   # .Call, .C, .Fortran, .External
   if (length(string) && 
       string[[1]] %in% c(".Call", ".C", ".Fortran", ".External") &&
       numCommas[[1]] == 0)
   {
      return(.rs.getCompletionsNativeRoutine(token, string[[1]]))
   }
   
   # data
   if (length(context) &&
       context[[1]] == .rs.acContextTypes$FUNCTION &&
       string[[1]] == "data" &&
       numCommas[[1]] == 0)
   {
      return(.rs.getCompletionsData(token))
   }
   
   # package name
   if (.rs.acContextTypes$PACKAGE %in% context)
      return(.rs.getCompletionsPackages(token = token,
                                        appendColons = TRUE,
                                        excludeOtherCompletions = TRUE))
   
   # environment variables
   if (length(string) &&
       string[[1]] %in% c("Sys.getenv", "Sys.setenv", "Sys.unsetenv") &&
       numCommas[[1]] == 0)
      return(.rs.getCompletionsEnvironmentVariables(token))
   
   # Python virtual environments
   if (length(string) &&
       string[[1]] %in% c("use_virtualenv", "reticulate::use_virtualenv") &&
       numCommas[[1]] == 0)
   {
      return(.rs.getCompletionsPythonVirtualEnvironments(token))
   }
   
   # No information on completions other than token
   if (!length(string))
   {
      # If there was no token, give up
      if (!nzchar(token))
         return(.rs.emptyCompletions(excludeOtherCompletions = TRUE))
      
      # Otherwise, complete from the search path + available packages
      completions <- Reduce(.rs.appendCompletions, list(
         .rs.getCompletionsSearchPath(token),
         .rs.getCompletionsNAMESPACE(token, documentId),
         .rs.getCompletionsPackages(token, TRUE),
         .rs.getCompletionsActiveFrame(token, envir),
         .rs.getCompletionsLibraryContext(token,
                                          string,
                                          context,
                                          numCommas,
                                          functionCall,
                                          documentId,
                                          envir)
      ))
      
      # remove all queries that start with a '.' unless the
      # token itself starts with a dot
      if (!.rs.startsWith(token, "."))
      {
         startsWithDot <- .rs.startsWith(completions$results, ".")
         completions <- .rs.subsetCompletions(completions, which(!startsWithDot))
      }
      
      # try completing from the source index if this is an
      # R file within a package
      if (.rs.isRScriptInPackageBuildTarget(filePath))
      {
         # get the active package
         pkgName <- .rs.packageNameForSourceFile(filePath)
         completions <- .rs.appendCompletions(
            completions,
            .rs.getCompletionsActivePackage(token, pkgName)
         )
      }
      
      # Ensure case-sensitive matches come first.
      return(.rs.sortCompletions(completions, token))
   }
   
   # transform 'install.packages' to 'utils::install.packages' to avoid
   # getting arguments from the RStudio hook
   if ("install.packages" %in% string[[1]])
   {
      fn <- .rs.getAnywhere("install.packages", envir)
      if (is.function(fn) && identical(names(formals(fn)), "..."))
      {
         string[[1]] <- "utils::install.packages"
      }
   }
   
   # library, require, requireNamespace, loadNamespace
   if (string[[1]] %in% c("library", "require", "requireNamespace") &&
       numCommas[[1]] == 0)
   {
      quote <- !(string[[1]] %in% c("library", "require"))
      return(.rs.getCompletionsPackages(token, 
                                        excludeOtherCompletions = TRUE,
                                        quote = quote))
   }
   
   ## File-based completions
   if (.rs.acContextTypes$FILE %in% context)
   {
      whichIndex <- which(context == .rs.acContextTypes$FILE)
      
      tokenToUse <- string[[whichIndex]]
      
      directoriesOnly <- FALSE
      if (length(string) > whichIndex && .rs.isDirectoryOnlyCompletionFunction(string[[whichIndex + 1]]))
      {
         directoriesOnly <- TRUE
      }
      
      # NOTE: For Markdown link completions, we overload the meaning of the
      # function call string here, and use it as a signal to generate paths
      # relative to the R markdown path.
      isNotebook <- .rs.endsWith(tolower(filePath), ".rmd") ||
         .rs.endsWith(tolower(filePath), ".qmd")
      
      path <- NULL
      
      # if in an Rmd file, ask it for its desired working dir (can be changed
      # with the knitr root.dir option)
      if (isNotebook)
      {
         path <- .Call("rs_getNotebookWorkingDir", filePath, documentId)
      }
      
      if (is.null(path) && isNotebook)
      {
         # for R Markdown documents without an explicit working dir,
         # use preferences instead
         path <- .rs.markdown.resolveCompletionRoot(filePath)
      }
      
      if (is.null(path))
      {
         # in all other cases, use the current working directory for
         # completions
         path <- getwd()
      }
      
      return(.rs.getCompletionsFile(token = tokenToUse,
                                    path = path,
                                    quote = FALSE,
                                    directoriesOnly = directoriesOnly))
   }
   
   # Shiny completions
   
   ## Completions for server.r (from ui.r)
   if (context[[1]] %in% c(.rs.acContextTypes$DOLLAR,
                           .rs.acContextTypes$DOUBLE_BRACKET) &&
       tolower(basename(filePath)) == "server.r" &&
       string[[1]] %in% c("input", "output"))
   {
      completions <- .rs.getCompletionsFromShinyUI(token, filePath, string[[1]], context[[1]])
      if (!is.null(completions))
         return(completions)
   }
   
   ## Completions for server.r, on session
   if (context[[1]] == .rs.acContextTypes$DOLLAR &&
       tolower(basename(filePath)) == "server.r" &&
       string[[1]] == "session")
   {
      completions <- .rs.getCompletionsShinySession(token)
      if (!is.null(completions))
         return(completions)
   }
   
   ## Completions for ui.r (from server.r)
   if (context[[1]] == .rs.acContextTypes$FUNCTION &&
       tolower(basename(filePath)) == "ui.r" &&
       numCommas[[1]] == 0 &&
       .rs.mightBeShinyFunction(string[[1]]))
   {
      completions <- .rs.getCompletionsFromShinyServer(token, filePath, string[[1]], context[[1]])
      if (!is.null(completions))
         return(completions)
   }
   
   ## Other special cases (but we may still want completions from
   ## other contexts)
   triedGgplot2Completions <- FALSE
   didGetFunctionCompletions <- FALSE
   
   # attr
   completions <- if (string[[1]] == "attr")
   {
      .rs.getCompletionsAttr(token, functionCall, envir)
   }
   
   # getOption
   else if (string[[1]] == "getOption" && numCommas[[1]] == 0)
   {
      .rs.getCompletionsGetOption(token)
   }
   
   # options
   else if (string[[1]] == "options" && context[[1]] == .rs.acContextTypes$FUNCTION)
   {
      .rs.getCompletionsOptions(token)
   }
   
   # ggplot2
   else if (is.call(functionCall))
   {
      lhs <- functionCall[[1L]]
      if (is.symbol(lhs))
      {
         lhs <- as.character(lhs)
         if (lhs %in% c("aes") || grepl("^facet_", lhs))
         {
            triedGgplot2Completions <- TRUE
            didGetFunctionCompletions <- TRUE
            completions <- tryCatch(
               .rs.getCompletionsGgplot2(line, token, contextData, statementBounds, documentId, envir),
               error = function(e) {
                  didGetFunctionCompletions <<- FALSE
                  .rs.emptyCompletions(token)
               }
            )
         }
      }
   }
   
   if (is.null(completions))
      completions <- .rs.emptyCompletions(token)
   
   ## If we are getting completions from a '$', '@', '::' or ':::' then we do not
   ## want to look for completions in other contexts
   # dollar context
   dontLookBack <- length(context) && context[[1]] %in% c(
      .rs.acContextTypes$DOLLAR, .rs.acContextTypes$AT,
      .rs.acContextTypes$NAMESPACE_EXPORTED,
      .rs.acContextTypes$NAMESPACE_ALL
   )
   
   if (dontLookBack)
   {
      # dollar context
      if (context[[1]] %in% c(.rs.acContextTypes$DOLLAR, .rs.acContextTypes$AT))
      {
         completions <- .rs.getCompletionsDollar(
            token,
            string[[1]],
            functionCall,
            envir,
            context[[1]] == .rs.acContextTypes$AT
         )
      }
      
      # namespace context
      else if (context[[1]] %in% c(.rs.acContextTypes$NAMESPACE_EXPORTED,
                                   .rs.acContextTypes$NAMESPACE_ALL))
      {
         completions <- .rs.getCompletionsNamespace(
            token,
            string[[1]],
            context[[1]] == .rs.acContextTypes$NAMESPACE_EXPORTED,
            envir
         )
      }
   }
   
   # otherwise, look through the contexts and pick up completions
   else
   {
      for (i in seq_along(string))
      {
         # Don't provide function completions if we just provided
         # argument name completions
         stopGeneratingCompletions <-
            i > 1 &&
            context[[i]] == .rs.acContextTypes$FUNCTION &&
            context[[i - 1]] == .rs.acContextTypes$ARGUMENT
         
         if (stopGeneratingCompletions)
            break
         
         # Ignore completions from the 'aes()' function if we've
         # already tried to retrieve more relevant aesthetics
         skipFunctionCompletions <-
            triedGgplot2Completions &&
            context[[i]] == .rs.acContextTypes$FUNCTION &&
            string[[i]] %in% "aes"
         
         if (skipFunctionCompletions)
            next
         
         # Only retrieve function completions for the 'nearest'
         # function in the stack
         if (context[[i]] == .rs.acContextTypes$FUNCTION)
         {
            if (didGetFunctionCompletions)
               next
            
            didGetFunctionCompletions <- TRUE
         }
         
         completions <- .rs.appendCompletions(
            completions,
            .rs.getRCompletions(token,
                                i, 
                                string[[i]],
                                context[[i]],
                                numCommas[[i]],
                                functionCall,
                                completions$excludeOtherCompletions,
                                documentId,
                                envir)
         )
      }
   }
   
   ## If the caller has supplied information about chain completions (e.g.
   ## for completions from
   ##
   ##    x %>% foo() %>% bar()
   ##
   ## then retrieve those completions.
   ## unless it's a group_by() completion which has been dealt with already
   if (!(context[[1]] == .rs.acContextTypes$FUNCTION && string[[1]] == "group_by"))
   {
      completions <- .rs.appendCompletions(
         completions,
         .rs.getRChainCompletions(token,
                                  chainObjectName,
                                  additionalArgs,
                                  excludeArgs,
                                  excludeArgsFromObject,
                                  envir)
      )
   }
   
   # get completions from the search path for the 'generic' contexts
   if (token != "" &&
       context[[1]] %in% c(.rs.acContextTypes$UNKNOWN,
                           .rs.acContextTypes$FUNCTION,
                           .rs.acContextTypes$ARGUMENT,
                           .rs.acContextTypes$SINGLE_BRACKET,
                           .rs.acContextTypes$DOUBLE_BRACKET))
   {
      completions <- Reduce(.rs.appendCompletions, list(
         completions,
         .rs.getCompletionsSearchPath(token),
         .rs.getCompletionsNAMESPACE(token, documentId),
         .rs.getCompletionsActiveFrame(token, envir),
         .rs.getCompletionsLibraryContext(token,
                                          string[[1]],
                                          context[[1]],
                                          numCommas[[1]],
                                          functionCall,
                                          documentId,
                                          envir)
      ))
      
      if (.rs.isRScriptInPackageBuildTarget(filePath))
      {
         pkgName <- .rs.packageNameForSourceFile(filePath)
         completions <- .rs.appendCompletions(
            completions,
            .rs.getCompletionsActivePackage(token, pkgName)
         )
      }
   }
   
   ## Package completions (e.g. `stats::`)
   if (token != "" && .rs.acContextTypes$UNKNOWN %in% context)
      completions <- .rs.appendCompletions(
         completions,
         .rs.getCompletionsPackages(token, TRUE)
      )
   
   ## Override param insertion if the function was 'debug' or 'trace'
   for (i in seq_along(context))
   {
      if (context[[i]] %in% c(.rs.acContextTypes$FUNCTION, .rs.acContextTypes$UNKNOWN))
      {
         ## Exclude certain functions
         if (string[[i]] %in% c("help", "str", "args", "debug", "debugonce", "trace"))
         {
            completions$overrideInsertParens <- .rs.scalar(TRUE)
         }
         else
         {
            ## Exclude based on formals of the function
            object <- .rs.getAnywhere(string[[i]], envir)
            if (is.function(object))
            {
               argNames <- .rs.getFunctionArgumentNames(object)
               if (any(c("f", "fun", "func") %in% tolower(gsub("[^a-zA-Z]", "", argNames))))
                  completions$overrideInsertParens <- .rs.scalar(TRUE)
            }
         }
      }
   }
   
   completions <- .rs.sortCompletions(completions, token)
   
   completions$token <- token
   completions
   
})

.rs.addFunction("getTextRange", function(contents, range)
{
   # extract text from the rows in use
   rows <- seq(from = range$start$row, to = range$end$row)
   inner <- contents[rows]
   n <- length(inner)
   
   # subset based on provided columns
   if (n == 1L)
   {
      inner[[1L]] <- substring(
         inner[[1L]],
         range$start$column,
         range$end$column
      )
   }
   else
   {
      inner[[1L]] <- substring(inner[[1L]], range$start$column)
      inner[[n]] <- substring(inner[[n]], 1L, range$end$column)
   }
   
   # return collapsed text
   paste(inner, collapse = "\n")
})

.rs.addFunction("ggplot2.defaultAesthetics", function()
{
   c("x", "y", "fill", "colour", "alpha", "shape", "size", "linewidth", "linetype", "group")
})

.rs.addFunction("getCompletionsGgplot2", function(line,
                                                  token,
                                                  contextData,
                                                  statementBounds,
                                                  documentId,
                                                  envir)
{
   # get document contents
   contents <- ""
   if (nzchar(documentId))
   {
      document <- .rs.getSourceDocument(documentId, TRUE)
      contents <- strsplit(document$contents, "\n", fixed = TRUE)[[1L]]
   }
   else
   {
      contents <- line
   }
   
   # the data object associated with the aes() call, if any
   data <- NULL
   
   # search for a context relating to a geom_ invocation
   geomContext <- NULL
   for (i in seq_along(contextData))
   {
      if (grepl("(?:^|::)facet_", contextData[[i]]$data))
      {
         break
      }
      else if (grepl("(?:^|::)geom_", contextData[[i]]$data))
      {
         geomContext <- contextData[[i]]
         break
      }
   }
   
   # if we have a geom context, check it for a data argument
   if (!is.null(geomContext))
   {
      geomText <- .rs.getTextRange(contents, geomContext$range)
      geomCall <- parse(text = .rs.finishExpression(geomText))[[1L]]
      if ("data" %in% names(geomCall))
         data <- geomCall[["data"]]
   }
   
   # if we don't have a data argument, check if we can extract it
   # from the current statement being evaluated
   if (is.null(data))
   {
      # get current call
      currentStatement <- .rs.getTextRange(contents, statementBounds)
      currentCall <- parse(text = .rs.finishExpression(currentStatement))[[1L]]
      
      # find the top-most call in the hierarchy
      while (identical(currentCall[[1L]], as.symbol("+")))
         currentCall <- currentCall[[2L]]
      
      while (identical(currentCall[[1L]], as.symbol("<<-")) ||
             identical(currentCall[[1L]], as.symbol("<-")) ||
             identical(currentCall[[1L]], as.symbol("=")))
      {
         currentCall <- currentCall[[3L]]
      }
      
      # check for a data argument
      data <- currentCall[["data"]]
      if (is.null(data) && length(currentCall) >= 2L)
         data <- currentCall[[2L]]
   }
   
   # if 'data' is a call, check the contents to see if this is a plain pipe usage
   if (is.call(data))
   {
      .rs.tryCatch({
         newlineIndex <- regexpr("\n", currentStatement, fixed = TRUE)
         firstLine <- substring(currentStatement, 1L, newlineIndex - 1L)
         firstLine <- gsub("\\|\\>\\s*(?:#|$)", "", firstLine, perl = TRUE)
         firstLine <- gsub("%[^%]+%\\s*(?:#|$)", "", firstLine, perl = TRUE)
         firstCall <- parse(text = .rs.finishExpression(firstLine))[[1L]]
         if (is.call(firstCall) && length(firstCall) == 3L)
            firstCall <- firstCall[[2L]]
         if (is.symbol(firstCall))
            data <- firstCall
      })
   }
   
   # NOTE: We use 'eval()' here to ensure that things like datasets
   # are properly resolved; e.g. if working with mtcars from the datasets package.
   value <- NULL
   if (is.symbol(data))
   {
      source <- .rs.deparse(data)
      value <- eval(data, envir = envir)
      if (inherits(value, "gg"))
         value <- value$data
   }
   
   
   # check whether we should complete aesthetic names in this context
   completions <- .rs.emptyCompletions(token)
   
   # skip arguments on context stack
   includeAestheticNames <-
      "aes" %in% contextData[[1L]]$data &&
      .rs.acContextTypes$FUNCTION %in% contextData[[1L]]$type
   
   if (includeAestheticNames && requireNamespace("ggplot2", quietly = TRUE))
   {
      if (is.null(geomContext))
      {
         aestheticNames <- .rs.ggplot2.defaultAesthetics()
         aestheticSource <- "ggplot2"
      }
      else
      {
         geomName <- geomContext$data
         parts <- strsplit(geomName, ":{2,3}")[[1L]]
         if (length(parts) == 2L)
         {
            geomName <- parts[[2L]]
            envir <- asNamespace(parts[[1L]])
         }
         
         ggplot2 <- asNamespace("ggplot2")
         geomFunc <- if (exists(geomName, envir = envir))
            eval(as.symbol(geomName), envir = envir)
         else if (exists(geomName, envir = ggplot2))
            eval(as.symbol(geomName), envir = ggplot2)
            
         layerInfo <- geomFunc()
         aesthetics <- c(
            layerInfo$geom$required_aes,
            layerInfo$stat$required_aes,
            names(layerInfo$geom$default_aes),
            names(layerInfo$stat$default_aes),
            "group"
         )
         
         aestheticNames <- unlist(strsplit(aesthetics, "|", fixed = TRUE))
         aestheticNames <- aestheticNames[!duplicated(aestheticNames)]
         aestheticSource <- geomName
      }
      
      # exclude argument names which already been used
      .rs.tryCatch({
         aesRange <- contextData[[1]]$range
         aesText <- .rs.getTextRange(contents, aesRange)
         aesCall <- parse(text = aesText)[[1L]]
         aestheticNames <- setdiff(aestheticNames, names(aesCall))
      })
      
      results <- .rs.selectFuzzyMatches(aestheticNames, token)
      if (length(results))
      {
         completions <- .rs.makeCompletions(
            token = token,
            results = paste(results, "= "),
            packages = aestheticSource,
            type = .rs.acCompletionTypes$ARGUMENT,
            quote = FALSE
         )
      }
   }
   
   # now, add on completions from the source data object
   if (!is.null(value))
   {
      completions <- .rs.appendCompletions(
         completions,
         .rs.makeCompletions(
            token = token,
            results = .rs.selectFuzzyMatches(names(value), token),
            quote = FALSE,
            type = .rs.acCompletionTypes$COLUMN,
            packages = source,
            excludeOtherCompletions = TRUE,
            excludeOtherArgumentCompletions = TRUE
         )
      )
   }
   
   completions
   
})

.rs.addFunction("hasColumns", function(object)
{
   if (inherits(object, c("data.frame", "tbl")))
      return(TRUE)
   
   arrow <-
      isNamespaceLoaded("arrow") &&
      inherits(object, c("ArrowTabular", "Dataset", "arrow_dplyr_query"))
   
   if (arrow)
      return(TRUE)
   
   FALSE
})

.rs.addFunction("getRChainCompletions", function(token,
                                                 chainObjectName,
                                                 additionalArgs,
                                                 excludeArgs,
                                                 excludeArgsFromObject,
                                                 envir)
{
   result <- .rs.emptyCompletions()
   
   # chainObjectName will be provided if the client detected
   # that we were performing completions within an e.g.
   # `%>%` chain -- use completions from the associated data object.
   if (is.null(chainObjectName))
      return(result)
   
   # prevent evaluation of data.table `[` calls, e.g.
   # 
   #     dt[, y := 2] %>% ... %>% filter()
   if (.rs.isDataTableExtractCall(chainObjectName, envir = envir))
      return(result)
   
   object <- .rs.getAnywhere(chainObjectName, envir = envir)
   
   if (inherits(object, "python.builtin.object"))
      return(result)
   
   # additional completions from the client, e.g. rename(a = <...>)
   if (length(additionalArgs))
   {
      additionalArgsCompletions <- .rs.makeCompletions(
         token = token,
         results = .rs.selectFuzzyMatches(additionalArgs, token),
         packages = paste0(chainObjectName, " %>% ..."),
         type = .rs.acCompletionTypes$COLUMN
      )
      result <- .rs.appendCompletions(result, additionalArgsCompletions)
   }
   
   if (!excludeArgsFromObject && .rs.hasColumns(object))
   {
      columnCompletions <- .rs.makeCompletions(
         token = token,
         results = .rs.selectFuzzyMatches(setdiff(.rs.getNames(object), additionalArgs), token),
         packages = chainObjectName,
         quote = FALSE,
         type = .rs.acCompletionTypes$COLUMN
      )
      result <- .rs.appendCompletions(result, columnCompletions)
   }
   
   if (length(excludeArgs))
   {
      indices <- which(!(result$results %in% excludeArgs))
      result <- .rs.subsetCompletions(result, indices)
   }
   
   result
   
})

.rs.addFunction("getRCompletions", function(token,
                                            index,
                                            string,
                                            context,
                                            numCommas,
                                            functionCall,
                                            excludeOtherCompletions,
                                            documentId,
                                            envir)
{
   completions <- if (context == .rs.acContextTypes$FUNCTION)
      .rs.getCompletionsFunction(token, string, functionCall, numCommas, envir)
   else if (context == .rs.acContextTypes$ARGUMENT)
      .rs.getCompletionsArgument(token, string, functionCall, envir)
   else if (context == .rs.acContextTypes$SINGLE_BRACKET)
      .rs.getCompletionsSingleBracket(token, string, functionCall, numCommas, index, envir)
   else if (context == .rs.acContextTypes$DOUBLE_BRACKET)
      .rs.getCompletionsDoubleBracket(token, string, functionCall, envir)
   else
      .rs.emptyCompletions()
   
   if (index == 1L && !excludeOtherCompletions)
   {
      libraryContextCompletions <- .rs.getCompletionsLibraryContext(token, string, context, numCommas, functionCall, documentId, envir)
      
      # prefer argument completions from libraryContextCompletions
      # because it contains the package name too
      if (any(libraryContextCompletions$type == .rs.acCompletionTypes$ARGUMENT)) 
      {
         completions <- .rs.subsetCompletions(completions, completions$type != .rs.acCompletionTypes$ARGUMENT)
      }
      completions <- .rs.appendCompletions(completions, libraryContextCompletions)
   }
   completions
})

.rs.addFunction("getCompletionsCustomHelpHandler", function(token, scope)
{
   custom <- .rs.findCustomHelpContext(scope, "help_formals_handler")
   if (is.null(custom))
      return(NULL)
   
   formals <- .rs.tryCatch(custom$handler(custom$topic, custom$source))
   if (inherits(formals, "error"))
      return(NULL)
   
   if (length(formals) == 0L)
      return(.rs.emptyCompletions(excludeOtherCompletions = TRUE))
   
   completions <- paste(formals$formals, sep = "= ")
   .rs.makeCompletions(
      token                   = token,
      results                 = .rs.selectFuzzyMatches(completions, token),
      packages                = scope,
      type                    = .rs.acCompletionTypes$ARGUMENT,
      excludeOtherCompletions = TRUE,
      helpHandler             = formals$helpHandler, 
      context                 = .rs.acContextTypes$FUNCTION
   )
})

## NOTE: This is a modified version of 'matchAvailableTopics'
## in 'completions.R' of the R sources.
.rs.addFunction("getCompletionsHelp", function(token,
                                               quote = FALSE)
{
   ## Attempt to find the help topic item in the local
   ## cache, as reading files from disk multiple times
   ## could be slow
   pkgCacheName <- ".completions.attachedPackagesCache"
   helpTopicsName <- ".completions.helpTopics"
   
   attachedPackagesCache <- tryCatch(
      get(pkgCacheName, envir = .rs.toolsEnv()),
      error = function(e) character()
   )
   
   ## If the current search paths have changed, invalidate
   ## the cache and update our aliases
   paths <- searchpaths()[substring(search(), 1, 8) == "package:"]
   if (!identical(basename(paths), attachedPackagesCache))
   {
      assign(pkgCacheName,
             basename(paths),
             envir = .rs.toolsEnv())
      
      # Get the set of help topics
      topics <- lapply(paths, .rs.readAliases)
      names(topics) <- basename(paths)
      
      assign(helpTopicsName,
             topics,
             envir = .rs.toolsEnv())
   }
   
   aliases <- get(helpTopicsName, envir = .rs.toolsEnv())
   
   ## If the token is of the form `<pkg>::<topic>`,
   ## then attempt to get the topic 'topic' for that
   ## package.
   if (regexpr(":{2,3}", token, perl = TRUE) != -1)
   {
      splat <- strsplit(token, ":{2,3}", perl = TRUE)[[1]]
      pkg <- splat[[1]]
      
      token <- if (length(splat) > 1)
         splat[[2]]
      else
         ""
      
      ## If the help topics for this package have not been loaded,
      ## explicitly load and save them now.
      if (!(pkg %in% names(aliases)))
      {
         pkgPath <- tryCatch(
            find.package(pkg, quiet = TRUE),
            error = function(e) NULL
         )
         
         if (!is.null(pkgPath))
         {
            aliases[[pkg]] <- .rs.readAliases(pkgPath)
            assign(helpTopicsName, aliases, envir = .rs.toolsEnv())
         }
      }
      
      # filter the aliases list to just this package
      aliases <- aliases[names(aliases) %in% pkg]
   }
   
   filtered <- lapply(aliases, function(alias) {
      .rs.selectFuzzyMatches(alias, token)
   })
   
   listed <- .rs.namedVectorAsList(filtered)
   
   completions <- .rs.makeCompletions(
      token                = token,
      results              = listed$values,
      packages             = listed$names,
      quote                = quote,
      type                 = .rs.acCompletionTypes$HELP,
      overrideInsertParens = TRUE, 
      context              = .rs.acContextTypes$HELP
   )
   
   .rs.sortCompletions(completions, token)
   
})

.rs.addFunction("readDevAliases", function(path)
{
   meta <- pkgload::dev_meta(basename(path))
   if (!is.null(meta))
      return(pkgload:::dev_topic_index(path))
})

.rs.addFunction("readAliases", function(path)
{
   if (!length(path))
      return(character())
   
   # Check for packages loaded via devtools::load_all()
   devIndex <- .rs.tryCatch(.rs.readDevAliases(path))
   if (is.character(devIndex))
      return(names(devIndex))
   
   # Otherwise, read aliases directly
   aliasesPath <- file.path(path, "help/aliases.rds")
   if (file.exists(aliasesPath))
      names(readRDS(aliasesPath))
   else
      character()
})

.rs.addFunction("getCompletionsActivePackage", function(token, pkgName)
{
   # Get completions from the source index
   sourceIndexCompletions <- .rs.getSourceIndexCompletions(token)
   
   # format completions for return to R
   if (!length(sourceIndexCompletions$completions))
   {
      completions <- .rs.emptyCompletions()
   }
   else
   {
      results <- sourceIndexCompletions$completions
      
      # TODO: more granular lookup on the object type for source index completions
      type <- ifelse(sourceIndexCompletions$isFunction,
                     .rs.acCompletionTypes$FUNCTION,
                     .rs.acCompletionTypes$UNKNOWN)
      
      completions <- .rs.makeCompletions(token = token,
                                         results = results,
                                         packages = pkgName,
                                         quote = FALSE,
                                         type = type)
   }
   
   # get completions from the imports of the package
   importCompletions <- tryCatch(
      getNamespaceImports(asNamespace(pkgName)),
      error = function(e) NULL
   )
   
   # workaround for devtools::load_all() clobbering the
   # namespace imports
   if (length(importCompletions) && is.null(names(importCompletions))) {
      try({
         env <- new.env(parent = emptyenv())
         for (el in importCompletions) {
            # Length one element: get all exports from that package
            if (length(el) == 1) {
               env[[el]] <- c(env[[el]], getNamespaceExports(asNamespace(el)))
            }
            
            # Length >1 element: 'importFrom()'.
            else if (length(el) > 1) {
               env[[el]] <- c(env[[el]], tail(el, n = -1))
            }
         }
         importCompletions <- as.list(env)
      }, silent = TRUE)
   }
   
   # remove 'base' element if it's just TRUE
   if (length(importCompletions))
   {
      if (isTRUE(importCompletions[["base"]]))
         importCompletions$base <- NULL
   }
   
   # if we have import completions, use them
   if (length(importCompletions) && !is.null(names(importCompletions)))
   {
      importCompletionsList <- .rs.namedVectorAsList(importCompletions)
      
      # filter completions
      indices <- .rs.fuzzyMatches(importCompletionsList$values, token)
      importCompletionsList <- lapply(importCompletionsList, function(x) {
         x[indices]
      })
      
      objects <- lapply(seq_along(importCompletionsList$values), function(i) {
         
         tryCatch(
            expr = get(importCompletionsList$values[[i]],
                       envir = asNamespace(importCompletionsList$names[[i]])),
            error = function(e) NULL
         )
      })
      
      type <- vapply(objects, FUN.VALUE = numeric(1), USE.NAMES = FALSE, .rs.getCompletionType)
      
      completions <- .rs.appendCompletions(
         completions,
         .rs.makeCompletions(token = token,
                             results = importCompletionsList$values,
                             packages = paste("package:", importCompletionsList$names, sep = ""),
                             type = type)
      )
   }
   
   completions
   
})

.rs.addFunction("getCompletionsFromShinyServer", function(token, filePath, string, type)
{
   dir <- dirname(filePath)
   serverPath <- file.path(dir, "server.R")
   uiPath <- file.path(dir, "ui.R")
   name <- tolower(basename(filePath))
   
   if (!file.exists(serverPath))
      return(NULL)
   
   completions <- .rs.shinyServerCompletions(serverPath)
   results <- if (.rs.endsWith(string, "Input"))
      .rs.selectFuzzyMatches(completions$input, token)
   else
      .rs.selectFuzzyMatches(completions$output, token)
   
   return(.rs.makeCompletions(token = token,
                              results = results,
                              packages = serverPath,
                              quote = TRUE,
                              type = .rs.acCompletionTypes$CONTEXT,
                              excludeOtherCompletions = TRUE))
})

.rs.addFunction("getCompletionsFromShinyUI", function(token, filePath, string, type)
{
   dir <- dirname(filePath)
   serverPath <- file.path(dir, "server.R")
   uiPath <- file.path(dir, "ui.R")
   name <- tolower(basename(filePath))
   
   if (!file.exists(uiPath))
      return(NULL)
   
   completions <- .rs.shinyUICompletions(uiPath)
   results <- if (string == "input")
      .rs.selectFuzzyMatches(completions$input, token)
   else
      .rs.selectFuzzyMatches(completions$output, token)
   
   return(.rs.makeCompletions(token = token,
                              results = results,
                              packages = uiPath,
                              quote = type == .rs.acContextTypes$DOUBLE_BRACKET,
                              type = .rs.acCompletionTypes$CONTEXT,
                              excludeOtherCompletions = type == .rs.acContextTypes$DOLLAR))
})

.rs.addFunction("shinyUICompletions", function(file)
{
   # Check to see if we can re-use cached completions
   fileCacheName <- paste(file, "shinyUILastModifiedTime", sep = "-")
   completionsCacheName <- paste(file, "shinyUICompletions", sep = "-")
   
   info <- .rs.fileInfo(file)
   mtime <- info[1, "mtime"]
   if (identical(mtime, .rs.get(fileCacheName)) &&
       !is.null(.rs.get(completionsCacheName)))
   {
      return(.rs.get(completionsCacheName))
   }
   
   # Otherwise, get the completions
   parsed <- tryCatch(
      suppressWarnings(parse(file)),
      error = function(e) NULL
   )
   
   if (is.null(parsed))
      return(NULL)
   
   # We fill environments (since these can grow efficiently / by reference)
   inputEnv <- new.env(parent = emptyenv())
   outputEnv <- new.env(parent = emptyenv())
   
   inputCount <- new.env(parent = emptyenv())
   inputCount$count <- 1
   
   outputCount <- new.env(parent = emptyenv())
   outputCount$count <- 1
   
   shinyFunctions <- .rs.getInferredCompletions("shiny")$functions
   lapply(parsed, function(object) {
      .rs.doShinyUICompletions(object, inputEnv, outputEnv, inputCount, outputCount, shinyFunctions)
   })
   
   completions <- list(input = unlist(mget(objects(inputEnv), envir = inputEnv), use.names = FALSE),
                       output = unlist(mget(objects(outputEnv), envir = outputEnv), use.names = FALSE))
   
   .rs.assign(fileCacheName, mtime)
   .rs.assign(completionsCacheName, completions)
   
   completions
   
})

.rs.addFunction("extractFunctionNameFromCall", function(object)
{
   if (!is.call(object))
      return("")
   
   if (.rs.isSymbolCalled(object[[1]], "::") ||
       .rs.isSymbolCalled(object[[1]], ":::") ||
       (is.character(object[[1]]) && object[[1]] %in% c("::", ":::")))
   {
      if (length(object) > 2)
         return(as.character(object[[3]]))
      else
         return("")
   }
   
   if (is.character(object[[1]]) || is.symbol(object[[1]]))
      return(as.character(object[[1]]))
   
   if (is.call(object[[1]]))
      return(.rs.extractFunctionNameFromCall(object[[1]]))
   
   return("")
   
})

.rs.addFunction("doShinyUICompletions", function(object,
                                                 inputs,
                                                 outputs,
                                                 inputCount,
                                                 outputCount,
                                                 shinyFunctions)
{
   if (is.call(object) && length(object) > 1)
   {
      functionName <- .rs.extractFunctionNameFromCall(object)
      firstArgName <- if (is.character(object[[2]]) && length(object[[2]]) == 1)
         object[[2]]
      else
         ""
      
      if (nzchar(firstArgName))
      {
         functionArgs <- shinyFunctions[[functionName]]
         if ("outputId" %in% functionArgs || .rs.endsWith(functionName, "Output"))
         {
            outputCount$count <- outputCount$count + 1
            outputs[[as.character(outputCount$count)]] <- firstArgName
         }
         
         else if ("inputId" %in% functionArgs || .rs.endsWith(functionName, "Input"))
         {
            inputCount$count <- inputCount$count + 1
            inputs[[as.character(inputCount$count)]] <- firstArgName
         }
      }
      
      for (j in 2:length(object))
      {
         if (is.call(object[[j]]))
         {
            .rs.doShinyUICompletions(object[[j]],
                                     inputs,
                                     outputs,
                                     inputCount,
                                     outputCount,
                                     shinyFunctions)
         }
      }
   }
   
})

.rs.addFunction("shinyServerCompletions", function(file)
{
   # Check to see if we can re-use cached completions
   fileCacheName <- paste(file, "shinyServerLastModifiedTime", sep = "-")
   completionsCacheName <- paste(file, "shinyServerCompletions", sep = "-")
   
   info <- .rs.fileInfo(file)
   mtime <- info[1, "mtime"]
   if (identical(mtime, .rs.get(fileCacheName)) &&
       !is.null(.rs.get(completionsCacheName)))
   {
      return(.rs.get(completionsCacheName))
   }
   
   # Otherwise, get the completions
   parsed <- tryCatch(
      suppressWarnings(parse(file)),
      error = function(e) NULL
   )
   
   if (is.null(parsed))
      return(NULL)
   
   # We fill environments (since these can grow efficiently / by reference)
   inputEnv <- new.env(parent = emptyenv())
   outputEnv <- new.env(parent = emptyenv())
   
   inputCount <- new.env(parent = emptyenv())
   inputCount$count <- 1
   
   outputCount <- new.env(parent = emptyenv())
   outputCount$count <- 1
   
   lapply(parsed, function(object) {
      .rs.doShinyServerCompletions(object, inputEnv, outputEnv, inputCount, outputCount)
   })
   
   completions <- list(input = unlist(mget(objects(inputEnv), envir = inputEnv), use.names = FALSE),
                       output = unlist(mget(objects(outputEnv), envir = outputEnv), use.names = FALSE))
   
   .rs.assign(fileCacheName, mtime)
   .rs.assign(completionsCacheName, completions)
   
   completions
   
})

.rs.addFunction("doShinyServerCompletions", function(object,
                                                     inputs,
                                                     outputs,
                                                     inputCount,
                                                     outputCount)
{
   if (is.call(object))
   {
      operator <- as.character(object[[1]])
      if (length(object) == 3 && (operator == "$" || operator == "[["))
      {
         name <- if (is.symbol(object[[2]]))
            as.character(object[[2]])
         else if (is.character(object[[2]]) && length(object[[2]]) == 1)
            object[[2]]
         else
            ""
         
         value <- as.character(object[[3]])
         if (name == "output")
         {
            outputCount$count <- outputCount$count + 1
            outputs[[as.character(outputCount$count)]] <- .rs.stripSurrounding(value)
         }
         
         if (name == "input")
         {
            inputCount$count <- inputCount$count + 1
            inputs[[as.character(inputCount$count)]] <- .rs.stripSurrounding(value)
         }
      }
      
      if (length(object) > 1)
      {
         for (j in 2:length(object))
         {
            if (is.call(object[[j]]))
            {
               .rs.doShinyServerCompletions(object[[j]],
                                            inputs,
                                            outputs,
                                            inputCount,
                                            outputCount)
            }
         }
      }
   }
   
})

.rs.addFunction("getCompletionsShinySession", function(token)
{
   # Use cached completions if possible
   if (!is.null(results <- .rs.get("shinySessionCompletions")))
      return(results)
   
   # Get completions from shiny if available
   if (!("shiny" %in% loadedNamespaces()))
      return(NULL)
   
   # Check to see if this version of Shiny has a completions
   # function we can use
   completionGetter <- tryCatch(
      eval(call(":::", "shiny", "session_completions")),
      error = function(e) NULL
   )
   
   if (is.null(completionGetter))
      return(NULL)
   
   # Get the completions from Shiny
   completions <- tryCatch(
      completionGetter(),
      error = function(e) NULL
   )
   
   if (is.null(completions))
      return(NULL)
   
   # Ensure that this is a character vector
   if (!is.character(completions))
      return(NULL)
   
   # Return completions
   results <- .rs.selectFuzzyMatches(completions, token)
   output <- .rs.makeCompletions(token = token,
                                 results = results,
                                 type = .rs.acCompletionTypes$CONTEXT,
                                 excludeOtherCompletions = TRUE)
   
   # Cache for later use
   .rs.assign("shinySessionCompletions", output)
   
   output
   
})

# Get relevant completions for a particular argument, e.g. in
#
#   library(package = |)
#
# That is, if we're completing an argument called 'package', then infer
# that package names are an appropriate completion result.
.rs.addFunction("getCompletionsArgument", function(token,
                                                   activeArg,
                                                   functionCall = NULL,
                                                   envir = NULL)
{
   completions <- .rs.emptyCompletions()
   
   # data.table completions special case for single bracket + named argument case
   # dt[, by = |]
   if (identical(functionCall[[1]], quote(`[`))) 
   {
      # only consider the case where the data is a symbol (rule out calls)
      name <- functionCall[[2]]
      if (is.symbol(name)) 
      {
         name <- as.character(name)
         
         # and only consider data.table objects
         object <- try(.rs.getAnywhere(name, envir = envir))
         
         if (inherits(object, "data.table")) 
         {
            return(.rs.getDataTableNamedArgumentCompletions(
               token, 
               name = name, 
               object = object,
               activeArg = activeArg, 
               functionCall = functionCall
            ))
         }
      }
   }
   
   object <- if (!is.null(functionCall))
      .rs.resolveObjectFromFunctionCall(functionCall, envir)
   
   matchedCall <- if (!is.null(object))
      .rs.matchCall(object, functionCall)
   
   # Get completions from a data object name if the active argument is 'formula'.
   # Useful for formula incantations in e.g.
   #
   #    lm(|, data = mtcars)
   #
   # In this special case, we _override_ argument completions (since they
   # are often less interesting in this special case)
   if (.rs.startsWith(activeArg, "form") &&
       !is.null(matchedCall[["data"]]))
   {
      dataObject <- .rs.getAnywhere(matchedCall[["data"]])
      if (!is.null(dataObject))
      {
         dataNames <- .rs.getNames(dataObject)
         return(.rs.makeCompletions(
            token = token,
            results = .rs.selectFuzzyMatches(dataNames, token),
            quote = FALSE
         ))
      }
   }
   
   # Check for knitr chunk completions, if possible
   if ("knitr" %in% loadedNamespaces())
   {
      ns <- asNamespace("knitr")
      tryGet <- function(name, ns)
         tryCatch(get(name, envir = ns)$set, error = function(e) NULL)
      
      setter <- tryGet("opts_chunk", ns)
      if (identical(object, setter))
      {
         opts <- knitr:::opts_chunk_attr
         if (activeArg %in% names(opts))
         {
            # Options to fill in the various if statements
            foundCompletions <- FALSE
            results <- character()
            quote <- TRUE
            
            if (is.list(opts[[activeArg]]))
            {
               foundCompletions <- TRUE
               potentials <- unlist(opts[[activeArg]])
               results <- .rs.selectFuzzyMatches(potentials, token)
               quote <- TRUE
            }
            
            if (identical(opts[[activeArg]], "logical"))
            {
               foundCompletions <- TRUE
               potentials <- c(TRUE, FALSE)
               results <- .rs.selectFuzzyMatches(potentials, token)
               quote <- FALSE
            }
            
            if (foundCompletions)
               return(.rs.makeCompletions(token = token,
                                          type = .rs.acCompletionTypes$ARGUMENT,
                                          quote = quote,
                                          results = results))
         }
      }
   }
   
   # Get 'help', 'example' completions
   if (activeArg %in% "topic" &&
       (identical(object, utils::example) ||
        identical(object, utils::help)))
   {
      completions <- .rs.appendCompletions(
         completions,
         .rs.getCompletionsHelp(token, quote = TRUE)
      )
   }
   
   # Get package names for completions
   if (activeArg %in% c("pkg", "package"))
   {
      completions <- .rs.appendCompletions(
         completions,
         .rs.getCompletionsPackages(token = token,
                                    appendColons = FALSE,
                                    excludeOtherCompletions = FALSE)
      )
   }
   
   completions
})

.rs.addFunction("listInferredPackages", function(documentId)
{
   .Call("rs_listInferredPackages", documentId)
})

.rs.addFunction("getInferredCompletions", function(packages = character(),
                                                   simplify = TRUE)
{
   # get completions from database
   completionList <- .Call("rs_getInferredCompletions",
                           as.character(packages),
                           PACKAGE = "(embedding)")
   
   # append dataset completions on to export vector
   completionList <- lapply(completionList, function(completion) {
      datasetTypes <- rep.int(.rs.acCompletionTypes$DATASET, length(completion$datasets))
      completion$exports  <- c(completion$exports, completion$datasets)
      completion$types    <- c(completion$types, datasetTypes)
      completion$datasets <- NULL
      completion
   })
   
   # simplify if requested
   if (simplify && length(completionList) == 1)
      return(completionList[[1]])
   
   completionList
})

.rs.addFunction("getCompletionsLibraryContextArgumentNames", function(token,
                                                                      string,
                                                                      numCommas, 
                                                                      functionCall,
                                                                      completions)
{
   ## Figure out which package + args we actually want to use
   pkg <- NULL
   args <- NULL
   for (i in seq_along(completions))
   {
      if (string[[1]] %in% names(completions[[i]]$functions))
      {
         pkg <- names(completions)[[i]]
         args <- completions[[i]]$functions[[string[[1]]]]
         break
      }
   }
   
   # Bail if we couldn't find anything
   if (is.null(pkg))
      return(.rs.emptyCompletions())
   
   ## Make a dummy function to match a call against
   argsText <- paste(args, collapse = ", ")
   dummyFunction <- tryCatch(
      suppressWarnings(
         eval(parse(text = paste("function(", argsText, ") {}", sep = "")))
      ), error = function(e) NULL
   )
   if (is.null(dummyFunction))
      return(.rs.emptyCompletions())
   
   matchedCall <- .rs.matchCall(dummyFunction, functionCall, numCommas = numCommas)
   if (is.null(matchedCall))
      return(.rs.emptyCompletions())
   
   formals <- .rs.resolveFormals(token,
                                 dummyFunction,
                                 string[[1]],
                                 functionCall,
                                 matchedCall,
                                 envir = environment())
   
   # Protect against failure
   if (is.null(formals))
      return(.rs.emptyCompletions())
   
   results <- .rs.selectFuzzyMatches(formals$formals, token)
   if (length(results))
      results <- paste(results, "= ")
   
   .rs.makeCompletions(token = token,
                       results = results,
                       packages = paste(pkg, string[[1]], sep = "::"),
                       type = .rs.acCompletionTypes$ARGUMENT,
                       fguess = string[[1]])
})

.rs.addFunction("getCompletionsLibraryContext", function(token,
                                                         string,
                                                         context,
                                                         numCommas,
                                                         functionCall,
                                                         documentId,
                                                         envir)
{
   # Bail on null / empty documentId (necessary for e.g. the console)
   if (is.null(documentId) || !nzchar(documentId))
      return(.rs.emptyCompletions())
   
   ## If we detect that particular 'library' calls are in the source document,
   ## and those packages are actually available (but the package is not currently loaded),
   ## then we get an asynchronously-updated set of completions. We encode them as 'context'
   ## completions just so the user has a small hint that, even though we provide the
   ## completions, the package isn't actually loaded.
   packages <- .rs.listInferredPackages(documentId)
   if (!length(packages))
      return(.rs.emptyCompletions())
   
   # Remove any packages that are on the search path
   searchNames <- paste("package", packages, sep = ":")
   packages <- packages[!(searchNames %in% search())]
   
   if (!length(packages))
      return(.rs.emptyCompletions())
   
   completions <- .rs.getInferredCompletions(packages, simplify = FALSE)
   results <- .rs.emptyCompletions()
   
   # If we're getting completions for a particular function's arguments,
   # use those
   if (length(context) && context[[1]] == .rs.acContextTypes$FUNCTION)
   {
      results <- .rs.appendCompletions(
         results,
         .rs.getCompletionsLibraryContextArgumentNames(token,
                                                       string,
                                                       numCommas,
                                                       functionCall,
                                                       completions)
      )
   }
   
   # Add completions for exported items.
   results <- .rs.appendCompletions(
      results, 
      Reduce(.rs.appendCompletions, lapply(seq_along(completions), function(i) {
         
         completion <- completions[[i]]
         package <- names(completions)[[i]]
         
         keep <- .rs.fuzzyMatches(completion$exports, token)
         .rs.makeCompletions(token = token,
                             results = completion$exports[keep],
                             packages = package,
                             type = completion$types[keep])
      }))
   )
   
})

.rs.addFunction("isKnitrObject", function(object)
{
   if (!("knitr" %in% loadedNamespaces()))
      return(FALSE)
   
   ns <- asNamespace("knitr")
   if (identical(environment(object), ns))
      return(TRUE)
   
   parent <- tryCatch(
      parent.env(environment(object)),
      error = function(e) NULL
   )
   
   if (identical(parent, ns))
      return(TRUE)
   
   return(FALSE)
})

.rs.addJsonRpcHandler("transform_snippet", function(snippet)
{
   Encoding(snippet) <- "UTF-8"
   
   # Extract any R code from the snippet
   reRCode <- "`[Rr]\\s+[^`]+`"
   matches <- gregexpr(reRCode, snippet, perl = TRUE)[[1]]
   if (identical(c(matches), -1L))
      return(snippet)
   
   match.length <- attr(matches, "match.length")
   if (is.null(match.length))
      return(snippet)
   
   ranges <- lapply(seq_along(matches), function(i) {
      c(matches[[i]], matches[[i]] + match.length[[i]])
   })
   
   extracted <- lapply(ranges, function(range) {
      substring(
         snippet,
         range[[1]] + 2, # skip "`r "
         range[[2]] - 2 # leave out trailing "`"
      )
   })
   
   frame <- parent.frame()
   evaluated <- lapply(extracted, function(code) {
      tryCatch({
         captured <- capture.output(
            result <- paste(collapse = " ", as.character(suppressWarnings(
               eval(parse(text = code), envir = frame)
            )))
         )
         
         if (!length(result) && length(captured))
            paste(captured, collapse = " ")
         else
            result
         
      }, error = function(e) ""
      )
   })
   
   newSnippet <- snippet
   for (i in seq_along(evaluated))
   {
      range <- ranges[[i]]
      text <- substring(snippet, range[[1]], range[[2]] - 1)
      replacement <- evaluated[[i]]
      newSnippet <- gsub(text, replacement, newSnippet, fixed = TRUE)
   }
   
   .rs.scalar(newSnippet)
})

.rs.addFunction("isCustomCompletionsEnabled", function()
{
   completer <- utils::rc.getOption("custom.completer")
   is.function(completer)
})

.rs.addFunction("getCustomRCompletions", function(line)
{
   utils:::.assignLinebuffer(line)
   utils:::.assignEnd(nchar(line))
   token <- utils:::.guessTokenFromLine()
   utils:::.completeToken()
   results <- utils:::.retrieveCompletions()
   
   packages <- NULL
   type <- .rs.formCompletionVector(
      attr(results, "type"),
      .rs.acCompletionTypes$UNKNOWN,
      length(results)
   )
   
   if (type[[1]] %in% c(.rs.acCompletionTypes$UNKNOWN, .rs.acCompletionTypes$FUNCTION))
   {
      packages <- sub('^package:', '', .rs.which(results))
      
      # ensure spaces around =
      results <- sub("=$", " = ", results)
      
      choose <- packages == '.GlobalEnv'
      results <- c(results[choose], results[!choose])
      packages <- c(packages[choose], packages[!choose])
      type <- c(type[choose], type[!choose])
      
      packages <- sub('^\\.GlobalEnv$', '', packages)
   }
   
   .rs.makeCompletions(
      token = token,
      results = results,
      packages = packages,
      type = type
   )
})

#
# generate-commands-acessor.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

# Use stable project root for file paths
projectRoot <- here::here()
setwd(projectRoot)

# Find Commands.java
path <- "src/gwt/src/org/rstudio/studio/client/workbench/commands/Commands.java"
contents <- readLines(path, warn = FALSE)

# Pull out the AppCommand names
pattern <- "^\\s*public\\s+abstract\\s+AppCommand\\s+(\\w+).*$"
matchingLines <- grep(pattern, contents, perl = TRUE, value = TRUE)
commandNames <- gsub(pattern, "\\1", matchingLines, perl = TRUE)
commandInner <- paste(sprintf("   %1$s = \"%1$s\"", commandNames), collapse = ",\n")
commandCode <- paste("list(", commandInner, ")", sep = "\n")

# Generate code
generatedFileContents <- .rs.heredoc('
 #
 # AppCommands.R
 #
 # Copyright (C) %s by Posit Software, PBC
 #
 # Unless you have received this program directly from Posit Software pursuant
 # to the terms of a commercial license agreement with Posit Software, then
 # this program is licensed to you under the terms of version 3 of the
 # GNU Affero General Public License. This program is distributed WITHOUT
 # ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
 # MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
 # AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
 #
 
 #
 # This file was automatically generated -- please do not modify it by hand.
 # Generator: src/cpp/generate-commands-accessor.R
 #

 .rs.setVar("appCommands", %s)
 
', format(Sys.Date(), "%Y"), commandCode)

writeLines(generatedFileContents, con = "src/cpp/r/R/AppCommands.R")

# Test file for playing around with 'Rename in Scope'.
# Try activating the command on the various 'var's
# within this document and checking that the correct
# instances are selected.
var <- "outside"
env <- new.env(parent = emptyenv())
global <- function(var = "inside") {
  print(var)
  env$var <- 1
  nested <- function(var = "nested") {
    print(var)
  }
  print(var)
}
var

fn <- function() {
  var <- 1
  print(var)
  function(var) {
    var
  }
}

#
# test-api.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("rstudioapi")
test_that("invalid marker type generates informative error", {
   NULL_type <- list(type = NULL,
                     # 'file' would have to point to an actual R script to
                     # prevent the error 'The system cannot find the path
                     # specified' in normalizePath() in case of a valid 'type'.
                     file = file.path(".", "R", "fake_script.R"),
                     line = 1L,
                     column = 1L,
                     message = "Some message")
   char0_type <- NULL_type
   char0_type[["type"]] <- character(0)
   vector_type <- NULL_type
   vector_type[["type"]] <- c("warning", "error")
   
   expect_error(
      .rs.api.sourceMarkers(name = "with_NULL_type", markers = list(NULL_type)),
      regexp = "Invalid marker type", fixed = TRUE
   )
   
   expect_error(
      .rs.api.sourceMarkers(name = "with_char0_type", markers = list(char0_type)),
      regexp = "Invalid marker type", fixed = TRUE
   )
   
   expect_error(
      .rs.api.sourceMarkers(name = "with_vector_type", markers = list(vector_type)),
      regexp = "Invalid marker type", fixed = TRUE
   )
})

# Tests comments out until https://github.com/rstudio/rstudio/issues/12275 is resolved
# test_that("command callbacks are invoked", {
# 
#    # register a command callback
#    invoked <- 0
#    handle <- .rs.api.registerCommandCallback("insertChunk", function() {
#       invoked <<- invoked + 1
#    })
# 
#    expect_equal(invoked, 0)
# 
#    # record a command execution
#    .rs.invokeRpc("record_command_execution", "insertChunk")
# 
#    # this should invoke the callback once
#    expect_equal(invoked, 1)
# 
#    # record a second command execution
#    .rs.invokeRpc("record_command_execution", "insertChunk")
# 
#    # this should invoke the callback a second time
#    expect_equal(invoked, 2)
# 
#    # unregister the callback
#    .rs.api.unregisterCommandCallback(handle)
# 
#    # record a third command execution
#    .rs.invokeRpc("record_command_execution", "insertChunk")
# 
#    # the callback should not be invoked, so execution count should
#    # remain at 2
#    expect_equal(invoked, 2)
# })
# 
# test_that("command stream callbacks are invoked", {
#    # register a command stream callback
#    commands <- c()
#    handle <- .rs.api.registerCommandCallback("*", function(id) {
#       commands <<- c(commands, id)
#    })
# 
#    # record several command executions
#    .rs.invokeRpc("record_command_execution", "insertChunk")
#    .rs.invokeRpc("record_command_execution", "showHelpMenu")
#    .rs.invokeRpc("record_command_execution", "startJob")
# 
#    # ensure that the callback received all 3
#    expect_equal(commands, c("insertChunk", "showHelpMenu", "startJob"))
# 
#    # unregister the callback
#    .rs.api.unregisterCommandCallback(handle)
# 
#    # invoke one more command execution
#    .rs.invokeRpc("record_command_execution", "startProfiler")
# 
#    # this execution should not be received
#    expect_equal(commands, c("insertChunk", "showHelpMenu", "startJob"))
# })

#
# test-reticulate.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("reticulate")

test_that("RETICULATE_PYTHON environment variable is respected", {
   # save old value and set a dummy value
   oldPython <- Sys.getenv("RETICULATE_PYTHON")
   Sys.setenv(RETICULATE_PYTHON = "/opt/testthat/python")
   on.exit({
      # restore old value
      Sys.setenv(RETICULATE_PYTHON = oldPython)
   }, add = TRUE)

   # perform autodiscovery
   python <- .rs.inferReticulatePython()

   # we expect that since we set a custom value it'll be reflected
   expect_equal(python, Sys.getenv("RETICULATE_PYTHON"))
})

test_that("Python help topics accept only plain dotted names", {

   # legitimate help topics resolve to valid qualified names
   expect_true(.rs.python.isHelpTopicValid("numpy"))
   expect_true(.rs.python.isHelpTopicValid("os.path"))
   expect_true(.rs.python.isHelpTopicValid("pandas.DataFrame"))
   expect_true(.rs.python.isHelpTopicValid("_private.member"))

})

test_that("Python help topics reject code injection payloads", {

   # these would otherwise be evaluated as Python expressions
   expect_false(.rs.python.isHelpTopicValid("open('pwned.txt','w').write('RCE')"))
   expect_false(.rs.python.isHelpTopicValid("__import__('os').system('id')"))
   expect_false(.rs.python.isHelpTopicValid("os.system('id')"))
   expect_false(.rs.python.isHelpTopicValid("numpy.array(1)"))
   expect_false(.rs.python.isHelpTopicValid("a;b"))
   expect_false(.rs.python.isHelpTopicValid("a b"))
   expect_false(.rs.python.isHelpTopicValid("1abc"))
   expect_false(.rs.python.isHelpTopicValid(".leadingdot"))
   expect_false(.rs.python.isHelpTopicValid(""))

})

#
# test-pkg-deps.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("package dependencies")

test_that("package dependencies are discovered in R scripts", {
   contents <- paste(
      "library(ggplot2)",
      "require(dplyr)",
      "",
      "# Digest something",
      "digest::digest(something)", sep = "\n")
   packages <- .rs.parsePackageDependencies(contents, ".R")
   expect_equal(sort(packages), sort(c("ggplot2", "dplyr", "digest")))
})

test_that("package dependencies are discovered in R Markdown documents", {
   contents <- paste(
      "# This is a markdown header",
      "",
      "And here's a paragraph. Now, how about a code chunk?",
      "",
      "```{r}",
      "require(caret)",
      "",
      "# Knit something",
      "knitr::knit(something)", 
      "```",
      "", sep = "\n")
   packages <- .rs.parsePackageDependencies(contents, ".Rmd")
   expect_equal(sort(packages), sort(c("caret", "knitr")))
})


test_that("package dependencies are discovered in R Markdown YAML headers", {

   # simple YAML header naming a package
   contents <- paste(
      "---",
      "title: Test Doc 1",
      "output: flexdashboard::flex_dashboard",
      "---",
      "", sep = "\n")
   packages <- .rs.parsePackageDependencies(contents, ".Rmd")
   expect_equal(packages, "flexdashboard")

   # more complicated YAML header in which package name is used as a key
   contents <- paste(
      "---",
      "title: Test Doc 2",
      "output:",
      "  flexdashboard::flex_dashboard:",
      "    orientation: columns",
      "---",
      "", sep = "\n")
   packages <- .rs.parsePackageDependencies(contents, ".Rmd")
   expect_equal(packages, "flexdashboard")

   # runtime: shiny requires the shiny package
   contents <- paste(
      "---",
      "title: Test Doc 3",
      "output: flexdashboard::flex_dashboard",
      "runtime: shiny",
      "---",
      "", sep = "\n")
   packages <- .rs.parsePackageDependencies(contents, ".Rmd")
   expect_equal(sort(packages), sort(c("flexdashboard", "shiny")))

   # parameterized R Markdown also requires the shiny package (for parameter prompts/deployment)
   contents <- paste(
      "---",
      "title: Test Doc 4",
      "output: html_document",
      "params:",
      "  data: \"hawaii\"",
      "---",
      "", sep = "\n")
   packages <- .rs.parsePackageDependencies(contents, ".Rmd")
   expect_equal(packages, "shiny")
})

test_that("R scripts do not get treated like R Markdown docs", {
   # ensures that the --- YAML delimiters don't cause us to try to parse YAML inside R scripts
   contents <- paste(
      "require(ggplot2)",
      "require(yaml)",
      "",
      "# ---",
      "# This is a comment header: a long one, too.",
      "x <- 1",
      "y <- 2",
      "# ---",
      "",
      "", sep = "\n")
   packages <- .rs.parsePackageDependencies(contents, ".R")
   expect_equal(sort(packages), sort(c("ggplot2", "yaml")))
})

test_that("HTML comments are not treated like YAML delimiters", {
   contents <- paste(
      "",
      "<!--- html comment --->",
      "",
      "```{r}",
      "require(callr)",
      "require(crayon)",
      "```",
      "", sep = "\n")
   packages <- .rs.parsePackageDependencies(contents, ".Rmd")
   expect_equal(sort(packages), sort(c("callr", "crayon")))
})


test_that("Quarto files with no R chunks have no dependencies", {
   contents <- paste(
      "",
      "---",
      "title: Test Doc 5",
      "format: html",
      "editor: visual",
      "---",
      "```{python}",
      "import shiny",
      "```",
      "", sep = "\n")
   packages <- .rs.parsePackageDependencies(contents, ".qmd")
   expect_null(packages)
})

#
# test-data-import.R
#
# Copyright (C) 2026 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("data import")

test_that("assembleDataImport escapes column names against R code injection", {
   skip_if_not_installed("readr")

   # Each entry is a column name that, without escaping, would either escape
   # the cols() argument and inject a top-level call (the quote/paren case),
   # or break parse() outright (the backslash/newline cases).
   evilNames <- list(
      injection = 'foo"); .rs.injection.sentinel <- TRUE; readr::cols("',
      backslash = 'foo\\bar',
      newline   = 'foo\nbar'
   )

   for (evil in evilNames)
   {
      opts <- list(
         mode = "text",
         importLocation = "data.csv",
         delimiter = ",",
         columnDefinitions = list(
            list(
               name = evil,
               assignedType = "character",
               only = NULL,
               parseString = NULL,
               index = 0,
               rType = "character"
            )
         ),
         openDataViewer = FALSE
      )

      info <- .rs.assembleDataImport(opts)

      # The assembled previewCode must parse as a single top-level expression.
      # If the column name escapes the cols() argument, parse() yields multiple
      # expressions instead.
      parsed <- parse(text = info$previewCode)
      expect_length(parsed, 1L)

      # The single expression must be a call to readr::read_csv. R deparses
      # readr::read_csv as a 3-element call object: `::`, `readr`, `read_csv`.
      expect_equal(as.character(parsed[[1L]][[1L]]), c("::", "readr", "read_csv"))

      # The column name should round-trip: the col_types argument should contain
      # one named slot whose name equals the original (unescaped) malicious string.
      call <- parsed[[1L]]
      col_types <- call$col_types
      expect_false(is.null(col_types))
      expect_equal(names(eval(col_types)$cols), evil)
   }
})

test_that("assembleDataImport escapes character option values", {
   skip_if_not_installed("readr")

   # Same shape of test as the column-name case, but exercising the
   # "character" option-type path used for read_csv arguments such as `na`.
   evilValues <- list(
      injection = 'NA"); .rs.injection.sentinel <- TRUE; c("',
      backslash = 'na\\sentinel',
      newline   = 'na\nsentinel'
   )

   for (evil in evilValues)
   {
      opts <- list(
         mode = "text",
         importLocation = "data.csv",
         delimiter = ",",
         na = evil,
         openDataViewer = FALSE
      )

      info <- .rs.assembleDataImport(opts)

      parsed <- parse(text = info$previewCode)
      expect_length(parsed, 1L)
      expect_equal(as.character(parsed[[1L]][[1L]]), c("::", "readr", "read_csv"))

      # The na argument should round-trip to the original (unescaped) string.
      expect_equal(parsed[[1L]]$na, evil)
   }
})

test_that("assembleDataImport escapes locale option values", {
   skip_if_not_installed("readr")

   # Locale values reach the generated code via the "locale" option-type
   # branch, which formerly pasted the value into "..." with no escaping.
   evil <- 'UTC"); .rs.injection.sentinel <- TRUE; readr::locale("'

   opts <- list(
      mode = "text",
      importLocation = "data.csv",
      delimiter = ",",
      locale = list(
         dateName     = "en",
         dateFormat   = "%AD",
         timeFormat   = "%AT",
         decimalMark  = ".",
         groupingMark = ",",
         tz           = evil,
         encoding     = "UTF-8",
         asciify      = FALSE
      ),
      openDataViewer = FALSE
   )

   info <- .rs.assembleDataImport(opts)

   parsed <- parse(text = info$previewCode)
   expect_length(parsed, 1L)

   # The malicious tz value should round-trip in the parsed locale() call.
   # We inspect the AST rather than eval() since readr::locale validates
   # tz strings against the system tz database.
   localeCall <- parsed[[1L]]$locale
   expect_false(is.null(localeCall))
   expect_equal(localeCall$tz, evil)
})

test_that("assembleDataImport escapes import URLs in cache code", {
   skip_if_not_installed("readr")

   # When canCacheData is TRUE and importLocation is a URL, the assembled
   # importCode includes assignments such as `url <- "<importLocation>"`.
   # The URL must be encoded as an R string literal.
   evilUrl <- 'https://example.com/"); .rs.injection.sentinel <- TRUE; x <- c("data.csv'

   opts <- list(
      mode = "text",
      importLocation = evilUrl,
      delimiter = ",",
      canCacheData = TRUE,
      openDataViewer = FALSE
   )

   info <- .rs.assembleDataImport(opts)

   # importCode must parse as a sequence of top-level expressions; if the URL
   # escapes its string literal, parse() will reject the input.
   parsed <- parse(text = info$importCode)
   expect_gt(length(parsed), 0L)

   # Locate the `url <- "..."` assignment and confirm it round-trips.
   urlValue <- NULL
   for (expr in as.list(parsed))
   {
      if (is.call(expr) && identical(as.character(expr[[1L]]), "<-") &&
          identical(as.character(expr[[2L]]), "url"))
      {
         urlValue <- expr[[3L]]
         break
      }
   }
   expect_false(is.null(urlValue))
   expect_equal(urlValue, evilUrl)
})

#
# test-terminal.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("terminal")

test_that("terminal can be started and stopped", {
   
   terminalCountBefore <- length(.rs.api.terminalList())
   expect_gte(terminalCountBefore, 0)
   
   termId <- .rs.api.terminalCreate(caption = "Test Terminal", show = TRUE)
   while (!.rs.api.terminalRunning(termId)) {
      Sys.sleep(0.1)
   }
   expect_length(termId, 1)
   
   terminalCountAfter <- length(.rs.api.terminalList())
   expect_equal(terminalCountAfter, terminalCountBefore + 1)
   
   .rs.api.terminalKill(termId)
   terminalCountAfter <- length(.rs.api.terminalList())
   expect_equal(terminalCountAfter, terminalCountBefore)
})

#
# test-codetools.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

library(testthat)

context("codetools")

test_that(".rs.detectFreeVars() works as expected", {
   
   expect_equal(
      
      .rs.detectFreeVarsExpr({
         paste(apple + banana)
      }),
      
      c("apple", "banana")
      
   )
   
   expect_equal(
      
      .rs.detectFreeVarsExpr({
         base::paste(apple + banana)
      }),
      
      c("apple", "banana")
      
   )
   
   expect_equal(
      
      .rs.detectFreeVarsExpr({
         userDefinedFunction(apple, banana)
      }),
      
      c("userDefinedFunction", "apple", "banana")
      
   )
   
   expect_equal(
      
      .rs.detectFreeVarsExpr({
         for (i in 1:10) {
            print(i + j)
         }
      }),
      
      c("j")
      
   )
   
   expect_equal(
      
      .rs.detectFreeVarsExpr({
         udf <- function(apple, banana) {
            apple + banana + cherry + danish
         }
      }),
      
      c("cherry", "danish")
      
   )
   
   
})

test_that(".rs.CRANDownloadOptionsString() generates a valid R expression", {
   
   # restore options when done
   op <- options()
   on.exit(options(op), add = TRUE)
   
   # set up options used by download string
   options(
      repos = c(CRAN = "https://cran.rstudio.com"),
      download.file.method = "libcurl",
      download.file.extra = NULL,
      HTTPUserAgent = "dummy"
   )

   # create a dummy environment that makes it easier for us
   # to 'capture' the result of an options call
   envir <- new.env(parent = globalenv())
   envir[["options"]] <- base::list
   
   # check that we construct the right kind of R object after parse
   #
   # NOTE: we don't depend on the exact representation of the string as the
   # code returned by R's deparser might differ from version to version,
   # but should still produce the same result after evaluation
   string <- .rs.CRANDownloadOptionsString()
   actual <- eval(parse(text = string), envir = envir)
   for (item in c("repos", "download.file.method", "HTTPUserAgent"))
      expect_equal(actual[[item]], getOption(item))
   
   # https://github.com/rstudio/rstudio/issues/6597
   options(download.file.extra = "embedded 'quotes'")
   string <- .rs.CRANDownloadOptionsString()
   actual <- eval(parse(text = string), envir = envir)
   expect_equal(actual$download.file.extra, "embedded 'quotes'")
   
   # NOTE: double-quotes are translated to single-quotes here as
   # a workaround for issues with quotation of arguments when running
   # commands on Windows
   options(download.file.extra = "embedded \"quotes\"")
   string <- .rs.CRANDownloadOptionsString()
   actual <- eval(parse(text = string), envir = envir)
   expect_equal(actual$download.file.extra, "embedded 'quotes'")
   
})

test_that(".rs.CRANDownloadOptionsString() fills missing CRAN repo", {
   # read default CRAN URL from user preferences
   cran <- .rs.readUiPref("cran_mirror")$url

   # unset repos
   options(repos = NULL)

   # create dummy environment
   envir <- new.env(parent = globalenv())
   envir[["options"]] <- base::list

   # evaluate the download string and confirm that it contains the CRAN URL from user prefs
   string <- .rs.CRANDownloadOptionsString()
   actual <- eval(parse(text = string), envir = envir)
   expect_equal(unlist(actual[["repos"]]["CRAN"]), c(CRAN = cran))
})


test_that("HTML escaping escapes HTML entities", {
   fake_header <- "<h1>Not a real header.</h1>"

   escaped <- .rs.htmlEscape(fake_header)
   expect_false(grepl(escaped, "<"))
   expect_false(grepl(escaped, ">"))
})

test_that("heredoc trims trailing newlines + whitespace", {
   
   actual <- .rs.heredoc('
      c(
         person(
            "Jane", "Doe",
            email = "jane@example.com",
            role = c("aut", "cre")
         )
      )
   ')
   
   expected <- 'c(
   person(
      "Jane", "Doe",
      email = "jane@example.com",
      role = c("aut", "cre")
   )
)'
   
   expect_equal(actual, expected)
   
})

#
# test-s3-override.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("s3-override")

test_that("s3 methods can be overridden", {
   # create S3 object to print
   foo <- list(1, 2, 3)
   class(foo) <- "s3_test"

   # create override method
   answer <- function(x, ...) {
      return(c(42, 42))
   }
   
   # confirm that we get the base behavior by default
   expect_equal(c(1, 3), range(foo))

   # inject the override
   .rs.addS3Override("range.s3_test", answer)

   # confirm that the override has been applied
   expect_equal(c(42, 42), range(foo))

   # now remove the override and confirm that the base behavior has been restored
   .rs.removeS3Override("range.s3_test")
   expect_equal(c(1, 3), range(foo))
})

test_that("s3 overrides persist after package loads", {
   # create S3 object to print
   foo <- list(1, 1, 2, 3, 5)
   class(foo) <- "test_pkg"
   
   # create override method
   before <- function(x, ...) {
      return(c(0, 0))
   }

   # inject the override
   .rs.addS3Override("range.test_pkg", before)

   # confirm that the override has been applied
   expect_equal(before(foo), range(foo))

   # simulate a package load by replacing the S3 override with a different function
   after <- function(x, ...) {
      return(c(1, 1))
   }
   table <- .BaseNamespaceEnv[[".__S3MethodsTable__."]]
   assign("range.test_pkg", after, envir = table)

   # confirm that we're now using the "package" version (this will only happen in R >= 3.5)
   if (getRversion() >= "3.5")
      expect_equal(after(foo), range(foo))

   # reattach override and confirm the "before" version is restored
   .rs.reattachS3Overrides()
   expect_equal(before(foo), range(foo))

   # finally, remove the override; this should now restore the "package" version, not the base
   # version
   .rs.removeS3Override("range.test_pkg")
   expect_equal(after(foo), range(foo))
})

#
# test-document-apis.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("document API")

# TODO: These rely on client WaitFor methods, and so cannot be tested
test_that("insertText() handles various invocations", {
   
   skip("NYI")

   # Replace current selection
   .rs.api.insertText("foo")
   .rs.api.insertText(text = "foo")
   
   # Insert text at raw position (comment lines 3:5)
   .rs.api.insertText(Map(c, 3:5, 1), "#")
   
   # Insert text at raw ranges (uncomment lines 3:5)
   ranges <- Map(c, Map(c, 3:5, 1), Map(c, 3:5, 2))
   .rs.api.insertText(ranges, "")
   
   # Infinity is accepted
   .rs.api.insertText(c(Inf, 1), "# Hello\n")
   .rs.api.insertText(Inf, "# Hello\n")
   
})

#
# test-shiny.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("shiny")

test_that("shiny viewer type set by preference sticks", {
   # read the current value of the preference
   old <- .rs.api.readRStudioPreference("shiny_viewer_type")

   # set the viewer type to external browser (via pref)
   .rs.api.writeRStudioPreference("shiny_viewer_type", "browser")

   # set the viewer type to browser and verify that it was done as we requested
   .rs.setShinyViewerType("browser")
   expect_equal(.rs.getShinyViewerType(), "browser")

   # set the viewer type to external window (via pref)
   .rs.api.writeRStudioPreference("shiny_viewer_type", "window")

   # setting the type via the pref should trigger an update of the underlying R viewer function
   expect_equal(.rs.getShinyViewerType(), "window")

   # restore old value
   .rs.api.writeRStudioPreference("shiny_viewer_type", old)
})

#
# test-lists.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("lists")

test_that("lists converted to scalars", {
   input <- list(1, 2, 3)
   expect_equal(.rs.scalarListFromList(input), 
                list(.rs.scalar(1), .rs.scalar(2), .rs.scalar(3)))
})

test_that("nested lists converted to scalars", {
   input <- list(1, 2, list(3, 4))
   expect_equal(.rs.scalarListFromList(input), 
                list(.rs.scalar(1), .rs.scalar(2), 
                     list(.rs.scalar(3), .rs.scalar(4))))
})

#
# test-prefs
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

context("prefs")

test_that("preference values can be set", {
   # create a new temporary value for the code completion pref
   oldVal <- .rs.readUiPref("code_completion_delay")
   newVal <- oldVal + 50L

   # set it to a new value and ensure that it sticks
   .rs.writeUiPref("code_completion_delay", newVal)
   expect_equal(.rs.readUiPref("code_completion_delay"), newVal)

   # restore the old value and ensure that it sticks
   .rs.writeUiPref("code_completion_delay", oldVal)
   expect_equal(.rs.readUiPref("code_completion_delay"), oldVal)
})

test_that("default values for preferences are respected", {
   oldVal <- .rs.readUiPref("num_spaces_for_tab")

   # set it to a new value and ensure that it sticks
   newVal <- oldVal + 2L
   .rs.writeUiPref("num_spaces_for_tab", newVal)
   expect_equal(.rs.readUiPref("num_spaces_for_tab"), newVal)

   # remove the value entirely and ensure it falls back to the default (this presumes the default is
   # 2, but we are unlikely to change the historical default of this pref!)
   .rs.removePref("num_spaces_for_tab")
   expect_equal(.rs.readUiPref("num_spaces_for_tab"), 2)

   # restore the old value if it wasn't the default
   if (oldVal != 2) {
      .rs.writeUiPref("num_spaces_for_tab", oldVal)
   }
})

test_that("rstudio API prefs are separate from IDE prefs", {
   # read an old value from the RStudio preference
   oldVal <- .rs.api.readRStudioPreference("code_completion_delay")
   newVal <- oldVal + 50L

   # save the new value as a regular (non-RStudio) pref
   .rs.api.writePreference("code_completion_delay", newVal)

   # ensure that the new value was written correctly
   prefVal <- .rs.api.readPreference("code_completion_delay")
   expect_equal(prefVal, newVal)

   # ensure that the original RStudio preference is untouched
   prefVal <- .rs.api.readRStudioPreference("code_completion_delay")
   expect_equal(prefVal, oldVal)
})

context("Translations")

# https://github.com/rstudio/rstudio/issues/10308
test_that("translations work on Windows", {
   skip_if(Sys.info()[["sysname"]] != "Windows")
   withr::local_envvar(LANGUAGE = "fr")
   err <- tryCatch(noSuchVariable, error = identity)
   expect_equal(conditionMessage(err), "objet 'noSuchVariable' introuvable")
})

#
# test-debugger.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

library(testthat)

context("debugger")

test_that("deparsing large calls is not overly expensive", {
   
   # call including large data.frame
   big <- data.frame(x = as.numeric(1:1E5))
   cl <- call("dummy", big)
   summary <- .rs.callSummary(cl)
   expect_true(nchar(summary) < 1000)
   
   # call including large vector
   data <- as.list(0:200)
   data[[1L]] <- as.name("c")
   cl <- as.call(data)
   summary <- .rs.callSummary(cl)
   expect_equal(summary, "c(...)")
   
   # call including large data.frame should be described quickly
   big <- mtcars[rep.int(1, 1E5)]
   bigcall <- call("dummy", x = big)
   time <- system.time(.rs.describeObject("bigcall", environment()))
   expect_true(time[1] < 1)
   
})

test_that("we successfully parse the function name from different calls", {
   
   # regular old call
   cl <- call("eval", quote(1 + 1))
   expect_equal(.rs.functionNameFromCall(cl), "eval")
   
   # function directly in call object
   cl <- quote(c(1, 2, 3))
   cl[[1L]] <- c
   expect_equal(.rs.functionNameFromCall(cl), "[Anonymous function]")
   
})

test_that("function calls are not mangled into something un-printable", {
   
   cl <- call("function", pairlist(a = 1, b = 2, c = 3), quote({}))
   sanitized <- .rs.sanitizeCall(cl)
   expect_equal(cl, sanitized)
   
})

#!/bin/bash

# Remove old RStudio.app if it exists
rm -rf "${PREFIX}"/Applications/RStudio.app > /dev/null 2>&1 || true

[ -d "${PREFIX}"/Applications ] || mkdir -p "${PREFIX}"/Applications > /dev/null 2>%1

# Copy new one
cp -r "${PREFIX}"/rstudioapp "${PREFIX}"/Applications/RStudio.app

# Patch CONDA_PREFIX LSEnvironment value
sed -i.bak "s|@CONDA_PREFIX@|${PREFIX}|g" "${PREFIX}"/Applications/RStudio.app/Contents/Info.plist
rm "${PREFIX}"/Applications/RStudio.app/Contents/Info.plist.bak

# Make a symlink. I used a shell script initially, but the icon changes to a default one
# very soon after launching for some reason (this could be the Dock icon changing code in
# RStudio itself, I am not sure..)
mkdir -p "${PREFIX}"/Applications/RStudio.app/Contents/MacOS
cd "${PREFIX}"/Applications/RStudio.app/Contents/MacOS
ln -s ../../../../bin/rstudio rstudio
cd ../../..

# Update Apple's cached information
/System/Library/Frameworks/CoreServices.framework/Frameworks/LaunchServices.framework/Support/lsregister -v -f RStudio.app

cd ..

rm -rf "${PREFIX}"/rstudioapp

#!/usr/bin/env bash

#
# codesign-package.sh
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

set -e

if [ "$#" = "0" ] || [ "$1" = "--help" ]; then
	echo "Usage: codesign-package.sh [package] [codesign arguments...]"
	exit 0
fi

# read the package directory
package="$1"
shift

# recurse into hidden directories (that is, .webpack)
shopt -s nullglob
shopt -s dotglob

codesign_args=("$@")

retry () {

	local status=0

	for _ in 1 2 3; do

		if "$@"; then
			status=0
			break
		else
			status=$?
			sleep 1
		fi

	done

	return "${status}"

}

codesign-binary () {

	retry codesign "${codesign_args[@]}" "$@"

}

codesign-file () {

	retry codesign "${codesign_args[@]}" --entitlements entitlements/default.plist "$@"

}

codesign-directory () {

	# first, recurse into directories
	for FILE in "$1"/*; do
		if [ -d "${FILE}" ]; then
			codesign-directory "${FILE}"
		fi
	done

	# now, sign files
	for FILE in "$1"/*; do
		if [ -f "${FILE}" ]; then
			codesign-file "${FILE}"
		fi
	done

}

# remove Finder detritus that interferes with codesigning
echo "[i] Cleaning Finder metadata from ${package}"
find "${package}" -name '.DS_Store' -delete || true

echo "[i] Running codesign on package: ${package}"
codesign-directory "${package}"

entype="${RSESSION_ENTITLEMENTS_TYPE-adhoc}"
for executable in rsession rsession-arm64; do
	path="${package}/Contents/Resources/app/bin/${executable}"
	if [ -e "${path}" ]; then
		entitlements=entitlements/rsession-${entype}.plist
		echo "[i] Re-signing ${executable} with entitlements -- ${entype}"
		codesign-binary --entitlements "${entitlements}" "${path}"
	fi
done

echo "[i] Re-signing RStudio binary with entitlements -- ${entype}"
codesign-binary --entitlements "entitlements/rstudio-${entype}.plist" "${package}/Contents/MacOS/RStudio"

echo "[i] Validating signatures"
codesign -vvv --deep --strict "${package}"

setlocal EnableDelayedExpansion
:: Jom is much faster, but if you need to debug something, making Visual Studio
:: projects can be useful. Packages are always built with Jom though. That side
:: of the process has never been tested using Visual Studio but it might work.
set USE_JOM=1
:: set BUILD_TYPE=RelWithDebInfo
set BUILD_TYPE=Release

set _JAVA_OPTIONS=-Xmx768M

FOR /f "usebackqeol=; tokens=1 delims=." %%A IN ('%PKG_VERSION%') DO set RSTUDIO_VERSION_MAJOR=%%A
FOR /f "usebackqeol=; tokens=2 delims=." %%A IN ('%PKG_VERSION%') DO set RSTUDIO_VERSION_MINOR=%%A
FOR /f "usebackqeol=; tokens=3 delims=." %%A IN ('%PKG_VERSION%') DO set RSTUDIO_VERSION_PATCH=%%A

pushd dependencies\windows
  call install-dependencies.cmd
popd

pushd dependencies\common
  mkdir rmarkdown
  pushd rmarkdown
    call conda install -c r --no-deps --yes --copy --prefix "%CD%" r-markdown
  popd
popd

mkdir build
pushd build

if "%ARCH%"=="32" (
   set R_ARCH=i386
   set MS_MACH=X86
) else (
   set R_ARCH=x64
   set MS_MACH=X64
)

set R_ROOT=%PREFIX%\lib\R

:: Create an import library for the mingw-w64 compiled R.dll. We must not use
:: MS's dumpbin for this as that doesn't add 'DATA' annotations to variables.
:: mingw-w64's gendef must be used instead.
:: dumpbin /exports %PREFIX%\R\bin\!R_ARCH!\R.dll > %PREFIX%\R\bin\!R_ARCH!\R.dll.exports.txt
:: echo LIBRARY R > %PREFIX%\R\bin\!R_ARCH!\R.def
:: echo EXPORTS >> %PREFIX%\R\bin\!R_ARCH!\R.def
:: for /f "skip=19 tokens=4" %%A in (%PREFIX%\R\bin\!R_ARCH!\R.dll.exports.txt) do echo %%A >> %PREFIX%\R\bin\!R_ARCH!\R.def
gendef %R_ROOT%\bin\!R_ARCH!\R.dll - > %R_ROOT%\bin\!R_ARCH!\R.def
lib /def:%R_ROOT%\bin\!R_ARCH!\R.def /out:%R_ROOT%\bin\!R_ARCH!\R.lib /machine:!MS_MACH!

:: .. and one for Rgraphapp.dll. Unfortunately, the first export from this is bad:
:: ".refptr.GAI_active_windows.refptr.GAI_app_control_proc..." so this horrible loop
:: is used to create a new header then copy everything after line 8 from the defs file.
:: Yes, I know this is awful.
gendef %R_ROOT%\bin\!R_ARCH!\Rgraphapp.dll - > %R_ROOT%\bin\!R_ARCH!\Rgraphapp.dll.exports.txt
echo LIBRARY Rgraphapp > %R_ROOT%\bin\!R_ARCH!\Rgraphapp.def
echo EXPORTS >> %R_ROOT%\bin\!R_ARCH!\Rgraphapp.def
for /f "delims= skip=8" %%A in (%R_ROOT%\bin\!R_ARCH!\Rgraphapp.dll.exports.txt) do echo %%A >> %R_ROOT%\bin\!R_ARCH!\Rgraphapp.def
lib /def:%R_ROOT%\bin\!R_ARCH!\Rgraphapp.def /out:%R_ROOT%\bin\!R_ARCH!\Rgraphapp.lib /machine:!MS_MACH!

set BOOST_ROOT=%PREFIX%

:: It's not possible to use CMAKE_BUILD_TYPE=Debug here because
:: conda's Boost and Qt packages do not provide debug libraries:
:: '_ITERATOR_DEBUG_LEVEL': value '0' doesn't match value '2'
:: 'RuntimeLibrary': value 'MD_DynamicRelease' doesn't match value 'MDd_DynamicDebug'
if "%USE_JOM%" == "0" goto skip_jom
::  for /f "delims=" %%A in ('where cl.exe') do set "CL_EXE=%%A"
::  set "CL_EXE=!CL_EXE:\=/!"
  echo Using cmake -G"NMake Makefiles"
  cmake -G"NMake Makefiles" ^
        -DCMAKE_INSTALL_PREFIX=%PREFIX%\Library ^
        -DRSTUDIO_TARGET=Desktop ^
        -DCMAKE_BUILD_TYPE=%BUILD_TYPE% ^
        -DLIBR_HOME=%R_ROOT% ^
        -DLIBR_CORE_LIBRARY=%R_ROOT%\bin\!R_ARCH!\R.lib ^
        -DLIBR_GRAPHAPP_LIBRARY=%R_ROOT%\bin\!R_ARCH!\Rgraphapp.lib ^
        -DQT_QMAKE_EXECUTABLE=%PREFIX%\Library\bin\qmake.exe ^
        -DCMAKE_MAKE_PROGRAM=jom ^
        ..
::  if "%PROCESSOR_ARCHITECTURE%"=="x86" (
::     echo Early test for OpenJDK heap allocation problem
::     pushd %CONDA_PREFIX%\conda-bld\work\src\gwt
::     ant
::     popd
::  )
  jom VERBOSE=1
  if %errorlevel% neq 0 exit /b %errorlevel%
  jom install VERBOSE=1
  if %errorlevel% neq 0 exit /b %errorlevel%
  goto skip_msvs
:skip_jom
:: /MP == object level parallelism, but when added on its own
:: WIN32, _WINDOWS and /EHsc are dropped, so add them back too.
:: This needs to be fixed in the CMakeLists.txt files.
  echo Using cmake -G"%CMAKE_GENERATOR%"
  cmake -G"%CMAKE_GENERATOR%" ^
        -DCMAKE_INSTALL_PREFIX=%PREFIX%\Library ^
        -DRSTUDIO_TARGET=Desktop ^
        -DCMAKE_BUILD_TYPE=%BUILD_TYPE% ^
        -DLIBR_HOME=%R_ROOT% ^
        -DLIBR_CORE_LIBRARY=%R_ROOT%\bin\!R_ARCH!\R.lib ^
        -DLIBR_GRAPHAPP_LIBRARY=%R_ROOT%\bin\!R_ARCH!\Rgraphapp.lib ^
        -DQT_QMAKE_EXECUTABLE=%PREFIX%\Library\bin\qmake.exe ^
        -DCMAKE_CXX_FLAGS="/MP /DWIN32 /D_WINDOWS /EHsc" ^
        -DCMAKE_C_FLAGS="/MP /DWIN32 /D_WINDOWS /EHsc" ^
        ..
  cmake --build . --config %BUILD_TYPE% --target INSTALL
  if %errorlevel% neq 0 exit /b %errorlevel%
:skip_msvs

IF NOT EXIST %PREFIX%\Menu mkdir %PREFIX%\Menu
copy %RECIPE_DIR%\menu-windows.json %PREFIX%\Menu\
copy %RECIPE_DIR%\rstudio.ico %PREFIX%\Menu\

:: If you need to debug in an IDE:
:: exit /b 1

del %R_ROOT%\bin\!R_ARCH!\Rgraphapp.dll.exports.txt
del %R_ROOT%\bin\!R_ARCH!\Rgraphapp.lib
del %R_ROOT%\bin\!R_ARCH!\R.def
del %R_ROOT%\bin\!R_ARCH!\R.lib

popd

#!/usr/bin/env bash

# rstudio-version.sh
#
# This script reads official RStudio build numbers based on
# information observed in the local repository.
#
# The rules observed are as follows:
#
# 1. Every build of the open source version of RStudio results in a new patch release
#    formatted as:
#
#    <YYYY>.<MM>.<patch>[-(dev|daily|preview)]+<build number>
#
#    <YYYY>.<MM>
#    ===========
#    The first two sections, year and month, indicate the date when the branch was 
#    initially released. For development, daily, and preview branches, it's always 
#    the expected year and month of release. In the event that the release takes place 
#    early or late, the year and month will be updated accordingly.
#
#    <patch>
#    =======
#    The patch version is incremented with each subsequent release of the branch.
#
#    - Patch version 0: The first release from the branch.
#    - Patch version 1: The second release from the branch.
#    ...
#    - Patch version N: The N + 1 release from the branch.
#
#    [-(dev|daily|preview)]
#    ======================
#    This optional section indicates that the build is not a stable release build, and 
#    also indicates the degree of instability. Local development builds will include -dev 
#    in the version (least stable). Daily builds will include -daily, and preview builds will 
#    include -preview (most stable). Only stable releases should omit this value.
#
#    <build number>
#    ==============
#    The build number indicates the number of commits that have been introduced on the 
#    branch since work on the release has started. In the local repository, the file 
#    'version/base_commit/CALENDAR_VERSION.BASE_COMMIT' contains the commit hash of the 
#    base (starting) commit from which work on that calendar version started. This is 
#    used to determine the number of commits that have been made since the base commit, 
#    which is used as the patch version.
#
# 2. The build number of RStudio Pro is formatted as follows:
#
#    <YYYY>.<MM>.<patch>[-(dev|daily|preview)]+<build number>.pro<pro suffix>
#
#    All release designators match the open source version, based on the open source
#    commit hash stored in the upstream/VERSION file, with the addition of the pro suffix.
#
#    .pro<pro suffix>
#    ================
#    The pro suffix is generated in a similar manner to <build number> for the open source
#    version, but it is based on the number of commits to the pro branch since open source
#    was merged into the pro branch. In the local repository, the file upstream/VERSION
#    contains the commit hash that is used for this determination.
#
# Pass "debug" as the last parameter to print additional output

# abort on error
set -e

RSTUDIO_ROOT_DIR="$(readlink -f $(dirname "${BASH_SOURCE[0]}")/../..)"

function invalid_arg() {
    echo "Invalid argument: $1" >&2
    exit 1
}

function help() {
    echo "Usage: rstudio-version.sh [--patch=<patch number>] [--build-type=<build type>] [--debug]"
    echo "  -h, --help: Print this help message"
    echo "  -p, --patch: Set the patch number (e.g., --patch=1)"
    echo "  -b, --build-type: Set a custom build type (e.g., --build-type=hourly)"
    echo "  -d, --debug: Print additional output"
    exit 0
}

# Default values
PATCH=""
DEBUG=false
CUSTOM_BUILD_TYPE=""
HELP=false

for arg in "$@"; do

   case "$arg" in
   -h | --help)             help;;
   -p | --patch=*)          PATCH=${arg#*=} ;;
   -b | --build-type=*)     CUSTOM_BUILD_TYPE=${arg#*=} ;;
   -d | --debug)            DEBUG=true ;;
   *)                       invalid_arg "$arg" ;;
   esac

done

function log() {
    if [[ $DEBUG = true ]]; then
        echo "$@"
    fi
}

function buildType() {
    if [ -e "$RSTUDIO_ROOT_DIR/version/BUILDTYPE" ]; then
        BUILD_TYPE="$(cat "$RSTUDIO_ROOT_DIR/version/BUILDTYPE" | tr '[ ]' '-' | tr -d '[:space:]' | tr '[:upper:]' '[:lower:]')"
        if [[ -n "$CUSTOM_BUILD_TYPE" ]]; then
            BUILD_TYPE="$CUSTOM_BUILD_TYPE"
        fi
        if [[ -n "$BUILD_TYPE" && "$BUILD_TYPE" != "release" ]]; then
            echo "-${BUILD_TYPE}"
        else
            echo ""
        fi
    else
        echo "The $RSTUDIO_ROOT_DIR/version/BUILDTYPE file does not exist. A build version could not be generated" >&2
        exit 1
    fi
}

function flower() {
    if [ -e "$RSTUDIO_ROOT_DIR/version/RELEASE" ]; then
        echo "$(cat "$RSTUDIO_ROOT_DIR/version/RELEASE" | tr '[ ]' '-' | tr -d '[:space:]' | tr '[:upper:]' '[:lower:]')"
    else
        echo "The $RSTUDIO_ROOT_DIR/version/RELEASE file does not exist. A build version could not be generated" >&2
        exit 1
    fi
}

function calver() {
    if [ -e "$RSTUDIO_ROOT_DIR/version/CALENDAR_VERSION" ]; then
        echo "$(cat "$RSTUDIO_ROOT_DIR/version/CALENDAR_VERSION" | tr -d '[:space:]')"
    else
        echo "The $RSTUDIO_ROOT_DIR/version/CALENDAR_VERSION file does not exist. A build version could not be generated" >&2
        exit 1
    fi
}

function patch() {
    if [[ -n "$PATCH" ]]; then
        echo "$PATCH"
    elif [ -e "$RSTUDIO_ROOT_DIR/version/PATCH" ]; then
        echo "$(cat "$RSTUDIO_ROOT_DIR/version/PATCH" | tr -d '[:space:]')"
    else
        echo "The $RSTUDIO_ROOT_DIR/version/PATCH file does not exist and a -p option was not provided. A build version could not be generated" >&2
        exit 1
    fi
}

function baseCommit() {
    BASE_COMMIT_FILE="$RSTUDIO_ROOT_DIR/version/base_commit/$(flower).BASE_COMMIT"
    if [ -e $BASE_COMMIT_FILE ]; then
        echo "$(cat "$BASE_COMMIT_FILE" | tr -d '[:space:]')"
    else
        echo "The ${BASE_COMMIT_FILE} file does not exist. A build version could not be generated" >&2
        exit 1
    fi
}

VERSION="$(calver).$(patch)$(buildType)"

BASE_COMMIT=$(baseCommit)
log "BASE_COMMIT: $BASE_COMMIT"

if [[ -e "$RSTUDIO_ROOT_DIR/upstream/VERSION" ]]; then
    PRO=true
    OPEN_SOURCE_COMMIT=$(cat "$RSTUDIO_ROOT_DIR/upstream/VERSION")
    BUILD_NO=$(git rev-list ${BASE_COMMIT}..${OPEN_SOURCE_COMMIT} --count)
    SUFFIX=$(git rev-list ${OPEN_SOURCE_COMMIT}..HEAD --ancestry-path --count)
else
    OPEN_SOURCE=true
    BUILD_NO=$(git rev-list ${BASE_COMMIT}..HEAD --count)
fi

if [[ $OPEN_SOURCE = true ]]; then
    echo "$VERSION+$BUILD_NO"
    elif [[ $PRO = true ]]; then
    echo "$VERSION+$BUILD_NO.pro$SUFFIX"
fi

::
:: make-dist-packages.bat
::
:: Copyright (C) 2025 by Posit Software, PBC
::
:: Unless you have received this program directly from Posit Software pursuant
:: to the terms of a commercial license agreement with Posit Software, then
:: this program is licensed to you under the terms of version 3 of the
:: GNU Affero General Public License. This program is distributed WITHOUT
:: ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
:: MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
:: AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
::
@echo off
setlocal

if "%1" == "--help" goto :showhelp
if "%1" == "-h" goto :showhelp
if "%1" == "help" goto :showhelp
if "%1" == "/?" goto :showhelp

if "%PACKAGE_DIR%" == "" set PACKAGE_DIR=%~dp0
if "%BUILD_DIR%" == "" set BUILD_DIR=build
if "%CMAKE_BUILD_TYPE%" == "" set CMAKE_BUILD_TYPE=RelWithDebInfo
if "%CMAKE_BUILD_TYPE%" == "Debug" set BUILD_DIR=build-debug
if "%PKG_TEMP_DIR%" == "" set PKG_TEMP_DIR=C:/rsbuild

echo DEBUG: make-dist-packages.bat using following values:
echo DEBUG:     PACKAGE_DIR=%PACKAGE_DIR%
echo DEBUG:     BUILD_DIR=%BUILD_DIR%
echo DEBUG:     CMAKE_BUILD_TYPE=%CMAKE_BUILD_TYPE%
echo DEBUG:     PKG_TEMP_DIR=%PKG_TEMP_DIR%

if not exist %BUILD_DIR% (
    echo ERROR: Build directory not found at "%BUILD_DIR%"
    goto :error
)

pushd %BUILD_DIR%
set "BUILD_DIR=%CD%"

if not defined QUICK (
    echo Creating NSIS setup package...
    cpack -C "%CMAKE_BUILD_TYPE%" -G NSIS
    REM emit NSIS error output if present
    if exist "%PKG_TEMP_DIR%\_CPack_Packages\win64\NSIS\NSISOutput.log" type "%PKG_TEMP_DIR%\_CPack_Packages\win64\NSIS\NSISOutput.log"
    if not defined RSTUDIO_DOCKER_DEVELOPMENT_BUILD (
        move "%PKG_TEMP_DIR%\*.exe" "%BUILD_DIR%"
    )
)

if not defined NOZIP (
    if "%CMAKE_BUILD_TYPE%" == "RelWithDebInfo" (
        echo Creating ZIP package...
        cpack -C "%CMAKE_BUILD_TYPE%" -G ZIP
        if not defined RSTUDIO_DOCKER_DEVELOPMENT_BUILD (
            move "%PKG_TEMP_DIR%\*.zip" "%BUILD_DIR%"
        )
    )
)

popd

endlocal
goto :EOF

:showhelp
echo.
echo make-dist-packages
echo.
echo. Produces the RStudio setup package and zip file (installerless) distributables using
echo. already-built binaries.
echo.
echo  Must be invoked from the "package\win32" folder (in the cloned RStudio repository).
echo.
exit /b 0

:error
echo ERROR: Failed to package RStudio!
exit /b 1

@echo off

call %~dp0\..\..\..\dependencies\tools\rstudio-tools.cmd


pushd "%_VCTOOLSDIR%"
call VsDevCmd.bat -clean_env -no_logo || goto :error
call VsDevCmd.bat -arch=amd64 -startdir=none -host_arch=amd64 -winsdk=%WIN32_SDK_VERSION% -no_logo || goto :error
popd


echo Microsoft toolchain configured, can now use cmake. For example:
echo mkdir rstudio\src\build
echo cd rstudio\src\build
echo cmake ..\cpp -GNinja
echo ninja

#!/usr/bin/env bash

set -f
USERID=$1
USERINFO=$(getent passwd $USERID)

# okay if no user
if [ $? -ne 0 ]; then
    echo "No user exists with id $USERID"
    exit 0
fi

# turn userinfo into a space-separated array and extract the first element
USERINFO=(${USERINFO//:/ })
USERNAME="${USERINFO[0]}"

echo "Removing user $USERNAME with conflicting id $USERID"

# use appropriate command for user deletion
if hash userdel 2>/dev/null; then
    userdel $USERNAME
elif hash deluser 2>/dev/null; then
    deluser $USERNAME
fi

# Changing to not using an .app bundle is a bit tricky. I need to use
# Xcode.
_XCODE_BUILD=0
BUILD_TYPE=Release
# BUILD_TYPE=RelWithDebInfo

# Boost 1.65.1 cannot be used with -std=c++17 it seems. -std=c++14 works.
re='(.*[[:space:]])\-std\=[^[:space:]]*(.*)'
if [[ "${CXXFLAGS}" =~ $re ]]; then
  export CXXFLAGS="${BASH_REMATCH[1]} -std=c++14 ${BASH_REMATCH[2]}"
fi

export RSTUDIO_VERSION_MAJOR=$(echo ${PKG_VERSION} | cut -d. -f1)
export RSTUDIO_VERSION_MINOR=$(echo ${PKG_VERSION} | cut -d. -f2)
export RSTUDIO_VERSION_PATCH=$(echo ${PKG_VERSION} | cut -d. -f3)

pushd dependencies/common
  ./install-gwt
  ./install-dictionaries
  ./install-mathjax
# ./install-boost
# ./install-pandoc
  ./install-libclang
  ./install-packages
popd

if [[ ${target_platform} == osx-64 ]]; then
  for SHARED_LIB in $(find . -type f -iname "libclang.dylib"); do
    $INSTALL_NAME_TOOL -change /usr/lib/libc++.1.dylib "$PREFIX"/lib/libc++.1.dylib ${SHARED_LIB}
    # We may want to whitelist some of these instead?
    $INSTALL_NAME_TOOL -change /usr/lib/libz.1.dylib "$PREFIX"/lib/libz.1.dylib ${SHARED_LIB}
    # libncurses cannot be modified as there is not enough space:
    # changing install names or rpaths can't be redone for: ./dependencies/common/libclang/3.5/libclang.dylib (for architecture x86_64)
    # because larger updated load commands do not fit (the program must be relinked, and you may need to use -headerpad or -headerpad_max_install_names
    # $INSTALL_NAME_TOOL -change /usr/lib/libncurses.5.4.dylib "$PREFIX"/lib/libncursesw.6.dylib ${SHARED_LIB}
    $INSTALL_NAME_TOOL -change /usr/lib/libedit.3.dylib "$PREFIX"/lib/libedit.0.dylib ${SHARED_LIB}
  done
fi

mkdir build
cd build

if ! which javac; then
  echo "Fatal: Please install javac with your system package manager"
  exit 1
fi

if ! which ant; then
  echo "Fatal: Please install ant with your system package manager"
  exit 1
fi

# Note, you can select a different default R interpreter launching
# RStudio by:
# export RSTUDIO_WHICH_R=${CONDA_PREFIX}/bin/R

# You can use this so that -Wl,-rpath-link gets used during linking
# executables. Without it, -Wl,-rpath is used anyway (and also) and
# either works fine from the perspective of ld finding transitively
# linked shared libraries:
# -DCMAKE_PLATFORM_RUNTIME_PATH=${PREFIX}/lib

export BOOST_ROOT=${PREFIX}
_VERBOSE="VERBOSE=1"

declare -a _CMAKE_EXTRA_CONFIG
if [[ ${HOST} =~ .*darwin.* ]]; then
  if [[ ${_XCODE_BUILD} == 1 ]]; then
    _CMAKE_EXTRA_CONFIG+=(-G'Xcode')
    _CMAKE_EXTRA_CONFIG+=(-DCMAKE_OSX_ARCHITECTURES=x86_64)
    _VERBOSE=""
  fi
  _CMAKE_EXTRA_CONFIG+=(-DRSTUDIO_USE_LIBCXX=TRUE)
  unset MACOSX_DEPLOYMENT_TARGET
  export MACOSX_DEPLOYMENT_TARGET
else
  _CMAKE_EXTRA_CONFIG+=(-DQT_QMAKE_EXECUTABLE=${PREFIX}/bin/qmake)
fi

#      -Wdev --debug-output --trace                \

cmake                                   \
      -DCMAKE_INSTALL_PREFIX=${PREFIX}  \
      -DBOOST_ROOT=${PREFIX}            \
      -DBOOST_VERSION=1.65.1            \
      -DRSTUDIO_TARGET=Desktop          \
      -DCMAKE_BUILD_TYPE=${BUILD_TYPE}  \
      -DLIBR_HOME=${PREFIX}/lib/R       \
      -DUSE_MACOS_R_FRAMEWORK=FALSE     \
      -DCMAKE_C_COMPILER=${CC}          \
      -DCMAKE_CXX_COMPILER=${CXX}       \
      "${_CMAKE_EXTRA_CONFIG[@]}"       \
      ..

# on macOS 10.9, in spite of following: https://unix.stackexchange.com/a/221988
# and those limits seeming to have taken:
# launchctl limit | grep maxfiles
# maxfiles    262144         524288
# .. we still get failures:
# Error writing out generated unit at '$SRC_DIR/src/gwt/gen/org/rstudio/studio/client/rsconnect/ui/RSAccountConnector_Binder__Impl.java':
#  java.io.FileNotFoundException: gen/org/rstudio/studio/client/rsconnect/ui/RSAccountConnector_Binder__Impl.java (Too many open files)
# .. so instead build in series (it may be that running make install twice works just as well here).
# Update: It turns out that the number of files needed is constant and the number of threads has no bearing on this:
# https://groups.google.com/d/msg/google-web-toolkit/EGiOO0g85rI/tGrxa9_Ou9wJ
# When building a ClientBundle with images, the compiler holds all the source image files open at the same time, even if you never refer to the image in your code
# Also for macOS 10.9, the way to increase this limit is to add the following to ~/.bash_profile:
# ulimit -n 2048

# "cmake --build" might be fine on all OSes/generators (though it does
# seem to be building the Debug variant on Xcode), so for now check _XCODE_BUILD
if [[ ${_XCODE_BUILD} == 1 ]]; then
  cmake --build . --target install -- ${_VERBOSE} || exit 1
else
  make install -j${CPU_COUNT} ${VERBOSE_CM} || exit 1
fi

if [[ $(uname) == Darwin ]]; then
  cp -rf "${RECIPE_DIR}"/app/RStudio.app ${PREFIX}/rstudioapp
  cp "${RECIPE_DIR}"/osx-post.sh ${PREFIX}/bin/.rstudio-post-link.sh
  cp "${RECIPE_DIR}"/osx-pre.sh ${PREFIX}/bin/.rstudio-pre-unlink.sh
elif [[ $(uname) == Linux ]]; then
  echo "It would be nice to add a .desktop file here, but it would"
  echo "be even nicer if menuinst handled both that and App bundles."
fi

# exit 1

@if not defined _echo echo off
setlocal enabledelayedexpansion

:: Helper script used when installing Visual C++ build tools into docker image.
:: See: https://learn.microsoft.com/en-us/visualstudio/install/advanced-build-tools-container

call %*
if "%ERRORLEVEL%"=="3010" (
    exit /b 0
) else (
    if not "%ERRORLEVEL%"=="0" (
        set ERR=%ERRORLEVEL%
        call dependencies\windows\vscollect.exe -zip:C:\vslogs.zip

        exit /b !ERR!
    )
)

exit /b 0

#!/usr/bin/env bash

# Run this script to add node to the PATH.
# Node versions below should match RSTUDIO_NODE_VERSION
if [ "$(uname -ms)" = "Darwin arm64" ]; then
	NODE_PATH=$(readlink -fn ../../../dependencies/common/node/22.22.2-arm64/bin)
else
	NODE_PATH=$(realpath ../../../dependencies/common/node/22.22.2/bin)
fi

PATH="${NODE_PATH}:${PATH}"
export PATH

#!/bin/bash

# https://stackoverflow.com/a/246128
SCRIPT_DIR=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )

deno info --import-map dev_import_map.json quarto.ts | grep https | gsed -r 's/\x1B\[[0-9;]*[JKmsu]//g' | sed 's/[^ht]*ht/ht/g' | grep -v '\*$' | deno run --allow-read ${SCRIPT_DIR}/check-usage.ts $*

## Info on how to read the output
#
# The two biggest offenders right now are deno_dom and
# media_types. however, those two files are almost entirely composed
# of big strings, which take little compilation overhead.
#
# We tested this by creating a version of deno_dom which
# loaded its big string from a file, and the dry startup time
# didn't go down at all (even though the total file size did.)
#

#!/usr/bin/env bash

# This script copies Quarto release binaries into the RStudio Build Tools
# (rstudio-buildtools) S3 bucket. Presumes you've already got AWS command line
# tools (awscli) installed, and configured with a valid AWS account.

# Modify to set the Quarto version to upload
QUARTO_VERSION=1.9.38


# Check that we're logged in with AWS
aws sts get-caller-identity || aws sso login

BASEURL="https://github.com/quarto-dev/quarto-cli/releases/download/"
AWS_BUCKET="s3://rstudio-buildtools"

PLATFORMS=(
    linux-amd64.tar.gz
    linux-arm64.tar.gz
    macos.tar.gz
    win.zip
)

for PLATFORM in "${PLATFORMS[@]}"; do

    # Form filename from version and platform
    FILENAME="quarto-${QUARTO_VERSION}-${PLATFORM}"

    # Download from Pandoc release site
    wget -c "${BASEURL}/v${QUARTO_VERSION}/${FILENAME}"

    # Upload to S3 bucket
    aws s3 cp "${FILENAME}" "${AWS_BUCKET}/quarto/${QUARTO_VERSION}/" --acl public-read

done

@echo off
setlocal EnableDelayedExpansion

echo About to delete all per-user RStudio state and settings, proceed with caution!
echo (Does not delete Project-specific state in .Rproj.user, global machine state, or .Renviron)
pause

set ERRORS=0
set CLEANED=0

REM --- Helper: remove a directory if it exists ---
REM   Uses a subroutine so each call reports what it's doing and whether it succeeded.
goto :start

:rmdir_if_exists
if not exist "%~1\" exit /b 0
echo Removing directory: %~1
rd /q /s "%~1" 2>nul
if !ERRORLEVEL! neq 0 (
    echo ERROR: Failed to remove "%~1" -- is something holding it open?
    echo        Try: handle.exe "%~1" ^(Sysinternals^) to find the locking process.
    set /a ERRORS+=1
) else (
    set /a CLEANED+=1
)
exit /b 0

:del_if_exists
if not exist "%~1" exit /b 0
echo Deleting file: %~1
del /f "%~1" 2>nul
if !ERRORLEVEL! neq 0 (
    echo ERROR: Failed to delete "%~1" -- is something holding it open?
    echo        Try: handle.exe "%~1" ^(Sysinternals^) to find the locking process.
    set /a ERRORS+=1
) else (
    set /a CLEANED+=1
)
exit /b 0

:start

call :rmdir_if_exists "%localappdata%\RStudio-Desktop"
call :rmdir_if_exists "%localappdata%\RStudio"
call :rmdir_if_exists "%appdata%\RStudio"
call :del_if_exists "%localappdata%\R\crash-handler-permission"
call :del_if_exists "%localappdata%\R\crash-handler.conf"
call :rmdir_if_exists "%appdata%\R\rsconnect"
call :rmdir_if_exists "%appdata%\R\config\R\rsconnect"
call :rmdir_if_exists "%USERPROFILE%\.posit\assistant"
call :rmdir_if_exists "%USERPROFILE%\.positai"

for /f "tokens=*" %%i in ('powershell -NoProfile -Command "[System.Environment]::GetFolderPath([Environment+SpecialFolder]::MyDocuments)"') do set MyDocsDir=%%i

call :del_if_exists "%MyDocsDir%\.RData"
call :del_if_exists "%MyDocsDir%\.Rhistory"
call :rmdir_if_exists "%MyDocsDir%\.R\rstudio"

if exist "%MyDocsDir%\.Renviron" (
    echo Note: "%MyDocsDir%\.Renviron" found, not deleting
)

echo.
if %ERRORS% equ 0 (
    echo Done. Cleaned %CLEANED% item^(s^), no errors.
) else (
    echo Done. Cleaned %CLEANED% item^(s^), %ERRORS% FAILED.
    echo Re-run after closing RStudio and any R sessions.
    exit /b 1
)

endlocal

@echo off
setlocal EnableDelayedExpansion

::
:: Script to build docker image for building RStudio Desktop for Windows
::

for %%A in (%*) do (
    if /I "%%A" == "clean" (
        set "NO_CACHE=--no-cache"
    )
)

set IMAGE=windows

REM move to the repo root (script's parent directory)
cd %~dp0\..
call dependencies\tools\rstudio-tools.cmd

REM Determine the repository name.
REM Used to differentiate 'rstudio' from 'rstudio-pro' when tagging the image.
for /F "delims=" %%i in ("%CD%") do set REPO=%%~nxi

REM Build the image.
%RUN% with-echo docker build ^
    --file docker\jenkins\Dockerfile.%IMAGE% ^
    --tag %REPO%:%IMAGE% ^
    --memory 16GB ^
    %NO_CACHE% ^
    --build-arg JENKINS_URL=development-build ^
    --build-arg GITHUB_LOGIN=%DOCKER_GITHUB_LOGIN% ^
    .

if %ERRORLEVEL% NEQ 0 (
    echo -- Error creating image %REPO%:%IMAGE% [error code %ERRORLEVEL%]
    exit /b 1
)

echo -- Created image %REPO%:%IMAGE%

#!/usr/bin/env bash
#
# RStudio Release Signing (sign-release.sh)
#
# This script signs an RStudio release using GnuPG and a private RStudio
# release signing key. The command-line parameters are as follows:
#
# 1. The release binary. This can be an RPM, which will be signed with rpmsign,
#    or a DEB, which will be signed with dpkg-sig.
#
# 2. The encrypted private release signing key. This should be an ASCII armored
#    GnuPG private key, via e.g. gpg --export-secret-keys. 
# 
# 3. A file containing the passphrase for the release signing key.
#
# The script will not modify the GnuPG keyring of the calling user; it imports
# the signing key into a private, temporary keyring, uses it to sign the
# release, and then destroys the keyring.

# abort on error
set -e

if [[ "$#" -ne 3 ]]; then
    echo "Usage: sign-release.sh [installer-file] [key-file] [passphrase-file]"
    exit 1
fi

# label parameters for convenience
INSTALLER=$1
KEYFILE=$2
PASSFILE=$3

# to avoid cluttering the user's keyring with the signing key, we use a
# temporary keyring directory
TMP_KEYRING_DIR=$(mktemp -d)
TMP_SEC_KEYRING="$TMP_KEYRING_DIR/secring.gpg"
TMP_PUB_KEYRING="$TMP_KEYRING_DIR/pubring.gpg"

# make sure to clean up the temporary keyring when finished
function cleanup {
    if [ -d "$TMP_KEYRING_DIR" ]; then 
        rm -rf $TMP_KEYRING_DIR
    fi
}
trap cleanup EXIT

# this script only works with GnuPG 1.4 and 2.0; in 2.1 all the secret
# management happens in gpg-agent, which is much less amenable to automation.
# if the gpg1 binary is present on this machine, then presume that it exists as
# an alternative to a future, incompatible version, and use it for the "gpg"
# command by manipulating $PATH.
if [ -x "$(command -v gpg1)" ]; then 
    # emit notice
    GPG1=$(which gpg1)
    GPG2=$(which gpg)
    echo "Note: Using $GPG1 to provide GnuPG (was $GPG2)"
    # softlink gpg into our temporary work folder
    ln -s $GPG1 $TMP_KEYRING_DIR/gpg
    export PATH=$TMP_KEYRING_DIR:$PATH
fi

echo "Using GPG version: "
gpg --version

# import signing key
echo "Installing signing key from $KEYFILE..."
gpg --no-default-keyring --keyring=$TMP_PUB_KEYRING --secret-keyring=$TMP_SEC_KEYRING --import $KEYFILE
PASSPHRASE=$(cat $PASSFILE)

# scrape out the signing key ID
KEY_ID=$(gpg --list-secret-keys --no-default-keyring --keyring=$TMP_PUB_KEYRING --secret-keyring=$TMP_SEC_KEYRING --keyid-format long --with-colons | grep '^sec' | cut --delimiter ':' --fields 5)
echo "Signing installer $INSTALLER with key $KEY_ID..."

# extract filename to infer what kind of archive we're working with
FILENAME=$(basename "$INSTALLER")
EXT=${FILENAME##*.}

if [ "$EXT" == "deb" ]; then
    # ------------------------------------------------------------------------
    # Debian packages (.deb)
    # ------------------------------------------------------------------------

    # Signing with debsigs is currently disabled because it doesn't provide a
    # way to pass the *public* keyring to GPG. Even when passing the correct *secret*
    # keyring, GPG doesn't sign:
    # 
    # secret key without public key - skipped
    # gpg: no default secret key: secret key not available
    #
    # This seems to be a problem primarily with older GPG installations.

    # echo "Signing with debsigs..."
    # /usr/bin/expect << EOD
    # spawn bash -c "debsigs -v --sign=origin --default-key=$KEY_ID --secret-keyring=$TMP_SEC_KEYRING $INSTALLER"
    # expect "Enter passphrase:"
    # send "$PASSPHRASE\r"
    # expect eof
    # EOD

    echo "Signing with dpkg-sig..."
    dpkg-sig -k $KEY_ID --verbose --sign builder $INSTALLER --gpg-options="--no-default-keyring --keyring=$TMP_PUB_KEYRING --secret-keyring=$TMP_SEC_KEYRING --no-tty --no-use-agent --passphrase-file $PASSFILE"
elif [ "$EXT" == "rpm" ]; then
    # ------------------------------------------------------------------------
    # Redhat packages (.rpm)
    # ------------------------------------------------------------------------
    echo "Signing with rpmsign..."
    
    # set up the rpm macros file to point to our temporary key
    RPM_MACROS="$HOME/.rpmmacros"
    if [ -f "$RPM_MACROS" ]; then
        mv $RPM_MACROS $RPM_MACROS.bak
    fi
    touch "$RPM_MACROS"
    echo "%_signature gpg"  >> $RPM_MACROS

    # define key name and directory where we installed temporaries
    echo "%_gpg_name $KEY_ID" >> $RPM_MACROS
    echo "%_gpg_path $TMP_KEYRING_DIR" >> $RPM_MACROS

    if [ -f /etc/redhat-release ]; then
       REDHAT_VERSION=$(cat /etc/redhat-release | grep -oP "CentOS Linux release \K[\w.]+") || true
       VERSION_ARRAY=(${REDHAT_VERSION//./ })
       if [ -z ${REDHAT_VERSION} ]; then
          FORCE_NO_EXPECT=true
          echo "Not using expect approach because we are on a newer version of Redhat"
       else
          if ((${VERSION_ARRAY[0]} >= 8)); then
             FORCE_NO_EXPECT=true
             echo "Not using expect approach because we are on a newer version of Redhat"
          fi
       fi
    fi

    if [ -f /etc/fedora-release ] || [ "$FORCE_NO_EXPECT" = true ]; then
        # on fedora and centos 8 and greater, the expect-based approach doesn't work, so attempt to
        # supply the passphrase by redefining the GPG signature command in the
        # RPM macros definition to take a passphrase-file.
        echo "%__gpg_sign_cmd %{__gpg} \\" >> $RPM_MACROS
        echo "    gpg --no-verbose --no-armor --batch --pinentry-mode loopback \\" >> $RPM_MACROS
        echo "    --passphrase-file $PASSFILE \\" >> $RPM_MACROS
        echo "    %{?_gpg_sign_cmd_extra_args:%{_gpg_sign_cmd_extra_args}} \\" >> $RPM_MACROS
        echo "    %{?_gpg_digest_algo:--digest-algo %{_gpg_digest_algo}} \\" >> $RPM_MACROS
        echo "    --no-secmem-warning \\" >> $RPM_MACROS
        echo "    -u "%{_gpg_name}" -sbo %{__signature_filename} %{__plaintext_filename}" >> $RPM_MACROS

        rpmsign --addsign $INSTALLER
    else
        # on CentOS (and other RedHat platforms), use expect to supply the
        # passphrase "manually"
        /usr/bin/expect << EOD
spawn bash -c "rpmsign --addsign $INSTALLER"
expect "Enter pass phrase:"
send "$PASSPHRASE\r"
expect eof
EOD
    fi

    # dump the contents of the RPM macro files to stdout so that they're
    # visible in the build logs (this helps diagnose signing issues)
    cat $RPM_MACROS

    # restore old rpmacros file if we touched it
    rm -f $RPM_MACROS
    if [ -f "$RPM_MACROS.bak" ]; then
        mv $RPM_MACROS.bak $RPM_MACROS
    fi
else
    # not a deb or rpm; we don't know how to sign this
    echo "Unknown installer extension $EXT."
fi

#!/usr/bin/env bash

set -e

ELEMENTAL2_VERSION="1.2.3"
JSINTEROP_VERSION="1.0.3"

download () {
	echo -- Downloading $1
	curl -L -f -O "$1"
}

# Download elemental2.
mkdir -p elemental2
cd elemental2
download "https://repo1.maven.org/maven2/com/google/elemental2/elemental2-core/${ELEMENTAL2_VERSION}/elemental2-core-${ELEMENTAL2_VERSION}.jar"
download "https://repo1.maven.org/maven2/com/google/elemental2/elemental2-dom/${ELEMENTAL2_VERSION}/elemental2-dom-${ELEMENTAL2_VERSION}.jar"
download "https://repo1.maven.org/maven2/com/google/elemental2/elemental2-promise/${ELEMENTAL2_VERSION}/elemental2-promise-${ELEMENTAL2_VERSION}.jar"
cd ..

# Download jsinterop.
mkdir -p jsinterop
cd jsinterop
download "https://repo1.maven.org/maven2/com/google/jsinterop/base/${JSINTEROP_VERSION}/base-${JSINTEROP_VERSION}.jar"
cd ..

# Download jspecify.
#
# While all of the JARs above bundle both binary (.class) files and source (.java) files into the same archive,
# jspecify does not. GWT needs access to the .java sources for compilation, so we make sure to download both parts.
mkdir -p jspecify
cd jspecify
download "https://repo.maven.apache.org/maven2/org/jspecify/jspecify/1.0.0/jspecify-1.0.0.jar"
download "https://repo.maven.apache.org/maven2/org/jspecify/jspecify/1.0.0/jspecify-1.0.0-sources.jar"
cd ..

#!/usr/bin/env bash

set -f
GROUPID=$1
GROUPINFO=$(getent group $GROUPID)

# okay if no user
if [ $? -ne 0 ]; then
    echo "No group exists with id $GROUPID"
    exit 0
fi

# turn group info into a space-separated array and extract the first element
GROUPINFO=(${GROUPINFO//:/ })
GROUPNAME="${GROUPINFO[0]}"

echo "Removing group $GROUPNAME with conflicting id $GROUPID"

# use appropriate command for group deletion
if hash groupdel 2>/dev/null; then
    groupdel $GROUPNAME
elif hash delgroup 2>/dev/null; then
    delgroup $GROUPNAME
fi

#!/usr/bin/env bash

#
# fix-library-paths.sh
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

if [ "$#" = "0" ]; then
   echo "Usage: $0 [frameworks directory] [prefix] [files]"
   exit 0
fi

# The FILES argument can be a glob, e.g. '*.dylib', which may not exist
# for local package builds (which might only have build components
# for the current architecture).
shopt -s nullglob

DIR="$1"
PREFIX="$2"
FILES="$3"

cd "$DIR"
for FILE in ${FILES}; do

   install_name_tool -id "${FILE}" "${FILE}"

   LIBPATHS=$( \
      otool -L "${FILE}" | \
      tail -n+2 | \
      cut -d' ' -f1 | \
      sed 's|\t||g' | \
      grep -E 'homebrew|local'
   )

   for LIBPATH in ${LIBPATHS}; do
      OLD="${LIBPATH}"
      NEW="${PREFIX}/$(basename "${OLD}")"
      install_name_tool -change "${OLD}" "${NEW}" "${FILE}"
   done

done

#!/usr/bin/env bash

# new-version.sh
#
# A helper script to update and generate version files for RStudio. 
# It should be run from the root directory of the open source repository.
#
# This script is intended to be used when branching for release, or for when creating a new release branch 
# to start work on future development for that release. Upon completion, the script will stage the changes.
# The developer should review these changes, then commit to the repository.
#
#   Branching for Release
#   ---------------------
#   This script can be run to update version files on the main branch for the next release after 
#   a release branch has been created.
#
#   In this scenario, the developer may need to determine if a release branch already exists, and specify 
#   the base commit (or initial fork point) for that branch now that work.
#   
#
#   Creating a Release Branch for future work
#   ----------------------------------------- 
#   When creating a new release branch for future work, the script should be run on the release branch 
#   after it has been created.
#
#   In this scenario, it may be acceptable to use the default [base commit sha], since no prior work 
#   will have been done for the new release yet.
#
# Running the script
# ------------------
# ./new-version.sh <release flower> <calendar version> [base commit sha]
#     i.e., ./new-version.sh "Cherry Blossom" 2023.03 [base commit sha]
#
# The base commit sha is optional. If it is not provided, the script will use the current commit hash.
#   A base commit sha SHOULD be provided if a release branch for the calendar version already exists, 
#   and should be the commit hash of the fork point for the release branch. 
#   This is to ensure we "count" the work that was done on the release branch before starting builds.
#
# This script updates the following files:
# - version/BUILDTYPE: Changes the BUILDTYPE to "Daily"
# - version/RELEASE: Updates the release flower name
# - version/CALENDAR_VERSION: Updates the calendar version
#
# This script also generates the following files:
# - NEWS.md: Creates a new NEWS.md file for the release
# - version/base_commit/<calendar version>.BASE_COMMIT: Adds a new base commit for build number generation

# abort on error
set -e

if [[ "$#" -lt 2 ]]; then
    echo "Usage: new-version.sh <release flower> <calendar version> [base commit sha]"
    echo "       <release flower>   - The name of the release flower (i.e., \"Cherry Blossom\")"
    echo "       <calendar version> - The calendar version (i.e., \"2023.03\")"
    echo "       [base commit sha]  - The base commit sha that should be used for the [flower].BASE_COMMIT file (optional)"
    exit 1
fi

# read arguments
RELEASE_FLOWER=$1
CALENDAR_VERSION=$2

# Read the base commit sha if it was provided
if [[ "$#" -eq 3 ]]; then
    BASE_COMMIT_SHA=$3
else
    BASE_COMMIT_SHA=$(git rev-parse HEAD)
fi

BASE_COMMIT_FLOWER_NAME=$(echo ${RELEASE_FLOWER} | tr '[ ]' '-' | tr -d '[:space:]' | tr '[:upper:]' '[:lower:]')
# Next, check if the base commit file already exists. If it does, we need to exit and provide an error message.
BASE_COMMIT_FILE="version/base_commit/${BASE_COMMIT_FLOWER_NAME}.BASE_COMMIT"
if [ -e $BASE_COMMIT_FILE ]; then
    echo "The $BASE_COMMIT_FILE file already exists." >&2
    exit 1
fi

# Update the BUILDTYPE file
echo "Daily" > version/BUILDTYPE

# Update the RELEASE file
echo "${RELEASE_FLOWER}" > version/RELEASE

# Update the CALENDAR_VERSION file
echo "${CALENDAR_VERSION}" > version/CALENDAR_VERSION

# Update the PATCH file
echo "0" > version/PATCH

# Create a NEWS.md file
{
    echo "## RStudio ${CALENDAR_VERSION}.0 \"$RELEASE_FLOWER\" Release Notes"
    echo ""
    echo "### New"
    echo "-"
    echo ""
    echo "### Fixed"
    echo "-"
    echo ""
    echo "### Dependencies"
    echo "-"
    echo ""
} > NEWS.md


# Create the base commit file using the base commit sha
echo "${BASE_COMMIT_SHA}" > $BASE_COMMIT_FILE

git add version/BUILDTYPE version/RELEASE version/CALENDAR_VERSION NEWS.md $BASE_COMMIT_FILE

# Print a success message
echo "Successfully updated and staged version files and created NEWS.md and $BASE_COMMIT_FILE"
echo "Please commit these changes and push them to the remote repository. i.e., git commit -m \"Update version files for $RELEASE_FLOWER\" && git push"

@echo off

for %%F in ("%~dp0\..\..\dependencies\tools\rstudio-tools.cmd") do (
  set "RSTUDIO_TOOLS=%%~fF"
)

call %RSTUDIO_TOOLS%

%RUN% add-first-to-path ^
	%RSTUDIO_PROJECT_ROOT%\dependencies\common\node\%RSTUDIO_NODE_VERSION% ^
	%RSTUDIO_TOOLS_ROOT%\dependencies\common\node\%RSTUDIO_NODE_VERSION%

%RUN% subprocess "node --version" NODE_VERSION
echo node: %NODE_VERSION%

%RUN% subprocess "npm --version" NPM_VERSION
echo npm: %NPM_VERSION%

goto :eof

#!/usr/bin/env bash

set -e

# read canonical list of flavors from Jenkinsfile
SOURCEDIR=$(dirname "${BASH_SOURCE[0]}")
CONTAINERS=$(cat $SOURCEDIR/../Jenkinsfile | grep "\[os: ")
HOSTLIST=$(echo "$CONTAINERS" | cut -d \' -f 2 | tr '\n' ' ')
PLATFORMLIST=$(echo "$CONTAINERS" | cut -d \' -f 4 | tr '\n' ' ')
FLAVORLIST=$(echo "$CONTAINERS" | cut -d \' -f 6 | tr '\n' ' ')

# convert to formal arrays
IFS=' ' read -a HOSTS <<< "$HOSTLIST"
IFS=' ' read -a PLATFORMS <<< "$PLATFORMLIST"
IFS=' ' read -a FLAVORS <<< "$FLAVORLIST"

# iterate through array and perform a docker compile
for ((i = 0; i < ${#HOSTS[@]}; i++))
do
    echo "=== Building platform $((i+1))/${#HOSTS[@]}: ${HOSTS[$i]} ${FLAVORS[$i]} ==="
    "$SOURCEDIR/docker-compile.sh" "${HOSTS[$i]}-${PLATFORMS[$i]}" "${FLAVORS[$i]}"
done

@echo off
setlocal

REM Run from the script directory; install-soci.R places its build artifacts
REM under RSTUDIO_TOOLS_ROOT when that is set in the environment.
pushd "%~dp0install-soci"
R --vanilla -s -f install-soci.R
if ERRORLEVEL 1 (
  echo !! ERROR: SOCI build failed.
  popd
  exit /b 1
)
popd

#!/usr/bin/env bash
#
# Claude Code PreToolUse hook (Edit|Write matcher).
# Blocks edits to autogenerated files. Receives JSON on stdin with the
# tool invocation payload; inspects .tool_input.file_path.
#
# This script prevents accidental modification of autogenerated files
# in the build/package pipeline. Add file paths to the AUTOGENERATED_FILES
# array below to protect them from manual edits.
#

set -euo pipefail

# Autogenerated files that should not be manually edited.
#
# Each entry is either:
#   - A base name (no extension): matches any .cpp or .hpp file with that name
#     e.g. "UserPrefValues" blocks UserPrefValues.cpp and UserPrefValues.hpp
#   - A filename with extension: exact filename match (any directory)
#     e.g. "SessionUserPrefValues.R" blocks that specific file
#   - A regex pattern (contains [, |, or (): matched against the full path
#     e.g. "UserPrefsAccessor[^/]*\.(java|properties)" blocks all variants
AUTOGENERATED_FILES=(
  # Generated by scripts/generate-prefs.R
  "UserPrefValues"
  "UserStateValues"
  "UserPrefsAccessor[^/]*\.java"
  "UserStateAccessor[^/]*\.java"
  "UserPrefsAccessorConstants_en.properties"
  "UserStateAccessorConstants_en.properties"
  "SessionUserPrefValues.R"

  # Generated by scripts/generate-options.R
  "*.gen.*"

  # Generated during GWT build (ant draft)
  "CmdConstants[^/]*\.java"
  "MenuConstants[^/]*\.java"
  "CmdConstants_en.properties"
  "MenuConstants_en.properties"
  "Commands.cmd.xml.MD5"
)

# Read tool input JSON from stdin (passed by Claude Code PreToolUse hook)
input=$(cat)
file_path=$(echo "$input" | jq -r '.tool_input.file_path // empty') || {
  echo "WARNING: Failed to parse hook input JSON. Blocking as a precaution." >&2
  exit 2
}

if [ -z "$file_path" ]; then
  exit 0
fi

# Returns a remediation message for the matched file.
remediation_message() {
  local path="$1"
  if echo "$path" | grep -qE '(UserPrefValues|UserStateValues|UserPrefsAccessor|UserStateAccessor|SessionUserPrefValues)\b'; then
    echo "Edit the schema in src/cpp/session/resources/schema/ instead, then run: Rscript scripts/generate-prefs.R"
  elif echo "$path" | grep -qE '\.gen\.'; then
    echo "Edit server-options.json or session-options.json instead, then run: Rscript scripts/generate-options.R"
  elif echo "$path" | grep -qE '(CmdConstants|MenuConstants|Commands\.cmd\.xml\.MD5)'; then
    echo "Edit Commands.cmd.xml instead, then build with: cd src/gwt && ant draft"
  else
    echo "This file is autogenerated and should not be manually edited."
  fi
}

# Check if the file being edited matches any autogenerated file pattern
for entry in "${AUTOGENERATED_FILES[@]}"; do
  if [[ "$entry" =~ [\[\|\(] ]]; then
    # Regex pattern: match against full path
    match=$(echo "$file_path" | grep -E "(^|/)${entry}$" || true)
  elif [[ "$entry" == *[\*\?.]* ]]; then
    # Glob-style pattern (contains *, ?, or .): convert to regex
    regex=$(echo "$entry" | sed 's/\./\\./g; s/\*/.*/g')
    match=$(echo "$file_path" | grep -E "(^|/)${regex}$" || true)
  else
    # Base name (no extension): match .cpp or .hpp
    match=""
    for ext in cpp hpp; do
      match=$(echo "$file_path" | grep -E "(^|/)${entry}\.${ext}$" || true)
      if [ -n "$match" ]; then break; fi
    done
  fi

  if [ -n "$match" ]; then
    advice=$(remediation_message "$file_path")
    echo "BLOCKED: '$file_path' is autogenerated. $advice" >&2
    exit 2
  fi
done

#!/usr/bin/env bash

# This script copies Pandoc release binaries into the RStudio Build Tools
# (rstudio-buildtools) S3 bucket. Presumes you've already got AWS command line
# tools (awscli) installed, and configured with a valid AWS account.
# 
# Pandoc is not shy about changing the formulation of their paths and download
# filenames, so tweaking for new releases is expected.

# Modify to set the Pandoc version to upload
PANDOC_VERSION=3.2

BASEURL="https://github.com/jgm/pandoc/releases/download/"
AWS_BUCKET="s3://rstudio-buildtools"

PLATFORMS=(
    linux-amd64.tar.gz
    linux-arm64.tar.gz
    x86_64-macOS.zip
    arm64-macOS.zip
    windows-x86_64.zip
)

for PLATFORM in "${PLATFORMS[@]}"; do

    # Form filename from version and platform
    FILENAME="pandoc-${PANDOC_VERSION}-${PLATFORM}"

    # Download from Pandoc release site
    wget "${BASEURL}/${PANDOC_VERSION}/${FILENAME}"

    # Upload to S3 bucket
    aws s3 cp "${FILENAME}" "${AWS_BUCKET}/pandoc/${PANDOC_VERSION}/" --acl public-read

    # Clean up
    rm -f "${FILENAME}"

done

#!/usr/bin/env bash

# Merge a rel-* branch back into the current branch with the conventions
# this repo relies on. Handles a few release-presentation differences that
# would otherwise either silently corrupt the working tree or require
# manual conflict resolution after every release-branch merge.
#
# Specifically:
#
# 1. Pass `-X no-renames` so git's rename detection does not conflate the
#    rel branch's NEWS.md rename (NEWS.md -> version/news/os/NEWS-<ver>.md)
#    with main's own rotation of NEWS.md. Without this, `--theirs` on the
#    archived NEWS path returns git's three-way merged result rather than
#    the rel branch's actual content, silently corrupting the release notes.
#
# 2. Auto-resolve the expected conflicts:
#    - NEWS.md (deleted-by-them): keep main's rotated copy.
#    - version/news/os/NEWS-<ver>-<codename>.md (both-added): take the rel
#      branch's content, which has any bug-fix entries that landed after
#      the rotation.
#    - Any conflict under a release-only directory (e.g. the whats-new
#      assets): keep main's version, matching the reset policy below.
#
# 3. Reset release-only paths (version/BUILDTYPE, the whats-new assets
#    directory, etc.) to HEAD's value. Git's trivial-merge fast path
#    would otherwise silently take the rel branch's content (e.g.
#    flipping BUILDTYPE from "Daily" to "Release", or pulling in
#    release-finalized whats-new updates) because main has not modified
#    the file since the merge base. The `merge=ours` driver attribute
#    does not help here: it is only consulted when both sides have
#    changed the file, not in the one-sided trivial-merge case.
#
# The branch argument is resolved to a remote-tracking branch (e.g.
# "rel-golden-wattle" becomes "<remote>/rel-golden-wattle") so the merge
# always reflects what is published rather than a possibly-stale local
# copy. Pass a qualified ref like "origin/rel-golden-wattle" to skip the
# inference. The script also fetches the resolved branch before merging.
#
# The script stages a merge commit but does not commit it. Review with
# `git diff --staged` and then `git commit` once satisfied.

set -euo pipefail

if [ $# -lt 1 ]; then
    echo "usage: $0 <branch>" >&2
    echo "" >&2
    echo "Examples:" >&2
    echo "  $0 rel-golden-wattle           # resolves to <remote>/rel-golden-wattle" >&2
    echo "  $0 origin/rel-golden-wattle    # use an already-qualified ref" >&2
    exit 64
fi

BRANCH="$1"

# Move to the repo root.
SCRIPT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
REPO_ROOT="$(cd "$SCRIPT_DIR/.." && pwd)"
cd "$REPO_ROOT"

# Working tree must be clean so the merge state is unambiguous.
if ! git diff-index --quiet HEAD --; then
    echo "error: working tree has uncommitted changes; commit or stash first." >&2
    exit 1
fi

# Files that should always retain main's value after a rel-branch merge,
# regardless of what the rel branch did to them.
RELEASE_ONLY_FILES=(
    version/BUILDTYPE
    version/RELEASE
    version/CALENDAR_VERSION
    version/PATCH
)

# Directories whose contents should always retain main's value after a
# rel-branch merge. Any file under these paths that the merge modified
# (or added on the rel branch side) is reverted to HEAD.
RELEASE_ONLY_DIRS=(
    src/node/desktop/src/assets/whats-new
)

# Always resolve to a remote-tracking branch so the merge picks up what's
# actually published, not a possibly-stale local copy. If the user passes
# a qualified ref (e.g. "origin/rel-golden-wattle"), use it as-is. If they
# pass a bare branch name, prefix it with the remote tracked by the
# current branch (falling back to "origin", then to the first configured
# remote).
ORIGINAL_INPUT="$BRANCH"
REMOTE=""

if [[ "$BRANCH" != refs/* ]]; then
    while IFS= read -r r; do
        [ -n "$r" ] || continue
        if [[ "$BRANCH" == "$r/"* ]]; then
            REMOTE="$r"
            break
        fi
    done < <(git remote)

    if [ -z "$REMOTE" ]; then
        if upstream="$(git rev-parse --abbrev-ref '@{upstream}' 2>/dev/null)" \
            && [[ "$upstream" == */* ]] \
            && git remote get-url "${upstream%%/*}" >/dev/null 2>&1; then
            REMOTE="${upstream%%/*}"
        elif git remote get-url origin >/dev/null 2>&1; then
            REMOTE="origin"
        else
            REMOTE="$(git remote | head -n 1)"
        fi

        if [ -z "$REMOTE" ]; then
            echo "error: no remotes configured; cannot resolve '$BRANCH'." >&2
            exit 1
        fi

        BRANCH="$REMOTE/$BRANCH"
        echo "Resolved '$ORIGINAL_INPUT' -> '$BRANCH'"
    fi
fi

# Refresh the remote-tracking branch so the merge reflects the latest
# published state of the rel branch.
if [ -n "$REMOTE" ]; then
    REMOTE_BRANCH="${BRANCH#$REMOTE/}"
    echo "Fetching $REMOTE $REMOTE_BRANCH..."
    git fetch "$REMOTE" "$REMOTE_BRANCH"
fi

# Do the merge.
echo "Merging $BRANCH (-X no-renames, --no-ff, --no-commit)..."
git merge --no-commit --no-ff -X no-renames "$BRANCH" || true

# Auto-resolve the two expected conflicts.

# (1) NEWS.md "deleted by them": keep main's version. `git add` on a file
# with a UD stage tells git we want our version (the working copy).
if git status --porcelain | grep -Eq '^UD NEWS\.md$'; then
    git add NEWS.md
    echo "  resolved NEWS.md: kept main's version"
fi

# (2) version/news/os/NEWS-<ver>-<codename>.md "both added": take theirs.
while IFS= read -r path; do
    case "$path" in
        version/news/os/NEWS-*.md)
            git checkout --theirs -- "$path"
            git add -- "$path"
            echo "  resolved $path: took rel branch's content"
            ;;
    esac
done < <(git diff --name-only --diff-filter=U)

# (3) Conflicts under release-only directories: main's version always
# wins, same policy the reset pass below applies to paths that merged
# cleanly. If the path exists in HEAD, restore HEAD's content into the
# index and working tree; otherwise remove it. Note `git checkout --ours`
# does not work for all conflict types (e.g. delete/modify, where our
# stage is absent), so prefer the HEAD-based form.
while IFS= read -r path; do
    for d in "${RELEASE_ONLY_DIRS[@]}"; do
        case "$path" in
            "$d"/*)
                if git cat-file -e "HEAD:$path" 2>/dev/null; then
                    git checkout HEAD -- "$path"
                    echo "  resolved $path: kept main's version"
                else
                    git rm -f -- "$path" >/dev/null
                    echo "  resolved $path: removed (not present on main)"
                fi
                break
                ;;
        esac
    done
done < <(git diff --name-only --diff-filter=U)

# Report any remaining (unexpected) conflicts.
remaining="$(git diff --name-only --diff-filter=U)"
if [ -n "$remaining" ]; then
    echo "" >&2
    echo "Unresolved conflicts remain in:" >&2
    echo "$remaining" | sed 's/^/  /' >&2
    echo "" >&2
    echo "Resolve manually, then 'git add' the file(s) and 'git commit'." >&2
    exit 2
fi

# A clean merge with no conflicts means nothing was staged for merging --
# bail out rather than pretend.
MERGE_HEAD_PATH="$(git rev-parse --git-path MERGE_HEAD)"
if [ ! -f "$MERGE_HEAD_PATH" ]; then
    echo "" >&2
    echo "No merge in progress; nothing was changed." >&2
    exit 1
fi

# Restore release-only files to their pre-merge (HEAD) values where the
# merge wandered. During a merge, `git checkout HEAD -- <path>` resets
# both the index and working tree to the pre-merge commit's content.
echo ""
for f in "${RELEASE_ONLY_FILES[@]}"; do
    expected="$(git show "HEAD:$f")"
    actual="$(cat "$f")"
    if [ "$expected" != "$actual" ]; then
        git checkout HEAD -- "$f"
        echo "  reset $f: '$actual' -> '$expected'"
    fi
done

for d in "${RELEASE_ONLY_DIRS[@]}"; do
    while IFS= read -r f; do
        [ -z "$f" ] && continue
        if git cat-file -e "HEAD:$f" 2>/dev/null; then
            git checkout HEAD -- "$f"
            echo "  reset $f"
        else
            git rm -f -- "$f" >/dev/null
            echo "  removed $f (not present on main)"
        fi
    done < <(git diff --cached --name-only HEAD -- "$d")
done

# Summary so a human can eyeball that release-only files are correct.
echo ""
echo "Merge staged. Verify these values look right for main, then commit:"
for f in "${RELEASE_ONLY_FILES[@]}"; do
    printf "  %-32s = %s\n" "$f" "$(cat "$f")"
done
echo ""
echo "Then:  git diff --staged && git commit"

#!/usr/bin/env bash

# This script downloads the Boost + SOCI prebuilt archives produced by the
# "Build Dependencies (Windows, Open Source)" GitHub Actions workflow, and
# copies them into the RStudio Build Tools (rstudio-buildtools) S3 bucket.
# Use it until the workflow can upload to S3 directly; see
# https://github.com/rstudio/rstudio/issues/18124 for details.
#
# Presumes you've got the GitHub CLI (gh) and AWS command line tools (awscli)
# installed, and configured with a valid AWS account.
#
# Usage: upload-windows-dependencies.sh <workflow-run-id>

set -e

if [ -z "$1" ]; then
    echo "Usage: $(basename "$0") <workflow-run-id>"
    echo "Find run ids with: gh run list --workflow os-build-dependencies-windows.yml"
    exit 1
fi

RUN_ID="$1"
AWS_BUCKET="s3://rstudio-buildtools"

# Check that we're logged in with AWS
aws sts get-caller-identity || aws sso login

# Download the prebuilt archives from the workflow run
STAGING=$(mktemp -d)
gh run download "${RUN_ID}" --repo rstudio/rstudio --pattern 'windows-dependencies-*' --dir "${STAGING}"

# Upload Boost archives under Boost/, and SOCI archives at the bucket root,
# matching the paths install-dependencies.cmd downloads from.
find "${STAGING}" -name 'boost-*.zip' | while read -r FILE; do
    aws s3 cp "${FILE}" "${AWS_BUCKET}/Boost/$(basename "${FILE}")" --acl public-read
done

find "${STAGING}" -name 'soci-*.zip' | while read -r FILE; do
    aws s3 cp "${FILE}" "${AWS_BUCKET}/$(basename "${FILE}")" --acl public-read
done

rm -rf "${STAGING}"

# Retrieve latest Quarto version from GitHub

# $response = Invoke-WebRequest -UseBasicParsing -Uri https://quarto.org/docs/download/_download.json
$response = Invoke-WebRequest -UseBasicParsing -Uri https://quarto.org/docs/download/_prerelease.json
$releases = ConvertFrom-Json $response.content
$version = $releases.version
$quartoVersion = $version | Select-String -Pattern '[0-9]+\.[0-9]+\.[0-9]+'
$quartoVersion.Matches.Value

@echo off
setlocal EnableDelayedExpansion

::
:: Script to build RStudio Desktop for Windows using Docker
::
:: Requires a Windows machine, with Docker installed and set to use Windows
:: containers, and the RStudio repo cloned onto the machine. Then simply execute
:: this script from a command prompt in rstudio\docker directory.
::
:: This script will mount the RStudio project directory (from the host) into
:: the container for building, but the build will happen on the container's
:: local filesystem.
::

set "_CLEAN="
set "_BUILD="

for %%A in (%*) do (
    if /I "%%A" == "clean" (
        set _CLEAN=1
    )
)

set IMAGE=windows
set FLAVOR=electron

REM call the docker build image helper
cmd /C win-docker-build-image.cmd

REM move to the repo root (script's parent directory)
cd %~dp0\..
call dependencies\tools\rstudio-tools.cmd


REM determine repo name
for /F "delims=" %%i in ("%CD%") do set REPO=%%~nxi

REM figure out how many CPUs we want to use
set /A "CPUS=%NUMBER_OF_PROCESSORS%/2"
if %CPUS% gtr 8 set "CPUS=8"

REM set up build flags
set "CONTAINER_ID=build-%REPO%-%IMAGE%"
set "HOSTPATH=%CD:\=/%"
set "MAKEFLAGS=-j%NUMBER_OF_PROCESSORS%"

set "PROMPT=> "
@echo on

if defined _CLEAN (
    docker stop %CONTAINER_ID%
    docker rm %CONTAINER_ID%
)

REM Create the container if it doesn't already exist.
docker inspect %CONTAINER_ID% >NUL 2>NUL
if ERRORLEVEL 1 (

    docker create ^
        --name %CONTAINER_ID% ^
        --volume %HOSTPATH%:C:/rstudio:rw ^
        --cpu-count %CPUS% ^
        --memory 16GB ^
        --interactive ^
        %REPO%:%IMAGE% ^
        cmd.exe

    if ERRORLEVEL 1 (
        echo.!! ERROR: docker container creation failed.
        exit /b 1
    )

)

docker start %CONTAINER_ID%

docker exec %CONTAINER_ID% cmd.exe /C ^
    "git config --global --add safe.directory C:/rstudio/"

docker exec %CONTAINER_ID% cmd.exe /C ^
    "cd C:\rstudio-tools\dependencies\windows && C:\rstudio\dependencies\windows\install-dependencies.cmd"

docker exec %CONTAINER_ID% cmd.exe /C setx /M BUILD_DIR C:/build
docker exec %CONTAINER_ID% cmd.exe /C setx /M WIN32_BUILD_PATH C:/build32
docker exec %CONTAINER_ID% cmd.exe /C setx /M RSTUDIO_PROJECT_ROOT C:/rstudio
docker exec %CONTAINER_ID% cmd.exe /C setx /M RSTUDIO_DOCKER_DEVELOPMENT_BUILD 1

docker exec %CONTAINER_ID% cmd.exe /C ^
    "cd C:\rstudio\src\gwt && ant clean"

docker exec %CONTAINER_ID% cmd.exe /C ^
    "cd C:\rstudio\package\win32 && make-package.bat"

docker exec %CONTAINER_ID% cmd.exe /C "mkdir C:\package"
docker exec %CONTAINER_ID% cmd.exe /C "move C:\rsbuild\*.exe C:\package"
docker exec %CONTAINER_ID% cmd.exe /C "move C:\rsbuild\*.zip C:\package"

docker stop %CONTAINER_ID%

@echo off

if "%REPO%" == "rstudio-pro" (
    set PKG_FILENAME=RStudio-pro-99.9.9-RelWithDebInfo
) ELSE (
    set PKG_FILENAME=RStudio-99.9.9-RelWithDebInfo
)

@echo on
mkdir %HOSTPATH%\docker\package 2>NUL
docker cp %CONTAINER_ID%:C:/package %HOSTPATH%/docker
@echo off

#!/usr/bin/env bash

#
# vars.sh -- shared code to define environment variables for Linux builds
#
# Copyright (C) 2025 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

if test -z "$BUILD_DIR"
then
   # set build type (if necessary) and build dir
   if test -z "$CMAKE_BUILD_TYPE"
   then
      CMAKE_BUILD_TYPE=RelWithDebInfo
      BUILD_DIR=build-$RSTUDIO_TARGET-$PACKAGE_TARGET
   else
      BUILD_DIR=build-$RSTUDIO_TARGET-$PACKAGE_TARGET-$CMAKE_BUILD_TYPE
   fi
fi

# make build directory absolute
BUILD_DIR=$(readlink -f "$BUILD_DIR")

# build RStudio version suffix
RSTUDIO_VERSION_ARRAY=(
   "${RSTUDIO_VERSION_MAJOR-99}"
   "${RSTUDIO_VERSION_MINOR-9}"
   "${RSTUDIO_VERSION_PATCH-9}"
)

RSTUDIO_VERSION_FULL=$(IFS="."; echo "${RSTUDIO_VERSION_ARRAY[*]}")"${RSTUDIO_VERSION_SUFFIX}"

@echo off
setlocal

REM Variables defining the build. Update as appropriate.
set BOOST_VERSION=1.90.0
set MSVC_TOOLSET_VERSION=143

REM The file name prefix used for Boost build folders.
set BOOST_PREFIX=boost-%BOOST_VERSION%-win-msvc%MSVC_TOOLSET_VERSION%

REM Make sure our tools are on the PATH.
set PATH=%CD%\tools;%PATH%

REM Build Boost.
cd install-boost
cmd.exe /C R --vanilla -s -f install-boost.R --args debug static
cmd.exe /C R --vanilla -s -f install-boost.R --args release static
cd ..

REM Build the Boost archive for upload to S3.
echo -- Packaging Boost %BOOST_VERSION% ...
7z a -mmt8 -mx9 ^
   %BOOST_PREFIX%.zip ^
   %BOOST_PREFIX%-debug-static ^
   %BOOST_PREFIX%-release-static
echo -- Done!

# PowerShell script to publish a daily Windows binary

param(
    # The type of build, e.g. desktop-pro/windows
    [Parameter(Mandatory)]
    [string]$build, 

    # The URL to the location where the build can be downloaded
    [Parameter(Mandatory)]
    [string]$url, 

    # A path to a file on disk where the build is located
    [Parameter(Mandatory)]
    [string]$file, 

    # The version of the build
    [Parameter(Mandatory)]
    [string]$version,

    # The Github Personal Access PAT to use to publish the build
    [Parameter(Mandatory)]
    [string]$pat,

    # The release channel of the build, Hourly, Daily, Preview or Release
    # Default value if it's not supplied is the contents of the version/BUILDTYPE file
    # Otherwise we validate input and use that
    [Parameter(Mandatory=$false)]
	[ValidateSet("Hourly", "Daily", "Preview", "Release", IgnoreCase=$false)]
    [string]$channel = (Get-Content (Join-Path -Path "version" -ChildPath "BUILDTYPE") | Out-String).Trim()
)

# Function to urlize a string
function URLize {
    param(
        $string
    )

    # Convert to lower case and trim all whitespace
    $string = $string.ToLower()
    $string = $string.Trim()

    # Replace all non-ASCII characters with dashes
    $string = $string -replace "[^a-zA-Z0-9-]", "-"

    # Replace consecutive dashes with single dashes
    $string = $string -replace "--*", "-"

    return $string
}

function Handle409 {
    param(
        $url,
        $payload,
        $headers
    )

    Write-Host "Received a 409, assuming it's a commit interleaving error, waiting 3 seconds and retrying".
    Start-Sleep -Seconds 3

    # Identical call to the original above
    Write-Host "Retrying..."
    $retryCreateResponse = Invoke-RestMethod -Body $payload -Method 'PUT' -Headers $headers -Uri $url -UseBasicParsing
    Write-Host "Response :"
    Write-Host $retryCreateResponse.Content
}

# Extract file metadata
$size = (Get-Item $file).length
$filename = (Get-Item $file).Name
$timestamp = (Get-Date).ToUniversalTime().ToString("yyyy-MM-ddTHH:mm:ss")
$sha256 = (Get-FileHash -Algorithm SHA256 $file).Hash.ToLower()

# Compute path from script directory to version metadata directory
$parent = Split-Path -Path $PSScriptRoot -Parent
$root = Split-Path -Path $parent -Parent
$versionMeta = Join-Path -Path $root -ChildPath "version"

# Extract build metadata
$flower = Get-Content (Join-Path -Path $versionMeta -ChildPath "RELEASE") | Out-String
$flower = URLize -string $flower
$commit = git rev-parse HEAD

$versionStem = URLize -string $version

# Clean up plus symbols in URL
$url = $url.Replace("+", "%2B")

# Form the Markdown file's YAML header
$mdContents = @"
---
type: build
date: $timestamp
link: "$url"
filename: "$filename"
architecture: x86_64
sha256: "$sha256"
channel: "$channel"
version: "$version"
commit: "$commit"
size: $size
---
"@

Write-Host "Creating $flower/$build/$versionStem.md..."
Write-Host $mdContents

# Base64 encode the Markdown/YAML file
$bytes = [System.Text.Encoding]::UTF8.GetBytes($mdContents)
$base64 = [System.Convert]::ToBase64String($bytes)

# Prepare the payload for the Github API
$payload = @"
{ "message": "Add $flower build $version in $build", "content": "$base64" }
"@
Write-Host "Sending to Github: $payload"

# Prepare headers
$headers = @{}
$headers.Add("Accept", "application/vnd.github.v3+json")
$headers.Add("Authorization", "token $pat")

# Prepare the product name, redirects hourly builds to a different page
$product = "rstudio"
if ($channel -eq "Hourly")
{
    $product = $product + "-hourly"
}

$url = "https://api.github.com/repos/rstudio/latest-builds/contents/content/$product/$flower/$build/$versionStem.md"
# Send to Github! We have to use basic parsing here because this script runs on SKU of Windows that
# doesn't contain a working copy of IE (and, incredibly, without -UseBasicParsing, Invoke-WebRequest
# has a dendency on the IE DOM engine).

Write-Host "Writing content to $url"

try
{
    $createResponse = Invoke-RestMethod -Body $payload -Method 'PUT' -Headers $headers -Uri $url -UseBasicParsing
    Write-Host "Response :"
    Write-Host $createResponse.Content
} catch {
    $StatusCode = $_.Exception.Response.StatusCode.value__
    
    if ($StatusCode -eq 422) # Assume the file already exists and we need to do an update
    {
        Write-Host "Received a 422 error, assuming it's an issue updating. Getting existing file's SHA"
        $getSha = Invoke-RestMethod -Method 'GET' -Headers $headers -Uri $url -UseBasicParsing
        Write-Host "Github Response:"
        Write-Host $getSha
        $updateSha = $getSha.sha

        # This looks messy but the whitespace is meaningful
        $payload = @"
{ "message": "Update $flower build $version in $build", "content": "$base64", "sha": "$updateSha" }
"@
        try {
            Write-Host "Updating version file..."
            $updateResponse = Invoke-RestMethod -Body $payload -Method 'PUT' -Headers $headers -Uri $url -UseBasicParsing
            Write-Host "Response :"
            Write-Host $updateResponse.Content
        } catch {
            $StatusCode = $_.Exception.Response.StatusCode.value__

            if ($StatusCode -eq 409)
            {
                Handle409 -url $url -payload $payload -headers $headers
            }
            else 
            {
                Write-Host "Received an unexpected error code: $StatusCode"
            }
        }
    }
    
    if ($StatusCode -eq 409) { # Assume the repo has been updated backoff and try again.
        Handle409 -url $url -payload $payload -headers $headers
    }
}

::
:: run-unit-tests.cmd
::
:: Copyright (C) 2022 by Posit Software, PBC
::
:: Unless you have received this program directly from Posit Software pursuant
:: to the terms of a commercial license agreement with Posit Software, then
:: this program is licensed to you under the terms of version 3 of the
:: GNU Affero General Public License. This program is distributed WITHOUT
:: ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
:: MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
:: AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
::

@echo off
setlocal

call envvars.bat
echo Executing Electron unit tests
set RSTUDIO_DOCKER_WINDOWS=1
npm test
endlocal

#!/usr/bin/env bash

# RStudio Docker Compilation Helper
#
# The purpose of this script is to make it easy to compile under Docker on 
# a development machine, so it's easy to iterate when making platform-specific
# changes or configuration changes.
# 
# The syntax is as follows:
#
#     docker-compile.sh IMAGE-NAME FLAVOR-NAME [VERSION]
#
# where the image name is the platform and architecture, the flavor name is
# the kind of package you wish to build (electron or server), and the
# version is the number to assign to the resulting build.
#
# For example:
# 
#     docker-compile.sh rhel8 electron 1.2.345
#
# will produce an RPM of RStudio Electron from the RHEL8 container, 
# with build version 1.2.345, in your package/linux/ directory.
#
# For convenience, this script will build the required image if it doesn't
# exist, but for efficiency, this script does not attempt rebuild the image if
# it's already built. If you're iterating on the Dockerfiles themselves, you'll
# want to use "docker build" directly until you're happy with the
# configuration, then use this script to test a build under the new config.
#
# By default, the script will build packages that match the architecture of the
# host machine -- i.e. you will get AMD64 builds or ARM64 builds depending on 
# your processor's architecture. To force a mismatch, set the environment 
# variable CONTAINER_ARCH to "amd64" or "arm64".
#
# To produce a debug build, set the environment variable CMAKE_BUILD_TYPE to
# "Debug" before invoking the script.

# friendly names for arguments
IMAGE=$1
FLAVOR=$2
VERSION=$3

# abort on error
set -e

# set destination folder
PKG_DIR=$(pwd)/package
mkdir -p "$PKG_DIR"

# move to the repo root (script's grandparent directory)
cd "$(dirname "${BASH_SOURCE[0]}")/.."
REPO=$(basename "$(pwd)")

if [ "${IMAGE:0:7}" = "windows" ]; then
    echo -e "Use win-docker-compile.cmd in a Windows Command Prompt to build for Windows."
    exit 1
fi

# print usage if no argument supplied
if [ -z "$IMAGE" ] || [ -z "$FLAVOR" ]; then
    echo -e "Compiles RStudio inside a Docker container."
    echo -e "Usage: docker-compile.sh image-name flavor-name [version] [variant]\n"
    echo -e "Valid images:\n"
    find docker/jenkins -name 'Dockerfile.*' | sed -e 's/.*Dockerfile.//' | sort
    echo -e "\nValid flavors:\n"
    echo -e "electron"
    echo -e "server"
    exit 1
fi

# set container architecture from system architecture (if unspecified)
SYSTEM_ARCH=$(uname -m)
if [ -z "$CONTAINER_ARCH" ]; then
   if [ "$SYSTEM_ARCH" = "aarch64" ] || [ "$SYSTEM_ARCH" = "arm64" ]; then
      CONTAINER_ARCH="arm64"
   else
      CONTAINER_ARCH="amd64"
   fi
else
   echo "Building package for ${CONTAINER_ARCH} (system architecture is ${SYSTEM_ARCH})"
fi

# form image tag from container architecture
IMAGE_TAG="${IMAGE}-${CONTAINER_ARCH}"

# check to see if there's already a built image
IMAGEID=$(docker images "$REPO:$IMAGE_TAG" --format "{{.ID}}")
if [ -z "$IMAGEID" ]; then
    echo "No image found for $REPO:$IMAGE_TAG."
else
    echo "Found image $IMAGEID for $REPO:$IMAGE_TAG."
fi

# add architecture to build arguments
BUILD_ARGS=(--build-arg ARCH="${CONTAINER_ARCH}")

# get build arg env vars, if any
if [ -n "${DOCKER_GITHUB_LOGIN}" ]; then
  BUILD_ARGS+=(--build-arg GITHUB_LOGIN="${DOCKER_GITHUB_LOGIN}")
fi

# rebuild the image if necessary
docker build                                \
  --tag "$REPO:$IMAGE_TAG"                  \
  --file "docker/jenkins/Dockerfile.$IMAGE" \
  "${BUILD_ARGS[@]}"                        \
  .

# infer the package extension from the image name
if [ "${IMAGE:0:6}" = "fedora" ]; then
    PACKAGE=RPM
    INSTALLER=yum
elif [ "${IMAGE:0:4}" = "rhel" ]; then
    PACKAGE=RPM
    INSTALLER=yum
elif [ "${IMAGE:0:8}" = "opensuse" ]; then
    PACKAGE=RPM
    INSTALLER=zypper
else
    PACKAGE=DEB
    INSTALLER=debian
fi

if [ -n "$VERSION" ]; then
    SPLIT=(${VERSION//[-+]/ })
    FIRST_HALF=(${SPLIT[0]//\./ })

    # determine major and minor versions
    ENV="RSTUDIO_VERSION_MAJOR=${FIRST_HALF[0]} RSTUDIO_VERSION_MINOR=${FIRST_HALF[1]} RSTUDIO_VERSION_PATCH=${FIRST_HALF[2]}"

    # supply suffix
    if [[ ${#SPLIT[@]} -gt 2 ]]; then
        ENV="$ENV RSTUDIO_VERSION_SUFFIX=-${SPLIT[1]}+${SPLIT[2]}"
    else
        ENV="$ENV RSTUDIO_VERSION_SUFFIX=+${SPLIT[1]}"
    fi
fi

# set up build flags
ENV="$ENV GIT_COMMIT=$(git rev-parse HEAD)"
ENV="$ENV BUILD_ID=local"

# infer make parallelism
if [ "$(uname)" = "Darwin" ]; then
    # macos; Docker for Mac defaults to half of host's cores
    JVALUE=$(( `sysctl -n hw.ncpu` / 2 ))
    ENV="$ENV MAKEFLAGS=-j${JVALUE}"
elif hash nproc 2>/dev/null; then
    # linux
    ENV="$ENV MAKEFLAGS=-j$(nproc --all)"
fi

# forward build type if set
if [ -n "$CMAKE_BUILD_TYPE" ]; then
    ENV="$ENV CMAKE_BUILD_TYPE=$CMAKE_BUILD_TYPE"
fi

# adjust folder path when building debug
if [ "$CMAKE_BUILD_TYPE" = "Debug" ]; then
    FLAVOR_SUFFIX="-Debug"
fi

if [ "$CMAKE_BUILD_TYPE" = "Release" ]; then
    FLAVOR_SUFFIX="-Release"
fi

# remove previous image if it exists
CONTAINER_ID="build-$REPO-$IMAGE_TAG"
echo "Cleaning up container $CONTAINER_ID if it exists..."
docker rm "$CONTAINER_ID" || true

# form build command ---

# create and enter package build directory
CMD="mkdir /package &&"
CMD="${CMD} cd /package &&"

# perform the actual compile step w/ clean
CMD="${CMD} $ENV /src/package/linux/make-package ${FLAVOR^} ${PACKAGE} clean &&"

# output the name of the built package (will be captured later)
CMD="${CMD} echo build-${FLAVOR^}-${PACKAGE}/*.${PACKAGE,,} &&"
CMD="${CMD} ls build-${FLAVOR^}-${PACKAGE}${FLAVOR_SUFFIX}/*.${PACKAGE,,}"

echo "Running build command:"
echo "${CMD}"

# run compile step!
docker run                 \
  --name "$CONTAINER_ID"   \
  --volume "$(pwd):/src"   \
  "$REPO:$IMAGE_TAG" bash -c "${CMD}"

# extract logs to get filename (should be on the last line)
PKG_FILENAME=$(docker logs --tail 1 "$CONTAINER_ID")

if [ "${PKG_FILENAME:0:6}" = "build-" ]; then
  docker cp "$CONTAINER_ID:/package/$PKG_FILENAME" "$PKG_DIR"
  echo "Packages produced"
  echo "-----------------"
  echo "$PKG_FILENAME"
else
  echo "No package found."
fi

# stop the container
docker stop "$CONTAINER_ID"
echo "Container image saved in $CONTAINER_ID."

#!/usr/bin/env bash

#
# rstudio-tools.sh -- Bash toolkit used in dependency scripts
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

# Shared Environment Variables ----

# pick a default RSTUDIO_TOOLS_ROOT location
#
# prefer using home folder on Jenkins where we might not be able
# to access files at /opt and will lack sudo
#
# TODO: Remove this indirection in the future.
if [ -z "${RSTUDIO_TOOLS_ROOT}" ]; then
	if [ -n "${JENKINS_URL}" ] && [ "$(arch)" = "arm64" ]; then
		RSTUDIO_TOOLS_ROOT="$HOME/opt/rstudio-tools/$(uname -m)"
	else
		RSTUDIO_TOOLS_ROOT="/opt/rstudio-tools/$(uname -m)"
	fi
fi

export RSTUDIO_TOOLS_ROOT


# RStudio dependency cache
export RSTUDIO_BUILDTOOLS="https://rstudio-buildtools.s3.amazonaws.com"


#
# macOS deployment target
#
# Note that CMake reads this environment variable when choosing a default
# deployment target for builds.
#
# https://cmake.org/cmake/help/latest/envvar/MACOSX_DEPLOYMENT_TARGET.html
#
export MACOSX_DEPLOYMENT_TARGET="12.0"


# version of node.js used for building
#
# When changing node version you must upload the corresponding archives to aws s3; use
# rstudio/dependencies/tools/upload-node.sh
#
# In addition to updating the version here, search the entire repo for other instances of
# RSTUDIO_NODE_VERSION and update to match.
export RSTUDIO_NODE_VERSION="22.22.2"

# version of node.js installed with the product
#
# In the dependencies folder this will have a `-installed` suffix on the folder name to indicate
# that everything except the node binary has been removed.
#
# When changing node version you must upload the corresponding archives to aws s3; use
# rstudio/dependencies/tools/upload-node.sh
#
# In addition to updating the version here, search the entire repo for other instances of
# RSTUDIO_INSTALLED_NODE_VERSION and update to match.
export RSTUDIO_INSTALLED_NODE_VERSION="22.22.2"

# actual directory name of the node installation used
# mainly relevant for cases like macOS, where we have an -arm64 variant installed
if [ "$(uname -sm)" = "Darwin arm64" ]; then
	export RSTUDIO_NODE_DIR="${RSTUDIO_NODE_VERSION}-arm64"
else
	export RSTUDIO_NODE_DIR="${RSTUDIO_NODE_VERSION}"
fi

# version of go used for building
export WORKBENCH_GO_VERSION="1.24.5"


# Initialize ----

# Make sure AWS CLI is available on the PATH
if ! command -v aws &> /dev/null; then
	PATH="${RSTUDIO_TOOLS_ROOT}/aws-cli/bin:${PATH}"
	hash -r
fi


# Generic Tools ----

all-defined () {
	
	for VAR in "$@"; do
		if [ -z "${!VAR}" ]; then
			return 1
		fi
	done

	return 0

}

section () {
	echo -e "\033[1m\033[36m==>\033[39m $*\033[0m"
}

subsection () {
	echo -e "\033[1m\033[36m---\033[39m $*\033[0m"
}

info () {
	echo -e "\033[1m[I]\033[0m $*"
}

warn () {
	echo -e "\033[1m\033[31m[W]\033[0m $*"
}

error () {

	echo -e "\033[1m\033[31m[E]\033[0m $*"

	if [ "${BASH_SUBSHELL}" -eq 0 ]; then
		return 1
	else
		exit 1
	fi

}

yay ()  { 
   echo -e "\033[1;48:5:22m ✔ \033[0m \033[1m$@\033[0m"
}

set-default () {

	if [ "$#" = "0" ]; then
		cat <<- EOF
		Usage: set-default var val

		Set the value of a variable if it is unset.
		EOF
		return 0
	fi

	local VAR="$1"
	local VAL="$2"

	if [ -z "${!VAR}" ]; then
		eval "$VAR=$VAL"
	fi

}

rerun-as-root () {
	exec sudo -E /bin/bash "$0" "$@"
}

sudo-if-necessary-for () {

	# If the directory does not exist, try to create it
	if ! [ -e "$1" ]; then
		if mkdir -p "$1" &> /dev/null; then
			return 0
		fi
	fi

	# Otherwise, check if the directory is writable
	if ! [ -w "$1" ]; then
		echo "Execution of '$0' requires root privileges for access to '$1'"
		shift
		rerun-as-root "$@"
	fi

}

mkdir-sudo-if-necessary () {

	# If the directory does not exist, try to create it without sudo
	if ! [ -e "$1" ]; then
		mkdir -p "$1" &> /dev/null || true
	fi

	# Still not there, create with sudo
	if ! [ -e "$1" ]; then
		sudo -E mkdir -p "$1"
	fi

}

find-file () {

	if [ "$#" -lt 2 ] || [ "$1" = "--help" ]; then
		echo "Usage: find-file <var> [paths]"
		return 0
	fi

	local VAR="$1"
	shift

	if [ -n "${!VAR}" ]; then
		info "Found ${VAR}: ${!VAR} [cached]"
		return 0
	fi

	local FILE
	for FILE in "$@"; do
		if [ -e "${FILE}" ]; then
			info "Found ${VAR}: ${FILE}"
			echo "${VAR}=${FILE}"
			eval "${VAR}=${FILE}"
			return 0
		fi
	done

	error "could not find file"

}

# Aliases over 'pushd' and 'popd' just to suppress printing of
# the directory stack on stdout
pushd () {
	command pushd "$@" > /dev/null
}

popd () {
	command popd "$@" > /dev/null
}

# Detect whether a command is available (e.g. program on the PATH,
# Bash builtin, or otherwise)
has-command () {
	command -v "$1" &> /dev/null
}

has-program () {
	command -v "$1" &> /dev/null
}

find-program () {

	if [ "$#" -lt 2 ] || [ "$1" = "--help" ]; then
		echo "Usage: find-program <var> <program> [paths...]"
		return 0
	fi

	# read variable
	local VAR="$1"
	shift

	# if the variable is already set, bail
	if [ -n "${!VAR}" ]; then
		info "Found ${VAR}: ${!VAR} [cached]"
		return 0
	fi

	# read program name
	local PROGRAM="$1"
	shift

	# search for program in specified paths
	for DIR in "$@"; do
		local VAL="${DIR}/${PROGRAM}"
		if [ -f "${VAL}" ]; then
			info "Found ${VAR}: ${VAL}"
			eval "${VAR}=${VAL}"
			return 0
		fi
	done

	# if we couldn't find it, look for copy on the PATH
	local CANDIDATE=$(which "${PROGRAM}")
	if [ -n "${CANDIDATE}" ]; then
		info "Found ${PROGRAM}: ${CANDIDATE}"
		eval "${VAR}=${CANDIDATE}"
		return 0
	fi

	# failed to find program
	error "could not find program '${PROGRAM}'"

}

require-program () {
	if ! has-program "$1"; then
		error "required program '$1' is not available on the PATH"
	fi
}

is-verbose () {
	[ -n "${VERBOSE}" ] && [ "${VERBOSE}" != "0" ]
}

is-m1-mac () {
	[ "$(arch)" = "arm64" ] && [ "$(uname)" = "Darwin" ]
}

# Download a single file
download () {

	if [ "$#" -eq 0 ]; then
		echo "usage: download src [dst]"
		return 1
	fi

	# Compute source path
	local SRC="$1"

	# Compute destination path
	local DST
	if [ "$#" -eq 1 ]; then
		DST="$(basename "$SRC")"
	else
		DST="$2"
	fi

	if is-verbose; then
		echo -e "Downloading:\n- '$SRC' -> '$DST'"
	fi

	# Invoke downloader
	if has-command curl; then
		curl -L -f -C - "$SRC" > "$DST"
	elif has-command wget; then
		wget -c "$SRC" -O "$DST"
	else
		echo "no downloader detected on this system (requires 'curl' or 'wget')"
		return 1
	fi

}

# Extract an archive
extract () {
	local FILE="$1"

	if is-verbose; then
		echo "Extracting '$FILE' ..."
	fi

	case "${FILE}" in

		*.deb)
			dpkg -x "${FILE}"
		;;

		*.rpm)
			rpm2cpio "${FILE}" | cpio -idmv
		;;

		*.tar.gz)
			tar -xf "${FILE}"
		;;

		*.tar.xz)
			tar -xf "${FILE}"
		;;

		*.gz)
			gunzip "${FILE}"
		;;

		*.zip)
			unzip -o "${FILE}"
		;;

		*)
			echo "Don't know how to extract file '${FILE}'"
			return 1
		;;

	esac
}

is-interactive () {
   [ -t 0 ]
}

# Platform Detection ----

platform () {

	# Detect macOS variants
	if [ "$(uname)" = "Darwin" ]; then
		echo "darwin"
		return 0
	fi

	# Detect platform ID using /etc/os-release when available
	if [ -f /etc/os-release ]; then
		local ID="$(. /etc/os-release; echo "$ID")"
		if [ -n "${ID}" ]; then
			echo "${ID}"
			return 0
		fi
	fi

	# Detect platform using /etc/redhat-release when available
	if [ -f /etc/redhat-release ]; then

		# Detect CentOS
		if grep -siq "centos" /etc/redhat-release; then
			echo "centos"
			return 0
		fi

		# Detect Fedora
		if grep -siq "fedora" /etc/redhat-release; then
			echo "fedora"
			return 0
		fi

		# Detect Rocky Linux (used for RHEL8)
		if grep -siq "rocky" /etc/redhat-release; then
			echo "rocky"
			return 0
		fi

		# Warn about other RedHat flavors we don't yet recognize
		echo "unrecognized redhat variant '$(cat /etc/redhat-release)'"
		return 1
	fi

	echo "unrecognized platform detected"
	return 1
}

ubuntu-codename () {
	# try reading codename from /etc/os-release
	local CODENAME="$(. /etc/os-release; echo "${UBUNTU_CODENAME}")"
	if [ -n "${CODENAME}" ]; then
		echo "${CODENAME}"
		return 0
	fi

	# hard-coded values for older Ubuntu
	case "$(os-version)" in

	12.04) echo "precise" ;;
	12.10) echo "quantal" ;;
	13.04) echo "raring"  ;;
	13.10) echo "saucy"   ;;
	14.04) echo "trusty"  ;;
	14.10) echo "utopic"  ;;
	15.04) echo "vivid"   ;;
	15.10) echo "wily"    ;;
	16.04) echo "xenial"  ;;
	*)     echo "unknown"; return 1 ;;

	esac

	return 0
}

# Get the operating system version (as a number)
os-version () {

	if [ -f /etc/os-release ]; then
		local VERSION_ID="$(. /etc/os-release; echo "${VERSION_ID}")"
		if [ -n "${VERSION_ID}" ]; then
			echo "${VERSION_ID}"
			return 0
		fi
	fi

	if [ -f /etc/redhat-release ]; then
		grep -oE "[0-9]+([_.-][0-9]+)*" /etc/redhat-release
		return 0
	fi

	if has-command sw_vers; then
		sw_vers -productVersion
		return 0
	fi

	echo "don't know how to infer OS version for platform '$(platform)'"
	return 1

}

os-version-part () {

	local VERSION="$(os-version | cut -d"." -f"$1")"

	if [ -n "${VERSION}" ]; then
		echo "${VERSION}"
		return 0
	fi

	echo "0"
	return 0

}

os-version-major () {
	os-version-part 1
}

os-version-minor () {
	os-version-part 2
}

os-version-patch () {
	os-version-part 3
}

# Helper functions for quickly checking platform types
is-mac () {
	[ "$(uname)" = "Darwin" ]
}

is-macos () {
	[ "$(uname)" = "Darwin" ]
}

is-darwin () {
	[ "$(uname)" = "Darwin" ]
}

is-linux () {
	[ "$(uname)" = "Linux" ]
}

is-redhat () {
	[ -f /etc/redhat-release ]
}

is-rhel () {
	[ "$(platform)" = "rocky" ]
}

is-fedora () {
	[ "$(platform)" = "fedora" ]
}

is-opensuse () {
	[ "$(platform)" = "opensuse" ]
}

is-ubuntu () {
	[ "$(platform)" = "ubuntu" ]
}

is-amazon () {
	[ "$(platform)" = "amzn" ]
}

is-jenkins () {
	[ -n "${JENKINS_URL}" ]
}

# create a copy of a file in the same folder with .original extension
save-original-file () {

	local ORIGINAL_FILE="$1"
	local SAVED_FILE="$1.original"
	cp $ORIGINAL_FILE $SAVED_FILE
}

# restore a file previously saved with save-original-file
restore-original-file () {

	local ORIGINAL_FILE="$1"
	local SAVED_FILE="$1.original"
	local MODIFIED_FILE="$1.modified"

	rm -f $MODIFIED_FILE
	mv $ORIGINAL_FILE $MODIFIED_FILE
	mv $SAVED_FILE $ORIGINAL_FILE
	rm -f $MODIFIED_FILE
}

# Checks if environment variables are set (takes one or more env var names as arguments)
check_env_vars() {
	local all_set=0
	for var in "$@"; do
		if [ -z "${!var}" ]; then
			echo "internal error: environment variable '$var' is not set."
			all_set=1
		fi
	done
	return $all_set
}

call vcvarsall.bat amd64
cd sqlite
cd sqlite-*
cl /c /EHsc /MDd sqlite3.c
lib /OUT:sqlite3-debug-x64.lib sqlite3.obj
move sqlite3-debug-x64.lib ..
cl /c /EHsc /MD sqlite3.c
lib /OUT:sqlite3-release-x64.lib sqlite3.obj
move sqlite3-release-x64.lib ..
call vcvarsall.bat x86
cl /c /EHsc /MDd sqlite3.c
lib /OUT:sqlite3-debug-x86.lib sqlite3.obj
move sqlite3-debug-x86.lib ..
cl /c /EHsc /MD sqlite3.c
lib /OUT:sqlite3-release-x86.lib sqlite3.obj
move sqlite3-release-x86.lib ..

#!/usr/bin/env bash

# publish-daily-binary.sh

# abort on error
set -e

if [[ "$#" -lt 2 ]]; then
    echo "Usage: publish-daily-binary.sh [https://url/to/binary/rstudio.deb] [identity.pem]"
    exit 1
fi

# get name of package to publish
URL=$1
IDENTITY=$2
FILENAME="${URL##*/}"

# Don't publish redirects for hourly builds
if [[ "$FILENAME" =~ "hourly" ]]; then
    echo "Skipping publishing of hourly build"
    exit 0
fi

# parse the URL into components; save/restore IFS (field separator)
OLDIFS="$IFS"
IFS='/'
read -ra COMPONENTS <<< "$URL"
IFS="$OLDIFS"

# ensure sufficient components
if [[ ${#COMPONENTS[@]} -lt 6 ]]; then
    echo "Unexpected URL format '$URL'"
    exit 1
fi

# parse URL components to extract flavor/OS/platform
FLAVOR=${COMPONENTS[3]}
OS=${COMPONENTS[4]}
# linux uses: /flavor/os/platform but windows/mac only have /flavor/os
if [ "$OS" == "macos" ] || [ "$OS" == "windows" ];  then
   PLATFORM=""
else
   PLATFORM=${COMPONENTS[5]}
fi

# sanity check a URL component to fail faster if the URL is not in the format
# we expect
if [ "$FLAVOR" != "server" ] && [ "$FLAVOR" != "electron" ]; then
    echo "Unsupported flavor '$FLAVOR' (expected 'electron' or 'server')"
    exit 1
fi

# macOS => mac for URL
if [ "$OS" == "macos" ];  then
    OS="mac"
fi

# The links for latest now always point to desktop since we don't do all of the gwt desktop builds
if [ "$FLAVOR" == "electron" ] ; then
    FLAVOR="desktop"
fi

# figure out the "latest" package name by replacing the version number with "latest"; for example
# for "rstudio-workbench-2021.09.0-daily-123.pro1.deb", we want "rstudio-workbench-latest.deb"
if [[ $FILENAME =~ "preview" ]] ; then
   LATEST=$(echo "$FILENAME" | sed -e 's/[[:digit:]][[:digit:]][[:digit:]][[:digit:]]\.[[:digit:]][[:digit:]]\.[[:digit:]][[:digit:]]*-preview-[[:digit:]][[:digit:]]*\(\.pro[[:digit:]][[:digit:]]*\)*/latest/')
else
   LATEST=$(echo "$FILENAME" | sed -e 's/[[:digit:]][[:digit:]][[:digit:]][[:digit:]]\.[[:digit:]][[:digit:]]\.[[:digit:]][[:digit:]]*-daily-[[:digit:]][[:digit:]]*\(\.pro[[:digit:]][[:digit:]]*\)*/latest/')
fi

echo "Publishing $FILENAME as daily $FLAVOR build for $OS ($PLATFORM): $LATEST..."

# download the current .htaccess file to a temporary location
HTACCESS=$(mktemp)
SCP_COUNT=0
echo "Fetching .htaccess for update..."
until scp -o StrictHostKeyChecking=no -i $IDENTITY www-data@rstudio.org:/srv/www/rstudio.org/public_html/download/latest/daily/.htaccess $HTACCESS || (( SCP_COUNT++ >= 5))
do
   echo "Error fetching .htaccess - retrying: ${SCP_COUNT}"
   sleep 5
done

if [ "$SCP_COUNT" -ge "5" ] ; then
   echo "Error fetching .htaccess - giving up after ${SCP_COUNT} retries"
   exit
fi

# .htaccess expects URL encoded URLs so replace the + with %2B
ENC_URL=`echo $URL | sed -e 's/+/%2B/'`

if grep "/${FLAVOR}/${OS}/${LATEST}" $HTACCESS > /dev/null ; then

   # replace existing redirect
   sed -i.bak "s/${FLAVOR}\/${OS}\/${LATEST} .*/${FLAVOR}\/${OS}\/${LATEST} ${ENC_URL//\//\\/}/" $HTACCESS

   echo "Updated daily URL https://rstudio.org/download/latest/daily/${FLAVOR}/${OS}/${LATEST} to ${ENC_URL}"
else
   echo "  - daily URL - not found - appending new entry:"
   echo "Redirect 302 /download/latest/daily/${FLAVOR}/${OS}/${LATEST} ${ENC_URL}"
   echo "Redirect 302 /download/latest/daily/${FLAVOR}/${OS}/${LATEST} ${ENC_URL}" >> $HTACCESS
fi

# copy it back up
echo "Uploading new .htaccess..."
SCP_COUNT=0
until scp -o StrictHostKeyChecking=no -i $IDENTITY $HTACCESS www-data@rstudio.org:/srv/www/rstudio.org/public_html/download/latest/daily/.htaccess || (( SCP_COUNT++ >= 5))
do
   echo "Error updating .htaccess with scp - retrying: ${SCP_COUNT}"
   sleep 5
done

if [ "$SCP_COUNT" -ge "5" ] ; then
   echo "Error updating .htaccess - giving up after ${SCP_COUNT} retries"
   exit
fi

# clean up
rm -f $HTACCESS
rm -f $HTACCESS.bak

#!/usr/bin/env bash

# upload-node.sh
#
# This script copies node.js packages into the RStudio Build Tools
# (rstudio-buildtools) S3 bucket. Presumes you've already got AWS command line
# tools (awscli) installed, and configured with a valid AWS account.

# The node.js version used for building is set by RSTUDIO_NODE_VERSION and the version
# installed with the RStudio IDE by RSTUDIO_INSTALLED_NODE_VERSION.

# Modify to set the node.js version to upload
NODE_VERSION="v22.22.2"

# Check that we're logged in with AWS
aws sts get-caller-identity || aws sso login

BASEURL="https://nodejs.org/dist"
AWS_BUCKET="s3://rstudio-buildtools"

PLATFORMS=(
    darwin-arm64.tar.gz
    darwin-x64.tar.gz
    linux-arm64.tar.gz
    linux-x64.tar.gz
    win-x64.zip
    win-arm64.zip
)

for PLATFORM in "${PLATFORMS[@]}"; do

    # Form filename from version and platform
    FILENAME="node-${NODE_VERSION}-${PLATFORM}"

    # Download from node.js release site
    wget -c "${BASEURL}/${NODE_VERSION}/${FILENAME}"

    # Upload to S3 bucket
    aws s3 cp "${FILENAME}" "${AWS_BUCKET}/node/${NODE_VERSION}/" --acl public-read

done

@echo off
setlocal EnableDelayedExpansion

:: Resolve paths relative to this script (not the current directory), so the
:: tracked install scripts can be run from anywhere.
for %%F in ("%~dp0..\tools\rstudio-tools.cmd") do (
  set "RSTUDIO_TOOLS=%%~fF"
)

echo -- Using RStudio tools: %RSTUDIO_TOOLS%
call %RSTUDIO_TOOLS%

:: The source-tree directories holding the (tracked) install scripts. The
:: dependencies themselves are downloaded and installed into
:: RSTUDIO_TOOLS_ROOT (set by rstudio-tools.cmd if not already defined in
:: the environment), so that downloaded artifacts live outside the source
:: tree. Set RSTUDIO_TOOLS_ROOT to the root of an RStudio checkout to
:: reproduce the legacy in-tree layout.
set "WINDOWS_SCRIPTS_DIR=%~dp0"
for %%F in ("%~dp0..\common") do (
  set "COMMON_SCRIPTS_DIR=%%~fF"
)

set "COMMON_INSTALL_DIR=%RSTUDIO_TOOLS_ROOT%\dependencies\common"
set "WINDOWS_INSTALL_DIR=%RSTUDIO_TOOLS_ROOT%\dependencies\windows"

if not exist "%COMMON_INSTALL_DIR%" mkdir "%COMMON_INSTALL_DIR%"
if not exist "%WINDOWS_INSTALL_DIR%" mkdir "%WINDOWS_INSTALL_DIR%"

echo -- Installing dependencies to: %RSTUDIO_TOOLS_ROOT%\dependencies

set PATH=%WINDOWS_SCRIPTS_DIR%tools;%PATH%

set BOOST_VERSION=1.91.0
set GNUGREP_VERSION=3.0
set GWT_VERSION=2.12.2-apple-blossom
set LIBCLANG_VERSION=13.0.1
set MATHJAX_VERSION=2.7.9
REM The MSVC toolset used for Boost prebuilts. Can be set in the environment
REM to select a different set of prebuilts (e.g. 145 for Visual Studio 2026).
if not defined MSVC_TOOLSET_VERSION set MSVC_TOOLSET_VERSION=143
set NSPROCESS_VERSION=1.6
set OPENSSL_VERSION=3.1.4
set PANDOC_VERSION=3.2
set QUARTO_VERSION=1.9.38
set COPILOT_VERSION=1.509.1
set SUMATRA_VERSION=3.1.2
set WINUTILS_VERSION=1.0

set CLEAN=0
set QUIET=0
for %%A in (%*) do (

  if /I "%%A" == "clean" (
    set CLEAN=1
  )

  if /I "%%A" == "quiet" (
    set QUIET=1
  )

)

REM Check for required tools on the PATH.
for %%X in (R.exe 7z.exe cmake.exe curl.exe) do (
  where /q %%X
  if ERRORLEVEL 1 (
    echo ^^!^^! ERROR: %%X is not available on the PATH; cannot proceed.
    exit /b
  )
)

set QUARTO_URL=https://github.com/quarto-dev/quarto-cli/releases/download/v%QUARTO_VERSION%/quarto-%QUARTO_VERSION%-win.zip
set QUARTO_FOLDER=quarto
set QUARTO_OUTPUT=quarto


set COPILOT_URL=copilot-language-server/%COPILOT_VERSION%/copilot-language-server-js-%COPILOT_VERSION%.zip
set COPILOT_FOLDER=copilot-language-server-js
set COPILOT_OUTPUT=copilot-language-server-js


set GNUDIFF_URL=gnudiff.zip
set GNUDIFF_FOLDER=gnudiff
set GNUDIFF_OUTPUT=gnudiff


set GNUGREP_URL=gnugrep-%GNUGREP_VERSION%.zip
set GNUGREP_FOLDER=gnugrep\%GNUGREP_VERSION%
set GNUGREP_OUTPUT=gnugrep\%GNUGREP_VERSION%


set GWT_URL=gwt/gwt-%GWT_VERSION%.tar.gz
set GWT_FOLDER=gwtproject\%GWT_VERSION%
set GWT_OUTPUT=gwtproject


set SUMATRA_URL=sumatrapdf/SumatraPDF-%SUMATRA_VERSION%-64.zip
set SUMATRA_FOLDER=sumatra\%SUMATRA_VERSION%
set SUMATRA_OUTPUT=sumatra\%SUMATRA_VERSION%


set WINUTILS_URL=winutils-%WINUTILS_VERSION%.zip
set WINUTILS_FOLDER=winutils\%WINUTILS_VERSION%
set WINUTILS_OUTPUT=winutils\%WINUTILS_VERSION%


set OPENSSL_URL=openssl-%OPENSSL_VERSION%.zip
set OPENSSL_FOLDER=openssl-%OPENSSL_VERSION%
set OPENSSL_OUTPUT=


set BOOST_URL=Boost/boost-%BOOST_VERSION%-win-msvc%MSVC_TOOLSET_VERSION%.zip
set BOOST_FOLDER=boost-%BOOST_VERSION%-win-msvc%MSVC_TOOLSET_VERSION%
set BOOST_OUTPUT=


set RESHACKER_URL=resource-hacker/resource_hacker.zip
set RESHACKER_FOLDER=resource-hacker
set RESHACKER_OUTPUT=resource-hacker


set NSPROCESS_URL=nsprocess/NsProcess.zip
set NSPROCESS_FOLDER=nsprocess\%NSPROCESS_VERSION%
set NSPROCESS_OUTPUT=nsprocess\%NSPROCESS_VERSION%


set DICTIONARIES_URL=dictionaries/core-dictionaries.zip
set DICTIONARIES_FOLDER=dictionaries
set DICTIONARIES_OUTPUT=dictionaries


set MATHJAX_URL=mathjax-%MATHJAX_VERSION%.zip
set MATHJAX_FOLDER=mathjax-27
set MATHJAX_OUTPUT=


set PANDOC_URL=pandoc/%PANDOC_VERSION%/pandoc-%PANDOC_VERSION%-windows-x86_64.zip
set PANDOC_FOLDER=pandoc
set PANDOC_OUTPUT=pandoc


set LIBCLANG_URL=libclang-windows-%LIBCLANG_VERSION%.zip
set LIBCLANG_FOLDER=libclang\%LIBCLANG_VERSION%
set LIBCLANG_OUTPUT=


set NODEBUILD_VERSION=%RSTUDIO_NODE_VERSION%
set NODEBUILD_LABEL=node (%NODEBUILD_VERSION%; build)
set NODEBUILD_FILE=node-v%NODEBUILD_VERSION%-win-x64
set NODEBUILD_URL=%RSTUDIO_BUILDTOOLS%/node/v%NODEBUILD_VERSION%/%NODEBUILD_FILE%.zip
set NODEBUILD_FOLDER=node\%NODEBUILD_VERSION%
set NODEBUILD_OUTPUT=node

set NODEBUNDLE_VERSION=%RSTUDIO_INSTALLED_NODE_VERSION%
set NODEBUNDLE_LABEL=node (%NODEBUNDLE_VERSION%; bundled)
set NODEBUNDLE_FILE=node-v%NODEBUNDLE_VERSION%-win-x64
set NODEBUNDLE_URL=%RSTUDIO_BUILDTOOLS%/node/v%NODEBUNDLE_VERSION%/%NODEBUNDLE_FILE%.zip
set NODEBUNDLE_FOLDER=node\%NODEBUNDLE_VERSION%-installed
set NODEBUNDLE_OUTPUT=node

:: Install 'common' dependencies first.
cd /d "%COMMON_INSTALL_DIR%"

%RUN% install GWT
%RUN% install DICTIONARIES
%RUN% install MATHJAX
%RUN% install LIBCLANG

REM Determine if we have the correct version of quarto.exe already installed
if exist quarto\bin\quarto.exe (
  for /f "usebackq" %%v in (`quarto\bin\quarto.exe --version`) do (
    if not "%%v" == "%QUARTO_VERSION%" (
      echo -- Quarto version mismatch: found %%v, expected %QUARTO_VERSION%
      rmdir /s /q quarto
      if exist quarto (
        echo ^^!^^! ERROR: Could not remove old quarto directory. Close any process holding files in it and retry.
        exit /b 1
      )
    )
  )
)
REM If a quarto directory exists but quarto.exe is missing, a previous install was incomplete; remove it so the install can retry.
if exist quarto if not exist quarto\bin\quarto.exe (
  echo -- Removing incomplete quarto directory from a prior failed install
  rmdir /s /q quarto
  if exist quarto (
    echo ^^!^^! ERROR: Could not remove incomplete quarto directory. Close any process holding files in it and retry.
    exit /b 1
  )
)
%RUN% install QUARTO
if not exist quarto\bin\quarto.exe (
  echo ^^!^^! ERROR: Quarto install failed: quarto\bin\quarto.exe not found.
  exit /b 1
)

REM Always remove any existing copilot-language-server installations to ensure latest version
if exist copilot-language-server (
  echo -- Removing old copilot-language-server directory
  rmdir /s /q copilot-language-server
)
if exist copilot-language-server-js (
  echo -- Removing existing copilot-language-server-js directory
  rmdir /s /q copilot-language-server-js
)
%RUN% install COPILOT

%RUN% install PANDOC
if exist pandoc\pandoc-%PANDOC_VERSION% (
  rmdir /s /q pandoc\%PANDOC_VERSION% 2>NUL
  %RUN% move pandoc\pandoc-%PANDOC_VERSION% pandoc\%PANDOC_VERSION%
  if ERRORLEVEL 1 (
    echo ^^!^^! ERROR: Could not move pandoc installation to pandoc\%PANDOC_VERSION%.
    exit /b
  )
)

%RUN% install NODEBUILD
if exist node\%NODEBUILD_FILE% (
  rmdir /s /q node\%NODEBUILD_VERSION% 2>NUL
  %RUN% move node\%NODEBUILD_FILE% node\%NODEBUILD_VERSION%
  if ERRORLEVEL 1 (
    echo ^^!^^! ERROR: Could not move node installation to node\%NODEBUILD_VERSION%.
    exit /b
  )
)

%RUN% install NODEBUNDLE
if exist node\%NODEBUNDLE_FILE% (
  rmdir /s /q node\%NODEBUNDLE_VERSION%-installed 2>NUL
  mkdir node\%NODEBUNDLE_VERSION%-installed 2>NUL
  if ERRORLEVEL 1 (
    echo ^^!^^! ERROR: Could not create directory node\%NODEBUNDLE_VERSION%-installed.
    exit /b
  )
  move node\%NODEBUNDLE_FILE%\node.exe node\%NODEBUNDLE_VERSION%-installed\node.exe
  if ERRORLEVEL 1 (
    echo ^^!^^! ERROR: Could not move node installation to node\%NODEBUNDLE_VERSION%-installed.
    exit /b
  )
  rmdir /s /q node\%NODEBUNDLE_FILE% 2>NUL
)

pushd node\%NODEBUILD_VERSION%
if not exist yarn.cmd (
  echo -- Installing yarn
  call npm install --global yarn
)
popd

echo -- Installing packages
call "%COMMON_SCRIPTS_DIR%\install-packages.cmd"

:: Install the rest of our dependencies into the 'windows' folder.
cd /d "%WINDOWS_INSTALL_DIR%"

%RUN% install GNUDIFF
%RUN% install GNUGREP
%RUN% install SUMATRA
%RUN% install WINUTILS
%RUN% install OPENSSL
%RUN% install BOOST
%RUN% install RESHACKER
%RUN% install NSPROCESS


echo -- Installing panmirror (Visual Editor)
pushd "%WINDOWS_SCRIPTS_DIR%install-panmirror"
call clone-panmirror-repo.cmd
popd

echo -- Installing SOCI
call "%WINDOWS_SCRIPTS_DIR%install-soci.cmd"

:: The i18n helper scripts live relative to the source tree; run from there.
cd /d "%WINDOWS_SCRIPTS_DIR%"
%RUN% install-i18n-dependencies

#!/usr/bin/env bash

if [ $# -eq 0 ]; then
    echo "publish-build.sh: utility for adding builds to the latest builds site."
    echo ""
    echo "Creates, commits, and pushes a Markdown file containing the specified build metadata."
    echo ""
    echo "Arguments:"
    echo ""
    echo "--build   What kind of build is being added, as a path. Example: "
    echo "          desktop-pro/windows"
    echo ""
    echo "--arch    The CPU architecture supported by the build. Example: arm64"
    echo ""
    echo "--url     A URL to a location where the build can be downloaded. Example:"
    echo "          https://dl.dailies.rstudio.com/desktop/windows/RStudio-pro.exe"
    echo ""
    echo "--file    A path to a local copy of the build file. Example:"
    echo "          /tmp/RStudio-pro.exe"
    echo ""
    echo "--version The full build version. Example: 2025.09.0-daily+123"
    echo ""
    echo "--pat     The Github Personal Access Token (PAT) to be used to authorize the commit."
    echo "          May be specified in the environment variable GITHUB_PAT instead."
    echo ""
    echo "--channel (optional) The Channel type for the build. One of Hourly, Daily, Preview, Release."
    echo "          Required for setting to Hourly. If not set, the channel will be determined from"
    echo "          the value in the file: version/BUILDTYPE. Channel names are case sensitive."
    exit 0
fi

# abort on error
set -e


# List of arguments
ARGUMENT_LIST=(
    "build"
    "url"
    "file"
    "version"
    "pat"
    "channel"
)

# Parse arguments with getopt
opts=$(getopt \
    --longoptions "$(printf "%s:," "${ARGUMENT_LIST[@]}")" \
    --name "$(basename "$0")" \
    --options "" \
    -- "$@"
)

# Apply to variables
while [[ $# -gt 0 ]]; do
    case "$1" in
        --arch)
            arch=$2
            shift 2
            ;;

        --build)
            build=$2
            shift 2
            ;;

        --url)
            url=$2
            shift 2
            ;;

        --file)
            file=$2
            shift 2
            ;;

        --version)
            version=$2
            shift 2
            ;;

        --pat)
            pat=$2
            shift 2
            ;;

        --channel)
            channel=$2
            shift 2
            ;;

        *)
            break
            ;;
    esac
done

# Check args
if [ -z "$build" ]; then
    echo "Build not set; specify a build with --build. Example: --build desktop/windows"
    exit 1
fi

if [ -z "$arch" ]; then
    # No architecture set? No problem, just ask uname
    arch=$(uname -m)
fi

if [ -z "$url" ]; then
    echo "URL not set; specify a build with --url. Example: --url https://dl.dailies.rstudio.com/desktop/windows/RStudio-pro.exe"
    exit 1
fi

if [ -z "$file" ]; then
    echo "File not set; specify a file with --file. Example: --file /tmp/RStudio-pro.exe"
    exit 1
fi

if [ -z "$version" ]; then
    echo "Version not set; specify a version with --version. Example: --version 2025.09.0-daily+123"
    exit 1
fi

if [ -z "$pat" ]; then
    if [ -z "$GITHUB_PAT" ]; then
        echo "Github Personal Access Token (PAT) not set; specify a PAT with --pat or the GITHUB_PAT environment variable."
        exit 1
    else
        # PAT supplied in environment variable; promote to local
        pat="$GITHUB_PAT"
    fi
fi

# if channel is undefined, we'll just use version/BUILDTYPE. If it is provided,
# we make sure there's no typos in the channel name
if [ ! -z $channel ]; then
    if [[ ! "$channel" =~ ^(Hourly|Daily|Preview|Release)$ ]]; then 
        echo "Channel should be one of Hourly, Daily, Preview, or Release (case sensitive)"
        exit 1
    fi
fi

# Determine file size
if [[ -f $file  ]]; then
    size=$(wc -c $file | awk '{print $1}')
else
    size=0
fi

# Determine file SHA256 sum
if [[ "$OSTYPE" == "darwin"* ]]; then
  sha256=$(shasum -a 256 $file | awk '{print $1}')
else
  sha256=$(sha256sum $file | awk '{print $1}')
fi

# Form ISO 8601 timestamp
timestamp=$(date +"%Y-%m-%dT%H:%M:%S%z")

# Determine release channel (build type) and flower
RSTUDIO_ROOT_DIR="$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && cd ../.. && pwd )"
if [ -z "$channel" ]; then
    channel="$(cat "$RSTUDIO_ROOT_DIR/version/BUILDTYPE" | tr '[ ]' '-' | tr -d '[:space:]')"
fi
flower="$(cat "$RSTUDIO_ROOT_DIR/version/RELEASE" | tr '[ ]' '-' | tr -d '[:space:]' | tr '[:upper:]' '[:lower:]')"

# Determine commit (use local hash)
pushd $RSTUDIO_ROOT_DIR
commit=$(git rev-parse HEAD)
popd

# Escape + characters in URL (for versioning)
url=$(echo $url | sed -e 's/+/%2B/g')

# Create version stem. This is a very file-safe version of the version: first
# we replace non-alphanumerics with dashes, then collapse multiple dashes to a
# single dash.
version_stem=$(echo $version | sed -e 's/[^a-zA-Z0-9-]/-/g' | sed -e 's/--*/-/g')

filename=$(basename $file)

md_contents="---
type: build
date: $timestamp
link: \"$url\"
filename: \"$filename\"
architecture: \"$arch\"
sha256: \"$sha256\"
channel: \"$channel\"
version: \"$version\"
commit: \"$commit\"
size: $size
---
"

echo "Creating $flower/$build/$version_stem.md..."
echo "$md_contents"
if [[ "$OSTYPE" == "darwin"* ]]; then
  base64_contents=$(echo "$md_contents" | base64 --break=0)
else
  base64_contents=$(echo "$md_contents" | base64 --wrap=0)
fi

# The hourly builds upload to a different "product" directory in the dailies page
if [ $channel == "Hourly" ]; then
  product="rstudio-hourly"
else
  product="rstudio"
fi

githubUrl="https://api.github.com/repos/rstudio/latest-builds/contents/content/$product/$flower/$build/$version_stem.md"
curlOutFname="curl.out"

payload="{\"message\":\"Add $flower build $version in $build\",\"content\":\"$base64_contents\"}"

echo "Sending to Github: $payload"
httpCode=$(curl \
   -X PUT \
   -w %{http_code} \
   -o $curlOutFname \
   -H "Accept: application/vnd.github.v3+json" \
   -H "Authorization: token $pat" \
   $githubUrl \
   -d "$payload")
echo "Github's Response: "
echo "Http Code : $httpCode"
cat $curlOutFname

if [[ $httpCode -eq 422 ]]; then
   # An http code of 422 indicates a problem, probably that the file already exists and this is an
   # update not a create

   echo "Received a 422 http code, assuming this is actually an update not a create, so we get the existing file's info"
   getShaResponse=$(curl \
      -X GET \
      -H "Accept: application/vnd.github.v3+json" \
      -H "Authorization: token $pat" \
      $githubUrl)
   echo $getShaResponse

   fileSha=$(echo $getShaResponse | jq -r .sha)

   payload="{\"message\":\"Update $flower build $version in $build\",\"content\":\"$base64_contents\",\"sha\":\"$fileSha\"}"
   
   httpCode=$(curl \
      -X PUT \
      -w %{http_code} \
      -o $curlOutFname \
      -H "Accept: application/vnd.github.v3+json" \
      -H "Authorization: token $pat" \
      $githubUrl \
      -d "$payload")

   echo "Github's Update Response:"
   echo "Http Code : $httpCode"
   cat $curlOutFname
fi

# Retry, sleeping for random 
if [[ $httpCode -eq 409 ]]; then

   retry_count=0
   while [[ $retry_count -lt 5 ]]; do
      echo "Received a 409 error, assuming it's a commit interleaving error"
      # Sleep for a random amount of time between 3-10 seconds: $(($RANDOM%($max-$min+1)+$min))
      # Randomness is in case we're trying to upload at the same time as another process
      sleep $((RANDOM % 6 + 3))
      echo "Retrying the command (retry count: $((retry_count+1)) of $retry_count)"

       httpCode=$(curl \
        -X PUT \
        -w %{http_code} \
        -o $curlOutFname \
        -H "Accept: application/vnd.github.v3+json" \
        -H "Authorization: token $pat" \
        $githubUrl \
        -d "$payload")

      echo "Github's Response"
      echo "Http Code : $httpCode"
      cat $curlOutFname
      if [[ $httpCode -ne 409 ]]; then
         break
      fi
      retry_count=$((retry_count+1))
   done
fi

if [[ $(($httpCode)) -ge 400 ]]; then
   echo "An unrecoverable error has occured"
   exit 1
fi

#!/usr/bin/env bash
#
# Bootstrap a git worktree so the JS/TS test suites "just work".
#
# `git worktree add` only materializes tracked files. node_modules is
# gitignored, and a couple of generated files are gitignored too, so a fresh
# .worktrees/<name> checkout starts without them -- tsx/ts-node test runs and
# even `tsc` then fail with "Cannot find module" until deps are installed.
#
# When the worktree's package-lock.json matches the main checkout's, the main
# checkout's node_modules already satisfies it, so we copy-on-write CLONE it
# (APFS clonefile via `cp -c`, or reflink on Linux) instead of running
# `npm ci`. A clone is near-instant, needs no network, and -- crucially for
# src/node/desktop -- skips electron-rebuild and the failing generate.ts
# postinstall. We clone rather than symlink because tsx/ts-node/electron-mocha
# resolve files via realpath: a symlinked node_modules resolves back into the
# main checkout and its loader hook can't intercept the worktree's .ts files. A
# clone's files have their own worktree realpath, so resolution is correct. We
# clone rather than hardlink because clones are copy-on-write -- a write in the
# worktree can't corrupt the parent's node_modules through a shared inode.
#
# Falls back to `npm ci` when the lockfiles differ (the branch changed deps) or
# the main checkout has no node_modules to clone.
#
# Platforms: the clone mechanism is gated by OS -- clonefile on macOS (`cp -c`),
# reflink on Linux (`cp --reflink=auto`). On filesystems without copy-on-write
# (ext4, NTFS) the clone transparently degrades to a full recursive copy:
# correct and still offline, just not instant. Cloning is always from THIS
# machine's main checkout, so the compiled native modules match the platform.
# Run under bash (Git Bash or WSL on Windows).
#
# Alongside the desktop deps, this also materializes a "dev shim" build root
# (<worktree>/build-dev-shim) for running the desktop-dev Playwright suite from
# the worktree without a C++ build. The Electron dev launcher (findComponents
# in src/node/desktop/src/main/utils.ts) honors RSTUDIO_CPP_BUILD_OUTPUT and
# needs <root>/session/rsession.exe plus <root>/conf/rdesktop-dev.conf; the
# shim links session/ from the main checkout's build and rewrites the conf's
# www paths to THIS worktree's GWT output. Do NOT point
# RSTUDIO_CPP_BUILD_OUTPUT at the main checkout's build/src/cpp directly: its
# conf serves the main checkout's src/gwt/www, which (after `ant desktop` /
# `ant devmode`) is a Super Dev Mode stub that redirects to a code server on
# localhost:9876 -- without that code server running, RStudio dies at startup
# with "code server not available" and automation times out waiting for
# window.rstudio.ready.
#
# Usage:
#   scripts/bootstrap-worktree.sh [worktree-dir] [--skip-desktop] \
#       [--with-build-dir[=<dir>]]
#
#   worktree-dir   defaults to the current directory; may be any path inside
#                  the target worktree (it is normalized to the repo top).
#   --skip-desktop skip src/node/desktop (its deps are large; skip when you
#                  only need the e2e/rstudio suite). Also skips the dev shim.
#   --with-build-dir[=<dir>]
#                  also configure a CMake build directory for the worktree
#                  (default <worktree>/build; <dir> may be absolute or relative
#                  to the worktree). This configures FRESH -- it never copies
#                  the main checkout's build/, which bakes absolute paths (the
#                  cache's source dir, ninja depfiles, generated dev confs, and
#                  debug/__FILE__ strings in objects), so a copied tree would
#                  build and serve the wrong checkout. A fresh configure writes
#                  correct paths; the cross-checkout CCACHE_BASEDIR setup in
#                  cmake/globals.cmake then lets the compile reuse objects
#                  another checkout already built, keeping it cheap.

set -euo pipefail

SKIP_DESKTOP=0
WANT_BUILD_DIR=0
BUILD_DIR_ARG=""
TARGET=""
for arg in "$@"; do
  case "$arg" in
    --skip-desktop) SKIP_DESKTOP=1 ;;
    --with-build-dir) WANT_BUILD_DIR=1 ;;
    --with-build-dir=*) WANT_BUILD_DIR=1; BUILD_DIR_ARG="${arg#*=}" ;;
    *) TARGET="$arg" ;;
  esac
done

# Normalize to the repo top of the requested (or current) worktree so the
# relative package paths below resolve no matter where this is invoked from.
WORKTREE="$(git -C "${TARGET:-$PWD}" rev-parse --show-toplevel)"

# The primary worktree's .git is a real directory; --git-common-dir points at
# it, so its parent is the main checkout. We clone node_modules and copy
# generated-but-gitignored files from there.
COMMON_DIR="$(git -C "$WORKTREE" rev-parse --path-format=absolute --git-common-dir)"
MAIN_CHECKOUT="$(dirname "$COMMON_DIR")"

echo "[bootstrap] worktree:      $WORKTREE"
echo "[bootstrap] main checkout: $MAIN_CHECKOUT"

# Copy-on-write clone a directory tree (clonefile on macOS/APFS, reflink on
# Linux), falling back to a plain recursive copy where COW is unsupported. The
# destination must not already exist; we clear a partial tree before falling
# back so a failed clone can't nest into the retry.
clone_tree() {
  local src="$1" dst="$2"
  rm -rf "$dst"
  if [ "$(uname -s)" = "Darwin" ]; then
    cp -Rc "$src" "$dst" 2>/dev/null && return 0
  else
    cp -R --reflink=auto "$src" "$dst" 2>/dev/null && return 0
  fi
  rm -rf "$dst"
  cp -R "$src" "$dst"
}

# Make sure a package dir has node_modules: clone from main when the lockfiles
# match, otherwise npm ci.
ensure_deps() {
  local pkg="$1"
  local wt="$WORKTREE/$pkg"
  local main="$MAIN_CHECKOUT/$pkg"

  if [ ! -f "$wt/package-lock.json" ]; then
    echo "[bootstrap] skip $pkg (no package-lock.json)"
    return
  fi
  if [ -d "$wt/node_modules" ]; then
    echo "[bootstrap] $pkg already has node_modules; leaving as-is"
    return
  fi

  if [ "$WORKTREE" != "$MAIN_CHECKOUT" ] \
     && [ -d "$main/node_modules" ] \
     && cmp -s "$wt/package-lock.json" "$main/package-lock.json"; then
    echo "[bootstrap] cloning $pkg/node_modules from main (lockfiles match)"
    if clone_tree "$main/node_modules" "$wt/node_modules"; then
      return
    fi
    echo "[bootstrap] clone failed; falling back to npm ci"
  fi

  echo "[bootstrap] npm ci in $pkg"
  ( cd "$wt" && npm ci )
}

# Copy a generated, gitignored file from the main checkout when the worktree is
# missing it (and we are not already in the main checkout). Cloning
# node_modules sidesteps the desktop generate.ts postinstall, but this stub
# lives outside node_modules, so copy it explicitly.
copy_generated() {
  local rel="$1"
  if [ "$WORKTREE" = "$MAIN_CHECKOUT" ] || [ -f "$WORKTREE/$rel" ]; then
    return
  fi
  if [ ! -f "$MAIN_CHECKOUT/$rel" ]; then
    echo "[bootstrap] WARNING: $rel missing from main checkout too; build it there first"
    return
  fi
  echo "[bootstrap] copying generated $rel"
  mkdir -p "$(dirname "$WORKTREE/$rel")"
  cp "$MAIN_CHECKOUT/$rel" "$WORKTREE/$rel"
}

# Materialize the desktop-dev shim build root (see header). Best-effort: when
# the main checkout has no built rsession/conf yet, warn and move on -- the
# rest of the bootstrap is still useful. The conf is regenerated on every run
# (the main checkout's conf may have changed); the session link is only
# created when missing.
make_dev_shim() {
  local dir="$WORKTREE/build-dev-shim"
  local main_cpp="$MAIN_CHECKOUT/build/src/cpp"

  if [ "$WORKTREE" = "$MAIN_CHECKOUT" ]; then
    return
  fi
  if [ ! -f "$main_cpp/conf/rdesktop-dev.conf" ] || [ ! -d "$main_cpp/session" ]; then
    echo "[bootstrap] WARNING: no built session/conf under $main_cpp; build the main checkout first -- skipping dev shim"
    return
  fi

  mkdir -p "$dir/conf"

  # session/ must hold the main checkout's built rsession. A symlink is fine
  # everywhere but Windows, where Git Bash's `ln -s` silently degrades to a
  # copy -- use a real NTFS junction there instead. PowerShell rather than
  # `cmd /c mklink`: cmd's /c quote-stripping and MSYS path conversion both
  # mangle the mklink arguments.
  if [ ! -e "$dir/session" ]; then
    case "$(uname -s)" in
      MINGW*|MSYS*|CYGWIN*)
        powershell.exe -NoProfile -Command \
          "New-Item -ItemType Junction -Path '$(cygpath -w "$dir/session")' -Target '$(cygpath -w "$main_cpp/session")' | Out-Null"
        ;;
      *)
        ln -s "$main_cpp/session" "$dir/session"
        ;;
    esac
  fi

  # Rewrite the conf's www paths to THIS worktree's GWT output; everything
  # else (rpostback, staged R modules, dependency paths) stays pointed at the
  # main checkout's build. The conf wants forward slashes even on Windows.
  local wt_fwd="$WORKTREE"
  if command -v cygpath >/dev/null 2>&1; then
    wt_fwd="$(cygpath -m "$WORKTREE")"
  fi
  sed \
    -e "s|^www-local-path=.*|www-local-path=$wt_fwd/src/gwt/www|" \
    -e "s|^www-symbol-maps-path=.*|www-symbol-maps-path=$wt_fwd/src/gwt/extras/rstudio/symbolMaps|" \
    "$main_cpp/conf/rdesktop-dev.conf" > "$dir/conf/rdesktop-dev.conf"

  echo "[bootstrap] dev shim ready: $dir"
  if [ ! -f "$WORKTREE/src/gwt/www/rstudio/rstudio.nocache.js" ]; then
    echo "[bootstrap] NOTE: worktree GWT output missing; build it first: (cd src/gwt && ant draft)"
  fi
  echo "[bootstrap] run desktop-dev e2e from e2e/rstudio with:"
  echo "[bootstrap]   PW_RSTUDIO_DEV=1 RSTUDIO_CPP_BUILD_OUTPUT=\"$dir\" npx playwright test <spec> --project=desktop"
}

# Configure a CMake build directory for the worktree. Always a fresh configure
# (cmake -S <worktree> -B <dir>), never a copy of the main checkout's build/ --
# a CMake build tree bakes absolute paths into the cache, ninja depfiles, the
# generated dev confs (www-local-path), and the compiled objects themselves, so
# a copied tree would build and serve the main checkout rather than this one. A
# fresh configure writes correct paths; the cross-checkout CCACHE_BASEDIR setup
# in cmake/globals.cmake makes the subsequent compile reuse cached objects, so
# this stays cheap despite not copying.
configure_build() {
  local dir="$1"

  # Resolve a relative path against the worktree root so the build dir lands
  # inside the worktree no matter where this script was invoked from.
  case "$dir" in
    /*) ;;
    *) dir="$WORKTREE/$dir" ;;
  esac

  if ! command -v cmake >/dev/null 2>&1; then
    echo "[bootstrap] WARNING: cmake not found on PATH; skipping --with-build-dir"
    return
  fi

  echo "[bootstrap] configuring CMake build dir: $dir"
  cmake -S "$WORKTREE" -B "$dir" -DCMAKE_EXPORT_COMPILE_COMMANDS=1

  echo "[bootstrap] build dir configured; compile with: cmake --build \"$dir\""
}

# The e2e/rstudio Playwright suite -- the common case.
ensure_deps "e2e/rstudio"

# The Electron desktop suite. Cloning skips its electron-rebuild and the
# failing generate.ts postinstall; we still copy the type stub that postinstall
# would have generated (it lives outside node_modules).
if [ "$SKIP_DESKTOP" -eq 0 ]; then
  ensure_deps "src/node/desktop"
  copy_generated "src/node/desktop/src/types/user-state-schema.d.ts"
  make_dev_shim
else
  echo "[bootstrap] skipping src/node/desktop (--skip-desktop)"
fi

# Optional CMake build-dir configure (default <worktree>/build when no path
# was given).
if [ "$WANT_BUILD_DIR" -eq 1 ]; then
  configure_build "${BUILD_DIR_ARG:-build}"
fi

echo "[bootstrap] done"

#!/bin/bash

# Initialize variables
sql=""
type="internal"
directory=$(dirname "$(readlink -f "$0")")
flower_name=""
# Default flower_name to contents of version/RELEASE if the file exists
if [ -f "${directory}/../../../../version/RELEASE" ]; then
   flower_name=$(cat "${directory}/../../../../version/RELEASE")
   echo "Using flower name from version/RELEASE: ${flower_name}"
fi

# First, collect all arguments before any option flags into flower_name
while [[ $# -gt 0 && ! "$1" =~ ^- ]]; do
    if [ -z "$flower_name" ]; then
        flower_name="$1"
    else
        flower_name="$flower_name-$1"
    fi
    shift
done

if [ -z "$flower_name" ]; then
   echo "Helper script for creating schema update files."
   echo ""
   echo "Invocation: ./make-schema.sh [\"Release Flower\" [options]"
   echo "Ex: ./make-schema.sh \"Cucumberleaf Sunflower\" -t audit"
   echo ""
   echo "Options:"
   echo ""
   echo "Release Flower: The name of the release flower to be used in the filename."
   echo "                If not specified, the contents of version/RELEASE will be used."
   echo ""
   echo "-s | --sql      SQL provider. One of: sqlite, postgresql."
   echo "                If not specified, both .sqlite and .postgresql files will be created."
   echo ""
   echo "-t | --type     Which type of database the schema is for."
   echo "                One of: internal (default), audit"
   exit 1
fi

# Apply to variables
while [[ $# -gt 0 ]]; do
    case "$1" in
        --sql|-s)
            sql=$2
            shift 2
            ;;

        --type|-t)
            type=$2
            shift 2
            ;;

        *)
            break
            ;;
    esac
done

# Assemble the filename
filename=$(date -u '+%Y%m%d%H%M%S%N')
filename="${filename}_${flower_name}_AlterTables"
filename=$(echo "${filename}" | tr ' ' '-')

# Add audit and change directory if needed
if [ "$type" = "audit" ]; then
   directory="${directory}/audit"
   # if the directory does not exist, create it
   if [ ! -d "$directory" ]; then
      mkdir -p "$directory"
   fi
elif [ "$type" != "internal" ]; then
   echo "Unknown type: ${type}"
   exit 1
fi

echo "Flower name:  ${flower_name}"
echo "Type:         ${type}"
echo "Directory:    ${directory}"

# Create the migration file(s)
filename="${directory}/${filename}"
if [ -z "$sql" ]
then
   filename1="${filename}.sqlite"
   filename2="${filename}.postgresql"
   touch "${filename1}"
   touch "${filename2}"

   echo "SQL provider: [sqlite, postgresql]"
   echo "Filename:     ${filename1}"
   echo "              ${filename2}"
else
   if [ "$sql" = "sqlite" ]
   then
      filename="${filename}.sqlite"
   elif [ "$sql" = "postgresql" ]
   then
      filename="${filename}.postgresql"
   else
      echo ""
      echo "Error: Unknown SQL provider: ${sql}"
      exit 1
   fi

   echo "SQL provider: ${sql}"
   echo "Filename:     ${filename}"
fi


exit 0

::
:: make-install-win32.bat
::
:: Copyright (C) 2022 by Posit Software, PBC
::
:: Unless you have received this program directly from Posit Software pursuant
:: to the terms of a commercial license agreement with Posit Software, then
:: this program is licensed to you under the terms of version 3 of the
:: GNU Affero General Public License. This program is distributed WITHOUT
:: ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
:: MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
:: AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
::
@echo off
setlocal EnableDelayedExpansion

if not defined CMAKE_BUILD_TYPE (
    set CMAKE_BUILD_TYPE=Release
)

REM setup variables
if not defined WIN32_BUILD_PATH (
    if "%CMAKE_BUILD_TYPE%" == "Debug" (
        set WIN32_BUILD_PATH=build32-debug
    ) else (
        set WIN32_BUILD_PATH=build32
    )
)

REM normalize slashes
set "WIN32_BUILD_PATH=%WIN32_BUILD_PATH:/=\%"

set INSTALL_PATH=%1
for %%A in (%*) do (
    if /I "%%A" == "clean" (
        set CLEANBUILD=1
    )
)

if defined CLEANBUILD (
    if exist %WIN32_BUILD_PATH% (
        rmdir /s /q %WIN32_BUILD_PATH%
    )
)

REM Prepare the build directory.
if not exist %WIN32_BUILD_PATH% (
    mkdir %WIN32_BUILD_PATH%
)

cd %WIN32_BUILD_PATH%

REM Configure for a 32-bit build.
call vcvarsall.bat x86
cmake -G Ninja ^
      -DCMAKE_BUILD_TYPE=%CMAKE_BUILD_TYPE% ^
      -DCMAKE_INSTALL_PREFIX=%INSTALL_PATH% ^
      -DCMAKE_C_COMPILER=cl.exe ^
      -DCMAKE_CXX_COMPILER=cl.exe ^
      -DRSTUDIO_TARGET=SessionWin32 ^
      -DRSTUDIO_PACKAGE_BUILD=1 ^
      -DLIBR_HOME=C:\R\R-3.6.3 ^
      %RSTUDIO_PROJECT_ROOT% || goto :error

REM Perform the build.
cmake --build . --config %CMAKE_BUILD_TYPE% --target install -- %MAKEFLAGS% || goto :error

cd ..

endlocal
goto :EOF

:error
echo Failed to build 32bit components of RStudio! Error: %ERRORLEVEL%
exit /b %ERRORLEVEL%

::
:: rstudio-tools.cmd -- Batch file toolkit used in dependency scripts
::
:: Copyright (C) 2022 by Posit Software, PBC
::
:: Unless you have received this program directly from Posit Software pursuant
:: to the terms of a commercial license agreement with Posit Software, then
:: this program is licensed to you under the terms of version 3 of the
:: GNU Affero General Public License. This program is distributed WITHOUT
:: ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
:: MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
:: AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
::

::
:: This file provides helpers and subroutines that can be used in other
:: dependency installer scripts. The subroutines in this file can be invoked
:: by using something like:
::
::   call rstudio-tools.cmd <routine> <arguments>
::
:: Alternatively, using a helper variable defined in this script:
::
::  %RUN% <routine> <arguments>
::
:: When called without arguments, the 'initialize' subroutine is invoked,
:: which defines commonly-used variables.
::
:: When using subroutines that have output variables, make sure those usages
:: are expanded with !FOO! instead of %FOO%. %FOO% is expanded at parse time,
:: not use time, and so it's possible that usages of %FOO% in a script could
:: be expanded before the command populating FOO is called.
::
set "RUN=call %0"

if "%1" == "" goto initialize
call :%*
exit /b %ERRORLEVEL%


:initialize

:: Set the project root directory
call :find-project-root

:: Put Visual Studio tools on the PATH
call :add-vstools-to-path

:: Try to help RStudio find an appropriate version of Java
call :set-java-home

:: Node version used when building the product
set RSTUDIO_NODE_VERSION=22.22.2

:: Node version installed with the product
set RSTUDIO_INSTALLED_NODE_VERSION=22.22.2

:: The base URL where RStudio build tools are available for download.
set RSTUDIO_BUILDTOOLS=https://rstudio-buildtools.s3.amazonaws.com

goto :eof


::
:: Find the project root directory.
::
:find-project-root

if "!DOCKER_IMAGE_BUILD!" == "1" (
  echo -- Building Docker image
  goto :eof
)

setlocal EnableDelayedExpansion
set OWD=%CD%

:find-project-root-impl

if "!CWD!" == "%CD%" (
  echo ^^!^^! ERROR: Could not find project root directory.
  exit /b 1
)

if exist rstudio.Rproj goto find-project-root-done

set "CWD=%CD%"
cd ..
goto find-project-root-impl

:find-project-root-done:

echo -- Using project root: %CD%
endlocal & set "RSTUDIO_PROJECT_ROOT=%CD%"
goto :eof


::
:: Get the basename from a path.
::
:: The second parameter is expected to be an output variable.
::
:basename

setlocal EnableDelayedExpansion

set "_BASENAME=%~nx1"
set "_OUTPUT=%~2"

set "_RESULT=%_BASENAME%"

endlocal & set "%_OUTPUT%=%_RESULT%"
goto :eof


::
:: Get the dirname from a path.
::
:: The second parameter is expected to be an output variable.
::
:dirname

setlocal EnableDelayedExpansion

set "_PATH=%~1"
set "_OUTPUT=%~2"

for %%F in ("%_PATH%") do set _RESULT=%%~dpF

endlocal & set "%_OUTPUT%=%_RESULT:~0,-1%"
goto :eof


::
:: Move a file from one location to another.
::
:: This uses robocopy, which will be more robust when a folder
:: (or files within) are temporarily locked. This can occur when
:: unpacking large archives, whose contents are then promptly
:: scanned by e.g. Windows Defender.
::
:: Note that robocopy will use error codes from 0 through 7 to
:: indicate different kinds of success; error codes 8 and above
:: are used to indicate failure. This routine logs that, but
:: just returns a plain 0 for success or 1 for failure.
::
:move

setlocal EnableDelayedExpansion

set "_SRC=%~1"
set "_DST=%~2"
set "_LOG=%TEMP%\robocopy.%RANDOM%.log"

robocopy /MOVE /E /Z /R:5 /W:10 "%_SRC:/=\%" "%_DST:/=\%" >%_LOG% 2>&1
if %ERRORLEVEL% geq 8 (
  echo ^^!^^! ERROR: could not move %_SRC% to %_DST%. [exit code %ERRORLEVEL%]
  type "%_LOG%"
  del "%_LOG%"
  endlocal & exit /b 1
)

echo -- Moved %_SRC% to %_DST%

del "%_LOG%"
endlocal & exit /b 0


::
:: Normalize a path.
::
:normalize-path

setlocal EnableDelayedExpansion

set "_PATH=%~1"
set "_OUTPUT=%~2"

for %%F in ("%_PATH%") do set _RESULT=%%~fF

endlocal & set "%_OUTPUT%=%_RESULT%"
goto :eof


::
:: Download a file.
::
:: If the URL passed does not include 'http' as a prefix, then the
:: RSTUDIO_BUILDTOOLS URL above will be prepended as the base URL.
::
:download

setlocal EnableDelayedExpansion

set _URLARG=%~1
set _OUTARG=%~2

if "%_URLARG:~0,4%" == "http" (
  set _URL=%_URLARG%
) else (
  set _URL=%RSTUDIO_BUILDTOOLS%/%_URLARG%
)

if defined _OUTARG (
  set "_OUTPUT=%_OUTARG%"
) else (
  call :basename "%_URL%" _OUTPUT
)

echo -- Downloading %_URL% =^> !_OUTPUT!
curl -L -f -C - "%_URL%" -o "!_OUTPUT!"

if %ERRORLEVEL% neq 0 (
  echo ^^!^^! ERROR: Download of %_URL% failed. [exit code %ERRORLEVEL%]
  goto :error
)

endlocal
goto :eof


::
:: Extract an archive.
::
:: Extract an archive (usually a .zip) using 7z.
:: The second parameter is optional; if provided, then the archive
:: contents will be unpacked into that directory.
::
:extract

setlocal EnableDelayedExpansion

set _ARCHIVE=%~1
set _OUTPUT=%~2

if "%_ARCHIVE:~-4%" == ".zip" (
  call :extract-zip "%_ARCHIVE%" "%_OUTPUT%"
  endlocal & exit /b %ERRORLEVEL%
)

if "%_ARCHIVE:~-3%" == ".7z" (
  call :extract-zip "%_ARCHIVE%" "%_OUTPUT%"
  endlocal & exit /b %ERRORLEVEL%
)

if "%_ARCHIVE:~-7%" == ".tar.gz" (
  call :extract-tar "%_ARCHIVE%" "%_OUTPUT%"
  endlocal & exit /b %ERRORLEVEL%
)

echo -- ERROR: don't know how to extract archive %_ARCHIVE%
endlocal & exit /b 1


::
:: Extract a .zip archive.
::
:extract-zip

setlocal EnableDelayedExpansion

set _ARCHIVE=%~1
set _OUTPUT=%~2

if "%QUIET%" == "1" (
  set _QUIET=-bb0
)

if defined _OUTPUT (
  echo -- Extracting %_ARCHIVE% to %_OUTPUT%
  7z x -y %_QUIET% %_ARCHIVE% -o%_OUTPUT%
) else (
  echo -- Extracting %_ARCHIVE%
  7z x -y %_QUIET% %_ARCHIVE%
)

if %ERRORLEVEL% neq 0 (
  echo ^^!^^! ERROR: Could not extract %_ARCHIVE%. [exit code %ERRORLEVEL%]
  goto :error
)

endlocal & exit /b 0


::
:: Extract a .tar.gz archive.
::
:extract-tar

setlocal EnableDelayedExpansion

set _ARCHIVE=%CD%\%~1
set _OUTPUT=%~2

if defined _OUTPUT (
  mkdir %_OUTPUT%
  pushd %_OUTPUT%
  echo -- Extracting %_ARCHIVE% into %_OUTPUT%
) else (
  echo -- Extracting %_ARCHIVE%
)

tar -xf %_ARCHIVE%

if %ERRORLEVEL% neq 0 (
  echo ^^!^^! ERROR: Could not extract %_ARCHIVE%. [exit code %ERRORLEVEL%]
  goto :error
)

if defined _OUTPUT (
  popd
)

endlocal & exit /b 0


::
:: Install a dependency.
::
:: This subroutine expects a number of variables to be defined, of the form
::
:: - <dep>_URL    --  The URL from which the dependency can be downloaded.
:: - <dep>_FOLDER --  The name of the folder wherein the dependencies will be unpacked.
:: - <dep>_OUTPUT --  The directory in which the downloaded archive should be unpacked.
::
:: Note that <dep>_OUTPUT is optional; it's provided because some of the archives we
:: download and unpack have their archive contents at the 'root' of the archive, whereas
:: others will have their contents within a sub-folder.
::
:install

setlocal EnableDelayedExpansion

set _NAME=%~1
set _LABEL=!%_NAME%_LABEL!
set _VERSION=!%_NAME%_VERSION!
set _URL=!%_NAME%_URL!
set _FOLDER=!%_NAME%_FOLDER!
set _OUTPUT=!%_NAME%_OUTPUT!

if "%CLEAN%" == "1" (
  rmdir /s /q %_FOLDER%
)

if not defined _LABEL (
  call :tolower "%_NAME%" _NAME_LOWER
  if defined _VERSION (
    set _LABEL=!_NAME_LOWER! !_VERSION!
  ) else (
    set _LABEL=!_NAME_LOWER!
  )
)

if exist %_FOLDER% (
  echo -- !_LABEL! is already installed.
  goto :eof
)

echo -- Installing !_LABEL!
mkdir %_FOLDER%
call :download "%_URL%"
call :basename "%_URL%" _FILE
call :extract "!_FILE!" "!_OUTPUT!"

endlocal
goto :eof


::
:: Convert a string to lowercase.
::
:tolower

setlocal EnableDelayedExpansion

set _STRING=%~1
set _OUTPUT=%~2

set "_STRING=%_STRING:A=a%"
set "_STRING=%_STRING:B=b%"
set "_STRING=%_STRING:C=c%"
set "_STRING=%_STRING:D=d%"
set "_STRING=%_STRING:E=e%"
set "_STRING=%_STRING:F=f%"
set "_STRING=%_STRING:G=g%"
set "_STRING=%_STRING:H=h%"
set "_STRING=%_STRING:I=i%"
set "_STRING=%_STRING:J=j%"
set "_STRING=%_STRING:K=k%"
set "_STRING=%_STRING:L=l%"
set "_STRING=%_STRING:M=m%"
set "_STRING=%_STRING:N=n%"
set "_STRING=%_STRING:O=o%"
set "_STRING=%_STRING:P=p%"
set "_STRING=%_STRING:Q=q%"
set "_STRING=%_STRING:R=r%"
set "_STRING=%_STRING:S=s%"
set "_STRING=%_STRING:T=t%"
set "_STRING=%_STRING:U=u%"
set "_STRING=%_STRING:V=v%"
set "_STRING=%_STRING:W=w%"
set "_STRING=%_STRING:X=x%"
set "_STRING=%_STRING:Y=y%"
set "_STRING=%_STRING:Z=z%"

endlocal & set "%_OUTPUT%=%_STRING%"
goto :eof


::
:: Run a sub-process, and store its output into a variable.
::
:: The first argument should be the (double-quoted) command to run.
:: The second argument should be an output variable.
::
:subprocess

setlocal EnableDelayedExpansion

set "_COMMAND=%~1"
set "_OUTPUT=%~2"

for /f "tokens=* delims=" %%A in ('%_COMMAND%') do (
  set "_RESULT=%%A"
)

endlocal & set "%_OUTPUT%=%_RESULT%"
goto :eof


::
:: Iterate through a set of directories, and add the first match to the PATH.
::
:add-first-to-path

setlocal EnableDelayedExpansion

for %%F in (%*) do (
  if exist %%F (
    endlocal & set "PATH=%%~fF;%PATH%"
    exit /b 0
  )
)


::
:: Install internationalization dependencies.
::
:install-i18n-dependencies

if defined JENKINS_URL (
  echo -- Skipping i18n installation [on CI]
  exit /b 0
)

if not exist C:\Windows\py.exe (
  echo -- Skipping i18n installation [Python is not installed]
  exit /b 0
)

set I18N=..\..\src\gwt\tools\i18n-helpers
if not exist %I18N% (
  echo -- Skipping i18n installation [i18n-helpers does not exist]
  exit /b 0
)

pushd %I18N%
if not exist commands.cmd.xml\requirements.txt (
  echo -- Skipping i18n installation [requirements.txt does not exist]
  exit /b 0
)

echo -- Installing i18n dependencies
py -3 -m venv VENV
VENV\Scripts\pip install --disable-pip-version-check -r commands.cmd.xml\requirements.txt
popd

exit /b 0


::
:: Run a command with echo enabled.
::
:with-echo

setlocal EnableDelayedExpansion
set "PROMPT=> "
@echo on
%*
@echo off
endlocal

exit /b %ERRORLEVEL%


::
:: Add Visual Studio's tools to the PATH.
::
:add-vstools-to-path

for %%Q in ("BuildTools" "Community") do (
  for %%P in ("%ProgramFiles%" "%ProgramFiles(x86)%") do (
    call :add-vstools-to-path-impl "%%~P\Microsoft Visual Studio\2022\%%~Q"
    if defined _VCTOOLSDIR (
      goto :add-vstools-to-path-done
    )
  )
)

:add-vstools-to-path-impl

if exist "%~f1" (
  set "_VCTOOLSDIR=%~f1\Common7\Tools"
  set "_VCBUILDDIR=%~f1\VC\Auxiliary\Build"
)

goto :eof

:add-vstools-to-path-done:

set "PATH=%_VCTOOLSDIR%;%_VCBUILDDIR%;%PATH%"
where /Q VsDevCmd.bat
if %ERRORLEVEL% neq 0 (
  echo ^^!^^! ERROR: Could not find Visual Studio build tools.
  exit /b 1
)

goto :eof


::
:: Helper to set JAVA_HOME, so the appropriate version of Java is used.
::
:set-java-home

setlocal EnableDelayedExpansion

for %%F in ("C:\Java" "%ProgramFiles%\Eclipse Adoptium") do (
  if exist %%F (
    for /f "tokens=* delims=" %%A in ('dir /B %%F ^| findstr /L jdk-17') do (
      set "JAVA_HOME=%%~F\%%A"
      goto :set-java-home-done
    )
  )
)

:set-java-home-done

endlocal & set "JAVA_HOME=%JAVA_HOME%"
echo -- Using JDK: %JAVA_HOME%
exit /b 0


::
:: Called when an error occurs.
::
:error
exit /b %ERRORLEVEL%

REM This script installs R-devel from SVN trunk on Windows.
REM
REM This script assumes you have 'wget' on your path, as it
REM is used to download. You can find a binary here:
REM
REM     https://eternallybored.org/misc/wget/wget64.exe 
REM
REM We use SVN to checkout R trunk from SVN.
REM If you need a Windows SVN client, you can download SlikSVN here:
REM
REM     https://sliksvn.com/download/
REM
REM Be sure to place the installed binary directory on your PATH.
REM
REM If you modify the configuration below, be sure to use
REM a directory _within the %USERPROFILE%; ie, your user
REM directory; otherwise you will almost certainly run into
REM very bizarre permission issues on build.

REM ---------------------------------
REM - BEGIN CONFIGURATION VARIABLES -
REM ---------------------------------

REM Set to 32 for a 32bit build.
REM TODO Build both in one go.
SET "WIN=64"

IF NOT DEFINED WGET (
	where /q wget && (
		SET "WGET=wget"
	) || (
		where /q wget && (
			SET "WGET=wget64"
		)
	)
)

IF NOT DEFINED SVN (
	SET "SVN=svn"
)

IF NOT DEFINED ROOT_DIR (
	SET "ROOT_DIR=%USERPROFILE%\R-src"
)

if NOT DEFINED RTOOLS_DIR (
	SET "RTOOLS_DIR=C:\Rtools"
)

IF NOT DEFINED RTOOLS_BIN_DIR (
	SET "RTOOLS_BIN_DIR=C:\Rtools\bin"
)

IF NOT DEFINED TMPDIR (
	SET "TMPDIR=%USERPROFILE%\tmp"
)

REM -------------------------------
REM - END CONFIGURATION VARIABLES -
REM -------------------------------

REM Set some variables both for cleanup + download of
REM required tools.
SET "OLDDIR=%CD%"
SET "CRAN=http://cran.r-project.org"
SET "RTOOLS_VERSION=33"
SET "R_HOME=%ROOT_DIR%\trunk"

REM Ensure that some essential tools are on the PATH.
where /Q %WGET% || (
	ECHO wget [%WGET%] not found on PATH; exiting
	exit /b
)

where /Q %SVN% || (
	ECHO svn [%SVN%] not found on PATH; exiting
	exit /b
)

REM Set the current directory.
if not exist "%ROOT_DIR%" (
	mkdir "%ROOT_DIR%"
)
cd "%ROOT_DIR%"
SET "OLDPATH=%PATH%"

REM URI to RTools.exe
SET "RTOOLS_URL=%CRAN%/bin/windows/Rtools/Rtools%RTOOLS_VERSION%.exe"

REM URI to updated toolchains.
REM TODO Remove this once Rtools stabilized.
SET "TOOLCHAIN_BASE=http://www.stats.uwo.ca/faculty/murdoch/temp"
SET "TOOLCHAIN_32BIT=%TOOLCHAIN_BASE%/mingw32mingw32_gcc-4.9.2.toolchain.tar.gz"
SET "TOOLCHAIN_64BIT=%TOOLCHAIN_BASE%/mingw32mingw64_gcc-4.9.2.toolchain.tar.gz"

REM Download Rtools, and the updated toolchains.
REM TODO: Downloading the upgraded toolchains will not be necessary
REM once RTOOLS has been fully stabilized.
wget -c %RTOOLS_URL%
wget -c %TOOLCHAIN_32BIT%
wget -c %TOOLCHAIN_64BIT%

REM Install Rtools.
SET "RTOOLS_INSTALLER=.\Rtools%RTOOLS_VERSION%.exe"
"%RTOOLS_INSTALLER%" /VERYSILENT

REM Put Rtools on the path.
SET "PATH=%RTOOLS_BIN_DIR%;%PATH%"

REM Overwrite the toolchain paths with our own.
rmdir /S /Q %RTOOLS_DIR%\gcc492_32
rmdir /S /Q %RTOOLS_DIR%\gcc492_64

REM Untar the downloaded toolchains and move them.
tar -zxvf mingw32mingw32_gcc-4.9.2.toolchain.tar.gz
move mingw32 %RTOOLS_DIR%\gcc492_32

tar -zxvf mingw32mingw64_gcc-4.9.2.toolchain.tar.gz
move mingw64 %RTOOLS_DIR%\gcc492_64

REM Download the R sources. Get the latest R-devel sources using SVN.
svn checkout https://svn.r-project.org/R/trunk/
cd trunk

REM Copy in the 'extras' for a 64bit build. This includes tcltk
REM plus some other libraries. Note that the R64 directory should
REM have been populated by the RTools installation.
REM xcopy /E /Y C:\R %R_HOME%\trunk\
rmdir /S /Q %R_HOME%\Tcl
xcopy /E /Y C:\R64 %R_HOME%\

REM Ensure the temporary directory exists.
if not exist "%TMPDIR%" (
	mkdir "%TMPDIR%"
)

REM Create the binary directories that will eventually
REM be populated ourselves, rather than letting the
REM bundled cygwin toolkit do it. The RTools 'mkdir'
REM apparently can build directories without read
REM permissions, which will cause any attempt to link
REM to DLLs within those folders to fail.
rmdir /S /Q bin
mkdir bin\i386
mkdir bin\x64

REM Move into the root directory for 'Windows' builds.
cd src\gnuwin32

REM Since we're building from source, we need to get Recommended packages.
make rsync-recommended

REM Download external software -- libpng, libgsl, and so on.
make rsync-extsoft

REM Look at MkRules.dist and if settings need to be altered, copy it to
REM MkRules.local and edit the settings there.
if exist MkRules.local (
	rm MkRules.local
)
cp MkRules.dist MkRules.local

REM Don't use MIKTEX.
sed -i 's/^MIKTEX = TRUE//g' MkRules.local

REM Ensure that the make rules are properly set -- need to
REM point to 'extsoft'.
sed -i 's/^# LOCAL_SOFT/LOCAL_SOFT/g' MkRules.local
sed -i 's/^# EXT_LIBS/EXT_LIBS/g' MkRules.local

REM Attempt to fix up permissions before the build.
cacls %R_HOME% /T /E /G BUILTIN\Users:R > NUL
cacls %TMPDIR% /T /E /G BUILTIN\Users:R > NUL

REM Make it!
REM For this part, we ensure only Rtools is on the PATH. This
REM is important as if the wrong command line utilities are picked
REM up things can fail for strange reason. In particular, we
REM _must_ use the Rtools 'sort', _not_ the Windows 'sort', or
REM else we will get strange errors from 'comm' when attempting
REM to compare sorted files. Probably just placing Rtools first
REM on the PATH is sufficient, but this is fine too.
SET "PATH=C:\Rtools\bin"
make distclean

REM Now we should be able to build R + recommended packages.
make WIN=%WIN% all recommended

REM Clean up.
SET "PATH=%OLDPATH%"
cd %OLDDIR%

#!/usr/bin/env bash

# upload-copilot-language-server.sh
#
# This script copies the "Copilot Language Server" package into the RStudio Build Tools
# (rstudio-buildtools) S3 bucket. Presumes you've already got AWS command line
# tools (awscli) installed, and configured with a valid AWS account.

# Exit on error, undefined vars, pipe failures
set -euo pipefail

# Can pass version as first argument, or fallback to hardcoded value
COPILOT_VERSION="${1:-1.509.1}"

# Validate version format 
if [[ ! "${COPILOT_VERSION}" =~ ^[0-9]+\.[0-9]+\.[0-9]+$ ]]; then
   echo "Error: Invalid version format. Expected format: X.Y.Z" >&2
   exit 1
fi

BASEURL="https://github.com/github/copilot-language-server-release/releases/download"
AWS_BUCKET="s3://rstudio-buildtools"
FILENAME="copilot-language-server-js-${COPILOT_VERSION}.zip"
S3_PATH="${AWS_BUCKET}/copilot-language-server/${COPILOT_VERSION}/"

# check if command exists
command_exists() {
   command -v "$1" >/dev/null 2>&1
}

# Function to cleanup on exit
cleanup() {
   if [[ -f "${FILENAME}" ]]; then
      rm -f "${FILENAME}"
      echo "🧹 Cleaned up temporary file: ${FILENAME}"
   fi
}

# Set up cleanup trap
trap cleanup EXIT

# Check dependencies
if ! command_exists aws; then
   echo "Error: AWS CLI is not installed or not in PATH" >&2
   exit 1
fi

if ! command_exists wget; then
   echo "Error: wget is not installed or not in PATH" >&2
   exit 1
fi

# Check AWS authentication
echo "🔒 Checking AWS authentication..."
if ! aws sts get-caller-identity >/dev/null 2>&1; then
   echo "AWS authentication required. Attempting to login..."
   if ! aws sso login; then
      echo "Error: Failed to authenticate with AWS" >&2
      exit 1
   fi
fi

# Download the file
echo "⬇️ Downloading ${FILENAME}..."
if ! wget -c "${BASEURL}/${COPILOT_VERSION}/${FILENAME}"; then
   echo "Error: Failed to download ${FILENAME}" >&2
   exit 1
fi

# Upload to S3
echo "⬆️ Uploading to S3: ${S3_PATH}"
if ! aws s3 cp "${FILENAME}" "${S3_PATH}" --acl public-read; then
   echo "Error: Failed to upload to S3" >&2
   exit 1
fi

echo "✅ Successfully uploaded Copilot Language Server ${COPILOT_VERSION} to S3"

::
:: make-package.bat
::
:: Copyright (C) 2022 by Posit Software, PBC
::
:: Unless you have received this program directly from Posit Software pursuant
:: to the terms of a commercial license agreement with Posit Software, then
:: this program is licensed to you under the terms of version 3 of the
:: GNU Affero General Public License. This program is distributed WITHOUT
:: ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
:: MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
:: AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
::
@echo off

setlocal EnableDelayedExpansion
set "PACKAGE_DIR=%CD%"

REM This defines RSTUDIO_TOOLS_ROOT if it isn't already set in the environment.
call %PACKAGE_DIR%\..\..\dependencies\tools\rstudio-tools.cmd

REM Prefer dependencies installed within the tools root (see
REM dependencies/windows/install-dependencies.cmd); fall back to
REM dependencies installed within the source tree (the legacy layout).
if exist "%RSTUDIO_TOOLS_ROOT%\dependencies\windows" (
    set "RSTUDIO_DEPENDENCIES=%RSTUDIO_TOOLS_ROOT%\dependencies"
) else (
    set RSTUDIO_DEPENDENCIES=%PACKAGE_DIR%\..\..\dependencies
)

%RUN% normalize-path "%PACKAGE_DIR%\..\..\src\node\desktop" ELECTRON_SOURCE_DIR
%RUN% normalize-path "%ELECTRON_SOURCE_DIR%\..\desktop-build-AMD64" ELECTRON_BINARY_DIR
%RUN% normalize-path "%RSTUDIO_DEPENDENCIES%" RSTUDIO_DEPENDENCIES

set BUILD_GWT=1
set QUICK=
set NOZIP=
set CLEANBUILD=
set RSTUDIO_TARGET=Electron
set PACKAGE_VERSION_SET=
set DEBUG_BUILD=

REM Produce multiarch builds by default on Jenkins.
if defined JENKINS_URL (
    set MULTIARCH=1
) else (
    set MULTIARCH=0
)

if "%1" == "--help" goto :showhelp
if "%1" == "-h" goto :showhelp
if "%1" == "help" goto :showhelp
if "%1" == "/?" goto :showhelp

setlocal EnableDelayedExpansion
for %%A in (%*) do (
    set KNOWN_ARG=0
    if /I "%%A" == "clean" (
        set CLEANBUILD=1
        set KNOWN_ARG=1
    )
    if /I "%%A" == "debug" (
        set DEBUG_BUILD=1
        set KNOWN_ARG=1
    )
    if /I "%%A" == "electron" (
        set RSTUDIO_TARGET=Electron
        set KNOWN_ARG=1
    )
    if /I "%%A" == "multiarch" (
        set MULTIARCH=1
        set KNOWN_ARG=1
    )
    if /I "%%A" == "nogwt" (
        set BUILD_GWT=0
        set KNOWN_ARG=1
    )
    if /I "%%A" == "nozip" (
        set NOZIP=1
        set KNOWN_ARG=1
    )
    if /I "%%A" == "quick" (
        set QUICK=1
        set KNOWN_ARG=1
    )
    if "!KNOWN_ARG!" == "0" goto :showhelp
)

REM Check for debug build.
if defined DEBUG_BUILD (
    set CMAKE_BUILD_TYPE=Debug
)

REM Clean if requested.
if defined CLEANBUILD (
    call clean-build.bat
    if exist CMakeCache.txt del CMakeCache.txt
)

REM Check for required programs on the PATH.
for %%F in (ant cmake) do (
    where /q %%F
    if ERRORLEVEL 1 (
        echo '%%F' not found on PATH; exiting
        endlocal
        exit /b 1
    )
)

REM Find node tools.
set NODE_DIR=%RSTUDIO_DEPENDENCIES%\common\node\%RSTUDIO_NODE_VERSION%
set NODE=%NODE_DIR%\node.exe
if not exist %NODE% (
    echo node.exe not found at %NODE_DIR%; exiting
    endlocal
    exit /b 1
)
echo Using node: %NODE%

set NPM=%NODE_DIR%\npm
if not exist %NPM% (
    echo npm not found at %NODE_DIR%; exiting
    endlocal
    exit /b 1
)
echo Using npm: %NPM%

set NPX=%NODE_DIR%\npx
if not exist %NPX% (
    echo npx not found at %NODE_DIR%; exiting
    endlocal
    exit /b 1
)
echo Using npx: %NPX%

REM Put node on the path
set PATH=%NODE_DIR%;%PATH%

REM Set up resource-hacker utility.
set REZH=%RSTUDIO_DEPENDENCIES%\windows\resource-hacker\ResourceHacker.exe
if not exist %REZH% (
    echo ResourceHacker.exe not found; re-run install-dependencies.cmd and try again; exiting
    endlocal
    exit /b 1
)

REM Build GWT desktop module.
set GWT_MAIN_MODULE=RStudioDesktop

REM Remove system Rtools from PATH (can confuse CMake and other tools)
call set PATH=%PATH:C:\Rtools\bin=%
call set PATH=%PATH:C:\Rtools\gcc-4.6.3\bin=%

REM Remove Git from PATH (otherwise CMake complains about 'sh.exe')
call set PATH=%PATH:C:\Program Files (x86)\Git\bin=%
call set PATH=%PATH:C:\Program Files\Git\bin=%

REM Build RStudio version suffix.
if not defined RSTUDIO_VERSION_MAJOR set RSTUDIO_VERSION_MAJOR=99
if not defined RSTUDIO_VERSION_MINOR set RSTUDIO_VERSION_MINOR=9
if not defined RSTUDIO_VERSION_PATCH set RSTUDIO_VERSION_PATCH=9
if not defined RSTUDIO_VERSION_SUFFIX set RSTUDIO_VERSION_SUFFIX=-dev+999
set RSTUDIO_VERSION_FULL=%RSTUDIO_VERSION_MAJOR%.%RSTUDIO_VERSION_MINOR%.%RSTUDIO_VERSION_PATCH%%RSTUDIO_VERSION_SUFFIX%

REM Set default CMake build type.
if "%CMAKE_BUILD_TYPE%" == "" set CMAKE_BUILD_TYPE=RelWithDebInfo

REM Work in package directory.
cd "%PACKAGE_DIR%"

REM Compute build directory.
if not defined BUILD_DIR (
    if "%CMAKE_BUILD_TYPE%" == "Debug" (
        set BUILD_DIR=build-debug
    ) else (
        set BUILD_DIR=build
    )
)

REM Normalize slashes.
set "BUILD_DIR=%BUILD_DIR:/=\%"

REM Enter build directory.
if not exist "%BUILD_DIR%" mkdir "%BUILD_DIR%"
pushd "%BUILD_DIR%"

REM Use full path to build directory.
set "BUILD_DIR=%CD%"

REM Package these files into a shorter path to workaround windows max path of 260
REM Must match CPACK_PACKAGE_DIRECTORY set in rstudio/package/win32/CMakeLists.txt
set PKG_TEMP_DIR=C:\rsbuild
if exist "%PKG_TEMP_DIR%/_CPack_Packages" rmdir /s /q "%PKG_TEMP_DIR%\_CPack_Packages"

REM Configure the main build.
call vcvarsall.bat amd64
cmake -G Ninja ^
    -DCMAKE_BUILD_TYPE=%CMAKE_BUILD_TYPE% ^
    -DCMAKE_C_COMPILER=cl.exe ^
    -DCMAKE_CXX_COMPILER=cl.exe ^
    -DRSTUDIO_TARGET=%RSTUDIO_TARGET% ^
    -DRSTUDIO_PACKAGE_BUILD=1 ^
    -DLIBR_HOME=C:\R\R-3.6.3 ^
    -DGWT_BUILD=%BUILD_GWT% ^
    %RSTUDIO_PROJECT_ROOT% || (
        echo.!! ERROR: configure failed
        exit /b 1
    )

REM Perform the build.
cmake --build . --config %CMAKE_BUILD_TYPE% -- %MAKEFLAGS% || (
    echo.!! ERROR: build failed
    exit /b 1
)

REM Add icons for supported file types.
if "%RSTUDIO_TARGET%" == "Electron" (
    pushd %ELECTRON_BINARY_DIR%
    cd out\RStudio-win32-x64
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\RProject.ico -mask ICONGROUP,2,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\RSource.ico -mask ICONGROUP,3,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\CSS.ico -mask ICONGROUP,4,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\HTML.ico -mask ICONGROUP,5,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\JS.ico -mask ICONGROUP,6,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\Markdown.ico -mask ICONGROUP,7,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\QuartoMarkdown.ico -mask ICONGROUP,8,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\RData.ico -mask ICONGROUP,9,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\RDoc.ico -mask ICONGROUP,10,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\RHTML.ico -mask ICONGROUP,11,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\RMarkdown.ico -mask ICONGROUP,12,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\RPresentation.ico -mask ICONGROUP,13,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\RSweave.ico -mask ICONGROUP,14,1033
    %REZH% -open rstudio.exe -save rstudio.exe -action addoverwrite -resource ..\..\resources\icons\RTex.ico -mask ICONGROUP,15,1033
    popd
)

REM Return to package directory.
popd

REM Perform 32-bit build and install it into the 64-bit tree.
if "%MULTIARCH%" == "1" (
    call make-install-win32.bat "%BUILD_DIR%\src\cpp\session" %* || (
        echo.!! ERROR: 32-bit session components build failed
        exit /b 1
    )
)

REM Create packages for development builds.
REM The official build invokes this from Jenkinsfile after signing binaries.
if not defined JENKINS_URL (
    set _MAKE_PACKAGE=1
)

REM Allow an override if RSTUDIO_DOCKER_DEVELOPMENT_BUILD is set.
REM This is used by the win-docker-compile.bat script.
if defined RSTUDIO_DOCKER_DEVELOPMENT_BUILD (
    set _MAKE_PACKAGE=1
)

REM Generate a package if configured to do so.
if defined _MAKE_PACKAGE (
    call make-dist-packages.bat || (
        echo.!! ERROR: package creation failed
        exit /b 1
    )
)

echo RStudio was built successfully.
goto :eof


:showhelp
echo.
echo make-package [clean] [debug] [electron] [multiarch] [nogwt] [nozip] [quick]
echo.
echo     clean:      perform full rebuild
echo     debug:      perform a debug build
echo     electron:   build Electron desktop (default)
echo     multiarch:  produce both 32-bit and 64-bit rsession executables
echo     nogwt:      skip GWT build (use previous GWT build)
echo     nozip:      skip creation of ZIP file
echo     quick:      skip creation of setup package
echo.
echo     Environment variables specify the product's build version (default is 99.9.9).
echo.
echo     Example:
echo.
echo     set RSTUDIO_VERSION_MAJOR=2023
echo     set RSTUDIO_VERSION_MINOR=8
echo     set RSTUDIO_VERSION_PATCH=1
echo     set RSTUDIO_VERSION_SUFFIX=-daily+321
echo     make-package clean electron
echo.
exit /b 0

@REM @echo off

:: This folder won't exist when building the docker image
if not exist ..\..\..\src\gwt\lib (
    echo Creating directory ..\..\..\src\gwt\lib
    mkdir ..\..\..\src\gwt\lib
)
pushd ..\..\..\src\gwt\lib


:: IMPORTANT: When changing which branch this pulls from below, also update the Dockerfiles'
::            "panmirror check for changes" command to use the equivalent.

if not exist quarto (
  REM git clone https://github.com/quarto-dev/quarto.git ..\..\..\src\gwt\lib\quarto
  git clone --branch release/rstudio-pacific-dogwood https://github.com/quarto-dev/quarto.git ..\..\..\src\gwt\lib\quarto
  pushd ..\..\..\src\gwt\lib\quarto
  git rev-parse HEAD
  popd
) else (
  pushd quarto
  git fetch
  git reset --hard
  git clean -dfx
  REM git checkout main
  git checkout release/rstudio-pacific-dogwood
  git pull
  git rev-parse HEAD
  popd
)

popd

#!/usr/bin/env bash

# Creates a "_dev" locale, which is a copy of the _en locale with PREFIX prepended
# onto all strings for easy spotting in the UI
# 
# Running this script will result in a "XXX_dev.properties" file for each 
# "XXX_en.properties" file in this directory and its subdirectories

# Note: run this from /src/gwt/src, otherwise you'll create extra properties files
# from places that are generated code rather than input code

PREFIX="@"

for src in $(find . -name "*en.properties"); do
  tgt=$(echo "$src" | sed -e 's/_en.properties$/_dev.properties/')
  echo "Copying $src -> $tgt"
  if [ -f "$tgt" ]; then
  	echo "WARNING: Target $tgt already exists - skipping"
  else
    # "copy" src with sed, replacing all lines of "X = Y" with "X = {PREFIX}Y"
    if [[ "$OSTYPE" = "darwin"* ]]; then
      sed -E "s/^([^\x0D=]*)=([ ]*)([^\x0D]*)/\1=\2${PREFIX}\3/" $src > $tgt
    else
      sed -E "s/^([^\n=]*)=([ ]*)([^\n]*)\$/\1=\2${PREFIX}\3/" $src > $tgt
    fi
  fi
done

REM This script installs R-devel from source on Windows.
REM Update the variables up here as new versions of R are released;
REM we attempt to build from tarballs.
REM
REM This script assumes you have 'wget' on your path, as it
REM is used to download. You can find a binary here:
REM
REM     https://eternallybored.org/misc/wget/wget64.exe 
REM
REM

REM ---------------------------------
REM - BEGIN CONFIGURATION VARIABLES -
REM ---------------------------------

SET ROOT_DIR=C:\R-src
SET R_MAJOR_VERSION=3
SET R_FULL_VERSION=3.1.2
SET RTOOLS_BIN_DIR=C:\Rtools\bin
SET TMPDIR=C:\tmp

REM Note: Tool path must use forward slashes, and
REM should end with a trailing slash.
SET TOOL_PATH=C:/Rtools/gcc-4.6.3/bin/

REM -------------------------------
REM - END CONFIGURATION VARIABLES -
REM -------------------------------

REM Unix-style newline. The newline hack!
REM Creating a Newline variable (the two blank lines are required!)
set NLM=^


set NL=^^^%NLM%%NLM%^%NLM%%NLM%

REM Set the current directory.
if not exist "%ROOT_DIR%" mkdir "%ROOT_DIR%"
cd "%ROOT_DIR%"

SET OLDPATH=%PATH%

REM Download the R sources.
if not exist R-%R_FULL_VERSION%.tar.gz (
	wget http://cran.us.r-project.org/src/base/R-%R_MAJOR_VERSION%/R-%R_FULL_VERSION%.tar.gz
)

REM Put Rtools on the path.
SET PATH=C:\Rtools\bin;%PATH%

if exist R-%R_FULL_VERSION% rmdir /S /Q R-%R_FULL_VERSION%
tar -xf R-%R_FULL_VERSION%.tar.gz

REM Copy in the 'extras' for a 64bit build. This includes tcltk
REM plus some other libraries.
xcopy /E C:\R64 %ROOT_DIR%\R-%R_FULL_VERSION%

REM Ensure the temporary directory exists.
if not exist "%TMPDIR%" mkdir "%TMPDIR%"

cd R-%R_FULL_VERSION%\src\gnuwin32

REM Look at MkRules.dist and if settings need to be altered, copy it to
REM MkRules.local and edit the settings there. In particular, this is where a
REM 64-bit build is selected.
if exist MkRules.local rm MkRules.local
cp MkRules.dist MkRules.local

REM Set the MULTI and TOOL_PATH variables for the
REM R build. We focus on producing a 64bit build here.
sed -i 's/^MULTI =/MULTI = 64/g' MkRules.local
sed -i 's/^TOOL_PATH =//g' MkRules.local
echo | set /p=TOOL_PATH = %TOOL_PATH%%NL%>> MkRules.local

REM Don't use MIKTEX
sed -i 's/^MIKTEX = TRUE//g' MkRules.local

REM Make it!
REM For this part, we ensure only Rtools is on the PATH.
SET PATH=C:\Rtools\bin
make -j10 all recommended

REM Clean up
SET PATH=%OLDPATH%

#!/usr/bin/env bash
#
# RStudio Release Notarization (notarize-release.sh)
# 
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
# Notarizes an RStudio release using the public Apple notary service.
#
# Usage: 
#
#    notarize-release.sh [path-to-dmg]
#
# where path-to-dmg is a relative or absolute path to the DMG file to notarize.
#
# Expects the following environment variables to be present:
#  
#    APPLE_ID_USR: the ID of the Apple account under which to submit the
#      notarization request
#    APPLE_ID_PSW: An app-specific password (NOT the primary password) for
#      the Apple ID. See details here: https://support.apple.com/en-us/HT204397
#  

if [[ "$#" -lt 1 ]]; then
    echo "Usage: notarize-release.sh [path-to-dmg]"
    exit 1
fi

# Validate environment vars
if [ -z "${APPLE_ID_USR}" ]; then
    echo "Please set the environment variable APPLE_ID_USR to the AppleID under which to submit the notarization request."
    exit 1
fi
if [ -z "${APPLE_ID_PSW}" ]; then
    echo "Please set the environment variable APPLE_ID_PSW to the password to the account named in the APPLE_ID_USR environment variable."
    exit 1
fi

# Submit the notarization request to Apple
echo "Submitting notarization request using account ${APPLE_ID_USR} ..."

log=/tmp/rstudio-notarization-$$.log
mkfifo "${log}"
trap 'rm -f ${log}' EXIT

# The team-id uniquely identifies the organization with Apple. It does not need to be generated again and is found in the Apple developer account.
xcrun notarytool submit --wait   \
    --apple-id "${APPLE_ID_USR}" \
    --password "${APPLE_ID_PSW}" \
    --team-id FYF2F5GFX4         \
    --progress                   \
    "$1" > "${log}" 2>&1 &

# Stream logs, and collect the UUID used for the submission.
while IFS= read -r line < "${log}"; do
    
    echo "${line}"
    
    if [[ "${line}" =~ "id:" ]]; then
        uuid=$(echo "${line}" | cut -d: -f2 | xargs)
    fi

    if [[ "${line}" =~ "Current status: Invalid" ]]; then
        status="invalid"
    fi

    if [[ "${line}" =~ "Processing complete" ]]; then
        break
    fi

done

# Check for success.
if [[ "${status}" = "invalid" ]]; then

    echo
    echo ----------------------------------------
    xcrun notarytool log             \
        --apple-id "${APPLE_ID_USR}" \
        --password "${APPLE_ID_PSW}" \
        --team-id FYF2F5GFX4         \
        "${uuid}"
    echo ----------------------------------------
    echo

    echo "Notarization failed."
    exit 1

fi

# Staple the result to DMG file (allows offline verification of notarization)
xcrun stapler staple "$1"

# ----------------------------------------------------------------------------
# Bootstrap a clean Windows-11 system for RStudio development.
#
# Run this from an Administrator PowerShell prompt after enabling scripts
# via 'Set-ExecutionPolicy Unrestricted -force'.
#
# See README.md for more details.
# ----------------------------------------------------------------------------

# Set to $false to keep downloads after installing; helpful for debugging script
$DeleteDownloads = $true

function Test-Administrator {
    [CmdletBinding()]
    $user = [Security.Principal.WindowsIdentity]::GetCurrent();
    (New-Object Security.Principal.WindowsPrincipal $user).IsInRole([Security.Principal.WindowsBuiltinRole]::Administrator)
}

function Invoke-DownloadFile {
    [CmdletBinding()]
    param(
        [Parameter(Mandatory = $true)]
        [string]$url,

        [Parameter(Mandatory = $true)]
        [string]$output
    )
    Write-Verbose "Downloading from $url to $output"
    try {
        Invoke-WebRequest -Uri $url -OutFile $output -ErrorAction Stop
        Write-Verbose "Download completed successfully"
    }
    catch {
        Write-Error "Download failed: $_"
    }
}

function Install-ChocoPackageIfMissing {
    [CmdletBinding()]
    param(
        [Parameter(Mandatory=$true)]
        [string]$PackageName,

        [Parameter(Mandatory=$true)]
        [string]$TestCommand
    )

    if (!(Get-Command $TestCommand -ErrorAction SilentlyContinue)) {
        Write-Host "$TestCommand not found, installing $PackageName via chocolatey..."
        choco install -y $PackageName
    } else {
        Write-Host "$TestCommand already installed, skipping $PackageName installation"
    }
}

##############################################################################
# script execution starts here
##############################################################################
If (-Not (Test-Administrator)) {
    Write-Host "Error: Must run this script as Administrator"
    exit
}
if ($PSVersionTable.PSVersion.Major -lt 5) {
    Write-Host "Error: Requires PowerShell 5.0 or newer"
    exit
}

# Installation instructions borrowed from:
#
#   https://learn.microsoft.com/en-us/visualstudio/install/build-tools-container?view=vs-2022
#
# If you need to add (or change) the components installed here, use:
#
#   https://learn.microsoft.com/en-us/visualstudio/install/workload-component-id-vs-community?view=vs-2022
#
# to look up the associated component name.
#
# Note that we use this tool to install Visual Studio's build tools, as well as the
# required Windows 10 SDK, as chocolatey doesn't seem to provide the versions we need.
#

# Download the Build Tools bootstrapper.
Invoke-DownloadFile https://aka.ms/vs/17/release/vs_buildtools.exe vs_buildtools.exe

# Install Build Tools. For whatever reason, this fails when we try to install
# into C:/Program Files (x86), so just use the "regular" C:/Program Files.
Write-Host "Installing Visual Studio Build Tools..."
$installArgs = @(
    '--quiet', '--wait', '--norestart', '--nocache',
    '--installPath', '"C:/Program Files/Microsoft Visual Studio/2022/BuildTools"',
    '--add', 'Microsoft.VisualStudio.Workload.VCTools',
    '--add', 'Microsoft.VisualStudio.Component.VC.Tools.x86.x64',
    '--add', 'Microsoft.VisualStudio.Component.VC.Tools.ARM64',
    '--add', 'Microsoft.VisualStudio.Component.Windows11SDK.26100'
)
$vsProcess = Start-Process -FilePath ".\vs_buildtools.exe" -ArgumentList $installArgs -Wait -NoNewWindow -PassThru
if ($vsProcess.ExitCode -ne 0) {
    Write-Error "Visual Studio Build Tools installation failed with exit code $($vsProcess.ExitCode)"
    exit
}

# Try testing the build tools. You might see some telemetry errors here;
# they can apparently be ignored.
Write-Host "Testing VsDevCmd.bat..."
$vsDevCmdPath = "C:\Program Files\Microsoft Visual Studio\2022\BuildTools\Common7\Tools\VsDevCmd.bat"
if (Test-Path $vsDevCmdPath) {
    Push-Location "C:\Program Files\Microsoft Visual Studio\2022\BuildTools\Common7\Tools"
    cmd /c "VsDevCmd.bat -clean_env -no_logo && VsDevCmd.bat -arch=x86 -startdir=none -host_arch=x86 -no_logo && echo -- Testing VsDevCmd.bat -- success"
    Pop-Location
    Write-Host "Build tools verification completed"
} else {
    Write-Warning "VsDevCmd.bat not found at expected path, skipping verification"
}

# Clean up.
if ($DeleteDownloads -and (Test-Path "vs_buildtools.exe")) {
    Remove-Item vs_buildtools.exe -Force -ErrorAction SilentlyContinue
}

# install R
if (-Not (Test-Path -Path "C:\R")) {
    $RSetupPackage = "C:\R-3.6.3-win.exe"
    if (-Not (Test-Path -Path $RSetupPackage)) {
        Invoke-DownloadFile https://rstudio-buildtools.s3.amazonaws.com/R/R-3.6.3-win.exe $RSetupPackage -Verbose
    } else {
        Write-Host "Using previously downloaded R installer"
    }
    Write-Host "Installing R..."
    $rProcess = Start-Process $RSetupPackage -Wait -ArgumentList '/VERYSILENT /DIR="C:\R\R-3.6.3\"' -PassThru
    if ($rProcess.ExitCode -ne 0) {
        Write-Error "R installation failed with exit code $($rProcess.ExitCode)"
        exit
    }
    if ($DeleteDownloads) { Remove-Item $RSetupPackage -Force -ErrorAction SilentlyContinue }
    $rBinPath = 'C:\R\R-3.6.3\bin\x64\'
    $env:path += ";$rBinPath"
    $machinePath = [Environment]::GetEnvironmentVariable('Path', [System.EnvironmentVariableTarget]::Machine)
    if ($machinePath -notlike "*$rBinPath*") {
        [Environment]::SetEnvironmentVariable('Path', "$machinePath;$rBinPath", [System.EnvironmentVariableTarget]::Machine)
    }
} else {
    Write-Host "C:\R already exists, skipping R installation"
}

# install chocolatey
Invoke-Expression ((New-Object System.Net.WebClient).DownloadString('https://chocolatey.org/install.ps1'))
refreshenv

# install some deps via chocolatey
choco install -y cmake --installargs 'ADD_CMAKE_TO_PATH=""System""' --fail-on-error-output
refreshenv
choco install -y temurin17
choco install -y -i ant
choco install -y 7zip
choco install -y ninja
choco install -y nsis
choco install -y python313
choco install -y strawberryperl
choco install -y jq
Install-ChocoPackageIfMissing -PackageName "git" -TestCommand "git"

# cpack (an alias from chocolatey) and cmake's cpack conflict.
# Newer choco doesn't have this so don't fail if not found
$ChocoCPack = 'C:\ProgramData\chocolatey\bin\cpack.exe'
if (Test-Path $ChocoCPack) { Remove-Item -Force $ChocoCPack }

Write-Host "-----------------------------------------------------------"
Write-Host "Core dependencies successfully installed. Next steps:"
Write-Host "(1) Start a non-administrator Command Prompt"
Write-Host "(2) git clone https://github.com/rstudio/rstudio"
Write-Host "(3) change working dir to rstudio\dependencies\windows"
Write-Host "(4) install-dependencies.cmd"
Write-Host "-----------------------------------------------------------"

#!/usr/bin/env bash
#
# Claude Code PreToolUse hook (Bash matcher).
# Blocks git push and git commit when the current branch is main or matches rel-*.
#
set -euo pipefail

# Read the tool input from stdin
input=$(cat)

# Extract the command from the JSON payload
command=$(echo "$input" | jq -r '.tool_input.command // empty') || {
  echo "WARNING: Failed to parse hook input JSON. Blocking as a precaution." >&2
  exit 2
}

# A git invocation may carry global options between 'git' and its subcommand
# (e.g. 'git -C <dir> -c x=y commit'), so the subcommand is not necessarily the
# first token. This fragment matches a run of such options -- '-C <dir>' (whose
# argument may be single- or double-quoted, e.g. a path with spaces), '-c
# <name>=<value>', and other single-/double-dash flags -- so we can find the
# real commit/push subcommand, and the -C target, past them.
git_opts="([[:space:]]+(-C[[:space:]]+(\"[^\"]*\"|'[^']*'|[^[:space:]]+)|-c[[:space:]]+[^[:space:]]+|--?[^[:space:]]+))*"

# Block git push and git commit on protected branches
if echo "$command" | grep -qE "\bgit${git_opts}[[:space:]]+(push|commit)\b"; then

  # Resolve the directory the git command actually targets, so that commits
  # and pushes from a worktree are evaluated against the worktree's branch --
  # not whatever branch happens to be checked out in this hook's working
  # directory (typically the primary checkout). Prefer the argument to an
  # explicit 'git -C <dir>', then a leading 'cd <dir>', else the cwd. The -C
  # match is anchored to the leading option region (via "$git_opts") so a -C
  # appearing only inside a commit message (e.g. -m "see -C") is not mistaken
  # for a target directory.
  #
  # The '|| true' is required: under 'set -e'/'pipefail' a non-matching grep (no
  # -C / no cd, the common bare 'git commit' case) would otherwise fail the
  # assignment and abort the hook -- letting the command through unchecked.
  target_dir=$(echo "$command" | grep -oE "\bgit${git_opts}[[:space:]]+-C[[:space:]]+(\"[^\"]*\"|'[^']*'|[^[:space:]]+)" | head -1 | sed -E "s/.*-C[[:space:]]+//" || true)
  if [ -z "$target_dir" ]; then
    target_dir=$(echo "$command" | grep -oE '\bcd[[:space:]]+[^ ;&|]+' | head -1 | sed -E 's/^cd[[:space:]]+//' || true)
  fi
  target_dir="${target_dir:-.}"

  # strip surrounding quotes, if any
  target_dir="${target_dir%\"}"; target_dir="${target_dir#\"}"
  target_dir="${target_dir%\'}"; target_dir="${target_dir#\'}"

  branch=$(git -C "$target_dir" rev-parse --abbrev-ref HEAD 2>/dev/null) || {
    echo "WARNING: Could not determine current branch. Blocking as a precaution." >&2
    exit 2
  }

  if [ "$branch" = "main" ] || echo "$branch" | grep -qE '^rel-'; then
    if echo "$command" | grep -qE "\bgit${git_opts}[[:space:]]+push\b"; then
      echo "BLOCKED: git push on '$branch' is not allowed. Create a feature branch first." >&2
    else
      echo "BLOCKED: git commit on '$branch' is not allowed. Create a feature branch first." >&2
    fi
    exit 2
  fi
fi

# Allow: nothing matched a protected branch. Exit explicitly so the allow path
# does not inherit a non-zero status from a preceding test (e.g. the branch
# comparison above), which Claude Code would surface as a hook error.
exit 0

@echo off

setlocal

REM Ensure (the default install location for) Git is on the PATH here. Having
REM this directory on the PATH by default can be a pain because Rtools (and its
REM competing tools) can compete with that directory.
set "PATH=C:\Program Files (x86)\Git\bin;%PATH%"

set PATH=%PATH%;%CD%\tools

REM call:install rmarkdown main rstudio --no-build-vignettes
REM call:install rsconnect main rstudio --no-build-vignettes
REM call:install renv master rstudio --no-build-vignettes

GOTO:EOF

:install

set PACKAGE=%1
set PACKAGE_VERSION=%2
set PACKAGE_GITHUB_ROOT=%3
set PACKAGE_BUILD_OPTIONS=%4

REM git clone if necessary
set PACKAGE_DIR="%PACKAGE%"
if not exist "%PACKAGE_DIR%" (
   if "%RSTUDIO_GITHUB_LOGIN%" == "" (
      git clone "https://github.com/%PACKAGE_GITHUB_ROOT%/%PACKAGE%.git"
   ) else (
      git clone "https://%RSTUDIO_GITHUB_LOGIN%@github.com/%PACKAGE_GITHUB_ROOT%/%PACKAGE%.git"
   )
)

REM clean and checkout target branch
pushd "%PACKAGE_DIR%"
git checkout .
git clean -df .
git pull
git checkout "%PACKAGE_VERSION%"


REM append GitHub fields to DESCRIPTION
REM NOTE: older-style Github prefix required by Packrat 0.5.0;
REM       newer-style Remote prefix required by renv.
git rev-parse "%PACKAGE_VERSION%" > PACKAGE_SHA1
set /p PACKAGE_SHA1= < PACKAGE_SHA1
del PACKAGE_SHA1
echo GithubRepo: %PACKAGE% >> DESCRIPTION
echo GithubUsername: rstudio >> DESCRIPTION
echo GithubRef: %PACKAGE_VERSION% >> DESCRIPTION
echo GithubSHA1: %PACKAGE_SHA1% >> DESCRIPTION
echo RemoteType: github >> DESCRIPTION
echo RemoteHost: api.github.com >> DESCRIPTION
echo RemoteRepo: %PACKAGE% >> DESCRIPTION
echo RemoteUsername: rstudio >> DESCRIPTION
echo RemoteRef: %PACKAGE_VERSION% >> DESCRIPTION
echo RemoteSha: %PACKAGE_SHA1% >> DESCRIPTION
echo Origin: RStudioIDE >> DESCRIPTION

REM create source package
popd
set PACKAGE_ARCHIVE_PATTERN="%PACKAGE%*.tar.gz"
del /s /q %PACKAGE_ARCHIVE_PATTERN%
R CMD build "%PACKAGE_BUILD_OPTIONS%" "%PACKAGE%"

REM modify filename to include SHA1
for %%f in (%PACKAGE_ARCHIVE_PATTERN%) do set PACKAGE_ARCHIVE=%%f
set PACKAGE_ARCHIVE_STEM=%PACKAGE_ARCHIVE:~0,-7%
set PACKAGE_ARCHIVE_SHA1=%PACKAGE_ARCHIVE_STEM%_%PACKAGE_SHA1%.tar.gz
move %PACKAGE_ARCHIVE% %PACKAGE_ARCHIVE_SHA1%

GOTO:EOF

#!/usr/bin/env bash

# REPORTS THE USAGE OF SERVER AND SESSION OPTIONS, pairs with generate-options.R
###############################################################################
# We look in the documentation for 3 ways in which an option may be used:
# - A mention like `auth-none`
# - A command like `--auth-none`
# - A example of config file like:
# ```
# auth-none=1
# ```
# If none of these are present in the Rmd files, we warn for non-hidden, non-deprecated options.
#
# To see all options instead of just the ones being misused, run this script with the `ALL=1` variable.
###############################################################################
ALL=$1

function inDocs() {
	line=$1
	MENTION_COUNT=$(grep -l -w "\`$line\`" ../../docs/server/*/*.qmd | wc -l)
	EXAMPLE_COUNT=$(grep -l -e "^\b$line\b" ../../docs/server/*/*.qmd | wc -l)
	COMMAND_COUNT=$(grep -l -w "\-\-$line" ../../docs/server/*/*.qmd | wc -l)
	if [[ $MENTION_COUNT -ne 0 || $EXAMPLE_COUNT -ne 0 || $COMMAND_COUNT -ne 0 ]]; then
		return 1
	fi
	return 0
}

function inCode() {
	COUNT=$(find ./ -name *.cpp -o -name *.hpp | grep -v '.gen' | xargs grep -w $line | wc -l)
	if [[ $COUNT -eq 0 ]]; then
		return 0
	fi
	return 1
}

function listDocFiles() {
	grep -l -w "$line" ../../docs/server/*.Rmd | cut -d':' -f 1 | tr '\n' ' '
}

function scanPublicOptions() {
	FILE="$1"
	OPTIONS=$(cat ./$FILE/$FILE-options*.json | jq -r '.options | keys[] as $k | .[$k] | flatten |  .[] | select(.isHidden != true and .isDeprecated != true) | .name | if type=="object" then .value else . end' | sort)
	while IFS= read -r line; do
		inDocs $line
		if [[ $? -eq 0 ]]; then
			echo "$FILE: $line -- MISSING IN DOCS, ADD IT TO DOCS, MAKE IT HIDDEN OR DEPRECATED"
		elif [[ ! -z $ALL ]]; then
			FILES=$(listDocFiles)
			echo "$FILE: $line -- IN DOCS $FILES, OK"
		fi
	done <<< $OPTIONS
}

function serverOptionsMatch() {
	OPTION="$1"
	SERVER_OPTIONS=$(cat ./server/server-options*.json | jq -r '.options | keys[] as $k | .[$k] | flatten |  .[] | .name | if type=="object" then .value else . end' | sort)
	echo "$SERVER_OPTIONS" | grep -l -w $OPTION | wc -l
}

function scanSomeOptions() {
	FILE="$1"
	TYPE="$2"
	OPTIONS=$(cat ./$FILE/$FILE-options*.json | jq --arg field "$TYPE" -r '.options | keys[] as $k | .[$k] | flatten |  .[] | select(.[$field] == true) | .name | if type=="object" then .value else . end' | sort)
	while IFS= read -r line; do
		inDocs $line
		if [[ $? -eq 1 ]]; then
			FILES=$(listDocFiles)
			if [[ $FILE == "session" ]]; then
				OTHER=$(serverOptionsMatch $line)
			else
				OTHER=0
			fi
			if [[ $TYPE == "isHidden" ]]; then
				VISIBILITY="VISIBLE"
			else
				VISIBILITY="HIDDEN"
			fi
			if [[ $OTHER -eq 0 ]]; then
				echo "$FILE: $line -- $TYPE BUT SHOWN IN $FILES, MAKE IT $VISIBILITY OR REMOVE IT FROM DOCS"
			elif [[ ! -z $ALL ]]; then
				echo "$FILE: $line -- $TYPE IN SESSION BUT ALSO IN SERVER, SHOWN IN $FILES, PLEASE CHECK"
			fi
		elif [[ ! -z $ALL ]]; then
			echo "$FILE: $line -- $TYPE AND NOT IN DOCS, OK"
		fi
	done <<< $OPTIONS
}

function scanCodeOptions() {
	FILE=$1
	OPTIONS=$(cat ./$FILE/$FILE-options*.json | jq -r '.options | keys[] as $k | .[$k] | flatten |  .[] | if .accessorName then .accessorName else (if .memberName then .memberName|sub("_"; "") else (if .name|type=="object" then .name.constant else . end) end) end' | sort)
	while IFS= read -r line; do
		COUNT=$(find ./ -name *.cpp -o -name *.hpp | grep -v '.gen' | xargs grep -w $line | wc -l)
		if [[ $COUNT -eq 0 ]]; then
			echo "$FILE: $line -- NOT IN CODE, MAKE IT DEPRECATED AND HIDDEN"
		fi
	done <<< $OPTIONS
}

echo "## Public Options"

# Indicates whether a public server option (not deprecated or hidden) is present in the documentation
scanPublicOptions "server"

# Indicates whether a public session option (not deprecated or hidden) is present in the documentation
scanPublicOptions "session"

echo "## Hidden Options"

# Indicates whether a hidden server option is erroneously present in the documentation
scanSomeOptions "server" "isHidden"

# Indicates whether a hidden session option is erroneously present in the documentation. A server option with the same name may be there instead.
scanSomeOptions "session" "isHidden"

echo "## Deprecated Options"

# Indicates whether a deprecated session option is erroneously present in the documentation. A server option with the same name may be there instead.
scanSomeOptions "session" "isDeprecated"

# Indicates whether a deprecated server option is erroneously present in the documentation
scanSomeOptions "server" "isDeprecated"

echo "## Code Options"

# Indicates whether a server option is not being used by the code
scanCodeOptions "server"

# Indicates whether a session option is not being used by the code
scanCodeOptions "session"

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

## R Markdown

This is an R Markdown document. Markdown is a simple formatting syntax for authoring HTML, PDF, and MS Word documents. For more details on using R Markdown see <http://rmarkdown.rstudio.com>.

When you click the **Knit** button a document will be generated that includes both content as well as the output of any embedded R code chunks within the document. You can embed an R code chunk like this:

```{r cars}
summary(cars)
```

## Including Plots

You can also embed plots, for example:

```{r pressure, echo=FALSE}
plot(pressure)
```

Note that the `echo = FALSE` parameter was added to the code chunk to prevent printing of the R code that generated the plot.

---
title: "R Notebook"
output: html_notebook
---

This is an [R Markdown](http://rmarkdown.rstudio.com) Notebook. When you execute code within the notebook, the results appear beneath the code. 

Try executing this chunk by clicking the *Run* button within the chunk or by placing your cursor inside it and pressing *Ctrl+Shift+Enter*. 

```{r}
plot(cars)
```

Add a new chunk by clicking the *Insert Chunk* button on the toolbar or by pressing *Ctrl+Alt+I*.

When you save the notebook, an HTML file containing the code and output will be saved alongside it (click the *Preview* button or press *Ctrl+Shift+K* to preview the HTML file).

The preview shows you a rendered HTML copy of the contents of the editor. Consequently, unlike *Knit*, *Preview* does not run any R code chunks. Instead, the output of the chunk when it was last run in the editor is displayed.

Title
========================================================

This is an R Markdown document. Markdown is a simple formatting syntax for authoring web pages (click the **Help** toolbar button for more details on using R Markdown).

When you click the **Knit HTML** button a web page will be generated that includes both content as well as the output of any embedded R code chunks within the document. You can embed an R code chunk like this:

```{r}
summary(cars)
```

You can also embed plots, for example:

```{r fig.width=7, fig.height=6}
plot(cars)
```

---
title: "Posit Assistant"
date-meta: 2026-02-25
---

[Posit Assistant](https://pos.it/assistant) is a set of artificial intelligence (AI) features available as a downloadable extension for RStudio. To provide feedback or report bugs, please open a [GitHub Issue on the RStudio repository](https://github.com/rstudio/rstudio/issues).

## Prerequisites

-   To use Posit Assistant in RStudio, you must have a compatible version of RStudio installed. Posit Assistant is available for RStudio Desktop or Server 2026.04.0 and later. Posit Workbench disables Posit Assistant by default, but an administrator can enable it.
-   To use Posit Assistant, you must have access to the internet in order to send requests to the Posit AI APIs and receive suggestions.

::: {.callout-note title="Posit Assistant in RStudio Server and Workbench"}
Support for RStudio Server and Posit Workbench is currently considered experimental and will be fully supported in a future release.
:::

## Setup

To configure Posit Assistant in RStudio click on the "Posit Assistant" button on the toolbar to display the "Posit Assistant" pane.

![](images/posit-assistant-button.png){fig-alt="Posit Assistant Toolbar Button" fig-align="left"}

Click **Install Posit Assistant** to download and install the add-in package, then click **Sign In** to login and signup for Posit-AI.

::: {.callout-note title="Posit AI Account Assistance"}
For more information on signing up and managing your Posit AI account visit <https://docs.posit.co/posit-ai>.
:::

::: {layout-ncol="2"}
![](images/install-posit-ai.png){fig-alt="Install Posit Assistant"}

![](images/posit-ai-sign-in.png){fig-alt="Sign in to Posit AI"}
:::

Once signed up and authenticated, the Posit Assistant chat feature is ready to use.

## Using Posit Assistant

For information on using Posit Assistant, visit the [Posit Assistant documentation](https://pos.it/assistant-docs).

## Removing Posit Assistant

To uninstall the downloaded Posit Assistant components, select **Help** \> **Diagnostics** \> **Uninstall Posit Assistant**. RStudio restarts after the uninstall completes.

RStudio preserves your chat history and account settings, which remain available if you reinstall Posit Assistant.

## Hiding Posit Assistant features

To disable and hide the Posit Assistant features entirely, set the `RSTUDIO_DISABLE_POSIT_ASSISTANT` environment variable to any value (e.g., `RSTUDIO_DISABLE_POSIT_ASSISTANT=1`) before starting RStudio. When the variable is set, RStudio does not display the Posit Assistant toolbar button or pane, and you cannot install or use Posit Assistant in that session.

On RStudio Server, administrators can also disable Posit Assistant for all users by adding the following line to `/etc/rstudio/rsession.conf`:

```ini
posit-assistant-enabled=0
```

See the [Environment Variables](../../reference/environment-variables.qmd) reference for other environment variables that affect RStudio.

# RStudio

These instructions apply to the RStudio open-source IDE repository.


## Code Structure

Broadly speaking, RStudio is split into three different components -- the front-end / user interface, the desktop integration, and the backend / server components.

- The user interface uses a mixture of Google GWT and JavaScript, in `src/gwt`.
- The desktop integration lives in `src/node/desktop`, as an Electron application.
- The backend and server components live in `src/cpp`, and are primarily authored in C++ and R.


### Backend Layout (`src/cpp`)

    src/cpp/
    ├── core/              # Foundation libraries (http, json, system, text, etc.)
    ├── shared_core/       # Shared between server and session
    ├── server_core/       # Server-specific core utilities
    ├── r/                 # R integration layer
    │   └── R/             # Core R functions (Api.R, Tools.R, etc.)
    ├── session/           # Session management (main IDE backend)
    │   ├── modules/       # Feature modules (one per feature)
    │   ├── include/       # Public headers
    │   └── resources/     # Schemas, templates, static resources
    ├── server/            # RStudio Server (auth, db, launcher)
    └── tests/             # C++ and automation tests


### Frontend Layout (`src/gwt`)

    src/gwt/src/org/rstudio/
    ├── core/client/               # Core GWT utilities (widgets, dom, events, js interop)
    └── studio/client/
        ├── application/           # Application lifecycle
        ├── common/                # Shared components
        ├── server/                # Server communication interfaces
        └── workbench/
            ├── commands/          # Command infrastructure (Commands.cmd.xml)
            ├── events/            # Event definitions
            ├── model/             # Data models
            ├── ui/                # UI components
            └── views/             # Feature views (one per pane)
                ├── source/        # Source editor (largest subsystem)
                ├── console/       # R console
                ├── environment/   # Environment pane
                ├── files/         # Files pane
                ├── plots/         # Plots pane
                ├── packages/      # Packages pane
                ├── help/          # Help pane
                ├── terminal/      # Terminal pane
                ├── chat/          # AI chat pane
                ├── vcs/           # Git/SVN integration
                ├── connections/   # Database connections
                ├── jobs/          # Background jobs
                └── ...            # buildtools, viewer, tutorial, presentation, etc.


### R Code Locations

R code lives in several places and serves different purposes:

- `src/cpp/r/R/` -- core R functions shipped with RStudio (Api.R, Tools.R, etc.)
- `src/cpp/session/modules/*.R` -- R-side logic for session modules (e.g. SessionChat.R)
- `scripts/` -- build and code generation scripts


## Session Module System

Each backend feature is implemented as a session module. Modules follow a consistent pattern:


### File naming convention

    src/cpp/session/modules/SessionXxx.cpp   # C++ implementation
    src/cpp/session/modules/SessionXxx.hpp   # C++ header (if needed)
    src/cpp/session/modules/SessionXxx.R     # R-side logic (if needed)


### Module structure

Each module lives in its own namespace and has an `initialize()` function that registers RPC methods and event handlers:

```cpp
namespace rstudio {
namespace session {
namespace modules {
namespace xxx {

namespace {
// Private helper functions and RPC handlers
} // anonymous namespace

Error initialize()
{
   using boost::bind;
   using namespace module_context;

   ExecBlock initBlock;
   initBlock.addFunctions()
      (bind(registerRpcMethod, "xxx_do_something", xxxDoSomething))
      (bind(sourceModuleRFile, "SessionXxx.R"));

   return initBlock.execute();
}

} // namespace xxx
} // namespace modules
} // namespace session
} // namespace rstudio
```


### Key module infrastructure

- `src/cpp/session/include/session/SessionModuleContext.hpp` -- module registration API (`registerRpcMethod`, `registerAsyncRpcMethod`, `sourceModuleRFile`, `enqueClientEvent`, etc.)
- `src/cpp/session/include/session/SessionClientEvent.hpp` -- all client event type constants


## Client-Server Communication

The frontend and backend communicate via JSON-RPC over HTTP. Understanding this flow is essential for most feature work.


### RPC (Frontend → Backend)

1. **Backend** registers an RPC handler in a session module's `initialize()`:

       registerRpcMethod("chat_start_backend", chatStartBackend)

   The handler function receives a `JsonRpcRequest` and populates a `JsonRpcResponse`.

2. **Frontend** defines the method in a `*ServerOperations` interface:

   ```java
   // e.g. ChatServerOperations.java
   public interface ChatServerOperations
   {
       void chatStartBackend(ServerRequestCallback<JsObject> callback);
   }
   ```

   The method name is auto-converted from snake_case to camelCase (e.g. `chat_start_backend` → `chatStartBackend`).

3. **Frontend** calls it from a presenter or view via the injected server operations interface.


### Client Events (Backend → Frontend)

1. **Backend** fires an event using `module_context::enqueClientEvent()`:

   ```cpp
   ClientEvent event(client_events::kChatOutput, data);
   module_context::enqueClientEvent(event);
   ```

   Event type constants are defined in `SessionClientEvent.hpp`.

2. **Frontend** receives the event through the `EventBus` and dispatches it to registered handlers.


## GWT Frontend Patterns


### Dependency Injection (GIN)

The GWT frontend uses GIN (GWT INjection, based on Guice) for dependency injection.

- `RStudioGinModule.java` -- binds interfaces to implementations
- `RStudioGinjector.java` -- provides access to injected singletons
- Use `@Inject` on constructors to wire dependencies


### MVP Pattern

Views follow Model-View-Presenter separation:

- **Presenter** (e.g. `ChatPresenter.java`) -- manages logic, handles events, calls server operations
- **View interface** (e.g. `ChatPresenter.Display`) -- defines the UI contract
- **View implementation** (e.g. `ChatPane.java`) -- implements the widget and UI


### EventBus

Components communicate through a central `EventBus` using typed events. Fire events with `eventBus_.fireEvent()` and handle them by implementing the corresponding `Handler` interface.


### Server Operations

Each feature area defines a `*ServerOperations` interface for its RPC calls. These are aggregated into `Server.java`, which is the main server interface.


## Adding a New Feature (Checklist)

When implementing a new feature end-to-end:

1. **Backend module**: Create `src/cpp/session/modules/SessionXxx.cpp` with `initialize()`, RPC handlers, and optionally a companion `.R` file.
2. **Wire the module**: Register the module's `initialize()` in the session startup sequence.
3. **Client events** (if needed): Add event type constants to `SessionClientEvent.hpp`.
4. **Server operations**: Create a `*ServerOperations.java` interface in the GWT frontend and add it to `Server.java`.
5. **Frontend view**: Add UI under `src/gwt/.../workbench/views/`.
6. **Commands** (if needed): Add to `Commands.cmd.xml`, add stubs to `Commands.java`, and update the MD5 checksum.
7. **DI wiring**: Bind new classes in `RStudioGinModule.java`.


## Key Files Reference

Backend:
- `src/cpp/session/include/session/SessionModuleContext.hpp` -- module registration API
- `src/cpp/session/include/session/SessionClientEvent.hpp` -- client event type constants
- `src/cpp/session/resources/schema/user-prefs-schema.json` -- user preferences schema
- `src/cpp/session/resources/schema/user-state-schema.json` -- UI state schema
- `src/cpp/session/session-options.json` -- session CLI options schema
- `src/cpp/server/server-options.json` -- server CLI options schema

Frontend:
- `src/gwt/src/org/rstudio/studio/client/RStudioGinModule.java` -- DI bindings
- `src/gwt/src/org/rstudio/studio/client/RStudioGinjector.java` -- DI accessor
- `src/gwt/src/org/rstudio/studio/client/server/Server.java` -- aggregated server operations
- `src/gwt/src/org/rstudio/studio/client/workbench/commands/Commands.cmd.xml` -- command definitions
- `src/gwt/src/org/rstudio/studio/client/workbench/commands/Commands.java` -- command stubs


## Common Debugging Patterns

- **Find where an RPC is handled**: grep for the RPC name (e.g. `"chat_start_backend"`) in `src/cpp/session/modules/`.
- **Find a command handler**: grep for `on<CommandName>` with `@Handler` in `src/gwt/`.
- **Find where a preference is used**: search for its key from `user-prefs-schema.json` in both `src/cpp/` and `src/gwt/`.
- **Trace a client event**: find the event constant in `SessionClientEvent.hpp`, then grep for it in both backend (where it's fired) and frontend (where it's handled).


## Building RStudio

These sections describe how to build RStudio from the command line.


### Frontend

To quickly verify that Java changes compile correctly:

    cd src/gwt && ant javac

This only runs the Java compiler — it does NOT produce runnable JavaScript.

To produce runnable code (GWT transpile to JavaScript, draft/debug mode):

    cd src/gwt && ant draft

Use `ant draft` after making changes you need to test in the browser. Use `ant javac` as a fast check when iterating on Java code.

If you modify JavaScript components (e.g. in `src/gwt/acesupport`), also run:

    cd src/gwt && ant acesupport


### Backend

To build the backend components, you can use:

    cd build && cmake --build . --target all

If the build directory does not yet exist, you can create and configure the project with:

    mkdir build
    cd build
    cmake -DCMAKE_EXPORT_COMPILE_COMMANDS=1 ..


### Desktop Integration

To build the Electron application / desktop components, you can use:

    cd src/node/desktop && npm run package


## Writing Automated Tests

End-to-end tests are written in TypeScript with Playwright, under `e2e/rstudio/`. They drive the IDE through a JS automation bridge at `window.rstudio`, documented in `e2e/rstudio/CLAUDE.md`. See `.claude/skills/rstudio-create-playwright-tests/SKILL.md` for detailed guidance on writing Playwright tests, and `.claude/skills/rstudio-run-playwright-tests/SKILL.md` for how to run them.


## Testing


### C++ and R Tests

Both are run through `rstudio-tests`, generated into the build directory
(from `src/cpp/rstudio-tests.in`):

    ./build/src/cpp/rstudio-tests --scope <scope> --filter <pattern>

The `core`, `rserver`, and `rsession` scopes run the C++ Google Test suites.
The `r` scope runs the R `testthat` suite under `src/cpp/tests/testthat/`
(e.g. `test-help.R`). `--filter` is a `testthat::test_dir()` filter: a regular
expression matched against the test file name after its `test-` prefix and
`.R` extension are stripped, so `test-help.R` is reached with
`--scope r --filter help` -- NOT with `--scope rsession`, which only runs C++
tests and ignores the testthat files. Rebuild first so the staged R copies
under `build/src/cpp/session/modules/R/` are current.


### GWT Tests

    cd src/gwt && ant unittest

The standalone HTML test pages in `src/gwt/test/` (autoindent, highlight) are exercised in headless chromium via:

    cd src/gwt && ant testpage

`ant test` runs both `unittest` and `testpage`.


### Desktop (Electron) Verification

    cd src/node/desktop && npm test          # Unit tests
    cd src/node/desktop && npm run lint      # ESLint
    cd src/node/desktop && npm run typecheck # TypeScript type checking (tsc --noEmit)

Run all three before committing changes to `src/node/desktop/`. Note that `npm run lint` only runs ESLint — it does not catch type errors that the webpack build will reject.


## Code Style


### Non-ASCII Characters

In R source files (`.R`) under `src/cpp`, use only ASCII characters -- including in comments. Replace non-ASCII characters with ASCII equivalents (e.g. `-` for `·`, `--` for `—`, straight `'`/`"` for smart quotes). This is enforced: the test in `src/cpp/tests/testthat/test-linter.R` fails if any such file contains non-ASCII characters.


### R

When documenting R code, use Roxygen style for formatting. For example:

    #' Work
    #'
    #' Perform work until the timeout is reached.
    #'
    #' @param callback The R callback to execute.
    #' @param timeout The maximum amount of time to wait, in seconds.
    work <- function(callback, timeout) { ... }


### C++

C++ code is formatted with clang-format. The configuration is in `src/cpp/.clang-format`. Key settings:

- 3-space indentation
- Allman brace style
- No tabs


### TypeScript (Desktop)

TypeScript code uses ESLint and Prettier. From `src/node/desktop`:

    npm run lint      # Check for issues
    npm run format    # Auto-format code


## Schema-Driven Code Generation

Several parts of the codebase are generated from JSON schema files.


### User Preferences and State

User preferences and UI state are declaratively defined in:

    src/cpp/session/resources/schema/user-prefs-schema.json
    src/cpp/session/resources/schema/user-state-schema.json

After modifying either file, regenerate with:

    Rscript scripts/generate-prefs.R


### Server and Session Options

Command-line options for the server and session binaries are defined in:

    src/cpp/server/server-options.json
    src/cpp/session/session-options.json

After modifying either file, regenerate with:

    Rscript scripts/generate-options.R


## Commands

RStudio defines its commands as part of a file at:

    src/gwt/src/org/rstudio/studio/client/workbench/commands/Commands.cmd.xml

When a command is added here, a stub will also need to be added to the file at:

    src/gwt/src/org/rstudio/studio/client/workbench/commands/Commands.java

When Commands.cmd.xml is modified in any way, a checksum stored in src/gwt/src/org/rstudio/studio/client/workbench/commands/Commands.cmd.xml.MD5 MUST be updated to match, and that file included in the commit. The MD5 file is updated when the GWT code is built using `ant` or `ant draft`.


### Command Handlers

Handlers for commands can be implemented almost anywhere in the code base. A command handler has the format:

    @Handler
    void on<Command>() { ... }

where `<Command>` is the name of the command, but with the first letter capitalized.


Any class which implements handlers in this form will also need to create a CommandBinder; e.g.

    interface Binder extends CommandBinder<Commands, ThisClass> {}

And then the constructor should have the form:

    @Inject
    class ThisClass(Commands commands, Binder binder)
    {
        binder.bind(commands, this);
    }

possibly with other injected parameters.


## NEWS.md

When fixing a bug or adding a new feature, add an entry to the appropriate section (`### New`, `### Fixed`, etc.) of `NEWS.md`. Follow the existing format:

    - ([#NNNN](https://github.com/rstudio/rstudio/issues/NNNN)): Brief description of the change

Exceptions — do NOT add a NEWS.md entry for:
- Fixes to unreleased features still under active development
- Fixes to bugs introduced since the last release (i.e., bugs no official-release user has encountered)
- Open-source companion PRs for rstudio-pro changes (typically identified by a link to a pro-repo PR/issue or wording like "open-source companion") -- these are tracked in a separate NEWS file in the pro repository


## Pull Requests

- Pull requests should be associated with a GitHub issue.
- Pull requests that fix an existing issue, and also include tests, should include "Fixes #<issue>." in their body.
- Pull requests that only partially address an issue, or require manual verification, should include "Addresses #<issue>." in their body.
- When generating a pull request, set the Milestone of the pull request to match contents of @version/RELEASE, if there is a matching milestone already defined. Never create a new milestone.


## Git Conventions

For commit messages:

- Use "Addresses #<issue>" instead of "Fixes #<issue>".

For branch naming:

- Use the 'bugfix/' prefix for code changes which fix an existing issue.
- Use the 'feature/' prefix for code changes that add or extend existing functionality.
- Use the 'developer/' prefix for code changes that are primarily for developer ergonomics.
- Use the 'test/' prefix for code changes that are focused on automated tests.


## Issues

- When instructed to investigate or fix a GitHub issue, update the Assignee to the current user (`gh api user --jq .login`), and check that the issue has been added to the RStudio IDE project with an "In Progress" status.
- If the issue describes a bug, add the label `bug`
- If the issue is for a new feature or enhancements to an existing feature, add the label `enhancement`
- These labels apply to issues only, not to pull requests

---
name: rstudio-update-nodejs
description: Use when updating Node.js versions in the RStudio repository, e.g. bumping to a new release. Handles both build-time Node (RSTUDIO_NODE_VERSION, used for building Electron/GWT) and installed Node (RSTUDIO_INSTALLED_NODE_VERSION, shipped with the product). This skill is for macOS and Linux only.
---

# Update Node.js Versions

Updates the pinned Node.js version(s) across the RStudio codebase, uploads binaries to S3, verifies the install, and opens a PR.

RStudio maintains **two distinct Node.js versions**:

- **Build-time Node** (`RSTUDIO_NODE_VERSION`) — used for building Electron, GWT, and other product components. Not shipped to users.
- **Installed Node** (`RSTUDIO_INSTALLED_NODE_VERSION`) — stripped-down `node` binary shipped with the product, used by copilot and Posit AI.

These versions can differ. The skill handles updating either or both in a single invocation.

## Arguments

The user specifies which version(s) to update:

- **Build-time only**: e.g. "update build node to 22.14.0"
- **Installed only**: e.g. "update installed node to 22.23.0"
- **Both**: e.g. "update both node versions to 22.14.0" or "update build node to 22.14.0 and installed to 22.23.0"

Each version is a semver string like `22.14.0` (no `v` prefix).

## Steps

### 1. Verify starting branch

Before doing anything else, confirm the current branch is `main`. This skill creates a new feature branch off the current branch, so starting off anything other than `main` would base the work on the wrong commit.

```bash
git branch --show-current
```

If the output is not `main`, **stop immediately** and warn the user that they must switch to `main` (and pull the latest) before re-running this skill. Do not proceed with any further steps.

### 2. Validate the version(s)

Confirm each provided version matches the format `X.Y.Z` (digits and dots only). If any version doesn't match, ask the user to correct it before proceeding.

### 3. Check prerequisites

Before modifying any files, verify that AWS credentials and required tools are in place. The upload script needs working AWS access, and discovering a credential problem after editing files wastes effort.

Run these checks and stop if any fail:

```bash
command -v aws >/dev/null 2>&1 && echo "aws: ok" || echo "aws: MISSING"
command -v wget >/dev/null 2>&1 && echo "wget: ok" || echo "wget: MISSING"
aws sts get-caller-identity
```

If `aws` or `wget` is missing, tell the user to install it. If `aws sts get-caller-identity` fails, tell the user to configure AWS credentials (e.g. `aws sso login` or `aws configure sso` if SSO isn't set up yet) and try again.

### 4. Create a branch

Use the following naming convention:

- Build-time only: `feature/update-node-build-<VERSION>`
- Installed only: `feature/update-node-installed-<VERSION>`
- Both, same version: `feature/update-node-<VERSION>`
- Both, different versions: `feature/update-node-build-<V1>-installed-<V2>`

```bash
git checkout -b <BRANCH_NAME>
```

### 5. Update version strings

Each file uses a different syntax — match the existing pattern exactly. Only update files for the version(s) being changed.

Before editing, note the current values of `RSTUDIO_NODE_VERSION` and `RSTUDIO_INSTALLED_NODE_VERSION` from `cmake/globals.cmake` so you can find-and-replace accurately.

#### 5a. Build-time Node files (only if updating build)

**`cmake/globals.cmake`** (~line 243) — CMake cache variable:
```cmake
set(RSTUDIO_NODE_VERSION "<VERSION>" CACHE INTERNAL "Node version for building")
```

**`dependencies/tools/rstudio-tools.sh`** (~line 58) — bash export with quotes:
```bash
export RSTUDIO_NODE_VERSION="<VERSION>"
```

**`dependencies/tools/rstudio-tools.cmd`** (~line 54) — Windows batch, no quotes:
```cmd
set RSTUDIO_NODE_VERSION=<VERSION>
```

**`src/gwt/build.xml`** (~line 234) — XML property attribute:
```xml
<property name="node.version" value="<VERSION>"/>
```

**`src/node/desktop/envvars.sh`** (~lines 6, 8) — two hardcoded paths, one with `-arm64` suffix:
```bash
NODE_PATH=$(readlink -fn ../../../dependencies/common/node/<VERSION>-arm64/bin)
```
```bash
NODE_PATH=$(realpath ../../../dependencies/common/node/<VERSION>/bin)
```

**`src/node/CMakeNodeTools.txt`** (~line 22) — CMake fallback default:
```cmake
set(RSTUDIO_NODE_VERSION "<VERSION>")
```

**`src/node/desktop/.vscode/settings.json`** (~line 81) — JSON string with backslash path separators:
```json
"PATH": "${workspaceFolder}\\..\\..\\..\\dependencies\\common\\node\\<VERSION>;${env:PATH}"
```

#### 5b. Installed Node files (only if updating installed)

**`cmake/globals.cmake`** (~line 246) — CMake cache variable:
```cmake
set(RSTUDIO_INSTALLED_NODE_VERSION "<VERSION>" CACHE INTERNAL "Node version installed with product")
```

**`dependencies/tools/rstudio-tools.sh`** (~line 70) — bash export with quotes:
```bash
export RSTUDIO_INSTALLED_NODE_VERSION="<VERSION>"
```

**`dependencies/tools/rstudio-tools.cmd`** (~line 57) — Windows batch, no quotes:
```cmd
set RSTUDIO_INSTALLED_NODE_VERSION=<VERSION>
```

**`dependencies/tools/upload-node.sh`** (~line 13) — bash variable with `v` prefix:
```bash
NODE_VERSION="v<VERSION>"
```
The `v` prefix is required here and only here. All other files use the bare version.

**`NEWS.md`** — in the `### Dependencies` section, update the Node.js line:
```
- Node.js <VERSION> (copilot, Posit AI)
```

Build-time updates do NOT get a NEWS.md entry — only installed node does.

#### 5c. Verify edits

Three files contain both versions (`cmake/globals.cmake`, `rstudio-tools.sh`, `rstudio-tools.cmd`). When updating both versions, take care not to cross-contaminate the two variables in these files.

After editing, review the diff:

```bash
git diff
```

Confirm:
- Only the intended version strings changed
- Syntax matches each file's format (CMake quotes, bash quotes, batch no-quotes, XML attributes, JSON strings)
- The `v` prefix appears ONLY in `upload-node.sh`

### 6. Upload to S3

Upload Node.js binaries for each unique new version using `dependencies/tools/upload-node.sh`. This script downloads platform archives from nodejs.org and uploads them to the `rstudio-buildtools` S3 bucket.

The script reads its version from the hardcoded `NODE_VERSION` variable on line 13 (set in Step 5b for installed updates). The upload covers all platforms: darwin-arm64, darwin-x64, linux-arm64, linux-x64, win-x64, win-arm64.

**If updating installed** (or both to the same version): `upload-node.sh` already has the correct version from Step 5b. Run it:

```bash
bash dependencies/tools/upload-node.sh
```

Confirm exit code 0.

**If updating build only**: `upload-node.sh` wasn't edited in Step 5 (it tracks the installed version by convention). Temporarily edit it to `NODE_VERSION="v<BUILD_VERSION>"`, run it, then revert to the original installed value:

```bash
# Save the original value, set to build version, upload, restore
bash dependencies/tools/upload-node.sh
git checkout dependencies/tools/upload-node.sh
```

**If updating both to different versions**: `upload-node.sh` was set to the installed version in Step 5b. Upload the build version first (temporarily), then the installed version:

1. Edit `upload-node.sh` to `NODE_VERSION="v<BUILD_VERSION>"`
2. Run `bash dependencies/tools/upload-node.sh` — confirm exit code 0
3. Edit `upload-node.sh` back to `NODE_VERSION="v<INSTALLED_VERSION>"` (its committed value)
4. Run `bash dependencies/tools/upload-node.sh` — confirm exit code 0

If any upload fails, report the error and stop.

After uploading, remove the downloaded archives left in the repo root by the upload script (they match `node-v*` and are not gitignored):

```bash
rm -f node-v<VERSION>-*
```

If both versions were uploaded and they differ, remove both:

```bash
rm -f node-v<BUILD_VERSION>-* node-v<INSTALLED_VERSION>-*
```

### 7. Verify the install

Run the dependency installer to confirm the S3 binaries download and extract correctly. The script must be run from `dependencies/common/` because it invokes `./install-node` and `./install-yarn` via relative paths. It installs into `dependencies/common/node/` which is gitignored.

First, remove any cached local installs for the new version(s) so the installer is forced to download fresh from S3. The `install-node` script skips download when it finds an existing `node/<version>/bin/node`, so stale local copies would mask a broken upload.

```bash
cd dependencies/common
# Remove cached installs for the new version(s) to force a fresh download.
# Glob covers both plain and suffixed dirs (e.g. 22.14.0, 22.14.0-arm64, 22.14.0-installed, 22.14.0-arm64-installed).
rm -rf node/<VERSION>*
```

If both versions are being updated to different values, remove both:

```bash
rm -rf node/<BUILD_VERSION>* node/<INSTALLED_VERSION>*
```

Then run the installer:

```bash
bash install-npm-dependencies
```

Confirm exit code 0. If the install fails, report the error and stop. This also installs the new Node.js locally for development use.

### 8. Commit and open a PR

Commit all modified files and open a pull request.

**Commit message and PR title** (varies by mode):

- Build-time only: `Update build-time Node.js to <VERSION>`
- Installed only: `Update installed Node.js to <VERSION>`
- Both, same version: `Update Node.js to <VERSION>`
- Both, different versions: `Update Node.js (build: <V1>, installed: <V2>)`

**PR body** should mention the version bump(s), that the S3 upload and local install were verified, and list old→new for each version that changed.

---
title: "Pane Layout"
date-meta: 2025-12-1
---

The RStudio user interface has 4 primary panes and an optional sidebar pane:

-  **Source pane**\
-  **Console pane**\
-  **Environment pane**, containing the **Environment**, **History**, **Connections**, **Build**, **VCS** , and **Tutorial** tabs\
-  **Output pane**, containing the **Files**, **Plots**, **Packages**, **Help**, **Viewer**, and **Presentation** tabs\
-  **Sidebar pane**, initially empty and hidden but can be configured to show any of the tabs from the **Environment pane** or the **Output pane**, and can be displayed to the left (default) or right of the other panes

Each pane can be minimized or maximized within the column by clicking the minimize/maximize buttons ![](images/min-max.png){width="30" fig-alt="The min-max button which shows a collapsed or expanded Window."}.

![](images/rstudio-panes-labeled.png){fig-alt="A screenshot of the four RStudio panes, labeled Source, Environments, Console, and Output, and the Sidebar toggle button"}
Clicking the Sidebar toggle button displays the Sidebar pane.

![](images/rstudio-panes-sidebar.png){fig-alt="A screenshot of the four RStudio panes and the default empty Sidebar"}

The documentation below provides information based on the default layout/options of each pane. The specific components within each pane and overall arrangement of panes can be modified by opening the **Tools \> Global Options** \> **pane Layout**.

Additional source "columns" can be added to the left of the four primary panes. Arbitrary editor placement (for example, placing source columns to the right of the primary panes) is not supported. To add additional source columns, from the RStudio menu: **Global Options** \> **Pane Layout** \> **Add Source Column**, which provides the ability to work on two (or more) source files at a time within the Source Pane.

![](images/pane-layout.png){fig-alt="Screenshot of the Tools > Global Options > pane Layout page inside RStudio."}

## Source

The source pane allows users to view and edit various code-related files, such as .R, .rmd, .qmd, .py, .css, or general text files such as .txt or .md. By default it is the top-left panel and can be launched by opening any editable file in RStudio. Each additional file that is opened will be added as a new tab within the Source pane.

Additional source "columns" can be added to the left of the four primary panes. Arbitrary editor placement (for example, placing source columns to the right of the primary panes) is not supported. To add additional source columns, from the RStudio menu: **Global Options** \> **pane Layout** \> **Add Source Column**, which provides the ability to work on two (or more) source files at a time within the Source pane.

Individual source files can also be opened in their own window, rather than only within the **Source pane**. Source windows allow you to edit files outside the main RStudio window. This is useful for splitting your work among multiple monitors, or devoting more space to your editor.

### Creating Source Windows

There are two ways to open a new source window:

**Pop out an editor**: click the *Show in New Window button* in any source editor tab.

![](images/source-popout.png){fig-alt="A screenshot of the Source pane toolbar, highlighting the Source Popout button"}

**Tear off a pane**: drag a tab out of the main Source pane and onto the desktop; a new source window will be created where you dropped the tab.

You can have as many source windows open as you like.

### Managing Source Windows

Each source window has its own set of tabs; these tabs are independent of the tabs in RStudio's main source pane.

To return a document to the main window, click the **Return to Main Window** button on the editor toolbar.

![](images/source-return.png){fig-alt="A screenshot of the Source pane toolbar, highlighting the Return to Main Window button"}

### Navigating to Source Windows

The easiest way to jump to a source window is to use the global **Go To File/Function** tool (<kbd>Ctrl + .</kbd>). Begin typing the name of the file you want to navigate to; when it appears, select it and press Enter.

When a document is open in a source window, RStudio will jump to that window whenever you navigate to the document, or to a symbol in the document.

You can also use the shortcut <kbd>Ctrl+1</kbd> to go to the last source window that had focus (which may be the main RStudio source pane).

Based on the type of file, specific menu-bar options will be available. A subset of important file types are discussed below.

### .R

R source files `.R` have a Undo/Redo arrows, a Show in New Window button to tear out that pane into it's own window, a Save button along with a "Source on Save" button that will source the entire script each time it is saved. There is Find/Replace button and then code-tools button. A .R file can be compiled into a report.

The right side of the menu bar has a run button to run the selected line, a Re-Run button to rerun the previous code, a source drop-down button for sourcing the file silently, with echo, or as a Background Job. The last icon opens a document outline which will display section labels in the code. Section labels are written as special comments:

``` r
# section name ----
```

Subsections can be indicated by increasing the number of `#`:

``` r
# Heading 1 ----
## Subheading ----
### Smaller subheading ----

# Section 2 ----
## Subheading 2 ----
```

### `.qmd`

Quarto documents (`.qmd`) have a toggle-able **Source** or **Visual mode** for displaying real time view of the formatted markdown, along with a Save button, a Render on Save, Spellcheck, search, Render button, a gear for selecting whether to have inline output or output to the R console or Plot pane.

On the right side of the menu bar there is a section for adding specific language code chunks, a dropdown for running various methods of the code, and a blue publish button for publishing to Posit Connect, Shinyapps.io, Quarto Pubs or RPubs.

## Console

By default the console pane is the bottom left pane. The console pane provides an area to interactively execute code. By default it is tied to R, but through the use of the `reticulate` package, it can also provide a Python console.

The Console pane also includes an integrated **Terminal** tab for executing system commands, adding or removing additional integrated terminals, as well as general controls of the current selected terminal.

The **Background Jobs** tab provides the ability to send long running R scripts to [local and remote background jobs](../tools/jobs.html). This functionality can dramatically improve the productivity of data scientists and analysts using R since they can continue working in RStudio while jobs are running in the background.

<kbd>Ctrl+1</kbd> --- Move focus to the Source pane <kbd>Ctrl+2</kbd> --- Move focus to the Console <kbd>Ctrl+L</kbd> --- Clear the Console <kbd>Esc</kbd> --- Interrupt R

## Environment pane

By default, the Environment pane is located in the top-right and includes the Environment, History, Connections, Build, and Version Control System (VCS) tabs.

### Environment

The environment tab displays currently saved R and Python objects. For example, the following code would add `avg_mpg` to the environments pane for the duration of the current session.

``` r
avg_mpg <- mean(mtcars$mpg)
```

The R icon can be toggled between R or Python environment objects.

The environment menu bar provides loading or saving of R Workspaces, interactive import of datasets from text files, Excel, or SPSS/SAS/Stata. It also displays the memory currently used by the active R session, and a broom icon to remove all of the current environment objects.

### History

The history tab displays the commands that were executed in the current session along with search. There are buttons for loading/saving the command history to a file, as well as sending the selected command into the console or inserting it into the current working document. There is a delete button for deleting the selected history or the broom button for removing all history of the current session.

### Connections

The connections tab displays connections to local or remote databases or `pins`. Additional possible connections can be added by installing database drivers or specific R packages. You can interactively click on available connections and it will provide generic R code to register an active connection with that data source. Once the connection is created, you can then explore available tables or `pins` in that connection.

There is also a Connect button for creating a connection in the R console, script, or a notebook, as well as copying the relevant code to the clipboard if available.

### Build

The Build tab is available in specific R projects that interact with it such as R packages or Quarto/R Markdown websites/books

Based on the type of R Project, the build pane will provide options for building the R Package or rendering the website.

### VCS (Version Control System)

The VCS tab will change based on the version control system you have enabled for that session. For example, using Git will change the tab name to Git and provide commands for:

-   Viewing diffs

-   Committing selected files

-   Performing Pull or Push commands

-   Viewing the version control history

-   Adding selected files to the .gitignore

-   Creating or selecting a specific branch

### Tutorial

The tutorial tab is used to load interactive `learnr` tutorials. These tutorials provide an interactive environment to step through lessons that package authors or educators have written.

## Output pane

By default, the **Output pane** is the bottom-right pane and displays various outputs such as plots, HTML content, or on-disk files. It contains the Files, Plots, R Packages, Help, Tutorial, Viewer, and Presentation tabs.

### Files

This tab provides interactive exploration of the current R Project along with the entire directory. There are menu bar options for adding new folders, new blank files, deletion/renaming of files, as well as a gear pane for additional functions.

### Plots pane

This tab will display static images generated by code until the session is restarted. There are backwards and forwards arrows for navigating between older and newer plots that have been displayed, a Zoom feature, an export button for saving displayed outputs, a delete button for removing the currently displayed image, and a broom icon which will clear ALL temporary plots from this tab

### Packages

The package tab allows for viewing currently installed R packages, and has a search bar for searching the current library of packages. There is an install and update button for installation of new packages or updating existing selected packages.

### Help

The help tab is used to display package documentation and vignettes. There are arrows for navigating backwards and forwards as additional help pages are viewed. The home icon will return to the general help page, with links to Resources, Manuals, References, and Posit Support.

To get help on a specific R function use the `?functionName` or `help(functionName)` syntax, for example the following code when executed would open the help page for the `paste0()` function:

``` r
?paste0()
# or
help(paste0)
```

Additionally, sections of code can be highlighted and executed in the R console with the <kbd>Ctrl+Enter</kbd> shortcut (<kbd>Cmd+Enter</kbd> on Mac).

![](images/help-pane-console.png){fig-alt="The help pane and R console, where an example code snippet from the examples for paste function has been executed in the R console."}

### Viewer

The viewer tab is used to display web content such as Shiny apps, Quarto generated web pages, or interactive `htmlwidgets` like `plotly` graphs.

### Presentation

The Presentation tab is used to display HTML slides generated via Quarto's `revealjs` format.

## Sidebar pane

By default, the Sidebar pane is hidden, and can be displayed using the Sidebar toggle button or View / Show Sidebar. The Sidebar can be configured to display on the right, if desired, and to show any of the tabs from the Environment or Output panes.

| Platform | Download |
|----------|----------|
| Windows | [`RStudio-{{< var osVersion >}}.exe`](https://download1.rstudio.org/electron/windows/RStudio-{{< var osVersion >}}.exe) |
| Windows (zip archive) | [`RStudio-{{< var osVersion >}}.zip`](https://download1.rstudio.org/electron/windows/RStudio-{{< var osVersion >}}.zip) |
| macOS 13+ | [`RStudio-{{< var osVersion >}}.dmg`](https://download1.rstudio.org/electron/macos/RStudio-{{< var osVersion >}}.dmg) |
| Ubuntu 22 / 24, Debian 12 / 13 | [`rstudio-{{< var osVersion >}}-amd64.deb`](https://download1.rstudio.org/electron/jammy/amd64/rstudio-{{< var osVersion >}}-amd64.deb) |
| Ubuntu / Debian (tar.gz) | [`rstudio-{{< var osVersion >}}-amd64-debian.tar.gz`](https://download1.rstudio.org/electron/jammy/amd64/rstudio-{{< var osVersion >}}-amd64-debian.tar.gz) |
| RHEL 9 / 10, Fedora | [`rstudio-{{< var osVersion >}}-x86_64.rpm`](https://download1.rstudio.org/electron/rhel9/x86_64/rstudio-{{< var osVersion >}}-x86_64.rpm) |
| RHEL / Fedora (tar.gz) | [`rstudio-{{< var osVersion >}}-x86_64-fedora.tar.gz`](https://download1.rstudio.org/electron/rhel9/x86_64/rstudio-{{< var osVersion >}}-x86_64-fedora.tar.gz) |

---
name: Feature request
about: Request a new feature.
title: ''
labels: ['enhancement']
assignees: ''

---

<!--

Thanks for taking the time to file a feature request! Please take the time to search for an existing feature request, to avoid creating duplicate requests. If you find an existing feature request, please give it a thumbs-up reaction, as we'll use these reactions to help prioritize the implementation of these features in the future.

If the feature has not yet been filed, then please describe the feature you'd like to see become a part of RStudio. See:

https://github.com/rstudio/rstudio/wiki/Writing-Good-Feature-Requests

for a guide on how to write good feature requests.

-->

### Problem Statement

> Describe the problem for which you are creating this issue.

### Proposed Behaviour

> Describe the proposed behaviour which would solve the problem above.

### QA Notes

> Once you have opened a PR, add additional information for QA on how to validate the change, paying special attention to the level of risk, adjacent areas that could be affected by the change, and any important contextual information not present in the original description.

---
name: rstudio-update-copilot
description: Use when updating the copilot-language-server version in the RStudio repository, e.g. bumping to a new release. This skill is for macOS and Linux only.
---

# Update Copilot Language Server

Updates the pinned copilot-language-server version across the RStudio codebase, uploads the new version to S3, verifies the install, and opens a PR.

## Arguments

The user provides the **target copilot-language-server version** (e.g. `1.459.0`).

## Steps

### 1. Verify starting branch

Before doing anything else, confirm the current branch is `main`. This skill creates a new feature branch off the current branch, so starting off anything other than `main` would base the work on the wrong commit.

```bash
git branch --show-current
```

If the output is not `main`, **stop immediately** and warn the user that they must switch to `main` (and pull the latest) before re-running this skill. Do not proceed with any further steps.

### 2. Validate the version

Confirm the version argument matches the format `X.Y.Z` (digits and dots only). If it doesn't, ask the user to correct it before proceeding.

### 3. Check prerequisites

Before modifying any files, verify that AWS credentials are in place. The upload script needs working AWS access, and discovering a credential problem after editing files wastes effort.

Run these checks and stop if any fail:

```bash
command -v aws >/dev/null 2>&1 && echo "aws: ok" || echo "aws: MISSING"
command -v wget >/dev/null 2>&1 && echo "wget: ok" || echo "wget: MISSING"
aws sts get-caller-identity
```

If `aws` or `wget` is missing, tell the user to install it. If `aws sts get-caller-identity` fails, tell the user to configure AWS credentials (e.g. `aws sso login` or `aws configure sso` if SSO isn't set up yet) and try again.

### 4. Create a branch

```bash
git checkout -b feature/update-copilot-language-server-<VERSION>
```

### 5. Update version strings

Update `COPILOT_VERSION` in the following four files. Each file uses a slightly different syntax — match the existing pattern exactly.

#### `NEWS.md`

In the `### Dependencies` section, update the Copilot Language Server line:

```
- Copilot Language Server <VERSION>
```

#### `dependencies/common/install-copilot-language-server`

```bash
COPILOT_VERSION="<VERSION>"
```

#### `dependencies/tools/upload-copilot-language-server.sh`

This file uses the version as both a default value and a command-line argument fallback:

```bash
COPILOT_VERSION="${1:-<VERSION>}"
```

#### `dependencies/windows/install-dependencies.cmd`

Windows batch syntax — no quotes:

```cmd
set COPILOT_VERSION=<VERSION>
```

After editing, verify all four files contain the new version string.

### 6. Upload to S3

Run the upload script, passing the new version as an argument. This downloads the release from GitHub and uploads it to the rstudio-buildtools S3 bucket.

```bash
bash dependencies/tools/upload-copilot-language-server.sh <VERSION>
```

Confirm exit code 0 and the "Successfully uploaded" message. If it fails, report the error and stop.

### 7. Verify the install

The default tools root (`/opt/rstudio-tools/...`) requires elevated privileges, so use a temporary directory to verify the S3 download without needing `sudo`.

```bash
VERIFY_DIR="$(mktemp -d)"
trap 'rm -rf "$VERIFY_DIR"' EXIT
RSTUDIO_TOOLS_ROOT="$VERIFY_DIR" bash dependencies/common/install-copilot-language-server
```

Confirm exit code 0. The `trap` ensures the temp directory is cleaned up whether the install succeeds or fails. If the install fails, report the error and stop.

After verification, tell the user they will need to re-run `dependencies/common/install-copilot-language-server` themselves (with appropriate privileges) to install the new copilot-language-server into their dev environment.

### 8. Commit and open a PR

Commit the four modified files and open a pull request:

- **Branch**: `feature/update-copilot-language-server-<VERSION>`
- **Commit message**: `Update copilot-language-server to <VERSION>`
- **PR title**: `Update copilot-language-server to <VERSION>`
- **PR body**: mention the version bump and that the S3 upload and local install were verified

---
title: "Executing code"
date-meta: 2022-12-12
---

RStudio supports the direct execution of code from within the source editor (the executed commands are inserted into the console where the output also appears).

## Source files

Source code files such as .R or .py can be executed in several different ways.

### Executing a single line

To execute the line of source code where the cursor currently resides press the <kbd>Ctrl+Enter</kbd> keys (or use the **Run** toolbar button):

![](images/run-current-line.png){fig-alt="A screenshot of the RStudio source pane and the 'Run' button."}

After executing the line of code, RStudio automatically advances the cursor to the next line. This enables single-stepping through a sequence of lines.

### Executing multiple lines

There are three ways to execute multiple lines from within the editor:

1.   Select the lines and press the <kbd>Ctrl+Enter</kbd> keys (or use the **Run** toolbar button); or

2.  After executing a selection of code, use the **Re-Run Previous Region** command (or its associated toolbar button) to run the same selection again. Note that changes to the selection including additional, removal, and modification of lines will be reflected in this subsequent run of the selection.

3.   To run the entire document press the <kbd>Ctrl+Shift+Enter</kbd> keys (or use the **Source** toolbar button).

The difference between running lines from a selection and invoking **Source** is that when running a selection all lines are inserted directly into the console whereas for **Source** the file is saved to a temporary location and then sourced into the console from there (thereby creating less clutter in the console).

![](images/re-run-source.png){fig-alt="Highlighting the Run, Run previous, and Source menu options in the Source pane."}

### Source on save

When editing re-usable functions (as opposed to freestanding lines of R) you may wish to set the **Source on Save** option for the document (available on the toolbar next to the Save icon). Enabling this option will cause the file to automatically be sourced into the global environment every time it is saved.

Setting **Source on Save** ensures that the copy of a function within the global environment is always in sync with its source, and also provides a good way to arrange for frequent syntax checking as you develop a function.

## Computational documents

Code within computational documents such as Quarto or R Markdown is written inside "code chunks" as written below:

    ```{{r}}
    library(ggplot2)
    ggplot(mpg, aes(x = displ, y = hwy)) +
      geom_point()
    ```

Similar to source code files, code can be executed via RStudio "Run" commands or keyboard shortcuts <kbd>Ctrl + Enter</kbd>. However, each chunk also has a green "Run" button to execute that specific chunk.

![](images/document-chunk.png){fig-alt="A screenshot of a R code chunk in Quarto. It primarily consists of 3x backticks, curly brackets, and a language engine with code inside the backticks"}

### Executing a single line

To execute the line of source code where the cursor currently resides press the **Ctrl+Enter** keys (or use the **Run** toolbar button):

![](images/quarto-execute-line.png){fig-alt="A screenshot of a '.qmd' document, highlighting the Run menu and the ability to run selected highlighted lines."}

After executing the line of code, RStudio automatically advances the cursor to the next line. This enables you to single-step through a sequence of lines.

### Executing multiple lines

There are four ways to execute multiple lines from within the editor:

1.  Select the lines and press the **Ctrl+Enter** key (or use the **Run** toolbar button); or

2.  To run the entire document press the **Ctrl+Alt+R** keys (or use the **Run All** toolbar button).

3.  To run the entire document and convert it to the final output, use the **Knit** or **Render** button.

4.  To run an entire cell, press the "Run Current Chunk" button on the code chunk, or in the **Run** toolbar via "Run Current Chunk", or with the **Ctrl+Shift+Enter** shortcut

![](images/quarto-execute-line-labeled.png){fig-alt="A screenshot of a '.qmd' file, the Run select lines button, the Run All lines button, the Render button, and the Run current chunk button."}

The difference between running the entire document and invoking **Knit**/**Render** is that when running a selection all lines are inserted directly into the console whereas for **Knit**/**Render** the code is executed in a fresh separate R session and the file is rendered to its output format.

### Render on Save

When editing Quarto documents (as opposed to editing freestanding lines of code in .R files) you may wish to set the **Render on Save** option for the document (available on the toolbar next to the Save icon). Enabling this option will cause the file to automatically be rendered and the display updated in the **Viewer pane** every time you save.

Setting **Render on Save** ensures that the displayed output is in sync with its source, and also provides a good way to arrange for frequent visual checking as you author a computational document.

---
title: "Screen Reader"
date-meta: 2022-12-12
---

This article aims to provide screen-reader users with some effective strategies for RStudio navigation.

Some features discussed are specific to RStudio Desktop or RStudio Server: if RStudio is loaded in your web browser, then you are using RStudio Server; otherwise, you have RStudio Desktop.

For the purposes of this discussion, "RStudio Server" encompasses both RStudio Server Open Source and Posit Workbench (previously RStudio Workbench or RStudio Server Pro).

## Accessibility menu

Several accessibility-related options are available under the Help / Accessibility menu:

| Command                    | Description                                                                                                      |
|----------------------------|------------------------------------------------------------------------------------------------------------------|
| Screen Reader Support      | Toggles screen reader support mode on and off; requires RStudio to restart                                       |
| Speak Text Editor Location | Announce details on current text editor cursor location (RStudio Server with screen reader only)                 |
| Focus Console Output       | Move keyboard focus to the Console output region, primarily for screen reader users                              |
| Focus Main Toolbar         | Move keyboard focus to the main toolbar                                                                          |
| Tab Key Always Moves Focus | Toggles a mode where the Tab key will always move focus to the next element, even when in a text editing control |
| Accessibility Options      | Display the Global Options dialog and automatically open the Accessibility pane                                  |
| Accessibility Help         | Opens this web page                                                                                              |

## RStudio Desktop

-   Notes: Screen-reader support for RStudio Desktop requires the Electron-based open-source version 2022.12 (Elsbeth Geranium) or newer. RStudio Desktop Pro does not support screen-reader operation at this time.

## Posit Workbench / RStudio Server

### Basic concepts

Posit Workbench (previously RStudio Server Pro/RStudio Workbench) and RStudio Server Open Source are web-based applications loaded in your preferred browser. Simply put, you can understand it as an online version of RStudio Desktop.

Since the main menubar (File, Edit, and so on) is actually part of the web page, it requires slightly different shortcuts. Tapping Alt (on Windows), for example, puts focus on the Web Browser\'s main menu, not the RStudio menu.

In most cases, screen reader users will have to keep turning off their virtual cursors (also known as browse mode and quick navigation mode) in order to better interact with the RStudio web application. We will revisit this concept in more detail later on after we configure some required screen reader settings.

-   Notes: while any combinations of screen readers and browsers are supported technically, we have tested the following pairs for RStudio Workbench / RStudio Server.

|                        |                     | Table 1: Tested combinations of screen readers and browsers. |
|------------------------|---------------------|--------------------------------------------------------------|
| Operating System       | Screen Reader       | Browser                                                      |
| Microsoft Windows 10   | JAWS version 2020   | Google Chrome                                                |
| Microsoft Windows 10   | NVDA version 2020.1 | Google Chrome                                                |
| macOS 10.15 (Catalina) | VoiceOver           | Safari                                                       |

### Screen reader settings

When using Posit Workbench, RStudio Server. or RStudio Desktop 2022.12 open-source (or later) with a screen reader, it is essential to enable screen reader support. Once set, this setting is persisted for future RStudio sessions. The option is available to toggle via the main menu at Help / Accessibility / Screen Reader Support, or via the Global Options dialog, under the Accessibility panel.

The easiest way to enable the \"Screen Reader Support\" mode, however, is using its own keyboard shortcut by pressing \"Alt+Shift+/ (forward slash)\" on Windows or Linux; \"Ctrl+Shift+U\" on Mac.

Once the \"Screen Reader Support\" mode is toggled on, you will hear the following dialog message:

> Are you sure you want to enable screen reader support? The application will reload to apply the change.

You can press tab to find \"Yes\" button and press spacebar.

You will then be asked the following question again:

> Reload site? Changes you made may not be saved.

After tabbing to find \"Reload\" button and pressing spacebar, your RStudio will be reloaded with the screen reader support enabled.

Besides the basic screen reader support, you can adjust various accessibility settings at Help / Accessibility / Accessibility Options...

To open this configuration, do the following:

1.  Make sure your screen reader\'s browse mode (also known as virtual cursor or QuickNav mode) is off. If you are using NVDA, you can switch between browse and focus modes by pressing NVDA+Spacebar. JAWS users can do this by pressing JAWS+Z; VoiceOver users can toggle it by pressing left and right arrow keys at the same time.

2.  Press Alt+Shift+H on Windows and Linux to put focus on the \"Help\" menu in the main menubar; press Ctrl+Opt+H on Mac.

-   Notes for Mac Users: the default VoiceOver modifier (VO) key conflict with any RStudio\'s shortcuts using Ctrl+Opt key combinations like above. Please use the VoiceOver pass-through keys (Ctrl+Opt+Tab) each time before pressing any RStudio\'s shortcuts requiring Ctrl+Opt key combination. Or, you can change the VO modifier key into \"Caps Lock\" via VoiceOver Utility (VO+F8) / General / \"Keys to use as the VoiceOver modifier\" setting.

3.  Hit down arrow key several times to find \"Accessibility\" menu and expand it via right arrow key.

4.  Once the menu expanded, press down-arrow key for few times to find \"Accessibility Options...\" and enter on it.

In the accessibility options, you can navigate each setting using tab and arrow keys. You need to keep the screen reader browse mode (also known as virtual cursor) off to better interact with this dialog box.

The following includes some settings we recommend screen-reader users make sure to keep turning on.

-    Screen reader support (requires restart)

-    Entire page has application role (requires restart)

-    Reduce user interface animations

The first item, \"Screen Reader support,\" is the switch we have just enabled and you will never want to turn it off.

The second one, \"Entire Page Has Application Role,\" allows screen readers to automatically recognize your RStudio as an application interface so that you don\'t have to manually turn off the browse mode/virtual cursor each time using the program.

Our last recommendation, \"Reduce User Interface Animations,\" will simplify some visual aspects so that you can better understand the RStudio environment using screen readers.

### Application layout

As described in the [basic concept](#basic-concepts) above, Posit Workbench and RStudio Server are web-based applications loaded inside your browser.

To provide screen-reader users with overview of the application layout, RStudio is annotated to divide it up into named landmarks (also known as regions in some screen readers). The regions in the default visual layout of RStudio are as follows:

1.  Banner (the RStudio logo in the upper-left)

2.  Navigation (the main menu and toolbar)

3.  Main Workbench (the area below the main menu and toolbar, containing 4 quadrants)

```{=html}
<!-- -->
```
1.  TabSet1 (upper-right quadrant, containing various feature tabs including Environment and History)

2.  TabSet2 (lower-right quadrant, containing various feature tabs including Files and Help)

3.  Source (upper-left quadrant, contains files open in text editor)

4.  Console (lower-left, contains Console and other optional tabs such as Terminal and Jobs)

```{=html}
<!-- -->
```
4.  Content Info Warning Bar (closable messagebar occasionally shown below the workbench)

-   Notes: To move around the user interface landmarks, you have to turn on screen readers\' browse mode (also known as virtual cursor or QuickNav mode).

### Menubar navigation

Posit Workbench or RStudio Server adds customizable keyboard shortcuts to get focus to the main menu, at which point the arrow keys can be used to navigate around the menus in essentially the same manner as standard application menus.

On Windows and Linux, each menu is access via \"Alt+Shift\" key combination; on Mac, it is \"Ctrl+Opt\" modifiers.

A full list of shortcuts for accessing each menu is as follows:

|              |                  | Table 2: Menubar shortcut keys. |
|--------------|------------------|---------------------------------|
| Description  | Windows & Linux  | Mac                             |
| File Menu    | Alt+Shift+F      | Ctrl+Opt+F                      |
| Edit Menu    | Alt+Shift+E      | Ctrl+Opt+I                      |
| Code Menu    | Alt+Shift+C      | Ctrl+Opt+C                      |
| View Menu    | Alt+Shift+V      | Ctrl+Opt+V                      |
| Plots Menu   | Alt+Shift+P      | Ctrl+Opt+P                      |
| Session Menu | Ctrl+Alt+Shift+S | Ctrl+Opt+Shift+S                |
| Build Menu   | Alt+Shift+B      | Ctrl+Opt+B                      |
| Debug Menu   | Alt+Shift+U      | Ctrl+Opt+U                      |
| Profile Menu | Alt+Shift+I      | Ctrl+Opt+O                      |
| Tools Menu   | Alt+Shift+S      | Ctrl+Opt+L                      |
| Help Menu    | Alt+Shift+H      | Ctrl+Opt+H                      |

-   Notes: Before accessing menubar, make sure your screen reader\'s browse mode (also known as virtual cursor or QuickNav mode) is off. If you are using NVDA, you can switch between browse and focus modes by pressing NVDA+Spacebar. JAWS users can do this by pressing JAWS+Z; VoiceOver users can toggle it by pressing left and right arrow keys at the same time.

-   Notes for Mac Users: the default VoiceOver modifier (VO) key conflict with any RStudio\'s shortcuts using Ctrl+Opt key combinations like above. Please use the VoiceOver pass-through keys (Ctrl+Opt+Tab) each time before pressing any RStudio\'s shortcuts requiring Ctrl+Opt key combination. Or, you can change the VO modifier key into \"Caps Lock\" via VoiceOver Utility (VO+F8) / General / \"Keys to use as the VoiceOver modifier\" setting.

### Keyboard shortcuts help

RStudio has a list of keyboard shortcuts that you can refer to anytime. To bring up the keyboard help, press \"Alt+Shift+K\" on Windows or Linux; \"Opt+Shift+K\" on Mac.

Each section has been marked up with proper headings (H2 tag) so that you can jump between different categories using screen readers\' quick navigation keys.

Under the headings, shortcuts are organized in a simple table form in which you can utilize screen readers\' table navigation keys.

Simply close the opened tab after you finish reading the content to go back to the RStudio main page.

### Console navigation

On the RStudio main page, you can move from anywhere to console by pressing \"Ctrl+2\" directly.

As this is an input area, you need to make sure your screen reader\'s browse mode (also known as virtual cursor or QuickNav mode) is off. If you are using NVDA, you can switch between browse and focus modes by pressing NVDA+Spacebar. JAWS users can do this by pressing JAWS+Z; VoiceOver users can toggle it by pressing left and right arrow keys at the same time.

You can use up/down-arrow key to cycle through your recent command history, and you can even edit any of the commands via standard methods (e.g., left/right arrow key to move around characters; backspace/delete keys to erase any of them).

Everything you type in the console will be executed via current R session as soon as you press enter key, and screen readers will announce the corresponding output in real time.

If you would like to review the executed output in more detail via arrow keys, you first need to put your cursor to the \"Console Output\" area by pressing \"Alt+Shift+2\" on Windows or Linux; \"Ctrl+Opt+2\" on Mac. Since the console output area requires browse mode (also known as virtual cursor or QuickNav mode), turn it on in case your arrow keys do not respond as you expected.

An useful shortcut key to clear the entire console output is \"Ctrl+L\". You may want to press this key before executing a new command to secure a cleaner output buffer for screen readers.

More useful keyboard shortcuts for source editor can be found under the \"Console\" and \"Editing (Console and Source)\" sections at Keyboard Shortcuts Help (\"Alt+Shift+K\" on Windows or Linux; \"Opt+Shift+K\" on Mac).

-   Notes: You can minimize the efforts to switch between the screen readers\' browse modes by enabling \"Entire page has application role\" via Help / Accessibility / Accessibility Options...

-   Notes for Mac Users: the default VoiceOver modifier (VO) key conflict with any RStudio\'s shortcuts using Ctrl+Opt key combinations like above. Please use the VoiceOver pass-through keys (Ctrl+Opt+Tab) each time before pressing any RStudio\'s shortcuts requiring Ctrl+Opt key combination. Or, you can change the VO modifier key into \"Caps Lock\" via VoiceOver Utility (VO+F8) / General / \"Keys to use as the VoiceOver modifier\" setting.

-   Notes for Cursor Movement: In any event your screen readers do not read anything when using up/down-arrow keys in either console input area or source editor, please place your cursor at the end of current line by pressing \"End\" key, and then try again.

### Source editor navigation

On the RStudio main page, you can move from anywhere to source editor by pressing \"Ctrl+1\" directly.

This is also an input area where you need to make sure your screen reader\'s browse mode (also known as virtual cursor or QuickNav mode) is off. If you are using NVDA, you can switch between browse and focus modes by pressing NVDA+Spacebar. JAWS users can do this by pressing JAWS+Z; VoiceOver users can toggle it by pressing left and right arrow keys at the same time.

Technically, you can utilize all the standard navigation keys (e.g., Home, End, Arrows, PgUp/Down) with \"Ctrl\" and/or \"Shift\" key combinations to edit your source code text.

An useful shortcut key to control the tab key behavior is \"Alt+Shift+\[ (left bracket)\" on Windows or Linux; \"Ctrl+Opt+\[ (left bracket)\" on Mac. This toggles a mode of whether or not the Tab key will always move focus to the next element , even when in a text editing control.

More useful keyboard shortcuts for source editor can be found under the \"Source\" and \"Editing (Console and Source)\" sections at Keyboard Shortcuts Help (\"Alt+Shift+K\" on Windows or Linux; \"Opt+Shift+K\" on Mac).

-   Notes for Cursor Movement: In any event your screen readers do not read anything when using up/down-arrow keys in either console input area or source editor, please place your cursor at the end of current line by pressing \"End\" key, and then try again.

-   Notes: You can minimize the efforts to switch between the screen readers\' browse modes by enabling \"Entire page has application role\" via Help / Accessibility / Accessibility Options...

## Contact

This document will be kept updated reflecting the latest RStudio\'s accessibility improvements.

We always very much welcome your feedback or questions on our product accessibility. Please email accessibility-related questions and comments anytime to [accessibility\@posit.co](mailto:accessibility@posit.co).

---
title: "Posit Assistant Terms and Conditions"
date-meta: 2026-07-02
aliases:
  - posit-ai-terms.html
---

# Posit Assistant specific EULA

Posit Software, PBC

This End User License Agreement including all Order Forms, the Software License Descriptions and all documents linked to herein and therein (collectively, this "Agreement") is a legal agreement between you ("you") and Posit Software, PBC, a Delaware corporation with its principal place of business at 250 Northern Avenue, Suite 410, Boston, Massachusetts 02210 ("Posit") (formerly known as RStudio, PBC), that governs your use of Posit’s proprietary Software, directly from Posit or indirectly through a Posit authorized reseller or distributor (a "Reseller"). It is effective between you and Posit as of the Subscription Start Date. Your execution of an Order Form constitutes a binding noncancelable commitment to license the Software set forth in the Order Form under the terms and conditions of this Agreement. All Order Forms, the Software License Descriptions and all documents linked to herein and therein are incorporated into this End User License Agreement by reference.

IMPORTANT -- PLEASE READ CAREFULLY BEFORE YOU DOWNLOAD OR USE THE SOFTWARE

By clicking on the “accept” button at the end of this document or by accessing, executing or otherwise using the Software, you acknowledge that you have read this Agreement, understand it and agree to be bound by its terms and conditions. If you are not willing to be bound by the terms of this Agreement, do not access or use the Software.

If you are using the Software in your capacity as employee or agent of a company or organization, then any references to “you” in this agreement shall refer to such entity and not to you in your personal capacity. You warrant that you are authorized to legally bind the company or organization on whose behalf you are accessing the Software. If you are not so authorized, then neither you nor your company or organization may use the Software in any manner whatsoever.

1\.  Definitions.

1.1 "Affiliate" means any entity which directly or indirectly controls, is controlled by, or is under common control with the subject entity. "Control," for purposes hereof, means (a) the legal power to direct or cause the direction of the general management and policies of an entity whether directly or indirectly and whether through the ownership of voting securities, by contract, or otherwise, or (b) the beneficial ownership, whether direct or indirect, of fifty percent (50%) or more of the voting securities or other ownership interest or other comparable equity interests of an entity.

1.2 "Customer Application" means a software application independently developed by you or your Users and/or deployed by you or your Users using the Software.

1.3 "Documentation" means the published and generally available instructions for Software installation, use, and administration set forth at docs.posit.co, as updated from time to time to reflect Updates, and the Software License Descriptions.

1.4 "Order Form" means Posit’s order form which is separately executed by you and Posit and which lists the Software ordered by you, the annual subscription fees payable for such Software, the Subscription Term, the Software License Descriptions, and any additional terms and conditions agreed to by the parties. All Order Forms, executed by the parties and their respective Affiliates, are incorporated herein by reference.

1.5 "Open Source Language(s)" means open source programming languages and software environments for statistical computing and graphics made available in source code form for free by third parties, such as "R" or Python.

1.6 "Posit Support Program" means Posit’s Support Program for the Software at https://posit.co/about/support-agreement/, as the same may be updated from time to time by Posit in its discretion; provided, that any updates will not take effect with respect to your subscription to the Software until renewal of the Subscription Term for such Software.

1.7 "Software License Descriptions" means the license entitlements applicable to the Software set forth at https://posit.co/about/software-license-descriptions/, as updated from time to time, provided, that for Software that is subject to a then-current Subscription Term, such updates will not take effect until the renewal of the Subscription Term for such Software.

1.8 "Software" means the object code version of the proprietary Posit software program(s) set forth on an Order Form (or downloaded by you as part of a free trial pursuant to Section 2 below) and all Updates provided to you by Posit. "Software" expressly excludes Posit's Posit Cloud and shinyapps.io online services for which the terms of service are as set forth at https://posit.co/about/posit-service-terms-of-use/ as the same are updated from time to time.

1.9 "Subscription Term" means the period of time set forth on the Order Form during which you are licensed to use the Software in accordance with this Agreement and the Order Form and which period of time commences on the Subscription Start Date.

1.10 "Subscription Start Date" means the date a license key to activate the Software is provided to you.

1.11 "Support Services" mean the technical support services for the Software made generally commercially available by Posit to its customers pursuant to and as described in the Posit Support Program.

1.12 "Update" means any subsequent release of the Software that Posit makes generally commercially available to its customers pursuant to the Support Program. Updates do not include any Software that is marketed and priced separately by Posit.

1.13 "User" means an individual who is authorized by you or your Affiliates to use the Software, has been given access credentials by you to access and use the Software, and who is bound by enforceable terms at least as protective of the Software and the Posit Confidential Information as this Agreement.

1.14 "Third-Party Commercial Platform" means any platform, environment, product, or service operated, hosted, distributed, or otherwise made available by a person or entity (other than you for your own internal business purposes) under which third parties are granted access to software, computing environments, or development tools, whether on a hosted, software-as-a-service, platform-as-a-service, managed, self-managed, or on-premise basis, in each case in exchange for payment, subscription, or other consideration paid to such person or entity. For clarity, a platform or environment that you operate solely for your own internal business purposes and solely for access by your Users is not a Third-Party Commercial Platform.

2\.  Free Trial. If you either register on the Posit web site for a free trial of the Software or otherwise order a free trial version of the Software, Posit will make the Software available to you free of charge (the "Trial Version") until the end of the free trial period for which you registered or ordered the applicable Software. You may only use the Trial Version to review, demonstrate, and evaluate the Software, and the Trial Version may have limited functionality. The Trial Version will cease operating after the applicable time period based on an internal metering mechanism within the Trial Version itself. Regardless of any such metering, you must stop use at the end of the free trial period. Additional trial terms and conditions may appear on the trial registration web page or Order Form. Any such additional terms and conditions are incorporated into this Agreement by reference and are legally binding. You shall not (A) install or use more than one copy of the Trial Version or use the Trial Version on more than one computer except, if necessary, for the sole purpose of evaluating load balancing features, (B) download the Trial Version under more than one username, (C) alter the contents of a hard drive or computer system to enable the use of the Trial Version for an aggregate period in excess of the trial period for one license to such Trial Version, (D) disclose the results of software performance benchmarks obtained using the Trial Version to any third party without Posit’s prior written consent, (E) use the Trial Version to update Software that is no longer eligible for Support Services, or (F) use the Trial Version for any purpose other than the sole purpose of determining whether to purchase a license to the Software. NOTWITHSTANDING SECTION 9 (LIMITED WARRANTY AND DISCLAIMER), DURING A FREE TRIAL, THE TRIAL VERSION AND ANY APPLICABLE SERVICES ARE PROVIDED "AS-IS" WITHOUT WARRANTY.

3\.  License Grant.

3.1 License Grant Subject to all terms and conditions set forth in this Agreement, the Software License Descriptions, and the applicable Order Form, Posit grants you a limited, worldwide, nonexclusive, royalty-free license (without right of sublicense) during the Subscription Term to install and use the Software, and to permit your Users to use the Software, for your own business purposes, in accordance with the Documentation and subject to the license limitations and entitlements set forth in the applicable Order Form and the Software License Descriptions. Notwithstanding anything to the contrary herein, you may make a reasonable number of copies of the Software for the sole purpose of backing-up and archiving the Software; provided, that any such copies may not be used in a live production environment unless you have ordered a subscription for a High Availability Server or an Execution Server (as such terms are defined in the Software License Descriptions) pursuant to an Order Form. Further, unless you have purchased a subscription to Staging Software (as such term is defined in the Software License Descriptions), you may not use copies of the Software for purposes of testing changes to your computing environment or testing Customer Applications, scripts, or documents before deploying them to your Users. All copies of the Software are subject to this Agreement and must contain the same titles, trademarks, and copyrights as the original. You are responsible for the compliance of your Users with the terms and conditions of this Agreement, including their compliance with the Documentation and for any breach of this Agreement by your Users. At Posit’s written request, and not more than once every twelve (12) months (or more frequently if a previous violation has taken place but only to confirm the violation has been corrected and not to exceed more than once per calendar quarter), you will certify to Posit that you and your Users are in compliance with this Agreement and the Documentation.

3.2 Delivery. Delivery of the Software shall be made by electronic means and such delivery shall be deemed to have been made as of the Subscription Start Date. Notwithstanding the foregoing, where the Order Form provides for physical delivery or where electronic delivery is not possible given the nature of the requirements, delivery shall be deemed to have been made upon the transfer of the Software to the shipping agent. Posit’s Software (other than Trial Versions) may transmit license-related data at the time of license activation to a license server in order to activate your license and provide you with notifications, including notifications of Updates, and to protect you and Posit against unlicensed or illegal use of the Software. Notwithstanding the foregoing, if you desire that license-related data not be transmitted to Posit, you may elect to use the off-line activation mechanism as provided in the Software, in which case license-related data will not be transmitted. You acknowledge that the Software may include licensing technology, measures to prevent activating the Software on more than one physical or virtual computer, and other security measures designed to limit usage of the Software to that which is licensed. Such measures will not interfere with your normal and permitted operation of the Software as licensed hereunder.

3.3 Virtualization Technology; Third Party Hosting Provider. The Software may be installed within a virtual (or otherwise emulated) hardware system so long as the use of the Software meets the terms of the Software License Descriptions and these virtual machines are run on hardware you own, lease or otherwise control (including for such purpose the hardware of a third party hosting provider that hosts the Software for your benefit, such as Amazon Web Services). Virtualization technology may not be used to circumvent licensing terms or restrictions. Notwithstanding anything to the contrary herein, Posit grants you the right to sublicense the right to install and use the Software to a third party hosting provider for the sole purpose of enabling the third party hosting provider to host the Software on your behalf and for your exclusive benefit. You agree that you will be liable to Posit for any breach of this Agreement or unauthorized use of the Software by such third party hosting provider.

3.4 Restrictions; Export Laws.

3.4.1 Restrictions. You shall not and shall not permit any third party to: (a) use the Software other than in accordance with the Documentation, (b) use the Software in violation of the license restrictions applicable to the Software, (c) copy the Software (except for a reasonable number of backup and archival copies to the extent and as permitted in Section 3.1 above), (d) modify, adapt, transfer, distribute, make publicly available, resell, rent, lease, sublicense or loan the Software or create or prepare derivative works based upon the Software or any part thereof, (e) use the Software in a service bureau or application service provider environment, in a commercial time share arrangement, or for purposes of providing services to a third party other than in connection with deploying your Customer Applications created using the Software as permitted in the last two sentences of this Section 3.4.1, (f) combine all or any part of the Software with other software or use all or any part of the Software to create a new product, application or service, provided, that for purposes of clarity, you and your Users may use the Software to develop and deploy Customer Applications to the extent enabled by the Software and so long as you comply with the terms and conditions of this Agreement and do not infringe on or violate Posit’s intellectual property rights in the Software; (g) develop, resell, distribute or make available any service, software or device incorporating all or any part of the Software, (h) use the Software except on your own internal computer networks on devices that you own, lease or otherwise control (including for such purpose the hardware of a third party hosting providers that hosts the Software for your benefit, such as Amazon Web Services), (i) use the Software in contravention of, or to violate, any applicable laws, rules, regulations or guidelines or to develop Customer Applications that contravene or violate any applicable laws, rules, regulations or guidelines, (j) remove or alter any trademark, trade names, product names, logo, copyright or other proprietary notices, legends, symbols or labels from the Software, (k) decompile, disassemble, reverse engineer or otherwise attempt to derive the source code of the Software or attempt to modify, alter, or circumvent the license control and protection mechanisms within the Software, or (l) deploy, install, host, integrate, embed, make available, or otherwise enable use of the Software, either directly or as integrated within or accessed through RStudio or any other host integrated development environment, within, as part of, or as a feature or service of any Third-Party Commercial Platform, or otherwise provide the Software (alone or in combination with RStudio or any other software) to any third party as, or as part of, a commercial offering or service. The license granted in Section 3.1 does not extend to use of the Software within or in connection with any Third-Party Commercial Platform, and no such use is permitted under this Agreement. For the avoidance of doubt, the foregoing restriction regarding Third-Party Commercial Platforms and uses of the Software in connection with commercial offering or service, applies regardless of whether the Software is provided on a hosted, software-as-a-service, platform-as-a-service, managed, self-managed, or on-premise basis. Use of the Software in connection with the provision of software, development environments, or computing services to third parties is available solely through Posit Workbench under a separate subscription and Order Form. If 3.4(k) is prohibited by applicable law, you shall provide Posit with a detailed prior written notice of any such intention to reverse engineer the Software and shall provide Posit with a right of first refusal to perform such work at rates equal to those proposed by a recognized third-party software services provider for such work. You may only use Disaster Recovery Software and Staging Software as described in the Software License Descriptions. To the extent users of your Customer Applications access and use your Customer Applications as enabled through use of the Software, such users shall be deemed "Users" for all purposes hereunder except that such Users shall be restricted to viewing your directory of Customer Applications and to using and viewing the output of your Customer Applications. Such Users may not be authorized to, and must not, develop, publish, or modify Customer Applications. You agree that you will require your Users to comply with all applicable laws, rules and regulations and this Agreement in their use of your Customer Applications will comply with. 

3.4.2 Export. You may not export the Software or Customer Applications into any country prohibited by the United States Export Administration Act and the regulations thereunder. You acknowledge that the release of software, technology, or data to a non-US person within the United States or elsewhere abroad is deemed to be an export to the non-U.S. person’s home country or countries. You acknowledge that the export of any Software or Customer Applications is subject to export controls and you agree that the Software and any Customer Applications, and the direct or indirect product thereof, will not be exported (or re-exported from a country of installation), directly or indirectly, unless you obtain all necessary licenses from the U.S. Department of Commerce or other applicable agency or governmental body as required under applicable law or you qualify for exemptions or exceptions. You shall comply with the export laws and regulations of the United States and other applicable jurisdictions in using the Software, including without limitation the International Traffic in Arms Regulations (ITAR), 22 CFR 120 – 130, the Export Administration Regulations (EAR), 15 CFR 730 – 799, and the Foreign Assets Control Regulations (FACR), 31 CFR 500 – 599. Without limiting the foregoing, (i) you represent that neither you nor your Users are not named on any U.S. government list of persons or entities prohibited from receiving exports, and (ii) you shall not use, and shall not permit your Users to access or use, the Software or Customer Applications in violation of any U.S. export embargo, prohibition or restriction. You acknowledge and agree that the Software is prohibited for export or re-export to Cuba, North Korea, Iran, Libya, Syria and Sudan or to any person or entity on the U.S. Department of Commerce Denied Persons List, Entity List, or Unverified List, U.S. State Department’s Nonproliferation Sanctions List, or on the U.S. Department of Treasury’s lists of Specially Designated Nationals, Specially Designated Narcotics Traffickers or Specially Designated Terrorists, as such is changed from time to time.

3.5 Third Party Materials. You acknowledge and agree that the Software is intended for use with Open Source Languages, and, as such, interoperates with certain open source components, including without limitation open source packages and libraries, as part of its basic functionality and that to use the Software, you will need to separately license Open Source Languages from the licensor. Posit is not responsible for Open Source Languages and does not assume any obligations or liability with respect to your or your Users’ use of Open Source Languages. Further, you may elect to use, or Posit may make available to you or your Users for download, access or use, certain third party components, packages, applications, services, data, content or resources (collectively all of the foregoing, "Third Party Materials"). Posit may make available Third Party Materials via Posit’s website or may provide links to third party websites where you may purchase and/or download or access Third Party Materials or the Software may enable you to download, or to access and use, such Third Party Materials. You acknowledge and agree that Third Party Materials may be protected by intellectual property rights which are owned by the third-party providers or their licensors and not Posit. Accordingly, you acknowledge and agree that your use of Third Party Materials may be subject to separate terms between you and the relevant third party and you acknowledge and that Posit is not responsible for Third Party Materials and makes no representations or warranties with respect thereto, all of which are provided "as is". Posit assumes no liability or other obligations with respect thereto and, without limiting the foregoing, is not liable for any loss or damage that you or your Users may experience as a result of the use or access thereof. Third Party Materials are the sole responsibility of the third party from which they originated.

3.6 Open Source Software. You acknowledge that certain third party software incorporated in the Software requires that Posit provide copyright notices and/or additional terms and conditions to you, which copyright notices and additional terms and conditions may be accessed by you at https://www.posit.co/about/opensourcelicenses/ and are incorporated by reference into this Agreement. Use, reproduction and distribution of those components of the Software that are licensed under an open source software license are governed solely by the terms of that open source software license and not this Agreement.

4\. Support Services. During a Subscription Term, for the fee, if any, set forth in the applicable Order Form, Posit will provide you (through your designated representatives) with Support Services, including Updates, in accordance with and subject to the terms of the Support Program. Posit may use technical information provided by you relating to the Software as part of the Support Services, including for product support and development. As part of the Support Services, Posit may make available bug lists, planned feature lists, and other supplemental materials, all of which are Confidential Information of Posit and for which Posit makes no representations or warranties of any kind.

5\. Fees and Payments. You shall pay Posit the fees, charges and other amounts specified in an Order Form within forty-five (45) days from your receipt of Posit’s complete, accurate and undisputed invoice. If your internal procedures require that an invoice be submitted against a purchase order before payment can be made, you shall be responsible for issuing such purchase order to Posit prior to the Software license key being delivered and your failure to do so will not extend or obviate your responsibilities to pay all fees, charges and other amounts in accordance with this Agreement and the Order Form. All fees, charges, and other amounts are payable in United States dollars and, except as expressly otherwise provided herein, are nonrefundable. You shall be responsible for taxes levied on any transaction under this Agreement, including all federal, state, and local taxes, levies, and assessments, excluding any taxes based on Posit’s net income, employees, or property.

6\. Confidentiality.

6.1 Confidential Information. During the term of this Agreement, each party will regard any information provided to it by the other party and designated in writing as proprietary or confidential to be confidential ("Confidential Information"). Confidential Information shall also include information which, to a reasonable person familiar with the disclosing party’s business and the industry in which it operates, is of a confidential or proprietary nature. A party will not disclose the other party’s Confidential Information to any third party without the prior written consent of the other party, nor make use of any of the other party’s Confidential Information except in its performance under this Agreement. Each party accepts responsibility for the actions of its agents or employees and shall protect the other party’s Confidential Information in the same manner as it protects its own valuable confidential information, but in no event shall less than reasonable care be used. For the avoidance of doubt, the parties expressly agree that the Software, the fees payable under an Order Form and the terms of this Agreement are the Confidential Information of Posit. A receiving party shall promptly notify the disclosing party upon becoming aware of a breach or threatened breach hereunder, and shall cooperate with any reasonable request of the disclosing party in enforcing its rights.

6.2 Exclusions. Information will not be deemed Confidential Information hereunder if such information: (i) is known prior to receipt from the disclosing party, without any obligation of confidentiality; (ii) becomes known to the receiving party directly or indirectly from a source other than one having an obligation of confidentiality to the disclosing party; (iii) becomes publicly known or otherwise publicly available, except through a breach of this Agreement; or (iv) is independently developed by the receiving party without use of or reference to the disclosing party’s Confidential Information or breach of this Agreement. The receiving party may disclose Confidential Information pursuant to the requirements of applicable law (including without limitation applicable state or federal regulations which may require you to make disclosure pursuant to and as limited by such regulations, such as freedom of information regulations), legal process or government regulation, provided that it gives the disclosing party reasonable prior written notice to permit the disclosing party to contest such disclosure, and such disclosure is otherwise limited to the required disclosure.

6.3 Specific Performance. If the receiving party discloses or uses (or threatens to disclose or use) any Confidential Information in breach of this Section 6, the disclosing party shall have the right, in addition to any other remedies available to it, to seek injunctive relief to enjoin such acts, it being specifically acknowledged by the parties that any other available remedies are inadequate.

7\. Ownership; Feedback.

7.1 Posit Software. Posit and its licensors retain ownership of all right, title, and interest in and to the Software, including all intellectual property rights therein and thereto, and Posit reserves all rights not specifically granted in this Agreement. If the Software was acquired outside the United States, then you agree and assent to the adherence to all applicable international treaties regarding intellectual property rights which shall also apply. You shall take all reasonable precautions to prevent unauthorized or improper use or disclosure of the Software. Posit and other trademarks contained in the Software are trademarks or registered trademarks of Posit Software, PBC in the United States and/or other countries.

7.2 Customer Applications. To the extent you use the Software to develop and deploy Customer Applications, you and your licensors retain ownership of all right, title, and interest in and to the Customer Applications. Posit shall have no right to access or use your Customer Applications unless you separately grant Posit a license or right to access and use your Customer Applications.

7.3 Feedback. You and you Users may, from time to time, voluntarily make known to Posit suggestions, enhancement requests, techniques, know-how, comments, feedback, or other input to Posit with respect to the Software (collectively, "Suggestions"). Unless otherwise agreed to in writing by the parties with respect to any Suggestion, Posit shall have a royalty-free, worldwide, irrevocable, perpetual license to use, disclose, reproduce, license, distribute, and exploit any Suggestion without restriction or obligation of any kind, on account of confidential information, intellectual property rights, or otherwise, and may incorporate into its services any service, product, technology, enhancement, documentation, or other development ("Improvement") incorporating or derived from any Suggestion with no obligation to license or to make available the Improvement to you or any other person or entity.

8\. Limited Warranty.

8.1 Software Warranty. Except with respect to the Trial Version of the Software for which Posit provides no representations, warranties, or covenants, Posit represents, warrants and covenants that (a) the Software will perform in conformity with its Documentation; (b) any Support Services will be provided in a professional manner, with reasonable skill and care and in conformance with generally accepted software industry standards; and (c) as of the Subscription Start Date, the Software has been scanned using the most recent version of a leading commercially available virus scanning program designed to detect and remediate known viruses and other harmful and malicious code. Your exclusive remedy for Posit’s breach of the foregoing warranties is that Posit will, at its option and at no cost to you, either (a) provide remedial services necessary to enable the Software or Support Services to conform to the warranty, or (b) replace any defective Software or media. If neither of the foregoing options is commercially feasible within a reasonable period of time, upon your return of the affected Software to Posit, Posit will refund all prepaid fees for the unused remainder of the applicable Subscription Term following the date of termination for the affected Software and this Agreement and any associated Order Forms for the affected Software will immediately terminate without further action of the parties. You agree to provide Posit with a reasonable opportunity to remedy any breach and reasonable assistance in remedying any nonconformities.

8.2 DISCLAIMER. EXCEPT AS SET FORTH IN THE FOREGOING LIMITED WARRANTY IN SECTION 8.1, THE SOFTWARE IS PROVIDED "AS IS" AND POSIT AND ITS LICENSORS DISCLAIM ALL OTHER WARRANTIES AND REPRESENTATIONS, WHETHER EXPRESS, IMPLIED, STATUTORY OR OTHERWISE, AND EXPRESSLY DISCLAIM THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT. POSIT DOES NOT REPRESENT OR WARRANT THAT THE SOFTWARE IS ERROR FREE OR THAT ALL ERRORS CAN BE CORRECTED. THE SOFTWARE IS NOT DESIGNED, INTENDED, OR LICENSED FOR USE IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE CONTROLS, INCLUDING WITHOUT LIMITATION, THE DESIGN, CONSTRUCTION, MAINTENANCE, OR OPERATION OF NUCLEAR FACILITIES, AIRCRAFT NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, AND LIFE SUPPORT OR WEAPONS SYSTEMS. POSIT SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR SUCH PURPOSES. No oral or written information or advice given by Posit, its resellers, dealers, distributors, agents, representatives or employees shall create any warranty or in any way increase any warranty provided herein.

8.3 Limitation. If applicable law requires any warranties other than the foregoing, all such warranties are limited in duration to ninety (90) days from the date of delivery. Some jurisdictions do not allow the exclusion of implied warranties, so the above exclusion may not apply to you. The warranty provided herein gives you specific legal rights and you may also have other legal rights that vary from jurisdiction to jurisdiction. The limitations or exclusions of warranties, remedies or liability contained in this Agreement shall apply to you only to the extent such limitations or exclusions are permitted under the laws of the jurisdiction where you are located.

9\.  Indemnity

9.1 By Posit. Posit agrees to defend (at Posit’s expense) you and your Affiliates and your respective officers, directors, and employees from and against any and all claims, demands, suits, and proceedings asserted by a third party ("Third Party Claims") against any or all of them which Third Party Claims allege that the Software or your use thereof infringes the intellectual property rights of a third party and Posit shall indemnify and hold you and your indemnitees harmless from all damages finally awarded by a court of competent jurisdiction or in a binding arbitration or agreed to by Posit in settlement with respect to such Third Party Claims. Notwithstanding the foregoing, Posit shall have no obligation with respect to Third Party Claims or demands arising from (i) an allegation that does not state with specificity that the Software is the basis of the Third Party Claims; (ii) the use or combination of the Software or any part thereof with software, hardware, or other materials not developed by Posit if the Software or use thereof would not infringe without such combination; (iii) modification of the Software by a party other than Posit or its authorized contractors, if the use of unmodified Software would not constitute infringement; (iv) Third Party Materials or your Customer Applications; (v) your use of the Software in violation of this Agreement or the Documentation if the infringement would not have arisen but for such violation; (vi) your failure to install an Update that would have avoided the infringement provided that Posit made the Update available to you for free and with notice that it was provided to avoid an infringement; (vii) an allegation of infringement or misappropriation deriving from Open Source Languages or other open source software; or (viii) an allegation made against you prior to the execution of this Agreement. Further, if Posit has a reasonable belief that the Software is infringing, Posit will, at Posit’s sole cost and expense, either (a) obtain for you a license to continue using the Software, or (b) modify the Software so that it is no longer infringing without any material loss of functionality; provided that if neither option is commercially feasible within a reasonable period of time, either party may elect to terminate this Agreement upon written notice to the other party and Posit will refund all prepaid fees for the unused remainder of the Subscription Term following the termination date with respect to the Software that is the subject of the Third Party Claim. This Section 9.1 states Posit’s sole liability and your exclusive remedy for claims of infringement or misappropriation of third-party intellectual property rights.

9.2 Your Indemnity. You agree to defend (at your expense) Posit and its officers, directors, and employees from and against any and all Third Party Claims asserted against any or all of them which Third Party Claims arise out of or relate to your Customer Applications or use of the Software in violation of this Agreement, and you shall indemnify and hold Posit and its indemnitees harmless from all damages finally awarded by a court of competent jurisdiction or in a binding arbitration or agreed to by you in settlement with respect to such Third Party Claims.

9.3 Process. Each party’s obligations under this Section 9 are conditioned on the indemnified party (i) providing the indemnifying party with written notice promptly upon learning of any claim for which it seeks indemnification; provided that any failure to provide prompt notice shall not relieve the indemnifying party of its obligations except to the extent the indemnifying party was prejudiced by such failure; (ii) providing the indemnifying party sole control over the defense and settlement of the claim; provided that the indemnifying party may not settle the claim in a manner adverse to the indemnified party or which would impose liability on the indemnified party without the indemnified party’s prior written consent (which will not be unreasonably withheld or delayed); and provided, further, that the indemnified party may participate in the defense of the claim at its own cost and expense; and (iii) providing the indemnifying party with assistance in the defense and settlement of the claim at the indemnifying party’s expense.

10\. LIMITATION OF LIABILITY

10.1 Limitation of Liability. TO THE MAXIMUM EXTENT PERMITTED BY LAW, NEITHER PARTY SHALL BE LIABLE TO THE OTHER PARTY OR ANY THIRD PARTY FOR ANY INDIRECT, SPECIAL, INCIDENTAL, EXEMPLARY, PUNITIVE, COVER, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, LOSS OF BUSINESS, LOSS OF PROFITS, LOSS OF GOODWILL, LOSS OF USE, LOSS OR CORRUPTION OF DATA, INABILITY TO ACCESS OR USE EQUIPMENT, SOFTWARE OR DATA, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES, BUSINESS INTERRUPTION OR THE LIKE), ARISING OUT OF THIS AGREEMENT OR THE USE OF, OR INABILITY TO USE, THE SOFTWARE, OR BASED ON ANY THEORY OF LIABILITY INCLUDING WITHOUT LIMITATION BREACH OF CONTRACT, BREACH OF WARRANTY, TORT (INCLUDING NEGLIGENCE), PRODUCT LIABILITY OR OTHERWISE, EVEN IF SUCH PARTY OR ITS REPRESENTATIVES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES AND EVEN IF A REMEDY SET FORTH HEREIN IS FOUND TO HAVE FAILED OF ITS ESSENTIAL PURPOSE. TO THE MAXIMUM EXTENT PERMITTED BY LAW, EACH PARTY’S TOTAL AGGREGATE LIABILITY UNDER THIS AGREEMENT FOR ANY CAUSE WHATSOEVER WILL NOT EXCEED THE AMOUNT PAID TO POSIT FOR THE SOFTWARE THAT CAUSED SUCH DAMAGE IN THE TWELVE MONTHS IMMEDIATELY PRIOR TO THE DATE THE CAUSE OF ACTION AROSE.

10.2 Exclusions. The foregoing limitations in Section 10.1 shall not apply to (i) gross negligence, willful misconduct, or fraud, (ii) breach of the obligations of confidentiality set forth in Section 6, (iii) violation or misappropriation by a party of the other party’s intellectual property rights, or (iv) you or your Users’ or third party hosting providers’ breach of Section 3.1 (License Grant), 3.3 (Virtualization Technology; Third Party Hosting Providers), or Section 3.4 (Restrictions; Export Laws). Further, the foregoing limitations shall not apply to a party’s indemnification obligations in Section 9 for which a party’s total aggregate liability shall be limited to (x) three times (3x) the fees paid to Posit for the Software that is the subject of the Third Party Claim in the twelve months immediately preceding the date the claim arose or (y) $100,000, whichever is greater. Further, nothing Section 10.1 shall limit your obligation to pay the applicable fee(s) for all authorized and unauthorized use of the Software.

10.3 Basis of the Bargain. The Disclaimer set forth in Section 8.2 and Limitation of Liability set forth in this Section 10 are fundamental elements of the basis of the agreement between Posit and you. Posit and its suppliers would not be able to provide the Software on an economic basis without such limitations.

11\.  Term and Termination.

11.1 Term. This Agreement shall remain in full force and effect until all Order Forms entered into hereunder have terminated or expired or until earlier terminated in accordance herewith. Each Order Form shall commence on the Subscription Start Date and shall continue for the Subscription Term set forth therein unless earlier terminated in accordance herewith. Unless either party provides the other party of written notice of termination at least 30 days prior to the end of the then current Subscription Term, the Subscription Term will be extended for an additional twelve months on each anniversary of the Subscription Start Date. Prior to the commencement of the renewal Subscription Term, you shall either submit a purchase order or make payment in full of the applicable annual license fees for such renewal Subscription Term. If you do not submit a purchase order or make payment in full on or before the commencement of the renewal Subscription Term, the Subscription Term will immediately terminate without further action by the parties.

11.2 Termination. This Agreement or an individual Order Form may be terminated (a) in the case of Posit, if you fail to pay any amount due hereunder within ten (10)business days after written demand by Posit for payment thereof, (b) by either party if the other party becomes insolvent, resolves to file bankruptcy, is adjudicated as bankrupt, or if a petition in bankruptcy is filed against the other party and such petition is not discharged within sixty (60) days of such filing, (c) by mutual written agreement of the parties, or (d) by either party if the other party materially breaches this Agreement and fails to cure such breach to such party’s reasonable satisfaction within thirty (30) days following receipt of written notice thereof.

11.3 Effect of Termination. Upon any termination of this Agreement or the affected Order Form, You and your Users shall immediately cease all use of the Software and certify in writing to Posit within thirty (30) days after termination that such Software and all copies thereof have been destroyed, purged, or returned to Posit.Termination of this Agreement or a license granted hereunder shall not limit either party from pursuing any remedies available to it, including injunctive relief, or relieve you of your obligation to pay all fees that have accrued or have become payable hereunder, without right of refund. Sections 1, 5, 6, 7, 8.2, 9, 10, 11.3 and 12 shall survive any expiration or termination of this Agreement.

12\.  General.

12.1 Governing Law; Jurisdiction. This Agreement shall be governed by the internal laws of the Commonwealth of Massachusetts, U.S.A., without giving effect to principles of conflict of laws. Each party hereby irrevocably consents to the exclusive jurisdiction and venue of the state courts sitting in the Commonwealth of Massachusetts or the federal courts in the Commonwealth of Massachusetts to resolve any disputes arising under this Agreement. In each case this Agreement shall be construed and enforced without regard to the United Nations Convention on the International Sale of Goods and without regard to the Uniform Computer Information Transactions Act. To the fullest extent permitted, each party waives the right to trial by jury in any legal proceeding arising out of or relating to this Agreement or the transactions contemplated hereby.

12.2 Assignment. Neither party may assign any of its rights or obligations hereunder, whether by operation of law or otherwise, without the prior written consent of the other party (not to be unreasonably withheld). Notwithstanding the foregoing, either party may assign this Agreement in its entirety (including all Order Forms), without consent of the other party, to its Affiliate or to its successor in a merger, acquisition, corporate reorganization, or sale of all or substantially all of its assets, stock, or business to which this Agreement relates. Subject to the foregoing, this Agreement shall bind and inure to the benefit of the parties, their respective successors and permitted assigns.

12.3 Entire Agreement. This Agreement (including all Order Form(s) entered into by the parties, the Software License Descriptions and all documents linked to herein and therein) contain the complete agreement between the parties with respect to the subject matter hereof, and supersede all prior and contemporaneous agreements and understandings whether oral or written. You agree that any varying or additional terms contained in any purchase order or other written notification or document issued by you in relation to the Software licensed hereunder shall be of no effect and all such terms or conditions shall be null and void. You acknowledge and agree that your agreement hereunder is not contingent upon the delivery of any future functionality or features not specified herein or in an Order Form or dependent upon any oral or written, public or private comments made by Posit with respect to future functionality or features for the Software. In the event of any conflict between this Agreement, the Software License Descriptions, any Order Form or any document linked to herein or therein, this Agreement shall govern; provided, however, that notwithstanding the foregoing and for the avoidance of doubt: (i) the license limitations and entitlements set forth in an Order Form and the Software License Descriptions shall supplement this Agreement and shall supersede any conflicting terms for purposes of determining the license limitations and entitlements applicable to your and your Users use of the Software and (ii) the Support Program shall supplement this Agreement and shall supersede any conflicting terms for purposes of defining your Support Services entitlements.

12.4 Waiver. The failure or delay of a party to exercise any of its rights under this Agreement or upon any breach of this Agreement shall not be deemed a waiver of those rights or of the breach. No Reseller or Posit dealer or agent is authorized to make any amendment to this Agreement. The parties may amend this Agreement by mutual written agreement executed by duly authorized representatives of the parties. The parties agree that there are no third party beneficiaries to this Agreement. Neither party shall be deemed to be an employee, agent, or other legal representative of the other party for any purpose whatsoever, or have the right or authority to assume or otherwise create any obligation or responsibility, express or implied, on behalf of the other party or to bind the other party in any manner whatsoever.

12.5 Severability. If any provision of this Agreement shall be held by a court of competent jurisdiction to be contrary to law that provision will be enforced to the maximum extent permissible and the remaining provisions of this Agreement will remain in full force and effect. A waiver by either party of any term or condition of this Agreement or any breach thereof, in any one instance, shall not waive such term or condition or any subsequent breach thereof.

12.6 Notices. Notices must be in English, in writing, and will be deemed given upon receipt, after being sent using a method that provides for positive confirmation of delivery to the physical address or email address set forth in the Order Form, including without limitation through automated receipt or by electronic log.

12.7 U.S. Government Users. The Software and its Documentation are "Commercial items," "Commercial computer software" and "Computer software documentation" as defined by the Federal Acquisition Regulations ("FAR") and Defense Federal Acquisition Regulations Supplement ("DFARS"). Pursuant to FAR 12.211, FAR 12.212, DFARS, 227.7202-1 through 227.7202-4, and their successors, the U.S. Government acquires the Software and its documentation subject to the terms of this Agreement.

12.8 Counterparts; Electronic Signatures; Construction. This Agreement and any Order Form may be executed in counterparts, which taken together shall form one legal instrument. A manually or electronically signed copy of this Agreement or any Order Form delivered by facsimile, e-mail or other means of electronic transmission shall be deemed to have the same legal effect as delivery of an original signed copy of the Agreement or the Order Form. The titles of the sections of this Agreement are for convenience of reference only and are not to be considered in construing this Agreement. Unless the context of this Agreement clearly requires otherwise: (i) references to the plural include the singular, the singular the plural, and the part the whole, (ii) "or" has the inclusive meaning frequently identified with the phrase "and/or," (iii) "including" has the inclusive meaning frequently identified with the phrase "including but not limited to" or "including without limitation," and (iv) references to "hereunder," "herein" or "hereof" relate to this Agreement as a whole. Any reference in this Agreement to any statute, rule, regulation or agreement, including this Agreement, shall be deemed to include such statute, rule, regulation or agreement as it may be modified, varied, amended or supplemented from time to time. The parties agree that this Agreement shall be fairly interpreted in accordance with its terms without any strict construction in favor of or against either party and that ambiguities shall not be interpreted against the drafting party.  

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

This R Markdown document is made interactive using Shiny. Unlike the more traditional workflow of creating static reports, you can now create documents that allow your readers to change the assumptions underlying your analysis and see the results immediately. 

To learn more, see [Interactive Documents](http://rmarkdown.rstudio.com/authoring_shiny.html).

## Inputs and Outputs

You can embed Shiny inputs and outputs in your document. Outputs are automatically updated whenever inputs change.  This demonstrates how a standard R plot can be made interactive by wrapping it in the Shiny `renderPlot` function. The `selectInput` and `sliderInput` functions create the input widgets used to drive the plot.

```{r eruptions, echo=FALSE}
inputPanel(
  selectInput("n_breaks", label = "Number of bins:",
              choices = c(10, 20, 35, 50), selected = 20),
  
  sliderInput("bw_adjust", label = "Bandwidth adjustment:",
              min = 0.2, max = 2, value = 1, step = 0.2)
)

renderPlot({
  hist(faithful$eruptions, probability = TRUE, breaks = as.numeric(input$n_breaks),
       xlab = "Duration (minutes)", main = "Geyser eruption duration")
  
  dens <- density(faithful$eruptions, adjust = input$bw_adjust)
  lines(dens, col = "blue")
})
```

## Embedded Application

It's also possible to embed an entire Shiny application within an R Markdown document using the `shinyAppDir` function. This example embeds a Shiny application located in another directory:

```{r tabsets, echo=FALSE}
shinyAppDir(
  system.file("examples/06_tabsets", package = "shiny"),
  options = list(
    width = "100%", height = 550
  )
)
```

Note the use of the `height` parameter to determine how much vertical space the embedded application should occupy.

You can also use the `shinyApp` function to define an application inline rather then in an external directory.

In all of R code chunks above the `echo = FALSE` attribute is used. This is to prevent the R code within the chunk from rendering in the document alongside the Shiny components.

---
title: "Environment variables"
date-meta: 2026-05-04
---

You can control certain aspects of RStudio by setting environment variables before starting it. RStudio reads these variables at startup, so set them in the environment that launches RStudio (for example, in your shell profile, a launcher script, or your operating system's environment settings).

In the table below, a Value of "Non-empty" means RStudio treats the variable as enabled whenever you set it to any string other than the empty string. Setting the variable to `1` is the conventional choice, but values such as `true`, `yes`, or even `0` and `false` also enable the behavior because the variable is non-empty. To turn the behavior off, unset the variable rather than setting it to an empty string.

| Environment Variable | Value | Platform | Impact |
|---|---|---|---|
| `RS_NO_SPLASH` | Non-empty | Desktop | Disables the splash screen shown while RStudio is starting up. |
| `RSTUDIO_DISABLE_CHECK_FOR_UPDATES` | Non-empty | Desktop | Disables automatic checks for new RStudio releases. |
| `RSTUDIO_DISABLE_EXTERNAL_PUBLISH` | Non-empty | Desktop, Server | Disables publishing to external services such as RPubs. Publishing to internal services (e.g., Posit Connect) remains available. |
| `RSTUDIO_DISABLE_PACKAGES` | Non-empty | Desktop, Server | Disables the package management UI. |
| `RSTUDIO_DISABLE_PACKAGE_INSTALL_PROMPT` | Non-empty | Desktop, Server | Suppresses prompts to install missing packages required by your code. |
| `RSTUDIO_DISABLE_POSIT_ASSISTANT` | Non-empty | Desktop, Server | Disables and hides the [Posit Assistant](../guide/tools/posit-ai.qmd) features. RStudio does not display the Posit Assistant toolbar button or pane, and you cannot install or use Posit Assistant. |
| `RSTUDIO_DISABLE_PUBLISH` | Non-empty | Desktop, Server | Disables content publishing entirely, including both internal and external services. |
| `RSTUDIO_DISABLE_WHATS_NEW` | Non-empty | Desktop | Suppresses the "What's New" dialog that is otherwise shown after RStudio is updated to a new version. |

<!-- include an entry in NEWS.md if required -->

### Intent

> Describe briefly what problem this pull request resolves, or what new feature it introduces. Include screenshots of any new or altered UI. Link to any Github issues that are related.

### Approach

> Describe the approach taken and the tradeoffs involved if non-obvious; add an overview of the solution if it's complicated.

### Automated Tests

> Indicate whether this change includes unit tests or integration tests, or link a work item or pull request to add those tests to another repo. If the change cannot or will not be covered by a test, indicate why.

### QA Notes

> Ensure you have updated the QA Notes in the original issue.

### Documentation

> Specify which documentation has been added or modified and why (User Guide? Admin Guide?). If no documentation was added for a new feature, indicate why. If documentation was added in a separate PR, link the PR here.

### Checklist

- [ ] If this PR adds a new feature, or fixes a bug in a previously released version, it includes an entry in `NEWS.md`
- [ ] If this PR adds or changes UI, the updated UI meets [accessibility standards](https://github.com/rstudio/rstudio/wiki/Accessibility)
- [ ] A reviewer is assigned to this PR (if unsure who to assign, check Area Owners list)
- [ ] This PR passes all local unit tests

<!-- Note for community contributors: Please sign our contributor agreement as described in CONTRIBUTING.md and note that you've done so in this space. Very much appreciate your contributions and support! -->

---
title: "Project Templates"
date-meta: 2022-12-12
---

RStudio includes support for custom, user-defined project templates. Project templates can be used to create new projects with a pre-specified structure.

Project templates can be accessed through the **New Project...** wizard. All registered project templates are made available within the **New Directory** portion of the wizard:

![](images/new-project.png){fig-alt="A screenshot of the RStudio > New Project wizard"}

R packages are the primary vehicle through which RStudio project templates are distributed. Package authors can provide a small bit of metadata describing the template functions available in their package -- RStudio will discover these project templates on start up, and make them available in the **New Project...** dialog.

## Example

We'll use the [ptexamples](https://github.com/rstudio/ptexamples) package to illustrate how a project template can be defined. This package exports a project template that is presented like so from the **New Project...** wizard:

![](images/ptexamples-wizard.png){fig-alt="A screenshot of the Create Example Project Template wizard with a directory name and other user input options."}

After the user clicks **Create Project**, a new project will be created, and the `hello_world()` template function will be called to initialize the project. Here's what the IDE looks like after calling this template function with the aforementioned inputs:

![](images/ptexamples-rstudio.png){fig-alt="A screenshot of the newly created ptexamples RStudio project displaying the index with the user inputs."}

To try using this project template locally, install the package:

``` r
# if needed install.packages("devtools")
devtools::install_github("rstudio/ptexamples")
```

Restart RStudio and then access the `ptexamples` template from the **New Project** wizard.

## Defining the Template Function

The `ptexamples` package contains a function, [`hello_world()`](https://github.com/rstudio/ptexamples/blob/master/R/hello_world.R), intended to be used as a project template. The function has the signature:

``` r
hello_world <- function(path, ...) {
  # ensure path exists
  dir.create(path, recursive = TRUE, showWarnings = FALSE)

  # generate header for file
  header <- c(
    "# This file was generated by a call to 'ptexamples::hello_world()'.",
    "# The following inputs were received:",
    ""
  )

  # collect inputs and paste together as 'Parameter: Value'
  dots <- list(...)
  text <- lapply(seq_along(dots), function(i) {
    key <- names(dots)[[i]]
    val <- dots[[i]]
    paste0(key, ": ", val)
  })

  # collect into single text string
  contents <- paste(
    paste(header, collapse = "\n"),
    paste(text, collapse = "\n"),
    sep = "\n"
  )

  # write to index file
  writeLines(contents, con = file.path(path, "INDEX"))
}
```

When this function is invoked by RStudio, it will receive the `path` as the path to the newly created project, as well as arguments as received from its input widgets. This function collects its inputs, and echos them to a file called `INDEX` in the newly-created project path.

## Defining the Template Metadata

After defining a function to be used as a project template, some initial metadata must be provided to let RStudio know how to use this function as a project template. The `ptexamples` package defines a project template in a file located at:

[inst/rstudio/templates/project/hello_world.dcf](https://github.com/rstudio/ptexamples/blob/master/inst/rstudio/templates/project/hello_world.dcf)

The first set of fields are used to define primary information about the project template:

``` yaml
Binding: hello_world
Title: Example Project Template
OpenFiles: INDEX
```

-   The **Binding** field tells RStudio which R function the project template is associated with. When a user creates a new project using this template, the `hello_world()` function defined by this package will be used to generate the project.

-   The **Title** field is used and shown within the new project wizard.

-   The **OpenFiles** field instructs the IDE to open a file called `INDEX` when the project is first opened, after creating the project.

The following sets of fields are used to define input widgets:

``` yaml
Parameter: check
Widget: CheckboxInput
Label: Checkbox Input
Default: On
Position: left
```

-   The **Parameter** field is used to identify the parameter name. That is, the value of the widget used here will be associated with the parameter called `check` when passed to the template function `hello_world()`.

-   The **Widget** field is used to specify the type of widget to be used. Here, we use a checkbox, to allow for 'on / off' input from the user.

-   The **Label** field is used to give a label associated with the checkbox.

-   The **Default** field gives the default value for the checkbox input -- here, we want to default having the checkbox 'on', or checked.

-   The **Position** field tells the RStudio IDE that this widget should be displayed on the left side of the wizard dialog.

All together, this information tells RStudio that `hello_world()` is a function to be used in generating new projects, as well as what widgets should be used for arguments that `hello_world()` can accept.

## Primary Metadata

The following fields are accepted as part of the primary metadata regarding a project template:

-   **Binding** *(required)*: The name of the R function to be called when this project template is invoked.

-   **Title** *(required)*: The title to be shown within the **New Project...** wizard.

-   **Subtitle**: The subtitle to be shown within the **New Project...** wizard. This will be shown when the user hovers over the project name in the dialog. When unsupplied, this field will be generated based on the content of the **Title** field.

-   **Caption**: The caption to be shown on the landing page for this template function. When unsupplied, this field will be generated based on the content of the **Title** field.

-   **Icon**: The path to an icon, on disk, to be used in the dialog. Must be a `.png` file of size less than 64kb.

-   **OpenFiles**: A comma-delimited set of values, indicating files that should be opened by RStudio when the project is generated. Shell-style globs can be used to indicate when multiple files matching some pattern should be opened -- for example, `OpenFiles: R/*.R` would indicate that RStudio should open all `.R` files within the `R` folder of the generated project.

## Input Widgets

The following widget types are accepted for the **Widget** field in widget descriptions.

### CheckboxInput

Represent a `TRUE` / `FALSE` input value using a checkbox.

#### Example

``` yaml
Parameter: check
Widget: CheckboxInput
Label: label
```

### SelectInput

Select a single item out of a menu list of items. The **Fields** field should be a comma-separated list of fields to be included in the select input.

#### Example

``` yaml
Parameter: project_type
Widget: SelectInput
Label: Project Type
Fields: project, package
```

#### TextInput

Accept unrestricted text input from the user.

#### Example

``` yaml
Parameter: author
Widget: TextInput
Label: Author
```

### FileInput

Provide the path to a file on disk.

#### Example

``` yaml
Parameter: file
Widget: FileInput
Label: Data file
```

---
title: "Get Started"
date-meta: 2022-12-12
---

The following documentation walks through an example of using the `ggplot2` R package and RStudio for basic data visualization. If you are new to R and want to learn more about using R for Data Science, also see the [R for Data Science](https://r4ds.hadley.nz/) textbook which is available in [print](https://www.oreilly.com/library/view/r-for-data/9781492097396/) or as a [freely available website](https://r4ds.hadley.nz/)

`ggplot2` is part of the `tidyverse` ecosystem of packages.

> The tidyverse is an opinionated [**collection of R packages**](https://www.tidyverse.org/packages) designed for data science. All packages share an underlying design philosophy, grammar, and data structures.

## Hello RStudio

RStudio is an integrated development environment (IDE) designed to help you be more productive in your daily data science work.

After you have installed [R](https://cloud.r-project.org/) and [RStudio](../../index.qmd#rstudio-ide-oss-downloads), you are ready to begin this section!

When you start RStudio, you'll see four key regions or "panes" in the interface: the Source pane, the Console pane, the Environment pane and the Output Pane.

### RStudio Panes

1.  The **Source pane** is where you can edit and save R or Python scripts or author computational documents like Quarto and R Markdown.

2.  The **Console pane** is used to write short interactive R commands.

3.  The **Environment pane** displays temporary R objects as created during that R session.

4.  The **Output pane** displays the plots, tables, or HTML outputs of executed code along with files saved to disk.

![](images/rstudio-panes-labeled.jpeg){fig-alt="A screenshot of the RStudio UI. There are 4 primary panes, the source, console, environment, and output panes."}

### Blank slate

When you quit R, do not save the workspace to an .Rdata file. When you launch, do not reload the workspace from an `.Rdata` file. Long-term reproducibility is enhanced when you turn this feature off and clear R's memory at every restart. Starting with a blank slate provides timely feedback that encourages the development of scripts that are complete and self-contained.

In RStudio, set this via **Tools** > **Global Options**, making sure to clear "Restore .RData into Workspace at Startup" and choosing **Never** on the "Save workspace to .RData on exit".

![](images/blank-slate.png){fig-alt="A screenshot of Tools > Global Options in RStudio. It highlights turning off the saving of workspace and restoration of .RData into workspace."}

### Hello RStudio Projects

RStudio projects make it straightforward to divide your work into multiple contexts, each with their own working directory, workspace, history, and source documents.

To create a new project in the RStudio, use the **File** \> **New Project** command.

In the **New Project** wizard that pops up, select **New Directory**, then **New Project**. Name the project "hello-ggplot2" and then click the **Create Project** button.

This will launch you into a new RStudio Project inside a new folder called "hello-ggplot2".

RStudio projects give you a solid workflow that will serve you well in the future:

-   Create an RStudio project for each data analysis project.

-   Keep data files there; we'll talk about loading them into R in [Local Data](../guide/data/data-local.html).

-   Keep scripts there; edit them, run them in bits or as a whole.

-   Save your outputs (plots and cleaned data) there.

Everything you need is in one place, and cleanly separated from all the other projects that you are working on.

## Hello `ggplot2`

The following section is adapted from the ["Data Visualization" chapter](https://r4ds.hadley.nz/data-visualize) of R for Data Science.

> R has several systems for making graphs, but `ggplot2` is one of the most elegant and most versatile.

Let's get started creating a basic graph with R via `ggplot2`.

-   Install the `ggplot2` R package by executing the below code via the R console

``` r
install.packages("ggplot2")
```

You only need to install a package once, but you need to load it with `library()` every time you start a new session.

-   In RStudio, create a new .R file and label it `ggplot2.R` via **File Menu** > **New File** > **R Script**

The `ggplot2.R` file you have just created will open in the **Source Pane**, which by default is in the top left.

Since you have already installed `ggplot2`, you can write the following code into the first line of your `ggplot2.R` script to load the `ggplot2` package for that session.

``` r
library(ggplot2)
```

The `library()` function will load a specific R package (`ggplot2`) so you can use the R functions within it. In the case of `ggplot2`, it contains many functions for creating useful and elegant graphs in R.

To execute that code in the R console, you can move your cursor to the specific line of code and either use the Run command in RStudio or the <kbd>`Ctrl + Enter`</kbd> (<kbd>`Cmd + Enter`</kbd> on Mac) shortcut.

### First Steps

Let's use our first graph to answer a question:

> Do cars with big engines use more fuel than cars with small engines?

We will be looking at the `mpg` data frame built into `ggplot2`. A data frame is a rectangular collection of variables (in the columns) and observations (in the rows). mpg contains observations collected by the US Environmental Protection Agency on 38 car models.

We can temporarily save this data frame object in R to our **Environments pane** by assigning it with the `<-` operator. Objects in the **Environment pane** are available for the duration of the current session, but are removed upon restarting R or RStudio.

As a beginning R user, it's OK to consider your environment (i.e. the objects listed in the environment pane) "real". However, in the long run, you'll be much better off if you consider your R scripts as "real". With your R scripts (and your data files), you can recreate the environment. It's much harder to recreate your R scripts from your environment!

``` r
# this will temporarily assign the mpg dataset 
# to the mpg object in our current session
mpg <- ggplot2::mpg
```

### Display the data

You can then display the first few rows of the `mpg` dataframe like so:

``` r
head(mpg)
```

```r
#> # A tibble: 6 × 11
#>   manufacturer model displ  year   cyl trans      drv     cty   hwy fl    class  
#>   <chr>        <chr> <dbl> <int> <int> <chr>      <chr> <int> <int> <chr> <chr>  
#> 1 audi         a4      1.8  1999     4 auto(l5)   f        18    29 p     compact
#> 2 audi         a4      1.8  1999     4 manual(m5) f        21    29 p     compact
#> 3 audi         a4      2    2008     4 manual(m6) f        20    31 p     compact
#> 4 audi         a4      2    2008     4 auto(av)   f        21    30 p     compact
#> 5 audi         a4      2.8  1999     6 auto(l5)   f        16    26 p     compact
#> 6 audi         a4      2.8  1999     6 manual(m5) f        18    26 p     compact
```

Among the variables in `mpg` are:

1.  `displ`, a car's engine size, in liters.

2.  `hwy`, a car's fuel efficiency on the highway, in miles per gallon (mpg). A car with a low fuel efficiency consumes more fuel than a car with a high fuel efficiency when they travel the same distance.

To get more of a spreadsheet "view" of the data, you can use the `View()` function:

``` r
View(mpg)
```

This will open up a new tab in the **Source pane** titled "mpg". You can explore the data here interactively. To get back to your "ggplot2.R" file, select the `ggplot2.R` tab in the **Source pane**.

![](images/mpg-view.png){fig-alt="A screenshot of the output of `View(mpg)` which creates a spreadsheet-like view of the mpg dataset."}

### Create a graph

Next, in your `ggplot2.R` file in the source pane, you can type the following code:

``` r
mpg_plot <- ggplot(data = mpg, mapping = aes(x = displ, y = hwy)) +
  geom_point(mapping = aes(colour = class)) +
  geom_smooth(method = "lm", formula = "y ~ x")
```

Again, you will want to execute that by either the Run command or shortcut (<kbd>`Ctrl + Enter`</kbd> or <kbd>`Cmd + Enter`</kbd> on Mac). Note that we are using the `<-` operator to assign this plot to the `mpg_plot` object.  The `mpg_plot` object will be visible in the top right **Environment Pane**.

![](images/get-started-environment.png){fig-alt="A screenshot of the Environments pane, showing the mpg and mpg_plot objects"}

### Print the graph

To print the graph in the **Output Pane**, we can add and then execute one more line of code:

``` r
mpg_plot
```

That will then display the plot into the **Output Pane** \> **Plots** tab.

![](images/basic-car-plot.png){fig-alt="A ggplot of fuel displacement on the x-axis and highway miles per gallon on the y-axis. There is a negative, roughly linear relationship between mpg and displacement, as fuel displacement increases, the highway mpg decreases. The points are colored by class of vehicle, where pickups and SUVs have larger engines and worse fuel-efficiency than subcompact, compact, or midsize vehicles."}

The plot shows a negative relationship between engine size (`displ`) and fuel efficiency (`hwy`). In other words, cars with smaller engine sizes have higher fuel efficiency and, in general, as engine size increases, fuel efficiency decreases. Does this confirm or refute your hypothesis about fuel efficiency and engine size?

### Save the graph

Lastly, we may want to save this image as proof of our hardwork! We can use `ggplot2` to save the image to disk with the below code *or* use the Export button in the **Plot Pane**.

``` r
ggsave("my-first-plot.png", plot = mpg_plot, height = 4, width = 6)
```

Now that the file has been saved to disk, we can find it by switching from the **Plot tab** to the **Files tab**, both of which are located by default in the **Output Pane**.

If you haven't already, you should also save your `ggplot2.R` file at this point. From the **Files Tab** you can find your saved `ggplot2` graph as "my-first-plot.png", and if you have saved your `ggplot2.R` script - it will also be in this same folder.

Remember - with your R scripts and data files you can recreate this temporary session environment! To prove our point, after you have saved your `ggplot2.R` file, restart your session with the RStudio menu: **Session \> Restart R**. Even in this fresh environment, you can recreate your plot by re-executing the source code with the same data!

## Closing

While this exercise may have seemed simple, we have learned quite a few things about RStudio:

There are 4 core panes for managing data analysis tasks

1.  The **Source Pane** is used to write longer scripts that can executed line-by-line or be saved to disk
2.  The **Console Pane** is used to execute short interactive code
3.  The **Environment Pane** is used to temporarily store session objects
4.  The **Output Pane** contains the **Plot tab** which display graphs, and the **Files tab** which lets you explore source code and output files.

To go deeper on learning about `ggplot2` and the rest of the `tidyverse` please see the R for Data Science textbook. R for Data Science is available in [print](https://www.oreilly.com/library/view/r-for-data/9781492097396/) or as a [freely available website](https://r4ds.hadley.nz/)

To learn more about the RStudio, please continue exploring this [User Guide](../guide/ui/ui-panes.qmd)!

---
title: "Simplified Interface"
date-meta: 2022-12-12
---

RStudio has many features and options to help you work the way that best suits your needs.

Some features discussed are specific to RStudio Desktop or RStudio Server: if RStudio is loaded in your web browser, then you are using RStudio Server; otherwise, you have RStudio Desktop.

For the purposes of this discussion, "RStudio Server" encompasses both RStudio Server Open Source and Posit Workbench (previously RStudio Workbench or RStudio Server Pro).

Email accessibility-related questions and comments to [accessibility\@posit.co](mailto:accessibility@posit.co).

## Zoom level

The size of text and other RStudio user-interface elements can be adjusted using the Zoom feature.

For RStudio Desktop, use the "Zoom In", "Zoom Out", or "Actual Size" commands on the View menu.

RStudio Server relies on your web browser's zooming features. Consult web browser help for more details.

-   [Google Chrome Zoom Documentation](https://support.google.com/chrome/answer/96810)

-   [Firefox Zoom Documentation](https://support.mozilla.org/en-US/kb/font-size-and-zoom-increase-size-of-web-pages)

-   [Safari on MacOS Zoom Documentation](https://support.apple.com/guide/safari/zoom-in-on-webpages-ibrw1068)

-   [Microsoft Edge Accessibility Features](https://support.microsoft.com/en-us/help/4000734/microsoft-edge-accessibility-features)

## Look and feel

You can change the look and feel of the RStudio user interface by choosing from three RStudio themes, and many editor themes. Use the Tools / Global Options / Appearance settings pane to experiment and find the look that works best for you.

Pebble-Safe is a colorblind-friendly theme created by Desi Quintans. It can be downloaded and installed from the [Pebble-Safe GitHub page](https://github.com/DesiQuintans/Pebble-safe).

More details on RStudio's theming features are in the [Using RStudio Themes article](../ui/appearance.html).

## Keyboard

Many RStudio features can be operated entirely with the keyboard. Using the keyboard can be an efficient way to get things done whether you are a keyboard-only user, or just prefer to reduce how often you have to reach for the mouse or touchpad.

### Keyboard shortcuts

RStudio has many keyboard shortcuts to trigger actions, move between areas of the user interface, and so on. Many of these can be discovered by browsing the main menu, hovering the mouse cursor over toolbar buttons, and viewing keyboard shortcut reference from the Help / Keyboard Shortcut Help menu.

Keyboard shortcuts may be customized using the Tools / Modify Keyboard Shortcuts menu. For more on this, see the [Customizing Keyboard Shortcuts article.](../productivity/custom-shortcuts.html)

Moving between RStudio's various tabs such as the Console and the Source Editor can be achieved using shortcuts such as Ctrl+1 to move to the editor tab, and Ctrl+2 to move to the Console. Many more such commands are found under the View menu.

The keyboard shortcuts available for manipulating text in the Source Editor will vary depending which editor keybindings are selected in Global Options / Code / Keybindings.

### Main menu

In RStudio Desktop, the main menu is operated via keyboard the same as the main menu in other applications on your operating system. For example, on Microsoft Windows, Alt+F will open the file menu.

RStudio Server, however, has slightly different shortcuts for activating its main menu items. As a starting point, on Windows and Linux, use Alt+Shift+F to activate the File menu, or Alt+Shift+H for the Help menu. On macOS, use Control+Option+F and Control+Option+H. Once a menu is open, use the left and right arrow keys to move between menus, and up and down arrows to navigate within the current menu, just like on RStudio Desktop.

A full list of Main Menu shortcuts is available in the Help / Keyboard Shortcuts reference, under the title "Main Menu (Server)".

If you wish to customize these shortcuts, they are named "Show File Menu", "Show Help Menu", and so on.

### Navigating dialog boxes

When a dialog box such as Global Options is opened, you can move around it using a combination of arrow keys and Tab and Shift+Tab. Generally the spacebar and/or Enter key can be used to "click" a button, just like other desktop applications.

## Reduced motion

Some aspects of RStudio's user interface use subtle motion or animations. There is an option to eliminate these via the **Tools** > **Global Options** > **Accessibility** > **Reduce User Interface Animations** checkbox.

## Simplify layout

RStudio's main window is quite visually complex. There is a menubar at the top, a toolbar, and up to four quadrants each potentially containing many different types of tabs which in turn contain RStudio's many features! Additionally, some features will open entirely new windows.

This can be overwhelming when first learning to use RStudio, and potentially distracting even if you are experienced with the product. Here are some things you can try.

### Hiding toolbar

If you are not going to use it, the main toolbar can be hidden via View / Hide Toolbar, and redisplayed with View / Show Toolbar.

### Zooming a region

A strategy you can employ is to "zoom" the region you are currently using. For example, View / Panes / Zoom Console will cause the Console to fill the entire RStudio Window. Note this is a different meaning of "Zoom" than was mentioned earlier in this document where it referred to changing the overall size of all elements in the window.

The keyboard shortcut for zooming a pane is often the same as for moving to the pane, plus the Shift key. So, Ctrl+Shift+2 will zoom the Console; use the same sequence to un-zoom the Console and restore the prior layout.

For mouse users, there are also widgets in the upper-right corner of each quadrant which can be used to maximize and minimize that particular quadrant.

Another strategy to employ is zooming a single column of the user interface. For example, in the default layout the Source Editor is in the top-left (assuming you have some files open) and the Console is below it. If you then use View / Panes / Zoom Left Column, those two panes will expand to fill the entire main window.

### Customizing pane layout

Another tool you can experiment with is customizing which quadrants contain certain tabs, as well as where each quadrant is displayed relative to the others. This is configured via View / Panes / Pane Layout dialog (also available within the Global Options dialog under Pane Layout).

The Source and Console quadrants are currently fixed in terms of what tab-types may appear in them. You can, however, configure the other two quadrants to hold specific tabs. The only limitation is that a quadrant must contain at least one tab, so it is not possible to completely eliminate one quadrant. Still, you can move the tabs you don't routinely use into one quadrant then minimize that quadrant, giving what is essentially a 3 panel layout.

## Accessibility options

The Global Options dialog contains a section dedicated to accessibility options. Options for reducing motion in the user interface, and for toggling the Tab key to always move focus, were mentioned earlier in this article. The rest of the options are specific to screen reader usage, and are discussed in the [section on RStudio Screen Reader support](screen-reader.html).

## Resources

Here are some additional resources related to RStudio accessibility, and accessibility of the R ecosystem.

-   [RStudio Blog: 1.3 Preview Accessibility](https://posit.co/blog/rstudio-1-3-preview-accessibility/)

-   [BlindRUG - Blind R Users Group](http://nfbnet.org/mailman/listinfo/blindrug_nfbnet.org)

-   [Statistical Software and Blind Users](https://r-resources.massey.ac.nz/StatSoftware/)

---
title: "Code Diagnostics"
date-meta: 2022-12-12
---

RStudio has the ability to perform static and dynamic analysis of R code or what is known as "Diagnostics". 
Diagnostics are a way to indicate stylistic issues or errors with the code.

## Enabling diagnostics

Diagnostics can be enabled and options can be set within the **Global Options** > **Code Diagnostics** editing pane:

![](images/enable-diagnostics.png){fig-alt="A screenshot of the RStudio Global Options popup, selected on the Code > Diagnostics tab."}

A brief outline of the options available:

### Show diagnostics for R

Toggle the display of R code diagnostics.

### Enable diagnostics within R function calls

Controls whether diagnostics are performed within function calls, e.g. `dplyr::select(mtcars, mpg, cyl)`. Toggle this if your code makes heavy use of non-standard evaluation, and RStudio is unable to produce correct diagnostics for you.

### Check arguments to R function calls

Try to detect whether a particular call to a function will succeed. The diagnostics engine will report if it detects missing arguments, unmatched arguments, partially matched arguments, and too many arguments.

For example, in the code sample below, RStudio detects that the function `add_numbers` is missing the `y` argument. It is not necessary for `add_numbers` to exist in the current environment (i.e., within the running R session).

![](images/argument-missing-error.png){fig-alt="A screenshot of the RStudio error diagnostics suggesting that a function argument is missing."}

Similarly, missing arguments (alongside extra, or missing, commas) are reported:

![](images/error-missing-comma.png){fig-alt="A screenshot of R code missing commas after each line, which returns an error 'exepcted , after expression'"}

### Warn if variable used has no definition in scope

Warn if a symbol is used with no definition in the current, or parent, scope. The diagnostics engine will supply a suggestion if there appears to be a typo in the symbol's name; that is, if a symbol with a similar name exists in scope as well.

![](images/error-missing-symbol.png){fig-alt="A screenshot of R code with a defined object not found, with a suggestion to use the correct object."}

### Warn if variable is defined but not used

This diagnostic helps to identify if a variable is created but never used. This can be helpful when attempting to clean up old code, or in diagnosing other errors (wherein you believe a particular variable should be used, but isn't).

In the following example, the variable `result` is assigned but never used or returned; instead, the sum is re-computed and then returned.

![](images/error-unused.png){fig-alt="A screenshot of a function where a defined object is not used, resulting a warning."}

### Provide R style diagnostics (e.g. whitespace)

The style diagnostic checks to see if your code conforms to [Hadley Wickham's style guide](http://adv-r.had.co.nz/Style.html), and reports style warnings when encountered. In particular, the diagnostics engine attempts to identify inappropriate use (or lack thereof) of whitespace.

![](images/warning-whitespace.png){alt="" fig-alt="A screenshot of x<-2+1 without any spacing - RStudio provides a note for the style issue expecting whitespace"}

Currently, the style diagnostics feature is not user configurable; this may be addressed in an upcoming release.

## Other diagnostics

Diagnostics for other languages, such as C / C++, JavaScript, and Python, are also available.

The C / C++ diagnostics engine is powered by `libclang`, and is able to report compiler errors and warnings inline in the source document.

## Viewing diagnostics

When an error or warning is discovered, it is reported in two places:

1.  The left gutter will show an icon related to the diagnostic's severity

2.  The associated diagnostic will be underlined.

![](images/error-diagnostic-view.png){fig-alt="A screenshot of R code displaying a yellow warning in the gutter, a popup for result is defined but not used, and a yellow underline bellow the defined but not used element."}

## Show diagnostics

These features allow you to control when diagnostics are presented and updated. Diagnostics can either be shown on save, or after a certain amount of keyboard idle time.

## Project-level diagnostics

You can run the diagnostics engine over all R files in the project either using the code wizard menu, or with the keyboard shortcut <kbd>Ctrl + Alt + Shift + D</kbd> (<kbd>Cmd + Alt + Shift + D</kbd> on Mac):

![](images/project-level-diagnostics.png){fig-alt="A screenshot of the 'Code Tools' dropdown, displaying the ability to 'Show Diagnostics' for an entire project."}

After running diagnostics over the project (this may take some time), you will see the `Markers` pane populated with all discovered warnings and errors.

![](images/project-diagnostics.png){fig-alt="A screenshot of the Markers for the addtwo.R file and other diagnostics across the project."}

## Magic comments

RStudio's diagnostics engine can be controlled on a per-file basis by adding magic comments to the document.

The following settings are currently supported:

`# !diagnostics off` \-- disable diagnostics within this document.

`# !diagnostics style=[true/false]` \-- toggle style diagnostics for this document.

`# !diagnostics level=[syntax/core/all]` \-- toggle the level, or severity, of diagnostics reported.

In addition, diagnostic warnings for particular variables can be suppressed with the suppress keyword:

`# !diagnostics suppress=<comma-separated list of variables>`

For example, in the below code snippet, the usage of `global_variable` is not reported, while the usage of `other_global_variable` is:

![](images/magic-comments.png){fig-alt="A screenshot of a magic '!diagnostics suppress' comment that prevents a warning from being displayed in RStudio."}

# Code suggestions: Copilot and NES

Read this when working on tests in `tests/panes/editor/code_suggestions.test.ts`,
`tests/panes/editor/edit_suggestions.test.ts`, or anything that exercises ghost
text, inline suggestions, or next-edit suggestions.

## Copilot ghost text

Ghost text renders as multiple DOM elements. Use `.first()` for visibility and
`.allTextContents()` to assemble the full text:

```typescript
const ghostText = page.locator('[class*=ace_ghost_text]');
await expect(ghostText.first()).toBeVisible({ timeout: 30000 });
const fullText = (await ghostText.allTextContents()).join('');

// After acceptance:
await expect(ghostText).toHaveCount(0, { timeout: 5000 });
```

Accept the suggestion with `ControlOrMeta+;`.

## NES (Next Edit Suggestions)

NES does **not** use `ace_ghost_text` and has a different UI. NES triggers
only from keyboard-driven edits; programmatic edits via
`rstudioapi::modifyRange()` do **not** trigger NES.

**Don't shortcut the trigger.** APIs like `.rs.api.showEditSuggestion` can
inject a NES widget directly, which makes the test pass mechanical
assertions but only exercises widget rendering -- not the actual trigger
flow the feature is supposed to test. Use a real keyboard-driven edit and
let NES surface organically.

| Element                            | Selector                                |
|------------------------------------|------------------------------------------|
| Suggestion highlight               | `.ace_next-edit-suggestion-highlight`    |
| Suggestion preview (read-only Ace) | `.ace_lineWidgetContainer .ace_content`  |
| Apply link                         | XPath: `//*[text()='Apply']`             |
| Discard link                       | XPath: `//*[text()='Discard']`           |

## Reaching into Ace from page.evaluate

Use `element.env.editor` to get the existing editor instance. **Never** call
`ace.edit(element)` -- it reinitializes the editor and breaks Copilot/NES.

## Scoping to the active editor tab

With multiple files open, generic selectors match all tabs. Scope to the
visible tabpanel:

```
//div[@role='tabpanel' and not(contains(@style, 'display: none'))]//*[starts-with(@id,'rstudio_source_text_editor')]//textarea[contains(@class,'ace_text-input')]
```

---
title: "R Package Repositories"
date-meta: 2022-12-12
---

R packages allow the R community to extend the base functionality provided in R with a rich set of packages available in package repositories.

CRAN, The Comprehensive R Archive Network, is the primary package repository in the R community. CRAN is a network of ftp and web servers around the world that store identical, up-to-date, versions of code and documentation for R.

## Primary repository

RStudio uses the RStudio CRAN mirror ([https://cran.rstudio.com](https://cran.rstudio.com/)) by default. This mirror is globally distributed using Amazon S3 storage so should provide good performance for all locales. If needed, override the default CRAN mirror from the **Tools** menu > **Global Options** > **Packages**:

![](images/primary-rstudio-repo.png){fig-alt="The RStudio Global options > Packages menu, highlighting RStudio's global CRAN mirror."}

Then, changing the "Primary CRAN repo" to a custom CRAN mirror or a custom package manager by providing its URL:

![](images/change-primary-repo.png){fig-alt="The menu for Choosing an alternative Primary Repository"}

For even easier way to organize and centralize packages across your team, department, or entire organization, you can configure RStudio with [Posit Package Manager](https://www.posit.co/products/package-manager/) or Posit's [free Public Package Manager](https://packagemanager.posit.co/client/#/repos/1/overview).

## Secondary repositories

While specifying the primary CRAN repo is sufficient in most cases, RStudio also allows specifying a secondary package management repository. This allows you to choose additional package repositories that can be made available in your organization with solutions like [Posit Package Manager](https://www.posit.co/products/package-manager/), [drat](https://cran.r-project.org/package=drat), [minicran](https://cran.r-project.org/package=miniCRAN), or [r-universe](https://ropensci.r-universe.dev/ui#packages). 

For instance, the [rOpenSci](https://ropensci.org/) project maintains a r-universe repository under <https://ropensci.r-universe.dev/> that could be easily added as a secondary repo from RStudio. Secondary repositories can be named and added using **Tools** > **Global Options** > **Packages** > **Add** then adding a named repository entry in the **Add Secondary Repository** popup as follows: 

![](images/ropensci-secondary.png){fig-alt="The Add Secondary Repository popup, showing adding ropensci from r-universe."}

When you press ok, RStudio will validate that the URL is hosting a valid CRAN-like repository. If it doesn't adhere to the correct directory structure, it will return an error: 

> The given URL does not appear to be a valid CRAN repository

Otherwise, it will succeed and move back to the previous **Packages** tab within **Global Options**.

Some package management solutions can also suggest package repos which, if available, will be listed while adding secondary repos as follows:

![](images/suggested-secondary-repos.png){fig-alt="The secondary repos menu with suggested secondary options."}

::: {.callout-tip}

Notice that the secondary repository's order is important since packages will be searched in priority. The order of the repositories can be changed by moving up/down their priority (see also the [repository options](https://stat.ethz.ch/R-manual/R-devel/library/base/html/options.html) for additional information on this topic):

![](images/secondary-repo-order.png){fig-alt="The Global options > Packages menu - and the option to Move up/down specific repos."}

:::

---
title: "GitHub Copilot"
date-meta: 2023-08-25
---

[GitHub Copilot](https://docs.github.com/en/copilot) is an "AI pair programmer that offers autocomplete-style suggestions as you code". GitHub Copilot is available as an opt-in integration with RStudio. To provide feedback or report bugs, please open a [GitHub Issue on the RStudio repository](https://github.com/rstudio/rstudio/issues).

## Prerequisites

-   To use GitHub Copilot, you must have a GitHub account and an active subscription to Copilot for Individuals or Copilot for Business. For more information, see [billing for GitHub Copilot](https://docs.github.com/en/billing/managing-billing-for-github-copilot/about-billing-for-github-copilot).
-   Students and faculty can use GitHub Copilot for free as part of the GitHub Education program. For more information, see the [GitHub Education page](https://education.github.com/).
-   To use GitHub Copilot in RStudio, you must have a compatible version of RStudio installed. GitHub Copilot is available for RStudio Desktop 2023.09.0 and later. GitHub Copilot is disabled by default in RStudio Server and Posit Workbench, but can be enabled by an administrator.
-   To use GitHub Copilot, you must have access to the internet in order to send requests to the Copilot APIs and receive suggestions from GitHub Copilot.

## Setup

::: {.callout-note title="Using GitHub Copilot with RStudio Server and Posit Workbench"}
With RStudio Server and Posit Workbench, GitHub Copilot must first be explicitly enabled by a system administrator. This can be done by adding the line:

```         
copilot-enabled=1
```

to `/etc/rstudio/rsession.conf`.
:::

To enable GitHub Copilot in RStudio:

1.  Navigate to Tools \> Global Options \> Assistant.\
2.  Select "GitHub Copilot" from the "Use code assistant" dropdown.\
3.  Download and install the Copilot Agent components.\
4.  Click the "Sign In" button.\
5.  In the "GitHub Copilot: Sign in" dialog, copy the Verification Code.\

![](images/copilot_sign-in.png){fig-alt="GitHub Copilot: Sign in"}

6.  Navigate to or click on the link to <https://github.com/login/device>, paste the Verification Code and click "Continue".\
7.  GitHub will request the necessary permissions for GitHub Copilot. To approve these permissions, click "Authorize GitHub Copilot Plugin".\
8.  After the permissions have been approved, your RStudio IDE will indicate the currently signed in user.\
9.  Close the Global Options dialogue, open a source file (`.R`, `.py`, `.qmd`, etc) and begin coding with Copilot!

To disable GitHub Copilot either:

-   Navigate to Tools \> Global Options \> Assistant and select a different option in the "Use code assistant" dropdown, or\
-   Use the Command Palette <kbd>Cmd+Shift+P</kbd> on Mac or <kbd>Ctrl+Shift+P</kbd> on Windows/Linux, search for "AI Assistant" and then select a different option.

### Using GitHub Copilot with Proxy Servers

If you are using RStudio in an environment with limited public internet access, you may need to first instruct the GitHub Copilot agent to use your enterprise's internal proxy server. For RStudio Server and Posit Workbench, this can be done by a system administrator, by setting:

```         
copilot-proxy-url=<url>
```

in `/etc/rstudio/rsession.conf`. Alternatively, for RStudio Desktop installations, you can set the environment variable:

```         
COPILOT_PROXY_URL=<url>
```

in an appropriate R start-up file; for example, your own `~/.Renviron`, or in your R installation's `etc/Rprofile.site` file. Please consult `?Startup` in an R session for more details.

### Using Custom Certificates with GitHub Copilot

If you are using RStudio in an environment with custom SSL certificates, you may need to first instruct the GitHub Copilot agent to use your enterprise's custom SSL certificates. For RStudio Server and Posit Workbench, this can be done by a system administrator, by setting:

```         
copilot-ssl-certificates-file=<path>
```

in your `/etc/rstudio/rsession.conf`. Note that this is functionally equivalent to setting the `NODE_EXTRA_CA_CERTS` environment variable for the GitHub Copilot agent process -- see https://nodejs.org/api/cli.html#node_extra_ca_certsfile for more details.

You can also enable **Tools > Global Options > Assistant > "Use the system certificate store"**. This works in all modes and is the recommended approach on RStudio Desktop, where `rsession.conf` is not available. When enabled, RStudio trusts the operating system certificate store (the Windows Certificate Store or macOS Keychain) in addition to Node.js's built-in certificate authorities, which is usually all that is needed behind a TLS-inspecting proxy whose root CA the machine already trusts. The setting applies to both the GitHub Copilot agent and the Posit Assistant. Restart the R session for the change to take effect.

This option is additive: it supplements `NODE_EXTRA_CA_CERTS` and `copilot-ssl-certificates-file` rather than replacing them. It requires the bundled Node.js (or any configured Node.js 22.17.0 or newer); with an older configured Node.js the option is ignored.

::: callout-warning
In some enterprise environments -- particularly certain SASE/ZTNA products such as Check Point Harmony -- the operating system trust store contains several CA certificates that share the same subject name but use different keys. The operating system tolerates this (it tries each name match until one verifies), but Node.js and OpenSSL select the first certificate matching the subject and may fail with `CERT_SIGNATURE_FAILURE` if that is not the right one. In such environments, enabling **"Use the system certificate store"** can prevent the assistant from connecting rather than help it; leave the option disabled.

Note also that the GitHub Copilot language server reads the operating system trust store on its own, independent of this setting and of `NODE_EXTRA_CA_CERTS`. Because `NODE_EXTRA_CA_CERTS` can only add certificates, supplying a clean single-CA PEM does not exclude conflicting duplicates that the language server picks up from the system store for GitHub Copilot. When duplicate same-subject certificates cause connection failures, the reliable fix is to remove the duplicate or invalid certificates from the operating system trust store.
:::

### External Services Used by GitHub Copilot

The GitHub Copilot agent process will communicate with the following external services when authenticating the current user, and also when generating code suggestions:

-   github.com
-   copilot-proxy.githubusercontent.com
-   api.githubcopilot.com
-   default.exp-tas.com

If you are having trouble setting up GitHub Copilot in an environment with limited public internet access, you may need to ensure that your network allows access to these services.

### Copilot Diagnostics

The GitHub Copilot agent used by RStudio can also generate a diagnostics report. This report is accessible from the Assistant preferences pane, using the `Diagnostics` button:

![](images/copilot-diagnostics-button.png){fig-alt="GitHub Copilot: Diagnostics button"}

After clicking this button, you will be presented with a small diagnostics report produced by the Copilot Agent. For example:

![](images/copilot-diagnostics-report.png){fig-alt="GitHub Copilot: Diagnostics report"}

This report may be useful when diagnosing Copilot connectivity issues.

## Using Copilot

Copilot offers autocomplete-style suggestions as you code as "ghost text". This ghost-text is similar to the existing autocomplete available in RStudio but importantly is a generated suggestion rather than an exact auto-completion.

![](images/copilot-rstudio.png){fig-alt="Copilot in RStudio"}

1.  A simple but specific comment providing additional context to Copilot.
2.  Copilot's code suggestion, shown in light grey "ghost text".
3.  The Copilot status bar, which indicates whether RStudio is waiting on a response to be generated, a completion response has been received, or no completions are available.

GitHub Copilot primarily relies on the context in the file you are actively editing. Any comments, code, or other context provided within the active document will be used as a "prompt" that Copilot will then use to provide a suggested completion. To expand the scope of the context used by Copilot beyond just the active document, there is a setting to also index and read from other [supported files](#language-support) in the current project. This setting can be toggled on or off in the Tools \> Global Options \> Copilot \> "Index project files with GitHub Copilot" setting.

For general advice on how to use Copilot, please see:

-   [How to use GitHub Copilot: Prompts, tips, and use cases](https://github.blog/2023-06-20-how-to-write-better-prompts-for-github-copilot/)\
-   [Learning GitHub Copilot video series](https://learn.microsoft.com/en-us/shows/introduction-to-github-copilot/)

::: {.callout-warning title="Trust but Verify"}
While Copilot often generates useful and functional code, it is important to note that the suggestions are not always valid code examples or completely solve the intended problem. Copilot suggestions are non-deterministic and Posit does not guarantee the quality, accuracy, or security of the outputs. It is important to review the suggestions and ensure that they are both accurate and appropriate for the intended use case. Copilot may generate code that contains insecure coding patterns, bugs, or outdated practices. You should always use best practices in code review, testing, and adherence to security standards when using Copilot. For more information, see the [FAQs on GitHub Copilot](https://github.com/features/copilot#faq) and [GitHub Copilot for Business](https://docs.github.com/en/copilot/overview-of-github-copilot/about-github-copilot-for-business).
:::

### Autocomplete vs Copilot

The existing autocomplete in RStudio is a static list of possible completions based on the session state. Copilot is a dynamic predicted suggestion that is generated based on the document and project context, including comments, code elsewhere in the document or project, and the currently focused characters. Copilot will also provide suggestions for code that is not currently in the active document.

Similar to normal autocomplete, Copilot suggestions will begin after a short delay. If you want to prompt Copilot directly in a new file, you can start typing a descriptive variable or function name and then pause for a moment. Copilot will then generate a suggestion based on the current context.

At times, normal autocomplete and Copilot may seem to conflict with each other. In these cases, it is best to review the Copilot suggestion and determine if it is appropriate for the current context. If it is, you can accept the suggestion by pressing <kbd>Tab</kbd>. If it is not, you can ignore the suggestion and continue typing or force the normal autocomplete to show by pressing <kbd>Ctrl+Space</kbd>. You can also toggle Copilot on and off for a particular document using the `Copilot: Toggle Automatic Completions` command, accessible from the Command Palette via <kbd>Ctrl+Shift+P</kbd>.

You can also disable the "Show code completions: Automatically" setting in the Tools \> Global Options \> Code \> Completion section.

![](images/autocomplete-settings.png){fig-alt="Autocomplete settings in RStudio"}

### Code

The primary use case for Copilot is to generate code. Copilot will use the context of the active document to generate suggestions for code that might be useful.

Copilot suggestions will be presented as grey "ghost text" which may be accepted by pressing the <kbd>Tab</kbd>, while the <kbd>Enter/Return</kbd> key will ignore the suggestion. Some suggestions will be a single entire line, inline of other code, or others with broader context may span multiple lines.

![](images/copilot_ghost-text.png){fig-alt="Copilot ghost text"}

Code suggestions are typically most useful when applied to a well-scoped and specific problem. When trying to solve larger problems or write longer functions, it is best to break the problem down into smaller pieces and use Copilot and your own expertise to generate code for each chunk. Similar to how a chef might use a recipe to cook each dish that makes up a larger meal, Copilot can be used to generate code for smaller pieces of a larger problem.

::: {.callout-info title="Copilot response limits"}
There are upper limits to the amount of characters or code that can be returned at any one time, commonly referred to as "tokens". If the token limit is exceeded on a suggestion, Copilot will usually return a truncated suggestion. This is most common when Copilot is used to generate code for a long function or other multi-line code block. To avoid truncated outputs, it is best to scope the problem down into several smaller prompts or problems. Alternatively, after accepting the "partial" response, you could finish writing the rest of the code yourself or add additional inline comments to prompt Copilot to suggest additional outputs to complete the remainder of the code snippet.
:::

### Questions

While Copilot is primarily intended to generate code, it can also be used to directly answer simple questions. To specifically ask a question of Copilot, use a comment with a `# q:` at the beginning and a question mark at the end. Copilot's completion should be an "answer" comment `# a:`.

For example, the below:

``` r
# q: What is the definition of standard error?
```

Might generate an answer like:

``` r
# q: What is the definition of standard error?
# a: The standard error is the standard deviation of the sampling distribution of a statistic.
```

::: {.callout-note title="Chat interfaces"}
Copilot is most effective when used to generate code, so it is best to use purpose-built generative AI interfaces for chat, such as the [`{chattr}` R package](https://mlverse.github.io/chattr/) which is an R interface to local or remote LLMs (Large Language Models). `{chattr}` includes a RStudio add-in as well as a built in app for interacting with LLMs via RStudio's Viewer Pane.
:::

### Comments

When using Copilot to solve a broad problem, it is a good idea to provide a high-level goal at the beginning of the file. This will help Copilot provide suggestions that are relevant to the specific problem you are trying to solve.

``` r
# This script will do x
# using the packages x,y,z
# other constraints or details
```

A real example might be:

``` r
# Create a robust function to calculate the standard error of a vector
# The function name will be calc_se with an argument x for the vector, with 
# an argument to remove missing values called na.rm, and a default value of TRUE
# The function should have type checking to only allow numeric vectors
```

Which might generate something like the below:

``` r
calc_se <- function(x, na.rm = TRUE) {
  if (!is.numeric(x)) {
    stop("x must be numeric")
  }
  if (na.rm) {
    x <- x[!is.na(x)]
  }
  sqrt(var(x) / length(x))
}
```

Which generated a working example!

``` r
calc_se(1:10)
#> [1] 0.9574

# note the function also properly indicates the need for a numeric input
calc_se(letters)
#> Error in calc_se(letters) : x must be numeric
```

For smaller problems or to provide context or guidance within a function or code block, comments can be used to provide a basic prompt for Copilot.

Comments in code such as:

``` r
# create a function that takes a number and returns the square
```

Might be used by Copilot to suggest a function that takes a number and returns the square:

``` r
# create a function that takes a number and returns the square
square_number <- function(x) {
  x^2
}
```

Lastly, comments can be used inline within code to provide additional context or guidance to Copilot. For example:

``` r
library(dplyr)

mtcars |> 
   group_by(cyl) |> 
   summarize(
      mean = mean(mpg),
      # add the standard error for mpg
   )
```

Might return:

``` r
mtcars |> 
   group_by(cyl) |> 
   summarize(
      mean = mean(mpg),
      # add the standard error for mpg
      se = sd(mpg) / sqrt(n())
   )
```

However, the comment may not be needed if a descriptive column name is used instead.

![](images/copilot_se-inline.png){fig-alt="Copilot inline completion"}

### Language support {#language-support}

While R is the primary expected language for RStudio users, Copilot also supports other languages. Copilot will use the file extension or other context to determine the language of the active document. In multi-language Quarto documents for example, Copilot could use the active language within a code chunk or the body of the document to generate suggestions.

Languages supported by Copilot include:

- C
- C++
- CSS
- HTML
- Java
- JavaScript
- LaTeX
- Markdown
- Python
- Quarto
- R
- R Markdown
- SQL
- TypeScript
- XML
- YAML

Comments in other languages can be used to generate suggestions in the active document. For example, a HTML comment (`<!-- COMMENT BODY -->`) might be used in the body of a `.qmd` file:

``` html
<!-- Using HTML and JavaScript return a clickable counter that is displayed -->
<!-- there should also be a button to reset the counter to zero -->
```

Where the above HTML comment might generate the below HTML and JavaScript:

``` html
<!-- Using HTML and JavaScript return a clickable counter that is displayed -->
<!-- there should also be a button to reset the counter to zero -->
<html>
<body>
<script>
var count = 0;
function countClicks() {
  count += 1;
  document.getElementById("clicks").innerHTML = count;
}
function resetClicks() {
  count = 0;
  document.getElementById("clicks").innerHTML = count;
}
</script>
<p>Click the button to count clicks.</p>
<button type="button" onclick="countClicks()">Click Me!</button>
<button type="button" onclick="resetClicks()">Reset</button>
<p>Clicks: <a id="clicks">0</a></p>
</body>
</html>
```

![](images/copilot_javascript.png){fig-alt="Copilot HTML and JavaScript completions"}

## Support and Terms of Service

Posit does not provide support or assistance for any code written or generated in RStudio, with or without Copilot. Posit does not support the Copilot output, or test the logic used by Copilot to generate code from prompts.

GitHub Copilot is a proprietary tool from GitHub. If you want to use GitHub Copilot, you need a [subscription for GitHub Copilot](https://docs.github.com/en/billing/managing-billing-for-github-copilot/about-billing-for-github-copilot) in your personal GitHub account or to be assigned a seat by an organization with a subscription for GitHub Copilot for Business. Individual snippets of source code or the contents of entire files may be sent to GitHub's servers to generate suggestions, for more information about how this information is handled, please see the [Copilot Privacy Statement](https://docs.github.com/en/site-policy/privacy-policies/github-general-privacy-statement#personal-data-we-collect).

Students and faculty can use GitHub Copilot for free as part of the GitHub Education program. For more information, see the [GitHub Education page](https://education.github.com/).

By using GitHub Copilot, you acknowledge that your use of GitHub Copilot is governed by their terms of service and you agree to abide by their [terms of service](https://docs.github.com/en/site-policy/github-terms/github-terms-for-additional-products-and-features#github-copilot). GitHub Copilot is considered "Third Party Materials" as defined in the [RStudio End User License Agreement](https://posit.co/about/eula/) and Posit assumes no liability or other obligations with respect thereto and, without limiting the foregoing, is not liable for any loss or damage resulting from the use or access thereof.

---
title: "RStudio Desktop will not start"
date-meta: 2025-01-07
---

Below is a list of common start-up problems. If one of the following does not describe your problem, see [Other start-up issues] for next steps.

## Check the version of R

RStudio requires R version 3.6.0, or higher, to run. Ensure your current installation meets this requirement. If not, please download and install R from [https://cran.r-project.org](https://cran.r-project.org).

On Windows, if you have multiple versions of R installed, you can press and hold Ctrl when starting RStudio to select your version of R.

## Check for Startup files

The R code within these files may be causing an error. So, try removing all startup files such as `.Rprofile`, `.Renviron`, and `.RData` from your initial working directory. If RStudio successfully starts after removing these files, try to pinpoint which file resulted in the error. If you are able to determine the source of the problem, please notify Support with the details. Be sure to include the steps to reproduce this error (including necessary code).

## RStudio cannot find R

If you installed R to a non-default location, it is possible RStudio cannot find R on your machine. Open a standard console session and type the following command at the console:

```R
> Sys.which("R")
```

The displayed location must be in your search path for RStudio to successfully bind to your R installation.

On Windows, you can force RStudio to bind to a specific version of R by pressing and holding Ctrl when starting RStudio.

## Check firewall, proxy settings, and antimalware

Although RStudio does not require internet access, it does use a localhost connection to link your R session with the RStudio IDE. As a result, it is possible a (software-based) firewall, network setting, or antimalware program is blocking access to RStudio. If you have a firewall, HTTP or HTTPS proxy configured, add `localhost` and `127.0.0.1` to the list of approved hosts and domains. Then, restart RStudio. If you have antimalware software configured that may be blocking RStudio, please check its settings and allow-list RStudio, if necessary.

## Check the permissions on the ~/.rstudio-desktop directory

RStudio saves some session files in the `~/.rstudio-desktop` directory. If this directory has its permissions changed, RStudio may not have read and write access for that folder and may fail to start. Check the permissions and make sure the folder has read, write, and execute permissions. If not, change the permissions or reset RStudio's state as described below.

## Reset RStudio's state

In some cases, it is necessary to reset RStudio's state analogous to a fresh installation. To do this, see the [Resetting RStudio's State](resetting-state.qmd).

# Other start-up issues

If you are unable to start RStudio and are using the open-source version, please open a new topic in [https://forum.posit.co](https://forum.posit.co) and provide any relevant details as noted below.

## System information

Upload a [diagnostic report](diagnostic-report.qmd) and the output from the associated terminal session to a service like Gist and include the link.

## Error information

- General description
- The version of RStudio you are trying to launch
- Error messages
- [Log files](logs.qmd)
- Attempted steps taken to fix
- Have you successfully launched RStudio in the past?

# Chat pane / Posit Assistant patterns

Read this when working on tests in `tests/panes/posit-assistant-chat/` or
anything that intercepts rsession RPCs via `page.route()` in the Electron
CDP context.

## RPC interception (page.route in Electron CDP)

- **Verify the contract before mocking.** Field names in a casual prompt may
  not match the real RPC. Check `actions/<feature>.actions.ts` (the wrapper
  that uses the response) and `src/cpp/session/modules/SessionXxx.cpp` (the
  handler) to confirm the actual field names. A sibling test that already
  mocks the same RPC is also a good reference.
- **Regex, not glob.** `page.route(/\/rpc\/method_name/, ...)` handles query
  strings; `**/rpc/method_name` may not.
- **Never `route.fetch()` in Electron CDP** -- it returns empty bodies from
  rsession. Use `route.fulfill()` directly with the JSON-RPC envelope:

  ```typescript
  await route.fulfill({
    status: 200,
    contentType: 'application/json',
    body: JSON.stringify({ result: mockPayload }),
  });
  ```

- RPC URL pattern: `http://127.0.0.1:<port>/rpc/<method_name>`.

## Chat-pane specifics

- **The `chatCheckForUpdates` cache.** The frontend fires it once at startup;
  toggling the chat provider preference does NOT re-trigger it. To force a
  fresh check, post `retry-manifest` *from inside the chat iframe*:

  ```typescript
  await chatPane.frame.locator('body').evaluate(() => {
    window.parent.postMessage('retry-manifest', '*');
  });
  ```

  ChatPresenter filters by `event.source`, so `window.postMessage(...)` from
  the main page is silently ignored.

- **A running PAI backend overwrites blocking pages.** `loadUrl()` reloads
  `ai-chat/index.html` on top of GWT's blocking-HTML write. For blocking-state
  tests, inject the HTML directly via `page.evaluate()` after verifying the
  RPC interception fired.

- **The Options dialog has its own install/update flow** that bypasses RPC
  interception. When you need to control the RPC response, write the
  preference directly via the `window.rstudio` bridge:

  ```typescript
  import { setPref } from '@utils/commands';
  await setPref(page, 'chat_provider', 'posit');
  ```

---
title: "Managing Files"
date-meta: 2022-12-12
---

RStudio supports syntax highlighting and other specialized code-editing features for specific file types:

-   Scripts in R, Python, SQL  
-   Computational and scientific documents in Quarto, R Markdown, and TeX  
-   Web content such as HTML and CSS  
-   and many more  

## File Menu

You can create a new file via the **File -\> New File** menu:

![](images/system-files-menu.png){fig-alt="A screenshot of the File Menu drop-down which has features like New File, Open File, Save File."}

An alternative workflow is to use the visual elements in the RStudio menu.

![](images/files-menu.png){fig-alt="A screenshot of the New File drop-down in RStudio, which provides new R, Python, Quarto, Rmarkdown, Shiny or Plumber files."}

To open an existing file, use either the **File -\> Open File\...** menu or the **Recent Files** menu to select from recently opened files.

## Files tab

The **Output** pane has a **Files** tab that includes several buttons for managing files within the currently selected folder, including the **New Blank File** drop-down, **Delete** button, and the **Rename** button. These buttons will operate on files that are selected within the **Files tab**.

![](images/file-pane-blank-file.png){fig-alt="A screenshot of the create blank file drop-down."}
The **More** drop-down contains a number of other useful features:  

- Copy or Move selected file(s) to a new location
- Open selected file(s) in **Source** pane or new columns
- Modify or navigate to the working directory
- Open a new terminal from the displayed folder
- Open the displayed folder in a new pop-out window
- Show hidden files


![](images/files-more.png){fig-alt="A screenshot of the Files tab in RStudio, with the More drop-down opened to display the possible options as expanded on above."}

### Existing files

To open existing files from the **Files** tab, use the **Files** tab to navigate to the folder that contains your file. Then click on the file of interest to open it in the **Source** pane of RStudio.

To modify existing files from the **Files** tab, select the checkbox next the file(s) of interest, then use the UI elements such as **Delete** or **More** > **Move...**.

### Display hidden files

RStudio’s **Files** tab by default shows only a selection of commonly needed hidden files, such as the .Rprofile. To instead show all of the hidden files, in the **Files** pane, click the **More** drop-down, then check **Show Hidden Files**.

![](images/more-show-hidden-files.png){fig-alt="The Files pane, showing the More drop-down and the Show Hidden Files check. A number of dot files such as .gitignore and folders such as .git, .Rproj.user, etc are displayed now."}

## Switching files

If several files are opened within RStudio, then they are all available as tabs within the **Source** pane to facilitate quick switching between open documents.

Use the <kbd>Ctrl+Tab</kbd> and <kbd>Ctrl+Shift+Tab</kbd> shortcuts on desktop (<kbd>Ctrl+F12</kbd> and <kbd>Ctrl+F11</kbd> on Linux) to quickly move to the next or previous tabs, respectively.

If there are a large number of open documents, navigate between them using the "**\>\>"** icon at the end of the tab bar (<kbd>Ctrl+Shift+.</kbd> shortcut or the **View -\> Switch to Tab\...** menu item). The **Switch to Tab...** provides a filtering search for all of the tabs in that **Source** pane:

![](images/file-switch.png){fig-alt="A screenshot of the Switching Files popup - it is a drop-down from the end of the Source pane, displayed as >>." width="500"}

To quickly navigate to any existing file in the current RStudio Project, even if it is not currently open, use the <kbd>Ctrl + .</kbd> shortcut. Entering the shortcut will bring up the **Go to File/Function** search bar with auto-completion of file names.

![](images/go-to-file.png){fig-alt="A screenshot of the go to file/function popup as a search bar." fig-align="center" width="450"}

---
title: "Visual Editor"
date-meta: 2022-12-12
---

The Quarto visual editor provides a [WYSIWYM](https://en.wikipedia.org/wiki/WYSIWYM) editing interface for all of Pandoc markdown, including tables, citations, cross-references, footnotes, divs/spans, definition lists, attributes, raw HTML/TeX, and more. The visual editor also includes support for executing code cells and viewing their output inline:

![](images/visual-editing.png){fig-alt="An R Markdown file opened in the RStudio visual editor. The page is titled 'Filter joins'. Underneath is a table containing R syntax, mathematical notation, and definitions for the semi- and anti-joins. Underneath this table is an R code chunk that displays a graphical representation of a semi-join."}

The visual editor doesn't attempt to abstract away or obscure the underlying markdown document. Rather, it aims to provide a highly productive writing interface for people that love markdown. Most markdown constructs (e.g., `#` or `**bold**`) can be used directly for formatting.

### Switching Modes

Markdown documents can be edited in either source or visual mode. To switch into visual mode for a given document, use the Source or Visual button at the top-left of the document toolbar (or alternatively the <kbd>Ctrl+Shift+F4</kbd>/<kbd>Cmd+Shift+F4</kbd> F4 keyboard shortcut):

![](images/visual-editing-switch-modes.png){fig-alt="A snippet of an RStudio window showing the options bar at the top of a Quarto document."}

It's possible to switch between source and visual mode at any time (editing location and undo/redo state will be preserved when you switch).

## Using the Editor

### Keyboard Shortcuts

There are keyboard shortcuts for all basic editing tasks. Visual mode supports both traditional keyboard shortcuts (e.g. <kbd>Ctrl + B</kbd> or <kbd>Cmd + B</kbd> for bold) as well as markdown shortcuts (using markdown syntax directly). For example, enclose `**bold**` text in asterisks or type `##` and press space to create a second level heading. Here are some of the most commonly used shortcuts:

| Command      | Keyboard Shortcut | Markdown Shortcut |
|--------------|:-----------------:|:-----------------:|
| Bold         |        ⌘ B        |    `**bold**`     |
| Italic       |        ⌘ I        |    `*italic*`     |
| Code         |        ⌘ D        |   `` `code` ``    |
| Link         |        ⌘ K        |     `<href>`      |
| Heading 1    |       ⌥⌘ 1        |        `#`        |
| Heading 2    |       ⌥⌘ 2        |       `##`        |
| Heading 3    |       ⌥⌘ 3        |       `###`       |
| R Code Chunk |       ⌥⌘ I        | ```` ```{r} ````  |

See the [editing shortcuts](https://quarto.org/docs/visual-editor/options.html#shortcuts) article for a complete list of all shortcuts.

### Insert Anything

You can also use the catch-all <kbd>Cmd+/</kbd>/<kbd>Ctrl+/</kbd> shortcut to insert just about anything. Just execute the shortcut then type what you want to insert. For example:

![](images/visual-editing-omni-list.png){fig-alt="There is a line of text (with a cursor at the end) where someone has typed '/lis'. There is a drop-down menu underneath this with options for 'Bullet List', 'Numbered List', and 'Definition List' arranged vertically. The title of each item is bolded, has a small icon to the left, and a small description in lighter gray text underneath it."}

![](images/visual-editing-omni-math.png){fig-alt="There is a line of text (with a cursor at the end) where someone has typed '/ma'. There is a drop-down menu underneath this with options for 'Inline Math', 'Display Math', and 'Image...' arranged vertically. The title of each item is bolded, has a small icon to the left, and a small description in lighter gray text underneath it."}

If you are at the beginning of a line (as displayed above), you can also enter plain `/` to invoke the shortcut.

### Editor Toolbar

The editor toolbar includes buttons for the most commonly used formatting commands:

![](images/visual-editing-toolbar.png){fig-alt="A snippet of an RStudio window showing the options bar at the top of an R Markdown document."}

Additional commands are available on the **Format**, **Insert**, and **Table** menus:

| Format                                                                                           | Insert                                                                                           | Table                                                                                          |
|--------------------------------------------------------------------------------------------------|--------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------|
| ![](images/visual-editing-format-menu.png){fig-alt="The contents of the Format drop down menu."} | ![](images/visual-editing-insert-menu.png){fig-alt="The contents of the Insert drop down menu."} | ![](images/visual-editing-table-menu.png){fig-alt="The contents of the Table drop down menu."} |

## Learning More

See the following resources on <https://quarto.org/> to learn more about visual markdown editing:

-   [Technical Writing](https://quarto.org/docs/visual-editor/technical.html) covers features commonly used in scientific and technical writing, including citations, cross-references, footnotes, equations, embedded code, and LaTeX.

-   [Content Editing](https://quarto.org/docs/visual-editor/content.html) provides more depth on visual editor support for tables, lists, pandoc attributes, CSS styles, comments, symbols/emojis, etc.

-   [Shortcuts & Options](https://quarto.org/docs/visual-editor/options.html) documents the two types of shortcuts you can use with the editor: standard keyboard shortcuts and markdown shortcuts and describes various options for configuring the editor.

-   [Markdown Output](https://quarto.org/docs/visual-editor/markdown.html) describes how the visual editor parses and writes markdown and describes various ways you can customize this.

---
title: "R Console"
date-meta: 2022-12-12
---

The **Console** in RStudio includes a variety of features intended to make interactively working with code more productive and straightforward. This documentation reviews these features. Learning to use these features along with the related features available in the [Source](execution.html) pane can have a substantial payoff in your overall productivity.

## Code completion

RStudio supports the automatic completion of code using the <kbd>Tab</kbd> key. For example, if an object named `pollResults` exists in the workspace, typing `poll` in the R console and then pressing the <kbd>Tab</kbd> key automatically completes the full name of the object. 

The code completion feature also provides inline help for functions whenever possible. For example, typing `med` and then pressing **Tab** would result in a popup of possible auto-completion:

![](images/console-completion.png){fig-alt="A screenshot of the RStudio console displaying tab-completion of the median function."}

Code completion also works for function arguments, so typing `median(` and then pressing **Tab** will result in the possible arguments being displayed:

![](images/console-completion-args.png){fig-alt="Code completion of variables within the median function, displaying the 'x', 'na.rm' and '...' function arguments."}

## Retrieving previous commands

As with the standard R console, the RStudio console supports the ability to recall previous commands using the arrow keys:

-   **Up** --- Recall previous command(s)

-   **Down** --- Reverse of Up

To reuse recently executed commands, use the <kbd>Ctrl+Up</kbd> shortcut to review the list (on Mac <kbd>Command-Up</kbd>) and then select a command from this list by pressing <kbd>Enter</kbd>:

![](images/retrieve-console-commands.png){fig-alt="A screenshot of the history of commands executed in the RStudio console."}

The same keyboard shortcut can quickly search for commands that match a given prefix. For example, to search for previous instances of the `glimpse` function start typing `glimpse` and then press <kbd>Ctrl+Up</kbd>  (on Mac <kbd>Cmd+Up</kbd>):

![](images/previous-commands.png){fig-alt="A screenshot of the R console in RStudio, showing a filtered list of executed commands that match 'glimpse'"}

## Find in Console

RStudio provides a Find bar for searching through Console output. This is useful for locating specific results, error messages, or any text that has been printed to the Console.

To open the Find bar, press <kbd>Ctrl+F</kbd> (<kbd>Cmd+F</kbd> on macOS) while the Console pane is focused, or click the magnifying glass icon in the Console toolbar. A search bar will appear at the top of the Console pane where you can type your search term.

The Find bar supports the following features:

- **Case-sensitive search** --- Toggle case sensitivity to match text exactly as typed.
- **Navigate matches** --- Use the arrow buttons or press <kbd>Enter</kbd> to move to the next match, and <kbd>Shift+Enter</kbd> to move to the previous match.
- **Close the Find bar** --- Press <kbd>Esc</kbd> to close the Find bar and return focus to the Console.

## Console title bar

The screenshot below illustrates a few additional capabilities provided by the Console title bar:

-   Display of the current version of R and working directory.

-   The ability to interrupt R during a long computation.

-   Minimizing and maximizing the Console in relation to the Source pane (using the buttons at the top-right or by double-clicking the title bar).

- There are two additional tabs **Terminal** and **Background Jobs** which are covered in the [Terminal](../tools/terminal.html) and [Background Jobs](../tools/jobs.html) sections of the User Guide.

![](images/console-buttons.png){fig-alt="A screenshot of R console menu bar, showing the red 'stopsign' indicating the ability to stop the currently executed R code"}

## Keyboard shortcuts

Beyond the history and code-completion oriented keyboard shortcuts described above, there are a wide variety of other shortcuts available. Some of the more useful shortcuts include:

-   <kbd>Ctrl+1</kbd> --- Move focus to the Source Editor

-   <kbd>Ctrl+2</kbd> --- Move focus to the Console

-   <kbd>Ctrl+F</kbd> --- Open the [Find bar](#find-in-console) to search Console output

-   <kbd>Ctrl+L</kbd> --- Clear the Console

-   <kbd>Esc</kbd> --- Interrupt R

-   <kbd>Ctrl+Shift+F10</kbd> or <kbd>Cmd+Shift+F10</kbd> (Mac) - Restart R

-   <kbd>Ctrl+Up</kbd> or <kbd>Command-Up</kbd> on Mac --- Display recently executed commands from the console

For a full list of shortcuts, see the [Shortcuts reference page](../../reference/shortcuts.qmd).

---
title: "Writing Packages"
date-meta: 2022-12-12
---

R packages are an ideal way to package and distribute R code and data for re-use by others. RStudio includes a variety of tools that make developing R packages easier and more productive, including:

-   **Build** pane with package development commands and a view of build output and errors

-   **Clean and Install** command that rebuilds the package and reloads it in a fresh R session.

-   R documentation tools including previewing, spell-checking, and [Roxygen](https://roxygen2.r-lib.org/) aware editing.

-   Integration with [devtools](https://devtools.r-lib.org/) package development functions.

-   Support for [Rcpp](http://dirk.eddelbuettel.com/code/rcpp.html) including syntax highlighting for C/C++ and gcc error navigation.

## Getting started

The following documentation covers fundamental R package development workflows inside RStudio. The [R packages book](https://r-pkgs.org/) provides a deeper overview of general R package development strategies.

::: {.callout-tip}

The [**Command Palette**](../ui/command-palette.html), accessed by <kbd>Ctrl+Shift+P</kbd>, can also execute `devtools`, `usethis`, or Package Development specific commands:

![](images/command-palette-pkgs.png){fig-alt="The Command Palette filtered down to package development specific commands."}

:::

### Package creation

Once you've come up with a name, there are two ways to create the package.

-   Call [`usethis::create_package()`](https://usethis.r-lib.org/reference/create_package.html).

-   In RStudio, do **File** \> **New Project** \> **New Directory** \> **R Package**. This ultimately calls [`usethis::create_package()`](https://usethis.r-lib.org/reference/create_package.html), so really there's just one way.

### Package development basics

If you aren't already familiar with the basics of R package development, the following links provide additional documentation and tutorials:

-   [Writing R Extensions](https://rstudio.github.io/r-manuals/)

-   [R Packages (Hadley Wickham)](https://r-pkgs.org/)

### Software prerequisites

There are two main prerequisites for building R packages:

1.  GNU software development tools including a C/C++ compiler; and

2.  LaTeX for building R manuals and vignettes.

To easily build and document robust R packages, you will also need the following R packages:

``` r
install.packages(c("devtools", "roxygen2", "testthat", "knitr"))
```

If you don't already have these tools installed on your system, please consult the "R Packages" chapter on [R build toolchain](https://r-pkgs.org/Setup.html#setup-tools) for additional details on how to install these dependencies.

### Creating a new package

To create a new package, use the **Create Project** command (available on the **Projects** menu and on the global toolbar) and select the **New Directory** option. Then on the following screen specify the project type as **R Package**:

![](images/create-r-pkg.png){fig-alt="A screenshot of the New Project Wizard"}

::: callout-tip

## Using existing R scripts

If you have existing R scripts that you'd like to use as the basis for the new package, you can specify them here and they'll be included in the new package.

:::

### Working with an existing package

To enable RStudio's package development tools for an existing package do the following:

1.  Create a new [RStudio Project](../code/projects.html) associated with the package's directory.

2.  If the package `DESCRIPTION` file is located either in the project's root directory or at `pkg/DESCRIPTION`, then it will be automatically discovered.

3.  Alternatively, navigate to **Tools** \> **Project Options** \> **Build Tools**, select "Package" as the project build tools type, and then specify the the subdirectory containing the package's `DESCRIPTION` file.

## Building a package

To build the completed package in RStudio, use the **Build** pane, which includes a variety of tools for building and testing packages. While iteratively developing a package in RStudio, you typically use the **Install** > **Clean and Install** command or call **Clean and Install** from the Command Palette to re-build the package and reinstall it in a fresh R session:

![](images/build-reload-pkg.png){fig-alt="The build pane in RStudio, showing the output of a 'Clean and Install' command."}

The **Clean and Install** command performs several steps in sequence to ensure a clean and correct result:

1.  Unloads any existing version of the package (including shared libraries if necessary).

2.  Builds and installs the package using `R CMD INSTALL`.

3.  Restarts the underlying R session to ensure a clean environment for re-loading the package.

4.  Reloads the package in the new R session by executing the `library` function.

You can also execute **Clean and Install** using the the Command Palette <kbd>Ctrl+Shift+P</kbd> (<kbd>Cmd+Shift+P</kbd> on Mac) or configure RStudio to automatically save open source files prior to rebuilding from the **Tools** > **Global Options** > **Packages** tab > **Development** tab > **Save all files prior to building packages** option. 

The **Build** pane also includes buttons for:  

![](images/build-pane.png){fig-alt="The build pane in RStudio, displaying the buttons available."}

- **Test** - run tests for current R package
- **Check** - run `R CMD Check` to test for package code or documentation problems
- **Load All** - runs `devtools::load_all()`
- **Build Source Package** - build a source package
- **Build Binary Package** - build a binary package
- **Configure Build Tools** - Opens **Project Options** > **Build Tools**

## Learning more

Once you've built a basic package with RStudio you'll want to learn about the tools that can be used to test, document, and prepare packages for distribution. Please consult the "R Packages" book at <https://r-pkgs.org/>.

# GWT for RStudio

## RStudio 1.3

RStudio uses a custom build of GWT with the resulting SDK checked directly into
the repo under `rstudio/src/gwt/lib/gwt/gwt-rstudio`.

The GWT fork is at https://github.com/rstudio/gwt.

### Changing GWT

To make GWT changes, use `./sync-gwt` to clone the repo into `./gwt/gwt`, and `./build-gwt` to
compile the SDK and copy the results into the source tree.

Changes must be submitted both to `rstudio` to update the SDK included in the repo, and to
the `gwt` repo to track changes to the sources.

### Updating to a new GWT

See comments in the `./sync-gwt` and `./build-gwt` scripts on steps to updating to a new
GWT SDK version and/or a new RStudio release.

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = FALSE)
```

## R Markdown

This is an R Markdown presentation. Markdown is a simple formatting syntax for authoring HTML, PDF, and MS Word documents. For more details on using R Markdown see <http://rmarkdown.rstudio.com>.

When you click the **Knit** button a document will be generated that includes both content as well as the output of any embedded R code chunks within the document.

## Slide with Bullets

- Bullet 1
- Bullet 2
- Bullet 3

## Slide with R Output

```{r cars, echo = TRUE}
summary(cars)
```

## Slide with Plot

```{r pressure}
plot(pressure)
```

---
title: "Quarto Integration"
date-meta: 2022-12-12
---

RStudio v2022.07.1 and later includes support for editing and preview of [Quarto documents](https://quarto.org/).

> Quarto^®^ is an open-source scientific and technical publishing system built on [Pandoc](https://pandoc.org/)
>
> -   Create dynamic content with [Python](https://quarto.org/docs/computations/python.html), [R](https://quarto.org/docs/computations/r.html), [Julia](https://quarto.org/docs/computations/julia.html), and  [Observable](https://quarto.org/docs/computations/ojs.html).
>
> -   Author documents as plain text markdown or [Jupyter](https://jupyter.org/) notebooks.
>
> -   Publish high-quality articles, reports, presentations, websites, blogs, and books in HTML, PDF, MS Word, ePub, and more.
>
> -   Author with scientific markdown, including equations, citations, crossrefs, figure panels, callouts, advanced layout, and more.

If you are using Quarto within RStudio, it is **strongly** recommended that you use RStudio v2022.07.1 or a later version (the documentation below assumes you are using this build or later).

## Installing Quarto

A stable release of Quarto is bundled with RStudio v2022.07.1, and later. Upgrading to new versions of RStudio in the future will also upgrade the bundled Quarto version.

To upgrade Quarto out of sync with the bundled version in RStudio, follow the directions at <https://quarto.org/docs/download/>

## Creating new documents

Use the **File** \> **New File** \> **Quarto Document** command to create new Quarto documents, which will launch the **New Quarto Document** wizard:

![](images/new-quarto-doc.png){fig-alt="The 'New Quarto Document' dialog menu in RStudio."}

## Render and Preview

Use the **Render** button to preview documents as you edit them:

![](images/rstudio-render.png){fig-alt="The top section of a qmd file as displayed in RStudio. There is a toolbar right above the document containing various options, including 'Render.' There is a stylized, segmented blue arrow pointing at the word."}

If you prefer to automatically render whenever you save you can check the **Render on Save** option on the editor toolbar.

The preview appears alongside the editor in the **Viewer** pane if **Preview in Viewer Pane** is selected:

![](images/rstudio-preview.png){fig-alt="An RStudio window. On the left half of the page is a Quarto document and the 'Jobs' pane open underneath that. There is messages in green text in the 'Jobs' pane that say: 'Watching files for changes. Browse at http://localhost:4064'. On the right half of the window is the Quarto output of the document on the left, as rendered by Knitr."}

The preview will update whenever document is re-rendered. Side-by-side preview works for both HTML and PDF output.

### Controlling output and preview

RStudio provides a dropdown menu to control the format options, such as the display location of preview renders, visual content such as tables and graphics, and raw text output from code.

![](images/quarto-preview-control.png){fig-alt="Screenshot of the 'Gear' menu dropdown for controlling format options of a Quarto document."}

#### Control location of rendered preview

Select one of the three following options:

- **Preview in Window**, opening in the default browser
- **Preview in Viewer Pane**, displaying the entire document preview in the **Viewer** Pane
- **(No Preview)**, there will not be a preview displayed when rendering

#### Control preview of markdown output

Select or deselect one of the following options:

- **Preview Images and Equations**, will show markdown images and formatted equations in the editor
- **Show Previews Inline**, when selected, outputs will be shown underneath the corresponding markdown, otherwise pop-ups will be shown when hovering over the markdown

#### Control output of code chunks

Turn the following features on or off:

- **Chunk Output Inline**, code output including graphics, tables, and printed output will display inline in the source document
- **Chunk Output in Console**, code output will display in the console, graphics and tables in the **Viewer** pane

## Quarto Background Job

Quarto documents are primarily rendered in RStudio with the **Render** button or the **Render on Save** option. Both of these options render the document within a [Background Job](../tools/jobs.html) which maintains a background preview web server. This provides a fresh R session for the rendered document along with a consistent URL to access the preview content.

To access and control the Quarto render, navigate to the **Console** pane and select the **Background Jobs** tab:

-   The duration of the current preview web server is available in the upper-right corner
-   Metadata, arguments, and output from the render process are printed and updated for each render
-   The URL to the preview web server is printed at the bottom of the output
-   To interrupt the render, press the red **Stop** button in the upper-right corner of the **Background Jobs** tab

![](images/quarto-job.png){fig-alt="A screenshot of the Background Jobs tab in RStudio, displaying the output of a Quarto render."}

## Projects

To create a new project for a Quarto document or set of documents:

1.  Use the **File : New Project...** command
2.  Specify **New Directory**
3.  Select **Quarto Project**

![](images/rstudio-new-knitr-project.png){fig-alt="A section of the 'New Project Wizard' menu from RStudio. This section is titled 'Create Quarto Project'. The Quarto logo is displayed on the left. ON the right are fields for 'Type', 'Directory name', and 'Create project as subdirectory of:'. Underneath that are options for 'Engine', 'Create a git repository', and 'Use renv with this project'. The option for 'Engine' is set to 'Knitr'. There are buttons for 'Create Project' and 'Cancel' arranged side-by-side in the bottom right of the window. There is an option to 'Open in new session' in the button left corner."}

You can use this UI to create both vanilla projects as well as [websites](https://quarto.org/docs/websites/) and [books](https://quarto.org/docs/books/). Options are also provided for creating a [git](https://git-scm.com/) repository and initializing an [renv](https://rstudio.github.io/renv/) environment for the project.

## Knitr engine

Quarto is designed to be highly compatible with existing [R Markdown](https://rmarkdown.rstudio.com/) documents. You should generally be able to use Quarto to render any existing Rmd document without changes.

One important difference between R Markdown documents and Quarto documents is that in Quarto chunk options are typically included in special comments at the top of code chunks rather than within the line that begins the chunk. For example:

    ```{{r}}
    #| echo: false
    #| fig-cap: "Air Quality"
    library(ggplot2)
    ggplot(airquality, aes(Temp, Ozone)) + 
            geom_point() + 
            geom_smooth(method = "loess", se = FALSE)
    ```

Quarto uses this approach to both better accommodate longer options like `fig-cap`, `fig-subcap`, and `fig-alt` as well as to make it straightforward to edit chunk options within more structured editors that don't have an easy way to edit chunk metadata (e.g., most traditional notebook UIs).

Chunk options included this way use YAML syntax rather than R syntax for consistency with options provided in YAML front matter. You can still however use R code for option values by prefacing them with `!expr`. For example:

``` yaml
#| fig-cap: !expr paste("Air", "Quality")
```

## Jupyter engine

You can also work with Quarto markdown documents that target the Jupyter engine within RStudio. These files will typically include a `jupyter` option in the YAML front matter indicating which kernel to use. For example:

``` yaml
---
title: "Matplotlib Demo"
author: "Norah Smith"
jupyter: python3
---
```

To work within a virtual environment ([venv](https://packaging.python.org/guides/installing-using-pip-and-virtual-environments/#creating-a-virtual-environment)):

1.  Use the **File :** **New Project...** command
2.  Specify the **Jupyter** engine with a venv
3.  Specify which packages you'd like to seed the venv with:

![](images/rstudio-new-jupyter-project.png){fig-alt="A section of the 'New Project Wizard' menu from RStudio. This section is titled 'Create Quarto Project'. The Quarto logo is displayed on the left. ON the right are fields for 'Type', 'Directory name', and 'Create project as subdirectory of:'. Underneath that are options for 'Engine' and 'Kernel'. The option for 'Engine' is set to 'Jupyter,' and the option for 'Kernel' is set to 'Python 3'. Underneath these are options for 'Create a git repository', and 'Use venv with this project'. The button for 'Use venv...' is selected, and there is a text box to the right with the Python package names 'matplotlib' and 'pandas' filled in. There are buttons for 'Create Project' and 'Cancel' arranged side-by-side in the bottom right of the window. There is an option to 'Open in new session' in the button left corner."}

RStudio will automatically activate this virtual environment whenever you open the project. You can install additional Python packages into the environment using the RStudio **Terminal** tab. For example:

![](images/rstudio-pip-install.png){alt="An RStudio terminal window. The prompt is prefixed by the word '(env)', indicating that this prompt is taking place in a Python virtual environment named 'env.' The first line is empty and the second line contains the command 'python3 -m pip install scikit-learn.'"}

## YAML intelligence

YAML code completion is available for project files, YAML front matter, and executable cell options:

![](images/rstudio-yaml-completion.png){alt="Quarto document with YAML being edited. Next to the cursor code completion helper is open showing YAML options beginning with the letters preceding the cursor ('to')."}

If you have incorrect YAML it will also be highlighted when documents are saved:

![](images/rstudio-yaml-diagnostics.png){fig-alt="Quarto document YAML metadata with an incorrect option underlined in red."}

## R package

If you are not using RStudio and/or you prefer to render from the R console, you can do so using the [quarto](https://quarto-dev.github.io/quarto-r/) R package. To install the R package:

``` r
install.packages("quarto")
```

Then, to render a document:

``` r
library(quarto)
quarto_render("document.qmd")
```

To live preview (automatically render & refresh the browser on save) for a document you are working on, use the `quarto_preview()` function:

``` r
library(quarto)
quarto_preview("document.qmd")
```

If you are working on a [website](https://quarto.org/docs/websites/) or [book](https://quarto.org/docs/books/) project, you can also use `quarto_preview()` on a project directory:

``` r
library(quarto)
quarto_preview()
```

---
name: rstudio-create-playwright-tests
description: Patterns and gotchas for authoring RStudio Playwright tests in TypeScript. Use when writing, reviewing, or migrating tests under e2e/rstudio/.
---

# Creating RStudio Playwright Tests

Most of what you need is in `e2e/rstudio/README.md` (basic structure,
conventions, selector hierarchy, Ace interactions, cross-platform shortcuts,
sandbox, tags, package deps) and in the existing tests under
`e2e/rstudio/tests/`. The fixture (`@fixtures/rstudio.fixture`) handles
RStudio launch/shutdown, save-dialog dismissal, and buffer cleanup -- author
tests as if the IDE starts clean.

This file covers RStudio-specific gotchas that aren't in the README.

## Before writing

- Skim `e2e/rstudio/tests/` for an existing similar test.
- Skim `e2e/rstudio/pages/`, `actions/`, and `utils/` for existing helpers.

## Universal rules

1. **`pressSequentially()` for GWT text inputs whose handlers fire per
   keystroke** -- console, editor, and most `input.gwt-TextBox` fields in
   dialogs/wizards (where typing a character enables OK, triggers
   autocomplete, etc.). `fill()` doesn't fire GWT key events in those cases.
   Inputs driven by a discrete trigger like `press('Enter')` or a button click
   (e.g., the console Find bar) work fine with `fill()`, which has the bonus
   of replacing text instead of appending. Start with `fill()`; switch to
   `pressSequentially()` only if the handler doesn't fire.

2. **Force-click Ace textareas:** `await locator.click({ force: true })`. An
   `ace_content` div overlays the hidden textarea and intercepts normal
   clicks. `focus()` is also unreliable -- keystrokes can land in the wrong
   pane.

3. **Derive selectors from source, never use `gwt-uid-XXXX`** (those change
   every restart):
   - `src/gwt/.../commands/Commands.cmd.xml` -- command IDs map to menu
     items at `#rstudio_label_<sanitized_id>` and toolbar buttons at
     `#rstudio_tb_<sanitized_id>` (see `ElementIds.java` for the sanitizer).
   - `src/gwt/.../core/client/theme/DocTabLayoutPanel.java` -- tab structure
     (`.gwt-TabLayoutPanelTab`, `.gwt-TabLayoutPanelTab-selected`, etc.).

4. **Invoke RStudio commands and prefs via the `window.rstudio` bridge** --
   import helpers from `@utils/commands` (`executeCommand`, `setPref`, etc.).
   Don't use `.rs.api.executeCommand(...)` (slow console roundtrip) or
   `window.desktopHooks.invokeCommand(...)` (Electron-only, crashes on Server).

5. **Decision order for triggering an action:** GUI button/menu/shortcut, then
   `executeCommand(page, id)`, then `page.evaluate()` as a last resort.
   Clicking a button tests the real user path; the helper is for
   setup/teardown or when the UI path is slow/flaky/tangential to what's
   being tested.

6. **RStudio binds some shortcuts to plain Ctrl on every platform**
   (including macOS) -- e.g., `Ctrl+Enter` Run Line, `Ctrl+L` Clear Console,
   `Ctrl+Space` Autocomplete. Use Playwright's plain `Control` for those, not
   `ControlOrMeta`. If you're unsure, check what RStudio's keyboard-shortcut
   UI shows for the binding.

7. **Tests must work on Desktop and Server.** Prefer stable IDs over wrapper
   selectors. Tag mode-specific tests `@desktop_only` or `@server_only`
   rather than runtime-branching on `testInfo.project.name`.

## Feature-specific patterns

When working in these areas, also read the corresponding file:

- **Code suggestions / Copilot / NES** (`tests/panes/editor/code_suggestions.test.ts`,
  `edit_suggestions.test.ts`): see `code-suggestions.md`.
- **Chat pane / Posit Assistant / RPC interception**
  (`tests/panes/posit-assistant-chat/`): see `chat-pane.md`.
- **Visual editor / citations** (`tests/panes/editor/citations.test.ts`, and any
  test that drives the panmirror visual editor): see `visual-editor.md`.

---
title: "Jobs in action"
date-meta: 2022-12-12
---

As mentioned in [RStudio Jobs](jobs.html), RStudio has the ability to send long running R scripts to [local and remote background jobs](https://posit.co/blog/rstudio-1-2-jobs/). This functionality can dramatically improve the productivity of data scientists and analysts using R since they can continue working in RStudio while jobs are running in the background.

A few examples of integrating RStudio Jobs with specific development workflows in shiny, plumber, machine learning, or any long-running process are documented below.

## Shiny app

Running a [Shiny](https://shiny.posit.co/r/getstarted/shiny-basics/lesson1/index.html) for R application as a local background job allows the current R session to remain free to work on other things. This can be especially helpful for making changes to the Shiny code and seeing the changes in real time.

A minimal example of running the Shiny app as a Job is documented below.

Use the RStudio global menu:  

- **File** \> **New File** \> **Shiny Web App\...** 
- Set the **Application Name:** as "shiny-example"  
- Set the **Application Type:** as a **Single File (app.R)**  

![](images/create-new-shiny.png){fig-alt="A screenshot of the RStudio > New Shiny Web Application wizard, populated with the above instructions."}

This workflow will create a new folder titled "shiny-example" and populate it with a Shiny `app.R` file. In the *same folder* ("shiny-example") as the newly created `app.R`, create a second .R file titled `shiny-local.R` with the following example code:

``` r
options(shiny.autoreload=TRUE)
shiny::runApp()
```

The `shiny.autoreload=TRUE` option provides the real-time updating of the Shiny app code without requiring an explicit reload of the Shiny app, and the `shiny::runApp()` code enables running all the Shiny components within the "shiny-example" folder. Sourcing as a `shiny-local.R` from within the same directory as a Shiny `app.R` will allow them to interact, using `shiny-local.R` to modify the behavior of the Shiny hosting. 

The purpose of this two-file system is that you have a ready to deploy Shiny app (`app.R`) and a way to interactively test it locally (`shiny-local.R`) prior to deploying to production.

The `shiny-local.R` source file will have a **Run App** drop-down menu. From the **Run App** drop-down, select **In Background Job** and then press the **Run App** button:

![](images/run-shiny-background.png){fig-alt="A screenshot of the `shiny-local.R` file, with the Run App > In Background Job menu option highlighted."}

With **In Background Job** set, the **Run App** button will execute the Shiny app in a Background Job, and automatically present it in the **Viewer Pane**:

![](images/live-reload-shiny.png){fig-alt="A screenshot of the RStudio interface, displaying the Shiny app running as a Background Job, displaying the shiny app in the Viewer pane."}

Working with Shiny apps in this way allows for interactive editing and updating of the displayed Shiny app in real time - both for Shiny user interface and server components.

### Reload app

Alternatively, in the Shiny `app.R` file, there will also be a **Run App** drop-down. From **Run App**, select **In Background Job** and then press the **Run App** button. This will not have auto-reloading but might be preferable for Shiny apps with a long startup time.

In this scenario, after making changes to the `app.R` file, the **Run App** button will be replaced with a **Reload App** button. The Shiny app will still be executed in a Background Job, but the user must explicitly reload the app after making changes and press the **Reload App** button, rather than the auto-reload behavior in the previous example.

![](images/reload-app-shiny.png){fig-alt="A screenshot of a shiny app.R file with the Run App button replaced with Reload App, indicating that changes have been made and the app can be updated when the user decides."}

## Plumber API

Similar to Shiny applications, [plumber](https://www.rplumber.io/) APIs can be run as a local background job. This allows the current R session to remain open for things like testing or interacting with the API via `curl` or R packages for querying APIs such as [httr](https://httr.r-lib.org/). [plumber](https://www.rplumber.io/) v1.1.0 or later is required for the below documentation.

If necessary, install the latest version of plumber and rapidoc from CRAN:

``` r
install.packages(c("plumber", "rapidoc))
```

A minimal example of running a plumber API as a Job is documented below:

Use the RStudio global menu: **File** \> **New File** \> **Plumber API\...** and save it as `plumber-example`.

In the *same directory* as `plumber.R`, create a second .R file titled `plumber-local.R` with the following example code:

``` r
library(plumber)
library(rapidoc)
pr("plumber.R") %>%
  pr_set_docs("rapidoc") %>%
  pr_set_docs_callback(rstudioapi::viewer) %>%
  pr_run()
```

This code will take an example plumber API, set rapidoc as the interactive documentation, and send the docs to the RStudio **Viewer** pane. The purpose of this two-file system is that you have a ready to deploy plumber API (`plumber.R`) and a way to interactively test it locally (`plumber-local.R`) prior to deploying to production.

Execute it as a Job from the **Source** pane via the **Source** \> **Source as a Background Job** drop-down option.

![](images/source-plumber-job.png){fig-alt="A screenshot of the Source pane, with the Source > Source as Background Job drop-down option highlighted."}

In the upper-right corner of the RStudio **Viewer** pane, press the **Refresh Viewer** ![](images/reload-button.png){height=20}. This will display the plumber API's rapidoc interface in the **Viewer** pane, allowing for interactive testing with the active plumber API in real time.

![](images/plumber-interaction.png){fig-alt="A screenshot of RStudio with the plumber-job.R file open in the Source pane, the Background job tab selected from the Console pane displaying the url to the API and it's docs, and the Viewer pane displaying the plumber API's Swagger docs."} 

To interact with the API programatically in RStudio, use a R package such as [httr](https://httr.r-lib.org/) or a command line tool such as [curl](https://curl.se/). The example API has a few endpoints (`/sum`, `/echo`, `/plot`) and you can query them with `GET()` or `POST()` commands.

```r
# if needed install.packages("httr")
```

From the **Background Jobs** tab within the **Console** pane, the running API will return the URL to the API and it's rapidoc Docs:

![](images/plumber-job-url.png){fig-alt="A screenshot of the Background Jobs pane, displaying the example URL to the API and the rapidoc docs."}

``` bash
# This is an example URL and 
# it will vary between sessions
Running plumber API at http://127.0.0.1:6285
Running rapidoc Docs at http://127.0.0.1:6285/docs/
```

We can add specific endpoints to that URL (`http://127.0.0.1:6285`) such as `/sum` or `/echo` and then query them with the httr package.

```r
post_sum <- httr::POST("http://127.0.0.1:6285/sum", query = list(a=1, b = 2))

httr::content(post_sum)
#> [1] 3
```

```r
get_echo <- httr::GET("http://127.0.0.1:6285/echo", query = list(msg = "dog"))

httr::content(get_echo)
#> $msg
#> [1] "The message is: 'dog'"
```


## vetiver model as an API

The [vetiver framework](https://vetiver.rstudio.com/) is for MLOps tasks in Python and R. The [vetiver R package](https://rstudio.github.io/vetiver-r/) has functions for deploying vetiver models as plumber APIs. This allows for remote deployment, as well as local testing in a similar way to generic plumber APIs. The vetiver example below is taken from the [vetiver 'Get Started' documentation](https://vetiver.rstudio.com/get-started/deploy.html).

If necessary, install the latest versions of these packages from CRAN:

``` r
install.packages(c("tidymodels", "vetiver", "pins", "plumber"))
```

First, save the below code as `vetiver-train.R` and execute it to generate a vetiver model and write out that model to a plumber API.

``` r
library(tidymodels)
library(vetiver)
library(pins)

car_mod <-
    workflow(mpg ~ ., decision_tree(mode = "regression")) %>%
    fit(mtcars)
v <- vetiver_model(car_mod, "cars_mpg")
model_board <- board_folder("pins-r", versioned = TRUE)
model_board %>% vetiver_pin_write(v)

# write out a vetiver model to a plumber API
vetiver_write_plumber(model_board, "cars_mpg", file = "vetiver-plumber.R")
```

Create and save a second file as `vetiver-local.R` with the code below:

``` r
# vetiver-local.R
library(plumber)
library(vetiver)

pr("vetiver-plumber.R") %>%
  pr_set_docs_callback(rstudioapi::viewer) %>%
  pr_run()
```

The `vetiver-local.R` file can be run as a **Background Job** like any other plumber API, hosting the vetiver model as an API temporarily. The purpose of this two-file system is that you have a ready to deploy vetiver model as a plumber API (`vetiver-plumber.R`) and a way to interactively test it locally (`vetiver-local.R`) prior to deploying to production.

If you don't want to write out the plumber API yet, you can also launch a vetiver API directly with vetiver. This requires selecting **Run job with copy of global environment** when pressing **Source as Background Job**, as the `vetiver_model()` exists in the global environment as `v` in the current example:

```r
pr() %>%
  pr_set_docs_callback(rstudioapi::viewer) %>%
  # use the existing vetiver_model object 'v'
  vetiver_api(v) %>%
  pr_run()
```

From the **Source** drop-down menu, select **Source as Background Job**. This will launch the API as a **Background Job**. 

![](images/vetiver-source-background-job.png){fig-alt="A screenshot of the Source pane, with the Source > Source as Background Job drop-down option highlighted."}

In the upper-right corner of the RStudio **Viewer** pane, press the **Refresh Viewer** ![](images/reload-button.png){height=20}. This will display the API's interface in the **Viewer** pane, allowing for interactive testing of the temporarily hosted vetiver model in real time.

![](images/vetiver-view-docs.png){fig-alt="A screenshot of RStudio with the vetiver-local.R file open in the Source pane, the Console pane displaying the url to the API and it's docs, and the Viewer pane displaying the vetiver model API's rapidocs docs."}

You can also programatically send new data and test new predictions with the vetiver model. In the **Background Jobs** tab within the **Console** pane, the active API will return the URL to the API and it's rapidoc Docs.

![](images/vetiver-docs-url.png){fig-alt="A screenshot of the Background Jobs pane, displaying the example URL to the API and the rapidoc docs."}

``` bash
# This is an example URL and 
# it will vary between sessions
Running plumber API at http://127.0.0.1:6030
Running rapidoc Docs at http://127.0.0.1:6030/__docs__/
```

Add the `/predict` endpoint to the end of the URL and save it as a `vetiver_endpoint()`.

``` r
endpoint <- vetiver_endpoint("http://127.0.0.1:6030/predict")
```

You can then make predictions with new data for that model running in the separate **Background Job** process.

``` r
new_car <- tibble(cyl = 4,  disp = 200, 
                  hp = 100, drat = 3,
                  wt = 3,   qsec = 17, 
                  vs = 0,   am = 1,
                  gear = 4, carb = 2)
predict(endpoint, new_car)

#> # A tibble: 11 × 1
#>    .pred
#>    <chr>      
#>  1 22.3
```

## Extract, transform, load (ETL)

Background and Workbench Jobs are ideal for long running processes, like interactively loading data from an external database or API. Non-interactive, scheduled ETL scripts should be handled by Posit Connect.

## Simulations

Long running tasks like simulation studies can be run as background or Workbench Jobs in order to keep the original R session open for other work.

For example - a Monte Carlo simulation for estimating pi could be saved as `simulate-pi.R`:

<details>

<summary>`simulate-pi.R` Code</summary>

``` r
# Use a monto carlo simulation to estimate pi
n <- 1e6
if (!dir.exists("output")) dir.create("output")
results_file <- tempfile("pi-", "output", ".rds")

results <- matrix(nrow = n, ncol = 2)

for (i in 1:n){
   results[i,] <- runif(2)
   # save out results every 25 iterations
   if (i %% 25 == 0) {
      print(paste0("Saving results (i = ", i, ")"))
      save_results <- results[apply(results, 1, function(x) !all(is.na(x))),]
      print(
         paste0(
            "Pi estimate: ",
            mean((save_results[,1]^2 + save_results[,2]^2) <= 1) * 4)
      )
      saveRDS(save_results, results_file)
   }
}
```

</details>

This script includes:

-   `print()` calls for each 25 runs and the estimation of pi at that moment in time
-   `saveRDS()` to save out and overwrite the results after each 25 runs

Executing this script as a Job with the included `print()` calls will display the current estimated value of Pi and a running number of simulations in the Background Jobs pane:

![](images/estimating-pi-output.png){fig-alt="A screenshot of the Background Jobs pane displaying the output of the current estimated value of Pi and that it is being saved to a file along with the number of simulations."}

## Model training

Model training and tuning, which can often take a long time, is another great use case for background and Workbench Jobs. Local jobs are ideal for sequential model training while Workbench Jobs can be used to train multiple models in parallel on elastic scaling infrastructure.

The example script at <https://tune.tidymodels.org/reference/example_ames_knn.html> can be executed as a background or Workbench Job, enhanced with one modification.

Add `control = control_grid(verbose = TRUE)` to the `tune_grid()` step:

``` r
ames_grid_search <-
  tune_grid(
    ames_wflow,
    resamples = rs_splits,
    grid = ames_grid,
    # this will print each step of the tuning process
    control = control_grid(verbose = TRUE)
  )
```

Including the `control_grid(verbose = TRUE)` means the output from that grid tuning of a tidymodels workflow will print and update wherever it is being executed, including the **Background Jobs** tab. For this code it will print the current fold and split:

![](images/tidymodels-control-grid.png){fig-alt="A screenshot of the output from grid tuning of a tidymodels workflows with printing in the **Background Jobs** tab, including the current fold and split."}

## Programmatic Jobs

The above documentation has focused on using the RStudio user interface to kick off and interact with Jobs. The [`rstudioapi`](https://github.com/rstudio/rstudioapi) package provides tools for programmatically creating local and Workbench jobs.

### Local Background Jobs

| Interact with the jobs pane.                                                             |                                |
|:------------------------------|-----------------------------------------|
| [`jobAdd()`](https://rstudio.github.io/rstudioapi/reference/jobAdd.html)                 | Add a Job                      |
| [`jobAddOutput()`](https://rstudio.github.io/rstudioapi/reference/jobAddOutput.html)     | Add Background Job Output      |
| [`jobAddProgress()`](https://rstudio.github.io/rstudioapi/reference/jobAddProgress.html) | Add Background Job Progress    |
| [`jobRemove()`](https://rstudio.github.io/rstudioapi/reference/jobRemove.html)           | Remove a Background Job        |
| [`jobRunScript()`](https://rstudio.github.io/rstudioapi/reference/jobRunScript.html)     | Run R Script As Background Job |
| [`jobSetProgress()`](https://rstudio.github.io/rstudioapi/reference/jobSetProgress.html) | Set Background Job Progress    |
| [`jobSetState()`](https://rstudio.github.io/rstudioapi/reference/jobSetState.html)       | Set Background Job State       |
| [`jobSetStatus()`](https://rstudio.github.io/rstudioapi/reference/jobSetStatus.html)     | Set Background Job Status      |

### Workbench Jobs

| Interact with the **Workbench Jobs** pane.                                                                                   |                                                  |
|:------------------------------|-----------------------------------------|
| [`launcherAvailable()`](https://rstudio.github.io/rstudioapi/reference/launcherAvailable.html)                     | Check if Workbench Launcher is Available         |
| [`launcherConfig()`](https://rstudio.github.io/rstudioapi/reference/launcherConfig.html)                           | Define a Workbench Launcher Configuration        |
| [`launcherContainer()`](https://rstudio.github.io/rstudioapi/reference/launcherContainer.html)                     | Define a Workbench Launcher Container            |
| [`launcherControlJob()`](https://rstudio.github.io/rstudioapi/reference/launcherControlJob.html)                   | Interact with (Control) a Workbench Job          |
| [`launcherGetInfo()`](https://rstudio.github.io/rstudioapi/reference/launcherGetInfo.html)                         | Retrieve Workbench Launcher Information          |
| [`launcherGetJob()`](https://rstudio.github.io/rstudioapi/reference/launcherGetJob.html)                           | Retrieve Workbench Job Information               |
| [`launcherGetJobs()`](https://rstudio.github.io/rstudioapi/reference/launcherGetJobs.html)                         | Retrieve Workbench Job Information               |
| [`launcherHostMount()`](https://rstudio.github.io/rstudioapi/reference/launcherHostMount.html)                     | Define a Workbench Launcher Host Mount           |
| [`launcherNfsMount()`](https://rstudio.github.io/rstudioapi/reference/launcherNfsMount.html)                       | Define a Workbench Launcher NFS Mount            |
| [`launcherPlacementConstraint()`](https://rstudio.github.io/rstudioapi/reference/launcherPlacementConstraint.html) | Define a Workbench Launcher Placement Constraint |
| [`launcherResourceLimit()`](https://rstudio.github.io/rstudioapi/reference/launcherResourceLimit.html)             | Define a Workbench Launcher Resource Limit       |
| [`launcherSubmitJob()`](https://rstudio.github.io/rstudioapi/reference/launcherSubmitJob.html)                     | Submit a Workbench Job                           |
| [`launcherSubmitR()`](https://rstudio.github.io/rstudioapi/reference/launcherSubmitR.html)                         | Execute an R Script as a Workbench Job           |

\

---
title: "RStudio Jobs"
date-meta: 2022-12-12
---

RStudio has the ability to send long running R scripts to [local and remote background jobs](https://posit.co/blog/rstudio-1-2-jobs/). This functionality can dramatically improve the productivity of data scientists and analysts using R since they can continue working in RStudio while jobs are running in the background.

Local background jobs are supported by all versions of the RStudio IDE, server and desktop. Remote background jobs are a feature of [Posit Workbench](https://posit.co/products/enterprise/workbench/) and are orchestrated by the [Launcher](https://docs.posit.co/ide/server-pro/job_launcher/job_launcher.html), which also supports running interactive sessions on remote resource managers like [Kubernetes](https://kubernetes.io/). More information about configuring the Job Launcher can be found in the [Posit Workbench Admin Guide](https://docs.posit.co/ide/server-pro/job_launcher/job_launcher.html#configuration.html), and more information about using Workbench Jobs can be found in the [Posit Workbench User Guide](https://docs.posit.co/ide/server-pro/user/rstudio-pro/guide/workbench-jobs.html).

Background jobs can be started manually or programatically. Local background jobs are ideal for interactive, ad-hoc usage.

## Background jobs

A "background job" is an R script that runs in a separate, dedicated R session. Any R script can be run in a separate session by:

from the **Background Job** tab in the **Console**, select **Start Background Job**.

![](images/background-job-console-start.png){fig-alt="Screenshot of the 'Start Background job' tab in the terminal pane."}

Or from within a .R file, click the **Source** menu and select **Source as Background Job**.

![](images/source-job.png){fig-alt="Source script as background job" width="450"}

Either method will give you some options for running your job.

![](images/background-job-option.png){fig-alt="Dialog showing options for starting R script job"}

By default, the job runs in a clean R session, and its temporary workspace is discarded when the job is complete. This is the fastest and safest configuration, suitable for reproducible scripts without side effects. Because the job runs as a child process of the current session, any environment variables set at the process-level or shell-level are passed to the background job from the main session.

However, if you want to feed data from your current R session into the job, or have the job return data to your current R session, change the dialog options as follows:

#### Run job with copy of global environment: 

If selected, this option saves your global environment and loads it into the job's R session before it runs. This is useful because it will allow your job to see all the same variables you can see in the IDE. Note that this can be slow if you have large objects in your environment.

#### Copy job results: 

By default, the temporary workspace in which the job runs is not saved. If you'd like to import data from your job back into your R session, you have a couple of choices:

-   **Global environment**: This places all the R objects your job creates back in your R session's global environment. 
  
::: {.callout-caution}

## Copy jobs results to Global environment

Use **Copy jobs results** to **Global environment** option with caution! The objects created by the job will overwrite, without a warning, any objects that have the same name in your environment.

:::

-   **Results object**: This places all the R objects your job creates into a new environment named with the the following pattern "yourscriptname" + "_results". For example, a script titled `training.R` executed as Background Job would be saved back into the global environment as an object titled `training_results`.

An additional option is to include specific R code to save out the results to files on disk such as `saveRDS(object, "results.rds")`.

### Lifetime

Background jobs run as non-interactive child R processes of your main R process, which means that they will be shut down if R is. While the R session is running jobs:

-   You will be warned if you attempt to close the window while jobs are still running (on RStudio Desktop)

-   Your R session will not be suspended (on Posit Workbench)

While background jobs are running, a progress bar will appear in the R console summarizing the progress of all running jobs.

![](images/background-job-console.png){fig-alt="R console pane showing job progress tab" width="350"}

### Detailed progress

The progress bar RStudio shows for your job represents the execution of each top-level statement in your R script. If you want a little more insight into which part of the script is currently running, you can use RStudio's [code sections](../code/code-sections.html) feature. Add a section marker like this to your R script:

```markdown
# Apply the model ----
```

When your job reaches that line in your script, the name of the section will appear on the progress bar.

![](images/background-job-name.png){fig-alt="Job progress bar showing section progress"}

You can also emit output using the usual R mechanisms, such as:
- `print`
- `message`
- `cat`

This output appears in the Jobs pane when you select your job.

![](images/background-job-print.png){fig-alt="Jobs pane with output of a local job"}

### Scripting

You can script the creation of jobs using the [rstudioapi](https://rstudio.github.io/rstudioapi/) package method [jobRunScript](https://rstudio.github.io/rstudioapi/reference/jobRunScript.html); it has options which correspond to each dialog option above. This makes it possible to automate and orchestrate more complicated sets of background tasks.

However, the RStudio's background job runner is generally designed for interactive script runs. If you are writing R code and need to run a subtask asynchronously in a background R session, we recommend using the [callr package](https://callr.r-lib.org/) instead.

## Showing task progress

RStudio's Jobs pane can show more than just the progress of Background or Workbench jobs. It can also be scripted from R packages (and R code) to show status, progress, and output for any long-running task.

To show progress and/or output from a task using the jobs UI, refer to the [rstudioapi documentation](https://rstudio.github.io/rstudioapi/reference/index.html#jobs) for details; start with `jobAdd()`, which creates a new job in the UI and returns a handle you can use to update the UI as the job progresses.

| Interact with the jobs pane.                                                             |     |
|:------------------------------|-----------------------------------------|
| [`jobAdd()`](https://rstudio.github.io/rstudioapi/reference/jobAdd.html)                 |   Add a Job  |
| [`jobAddOutput()`](https://rstudio.github.io/rstudioapi/reference/jobAddOutput.html)     |   Add Background Job Output  |
| [`jobAddProgress()`](https://rstudio.github.io/rstudioapi/reference/jobAddProgress.html) |  Add Background Job Progress   |
| [`jobRemove()`](https://rstudio.github.io/rstudioapi/reference/jobRemove.html)           |   Remove a Background Job  |
| [`jobSetProgress()`](https://rstudio.github.io/rstudioapi/reference/jobSetProgress.html) |  Set Background Job Progress   |
| [`jobSetState()`](https://rstudio.github.io/rstudioapi/reference/jobSetState.html)       |  Set Background Job State   |
| [`jobSetStatus()`](https://rstudio.github.io/rstudioapi/reference/jobSetStatus.html)     |   Set Background Job Status  |

## Workbench (Launcher) jobs {.pro-header}

On Posit Workbench, you also have the option of running your R script on your company's compute infrastructure, using a [Workbench Job](https://docs.posit.co). To do this, from the **Source** drop-down menu, select **Source as Workbench Job**:

![](images/workbench-job.png){fig-alt="Source script as launcher job" width="350"}

See more documentation specific to Workbench Jobs:

- [Workbench Jobs in RStudio Pro](https://docs.posit.co/ide/server-pro/user/rstudio-pro/guide/workbench-jobs.html)
- [Workbench Jobs in VS Code](https://docs.posit.co/ide/server-pro/user/vs-code/guide/workbench-jobs.html)
- [Comparison of Workbench Jobs and Background Jobs](https://docs.posit.co/ide/server-pro/user/rstudio-pro/guide/workbench-jobs.html#workbench-jobs-vs-background-jobs)

---
title: "Managing R"
date-meta: 2022-12-12
---

## R startup

Upon startup, R and RStudio look for a few different files used to control the behavior of the R session (e.g., settings options or environment variables). 

In the context of [Posit Team](https://docs.posit.co/posit-team/), these settings are often used to direct Posit Workbench to search for packages in a Posit Package Manager repository.

This section is a practical guide on how to set particular options on R startup. For more information on: 

- How to manage R package environments, refer to the Posit Solutions guide on [Reproducible Environments](https://solutions.posit.co/envs-pkgs/environments/)
- A deeper treatment of R process startup, refer to [What They Forgot to Teach You About R](https://rstats.wtf/r-startup.html)

Here is a summary table of how to control R options and environment variables on startup:

| File            | Who Controls  | Level           | Limitations                                    |
|--------------|--------------|--------------|-------------------------------|
| `.Renviron`     | User or Admin | User or Project | Set environment variables only.                |
| `.Rprofile`     | User or Admin | User or Project | None, sourced as R code.                       |
| `Rprofile.site` | Admin         | Version of R    | None, sourced as R code.                       |
| `Renviron.site` | Admin         | Version of R    | Set environment variables only.                |
| `rsession.conf` | Admin         | Server          | Only RStudio settings, only single repository. |
| `repos.conf`    | Admin         | Server          | Only for setting repositories.                 |

### `.Renviron`

The `.Renviron` file is:

- A user-controllable file used to create environment variables.
- Written in a key-value format. Environment variables are created in the format:

  ``` yaml
  Key1=value1
  Key2=value2
  ...additional key=value pairs
  ```

  - In this example, `Sys.getenv("Key1")` will return `"value1"` in an R session.

- Located at either the user or project level. If there is a project-level `.Renviron` file, the user-level file will not be sourced. 
- Most useful for defining sensitive information like API keys (e.g., GitHub, Twitter, or Posit Connect), as well as R-specific environment variables like the history size (`R_HISTSIZE=100000`) and default library locations `R_LIBS_USER`.

:::{.callout-tip}
The [`usethis`](https://usethis.r-lib.org/) package includes a helper function for editing `.Renviron` files from an R session with `usethis::edit_r_environ()`. You can specify whether you want to edit the user or project level `.Renviron.`
:::

### `.Rprofile`

The `.Rprofile` file:

- Contains R code that is run when R starts up, after the `.Renviron` file is sourced.
- Is user-controllable, and sets options and environment variables. 
- Can be located either at the user or project level. User-level `.Rprofile` files live in the base of the user's home directory. Project-level `.Rprofile` files live in the base of the project directory.
  - If there is a project-level `.Rprofile` file, the user-level file will not be sourced. In this situtaion, if you want the user-level file to be sourced, explicitly source it at the top of your project-level `.Rprofile` with `source("~/.Rprofile")`.
- Are sourced as regular R code, so setting environment variables must be done inside a `Sys.setenv(key = "value")` call.

A simple example of a `.Rprofile` is:

``` r
options(repos = c(CRAN = "https://packagemanager.posit.co/all/latest"))

if (interactive()) {
  options(width = 120)
}
```

:::{.callout-tip}
The [`usethis`](https://usethis.r-lib.org/) package includes a helper function for editing `.Rprofile` files from an R session with `usethis::edit_r_profile()`. You can specify whether you want to edit the user or project level `.Rprofile.`
:::

### `Rprofile.site` and `Renviron.site`

Both `.Rprofile` and `.Renviron` files have equivalents that apply server wide: `Rprofile.site` and`Renviron.site` (no leading dot). These files are:

- Managed by admins on Posit Workbench or RStudio Server.
- Specific to a particular version of R. 
- Most commonly used to manage settings related to package repository access. 
  - For example, administrators generally use the `Rprofile.site` file to implement the [shared-baseline](https://solutions.posit.co/envs-pkgs/environments/shared/) package management strategy.
- Able to be overriden by users in their individual `.Rprofile` or `.Renviron` files.
- Set for each version of R, and should be located in `R_HOME/etc/`. `R_HOME` can be found by running the command `R.home(component = "home")` in a session of that version of R. 
  - For example: if `R_HOME` is `/opt/R/4.2.0/lib/R`, the `Rprofile.site` for R 4.2.0 would go in `/opt/R/4.2.0/lib/R/etc/Rprofile.site`.

### `rsession.conf` and `repos.conf`

The `rsession.conf` and `repos.conf` files allow Posit Workbench and RStudio Server administrators to configure particular server-wide R package repositories. 

Only one repository can be configured in `rsession.conf`. If multiple repositories are needed, administrators should use `repos.conf`. Details on configuring Posit Workbench and RStudio Server with these files are in the  [Package Installation section](https://docs.posit.co/ide/server-pro/rstudio_pro_sessions/package_installation.html) of the Posit Workbench Admin Guide guide.

## Managing R versions

RStudio requires R version 3.6.0 or higher. Since multiple R versions can be installed side-by-side on a system, RStudio needs to select which version of R to run against. 

### Using `rig` to manage R versions

The simplest way to manage your installed R versions is to use the `rig` R Installation Manager. It works on macOS, Windows, and Linux operating systems. 

For more information and to download it, visit the [`rig`](https://github.com/r-lib/rig?tab=readme-ov-file#the-r-installation-manager) GitHub repository and review the README. 

Once you have installed `rig`, you can use the `rig rstudio` command to start RStudio with a specified R version. For example, to start RStudio with R version 4.3.0, run:

```bash
rig rstudio 4.3.0
```

### Managing R versions manually on Windows

You can override which R version RStudio uses on a Windows machine by navigating to **Tools** > **Global Options** > **General** > **Basic** > **R Sessions**. Select **Change** next to the **R Version** field.

A **Choose R Installation** dialog displays that allows you to select the version of R to use. This dialog box, pictured below, also appears if you hold down the `Ctrl` key at RStudio startup. 

![](images/choose-r-version.png){fig-alt="A screenshot of the dialog box to select an R installation on a Windows operating system." width="450"}

---
title: "Resetting RStudio's State"
date-meta: 2025-01-08
---

## Overview

RStudio Desktop stores its internal state in a hidden directory. If this directory does not exist, RStudio creates it on start-up. This directory includes information about open documents, log files, and other state information. Removing (or renaming) this directory resets RStudio's state. 

Instead of deleting the directory, we recommend renaming this directory to create a backup version. If you experience a crash or RStudio fails to start, this directory contains vital information for determining the source of the error. In this case, we recommend renaming this directory and forwarding it to Posit's support team.

User preferences are stored in a separate folder from internal state. This allows you to perform a state reset without losing your settings. Additionally, it allows for preferences to be synced between machines without including machine-specific internal state information.

Some versions of RStudio Desktop store additional preferences (such as the size and location of the window and the rendering mode) in a separate location. To fully reset state, this must also be deleted or renamed. Learn more in the [Resetting other preferences] section below.

If you are using RStudio Projects, and you are having issues, reset the project-specific state by navigating to the Project's folder in your file browser and renaming the `.Rproj.user` directory.

# Accessing the RStudio Desktop directory (internal state)

## Windows

Open an Explorer window in the RStudio Desktop directory by typing the following command into **Start** > **Run**:

```powershell
%localappdata%\RStudio
```

Then, rename this directory and send it with your support request.

## macOS

Create a backup by running the following command from the terminal. Then, send this backup with your support request:

```zsh
mv ~/.local/share/rstudio ~/.local/share/rstudio-backup
```

Alternatively, open a Finder window in the RStudio directory by typing the following command at the Terminal:

```zsh
open ~/.local/share/rstudio
```

## Linux

Create a backup by running the following command from the terminal. Then, send this backup with your support request:

```bash
mv ~/.local/share/rstudio ~/.local/share/rstudio-backup
```

Alternatively, open a File Browser in the RStudio directory by typing the following command at the Terminal:

```bash
xdg-open ~/.local/share/rstudio
```

# Resetting other preferences

Most problems do not require clearing preferences to resolve. However, you need to rename or remove this folder if to perform a full factory reset. 

## Windows

Open an Explorer window in the RStudio preferences directory by typing the following command into **Start** > **Run**:

```powershell
%appdata%\RStudio
```

Then, rename this directory to backup-RStudio and send it with your support request.

## macOS

To create a backup, run the following command from the terminal. Then include the file `~/backup-rstudio-prefs` with your support request:

```zsh
defaults read com.rstudio.desktop > ~/backup-rstudio-prefs
```

To delete these settings, run the following command from the terminal. 

:::{.callout-warning}
This action cannot be undone unless you have created the backup file. Deleting anything other than `com.rstudio.desktop` could create serious problems with your system.
:::

```zsh
defaults delete com.rstudio.desktop
```

## Linux

Create a backup by running the following command from the terminal. Then, send this backup with your support request:

```bash
mv ~/.config/rstudio ~/backup-rstudio
```

Alternatively, open a File Browser in the RStudio preferences directory by typing the following command at the Terminal:

```bash
xdg-open ~/.config/rstudio
```

| Platform | Download |
|----------|----------|
| Ubuntu 22 / 24, Debian 12 / 13 | [`rstudio-server-{{< var osVersion >}}-amd64.deb`](https://download2.rstudio.org/server/jammy/amd64/rstudio-server-{{< var osVersion >}}-amd64.deb) |
| RHEL 8 | [`rstudio-server-rhel-{{< var osVersion >}}-x86_64.rpm`](https://download2.rstudio.org/server/rhel8/x86_64/rstudio-server-rhel-{{< var osVersion >}}-x86_64.rpm) |
| RHEL 9 / 10 | [`rstudio-server-rhel-{{< var osVersion >}}-x86_64.rpm`](https://download2.rstudio.org/server/rhel9/x86_64/rstudio-server-rhel-{{< var osVersion >}}-x86_64.rpm) |
| SUSE 15 SP7 / openSUSE 15.6 | [`rstudio-server-{{< var osVersion >}}-x86_64.rpm`](https://download2.rstudio.org/server/opensuse15/x86_64/rstudio-server-{{< var osVersion >}}-x86_64.rpm) |

---
title: "R Notebook"
output: html_notebook
---

This is an [R Markdown](http://rmarkdown.rstudio.com) Notebook. When you execute code within the notebook, the results appear beneath the code. 

Try executing this chunk by clicking the *Run* button within the chunk or by placing your cursor inside it and pressing *Cmd+Shift+Enter*. 

```{r}
plot(cars)
```

Add a new chunk by clicking the *Insert Chunk* button on the toolbar or by pressing *Cmd+Option+I*.

When you save the notebook, an HTML file containing the code and output will be saved alongside it (click the *Preview* button or press *Cmd+Shift+K* to preview the HTML file). 

The preview shows you a rendered HTML copy of the contents of the editor. Consequently, unlike *Knit*, *Preview* does not run any R code chunks. Instead, the output of the chunk when it was last run in the editor is displayed.

---
title: "Code Sections"
date-meta: 2022-12-12
---

Code sections provide structure for both navigation and folding of long functions or other code control flow.

## Code folding

The **Source** pane in RStudio supports both automatic and user-defined folding for regions of code. Code folding provides the ability to easily show and hide blocks of code to make it easier to navigate source files and focus on the coding task at hand. For example, in the following source file the body of the `rescale01` has been folded, indicated by the gutter arrow pointing to the right, instead of the down or up:

![](images/rescale-function-collapse.png){fig-alt="A screenshot of a collapsed user-defined function."}

To expand the folded region:

- Click on the arrow in the gutter _or_  
- Click the icon that overlays the folded code _or_  
- Use the keyboard shortcut <kbd>Ctrl+Alt+Shift+L</kbd>  

## Foldable regions

The following types of code regions are automatically foldable within RStudio:

-   Braced regions (function definitions, conditional blocks, etc.)

-   Code chunks within Quarto or R Markdown documents

-   Text sections between headers within Quarto or R Markdown documents

-   Code sections (see below for details)

The following screenshot displays the arrow indicators for all the foldable regions in scripts:

-   Top-level code section
-   Function body
-   Conditional blocks

![](images/rescale-function-labeled.png){fig-alt="A diagram of foldable sections including the code section, function body, and conditional blocks."}

Arbitrary selections of code can be folded by using **Edit \> Folding \> Collapse**, or the keyboard shortcut: <kbd>Alt+L</kbd> (<kbd>Cmd+Option+L</kbd> on Mac).

Folded regions are preserved while editing a document; however all foldable regions are shown expanded by default when a file is closed and re-opened.

### Computational documents

In Quarto and R Markdown documents, the following sections can also be collapsed separately:

-   YAML metadata
-   Headings and subheadings
-   Code chunks

![](images/quarto-folding.png){fig-alt="A Quarto document, highlighting the sections that can be collapsed including the YAML, section headings, and code chunks."}

## Code sections

Code sections allow breaking a larger source file into a set of discrete regions for easy navigation between them. Code sections are automatically foldable.

For example, the following source file has three sections (one expanded and the other two folded):

![](images/plot-examples.png){fig-alt="A screenshot of an example .R file with 2 folded regions and one expanded region."}

To insert a new code section use the **Code** -\> **Insert Section** command. Alternatively, any comment line which includes at least four trailing dashes (-), equal signs (=), or pound signs (#) automatically creates a code section. For example, all of the following lines create valid code sections:

```r
# Section One ---------------------------------
# Section One ----

# Section Two =================================
# Section Two ====

### Section Three ############################# 
### Section Three ####
```

::: {callout-tip}

## Code section levels

As illustrated above, the line can start with any number of pound signs (#) so long as it ends with a space followed by four or more `-`, `=`, or `#` characters.

:::

To navigate between code sections, use the **Jump To** menu available at the bottom of the editor:

![](images/plot-examples-navigation.png){fig-alt="A screenshot of the Jump To Menu, which is at the bottom left of the Source Pane."}

Code sections can also be navigated with the **Document Outline** on the **Source Pane** menu bar.

![](images/plot-examples-outline.png){fig-alt="A screenshot of a .R file with code sections that can be navigated via the Document Outline"}

### Computational documents

In Quarto and R Markdown documents, headings/subheadings and labeled code chunks are automatically added to the document **Outline** and **Jump To** menus:

![](images/quarto-sections.png){fig-alt="A screenshot of a Quarto document with the Outline and Jump To menus expanded for navigating the document headings and code chunks."}


## Menu commands and shortcuts

The following menu commands and shortcuts are available for working with folded regions and code sections:

-   **Edit** -\> **Folding**:

    -   **Collapse** --- <kbd>Alt+L</kbd> (<kbd>Cmd+Option+L</kbd> on Mac)

    -   **Expand** --- <kbd> Shift+Alt+L</kbd> (<kbd>Cmd+Shift+Option+L</kbd> on Mac)

    -   **Collapse All** --- <kbd>Alt+O</kbd> (<kbd>Cmd+Option+O</kbd> on Mac)

    -   **Expand All** --- <kbd>Shift+Alt+O</kbd> (<kbd>Cmd+Shift+Option+O</kbd> on Mac)

-   **Code**:

    -   **Insert Section** --- <kbd>Ctrl+Shift+R</kbd> (<kbd>Cmd+Shift+R</kbd> on Mac)

    -   **Jump To** --- <kbd>Shift+Alt+J</kbd> (<kbd>Cmd+Shift+Option+J</kbd> on Mac)

::: {callout-tip}

The **Collapse All** command collapses all of the outermost foldable regions (rather than all of the nested regions within the source file).

:::

## Shiny Documents

This Quarto document is made interactive using Shiny. Interactive documents allow readers to modify parameters and see the results immediately. Learn more about Shiny interactive documents at <https://quarto.org/docs/interactive/shiny/>.

## Inputs and Outputs

You can embed Shiny inputs and outputs in your document. Outputs are automatically updated whenever inputs change. This demonstrates how a standard R plot can be made interactive:

```{r}
sliderInput("bins", "Number of bins:", 
            min = 1, max = 50, value = 30)
plotOutput("distPlot")
```

```{r}
#| context: server
output$distPlot <- renderPlot({
   x <- faithful[, 2]  # Old Faithful Geyser data
   bins <- seq(min(x), max(x), length.out = input$bins + 1)
   hist(x, breaks = bins, col = 'darkgray', border = 'white',
        xlab = 'Waiting time to next eruption (in mins)',
        main = 'Histogram of waiting times')
})
```

---
title: "Local Data"
date-meta: 2022-12-12
---

R packages such as `readr`, `arrow`, `data.table`, `readxl`, and `haven` provide functions to read in various formats of datasets. RStudio also provides an **Import Dataset** wizard for common file types which can also output the requisite R code to reproduce.

## Importing data

The data import features can be accessed from the **Environment pane** or from the **Tools** menu. The importers are grouped into 3 categories: 

- Text data 
- Excel data 
- Statistical data 

To access this feature, do one of the following:  

- Through the RStudio menu: **File** \> **Import Dataset**
- From the **Environment** pane use the **Import Dataset** dropdown menu:

![](images/import-dataset.png){fig-alt="A screenshot of the Import Dataset dropdown." width=700}

## Importing data from Text and CSV files

Importing "From Text (readr)" files allows reading in CSV files and in general, character delimited files using the [readr](https://readr.tidyverse.org/) package. The **Import Text Data** wizard provides support to:

-   Import from the file system or a url

-   Change column data types

-   Skip or include-only columns

-   Rename the data set

-   Skip the first N rows

-   Use the header row for column names

-   Trim spaces in names

-   Change the column delimiter

-   Encoding selection

-   Select quote, escape, comment and NA identifiers

For example, a csv can be imported by pasting this url <https://raw.githubusercontent.com/allisonhorst/palmerpenguins/main/inst/extdata/penguins.csv> and selecting "Import".


![](images/import-readr.png){fig-alt="A screenshot of the import Text Data popup."}

## Importing data from Text files

Importing using "From Text (base)" enables importing text files using the base R package:

![](images/import-base.png){fig-alt="A screenshot of the base Import Dataset wizard."}

## Importing data from Excel files

The Excel importer provides support to:

-   Import from the file system or a url

-   Change column data types

-   Skip columns

-   Rename the data set

-   Select an specific Excel sheet

-   Skip the first N rows

-   Select NA identifiers

For example, the **Import Excel Data** wizard can import an xls file from the `readxl` R package by pasting this url: <https://github.com/tidyverse/readxl/blob/main/inst/extdata/deaths.xlsx?raw=true> and pressing **Update**.

::: {.callout-tip}
This file contains text at the top of the file and therefore, requires the first few rows to be removed, which can be accomplished by changing `Skip: 4` and pressing **Update**.
:::

![](images/import-excel.png){fig-alt="A screenshot of the Import Excel Data popup wizard."}

The final step is to press **Import** to execute the code under **Code Preview** and import the data into RStudio.

## Importing data from SPSS, SAS and Stata files

The SPSS, SAS and Stata importer provides support to:

-   Import from the file system or a url

-   Rename the data set

-   Specify a model file

An example `.sav` file is available at: <https://github.com/rstudio/webinars/raw/master/23-Importing-Data-into-R/data/Child_Data.sav>. Paste that URL under **File/Url**, press **Update** and then press **Import**.

---
name: rstudio-update-electron
description: Use when updating the Electron version in the RStudio repository, e.g. bumping to a new release
---

# Update Electron

Updates the pinned Electron version across the RStudio codebase and verifies the result.

## Arguments

The user provides the **target Electron version** (e.g. `39.8.4`).

## Steps

### 1. Verify starting branch

Before doing anything else, confirm the current branch is `main`. Starting off anything other than `main` would base the work on the wrong commit.

```bash
git branch --show-current
```

If the output is not `main`, **stop immediately** and warn the user that they must switch to `main` (and pull the latest) before re-running this skill. Do not proceed with any further steps.

### 2. Update `NEWS.md`

Find the `### Dependencies` section and update the Electron version line:

```
- Electron <NEW_VERSION>
```

### 3. Update `src/node/desktop/package.json` and lockfile

Run from `src/node/desktop`:

```bash
cd src/node/desktop && npm install --save-dev --save-exact electron@<NEW_VERSION>
```

The `--save-exact` flag is **required** — Electron must be pinned to an exact version (e.g. `"electron": "39.8.5"`, not `"^39.8.5"`). This prevents uncontrolled upgrades across major/minor versions.

This updates both `package.json` and `package-lock.json` in one step. Confirm the command exits successfully (exit code 0). If it fails, report the error and stop.

After the install, verify that:
1. `package.json` has the exact version with **no `^` or `~` prefix**.
2. `package-lock.json` contains the new Electron version.

The lockfile must be included in the commit — if it drifts from the manifest, `npm ci` in CI will fail.

### 4. Run tests

Run from `src/node/desktop`:

```bash
cd src/node/desktop && npm test
```

Confirm the command exits successfully. If tests fail, report the failures and stop.

### 5. Done

Report that the Electron version has been updated and both `npm i` and `npm test` passed.

## Filing Bugs

If you're experiencing behavior that appears to be a bug in RStudio, you're welcome to [file an issue](https://github.com/rstudio/rstudio/issues/new). Before you do, please go through this pre-flight checklist:

1. Is the RStudio IDE itself the source of the error or problem? Many errors you see inside RStudio come from R or R packages. If you're having trouble with R, read [Getting Help with R](https://www.r-project.org/help.html) for pointers.

2. Is your issue a bug rather than a question? If you're having general trouble with RStudio or have questions for the RStudio community, the [RStudio Community Forum](https://forum.posit.co/c/rstudio-ide) is an excellent resource.

3. Are you the first person to report this issue? [Search the issue list](https://github.com/rstudio/rstudio/issues) to find out. If you aren't, the most helpful thing you can do is vote for the existing issue (add a +1 reaction to it), and optionally add a comment describing your own experience.

When you're ready to file an issue, see our [guide to writing good bug reports](https://github.com/rstudio/rstudio/wiki/Writing-Good-Bug-Reports) for more on how to write a great bug report.

## Enhancements

You're also welcome to submit ideas for enhancements to RStudio. When doing so, please [search the issue list](https://github.com/rstudio/rstudio/issues) to see if the enhancement has already been filed. If it has, vote for it (add a reaction to it) and optionally add a comment with your perspective on the idea.

See our [guide to writing feature requests](https://github.com/rstudio/rstudio/wiki/Writing-Good-Feature-Requests) for more on how to write a great feature request.

## RStudio Pro

This repo contains the open source version of RStudio and RStudio Server; its issue tracker is scoped to that version. To report issues or request new features for the professional version of RStudio, please get in touch with the Posit Support team at <support@posit.co>.

## Contributing Code

We welcome contributions to RStudio. To submit a contribution:

1. [Fork](https://github.com/rstudio/rstudio/fork) the repository and make your changes.

2. Ensure that you have signed the [individual](https://posit.co/individual-contributor-agreement) or [corporate](https://posit.co/corporate-contributor-agreement) contributor agreement as appropriate. You can send the signed copy to <contribute@posit.co>.

3. Submit a [pull request](https://help.github.com/articles/using-pull-requests).

We'll try to be as responsive as possible in reviewing and accepting pull requests. We appreciate your contributions very much!

## Pull Request Guidelines

Reviewing pull requests (PRs) takes real time from a small team, so we ask that every contribution meets the bar described below. PRs that don't will be closed.

### Build and Test Locally

Every pull request is expected to have been built and tested locally before it is opened. In the PR description, please include:

- **What you tested**: the scenarios, workflows, or behaviors you verified, including any edge cases you considered
- **Which platforms you tested on**: macOS, Windows, or Linux

If you were unable to test on a particular platform, say so explicitly. We'd much rather know up front than discover it during review or after merge.

### Limit on Open Pull Requests

We ask that external contributors keep at most two open pull requests at a time. Additional PRs opened while two are already open will be closed without review, but may be re-opened at later time.

Once a contributor has established a track record of thoughtful, high-quality contributions, we're happy to lift this limit on a case-by-case basis.

### AI-Assisted Contributions

Using AI tools to help write code or PR descriptions is not prohibited, but the responsibility for the contribution is yours. Before submitting, please:

- Read every line of the change and make sure you understand it
- Confirm the change actually addresses a real problem, not a hypothetical one inferred from the code
- Verify the change fits the surrounding code style and conventions
- Make sure the PR description matches what the diff actually does

PRs that read as unedited AI output will be closed. Examples include speculative refactors, fabricated issue descriptions, changes that don't match the linked issue, and generic "improvements" with no concrete motivation.

## Code of Conduct

As contributors and maintainers of this project, we pledge to respect all people who contribute through reporting issues, posting feature requests, updating documentation, submitting pull requests or patches, and other activities.

We are committed to making participation in this project a harassment-free experience for everyone, regardless of level of experience, gender, gender identity and expression, sexual orientation, disability, personal appearance, body size, race, ethnicity, age, or religion.

Examples of unacceptable behavior by participants include the use of sexual language or imagery, derogatory comments or personal attacks, trolling, public or private harassment, insults, or other unprofessional conduct.

Project maintainers have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct. Project maintainers who do not follow the Code of Conduct may be removed from the project team.

Instances of abusive, harassing, or otherwise unacceptable behavior may be reported by opening an issue or contacting one or more of the project maintainers.

This Code of Conduct is adapted from the Contributor Covenant, version 1.0.0, available at <https://www.contributor-covenant.org/version/1/0/0/code-of-conduct.html>.

---
title: "Log files"
date-meta: 2025-01-07
---

If you are experiencing difficulties with the RStudio Desktop IDE, then finding your RStudio application logs could expose the issue. To browse the directory containing the logs from within RStudio Desktop IDEi, open **Help Menu** > **Diagnostics** > **Show Log Files**.

## RStudio Desktop IDE is not starting

### Windows

Open an Explorer window to the log file directory by typing the following command into **Start** > **Run**:

```powershell
%LOCALAPPDATA%\RStudio\log
```

### macOS

Open a Finder window to the log file directory by typing the following command at a terminal:

```zsh
open ~/.local/share/rstudio/log
```

### Linux

The log file is located in this directory: 

```bash
~/.local/share/rstudio/log
```

Open the log files directly from the file browser or with the text editor of your choice.

---
title: "renv"
date-meta: 2022-12-12
---

The [`renv` package](https://rstudio.github.io/renv/articles/renv.html) helps you create **r**eproducible **env**ironments for your R projects. Use `renv` to make your R projects more:

**Isolated**: Installing a new or updated package for one project won't break your other projects, and vice versa. That's because `renv` gives each project its own private package library.

**Portable**: Easily transport your projects from one computer to another, even across different platforms. `renv` makes it easy to install the packages your project depends on.

**Reproducible**: `renv` records the exact package versions you depend on, and ensures those exact versions are the ones that get installed wherever you go.

## Workflow

The general workflow when working with `renv` is:

1.  Call [`renv::init()`](https://rstudio.github.io/renv/reference/init.html) to initialize a new project-local environment with a private R library,

2.  Work in the project as normal, installing and removing new R packages as they are needed in the project,

3.  Call [`renv::snapshot()`](https://rstudio.github.io/renv/reference/snapshot.html) to save the state of the project library to the lockfile (called `renv.lock`),

4.  Continue working on your project, installing and updating R packages as needed.

5.  Call [`renv::snapshot()`](https://rstudio.github.io/renv/reference/snapshot.html) again to save the state of your project library if your attempts to update R packages were successful, or call [`renv::restore()`](https://rstudio.github.io/renv/reference/restore.html) to revert to the previous state as encoded in the lockfile if your attempts to update packages introduced some new problems.

The [`renv::init()`](https://rstudio.github.io/renv/reference/init.html) function attempts to ensure the newly-created project library includes all R packages currently used by the project. It does this by crawling R files within the project for dependencies with the [`renv::dependencies()`](https://rstudio.github.io/renv/reference/dependencies.html) function. The discovered packages are then installed into the project library with the [`renv::hydrate()`](https://rstudio.github.io/renv/reference/hydrate.html) function, which will also attempt to save time by copying packages from your user library (rather than reinstalling from CRAN) as appropriate.

Calling [`renv::init()`](https://rstudio.github.io/renv/reference/init.html) will also write out the infrastructure necessary to automatically load and use the private library for new R sessions launched from the project root directory. This is accomplished by creating (or amending) a project-local `.Rprofile` with the necessary code to load the project when the R session is started.

If you'd like to initialize a project without attempting dependency discovery and installation -- that is, you'd prefer to manually install the packages your project requires on your own -- you can use `renv::init(bare = TRUE)` to initialize a project with an empty project library.

For full details, see the [`renv` package documentation](https://rstudio.github.io/renv/articles/renv.html).

## New project, use renv with this project

The general details on creating a new Project in RStudio are covered in [RStudio Projects](../../code/projects.html). Users can opt in to using `renv` when creating a new Project in RStudio.

![](images/use-renv-with-project.png){fig-alt="The New Project wizard in RStudio, with the 'use renv with this project' option selected."}

Select the **Use renv with this project** checkbox, and the new project will automatically create and activate the necessary scaffolding for `renv` within that project. Since those files now exist in the newly created project, you can skip step 1 from the above [workflow](#Workflow).

![](images/new-renv-project.png){fig-alt="The Files pane in RStudio, displaying the newly created project with a 'renv' folder, a renv.lock file, and a .Rprofile."}

---
title: "Custom Shortcuts"
date-meta: 2022-12-12
---

Users can customize or bind keyboard shortcuts to execute:  

- RStudio application commands 
- Editor commands 
- User defined R functions 
- [RStudio Addins](https://rstudio.github.io/rstudioaddins/) or the [`shrtcts`](https://pkg.garrickadenbuie.com/shrtcts/) package

Access the keyboard shortcuts from the RStudio menu: **Tools** \> **Modify Keyboard Shortcuts**:

![](images/keyboard-shortcuts.png){fig-alt="A screenshot of the Tools menu bar highlighting the Modify Keyboards Shortcuts" width="300"}

Selecting **Modify Keyboard Shortcuts** will display available editor commands (commands that affect the current document's contents, or the current selection), alongside RStudio commands (commands whose actions are scoped beyond just the current editor).

![](images/keyboard-shortcut-table.png){fig-alt="A screenshot of the available keyboard shortcuts."}

Each row represents a particular command binding:

-   The command's **Name**
-   The keyboard **Shortcut** it is bound to
-   The **Scope** where that binding is active

Modify a command's shortcut by clicking on the cell containing the current shortcut key sequence, and typing the new sequence to bind the command to. As you type, the current row will be marked to show that the binding has been updated, and the shortcut field will be updated based on the keys entered.

![](images/modify-shortcut.png){fig-alt="A screenshot of a customized shortcut"}

If a mistake was made, press <kbd>Backspace</kbd> to clear a single key combination, or <kbd>Delete</kbd> to reset that binding to the original value it had when the widget was opened.

Commands can be either a single 'key chord'; e.g. <kbd>Ctrl+Alt+F</kbd>, or also to a sequence of keys, as in <kbd>Ctrl+X Ctrl+F</kbd>.

You can also filter, based on the names of commands, by typing within the **Filter...** search box at the top left, to more easily find commands of interest:

![](images/filter-shortcut.png){fig-alt="A screenshot of the keyboard shortcut wizard filtered to 'reflow'"}

After a keyboard shortcut has been modified, press **Apply** and the shortcuts will be applied to the current session and saved for future sessions.

## Handling conflicts

By default, RStudio application command bindings will override editor command bindings. If an editor command and an RStudio command are both bound to the same key sequence, the RStudio command will take precedence and the editor command will not be executed. Editor commands that are masked by an RStudio command will be crossed out and have a small icon showing the masking command:

![](images/masked-shortcut.png){fig-alt="A screenshot of a 'masked' shortcut which indicates the conflict with 'Clear Console'"}

If two commands are bound to the same key sequence, then that conflict will be highlighted and displayed in yellow.

![](images/shortcut-conflict.png){fig-alt="A screenshot of a shortcut conflict, displaying the specific command it conflicts with."}

## Saving and loading

The RStudio keybindings are saved as JSON files in the directory `~/.R/rstudio/keybindings/` \-- the bindings for the editor and RStudio itself at:

**RStudio 1.3, and later (Windows)**

    ~/AppData/Roaming/RStudio/keybindings/rstudio_bindings.json
    ~/AppData/Roaming/RStudio/keybindings/editor_bindings.json

**RStudio 1.3, and later (MacOS/Linux)**

    ~/.config/rstudio/keybindings/rstudio_bindings.json
    ~/.config/rstudio/keybindings/editor_bindings.json

---
title: "Publishing"
date-meta: 2025-04-09
---

The following documentation is an overview of "Push-button Deployment" in RStudio. 

For full documentation on options for specific platforms:  

-   [Posit Connect User Guide](https://docs.posit.co/connect/user/connecting/)
-   [RPubs - Getting Started](https://rpubs.com/about/getting-started)
-   [ShinyApps.io User Guide](https://docs.posit.co/shinyapps.io/)

## Push-button deployment

The blue **publishing icon** in RStudio indicates built-in support for publishing the currently selected type of content to Posit Connect, Shinyapps.io, or RPubs.com.

![The RStudio publishing icon](images/publishIcon_2x.png){fig-alt="The RStudio publishing icon"}

The blue **publishing icon** is present in the following locations:

-   The upper right of the file editor

-   The document **Viewer** pane when viewing a document

-   The embedded **Viewer** when running a Shiny application

-   The **Plots** pane

Click the blue **publishing icon** to open a publishing dialog where you can name your content and select additional files to include in the deployment. By default, RStudio will try to infer the data files and scripts that are used in your content. This window lets you refine those file selections.

![](images/publishing-quarto.png){fig-alt="RStudio publishing dialog for a Quarto document"}

Typically, RStudio is able to determine automatically which files are needed to render your document on the remote server. However, there are situations in which it will miss a file (for instance, if it isn't referenced directly in your document). The **Add More\...** button lets you add files to the bundle, so that they will be available on the server when your document is rendered. You can also use the `resource_files` field in the document's YAML header to add additional files.

Deployed data files must be in the same directory as the Shiny application or R Markdown/Quarto document, or in a subdirectory of that location. Files stored elsewhere on the computer will not be available on the remote server and cannot be included in the content bundle.

Click **Publish** after verifying the settings.

## Publishing documents

You can publish R Markdown (`.Rmd`) and Quarto (`.qmd`) documents to Posit Connect or RPubs.com.

![Publish to RPubs or Posit Connect](images/connecting-2.png){fig-alt="Publish to RPubs or Connect"}

[RPubs](http://rpubs.com/) is a service for easily sharing public R Markdown documents. RPubs is not related to Posit Connect, and you should always choose "Posit Connect" if you wish to publish your content to Posit Connect.

## Publishing Shiny apps

You can publish Shiny apps to Posit Connect or shinyapps.io.

![](images/connect-account.png){fig-alt="Connect account in RStudio"}

## Including secrets

Posit Connect supports including secrets and other sensitive information as [Vars (Environment Variables)](https://docs.posit.co/connect/user/content-settings/index.html#content-vars). When developing content for Connect, you should never place secrets (keys, tokens, passwords, etc.) in the code itself.

RStudio also supports the inclusion of environment variables defined in the user/project `.Renviron` file when publishing content to Posit Connect. 

![](images/publish-env-vars.png){fig-alt="Screenshot of including environment variables when publishing from RStudio."}

One or more environment variables can be selected for inclusion on Posit Connect. On publish, environment variables are sent over an encrypted connection and are not stored in the bundle. Environment variables are set prior to deployment so that your code can use them and the first deployment can still succeed. This means that if the deployment fails, the values will still be updated.

Reference the Posit Connect User Guide section on [Vars (Environment Variables)](https://docs.posit.co/connect/user/content-settings/index.html#content-vars) for more information. The `rsconnect` R package can also include environment variables when publishing programatically. For more information, reference the `[rsconnect` documentation for envVars](https://rstudio.github.io/rsconnect/reference/deployApp.html#arg-envvars)

## Citing RStudio

To cite RStudio in publications, retrieve the ciation information by running `RStudio.Version()`. For example:

```{.r filename="console"}
> RStudio.Version()
$citation

To cite RStudio in publications use:

  Posit team (2026). RStudio: Integrated Development Environment for R. Posit Software,
  PBC, Boston, MA. URL http://www.posit.co/.

A BibTeX entry for LaTeX users is

  @Manual{,
    title = {RStudio: Integrated Development Environment for R},
    author = {{Posit team}},
    organization = {Posit Software, PBC},
    address = {Boston, MA},
    year = {2026},
    url = {http://www.posit.co/},
  }

```


## Additional content

For additional details or other content types, refer to the product-specific documentation:

-   [Posit Connect User Guide](https://docs.posit.co/connect/user/connecting/)
-   [RPubs - Getting Started](https://rpubs.com/about/getting-started)
-   [ShinyApps.io User Guide](https://docs.posit.co/shinyapps.io/)

---
title: "Navigating Code"
date-meta: 2022-12-12
---

RStudio includes a number of features to enable rapid navigation through source code. Learning these features can be a major productivity enhancement and can also assist in gaining a better understanding of source code written by others on your team or within external packages.

## Find in Files

Given a specific directory, Find in Files allows recursively searching every file for each occurrence of a given string. To display the Find in Files dialog box, go to the RStudio menu: **Edit** \> **Find in Files** or use the keyboard short: <kbd>Ctrl+Shift+F</kbd>.

![](images/find-in-files.png){fig-alt="A screenshot of the Find in Files popup with the 'Find' text prompt."}

**Find in Files** also allows for further customization of the search with regular expressions and filters for specific file types. Search results will display in the pane adjacent to the console. For each matching string, the following will be displayed:

-   The file path

-   The line number of each occurrence

-   The matching string (highlighted), in the context of the current line

Double clicking the line will open the file in the RStudio source editor.

## Go to File/Function

If the name of the source file or function is known, the "Go to File/Function" search box on the main RStudio toolbar allows for quick navigation to it:

![](images/go-to-function.png){fig-alt="A screenshot of the Go to File/Function menu item on the Source pane of RStudio."}

The **Go to File/Function** feature works from a constantly updated index of your source code. The specific source files to index are determined as follows:

1.  If an [RStudio Project](projects.html) is active, then all R source files within the project directory are indexed.

2.  If a Project is not active then all currently open R source files are indexed.

The keyboard shortcut for Go to File/Function is <kbd>Ctrl+.</kbd> which will open up a floating **Go to File/Function** dialog box.

![](../ui/images/go-to-file.png){fig-alt="A screenshot of the 'Go to File/Function' popup and it's matched search prompt"}

## Go to Function Definition

Since an index of the current Project's source code (as described above) is maintained, RStudio can also help with quick navigation to the definition of any R function. To navigate a function definition, place the cursor on the function name (it doesn't have to be fully selected), and then from the RStudio menu choose the **Code** \> **Go to Function Definition** command.

From either the source editor or the console, the following shortcuts provide access to the function definition:

-   Using the <kbd>F2</kbd> keyboard shortcut

-   Using <kbd>Ctrl+Click</kbd> (<kbd>Cmd+Click</kbd> on Mac) with the mouse

It is possible to navigate to both user-defined own functions (defined in R source files) and any other function defined within an R package. For functions defined within packages, the code is displayed in a special **Source Viewer** pane, which is read-only.

## Navigating within a Source File

There are several ways to navigate through the code within a source file:

-   The go to function definition feature described above also works for functions within the current source file (giving precedence to functions defined within the calling scope).

-   The **Jump to Line** command can be used to go to any line in the current file. Keyboard shortcut: **Alt+Shift+G** (Mac: **Option+Shift+Cmd+G**).

-   Use the function menu to quickly jump to functions by name.

## Going back and forward

RStudio maintains a list of active navigations and allows you to traverse them using the **Back** and **Forward** commands (available on the Edit menu and on the far left of the source editor toolbar). This is used to quickly return to the previous editing location when navigating through code, which is especially useful when navigating through a sequence of function calls.

**Back** and **Forward** apply to the following navigation gestures:

-   Opening a document (or switching tabs)

-   Going to a function definition

-   Jumping to a line

-   Jumping to a function using the function menu

- **Back** shortcut: <kbd>Ctrl+F9</kbd> (<kbd>Cmd+F9</kbd> on Mac)  
- **Forward** shortcut: <kbd>Ctrl+F10</kbd> (<kbd>Cmd+F10</kbd> on Mac)  

![](images/back-forward-arrows.png){fig-alt="A screenshot of the Source Pane menu in RStudio and the Back/Forward arrows" width="350" height="35"}

---
name: rstudio-run-playwright-tests
description: How to run RStudio Playwright tests in Desktop and Server modes. Use this skill whenever the user asks to run, execute, or launch Playwright tests against RStudio - whether on Desktop (local) or Server (remote). Also use when the user asks about the test command, environment variables, or how to point tests at a server URL. Trigger on phrases like "run the test", "execute on server", "run it on desktop", "run against <IP>", or any request involving npx playwright test for the RStudio test suite.
---

# Running RStudio Playwright Tests

Run from `e2e/rstudio/`. Setup, env vars, tags, sandbox, external-server config,
and the cross-env / dotenv helpers all live in `e2e/rstudio/README.md` -- open
it when you need any of that.

## The four run modes

| Mode | Command | Platforms |
|------|---------|-----------|
| Installed desktop | `npm run test:desktop` | macOS, Linux, Windows |
| Dev desktop build | `npm run test:desktop-dev` | macOS, Linux, Windows |
| Installed server | `npm run test:server` | Linux |
| Dev server build | `npm run test:server-dev` | macOS, Linux |

Append a test path or Playwright flags after the script name:

```bash
npm run test:desktop -- tests/path/to/test.test.ts
npm run test:server-dev -- -g "test name here"
```

### `test:desktop-dev` prerequisites (from repo root)

1. `cmake --build build` -- C++ session
2. `(cd src/gwt && ant draft)` -- GWT transpile (2-5 min; rerun after Java edits)
3. `(cd src/node/desktop && npm ci)` -- Electron deps

Tests that exercise `doRestart()` (e.g. uninstall Posit Assistant) aren't
supported in this mode.

## Test running protocol

Before the first run in a conversation, pick a mode -- ask the user which of
the four they want (use `AskUserQuestion` if available), filtering out modes
unsupported by the host platform. If a `build/` directory exists at the repo
root, list `test:desktop-dev` first in the options. Then run the tests
directly; don't prompt for approval before kicking off the run. Prefer
`npm run ...` over raw `npx playwright test`.

After the first run, don't re-ask to re-run the same file in the same mode --
just go. Switching modes (not files) warrants a fresh mode-pick.

## Profiling a slow test

When a test passes but is slower than expected, don't guess at the cause --
capture a trace and read per-action timing. Re-run with `--trace on`, then
unzip the `trace.zip` and pair the `before`/`after` events in `test.trace` by
`callId` to rank actions by duration. The full recipe (with a ready-to-run
Node parser) is in the "Profiling a slow test" section of
`e2e/rstudio/README.md`.

Common culprit it surfaces: a value-reading action (e.g. `locator.inputValue()`)
on an element not yet in the DOM blocks on the action timeout -- probe with
`locator.count()` instead and open the editor/popup before reading from it.

---
title: "Code Snippets"
engine: knitr
date-meta: 2022-12-12
---

Code snippets are text macros that are used for quickly inserting common snippets of code. For example, the `fun` snippet inserts an R function definition:

![](images/fun-snippet.png){fig-alt="A screenshot of the output from using the `fun` snippet to autocomplete to function definition."}

Selecting the `fun` snippet from the completion list will insert a `function()` skeleton along with several text placeholders. The placeholders can be filled interactively and then click <kbd>tab</kbd> to advance to the next placeholder:

![](images/fun-expanded.png){fig-alt="A screenshot of the output snippet highlighted on the first text placeholder."}

Other useful snippets include:

-   `lib` for the `library()` function

-   `mat` for defining matrices

-   `if`, `el`, and `ei` for conditional expressions

-   `apply`, `lapply`, `sapply`, etc. for the apply family of functions

-   `shinyapp` for defining a basic shiny app structure

Snippets are a great way to automate inserting common/boilerplate code and are available for R, C/C++, Python, JavaScript, and several other languages.

## Inserting snippets

As illustrated above, code snippets show up alongside other code completion results and can be inserted by picking them from the completion list. By default the completion list will show up automatically when you pause typing for >= 250 milliseconds and can also be manually activated via the **Tab** key. In addition, if you have typed the character sequence for a snippet and want to insert it immediately (without going through the completion list) you can press **Shift+Tab**.

### Markdown snippets

For markdown snippets within R Markdown or Quarto documents using the <kbd>Shift+Tab</kbd> sequence is always required as there is no standard tab completion available within the markdown editing mode.

For example, here is a snippet to insert a Callout Tip in a Quarto document. This snippet would require typing `callout` and then <kbd>Shift+Tab</kbd> to insert the callout snippet and begin interactively editing the title, then the body.

```markdown
snippet callout
  :::{.callout-tip}
  ## ${1:title}
    
  ${2:body}
  :::
```


## Customizing snippets

Users can edit the built-in snippet definitions and even add snippets of their own via the **Edit Snippets** button in **Global Options** -\> **Code**:

![](images/edit-snippets.png){fig-alt="A screenshot of the Edit Snippets wizard, displaying the snippets for R."}

Custom snippets are defined using the `snippet` keyword. The contents of the snippet should be indented below using the `<tab>` key (rather than with spaces). Variables can be defined using the form `{1:varname}`. For example, here's the definition of the `setMethod` snippet:

```markdown
snippet sm
    setMethod("${1:gen}", ${2:"class"}, function(${3:obj}, ...) {
        ${0}
    })
```

Because `$` is used as a special character to denote where the cursor should jump after completing each section of a snippet, in order to insert a literal `$` it must be escaped as `\$`.

### Including R code

R code can also be executed in a custom snippet. Use `` `r ` `` anywhere in the snippet; the R code will be executed when the snippet is expanded, and the result inserted into the document.

As an example, here is a variant of the `ts` snippet to insert a datetime into a code section:

```{verbatim, lang="markdown"}
snippet time
    `r paste("#", Sys.time(), "------------------------------\n")`

```

## Saving and sharing snippets

Customized snippets for a given language are written into the `~/.R/snippets` directory. For example, the customized versions of R and C/C++ snippets are written to:

### RStudio 1.3 and later (Windows)

``` bash
%appdata%/Roaming/RStudio/snippets/r.snippets
%appdata%/Roaming/RStudio/snippets/c_cpp.snippets
```

### RStudio 1.3 and later (macOS/Linux)

``` bash
~/.config/rstudio/snippets/r.snippets
~/.config/rstudio/snippets/c_cpp.snippets
```

These files can be edited directly to customize snippet definitions or use the **Edit Snippets** dialog as described above. To move custom snippet definitions to another system then simply copy the files across to the same path.

---
title: "Terminal"
date-meta: 2022-12-12
---

The RStudio terminal provides access to the system shell from within the RStudio. It supports full-screen terminal applications such as vim, Emacs, and tmux as, well as regular command-line operations with line-editing and shell history.

Potential uses of the shell including advanced source control operations, execution of long-running jobs, remote logins, system administration of Posit Workbench or RStudio Server, and the aforementioned full-screen terminal programs.

This article does not attempt to cover fundamentals on when and how to use a system shell. Instead, it focuses on the features, design, options, and limitations of the RStudio terminal feature itself.

Unlike most RStudio features, the nature of the terminal leads to several platform-specific differences. These primarily break down into two categories: Windows, and everything else (Mac, Linux, and Server). Windows provides emulators for unix-based terminals such as Git Bash, Windows Subsystem for Linux, or PowerShell.

## Getting started

The **Terminal tab** is next to the **Console tab**. Click on the Terminal tab and a new terminal session will be created (if there isn't one already).

-   If the tab isn't visible, display it via **Tools** \> **Terminal** \> **Move Focus to Terminal** (or use the keyboard shortcut <kbd>Shift+Alt+M</kbd> or <kbd>Shift+Option+M</kbd> on Mac).

-   The full list of terminal-related keyboard shortcuts is in the Reference: Keyboard Shortcuts [Terminal section](../../reference/shortcuts.html#terminal). Most terminal-related commands can be found on the **Terminal drop-down** menu in the terminal pane, and on the **Tools** > **Terminal** menu.

Here's a terminal with the output of simple command:

![](images/terminal-basic.png){fig-alt="screenshot of terminal showing simple output"}

The visual appearance of the terminal is controlled via the **Tools** \> **Global Options** \> **Appearance** settings. 

## Multiple terminals

RStudio supports multiple terminal sessions. To start another terminal session, use the **New Terminal** command on the Terminal drop-down menu, or <kbd>Alt+Shift+R</kbd>.

![](images/terminal-menu.png){fig-alt="screenshot showing terminal menu opened"}
Each terminal session is independent, with its own system shell process and buffer. Switch between them by:  

- Using the arrows next to the drop-down menu  
- Clicking on the terminal's name in the drop-down  
- Using the **Previous Terminal**/**Next Terminal** drop-down menu commands. The drop-down button shows the name of the currently selected terminal session ("Terminal 1" in the following screenshot):  

![](images/terminal-menu-labeled.png){fig-alt="screenshot showing navigation between multiple terminals"}

## Terminal names

Terminal sessions have a default name, "Terminal 1", "Terminal 2", and so on. Rename the current terminal via the **Rename Terminal** command on the drop-down. 

Thus, in your workflow, you can create multiple terminals and give them meaningful names to simplify navigation. A collection of named terminals, or "terminal set", is generally associated with an RStudio project.

An alternative (or complementary) approach is to use a terminal multiplexer such as Tmux or Screen.

## Execute in terminal

When editing files in the RStudio editor, any selection (or the current line if nothing is selected) can be sent to the active terminal via <kbd>Ctrl+Alt+Enter</kbd> (<kbd>Cmd+Alt+Enter</kbd> on the Mac). If a single-line was sent to the terminal the cursor will advance automatically to the next line, allowing single-stepping.

In following example:  

1. A simple Python source file was loaded
2. A Python interpreter started in the current terminal
3. Ctrl+Alt+Enter used to step through the script:

![](images/terminal-python.png){fig-alt="screenshot of a simple Python REPL example"}

This is just an example; for more powerful integrated Python support [look at the reticulate package](https://rstudio.github.io/reticulate/).

If a shell file is being edited (`*.sh`), <kbd>Ctrl+Enter</kbd> (<kbd>Cmd+Enter</kbd> on Mac) can be used to single-step, as can the **Run** toolbar button. This will also work on Windows, but no check is done that the shell-type loaded in the active terminal session matches the commands being sent.


![](images/terminal-shell.png){fig-alt="screenshot example of running a shell script"} 

The **Run Script** button does the same as prior versions of RStudio and will save and run the entire script via `system()` in the R Console. This button does not appear in Windows.

## Busy terminals

Programs running in a terminal do not block the rest of the RStudio user-interface, so work can continue working in RStudio even when one or more terminal sessions have a child process running.

A terminal with child processes is considered *busy* by RStudio, and will have:

1. **(busy)** next to the terminal name.
2. The close **x** changes to a **STOP** button.

![](images/terminal-close.png){fig-alt="The RStudio integrated terminal, highlighting the 'x' button to close."}

![screenshot showing a busy terminal](images/terminal-sleep.png){fig-alt="screenshot showing a busy terminal"}

This "busy detection" feature is only available on Mac, Linux, and Posit Workbench / RStudio Server and not on Windows.

## Closing terminal sessions

To close a terminal session, use the **Close Terminal** command on the Terminal drop-down menu, click the **x** on the far-right of the Terminal pane toolbar, or type **exit** from within the shell itself.

As discussed earlier, if a terminal is currently busy, the **x** changes to a **STOP** button.

Clicking the **STOP** button will trigger the **Interrupt Current Terminal** command, sending an interrupt to the terminal; this may close the currently running program (the program itself decides what to do when receiving an interrupt), but will not close the terminal.

Finally, if the terminal feature it not useful to your workflow, you can remove the tab altogether by clicking the **x** on the Terminal tab itself. This will close all running terminal sessions, including any custom-named terminal sessions. Subsequent instances of RStudio will not show the Terminal tab: to bring it back, use **Tools** \> **Terminal** \> **Move Focus to Terminal** (keyboard shortcut: <kbd>Shift+Alt+M</kbd> or <kbd>Shift+Option+M</kbd> on Mac).

## Terminal buffer

The terminal buffer keeps the last 1000 lines of output when running non-full-screen terminal programs. Scroll through this buffer using the scrollbars (via the mouse) or a mouse-wheel if the system supports it. Full-screen programs typically have their own built-in buffers and navigation conventions.

Clearing the display with the native shell command (e.g. `clear` for a Posix-style shell, `cls` for a Windows Command Prompt, or `Clear-Host` for PowerShell) will only clear the visible portion of the buffer. To clear the entire buffer, use <kbd>Ctrl+L</kbd> when focus is in the terminal.

The mouse can be used to select text in the terminal so it can be copied & pasted elsewhere.

To send the entire terminal buffer to a new RStudio editor buffer, use the **Copy Terminal to Editor** command on the terminal drop-down menu.

---
title: "Python"
date-meta: 2022-12-12
---

This page explores how Python can be used together with R and RStudio.

## Getting started

RStudio uses the [reticulate](https://rstudio.github.io/reticulate/) R package to interface with Python, and so RStudio's Python integration requires:

1.  An installation of Python (2.7 or newer; 3.5 or newer preferred), and

2.  The reticulate R package (1.20 or newer, as available from [CRAN](https://cran.r-project.org/package=reticulate))

### Installing python

First, Python needs to be installed on the machine. For Posit Workbench or RStudio Server, admins can follow the instructions at <https://docs.posit.co/resources/install-python/>

For local installations, Python can be installed in several ways:

-  (Recommended) Using `reticulate::install_miniconda()`, to install a [Miniconda](https://docs.conda.io/en/latest/miniconda.html) distribution of Python using the reticulate package,

-  (Windows) Install Python via the official Python binaries available from <https://www.python.org/downloads/windows/>,

-  (macOS) Install Python via the official Python binaries available from <https://www.python.org/downloads/mac-osx/>,

-  (Linux) Install Python either from sources, or via the version of Python provided by your operating system's package manager. See <https://docs.python.org/3/using/unix.html> for more details. If you are installing Python from sources yourself, prefer installing it into a location like `/opt/python/<version>`, so that RStudio and reticulate can more easily discover it.

::: {.callout-warning}

## `--enable-shared` requirement

reticulate is unable to bind to a version of Python without an accompanying shared library available. If installing Python from sources, it must be configured with `--enable-shared`:

``` bash
./configure --enable-shared
make
make install
```

or for `pyenv`

``` bash
env PYTHON_CONFIGURE_OPTS="--enable-shared" pyenv install ${PY_VERSION}
```

:::



### Installing reticulate

The reticulate package can be installed from CRAN, with:

``` r
install.packages("reticulate")
```

::: {.callout-note}

## Building from source

The dev version of reticulate can be installed from GitHub, with:

```r
# If needed, install.packages("devtools")
devtools::install_github("rstudio/reticulate")
```

If you are installing reticulate from sources or GitHub, you will need the requisite build tools available - see <https://r-pkgs.org/Setup.html#setup-tools> for more details.

:::

## Using Python

The reticulate package makes it possible to load and use Python within the currently running R session. After reticulate has been installed, Python scripts (with the extension .py) can be opened, and the code within executed interactively, similarly to R.

![](images/python-hello-world.png){fig-alt="Screenshot of a simple Python script run via reticulate in the console."}

RStudio uses the reticulate Python REPL to execute code, and automatically switches between R and Python as appropriate for the script being executed.

When the reticulate REPL is active, objects in the R session can be accessed via the r helper object. For example, `r["mtcars"]` can be used to access the mtcars dataset from R, and convert that to a pandas DataFrame (if available), or a Python dictionary if not.


![](images/python-mtcars.png){fig-alt="A screenshot of the console displaying the dataframe contents of 'mtcars' in Python from R"}

## Selecting a default version of Python

It is possible to configure a default version of Python to be used with RStudio via **Tools** > **Global Options** > **Python**:

![](images/python-versions.png){fig-alt="Screenshot of the Global Options > Python menu and choosing a specific Python interpreter."}

The "Python interpreter:" text box shows the default Python interpreter to be used (if any). If you already know the location of the Python interpreter you wish to use, you can type the location of the interpreter into that text box.

Otherwise, Python interpreters can be discovered on the system by clicking the **Select** button:

![](images/python-interpreter.png){fig-alt="Screenshot of the available Python versions on the system"}

RStudio will search for Python interpreters via a few different methods:

-   On the PATH;

-   For virtual environments, located within the `~/.virtualenvs` folder;

-   For Conda environments, as reported by `conda --list`,

-   For [pyenv](https://github.com/pyenv/pyenv) Python installations located in `~/.pyenv`,

-   For Python installations located in `/opt/python`.

The `RETICULATE_PYTHON` environment variable can also be used to configure the default version of Python to be used by reticulate. If set, that environment variable will take precedence over any value configured via RStudio options.

### Custom Python locations

If Python is installed into a custom location, set the following R option to make it visible to RStudio:

``` r
options(rstudio.python.installationPath = "/path/to/python")
```

This can be set within an appropriate R startup file; for example, the R installation's `etc/Rprofile.site`.

## Environment pane

When the reticulate Python REPL is active, the **Environment** pane will update to show any available Python objects. For example:

![](images/python-environment.png){fig-alt="A screenshot of the Environment page, displaying Python specific objects"}

The **Environment** pane will automatically update to show objects as they are added and removed.

Mutated objects may not update in the **Environment** pane until the **Environment** pane is explicitly refreshed by pressing the **Refresh** button in the top right corner of the **Environment** pane.

## Learning more

For more detailed documentation around how Python, R, and reticulate can be used together, please consult the reticulate documentation online at <https://rstudio.github.io/reticulate/>.

---
name: rstudio-migrate-tests-selenium-to-playwright
description: Migrate Python Selenium/Selene electron tests to TypeScript/Playwright. Use when converting tests from rstudio-ide-automation/rstudio_server_pro/electron-tests/ to rstudio/e2e/rstudio/tests/.
---

# Migrate Electron Tests to Playwright

Converts Python test files from `rstudio-ide-automation/rstudio_server_pro/electron-tests/` to TypeScript/Playwright tests in `rstudio/e2e/rstudio/tests/`.

## Arguments

The user provides one or more targets:
- A single file: `/rstudio-migrate-tests-selenium-to-playwright test_desktop_console.py`
- A directory: `/rstudio-migrate-tests-selenium-to-playwright GlobalPrefs/`
- A keyword: `/rstudio-migrate-tests-selenium-to-playwright citations`

## Hard Rules

1. **Load skills and the README first** — Before doing any conversion work, always: (a) load `rstudio-create-playwright-tests`; (b) read `e2e/rstudio/README.md` in full, the suite's primary reference (read it fresh for each migration; don't assume it was read earlier in the session); (c) load `rstudio-run-playwright-tests`, whose run protocol governs the verification in Hard Rule 5.
2. **Check MIGRATION_FROM_SELENIUM_PROGRESS.md** — Before starting, verify the file hasn't already been converted or partially converted. Located at `e2e/rstudio/docs/MIGRATION_FROM_SELENIUM_PROGRESS.md`.
3. **Tests must work on Desktop and Server, and on Windows, macOS, and Linux** — Use the unified fixture (`@fixtures/rstudio.fixture`). Don't hardcode Desktop-only or OS-specific patterns; use cross-platform shortcuts (`ControlOrMeta` where appropriate) and `process.platform` guards, or tag mode/OS-specific tests (`@desktop_only`, `@windows_only`, etc.).
4. **No Claude dependency** — All test infrastructure must be runnable from terminal, CI, and GitHub Actions. Claude subagents are a convenience layer, not a requirement.
5. **A test isn't migrated until it passes.** Run the converted TypeScript test against a live RStudio instance (Desktop or Server, depending on target). Retry up to 3 times. If it still fails, mark it `test.fixme()` with a blocker note and track it as Fixme in `MIGRATION_FROM_SELENIUM_PROGRESS.md`. Do not list a fixme test as migrated in summaries, PR descriptions, or progress tracking.

## Steps

### Step 1: Resolve the target

- Search for the file under `electron-tests/`
- Read the full Python source — understand test methods, fixtures, imports, page objects
- Check `e2e/rstudio/docs/MIGRATION_FROM_SELENIUM_PROGRESS.md` for current status

### Step 2: Read reference materials

- Load `rstudio-create-playwright-tests` skill
- Read `e2e/rstudio/README.md` in full -- the suite's primary reference; read it fresh for each migration, don't assume it was read earlier in the session
- Load `rstudio-run-playwright-tests` skill -- its run protocol governs the verification gate (Hard Rule 5)
- Check `rstudio-ide-automation/rstudio_server_pro/electron-tests/` for other Selenium/Selene electron tests covering the same functionality — useful for test logic, assertions, and expected values
- Check `rstudio-ide-automation/rstudio_server_pro/tests/` for Selenium/Selene server tests covering the same functionality — useful for test logic, assertions, and expected values
- Check `rstudio-pro/e2e/` for Workbench e2e patterns (examples include `.or()` locator chaining, `clickIfVisible()` helpers, input fill with retry, reload-on-hang recovery) -- look for anything else reusable
- Read relevant existing Playwright page objects in `e2e/rstudio/pages/`
- Read relevant existing Playwright actions in `e2e/rstudio/actions/`
- Read relevant existing Playwright test specs in `e2e/rstudio/tests/` -- BRAT is retired; anything that was in BRAT is now in the Playwright suite

**For large files or batch migrations:** if the source has many methods (say 10+) or you're migrating a directory, consider launching a general-purpose subagent to analyze the Python source(s) and return a brief covering: test methods to convert, pytest markers / skip reasons, fixtures used, page objects referenced, parallel safety hints, and any unusual patterns. This keeps the main context lean for the writing and running phases. For typical single-file migrations with a handful of methods, do the analysis inline.

### Step 3: Determine the target location

Map the electron-test to the Playwright directory structure:

| Electron Location | Playwright Location |
|-------------------|---------------------|
| Root-level console/terminal tests | `tests/panes/console/` |
| EditorPane/ tests | `tests/panes/editor/` |
| GlobalPrefs/ tests | `tests/panes/preferences/` |
| Licensing/ tests | `tests/licensing/` |
| Projects/ tests | `tests/projects/` |
| Cross-pane tests (autocomplete, etc.) | `tests/panes/misc/` |

Use judgment — the Playwright structure is organized by function, not by the electron-tests layout.

### Step 4: Write the TypeScript test

Follow the rules in the `rstudio-create-playwright-tests` skill (already loaded per Hard Rule 1). That skill covers imports, selector hierarchy, idiomatic patterns, parallel safety, package dependencies, cross-platform considerations, Ace/NES patterns, and CDP setup.

Migration-specific guidance:
- Use `test.fixme()` for tests that can't pass yet -- never comment out or omit.
- If the Selenium source has multiple near-identical methods, consider data-driven restructuring (one `forEach` loop) in the Playwright version.
- When the Python source has `@pytest.mark.skip` or `pytest.skip()`:
  1. Read the skip reason. Check if any linked issue is still open.
  2. If the reason is Selenium-specific, stale, or resolved → write the test like any other and verify it passes.
  3. If the reason still applies (open RStudio bug, missing feature) → `test.fixme()` with the reason / URL preserved as a comment directly above:
     ```typescript
     // @skip: https://github.com/rstudio/rstudio/issues/12345
     test.fixme("test name", async () => {});
     ```
     If the Python skip has only a reason string (no URL), preserve the string verbatim. If the Python source has bare `@skip` with no reason, write `// @skip: no reason given in Python source`.

  Don't auto-fixme based on the marker alone.

### Step 5: Add missing page objects or actions

If the test needs locators or methods not yet available:
- Add locators to the appropriate file in `pages/`
- Add interaction methods to the appropriate file in `actions/`
- Follow existing patterns in those files

### Step 6: Run the test

**Hard gate (Hard Rule 5):** a test doesn't count as migrated until it passes here.

Defer to the `rstudio-run-playwright-tests` skill for the canonical run commands (Desktop and Server). Present the command and wait for user approval before executing.

Quick reference for Desktop:

```bash
cd e2e/rstudio && npx playwright test tests/<path>/<file>.test.ts
```

If the test fails:
- Review error output
- Fix and re-run (up to 3 attempts)
- If still failing, use `test.fixme()` for the failing test and note the blocker

### Step 7: Reevaluate

After the test passes, review for:

1. **Code clarity** — Remove unnecessary variables, simplify patterns, ensure descriptive test names
2. **Idiomatic patterns** — Check against the list in Step 4
3. **Selector quality** — Check against the hierarchy in Step 4
4. **Playwright + TypeScript conventions** — Verify the code follows standard Playwright and TypeScript conventions (e.g., proper async/await usage, correct type annotations, Playwright's built-in assertions over manual checks, proper use of lifecycle hooks, no floating promises). Consult official Playwright docs and TypeScript best practices if uncertain.
5. **Duplication** — Could any new helpers be shared via actions classes?

Present proposed improvements to the user. Only apply if approved. Re-run after changes.

### Step 8: Update progress tracking

Two records to update -- the progress doc (this repo) and the migrated marker
on the Selenium source (the `rstudio-ide-automation` repo).

**Progress doc** -- edit `e2e/rstudio/docs/MIGRATION_FROM_SELENIUM_PROGRESS.md`:
- Update the file's status (Complete, Partial, or Fixme)
- Add the Playwright target path and test count
- Add notes if relevant
- Add any fixme tests to the Fixme Tests table with blocker description

**Mark the Selenium source as migrated** -- in `rstudio-ide-automation`, add
`@pytest.mark.migratedToTypeScript` so the Python suite records which tests are
ported. Follow that repo's `migrate-test` skill, Step 15:
- Mark **each individual test method** that passed verification. **Never mark
  at the class level** -- a class may be only partially migrated, and class-level
  marking would wrongly imply every method is done.
- Module-level `pytestmark = [pytest.mark.migratedToTypeScript, ...]` is
  acceptable only when the file has no class and every method passed.
- Never mark a method that ended up `test.fixme()` in Playwright.
- This is a separate repo, so it needs its own `test/ron/` branch, commit, and
  PR -- don't fold it into the rstudio PR.

### Step 9: Commit and submit

Each substep requires explicit approval before proceeding. Ron may stop at any point -- not every migration goes all the way to merge.

**9.1 Check branch.** Run `git branch --show-current`, report the branch, ask Ron to confirm. Branch prefix for Playwright migration work: `test/ron/` (e.g., `test/ron/migrate-debugger`). Kebab-case for the descriptive part. Never commit directly to main.

**9.2 Review changes.** Run `git fetch origin`. Determine the base branch -- never assume `main`. Check `git log --oneline` or ask. For short-lived solo `test/ron/...` branches, defer the base-branch merge to 9.5. Run `git status` (never `-uall`), `git diff`, `git log --oneline -5`. Summarize what changed. Flag anything that shouldn't be committed (secrets, scratch files, unrelated changes).

**9.3 Stage and commit.** Stage specific files by name (never `git add -A`). Draft a commit message focused on the "why" -- concise, single line preferred, uppercase first letter, no Co-Authored-By. Show the message, wait for approval. Commit, then `git status`.

**9.4 Push.** Show the push command, wait for approval, push with `-u`. Never push to main directly.

**9.5 Create PR.** If `origin/<base>` has moved since the last sync, propose `git merge origin/<base>` and wait for approval before running; then push the merge commit. Draft PR title (under 70 chars) and summary. Summary only -- no "Test plan" section, no AI attribution. Ask about reviewers; aliases: Kevin → `kevinushey`, Gary → `gtritchie`, JonV → `jonvanausdeln`, AT → `astayleraz`. Show full PR details, wait for approval. Create with `gh pr create` (use `--reviewer` if specified). Add the `automation` label. Return the PR URL.

**9.6 Merge** (only if Ron asks to merge this session). Check and report source + target branches, confirm both, wait for approval, merge.

**9.7 Branch cleanup** (only after merge). Offer to delete the local branch, wait for explicit approval.

**Style throughout:** never ` - ` (space-hyphen-space) -- use `--` or em dash, no spaces. Never use `#N` numbering in GitHub comments (auto-links to wrong issues) -- use `1.`, `(1)`, or `Finding 1`.

### Step 10: Roborev review and assessment

Invoke the `roborev-review` skill on the commit to request a code review.

When findings come back, **assess them before presenting to Ron**:
- Read each finding in the actual code context
- Verify the finding is real and not a false positive
- Judge real severity; don't blindly trust roborev's label, and don't overstate
- Note any findings you'd skip and why

Present the assessed findings with recommendations. Wait for approval before editing any files. Severity policy:
- Fix High and Medium findings
- Fix Low findings only if they're real bugs or silent failures
- Skip cosmetic Lows and "add tests for simple scripts" suggestions

Apply fixes manually. **Do not invoke `roborev-fix`** -- Ron prefers manual fixes through the migration flow. Re-run the test (Hard Rule 5 still applies). Commit per Step 9. Re-run `roborev-review` on the new commit. Repeat until no actionable findings remain.

Close reviewed findings via the `roborev-respond` skill once they're addressed.

## Compact Instructions

If context compacts mid-migration, preserve:
- **Source and target paths** for each file being migrated
- **Per-method status**: which methods passed Step 6, which ended up `test.fixme()` and why
- **Page object / action additions** made during the migration (so they're not duplicated)
- **Open roborev findings** in progress: job ID, finding being fixed, severity assessment
- **Open blockers** flagged for Ron (issues to file, upstream bugs found)

If a step has been completed, that fact also survives -- don't redo work Ron has already approved.

## Server Mode Parallelism

Tests can run against multiple RStudio Server instances in parallel. This works from terminal, CI, or Claude subagents.

**Targeting a server:**
```bash
PW_RSTUDIO_SERVER_URL=https://server1:80 \
  npx playwright test tests/panes/misc/autocomplete.test.ts --project=server
```

**Parallel execution (5 servers):**
Each process gets its own `PW_RSTUDIO_SERVER_URL` — no shared config files, no conflicts:

```bash
# Terminal / CI / shell script
PW_RSTUDIO_SERVER_URL=https://server1:80 npx playwright test tests/file1.test.ts --project=server &
PW_RSTUDIO_SERVER_URL=https://server2:80 npx playwright test tests/file2.test.ts --project=server &
PW_RSTUDIO_SERVER_URL=https://server3:80 npx playwright test tests/file3.test.ts --project=server &
wait
```

**Claude subagent execution:**
Same commands, but each Agent tool call targets a different server with `run_in_background: true`. Results are collected and aggregated by the parent agent.

**Desktop mode is unaffected** — it doesn't use `PW_RSTUDIO_SERVER_URL`. The env var is only read by the server fixture path.

## Output

After conversion, summarize:
- Source file and methods converted
- Playwright target file and location
- Page objects or actions added/modified
- Test results (passed/fixme with blockers)
- Improvements made during reevaluation
- MIGRATION_FROM_SELENIUM_PROGRESS.md updates

---
title: "Page not found"
---

![404: Not found](images/404.png "You have arrived at a 404 page."){fig.alt="The link you used may longer be valid. Please use the links or the search function in the navbr to get you back on track."}

To find the information you were looking for, please use the links or the search functionality on the top navigation bar.

---
title: "Command Palette"
date-meta: 2022-12-12
---

## What's a Command Palette?

Just as a paint palette gives the artist instant access to all their colors, a command palette is a software affordance that gives instant, searchable access to all of a program's commands.

![](images/command-palette.png){fig-alt="A screenshot of the Command Palette in use, which provides a search bar for all available RStudio shortcuts." width="1200"}

Command palettes have become a fixture of modern IDEs, and with good reason. They improve:

-   **Keyboard accessibility**; even commands that do not have keyboard shortcuts are easily invoked from the palette.

-   **Speed**; it is often much faster to invoke a command from the palette with a few quick keystrokes than to reach for the mouse or drill into a menu.

-   **Discoverability**; since the palette lists all the commands, it can be browsed to find a command for a task by name without trying to figure out which menu or toolbar might contain it.

## Invoking the Palette

The palette can be invoked with the keyboard shortcut:\
<kbd>Ctrl + Shift + P</kbd> (<kbd>Cmd + Shift + P</kbd> on macOS).

It's also available on the **Tools** menu (**Tools** \> **Show Command Palette**).

## Search Syntax

The command palette's search syntax is simple; it looks for complete matches for each space-separated term you enter. For example, a query for `new proj` will find all of the entries that contain the term `new` AND the term `proj`.

## Content

RStudio's command palette has three main types of content:

### Commands

First and foremost, the command palette serves as a way to search for and invoke RStudio commands quickly with just a few keystrokes. Every RStudio command is in the palette, unless it's been explicitly hidden in the current mode.

To find a command, enter a word or short sequence of characters from the command. For example, to create a new script, start typing `new scr`.

![](images/new-script.png){fig-alt="A screenshot of the Command Palette and search results for 'new scr'."}

Keep typing to filter the list, or press Up/Down to choose a command from the list and then press **Enter** to execute the chosen command. Commands are displayed with their bound keyboard shortcuts, if any, so that you know how to invoke the command directly with the keyboard next time.

If your command doesn't have a shortcut, use the [**Modify Keyboard Shortcuts** command](../productivity/custom-shortcuts.html) to add one.

### Settings

In addition to all of RStudio's commands, the Command Palette provides easy access to most of its settings. You'll see the word `Setting` in front of settings, along with a small control that allows you to change the setting.

For example, you can turn RStudio's code margin indicator off and on or move it to a different column. If you have a code editor open, you'll see these changes reflected in real time as you make them.

![](images/margin.png){fig-alt="A screenshot of the command palette, displaying toggle options for the margin in RStudio."}

Note that the settings displayed are your personal (user-level) settings. Just like the settings in Global Options, they can be overridden by project-level settings, and some settings don't take effect until after a restart.

### RStudio Addins

Finally, the command palette shows all of the commands exposed by any installed RStudio add-ins. You can find these by typing any part of the add-in name and/or part of the command. For example, to use a command from the excellent [styler addin](https://github.com/r-lib/styler):

![](images/style-selection.png){fig-alt="A screenshot of the command palette displaying 'style' search and the styler add-in results."}

This makes the palette user-extensible; to add additional commands to the palette create an [RStudio Addin](../productivity/add-ins.html). The [`shrtcts` package](https://github.com/gadenbuie/shrtcts) can also create shortcuts for common tasks.

---
title: "Posit AI Terms and Conditions"
date-meta: 2026-02-25
---

## Posit Assistant/Posit AI Next Edit Suggestions License

1. **Grant of License** Posit Software, PBC ("Posit") grants you a non-exclusive, non-transferable license to download, install, and use Posit Assistant and Posit AI Next Edit Suggestions for personal or internal business purposes at no cost.
2. **Ownership & Restrictions** Posit retains all ownership, copyright, and intellectual property rights to the software. By downloading this software, you agree not to:
   * **Decompile or Reverse Engineer:** You may not attempt to discover or modify the source code.
   * **Redistribute:** You may not host this software on other websites, include it in software bundles, or distribute it via other media without written permission.
   * **Sell:** You may not rent, lease, lend, or sell the software or any portion of it.
3. **No Warranty ("As-Is")** The software is provided "as-is," without any warranty of any kind. Posit is not liable for any damages (including data loss or hardware failure) arising from the use or inability to use this software.
4. **Termination** This license is effective until terminated. Your rights under this license will terminate automatically if you fail to comply with any of its terms.

---
title: "Version Control"
date-meta: 2022-12-12
---

Version control helps software teams manage changes to source code over time. Version control software keeps track of every modification to the code in a special kind of database. If a mistake is made, developers can turn back the clock and compare earlier versions of the code to help fix the mistake while minimizing disruption to all team members. Version control systems have been around for a long time but continue to increase in popularity with data science workflows.

RStudio has integrated support for version control. If you are new to version control, see a deeper overview in: [Happy Git and Github for the useR](https://happygitwithr.com/)

## Requirements

RStudio supports the following open source version control systems:

-   [Git](http://git-scm.com/)

-   [Subversion](http://subversion.apache.org/)

To use version control with RStudio, first ensure that Git and/or Subversion tools are installed on your workstation (details below).

Version control is most useful when used with a remote repository. Remote repositories are typically managed by your company or are hosted in the cloud (e.g., [Github](https://github.com/) or [GitLab](https://about.gitlab.com/)). Make sure you have credentials to access these systems. If you only want to learn how to use version control, you can manage a standalone system on your workstation but you will not be able to share code with others.

You should also become familiar with using [RStudio Projects](../code/projects.html) (which are required for version control features to be enabled).

## Installation

Prior to using RStudio's version control features you will need to ensure that you have Git and/or Subversion installed on your system. The following describes how to do this for various platforms.

### Git

Prior to using Git with RStudio you should install it using the appropriate method for your platform as indicated at <https://git-scm.com/download/>.

An excellent resource for learning more about Git and how to use it is the [Pro Git](https://git-scm.com/book/en/v2) online book. Another good resource for learning about git is the [Git Bootcamp](https://help.github.com/articles/set-up-git/) provided by GitHub.

### Subversion

Prior to using Subversion with RStudio you should install it using the appropriate method for your platform as indicated at <https://subversion.apache.org/packages.html>.

An excellent resource for learning more about Subversion and how to use it is the [Red Bean](http://svnbook.red-bean.com/) online book.

## Getting Started

Once a Version Control system has been installed, it needs to be activated on the system by following these steps:

1.  From the **Tools** menu, click **Global Options**

2.  Click on the **Git/SVN** tab

3.  Click **Enable version control interface for RStudio projects**

4.  If necessary, enter the path for the Git or SVN executable where provided. A SSH key can be created or added for SSH if necessary.

![](images/version-control-options.png){fig-alt="A screenshot of the Git/SVN tab in Global Options displaying an active Git executable."}

If you are using RStudio Server, by default RStudio Server will look at the PATH for the first Git executable it finds, and sets that as the default. If you have a specific version that you want to set for all users, the easiest option is to make sure it's the first available on the PATH system-wide.

Alternately, in Posit Workbench (previously RStudio Server Pro/RStudio Workbench), you can set the default Git version system-wide by setting the `git_exe_path` option in your system rstudio-prefs.json file. See here for more:\
<https://docs.posit.co/ide/server-pro/r-sessions.html#customizing-session-settings>\
<https://docs.posit.co/ide/server-pro/session-user-settings.html>

RStudio's version control features are tied to the use of [Projects](../code/projects.html) (which are a way of dividing work into multiple contexts, each with their own working directory). The steps required to use version control with a project vary depending on whether the project is new or existing as well as whether it is already under version control.

### Integrations

Once version control such as Git has been enabled for the current RStudio Project, a few visual elements are added, specifically the **Git/Version control dropdown** and the **Git/Version Control tab**.

::: {.callout-note}
If you've installed Git for version control but the Git pane doesn't display, you may need to perform the steps outlined in the section [Git is installed, but the Git pane doesn't appear].
:::

![](images/rstudio-vcs-pane-labeled.png){fig-alt="A screenshot of the RStudio interface, highlighting the Git tab in the Environments pane."}

The **Git menu dropdown** provides Commit, Pull/Push Branch, History and Project Setup.

![](images/git-drop-down.png){width="350" fig-alt="A screenshot of the git dropdown."}

The **Git tab** within the **Environment pane** provides a number of useful commands such as "Diff", "Commit", the Push/Pull arrows, View history 'clock', or selecting a specific branch.

![](images/git-tab.png){fig-alt="A screenshot of the Git tab in RStudio, showing a few files that can be added to staging."}

Once you are finished with your local work and are ready to Commit your changes, selecting **Commit** in either the **Git** drop-down menu or **Git** tab opens the **Review Changes** pop-up to select files for staging, add a commit message, and eventually push the commit.

![](images/git-commit-pane.png){fig-alt="A screenshot of the Review Changes pop-up, indicating the files for staging and the ability to commit, push and pull changes."}

## Using version control

There are several options for using version control, depending on whether you are starting a new project or working on an existing project.

### Using a directory already under version control

If you have an existing directory which is already under Git or Subversion version control then you can create a new RStudio project for that directory and then version control features will be automatically enabled. To do this:

1.  Execute the **New Project** command (from the Project menu)

2.  Choose to create a new project from an **Existing Directory**

3.  Select the appropriate directory and then click **Create Project**

A new project will be created for the directory and RStudio's version control features will then be available for that directory.

### Creating a new project based on a remote Git or Subversion repository

If you have an existing remote Git or Subversion repository that you want to use as the basis for an RStudio project you should:

1.  Execute the **New Project** command (from the Project menu)

2.  Choose to create a new project from **Version Control**

3.  Choose **Git** or **Subversion** as appropriate

4.  Provide the repository URL (and other appropriate options) and then click **Create Project**

The remote repository will be cloned into the specified directory and RStudio's version control features will then be available for that directory.

### Adding version control to an existing project

**Directions for remote repositories**

Subversion directories are always paired with an external repository, so cannot be configured for version control without also configuring the external connection. In addition, we recommend that Git repositories always be configured with a remote repository in order to protect your data and maintain a separate backup.

If you have an existing directory that you want to add version control to, you should consult the documentation for Git or Subversion concerning how to initialize a repository (both local commands as well as commands required to connect it to a remote server). See the resources linked above for more on connecting your project to a remote repository.

Once you've configured your project with your repository, RStudio will detect that the project has been added and RStudio's version control features will then be available for that directory.

**Directions for Git (local)**

Git repositories can be created in purely local mode (if for example you want to track changes locally but aren't concerned with collaborating and/or syncing between multiple workstations). To add a git repository to an existing project:

1.  Execute the **Project Options** command (from the Project menu)

2.  Choose **Version Control** options

3.  Change the version control system from (None) to **Git**

4.  Confirm that you wish to initialize a new Git repository

A Git repository will be created for the project and you'll be prompted to restart RStudio to enable version control features for the project.

## Additional Topics

### Using the Shell

RStudio provides an interface to the most common version control operations including managing changelists, diffing files, committing, and viewing history. While these features cover basic everyday use of Git and Subversion, you may also occasionally need to use the system shell to access all of their underlying functionality.

RStudio includes functionality to make it more straightforward to use the shell with projects under version control. This includes:

-   On all platforms, you can use the **Terminal** to open a new system shell with the working directory already initialized to your project's root directory.

-   On Windows when using Git, the Shell command will open Git Bash, which is a port of the bash shell to Windows specially configured for use with Git for Windows (note you can disable this behavior and use the standard Windows command prompt instead using Options -\> Version Control).

-   On Windows when using Subversion, RStudio opens a shell with a PATH configured to use a version of ssh.exe which ships with RStudio (required for svn+ssh connections, see below).

-   When running over the web, RStudio provides a web-based shell dialog.

### SSH

Version control repositories can typically be accessed using a variety of protocols (including http and https). Many repositories can also be accessed using SSH (this is the mode of connection for many hosting services including GitHub and R-Forge).

In many cases the authentication for an SSH connection is done using public/private SSH key pairs. This type of authentication requires two steps:

1.  Generate a public/private key pair

2.  Provide the public key to the hosting provider (e.g. GitHub or R-Forge)

To make working with SSH key pairs more straightforward the RStudio Version Control options panel can be used to both create new SSH public/private key pairs as well as view and copy the current SSH public key.

Linux and Mac OSX both include SSH as part of the base system. Windows 11 also includes SSH as an optional Windows component, as does the standard Windows distribution of Git (Git for Windows, referenced above).

### Git Commit Signing

Git commit signing is a process used to verify the authenticity and integrity of commits within a Git repository. The **Git/SVN** Global Options pop-up in RStudio includes a **Sign git commits** check box. When it is selected, git will attempt to sign all future commits.

If commit signing is globally enabled via `git config --global commit.gpgsign true` it is not necessary to select the check box.

::: {.callout-important}
You are responsible for configuring git commit signing and ensuring the associated key is unlocked. Otherwise, you will receive an error if you attempt to sign a commit via the **Review Changes** pop-up. Please consult the git documentation for details on how to configure commit signing for your platform.
:::

![](images/git-sign-commit.png){fig-alt="A screenshot of the Global Options pop-up, highlighting the Sign git commits check box."}

## Troubleshooting

### Git is installed, but the Git pane doesn't appear

The Git pane may not display if you're working in a folder that your user does not have ownership of, such as a shared project. This is due to a security feature in git `2.35.2` that disables git repos created in directories the user does not own. You can verify that this is blocking the Git pane from displaying by submitting a git command in the terminal:

``` bash
$ git status
fatal: detected dubious ownership in repository at '/home/posit-user/my-project-folder'
To add an exception for this directory, call:

        git config --global --add safe.directory /home/posit-user/my-project-folder
```

You can mark the offending directory as safe by following the suggested action above and then closing and re-opening the project in RStudio.

Additionally, the Git pane will not appear if Git is not activated for the current project in the project options. To enable Git for the project:

1.  Open the Tools menu and select Project Options.

2.  Navigate to the Git/SVN tab.

3.  In the dropdown field labeled Version control system, change the selection from (None) to Git.

4.  Restart RStudio and check if the Git pane appears.

---
title: "Connections Contract"
date-meta: 2022-12-12
---

The RStudio **Connections** pane can display database-like connections from any R package which implements a connections contract.

The **Connections** pane acts like an observer; the R package notifies the observer when an event related to the connection occurs. In RStudio builds which support the **Connections** Pane, the `connectionObserver` option is populated with a list of three functions:

-   `connectionOpened()`
-   `connectionUpdated()`
-   `connectionClosed()`

## Connection opened

When a new connection is opened, the R package should inform the **Connections** pane by calling `connectionOpened()`. For example:

``` r
observer <- getOption("connectionObserver")
if (!is.null(observer))
  observer$connectionOpened(...)
```

### Arguments

The arguments to the `connectionOpened()` function are as follows:

| Argument           | Value                                                                                                                                                                                                                                   |
|:-----------------|:-----------------------------------------------------|
| `type`             | Free-form text; the type of data connection (e.g., "SQL").                                                                                                                                                                              |
| `displayName`      | Free-form text; the name shown to the user in the **Connections** pane.                                                                                                                                                                 |
| `host`             | The name of the server/host being connected to; optional.                                                                                                                                                                               |
| `icon`             | The full path to a small, square PNG icon representing the connection; optional.                                                                                                                                                        |
| `connectCode`      | A snippet of R code which can be used to open the connection again.                                                                                                                                                                     |
| `disconnect`       | A function which can be used to close the connection.                                                                                                                                                                                   |
| `listObjectTypes`  | A function which returns the hierarchy of object types returned by the connection, as a nested list; see [Specifying Objects](#specifying-objects) below for details.                                                                   |
| `listObjects`      | A function which lists top-level objects in the database when called without arguments, or the objects inside some other object when invoked with an object specifier. The return value is a data frame with `name` and `type` columns. |
| `listColumns`      | A function which lists the columns of a data object. The return value is a data frame with `name` and `type` columns.                                                                                                                   |
| `previewObject`    | A function accepting a row limit and an object specifier; it returns the given number of rows from the data object as a data frame.                                                                                                     |
| `actions`          | A named list of actions which can be performed on the connection. Each list entry should be a list with `icon` (path to an small, square PNG representing the action) and `callback` (function to perform when the action is invoked)   |
| `connectionObject` | The raw connection object.                                                                                                                                                                                                              |

### Specifying objects {#specifying-objects}

#### Hierarchy

The `listObjectTypes()` function is invoked by RStudio to discover the hierarchy of objects supported by the connection. The return value should be a nested list, where each entry has a `contains` member that indicates what the object type contains, and optionally an `icon` member indicating the path to a small, square PNG representing the object type.

The `contains` member is either a list of object types that the object contains, or the special value `"data"` if the object contains data.

For example, if a database has schemas, and schemas can have tables and views, the developer might return a list like the following:

``` r
list(
  schema = list(
    icon = "path/to/schema.png",
    contains = list(
      table = list(
        contains = "data"),
      view = list(
        contains = "data"))))
```

#### Arguments

The `listObjects()`, `listColumns()`, and `previewObject()` functions are invoked by RStudio as the user explores the objects and data in the connection. They are all invoked with an *object specifier*, which is a set of named arguments corresponding to the object types returned by `listObjectTypes()`.

For instance, suppose the user opens a connection, expands the schema "foo", and then previews the table "bar" inside that schema. RStudio will invoke the functions as follows:

``` r
listObjects()                  ## returns all schema
listObjects(schema = "foo")    ## returns tables and views in "foo"
previewObject(schema = "foo",  ## returns data in foo.bar
              table  = "bar")
```

### Persistence

When a R package informs RStudio that a connection has been opened via `connectionOpened()`, RStudio saves some of the connection's metadata. Even after the connection is closed, RStudio shows users the connection along with the code (which is supplied in the `connectCode` argument to `connectionOpened` as described above) to re-open it. It's therefore important to supply a `connectCode` string which will work with few prerequisites.

## Connection updated

If the list of objects in the data source changes while the connection is open, your R package can tell RStudio to refresh the **Connections** pane to show the new information. This is done by invoking the `connectionUpdated()` method as follows:

``` r
observer <- getOption("connectionObserver")
if (!is.null(observer))
  observer$connectionUpdated(type, host)
```

where `type` and `host` match the type and host parameters given when the connection was opened.

## Connection closed

When the user closes the connection, your R package should tell RStudio to update the pane. This done by invoking the `connectionClosed()` method, which works identically to `connectionUpdated()`:

``` r
observer <- getOption("connectionObserver")
if (!is.null(observer))
  observer$connectionClosed(type, host)
```

## Examples

There are currently two packages which implement the connections contract and can be used as examples for other packages:

-   [odbc](https://github.com/rstats-db/odbc/blob/5acc55350e0664002d6281f4659c089911fbd7c3/R/Viewer.R)

-   [sparklyr](https://github.com/rstudio/sparklyr/blob/4b7098628fcd14c1cc562a38940b2e67bf2fb63a/R/connection_viewer.R)

---
title: "RStudio Projects"
date-meta: 2022-12-12
---

Expert data scientists keep all the files associated with a given project together --- input data, scripts, analytical results, and figures. This is such a wise and common practice that RStudio has built-in support for this via Projects. RStudio Projects make it straightforward to divide your work into multiple contexts, each with their own working directory, workspace, history, and source documents.

## Creating Projects

RStudio projects are associated with R working directories. 

RStudio projects can be created:

-   In a brand new directory

-   In an existing directory where you already have R code and data

-   By cloning a version control (Git or Subversion) repository

To create a new project in RStudio, use **File** > **New Project** or use the **New Project** button (available on the Projects toolbar in the top right corner or on the global toolbar at the top left corner). 

This will open the "New Project Wizard" popup:

![](images/projects_new.png){fig-alt="A screenshot of the RStudio \"New Project Wizard\" popup. It starts with Create Project from: and the choice of \"New Directory\", \"Existing directory\", or from \"Version control\""}

When a new project is created, RStudio:

1.  Creates a project file (with an .Rproj extension) within the project directory. This file contains various project options (discussed below) and can also be used as a shortcut for opening the project directly from the filesystem.

2.  Creates a hidden directory (named .Rproj.user) where project-specific temporary files (e.g. auto-saved source documents, window-state, etc.) are stored. This directory is also automatically added to .Rbuildignore, .gitignore, etc. if required.

3.  Loads the project into RStudio and display its name in the Projects toolbar (which is located on the far right side of the main toolbar)

## Working with Projects

The **Projects Toolbar** is located at the top right corner of RStudio. It displays the current Project name, and has commands for:

-   Creating a New Project
-   Opening existing projects in current or a new RStudio session
-   Closing the currently active Project
-   Clearing the list of recently opened Projects
-   Controlling Project Options

![](images/project-open.png){fig-alt="A screenshot of the New Project dropdown menu, providing commands for creating or opening projects" width="350"}

### Opening Projects

There are several ways to open a project:

1.  Using the **Open Project** command (available from both the **File** \> **Open Project** menu and the **Projects toolbar**) to browse for and select an existing project file (e.g. MyProject.Rproj).

2.  Selecting a project from the list of most recently opened projects (also available from both the **File** \> **Projects** menu and toolbar).

3.  Double-clicking on the project file within the system shell (e.g. Windows Explorer, OSX Finder, etc.).

When a project is opened within RStudio the following actions are taken:

-   A new R session (process) is started

-   The .Rprofile file in the project's main directory (if any) is sourced by R

-   The .RData file in the project's main directory is loaded (if project options indicate that it should be loaded).

-   The .Rhistory file in the project's main directory is loaded into the RStudio History pane (and used for Console Up/Down arrow command history).

-   The current working directory is set to the project directory.

-   Previously edited source documents are restored into editor tabs

-   Other RStudio settings (e.g. active tabs, splitter positions, etc.) are restored to where they were the last time the project was closed.

### Quitting a Project

When you are within a project and choose to either Quit, close the project, or open another project the following actions are taken:

-   .RData and/or .Rhistory are written to the project directory (if current options indicate they should be)

-   The list of open source documents is saved (so it can be restored next time the project is opened)

-   Other RStudio settings (as described above) are saved.

-   The R session is terminated.

### Working with multiple Projects at once

You can work with more than one RStudio project at a time by simply opening each project in its own instance of RStudio. There are two ways to accomplish this:

1.  Use the **Open Project in New Session** command located on the Project menu.

2.  Opening multiple project files via the system shell (i.e. double-clicking on the project file).

### Project options

There are several options that can be set on a per-project basis to customize the behavior of RStudio. You can edit these options using the **Project Options** command on the **Project** menu:

![](images/project-options.png){fig-alt="A screenshot of the Project Options popup - it has tabs for General, Code Editing, R Markdown, Python, Sweave, Spelling, Build Tools, Git/SVN, Environments."}

## General

Note that the General project options are all overrides of existing global options. To inherit the default global behavior for a project you can specify (Default) as the option value.

-   **Restore .RData into workspace at startup** --- Load the .RData file (if any) found in the initial working directory into the R workspace (global environment) at startup. If you have a very large .RData file then unchecking this option will improve startup time considerably.

-   **Save workspace to .RData on exit** --- Ask whether to save .RData on exit, always save it, or never save it. Note that if the workspace is not dirty (no changes made) at the end of a session then no prompt to save occurs even if Ask is specified.

-   **Always save history (even when not saving .RData)** --- Make sure that the .Rhistory file is always saved with the commands from your session even if you choose not to save the .RData file when exiting.

### Code editing

-   **Index R source files** --- Determines whether R source files within the project directory are indexed for code navigation (i.e. go to file/function, go to function definition). Normally this should remain enabled, however if you have a project directory with thousands of files and are concerned about the overhead of monitoring and indexing them you can disable indexing here.

-   **Insert spaces for tab** --- Determine whether the tab key inserts multiple spaces rather than a tab character (soft tabs). Configure the number of spaces per soft-tab.

-   **Text encoding** --- Specify the default text encoding for source files. Note that source files which don't match the default encoding can still be opened correctly using the **File : Reopen with Encoding** menu command.

### Git/SVN

-   **Version control system** --- Specify the version control system to use with this project. Note that RStudio automatically detects the presence of version control for projects by scanning for a .git or .svn directory. Therefore it isn't normally necessary to change this setting. You may want to change the setting for the following reasons:

    1.  You have both a .git and .svn directory within the project and wish to specify which version control system RStudio should bind to.

    2.  You have no version control setup for the project and you want to add a local git repository (equivalent to executing `git init` from the project root directory).

-   **Origin** --- Read-only display of the remote origin (if any) for the project version control repository.

---
title: "Connecting"
date-meta: 2022-12-12
---

RStudio provides Push-button deployment to Posit Connect, Shinyapps.io, and RPubs.com.

[Posit Connect](https://www.posit.co/products/enterprise/connect/) supports a spectrum of data products, static or dynamic, developed in R and Python: Dashboards, applications, APIs, reports, and more. Connect enables flexible permissions configurations and meets all enterprise security requirements.

[Shinyapps.io](https://www.shinyapps.io/) supports hosting of Shiny for R and Python.

[RPubs.com](https://rpubs.com/) only supports hosting of static content, such as R Markdown.

## Connecting Your Account

Install the [rsconnect](https://rstudio.github.io/rsconnect/) R package, which is required for publishing:

``` r
install.packages("rsconnect")
# or the development version from GitHub
# install.packages("devtools")
# devtools::install_github("rstudio/rsconnect")
```

### Publishing to Connect or Shinyapps.io

You need to connect RStudio to the remote hosting environment (e.g., Connect, Shinyapps.io) and authorize RStudio to use your account. 

To connect a publishing account to RStudio, from the main menu, click **Tools** > **Global Options\...**.

![Global options menu](images/connecting-1.png){fig-alt="Global options menu"}

In the Options panel that displays, click **Publishing** > **Connect\...** button to add a new account.

![](images/connecting-publishing.png){fig-alt="The Global options menu, highlighting the Publishing tab and the Connect... button"}

Select the publishing destination, then follow the **Connect Account** wizard's instructions for that particular product.

![Publishing account configuration](images/connect-account.png){fig-alt="Publishing account configuration"}

To authorize the IDE to deploy on your behalf, Log in and click **Connect**. Then, return to the IDE and click **Connect Account**.

Once you have successfully configured the connection within RStudio, you can now publish content to Connect or Shinyapps.io.

### Publishing to RPubs

Publishing static content, such as R Markdown, to RPubs has a slightly different publishing workflow.

Once you save and knit your R Markdown document, click **Publish**.

![Publish R Markdown document](images/rmarkdown-publish-button.png){fig-alt="Publishing R Markdown file"}

Select **RPubs** as your publishing destination.

![Publish to RPubs](images/publish-to-rpubs.png){fig-alt="Publishing to RPubs"}

Click **Publish**.

![Click Publish](images/rpubs-click-publish.png){fig-alt="Click Publish"}

## Additional resources

For more information, reference the documentation for your desired push-button deployment destination:

-   [Posit Connect User Guide](https://docs.posit.co/connect/user/connecting/)
-   [RPubs - Getting Started](https://rpubs.com/about/getting-started)
-   [ShinyApps.io User Guide](https://docs.posit.co/shinyapps.io/)

---
title: "Connections Pane"
date-meta: 2022-12-12
---

## Connection history and existing connections

![](images/connections-pane.png){fig-alt="A screenshot of the Connections pane in RStudio, displaying existing database connections." fig-align="center" width="450"}

The **Connections** pane displays all the connections to supported data sources and which connections are currently active. RStudio supports multiple, simultaneous database connections. This history is specific to your user account and is stored privately in RStudio's settings; it applies to all of your RStudio projects.

## Connecting to a database in R

In RStudio, there are two ways to connect to a database:

-   Write the connection code manually**.** See this article for more information: [Connect to a Database](https://solutions.posit.co/connections/db/getting-started/connect-to-database/)

-   Use the **New Connection** interface. The dialog lists all the connection types and drivers it can find on the system. See the next section for more information.

### New connection interface

The **New Connection** interface will list possible connections:

-   ODBC DSNs installed on your system. If the `odbc` package is installed, any system DSN (Data Source Name) you have installed will be listed. For more information, see [Integrated security with DSN](https://solutions.posit.co/connections/db/best-practices/managing-credentials/#integrated-security-with-dsn).

-   Connections supplied by your administrator. An administrator may put connection snippets into a folder to make them available to end users. If you are an administrator, see our page on [RStudio Connection Snippet Files](connection-snippets.html) for more information.

-   ODBC drivers installed on your system. If the `odbc` package is installed, any ODBC driver you have installed on your system will be listed. The method for installing ODBC drivers varies by system. See our page on [Setting up ODBC Drivers](https://solutions.posit.co/connections/db/best-practices/drivers/). Because the resulting connection code in the **New Connection** interface will have to be changed significantly, it may be better to write the connection code manually. See this article for more information: [Connecting to a Database in R](https://solutions.posit.co/connections/db/getting-started/connect-to-database/)

![](images/connect-existing-data.png){fig-alt="A screenshot of the Connections > New Connections popup, providing available ODBC connections for the system such as Snowflake, Livy, Spark, Athena, etc." fig-align="center" width="450"}

## Connections pane

After successfully connecting to a database using `odbc`, the **Connections** pane will do the following:

-   Enable navigation by displaying an expandable list with the hierarchy of databases, schema, tables and fields

-   Allow you to preview the top 1,000 rows of a table by clicking in the icon to the right of the table's name

-   Close the database connection by simply clicking on the corresponding button inside the pane

![](images/connections-diagram.png){fig-alt="A diagram of available options in the connections pane."}

# E2E Anti-Pattern Cleanup

Tracking cleanup of anti-patterns surfaced by the 2026-05-24 scan of
`e2e/rstudio/` (102 TypeScript files across `tests/`, `utils/`, `pages/`,
`actions/`, `fixtures/`).

Items are grouped into three tiers:

- **Must** -- documented project rules; every occurrence is a violation.
- **Should** -- structural fixes that pay back across many tests.
- **Nice** -- stylistic polish; address opportunistically.

Initial counts are recorded so progress can be checked against the scan
baseline.

## Initial baseline

| Category                                   | Count           |
|--------------------------------------------|-----------------|
| Blind sleeps (`waitForTimeout` + `sleep`)  | 4 + ~150        |
| Console-based `.rs.*` RPC                  | 8 sites         |
| Focused / unexplained tests                | 0 `.only`; 1 bare `test.skip` |
| Inline `timeout: NNNN`                     | 371 (50 are 30000 / 60000)    |
| XPath / deep CSS selectors                 | 0               |
| `force: true` clicks                       | 16              |
| `page.evaluate` driving UI                 | 72 (4 = desktopHooks command palette) |
| `toBe(true|false)` on locator booleans     | ~200            |
| In-test `try/catch` swallowing             | 9               |
| `console.log` leftovers                    | ~150            |
| `if (await ...)` branches in tests         | 24+             |

---

## Must -- rule violations

### Blind sleeps

Project rule: wait for a measurable condition, not a fixed duration. See
memory `feedback_avoid_blind_sleeps.md`.

Hot-spot test files:

- [ ] `tests/panes/editor/code_suggestions.test.ts` -- 38 `await sleep()`
      calls; 22 are `sleep(5000)`. Single highest-leverage file.
- [ ] `tests/panes/layout/panes.test.ts` -- 21 `sleep(TIMEOUTS.layoutSettle)`
      calls. See the "layout-settle signal" item under **Should**.
- [ ] `tests/panes/misc/s4_unloaded_package.test.ts:168` -- `sleep(5000)`
      after `restartR`; comment notes "replace once restartR has a
      confirmable post-condition".
- [ ] `tests/panes/misc/python_completions.test.ts:56,59` -- `sleep(3000)` /
      `sleep(500)` around Python REPL typing.
- [ ] `tests/panes/posit-assistant-chat/uninstall-posit-ai.test.ts:74,119`
- [ ] `tests/panes/posit-assistant-chat/chat-pane-persistence.test.ts:27,78`
- [ ] `tests/panes/debugger/debugger_extras.test.ts:89` -- `sleep(300)`

Shared infrastructure (each removal cascades through many tests):

- [ ] `actions/chat_pane.actions.ts` -- 15 sleeps in lines 90-230
- [ ] `actions/console_pane.actions.ts` -- 10 sleeps
      (150, 158, 170, 179, 182, 197, 221, 240, 298, 316)
- [ ] `actions/assistant_options.actions.ts` -- 11 sleeps in lines 37-116
- [ ] `actions/autocomplete.actions.ts` -- 9 sleeps
- [ ] `actions/source_pane.actions.ts` -- 5 sleeps (line 242: `sleep(2000)`)
- [ ] `fixtures/desktop.fixture.ts` -- 10 sleeps; worst at line 529
      (`sleep(5000)`) and line 551 (`sleep(3000)`)
- [ ] `fixtures/server.fixture.ts` -- 7 sleeps (line 288: `sleep(2000)`;
      line 300 manual race timeout may be OK)
- [ ] `pages/console_pane.page.ts` -- 6 sleeps in `typeInConsole`,
      `clearConsole`, `goToLine`, `closeAllBuffersWithoutSaving`
- [ ] `pages/modals.page.ts:21,33` -- `sleep(5000)` then `sleep(1000)`
- [ ] `pages/environment_pane.page.ts:65,67`
- [ ] `utils/project.ts` -- 6 sleeps (3000, 2000, 1500, others)

`waitForTimeout` sites (4):

- [ ] `tests/smoke/startup.test.ts:10` -- 30s "stay alive" body; consider
      replacing with an actual readiness assertion
- [ ] `tests/panes/files/files.test.ts:133` -- 1500ms mtime granularity
      guard; has comment, may stay
- [ ] `tests/panes/posit-assistant-chat/chat-user-skills.test.ts:130` --
      5000ms; comment "no bridge-exposed signal for backend shutdown"
- [ ] `tests/panes/posit-assistant-chat/readline-notification.test.ts:60` --
      1000ms absence-of-event window

### Console-based `.rs.*` RPC

Project rule: use `executeCommand(page, ...)` / bridge helpers instead of
typing `.rs.api.*` into the console. See memory
`feedback_executecommand_over_console_api.md`.

Ported:

- [x] `tests/projects/shinytest2.test.ts:78` -- `.rs.api.openProject` ->
      `openProject(page, '${dir}/${basename}.Rproj')`
- [x] `tests/panes/misc/build_pane_testthat.test.ts:69` -- same as above
- [x] `tests/panes/editor/syntax-highlighting.test.ts:62,89` --
      `.rs.writeUserPref("rainbow_fenced_divs", ...)` -> `setPref`
- [x] `tests/projects/project_trust_dialog.test.ts:239,248` --
      `.rs.api.readRStudioPreference(...)` via `captureResult` -> `getPref`
- [x] `tests/projects/shinytest2.test.ts:87` and
      `tests/panes/misc/build_pane_testthat.test.ts:82` --
      `.rs.api.documentOpen(...)` -> `documentOpen(page, path)` via new
      `window.rstudio.documents.open(path, opts?)` bridge method.

Intentionally kept as console RPC (no bridge equivalent or testing the API
itself); each site has an inline comment explaining the reason:

- `tests/projects/shinytest2.test.ts` -- `.rs.api.initializeProject` writes
  the .Rproj file; no bridge for project initialization.
- `tests/panes/misc/session_restart.test.ts` -- the test specifically
  exercises `.rs.api.restartSession`'s `afterRestart` parameter, which the
  `restartR` AppCommand does not expose.

Follow-up: adding `project.initialize(path)` to the automation bridge would
close out the initializeProject site.

### Lone unexplained `test.skip`

- [ ] `tests/panes/editor/rmarkdown.test.ts:211` -- bare
      `test.skip('visual mode go to next and prev chunk', ...)` with no
      comment or linked issue. Either explain, link an issue, or restore.

---

## Should -- structural fixes

### Build a measurable layout-settle signal

`tests/panes/layout/panes.test.ts` has 21 `sleep(TIMEOUTS.layoutSettle)`
calls (and `pane_layout.test.ts` has more). A real signal -- mutation
observer on the pane container, a `data-layout-settled` attribute, or a
busy-class watcher -- would let us strike all of them at once and stop
papering over real races.

- [ ] Design a layout-settle signal in the GWT layout code (or expose an
      existing one through the automation bridge)
- [ ] Replace `sleep(layoutSettle)` calls in `panes.test.ts` and
      `pane_layout.test.ts`

### Clean up `code_suggestions.test.ts`

Single worst file in the suite (38 sleeps, ~40 `console.log` calls, several
`if (await ...)` branches, two `force: true` clicks). Worth a dedicated
pass.

- [ ] Replace sleeps with measurable waits
- [ ] Strip step-narration `console.log` calls (lines 84, 137, 143, 176,
      226, 229, 270, 286, 289, 329, 340, 343, 346, 373, 384, 419, 433, 469,
      483, 486, 518, 536, 538, 587, 593, 597, 619, 628, 634)
- [ ] Collapse `if (await ...)` branches at lines 136, 269, 328, 584
      (especially line 137 which logs a WARNING for a stale gutter icon
      instead of failing -- file the bug or assert it)
- [ ] Document or remove `force: true` click at line 630

### Strip `console.log` debugging leftovers

~150 occurrences total; cleanup hooks that log cleanup errors are fine,
but step-narration inside test bodies should go. Worst (outside
`code_suggestions.test.ts`):

- [ ] `tests/panes/editor/quarto.test.ts:68-83` -- 7 "Checking ..." logs
- [ ] `tests/projects/project_trust_dialog.test.ts:240,311,327,328`
- [ ] `tests/panes/misc/s4_unloaded_package.test.ts:79,180,196,199,212`
- [ ] `tests/panes/layout/pane_location_persistence.test.ts:133,138,141,148`

### Move conditional cleanup out of test bodies

Tests should follow a single deterministic path; conditional cleanup logic
belongs in `afterEach`.

- [ ] `tests/panes/posit-assistant-chat/shiny-app-r.test.ts:48,64,76,89` --
      four conditional cleanup branches in the test body
- [ ] `tests/panes/posit-assistant-chat/open-chat-pane.test.ts:39,57` --
      `chatIframe.isVisible()` branching
- [ ] `tests/panes/layout/panes.test.ts:73,85,228` -- sidebar-presence
      branches
- [ ] `tests/panes/layout/pane_location_persistence.test.ts:38,51,65,74`
- [ ] `tests/panes/console/console_pane.test.ts:141,170` -- find-bar state
      branches
- [ ] `tests/panes/editor/air_formatting.test.ts:120` -- modal-handling
      branch
- [ ] `tests/panes/misc/rstudioapi_show_dialog.test.ts:69` -- iterating
      buttons with `.isVisible().catch(() => false)`
- [ ] `tests/projects/project_id.test.ts:45` -- pre-existing-modal close
- [ ] Eliminate the `.isVisible().catch(() => false)` swallow pattern in
      chat / dialog tests -- it can't distinguish "not present" from
      "selector broke"

### Document or remove undocumented `force: true` clicks

16 sites; the comment at `actions/chat_pane.actions.ts:294` is a good
template ("GWT console DOM elements report overlapping coordinates").

- [ ] `tests/panes/debugger/debugger_extras.test.ts:51`
- [ ] `tests/panes/editor/code_suggestions.test.ts:630` -- on
      `statusBarCompletionReceived`
- [ ] `tests/panes/console/console_pane.test.ts:38,76`
- [ ] `utils/project.ts:109`
- [ ] `pages/console_pane.page.ts:277,284`
- [ ] `actions/source_pane.actions.ts:114,121,144`
- [ ] `actions/autocomplete.actions.ts:103`
- [ ] `fixtures/server.fixture.ts:268`

### Stop bypassing the command bridge for the command palette

- [ ] `tests/panes/posit-assistant-chat/uninstall-posit-ai.test.ts:42,73,87,99`
      -- `page.evaluate("window.desktopHooks.invokeCommand('showCommandPalette')")`
      should be `executeCommand(page, 'showCommandPalette')`

### Remove the `TIMEOUTS` object; wait on observable state

`utils/constants.ts` exports `TIMEOUTS` (`sessionRestart: 30000`,
`fileOpen: 20000`, `consoleReady: 15000`, `settleDelay: 1000`, etc.). Its
existence implies that long blind timeouts on assertions are an acceptable
substitute for waiting on observable state -- they aren't. The right
pattern is to poll a bridge-state predicate
(`window.rstudio.project.path()`, `documents.active()`, the `console-busy`
class, etc.) and let the assertion run at Playwright's default short
timeout. Each `TIMEOUTS` entry callers reach for is a missing or
under-exposed bridge signal.

PR #17761 demonstrates the pattern: `openProject` polls
`window.rstudio.project.path()` against the requested .Rproj, so the
follow-up `expect(PROJECT_MENU).toContainText(...)` runs at the default
5s timeout instead of the previous 30s `TIMEOUTS.sessionRestart` blind
wait.

Goal: shrink `TIMEOUTS` to only the legitimate non-wait constants
(`pollInterval`, `slowKeystroke`) and remove the rest.

- [ ] Audit each `TIMEOUTS.*` use site and identify the observable
      post-condition it's papering over (e.g. `consoleReady` ->
      `#rstudio_console_input` visible + not `.rstudio-console-busy`).
- [ ] Surface the underlying signal in the automation bridge if not
      already exposed.
- [ ] Convert each call site to poll the signal; the assertion that
      follows can run at Playwright's default.
- [ ] Delete the entry from `TIMEOUTS` once all sites are gone.

Volume to chase: 371 inline `timeout: NNNN` occurrences in test code; 50
of them are the 30000 / 60000 cases. Worst files: `panes.test.ts` (47),
`project_trust_dialog.test.ts` (26), `rmarkdown.test.ts` (25),
`code_suggestions.test.ts` (24), `chat_pane.actions.ts` (21),
`create_projects.test.ts` (17), `pane_layout.test.ts` (15).

---

## Nice -- stylistic polish

### Prefer auto-retrying matchers over `toBe(true|false)` on locator booleans

~200 sites. Most are `expect(await isTabChecked(...)).toBe(true)` style in
`tests/panes/layout/pane_layout.test.ts`; `toBeChecked()` or `expect.poll`
would auto-retry and give a better failure message.

- [ ] Audit `pane_layout.test.ts`
- [ ] Audit the rest of `tests/panes/layout/`

### Use specific matchers instead of `toBeTruthy`

- [ ] `tests/panes/misc/s4_unloaded_package.test.ts:42` -- regex match
- [ ] `tests/panes/misc/rs_value_contents.test.ts:28,120`

### Remove in-test `try/catch` swallows

9 sites where catches inside tests hide failure modes (cleanup-hook
catches are fine and excluded):

- [ ] `tests/panes/misc/autocomplete_extras.test.ts:132`
- [ ] `tests/panes/data-viewer/data_viewer.test.ts:165,207,239`
- [ ] `tests/panes/posit-assistant-chat/chat-websocket-url.test.ts:39`
- [ ] `tests/panes/editor/code_suggestions.test.ts:215`
- [ ] `tests/panes/console/console_output.test.ts:77,94,162`
- [ ] `tests/panes/editor/syntax-highlighting.test.ts:63`
- [ ] `tests/panes/editor/editor.test.ts:49`
- [ ] `tests/panes/editor/air_formatting.test.ts:104`

---

## Verified clean (no action needed)

- `test.only` / `describe.only` -- none committed.
- XPath selectors -- none.
- `debugger;` statements -- none.
- `noWaitAfter: true` -- none.
- `#rstudio_*` GWT id selectors (43) -- these are stable, project-preferred
  handles; not a smell.
- Recorded `test.skip` / `test.fixme` -- all but `rmarkdown.test.ts:211`
  have explanations or linked issues.

| Platform | Download |
|----------|----------|
| Windows | [`RStudio-pro-{{< var proVersion >}}.exe`](https://download1.rstudio.org/electron/windows/RStudio-pro-{{< var proVersion >}}.exe) |
| Windows (zip archive) | [`RStudio-pro-{{< var proVersion >}}.zip`](https://download1.rstudio.org/electron/windows/RStudio-pro-{{< var proVersion >}}.zip) |
| macOS 13+ | [`RStudio-pro-{{< var proVersion >}}.dmg`](https://download1.rstudio.org/electron/macos/RStudio-pro-{{< var proVersion >}}.dmg) |
| Ubuntu 22 / 24, Debian 12 / 13 | [`rstudio-pro-{{< var proVersion >}}-amd64.deb`](https://download1.rstudio.org/electron/jammy/amd64/rstudio-pro-{{< var proVersion >}}-amd64.deb) |
| RHEL 9 / 10 | [`rstudio-pro-{{< var proVersion >}}-x86_64.rpm`](https://download1.rstudio.org/electron/rhel9/x86_64/rstudio-pro-{{< var proVersion >}}-x86_64.rpm) |

---
title: "Data Viewer"
date-meta: 2022-12-12
---

RStudio includes a Data Viewer that allows you to look inside data frames and other rectangular data structures. The viewer also allows includes some simple exploratory data analysis (EDA) features that can help you understand the data as you manipulate it with R or Python.

## Starting the viewer

You can invoke the viewer in a console by calling the `View` function on the data frame you want to look at. 

For example, to view the `mpg` dataset from `ggplot2`, execute these commands in the R console:

``` r
library(ggplot2)
mpg_df <- ggplot2::mpg[c("manufacturer", "model", "displ", "cty", "hwy")]
View(mpg_df)
```

![](images/mpg_df-view.png){fig-alt="A datatable in the Data Viewer displaying 5 columns and 10 rows of the mpg_df dataset."}

You can also start the viewer by clicking on the table data icon on the right, in the environment pane:

![](images/mpg_df-object.png){fig-alt="The Environment pane, displaying the mpg_df and highlighting the button for opening the view tab"}

## Sorting

You can sort by any column by clicking on the column label. Click on a column that is already sorted to reverse the sort direction.

![](images/mpg_df-sort.png){fig-alt="A datatable in the Data Viewer displaying 5 columns and 10 rows of the mpg_df dataset, sorted by ascending displ"}

To remove sorting and show the data in the original order, click the empty column label cell in the upper left.

## Scrolling

If you have more than 50 columns in your dataset, the data viewer only displays up to 50 columns. To view additional columns, click the single Cols **>** arrow to scroll right (columns display in groups of 50). If you want to jump to the end of your dataset, click the double Cols **>>** arrows.

![](images/mpg_df-cols.png){fig-alt="A dataset in the Data Viewer displaying 50 columns. The Cols arrows, located at the top of the Data Viewer, are highlighted"}

## Filtering

To apply filters, click the **Filter** icon in the toolbar. Any field that can be filtered will have a white box labeled **All**. Click this box to change which field values you want to see. For instance, to filter out cars with a highway fuel efficiency between 10 and 25 miles/gallon:

![](images/mpg_df-filter.png){fig-alt="A datatable in the Data Viewer displaying 5 columns and 10 rows of the mpg_df dataset. The data is filtered to show values between 10 and 25 for hwy."}

The **Data Viewer** includes a histogram filter or the raw values themselves can be modified. The text on the bottom of the pane indicates how many records the dataset contained before and after filtering; in this case we've filtered 234 records down to 133.

Not all kinds of fields can be filtered. At the moment, the following types are supported:

-   Numeric

-   Character

-   Factor (treated as character if > 256 levels)

-   Boolean (logical)

Filters are additive (i.e. joined with AND); that is, if you apply two column filters, you will see only records that match both of them.

Clear individual filters by clicking the (x) next to the filter; to clear all the filters at once, click the Filter icon in the toolbar.

## Searching

You can search for text across all the columns of your frame by typing in the global filter box:

![](images/mpg_df-search.png){fig-alt="A datatable in the Data Viewer displaying 5 columns and 10 rows of the mpg_df dataset. The data is filtered down to rows that contain 'audi'."}

The search feature matches the literal text you type in with the displayed values, so in addition to searching for text in character fields, you can search for e.g. `TRUE` or `4.6` and see results in logical and numeric field types.

Searching and filtering are additive; when both are applied, you will see only records that match your filters _and_ contain your search text.

## Auto-refreshing

In most cases the viewer will automatically refresh itself if it detects that the underlying data has changed. Auto-refreshing works even when the Data Viewer is popped out into its own window. 

As an example, execute this code:

```r
data(Orange)
View(Orange)
Orange[1, "age"] <- 120
```

The age of the first tree change from 118 to 120 in the viewer.

This auto-refreshing feature has some prerequisites, so if it doesn't seem to be working:

You must call `View()` on a variable directly. If, for instance, you call `View(as.data.frame(foo))` or `View(rbind(foo, bar))`, you're invoking `View()` on a new object created by evaluating your expression, and while that object contains data, it's just a copy and won't update when `foo` and `bar` do.

The variable must be in an environment in the search path ideally in the global environment.

## Labels

The viewer supports column labels, such as those attached by the `Hmisc` package, by SPSS import from `haven`, or manually set via `attr()`. 

As an example, execute the below code:

```r
attr(mpg_df$displ, "label") <- "engine displacement, in litres"
attr(mpg_df$cty, "label") <- "city miles per gallon"
attr(mpg_df$hwy, "label") <- "highway miles per gallon"
View(mpg_df)
```

![](images/mpg_df-label.png){fig-alt="A datatable in the Data Viewer displaying 3 columns and 9 rows of the mpg_df dataset. The columns have labels below the column name."}

Both the `label` attribute on individual columns and the `variable.labels` attribute on the outer frame are supported.

## Restrictions and performance

The number of rows the viewer can display is effectively unbounded, and large numbers of rows won't slow down the interface. It uses the [DataTables](http://www.datatables.net/) JavaScript library to virtualize scrolling, so only a few hundred rows are actually loaded at a time.

While rows and columns are unbounded, large numbers of columns may cause the interface to slow significantly.

Finally, while we've made every effort to keep things speedy, very large amounts of data may cause sluggishness, especially when a sort or filter is applied, as this requires R to fully scan the frame. If you're working with large frames, try applying filters to reduce it to the subset you're interested in to improve performance.

## Lists and other objects

The Data Viewer can also operate on `list()` or JSON objects. This is very helpful for understanding the structure of deeply nested JSON.

Execute the following example:

```r
my_list <- list(
  letters = list(a = 1, b = 2, c = 3),
  pets = list(c("dog", "cat", "lizard"))
)

View(my_list)
```

![](images/list-view.png){fig-alt="A list in the Data Viewer, displaying the ability to open/close nested objects and filter the data."}
The Data Viewer also provides the ability to output the R code to extract a nested object.

Click on a specific line, and the Data Viewer will display the R code to extract that element, or click on the **Send to Console** icon to send the R code to the R console.

![](images/list-extract.png){fig-alt="A list in the Data Viewer, displaying the ability to open/close nested objects and filter the data."}
The data can also be filtered with the search bar, providing a way to navigate larger or more deeply nested objects that will not easily fit on the page.

---
title: "Connection Snippets"
date-meta: 2022-12-12
---

RStudio connections can be extended through two methods:

-  **Snippet Files** on a server-based version of RStudio that provide support for new connections using R templates that enable users and system administrators to list and create new connections.

-  **Packages** that do one or more of the following:

    -   Implement the [Connections Contract](connection-contracts.html) to manage and explore data in the **Connections** Pane and/or

    -   Supply Snippet Files or a Shiny Application to extend the **New Connection** dialog.

## Snippet files

A Connection snippet file is an R code snippet with additional metadata which is intended to initialize a connection. This file can be as simple as:

```r
library(readr)
data <- read_csv(readr_example("mtcars.csv"))
```

This snippet can be saved on a server-based version of RStudio under `/etc/rstudio/connections/`. For desktop versions of RStudio, Connection Snippets are distributed through R packages as detailed in the [R packages] section below.

For the above example on a server, it would be saved as:

```bash
# Linux server only
/etc/rstudio/connections/Motor Trend Cars.R
```

Once that file is created and RStudio is restarted, RStudio will make this connection available as *Motor Trend Cars* underneath **Connect to Existing Data Sources**:

::: {layout-ncol="2"}
![](images/motortrend-connection.png){fig-alt="A screenshot of the New Connection wizard displaying the example \"Motor Trends Cars\" existing data source"}

![](images/basic-connection-interface.png){fig-alt="A screenshot of the New Connection wizard, displaying the snippet output."}
:::

### Snippet test

The snippet can also be tested by pressing the **Test** button in the **New Connection** wizard. Testing will return either a success or failure based on the available code snippet.

![](images/motortrend-test.png){fig-alt="A screenshot of the New Connections wizard, displaying the result of a successful connection test."}

### Snippet customization

The path is configurable through the `connections-path` environment variable and multiple connection files can be specified.

In order to parameterize this connection, one can create fields using using the `${Position:Label=Default}` syntax:

-   **Position:** The row position starting at zero.

-   **Label:** The label assigned to this field.

-   **Default:** An optional default value.

For example, a filter interface for this dataframe can be added with the following connection snippet:

```r
library(readr)
data <- read_csv(readr_example("mtcars.csv"))
data[data$mpg == ${0:Miles per Gallon=21.4} | data$cyl == ${1:Cylinders=6}, ]
```

![](https://rstudio.github.io/rstudio-extensions/resources/connections/fields-connection-interface.png){fig-alt="A screenshot of the New Connection wizard, displaying the ability to add filters or other UI components to the connection/data"}

In order to create a `;` separated list of values, use the syntax `${Position:Label=Default:Key}`. Semicolon-separated list are common in database connections and therefore, natively supported in snippet files, for instance:

```r
"${2:Letters=ABC:LettersKey}${3:Numbers=123:NumbersKey}"
```

![](https://rstudio.github.io/rstudio-extensions/resources/connections/keyvalue-connection-interface.png){fig-alt="A screenshot of the New Connection wizard, displaying the ability to add filters or other UI components to the connection/data"}

There are several escape characters supported: `$colon$` to escape `:` and `$equal` to escape `=`.

## R packages

R packages provide the **New Connection** integration to both server and desktop based versions of RStudio.

### Package structure

A package supporting connections defines the following components:

-   **Connections File:** A DCF file must be created under `inst/rstudio/connections.dcf` to enumerate each connection supported in the package.

-   **Snippet Files:** Snippet files are stored under `inst/rstudio/connections/`.

As a quick start, the [RStudio Connections Example](https://github.com/rstudio/rstudio-connections-example) GitHub repo contains a working example of this structure.

### Connections contract

You can integrate with RStudio's **Connections** pane to allow users to explore connections created with your R package by using the [Connections Contract](connection-contracts.html).

### Snippet files

Snippet Files are specified under the `/inst/rstudio/connections` and follow the same syntax mentioned in the "Snippet Files" section.

### Shiny application

For advanced connection interfaces, a shiny application can be specified. See [sparklyr](https://github.com/rstudio/sparklyr/blob/master/R/connection_shinyapp.R) for a working application.

---
title: "Debugging"
date-meta: 2022-12-12
---

Debugging in R is a broad topic. This documentation focuses specifically on the R debugging tools built into the RStudio. The [Advanced R - Debugging chapter](https://adv-r.hadley.nz/debugging.html) provides more general advice on debugging in R (such as philosophy and problem-solving strategies).

In a very general sense, debugging is designed to help find bugs by figuring out where the code is not behaving as expected. 

To do this:

1.  Begin running the code.

2.  Stop the code at the point where you suspect the problem is arising.

3.  Review and/or walk through the code, step-by-step at that point.

This documentation covers the last two tasks in detail:

- Enter debug mode  
- Stopping on a line  

## Entering debug mode (stopping)

In order to enter debug mode, you need to tell R *when* you want to pause the computation. R doesn't have a "pause now" feature (and most computations are so fast that such a feature would not be helpful). Instead, set "stop points" prior to starting computation.

There are several ways to do this; pick one that corresponds best to the current problem.

### Stopping on a line

#### Editor breakpoints

The most common (and easiest) way to stop on a line of code is to set a breakpoint on that line. To do this in RStudio, click to the left of the line number in the editor, or press <kbd>Shift+F9</kbd> with the cursor on the desired line.

<details>

<summary>Example Code</summary>

```r
library(stringi)

palindrome <- function(x) stri_reverse(x)==x

biggest_palindrome <- function(best_val, print = FALSE) {

  best <- best_val

  for (x in 100:999) {
    for (y in x:999) {
      candidate <- x * y
      if (candidate > best && palindrome(candidate)) {
        best <- candidate
        if(print) message("Candidate is better!")
      }
    }
  }

  return(best)
}

biggest_palindrome(best_val = 0, print = TRUE)
```

</details>

![](images/breakpoint-rstudio.png){fig-alt="A screenshot of example R code, displaying a red break point in the left gutter of the code."}

This is an "editor breakpoint". Editor breakpoints take effect immediately and don't require changes to the code (unlike `browser()` breakpoints, below).

Editor breakpoints work by injecting some tracing code into the R function object. R function objects that include this tracing code have a red dot in the environment pane, indicating that they contain breakpoints.

![](images/breakpoint-environment.png){fig-alt="A screenshot of the RStudio Environment pane, indicating a breakpoint function with a red circle." width="450"}

If the function object doesn't exist yet (for instance, because `source()` hasn't been called on the file), or the function object doesn't match the contents of the editor (for instance, because the file has changed since the last `source()`), the breakpoint will be deferred.

![](images/breakpoint-sourced.png){fig-alt="A screenshot of example R code and a warning that 'breakpoints will be activated when this file is sourced.'"}

The hollow red circle indicates that RStudio is aware of the breakpoint, but that it hasn't been injected. In most cases, call `source()` on the file to resolve this problem.

#### browser() breakpoints

The R function [`browser()`](https://stat.ethz.ch/R-manual/R-devel/library/base/html/browser.html) halts execution and invokes an environment browser when it is called. A `browser()` call can be added anywhere in the code to stop at that point in the code for debugging. Here, for instance, it's used to halt when a function is about to return `TRUE`:

![](images/browser-debug.png){fig-alt="A screenshot of R code with a browser() call, along with the traceback."}

Unlike an editor breakpoint, the `browser()` statement is actually part of the code, so it needs to be applied like any other code change in order to become active (by sourcing the containing document, rebuilding the containing package, reloading the Shiny application, etc.).

The environment browser invoked by `browser()` is the same one used in all of the other debugging facilities, so it can be considered the lowest-level debugging tool. Because the `browser()` statement requires no special tooling, it can be used in contexts where editor breakpoints won't work.

`browser()` is also useful for creating conditional breakpoints. For instance, if you want to start debugging after hundreds of loop iterations:

```r
for (i in 1:1024) {
  start_work()
  if (i == 512)
    browser()
  finish_work()
}
```

### Stopping when a function executes

If there is a local copy of the .R file corresponding to the code needing debugging, it's easy to use editor breakpoints or `browser()` to add breakpoints to it. Sometimes, however, there isn't a source file for the code.

When this is the case, **set a debug flag** on the function to debug. This is similar to setting a breakpoint before the very first statement in a function; it does not change the function itself, but it causes the debugger to activate immediately when the function is run.

Use the R function [`debugonce()`](https://stat.ethz.ch/R-manual/R-devel/library/base/html/debug.html) to set the debug flag on a function. For instance, to debug `devtools::install()`:

```r
> debugonce(devtools::install)
```

`debugonce()` sets a one-shot breakpoint--that is, the function will enter the debugger the very next time it runs, but not after that. To debug a function *every* time it executes, call `debug(...)` on the function. Call `undebug(...)` on the function when to stop debugging the function each time it executes. We don't recommend this pattern, since it can leave you trapped in the debugger for some special functions.

### Stopping when an error occurs

When diagnosing a specific error, RStudio can halt execution at the point where the error is raised. To do this, go to *Debug -\> On Error* and change the value from "Error Inspector" to "Break in Code".

![](images/error-inspector.png){fig-alt="A screenshot of the Debug Menu in RStudio and selecting 'On Error > Error Inspector'" width="350"}

To keep the the debugger from being invoked whenever any error anywhere happens, RStudio does not invoke the debugger if it looks like none of your own code is on the stack. If you find that this is excluding an error you want to catch, go to *Tools -\> Global Options* and uncheck "Use debug error handler only when my code contains errors".

The following code will always invoke the debugger on every error:

``` r
options(error = browser())
```

This overrides RStudio's error handler settings. Trapping every error will quickly become annoying, though, so be sure to use the *Debug* menu to change the `error` option back when you're done troubleshooting (or turn off error handling entirely with `options(error = NULL)`

## Using the debugger

Once the code is stopped, the IDE automatically enters debug mode, in which a variety of tools for inspecting and altering the state of your program become available. The debugging tools are displayed in the screenshot below, and further explored in the below sections.

![](images/using-the-debugger.png){fig-alt="A screenshot of RStudio displaying example R code with a browser(), the R Console executing within the browser() context, the environment pane, and the traceback to the specific function with the browser." width="750"}

### Environment pane

Usually in R you're interacting with the "global environment", a list of named objects such as values, functions, and data. When you enter debug mode, the IDE begins viewing and interacting with the currently executing function's environment instead. That means that the objects you see in the Environment pane belong to the currently executing function, and statements you enter in the Console will be evaluated in the context of the function.

![](images/environment-pane.png){fig-alt="A screenshot of the Environment Pane relevant to the currently execting function." width=450}

The gray values are promises--in this case, function arguments that haven't been evaluated yet.

Above the list of local objects in the Environment pane is a drop-list that shows you the "environment stack". This shows you the inheritance chain for the active environment--that is, the list of places that will be searched to resolve variable names to values.

![](images/traceback-dropdown.png){fig-alt="A screenshot of the RStudio Environment pane and the environment stack with additional packages, global environment, etc, that are all part of the debugger stack." width=450}

Most of the time it will include just the current function, the global environment, and some package namespaces, but if you're writing a package or nesting functions, it'll have additional entries. You can click any item in the droplist to see the contents of the corresponding environment.

If this all sounds confusing, don't worry--most of the time you won't need to dive into the environment stack! If you want to understand what's going on under the covers, see [Environments](https://adv-r.hadley.nz/environments.html) for a detailed look at how environments and inheritance work.

#### Traceback (Callstack)

The traceback shares space with the environment pane. It shows you how execution reached the current point, from the first function that was run (at the bottom) to the function that is running now (at the top).

![](images/traceback.png){fig-alt="A screenshot of the Traceback pane, indicating the current function that is running." width=450}

This is called the "call stack" in most languages; RStudio refers to it as the "traceback" for symmetry with the R command [`traceback()`](https://stat.ethz.ch/R-manual/R-devel/library/base/html/traceback.html).

You can click on any function in the callstack to see the current contents of its environment and the execution point in the function's code, if it can be determined. Note that selecting a frame in the callstack does *not* change the active environment in the console! If you need to do that, use `recover()` (described below).

Most of the time you'll only be interested in looking at the portions of the callstack that contain your own code, so by default RStudio hides internal functions (i.e. those for which it does not have a corresponding .R file) in the callstack to keep it from becoming too verbose. The **View Internals** checkbox can be toggled to show or hide internal functions in the callstack. For instance, inside a `tryCatch` block, you can expand the internals to see R's exception handling functions (shown in gray):

![](images/traceback-show-internals.png){fig-alt="A screenshot of the Traceback pane, along with the 'Show Internals' box checked, displaying internal functions in grey." width=450}

### Code window

The code window shows you the currently executing function. The line about to execute is highlighted in yellow.

![](images/debug-source.png){fig-alt="A screenshot of a R script, where the line about to execute is highlighted in yellow."}

If RStudio can't find a .R file that matches the function, it will show the code in the Source Viewer. This can happen either because no .R file exists or because the function object doesn't match the definition in the .R file.

### Console

![](images/debug-console.png){fig-alt="A screenshot of the R console and that the prompt has been turned into Browse>."}

While debugging, you'll notice two changes to the R console. The first is that the prompt is different:

    Browse[1]> 

This prompt indicates that you're inside the R environment browser.

The R console while debugging supports all the same commands as the ordinary console, with a few differences:

1.  Statements are evaluated in the current environment--that is, if your function has a variable named `x`, typing `x` at the prompt will show you the value of that variable. (Try `ls()` at the prompt to see all the variables).

2.  Simply pressing Enter at the console will execute the current statement and move on to the next one. This is a convenient way to step through statements quickly.

3.  A variety of special debugging commands are available (described below)

If you want to interact with a different function's environment at the console, use [`recover()`](https://stat.ethz.ch/R-manual/R-devel/library/utils/html/recover.html) to display a list of running functions, from which you can select.

The second is that there's a new toolbar on top of the console:

![](images/debug-menu.png){fig-alt="The debug menu with next, recover, continue or stop buttons."}

This toolbar provides convenient buttons that send the special debug control commands (see table below) to the R console. There's no difference between using the toolbar and entering the commands at the console directly, so it's helpful to learn the command shortcuts if you spend much time debugging.

### Debugging commands

| Command    | Shortcut | Description            |
|------------|----------|------------------------|
| n or Enter | F10      | Execute next statement |
| s          | Shift+F4 | Step into function     |
| f          | Shift+F6 | Finish function/loop   |
| c          | Shift+F5 | Continue running       |
| Q          | Shift+F8 | Stop debugging         |

All of these commands are documented in the R help page for [browser()](https://stat.ethz.ch/R-manual/R-devel/library/base/html/browser.html); you can also type `help` at the `Browse[N]>` prompt to see them.

## Special circumstances

Most of the time you'll likely be debugging in straightforward, free-standing R functions and scripts. However, some special circumstances arise when debugging R code that's part of a larger project; here are four that require some special mention:

### Debugging outside functions

You might have noticed earlier that RStudio (and R itself, via [`setBreakpoint()`](https://stat.ethz.ch/R-manual/R-devel/library/utils/html/findLineNum.html)) creates breakpoints by modifying the function in which a breakpoint is set. What happens when you set a breakpoint *outside* a function?

The most common use case here is halting during execution of a `source()` command, to examine the state during execution of an R script. R's built-in `source()` command doesn't have a way to do this, but RStudio includes its own version of `source()` called `debugSource()` that does. This version is able to halt at the breakpoints RStudio knows about.

Consequently, if a file contains breakpoints outside functions, you'll need to call `debugSource()` in place of `source()` on that file. RStudio does this for you automatically when the file contains breakpoints and you use the RStudio **Source** command to source your script.

It's important to note that `debugSource` is not recursive. This implies that if you call `source("file1.R")` inside `file2.R`, then execute the whole thing with `debugSource("file2.R")`, you'll hit breakpoints in `file2.R`, but not `file1.R`. We generally recommend that you isolate code for debugging, but if you need to work this way, you can call `debugSource` manually inside your R script.

### Debugging in packages

Breakpoints can be set in package code just as they can in free-standing R code. The primary difference is that you'll need to have an up-to-date build of your package in order to set breakpoints. If your package build isn't up to date, RStudio will warn you when you try to set a breakpoint.

In order to debug effectively in your package, you'll also want to ensure that your package is compiled with the `--with-keep.source` option. This option is the default for new packages in RStudio; if you need to set it manually, it can be found in *Tools -\> Project Options -\> Build Tools*.

![](images/debug-package-tools.png){alt=""}

When a breakpoint is set in a file inside a package, RStudio will automatically disable the breakpoint when the package is unloaded and enable the breakpoint when the package is loaded. If you're having trouble setting breakpoints in a package, make sure that the package was compiled with source information as described above and that its build is up-to-date.

### Debugging in Shiny applications

Shiny applications present some challenges for the debugger because the breakpoints can't be set until the application is executed; the function objects that need to have breakpoints injected don't exist until then.

For this reason, breakpoints in Shiny applications *only* work inside the `shinyServer` function. Breakpoints are not currently supported in the user interface (i.e. `ui.R`), globals (i.e. `global.R`), or other .R sources used in Shiny applications.

![](images/debug-shiny.png){fig-alt="A screenshot of the debugger operating on a Shiny app"}

Finally, be aware that Shiny's infrastructure displays in the callstack, and there's quite a lot of it before control reaches your code! The ["Mastering Shiny" Debugging chapter](https://mastering-shiny.org/action-workflow.html#debugging) goes deeper on general Shiny debugging.

### Debugging in R Markdown documents

Breakpoints don't currently work inside R chunks in R Markdown documents, so you'll need to use `browser()` to halt execution in a chunk if needed.

By default, RStudio renders R Markdown documents using a separate R process when you click the **Knit** button. This has many benefits; it keeps the document reproducible by isolating it from your current session's state, and it keeps the UI and console responsive while the document renders. However, debugging only works with the primary R process, so when rendering the document for debugging, you'll need to ensure it renders there.

To do this, call `rmarkdown::render()` directly on your file:

```r
rmarkdown::render("path/to/file.Rmd")
```

This runs the code in the current session, which makes it easier to debug. If doing this makes the problem go away, you’ll need to figure out what makes the environments different.

If the problem persists, you’ll need to use your interactive debugging skills.

When the interactive debugger shows up in the console, it will not print user output. If you want to see output in the console, you should use `sink()`.

```r
Browse[1]> sink()
```

This removes the default sink that knitr uses to capture all output, and ensures that you can see the results in the console. For example, to use `recover()` with R Markdown, you’d put the following code in your setup block:

```r
options(error = function() {
  sink()
  recover()
})
```

This generates a "no sink to remove" warning when knitr completes; you can safely ignore this warning.

If you simply want a traceback, the easiest option is to use `rlang::trace_back()`, taking advantage of the `rlang_trace_top_env` option. This ensures that you only see the traceback from your code, instead of all the functions called by R Markdown and knitr.

```r
options(rlang_trace_top_env = rlang::current_env())
options(error = function() {
  sink()
  print(rlang::trace_back(bottom = sys.frame(-1)), simplify = "none")
})
```

Finally, because R Markdown chunks don't contain [source references](http://journal.r-project.org/archive/2010-2/RJournal_2010-2_Murdoch.pdf), most of the debugger's visual features are disabled; you won't see the active line highlighting in the editor and most debugging will need to be done in the console. The ["Advanced R" - Debugging R Markdown chapter](https://adv-r.hadley.nz/debugging.html#rmarkdown) has does deeper on general R Markdown debugging.

### Debugging in Quarto Documents

When debugging Quarto documents with a knitr engine, rather than using `quarto::quarto_render()`, use `rmarkdown::render("path/to/file.qmd")`. This will provide the same workflow as above for R Markdown documents.

::: {.callout-warning}

Using `quarto::quarto_render("path/to/file.qmd")` is currently not compatible with debugging strategies outlined in this documentation. Instead, use `rmarkdown::render()` to troubleshoot knitr issues as indicated above.

:::

# RStudio End-to-End Tests

End-to-end tests are written in TypeScript with Playwright. The rsession is started with `--automation-agent`, which causes the GWT frontend to install a JS automation bridge at `window.rstudio` (see `ApplicationAutomation.java`). The Playwright command helpers in `utils/commands.ts` drive the IDE through this bridge instead of the R console, avoiding the focus-shift and pane-collapse pitfalls of the console path.

The `window.rstudio` surface includes:

- `window.rstudio.ready` -- boolean flipped to `true` once R's deferred init has run; the canonical "automation can start" signal (reset to `false` on restart or project open/close).
- `window.rstudio.commands.<commandId>()` -- execute an AppCommand; `.isChecked()` / `.isEnabled()` / `.isVisible()` query its state (note `isEnabled()` is `enabled_ && isVisible()`, so an invisible programmatic command reads disabled even when it dispatches fine). `commands.list` is the array of all command ids.
- `window.rstudio.prefs.<camelCaseName>.get()` / `.set(value)` / `.clear()` -- `set` and `clear` return a Promise that resolves once the `setUserPrefs` RPC has landed server-side.
- `window.rstudio.documents` -- `active()`, `activeEditor()` (native Ace editor), `open(path, opts?)`, `closeAllNoSave()`, `resetToUntitled()`.
- `window.rstudio.project` -- `path()`, `name()`, `isActive()`, `open(path)`.
- `window.rstudio.version` -- `{ rstudio, r }` version strings.
- `window.rstudio.dialogs` -- `numShowing()`, `dismissAll()`.
- `window.rstudio.console.promptCount` -- a monotonic counter that advances by one each time R returns to its top-level prompt (i.e. a submitted console command completed). It is driven by the `ConsolePromptEvent`, so it is a race-free completion signal: `executeInConsole({wait:true})` captures it before submitting and waits for it to increase, rather than sampling the `rstudio-console-busy` class (which can be read stale in the submit->busy gap, or miss a fast command's busy flash). Prefer this for awaiting R-side side effects; the busy-class `waitForConsoleIdle` remains only as a fallback for binaries that predate the counter.
- `window.rstudio.layout.reset()` -- end any active pane/column zoom or pane maximize.
- `window.rstudio.completions.setAlwaysShowPopup(force)` -- automation-only override: when `force` is true, a completion request returning exactly one result shows the popup instead of auto-accepting the match (the default RCompletionManager / CompletionManagerBase behavior for explicit requests, e.g. Ctrl+Space). The popup-reading helpers in `actions/autocomplete.actions.ts` wrap their requests in this so item enumeration is deterministic regardless of result count; leave it off (the default) to exercise the real auto-accept path.
- `window.rstudio.errors` -- `list()` / `clear()` the uncaught client exceptions recorded by the agent (message + stack); `simulate(msg)` raises a real one (harness self-test only). Unhandled promise rejections are recorded too (message prefixed with "Unhandled promise rejection:"), since GWT does not route native promise continuations through its uncaught-exception handler. The per-test fixture drains this and fails the test that raised an exception (opt out with `PW_IGNORE_CLIENT_EXCEPTIONS=1`).

When a test fails, the per-test fixture (`fixtures/rstudio.fixture.ts`) attaches two diagnostics to the report so symptoms that never reach a failed assertion are still recoverable: `browser-console.log` (buffered `console.error`/`console.warning` plus uncaught `pageerror`s captured during the test body) and, on Desktop, the slice of each rsession log file (`RSTUDIO_DATA_HOME/log/*.log`) written while the test ran. Both are scoped to the single test -- the console buffer is cleared and the log byte-offsets are snapshotted at test start. This is separate from the `window.rstudio.errors` fail-the-test mechanism above: client exceptions still fail the test by themselves, but the attachments add the surrounding browser-console and backend-log context.

Commands and prefs are enumerated up front at agent init, so a missing-by-name lookup is a genuine "doesn't exist" rather than "not yet touched by GWT code".

See `.claude/skills/rstudio-create-playwright-tests/SKILL.md` for detailed guidance on writing Playwright tests, and `.claude/skills/rstudio-run-playwright-tests/SKILL.md` for how to run them.

This folder contains the RStudio UI code, written using the Google Web Toolkit (GWT).

RStudio uses a custom fork of GWT, with the pre-built custom JARS installed as a dependency.

The source code for this fork can be found at https://github.com/rstudio/gwt. Only read this
if working on something requiring deep knowledge of GWT internals that can't be figured out
from existing usage and the documentation.

# ANSI / Control Code Support in the RStudio Console

Last Updated: 2026-05-29

This summarizes how the RStudio Console's `VirtualConsole` and `AnsiCode`
classes handle terminal control sequences.

- Frontend parser: `src/gwt/src/org/rstudio/core/client/VirtualConsole.java`
- SGR / color logic: `src/gwt/src/org/rstudio/core/client/AnsiCode.java`

The branch `bugfix/17768-multi-progress-bars` (PR #17786) adds line-aware
cursor movement: **CSI A/B (up/down)**, **CSI E/F (next/previous line)**, and
**CSI G (cursor horizontal absolute)**. It also changes the horizontal moves
**CSI C/D and backspace** so they no longer cross line boundaries (see
[Behavior change](#behavior-change-horizontal-moves-stay-within-the-line)).
Items not marked "New on this branch" predate it.

ANSI handling is gated by the `ansi_console_mode` user preference
(`on` / `off` / `strip`). When `off`, only the plain control characters
`\r \b \f \n` are interpreted and escape sequences are passed through; when
`strip`, SGR styling is removed rather than applied.

---

## Supported control characters

| Char | Name | Behavior |
|------|------|----------|
| `\r` (CR) | Carriage return | Moves cursor to start of current line |
| `\b` (BS) | Backspace | Moves cursor back one column, clamped to the start of the current line (no longer crosses the preceding newline) |
| `\n` (LF) | Line feed / newline | Moves to / inserts a new line |
| `\f` (FF) | Form feed | Clears the entire console |

## Supported CSI sequences (`ESC [ ... <letter>`)

| Sequence | Name | Status | Behavior |
|----------|------|--------|----------|
| `CSI n m` | SGR (Select Graphic Rendition) | Supported | Colors / font styling (see SGR table) |
| `CSI n A` | CUU (Cursor Up) | **New on this branch** | Move cursor up n rows, column preserved/clamped |
| `CSI n B` | CUD (Cursor Down) | **New on this branch** | Move cursor down n rows, column preserved/clamped |
| `CSI n C` | CUF (Cursor Forward) | Supported | Move cursor right n columns, clamped to the end of the current line |
| `CSI n D` | CUB (Cursor Back) | Supported | Move cursor left n columns, clamped to the start of the current line |
| `CSI n E` | CNL (Cursor Next Line) | **New on this branch** | Move to column 0 of the line n rows down (clamped to last row) |
| `CSI n F` | CPL (Cursor Previous Line) | **New on this branch** | Move to column 0 of the line n rows up (clamped to first row) |
| `CSI n G` | CHA (Cursor Horizontal Absolute) | **New on this branch** | Move to column n (1-based) on the current line, clamped to line length |
| `CSI n K` | EL (Erase in Line) | Supported | Modes 0 (to EOL), 1 (to BOL), 2 (whole line) |

## Supported SGR parameters (`CSI n m`)

| Code(s) | Meaning | Notes |
|---------|---------|-------|
| `0` | Reset all attributes | |
| `1` | Bold | |
| `2` | Faint / dim | |
| `22` | Bold/faint off | |
| `3` | Italic | |
| `23` | Italic off | |
| `4` | Underline | |
| `24` | Underline off | |
| `5` | Blink (slow) | Rendered as a single blink style |
| `6` | Blink (fast) | Rendered as a single blink style |
| `25` | Blink off | |
| `7` | Inverse / reverse video | Swaps fg/bg |
| `27` | Inverse off | |
| `8` | Hidden / conceal | |
| `28` | Hidden off | |
| `9` | Strikethrough | |
| `29` | Strikethrough off | |
| `30`-`37` | Foreground color (8 standard) | |
| `40`-`47` | Background color (8 standard) | |
| `90`-`97` | Bright foreground color | |
| `100`-`107` | Bright background color | |
| `38;5;n` | 256-color foreground | Index colors supported |
| `48;5;n` | 256-color background | Index colors supported |
| `38;2;r;g;b` | 24-bit RGB foreground | **Parsed but ignored** (not rendered) |
| `48;2;r;g;b` | 24-bit RGB background | **Parsed but ignored** (not rendered) |
| `39` | Default foreground | |
| `49` | Default background | |
| `10` | Default (primary) font | |
| `11`-`18` | Alternate fonts | Treated only as "turn off font 19" |
| `19` | Font 19 | RStudio-specific: reduces line spacing |

## Supported non-CSI / RStudio-custom escapes

| Sequence | Meaning | Behavior |
|----------|---------|----------|
| `ESC ] 8 ; params ; url BEL` (OSC 8) | Hyperlink start/end | Renders clickable links |
| `ESC \` (ST, String Terminator) | Terminator | Consumed / skipped |
| `ESC G n ;` ... `ESC g` | RStudio group span (error/warning/message/agent) | Custom output grouping |
| `ESC H n ;` ... `ESC h` | RStudio highlight span (error/warning/message) | Custom condition highlighting |

---

## Behavior change: horizontal moves stay within the line

Before this branch, `CSI C` (right), `CSI D` (left), and backspace operated as
plain arithmetic on the flat buffer offset, so moving past the edge of a line
would slide across the embedded `\n` onto an adjacent line -- a horizontal move
effectively travelling vertically. That never matches a real terminal.

They are now clamped to the current line: left/backspace stop at the start of
the line, right stops at the end. Code that used "cursor left N" or backspace
to climb to a previous line will no longer do so and should use `CSI A` (up) or
`CSI F` (previous line). This also keeps the cursor from landing on a foreign
line's `\n`, which the line-sensitive operations (`\r`, `CSI K`) would otherwise
misattribute to the following line.

---

## Commonly used ANSI codes that are NOT supported

These are recognized by the generic ANSI regex and **silently discarded**
(the bytes are consumed so they don't appear as garbage, but they have no
effect). Tab and BEL are not matched at all and pass through as literal
characters.

| Sequence | Name | Notes |
|----------|------|-------|
| `\t` (TAB) | Horizontal tab | Not in the control-char set; emitted literally |
| `\a` / `BEL` (`\007`) | Bell | Not interpreted; passes through |
| `CSI r ; c H` | CUP (Cursor Position) | Discarded - no absolute positioning |
| `CSI r ; c f` | HVP (Horizontal/Vertical Position) | Discarded |
| `CSI n J` | ED (Erase in Display) | Discarded - cannot clear screen regions |
| `CSI n S` | SU (Scroll Up) | Discarded |
| `CSI n T` | SD (Scroll Down) | Discarded |
| `CSI s` / `CSI u` | Save / Restore cursor position | Discarded |
| `CSI n @` | ICH (Insert Character) | Discarded |
| `CSI n P` | DCH (Delete Character) | Discarded |
| `CSI n X` | ECH (Erase Character) | Discarded |
| `CSI n L` | IL (Insert Line) | Discarded |
| `CSI n M` | DL (Delete Line) | Discarded |
| `CSI ? 25 h` / `CSI ? 25 l` | Show / Hide cursor | Discarded |
| `CSI ? 1049 h/l` | Alternate screen buffer | Discarded |
| `CSI n h` / `CSI n l` | SM / RM (Set / Reset mode) | Discarded |
| `CSI n n` | DSR (Device Status Report) | Discarded |
| `ESC c` | RIS (Reset to Initial State) | Discarded |
| `ESC 7` / `ESC 8` | DECSC / DECRC (save/restore cursor) | Discarded |
| `ESC ( B` etc. | Designate character set | Discarded |
| SGR `53` / `55` | Overline on/off | Discarded |

### Notable gaps

Everything below describes the **Console pane** (`VirtualConsole`). The
separate **Terminal pane** is built on xterm.js (`TerminalSession extends
XTermWidget`) and is a full terminal emulator, so it supports absolute cursor
positioning, erase-in-display, alternate screen buffer, etc.

- **No 2-D absolute cursor positioning** (`CUP`/`HVP`): the console can move
  within a line (`CHA`/`CSI G` is now supported) and between lines (`CSI A/B/E/F`),
  but cannot set an absolute (row, column). Full-screen TUIs relying on
  `ESC[r;cH` will not render correctly.
- **No Erase in Display** (`CSI J`): only single-line erase (`CSI K`) is
  available; `\f` is the only way to clear everything.
- **No 24-bit truecolor**: RGB SGR sequences are parsed to keep the stream in
  sync but produce no color; only the 256-index palette is rendered.
- **No alternate screen buffer / scroll-region** support, so programs that
  expect a real terminal (e.g. `htop`, full-screen pagers) are not supported.

---
title: "RStudio Addins"
date-meta: 2022-12-12
---

RStudio addins provide a mechanism for executing R functions interactively from within RStudio; either through keyboard shortcuts, through the **Command Palette** or through the **Addins** menu.

An addin can be as simple as a function that inserts a commonly used snippet of text, and as complex as a Shiny application that accepts input from the user, and later mutates a document open in RStudio.

## Using addins

The following documentation covers:  

- Basics of installing addins  
- Binding keyboard shortcuts to them  
- Developing new addins  

## Installation

RStudio addins are distributed as [R packages](https://r-pkgs.org/). Once you've installed an R package that contains addins, they'll be immediately become available within RStudio.

Let's start by playing around with a couple of the example addins provided by the [addinexamples](https://github.com/rstudio/addinexamples) package. Within RStudio, install this package (plus its requisite dependencies) with:

``` r
# if necessary: install.packages("devtools")
devtools::install_github("rstudio/addinexamples", type = "source")
```

## Running addins

After installing this package, you should see the *Addins* toolbar menu populated with the addins exported by this package:

![](images/addin-examples.png){alt="Addins Menu" fig-alt="A screenshot of the addinexamples dropdown - displaying the insert, find and replace, reformat R code, and Subset a data frame add-ins." width="400"}

Try pressing the **Insert %in%** addin -- the text `%in%` will be inserted at the cursor position.

The **Addins** menu displays all available addins, along with a search bar for searching by package name or by addin name:

![](images/addin-search.png){width="450"}

### Keyboard shortcuts

Addins can be assigned a keyboard shortcut through the **Tools** \> **Modify Keyboard Shortcuts** menu.

![](images/addin-shortcut.png){fig-alt="A screenshot of the Customize Keyboard shortcuts menu"}

## Developing addins

### Addin basics

The **Insert %in%** addin is implemented entirely with R code. In fact, the R function that made this happen is located [here](https://github.com/rstudio/addinexamples/blob/master/R/insertInAddin.R), and its definition is show below:

``` r
insertInAddin <- function() {
  rstudioapi::insertText(" %in% ")
}
```

Executing `addinexamples::insertInAddin()` directly at the console will insert `%in%`. RStudio is executing that R script behind the scenes, the addin is providing a user interface element and potentially a shortcut rather than manually writing and executing the function each time.

There are two major types of addins:

1.  Text macros, which insert text into the console or source pane and in some cases transform text within the source pane. The `insertInAddin` addin defined above is an example of a text macro.

2.  Shiny Gadgets, which are fully interactive Shiny applications. Gadgets may also perform text transformations but they are capable of much more.

More details on Shiny Gadgets are provided below, but first we'll take a look at using the [rstudioapi](https://rstudio.github.io/rstudioapi/) package (which allows us to interact with RStudio from R code) and then what it takes to install and register an addin.

### RStudio API

The [rstudioapi](https://rstudio.github.io/rstudioapi/) package allows interacting with RStudio directly with R code.

``` r
install.packages("rstudioapi")
```

For addins in particular, a number of methods were added that allow R code to introspect and mutate the contents of a document open in RStudio. These methods are outlined below briefly, but see documentation within the [rstudioapi](https://rstudio.github.io/rstudioapi/) package for more details.

|                                         |                                                                                              |
|----------------------|--------------------------------------------------|
| `getActiveDocumentContext()`            | Returns information about the currently active RStudio document. See below for more details. |
| `insertText(location, text, id = NULL)` | Insert text at a specific location within a document.                                        |
| `setDocumentContext(text, id = NULL)`   | Set the contents of a document open in RStudio.                                              |

The list returned from `getActiveDocumentContext()` provides the following information about the active RStudio document:

-   *id* --- The unique document id.

-   *path* --- The path to the document on disk.

-   *contents* --- The contents of the document.

-   *selection* --- A list of selections.

The `id` can be passed to other functions within the API to address a specific document instance rather than the currently active document. Even though it's optional, it's highly recommended that you use the `id` parameter to ensure that you modify the document that was active when your addin was invoked.

The `location` argument to several of the API functions specifies a position or range to operate on. See the [rstudioapi manual](https://rstudio.github.io/rstudioapi/) for more details on specifying locations.

### Registering addins

Addins are just R functions, distributed via R packages. The registration file located at [inst/rstudio/addins.dcf](https://github.com/rstudio/addinexamples/blob/master/inst/rstudio/addins.dcf) lets RStudio know which addins are available. Each addin should have the following four fields:

-   **Name**: The name of the addin.

-   **Description**: A description of the addin.

-   **Binding**: The R function this addin is associated with.

-   **Interactive**: Whether this addin is interactive (e.g. runs a Shiny application).

For example:

``` markdown
Name: Insert %in%
Description: Inserts `%in%` at the cursor position.
Binding: insertInAddin
Interactive: false
```

To create your own RStudio addins:

1.  Create an R package

2.  Create some R functions

3.  Create a file at `inst/rstudio/addins.dcf`

RStudio will automatically discover and register these addins when your package is installed. Any number of addins can be added with a single `addins.dcf` file, but a blank line must be between each addin that is registered.

### Execution Modes

The `Interactive` field within the addin registration describes whether the addin is interactive or non-interactive. It's important to understand when an addin should be declared as interactive versus non-interactive, as this affects how RStudio will attempt to execute the addin:

-   Interactive addins are invoked by emitting a call to their function directly into the R console. For addins that display user-interface (e.g. using a Shiny application) this enables users to stop/interrupt them.

-   Non-interactive addins are run in the background and **can not be interrupted**, so it's imperative that these addins complete execution quickly. Otherwise, it's possible that the addin could freeze the user's R session.

The use case for non-interactive addins is typically simple text insertion or transformation, in which case users would be annoyed if each invocation resulted in code being inserted into the console.

## Shiny Gadgets

Shiny gadgets are Shiny applications which can be registered and run as addins. Typically, a Shiny Gadget provides a mechanism for interactively generating code, or modifying a document, but within this realm the possibilities are endless. This article demonstrates how you might create a simple Shiny Gadget, for more complete documentation see the following articles on the Shiny Developer Center:

-   [Shiny Gadgets](https://shiny.posit.co/r/articles/build/gadgets/)

-   [Designing Gadget UI](https://shiny.posit.co/r/articles/build/gadget-ui/)

Shiny Gadgets are similar to regular Shiny applications. You will need to develop a `ui` and a `server` for your gadget, and then use the `runGadget()` function to launch your gadget.

Shiny Gadgets require the **shiny** and **miniUI** packages:

``` r
install.packages(c("shiny", "miniUI"))
```

### Gadget UI

The UI for a Shiny Gadget can be generated using functions from the miniUI package. Typically, the UI definition of a Shiny Gadget will have the following form:

``` r
ui <- miniPage(
  gadgetTitleBar("My Gadget"),
  miniContentPanel(
    ## Your UI items go here.
  )
)
```

If you're unfamiliar with how the UI for a Shiny application can be generated, please read the [Shiny UI Lesson](https://shiny.posit.co/r/getstarted/shiny-basics/lesson2/) to get further acquainted with how the UI for a Shiny application might be developed.

### Gadget Server

The server function used for a Shiny Gadget is similar to one as provided for a regular Shiny application, except with the requirement that your application must respond to the `done` event. For example,

``` r
server <- function(input, output, session) {
  
  ## Your reactive logic goes here.
  
  # Listen for the 'done' event. This event will be fired when a user
  # is finished interacting with your application, and clicks the 'done'
  # button.
  observeEvent(input$done, {
    
    # Here is where your Shiny application might now go and affect the
    # contents of a document open in RStudio, using the `rstudioapi` package.
    #
    # At the end, your application should call 'stopApp()' here, to ensure that
    # the gadget is closed after 'done' is clicked.
    stopApp()
  })
}
```

### Gadget Viewer

After defining the ui and server for your Shiny gadget, choose what kind of viewer the application should run in. Currently, there are three options available:

-   **paneViewer()**: Launch the Shiny Gadget within the RStudio **Viewer** pane. This is useful for gadgets that want to run without obscuring other windows in the RStudio, but such applications should require only a minimal amount of space (as the viewer may be small on the user's computer).

-   **dialogViewer()**: Launch the Shiny Gadget as a modal dialog within the RStudio. Use this when your gadget requires a large amount of screen real estate, but is not heavy-weight enough to require a separate window.

-   **browserViewer()**: Launch the Shiny gadget in a separate window. Use this for large Shiny gadgets that require a large amount of real estate, and perhaps are more complex than applications that could fit comfortably within an RStudio modal dialog.

### Putting It Together

Let's combine the above components into a simple 'Hello Shiny' gadget. We'll create a clock that updates its display every second. Try running the following code in RStudio -- you should see a clock displayed in the viewer pane. When you click `Done`, the current time will be inserted at the cursor position.

``` r
library(shiny)
library(miniUI)

# We'll wrap our Shiny Gadget in an addin.
# Let's call it 'clockAddin()'.
clockAddin <- function() {
  
  # Our ui will be a simple gadget page, which
  # simply displays the time in a 'UI' output.
  ui <- miniPage(
    gadgetTitleBar("Clock"),
    miniContentPanel(
      uiOutput("time")
    )
  )
  
  server <- function(input, output, session) {
    
    # Set some CSS styles for our clock.
    clockStyles <- paste(
      "border: 1px solid #DADADA",
      "background-color: #EFEFEF",
      "border-radius: 5px",
      "font-size: 6em",
      "margin-top: 60px",
      "text-align: center",
      sep = "; "
    )
    
    # We'll use a 'reactiveTimer()' to force Shiny
    # to update and show the clock every second.
    invalidatePeriodically <- reactiveTimer(intervalMs = 1000)
    observe({
      
      # Call our reactive timer in an 'observe' function
      # to ensure it's repeatedly fired.
      invalidatePeriodically()
      
      # Get the time, and render it as a large paragraph element.
      time <- Sys.time()
      output$time <- renderUI({
        p(style = clockStyles, time)
      })
    })
    
    # Listen for 'done' events. When we're finished, we'll
    # insert the current time, and then stop the gadget.
    observeEvent(input$done, {
      timeText <- paste0("\"", as.character(Sys.time()), "\"")
      rstudioapi::insertText(timeText)
      stopApp()
    })
    
  }
  
  # We'll use a pane viwer, and set the minimum height at
  # 300px to ensure we get enough screen space to display the clock.
  viewer <- paneViewer(300)
  runGadget(ui, server, viewer = viewer)
  
}

# Try running the clock!
clockAddin()

# Now all that's left is sharing this addin -- put this function
# in an R package, provide the registration metadata at
# 'inst/rstudio/addins.dcf', and you're ready to go!
```

That example provides a fully functional Shiny gadgets. Additional documentation on creating Gadgets is available at the Shiny Developer Center:

-   [Shiny Gadgets](https://shiny.posit.co/r/articles/build/gadgets/)

-   [Designing Gadget UI](https://shiny.posit.co/r/articles/build/gadget-ui/)

### Installation

Creating addins with Shiny Gadgets requires **shiny**, **miniUI**, and **rstudioapi** packages from CRAN. To create an addin package, add these packages to the package DESCRIPTION file as follows:

``` yaml
Imports:
  shiny,
  miniUI,
  rstudioapi
```

### More Examples

The **addinexamples** package contains several additional examples of Shiny Gadget based addins:

-   [Find and Replace](https://github.com/rstudio/addinexamples/blob/master/R/findAndReplaceAddin.R) --- Find and replace words in a document.

-   [Reformat R Code](https://github.com/rstudio/addinexamples/blob/master/R/reformatAddin.R) --- Reformat R code using `formatR::tidy_source()`.

-   [Subset a Data Frame](https://github.com/rstudio/addinexamples/blob/master/R/subsetAddin.R) --- Interactively subset a data frame.

\

# Generating options
The `generate-options.R` script within this directory can be used to automatically generate C++ options code and corresponding Rmd documentation for any option `json` files specified on the command line. By default, the following json files are loaded, generating code and documentation for each:

* server/server-options.json
* server/server-options-overlay.json
* session/session-options.json
* session/session-options-overlay.json

The overlay options are only picked up if they exist, which they will not in the open source repo.

To generate for all options file, simply invoke the script `./generate-options.R` from within the `src/cpp` directory. If you only want to generate specific options files, you can specify each one on the command line. Note that you should only specify the non-overlay file - the overlay files are **always** pulled in if they exist.

*Note: When merging new open source options to Pro, you will need to rerun the generation script to ensure the documentation is generated, as the documentation only exists in the Pro repo.*

# Verifying options

An option can be:
- Public
- Internal (hidden)
- Deprecated

The following conditions are accepted for options in the different states:

- In general, a deprecated option should not be present in the server docs.
- A deprecated option can also be hidden to not be listed by `generate-options.R` in the server docs _appendix_.
- A deprecated option may no longer be used in the code but we keep the option around to not break existing customers.
- A public option most likely needs to be in the server docs.
- A public option which is obscure or rarely used can only be listed in the server docs _appendix_ and have no other mention in the server docs.
- A hidden option **must not** be in the server docs. Also, `generate-options.R` does not list a hidden option in the server docs _appendix_.
- A hidden or public option that's not deprecated must be used in the code. Otherwise, it's a dead option.

In order to make it easier to evaluate these conditions, you can run the `./report-options.sh` script.

This script will report the following conditions about each server or session option:

- `<server|session>: <option> -- MISSING IN DOCS, ADD IT TO DOCS, MAKE IT HIDDEN OR DEPRECATED`
- `<server|session>: <option> -- isHidden BUT SHOWN IN <doc files>, MAKE IT VISIBLE OR REMOVE IT FROM DOCS`
- `<server|session>: <option> -- isDeprecated BUT SHOWN IN <doc files>, MAKE IT HIDDEN OR REMOVE IT FROM DOCS`
- `<server|session>: <option> -- NOT IN CODE, MAKE IT DEPRECATED AND HIDDEN`

Based on the results of the command, you can take actions to correct the found conditions if necessary.

To see all options, including the ones in good shape, run `./report-options.sh all`.

You will additional output like:

- `<server|session>: <option> -- IN DOCS <doc files>, OK`
- `<server|session>: <option> -- isHidden AND NOT IN DOCS, OK`
- `<server|session>: <option> -- isDeprecated AND NOT IN DOCS, OK`

In this mode, some options that may exist with the same name as both server and session options will show as:

- `session: <option> -- isHidden IN SESSION BUT ALSO IN SERVER, SHOWN IN <doc files>, PLEASE CHECK`
- `session: <option> -- isDeprecated IN SESSION BUT ALSO IN SERVER, SHOWN IN <doc files>, PLEASE CHECK`

In most case, there's no action to be taken here. The server option is just being forwarded to the session.

## Options JSON documentation
The following sections list all of the properties that can be specified within an options json file.

### Root document

| Property   |      Description     | 
|----------|-------------|
| metadata |  Metadata field which contains meta information about file generation, etc. |
| options | List of option categories which contain the actual options to generate/document. |

### metadata

| Property   |      Description     | 
|----------|-------------|
| generatorType |  The type of code generator to use. |
| namespace | The C++ namespace name to use. |
| includeGuard | The C++ include guard to use for the header file. |
| configFile | The name of the config file that these options are documenting. |
| docDescription | The document description to use for the list of options being generated. This will appear verbatim as the text in the admin guide appendix preceding the options documentation. |
| outputSourceFile | The output file of the generated source. |
| outputHeaderFile | The output file of the generated source header. Only necessary for generators that output a source and header file. Regular ProgramOptions generation only generates a header file, so `outputSourceFile` is used instead. Overlay options require both a source and a header file. |
| outputDocFile | The output file of the generated Rmd documentation. |
| additionalIncludes | A string array of additional C++ includes that are needed to build the options. |
| additionalConstants | Additional constants to define. This is only used for overlay options to specify constants that should be generated with the rest of the auto generated constants, so that external source files can reference all constants from one file. |

### options

The options property is a string dictionary, where each entry is a category of options to specify. Within each category, you may specify multiple `option` objects that may have the following properties.

| Property   |      Description     | 
|----------|-------------|
| name |  The name of the option. A constant may also be specified by setting this to an object and specifying the `constant` (for the name of the constant) and `value` properties (to document the actual value of the constant). Constants are generated for overlay options, and are expected to be pulled in as an additional include for regular options.
| type | The type of the option. Can be one of `string`, `bool`, `int`, `double`, `core::FilePath`, or `stringList` (which maps to std::vector). |
| defaultValue | Indicates the default value for the option, should one not be provided. This can also be specified as raw C++ code by setting it to an object containing the properties `code` (containing the raw code) and `description` (indicating a human readable string that describes what the code does). |
| description | The description of the option. This is the text, verbatim, that will be documented in the Rmd documentation. |
| isDeprecated | A boolean indicating whether or not the option is deprecated and should no longer be used. |
| isMultitoken | A boolean indicating whether or not the option is multitoken, meaning it can be specified multiple times with multiple values to be built as part of a list. |
| skipAccessorGeneration | A boolean indicating if the C++ accessor should not be generated. Use this for times when you need to specify your own complicated accessor, or simply do not need an accessor to be available (such as with deprecated options). |
| tempName | The name of the temp variable that the option will be read into. Only necessary if you are reading the option into a temporary variable, transforming the variable into another type, then surfacing that final transform to callers within the C++ code. Use this if you need to do some preprocessing on the option before it is made available by the accessor. |
| tempType| The type of the temporary variable which the option will be read into. |
| isHidden | A boolean indicating whether or not the option should be documented. This should only be used for options that are passed through the system that need to be hidden from the user, such as derivative options. |
| shortName | Specifies the short option name to use, as an alternative to the full name. Generally used for command line switches. |

---
title: "Custom Settings"
date-meta: 2022-12-12
---

The examples in this section presume you are setting individual user account settings by changing files in `~/.config/rstudio` (Mac/Linux) or `AppData/Roaming/RStudio/` (Windows). For information on server wide setting on Posit Workbench or RStudio Server, see the [Customizing Session Settings section](https://docs.posit.co/ide/server-pro/r_sessions/customizing_session_settings.html) from <https://docs.posit.co/ide/server-pro/>.

```bash
# Mac or Linux, user level
~/.config/rstudio/
# Windows
AppData/Roaming/RStudio/
```

## User preferences

User preferences set in the RStudio **Global Options** dialog can also be set in the JSON file `rstudio-prefs.json`, located in the settings directory:

``` bash
# Mac or Linux, user level
~/.config/rstudio/rstudio-prefs.json
# Windows
AppData/Roaming/RStudio/rstudio-prefs.json
```

You can see a summary of this information in the [Session User Settings](https://docs.posit.co/ide/server-pro/session_user_settings/session_user_settings.html) appendix.

## Snippets

You can install snippets files into `~/.config/rstudio/snippets` (Mac/Linux) or `AppData/Roaming/RStudio/snippets` (Windows). For example, if you'd like to create a snippet `lib` for an R library call:


```r
# ~/.config/rstudio/snippets on Mac/Linux
# AppData/Roaming/RStudio/snippets on Windows
snippet lib
    library(${1:package})
```
You can also define snippets for CSS files in the file `css.snippets`, and so on. Documentation on the snippet file format can be found in the [Cloud 9 IDE snippet documentation](https://cloud9-sdk.readme.io/docs/snippets). For more information on custom snippets, see the [RStudio Custom Snippets section](../productivity/snippets.qmd).

::: {.callout-note}

RStudio will not merge snippet files.

If you define your own snippets (for a given file type), they will replace those that ship with RStudio (for that same file type).

:::

## Default document templates

RStudio typically opens new documents with completely blank contents. You can, however, define the contents of the blank document by creating a file named `default.X` in `~/.config/rstudio/templates` (Mac/Linux) or `AppData/Roaming/RStudio/templates` (Windows), where `X` is the file extension you wish to customize. For example, to start all R scripts with a standard comment header users can fill out, you could use the following:

```r
# ~/.config/rstudio/templates on Mac/Linux
# AppData/Roaming/RStudio/templates on Windows
# -------------------------------------
# Script:
# Author:
# Purpose:
# Notes:
#
# Copyright(c) Corporation Name
# -------------------------------------
```

There are also some special template files which ship with RStudio; these, too, are customizable. In `~/.config/rstudio/templates` (Mac/Linux) or `AppData/Roaming/RStudio/templates` (Windows), you can customize the following:

| File               | Description                                                            |
|:----------------------------------------------------------------------------------------------------------------------------|:------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| `document.Rmd`     | The default R Markdown document file content (without YAML header)     |
| `document.qmd`     | The default Quarto document file content (without YAML header)         |
| `notebook.Rmd`     | The default R Notebook file content (without YAML header)              |
| `presentation.Rmd` | The default R Markdown presentation file content (without YAML header) |
| `presentation.qmd` | The default Quarto presentation file content (without YAML header)     |
| `shiny.Rmd`        | The default Shiny R Markdown file content (without YAML header)        |
| `query.sql`        | The default SQL query                                                  |

For Quarto and R Markdown documents, templates should not have a YAML header. The **File** > **New File** workflow provides a popup wizard where users select specific options that populate the YAML header.

## Color themes

You can define additional custom themes for RStudio by placing `.rstheme` files in the following directory:

```bash
# Mac or Linux
~/.config/rstudio/themes
# Windows
AppData/Roaming/RStudio/themes
```

The `.rstheme` file contains plain-text CSS with some special metadata. You can create one by importing an existing TextMate theme file, or by starting from scratch (using an existing theme file as a template). Run the R command `?rstudioapi::addTheme` for more help. For more information on custom themes, see the [RStudio Themes section](../ui/appearance.qmd).

## Keybindings

RStudio or editor keybindings can be defined using the following two files:

```bash
# Mac or Linux
~/.config/rstudio/keybindings/editor_commands.json
~/.config/rstudio/keybindings/rstudio_commands.json

# Windows
AppData/Roaming/RStudio/keybindings/editor_commands.json
AppData/Roaming/RStudio/keybindings/rstudio_commands.json
```

For more information on creating custom shortcuts, see [RStudio Custom Shortcuts](../productivity/custom-shortcuts.qmd).

## Spelling

You can define additional spelling dictionaries for RStudio by placing dictionary files in the following folders:

- Languages in `rstudio/dictionaries/languages-system`
- Dictionaries in `rstudio/dictionaries/custom`

### Languages

Define additional system languages by placing Hunspell `.aff` files in:

```bash
# Mac or Linux
~/.config/rstudio/dictionaries/languages-system
# Windows
AppData/Roaming/RStudio/dictionaries/languages-system
```

### Dictionaries

Define additional custom dictionaries by placing Hunspell `.dic` files in:

```bash
# Mac or Linux
~/.config/rstudio/dictionaries/custom
# Windows
AppData/Roaming/RStudio/dictionaries/custom
```

## Observable JS

This Quarto document is made interactive using Observable JS. Interactive documents allow readers to modify parameters and see the results immediately. Learn more about OJS interactive documents at <https://quarto.org/docs/interactive/ojs/>.

## Bubble Chart

This example uses a D3 bubble chart imported from Observable HQ to analyze commits to GitHub repositories.

Select a repository to analyze the commits of:

```{ojs}
//| echo: false
//| panel: input
viewof repo = Inputs.radio(
  [
    "pandas-dev/pandas",
    "tidyverse/ggplot2",
  ], 
  { label: "Repository:", value: "pandas-dev/pandas"}
)
```

Fetch the commits for the specified `repo` using the GitHub API:

```{ojs}
d3 = require('d3')
contributors = await d3.json(
  "https://api.github.com/repos/" + repo + "/stats/contributors"
)
commits = contributors.map(contributor => {
  const author = contributor.author;
  return {
    name: author.login,
    title: author.login,
    group: author.type,
    value: contributor.total
  }
})
```

Note that the `repo` variable is bound dynamically from the radio input defined above. If you change the input the contributors query will be automatically re-executed.

View the commits sorted by most to least:

```{ojs}
Inputs.table(commits, { sort: "value", reverse: true })
```

Visualize using a D3 bubble chart imported from Observable HQ:

```{ojs}
import { chart } with { commits as data } 
  from "@d3/d3-bubble-chart"
chart
```

---
title: "Text Editor"
date-meta: 2022-12-12
---

RStudio's source editor includes a variety of productivity enhancing features including syntax highlighting, code completion, multiple-file editing, and find/replace.

RStudio also enables flexible execution of R code directly from the source editor. For many R developers this represents their preferred way of working with R. Working in the source editor makes it much easier to reproduce sequences of commands and to package commands for re-use as a function. These features are described in the [Executing Code](../code/execution.html) section of the user guide.

The core features listed below are accessible via the **Code Tools** "Magic Wand" dropdown menu in the **Source** pane.

![](images/code-tools.png){fig-alt="Screenshot of the Code Tools dropdown"}

Most of these features have corresponding keyboard shortcuts, which also means they can be accessed via the Command Palette (<kbd>Ctrl/Cmd + Shift + P</kbd>).

![](images/rename-in-scope.png){fig-alt="A screenshot of the Command Palette with the search limited to 'Rename' symbol in scope"}

## Code completion

RStudio supports the automatic completion of code using the **Tab** key. For example, start typing `return` as `ret` then **Tab** and RStudio will automatically complete the full name of the function or object.

![](images/tab-completion.png){fig-alt="Screenshot of RStudio's autocompletion of the 'return' function"}

Code completion also works in the console, and more details on using it can be found in the console [Console](../code/console.html) documentation.

## Extract Function

RStudio can analyze a selection of code from within the source editor and automatically convert it into a re-usable function. Any "free" variables within the selection (objects that are referenced but not created within the selection) are converted into function arguments:

![](images/extract-function-dropdown.png){fig-alt="Screenshot of the Code Tools > Extract Function button"}

## Find and Replace

RStudio supports finding and replacing text within source documents:

![](images/find-replace.png){fig-alt="A screenshot of the Find and Replace text interface within a source file."}

Find and replace can be opened using the <kbd>Ctrl+F</kbd> shortcut key, or from the **Edit** > **Find\...** menu item. Replacement can be done all at once or by stepping through each instance.

## Comment/Uncomment

RStudio provides the ability to comment and uncomment entire selections of code using the **Code > Comment/Uncomment Lines** menu item or with the <kbd>Command+Shift + C</kbd> keyboard shortcut.

![](images/comment-uncomment.png){fig-alt="Screenshot of the 'Comment/Uncomment Lines' button" }

## Multiple Cursors

-   Press **Ctrl + Alt + {Up/Down}** to create a new cursor in the pressed direction,

-   Press **Ctrl + Alt + Shift + {Direction}** to move a second cursor in the specified direction,

-   Use **Alt** and drag with the mouse to create a rectangular selection,

-   Use **Alt + Shift** and click to create a rectangular selection from the current cursor position to the clicked position.

![](images/multicursor-lines.png){fig-alt="Screenshot of multiple cursors across 3 lines of code"}

Use the "All" button on the **Find/Replace** toolbar to create cursors at each instance of a word.

![](images/multicursor-find-replace.png){fig-alt="Screenshot of 3 cursors, one at each instance of the searched term in the current R script."}

## Move lines up/down

Text or code in source files can be moved up or down by the <kbd>Alt+Up/Down</kbd> (<kbd>Option+Up/Down</kbd> on Mac). This applies to individual lines of code where the cursor is, as well as to multiline selections.

![](images/move-lines-up-down.gif){fig-alt="A screencast of an example line of text being moved up with the move lines up/down shortcut"}

## Copy lines up/down

Text or code in source files can be copied up or down with the <kbd>Shift+Alt+Up/Down</kbd> (<kbd>Cmd+Option+Up/Down</kbd> on Mac) shortcut. This applies to individual lines of code where the cursor is, as well as to multiline selections.

![](images/copy-lines-up-down.gif){fig-alt="A screencast of an example line of text being duplicated across multiple lines with the copy lines up/down shortcut"}

## Keyboard Shortcuts

Beyond the keyboard shortcuts described above, there are a wide variety of other shortcuts available. Some of the more useful ones include:

-   <kbd>Ctrl+Shift+N</kbd> --- New document

-   <kbd>Ctrl+O</kbd> --- Open document

-   <kbd>Ctrl+S</kbd> --- Save active document

-   <kbd>Ctrl+1</kbd> --- Move focus to the Source Editor

-   <kbd>Ctrl+2</kbd> --- Move focus to the Console

A list of all shortcuts in the [Keyboard Shortcuts](../../reference/shortcuts.html).

## Quarto

Quarto enables you to weave together content and executable code into a finished document. To learn more about Quarto see <https://quarto.org>.

## Running Code

When you click the **Render** button a document will be generated that includes both content and the output of embedded code. You can embed code like this:

```{r}
1 + 1
```

You can add options to executable code like this 

```{r}
#| echo: false
2 * 2
```

The `echo: false` option disables the printing of code (only output is displayed).

---
title: "Creating a Diagnostic Report"
date-meta: 2025-01-07
---

Diagnostic reports can be created within a working session, or from outside a session on a terminal.

## In an RStudio session

From the menu, click **Help** > **Diagnostics** > **Write Diagnostics Report**.

## Outside of an RStudio session

If RStudio is not starting, run a diagnostics report using the following method. Additionally, you need to provide the contents of the started terminal session.

### Windows

Run a diagnostics report by typing the following command into **Start** > **Run**:

```powershell
"C:\Program Files\RStudio\rstudio.exe" --run-diagnostics
```

The diagnostics report is placed in your user's Documents directory in a directory called `rstudio-diagnostics`. For example: `C:\Users\Username\Documents\rstudio-diagnostics\diagnostics-report.txt`

If you installed RStudio to a location other than `C:\Program Files`, specify this unique location in the command.

### macOS

Run a diagnostics report by typing the following command at the Terminal:

```zsh
/Applications/RStudio.app/Contents/MacOS/RStudio --run-diagnostics
```

The diagnostics report is placed in your user home directory For example: `~/rstudio-diagnostics/diagnostics-report.txt`.

### Linux

Run a diagnostics report by typing the following command at the Terminal:

```bash
rstudio --run-diagnostics
```

The diagnostics report is placed in your user home directory. For example: `~/rstudio-diagnostics/diagnostics-report.txt`.

---
name: rstudio-update-quarto
description: Use when updating the Quarto version in the RStudio repository, e.g. bumping to a new release. This skill is for macOS and Linux only.
---

# Update Quarto

Updates the pinned Quarto version across the RStudio codebase, mirrors the new release into the rstudio-buildtools S3 bucket, verifies the install, and opens a PR.

## Arguments

The user provides the **target Quarto version** (e.g. `1.9.36`).

## Steps

### 1. Verify starting branch

Before doing anything else, confirm the current branch is `main`. This skill creates a new feature branch off the current branch, so starting off anything other than `main` would base the work on the wrong commit.

```bash
git branch --show-current
```

If the output is not `main`, **stop immediately** and warn the user that they must switch to `main` (and pull the latest) before re-running this skill. Do not proceed with any further steps.

### 2. Validate the version

Confirm the version argument matches the format `X.Y.Z` (digits and dots only). If it doesn't, ask the user to correct it before proceeding.

### 3. Check prerequisites

Before modifying any files, verify that AWS credentials and required tools are in place. The upload script needs working AWS access, and discovering a credential problem after editing files wastes effort.

Run these checks and stop if any fail:

```bash
command -v aws >/dev/null 2>&1 && echo "aws: ok" || echo "aws: MISSING"
command -v wget >/dev/null 2>&1 && echo "wget: ok" || echo "wget: MISSING"
aws sts get-caller-identity
```

If `aws` or `wget` is missing, tell the user to install it. If `aws sts get-caller-identity` fails, tell the user to configure AWS credentials (e.g. `aws sso login` or `aws configure sso` if SSO isn't set up yet) and try again.

### 4. Create a branch

```bash
git checkout -b feature/update-quarto-<VERSION>
```

### 5. Update version strings

Update the Quarto version in the following four files. Each file uses a slightly different syntax — match the existing pattern exactly.

#### `NEWS.md`

In the `### Dependencies` section, update the Quarto line:

```
- Quarto <VERSION>
```

#### `dependencies/tools/upload-quarto.sh`

Bash assignment, no quotes:

```bash
QUARTO_VERSION=<VERSION>
```

Unlike the copilot upload script, `upload-quarto.sh` does not accept a CLI argument — it reads the version from this hardcoded value, so it must be updated before running the upload step.

#### `dependencies/common/install-quarto`

Bash assignment, no quotes:

```bash
QUARTO_VERSION=<VERSION>
```

#### `dependencies/windows/install-dependencies.cmd`

Windows batch syntax, no quotes:

```cmd
set QUARTO_VERSION=<VERSION>
```

After editing, verify all four files contain the new version string.

### 6. Upload to S3

Run the upload script. It downloads release archives for all supported platforms (linux-amd64, linux-arm64, macos, win) from the Quarto GitHub releases page and copies each to the `rstudio-buildtools` S3 bucket.

```bash
bash dependencies/tools/upload-quarto.sh
```

Confirm exit code 0 and that every platform archive was uploaded. If any download or upload fails, report the error and stop.

The upload script downloads each archive into the current working directory and does **not** clean up afterward, so remove the leftover archives once the upload succeeds:

```bash
rm -f quarto-<VERSION>-*
```

### 7. Verify the install

The default tools root (`/opt/rstudio-tools/...`) requires elevated privileges, so use a temporary directory to verify the install without needing `sudo`.

```bash
VERIFY_DIR="$(mktemp -d)"
trap 'rm -rf "$VERIFY_DIR"' EXIT
RSTUDIO_TOOLS_ROOT="$VERIFY_DIR" bash dependencies/common/install-quarto
```

Confirm exit code 0. The install script checks the resulting `quarto --version` against the expected value, so a successful run end-to-end is meaningful verification that the new release is usable. The `trap` ensures the temp directory is cleaned up whether the install succeeds or fails. If the install fails, report the error and stop.

After verification, tell the user they will need to re-run `dependencies/common/install-quarto` themselves (with appropriate privileges) to install the new Quarto into their dev environment.

### 8. Commit and open a PR

Commit the four modified files and open a pull request:

- **Branch**: `feature/update-quarto-<VERSION>`
- **Commit message**: `Update Quarto to <VERSION>`
- **PR title**: `Update Quarto to <VERSION>`
- **PR body**: mention the version bump and that the S3 upload and local install were verified

---
title: "Themes"
date-meta: 2022-12-12
---

## Switching global themes

RStudio provides support for two global themes that customize the RStudio IDE's user interface: Modern and Sky. By default, the Modern theme is selected.

The Modern theme flattens all user interface elements with a default white background, while the Sky theme has a light blue background.

To switch between RStudio themes, from the **Tools** \> **Global Options \> Appearance** menu, use the **RStudio theme** dropdown.

## Editor themes

RStudio provides support for adding custom editor themes in one of two formats: tmTheme or rstheme. The tmTheme format was first introduced for TextMate, and has since become one of the standard formats for themes. This [tmTheme editor](https://tmtheme-editor.herokuapp.com/) also includes a large collection of tmThemes. The rstheme format is specific to RStudio.

To switch between the Editor themes, from the **Tools** \> **Global Options \> Appearance** menu, use the **Editor theme** selector. A number of common themes are included, but users can also define and uploaded their own themes. The [`rsthemes` R package](https://www.garrickadenbuie.com/project/rsthemes/) provides a number of additional common themes for use in RStudio.

![](images/rstudio-theme.png){width="800" fig-alt="A screenshot of the Global Options > Appearance tab, so that the theme of the IDE can be changed."}

## Creating custom themes for RStudio

User defined themes are supported in one of two formats: tmTheme and rstheme. A tmTheme is an XML based theme description first introduced by the text editor TextMate. An rstheme is a CSS based theme format designed to work specifically with RStudio. When a tmTheme is added to RStudio, it is converted to an rstheme before it is saved locally. To create a new theme for RStudio, you can write a tmTheme and import it to RStudio, write an rstheme, or write a tmTheme and then modify the rstheme that RStudio will generate for you.

## Creating a tmTheme

To create a new tmTheme from scratch you can use a tmTheme editor like [this one](https://tmtheme-editor.herokuapp.com/), or write it by hand. tmTheme files are very general and may include any scope the writer wishes; however, RStudio only supports a certain set of scopes. Below, you can find a table that describes the scopes supported by RStudio and the impact they will have on your resulting theme:

| Scope                          | Description                                                                                                                                                                                                                     |
|:-------------|:---------------------------------------------------------|
| comment                        | Changes the color and style of comments.                                                                                                                                                                                        |
| constant                       | Changes the color and style of constants like `TRUE`, `FALSE`, and numeric literals.                                                                                                                                            |
| constant.language              | Changes the color and style of language constants like `TRUE` and `FALSE`. This value will override the settings in the "constant" scope for language constants, if set. Also in R Markdown files, everything surrounded in `*`. |
| constant.numeric               | Changes the color and style of numeric literals. This value will override the settings in the "constant" scope for numeric literals, if set. Also in R Markdown files, everything surrounded in `**`.                            |
| keyword                        | Changes the color and style of keywords like `function`, `if`, `else`, `stop`, and operators.                                                                                                                                   |
| keyword.operator               | Changes the color and style of operators like `(`, `)`, `=`, `+`, and `-`. This value will override the settings in the "keyword" scope for operators, if set.                                                                  |
| marker-layer.active_debug_line | Changes the color and style of the highlighting on the line of code which is currently being debugged.                                                                                                                          |
| markup.heading                 | Changes the color and style of the characters that start a heading in R Markdown documents.                                                                                                                                      |
| meta.tag                       | Changes the color and style of metadata tags in R Markdown documents, like `title`.                                                                                                                                              |
| string                         | Changes the color and style of string literals.                                                                                                                                                                                 |
| support.function               | Changes the color and style of code blocks in R Markdown documents.                                                                                                                                                              |

: {tbl-colwidths="\[25,75\]"}

## Creating an rstheme

While an rstheme can be written from scratch, they contain a fair amount of generated values. The most straightforward method to create one would be to write a tmTheme and import to RStudio and then modify the generated rstheme. Another straightforward method would be to copy an existing rstheme and then modify the values.

Because of the structure of the elements being styled, not all the CSS rule sets may end up being used. Below is a table that describes the most relevant selectors, which tmTheme scope they correspond to, if any, and how they impact the style of RStudio.

:::{.column-body}

| Selector                                     | Description                                                                                                                                                                                                                    |
|:---------------|:------------------------------------------------------|
| .ace_bracket                               | Overrides default styling for matching bracket highlighting provided by Ace.                                                                                                                                                   |
| .ace_comment                               | Changes the color and style of comments.                                                                                                                                                                                       |
| .ace_constant                              | Changes the color and style of constants like TRUE, FALSE, and numeric literals.                                                                                                                                           |
| .ace_constant.ace_language                 | Changes the color and style of language constants like TRUE and FALSE. This rule set will override rules in .ace_constant for language constants. Also in R Markdown files, everything surrounded in *.                 |
| .ace_constant.ace_numeric                  | Changes the color and style of numeric literals. This value will override the settings in the "constant" scope, if set. Also in R Markdown files, everything surrounded in **.                                                |
| .ace_cursor                                | Changes the color and style of the text cursor in the editor window.                                                                                                                                                           |
| .ace_editor                                | Changes the default color and background of the RStudio editor windows. This selector will usually be the first in a list of other selectors for the same rule set, such as .rstudio-themes-flat.ace_editor_theme and so on. |
| .ace_gutter                                | Changes the color and style of the gutter: the panel on the left-hand side of the editor which holds line numbers, breakpoints, and fold widgets.                                                                              |
| .ace_gutter-active-line                    | Changes the color and style of the gutter at the active line in the editor.                                                                                                                                                    |
| .ace_heading                               | Changes the color and style of headings in R Markdown documents.                                                                                                                                                                |
| .ace_indent-guide                          | Changes the color and style of the indent guide, which can be enabled or disabled through Global Options > Code > Display > Show indent guides.                                                                              |
| .ace_invisible                             | Changes the color and style of invisible characters, which can be enabled or disabled through Global Options > Code Display > Show whitespace characters.                                                                    |
| .ace_keyword                               | Changes the color and style of keywords like function, if, else, stop, and operators.                                                                                                                                  |
| .ace_keyword.ace_operator                  | Changes the color and style of operators like (, ), =, +, and -. This value will override the settings in the .ace_keyword block for operators, if set.                                                            |
| .ace_meta.ace_tag                          | Changes the color and style of metadata tags in R Markdown documents, like title and output.                                                                                                                                |
| .ace_marker-layer .ace_active-debug-line   | Changes the color and style of the highlighting on the line of code which is currently being debugged.                                                                                                                         |
| .ace_marker-layer .ace_bracket             | Changes the color and style of the highlighting on matching brackets.                                                                                                                                                          |
| .ace_marker-layer .ace_selection           | Changes the color and style of the highlighting for the currently selected line or block of lines.                                                                                                                             |
| .ace_markup.ace_heading                    | Changes the color and style of the characters that start a heading in R Markdown documents.                                                                                                                                     |
| .ace_paren_color_0 to .ace_paren_color_6 | Changes the color and style of the rainbow parentheses.                                                                                                                                                                        |
| .ace_print-margin                          | Changes the color and style, if applicable, of the line-width margin that can be enabled or disabled through Global Options > Code > Display > Show margin.                                                                  |
| .ace_selection.ace_start                   | Changes the color and style of the highlighting for the start of the currently selected block of lines.                                                                                                                        |
| .ace_string                                | Changes the color and style of string literals.                                                                                                                                                                                |
| .ace_support.ace_function                  | Changes the color and style of code blocks in R Markdown documents.                                                                                                                                                             |
:::

In addition to these rule sets, you will also find a number of rule sets related to the Terminal pane, with selectors that include `.terminal` or selectors that begin with `.xterm`. It is possible to change these values as well, but it may be advisable to keep a back up copy of your original theme in case you don't like any of the changes. There are also a number of classes that can be used to modify parts of RStudio unrelated to the editor. These classes are all prefixed with `rstheme_`, with the exception of `dataGridHeader` and `themedPopupPanel`. Any classes you find in the html of RStudio which are not prefixed with `rstheme_`, `ace_`, or explicitly listed in this article are subject to change at anytime, and so are unsafe to use in custom themes.

Since an rstheme is just CSS, anything that you can do with CSS you can do in an rstheme.

## Testing changes to a theme

If you're modifying a theme which has already been added to RStudio, you may need to restart RStudio desktop in order to make the changes take effect.

## Sharing a theme

Once you're satisfied with your theme, you can easily share it with anyone by simply sharing the tmTheme or rstheme file. You can find rstheme files in `appdata/roaming/rstudio/themes` on Windows and `~/.config/rstudio/themes` on linux and Mac.

## Themes API

For those interested in authoring packages or integrating themes programmatically, you can make use of the [rstudioapi](https://cran.r-project.org/web/packages/rstudioapi/index.html) package.

Then we can query the current theme using:

`rstudioapi::getThemeInfo()`

which, for the Modern theme and Xcode this function would return:

`$editor[1] "Xcode"$global[1] "Modern"$dark[1] TRUE`

This can be used to properly customize the output from your package to match the RStudio theme selected by each user.

To add a new rstheme, use:

`rstudioapi::addTheme(themePath, apply, force, globally)`

which returns the name of the newly added theme. It's parameters are described below:

| **Parameter** | **Description**                                                                                   |
|---------------|---------------------------------------------------------|
| `themePath`   | A full or relative path or URL to the rstheme file to add.                                        |
| `apply`       | Whether to immediately apply the newly added theme. Default: `FALSE`.                             |
| `force`       | Whether to force the add operation if a file with the same name already exists. Default: `FALSE`. |
| `globally`    | Whether to add the theme for all users (`TRUE`) or the current user (`FALSE`). Default: `FALSE`.  |

To add a new tmTheme, use:
```r
rstudioapi::convertTheme(
  themePath, add, outputLocation, 
  apply, force, globally
)
```
which also returns the name of the newly added theme. It's parameters are described in the table below:

| **Parameter**    | **Description**                                                                                                                                                                    |
|-------------|-----------------------------------------------------------|
| `themePath`      | A full or relative path to the tmTheme file to add.                                                                                                                                |
| `add`            | Whether to add the converted theme to RStudio immediately. Default: `TRUE`.                                                                                                        |
| `outputLocation` | A full or relative path where an additional copy of the converted theme will be saved. If this value is not set and add is set to `FALSE`, no file will be saved. Default: `NULL`. |
| `apply`          | Whether to immediately apply the newly added theme. Default: `FALSE`.                                                                                                              |
| `force`          | Whether to force the add operation if a file with the same name already exists. Default: `FALSE`.                                                                                  |
| `globally`       | Whether to add the theme for all users (`TRUE`) or the current user (`FALSE`). Default: `FALSE`.                                                                                   |

To apply a particular theme use:

`rstudioapi::applyTheme(name)`

where `name` is the name of theme returned by `rstudioapi::getThemes()`.

To remove a custom theme use:

`rstudioapi::removeTheme(name)`

where `name` is the name of theme returned by `rstudioapi::getThemes()`.

To list all the available editor themes, use:

`rstudioapi::getThemes()`

which returns a list of themes in the format `id = list(name = "a theme name", isDark = TRUE)`. For example, some values in the list would look like:

``` code
$ambiance
ambiance$name
[1] "Ambiance"

$ambiance$isDark
[1] TRUE

$chaos
$chaos$name
[1] "Chaos"

$chaos$isDark
[1] TRUE

$chrome
$chrome$name
[1] "Chrome"

$chrome$isDark
[1] FALSE
```

# Electron-to-Playwright Migration Progress

Source: `rstudio-ide-automation/rstudio_server_pro/electron-tests/`
Target: `e2e/rstudio/tests/`

## Summary

| Metric | Count |
|--------|-------|
| Total electron test files | 32 |
| Total electron test methods | 115 |
| Files fully converted | 32 |
| Files partially converted | 0 |
| Files not started | 5 |

## Conversion Status

### Root-level tests (11 files, 57 methods)

| Electron Source | Methods | Playwright Target | Status | Notes |
|----------------|---------|-------------------|--------|-------|
| test_desktop_Citations.py | 17 | panes/editor/citations.test.ts (11) | Complete | Restarted from scratch. The 17 Selenium methods are collapsed into 11 representative tests (per-source and per-format delete/blank/dont-escape duplicates folded): DOI insert (markdown + Quarto), R Package insert, delete a staged citation, no-duplicate dedup with a references.bib single-entry check, blank-insert dialog dismissal, non-escaping visual round-trip (.md + .qmd), and keyword search for Crossref/DataCite/PubMed. Insert tests also assert references.bib content (key, entry type, title, DOI, and no author field). All against live services. R Package delete is not ported (delete is source-agnostic, covered by the DOI delete; package staging is covered by the R Package insert). |
| test_desktop_Command_Palette.py | 2 | panes/misc/command_palette.test.ts (2) | Complete | Open/filter/run (Escape closes; "script" keeps R + SQL script, drops text file; Enter runs the front-loaded New R Script), and the inline native-pipe pref toggle (verified by inserting "\|>"). Both cross-mode. |
| test_desktop_console.py | 11 | panes/console/console_pane.test.ts (8), panes/console/console_command_effects.test.ts (7), panes/console/execute_from_editor.test.ts (1) | Complete | Split by theme; added Find in Console coverage (3 new tests) and upgraded `help.start()` to verify help-pane contents |
| test_desktop_EnvironmentPane.py | 5 | panes/environment/environment_pane.test.ts (5) | Complete | Toolbar elements, the import-dataset/object-view/environment-list dropdowns, and memory-pie growth + usage-report modal. No Desktop-only assumptions; the Selenium maximize/restore workaround was dropped. |
| test_desktop_FindInFiles.py | 3 | panes/misc/find_in_files_replace.test.ts (3) | Complete | Folded 2 new cross-mode tests into the existing spec: the search-options dialog (case/whole-word/regex), and a multi-file search (3 files, term in 2 of 3) with the search/replace toolbar toggle. The third method (Replace All) was already covered there. |
| test_desktop_Package_Installation.py | 1 | panes/console/package_installation.test.ts (1) | Complete | |
| test_desktop_PlotsPane.py | 11 | panes/plots/plots_pane.test.ts (11) | Complete | All 11 tests including the 3 that were commented out in the desktop source (export dropdown, save as image, save as PDF). Two-step save flow (OK + GWT file chooser) with R file-exists verification. Zoom and resize tests are @desktop_only. |
| test_desktop_R.py | 1 | panes/editor/r_execution.test.ts (1) | Complete | |
| test_desktop_R_Session_Restart.py | 1 | panes/console/r_session_restart.test.ts (1) | Complete | |
| test_desktop_terminal.py | 4 | panes/terminal/terminal.test.ts (4) | Complete | Added to existing terminal spec: toolbar next/previous buttons, R --version output, file create and ls, Shift+Backspace character deletion (@desktop_only). Uses rstudioapi::terminalBuffer for all output assertions. |
| test_desktop_ViewerPane.py | 1 | panes/viewer/htmlwidgets.test.ts (1) | Complete | plotly htmlwidget auto-displays in the Viewer pane; asserts the text-trace label renders in the iframe |

### EditorPane (10 files, 37 methods)

| Electron Source | Methods | Playwright Target | Status | Notes |
|----------------|---------|-------------------|--------|-------|
| test_desktop_CodeSuggestions.ts | — | panes/editor/code_suggestions.test.ts (5) | Complete | Already TypeScript in electron-tests |
| test_desktop_Copilot.py | 12 | panes/editor/copilot_ghost_text.test.ts (22) | Complete | Restructured with loops; test_enabling_copilot not included |
| test_desktop_Create_File_Types.py | 6 | panes/editor/create_file_types.test.ts (22 + 1 fixme) | Complete | One test per type. 13 need no package or dialog (C/C++ x3, CSS, HTML, JavaScript, Markdown, Python, R HTML, Shell, R Script, R Sweave, Text). Each create gates on the source-tab count reaching 2 so it can't race the leftover Untitled placeholder (and the footer reading the placeholder's "R Script"). SQL is its own test: creating it pops an "update RSQLite" modal (from the template's !preview line) which the test declines (the doc is created either way), so the leftover modal can't block the next test -- it was breaking newRNotebook. D3 and R Notebook need packages; R Notebook's footer reads "R Markdown" (it creates an RMARKDOWN doc). Quarto document and presentation, R Markdown, and Shiny drive their creation dialogs; the Selenium presentation method re-ran newQuartoDoc (dead newQuartoPres var), fixed to drive newQuartoPres. Rd and Plumber (Selenium WIP types) pass. Stan (also WIP) skips unless rstan is already installed (no auto-install; heavy source compile). R Presentation is fixme (save-file dialog). |
| test_desktop_DataViewer.py | 4 | panes/data-viewer/pagination-sorting.test.ts (4) | Complete | |
| test_desktop_Markdown.py | 2 | panes/editor/markdown.test.ts (2) | Complete | newMarkdownDoc creation, plus previewHTML to the Viewer pane with rendered-text assertions |
| test_desktop_Quarto.py | 1 | panes/editor/quarto.test.ts (1) | Complete | |
| test_desktop_RMarkdown.py | 7 | panes/editor/rmarkdown.test.ts (6) | Complete | |
| test_desktop_RNotebook.py | 1 | panes/editor/rnotebook.test.ts (1) | Complete | Preview displays the .nb.html sidecar written by the editor save hook, so the doc is saved before previewing; preview click retried for the first-click-does-nothing quirk |
| test_desktop_Sweave.py | 2 | panes/editor/sweave.test.ts (2) | Complete | Creation test covered by create_file_types; added PDF compile test |
| test_desktop_SyntaxHighlighting.py | 1 | panes/editor/syntax-highlighting.test.ts (1) | Complete | |

### GlobalPrefs (10 files, 19 methods)

| Electron Source | Methods | Playwright Target | Status | Notes |
|----------------|---------|-------------------|--------|-------|
| test_desktop_GlobalPrefAccessibility.py | 6 | preferences/global_prefs_accessibility.test.ts (6) | Complete | Keyboard a11y of the Global Options dialog: initial focus, Arrow-key section navigation, and Tab/Shift+Tab focus wrapping (including wrap-to-current-section after changing panes). Cross-mode. Fixed two latent Selenium assertion bugs (`assert focused, x` -> proper focus checks) and added the `console_options` tab selector. |
| test_desktop_GlobalPrefAppearance.py | 1 | preferences/global_prefs_panels.test.ts (1) | Complete | |
| test_desktop_GlobalPrefCode.py | 2 | preferences/global_prefs_panels.test.ts (2) | Complete | |
| test_desktop_GlobalPrefGeneral.py | 3 | preferences/global_prefs_panels.test.ts (1) | Complete | 2 WIP methods were commented out in the Python source; not migrated |
| test_desktop_GlobalPrefPackages.py | 2 | preferences/global_prefs_panels.test.ts (1) | Complete | 1 method was commented out in the Python source; not migrated |
| test_desktop_GlobalPrefPaneLayout.py | 1 | preferences/global_prefs_panels.test.ts (1) | Complete | |
| test_desktop_GlobalPrefRMarkdown.py | 1 | preferences/global_prefs_panels.test.ts (1) | Complete | |
| test_desktop_GlobalPrefSpelling.py | 1 | preferences/global_prefs_panels.test.ts (1) | Complete | |
| test_desktop_GlobalPrefSweave.py | 1 | preferences/global_prefs_panels.test.ts (1) | Complete | |
| test_desktop_GlobalPrefTerminal.py | 1 | preferences/global_prefs_panels.test.ts (1) | Complete | Also includes 2 new tests (Python panel, Assistant panel) with no Selenium equivalent |

### Licensing (4 files, 9 methods)

| Electron Source | Methods | Playwright Target | Status | Notes |
|----------------|---------|-------------------|--------|-------|
| test_desktop_activate_license.py | 3 | — | Not started | |
| test_desktop_license.py | 2 | — | Not started | |
| test_desktop_License_Diagnostics.py | 2 | — | Not started | |
| test_desktop_remove_license.py | 2 | — | Not started | |

### Projects (1 file, 5 methods)

| Electron Source | Methods | Playwright Target | Status | Notes |
|----------------|---------|-------------------|--------|-------|
| test_desktop_Create_Projects.py | 5 | projects/create_projects.test.ts (5) | Complete | |

## Fixme Tests

| Playwright File | Test Name | Blocker | Notes |
|----------------|-----------|---------|-------|
| panes/editor/create_file_types.test.ts | create R Presentation via newRPresentationDoc | Opens a save-file dialog (native OS chooser on Desktop, GWT chooser on Server) to choose the .Rpres path; the harness can't drive that yet. R Presentation was never implemented in Selenium either, only a WIP comment in the source. | — |

## Quarto

Quarto enables you to weave together content and executable code into a finished presentation. To learn more about Quarto presentations see <https://quarto.org/docs/presentations/>.

## Bullets

When you click the **Render** button a document will be generated that includes:

-   Content authored with markdown
-   Output from executable code

## Code

When you click the **Render** button a presentation will be generated that includes both content and the output of embedded code. You can embed code like this:

```{r}
1 + 1
```

---
name: Backport an issue
about: File an issue to backport another issue to a specific previous version.
title: 'Backport #<issue> to <version name> <YYYY.MM.patch>'
labels: ['backport']
assignees: ''

---

<!--

Please set the issue number in the title and the description. <version name> should be the full name of the version (e.g. "Spotted Wakerobin" or "Prairie Trillium"), and <YYYY.MM.patch> should be the calendar version of the release with the name, followed by the patch version we are targeting this issue for (e.g. 2022.07.2 or 2022.02.4).

Please also add this issue to the milestone titled "Patch <YYYY.MM.patch>". If one is not created for that patch, please tag @MariaSemple or @mikebessuille.

-->

Backport #<issue> to <version name> <YYYY.MM.patch>.

**Note: This issue is to record the need to backport the linked issue only. Please add comments or discussion relating to the original issue onto it directly.**

# Visual editor (panmirror) patterns

Read this when driving the visual (WYSIWYG) markdown editor -- the Insert
Citation dialog, format/insert menus, etc. panmirror is a React app; its source
lives in the Quarto repo (`packages/editor/src/behaviors/...`), not in this repo.

## Entering visual mode

Citations and the Insert menu exist only in visual mode. Use
`SourcePaneActions.ensureVisualMode()`; it handles the first-switch
pandoc-conversion confirmation dialog. Plain `newMarkdownDoc` is the cheapest
host (no `rmarkdown` package, no Quarto new-doc wizard).

## panmirror renders outside the GWT dialog

panmirror UI (e.g. the Insert Citation panel) renders in a React root that is a
sibling of the GWT `[role="dialog"]` shell, not inside it. Scope selectors to
`page` -- a dialog-scoped `locator('button')` or `outerHTML` dump misses the
real controls.

## Insert Citation dialog

Open it in visual mode:

```typescript
await page.locator('[aria-label="Insert"]').click();
await page.locator('#rstudio_label_citation_command').click();
await page.locator('[role="dialog"][aria-label="Insert Citation"]')
  .waitFor({ state: 'visible', timeout: 15000 });
```

**Select a source by clicking the node row, not the icon:**
`.pm-navigation-tree-node` containing the source's `img[alt='<Source>']`.
Clicking the img or its wrapper only moves the highlight. The tree is
react-window virtualized (it scrolls on selection), so don't rapid-fire clicks
at it.

**Highlight != selected.** `pm-selected-navigation-tree-item` moving to a source
does not mean its panel is active. Verify true selection by the source's own
search box (placeholder e.g. `Search DataCite for Citations`) or its Search
button becoming visible -- never by the highlight class.

**Survive the one-time init reset.** When the dialog's bibliography load
resolves, the post-load configuration poll fires once and calls
`setSelectedPanelProvider`, snapping the active panel back to the dialog's
initially-selected node (My Sources on a fresh open) while leaving the tree
highlight where you put it. It fires at most once. So select, and re-select if
the panel reverts -- the second selection lands after the reset and is
permanent:

```typescript
const node = page.locator('.pm-navigation-tree-node', { has: page.locator("[alt='DataCite']") });
const box = page.getByPlaceholder('Search DataCite for Citations');
await node.click();
await expect(box).toBeVisible({ timeout: 15000 });
const deadline = Date.now() + 6000;
while (Date.now() < deadline) {
  if (!(await box.isVisible().catch(() => false))) {
    await node.click();               // reverted; re-select (now permanent)
    await expect(box).toBeVisible({ timeout: 15000 });
    break;
  }
  await page.waitForTimeout(200);
}
```

## Latent search (external sources: DataCite, Crossref, DOI, PubMed)

Typing does not search -- it only updates the term. The search fires on Enter,
paste, or the Search button (`button.pm-insert-citation-panel-latent-search-button`),
which is present whenever the source panel is active and disabled only while a
search is running. Type, then click the button:

```typescript
await box.pressSequentially('bobolink');   // real keystrokes, not fill()
await page.locator('button.pm-insert-citation-panel-latent-search-button').click();
const results = page.locator('.pm-insert-citation-source-panel-item-detailed');
await expect.poll(() => results.count(), { timeout: 30000 }).toBeGreaterThan(0);
```

Use `pressSequentially`, not `fill()`: `fill()` sets the DOM value but does not
reliably fire React's controlled-input `onChange`, so the term can stay empty
and Enter/the button do nothing even though the box visibly shows the text.

## Search RPCs are async

`datacite_search`, `crossref_works`, `pubmed_search`, and `doi_fetch_csl` are
async RPCs: the POST returns only `{asyncHandle}`, and the results arrive later
via `/events/get_events` as an `async_completion` event keyed by that handle.
The service HTTP request is made server-side (rsession), so it is not reachable
at the API boundary from Playwright -- only the browser<->rsession RPC seam is.

---
title: "Keyboard Shortcuts"
date-meta: 2022-12-12
---

Some shortcuts may differ if non-default keybindings are selected (e.g., Emacs, Vim, or Sublime Text).

## Command Palette

A command palette is a software affordance that gives instant, searchable access to all of a program's commands. Command palettes have become a fixture of modern IDEs, and with good reason. They improve:

-   **Keyboard accessibility**; even commands that do not have keyboard shortcuts are easily invoked from the palette.

-   **Speed**; it is often much faster to invoke a command from the palette with a few quick keystrokes than to reach for the mouse or drill into a menu.

-   **Discoverability**; since the palette lists all the commands, it can be browsed to find a command for a task by name without trying to figure out which menu or toolbar might contain it.

All shortcuts can be accessed via the Command Palette:

| Description          | Windows & Linux                          | Mac             |
|:---------------------|:-----------------------------------------|:----------------|
| Show Command Palette | Ctrl+Shift+P, Ctrl+Alt+Shift+P (Firefox) | Shift+Command+P |

It's also available on the *Tools* menu (*Tools* -\> *Show Command Palette*).

![](images/new-script.png)

## Accessibility

| Description                       | Windows & Linux        | Mac                      |
|:----------------------------------|:-----------------------|:-------------------------|
| Toggle Screen Reader Support      | Alt+Shift+/            | Ctrl+Option+/            |
| Speak Text Editor Location        | Alt+Shift+1            | Ctrl+Option+1            |
| Focus Console Output              | Ctrl+\` or Alt+Shift+2 | Ctrl+\` or Ctrl+Option+2 |
| Toggle Tab Key Always Moves Focus | Alt+Shift+\[           | Ctrl+Option+\[           |
| Focus Next Pane                   | F6                     | F6                       |
| Focus Previous Pane               | Shift+F6               | Shift+F6                 |
| Focus Main Toolbar                | Alt+Shift+Y            | Ctrl+Option+Y            |

## Console

| Description                           | Windows & Linux | Mac           |
|:--------------------------------------|:----------------|:--------------|
| Move cursor to Console                | Ctrl+2          | Ctrl+2        |
| Clear console                         | Ctrl+L          | Ctrl+L        |
| Move cursor to beginning of line      | Home            | Command+Left  |
| Move cursor to end of line            | End             | Command+Right |
| Navigate command history              | Up/Down         | Up/Down       |
| Popup command history                 | Ctrl+Up         | Command+Up    |
| Interrupt currently executing command | Esc             | Esc           |
| Change working directory              | Ctrl+Shift+H    | Ctrl+Shift+H  |

## Source

| Description                                         | Windows & Linux                        | Mac                                       |
|:----------------------------------------------------|:---------------------------------------|:------------------------------------------|
| Go to File/Function                                 | Ctrl+. \[period\]                      | Ctrl+. \[period\]                         |
| Move cursor to Source Editor                        | Ctrl+1                                 | Ctrl+1                                    |
| Toggle document outline                             | Ctrl+Shift+O                           | Shift+Command+O                           |
| Toggle visual markdown editor                       | Ctrl+Shift+F4                          | Ctrl+Shift+F4                             |
| New document (except on Chrome/Windows)             | Ctrl+Shift+N                           | Shift+Command+N                           |
| New document (Chrome only)                          | Ctrl+Alt+Shift+N                       | Option+Shift+Command+N                    |
| Open document                                       | Ctrl+O                                 | Command+O                                 |
| Save active document                                | Ctrl+S                                 | Command+S                                 |
| Save all documents                                  | Ctrl+Alt+S                             | Command+Option+S                          |
| Close active document (except on Chrome)            | Ctrl+W                                 | Command+W                                 |
| Close active document (Chrome only)                 | Ctrl+Alt+W                             | Option+Command+W                          |
| Close all open documents                            | Ctrl+Shift+W                           | Shift+Command+W                           |
| Close other documents                               | Ctrl+Shift+Alt+W                       | Option+Shift+Command+W                    |
| Preview HTML (Markdown and HTML)                    | Ctrl+Shift+K                           | Shift+Command+K                           |
| Knit Document (knitr)                               | Ctrl+Shift+K                           | Shift+Command+K                           |
| Compile Notebook                                    | Ctrl+Shift+K                           | Shift+Command+K                           |
| Compile PDF (TeX and Sweave)                        | Ctrl+Shift+K                           | Shift+Command+K                           |
| Insert chunk (Sweave and Knitr)                     | Ctrl+Alt+I                             | Option+Command+I                          |
| Insert code section                                 | Ctrl+Shift+R                           | Shift+Command+R or Ctrl+Shift+R           |
| Run current line/selection                          | Ctrl+Enter                             | Command+Return                            |
| Run current line/selection (retain cursor position) | Alt+Enter                              | Option+Return                             |
| Re-run previous region                              | Ctrl+Alt+P                             | Option+Command+P                          |
| Run current document                                | Ctrl+Alt+R                             | Option+Command+R                          |
| Run from document beginning to current line         | Ctrl+Alt+B                             | Option+Command+B                          |
| Run from current line to document end               | Ctrl+Alt+E                             | Option+Command+E                          |
| Run the current function definition                 | Ctrl+Alt+F                             | Option+Command+F                          |
| Run the current code section                        | Ctrl+Alt+T                             | Option+Command+T                          |
| Run previous Sweave/Rmd code                        | Ctrl+Alt+Shift+P                       | Option+Shift+Command+P                    |
| Run the current Sweave/Rmd chunk                    | Ctrl+Alt+C                             | Option+Command+C                          |
| Run the next Sweave/Rmd chunk                       | Ctrl+Alt+N                             | Option+Command+N                          |
| Source a file                                       | Ctrl+Alt+G                             | Ctrl+Option+G                             |
| Source the current document                         | Ctrl+Shift+S                           | Shift+Command+S                           |
| Source the current document (with echo)             | Ctrl+Shift+Enter                       | Shift+Command+Return                      |
| Send current line/selection to terminal             | Ctrl+Alt+Enter                         | Option+Command+Return                     |
| Fold Selected                                       | Alt+L                                  | Option+Command+L                          |
| Unfold Selected                                     | Shift+Alt+L                            | Option+Shift+Command+L                    |
| Fold All                                            | Alt+O                                  | Option+Command+O                          |
| Unfold All                                          | Shift+Alt+O                            | Option+Shift+Command+O                    |
| Go to line                                          | Shift+Alt+G                            | Option+Shift+Command+G                    |
| Jump to                                             | Shift+Alt+J                            | Option+Shift+Command+J                    |
| Expand selection                                    | Ctrl+Shift+Up                          | Ctrl+Option+Shift+Up                      |
| Shrink selection                                    | Ctrl+Shift+Down                        | Ctrl+Option+Shift+Down                    |
| Next section                                        | Ctrl+PageDown                          | Command+PageDown                          |
| Previous section                                    | Ctrl+PageUp                            | Command+PageUp                            |
| Split into lines                                    | Ctrl+Alt+A                             | Ctrl+Option+A                             |
| Edit lines from start                               | Ctrl+Alt+Shift+A                       | Ctrl+Option+Shift+A                       |
| Switch to tab                                       | Ctrl+Shift+. \[period\]                | Ctrl+Shift+. \[period\]                   |
| Previous tab                                        | Ctrl+F11 or Ctrl+Alt+Left              | Ctrl+F11 or Ctrl+Option+Left              |
| Previous tab (desktop only)                         | Ctrl+Shift+Tab                         | Ctrl+Shift+Tab                            |
| Next tab                                            | Ctrl+F12 or Ctrl+Alt+Right             | Ctrl+F12 or Ctrl+Option+Right             |
| Next tab (desktop only)                             | Ctrl+Tab                               | Ctrl+Tab                                  |
| First tab                                           | Ctrl+Shift+F11 or Ctrl+Alt+Shift+Left  | Ctrl+Shift+F11 or Ctrl+Option+Shift+Left  |
| Last tab                                            | Ctrl+Shift+F12 or Ctrl+Alt+Shift+Right | Ctrl+Shift+F12 or Ctrl+Option+Shift+Right |
| Navigate back                                       | Ctrl+F9                                | Command+F9                                |
| Navigate forward                                    | Ctrl+F10                               | Command+F10                               |
| Extract function from selection                     | Ctrl+Alt+X                             | Option+Command+X                          |
| Extract variable from selection                     | Ctrl+Alt+V                             | Option+Command+V                          |
| Reindent lines                                      | Ctrl+I                                 | Command+I                                 |
| Comment/uncomment current line/selection            | Ctrl+Shift+C                           | Shift+Command+C                           |
| Reflow Comment                                      | Ctrl+Shift+/                           | Ctrl+Shift+/                              |
| Reformat Selection                                  | Ctrl+Shift+A                           | Shift+Command+A                           |
| Show Diagnostics for Current Project                | Ctrl+Shift+Alt+D                       | Option+Shift+Command+D                    |
| Transpose Letters                                   | No shortcut                            | Ctrl+T                                    |
| Move Lines Up/Down                                  | Alt+Up/Down                            | Option+Up or Down                         |
| Copy Lines Up/Down                                  | Shift+Alt+Up/Down                      | Option+Command+Up or Down                 |
| Jump to Matching Brace/Paren                        | Ctrl+P                                 | Ctrl+P                                    |
| Expand to Matching Brace/Paren                      | Ctrl+Shift+Alt+E                       | Ctrl+Shift+E                              |
| Add Cursor Above Current Cursor                     | Ctrl+Alt+Up                            | Ctrl+Option+Up                            |
| Add Cursor Below Current Cursor                     | Ctrl+Alt+Down                          | Ctrl+Option+Down                          |
| Move Active Cursor Up                               | Ctrl+Alt+Shift+Up                      | Ctrl+Option+Shift+Up                      |
| Move Active Cursor Down                             | Ctrl+Alt+Shift+Down                    | Ctrl+Option+Shift+Down                    |
| Find and Replace                                    | Ctrl+F                                 | Command+F                                 |
| Find Next                                           | Win: F3, Linux: Ctrl+G                 | Command+G                                 |
| Find Previous                                       | Win: Shift+F3, Linux: Ctrl+Shift+G     | Shift+Command+G                           |
| Use Selection for Find                              | Ctrl+F3                                | Command+E                                 |
| Replace and Find                                    | Ctrl+Shift+J                           | Shift+Command+J                           |
| Find in Files                                       | Ctrl+Shift+F                           | Shift+Command+F                           |
| Check Spelling                                      | F7                                     | F7                                        |
| Rename Symbol in Scope                              | Ctrl+Alt+Shift+M                       | Option+Shift+Command+M                    |
| Insert Roxygen Skeleton                             | Ctrl+Shift+Alt+R                       | Option+Shift+Command+R                    |

## Editing (Console and Source)

| Description                             | Windows & Linux                          | Mac                                       |
|:----------------------------------------|:-----------------------------------------|:------------------------------------------|
| Undo                                    | Ctrl+Z                                   | Command+Z                                 |
| Redo                                    | Ctrl+Shift+Z                             | Shift+Command+Z                           |
| Cut                                     | Ctrl+X                                   | Command+X                                 |
| Copy                                    | Ctrl+C                                   | Command+C                                 |
| Paste                                   | Ctrl+V                                   | Command+V                                 |
| Paste with Indent                       | Ctrl+Shift+V                             | Command+Shift+V                           |
| Select All                              | Ctrl+A                                   | Command+A                                 |
| Jump to Word                            | Ctrl+Left/Right                          | Option+Left or Right                      |
| Jump to Start/End                       | Ctrl+Home/End or Ctrl+Up/Down            | Command+Up or Down                        |
| Delete Line                             | Ctrl+D                                   | Command+D                                 |
| Select                                  | Shift+\[Arrow\]                          | Shift+\[Arrow\]                           |
| Select Word                             | Ctrl+Shift+Left/Right                    | Option+Shift+Left or Right                |
| Select to Line Start                    | Alt+Shift+Left                           | Shift+Command+Left                        |
| Select to Line End                      | Alt+Shift+Right                          | Shift+Command+Right                       |
| Select Page Up/Down                     | Shift+PageUp/PageDown                    | Shift+PageUp or PageDown                  |
| Select to Start/End                     | Ctrl+Shift+Home/End or Shift+Alt+Up/Down | Shift+Command+Up or Down                  |
| Delete Word Left                        | Ctrl+Backspace                           | Option+Backspace or Ctrl+Option+Backspace |
| Delete Word Right                       | No shortcut                              | Option+Delete                             |
| Delete to Line End                      | No shortcut                              | Ctrl+K                                    |
| Delete to Line Start                    | No shortcut                              | Option+Backspace                          |
| Indent                                  | Tab (at beginning of line)               | Tab (at beginning of line)                |
| Outdent                                 | Shift+Tab                                | Shift+Tab                                 |
| Yank line up to cursor                  | Ctrl+U                                   | Ctrl+U                                    |
| Yank line after cursor                  | Ctrl+K                                   | Ctrl+K                                    |
| Insert currently yanked text            | Ctrl+Y                                   | Ctrl+Y                                    |
| Insert assignment operator              | Alt+-                                    | Option+-                                  |
| Insert pipe operator                    | Ctrl+Shift+M                             | Shift+Command+M                           |
| Show help for function at cursor        | F1                                       | F1                                        |
| Show source code for function at cursor | F2                                       | F2                                        |
| Find usages for symbol at cursor (C++)  | Ctrl+Alt+U                               | Option+Command+U                          |

## Completions (Console and Source)

| Description               | Windows & Linux      | Mac                   |
|:--------------------------|:---------------------|:----------------------|
| Attempt completion        | Tab or Ctrl+Space    | Tab or Command+Space  |
| Navigate candidates       | Up/Down              | Up or Down            |
| Accept selected candidate | Enter, Tab, or Right | Return, Tab, or Right |
| Dismiss completion popup  | Esc                  | Esc                   |

## Views

| Description                 | Windows & Linux    | Mac                                                                                |
|:----------------------------|:-------------------|:-----------------------------------------------------------------------------------|
| Move focus to Source Editor | Ctrl+1             | Ctrl+1                                                                             |
| Zoom Source Editor          | Ctrl+Shift+1       | Ctrl+Shift+1                                                                       |
| Move focus to Console       | Ctrl+2             | Ctrl+2                                                                             |
| Zoom Console                | Ctrl+Shift+2       | Ctrl+Shift+2                                                                       |
| Move focus to Help          | Ctrl+3             | Ctrl+3                                                                             |
| Zoom Help                   | Ctrl+Shift+3       | Ctrl+Shift+3                                                                       |
| Move Focus to Terminal      | Alt+Shift+M        | Option+Shift+M                                                                     |
| Show History                | Ctrl+4             | Ctrl+4                                                                             |
| Zoom History                | Ctrl+Shift+4       | Ctrl+Shift+4                                                                       |
| Show Files                  | Ctrl+5             | Ctrl+5                                                                             |
| Zoom Files                  | Ctrl+Shift+5       | Ctrl+Shift+5                                                                       |
| Show Plots                  | Ctrl+6             | Ctrl+6                                                                             |
| Zoom Plots                  | Ctrl+Shift+6       | Ctrl+Shift+6                                                                       |
| Show Packages               | Ctrl+7             | Ctrl+7                                                                             |
| Zoom Packages               | Ctrl+Shift+7       | Ctrl+Shift+7                                                                       |
| Show Environment            | Ctrl+8             | Ctrl+8                                                                             |
| Zoom Environment            | Ctrl+Shift+8       | Ctrl+Shift+8                                                                       |
| Show Viewer                 | Ctrl+9             | Ctrl+9                                                                             |
| Zoom Viewer                 | Ctrl+Shift+9       | Ctrl+Shift+9                                                                       |
| Show Git/SVN                | Ctrl+F1            | Command+F1                                                                         |
| Zoom Git/SVN                | Ctrl+Shift+F1      | Ctrl+Shift+F1                                                                      |
| Show Build                  | Ctrl+F2            | Command+F2                                                                         |
| Zoom Build                  | Ctrl+Shift+F2      | Ctrl+Shift+F2                                                                      |
| Show Connections            | Ctrl+F5            | No shortcut                                                                        |
| Zoom Connections            | Ctrl+Shift+F5      | Ctrl+Shift+F5                                                                      |
| Zoom Tutorial               | Ctrl+Shift+F6      | Ctrl+Shift+F6                                                                      |
| Show Find in Files Results  | Ctrl+F6            | Command+F6                                                                         |
| Sync Editor & PDF Preview   | Ctrl+F8            | Command+F8                                                                         |
| Zoom left column            | Ctrl+Alt+Shift+F12 | Ctrl+Option+Shift+F12                                                              |
| Zoom right column           | Ctrl+Alt+Shift+F11 | Ctrl+Option+Shift+F11                                                              |
| Show all panes              | Ctrl+Alt+Shift+0   | Ctrl+Alt+0                                                                         |
| Add source column           | Ctrl+F7            | Command+F7                                                                         |
| Global Options              | No shortcut        | Command+, \[comma\] (Chrome, Desktop) Option+Command+, \[comma\] (Safari, Firefox) |
| Project Options             | No shortcut        | Shift+Command+, \[comma\]                                                          |

## Help

| Description                      | Windows & Linux                          | Mac             |
|:---------------------------------|:-----------------------------------------|:----------------|
| Show Command Palette             | Ctrl+Shift+P, Ctrl+Alt+Shift+P (Firefox) | Shift+Command+P |
| Show Keyboard Shortcut Reference | Alt+Shift+K                              | Option+Shift+K  |
| Search R Help                    | Ctrl+Alt+F1                              | Ctrl+Option+F1  |
| Find in Help Topic               | Ctrl+F                                   | Command+F       |
| Previous Help Topic              | Shift+Alt+F2                             | Option+Shift+F2 |
| Next Help Topic                  | Shift+Alt+F3                             | Option+Shift+F3 |

## Build

| Description            | Windows & Linux | Mac               |
|:-----------------------|:----------------|:------------------|
| Install and Restart    | Ctrl+Shift+B    | Shift+Command+B   |
| Load All (devtools)    | Ctrl+Shift+L    | Shift+Command+L   |
| Test Package (Desktop) | Ctrl+Shift+T    | Shift+Command+T   |
| Test Package (Web)     | Ctrl+Alt+F7     | Option+Command+F7 |
| Check Package          | Ctrl+Shift+E    | Shift+Command+E   |
| Document Package       | Ctrl+Shift+D    | Shift+Command+D   |

## Debug

| Description          | Windows & Linux | Mac      |
|:---------------------|:----------------|:---------|
| Toggle Breakpoint    | Shift+F9        | Shift+F9 |
| Execute Next Line    | F10             | F10      |
| Step Into Function   | Shift+F4        | Shift+F4 |
| Finish Function/Loop | Shift+F7        | Shift+F7 |
| Continue             | Shift+F5        | Shift+F5 |
| Stop Debugging       | Shift+F8        | Shift+F8 |

## Plots

| Description   | Windows & Linux                     | Mac                                          |
|:--------------|:------------------------------------|:---------------------------------------------|
| Previous plot | Ctrl+Alt+F11 or Ctrl+Shift+PageUp   | Option+Command+F11 or Shift+Command+PageUp   |
| Next plot     | Ctrl+Alt+F12 or Ctrl+Shift+PageDown | Option+Command+F12 or Shift+Command+PageDown |

## Git/SVN

| Description                          | Windows & Linux | Mac             |
|:-------------------------------------|:----------------|:----------------|
| Diff active source document          | Ctrl+Alt+D      | Ctrl+Option+D   |
| Commit changes                       | Ctrl+Alt+M      | Ctrl+Option+M   |
| Scroll diff view                     | Ctrl+Up/Down    | Ctrl+Up or Down |
| Stage/Unstage (Git)                  | Spacebar        | Spacebar        |
| Stage/Unstage and move to next (Git) | Enter           | Return          |

## Session

| Description                 | Windows & Linux | Mac             |
|:----------------------------|:----------------|:----------------|
| Quit Session (desktop only) | Ctrl+Q          | Command+Q       |
| Restart R Session           | Ctrl+Shift+F10  | Shift+Command+0 |

## Terminal

| Description            | Windows & Linux | Mac              |
|:-----------------------|:----------------|:-----------------|
| New Terminal           | Shift+Alt+R     | Option+Shift+R   |
| Move Focus to Terminal | Shift+Alt+M     | Option+Shift+M   |
| Previous Terminal      | Shift+Alt+F11   | Option+Shift+F11 |
| Next Terminal          | Shift+Alt+F12   | Option+Shift+F12 |

## Main Menu (Server)

| Description  | Windows & Linux | Mac           |
|:-------------|:----------------|:--------------|
| File Menu    | Alt+Shift+F     | Ctrl+Option+F |
| Edit Menu    | Alt+Shift+E     | Ctrl+Option+I |
| Code Menu    | Alt+Shift+C     | Ctrl+Option+C |
| View Menu    | Alt+Shift+V     | Ctrl+Option+V |
| Plots Menu   | Alt+Shift+P     | Ctrl+Option+P |
| Session Menu | Alt+Shift+S     | Ctrl+Option+S |
| Build Menu   | Alt+Shift+B     | Ctrl+Option+B |
| Debug Menu   | Alt+Shift+U     | Ctrl+Option+U |
| Profile Menu | Alt+Shift+I     | Ctrl+Option+O |
| Tools Menu   | Alt+Shift+T     | Ctrl+Option+T |
| Help Menu    | Alt+Shift+H     | Ctrl+Option+H |

---
name: Bug report
about: Report a bug in RStudio.
title: ''
labels: ['bug']
assignees: ''

---

<!--

IMPORTANT: Please provide a reproducible example! This can be a snippet of code, or set of actions, that we can use to reproduce the issue you are encountering. We are typically unable to fix issues that we cannot reproduce locally -- if we can reproduce the issue you are encountering on our own machines, then we are much more likely to be able to fix the issue.

This issue tracker is for bugs and feature requests in the RStudio IDE. If you're having trouble with R itself or an R package, see https://www.r-project.org/help.html, and if you want to ask a question rather than report a bug, go to https://forum.posit.co/. Finally, if you use RStudio Server Pro, get in touch with Posit Support at support@posit.co.

-->

### System details

    RStudio Edition : <!-- Desktop or Server -->
    RStudio Version : 
    OS Version      : 
    R Version       : 

### Steps to reproduce the problem

### Describe the problem in detail

### Describe the behavior you expected


<!-- 
Please keep the below portion in your issue, and check `[x]` the applicable boxes.
-->

- [ ] I have read the guide for [submitting good bug reports](https://github.com/rstudio/rstudio/wiki/Writing-Good-Bug-Reports).
- [ ] I have installed the latest version of RStudio, and confirmed that the issue still persists.
- [ ] If I am reporting an RStudio crash, I have included a [diagnostics report](https://support.posit.co/hc/en-us/articles/200321257-Running-a-Diagnostics-Report).
- [ ] I have done my best to include a minimal, self-contained set of instructions for consistently reproducing the issue.

---
title: "RStudio IDE User Guide"
subtitle: "RStudio is an integrated development environment (IDE) designed to support multiple languages, including both R and Python."
date: today
description: "Revision {{< var revision >}}"
date-format: iso
---

RStudio is available in open source and commercial editions and runs on the desktop (Windows 11, macOS 14+, and Linux) or in a browser connected to RStudio Server or Posit Workbench. Development of the open source and commercial RStudio IDE variants is supported by Posit Software, PBC (formerly named RStudio, PBC). Please review our [Blog post/FAQ](https://pos.it/rebrand-faq/) for additional information about the rebrand.

RStudio includes a console, syntax-highlighting editor that supports direct code execution, and a variety of robust tools for plotting, viewing history, debugging and managing your workspace. 

Please visit the individual product pages for additional information about the open source [RStudio IDE](https://posit.co/products/open-source/rstudio/) or RStudio within [Posit Workbench](https://posit.co/products/enterprise/workbench/). 

Some of the functionality that RStudio provides is:

-   Access RStudio locally.  
-   Syntax highlighting, code completion, and smart indentation.  
-   Execute R code directly from the source editor.  
-   Quickly jump to function definitions.  
-   View content changes in real-time with the Visual Markdown Editor for RMarkdown or Quarto documents.  
-   Easily manage multiple working directories using Projects.  
-   Integrated R help and documentation.  
-   View Python data, publish and render in Python and share objects with R.  
-   Interactive debugger to diagnose and fix errors.  
-   Extensive package development tools.  
-   Easily publish apps and reports.  

## About this guide

The following documentation helps a user understand the core workflows in RStudio. It provides information for navigating the user interface and appearance, managing R and R packages, working with Python, authoring code or text editing, debugging and diagnostics, using the Visual Editor for Quarto and RMarkdown, reading in data from local and remote sources, and integrations with version control systems and the terminal.

### Intended audience

This guide is intended for RStudio IDE users (e.g., data scientists).

:::{.callout-note}
This guide is intended for RStudio IDE users.

Posit Workbench users (e.g., data scientists) can reference the [Posit Workbench User Guide](https://docs.posit.co/ide/server-pro/user/).

Posit Workbench administrators can reference the [Posit Workbench Administrator Guide](https://docs.posit.co/ide/server-pro/).

:::

## Commercial Edition

Posit Workbench has several features that differentiate it from the open-source [RStudio desktop](https://posit.co/products/open-source/rstudio/) and [RStudio Server](https://posit.co/products/open-source/rstudio-server/), which you can read about on the [Posit Workbench comparison page](https://posit.co/products/enterprise/workbench/). The main advantages of using Posit Workbench are:

- Enhanced security and authentication, including Single Sign On (SSO).  
- Run multiple-concurrent sessions.  
- Use multiple different versions of R and Python.  
- Support for multiple IDEs such as VSCode and JupyterLab, in addition to RStudio.  
- Collaborate on projects.  
- Easily connect to shared resources such as databases or mounted file systems.  
- Launch jobs into remote or local clusters using Workbench Jobs.  
- The ability to fine-tune the performance of the user experience.  
- The ability to monitor the performance of sessions/users.  
- A commercial license to remove the restrictions of the AGPL license.  

## Install Links

### Open Source

- [RStudio Desktop download](#rstudio-ide-oss-downloads) - available for Windows/Mac/Linux
- [RStudio Server download](#rstudio-server-oss-downloads) - available for Linux

### Commercial

- [Posit Workbench](https://docs.posit.co/rsw/installation/) - administration guide for installation and configuration
- [RStudio Desktop Pro](https://docs.posit.co/ide/desktop-pro/getting_started/installation.html#direct-downloads) - available for Windows/Mac/Linux

### Direct Downloads (Open Source)

#### RStudio IDE {#rstudio-ide-oss-downloads}

Direct download links for RStudio Desktop {{< var version >}}, the version this documentation describes:

{{< include ../../_snippets/install-desktop-oss.qmd >}}

#### RStudio Server {#rstudio-server-oss-downloads}

Direct download links for RStudio Server {{< var version >}}, the version this documentation describes:

{{< include ../../_snippets/install-server-oss.qmd >}}

### Direct Downloads (Commercial)

Direct download links for RStudio Desktop Pro {{< var version >}}, the version this documentation describes:

{{< include ../../_snippets/install-desktop-pro.qmd >}}

::: {.callout-warning }

### Daily Builds

[RStudio Daily builds](https://dailies.rstudio.com/) are intended for testing purposes, and are not recommended for general use. For stable builds, please use one of the above links for Open Source or Commercial downloads.

:::

---
format: html
---

```{r}
#| foo: bar
#| comments:
#| - Some text. # This is a comment.
#| - Some text# This is not a comment!
#| - Some#text#with#embedded#hashes. # A real comment.
#| - # This is a comment. The entry here should be parsed as NULL.
#| 
#| text:
#| - This is a string. It has numbers like 1, 2, and 3.
#| - The next few lines are plain numbers, and should be highlighted like so.
#| - 42.0
#| - -35.5
#| 
#| strings:
#| - "This is a
#|    multi-line string.
#|    It has some escapes: \a.
#|    \"These are embedded quotes.\""
#| 
#| - 'This is a
#|    multi-line string.
#|    Quotes are escaped by ''doubling'' them.'
#|    
#| - >
#|    This is a multi-line string.
#|    It doesn't end until the indent decreases
#|    below the initial indent.
#| 
#|    For example, this is still part of the string:
#|    section:
#|       sub-section:
#|          value
#| 
#|    The next part is no longer part of the string.
#| 
#| lists:
#| - section: ["a", b42, 42.0, no, 64.0]
#| - section: [
#|    "a",
#|    b42,
#|    42.0,
#|    true,
#|    64.0
#| ]
#| 
#| dictionaries:
#| - { "a": 42, "b": 64 }
#| 
#| https://github.com/rstudio/rstudio/issues/13836:
#| - label: fig-plot-no-1
#| - fig-subcap:
#|    - Caption for Plot 1
#|    - Caption for Plot 2
#| - layout-ncol: 2.1

```

---
title: "Untitled"
output: html_document
---

This is an R Markdown document. Markdown is a simple formatting syntax for authoring HTML, PDF, and MS Word documents. For more details on using R Markdown see <http://rmarkdown.rstudio.com>.

When you click the **Knit** button a document will be generated that includes both content as well as the output of any embedded R code chunks within the document. You can embed an R code chunk like this:

# A Markdown Header

Another Markdown Header
=======================

## A Sub-Header

## A Second Sub-Header

```{r first-chunk}
```

```{r second-chunk}
foo <- function(x) {
  bar <- function(y) {
    bar(1)
  }
}
```

```{r third-chunk}

```

% Fixture for test-completions-inherit-dot-params.R
% Mimics the Rd output that roxygen2 generates for a function documented with
% @inheritDotParams. The \item{...}{} block is intentionally structured to
% match roxygen2's generated output: the description begins with the sentinel
% text "Arguments passed on to" followed by a \describe block listing each
% forwarded argument as \item{\code{argname}}{description}.
\name{wrapper}
\alias{wrapper}
\title{Wrapper function}
\usage{wrapper(x, ...)}
\arguments{
\item{x}{A value.}
\item{...}{Arguments passed on to \code{\link[=target]{target}}
\describe{
\item{\code{alpha}}{Description of alpha.}
\item{\code{beta}}{Description of beta.}
\item{\code{gamma}}{Description of gamma.}
\item{\code{if}}{An argument with a reserved word name requiring backtick-quoting.}
\item{\code{n,prop}}{Comma-separated args sharing a description.}
}
}
}
\description{A wrapper that forwards dots to target.}

% Fixture for test-completions-inherit-dot-params.R
% Mimics @inheritDotParams with specific args excluded, e.g.:
%   @inheritDotParams target -gamma
\name{wrapper_partial}
\alias{wrapper_partial}
\title{Wrapper with partial inheritDotParams}
\usage{wrapper_partial(x, ...)}
\arguments{
\item{x}{A value.}
\item{...}{Arguments passed on to \code{\link[=target]{target}}
\describe{
\item{\code{alpha}}{Description of alpha.}
\item{\code{beta}}{Description of beta.}
}
}
}
\description{A wrapper that forwards only some dots to target.}
